C> \brief Tells whether a given module is present in the build
C>
C> Provided with a module name this function returns whether the 
C> module is available in the current build. 
C>
C> \return
C> * `.true.` if the module is available
C> * `.false.` if the module is unavailable
C>
      logical function util_module_avail(mod_name)
      implicit none
#include "inp.fh"
      character*(*) mod_name
      util_module_avail = .true.
      select case (mod_name(1:inp_strlen(mod_name)))
c This function was auto generated by make_nwchem_config
        case ("NWints")
        case ("analyz")
        case ("atomscf")
        case ("bq")
        case ("cafe")
        case ("ccca")
        case ("ccsd")
        case ("cons")
        case ("cphf")
        case ("dangchang")
        case ("ddscf")
        case ("dimqm")
        case ("dntmc")
        case ("dplot")
        case ("drdy")
        case ("driver")
        case ("esp")
        case ("etrans")
        case ("fcidump")
        case ("fft")
        case ("gradients")
        case ("gwmol")
        case ("hessian")
        case ("mcscf")
        case ("mm")
        case ("moints")
        case ("mp2_grad")
        case ("nwdft")
        case ("nwmd")
        case ("nwpw")
        case ("optim")
        case ("perfm")
        case ("prepar")
        case ("property")
        case ("python")
        case ("qhop")
        case ("qmd")
        case ("qmmm")
        case ("rimp2")
        case ("selci")
        case ("solvation")
        case ("space")
        case ("stepper")
        case ("symmetry")
        case ("tce")
        case ("vib")
        case ("vscf")
        case default
          util_module_avail = .false.
      end select
      return
      end
