c
c     $Id$
c
      logical function xc_vdw_init(angs2au)
      implicit none
#include "xc_vdw.fh"
#include "util_params.fh"
      integer ii
      double precision angs2au
      double precision scalerad
      double precision r0_grimme1(54)
      double precision r0_grimme2(54)
c
c VDW radii are in ang. determined by
c atomic ROHF/TZV calculations and then taken as the radius 
c of the 0.01 density contour
c (scaling done below)
c data obatained using the 0.005 contour and scale=1.0 
c gave too large differences
c between the atoms i.e 1.1 1.5 1.42 1.36 1.3 for H,C,N,O,F
      data r0_grimme2
c H, He
     .     /0.91d0,0.92d0,
c Li-Ne
     .      0.75d0,1.28d0,1.35d0,1.32d0,1.27d0,1.22d0,1.17d0,1.13d0,
c Na-Ar
     .      1.04d0,1.24d0,1.49d0,1.56d0,1.55d0,1.53d0,1.49d0,1.45d0,
c K, Ca
     .      1.35d0,1.34d0,
c Sc-Zn
     .      1.42d0,1.42d0,1.42d0,1.42d0,1.42d0,
     .      1.42d0,1.42d0,1.42d0,1.42d0,1.42d0,
c Ga-Kr
     .      1.50d0,1.57d0,1.60d0,1.61d0,1.59d0,1.57d0,
c Rb, Sr
     .      1.48d0,1.46d0,
c Y-Cd
     .      1.49d0,1.49d0,1.49d0,1.49d0,1.49d0,
     .      1.49d0,1.49d0,1.49d0,1.49d0,1.49d0,
c In, Sn, Sb, Te, I, Xe
     .      1.52d0,1.64d0,1.71d0,1.72d0,1.72d0,1.71d0/
c    .      46*1.d+99/
c
      data r0_grimme1
c Original data radii from Grimme JCC(2004) now angstroms
c only for H,C,N,O,F,Ne
c H, He
     .     /1.11d0,0.0d0,
c Li-Ne
     .      0.00d0,0.00d0,0.00d0,1.61d0,1.55d0,1.49d0,1.43d0,1.38d0,
c Na-Ar
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,
c K, Ca
     .      0.00d0,0.00d0,
c Sc-Zn
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,
c Ga-Kr
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,
c Rb, Sr
     .      0.00d0,0.00d0,
c Y-Cd
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,
c In, Sn, Sb, Te, I, Xe
     .      0.00d0,0.00d0,0.00d0,0.00d0,0.00d0,0.00d0/
c    .      46*1.d+99/
c
      integer i
      double precision jnm6mol2au
c
c     initialize all c6 and r0
      do i=1,128
         c6(i)=0.d0
         r0(i)=0.d0
      enddo
c
      if(ivdw.eq.1.or.ivdw.eq.2)then
        do i=1, 54
           r0(i)=r0_grimme2(i)
        enddo
        r0(92)=1.86d0
      else if(ivdw.eq.0)then
        do i=1, 54
          r0(i)=r0_grimme1(i)
        enddo
      endif
c
      if(ivdw.eq.1)then
c scaled radii
c in J mol^-1 nm^6
        c6(1) =0.16d0
        c6(5) =1.65d0
        c6(6) =1.65d0
        c6(7) =1.11d0
        c6(8) =0.70d0
        c6(9) =0.57d0
        c6(10)=0.45d0
c not tested
        c6(14)=25.00d0
c quick and dirty fit for ph3 dimer (MP2/aug-cc-pVTZ)
        c6(15)=20.00d0
c quick and dirty fit for h2s dimer
        c6(16)=12.00d0
c quick and dirty fit for hcl dimer
        c6(17)=9.00d0
c quick and dirty fit for Ar2 (exp. value is 3.7)
        c6(18)=6.50d0
c not really tested
        c6(2) =0.15D0
        c6(24)=10.0D0
        c6(25)=10.0D0
        c6(26)=10.0D0
c estimate for bromine
        c6(35)=18.0D0
      else if(ivdw.eq.2)then
c scaled radii
c      c metals as average of preceeding rare gas and group 3 element
c      def2-QZVP PBE0 IP and alpha
        c6( 1) = 0.14
        c6( 2) = 0.08
        c6( 3) = 1.61
        c6( 4) = 1.61
        c6( 5) = 3.13
        c6( 6) = 1.75
        c6( 7) = 1.23
        c6( 8) = 0.70
        c6( 9) = 0.75
        c6(10) = 0.63
        c6(11) = 5.71
        c6(12) = 5.71
        c6(13) = 10.79
        c6(14) = 9.23
        c6(15) = 7.84
        c6(16) = 5.57
        c6(17) = 5.07
        c6(18) = 4.61
        do ii=19,30
           c6(ii) = 10.8
        enddo
        c6(31) = 16.99
        c6(32) = 17.10
        c6(33) = 16.37
        c6(34) = 12.64
        c6(35) = 12.47
        c6(36) = 12.01
        do ii=37,48
           c6(ii) = 24.67
        enddo
        c6(49) = 37.32
        c6(50) = 38.71
        c6(51) = 38.44
        c6(52) = 31.74
        c6(53) = 31.50
        c6(54) = 29.99
c       c6(92) = 101.70
      else if (ivdw.eq.3) then
        call init_cov_rad_d3(angs2au)
        call init_r0ab_d3(angs2au)
        call init_c6_params_d3
        call init_qat
      else if (ivdw.eq.4) then
c       As far as I understand the D3BJ scheme the parameters are the
c       same as for D3 (just the damping function is different).
        call init_cov_rad_d3(angs2au)
        call init_r0ab_d3(angs2au)
        call init_c6_params_d3
        call init_qat
      else if(ivdw.eq.0)then
c scaled radii
        c6(1) = 0.163d0
        c6(6) = 1.881d0
        c6(7) = 1.11d0
        c6(8) = 0.684d0
        c6(9) = 0.57d0
        c6(10)= 0.45d0
      endif
c
      if (ivdw.eq.0) then
        scalerad=1.00d0
      else if (ivdw.eq.1) then
c true ivdw eq 1
        scalerad=1.220d0
      else if (ivdw.eq.2) then
        scalerad=1.10d0
      else
        scalerad=0.0d0
      end if
c
c use  units change j nm6/mol to au
      jnm6mol2au=(((10*angs2au)**6)/4186)/cau2kcal
c
c use scaled radii and units change
      do i=1,128
         r0(i) = r0(i)*angs2au*scalerad
         c6(i) = c6(i)*jnm6mol2au
      end do
c
      xc_vdw_init=.true.
c
      return
      end
c
c     initialize coordination number dependent c6ab directly from Grimme's tables
c
      subroutine init_c6_params_d3
      implicit none
#include "xc_vdw.fh"
      double precision grimme_c6_parameters(161925)
      integer nlines, idata,iline,iat,jat,iadr,jadr
c
c     Number of distinct C6 value, atom pair combinations
c
      nlines=32385
c
c     Full data set in compact machine readable format
c
      grimme_c6_parameters(      1:    100)=(/
     . 0.30267000D+01,0.100D+01,0.100D+01,0.91180000D+00,0.91180000D+00
     .,0.20835000D+01,0.200D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.15583000D+01,0.200D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.38944800D+02,0.300D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22150800D+02,0.300D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.11634454D+04,0.300D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.24441500D+02,0.400D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.14824600D+02,0.400D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.49461900D+03,0.400D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.25748630D+03,0.400D+01,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.17314300D+02,0.500D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.11097500D+02,0.500D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.28373080D+03,0.500D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.16159710D+03,0.500D+01,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.10717770D+03,0.500D+01,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.12140200D+02,0.600D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.81841000D+01,0.600D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16990300D+03,0.600D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.10295600D+03,0.600D+01,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.71279400D+02,0.600D+01,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    101:    200)=(/
     . 0.49113000D+02,0.600D+01,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.87171000D+01,0.700D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.61380000D+01,0.700D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.10848540D+03,0.700D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.68645800D+02,0.700D+01,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.49113200D+02,0.700D+01,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.34814600D+02,0.700D+01,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.25268500D+02,0.700D+01,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.67180000D+01,0.800D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.48949000D+01,0.800D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.76961300D+02,0.800D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.50125200D+02,0.800D+01,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.36724700D+02,0.800D+01,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.26592900D+02,0.800D+01,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19654600D+02,0.800D+01,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.15505900D+02,0.800D+01,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.51616000D+01,0.900D+01,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.38825000D+01,0.900D+01,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.55093300D+02,0.900D+01,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.36745300D+02,0.900D+01,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    201:    300)=(/
     . 0.27482100D+02,0.900D+01,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.20282700D+02,0.900D+01,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.15241800D+02,0.900D+01,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.12183400D+02,0.900D+01,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.96916000D+01,0.900D+01,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.40112000D+01,0.100D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.31025000D+01,0.100D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.40473100D+02,0.100D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.27486700D+02,0.100D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.20902200D+02,0.100D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.15674000D+02,0.100D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11947900D+02,0.100D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.96606000D+01,0.100D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.77691000D+01,0.100D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.62896000D+01,0.100D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.46823200D+02,0.110D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.26862800D+02,0.110D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.13673272D+04,0.110D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.58745630D+03,0.110D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.33872120D+03,0.110D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    301:    400)=(/
     . 0.20376310D+03,0.110D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.13065630D+03,0.110D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.93026300D+02,0.110D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.66842300D+02,0.110D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.49279900D+02,0.110D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.16080286D+04,0.110D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.38353100D+02,0.120D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.23032000D+02,0.120D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.83081560D+03,0.120D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.41821640D+03,0.120D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.25813030D+03,0.120D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.16260820D+03,0.120D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10761500D+03,0.120D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.78225000D+02,0.120D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.57160500D+02,0.120D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.42677100D+02,0.120D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.98516970D+03,0.120D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.68337580D+03,0.120D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.36290900D+02,0.130D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22322400D+02,0.130D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    401:    500)=(/
     . 0.70582540D+03,0.130D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.37263020D+03,0.130D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.23647800D+03,0.130D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.15209340D+03,0.130D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10220000D+03,0.130D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.75075500D+02,0.130D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.55341200D+02,0.130D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.41596600D+02,0.130D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.83896480D+03,0.130D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.60346890D+03,0.130D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.54054060D+03,0.130D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.29594700D+02,0.140D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.18850000D+02,0.140D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.49534490D+03,0.140D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.27978630D+03,0.140D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.18451110D+03,0.140D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.12213870D+03,0.140D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.83849800D+02,0.140D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.62534900D+02,0.140D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.46693600D+02,0.140D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    501:    600)=(/
     . 0.35455000D+02,0.140D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.59104580D+03,0.140D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.44764230D+03,0.140D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.40896060D+03,0.140D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.31785740D+03,0.140D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.23760400D+02,0.150D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.15668900D+02,0.150D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.35080300D+03,0.150D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.20873310D+03,0.150D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.14234810D+03,0.150D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.96750300D+02,0.150D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.67787300D+02,0.150D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.51309800D+02,0.150D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.38808400D+02,0.150D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.29776700D+02,0.150D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.42000640D+03,0.150D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.33078010D+03,0.150D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.30729650D+03,0.150D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.24435460D+03,0.150D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.19168870D+03,0.150D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    601:    700)=(/
     . 0.20094800D+02,0.160D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.13610800D+02,0.160D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.27378670D+03,0.160D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.16795130D+03,0.160D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.11711210D+03,0.160D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.81091900D+02,0.160D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.57673400D+02,0.160D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.44147000D+02,0.160D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.33726400D+02,0.160D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.26094000D+02,0.160D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.32859900D+03,0.160D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.26466650D+03,0.160D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.24850080D+03,0.160D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.20053740D+03,0.160D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.15948980D+03,0.160D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.13400660D+03,0.160D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.16705200D+02,0.170D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.11630200D+02,0.170D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.21066260D+03,0.170D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.13298080D+03,0.170D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    701:    800)=(/
     . 0.94761200D+02,0.170D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.66840700D+02,0.170D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.48262400D+02,0.170D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.37368800D+02,0.170D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.28844500D+02,0.170D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.22512100D+02,0.170D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.25351360D+03,0.170D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.20849780D+03,0.170D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.19775940D+03,0.170D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.16186860D+03,0.170D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.13047250D+03,0.170D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.11070060D+03,0.170D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.92346000D+02,0.170D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.13870000D+02,0.180D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.99130000D+01,0.180D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16354970D+03,0.180D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.10572290D+03,0.180D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.76794900D+02,0.180D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.55089800D+02,0.180D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.40343500D+02,0.180D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    801:    900)=(/
     . 0.31578300D+02,0.180D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.24617800D+02,0.180D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.19377400D+02,0.180D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.19734400D+03,0.180D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.16510060D+03,0.180D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.15795950D+03,0.180D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.13089270D+03,0.180D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.10676980D+03,0.180D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.91401400D+02,0.180D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.76938300D+02,0.180D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.64646200D+02,0.180D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.76237600D+02,0.190D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.44041100D+02,0.190D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.23871574D+04,0.190D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.97231970D+03,0.190D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.55419800D+03,0.190D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.33226940D+03,0.190D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.21320010D+03,0.190D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.15214200D+03,0.190D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10964390D+03,0.190D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(    901:   1000)=(/
     . 0.81086100D+02,0.190D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.27986124D+04,0.190D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.16420587D+04,0.190D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.13879361D+04,0.190D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.96762830D+03,0.190D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.68449680D+03,0.190D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.53523840D+03,0.190D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.41315120D+03,0.190D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.32211550D+03,0.190D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.49835009D+04,0.190D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.65818000D+02,0.200D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.39070100D+02,0.200D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16144719D+04,0.200D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.75790700D+03,0.200D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.45484390D+03,0.200D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.28170350D+03,0.200D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.18454980D+03,0.200D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.13338470D+03,0.200D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.97082400D+02,0.200D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.72307200D+02,0.200D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1001:   1100)=(/
     . 0.19077081D+04,0.200D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.12525932D+04,0.200D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.10888420D+04,0.200D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.79063470D+03,0.200D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.57546270D+03,0.200D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.45684430D+03,0.200D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.35747370D+03,0.200D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.28168230D+03,0.200D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.32404393D+04,0.200D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.23526862D+04,0.200D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.54966900D+02,0.210D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.32899500D+02,0.210D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.12781183D+04,0.210D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.61733580D+03,0.210D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.37504180D+03,0.210D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.23419500D+03,0.210D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.15429470D+03,0.210D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.11193590D+03,0.210D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.81724200D+02,0.210D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.61015400D+02,0.210D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1101:   1200)=(/
     . 0.15125338D+04,0.210D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.10155454D+04,0.210D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.88860250D+03,0.210D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.65120400D+03,0.210D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.47727970D+03,0.210D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.38041070D+03,0.210D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.29876860D+03,0.210D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.23614170D+03,0.210D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.25499412D+04,0.210D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.18887902D+04,0.210D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.15224676D+04,0.210D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.53687500D+02,0.220D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.32531600D+02,0.220D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.11929128D+04,0.220D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.58748980D+03,0.220D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.36108650D+03,0.220D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.22757230D+03,0.220D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.15101990D+03,0.220D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.11014520D+03,0.220D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.80797500D+02,0.220D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1201:   1300)=(/
     . 0.60559400D+02,0.220D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.14131570D+04,0.220D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.96298310D+03,0.220D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.84746150D+03,0.220D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.62623530D+03,0.220D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.46232470D+03,0.220D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.37026310D+03,0.220D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.29218530D+03,0.220D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.23192080D+03,0.220D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.23746690D+04,0.220D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.17795162D+04,0.220D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.14382841D+04,0.220D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.13619185D+04,0.220D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.49481900D+02,0.230D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.30185100D+02,0.230D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.10690426D+04,0.230D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.53334990D+03,0.230D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.33010230D+03,0.230D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.20914500D+03,0.230D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.13935120D+03,0.230D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1301:   1400)=(/
     . 0.10193250D+03,0.230D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.74967100D+02,0.230D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.56310800D+02,0.230D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.12673139D+04,0.230D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.87225790D+03,0.230D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.77034320D+03,0.230D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.57211290D+03,0.230D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.42414700D+03,0.230D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.34060200D+03,0.230D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.26948630D+03,0.230D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.21440020D+03,0.230D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.21241985D+04,0.230D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.16049178D+04,0.230D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.12995197D+04,0.230D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.12323235D+04,0.230D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.11160984D+04,0.230D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.39122100D+02,0.240D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.24146300D+02,0.240D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.84409360D+03,0.240D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.41816350D+03,0.240D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1401:   1500)=(/
     . 0.25930210D+03,0.240D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.16498820D+03,0.240D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11048610D+03,0.240D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.81200000D+02,0.240D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.60009900D+02,0.240D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.45282000D+02,0.240D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.10004652D+04,0.240D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.68440150D+03,0.240D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.60440710D+03,0.240D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.44922160D+03,0.240D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.33383800D+03,0.240D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.26880290D+03,0.240D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.21336680D+03,0.240D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.17034650D+03,0.240D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.16836701D+04,0.240D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.12630809D+04,0.240D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.10216871D+04,0.240D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.96885650D+03,0.240D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.87738550D+03,0.240D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.69074250D+03,0.240D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1501:   1600)=(/
     . 0.43002800D+02,0.250D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.26497800D+02,0.250D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.89197560D+03,0.250D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.45336860D+03,0.250D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.28347440D+03,0.250D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.18100350D+03,0.250D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12132330D+03,0.250D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.89134600D+02,0.250D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.65811200D+02,0.250D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.49595900D+02,0.250D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.10585103D+04,0.250D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.73904110D+03,0.250D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.65607380D+03,0.250D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.49081560D+03,0.250D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.36612040D+03,0.250D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.29517370D+03,0.250D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.23445330D+03,0.250D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.18717280D+03,0.250D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.17680322D+04,0.250D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.13514785D+04,0.250D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1601:   1700)=(/
     . 0.10971539D+04,0.250D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.10426625D+04,0.250D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.94560720D+03,0.250D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.74331790D+03,0.250D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.80274840D+03,0.250D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.33911000D+02,0.260D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.21175000D+02,0.260D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.69845390D+03,0.260D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.35353580D+03,0.260D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.22175470D+03,0.260D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.14234670D+03,0.260D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.95978200D+02,0.260D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.70894200D+02,0.260D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.52631000D+02,0.260D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.39865900D+02,0.260D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.82889360D+03,0.260D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.57651210D+03,0.260D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.51208230D+03,0.260D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.38374450D+03,0.260D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.28716060D+03,0.260D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1701:   1800)=(/
     . 0.23226250D+03,0.260D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.18518230D+03,0.260D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.14843190D+03,0.260D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.13889522D+04,0.260D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.10565193D+04,0.260D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.85717300D+03,0.260D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.81484020D+03,0.260D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.73905420D+03,0.260D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.58181140D+03,0.260D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.62754030D+03,0.260D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.49133490D+03,0.260D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.36323400D+02,0.270D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22723300D+02,0.270D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.70153240D+03,0.270D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.36919280D+03,0.270D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.23486930D+03,0.270D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.15187030D+03,0.270D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10275030D+03,0.270D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.75991200D+02,0.270D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.56430700D+02,0.270D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1801:   1900)=(/
     . 0.42727000D+02,0.270D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.83418260D+03,0.270D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.59833020D+03,0.270D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.53597060D+03,0.270D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.40599070D+03,0.270D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.30592560D+03,0.270D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.24821160D+03,0.270D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.19835700D+03,0.270D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.15919570D+03,0.270D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.13829771D+04,0.270D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.10817690D+04,0.270D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.88245030D+03,0.270D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.84183350D+03,0.270D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.76531780D+03,0.270D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.60141780D+03,0.270D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.65196880D+03,0.270D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.50977640D+03,0.270D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.53277940D+03,0.270D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.37159600D+02,0.280D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.23079200D+02,0.280D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   1901:   2000)=(/
     . 0.73885800D+03,0.280D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.38391400D+03,0.280D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.24241740D+03,0.280D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.15585070D+03,0.280D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10498340D+03,0.280D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.77401000D+02,0.280D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.57324800D+02,0.280D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.43312900D+02,0.280D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.87793540D+03,0.280D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.62363050D+03,0.280D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.55653890D+03,0.280D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.41935930D+03,0.280D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.31456980D+03,0.280D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.25446830D+03,0.280D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.20277050D+03,0.280D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.16232640D+03,0.280D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.14584501D+04,0.280D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.11321074D+04,0.280D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.92189900D+03,0.280D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.87809390D+03,0.280D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2001:   2100)=(/
     . 0.79751950D+03,0.280D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.62664720D+03,0.280D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.67845310D+03,0.280D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.53032210D+03,0.280D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.55308340D+03,0.280D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.57474360D+03,0.280D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.28594000D+02,0.290D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.18021600D+02,0.290D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.56945260D+03,0.290D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.29279550D+03,0.290D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.18517410D+03,0.290D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.11963500D+03,0.290D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.81085500D+02,0.290D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.60133500D+02,0.290D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.44809800D+02,0.290D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.34054400D+02,0.290D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.67647730D+03,0.290D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.47624260D+03,0.290D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.42477230D+03,0.290D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.32019130D+03,0.290D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2101:   2200)=(/
     . 0.24079740D+03,0.290D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.19540750D+03,0.290D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.15631610D+03,0.290D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.12567760D+03,0.290D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.11299518D+04,0.290D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.86836740D+03,0.290D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.70607200D+03,0.290D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.67241280D+03,0.290D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.61057000D+03,0.290D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.48069380D+03,0.290D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.51930780D+03,0.290D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.40672680D+03,0.290D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.42308770D+03,0.290D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.43963650D+03,0.290D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.33718080D+03,0.290D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.29868900D+02,0.300D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.18969500D+02,0.300D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.54091600D+03,0.300D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.29331060D+03,0.300D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.18962930D+03,0.300D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2201:   2300)=(/
     . 0.12410320D+03,0.300D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.84731100D+02,0.300D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.63077400D+02,0.300D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.47112200D+02,0.300D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.35842700D+02,0.300D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.64434080D+03,0.300D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.47291430D+03,0.300D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.42716100D+03,0.300D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.32728100D+03,0.300D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.24897430D+03,0.300D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.20324270D+03,0.300D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.16338480D+03,0.300D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.13181190D+03,0.300D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.10625928D+04,0.300D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.84685270D+03,0.300D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.69367870D+03,0.300D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.66410090D+03,0.300D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.60506230D+03,0.300D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.47555940D+03,0.300D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.51709100D+03,0.300D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2301:   2400)=(/
     . 0.40455580D+03,0.300D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.42487900D+03,0.300D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.44009000D+03,0.300D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.33664930D+03,0.300D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.34052130D+03,0.300D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.35169700D+02,0.310D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22045800D+02,0.310D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.65674410D+03,0.310D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.35111410D+03,0.310D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.22539330D+03,0.310D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.14655440D+03,0.310D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.99440700D+02,0.310D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.73625300D+02,0.310D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.54678200D+02,0.310D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.41368100D+02,0.310D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.78135240D+03,0.310D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.56716380D+03,0.310D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.51058540D+03,0.310D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.38926560D+03,0.310D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.29479250D+03,0.310D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2401:   2500)=(/
     . 0.23981830D+03,0.310D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.19205780D+03,0.310D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.15434230D+03,0.310D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.12928121D+04,0.310D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.10198835D+04,0.310D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.83374240D+03,0.310D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.79686170D+03,0.310D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.72525140D+03,0.310D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.56976450D+03,0.310D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.61883870D+03,0.310D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.48378150D+03,0.310D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.50713160D+03,0.310D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.52581620D+03,0.310D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.40196130D+03,0.310D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.40545650D+03,0.310D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.48375160D+03,0.310D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.31817000D+02,0.320D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.20431800D+02,0.320D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.52792680D+03,0.320D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.29842200D+03,0.320D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2501:   2600)=(/
     . 0.19734480D+03,0.320D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.13109540D+03,0.320D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.90332800D+02,0.320D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.67593200D+02,0.320D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.50641200D+02,0.320D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.38574600D+02,0.320D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.63010410D+03,0.320D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.47737440D+03,0.320D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.43650600D+03,0.320D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.33983280D+03,0.320D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.26182350D+03,0.320D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.21531010D+03,0.320D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.17419690D+03,0.320D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.14120630D+03,0.320D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.10326651D+04,0.320D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.84336440D+03,0.320D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.69470240D+03,0.320D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.66837860D+03,0.320D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.61076390D+03,0.320D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.47996390D+03,0.320D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2601:   2700)=(/
     . 0.52418480D+03,0.320D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.41021060D+03,0.320D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.43385080D+03,0.320D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.44798680D+03,0.320D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.34242610D+03,0.320D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.34998850D+03,0.320D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.41595300D+03,0.320D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.36354740D+03,0.320D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.27788400D+02,0.330D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.18328400D+02,0.330D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.41515320D+03,0.330D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.24548310D+03,0.330D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.16690600D+03,0.330D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.11326160D+03,0.330D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.79308600D+02,0.330D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.60028900D+02,0.330D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.45418000D+02,0.330D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.34868600D+02,0.330D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.49693380D+03,0.330D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.38949270D+03,0.330D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2701:   2800)=(/
     . 0.36119130D+03,0.330D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.28659090D+03,0.330D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.22447740D+03,0.330D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.18663480D+03,0.330D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.15260350D+03,0.330D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.12485610D+03,0.330D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.81065540D+03,0.330D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.67900440D+03,0.330D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.56269470D+03,0.330D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.54467970D+03,0.330D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.49949700D+03,0.330D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.39319220D+03,0.330D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.43091460D+03,0.330D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.33800960D+03,0.330D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.35971500D+03,0.330D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.37003590D+03,0.330D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.28333230D+03,0.330D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.29250300D+03,0.330D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.34635080D+03,0.330D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.30710100D+03,0.330D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2801:   2900)=(/
     . 0.26294980D+03,0.330D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.25309800D+02,0.340D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.17024300D+02,0.340D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.35454290D+03,0.340D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.21502380D+03,0.340D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.14880080D+03,0.340D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.10243460D+03,0.340D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.72540300D+02,0.340D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.55362700D+02,0.340D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.42192300D+02,0.340D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.32584300D+02,0.340D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.42518640D+03,0.340D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.33957420D+03,0.340D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.31761820D+03,0.340D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.25500990D+03,0.340D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.20190190D+03,0.340D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.16913080D+03,0.340D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.13931630D+03,0.340D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.11474490D+03,0.340D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.69291160D+03,0.340D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   2901:   3000)=(/
     . 0.58796470D+03,0.340D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.48887150D+03,0.340D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.47503480D+03,0.340D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.43657180D+03,0.340D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.34429560D+03,0.340D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.37782760D+03,0.340D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.29703960D+03,0.340D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.31701740D+03,0.340D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.32534190D+03,0.340D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.24963850D+03,0.340D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.25904590D+03,0.340D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.30595010D+03,0.340D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.27365300D+03,0.340D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.23634730D+03,0.340D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.21367380D+03,0.340D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.22483400D+02,0.350D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.15455300D+02,0.350D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.29478970D+03,0.350D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.18337420D+03,0.350D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.12924950D+03,0.350D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3001:   3100)=(/
     . 0.90342400D+02,0.350D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.64763200D+02,0.350D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.49879500D+02,0.350D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.38322500D+02,0.350D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.29795800D+02,0.350D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.35428690D+03,0.350D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.28827360D+03,0.350D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.27200980D+03,0.350D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.22105370D+03,0.350D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.17699300D+03,0.350D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.14945630D+03,0.350D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.12409090D+03,0.350D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.10294710D+03,0.350D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.57723180D+03,0.350D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.49597540D+03,0.350D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.41374680D+03,0.350D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.40365760D+03,0.350D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.37180710D+03,0.350D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.29391850D+03,0.350D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.32284330D+03,0.350D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3101:   3200)=(/
     . 0.25453060D+03,0.350D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.27230530D+03,0.350D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.27877050D+03,0.350D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.21450590D+03,0.350D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.22363480D+03,0.350D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.26334580D+03,0.350D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.23762950D+03,0.350D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.20707720D+03,0.350D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.18836050D+03,0.350D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.16712970D+03,0.350D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.19818200D+02,0.360D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.13921100D+02,0.360D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.24455540D+03,0.360D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.15556160D+03,0.360D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.11153710D+03,0.360D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.79108000D+02,0.360D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.57389500D+02,0.360D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.44600300D+02,0.360D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.34545200D+02,0.360D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.27043000D+02,0.360D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3201:   3300)=(/
     . 0.29455740D+03,0.360D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.24359650D+03,0.360D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.23169040D+03,0.360D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.19039340D+03,0.360D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.15405750D+03,0.360D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.13109280D+03,0.360D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.10968390D+03,0.360D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.91643000D+02,0.360D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.48024720D+03,0.360D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.41697770D+03,0.360D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.34884740D+03,0.360D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.34162730D+03,0.360D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.31532510D+03,0.360D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.24994130D+03,0.360D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.27464190D+03,0.360D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.21720710D+03,0.360D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.23275940D+03,0.360D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.23774470D+03,0.360D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.18353470D+03,0.360D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.19204840D+03,0.360D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3301:   3400)=(/
     . 0.22545370D+03,0.360D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.20505980D+03,0.360D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.18018180D+03,0.360D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.16484940D+03,0.360D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.14718300D+03,0.360D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.13040170D+03,0.360D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.85949900D+02,0.370D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.50049100D+02,0.370D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.26473331D+04,0.370D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.10827052D+04,0.370D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.62008780D+03,0.370D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.37353840D+03,0.370D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.24069400D+03,0.370D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.17233980D+03,0.370D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12458790D+03,0.370D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.92382700D+02,0.370D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.31041016D+04,0.370D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.18264648D+04,0.370D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.15469229D+04,0.370D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.10820563D+04,0.370D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3401:   3500)=(/
     . 0.76813350D+03,0.370D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.60222210D+03,0.370D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.46615650D+03,0.370D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.36440670D+03,0.370D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.55302806D+04,0.370D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.35994349D+04,0.370D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.28340920D+04,0.370D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.26412435D+04,0.370D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.23637175D+04,0.370D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.18740326D+04,0.370D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.19687631D+04,0.370D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.15471982D+04,0.370D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.15418997D+04,0.370D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.16251034D+04,0.370D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.12594427D+04,0.370D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.11862631D+04,0.370D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.14423807D+04,0.370D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.11551526D+04,0.370D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.90942570D+03,0.370D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.77892040D+03,0.370D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3501:   3600)=(/
     . 0.65036060D+03,0.370D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.54231600D+03,0.370D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.61387755D+04,0.370D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.78390100D+02,0.380D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.46665800D+02,0.380D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.19442260D+04,0.380D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.90392650D+03,0.380D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.54157290D+03,0.380D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.33545970D+03,0.380D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.21996080D+03,0.380D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.15914600D+03,0.380D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.11596470D+03,0.380D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.86462700D+02,0.380D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.22961906D+04,0.380D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.14958141D+04,0.380D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.12985356D+04,0.380D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.94141210D+03,0.380D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.68496320D+03,0.380D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.54396270D+03,0.380D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.42589970D+03,0.380D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3601:   3700)=(/
     . 0.33586900D+03,0.380D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.39153529D+04,0.380D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.28194935D+04,0.380D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.22604217D+04,0.380D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.21283951D+04,0.380D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.19186941D+04,0.380D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.15113043D+04,0.380D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.16147190D+04,0.380D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.12632327D+04,0.380D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.12908718D+04,0.380D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.13513702D+04,0.380D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.10377284D+04,0.380D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.10096809D+04,0.380D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.12165138D+04,0.380D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.10044824D+04,0.380D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.80833700D+03,0.380D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.70005320D+03,0.380D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.59073260D+03,0.380D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.49691200D+03,0.380D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.43492577D+04,0.380D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3701:   3800)=(/
     . 0.33813672D+04,0.380D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.70057000D+02,0.390D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.42419500D+02,0.390D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.15853950D+04,0.390D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.77148440D+03,0.390D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.47243640D+03,0.390D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.29721710D+03,0.390D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19706110D+03,0.390D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.14366020D+03,0.390D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10534470D+03,0.390D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.78931600D+02,0.390D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.18768634D+04,0.390D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.12667602D+04,0.390D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11122980D+04,0.390D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.81954180D+03,0.390D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.60399160D+03,0.390D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.48337970D+03,0.390D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.38124620D+03,0.390D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.30251430D+03,0.390D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.31660625D+04,0.390D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3801:   3900)=(/
     . 0.23508018D+04,0.390D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.18967809D+04,0.390D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.17943180D+04,0.390D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.16224689D+04,0.390D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.12764352D+04,0.390D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.13714492D+04,0.390D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.10723265D+04,0.390D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11053016D+04,0.390D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.11535737D+04,0.390D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.88416480D+03,0.390D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.87069350D+03,0.390D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10455505D+04,0.390D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.87478360D+03,0.390D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.71175060D+03,0.390D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.62033340D+03,0.390D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.52682990D+03,0.390D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.44570130D+03,0.390D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.35209466D+04,0.390D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.28137007D+04,0.390D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.23658925D+04,0.390D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   3901:   4000)=(/
     . 0.63780100D+02,0.400D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.39108800D+02,0.400D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.13632842D+04,0.400D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.68152830D+03,0.400D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.42323020D+03,0.400D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.26904900D+03,0.400D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.17977770D+03,0.400D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.13178520D+03,0.400D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.97097700D+02,0.400D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.73031500D+02,0.400D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.16162863D+04,0.400D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.11138339D+04,0.400D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.98504940D+03,0.400D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.73318070D+03,0.400D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.54488820D+03,0.400D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.43838900D+03,0.400D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.34753340D+03,0.400D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.27699080D+03,0.400D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.27111542D+04,0.400D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.20485251D+04,0.400D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4001:   4100)=(/
     . 0.16591156D+04,0.400D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.15741401D+04,0.400D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.14260687D+04,0.400D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.11215489D+04,0.400D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.12087451D+04,0.400D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.94517130D+03,0.400D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.97897670D+03,0.400D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.10197589D+04,0.400D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.78111330D+03,0.400D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.77458710D+03,0.400D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.92819820D+03,0.400D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.78294420D+03,0.400D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.64155640D+03,0.400D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.56154740D+03,0.400D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.47900400D+03,0.400D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.40687270D+03,0.400D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.30176856D+04,0.400D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.24494723D+04,0.400D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.20726170D+04,0.400D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.18227181D+04,0.400D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4101:   4200)=(/
     . 0.58676800D+02,0.410D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.36341800D+02,0.410D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.12090304D+04,0.410D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.61398500D+03,0.410D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.38490720D+03,0.410D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.24652410D+03,0.410D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.16569430D+03,0.410D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.12198680D+03,0.410D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.90223400D+02,0.410D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.68076900D+02,0.410D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.14346641D+04,0.410D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.10005663D+04,0.410D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.88903020D+03,0.410D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.66615070D+03,0.410D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.49797030D+03,0.410D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.40219740D+03,0.410D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.32006760D+03,0.410D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.25597690D+03,0.410D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.24006918D+04,0.410D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.18308523D+04,0.410D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4201:   4300)=(/
     . 0.14860620D+04,0.410D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.14126818D+04,0.410D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.12813349D+04,0.410D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.10078571D+04,0.410D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.10879837D+04,0.410D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.85106340D+03,0.410D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.88388900D+03,0.410D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.91953540D+03,0.410D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.70437890D+03,0.410D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.70135490D+03,0.410D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.83928280D+03,0.410D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.71168230D+03,0.410D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.58600840D+03,0.410D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.51450770D+03,0.410D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.44029990D+03,0.410D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.37513390D+03,0.410D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.26739344D+04,0.410D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.21882864D+04,0.410D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.18586377D+04,0.410D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.16384938D+04,0.410D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4301:   4400)=(/
     . 0.14752500D+04,0.410D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.46040600D+02,0.420D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.29161700D+02,0.420D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.89051260D+03,0.420D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.46330650D+03,0.420D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.29535920D+03,0.420D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.19195280D+03,0.420D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.13060450D+03,0.420D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.97067500D+02,0.420D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.72418600D+02,0.420D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.55048700D+02,0.420D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.10583899D+04,0.420D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.75166280D+03,0.420D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.67311930D+03,0.420D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.51023520D+03,0.420D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.38558950D+03,0.420D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.31386570D+03,0.420D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.25177230D+03,0.420D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.20285720D+03,0.420D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.17658946D+04,0.420D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4401:   4500)=(/
     . 0.13654837D+04,0.420D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.11120098D+04,0.420D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.10606255D+04,0.420D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.96394340D+03,0.420D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.75899550D+03,0.420D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.82093130D+03,0.420D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.64312470D+03,0.420D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.67034900D+03,0.420D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.69583480D+03,0.420D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.53365350D+03,0.420D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.53452070D+03,0.420D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.63792330D+03,0.420D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.54578450D+03,0.420D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.45341860D+03,0.420D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.40049980D+03,0.420D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.34498260D+03,0.420D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.29579940D+03,0.420D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.19694796D+04,0.420D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.16315424D+04,0.420D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.13940976D+04,0.420D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4501:   4600)=(/
     . 0.12339095D+04,0.420D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.11140924D+04,0.420D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.84589720D+03,0.420D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.51052700D+02,0.430D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.32058800D+02,0.430D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.10116099D+04,0.430D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.52142490D+03,0.430D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.33032570D+03,0.430D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.21347990D+03,0.430D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.14456970D+03,0.430D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.10705880D+03,0.430D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.79612100D+02,0.430D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.60352100D+02,0.430D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.12015234D+04,0.430D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.84734970D+03,0.430D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.75661950D+03,0.430D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.57105010D+03,0.430D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.42976770D+03,0.430D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.34877440D+03,0.430D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.27891230D+03,0.430D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4601:   4700)=(/
     . 0.22407940D+03,0.430D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.20076137D+04,0.430D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.15434258D+04,0.430D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.12553446D+04,0.430D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.11958434D+04,0.430D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.10860231D+04,0.430D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.85474740D+03,0.430D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.92387430D+03,0.430D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.72332020D+03,0.430D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.75296780D+03,0.430D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.78224830D+03,0.430D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.59961920D+03,0.430D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.59931410D+03,0.430D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.71598110D+03,0.430D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.61053270D+03,0.430D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.50550910D+03,0.430D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.44547780D+03,0.430D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.38275910D+03,0.430D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.32738270D+03,0.430D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.22379665D+04,0.430D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4701:   4800)=(/
     . 0.18443774D+04,0.430D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.15723759D+04,0.430D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.13895979D+04,0.430D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.12533465D+04,0.430D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.94964900D+03,0.430D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.10670169D+04,0.430D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.39574500D+02,0.440D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.25462200D+02,0.440D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.73055330D+03,0.440D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.38726810D+03,0.440D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.24993820D+03,0.440D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.16412790D+03,0.440D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11263780D+03,0.440D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.84272500D+02,0.440D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.63259900D+02,0.440D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.48342900D+02,0.440D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.86937740D+03,0.440D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.62621040D+03,0.440D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.56407160D+03,0.440D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.43121320D+03,0.440D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4801:   4900)=(/
     . 0.32840720D+03,0.440D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.26878240D+03,0.440D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.21680700D+03,0.440D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.17558760D+03,0.440D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.14473048D+04,0.440D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.11311769D+04,0.440D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.92358110D+03,0.440D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.88314920D+03,0.440D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.80388070D+03,0.440D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.63343940D+03,0.440D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.68617720D+03,0.440D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.53814350D+03,0.440D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.56248000D+03,0.440D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.58290140D+03,0.440D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.44742590D+03,0.440D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.45015430D+03,0.440D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.53610930D+03,0.440D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.46167950D+03,0.440D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.38598830D+03,0.440D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.34238140D+03,0.440D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   4901:   5000)=(/
     . 0.29626680D+03,0.440D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.25515160D+03,0.440D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.16158387D+04,0.440D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.13511988D+04,0.440D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.11599071D+04,0.440D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.10297665D+04,0.440D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.93174450D+03,0.440D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.71028370D+03,0.440D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.79619510D+03,0.440D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.59819880D+03,0.440D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.43166100D+02,0.450D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.27574500D+02,0.450D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.79420060D+03,0.450D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.42441200D+03,0.450D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.27371950D+03,0.450D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.17927080D+03,0.450D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12264260D+03,0.450D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.91495900D+02,0.450D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.68488800D+02,0.450D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.52207200D+02,0.450D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5001:   5100)=(/
     . 0.94542210D+03,0.450D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.68566280D+03,0.450D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.61792440D+03,0.450D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.47237380D+03,0.450D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.35925470D+03,0.450D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.29352140D+03,0.450D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.23627500D+03,0.450D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.19093520D+03,0.450D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.15674954D+04,0.450D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.12346013D+04,0.450D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.10091933D+04,0.450D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.96523080D+03,0.450D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.87880270D+03,0.450D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.69163140D+03,0.450D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.75032510D+03,0.450D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.58775440D+03,0.450D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.61543640D+03,0.450D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.63776340D+03,0.450D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.48875010D+03,0.450D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.49263190D+03,0.450D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5101:   5200)=(/
     . 0.58677320D+03,0.450D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.50544520D+03,0.450D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.42219710D+03,0.450D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.37406320D+03,0.450D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.32319410D+03,0.450D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.27786800D+03,0.450D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.17497615D+04,0.450D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.14735487D+04,0.450D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.12668436D+04,0.450D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.11253403D+04,0.450D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.10182915D+04,0.450D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.77583530D+03,0.450D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.86989620D+03,0.450D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.65317750D+03,0.450D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.71394270D+03,0.450D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.40237200D+02,0.460D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.25871600D+02,0.460D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.72242940D+03,0.460D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.39043100D+03,0.460D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.25334250D+03,0.460D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5201:   5300)=(/
     . 0.16671110D+03,0.460D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11447630D+03,0.460D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.85642700D+02,0.460D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.64270700D+02,0.460D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.49099000D+02,0.460D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.86062090D+03,0.460D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.62959120D+03,0.460D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.56914100D+03,0.460D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.43694630D+03,0.460D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.33352190D+03,0.460D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.27315680D+03,0.460D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.22040990D+03,0.460D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.17850210D+03,0.460D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.14240271D+04,0.460D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.11296670D+04,0.460D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.92485560D+03,0.460D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.88576570D+03,0.460D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.80712580D+03,0.460D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.63532570D+03,0.460D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.68996470D+03,0.460D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5301:   5400)=(/
     . 0.54065990D+03,0.460D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.56710440D+03,0.460D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.58718190D+03,0.460D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.45005590D+03,0.460D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.45480310D+03,0.460D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.54115010D+03,0.460D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.46770420D+03,0.460D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.39185280D+03,0.460D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.34783930D+03,0.460D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.30113900D+03,0.460D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.25939640D+03,0.460D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.15904415D+04,0.460D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.13479007D+04,0.460D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.11619289D+04,0.460D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.10338735D+04,0.460D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.93655280D+03,0.460D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.71494950D+03,0.460D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.80104420D+03,0.460D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.60279560D+03,0.460D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.65887530D+03,0.460D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5401:   5500)=(/
     . 0.60850410D+03,0.460D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.33541300D+02,0.470D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.21789600D+02,0.470D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.61414770D+03,0.470D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.32557750D+03,0.470D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.21068110D+03,0.470D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.13887580D+03,0.470D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.95713700D+02,0.470D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.71892600D+02,0.470D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.54190300D+02,0.470D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.41578000D+02,0.470D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.73108320D+03,0.470D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.52647760D+03,0.470D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.47457130D+03,0.470D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.36335850D+03,0.470D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.27735770D+03,0.470D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.22750240D+03,0.470D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.18398760D+03,0.470D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.14942690D+03,0.470D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.12184699D+04,0.470D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5501:   5600)=(/
     . 0.95149350D+03,0.470D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.77689140D+03,0.470D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.74320410D+03,0.470D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.67665530D+03,0.470D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.53368780D+03,0.470D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.57781270D+03,0.470D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.45363270D+03,0.470D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.47392440D+03,0.470D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.49097830D+03,0.470D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.37735310D+03,0.470D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.37956550D+03,0.470D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.45158870D+03,0.470D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.38930750D+03,0.470D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.32603710D+03,0.470D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.28964690D+03,0.470D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.25111890D+03,0.470D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.21673360D+03,0.470D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.13607517D+04,0.470D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.11369099D+04,0.470D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.97620250D+03,0.470D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5601:   5700)=(/
     . 0.86700560D+03,0.470D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.78481880D+03,0.470D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.59905300D+03,0.470D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.67117170D+03,0.470D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.50502690D+03,0.470D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.55108020D+03,0.470D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.50877420D+03,0.470D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.42674500D+03,0.470D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.35687900D+02,0.480D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.23156300D+02,0.480D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.62105360D+03,0.480D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.34041220D+03,0.480D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.22262730D+03,0.480D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.14741380D+03,0.480D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10173770D+03,0.480D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.76409200D+02,0.480D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.57550000D+02,0.480D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.44106200D+02,0.480D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.74057870D+03,0.480D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.54767210D+03,0.480D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5701:   5800)=(/
     . 0.49703370D+03,0.480D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.38367900D+03,0.480D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.29424650D+03,0.480D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.24176140D+03,0.480D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.19570440D+03,0.480D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.15896500D+03,0.480D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.12225553D+04,0.480D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.97842510D+03,0.480D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.80260200D+03,0.480D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.77003030D+03,0.480D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.70242130D+03,0.480D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.55309190D+03,0.480D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.60140530D+03,0.480D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.47153290D+03,0.480D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.49563130D+03,0.480D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.51262200D+03,0.480D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.39305100D+03,0.480D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.39845720D+03,0.480D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.47342030D+03,0.480D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.41090580D+03,0.480D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5801:   5900)=(/
     . 0.34560850D+03,0.480D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.30755390D+03,0.480D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.26697000D+03,0.480D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.23054930D+03,0.480D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.13663938D+04,0.480D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.11670471D+04,0.480D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.10094418D+04,0.480D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.90011540D+03,0.480D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.81654950D+03,0.480D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.62495060D+03,0.480D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.69953820D+03,0.480D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.52793870D+03,0.480D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.57701070D+03,0.480D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.53341340D+03,0.480D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.44587010D+03,0.480D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.46819000D+03,0.480D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.44041700D+02,0.490D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.27958600D+02,0.490D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.82896730D+03,0.490D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.43833960D+03,0.490D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   5901:   6000)=(/
     . 0.28117370D+03,0.490D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.18333680D+03,0.490D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12497980D+03,0.490D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.92996800D+02,0.490D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.69455800D+02,0.490D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.52851700D+02,0.490D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.98609990D+03,0.490D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.70935650D+03,0.490D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.63758320D+03,0.490D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.48553920D+03,0.490D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.36802750D+03,0.490D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.29998530D+03,0.490D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.24091040D+03,0.490D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.19426460D+03,0.490D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.16388153D+04,0.490D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.12812612D+04,0.490D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.10458401D+04,0.490D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.99909710D+03,0.490D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.90897530D+03,0.490D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.71527990D+03,0.490D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6001:   6100)=(/
     . 0.77527360D+03,0.490D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.60709640D+03,0.490D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.63472630D+03,0.490D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.65825260D+03,0.490D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.50438020D+03,0.490D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.50724520D+03,0.490D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.60471830D+03,0.490D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.51935010D+03,0.490D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.43261670D+03,0.490D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.38259680D+03,0.490D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.32992500D+03,0.490D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.28312690D+03,0.490D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.18285696D+04,0.490D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.15296862D+04,0.490D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.13118922D+04,0.490D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.11635963D+04,0.490D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.10518917D+04,0.490D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.79999940D+03,0.490D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.89764510D+03,0.490D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.67265160D+03,0.490D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6101:   6200)=(/
     . 0.73525250D+03,0.490D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.67809960D+03,0.490D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.56733030D+03,0.490D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.59335740D+03,0.490D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.75773970D+03,0.490D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.41533400D+02,0.500D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.26786200D+02,0.500D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.70845970D+03,0.500D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.39379910D+03,0.500D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.25871460D+03,0.500D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.17143670D+03,0.500D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11815090D+03,0.500D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.88540800D+02,0.500D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.66499600D+02,0.500D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.50811000D+02,0.500D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.84513480D+03,0.500D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.63194340D+03,0.500D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.57540180D+03,0.500D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.44576230D+03,0.500D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.34241690D+03,0.500D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6201:   6300)=(/
     . 0.28132550D+03,0.500D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.22756350D+03,0.500D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.18458450D+03,0.500D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.13902912D+04,0.500D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.11230616D+04,0.500D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.92301820D+03,0.500D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.88663180D+03,0.500D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.80941340D+03,0.500D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.63665610D+03,0.500D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.69374420D+03,0.500D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.54336290D+03,0.500D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.57281690D+03,0.500D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.59204640D+03,0.500D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.45320890D+03,0.500D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.46119710D+03,0.500D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.54805490D+03,0.500D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.47710340D+03,0.500D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.40194150D+03,0.500D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.35778710D+03,0.500D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.31050930D+03,0.500D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6301:   6400)=(/
     . 0.26795320D+03,0.500D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.15543698D+04,0.500D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.13385665D+04,0.500D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.11613674D+04,0.500D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.10372812D+04,0.500D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.94177920D+03,0.500D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.72129060D+03,0.500D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.80723580D+03,0.500D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.60961520D+03,0.500D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.66689540D+03,0.500D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.61675220D+03,0.500D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.51444770D+03,0.500D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.54154900D+03,0.500D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.68561380D+03,0.500D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.62756770D+03,0.500D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.37768100D+02,0.510D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.24858300D+02,0.510D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.58668880D+03,0.510D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.34030300D+03,0.510D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.22904210D+03,0.510D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6401:   6500)=(/
     . 0.15448510D+03,0.510D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10784360D+03,0.510D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.81535800D+02,0.510D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.61691200D+02,0.510D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.47407300D+02,0.510D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.70169030D+03,0.510D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.54198260D+03,0.510D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.49972920D+03,0.510D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.39368990D+03,0.510D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.30669120D+03,0.510D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.25424180D+03,0.510D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.20740430D+03,0.510D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.16945330D+03,0.510D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.11476700D+04,0.510D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.95065430D+03,0.510D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.78583230D+03,0.510D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.75894060D+03,0.510D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.69506830D+03,0.510D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.54719810D+03,0.510D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.59851680D+03,0.510D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6501:   6600)=(/
     . 0.46945690D+03,0.510D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.49804720D+03,0.510D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.51305850D+03,0.510D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.39302490D+03,0.510D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.40386210D+03,0.510D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.47839930D+03,0.510D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.42186160D+03,0.510D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.35955640D+03,0.510D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.32236080D+03,0.510D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.28180500D+03,0.510D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.24479020D+03,0.510D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.12861750D+04,0.510D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.11321713D+04,0.510D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.99240010D+03,0.510D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.89208770D+03,0.510D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.81343450D+03,0.510D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.62768490D+03,0.510D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.70051630D+03,0.510D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.53338040D+03,0.510D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.58333460D+03,0.510D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6601:   6700)=(/
     . 0.54091250D+03,0.510D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.45064270D+03,0.510D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.47657830D+03,0.510D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.59828910D+03,0.510D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.55335920D+03,0.510D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.49293790D+03,0.510D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.35484100D+02,0.520D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.23691100D+02,0.520D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.52125110D+03,0.520D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.30954390D+03,0.520D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.21148980D+03,0.520D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.14430320D+03,0.520D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10161240D+03,0.520D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.77297000D+02,0.520D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.58788100D+02,0.520D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.45361300D+02,0.520D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.62440760D+03,0.520D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.49087600D+03,0.520D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.45604000D+03,0.520D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.36295180D+03,0.520D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6701:   6800)=(/
     . 0.28527790D+03,0.520D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.23790180D+03,0.520D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.19518610D+03,0.520D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.16026740D+03,0.520D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.10193121D+04,0.520D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.85518820D+03,0.520D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.70913030D+03,0.520D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.68712350D+03,0.520D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.63049010D+03,0.520D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.49691430D+03,0.520D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.54441560D+03,0.520D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.42764390D+03,0.520D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.45508360D+03,0.520D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.46784930D+03,0.520D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.35881670D+03,0.520D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.37059360D+03,0.520D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.43811020D+03,0.520D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.38929970D+03,0.520D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.33422340D+03,0.520D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.30105450D+03,0.520D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6801:   6900)=(/
     . 0.26445160D+03,0.520D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.23074260D+03,0.520D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.11441913D+04,0.520D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.10183413D+04,0.520D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.89780430D+03,0.520D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.81010280D+03,0.520D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.74062110D+03,0.520D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.57429320D+03,0.520D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.63974650D+03,0.520D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.48969560D+03,0.520D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.53521890D+03,0.520D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.49709590D+03,0.520D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.41415120D+03,0.520D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.43888610D+03,0.520D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.54812670D+03,0.520D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.50996980D+03,0.520D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.45710570D+03,0.520D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.42553550D+03,0.520D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.32517100D+02,0.530D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22081300D+02,0.530D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   6901:   7000)=(/
     . 0.44985120D+03,0.530D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.27373980D+03,0.530D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.19010940D+03,0.530D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.13140510D+03,0.530D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.93456200D+02,0.530D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.71605900D+02,0.530D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.54799000D+02,0.530D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.42495400D+02,0.530D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.53985360D+03,0.530D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.43217920D+03,0.530D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.40476310D+03,0.530D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.32569120D+03,0.530D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.25851210D+03,0.530D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.21703370D+03,0.530D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.17923060D+03,0.530D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.14802160D+03,0.530D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.88017410D+03,0.530D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.74793060D+03,0.530D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.62218410D+03,0.530D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.60505080D+03,0.530D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7001:   7100)=(/
     . 0.55631660D+03,0.530D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.43916600D+03,0.530D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.48180770D+03,0.530D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.37922120D+03,0.530D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.40469290D+03,0.530D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.41513030D+03,0.530D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.31896420D+03,0.530D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.33106510D+03,0.530D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.39045420D+03,0.530D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.34977600D+03,0.530D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.30267430D+03,0.530D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.27406300D+03,0.530D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.24205560D+03,0.530D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.21228200D+03,0.530D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.98989210D+03,0.530D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.89067230D+03,0.530D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.79002570D+03,0.530D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.71573180D+03,0.530D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.65622760D+03,0.530D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.51167720D+03,0.530D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7101:   7200)=(/
     . 0.56879090D+03,0.530D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.43799920D+03,0.530D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.47824810D+03,0.530D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.44496620D+03,0.530D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.37093440D+03,0.530D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.39376550D+03,0.530D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.48897090D+03,0.530D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.45771560D+03,0.530D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.41298520D+03,0.530D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.38609970D+03,0.530D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.35196670D+03,0.530D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.29605500D+02,0.540D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.20459400D+02,0.540D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.38699690D+03,0.540D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.24076890D+03,0.540D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.16985780D+03,0.540D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.11891780D+03,0.540D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.85429300D+02,0.540D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.65940300D+02,0.540D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.50790000D+02,0.540D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7201:   7300)=(/
     . 0.39595100D+02,0.540D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.46528170D+03,0.540D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.37861340D+03,0.540D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.35729600D+03,0.540D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.29049850D+03,0.540D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.23277860D+03,0.540D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.19673740D+03,0.540D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.16353680D+03,0.540D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.13585920D+03,0.540D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.75832530D+03,0.540D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.65153920D+03,0.540D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.54356310D+03,0.540D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.53043120D+03,0.540D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.48865220D+03,0.540D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.38650670D+03,0.540D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.42441250D+03,0.540D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.33482590D+03,0.540D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.35809540D+03,0.540D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.36655970D+03,0.540D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.28228880D+03,0.540D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7301:   7400)=(/
     . 0.29421380D+03,0.540D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.34613450D+03,0.540D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.31242650D+03,0.540D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.27241100D+03,0.540D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.24792750D+03,0.540D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.22015810D+03,0.540D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.19406990D+03,0.540D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.85452230D+03,0.540D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.77608590D+03,0.540D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.69223860D+03,0.540D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.62952300D+03,0.540D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.57878760D+03,0.540D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.45379980D+03,0.540D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.50338110D+03,0.540D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.38995320D+03,0.540D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.42526840D+03,0.540D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.39634680D+03,0.540D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.33076460D+03,0.540D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.35152850D+03,0.540D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.43409320D+03,0.540D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7401:   7500)=(/
     . 0.40859520D+03,0.540D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.37095720D+03,0.540D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.34822390D+03,0.540D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.31889050D+03,0.540D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.29022230D+03,0.540D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.10500960D+03,0.550D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.61318400D+02,0.550D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.32422404D+04,0.550D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.13162189D+04,0.550D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.75492430D+03,0.550D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.45569600D+03,0.550D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.29414830D+03,0.550D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.21086720D+03,0.550D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.15256720D+03,0.550D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.11317640D+03,0.550D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.37989439D+04,0.550D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.22209652D+04,0.550D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.18817164D+04,0.550D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.13170056D+04,0.550D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.93630690D+03,0.550D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7501:   7600)=(/
     . 0.73500610D+03,0.550D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.56967010D+03,0.550D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.44581710D+03,0.550D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.68083900D+04,0.550D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.43871669D+04,0.550D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.34508369D+04,0.550D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.32158544D+04,0.550D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.28775279D+04,0.550D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.22830674D+04,0.550D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.23963445D+04,0.550D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.18842824D+04,0.550D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.18757209D+04,0.550D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.19768609D+04,0.550D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.15334063D+04,0.550D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.14430004D+04,0.550D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.17555105D+04,0.550D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.14062206D+04,0.550D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.11083145D+04,0.550D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.95019750D+03,0.550D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.79421840D+03,0.550D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7601:   7700)=(/
     . 0.66295560D+03,0.550D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.75604361D+04,0.550D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.53051627D+04,0.550D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.42896097D+04,0.550D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.36748556D+04,0.550D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.32563633D+04,0.550D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.23987520D+04,0.550D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.27260486D+04,0.550D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.19683066D+04,0.550D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.21299275D+04,0.550D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.19358392D+04,0.550D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.16577829D+04,0.550D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.16630447D+04,0.550D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.22264867D+04,0.550D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.18919207D+04,0.550D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.15665042D+04,0.550D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.13945709D+04,0.550D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.12075672D+04,0.550D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.10433955D+04,0.550D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.93307294D+04,0.550D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7701:   7800)=(/
     . 0.99457900D+02,0.560D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.59114100D+02,0.560D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.25515260D+04,0.560D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.11604419D+04,0.560D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.69068520D+03,0.560D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.42636670D+03,0.560D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.27907420D+03,0.560D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.20174110D+03,0.560D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.14691740D+03,0.560D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.10950000D+03,0.560D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.30097233D+04,0.560D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.19263504D+04,0.560D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.16657662D+04,0.560D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.12012021D+04,0.560D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.87116470D+03,0.560D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.69086510D+03,0.560D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.54031600D+03,0.560D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.42579090D+03,0.560D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.51712978D+04,0.560D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.36591655D+04,0.560D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7801:   7900)=(/
     . 0.29244395D+04,0.560D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.27489797D+04,0.560D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.24751427D+04,0.560D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.19521126D+04,0.560D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.20794950D+04,0.560D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.16284040D+04,0.560D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.16569384D+04,0.560D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.17363987D+04,0.560D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.13357319D+04,0.560D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.12926630D+04,0.560D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.15597012D+04,0.560D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.12819152D+04,0.560D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.10285424D+04,0.560D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.88961470D+03,0.560D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.74984750D+03,0.560D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.63024360D+03,0.560D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.57435673D+04,0.560D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.43943607D+04,0.560D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.36394735D+04,0.560D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.31601776D+04,0.560D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   7901:   8000)=(/
     . 0.28195147D+04,0.560D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.20984813D+04,0.560D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.23739131D+04,0.560D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.17354827D+04,0.560D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.18901371D+04,0.560D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.17272738D+04,0.560D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.14605858D+04,0.560D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.14937369D+04,0.560D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.19640913D+04,0.560D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.17108832D+04,0.560D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.14425135D+04,0.560D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.12956354D+04,0.560D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.11317221D+04,0.560D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.98512660D+03,0.560D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.70164917D+04,0.560D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.57269887D+04,0.560D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.89101800D+02,0.570D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.53798200D+02,0.570D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.20850661D+04,0.570D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.99403160D+03,0.570D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8001:   8100)=(/
     . 0.60449150D+03,0.570D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.37879280D+03,0.570D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.25055770D+03,0.570D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.18240750D+03,0.570D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.13361230D+03,0.570D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.10002770D+03,0.570D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.24655965D+04,0.570D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.16371586D+04,0.570D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.14317496D+04,0.570D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.10491934D+04,0.570D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.77049240D+03,0.570D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.61555590D+03,0.570D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.48476910D+03,0.570D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.38423060D+03,0.570D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.41858968D+04,0.570D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.30598941D+04,0.570D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.24617619D+04,0.570D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.23247454D+04,0.570D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.20995853D+04,0.570D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.16534435D+04,0.570D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8101:   8200)=(/
     . 0.17717653D+04,0.570D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.13863132D+04,0.570D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.14234023D+04,0.570D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.14871454D+04,0.570D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.11414078D+04,0.570D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.11183973D+04,0.570D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.13447968D+04,0.570D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.11200021D+04,0.570D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.90836700D+03,0.570D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.79048550D+03,0.570D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.67038430D+03,0.570D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.56651010D+03,0.570D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.46537454D+04,0.570D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.36666556D+04,0.570D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.30693037D+04,0.570D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.26820879D+04,0.570D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.24019326D+04,0.570D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.17981970D+04,0.570D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.20296163D+04,0.570D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.14938895D+04,0.570D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8201:   8300)=(/
     . 0.16299126D+04,0.570D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.14934855D+04,0.570D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.12574297D+04,0.570D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.12959364D+04,0.570D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.16894085D+04,0.570D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.14890440D+04,0.570D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.12682622D+04,0.570D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.11455595D+04,0.570D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.10065104D+04,0.570D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.88082020D+03,0.570D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.56757434D+04,0.570D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.47544826D+04,0.570D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.39906172D+04,0.570D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.44510400D+02,0.580D+02,0.100D+01,0.27991000D+01,0.91180000D+00
     .,0.29308100D+02,0.580D+02,0.200D+01,0.27991000D+01,0.00000000D+00
     .,0.70433450D+03,0.580D+02,0.300D+01,0.27991000D+01,0.00000000D+00
     .,0.40374270D+03,0.580D+02,0.400D+01,0.27991000D+01,0.00000000D+00
     .,0.27061870D+03,0.580D+02,0.500D+01,0.27991000D+01,0.00000000D+00
     .,0.18221640D+03,0.580D+02,0.600D+01,0.27991000D+01,0.00000000D+00
     .,0.12713550D+03,0.580D+02,0.700D+01,0.27991000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(   8301:   8400)=(/
     . 0.96118900D+02,0.580D+02,0.800D+01,0.27991000D+01,0.00000000D+00
     .,0.72735900D+02,0.580D+02,0.900D+01,0.27991000D+01,0.00000000D+00
     .,0.55904800D+02,0.580D+02,0.100D+02,0.27991000D+01,0.00000000D+00
     .,0.84189860D+03,0.580D+02,0.110D+02,0.27991000D+01,0.00000000D+00
     .,0.64422200D+03,0.580D+02,0.120D+02,0.27991000D+01,0.00000000D+00
     .,0.59240470D+03,0.580D+02,0.130D+02,0.27991000D+01,0.00000000D+00
     .,0.46526310D+03,0.580D+02,0.140D+02,0.27991000D+01,0.00000000D+00
     .,0.36180150D+03,0.580D+02,0.150D+02,0.27991000D+01,0.00000000D+00
     .,0.29974470D+03,0.580D+02,0.160D+02,0.27991000D+01,0.00000000D+00
     .,0.24444680D+03,0.580D+02,0.170D+02,0.27991000D+01,0.00000000D+00
     .,0.19971380D+03,0.580D+02,0.180D+02,0.27991000D+01,0.00000000D+00
     .,0.13810183D+04,0.580D+02,0.190D+02,0.27991000D+01,0.00000000D+00
     .,0.11346748D+04,0.580D+02,0.200D+02,0.27991000D+01,0.00000000D+00
     .,0.93640680D+03,0.580D+02,0.210D+02,0.27991000D+01,0.00000000D+00
     .,0.90333060D+03,0.580D+02,0.220D+02,0.27991000D+01,0.00000000D+00
     .,0.82670470D+03,0.580D+02,0.230D+02,0.27991000D+01,0.00000000D+00
     .,0.65114400D+03,0.580D+02,0.240D+02,0.27991000D+01,0.00000000D+00
     .,0.71114230D+03,0.580D+02,0.250D+02,0.27991000D+01,0.00000000D+00
     .,0.55801770D+03,0.580D+02,0.260D+02,0.27991000D+01,0.00000000D+00
     .,0.59073870D+03,0.580D+02,0.270D+02,0.27991000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(   8401:   8500)=(/
     . 0.60892420D+03,0.580D+02,0.280D+02,0.27991000D+01,0.00000000D+00
     .,0.46681100D+03,0.580D+02,0.290D+02,0.27991000D+01,0.00000000D+00
     .,0.47833500D+03,0.580D+02,0.300D+02,0.27991000D+01,0.00000000D+00
     .,0.56687830D+03,0.580D+02,0.310D+02,0.27991000D+01,0.00000000D+00
     .,0.49862840D+03,0.580D+02,0.320D+02,0.27991000D+01,0.00000000D+00
     .,0.42429060D+03,0.580D+02,0.330D+02,0.27991000D+01,0.00000000D+00
     .,0.38016060D+03,0.580D+02,0.340D+02,0.27991000D+01,0.00000000D+00
     .,0.33218840D+03,0.580D+02,0.350D+02,0.27991000D+01,0.00000000D+00
     .,0.28850100D+03,0.580D+02,0.360D+02,0.27991000D+01,0.00000000D+00
     .,0.15470780D+04,0.580D+02,0.370D+02,0.27991000D+01,0.00000000D+00
     .,0.13520803D+04,0.580D+02,0.380D+02,0.27991000D+01,0.00000000D+00
     .,0.11820124D+04,0.580D+02,0.390D+02,0.27991000D+01,0.00000000D+00
     .,0.10609721D+04,0.580D+02,0.400D+02,0.27991000D+01,0.00000000D+00
     .,0.96662010D+03,0.580D+02,0.410D+02,0.27991000D+01,0.00000000D+00
     .,0.74511760D+03,0.580D+02,0.420D+02,0.27991000D+01,0.00000000D+00
     .,0.83183600D+03,0.580D+02,0.430D+02,0.27991000D+01,0.00000000D+00
     .,0.63266390D+03,0.580D+02,0.440D+02,0.27991000D+01,0.00000000D+00
     .,0.69156460D+03,0.580D+02,0.450D+02,0.27991000D+01,0.00000000D+00
     .,0.64096110D+03,0.580D+02,0.460D+02,0.27991000D+01,0.00000000D+00
     .,0.53459930D+03,0.580D+02,0.470D+02,0.27991000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(   8501:   8600)=(/
     . 0.56439100D+03,0.580D+02,0.480D+02,0.27991000D+01,0.00000000D+00
     .,0.70950090D+03,0.580D+02,0.490D+02,0.27991000D+01,0.00000000D+00
     .,0.65467230D+03,0.580D+02,0.500D+02,0.27991000D+01,0.00000000D+00
     .,0.58216180D+03,0.580D+02,0.510D+02,0.27991000D+01,0.00000000D+00
     .,0.53941670D+03,0.580D+02,0.520D+02,0.27991000D+01,0.00000000D+00
     .,0.48703330D+03,0.580D+02,0.530D+02,0.27991000D+01,0.00000000D+00
     .,0.43728340D+03,0.580D+02,0.540D+02,0.27991000D+01,0.00000000D+00
     .,0.18844554D+04,0.580D+02,0.550D+02,0.27991000D+01,0.00000000D+00
     .,0.17247415D+04,0.580D+02,0.560D+02,0.27991000D+01,0.00000000D+00
     .,0.15122504D+04,0.580D+02,0.570D+02,0.27991000D+01,0.00000000D+00
     .,0.68803530D+03,0.580D+02,0.580D+02,0.27991000D+01,0.27991000D+01
     .,0.88687700D+02,0.590D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.53152300D+02,0.590D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.22103168D+04,0.590D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.10189540D+04,0.590D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.61076150D+03,0.590D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.37910380D+03,0.590D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.24926330D+03,0.590D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.18083830D+03,0.590D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.13215840D+03,0.590D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8601:   8700)=(/
     . 0.98822000D+02,0.590D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.26090440D+04,0.590D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.16875419D+04,0.590D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.14644446D+04,0.590D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.10615213D+04,0.590D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.77317210D+03,0.590D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.61486520D+03,0.590D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.48225090D+03,0.590D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.38105030D+03,0.590D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.44737784D+04,0.590D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.31902086D+04,0.590D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.25547353D+04,0.590D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.24050561D+04,0.590D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.21676325D+04,0.590D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.17091137D+04,0.590D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.18237858D+04,0.590D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.14281039D+04,0.590D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.14570358D+04,0.590D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.15254141D+04,0.590D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.11729549D+04,0.590D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8701:   8800)=(/
     . 0.11394352D+04,0.590D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.13728649D+04,0.590D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.11331627D+04,0.590D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.91252630D+03,0.590D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.79102140D+03,0.590D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.66833280D+03,0.590D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.56301560D+03,0.590D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.49710778D+04,0.590D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.38289626D+04,0.590D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.31814405D+04,0.590D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.27679894D+04,0.590D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.24726905D+04,0.590D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.18440715D+04,0.590D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.20845975D+04,0.590D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.15276056D+04,0.590D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.16644640D+04,0.590D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.15224806D+04,0.590D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.12860441D+04,0.590D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.13182791D+04,0.590D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.17282162D+04,0.590D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8801:   8900)=(/
     . 0.15110459D+04,0.590D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.12783406D+04,0.590D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.11504200D+04,0.590D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.10070198D+04,0.590D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.87837980D+03,0.590D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.60738935D+04,0.590D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.49833126D+04,0.590D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.41503203D+04,0.590D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.15271461D+04,0.590D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.43422386D+04,0.590D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.85408000D+02,0.600D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.51295200D+02,0.600D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.20915068D+04,0.600D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.97461670D+03,0.600D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.58618960D+03,0.600D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.36465190D+03,0.600D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.24011390D+03,0.600D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.17436780D+03,0.600D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12753080D+03,0.600D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.95420200D+02,0.600D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   8901:   9000)=(/
     . 0.24706020D+04,0.600D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.16117831D+04,0.600D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.14013191D+04,0.600D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.10185098D+04,0.600D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.74324070D+03,0.600D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.59167520D+03,0.600D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.46450620D+03,0.600D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.36731630D+03,0.600D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.42163998D+04,0.600D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.30363662D+04,0.600D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.24350889D+04,0.600D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.22942857D+04,0.600D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.20689809D+04,0.600D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.16306018D+04,0.600D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.17421942D+04,0.600D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.13638456D+04,0.600D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.13940822D+04,0.600D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.14587399D+04,0.600D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.11209931D+04,0.600D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.10915722D+04,0.600D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9001:   9100)=(/
     . 0.13142306D+04,0.600D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.10872533D+04,0.600D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.87700660D+03,0.600D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.76089490D+03,0.600D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.64343050D+03,0.600D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.54243830D+03,0.600D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.46850846D+04,0.600D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.36420492D+04,0.600D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.30329183D+04,0.600D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.26420526D+04,0.600D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.23616974D+04,0.600D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.17631139D+04,0.600D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.19921534D+04,0.600D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.14616458D+04,0.600D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.15933696D+04,0.600D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.14581671D+04,0.600D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.12304969D+04,0.600D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.12633482D+04,0.600D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.16535039D+04,0.600D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.14488711D+04,0.600D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9101:   9200)=(/
     . 0.12277455D+04,0.600D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.11058143D+04,0.600D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.96879470D+03,0.600D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.84567030D+03,0.600D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.57167999D+04,0.600D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.47334185D+04,0.600D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.39519956D+04,0.600D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.14659695D+04,0.600D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.41259023D+04,0.600D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.39244211D+04,0.600D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.83331000D+02,0.610D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.50074800D+02,0.610D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.20312740D+04,0.610D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.94912550D+03,0.610D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.57141130D+03,0.610D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.35567120D+03,0.610D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.23429130D+03,0.610D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.17018170D+03,0.610D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12449460D+03,0.610D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.93163500D+02,0.610D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9201:   9300)=(/
     . 0.23998207D+04,0.610D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.15689885D+04,0.610D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.13648494D+04,0.610D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.99275070D+03,0.610D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.72481970D+03,0.610D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.57716960D+03,0.610D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.45323130D+03,0.610D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.35847210D+03,0.610D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.40920575D+04,0.610D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.29529794D+04,0.610D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.23691244D+04,0.610D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.22326503D+04,0.610D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.20137194D+04,0.610D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.15868512D+04,0.610D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.16960441D+04,0.610D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.13276064D+04,0.610D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.13577395D+04,0.610D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.14205045D+04,0.610D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.10914214D+04,0.610D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.10634898D+04,0.610D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9301:   9400)=(/
     . 0.12801762D+04,0.610D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.10597536D+04,0.610D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.85521770D+03,0.610D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.74216490D+03,0.610D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.62773420D+03,0.610D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.52930700D+03,0.610D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.45470720D+04,0.610D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.35414930D+04,0.610D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.29509303D+04,0.610D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.25714964D+04,0.610D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.22990481D+04,0.610D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.17168038D+04,0.610D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.19396215D+04,0.610D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.14235531D+04,0.610D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.15520522D+04,0.610D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.14205469D+04,0.610D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.11984194D+04,0.610D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.12309598D+04,0.610D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.16104142D+04,0.610D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.14119588D+04,0.610D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9401:   9500)=(/
     . 0.11970157D+04,0.610D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.10783854D+04,0.610D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.94498140D+03,0.610D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.82504730D+03,0.610D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.55474900D+04,0.610D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.46012171D+04,0.610D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.38440367D+04,0.610D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.14290690D+04,0.610D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.40113635D+04,0.610D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.38161118D+04,0.610D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.37109375D+04,0.610D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.81412300D+02,0.620D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.48940600D+02,0.620D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.19766955D+04,0.620D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.92581580D+03,0.620D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.55783800D+03,0.620D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.34739210D+03,0.620D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.22890650D+03,0.620D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.16630040D+03,0.620D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12167270D+03,0.620D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9501:   9600)=(/
     . 0.91061400D+02,0.620D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.23356474D+04,0.620D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.15299120D+04,0.620D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.13314786D+04,0.620D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.96910260D+03,0.620D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.70786040D+03,0.620D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.56378900D+03,0.620D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.44280950D+03,0.620D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.35028120D+03,0.620D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.39796309D+04,0.620D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.28770680D+04,0.620D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.23089962D+04,0.620D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.21764184D+04,0.620D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.19632723D+04,0.620D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.15469195D+04,0.620D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.16538773D+04,0.620D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.12944951D+04,0.620D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.13244770D+04,0.620D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.13855313D+04,0.620D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.10643798D+04,0.620D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9601:   9700)=(/
     . 0.10377490D+04,0.620D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.12489915D+04,0.620D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.10345024D+04,0.620D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.83516220D+03,0.620D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.72489870D+03,0.620D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.61324050D+03,0.620D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.51716170D+03,0.620D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.44222696D+04,0.620D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.34499906D+04,0.620D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.28761716D+04,0.620D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.25070805D+04,0.620D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.22418085D+04,0.620D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.16744360D+04,0.620D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.18915883D+04,0.620D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.13886668D+04,0.620D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.15142016D+04,0.620D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.13860622D+04,0.620D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.11690360D+04,0.620D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.12012473D+04,0.620D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.15709643D+04,0.620D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9701:   9800)=(/
     . 0.13780830D+04,0.620D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.11687524D+04,0.620D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.10531255D+04,0.620D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.92301940D+03,0.620D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.80600020D+03,0.620D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.53944846D+04,0.620D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.44810449D+04,0.620D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.37456921D+04,0.620D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.13951471D+04,0.620D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.39071923D+04,0.620D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.37175407D+04,0.620D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.36152067D+04,0.620D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.35220508D+04,0.620D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.79713800D+02,0.630D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.47936500D+02,0.630D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.19280810D+04,0.630D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.90511010D+03,0.630D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.54580150D+03,0.630D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.34005800D+03,0.630D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.22413830D+03,0.630D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9801:   9900)=(/
     . 0.16286380D+03,0.630D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.11917340D+03,0.630D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.89198800D+02,0.630D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.22784898D+04,0.630D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.14951792D+04,0.630D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.13018438D+04,0.630D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.94812880D+03,0.630D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.69283380D+03,0.630D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.55193900D+03,0.630D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.43358310D+03,0.630D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.34303070D+03,0.630D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.38794729D+04,0.630D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.28095233D+04,0.630D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.22555157D+04,0.630D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.21264190D+04,0.630D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.19184254D+04,0.630D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.15114156D+04,0.630D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.16164023D+04,0.630D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.12650643D+04,0.630D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.12949313D+04,0.630D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(   9901:  10000)=(/
     . 0.13544595D+04,0.630D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.10403490D+04,0.630D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.10148959D+04,0.630D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.12213030D+04,0.630D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.10121053D+04,0.630D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.81738880D+03,0.630D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.70960390D+03,0.630D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.60040640D+03,0.630D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.50640980D+03,0.630D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.43110961D+04,0.630D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.33685646D+04,0.630D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.28096885D+04,0.630D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.24498188D+04,0.630D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.21909387D+04,0.630D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.16367956D+04,0.630D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.18489097D+04,0.630D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.13576810D+04,0.630D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.14805878D+04,0.630D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.13554425D+04,0.630D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.11429352D+04,0.630D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10001:  10100)=(/
     . 0.11748699D+04,0.630D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.15359254D+04,0.630D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.13480216D+04,0.630D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.11436919D+04,0.630D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.10307380D+04,0.630D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.90356300D+03,0.630D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.78913200D+03,0.630D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.52582068D+04,0.630D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.43740826D+04,0.630D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.36582120D+04,0.630D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.13650615D+04,0.630D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.38144921D+04,0.630D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.36298268D+04,0.630D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.35300228D+04,0.630D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.34391601D+04,0.630D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.33583122D+04,0.630D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.64188000D+02,0.640D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.39578600D+02,0.640D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.14077335D+04,0.640D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.68992870D+03,0.640D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10101:  10200)=(/
     . 0.42648970D+03,0.640D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.27091830D+03,0.640D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.18125810D+03,0.640D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.13314380D+03,0.640D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.98357300D+02,0.640D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.74191200D+02,0.640D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.16673895D+04,0.640D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.11308198D+04,0.640D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.99679240D+03,0.640D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.73902000D+03,0.640D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.54836330D+03,0.640D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.44123030D+03,0.640D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.35003690D+03,0.640D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.27935150D+03,0.640D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.28176333D+04,0.640D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.20945326D+04,0.640D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.16917052D+04,0.640D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.16028927D+04,0.640D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.14507174D+04,0.640D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.11427015D+04,0.640D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10201:  10300)=(/
     . 0.12280426D+04,0.640D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.96156000D+03,0.640D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.99206730D+03,0.640D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.10341932D+04,0.640D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.79387630D+03,0.640D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.78351140D+03,0.640D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.93936520D+03,0.640D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.78963690D+03,0.640D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.64598490D+03,0.640D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.56529910D+03,0.640D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.48231720D+03,0.640D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.40998030D+03,0.640D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.31359242D+04,0.640D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.25077589D+04,0.640D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.21132076D+04,0.640D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.18544837D+04,0.640D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.16654372D+04,0.640D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.12530730D+04,0.640D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.14116759D+04,0.640D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.10450617D+04,0.640D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10301:  10400)=(/
     . 0.11404525D+04,0.640D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.10471279D+04,0.640D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.88053130D+03,0.640D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.91107960D+03,0.640D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.11799720D+04,0.640D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.10480976D+04,0.640D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.89951620D+03,0.640D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.81630470D+03,0.640D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.72098470D+03,0.640D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.63421630D+03,0.640D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.38238426D+04,0.640D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.32436561D+04,0.640D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.27405478D+04,0.640D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.10709597D+04,0.640D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.28381357D+04,0.640D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.27056826D+04,0.640D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.26326657D+04,0.640D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.25660607D+04,0.640D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.25068352D+04,0.640D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.18916719D+04,0.640D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10401:  10500)=(/
     . 0.70179400D+02,0.650D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.42367900D+02,0.650D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.18023852D+04,0.650D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.80848660D+03,0.650D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.48279770D+03,0.650D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.29984690D+03,0.650D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19762340D+03,0.650D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.14377540D+03,0.650D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10539700D+03,0.650D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.79048400D+02,0.650D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.21240831D+04,0.650D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.13433651D+04,0.650D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11621560D+04,0.650D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.83917760D+03,0.650D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.61083180D+03,0.650D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.48623190D+03,0.650D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.38195840D+03,0.650D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.30241490D+03,0.650D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.36876305D+04,0.650D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.25641443D+04,0.650D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10501:  10600)=(/
     . 0.20454927D+04,0.650D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.19228302D+04,0.650D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.17309890D+04,0.650D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13680049D+04,0.650D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.14541614D+04,0.650D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.11408713D+04,0.650D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11579011D+04,0.650D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.12132014D+04,0.650D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.93575440D+03,0.650D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.90359910D+03,0.650D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10900939D+04,0.650D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.89646510D+03,0.650D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.72120420D+03,0.650D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.62544800D+03,0.650D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.52893810D+03,0.650D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.44620840D+03,0.650D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.40985678D+04,0.650D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.30839899D+04,0.650D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.25485911D+04,0.650D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.22114907D+04,0.650D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10601:  10700)=(/
     . 0.19735648D+04,0.650D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.14705265D+04,0.650D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.16631347D+04,0.650D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.12173511D+04,0.650D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.13235223D+04,0.650D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.12096847D+04,0.650D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10256835D+04,0.650D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.10465789D+04,0.650D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.13756067D+04,0.650D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.11975597D+04,0.650D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.10112975D+04,0.650D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.90991270D+03,0.650D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.79669950D+03,0.650D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.69543500D+03,0.650D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.50226967D+04,0.650D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.40300910D+04,0.650D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.33357435D+04,0.650D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.12096287D+04,0.650D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.35071716D+04,0.650D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.33250797D+04,0.650D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10701:  10800)=(/
     . 0.32313241D+04,0.650D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.31461740D+04,0.650D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.30703853D+04,0.650D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.22762532D+04,0.650D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.28516677D+04,0.650D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.67958000D+02,0.660D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.41162200D+02,0.660D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.17207353D+04,0.660D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.77577180D+03,0.660D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.46524390D+03,0.660D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.28984550D+03,0.660D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19145500D+03,0.660D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.13949370D+03,0.660D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10238110D+03,0.660D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.76855700D+02,0.660D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.20278568D+04,0.660D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.12872471D+04,0.660D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11160341D+04,0.660D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.80833220D+03,0.660D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.58989410D+03,0.660D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10801:  10900)=(/
     . 0.47029770D+03,0.660D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.36998330D+03,0.660D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.29329050D+03,0.660D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.35269705D+04,0.660D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.24517734D+04,0.660D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.19574581D+04,0.660D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.18415883D+04,0.660D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.16587019D+04,0.660D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13107538D+04,0.660D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.13944853D+04,0.660D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.10940016D+04,0.660D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11118174D+04,0.660D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.11642755D+04,0.660D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.89783730D+03,0.660D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.86875770D+03,0.660D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10475640D+04,0.660D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.86358600D+03,0.660D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.69627600D+03,0.660D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.60460480D+03,0.660D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.51197160D+03,0.660D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  10901:  11000)=(/
     . 0.43238930D+03,0.660D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.39216962D+04,0.660D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.29485688D+04,0.660D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.24401762D+04,0.660D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.21194908D+04,0.660D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.18927858D+04,0.660D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.14117363D+04,0.660D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.15962074D+04,0.660D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.11696785D+04,0.660D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.12718937D+04,0.660D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.11630374D+04,0.660D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.98556970D+03,0.660D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.10068382D+04,0.660D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.13215257D+04,0.660D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.11527975D+04,0.660D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.97544350D+03,0.660D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.87867530D+03,0.660D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.77029080D+03,0.660D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.67313940D+03,0.660D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.48123323D+04,0.660D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11001:  11100)=(/
     . 0.38522949D+04,0.660D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.31924039D+04,0.660D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.11661633D+04,0.660D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.33558765D+04,0.660D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.31799629D+04,0.660D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.30904072D+04,0.660D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.30090778D+04,0.660D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.29367065D+04,0.660D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.21810675D+04,0.660D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.27299739D+04,0.660D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.26173310D+04,0.660D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.72220300D+02,0.670D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.43571100D+02,0.670D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.17049679D+04,0.670D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.81136880D+03,0.670D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.49188750D+03,0.670D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.30751980D+03,0.670D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.20315540D+03,0.670D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.14783550D+03,0.670D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10830760D+03,0.670D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11101:  11200)=(/
     . 0.81141600D+02,0.670D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.20163392D+04,0.670D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.13374783D+04,0.670D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11679358D+04,0.670D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.85407400D+03,0.670D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.62593940D+03,0.670D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.49945760D+03,0.670D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.39293850D+03,0.670D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.31124870D+03,0.670D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.34195160D+04,0.670D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.25014164D+04,0.670D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.20120352D+04,0.670D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.18992044D+04,0.670D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.17148635D+04,0.670D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13502932D+04,0.670D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.14466020D+04,0.670D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.11317710D+04,0.670D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11614905D+04,0.670D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.12139348D+04,0.670D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.93167930D+03,0.670D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11201:  11300)=(/
     . 0.91200820D+03,0.670D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10964450D+04,0.670D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.91172230D+03,0.670D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.73821290D+03,0.670D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.64174520D+03,0.670D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.54371620D+03,0.670D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.45912050D+03,0.670D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.38008304D+04,0.670D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.29970212D+04,0.670D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.25073572D+04,0.670D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.21900272D+04,0.670D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.19605194D+04,0.670D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.14668017D+04,0.670D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.16559466D+04,0.670D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.12180651D+04,0.670D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.13291426D+04,0.670D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.12176582D+04,0.670D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10253902D+04,0.670D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.10563718D+04,0.670D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.13778901D+04,0.670D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11301:  11400)=(/
     . 0.12131043D+04,0.670D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.10318071D+04,0.670D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.93112390D+03,0.670D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.81732200D+03,0.670D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.71464770D+03,0.670D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.46328428D+04,0.670D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.38855093D+04,0.670D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.32599132D+04,0.670D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.12305989D+04,0.670D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.33915411D+04,0.670D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.32298168D+04,0.670D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.31416098D+04,0.670D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.30612537D+04,0.670D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.29897660D+04,0.670D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.22379026D+04,0.670D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.27243602D+04,0.670D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.26065136D+04,0.670D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.26641668D+04,0.670D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.70715400D+02,0.680D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.42665800D+02,0.680D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11401:  11500)=(/
     . 0.16647700D+04,0.680D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.79368770D+03,0.680D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.48143850D+03,0.680D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.30106920D+03,0.680D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19891850D+03,0.680D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.14475870D+03,0.680D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10605520D+03,0.680D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.79453900D+02,0.680D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.19689928D+04,0.680D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.13079814D+04,0.680D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11425656D+04,0.680D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.83589690D+03,0.680D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.61278090D+03,0.680D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.48901070D+03,0.680D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.38474960D+03,0.680D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.30477480D+03,0.680D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.33372227D+04,0.680D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.24446758D+04,0.680D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.19669050D+04,0.680D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.18568743D+04,0.680D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11501:  11600)=(/
     . 0.16768129D+04,0.680D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13201912D+04,0.680D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.14147048D+04,0.680D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.11067246D+04,0.680D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11361897D+04,0.680D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.11873873D+04,0.680D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.91117070D+03,0.680D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.89233320D+03,0.680D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10726768D+04,0.680D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.89230170D+03,0.680D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.72266540D+03,0.680D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.62829340D+03,0.680D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.53236410D+03,0.680D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.44955920D+03,0.680D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.37094297D+04,0.680D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.29287164D+04,0.680D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.24511775D+04,0.680D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.21414202D+04,0.680D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.19172203D+04,0.680D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.14346130D+04,0.680D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11601:  11700)=(/
     . 0.16195186D+04,0.680D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.11914716D+04,0.680D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.13002637D+04,0.680D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.11912962D+04,0.680D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10029797D+04,0.680D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.10336009D+04,0.680D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.13478497D+04,0.680D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.11871040D+04,0.680D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.10099583D+04,0.680D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.91151370D+03,0.680D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.80019180D+03,0.680D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.69972310D+03,0.680D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.45209645D+04,0.680D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.37960924D+04,0.680D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.31862327D+04,0.680D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.12044185D+04,0.680D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.33138879D+04,0.680D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.31561992D+04,0.680D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.30700842D+04,0.680D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.29916275D+04,0.680D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11701:  11800)=(/
     . 0.29218310D+04,0.680D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.21877803D+04,0.680D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.26611461D+04,0.680D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.25461249D+04,0.680D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.26039653D+04,0.680D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.25451713D+04,0.680D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.69379100D+02,0.690D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.41872700D+02,0.690D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16270951D+04,0.690D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.77746020D+03,0.690D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.47198600D+03,0.690D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.29530140D+03,0.690D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19516300D+03,0.690D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.14204780D+03,0.690D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10408000D+03,0.690D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.77978800D+02,0.690D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.19246593D+04,0.690D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.12807911D+04,0.690D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11193391D+04,0.690D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.81942800D+03,0.690D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11801:  11900)=(/
     . 0.60097010D+03,0.690D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.47969090D+03,0.690D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.37748730D+03,0.690D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.29906220D+03,0.690D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.32599368D+04,0.690D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.23919954D+04,0.690D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.19251263D+04,0.690D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.18177881D+04,0.690D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.16417354D+04,0.690D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.12924384D+04,0.690D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.13853712D+04,0.690D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.10836957D+04,0.690D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11130259D+04,0.690D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.11630369D+04,0.690D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.89235160D+03,0.690D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.87439610D+03,0.690D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10509705D+04,0.690D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.87471320D+03,0.690D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.70869500D+03,0.690D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.61626580D+03,0.690D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  11901:  12000)=(/
     . 0.52226550D+03,0.690D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.44109320D+03,0.690D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.36236511D+04,0.690D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.28652613D+04,0.690D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.23992487D+04,0.690D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.20966400D+04,0.690D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.18774174D+04,0.690D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.14051352D+04,0.690D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.15861100D+04,0.690D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.11671878D+04,0.690D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.12739026D+04,0.690D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.11672707D+04,0.690D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.98252100D+03,0.690D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.10128904D+04,0.690D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.13203887D+04,0.690D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.11634988D+04,0.690D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.99025880D+03,0.690D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.89390800D+03,0.690D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.78488410D+03,0.690D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.68644520D+03,0.690D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12001:  12100)=(/
     . 0.44159694D+04,0.690D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.37128812D+04,0.690D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.31180001D+04,0.690D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.11807776D+04,0.690D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.32417266D+04,0.690D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.30878489D+04,0.690D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.30036922D+04,0.690D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.29270118D+04,0.690D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.28587977D+04,0.690D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.21415264D+04,0.690D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.26023122D+04,0.690D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.24899643D+04,0.690D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.25481802D+04,0.690D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.24906989D+04,0.690D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.24374539D+04,0.690D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.68494900D+02,0.700D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.41286600D+02,0.700D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16127581D+04,0.700D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.76939830D+03,0.700D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.46660990D+03,0.700D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12101:  12200)=(/
     . 0.29168170D+03,0.700D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.19263240D+03,0.700D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.14013000D+03,0.700D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.10262510D+03,0.700D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.76858100D+02,0.700D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.19075332D+04,0.700D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.12678866D+04,0.700D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.11075215D+04,0.700D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.81018450D+03,0.700D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.59379110D+03,0.700D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.47373900D+03,0.700D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.37262670D+03,0.700D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.29508360D+03,0.700D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.32317117D+04,0.700D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.23690958D+04,0.700D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.19062802D+04,0.700D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.17996377D+04,0.700D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.16251430D+04,0.700D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.12793493D+04,0.700D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.13711198D+04,0.700D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12201:  12300)=(/
     . 0.10724959D+04,0.700D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11012182D+04,0.700D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.11508553D+04,0.700D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.88299190D+03,0.700D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.86485460D+03,0.700D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.10396601D+04,0.700D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.86479960D+03,0.700D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.70027180D+03,0.700D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.60871740D+03,0.700D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.51566490D+03,0.700D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.43535350D+03,0.700D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.35920465D+04,0.700D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.28379423D+04,0.700D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.23754679D+04,0.700D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.20753417D+04,0.700D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.18580353D+04,0.700D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.13902059D+04,0.700D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.15694426D+04,0.700D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.11545209D+04,0.700D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.12600764D+04,0.700D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12301:  12400)=(/
     . 0.11544639D+04,0.700D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.97180930D+03,0.700D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.10016214D+04,0.700D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.13062023D+04,0.700D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.11504571D+04,0.700D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.97868710D+03,0.700D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.88319190D+03,0.700D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.77520910D+03,0.700D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.67775440D+03,0.700D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.43774766D+04,0.700D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.36779606D+04,0.700D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.30875154D+04,0.700D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.11670799D+04,0.700D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.32108489D+04,0.700D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.30582277D+04,0.700D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.29748238D+04,0.700D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.28988349D+04,0.700D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.28312344D+04,0.700D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.21199794D+04,0.700D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.25778005D+04,0.700D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12401:  12500)=(/
     . 0.24663583D+04,0.700D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.25233630D+04,0.700D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.24664143D+04,0.700D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.24136514D+04,0.700D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.23901227D+04,0.700D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.58651900D+02,0.710D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.35951600D+02,0.710D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.12947583D+04,0.710D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.63458810D+03,0.710D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.39146520D+03,0.710D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.24795570D+03,0.710D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.16541840D+03,0.710D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.12121480D+03,0.710D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.89340500D+02,0.710D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.67257500D+02,0.710D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.15332675D+04,0.710D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.10401825D+04,0.710D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.91638240D+03,0.710D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.67855410D+03,0.710D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.50255170D+03,0.710D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12501:  12600)=(/
     . 0.40367180D+03,0.710D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.31962860D+03,0.710D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.25459790D+03,0.710D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.25921299D+04,0.710D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.19255453D+04,0.710D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.15553939D+04,0.710D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.14734091D+04,0.710D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.13334027D+04,0.710D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.10496142D+04,0.710D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.11285309D+04,0.710D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.88302170D+03,0.710D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.91141500D+03,0.710D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.95032780D+03,0.710D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.72889260D+03,0.710D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.71952410D+03,0.710D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.86291390D+03,0.710D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.72475130D+03,0.710D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.59205870D+03,0.710D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.51745760D+03,0.710D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.44084280D+03,0.710D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12601:  12700)=(/
     . 0.37414020D+03,0.710D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.28847585D+04,0.710D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.23048558D+04,0.710D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.19421387D+04,0.710D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.17040440D+04,0.710D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.15299721D+04,0.710D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.11501604D+04,0.710D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.12962701D+04,0.710D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.95869920D+03,0.710D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.10467597D+04,0.710D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.96091280D+03,0.710D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.80744060D+03,0.710D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.83583100D+03,0.710D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.10833008D+04,0.710D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.96184020D+03,0.710D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.82469640D+03,0.710D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.74775790D+03,0.710D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.65970490D+03,0.710D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.57959110D+03,0.710D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.35195236D+04,0.710D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12701:  12800)=(/
     . 0.29806436D+04,0.710D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.25182192D+04,0.710D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.98175310D+03,0.710D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.26089193D+04,0.710D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.24861931D+04,0.710D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.24191164D+04,0.710D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.23579439D+04,0.710D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.23035540D+04,0.710D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.17376565D+04,0.710D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.20919380D+04,0.710D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.20059243D+04,0.710D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.20565310D+04,0.710D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.20105203D+04,0.710D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.19680474D+04,0.710D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.19483102D+04,0.710D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.15974796D+04,0.710D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.58850400D+02,0.720D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.36574900D+02,0.720D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.11772268D+04,0.720D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.60758590D+03,0.720D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12801:  12900)=(/
     . 0.38350840D+03,0.720D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.24668260D+03,0.720D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.16624720D+03,0.720D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.12259130D+03,0.720D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.90778400D+02,0.720D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.68550500D+02,0.720D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.13981254D+04,0.720D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.98752390D+03,0.720D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.88079020D+03,0.720D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.66333140D+03,0.720D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.49770150D+03,0.720D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.40279470D+03,0.720D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.32111450D+03,0.720D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.25716510D+03,0.720D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.23300562D+04,0.720D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.17971024D+04,0.720D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.14619589D+04,0.720D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.13919848D+04,0.720D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.12638660D+04,0.720D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.99362820D+03,0.720D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  12901:  13000)=(/
     . 0.10747287D+04,0.720D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.84045370D+03,0.720D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.87543360D+03,0.720D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.90984070D+03,0.720D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.69642830D+03,0.720D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.69621350D+03,0.720D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.83232490D+03,0.720D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.70869710D+03,0.720D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.58542500D+03,0.720D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.51487840D+03,0.720D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.44133770D+03,0.720D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.37652870D+03,0.720D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.25964033D+04,0.720D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.21464040D+04,0.720D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.18297515D+04,0.720D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.16164737D+04,0.720D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.14572492D+04,0.720D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.11025669D+04,0.720D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.12395201D+04,0.720D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.92341980D+03,0.720D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13001:  13100)=(/
     . 0.10097527D+04,0.720D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.92946760D+03,0.720D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.77779950D+03,0.720D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.81120400D+03,0.720D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.10422993D+04,0.720D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.93663610D+03,0.720D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.81148690D+03,0.720D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.74006690D+03,0.720D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.65681710D+03,0.720D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.58013770D+03,0.720D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.31606446D+04,0.720D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.27609094D+04,0.720D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.23609186D+04,0.720D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.96347730D+03,0.720D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.24240491D+04,0.720D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.23170514D+04,0.720D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.22560584D+04,0.720D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.22002906D+04,0.720D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.21507417D+04,0.720D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.16406567D+04,0.720D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13101:  13200)=(/
     . 0.19309949D+04,0.720D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.18529581D+04,0.720D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.19265925D+04,0.720D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.18843048D+04,0.720D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.18455050D+04,0.720D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.18262149D+04,0.720D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.15072441D+04,0.720D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.14412394D+04,0.720D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.54401500D+02,0.730D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.34283400D+02,0.730D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.10273577D+04,0.730D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.54443550D+03,0.730D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.34862850D+03,0.730D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.22671590D+03,0.730D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.15406960D+03,0.730D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.11429670D+03,0.730D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.85081400D+02,0.730D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.64523800D+02,0.730D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.12220335D+04,0.730D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.88084690D+03,0.730D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13201:  13300)=(/
     . 0.79141350D+03,0.730D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.60213470D+03,0.730D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.45569700D+03,0.730D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.37087230D+03,0.730D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.29728390D+03,0.730D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.23922910D+03,0.730D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.20266698D+04,0.730D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.15894883D+04,0.730D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.12977826D+04,0.730D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.12395033D+04,0.730D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.11275812D+04,0.730D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.88658800D+03,0.730D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.96151940D+03,0.730D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.75231040D+03,0.730D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.78703270D+03,0.730D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.81634550D+03,0.730D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.62484080D+03,0.730D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.62867410D+03,0.730D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.74997760D+03,0.730D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.64373010D+03,0.730D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13301:  13400)=(/
     . 0.53560150D+03,0.730D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.47316850D+03,0.730D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.40746910D+03,0.730D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.34913050D+03,0.730D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.22608400D+04,0.730D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.18969799D+04,0.730D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.16272670D+04,0.730D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.14431973D+04,0.730D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.13043213D+04,0.730D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.99116570D+03,0.730D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.11124511D+04,0.730D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.83281910D+03,0.730D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.91084260D+03,0.730D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.83983510D+03,0.730D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.70192840D+03,0.730D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.73456590D+03,0.730D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.93877020D+03,0.730D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.84925790D+03,0.730D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.74051010D+03,0.730D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.67794300D+03,0.730D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13401:  13500)=(/
     . 0.60419180D+03,0.730D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.53577730D+03,0.730D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.27516509D+04,0.730D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.24344207D+04,0.730D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.20948531D+04,0.730D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.87810980D+03,0.730D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.21417667D+04,0.730D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.20496125D+04,0.730D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.19962879D+04,0.730D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.19474669D+04,0.730D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.19041085D+04,0.730D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.14623131D+04,0.730D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.17026705D+04,0.730D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.16355752D+04,0.730D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.17084912D+04,0.730D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.16713110D+04,0.730D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.16373225D+04,0.730D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.16197710D+04,0.730D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.13428697D+04,0.730D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.12925836D+04,0.730D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13501:  13600)=(/
     . 0.11638241D+04,0.730D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.46481300D+02,0.740D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.29820600D+02,0.740D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.84241230D+03,0.740D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.45198610D+03,0.740D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.29290150D+03,0.740D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.19259840D+03,0.740D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.13214100D+03,0.740D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.98766600D+02,0.740D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.74030900D+02,0.740D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.56476700D+02,0.740D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.10029508D+04,0.740D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.72933520D+03,0.740D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.65874710D+03,0.740D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.50518900D+03,0.740D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.38541090D+03,0.740D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.31556320D+03,0.740D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.25452870D+03,0.740D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.20602860D+03,0.740D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.16644321D+04,0.740D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13601:  13700)=(/
     . 0.13117641D+04,0.740D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.10728050D+04,0.740D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.10269214D+04,0.740D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.93538590D+03,0.740D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.73650630D+03,0.740D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.79917580D+03,0.740D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.62633800D+03,0.740D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.65622600D+03,0.740D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.67963140D+03,0.740D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.52108220D+03,0.740D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.52588940D+03,0.740D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.62622030D+03,0.740D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.54069840D+03,0.740D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.45278370D+03,0.740D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.40184290D+03,0.740D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.34779630D+03,0.740D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.29948800D+03,0.740D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.18587683D+04,0.740D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.15659413D+04,0.740D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.13478163D+04,0.740D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13701:  13800)=(/
     . 0.11983202D+04,0.740D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.10850878D+04,0.740D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.82786250D+03,0.740D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.92774070D+03,0.740D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.69763460D+03,0.740D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.76226600D+03,0.740D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.70376190D+03,0.740D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.58870290D+03,0.740D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.61664100D+03,0.740D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.78470960D+03,0.740D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.71294940D+03,0.740D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.62490100D+03,0.740D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.57415840D+03,0.740D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.51383150D+03,0.740D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.45758530D+03,0.740D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.22639013D+04,0.740D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.20087751D+04,0.740D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.17339129D+04,0.740D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.74068630D+03,0.740D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.17694139D+04,0.740D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13801:  13900)=(/
     . 0.16938988D+04,0.740D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.16500004D+04,0.740D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.16097798D+04,0.740D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.15740661D+04,0.740D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.12144448D+04,0.740D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.14078390D+04,0.740D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.13533433D+04,0.740D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.14132821D+04,0.740D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.13825761D+04,0.740D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.13545779D+04,0.740D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.13397711D+04,0.740D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.11143056D+04,0.740D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.10763807D+04,0.740D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.97195240D+03,0.740D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.81436220D+03,0.740D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.47481400D+02,0.750D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.30549200D+02,0.750D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.84030290D+03,0.750D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.45686870D+03,0.750D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.29769360D+03,0.750D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  13901:  14000)=(/
     . 0.19640730D+03,0.750D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.13504060D+03,0.750D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.10106690D+03,0.750D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.75833700D+02,0.750D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.57897000D+02,0.750D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.10011833D+04,0.750D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.73565530D+03,0.750D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.66653080D+03,0.750D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.51321450D+03,0.750D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.39266040D+03,0.750D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.32200220D+03,0.750D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.26008050D+03,0.750D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.21074970D+03,0.750D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.16563829D+04,0.750D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.13172961D+04,0.750D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.10793168D+04,0.750D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.10345489D+04,0.750D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.94314230D+03,0.750D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.74238390D+03,0.750D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.80678450D+03,0.750D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14001:  14100)=(/
     . 0.63220880D+03,0.750D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.66388710D+03,0.750D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.68701430D+03,0.750D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.52648590D+03,0.750D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.53299620D+03,0.750D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.63416620D+03,0.750D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.54932810D+03,0.750D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.46115310D+03,0.750D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.40981080D+03,0.750D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.35513780D+03,0.750D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.30613060D+03,0.750D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.18506131D+04,0.750D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.15716863D+04,0.750D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.13568533D+04,0.750D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.12084737D+04,0.750D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.10954282D+04,0.750D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.83707080D+03,0.750D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.93753010D+03,0.750D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.70623580D+03,0.750D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.77195670D+03,0.750D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14101:  14200)=(/
     . 0.71318460D+03,0.750D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.59599800D+03,0.750D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.62541990D+03,0.750D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.79423010D+03,0.750D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.72367260D+03,0.750D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.63581610D+03,0.750D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.58492700D+03,0.750D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.52412750D+03,0.750D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.46726420D+03,0.750D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.22535037D+04,0.750D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.20134740D+04,0.750D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.17433791D+04,0.750D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.75313690D+03,0.750D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.17753357D+04,0.750D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.17005706D+04,0.750D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.16567768D+04,0.750D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.16166266D+04,0.750D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.15809835D+04,0.750D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.12234224D+04,0.750D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.14105904D+04,0.750D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14201:  14300)=(/
     . 0.13567115D+04,0.750D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.14207081D+04,0.750D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.13899934D+04,0.750D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.13620334D+04,0.750D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.13469951D+04,0.750D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.11225706D+04,0.750D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.10876931D+04,0.750D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.98375910D+03,0.750D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.82496150D+03,0.750D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.83633100D+03,0.750D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.43502700D+02,0.760D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.28354600D+02,0.760D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.73192340D+03,0.760D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.40716460D+03,0.760D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.26873040D+03,0.760D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.17905630D+03,0.760D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12405100D+03,0.760D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.93359700D+02,0.760D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.70395400D+02,0.760D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.53964200D+02,0.760D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14301:  14400)=(/
     . 0.87335890D+03,0.760D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.65307500D+03,0.760D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.59556280D+03,0.760D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.46268400D+03,0.760D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.35670880D+03,0.760D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.29400210D+03,0.760D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.23864150D+03,0.760D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.19423140D+03,0.760D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.14396620D+04,0.760D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.11612618D+04,0.760D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.95445330D+03,0.760D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.91746900D+03,0.760D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.83784550D+03,0.760D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.65982040D+03,0.760D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.71850590D+03,0.760D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.56350590D+03,0.760D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.59375330D+03,0.760D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.61335130D+03,0.760D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.47025530D+03,0.760D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.47853750D+03,0.760D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14401:  14500)=(/
     . 0.56822510D+03,0.760D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.49561460D+03,0.760D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.41868920D+03,0.760D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.37355900D+03,0.760D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.32506940D+03,0.760D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.28130190D+03,0.760D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.16103754D+04,0.760D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.13848254D+04,0.760D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.12021044D+04,0.760D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.10743491D+04,0.760D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.97608420D+03,0.760D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.74894180D+03,0.760D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.83752750D+03,0.760D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.63378860D+03,0.760D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.69267540D+03,0.760D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.64089680D+03,0.760D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.53528690D+03,0.760D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.56312050D+03,0.760D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.71169730D+03,0.760D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.65211350D+03,0.760D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14501:  14600)=(/
     . 0.57610750D+03,0.760D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.53178230D+03,0.760D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.47825570D+03,0.760D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.42787240D+03,0.760D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.19610192D+04,0.760D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.17707984D+04,0.760D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.15416747D+04,0.760D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.68178680D+03,0.760D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.15643082D+04,0.760D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.14998732D+04,0.760D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.14616315D+04,0.760D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.14265281D+04,0.760D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.13953763D+04,0.760D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.10864242D+04,0.760D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.12413205D+04,0.760D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.11950783D+04,0.760D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.12556728D+04,0.760D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.12287111D+04,0.760D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.12042523D+04,0.760D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.11906528D+04,0.760D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14601:  14700)=(/
     . 0.99636440D+03,0.760D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.97080130D+03,0.760D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.88109380D+03,0.760D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.74095590D+03,0.760D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.75215710D+03,0.760D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.67852780D+03,0.760D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.40192800D+02,0.770D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.26493600D+02,0.770D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.64922250D+03,0.770D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.36768190D+03,0.770D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.24523810D+03,0.770D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.16475860D+03,0.770D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11488740D+03,0.770D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.86879300D+02,0.770D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.65790400D+02,0.770D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.50615900D+02,0.770D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.77563370D+03,0.770D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.58794870D+03,0.770D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.53899920D+03,0.770D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.42178390D+03,0.770D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14701:  14800)=(/
     . 0.32723040D+03,0.770D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.27085510D+03,0.770D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.22077630D+03,0.770D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.18037110D+03,0.770D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.12755198D+04,0.770D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.10398993D+04,0.770D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.85678860D+03,0.770D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.82551250D+03,0.770D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.75491930D+03,0.770D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.59487280D+03,0.770D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.64870850D+03,0.770D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.50921810D+03,0.770D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.53789460D+03,0.770D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.55484790D+03,0.770D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.42567880D+03,0.770D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.43487920D+03,0.770D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.51550510D+03,0.770D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.45212560D+03,0.770D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.38392650D+03,0.770D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.34368330D+03,0.770D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14801:  14900)=(/
     . 0.30011780D+03,0.770D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.26056720D+03,0.770D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.14282493D+04,0.770D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.12397351D+04,0.770D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.10808340D+04,0.770D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.96864880D+03,0.770D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.88171010D+03,0.770D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.67887180D+03,0.770D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.75818340D+03,0.770D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.57594520D+03,0.770D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.62929090D+03,0.770D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.58296220D+03,0.770D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.48681310D+03,0.770D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.51303760D+03,0.770D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.64586290D+03,0.770D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.59440490D+03,0.770D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.52746810D+03,0.770D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.48823190D+03,0.770D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.44042470D+03,0.770D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.39518890D+03,0.770D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  14901:  15000)=(/
     . 0.17394992D+04,0.770D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.15831333D+04,0.770D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.13842225D+04,0.770D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.62381140D+03,0.770D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.14006813D+04,0.770D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.13439514D+04,0.770D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.13099454D+04,0.770D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.12786986D+04,0.770D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.12509767D+04,0.770D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.97887040D+03,0.770D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.11106969D+04,0.770D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.10701912D+04,0.770D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.11269388D+04,0.770D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.11028614D+04,0.770D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.10810811D+04,0.770D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.10686460D+04,0.770D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.89729150D+03,0.770D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.87805750D+03,0.770D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.79916860D+03,0.770D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.67370750D+03,0.770D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15001:  15100)=(/
     . 0.68458550D+03,0.770D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.61911480D+03,0.770D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.56606600D+03,0.770D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.33737400D+02,0.780D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22655000D+02,0.780D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.52329220D+03,0.780D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.30016240D+03,0.780D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.20254080D+03,0.780D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.13757620D+03,0.780D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.96865800D+02,0.780D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.73818300D+02,0.780D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.56305300D+02,0.780D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.43593000D+02,0.780D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.62596250D+03,0.780D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.47885350D+03,0.780D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.44120140D+03,0.780D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.34788170D+03,0.780D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.27198720D+03,0.780D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.22647100D+03,0.780D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.18574640D+03,0.780D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15101:  15200)=(/
     . 0.15265670D+03,0.780D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.10299899D+04,0.780D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.84443870D+03,0.780D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.69692720D+03,0.780D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.67305270D+03,0.780D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.61630660D+03,0.780D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.48652160D+03,0.780D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.53065270D+03,0.780D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.41743140D+03,0.780D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.44140210D+03,0.780D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.45462950D+03,0.780D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.34958030D+03,0.780D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.35801260D+03,0.780D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.42342920D+03,0.780D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.37342980D+03,0.780D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.31904090D+03,0.780D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.28687030D+03,0.780D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.25174820D+03,0.780D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.21965520D+03,0.780D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.11547638D+04,0.780D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15201:  15300)=(/
     . 0.10070623D+04,0.780D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.88099930D+03,0.780D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.79155440D+03,0.780D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.72193400D+03,0.780D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.55823890D+03,0.780D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.62242220D+03,0.780D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.47507150D+03,0.780D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.51845950D+03,0.780D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.48093890D+03,0.780D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.40219150D+03,0.780D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.42403900D+03,0.780D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.53144420D+03,0.780D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.49101090D+03,0.780D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.43782090D+03,0.780D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.40661850D+03,0.780D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.36825920D+03,0.780D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.33179040D+03,0.780D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.14071724D+04,0.780D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.12854322D+04,0.780D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.11275157D+04,0.780D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15301:  15400)=(/
     . 0.51768570D+03,0.780D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.11388994D+04,0.780D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.10932462D+04,0.780D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.10657050D+04,0.780D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.10403742D+04,0.780D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.10179032D+04,0.780D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.80035340D+03,0.780D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.90395940D+03,0.780D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.87158450D+03,0.780D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.91760410D+03,0.780D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.89802720D+03,0.780D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.88036430D+03,0.780D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.87003670D+03,0.780D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.73291850D+03,0.780D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.71957520D+03,0.780D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.65682120D+03,0.780D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.55562970D+03,0.780D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.56502640D+03,0.780D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.51242690D+03,0.780D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.46966640D+03,0.780D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15401:  15500)=(/
     . 0.39114480D+03,0.780D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.31643100D+02,0.790D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.21405700D+02,0.790D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.48271200D+03,0.790D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.27848740D+03,0.790D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.18878590D+03,0.790D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.12878430D+03,0.790D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.91021000D+02,0.790D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.69577200D+02,0.790D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.53225800D+02,0.790D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.41316600D+02,0.790D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.57775500D+03,0.790D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.44384910D+03,0.790D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.40978640D+03,0.790D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.32409250D+03,0.790D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.25414960D+03,0.790D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.21210390D+03,0.790D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.17438080D+03,0.790D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.14364860D+03,0.790D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.95062180D+03,0.790D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15501:  15600)=(/
     . 0.78160440D+03,0.790D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.64557500D+03,0.790D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.62406930D+03,0.790D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.57177460D+03,0.790D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.45167990D+03,0.790D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.49272680D+03,0.790D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.38791960D+03,0.790D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.41040680D+03,0.790D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.42244780D+03,0.790D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.32511980D+03,0.790D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.33331770D+03,0.790D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.39382270D+03,0.790D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.34809220D+03,0.790D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.29810130D+03,0.790D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.26850000D+03,0.790D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.23607650D+03,0.790D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.20637560D+03,0.790D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.10663289D+04,0.790D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.93220550D+03,0.790D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.81674650D+03,0.790D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15601:  15700)=(/
     . 0.73461520D+03,0.790D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.67055170D+03,0.790D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.51941000D+03,0.790D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.57874610D+03,0.790D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.44259210D+03,0.790D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.48280890D+03,0.790D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.44812160D+03,0.790D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.37494860D+03,0.790D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.39541490D+03,0.790D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.49465360D+03,0.790D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.45775290D+03,0.790D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.40894270D+03,0.790D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.38029110D+03,0.790D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.34494080D+03,0.790D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.31127000D+03,0.790D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.12995975D+04,0.790D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.11895405D+04,0.790D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.10448996D+04,0.790D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.48348310D+03,0.790D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.10546339D+04,0.790D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15701:  15800)=(/
     . 0.10125735D+04,0.790D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.98712160D+03,0.790D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.96370210D+03,0.790D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.94292740D+03,0.790D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.74291920D+03,0.790D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.83729210D+03,0.790D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.80754210D+03,0.790D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.85029540D+03,0.790D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.83217180D+03,0.790D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.81583760D+03,0.790D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.80619030D+03,0.790D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.68007310D+03,0.790D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.66862000D+03,0.790D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.61103860D+03,0.790D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.51760830D+03,0.790D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.52653700D+03,0.790D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.47806720D+03,0.790D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.43860830D+03,0.790D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.36582470D+03,0.790D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.34235260D+03,0.790D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15801:  15900)=(/
     . 0.32647500D+02,0.800D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.22083700D+02,0.800D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.48740200D+03,0.800D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.28506170D+03,0.800D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.19416150D+03,0.800D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.13273170D+03,0.800D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.93883600D+02,0.800D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.71776000D+02,0.800D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.54902300D+02,0.800D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.42608500D+02,0.800D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.58379600D+03,0.800D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.45335960D+03,0.800D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.41983840D+03,0.800D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.33321670D+03,0.800D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.26185840D+03,0.800D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.21871850D+03,0.800D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.17991240D+03,0.800D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.14823250D+03,0.800D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.95736170D+03,0.800D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.79465850D+03,0.800D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  15901:  16000)=(/
     . 0.65759170D+03,0.800D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.63652100D+03,0.800D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.58366570D+03,0.800D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.46085090D+03,0.800D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.50355400D+03,0.800D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.39629990D+03,0.800D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.42025520D+03,0.800D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.43227410D+03,0.800D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.33243400D+03,0.800D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.34187100D+03,0.800D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.40370590D+03,0.800D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.35784550D+03,0.800D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.30703710D+03,0.800D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.27676970D+03,0.800D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.24349600D+03,0.800D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.21293560D+03,0.800D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.10744128D+04,0.800D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.94720110D+03,0.800D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.83242220D+03,0.800D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.74998240D+03,0.800D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16001:  16100)=(/
     . 0.68523850D+03,0.800D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.53145620D+03,0.800D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.59192160D+03,0.800D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.45328020D+03,0.800D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.49471860D+03,0.800D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.45942820D+03,0.800D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.38395180D+03,0.800D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.40566070D+03,0.800D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.50664510D+03,0.800D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.47008500D+03,0.800D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.42079320D+03,0.800D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.39167400D+03,0.800D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.35554970D+03,0.800D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.32102510D+03,0.800D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.13092921D+04,0.800D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.12070341D+04,0.800D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.10636276D+04,0.800D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.49715300D+03,0.800D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.10712093D+04,0.800D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.10290835D+04,0.800D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16101:  16200)=(/
     . 0.10033846D+04,0.800D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.97972320D+03,0.800D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.95873970D+03,0.800D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.75756310D+03,0.800D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.84922660D+03,0.800D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.81952610D+03,0.800D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.86529630D+03,0.800D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.84694850D+03,0.800D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.83044190D+03,0.800D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.82053560D+03,0.800D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.69354790D+03,0.800D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.68391950D+03,0.800D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.62592010D+03,0.800D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.53051690D+03,0.800D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.54005040D+03,0.800D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.49085310D+03,0.800D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.45068210D+03,0.800D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.37600960D+03,0.800D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.35193500D+03,0.800D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.36207550D+03,0.800D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16201:  16300)=(/
     . 0.45565900D+02,0.810D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.29383200D+02,0.810D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.84156200D+03,0.810D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.44509900D+03,0.810D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.28743460D+03,0.810D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.18891370D+03,0.810D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12977590D+03,0.810D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.97188700D+02,0.810D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.73035300D+02,0.810D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.55878200D+02,0.810D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.10013499D+04,0.810D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.71984280D+03,0.810D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.64850370D+03,0.810D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.49588920D+03,0.810D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.37786060D+03,0.810D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.30940570D+03,0.810D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.24971520D+03,0.810D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.20236390D+03,0.810D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.16699732D+04,0.810D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.13012325D+04,0.810D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16301:  16400)=(/
     . 0.10621257D+04,0.810D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.10156676D+04,0.810D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.92450540D+03,0.810D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.72875260D+03,0.810D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.78917040D+03,0.810D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.61912140D+03,0.810D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.64688450D+03,0.810D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.67034360D+03,0.810D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.51478030D+03,0.810D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.51777130D+03,0.810D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.61653920D+03,0.810D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.53101480D+03,0.810D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.44413160D+03,0.810D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.39408930D+03,0.810D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.34115420D+03,0.810D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.29394640D+03,0.810D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.18646164D+04,0.810D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.15547036D+04,0.810D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.13341432D+04,0.810D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.11843558D+04,0.810D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16401:  16500)=(/
     . 0.10716858D+04,0.810D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.81713880D+03,0.810D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.91594930D+03,0.810D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.68833610D+03,0.810D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.75141170D+03,0.810D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.69349420D+03,0.810D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.58127400D+03,0.810D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.60745600D+03,0.810D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.77388330D+03,0.810D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.70133540D+03,0.810D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.61379650D+03,0.810D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.56366330D+03,0.810D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.50431850D+03,0.810D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.44915730D+03,0.810D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.22724078D+04,0.810D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.19977665D+04,0.810D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.17187930D+04,0.810D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.72802070D+03,0.810D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.17584731D+04,0.810D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.16821281D+04,0.810D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16501:  16600)=(/
     . 0.16382173D+04,0.810D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.15980083D+04,0.810D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.15622939D+04,0.810D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.12025229D+04,0.810D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.14026627D+04,0.810D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.13479037D+04,0.810D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.14013832D+04,0.810D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.13707449D+04,0.810D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.13427654D+04,0.810D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.13281907D+04,0.810D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.11030932D+04,0.810D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.10619960D+04,0.810D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.95783300D+03,0.810D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.80262850D+03,0.810D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.81249710D+03,0.810D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.72924020D+03,0.810D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.66279090D+03,0.810D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.54691720D+03,0.810D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.50961460D+03,0.810D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.52190910D+03,0.810D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16601:  16700)=(/
     . 0.79223780D+03,0.810D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.45178600D+02,0.820D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.29396300D+02,0.820D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.77049850D+03,0.820D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.42598770D+03,0.820D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.28017140D+03,0.820D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.18622350D+03,0.820D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12882430D+03,0.820D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.96880100D+02,0.820D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.73028500D+02,0.820D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.55990900D+02,0.820D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.91912570D+03,0.820D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.68410110D+03,0.820D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.62271340D+03,0.820D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.48258810D+03,0.820D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.37129390D+03,0.820D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.30563890D+03,0.820D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.24781410D+03,0.820D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.20153300D+03,0.820D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.15164193D+04,0.820D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16701:  16800)=(/
     . 0.12187009D+04,0.820D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.10008602D+04,0.820D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.96137180D+03,0.820D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.87756550D+03,0.820D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.69108340D+03,0.820D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.75211560D+03,0.820D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.58980850D+03,0.820D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.62087440D+03,0.820D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.64167640D+03,0.820D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.49199760D+03,0.820D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.49993220D+03,0.820D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.59373850D+03,0.820D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.51689320D+03,0.820D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.43592810D+03,0.820D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.38853730D+03,0.820D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.33776830D+03,0.820D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.29204720D+03,0.820D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.16956909D+04,0.820D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.14534745D+04,0.820D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.12598691D+04,0.820D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16801:  16900)=(/
     . 0.11249617D+04,0.820D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.10214733D+04,0.820D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.78299060D+03,0.820D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.87595820D+03,0.820D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.66216750D+03,0.820D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.72370460D+03,0.820D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.66938820D+03,0.820D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.55927100D+03,0.820D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.58793680D+03,0.820D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.74387970D+03,0.820D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.68057520D+03,0.820D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.60037140D+03,0.820D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.55368260D+03,0.820D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.49748720D+03,0.820D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.44470070D+03,0.820D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.20646687D+04,0.820D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.18594085D+04,0.820D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.16164677D+04,0.820D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.71062890D+03,0.820D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.16419885D+04,0.820D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  16901:  17000)=(/
     . 0.15739763D+04,0.820D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.15337469D+04,0.820D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.14968291D+04,0.820D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.14640624D+04,0.820D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.11380979D+04,0.820D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.13034316D+04,0.820D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.12545335D+04,0.820D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.13170177D+04,0.820D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.12886907D+04,0.820D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.12629662D+04,0.820D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.12487891D+04,0.820D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.10439034D+04,0.820D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.10154887D+04,0.820D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.92083050D+03,0.820D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.77385260D+03,0.820D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.78529450D+03,0.820D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.70790090D+03,0.820D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.64554700D+03,0.820D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.53402070D+03,0.820D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.49813010D+03,0.820D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17001:  17100)=(/
     . 0.51131450D+03,0.820D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.76196480D+03,0.820D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.73881560D+03,0.820D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.42241900D+02,0.830D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.27932900D+02,0.830D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.66152780D+03,0.830D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.38103070D+03,0.830D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.25605370D+03,0.830D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.17278310D+03,0.830D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.12079930D+03,0.830D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.91493400D+02,0.830D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.69368900D+02,0.830D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.53420400D+02,0.830D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.79108680D+03,0.830D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.60760080D+03,0.830D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.55943360D+03,0.830D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.44013430D+03,0.830D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.34277880D+03,0.830D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.28429480D+03,0.830D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.23212190D+03,0.830D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17101:  17200)=(/
     . 0.18987560D+03,0.830D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.12966253D+04,0.830D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.10686331D+04,0.830D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.88251530D+03,0.830D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.85188550D+03,0.830D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.77993360D+03,0.830D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.61445090D+03,0.830D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.67130550D+03,0.830D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.52693210D+03,0.830D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.55817400D+03,0.830D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.57514870D+03,0.830D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.44105510D+03,0.830D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.45236780D+03,0.830D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.53570130D+03,0.830D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.47183760D+03,0.830D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.40199200D+03,0.830D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.36047350D+03,0.830D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.31527740D+03,0.830D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.27407550D+03,0.830D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.14529418D+04,0.830D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17201:  17300)=(/
     . 0.12732370D+04,0.830D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.11143977D+04,0.830D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.10010315D+04,0.830D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.91248200D+03,0.830D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.70407130D+03,0.830D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.78575170D+03,0.830D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.59827920D+03,0.830D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.65393370D+03,0.830D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.60631280D+03,0.830D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.50575740D+03,0.830D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.53417140D+03,0.830D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.67073540D+03,0.830D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.61958270D+03,0.830D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.55156050D+03,0.830D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.51139760D+03,0.830D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.46208340D+03,0.830D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.41520110D+03,0.830D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.17696390D+04,0.830D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.16234740D+04,0.830D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.14251223D+04,0.830D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17301:  17400)=(/
     . 0.65171260D+03,0.830D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.14382615D+04,0.830D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.13809451D+04,0.830D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.13462674D+04,0.830D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.13143784D+04,0.830D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.12860963D+04,0.830D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.10103860D+04,0.830D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.11390166D+04,0.830D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.10983110D+04,0.830D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.11597774D+04,0.830D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.11351424D+04,0.830D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.11129109D+04,0.830D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.10999410D+04,0.830D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.92612910D+03,0.830D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.90981540D+03,0.830D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.82982850D+03,0.830D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.70043950D+03,0.830D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.71241700D+03,0.830D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.64537650D+03,0.830D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.59085050D+03,0.830D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17401:  17500)=(/
     . 0.49072340D+03,0.830D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.45847260D+03,0.830D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.47152310D+03,0.830D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.68856550D+03,0.830D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.67269040D+03,0.830D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.61752960D+03,0.830D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.40710600D+02,0.840D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.27211800D+02,0.840D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.60731510D+03,0.840D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.35746030D+03,0.840D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.24330570D+03,0.840D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.16573270D+03,0.840D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.11666150D+03,0.840D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.88773600D+02,0.840D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.67567200D+02,0.840D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.52188100D+02,0.840D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.72726310D+03,0.840D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.56780720D+03,0.840D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.52626000D+03,0.840D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.41768440D+03,0.840D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17501:  17600)=(/
     . 0.32771360D+03,0.840D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.27309950D+03,0.840D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.22398500D+03,0.840D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.18392230D+03,0.840D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.11891902D+04,0.840D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.99221250D+03,0.840D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.82178250D+03,0.840D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.79553840D+03,0.840D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.72956570D+03,0.840D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.57517310D+03,0.840D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.62948100D+03,0.840D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.49459140D+03,0.840D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.52549790D+03,0.840D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.54053270D+03,0.840D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.41478690D+03,0.840D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.42746160D+03,0.840D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.50536000D+03,0.840D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.44808220D+03,0.840D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.38408530D+03,0.840D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.34572660D+03,0.840D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17601:  17700)=(/
     . 0.30354480D+03,0.840D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.26479780D+03,0.840D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.13343692D+04,0.840D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.11818604D+04,0.840D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.10398622D+04,0.840D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.93720360D+03,0.840D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.85623980D+03,0.840D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.66336080D+03,0.840D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.73919570D+03,0.840D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.56531410D+03,0.840D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.61769980D+03,0.840D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.57350990D+03,0.840D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.47823360D+03,0.840D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.50616860D+03,0.840D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.63278330D+03,0.840D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.58760970D+03,0.840D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.52587280D+03,0.840D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.48916400D+03,0.840D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.44353000D+03,0.840D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.39983350D+03,0.840D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17701:  17800)=(/
     . 0.16260419D+04,0.840D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.15047607D+04,0.840D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.13277397D+04,0.840D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.62085480D+03,0.840D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.13354309D+04,0.840D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.12832336D+04,0.840D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.12512879D+04,0.840D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.12218775D+04,0.840D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.11958046D+04,0.840D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.94515700D+03,0.840D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.10569864D+04,0.840D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.10202790D+04,0.840D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.10796889D+04,0.840D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.10568831D+04,0.840D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.10363788D+04,0.840D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.10240338D+04,0.840D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.86580300D+03,0.840D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.85504390D+03,0.840D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.78248020D+03,0.840D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.66238200D+03,0.840D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17801:  17900)=(/
     . 0.67449800D+03,0.840D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.61277720D+03,0.840D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.56231000D+03,0.840D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.46825250D+03,0.840D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.43792710D+03,0.840D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.45080740D+03,0.840D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.65074290D+03,0.840D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.63822510D+03,0.840D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.58861880D+03,0.840D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.56260110D+03,0.840D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.38046800D+02,0.850D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.25807100D+02,0.850D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.53565210D+03,0.850D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.32315400D+03,0.850D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.22339710D+03,0.850D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.15398830D+03,0.850D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10936180D+03,0.850D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.83743700D+02,0.850D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.64079700D+02,0.850D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.49704300D+02,0.850D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  17901:  18000)=(/
     . 0.64255990D+03,0.850D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.51104720D+03,0.850D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.47738160D+03,0.850D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.38289140D+03,0.850D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.30317170D+03,0.850D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.25418990D+03,0.850D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.20969510D+03,0.850D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.17306680D+03,0.850D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.10486754D+04,0.850D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.88679380D+03,0.850D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.73687680D+03,0.850D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.71582420D+03,0.850D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.65777000D+03,0.850D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.51922800D+03,0.850D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.56918500D+03,0.850D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.44794120D+03,0.850D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.47740460D+03,0.850D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.49002960D+03,0.850D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.37654500D+03,0.850D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.39005450D+03,0.850D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18001:  18100)=(/
     . 0.46013230D+03,0.850D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.41119140D+03,0.850D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.35508990D+03,0.850D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.32115720D+03,0.850D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.28336260D+03,0.850D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.24831690D+03,0.850D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.11787843D+04,0.850D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.10561781D+04,0.850D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.93492800D+03,0.850D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.84595890D+03,0.850D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.77500770D+03,0.850D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.60351860D+03,0.850D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.67120920D+03,0.850D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.51618070D+03,0.850D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.56361340D+03,0.850D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.52417160D+03,0.850D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.43716280D+03,0.850D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.46363160D+03,0.850D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.57648690D+03,0.850D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.53857130D+03,0.850D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18101:  18200)=(/
     . 0.48503660D+03,0.850D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.45297260D+03,0.850D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.41249290D+03,0.850D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.37339600D+03,0.850D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.14375237D+04,0.850D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.13427557D+04,0.850D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.11918004D+04,0.850D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.57219880D+03,0.850D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.11941552D+04,0.850D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.11484879D+04,0.850D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.11201674D+04,0.850D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.10940580D+04,0.850D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.10709219D+04,0.850D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.85263060D+03,0.850D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.94504500D+03,0.850D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.91333710D+03,0.850D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.96825870D+03,0.850D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.94792020D+03,0.850D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.92971630D+03,0.850D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.91834420D+03,0.850D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18201:  18300)=(/
     . 0.78031510D+03,0.850D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.77523370D+03,0.850D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.71228880D+03,0.850D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.60524130D+03,0.850D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.61710680D+03,0.850D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.56258800D+03,0.850D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.51772850D+03,0.850D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.43264880D+03,0.850D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.40518020D+03,0.850D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.41747370D+03,0.850D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.59434970D+03,0.850D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.58543140D+03,0.850D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.54287440D+03,0.850D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.52058720D+03,0.850D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.48365360D+03,0.850D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.35275000D+02,0.860D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.24288600D+02,0.860D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.47129940D+03,0.860D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.29040790D+03,0.860D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.20366210D+03,0.860D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18301:  18400)=(/
     . 0.14199460D+03,0.860D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.10173400D+03,0.860D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.78399300D+02,0.860D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.60320800D+02,0.860D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.46997000D+02,0.860D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.56630470D+03,0.860D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.45752070D+03,0.860D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.43040700D+03,0.860D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.34853240D+03,0.860D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.27834410D+03,0.860D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.23475630D+03,0.860D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.19477780D+03,0.860D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.16157780D+03,0.860D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.92348960D+03,0.860D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.78946510D+03,0.860D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.65782090D+03,0.860D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.64106890D+03,0.860D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.59013650D+03,0.860D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.46657860D+03,0.860D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.51200690D+03,0.860D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18401:  18500)=(/
     . 0.40371620D+03,0.860D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.43125430D+03,0.860D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.44180520D+03,0.860D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.34010290D+03,0.860D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.35375690D+03,0.860D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.41640720D+03,0.860D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.37473780D+03,0.860D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.32584680D+03,0.860D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.29605910D+03,0.860D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.26246780D+03,0.860D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.23103920D+03,0.860D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.10398788D+04,0.860D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.94037660D+03,0.860D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.83682440D+03,0.860D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.75986860D+03,0.860D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.69790750D+03,0.860D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.54617620D+03,0.860D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.60628810D+03,0.860D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.46875270D+03,0.860D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.51133700D+03,0.860D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18501:  18600)=(/
     . 0.47629130D+03,0.860D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.39751230D+03,0.860D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.42213930D+03,0.860D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.52225240D+03,0.860D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.49045740D+03,0.860D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.44423510D+03,0.860D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.41640380D+03,0.860D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.38074630D+03,0.860D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.34603400D+03,0.860D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.12691514D+04,0.860D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.11942553D+04,0.860D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.10653886D+04,0.860D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.52379990D+03,0.860D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.10641113D+04,0.860D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.10241601D+04,0.860D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.99910040D+03,0.860D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.97596710D+03,0.860D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.95547530D+03,0.860D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.76577540D+03,0.860D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.84248080D+03,0.860D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18601:  18700)=(/
     . 0.81508100D+03,0.860D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.86486000D+03,0.860D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.84676410D+03,0.860D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.83063370D+03,0.860D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.82022230D+03,0.860D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.70009390D+03,0.860D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.69908500D+03,0.860D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.64467130D+03,0.860D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.54983920D+03,0.860D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.56121370D+03,0.860D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.51327610D+03,0.860D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.47360870D+03,0.860D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.39719060D+03,0.860D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.37248250D+03,0.860D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.38402410D+03,0.860D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.53990550D+03,0.860D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.53369840D+03,0.860D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.49729720D+03,0.860D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.47831130D+03,0.860D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.44604470D+03,0.860D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18701:  18800)=(/
     . 0.41282750D+03,0.860D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.10074940D+03,0.870D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.59659400D+02,0.870D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.28945966D+04,0.870D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.12189348D+04,0.870D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.71065850D+03,0.870D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.43419670D+03,0.870D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.28277630D+03,0.870D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.20397230D+03,0.870D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.14835840D+03,0.870D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.11051200D+03,0.870D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.33986461D+04,0.870D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.20446296D+04,0.870D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.17465418D+04,0.870D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.12378269D+04,0.870D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.88882250D+03,0.870D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.70197610D+03,0.870D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.54727120D+03,0.870D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.43044680D+03,0.870D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.60209123D+04,0.870D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18801:  18900)=(/
     . 0.39885535D+04,0.870D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.31533933D+04,0.870D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.29483214D+04,0.870D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.26441348D+04,0.870D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.20951563D+04,0.870D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.22092516D+04,0.870D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.17359767D+04,0.870D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.17406013D+04,0.870D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.18302286D+04,0.870D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.14168737D+04,0.870D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.13464975D+04,0.870D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.16330869D+04,0.870D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.13219669D+04,0.870D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.10509064D+04,0.870D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.90547240D+03,0.870D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.76070860D+03,0.870D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.63792100D+03,0.870D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.66879551D+04,0.870D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.48140613D+04,0.870D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.39238630D+04,0.870D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  18901:  19000)=(/
     . 0.33777348D+04,0.870D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.30012009D+04,0.870D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.22208404D+04,0.870D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.25189457D+04,0.870D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.18286037D+04,0.870D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.19819822D+04,0.870D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.18052792D+04,0.870D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.15403020D+04,0.870D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.15550964D+04,0.870D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.20671731D+04,0.870D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.17732620D+04,0.870D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.14801255D+04,0.870D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.13236329D+04,0.870D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.11516386D+04,0.870D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.99949930D+03,0.870D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.82315280D+04,0.870D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.63397235D+04,0.870D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.51715628D+04,0.870D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.17765919D+04,0.870D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.54969601D+04,0.870D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19001:  19100)=(/
     . 0.51886826D+04,0.870D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.50376830D+04,0.870D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.49009739D+04,0.870D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.47792385D+04,0.870D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.35004650D+04,0.870D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.45180145D+04,0.870D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.43256882D+04,0.870D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.42216216D+04,0.870D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.41211013D+04,0.870D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.40270614D+04,0.870D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.39908778D+04,0.870D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.32187704D+04,0.870D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.29218119D+04,0.870D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.25563295D+04,0.870D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.21076991D+04,0.870D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.21032454D+04,0.870D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.18383882D+04,0.870D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.16363884D+04,0.870D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.13271181D+04,0.870D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.12270914D+04,0.870D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19101:  19200)=(/
     . 0.12394986D+04,0.870D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.21094753D+04,0.870D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.19333025D+04,0.870D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.16699965D+04,0.870D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.15408317D+04,0.870D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.13687363D+04,0.870D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.12134959D+04,0.870D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.73147398D+04,0.870D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.99413100D+02,0.880D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.59674000D+02,0.880D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.24340697D+04,0.880D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.11320344D+04,0.880D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.68137890D+03,0.880D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.42416130D+03,0.880D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.27936020D+03,0.880D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.20282600D+03,0.880D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.14825160D+03,0.880D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.11081260D+03,0.880D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.28745717D+04,0.880D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.18719600D+04,0.880D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19201:  19300)=(/
     . 0.16279493D+04,0.880D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.11837103D+04,0.880D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.86434290D+03,0.880D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.68837560D+03,0.880D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.54058680D+03,0.880D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.42751470D+03,0.880D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.49128581D+04,0.880D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.35289590D+04,0.880D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.28292273D+04,0.880D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.26655950D+04,0.880D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.24036878D+04,0.880D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.18947707D+04,0.880D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.20238919D+04,0.880D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.15845838D+04,0.880D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.16192221D+04,0.880D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.16942469D+04,0.880D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.13022136D+04,0.880D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.12677966D+04,0.880D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.15270149D+04,0.880D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.12635730D+04,0.880D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19301:  19400)=(/
     . 0.10197251D+04,0.880D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.88504330D+03,0.880D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.74865020D+03,0.880D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.63127570D+03,0.880D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.54594039D+04,0.880D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.42339736D+04,0.880D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.35246180D+04,0.880D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.30700206D+04,0.880D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.27442675D+04,0.880D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.20488350D+04,0.880D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.23149349D+04,0.880D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.16984672D+04,0.880D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.18511077D+04,0.880D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.16939362D+04,0.880D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.14296950D+04,0.880D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.14674624D+04,0.880D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.19210215D+04,0.880D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.16832537D+04,0.880D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.14267831D+04,0.880D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.12854608D+04,0.880D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19401:  19500)=(/
     . 0.11265319D+04,0.880D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.98363370D+03,0.880D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.66646049D+04,0.880D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.55052582D+04,0.880D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.45943095D+04,0.880D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.17037104D+04,0.880D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.47976061D+04,0.880D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.45623865D+04,0.880D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.44362592D+04,0.880D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.43214914D+04,0.880D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.42193690D+04,0.880D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.31447184D+04,0.880D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.38693475D+04,0.880D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.37006978D+04,0.880D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.37536534D+04,0.880D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.36679746D+04,0.880D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.35884351D+04,0.880D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.35540067D+04,0.880D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.28892983D+04,0.880D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.26921229D+04,0.880D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19501:  19600)=(/
     . 0.23813318D+04,0.880D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.19684730D+04,0.880D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.19760672D+04,0.880D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.17428522D+04,0.880D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.15616887D+04,0.880D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.12704258D+04,0.880D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.11766222D+04,0.880D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.11957573D+04,0.880D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.19547292D+04,0.880D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.18286515D+04,0.880D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.16046349D+04,0.880D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.14914089D+04,0.880D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.13351632D+04,0.880D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.11909286D+04,0.880D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.60457168D+04,0.880D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.53054399D+04,0.880D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.89406000D+02,0.890D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.54461300D+02,0.890D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.20082591D+04,0.890D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.97721480D+03,0.890D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19601:  19700)=(/
     . 0.60005330D+03,0.890D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.37866720D+03,0.890D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.25180860D+03,0.890D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.18403180D+03,0.890D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.13527920D+03,0.890D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.10158570D+03,0.890D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.23774617D+04,0.890D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.16040300D+04,0.890D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.14098711D+04,0.890D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.10405681D+04,0.890D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.76851320D+03,0.890D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.61613190D+03,0.890D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.48688350D+03,0.890D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.38707200D+03,0.890D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.40174782D+04,0.890D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.29771478D+04,0.890D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.24021540D+04,0.890D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.22732739D+04,0.890D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.20559589D+04,0.890D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.16183634D+04,0.890D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19701:  19800)=(/
     . 0.17384495D+04,0.890D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.13600663D+04,0.890D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.14017622D+04,0.890D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.14625357D+04,0.890D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.11217466D+04,0.890D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.11049523D+04,0.890D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.13263601D+04,0.890D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.11110958D+04,0.890D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.90553420D+03,0.890D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.79026450D+03,0.890D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.67216580D+03,0.890D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.56954790D+03,0.890D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.44690053D+04,0.890D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.35643510D+04,0.890D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.29977722D+04,0.890D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.26270446D+04,0.890D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.23567083D+04,0.890D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.17692538D+04,0.890D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.19948729D+04,0.890D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.14730457D+04,0.890D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19801:  19900)=(/
     . 0.16081722D+04,0.890D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.14753924D+04,0.890D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.12402274D+04,0.890D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.12822835D+04,0.890D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.16650502D+04,0.890D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.14751121D+04,0.890D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.12620917D+04,0.890D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.11429090D+04,0.890D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.10069141D+04,0.890D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.88341400D+03,0.890D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.54478929D+04,0.890D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.46120247D+04,0.890D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.38897052D+04,0.890D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.15031569D+04,0.890D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.40323992D+04,0.890D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.38433536D+04,0.890D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.37393646D+04,0.890D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.36445469D+04,0.890D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.35602278D+04,0.890D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.26796802D+04,0.890D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  19901:  20000)=(/
     . 0.32333681D+04,0.890D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.30968078D+04,0.890D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.31769406D+04,0.890D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.31056847D+04,0.890D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.30398461D+04,0.890D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.30095999D+04,0.890D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.24623774D+04,0.890D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.23202277D+04,0.890D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.20645670D+04,0.890D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.17115570D+04,0.890D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.17232231D+04,0.890D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.15276535D+04,0.890D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.13743640D+04,0.890D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.11213924D+04,0.890D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.10400238D+04,0.890D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.10600607D+04,0.890D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.16946605D+04,0.890D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.16008616D+04,0.890D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.14174346D+04,0.890D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.13236360D+04,0.890D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20001:  20100)=(/
     . 0.11913272D+04,0.890D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.10675065D+04,0.890D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.49814961D+04,0.890D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.44669584D+04,0.890D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.37996565D+04,0.890D+02,0.890D+02,0.00000000D+00,0.00000000D+00
     .,0.82083600D+02,0.900D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.51110300D+02,0.900D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16724768D+04,0.900D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.85252490D+03,0.900D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.53608580D+03,0.900D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.34435760D+03,0.900D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.23207230D+03,0.900D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.17124180D+03,0.900D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12693930D+03,0.900D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.95984500D+02,0.900D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.19852103D+04,0.900D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.13883756D+04,0.900D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.12352681D+04,0.900D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.92751070D+03,0.900D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.69479830D+03,0.900D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20101:  20200)=(/
     . 0.56206360D+03,0.900D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.44804860D+03,0.900D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.35892730D+03,0.900D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.33208171D+04,0.900D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.25377308D+04,0.900D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.20608901D+04,0.900D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.19602827D+04,0.900D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.17786546D+04,0.900D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13994778D+04,0.900D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.15110816D+04,0.900D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.11825093D+04,0.900D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.12287380D+04,0.900D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.12777896D+04,0.900D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.97919840D+03,0.900D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.97588560D+03,0.900D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.11670583D+04,0.900D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.99120150D+03,0.900D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.81755520D+03,0.900D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.71866790D+03,0.900D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.61585050D+03,0.900D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20201:  20300)=(/
     . 0.52542400D+03,0.900D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.36996637D+04,0.900D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.30331273D+04,0.900D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.25787074D+04,0.900D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.22748325D+04,0.900D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.20492299D+04,0.900D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.15491780D+04,0.900D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.17421202D+04,0.900D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.12966551D+04,0.900D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.14168423D+04,0.900D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.13036060D+04,0.900D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10925939D+04,0.900D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.11371745D+04,0.900D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.14631580D+04,0.900D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.13115880D+04,0.900D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.11344385D+04,0.900D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.10338769D+04,0.900D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.91709200D+03,0.900D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.80980180D+03,0.900D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.45055681D+04,0.900D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20301:  20400)=(/
     . 0.39071262D+04,0.900D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.33315473D+04,0.900D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.13478223D+04,0.900D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.34277894D+04,0.900D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.32744792D+04,0.900D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.31877428D+04,0.900D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.31084769D+04,0.900D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.30380345D+04,0.900D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.23122086D+04,0.900D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.27358113D+04,0.900D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.26241922D+04,0.900D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.27191319D+04,0.900D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.26591268D+04,0.900D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.26040009D+04,0.900D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.25769767D+04,0.900D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.21236819D+04,0.900D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.20248239D+04,0.900D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.18137564D+04,0.900D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.15101361D+04,0.900D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.15249297D+04,0.900D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20401:  20500)=(/
     . 0.13598576D+04,0.900D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.12292164D+04,0.900D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.10074225D+04,0.900D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.93609580D+03,0.900D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.95680470D+03,0.900D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.14915698D+04,0.900D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.14229431D+04,0.900D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.12726601D+04,0.900D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.11951492D+04,0.900D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.10828719D+04,0.900D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.97614170D+03,0.900D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.41555932D+04,0.900D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.38047750D+04,0.900D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.32704258D+04,0.900D+02,0.890D+02,0.00000000D+00,0.00000000D+00
     .,0.28472704D+04,0.900D+02,0.900D+02,0.00000000D+00,0.00000000D+00
     .,0.80726000D+02,0.910D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.50005200D+02,0.910D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.17306038D+04,0.910D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.85763790D+03,0.910D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.53308180D+03,0.910D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20501:  20600)=(/
     . 0.33998630D+03,0.910D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.22813330D+03,0.910D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.16791870D+03,0.910D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12426420D+03,0.910D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.93866300D+02,0.910D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.20511151D+04,0.910D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.14030924D+04,0.910D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.12403071D+04,0.910D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.92324960D+03,0.910D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.68729140D+03,0.910D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.55412740D+03,0.910D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.44044180D+03,0.910D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.35207430D+03,0.910D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.34570434D+04,0.910D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.25892888D+04,0.910D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.20945389D+04,0.910D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.19869265D+04,0.910D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.17996577D+04,0.910D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.14173421D+04,0.910D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.15251022D+04,0.910D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20601:  20700)=(/
     . 0.11941778D+04,0.910D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.12344914D+04,0.910D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.12859300D+04,0.910D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.98684670D+03,0.910D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.97668650D+03,0.910D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.11699494D+04,0.910D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.98664000D+03,0.910D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.80937540D+03,0.910D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.70943800D+03,0.910D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.60630260D+03,0.910D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.51614250D+03,0.910D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.38488310D+04,0.910D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.30987868D+04,0.910D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.26179361D+04,0.910D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.23009943D+04,0.910D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.20684111D+04,0.910D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.15587481D+04,0.910D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.17549706D+04,0.910D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.13015598D+04,0.910D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.14207211D+04,0.910D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20701:  20800)=(/
     . 0.13053320D+04,0.910D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10968175D+04,0.910D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.11367042D+04,0.910D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.14690715D+04,0.910D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.13085146D+04,0.910D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.11258498D+04,0.910D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.10231942D+04,0.910D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.90511410D+03,0.910D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.79733130D+03,0.910D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.46916964D+04,0.910D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.40037089D+04,0.910D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.33915606D+04,0.910D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.13396248D+04,0.910D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.35059336D+04,0.910D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.33442162D+04,0.910D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.32544268D+04,0.910D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.31724783D+04,0.910D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.30996207D+04,0.910D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.23450320D+04,0.910D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.28084101D+04,0.910D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20801:  20900)=(/
     . 0.26917985D+04,0.910D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.27690943D+04,0.910D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.27073188D+04,0.910D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.26503867D+04,0.910D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.26234579D+04,0.910D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.21538516D+04,0.910D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.20393959D+04,0.910D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.18205331D+04,0.910D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.15133881D+04,0.910D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.15256409D+04,0.910D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.13566458D+04,0.910D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.12236676D+04,0.910D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.10014754D+04,0.910D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.92999430D+03,0.910D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.94896980D+03,0.910D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.14976018D+04,0.910D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.14206996D+04,0.910D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.12642423D+04,0.910D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.11841627D+04,0.910D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.10698651D+04,0.910D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  20901:  21000)=(/
     . 0.96217680D+03,0.910D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.43039645D+04,0.910D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.38865716D+04,0.910D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.33200764D+04,0.910D+02,0.890D+02,0.00000000D+00,0.00000000D+00
     .,0.28725136D+04,0.910D+02,0.900D+02,0.00000000D+00,0.00000000D+00
     .,0.29089206D+04,0.910D+02,0.910D+02,0.00000000D+00,0.00000000D+00
     .,0.78203400D+02,0.920D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.48498000D+02,0.920D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.16716156D+04,0.920D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.82971320D+03,0.920D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.51601950D+03,0.920D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.32928020D+03,0.920D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.22106590D+03,0.920D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.16279260D+03,0.920D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12052900D+03,0.920D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.91086900D+02,0.920D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.19814675D+04,0.920D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.13571628D+04,0.920D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.12000275D+04,0.920D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.89364440D+03,0.920D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21001:  21100)=(/
     . 0.66549650D+03,0.920D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.53670890D+03,0.920D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.42673540D+03,0.920D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.34123400D+03,0.920D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.33376961D+04,0.920D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.25033576D+04,0.920D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.20254740D+04,0.920D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.19216819D+04,0.920D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.17407294D+04,0.920D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13709264D+04,0.920D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.14753669D+04,0.920D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.11552737D+04,0.920D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.11945389D+04,0.920D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.12442037D+04,0.920D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.95483090D+03,0.920D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.94527750D+03,0.920D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.11321107D+04,0.920D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.95506070D+03,0.920D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.78370690D+03,0.920D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.68708390D+03,0.920D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21101:  21200)=(/
     . 0.58734500D+03,0.920D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.50013680D+03,0.920D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.37160678D+04,0.920D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.29957186D+04,0.920D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.25317373D+04,0.920D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.22256807D+04,0.920D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.20009439D+04,0.920D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.15082494D+04,0.920D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.16979484D+04,0.920D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.12596142D+04,0.920D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.13749665D+04,0.920D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.12634136D+04,0.920D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10615457D+04,0.920D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.11003399D+04,0.920D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.14216099D+04,0.920D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.12666329D+04,0.920D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.10901053D+04,0.920D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.99086960D+03,0.920D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.87669020D+03,0.920D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.77245190D+03,0.920D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21201:  21300)=(/
     . 0.45291727D+04,0.920D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.38697611D+04,0.920D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.32793360D+04,0.920D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.12970461D+04,0.920D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.33890395D+04,0.920D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.32330975D+04,0.920D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.31463690D+04,0.920D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.30672053D+04,0.920D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.29968237D+04,0.920D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.22680138D+04,0.920D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.27140296D+04,0.920D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.26013226D+04,0.920D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.26775672D+04,0.920D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.26178718D+04,0.920D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.25628645D+04,0.920D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.25367915D+04,0.920D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.20830385D+04,0.920D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.19730821D+04,0.920D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.17616844D+04,0.920D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.14646529D+04,0.920D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21301:  21400)=(/
     . 0.14766337D+04,0.920D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.13133066D+04,0.920D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.11847530D+04,0.920D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.96980220D+03,0.920D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.90065620D+03,0.920D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.91908240D+03,0.920D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.14493061D+04,0.920D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.13752752D+04,0.920D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.12241322D+04,0.920D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.11467509D+04,0.920D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.10362496D+04,0.920D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.93211210D+03,0.920D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.41565121D+04,0.920D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.37572430D+04,0.920D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.32107560D+04,0.920D+02,0.890D+02,0.00000000D+00,0.00000000D+00
     .,0.27789432D+04,0.920D+02,0.900D+02,0.00000000D+00,0.00000000D+00
     .,0.28136269D+04,0.920D+02,0.910D+02,0.00000000D+00,0.00000000D+00
     .,0.27215209D+04,0.920D+02,0.920D+02,0.00000000D+00,0.00000000D+00
     .,0.79439100D+02,0.930D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.48724100D+02,0.930D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21401:  21500)=(/
     . 0.18005066D+04,0.930D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.86956410D+03,0.930D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.53289880D+03,0.930D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.33646270D+03,0.930D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.22420940D+03,0.930D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.16429590D+03,0.930D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.12116670D+03,0.930D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.91309000D+02,0.930D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.21313007D+04,0.930D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.14294308D+04,0.930D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.12543604D+04,0.930D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.92419700D+03,0.930D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.68227500D+03,0.930D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.54731890D+03,0.930D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.43301050D+03,0.930D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.34483050D+03,0.930D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.36085602D+04,0.930D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.26611178D+04,0.930D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.21449232D+04,0.930D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.20287846D+04,0.930D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21501:  21600)=(/
     . 0.18341800D+04,0.930D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.14450682D+04,0.930D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.15501899D+04,0.930D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.12138708D+04,0.930D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.12487909D+04,0.930D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.13033334D+04,0.930D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.10009549D+04,0.930D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.98372150D+03,0.930D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.11804499D+04,0.930D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.98737510D+03,0.930D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.80425620D+03,0.930D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.70203110D+03,0.930D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.59750350D+03,0.930D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.50682160D+03,0.930D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.40138973D+04,0.930D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.31875734D+04,0.930D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.26766472D+04,0.930D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.23437586D+04,0.930D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.21018417D+04,0.930D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.15778736D+04,0.930D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21601:  21700)=(/
     . 0.17790323D+04,0.930D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.13137158D+04,0.930D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.14331563D+04,0.930D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.13146561D+04,0.930D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.11068617D+04,0.930D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.11425196D+04,0.930D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.14840150D+04,0.930D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.13126653D+04,0.930D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.11221440D+04,0.930D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.10160025D+04,0.930D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.89523210D+03,0.930D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.78580380D+03,0.930D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.48930436D+04,0.930D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.41279330D+04,0.930D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.34757124D+04,0.930D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.13372850D+04,0.930D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.36078825D+04,0.930D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.34378544D+04,0.930D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.33445279D+04,0.930D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.32594431D+04,0.930D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21701:  21800)=(/
     . 0.31837627D+04,0.930D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.23935584D+04,0.930D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.28964080D+04,0.930D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.27730351D+04,0.930D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.28396469D+04,0.930D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.27757424D+04,0.930D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.27166522D+04,0.930D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.26897033D+04,0.930D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.21986632D+04,0.930D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.20680029D+04,0.930D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.18390464D+04,0.930D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.15251115D+04,0.930D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.15347972D+04,0.930D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.13602378D+04,0.930D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.12236448D+04,0.930D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.99920960D+03,0.930D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.92702850D+03,0.930D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.94428620D+03,0.930D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.15116714D+04,0.930D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.14258266D+04,0.930D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21801:  21900)=(/
     . 0.12612415D+04,0.930D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.11774038D+04,0.930D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.10596377D+04,0.930D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.94975540D+03,0.930D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.44697774D+04,0.930D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.39952606D+04,0.930D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.33932601D+04,0.930D+02,0.890D+02,0.00000000D+00,0.00000000D+00
     .,0.29170992D+04,0.930D+02,0.900D+02,0.00000000D+00,0.00000000D+00
     .,0.29646668D+04,0.930D+02,0.910D+02,0.00000000D+00,0.00000000D+00
     .,0.28671025D+04,0.930D+02,0.920D+02,0.00000000D+00,0.00000000D+00
     .,0.30329760D+04,0.930D+02,0.930D+02,0.00000000D+00,0.00000000D+00
     .,0.77102100D+02,0.940D+02,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.47379800D+02,0.940D+02,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.17278140D+04,0.940D+02,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.83944780D+03,0.940D+02,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.51579770D+03,0.940D+02,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.32625000D+03,0.940D+02,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.21767650D+03,0.940D+02,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.15964350D+03,0.940D+02,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.11781930D+03,0.940D+02,0.900D+01,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  21901:  22000)=(/
     . 0.88836500D+02,0.940D+02,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.20459284D+04,0.940D+02,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.13785876D+04,0.940D+02,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.12114443D+04,0.940D+02,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.89432550D+03,0.940D+02,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.66120920D+03,0.940D+02,0.150D+02,0.00000000D+00,0.00000000D+00
     .,0.53088280D+03,0.940D+02,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.42034980D+03,0.940D+02,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.33497590D+03,0.940D+02,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.34586883D+04,0.940D+02,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.25612750D+04,0.940D+02,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.20661768D+04,0.940D+02,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.19554505D+04,0.940D+02,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.17685649D+04,0.940D+02,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.13931385D+04,0.940D+02,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.14955657D+04,0.940D+02,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.11710013D+04,0.940D+02,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.12060158D+04,0.940D+02,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.12582170D+04,0.940D+02,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.96605990D+03,0.940D+02,0.290D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22001:  22100)=(/
     . 0.95086030D+03,0.940D+02,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.11405197D+04,0.940D+02,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.95550390D+03,0.940D+02,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.77929760D+03,0.940D+02,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.68073550D+03,0.940D+02,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.57979560D+03,0.940D+02,0.350D+02,0.00000000D+00,0.00000000D+00
     .,0.49211280D+03,0.940D+02,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.38477324D+04,0.940D+02,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.30671463D+04,0.940D+02,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.25790022D+04,0.940D+02,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.22600639D+04,0.940D+02,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.20277440D+04,0.940D+02,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.15233742D+04,0.940D+02,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.17171041D+04,0.940D+02,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.12690647D+04,0.940D+02,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.13847315D+04,0.940D+02,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.12706578D+04,0.940D+02,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.10692791D+04,0.940D+02,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.11047467D+04,0.940D+02,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.14334370D+04,0.940D+02,0.490D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22101:  22200)=(/
     . 0.12697368D+04,0.940D+02,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.10867671D+04,0.940D+02,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.98462910D+03,0.940D+02,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.86818680D+03,0.940D+02,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.76254070D+03,0.940D+02,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.46894909D+04,0.940D+02,0.550D+02,0.00000000D+00,0.00000000D+00
     .,0.39694488D+04,0.940D+02,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.33469278D+04,0.940D+02,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.12946997D+04,0.940D+02,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.34708103D+04,0.940D+02,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.33082782D+04,0.940D+02,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.32187253D+04,0.940D+02,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.31370576D+04,0.940D+02,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.30644224D+04,0.940D+02,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.23068366D+04,0.940D+02,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.27842586D+04,0.940D+02,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.26660816D+04,0.940D+02,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.27342974D+04,0.940D+02,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.26729042D+04,0.940D+02,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.26161724D+04,0.940D+02,0.690D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22201:  22300)=(/
     . 0.25900957D+04,0.940D+02,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.21189811D+04,0.940D+02,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.19960266D+04,0.940D+02,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.17764187D+04,0.940D+02,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.14737544D+04,0.940D+02,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.14836747D+04,0.940D+02,0.750D+02,0.00000000D+00,0.00000000D+00
     .,0.13158080D+04,0.940D+02,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.11842955D+04,0.940D+02,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.96746430D+03,0.940D+02,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.89773860D+03,0.940D+02,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.91479120D+03,0.940D+02,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.14602247D+04,0.940D+02,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.13790263D+04,0.940D+02,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.12212647D+04,0.940D+02,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.11407827D+04,0.940D+02,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.10273948D+04,0.940D+02,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.92140470D+03,0.940D+02,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.42885858D+04,0.940D+02,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.38444325D+04,0.940D+02,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.32695288D+04,0.940D+02,0.890D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22301:  22400)=(/
     . 0.28146033D+04,0.940D+02,0.900D+02,0.00000000D+00,0.00000000D+00
     .,0.28581875D+04,0.940D+02,0.910D+02,0.00000000D+00,0.00000000D+00
     .,0.27642585D+04,0.940D+02,0.920D+02,0.00000000D+00,0.00000000D+00
     .,0.29218223D+04,0.940D+02,0.930D+02,0.00000000D+00,0.00000000D+00
     .,0.28152366D+04,0.940D+02,0.940D+02,0.00000000D+00,0.00000000D+00
     .,0.47379000D+01,0.101D+03,0.100D+01,0.00000000D+00,0.91180000D+00
     .,0.31287000D+01,0.101D+03,0.200D+01,0.00000000D+00,0.00000000D+00
     .,0.68939100D+02,0.101D+03,0.300D+01,0.00000000D+00,0.00000000D+00
     .,0.41307800D+02,0.101D+03,0.400D+01,0.00000000D+00,0.00000000D+00
     .,0.28276700D+02,0.101D+03,0.500D+01,0.00000000D+00,0.00000000D+00
     .,0.19265300D+02,0.101D+03,0.600D+01,0.00000000D+00,0.00000000D+00
     .,0.13516400D+02,0.101D+03,0.700D+01,0.00000000D+00,0.00000000D+00
     .,0.10237100D+02,0.101D+03,0.800D+01,0.00000000D+00,0.00000000D+00
     .,0.77441000D+01,0.101D+03,0.900D+01,0.00000000D+00,0.00000000D+00
     .,0.59403000D+01,0.101D+03,0.100D+02,0.00000000D+00,0.00000000D+00
     .,0.82564100D+02,0.101D+03,0.110D+02,0.00000000D+00,0.00000000D+00
     .,0.65370300D+02,0.101D+03,0.120D+02,0.00000000D+00,0.00000000D+00
     .,0.60855800D+02,0.101D+03,0.130D+02,0.00000000D+00,0.00000000D+00
     .,0.48518200D+02,0.101D+03,0.140D+02,0.00000000D+00,0.00000000D+00
     .,0.38139700D+02,0.101D+03,0.150D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22401:  22500)=(/
     . 0.31771300D+02,0.101D+03,0.160D+02,0.00000000D+00,0.00000000D+00
     .,0.26017000D+02,0.101D+03,0.170D+02,0.00000000D+00,0.00000000D+00
     .,0.21305500D+02,0.101D+03,0.180D+02,0.00000000D+00,0.00000000D+00
     .,0.13444410D+03,0.101D+03,0.190D+02,0.00000000D+00,0.00000000D+00
     .,0.11348570D+03,0.101D+03,0.200D+02,0.00000000D+00,0.00000000D+00
     .,0.94208300D+02,0.101D+03,0.210D+02,0.00000000D+00,0.00000000D+00
     .,0.91333400D+02,0.101D+03,0.220D+02,0.00000000D+00,0.00000000D+00
     .,0.83831300D+02,0.101D+03,0.230D+02,0.00000000D+00,0.00000000D+00
     .,0.65983700D+02,0.101D+03,0.240D+02,0.00000000D+00,0.00000000D+00
     .,0.72411100D+02,0.101D+03,0.250D+02,0.00000000D+00,0.00000000D+00
     .,0.56799300D+02,0.101D+03,0.260D+02,0.00000000D+00,0.00000000D+00
     .,0.60574600D+02,0.101D+03,0.270D+02,0.00000000D+00,0.00000000D+00
     .,0.62253200D+02,0.101D+03,0.280D+02,0.00000000D+00,0.00000000D+00
     .,0.47649900D+02,0.101D+03,0.290D+02,0.00000000D+00,0.00000000D+00
     .,0.49346900D+02,0.101D+03,0.300D+02,0.00000000D+00,0.00000000D+00
     .,0.58420700D+02,0.101D+03,0.310D+02,0.00000000D+00,0.00000000D+00
     .,0.51990500D+02,0.101D+03,0.320D+02,0.00000000D+00,0.00000000D+00
     .,0.44651200D+02,0.101D+03,0.330D+02,0.00000000D+00,0.00000000D+00
     .,0.40201000D+02,0.101D+03,0.340D+02,0.00000000D+00,0.00000000D+00
     .,0.35274000D+02,0.101D+03,0.350D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22501:  22600)=(/
     . 0.30726100D+02,0.101D+03,0.360D+02,0.00000000D+00,0.00000000D+00
     .,0.15093400D+03,0.101D+03,0.370D+02,0.00000000D+00,0.00000000D+00
     .,0.13506640D+03,0.101D+03,0.380D+02,0.00000000D+00,0.00000000D+00
     .,0.11929610D+03,0.101D+03,0.390D+02,0.00000000D+00,0.00000000D+00
     .,0.10773060D+03,0.101D+03,0.400D+02,0.00000000D+00,0.00000000D+00
     .,0.98518300D+02,0.101D+03,0.410D+02,0.00000000D+00,0.00000000D+00
     .,0.76366100D+02,0.101D+03,0.420D+02,0.00000000D+00,0.00000000D+00
     .,0.85080000D+02,0.101D+03,0.430D+02,0.00000000D+00,0.00000000D+00
     .,0.65086300D+02,0.101D+03,0.440D+02,0.00000000D+00,0.00000000D+00
     .,0.71198500D+02,0.101D+03,0.450D+02,0.00000000D+00,0.00000000D+00
     .,0.66121100D+02,0.101D+03,0.460D+02,0.00000000D+00,0.00000000D+00
     .,0.54965800D+02,0.101D+03,0.470D+02,0.00000000D+00,0.00000000D+00
     .,0.58356800D+02,0.101D+03,0.480D+02,0.00000000D+00,0.00000000D+00
     .,0.72907600D+02,0.101D+03,0.490D+02,0.00000000D+00,0.00000000D+00
     .,0.67943000D+02,0.101D+03,0.500D+02,0.00000000D+00,0.00000000D+00
     .,0.60947000D+02,0.101D+03,0.510D+02,0.00000000D+00,0.00000000D+00
     .,0.56742700D+02,0.101D+03,0.520D+02,0.00000000D+00,0.00000000D+00
     .,0.51465600D+02,0.101D+03,0.530D+02,0.00000000D+00,0.00000000D+00
     .,0.46379400D+02,0.101D+03,0.540D+02,0.00000000D+00,0.00000000D+00
     .,0.18402230D+03,0.101D+03,0.550D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22601:  22700)=(/
     . 0.17170330D+03,0.101D+03,0.560D+02,0.00000000D+00,0.00000000D+00
     .,0.15211060D+03,0.101D+03,0.570D+02,0.00000000D+00,0.00000000D+00
     .,0.71883000D+02,0.101D+03,0.580D+02,0.00000000D+00,0.27991000D+01
     .,0.15245020D+03,0.101D+03,0.590D+02,0.00000000D+00,0.00000000D+00
     .,0.14658510D+03,0.101D+03,0.600D+02,0.00000000D+00,0.00000000D+00
     .,0.14296200D+03,0.101D+03,0.610D+02,0.00000000D+00,0.00000000D+00
     .,0.13962540D+03,0.101D+03,0.620D+02,0.00000000D+00,0.00000000D+00
     .,0.13666950D+03,0.101D+03,0.630D+02,0.00000000D+00,0.00000000D+00
     .,0.10836620D+03,0.101D+03,0.640D+02,0.00000000D+00,0.00000000D+00
     .,0.12040560D+03,0.101D+03,0.650D+02,0.00000000D+00,0.00000000D+00
     .,0.11631780D+03,0.101D+03,0.660D+02,0.00000000D+00,0.00000000D+00
     .,0.12352200D+03,0.101D+03,0.670D+02,0.00000000D+00,0.00000000D+00
     .,0.12093020D+03,0.101D+03,0.680D+02,0.00000000D+00,0.00000000D+00
     .,0.11860700D+03,0.101D+03,0.690D+02,0.00000000D+00,0.00000000D+00
     .,0.11718110D+03,0.101D+03,0.700D+02,0.00000000D+00,0.00000000D+00
     .,0.99298400D+02,0.101D+03,0.710D+02,0.00000000D+00,0.00000000D+00
     .,0.98513600D+02,0.101D+03,0.720D+02,0.00000000D+00,0.00000000D+00
     .,0.90285800D+02,0.101D+03,0.730D+02,0.00000000D+00,0.00000000D+00
     .,0.76415000D+02,0.101D+03,0.740D+02,0.00000000D+00,0.00000000D+00
     .,0.77879300D+02,0.101D+03,0.750D+02,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22701:  22800)=(/
     . 0.70802400D+02,0.101D+03,0.760D+02,0.00000000D+00,0.00000000D+00
     .,0.64989000D+02,0.101D+03,0.770D+02,0.00000000D+00,0.00000000D+00
     .,0.54045100D+02,0.101D+03,0.780D+02,0.00000000D+00,0.00000000D+00
     .,0.50508600D+02,0.101D+03,0.790D+02,0.00000000D+00,0.00000000D+00
     .,0.52054700D+02,0.101D+03,0.800D+02,0.00000000D+00,0.00000000D+00
     .,0.74881700D+02,0.101D+03,0.810D+02,0.00000000D+00,0.00000000D+00
     .,0.73669200D+02,0.101D+03,0.820D+02,0.00000000D+00,0.00000000D+00
     .,0.68103100D+02,0.101D+03,0.830D+02,0.00000000D+00,0.00000000D+00
     .,0.65160500D+02,0.101D+03,0.840D+02,0.00000000D+00,0.00000000D+00
     .,0.60333800D+02,0.101D+03,0.850D+02,0.00000000D+00,0.00000000D+00
     .,0.55434500D+02,0.101D+03,0.860D+02,0.00000000D+00,0.00000000D+00
     .,0.17492120D+03,0.101D+03,0.870D+02,0.00000000D+00,0.00000000D+00
     .,0.17050820D+03,0.101D+03,0.880D+02,0.00000000D+00,0.00000000D+00
     .,0.15181390D+03,0.101D+03,0.890D+02,0.00000000D+00,0.00000000D+00
     .,0.13747240D+03,0.101D+03,0.900D+02,0.00000000D+00,0.00000000D+00
     .,0.13587010D+03,0.101D+03,0.910D+02,0.00000000D+00,0.00000000D+00
     .,0.13156440D+03,0.101D+03,0.920D+02,0.00000000D+00,0.00000000D+00
     .,0.13473040D+03,0.101D+03,0.930D+02,0.00000000D+00,0.00000000D+00
     .,0.13059460D+03,0.101D+03,0.940D+02,0.00000000D+00,0.00000000D+00
     .,0.75916000D+01,0.101D+03,0.101D+03,0.00000000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22801:  22900)=(/
     . 0.14316500D+02,0.103D+03,0.100D+01,0.98650000D+00,0.91180000D+00
     .,0.87773000D+01,0.103D+03,0.200D+01,0.98650000D+00,0.00000000D+00
     .,0.28221060D+03,0.103D+03,0.300D+01,0.98650000D+00,0.00000000D+00
     .,0.14813230D+03,0.103D+03,0.400D+01,0.98650000D+00,0.00000000D+00
     .,0.93672900D+02,0.103D+03,0.500D+01,0.98650000D+00,0.00000000D+00
     .,0.60086000D+02,0.103D+03,0.600D+01,0.98650000D+00,0.00000000D+00
     .,0.40294400D+02,0.103D+03,0.700D+01,0.98650000D+00,0.00000000D+00
     .,0.29557500D+02,0.103D+03,0.800D+01,0.98650000D+00,0.00000000D+00
     .,0.21760500D+02,0.103D+03,0.900D+01,0.98650000D+00,0.00000000D+00
     .,0.16338800D+02,0.103D+03,0.100D+02,0.98650000D+00,0.00000000D+00
     .,0.33534500D+03,0.103D+03,0.110D+02,0.98650000D+00,0.00000000D+00
     .,0.24016270D+03,0.103D+03,0.120D+02,0.98650000D+00,0.00000000D+00
     .,0.21472650D+03,0.103D+03,0.130D+02,0.98650000D+00,0.00000000D+00
     .,0.16205080D+03,0.103D+03,0.140D+02,0.98650000D+00,0.00000000D+00
     .,0.12150670D+03,0.103D+03,0.150D+02,0.98650000D+00,0.00000000D+00
     .,0.98124900D+02,0.103D+03,0.160D+02,0.98650000D+00,0.00000000D+00
     .,0.77986500D+02,0.103D+03,0.170D+02,0.98650000D+00,0.00000000D+00
     .,0.62220500D+02,0.103D+03,0.180D+02,0.98650000D+00,0.00000000D+00
     .,0.55515160D+03,0.103D+03,0.190D+02,0.98650000D+00,0.00000000D+00
     .,0.43415760D+03,0.103D+03,0.200D+02,0.98650000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  22901:  23000)=(/
     . 0.35403170D+03,0.103D+03,0.210D+02,0.98650000D+00,0.00000000D+00
     .,0.33738960D+03,0.103D+03,0.220D+02,0.98650000D+00,0.00000000D+00
     .,0.30654820D+03,0.103D+03,0.230D+02,0.98650000D+00,0.00000000D+00
     .,0.24050330D+03,0.103D+03,0.240D+02,0.98650000D+00,0.00000000D+00
     .,0.26090190D+03,0.103D+03,0.250D+02,0.98650000D+00,0.00000000D+00
     .,0.20361490D+03,0.103D+03,0.260D+02,0.98650000D+00,0.00000000D+00
     .,0.21289780D+03,0.103D+03,0.270D+02,0.98650000D+00,0.00000000D+00
     .,0.22117390D+03,0.103D+03,0.280D+02,0.98650000D+00,0.00000000D+00
     .,0.16880750D+03,0.103D+03,0.290D+02,0.98650000D+00,0.00000000D+00
     .,0.16949490D+03,0.103D+03,0.300D+02,0.98650000D+00,0.00000000D+00
     .,0.20269000D+03,0.103D+03,0.310D+02,0.98650000D+00,0.00000000D+00
     .,0.17294250D+03,0.103D+03,0.320D+02,0.98650000D+00,0.00000000D+00
     .,0.14284710D+03,0.103D+03,0.330D+02,0.98650000D+00,0.00000000D+00
     .,0.12547680D+03,0.103D+03,0.340D+02,0.98650000D+00,0.00000000D+00
     .,0.10733800D+03,0.103D+03,0.350D+02,0.98650000D+00,0.00000000D+00
     .,0.91333300D+02,0.103D+03,0.360D+02,0.98650000D+00,0.00000000D+00
     .,0.61856810D+03,0.103D+03,0.370D+02,0.98650000D+00,0.00000000D+00
     .,0.51783930D+03,0.103D+03,0.380D+02,0.98650000D+00,0.00000000D+00
     .,0.44294480D+03,0.103D+03,0.390D+02,0.98650000D+00,0.00000000D+00
     .,0.39191790D+03,0.103D+03,0.400D+02,0.98650000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23001:  23100)=(/
     . 0.35350080D+03,0.103D+03,0.410D+02,0.98650000D+00,0.00000000D+00
     .,0.26737610D+03,0.103D+03,0.420D+02,0.98650000D+00,0.00000000D+00
     .,0.30065330D+03,0.103D+03,0.430D+02,0.98650000D+00,0.00000000D+00
     .,0.22388710D+03,0.103D+03,0.440D+02,0.98650000D+00,0.00000000D+00
     .,0.24525610D+03,0.103D+03,0.450D+02,0.98650000D+00,0.00000000D+00
     .,0.22580420D+03,0.103D+03,0.460D+02,0.98650000D+00,0.00000000D+00
     .,0.18833740D+03,0.103D+03,0.470D+02,0.98650000D+00,0.00000000D+00
     .,0.19709400D+03,0.103D+03,0.480D+02,0.98650000D+00,0.00000000D+00
     .,0.25313700D+03,0.103D+03,0.490D+02,0.98650000D+00,0.00000000D+00
     .,0.22808140D+03,0.103D+03,0.500D+02,0.98650000D+00,0.00000000D+00
     .,0.19776980D+03,0.103D+03,0.510D+02,0.98650000D+00,0.00000000D+00
     .,0.18030560D+03,0.103D+03,0.520D+02,0.98650000D+00,0.00000000D+00
     .,0.15986700D+03,0.103D+03,0.530D+02,0.98650000D+00,0.00000000D+00
     .,0.14098180D+03,0.103D+03,0.540D+02,0.98650000D+00,0.00000000D+00
     .,0.75234180D+03,0.103D+03,0.550D+02,0.98650000D+00,0.00000000D+00
     .,0.66457190D+03,0.103D+03,0.560D+02,0.98650000D+00,0.00000000D+00
     .,0.57042660D+03,0.103D+03,0.570D+02,0.98650000D+00,0.00000000D+00
     .,0.23452710D+03,0.103D+03,0.580D+02,0.98650000D+00,0.27991000D+01
     .,0.58397970D+03,0.103D+03,0.590D+02,0.98650000D+00,0.00000000D+00
     .,0.55869720D+03,0.103D+03,0.600D+02,0.98650000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23101:  23200)=(/
     . 0.54412320D+03,0.103D+03,0.610D+02,0.98650000D+00,0.00000000D+00
     .,0.53079090D+03,0.103D+03,0.620D+02,0.98650000D+00,0.00000000D+00
     .,0.51894980D+03,0.103D+03,0.630D+02,0.98650000D+00,0.00000000D+00
     .,0.39672230D+03,0.103D+03,0.640D+02,0.98650000D+00,0.00000000D+00
     .,0.46354420D+03,0.103D+03,0.650D+02,0.98650000D+00,0.00000000D+00
     .,0.44501010D+03,0.103D+03,0.660D+02,0.98650000D+00,0.00000000D+00
     .,0.46541000D+03,0.103D+03,0.670D+02,0.98650000D+00,0.00000000D+00
     .,0.45528270D+03,0.103D+03,0.680D+02,0.98650000D+00,0.00000000D+00
     .,0.44600300D+03,0.103D+03,0.690D+02,0.98650000D+00,0.00000000D+00
     .,0.44132200D+03,0.103D+03,0.700D+02,0.98650000D+00,0.00000000D+00
     .,0.36474670D+03,0.103D+03,0.710D+02,0.98650000D+00,0.00000000D+00
     .,0.35006170D+03,0.103D+03,0.720D+02,0.98650000D+00,0.00000000D+00
     .,0.31424830D+03,0.103D+03,0.730D+02,0.98650000D+00,0.00000000D+00
     .,0.26138330D+03,0.103D+03,0.740D+02,0.98650000D+00,0.00000000D+00
     .,0.26436970D+03,0.103D+03,0.750D+02,0.98650000D+00,0.00000000D+00
     .,0.23602580D+03,0.103D+03,0.760D+02,0.98650000D+00,0.00000000D+00
     .,0.21346440D+03,0.103D+03,0.770D+02,0.98650000D+00,0.00000000D+00
     .,0.17461320D+03,0.103D+03,0.780D+02,0.98650000D+00,0.00000000D+00
     .,0.16213420D+03,0.103D+03,0.790D+02,0.98650000D+00,0.00000000D+00
     .,0.16604890D+03,0.103D+03,0.800D+02,0.98650000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23201:  23300)=(/
     . 0.25738230D+03,0.103D+03,0.810D+02,0.98650000D+00,0.00000000D+00
     .,0.24683550D+03,0.103D+03,0.820D+02,0.98650000D+00,0.00000000D+00
     .,0.22143250D+03,0.103D+03,0.830D+02,0.98650000D+00,0.00000000D+00
     .,0.20812690D+03,0.103D+03,0.840D+02,0.98650000D+00,0.00000000D+00
     .,0.18860730D+03,0.103D+03,0.850D+02,0.98650000D+00,0.00000000D+00
     .,0.16989430D+03,0.103D+03,0.860D+02,0.98650000D+00,0.00000000D+00
     .,0.69764490D+03,0.103D+03,0.870D+02,0.98650000D+00,0.00000000D+00
     .,0.64903250D+03,0.103D+03,0.880D+02,0.98650000D+00,0.00000000D+00
     .,0.56135190D+03,0.103D+03,0.890D+02,0.98650000D+00,0.00000000D+00
     .,0.49107770D+03,0.103D+03,0.900D+02,0.98650000D+00,0.00000000D+00
     .,0.49346510D+03,0.103D+03,0.910D+02,0.98650000D+00,0.00000000D+00
     .,0.47742540D+03,0.103D+03,0.920D+02,0.98650000D+00,0.00000000D+00
     .,0.49952020D+03,0.103D+03,0.930D+02,0.98650000D+00,0.00000000D+00
     .,0.48234660D+03,0.103D+03,0.940D+02,0.98650000D+00,0.00000000D+00
     .,0.24057300D+02,0.103D+03,0.101D+03,0.98650000D+00,0.00000000D+00
     .,0.85319700D+02,0.103D+03,0.103D+03,0.98650000D+00,0.98650000D+00
     .,0.18465600D+02,0.104D+03,0.100D+01,0.98080000D+00,0.91180000D+00
     .,0.11465500D+02,0.104D+03,0.200D+01,0.98080000D+00,0.00000000D+00
     .,0.35221600D+03,0.104D+03,0.300D+01,0.98080000D+00,0.00000000D+00
     .,0.18634530D+03,0.104D+03,0.400D+01,0.98080000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23301:  23400)=(/
     . 0.11908150D+03,0.104D+03,0.500D+01,0.98080000D+00,0.00000000D+00
     .,0.77095100D+02,0.104D+03,0.600D+01,0.98080000D+00,0.00000000D+00
     .,0.52085200D+02,0.104D+03,0.700D+01,0.98080000D+00,0.00000000D+00
     .,0.38413200D+02,0.104D+03,0.800D+01,0.98080000D+00,0.00000000D+00
     .,0.28409800D+02,0.104D+03,0.900D+01,0.98080000D+00,0.00000000D+00
     .,0.21406700D+02,0.104D+03,0.100D+02,0.98080000D+00,0.00000000D+00
     .,0.41864880D+03,0.104D+03,0.110D+02,0.98080000D+00,0.00000000D+00
     .,0.30137770D+03,0.104D+03,0.120D+02,0.98080000D+00,0.00000000D+00
     .,0.27074610D+03,0.104D+03,0.130D+02,0.98080000D+00,0.00000000D+00
     .,0.20575440D+03,0.104D+03,0.140D+02,0.98080000D+00,0.00000000D+00
     .,0.15536440D+03,0.104D+03,0.150D+02,0.98080000D+00,0.00000000D+00
     .,0.12609930D+03,0.104D+03,0.160D+02,0.98080000D+00,0.00000000D+00
     .,0.10072120D+03,0.104D+03,0.170D+02,0.98080000D+00,0.00000000D+00
     .,0.80717400D+02,0.104D+03,0.180D+02,0.98080000D+00,0.00000000D+00
     .,0.69485960D+03,0.104D+03,0.190D+02,0.98080000D+00,0.00000000D+00
     .,0.54358420D+03,0.104D+03,0.200D+02,0.98080000D+00,0.00000000D+00
     .,0.44371900D+03,0.104D+03,0.210D+02,0.98080000D+00,0.00000000D+00
     .,0.42362170D+03,0.104D+03,0.220D+02,0.98080000D+00,0.00000000D+00
     .,0.38527540D+03,0.104D+03,0.230D+02,0.98080000D+00,0.00000000D+00
     .,0.30260610D+03,0.104D+03,0.240D+02,0.98080000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23401:  23500)=(/
     . 0.32840120D+03,0.104D+03,0.250D+02,0.98080000D+00,0.00000000D+00
     .,0.25660430D+03,0.104D+03,0.260D+02,0.98080000D+00,0.00000000D+00
     .,0.26862840D+03,0.104D+03,0.270D+02,0.98080000D+00,0.00000000D+00
     .,0.27871160D+03,0.104D+03,0.280D+02,0.98080000D+00,0.00000000D+00
     .,0.21297970D+03,0.104D+03,0.290D+02,0.98080000D+00,0.00000000D+00
     .,0.21442560D+03,0.104D+03,0.300D+02,0.98080000D+00,0.00000000D+00
     .,0.25620490D+03,0.104D+03,0.310D+02,0.98080000D+00,0.00000000D+00
     .,0.21973750D+03,0.104D+03,0.320D+02,0.98080000D+00,0.00000000D+00
     .,0.18253380D+03,0.104D+03,0.330D+02,0.98080000D+00,0.00000000D+00
     .,0.16096870D+03,0.104D+03,0.340D+02,0.98080000D+00,0.00000000D+00
     .,0.13827470D+03,0.104D+03,0.350D+02,0.98080000D+00,0.00000000D+00
     .,0.11812400D+03,0.104D+03,0.360D+02,0.98080000D+00,0.00000000D+00
     .,0.77496560D+03,0.104D+03,0.370D+02,0.98080000D+00,0.00000000D+00
     .,0.64864220D+03,0.104D+03,0.380D+02,0.98080000D+00,0.00000000D+00
     .,0.55615030D+03,0.104D+03,0.390D+02,0.98080000D+00,0.00000000D+00
     .,0.49301000D+03,0.104D+03,0.400D+02,0.98080000D+00,0.00000000D+00
     .,0.44537360D+03,0.104D+03,0.410D+02,0.98080000D+00,0.00000000D+00
     .,0.33790350D+03,0.104D+03,0.420D+02,0.98080000D+00,0.00000000D+00
     .,0.37952540D+03,0.104D+03,0.430D+02,0.98080000D+00,0.00000000D+00
     .,0.28356950D+03,0.104D+03,0.440D+02,0.98080000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23501:  23600)=(/
     . 0.31037810D+03,0.104D+03,0.450D+02,0.98080000D+00,0.00000000D+00
     .,0.28603950D+03,0.104D+03,0.460D+02,0.98080000D+00,0.00000000D+00
     .,0.23869620D+03,0.104D+03,0.470D+02,0.98080000D+00,0.00000000D+00
     .,0.24999150D+03,0.104D+03,0.480D+02,0.98080000D+00,0.00000000D+00
     .,0.32009120D+03,0.104D+03,0.490D+02,0.98080000D+00,0.00000000D+00
     .,0.28947130D+03,0.104D+03,0.500D+02,0.98080000D+00,0.00000000D+00
     .,0.25216490D+03,0.104D+03,0.510D+02,0.98080000D+00,0.00000000D+00
     .,0.23063090D+03,0.104D+03,0.520D+02,0.98080000D+00,0.00000000D+00
     .,0.20522370D+03,0.104D+03,0.530D+02,0.98080000D+00,0.00000000D+00
     .,0.18162600D+03,0.104D+03,0.540D+02,0.98080000D+00,0.00000000D+00
     .,0.94385470D+03,0.104D+03,0.550D+02,0.98080000D+00,0.00000000D+00
     .,0.83262510D+03,0.104D+03,0.560D+02,0.98080000D+00,0.00000000D+00
     .,0.71607580D+03,0.104D+03,0.570D+02,0.98080000D+00,0.00000000D+00
     .,0.29887820D+03,0.104D+03,0.580D+02,0.98080000D+00,0.27991000D+01
     .,0.73216420D+03,0.104D+03,0.590D+02,0.98080000D+00,0.00000000D+00
     .,0.70044420D+03,0.104D+03,0.600D+02,0.98080000D+00,0.00000000D+00
     .,0.68219010D+03,0.104D+03,0.610D+02,0.98080000D+00,0.00000000D+00
     .,0.66548680D+03,0.104D+03,0.620D+02,0.98080000D+00,0.00000000D+00
     .,0.65065570D+03,0.104D+03,0.630D+02,0.98080000D+00,0.00000000D+00
     .,0.49918370D+03,0.104D+03,0.640D+02,0.98080000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23601:  23700)=(/
     . 0.58212240D+03,0.104D+03,0.650D+02,0.98080000D+00,0.00000000D+00
     .,0.55929170D+03,0.104D+03,0.660D+02,0.98080000D+00,0.00000000D+00
     .,0.58370670D+03,0.104D+03,0.670D+02,0.98080000D+00,0.00000000D+00
     .,0.57100390D+03,0.104D+03,0.680D+02,0.98080000D+00,0.00000000D+00
     .,0.55938980D+03,0.104D+03,0.690D+02,0.98080000D+00,0.00000000D+00
     .,0.55342660D+03,0.104D+03,0.700D+02,0.98080000D+00,0.00000000D+00
     .,0.45865820D+03,0.104D+03,0.710D+02,0.98080000D+00,0.00000000D+00
     .,0.44137890D+03,0.104D+03,0.720D+02,0.98080000D+00,0.00000000D+00
     .,0.39713120D+03,0.104D+03,0.730D+02,0.98080000D+00,0.00000000D+00
     .,0.33121240D+03,0.104D+03,0.740D+02,0.98080000D+00,0.00000000D+00
     .,0.33522610D+03,0.104D+03,0.750D+02,0.98080000D+00,0.00000000D+00
     .,0.29995650D+03,0.104D+03,0.760D+02,0.98080000D+00,0.00000000D+00
     .,0.27181190D+03,0.104D+03,0.770D+02,0.98080000D+00,0.00000000D+00
     .,0.22291570D+03,0.104D+03,0.780D+02,0.98080000D+00,0.00000000D+00
     .,0.20718310D+03,0.104D+03,0.790D+02,0.98080000D+00,0.00000000D+00
     .,0.21231320D+03,0.104D+03,0.800D+02,0.98080000D+00,0.00000000D+00
     .,0.32610680D+03,0.104D+03,0.810D+02,0.98080000D+00,0.00000000D+00
     .,0.31346750D+03,0.104D+03,0.820D+02,0.98080000D+00,0.00000000D+00
     .,0.28229350D+03,0.104D+03,0.830D+02,0.98080000D+00,0.00000000D+00
     .,0.26602000D+03,0.104D+03,0.840D+02,0.98080000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23701:  23800)=(/
     . 0.24186880D+03,0.104D+03,0.850D+02,0.98080000D+00,0.00000000D+00
     .,0.21856870D+03,0.104D+03,0.860D+02,0.98080000D+00,0.00000000D+00
     .,0.87585630D+03,0.104D+03,0.870D+02,0.98080000D+00,0.00000000D+00
     .,0.81413080D+03,0.104D+03,0.880D+02,0.98080000D+00,0.00000000D+00
     .,0.70540110D+03,0.104D+03,0.890D+02,0.98080000D+00,0.00000000D+00
     .,0.61906050D+03,0.104D+03,0.900D+02,0.98080000D+00,0.00000000D+00
     .,0.62133990D+03,0.104D+03,0.910D+02,0.98080000D+00,0.00000000D+00
     .,0.60114960D+03,0.104D+03,0.920D+02,0.98080000D+00,0.00000000D+00
     .,0.62763850D+03,0.104D+03,0.930D+02,0.98080000D+00,0.00000000D+00
     .,0.60621390D+03,0.104D+03,0.940D+02,0.98080000D+00,0.00000000D+00
     .,0.30786600D+02,0.104D+03,0.101D+03,0.98080000D+00,0.00000000D+00
     .,0.10750830D+03,0.104D+03,0.103D+03,0.98080000D+00,0.98650000D+00
     .,0.13584450D+03,0.104D+03,0.104D+03,0.98080000D+00,0.98080000D+00
     .,0.14723700D+02,0.105D+03,0.100D+01,0.97060000D+00,0.91180000D+00
     .,0.95836000D+01,0.105D+03,0.200D+01,0.97060000D+00,0.00000000D+00
     .,0.23142090D+03,0.105D+03,0.300D+01,0.97060000D+00,0.00000000D+00
     .,0.13372650D+03,0.105D+03,0.400D+01,0.97060000D+00,0.00000000D+00
     .,0.89742900D+02,0.105D+03,0.500D+01,0.97060000D+00,0.00000000D+00
     .,0.60299600D+02,0.105D+03,0.600D+01,0.97060000D+00,0.00000000D+00
     .,0.41901500D+02,0.105D+03,0.700D+01,0.97060000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23801:  23900)=(/
     . 0.31535400D+02,0.105D+03,0.800D+01,0.97060000D+00,0.00000000D+00
     .,0.23736900D+02,0.105D+03,0.900D+01,0.97060000D+00,0.00000000D+00
     .,0.18142400D+02,0.105D+03,0.100D+02,0.97060000D+00,0.00000000D+00
     .,0.27656710D+03,0.105D+03,0.110D+02,0.97060000D+00,0.00000000D+00
     .,0.21299790D+03,0.105D+03,0.120D+02,0.97060000D+00,0.00000000D+00
     .,0.19620140D+03,0.105D+03,0.130D+02,0.97060000D+00,0.00000000D+00
     .,0.15429010D+03,0.105D+03,0.140D+02,0.97060000D+00,0.00000000D+00
     .,0.11993530D+03,0.105D+03,0.150D+02,0.97060000D+00,0.00000000D+00
     .,0.99215900D+02,0.105D+03,0.160D+02,0.97060000D+00,0.00000000D+00
     .,0.80727200D+02,0.105D+03,0.170D+02,0.97060000D+00,0.00000000D+00
     .,0.65758000D+02,0.105D+03,0.180D+02,0.97060000D+00,0.00000000D+00
     .,0.45251930D+03,0.105D+03,0.190D+02,0.97060000D+00,0.00000000D+00
     .,0.37388150D+03,0.105D+03,0.200D+02,0.97060000D+00,0.00000000D+00
     .,0.30887210D+03,0.105D+03,0.210D+02,0.97060000D+00,0.00000000D+00
     .,0.29808710D+03,0.105D+03,0.220D+02,0.97060000D+00,0.00000000D+00
     .,0.27287470D+03,0.105D+03,0.230D+02,0.97060000D+00,0.00000000D+00
     .,0.21463600D+03,0.105D+03,0.240D+02,0.97060000D+00,0.00000000D+00
     .,0.23480000D+03,0.105D+03,0.250D+02,0.97060000D+00,0.00000000D+00
     .,0.18397370D+03,0.105D+03,0.260D+02,0.97060000D+00,0.00000000D+00
     .,0.19517310D+03,0.105D+03,0.270D+02,0.97060000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  23901:  24000)=(/
     . 0.20113510D+03,0.105D+03,0.280D+02,0.97060000D+00,0.00000000D+00
     .,0.15388240D+03,0.105D+03,0.290D+02,0.97060000D+00,0.00000000D+00
     .,0.15808480D+03,0.105D+03,0.300D+02,0.97060000D+00,0.00000000D+00
     .,0.18757970D+03,0.105D+03,0.310D+02,0.97060000D+00,0.00000000D+00
     .,0.16519300D+03,0.105D+03,0.320D+02,0.97060000D+00,0.00000000D+00
     .,0.14056250D+03,0.105D+03,0.330D+02,0.97060000D+00,0.00000000D+00
     .,0.12584370D+03,0.105D+03,0.340D+02,0.97060000D+00,0.00000000D+00
     .,0.10980600D+03,0.105D+03,0.350D+02,0.97060000D+00,0.00000000D+00
     .,0.95176300D+02,0.105D+03,0.360D+02,0.97060000D+00,0.00000000D+00
     .,0.50694210D+03,0.105D+03,0.370D+02,0.97060000D+00,0.00000000D+00
     .,0.44526080D+03,0.105D+03,0.380D+02,0.97060000D+00,0.00000000D+00
     .,0.38988230D+03,0.105D+03,0.390D+02,0.97060000D+00,0.00000000D+00
     .,0.35019700D+03,0.105D+03,0.400D+02,0.97060000D+00,0.00000000D+00
     .,0.31911510D+03,0.105D+03,0.410D+02,0.97060000D+00,0.00000000D+00
     .,0.24585270D+03,0.105D+03,0.420D+02,0.97060000D+00,0.00000000D+00
     .,0.27453340D+03,0.105D+03,0.430D+02,0.97060000D+00,0.00000000D+00
     .,0.20863620D+03,0.105D+03,0.440D+02,0.97060000D+00,0.00000000D+00
     .,0.22828220D+03,0.105D+03,0.450D+02,0.97060000D+00,0.00000000D+00
     .,0.21155590D+03,0.105D+03,0.460D+02,0.97060000D+00,0.00000000D+00
     .,0.17606030D+03,0.105D+03,0.470D+02,0.97060000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24001:  24100)=(/
     . 0.18621990D+03,0.105D+03,0.480D+02,0.97060000D+00,0.00000000D+00
     .,0.23421710D+03,0.105D+03,0.490D+02,0.97060000D+00,0.00000000D+00
     .,0.21642760D+03,0.105D+03,0.500D+02,0.97060000D+00,0.00000000D+00
     .,0.19255420D+03,0.105D+03,0.510D+02,0.97060000D+00,0.00000000D+00
     .,0.17839190D+03,0.105D+03,0.520D+02,0.97060000D+00,0.00000000D+00
     .,0.16096790D+03,0.105D+03,0.530D+02,0.97060000D+00,0.00000000D+00
     .,0.14436970D+03,0.105D+03,0.540D+02,0.97060000D+00,0.00000000D+00
     .,0.61760580D+03,0.105D+03,0.550D+02,0.97060000D+00,0.00000000D+00
     .,0.56751360D+03,0.105D+03,0.560D+02,0.97060000D+00,0.00000000D+00
     .,0.49845340D+03,0.105D+03,0.570D+02,0.97060000D+00,0.00000000D+00
     .,0.22741890D+03,0.105D+03,0.580D+02,0.97060000D+00,0.27991000D+01
     .,0.50249670D+03,0.105D+03,0.590D+02,0.97060000D+00,0.00000000D+00
     .,0.48250770D+03,0.105D+03,0.600D+02,0.97060000D+00,0.00000000D+00
     .,0.47040290D+03,0.105D+03,0.610D+02,0.97060000D+00,0.00000000D+00
     .,0.45927530D+03,0.105D+03,0.620D+02,0.97060000D+00,0.00000000D+00
     .,0.44941020D+03,0.105D+03,0.630D+02,0.97060000D+00,0.00000000D+00
     .,0.35290870D+03,0.105D+03,0.640D+02,0.97060000D+00,0.00000000D+00
     .,0.39744990D+03,0.105D+03,0.650D+02,0.97060000D+00,0.00000000D+00
     .,0.38329520D+03,0.105D+03,0.660D+02,0.97060000D+00,0.00000000D+00
     .,0.40532850D+03,0.105D+03,0.670D+02,0.97060000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24101:  24200)=(/
     . 0.39673770D+03,0.105D+03,0.680D+02,0.97060000D+00,0.00000000D+00
     .,0.38898900D+03,0.105D+03,0.690D+02,0.97060000D+00,0.00000000D+00
     .,0.38447010D+03,0.105D+03,0.700D+02,0.97060000D+00,0.00000000D+00
     .,0.32364500D+03,0.105D+03,0.710D+02,0.97060000D+00,0.00000000D+00
     .,0.31828720D+03,0.105D+03,0.720D+02,0.97060000D+00,0.00000000D+00
     .,0.29018010D+03,0.105D+03,0.730D+02,0.97060000D+00,0.00000000D+00
     .,0.24456750D+03,0.105D+03,0.740D+02,0.97060000D+00,0.00000000D+00
     .,0.24877750D+03,0.105D+03,0.750D+02,0.97060000D+00,0.00000000D+00
     .,0.22518190D+03,0.105D+03,0.760D+02,0.97060000D+00,0.00000000D+00
     .,0.20597020D+03,0.105D+03,0.770D+02,0.97060000D+00,0.00000000D+00
     .,0.17065560D+03,0.105D+03,0.780D+02,0.97060000D+00,0.00000000D+00
     .,0.15926350D+03,0.105D+03,0.790D+02,0.97060000D+00,0.00000000D+00
     .,0.16388200D+03,0.105D+03,0.800D+02,0.97060000D+00,0.00000000D+00
     .,0.24000000D+03,0.105D+03,0.810D+02,0.97060000D+00,0.00000000D+00
     .,0.23460480D+03,0.105D+03,0.820D+02,0.97060000D+00,0.00000000D+00
     .,0.21530270D+03,0.105D+03,0.830D+02,0.97060000D+00,0.00000000D+00
     .,0.20513340D+03,0.105D+03,0.840D+02,0.97060000D+00,0.00000000D+00
     .,0.18899910D+03,0.105D+03,0.850D+02,0.97060000D+00,0.00000000D+00
     .,0.17288540D+03,0.105D+03,0.860D+02,0.97060000D+00,0.00000000D+00
     .,0.58298150D+03,0.105D+03,0.870D+02,0.97060000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24201:  24300)=(/
     . 0.56100860D+03,0.105D+03,0.880D+02,0.97060000D+00,0.00000000D+00
     .,0.49563890D+03,0.105D+03,0.890D+02,0.97060000D+00,0.00000000D+00
     .,0.44481020D+03,0.105D+03,0.900D+02,0.97060000D+00,0.00000000D+00
     .,0.44155780D+03,0.105D+03,0.910D+02,0.97060000D+00,0.00000000D+00
     .,0.42748070D+03,0.105D+03,0.920D+02,0.97060000D+00,0.00000000D+00
     .,0.44027100D+03,0.105D+03,0.930D+02,0.97060000D+00,0.00000000D+00
     .,0.42632550D+03,0.105D+03,0.940D+02,0.97060000D+00,0.00000000D+00
     .,0.23841200D+02,0.105D+03,0.101D+03,0.97060000D+00,0.00000000D+00
     .,0.77663300D+02,0.105D+03,0.103D+03,0.97060000D+00,0.98650000D+00
     .,0.98993800D+02,0.105D+03,0.104D+03,0.97060000D+00,0.98080000D+00
     .,0.75368600D+02,0.105D+03,0.105D+03,0.97060000D+00,0.97060000D+00
     .,0.11393200D+02,0.106D+03,0.100D+01,0.98680000D+00,0.91180000D+00
     .,0.77065000D+01,0.106D+03,0.200D+01,0.98680000D+00,0.00000000D+00
     .,0.16045900D+03,0.106D+03,0.300D+01,0.98680000D+00,0.00000000D+00
     .,0.96543100D+02,0.106D+03,0.400D+01,0.98680000D+00,0.00000000D+00
     .,0.66798600D+02,0.106D+03,0.500D+01,0.98680000D+00,0.00000000D+00
     .,0.46068100D+02,0.106D+03,0.600D+01,0.98680000D+00,0.00000000D+00
     .,0.32700900D+02,0.106D+03,0.700D+01,0.98680000D+00,0.00000000D+00
     .,0.25009700D+02,0.106D+03,0.800D+01,0.98680000D+00,0.00000000D+00
     .,0.19097400D+02,0.106D+03,0.900D+01,0.98680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24301:  24400)=(/
     . 0.14771600D+02,0.106D+03,0.100D+02,0.98680000D+00,0.00000000D+00
     .,0.19237290D+03,0.106D+03,0.110D+02,0.98680000D+00,0.00000000D+00
     .,0.15261300D+03,0.106D+03,0.120D+02,0.98680000D+00,0.00000000D+00
     .,0.14260940D+03,0.106D+03,0.130D+02,0.98680000D+00,0.00000000D+00
     .,0.11444050D+03,0.106D+03,0.140D+02,0.98680000D+00,0.00000000D+00
     .,0.90676700D+02,0.106D+03,0.150D+02,0.98680000D+00,0.00000000D+00
     .,0.76055200D+02,0.106D+03,0.160D+02,0.98680000D+00,0.00000000D+00
     .,0.62746500D+02,0.106D+03,0.170D+02,0.98680000D+00,0.00000000D+00
     .,0.51768400D+02,0.106D+03,0.180D+02,0.98680000D+00,0.00000000D+00
     .,0.31458000D+03,0.106D+03,0.190D+02,0.98680000D+00,0.00000000D+00
     .,0.26512060D+03,0.106D+03,0.200D+02,0.98680000D+00,0.00000000D+00
     .,0.22018540D+03,0.106D+03,0.210D+02,0.98680000D+00,0.00000000D+00
     .,0.21386820D+03,0.106D+03,0.220D+02,0.98680000D+00,0.00000000D+00
     .,0.19648850D+03,0.106D+03,0.230D+02,0.98680000D+00,0.00000000D+00
     .,0.15511710D+03,0.106D+03,0.240D+02,0.98680000D+00,0.00000000D+00
     .,0.16997960D+03,0.106D+03,0.250D+02,0.98680000D+00,0.00000000D+00
     .,0.13377000D+03,0.106D+03,0.260D+02,0.98680000D+00,0.00000000D+00
     .,0.14251400D+03,0.106D+03,0.270D+02,0.98680000D+00,0.00000000D+00
     .,0.14627110D+03,0.106D+03,0.280D+02,0.98680000D+00,0.00000000D+00
     .,0.11239140D+03,0.106D+03,0.290D+02,0.98680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24401:  24500)=(/
     . 0.11639870D+03,0.106D+03,0.300D+02,0.98680000D+00,0.00000000D+00
     .,0.13747230D+03,0.106D+03,0.310D+02,0.98680000D+00,0.00000000D+00
     .,0.12288050D+03,0.106D+03,0.320D+02,0.98680000D+00,0.00000000D+00
     .,0.10616860D+03,0.106D+03,0.330D+02,0.98680000D+00,0.00000000D+00
     .,0.96059900D+02,0.106D+03,0.340D+02,0.98680000D+00,0.00000000D+00
     .,0.84772300D+02,0.106D+03,0.350D+02,0.98680000D+00,0.00000000D+00
     .,0.74286500D+02,0.106D+03,0.360D+02,0.98680000D+00,0.00000000D+00
     .,0.35363020D+03,0.106D+03,0.370D+02,0.98680000D+00,0.00000000D+00
     .,0.31589230D+03,0.106D+03,0.380D+02,0.98680000D+00,0.00000000D+00
     .,0.27947270D+03,0.106D+03,0.390D+02,0.98680000D+00,0.00000000D+00
     .,0.25282130D+03,0.106D+03,0.400D+02,0.98680000D+00,0.00000000D+00
     .,0.23159760D+03,0.106D+03,0.410D+02,0.98680000D+00,0.00000000D+00
     .,0.18033900D+03,0.106D+03,0.420D+02,0.98680000D+00,0.00000000D+00
     .,0.20054640D+03,0.106D+03,0.430D+02,0.98680000D+00,0.00000000D+00
     .,0.15419380D+03,0.106D+03,0.440D+02,0.98680000D+00,0.00000000D+00
     .,0.16831150D+03,0.106D+03,0.450D+02,0.98680000D+00,0.00000000D+00
     .,0.15650060D+03,0.106D+03,0.460D+02,0.98680000D+00,0.00000000D+00
     .,0.13051440D+03,0.106D+03,0.470D+02,0.98680000D+00,0.00000000D+00
     .,0.13836720D+03,0.106D+03,0.480D+02,0.98680000D+00,0.00000000D+00
     .,0.17212290D+03,0.106D+03,0.490D+02,0.98680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24501:  24600)=(/
     . 0.16079100D+03,0.106D+03,0.500D+02,0.98680000D+00,0.00000000D+00
     .,0.14484620D+03,0.106D+03,0.510D+02,0.98680000D+00,0.00000000D+00
     .,0.13531220D+03,0.106D+03,0.520D+02,0.98680000D+00,0.00000000D+00
     .,0.12325380D+03,0.106D+03,0.530D+02,0.98680000D+00,0.00000000D+00
     .,0.11159230D+03,0.106D+03,0.540D+02,0.98680000D+00,0.00000000D+00
     .,0.43151720D+03,0.106D+03,0.550D+02,0.98680000D+00,0.00000000D+00
     .,0.40187740D+03,0.106D+03,0.560D+02,0.98680000D+00,0.00000000D+00
     .,0.35646100D+03,0.106D+03,0.570D+02,0.98680000D+00,0.00000000D+00
     .,0.17092620D+03,0.106D+03,0.580D+02,0.98680000D+00,0.27991000D+01
     .,0.35713990D+03,0.106D+03,0.590D+02,0.98680000D+00,0.00000000D+00
     .,0.34341530D+03,0.106D+03,0.600D+02,0.98680000D+00,0.00000000D+00
     .,0.33492450D+03,0.106D+03,0.610D+02,0.98680000D+00,0.00000000D+00
     .,0.32709910D+03,0.106D+03,0.620D+02,0.98680000D+00,0.00000000D+00
     .,0.32016570D+03,0.106D+03,0.630D+02,0.98680000D+00,0.00000000D+00
     .,0.25481220D+03,0.106D+03,0.640D+02,0.98680000D+00,0.00000000D+00
     .,0.28285470D+03,0.106D+03,0.650D+02,0.98680000D+00,0.00000000D+00
     .,0.27333750D+03,0.106D+03,0.660D+02,0.98680000D+00,0.00000000D+00
     .,0.28939200D+03,0.106D+03,0.670D+02,0.98680000D+00,0.00000000D+00
     .,0.28330010D+03,0.106D+03,0.680D+02,0.98680000D+00,0.00000000D+00
     .,0.27784930D+03,0.106D+03,0.690D+02,0.98680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24601:  24700)=(/
     . 0.27445000D+03,0.106D+03,0.700D+02,0.98680000D+00,0.00000000D+00
     .,0.23313940D+03,0.106D+03,0.710D+02,0.98680000D+00,0.00000000D+00
     .,0.23163340D+03,0.106D+03,0.720D+02,0.98680000D+00,0.00000000D+00
     .,0.21280410D+03,0.106D+03,0.730D+02,0.98680000D+00,0.00000000D+00
     .,0.18084620D+03,0.106D+03,0.740D+02,0.98680000D+00,0.00000000D+00
     .,0.18435860D+03,0.106D+03,0.750D+02,0.98680000D+00,0.00000000D+00
     .,0.16804770D+03,0.106D+03,0.760D+02,0.98680000D+00,0.00000000D+00
     .,0.15462480D+03,0.106D+03,0.770D+02,0.98680000D+00,0.00000000D+00
     .,0.12918350D+03,0.106D+03,0.780D+02,0.98680000D+00,0.00000000D+00
     .,0.12094850D+03,0.106D+03,0.790D+02,0.98680000D+00,0.00000000D+00
     .,0.12459510D+03,0.106D+03,0.800D+02,0.98680000D+00,0.00000000D+00
     .,0.17748530D+03,0.106D+03,0.810D+02,0.98680000D+00,0.00000000D+00
     .,0.17476750D+03,0.106D+03,0.820D+02,0.98680000D+00,0.00000000D+00
     .,0.16207400D+03,0.106D+03,0.830D+02,0.98680000D+00,0.00000000D+00
     .,0.15545060D+03,0.106D+03,0.840D+02,0.98680000D+00,0.00000000D+00
     .,0.14445320D+03,0.106D+03,0.850D+02,0.98680000D+00,0.00000000D+00
     .,0.13324320D+03,0.106D+03,0.860D+02,0.98680000D+00,0.00000000D+00
     .,0.41058600D+03,0.106D+03,0.870D+02,0.98680000D+00,0.00000000D+00
     .,0.39952250D+03,0.106D+03,0.880D+02,0.98680000D+00,0.00000000D+00
     .,0.35611270D+03,0.106D+03,0.890D+02,0.98680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24701:  24800)=(/
     . 0.32349590D+03,0.106D+03,0.900D+02,0.98680000D+00,0.00000000D+00
     .,0.31967610D+03,0.106D+03,0.910D+02,0.98680000D+00,0.00000000D+00
     .,0.30960820D+03,0.106D+03,0.920D+02,0.98680000D+00,0.00000000D+00
     .,0.31659670D+03,0.106D+03,0.930D+02,0.98680000D+00,0.00000000D+00
     .,0.30693030D+03,0.106D+03,0.940D+02,0.98680000D+00,0.00000000D+00
     .,0.18057500D+02,0.106D+03,0.101D+03,0.98680000D+00,0.00000000D+00
     .,0.56346800D+02,0.106D+03,0.103D+03,0.98680000D+00,0.98650000D+00
     .,0.72316200D+02,0.106D+03,0.104D+03,0.98680000D+00,0.98080000D+00
     .,0.56529500D+02,0.106D+03,0.105D+03,0.98680000D+00,0.97060000D+00
     .,0.43245200D+02,0.106D+03,0.106D+03,0.98680000D+00,0.98680000D+00
     .,0.81417000D+01,0.107D+03,0.100D+01,0.99440000D+00,0.91180000D+00
     .,0.57601000D+01,0.107D+03,0.200D+01,0.99440000D+00,0.00000000D+00
     .,0.10127010D+03,0.107D+03,0.300D+01,0.99440000D+00,0.00000000D+00
     .,0.63858000D+02,0.107D+03,0.400D+01,0.99440000D+00,0.00000000D+00
     .,0.45731900D+02,0.107D+03,0.500D+01,0.99440000D+00,0.00000000D+00
     .,0.32484800D+02,0.107D+03,0.600D+01,0.99440000D+00,0.00000000D+00
     .,0.23629500D+02,0.107D+03,0.700D+01,0.99440000D+00,0.00000000D+00
     .,0.18412800D+02,0.107D+03,0.800D+01,0.99440000D+00,0.00000000D+00
     .,0.14301500D+02,0.107D+03,0.900D+01,0.99440000D+00,0.00000000D+00
     .,0.11224300D+02,0.107D+03,0.100D+02,0.99440000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24801:  24900)=(/
     . 0.12196010D+03,0.107D+03,0.110D+02,0.99440000D+00,0.00000000D+00
     .,0.10014430D+03,0.107D+03,0.120D+02,0.99440000D+00,0.00000000D+00
     .,0.95091600D+02,0.107D+03,0.130D+02,0.99440000D+00,0.00000000D+00
     .,0.78046600D+02,0.107D+03,0.140D+02,0.99440000D+00,0.00000000D+00
     .,0.63166900D+02,0.107D+03,0.150D+02,0.99440000D+00,0.00000000D+00
     .,0.53810700D+02,0.107D+03,0.160D+02,0.99440000D+00,0.00000000D+00
     .,0.45095200D+02,0.107D+03,0.170D+02,0.99440000D+00,0.00000000D+00
     .,0.37752200D+02,0.107D+03,0.180D+02,0.99440000D+00,0.00000000D+00
     .,0.19944050D+03,0.107D+03,0.190D+02,0.99440000D+00,0.00000000D+00
     .,0.17204550D+03,0.107D+03,0.200D+02,0.99440000D+00,0.00000000D+00
     .,0.14376580D+03,0.107D+03,0.210D+02,0.99440000D+00,0.00000000D+00
     .,0.14071150D+03,0.107D+03,0.220D+02,0.99440000D+00,0.00000000D+00
     .,0.12982970D+03,0.107D+03,0.230D+02,0.99440000D+00,0.00000000D+00
     .,0.10301890D+03,0.107D+03,0.240D+02,0.99440000D+00,0.00000000D+00
     .,0.11302480D+03,0.107D+03,0.250D+02,0.99440000D+00,0.00000000D+00
     .,0.89486800D+02,0.107D+03,0.260D+02,0.99440000D+00,0.00000000D+00
     .,0.95705100D+02,0.107D+03,0.270D+02,0.99440000D+00,0.00000000D+00
     .,0.97776100D+02,0.107D+03,0.280D+02,0.99440000D+00,0.00000000D+00
     .,0.75598700D+02,0.107D+03,0.290D+02,0.99440000D+00,0.00000000D+00
     .,0.78918300D+02,0.107D+03,0.300D+02,0.99440000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  24901:  25000)=(/
     . 0.92602500D+02,0.107D+03,0.310D+02,0.99440000D+00,0.00000000D+00
     .,0.84127600D+02,0.107D+03,0.320D+02,0.99440000D+00,0.00000000D+00
     .,0.73914200D+02,0.107D+03,0.330D+02,0.99440000D+00,0.00000000D+00
     .,0.67663600D+02,0.107D+03,0.340D+02,0.99440000D+00,0.00000000D+00
     .,0.60472800D+02,0.107D+03,0.350D+02,0.99440000D+00,0.00000000D+00
     .,0.53649600D+02,0.107D+03,0.360D+02,0.99440000D+00,0.00000000D+00
     .,0.22519190D+03,0.107D+03,0.370D+02,0.99440000D+00,0.00000000D+00
     .,0.20515740D+03,0.107D+03,0.380D+02,0.99440000D+00,0.00000000D+00
     .,0.18368510D+03,0.107D+03,0.390D+02,0.99440000D+00,0.00000000D+00
     .,0.16755010D+03,0.107D+03,0.400D+02,0.99440000D+00,0.00000000D+00
     .,0.15443560D+03,0.107D+03,0.410D+02,0.99440000D+00,0.00000000D+00
     .,0.12180660D+03,0.107D+03,0.420D+02,0.99440000D+00,0.00000000D+00
     .,0.13478870D+03,0.107D+03,0.430D+02,0.99440000D+00,0.00000000D+00
     .,0.10509050D+03,0.107D+03,0.440D+02,0.99440000D+00,0.00000000D+00
     .,0.11434960D+03,0.107D+03,0.450D+02,0.99440000D+00,0.00000000D+00
     .,0.10674380D+03,0.107D+03,0.460D+02,0.99440000D+00,0.00000000D+00
     .,0.89341900D+02,0.107D+03,0.470D+02,0.99440000D+00,0.00000000D+00
     .,0.94877000D+02,0.107D+03,0.480D+02,0.99440000D+00,0.00000000D+00
     .,0.11649590D+03,0.107D+03,0.490D+02,0.99440000D+00,0.00000000D+00
     .,0.11009510D+03,0.107D+03,0.500D+02,0.99440000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25001:  25100)=(/
     . 0.10051820D+03,0.107D+03,0.510D+02,0.99440000D+00,0.00000000D+00
     .,0.94750800D+02,0.107D+03,0.520D+02,0.99440000D+00,0.00000000D+00
     .,0.87202800D+02,0.107D+03,0.530D+02,0.99440000D+00,0.00000000D+00
     .,0.79777300D+02,0.107D+03,0.540D+02,0.99440000D+00,0.00000000D+00
     .,0.27525670D+03,0.107D+03,0.550D+02,0.99440000D+00,0.00000000D+00
     .,0.26044810D+03,0.107D+03,0.560D+02,0.99440000D+00,0.00000000D+00
     .,0.23366190D+03,0.107D+03,0.570D+02,0.99440000D+00,0.00000000D+00
     .,0.11854700D+03,0.107D+03,0.580D+02,0.99440000D+00,0.27991000D+01
     .,0.23257830D+03,0.107D+03,0.590D+02,0.99440000D+00,0.00000000D+00
     .,0.22400400D+03,0.107D+03,0.600D+02,0.99440000D+00,0.00000000D+00
     .,0.21856110D+03,0.107D+03,0.610D+02,0.99440000D+00,0.00000000D+00
     .,0.21352770D+03,0.107D+03,0.620D+02,0.99440000D+00,0.00000000D+00
     .,0.20907000D+03,0.107D+03,0.630D+02,0.99440000D+00,0.00000000D+00
     .,0.16905560D+03,0.107D+03,0.640D+02,0.99440000D+00,0.00000000D+00
     .,0.18459040D+03,0.107D+03,0.650D+02,0.99440000D+00,0.00000000D+00
     .,0.17880740D+03,0.107D+03,0.660D+02,0.99440000D+00,0.00000000D+00
     .,0.18945310D+03,0.107D+03,0.670D+02,0.99440000D+00,0.00000000D+00
     .,0.18549310D+03,0.107D+03,0.680D+02,0.99440000D+00,0.00000000D+00
     .,0.18198230D+03,0.107D+03,0.690D+02,0.99440000D+00,0.00000000D+00
     .,0.17962020D+03,0.107D+03,0.700D+02,0.99440000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25101:  25200)=(/
     . 0.15422920D+03,0.107D+03,0.710D+02,0.99440000D+00,0.00000000D+00
     .,0.15491020D+03,0.107D+03,0.720D+02,0.99440000D+00,0.00000000D+00
     .,0.14357630D+03,0.107D+03,0.730D+02,0.99440000D+00,0.00000000D+00
     .,0.12323020D+03,0.107D+03,0.740D+02,0.99440000D+00,0.00000000D+00
     .,0.12591210D+03,0.107D+03,0.750D+02,0.99440000D+00,0.00000000D+00
     .,0.11569380D+03,0.107D+03,0.760D+02,0.99440000D+00,0.00000000D+00
     .,0.10717750D+03,0.107D+03,0.770D+02,0.99440000D+00,0.00000000D+00
     .,0.90445600D+02,0.107D+03,0.780D+02,0.99440000D+00,0.00000000D+00
     .,0.85014600D+02,0.107D+03,0.790D+02,0.99440000D+00,0.00000000D+00
     .,0.87649000D+02,0.107D+03,0.800D+02,0.99440000D+00,0.00000000D+00
     .,0.12108000D+03,0.107D+03,0.810D+02,0.99440000D+00,0.00000000D+00
     .,0.12012680D+03,0.107D+03,0.820D+02,0.99440000D+00,0.00000000D+00
     .,0.11264850D+03,0.107D+03,0.830D+02,0.99440000D+00,0.00000000D+00
     .,0.10881340D+03,0.107D+03,0.840D+02,0.99440000D+00,0.00000000D+00
     .,0.10205240D+03,0.107D+03,0.850D+02,0.99440000D+00,0.00000000D+00
     .,0.94992800D+02,0.107D+03,0.860D+02,0.99440000D+00,0.00000000D+00
     .,0.26444300D+03,0.107D+03,0.870D+02,0.99440000D+00,0.00000000D+00
     .,0.26065290D+03,0.107D+03,0.880D+02,0.99440000D+00,0.00000000D+00
     .,0.23476520D+03,0.107D+03,0.890D+02,0.99440000D+00,0.00000000D+00
     .,0.21630740D+03,0.107D+03,0.900D+02,0.99440000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25201:  25300)=(/
     . 0.21274560D+03,0.107D+03,0.910D+02,0.99440000D+00,0.00000000D+00
     .,0.20616310D+03,0.107D+03,0.920D+02,0.99440000D+00,0.00000000D+00
     .,0.20915240D+03,0.107D+03,0.930D+02,0.99440000D+00,0.00000000D+00
     .,0.20304180D+03,0.107D+03,0.940D+02,0.99440000D+00,0.00000000D+00
     .,0.12598000D+02,0.107D+03,0.101D+03,0.99440000D+00,0.00000000D+00
     .,0.37493900D+02,0.107D+03,0.103D+03,0.99440000D+00,0.98650000D+00
     .,0.48488500D+02,0.107D+03,0.104D+03,0.99440000D+00,0.98080000D+00
     .,0.39043300D+02,0.107D+03,0.105D+03,0.99440000D+00,0.97060000D+00
     .,0.30541000D+02,0.107D+03,0.106D+03,0.99440000D+00,0.98680000D+00
     .,0.22124100D+02,0.107D+03,0.107D+03,0.99440000D+00,0.99440000D+00
     .,0.60575000D+01,0.108D+03,0.100D+01,0.99250000D+00,0.91180000D+00
     .,0.44593000D+01,0.108D+03,0.200D+01,0.99250000D+00,0.00000000D+00
     .,0.67931200D+02,0.108D+03,0.300D+01,0.99250000D+00,0.00000000D+00
     .,0.44496800D+02,0.108D+03,0.400D+01,0.99250000D+00,0.00000000D+00
     .,0.32813600D+02,0.108D+03,0.500D+01,0.99250000D+00,0.00000000D+00
     .,0.23912000D+02,0.108D+03,0.600D+01,0.99250000D+00,0.00000000D+00
     .,0.17769800D+02,0.108D+03,0.700D+01,0.99250000D+00,0.00000000D+00
     .,0.14076400D+02,0.108D+03,0.800D+01,0.99250000D+00,0.00000000D+00
     .,0.11099400D+02,0.108D+03,0.900D+01,0.99250000D+00,0.00000000D+00
     .,0.88252000D+01,0.108D+03,0.100D+02,0.99250000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25301:  25400)=(/
     . 0.82182000D+02,0.108D+03,0.110D+02,0.99250000D+00,0.00000000D+00
     .,0.69367500D+02,0.108D+03,0.120D+02,0.99250000D+00,0.00000000D+00
     .,0.66745100D+02,0.108D+03,0.130D+02,0.99250000D+00,0.00000000D+00
     .,0.55817500D+02,0.108D+03,0.140D+02,0.99250000D+00,0.00000000D+00
     .,0.45993700D+02,0.108D+03,0.150D+02,0.99250000D+00,0.00000000D+00
     .,0.39709100D+02,0.108D+03,0.160D+02,0.99250000D+00,0.00000000D+00
     .,0.33731300D+02,0.108D+03,0.170D+02,0.99250000D+00,0.00000000D+00
     .,0.28600000D+02,0.108D+03,0.180D+02,0.99250000D+00,0.00000000D+00
     .,0.13465080D+03,0.108D+03,0.190D+02,0.99250000D+00,0.00000000D+00
     .,0.11824110D+03,0.108D+03,0.200D+02,0.99250000D+00,0.00000000D+00
     .,0.99293900D+02,0.108D+03,0.210D+02,0.99250000D+00,0.00000000D+00
     .,0.97834500D+02,0.108D+03,0.220D+02,0.99250000D+00,0.00000000D+00
     .,0.90600700D+02,0.108D+03,0.230D+02,0.99250000D+00,0.00000000D+00
     .,0.72287200D+02,0.108D+03,0.240D+02,0.99250000D+00,0.00000000D+00
     .,0.79304700D+02,0.108D+03,0.250D+02,0.99250000D+00,0.00000000D+00
     .,0.63186500D+02,0.108D+03,0.260D+02,0.99250000D+00,0.00000000D+00
     .,0.67711700D+02,0.108D+03,0.270D+02,0.99250000D+00,0.00000000D+00
     .,0.68908600D+02,0.108D+03,0.280D+02,0.99250000D+00,0.00000000D+00
     .,0.53642000D+02,0.108D+03,0.290D+02,0.99250000D+00,0.00000000D+00
     .,0.56288400D+02,0.108D+03,0.300D+02,0.99250000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25401:  25500)=(/
     . 0.65621400D+02,0.108D+03,0.310D+02,0.99250000D+00,0.00000000D+00
     .,0.60404100D+02,0.108D+03,0.320D+02,0.99250000D+00,0.00000000D+00
     .,0.53815300D+02,0.108D+03,0.330D+02,0.99250000D+00,0.00000000D+00
     .,0.49755200D+02,0.108D+03,0.340D+02,0.99250000D+00,0.00000000D+00
     .,0.44951000D+02,0.108D+03,0.350D+02,0.99250000D+00,0.00000000D+00
     .,0.40304300D+02,0.108D+03,0.360D+02,0.99250000D+00,0.00000000D+00
     .,0.15267570D+03,0.108D+03,0.370D+02,0.99250000D+00,0.00000000D+00
     .,0.14115920D+03,0.108D+03,0.380D+02,0.99250000D+00,0.00000000D+00
     .,0.12762820D+03,0.108D+03,0.390D+02,0.99250000D+00,0.00000000D+00
     .,0.11723280D+03,0.108D+03,0.400D+02,0.99250000D+00,0.00000000D+00
     .,0.10863780D+03,0.108D+03,0.410D+02,0.99250000D+00,0.00000000D+00
     .,0.86680300D+02,0.108D+03,0.420D+02,0.99250000D+00,0.00000000D+00
     .,0.95496600D+02,0.108D+03,0.430D+02,0.99250000D+00,0.00000000D+00
     .,0.75391000D+02,0.108D+03,0.440D+02,0.99250000D+00,0.00000000D+00
     .,0.81764000D+02,0.108D+03,0.450D+02,0.99250000D+00,0.00000000D+00
     .,0.76587100D+02,0.108D+03,0.460D+02,0.99250000D+00,0.00000000D+00
     .,0.64388000D+02,0.108D+03,0.470D+02,0.99250000D+00,0.00000000D+00
     .,0.68394300D+02,0.108D+03,0.480D+02,0.99250000D+00,0.00000000D+00
     .,0.83027800D+02,0.108D+03,0.490D+02,0.99250000D+00,0.00000000D+00
     .,0.79170400D+02,0.108D+03,0.500D+02,0.99250000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25501:  25600)=(/
     . 0.73071800D+02,0.108D+03,0.510D+02,0.99250000D+00,0.00000000D+00
     .,0.69390100D+02,0.108D+03,0.520D+02,0.99250000D+00,0.00000000D+00
     .,0.64414100D+02,0.108D+03,0.530D+02,0.99250000D+00,0.00000000D+00
     .,0.59446800D+02,0.108D+03,0.540D+02,0.99250000D+00,0.00000000D+00
     .,0.18687910D+03,0.108D+03,0.550D+02,0.99250000D+00,0.00000000D+00
     .,0.17895490D+03,0.108D+03,0.560D+02,0.99250000D+00,0.00000000D+00
     .,0.16203710D+03,0.108D+03,0.570D+02,0.99250000D+00,0.00000000D+00
     .,0.86166500D+02,0.108D+03,0.580D+02,0.99250000D+00,0.27991000D+01
     .,0.16052330D+03,0.108D+03,0.590D+02,0.99250000D+00,0.00000000D+00
     .,0.15480670D+03,0.108D+03,0.600D+02,0.99250000D+00,0.00000000D+00
     .,0.15109700D+03,0.108D+03,0.610D+02,0.99250000D+00,0.00000000D+00
     .,0.14765520D+03,0.108D+03,0.620D+02,0.99250000D+00,0.00000000D+00
     .,0.14460750D+03,0.108D+03,0.630D+02,0.99250000D+00,0.00000000D+00
     .,0.11853880D+03,0.108D+03,0.640D+02,0.99250000D+00,0.00000000D+00
     .,0.12778280D+03,0.108D+03,0.650D+02,0.99250000D+00,0.00000000D+00
     .,0.12401580D+03,0.108D+03,0.660D+02,0.99250000D+00,0.00000000D+00
     .,0.13130040D+03,0.108D+03,0.670D+02,0.99250000D+00,0.00000000D+00
     .,0.12856660D+03,0.108D+03,0.680D+02,0.99250000D+00,0.00000000D+00
     .,0.12616140D+03,0.108D+03,0.690D+02,0.99250000D+00,0.00000000D+00
     .,0.12444020D+03,0.108D+03,0.700D+02,0.99250000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25601:  25700)=(/
     . 0.10783510D+03,0.108D+03,0.710D+02,0.99250000D+00,0.00000000D+00
     .,0.10920420D+03,0.108D+03,0.720D+02,0.99250000D+00,0.00000000D+00
     .,0.10197340D+03,0.108D+03,0.730D+02,0.99250000D+00,0.00000000D+00
     .,0.88315600D+02,0.108D+03,0.740D+02,0.99250000D+00,0.00000000D+00
     .,0.90391800D+02,0.108D+03,0.750D+02,0.99250000D+00,0.00000000D+00
     .,0.83622700D+02,0.108D+03,0.760D+02,0.99250000D+00,0.00000000D+00
     .,0.77919400D+02,0.108D+03,0.770D+02,0.99250000D+00,0.00000000D+00
     .,0.66359100D+02,0.108D+03,0.780D+02,0.99250000D+00,0.00000000D+00
     .,0.62600800D+02,0.108D+03,0.790D+02,0.99250000D+00,0.00000000D+00
     .,0.64555200D+02,0.108D+03,0.800D+02,0.99250000D+00,0.00000000D+00
     .,0.86955200D+02,0.108D+03,0.810D+02,0.99250000D+00,0.00000000D+00
     .,0.86739200D+02,0.108D+03,0.820D+02,0.99250000D+00,0.00000000D+00
     .,0.82055900D+02,0.108D+03,0.830D+02,0.99250000D+00,0.00000000D+00
     .,0.79713300D+02,0.108D+03,0.840D+02,0.99250000D+00,0.00000000D+00
     .,0.75326800D+02,0.108D+03,0.850D+02,0.99250000D+00,0.00000000D+00
     .,0.70648000D+02,0.108D+03,0.860D+02,0.99250000D+00,0.00000000D+00
     .,0.18100550D+03,0.108D+03,0.870D+02,0.99250000D+00,0.00000000D+00
     .,0.18009880D+03,0.108D+03,0.880D+02,0.99250000D+00,0.00000000D+00
     .,0.16360420D+03,0.108D+03,0.890D+02,0.99250000D+00,0.00000000D+00
     .,0.15256500D+03,0.108D+03,0.900D+02,0.99250000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25701:  25800)=(/
     . 0.14955510D+03,0.108D+03,0.910D+02,0.99250000D+00,0.00000000D+00
     .,0.14501130D+03,0.108D+03,0.920D+02,0.99250000D+00,0.00000000D+00
     .,0.14619280D+03,0.108D+03,0.930D+02,0.99250000D+00,0.00000000D+00
     .,0.14207750D+03,0.108D+03,0.940D+02,0.99250000D+00,0.00000000D+00
     .,0.91812000D+01,0.108D+03,0.101D+03,0.99250000D+00,0.00000000D+00
     .,0.26270800D+02,0.108D+03,0.103D+03,0.99250000D+00,0.98650000D+00
     .,0.34198300D+02,0.108D+03,0.104D+03,0.99250000D+00,0.98080000D+00
     .,0.28232700D+02,0.108D+03,0.105D+03,0.99250000D+00,0.97060000D+00
     .,0.22517800D+02,0.108D+03,0.106D+03,0.99250000D+00,0.98680000D+00
     .,0.16677500D+02,0.108D+03,0.107D+03,0.99250000D+00,0.99440000D+00
     .,0.12816100D+02,0.108D+03,0.108D+03,0.99250000D+00,0.99250000D+00
     .,0.42672000D+01,0.109D+03,0.100D+01,0.99820000D+00,0.91180000D+00
     .,0.33077000D+01,0.109D+03,0.200D+01,0.99820000D+00,0.00000000D+00
     .,0.42062700D+02,0.109D+03,0.300D+01,0.99820000D+00,0.00000000D+00
     .,0.28861500D+02,0.109D+03,0.400D+01,0.99820000D+00,0.00000000D+00
     .,0.22093100D+02,0.109D+03,0.500D+01,0.99820000D+00,0.00000000D+00
     .,0.16637300D+02,0.109D+03,0.600D+01,0.99820000D+00,0.00000000D+00
     .,0.12710700D+02,0.109D+03,0.700D+01,0.99820000D+00,0.00000000D+00
     .,0.10286700D+02,0.109D+03,0.800D+01,0.99820000D+00,0.00000000D+00
     .,0.82739000D+01,0.109D+03,0.900D+01,0.99820000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25801:  25900)=(/
     . 0.66950000D+01,0.109D+03,0.100D+02,0.99820000D+00,0.00000000D+00
     .,0.51249800D+02,0.109D+03,0.110D+02,0.99820000D+00,0.00000000D+00
     .,0.44714100D+02,0.109D+03,0.120D+02,0.99820000D+00,0.00000000D+00
     .,0.43736400D+02,0.109D+03,0.130D+02,0.99820000D+00,0.00000000D+00
     .,0.37442100D+02,0.109D+03,0.140D+02,0.99820000D+00,0.00000000D+00
     .,0.31557700D+02,0.109D+03,0.150D+02,0.99820000D+00,0.00000000D+00
     .,0.27713700D+02,0.109D+03,0.160D+02,0.99820000D+00,0.00000000D+00
     .,0.23950500D+02,0.109D+03,0.170D+02,0.99820000D+00,0.00000000D+00
     .,0.20639400D+02,0.109D+03,0.180D+02,0.99820000D+00,0.00000000D+00
     .,0.84368800D+02,0.109D+03,0.190D+02,0.99820000D+00,0.00000000D+00
     .,0.75585000D+02,0.109D+03,0.200D+02,0.99820000D+00,0.00000000D+00
     .,0.63856400D+02,0.109D+03,0.210D+02,0.99820000D+00,0.00000000D+00
     .,0.63474800D+02,0.109D+03,0.220D+02,0.99820000D+00,0.00000000D+00
     .,0.59066500D+02,0.109D+03,0.230D+02,0.99820000D+00,0.00000000D+00
     .,0.47531800D+02,0.109D+03,0.240D+02,0.99820000D+00,0.00000000D+00
     .,0.52078000D+02,0.109D+03,0.250D+02,0.99820000D+00,0.00000000D+00
     .,0.41894200D+02,0.109D+03,0.260D+02,0.99820000D+00,0.00000000D+00
     .,0.44940700D+02,0.109D+03,0.270D+02,0.99820000D+00,0.00000000D+00
     .,0.45515500D+02,0.109D+03,0.280D+02,0.99820000D+00,0.00000000D+00
     .,0.35810000D+02,0.109D+03,0.290D+02,0.99820000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  25901:  26000)=(/
     . 0.37755900D+02,0.109D+03,0.300D+02,0.99820000D+00,0.00000000D+00
     .,0.43568500D+02,0.109D+03,0.310D+02,0.99820000D+00,0.00000000D+00
     .,0.40750000D+02,0.109D+03,0.320D+02,0.99820000D+00,0.00000000D+00
     .,0.36938900D+02,0.109D+03,0.330D+02,0.99820000D+00,0.00000000D+00
     .,0.34579200D+02,0.109D+03,0.340D+02,0.99820000D+00,0.00000000D+00
     .,0.31669900D+02,0.109D+03,0.350D+02,0.99820000D+00,0.00000000D+00
     .,0.28780000D+02,0.109D+03,0.360D+02,0.99820000D+00,0.00000000D+00
     .,0.96223500D+02,0.109D+03,0.370D+02,0.99820000D+00,0.00000000D+00
     .,0.90408100D+02,0.109D+03,0.380D+02,0.99820000D+00,0.00000000D+00
     .,0.82733700D+02,0.109D+03,0.390D+02,0.99820000D+00,0.00000000D+00
     .,0.76671200D+02,0.109D+03,0.400D+02,0.99820000D+00,0.00000000D+00
     .,0.71549300D+02,0.109D+03,0.410D+02,0.99820000D+00,0.00000000D+00
     .,0.57978400D+02,0.109D+03,0.420D+02,0.99820000D+00,0.00000000D+00
     .,0.63507900D+02,0.109D+03,0.430D+02,0.99820000D+00,0.00000000D+00
     .,0.50977000D+02,0.109D+03,0.440D+02,0.99820000D+00,0.00000000D+00
     .,0.55024000D+02,0.109D+03,0.450D+02,0.99820000D+00,0.00000000D+00
     .,0.51774000D+02,0.109D+03,0.460D+02,0.99820000D+00,0.00000000D+00
     .,0.43848000D+02,0.109D+03,0.470D+02,0.99820000D+00,0.00000000D+00
     .,0.46534000D+02,0.109D+03,0.480D+02,0.99820000D+00,0.00000000D+00
     .,0.55658900D+02,0.109D+03,0.490D+02,0.99820000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26001:  26100)=(/
     . 0.53624300D+02,0.109D+03,0.500D+02,0.99820000D+00,0.00000000D+00
     .,0.50147300D+02,0.109D+03,0.510D+02,0.99820000D+00,0.00000000D+00
     .,0.48053500D+02,0.109D+03,0.520D+02,0.99820000D+00,0.00000000D+00
     .,0.45084800D+02,0.109D+03,0.530D+02,0.99820000D+00,0.00000000D+00
     .,0.42063400D+02,0.109D+03,0.540D+02,0.99820000D+00,0.00000000D+00
     .,0.11797180D+03,0.109D+03,0.550D+02,0.99820000D+00,0.00000000D+00
     .,0.11446760D+03,0.109D+03,0.560D+02,0.99820000D+00,0.00000000D+00
     .,0.10480950D+03,0.109D+03,0.570D+02,0.99820000D+00,0.00000000D+00
     .,0.59137900D+02,0.109D+03,0.580D+02,0.99820000D+00,0.27991000D+01
     .,0.10336160D+03,0.109D+03,0.590D+02,0.99820000D+00,0.00000000D+00
     .,0.99833100D+02,0.109D+03,0.600D+02,0.99820000D+00,0.00000000D+00
     .,0.97478900D+02,0.109D+03,0.610D+02,0.99820000D+00,0.00000000D+00
     .,0.95284600D+02,0.109D+03,0.620D+02,0.99820000D+00,0.00000000D+00
     .,0.93341000D+02,0.109D+03,0.630D+02,0.99820000D+00,0.00000000D+00
     .,0.77874200D+02,0.109D+03,0.640D+02,0.99820000D+00,0.00000000D+00
     .,0.82715400D+02,0.109D+03,0.650D+02,0.99820000D+00,0.00000000D+00
     .,0.80460700D+02,0.109D+03,0.660D+02,0.99820000D+00,0.00000000D+00
     .,0.84947800D+02,0.109D+03,0.670D+02,0.99820000D+00,0.00000000D+00
     .,0.83182700D+02,0.109D+03,0.680D+02,0.99820000D+00,0.00000000D+00
     .,0.81643700D+02,0.109D+03,0.690D+02,0.99820000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26101:  26200)=(/
     . 0.80457500D+02,0.109D+03,0.700D+02,0.99820000D+00,0.00000000D+00
     .,0.70552200D+02,0.109D+03,0.710D+02,0.99820000D+00,0.00000000D+00
     .,0.72088700D+02,0.109D+03,0.720D+02,0.99820000D+00,0.00000000D+00
     .,0.67959000D+02,0.109D+03,0.730D+02,0.99820000D+00,0.00000000D+00
     .,0.59575800D+02,0.109D+03,0.740D+02,0.99820000D+00,0.00000000D+00
     .,0.61094900D+02,0.109D+03,0.750D+02,0.99820000D+00,0.00000000D+00
     .,0.57011100D+02,0.109D+03,0.760D+02,0.99820000D+00,0.00000000D+00
     .,0.53521400D+02,0.109D+03,0.770D+02,0.99820000D+00,0.00000000D+00
     .,0.46144200D+02,0.109D+03,0.780D+02,0.99820000D+00,0.00000000D+00
     .,0.43746800D+02,0.109D+03,0.790D+02,0.99820000D+00,0.00000000D+00
     .,0.45120500D+02,0.109D+03,0.800D+02,0.99820000D+00,0.00000000D+00
     .,0.58912900D+02,0.109D+03,0.810D+02,0.99820000D+00,0.00000000D+00
     .,0.59109700D+02,0.109D+03,0.820D+02,0.99820000D+00,0.00000000D+00
     .,0.56500700D+02,0.109D+03,0.830D+02,0.99820000D+00,0.00000000D+00
     .,0.55261400D+02,0.109D+03,0.840D+02,0.99820000D+00,0.00000000D+00
     .,0.52703300D+02,0.109D+03,0.850D+02,0.99820000D+00,0.00000000D+00
     .,0.49892700D+02,0.109D+03,0.860D+02,0.99820000D+00,0.00000000D+00
     .,0.11543210D+03,0.109D+03,0.870D+02,0.99820000D+00,0.00000000D+00
     .,0.11600620D+03,0.109D+03,0.880D+02,0.99820000D+00,0.00000000D+00
     .,0.10653030D+03,0.109D+03,0.890D+02,0.99820000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26201:  26300)=(/
     . 0.10090290D+03,0.109D+03,0.900D+02,0.99820000D+00,0.00000000D+00
     .,0.98576800D+02,0.109D+03,0.910D+02,0.99820000D+00,0.00000000D+00
     .,0.95662500D+02,0.109D+03,0.920D+02,0.99820000D+00,0.00000000D+00
     .,0.95732200D+02,0.109D+03,0.930D+02,0.99820000D+00,0.00000000D+00
     .,0.93161400D+02,0.109D+03,0.940D+02,0.99820000D+00,0.00000000D+00
     .,0.63000000D+01,0.109D+03,0.101D+03,0.99820000D+00,0.00000000D+00
     .,0.17173300D+02,0.109D+03,0.103D+03,0.99820000D+00,0.98650000D+00
     .,0.22541300D+02,0.109D+03,0.104D+03,0.99820000D+00,0.98080000D+00
     .,0.19202900D+02,0.109D+03,0.105D+03,0.99820000D+00,0.97060000D+00
     .,0.15685700D+02,0.109D+03,0.106D+03,0.99820000D+00,0.98680000D+00
     .,0.11947000D+02,0.109D+03,0.107D+03,0.99820000D+00,0.99440000D+00
     .,0.94048000D+01,0.109D+03,0.108D+03,0.99820000D+00,0.99250000D+00
     .,0.71341000D+01,0.109D+03,0.109D+03,0.99820000D+00,0.99820000D+00
     .,0.20756700D+02,0.111D+03,0.100D+01,0.96840000D+00,0.91180000D+00
     .,0.12728700D+02,0.111D+03,0.200D+01,0.96840000D+00,0.00000000D+00
     .,0.42571610D+03,0.111D+03,0.300D+01,0.96840000D+00,0.00000000D+00
     .,0.21865720D+03,0.111D+03,0.400D+01,0.96840000D+00,0.00000000D+00
     .,0.13695360D+03,0.111D+03,0.500D+01,0.96840000D+00,0.00000000D+00
     .,0.87395600D+02,0.111D+03,0.600D+01,0.96840000D+00,0.00000000D+00
     .,0.58485300D+02,0.111D+03,0.700D+01,0.96840000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26301:  26400)=(/
     . 0.42891100D+02,0.111D+03,0.800D+01,0.96840000D+00,0.00000000D+00
     .,0.31606000D+02,0.111D+03,0.900D+01,0.96840000D+00,0.00000000D+00
     .,0.23774500D+02,0.111D+03,0.100D+02,0.96840000D+00,0.00000000D+00
     .,0.50543630D+03,0.111D+03,0.110D+02,0.96840000D+00,0.00000000D+00
     .,0.35591800D+03,0.111D+03,0.120D+02,0.96840000D+00,0.00000000D+00
     .,0.31645880D+03,0.111D+03,0.130D+02,0.96840000D+00,0.00000000D+00
     .,0.23713260D+03,0.111D+03,0.140D+02,0.96840000D+00,0.00000000D+00
     .,0.17692050D+03,0.111D+03,0.150D+02,0.96840000D+00,0.00000000D+00
     .,0.14254300D+03,0.111D+03,0.160D+02,0.96840000D+00,0.00000000D+00
     .,0.11310250D+03,0.111D+03,0.170D+02,0.96840000D+00,0.00000000D+00
     .,0.90173500D+02,0.111D+03,0.180D+02,0.96840000D+00,0.00000000D+00
     .,0.84082990D+03,0.111D+03,0.190D+02,0.96840000D+00,0.00000000D+00
     .,0.64831050D+03,0.111D+03,0.200D+02,0.96840000D+00,0.00000000D+00
     .,0.52709170D+03,0.111D+03,0.210D+02,0.96840000D+00,0.00000000D+00
     .,0.50123930D+03,0.111D+03,0.220D+02,0.96840000D+00,0.00000000D+00
     .,0.45480300D+03,0.111D+03,0.230D+02,0.96840000D+00,0.00000000D+00
     .,0.35715080D+03,0.111D+03,0.240D+02,0.96840000D+00,0.00000000D+00
     .,0.38634260D+03,0.111D+03,0.250D+02,0.96840000D+00,0.00000000D+00
     .,0.30174010D+03,0.111D+03,0.260D+02,0.96840000D+00,0.00000000D+00
     .,0.31417180D+03,0.111D+03,0.270D+02,0.96840000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26401:  26500)=(/
     . 0.32682710D+03,0.111D+03,0.280D+02,0.96840000D+00,0.00000000D+00
     .,0.24981970D+03,0.111D+03,0.290D+02,0.96840000D+00,0.00000000D+00
     .,0.24939250D+03,0.111D+03,0.300D+02,0.96840000D+00,0.00000000D+00
     .,0.29840070D+03,0.111D+03,0.310D+02,0.96840000D+00,0.00000000D+00
     .,0.25314330D+03,0.111D+03,0.320D+02,0.96840000D+00,0.00000000D+00
     .,0.20818020D+03,0.111D+03,0.330D+02,0.96840000D+00,0.00000000D+00
     .,0.18247440D+03,0.111D+03,0.340D+02,0.96840000D+00,0.00000000D+00
     .,0.15582020D+03,0.111D+03,0.350D+02,0.96840000D+00,0.00000000D+00
     .,0.13243480D+03,0.111D+03,0.360D+02,0.96840000D+00,0.00000000D+00
     .,0.93630060D+03,0.111D+03,0.370D+02,0.96840000D+00,0.00000000D+00
     .,0.77398540D+03,0.111D+03,0.380D+02,0.96840000D+00,0.00000000D+00
     .,0.65879630D+03,0.111D+03,0.390D+02,0.96840000D+00,0.00000000D+00
     .,0.58124800D+03,0.111D+03,0.400D+02,0.96840000D+00,0.00000000D+00
     .,0.52340580D+03,0.111D+03,0.410D+02,0.96840000D+00,0.00000000D+00
     .,0.39500580D+03,0.111D+03,0.420D+02,0.96840000D+00,0.00000000D+00
     .,0.44452690D+03,0.111D+03,0.430D+02,0.96840000D+00,0.00000000D+00
     .,0.33022730D+03,0.111D+03,0.440D+02,0.96840000D+00,0.00000000D+00
     .,0.36142870D+03,0.111D+03,0.450D+02,0.96840000D+00,0.00000000D+00
     .,0.33243920D+03,0.111D+03,0.460D+02,0.96840000D+00,0.00000000D+00
     .,0.27794280D+03,0.111D+03,0.470D+02,0.96840000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26501:  26600)=(/
     . 0.28984740D+03,0.111D+03,0.480D+02,0.96840000D+00,0.00000000D+00
     .,0.37337940D+03,0.111D+03,0.490D+02,0.96840000D+00,0.00000000D+00
     .,0.33470230D+03,0.111D+03,0.500D+02,0.96840000D+00,0.00000000D+00
     .,0.28898880D+03,0.111D+03,0.510D+02,0.96840000D+00,0.00000000D+00
     .,0.26288460D+03,0.111D+03,0.520D+02,0.96840000D+00,0.00000000D+00
     .,0.23260530D+03,0.111D+03,0.530D+02,0.96840000D+00,0.00000000D+00
     .,0.20479860D+03,0.111D+03,0.540D+02,0.96840000D+00,0.00000000D+00
     .,0.11389256D+04,0.111D+03,0.550D+02,0.96840000D+00,0.00000000D+00
     .,0.99536600D+03,0.111D+03,0.560D+02,0.96840000D+00,0.00000000D+00
     .,0.85007680D+03,0.111D+03,0.570D+02,0.96840000D+00,0.00000000D+00
     .,0.34313820D+03,0.111D+03,0.580D+02,0.96840000D+00,0.27991000D+01
     .,0.87351340D+03,0.111D+03,0.590D+02,0.96840000D+00,0.00000000D+00
     .,0.83492630D+03,0.111D+03,0.600D+02,0.96840000D+00,0.00000000D+00
     .,0.81293500D+03,0.111D+03,0.610D+02,0.96840000D+00,0.00000000D+00
     .,0.79283360D+03,0.111D+03,0.620D+02,0.96840000D+00,0.00000000D+00
     .,0.77497190D+03,0.111D+03,0.630D+02,0.96840000D+00,0.00000000D+00
     .,0.58968210D+03,0.111D+03,0.640D+02,0.96840000D+00,0.00000000D+00
     .,0.69502110D+03,0.111D+03,0.650D+02,0.96840000D+00,0.00000000D+00
     .,0.66665150D+03,0.111D+03,0.660D+02,0.96840000D+00,0.00000000D+00
     .,0.69407420D+03,0.111D+03,0.670D+02,0.96840000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26601:  26700)=(/
     . 0.67884860D+03,0.111D+03,0.680D+02,0.96840000D+00,0.00000000D+00
     .,0.66485800D+03,0.111D+03,0.690D+02,0.96840000D+00,0.00000000D+00
     .,0.65799220D+03,0.111D+03,0.700D+02,0.96840000D+00,0.00000000D+00
     .,0.54208720D+03,0.111D+03,0.710D+02,0.96840000D+00,0.00000000D+00
     .,0.51742950D+03,0.111D+03,0.720D+02,0.96840000D+00,0.00000000D+00
     .,0.46327240D+03,0.111D+03,0.730D+02,0.96840000D+00,0.00000000D+00
     .,0.38490910D+03,0.111D+03,0.740D+02,0.96840000D+00,0.00000000D+00
     .,0.38879710D+03,0.111D+03,0.750D+02,0.96840000D+00,0.00000000D+00
     .,0.34639970D+03,0.111D+03,0.760D+02,0.96840000D+00,0.00000000D+00
     .,0.31281320D+03,0.111D+03,0.770D+02,0.96840000D+00,0.00000000D+00
     .,0.25572890D+03,0.111D+03,0.780D+02,0.96840000D+00,0.00000000D+00
     .,0.23740440D+03,0.111D+03,0.790D+02,0.96840000D+00,0.00000000D+00
     .,0.24279190D+03,0.111D+03,0.800D+02,0.96840000D+00,0.00000000D+00
     .,0.37972090D+03,0.111D+03,0.810D+02,0.96840000D+00,0.00000000D+00
     .,0.36256490D+03,0.111D+03,0.820D+02,0.96840000D+00,0.00000000D+00
     .,0.32393500D+03,0.111D+03,0.830D+02,0.96840000D+00,0.00000000D+00
     .,0.30383030D+03,0.111D+03,0.840D+02,0.96840000D+00,0.00000000D+00
     .,0.27473150D+03,0.111D+03,0.850D+02,0.96840000D+00,0.00000000D+00
     .,0.24706350D+03,0.111D+03,0.860D+02,0.96840000D+00,0.00000000D+00
     .,0.10521318D+04,0.111D+03,0.870D+02,0.96840000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26701:  26800)=(/
     . 0.96974210D+03,0.111D+03,0.880D+02,0.96840000D+00,0.00000000D+00
     .,0.83486500D+03,0.111D+03,0.890D+02,0.96840000D+00,0.00000000D+00
     .,0.72693870D+03,0.111D+03,0.900D+02,0.96840000D+00,0.00000000D+00
     .,0.73265540D+03,0.111D+03,0.910D+02,0.96840000D+00,0.00000000D+00
     .,0.70879360D+03,0.111D+03,0.920D+02,0.96840000D+00,0.00000000D+00
     .,0.74391900D+03,0.111D+03,0.930D+02,0.96840000D+00,0.00000000D+00
     .,0.71791000D+03,0.111D+03,0.940D+02,0.96840000D+00,0.00000000D+00
     .,0.34995200D+02,0.111D+03,0.101D+03,0.96840000D+00,0.00000000D+00
     .,0.12582450D+03,0.111D+03,0.103D+03,0.96840000D+00,0.98650000D+00
     .,0.15832680D+03,0.111D+03,0.104D+03,0.96840000D+00,0.98080000D+00
     .,0.11340160D+03,0.111D+03,0.105D+03,0.96840000D+00,0.97060000D+00
     .,0.82014400D+02,0.111D+03,0.106D+03,0.96840000D+00,0.98680000D+00
     .,0.54445400D+02,0.111D+03,0.107D+03,0.96840000D+00,0.99440000D+00
     .,0.38122700D+02,0.111D+03,0.108D+03,0.96840000D+00,0.99250000D+00
     .,0.24956000D+02,0.111D+03,0.109D+03,0.96840000D+00,0.99820000D+00
     .,0.18610520D+03,0.111D+03,0.111D+03,0.96840000D+00,0.96840000D+00
     .,0.31991300D+02,0.112D+03,0.100D+01,0.96280000D+00,0.91180000D+00
     .,0.19464800D+02,0.112D+03,0.200D+01,0.96280000D+00,0.00000000D+00
     .,0.67003300D+03,0.112D+03,0.300D+01,0.96280000D+00,0.00000000D+00
     .,0.34026020D+03,0.112D+03,0.400D+01,0.96280000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26801:  26900)=(/
     . 0.21221800D+03,0.112D+03,0.500D+01,0.96280000D+00,0.00000000D+00
     .,0.13492270D+03,0.112D+03,0.600D+01,0.96280000D+00,0.00000000D+00
     .,0.89964600D+02,0.112D+03,0.700D+01,0.96280000D+00,0.00000000D+00
     .,0.65760900D+02,0.112D+03,0.800D+01,0.96280000D+00,0.00000000D+00
     .,0.48286500D+02,0.112D+03,0.900D+01,0.96280000D+00,0.00000000D+00
     .,0.36191100D+02,0.112D+03,0.100D+02,0.96280000D+00,0.00000000D+00
     .,0.79475970D+03,0.112D+03,0.110D+02,0.96280000D+00,0.00000000D+00
     .,0.55459670D+03,0.112D+03,0.120D+02,0.96280000D+00,0.00000000D+00
     .,0.49208290D+03,0.112D+03,0.130D+02,0.96280000D+00,0.00000000D+00
     .,0.36758110D+03,0.112D+03,0.140D+02,0.96280000D+00,0.00000000D+00
     .,0.27352680D+03,0.112D+03,0.150D+02,0.96280000D+00,0.00000000D+00
     .,0.21994890D+03,0.112D+03,0.160D+02,0.96280000D+00,0.00000000D+00
     .,0.17413990D+03,0.112D+03,0.170D+02,0.96280000D+00,0.00000000D+00
     .,0.13851900D+03,0.112D+03,0.180D+02,0.96280000D+00,0.00000000D+00
     .,0.13273176D+04,0.112D+03,0.190D+02,0.96280000D+00,0.00000000D+00
     .,0.10137695D+04,0.112D+03,0.200D+02,0.96280000D+00,0.00000000D+00
     .,0.82289570D+03,0.112D+03,0.210D+02,0.96280000D+00,0.00000000D+00
     .,0.78169930D+03,0.112D+03,0.220D+02,0.96280000D+00,0.00000000D+00
     .,0.70876840D+03,0.112D+03,0.230D+02,0.96280000D+00,0.00000000D+00
     .,0.55661270D+03,0.112D+03,0.240D+02,0.96280000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  26901:  27000)=(/
     . 0.60144990D+03,0.112D+03,0.250D+02,0.96280000D+00,0.00000000D+00
     .,0.46964370D+03,0.112D+03,0.260D+02,0.96280000D+00,0.00000000D+00
     .,0.48817150D+03,0.112D+03,0.270D+02,0.96280000D+00,0.00000000D+00
     .,0.50815850D+03,0.112D+03,0.280D+02,0.96280000D+00,0.00000000D+00
     .,0.38842090D+03,0.112D+03,0.290D+02,0.96280000D+00,0.00000000D+00
     .,0.38688840D+03,0.112D+03,0.300D+02,0.96280000D+00,0.00000000D+00
     .,0.46356910D+03,0.112D+03,0.310D+02,0.96280000D+00,0.00000000D+00
     .,0.39225330D+03,0.112D+03,0.320D+02,0.96280000D+00,0.00000000D+00
     .,0.32187320D+03,0.112D+03,0.330D+02,0.96280000D+00,0.00000000D+00
     .,0.28171730D+03,0.112D+03,0.340D+02,0.96280000D+00,0.00000000D+00
     .,0.24015650D+03,0.112D+03,0.350D+02,0.96280000D+00,0.00000000D+00
     .,0.20374730D+03,0.112D+03,0.360D+02,0.96280000D+00,0.00000000D+00
     .,0.14776556D+04,0.112D+03,0.370D+02,0.96280000D+00,0.00000000D+00
     .,0.12109593D+04,0.112D+03,0.380D+02,0.96280000D+00,0.00000000D+00
     .,0.10281365D+04,0.112D+03,0.390D+02,0.96280000D+00,0.00000000D+00
     .,0.90577500D+03,0.112D+03,0.400D+02,0.96280000D+00,0.00000000D+00
     .,0.81492890D+03,0.112D+03,0.410D+02,0.96280000D+00,0.00000000D+00
     .,0.61402650D+03,0.112D+03,0.420D+02,0.96280000D+00,0.00000000D+00
     .,0.69144970D+03,0.112D+03,0.430D+02,0.96280000D+00,0.00000000D+00
     .,0.51267590D+03,0.112D+03,0.440D+02,0.96280000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27001:  27100)=(/
     . 0.56100100D+03,0.112D+03,0.450D+02,0.96280000D+00,0.00000000D+00
     .,0.51564570D+03,0.112D+03,0.460D+02,0.96280000D+00,0.00000000D+00
     .,0.43128070D+03,0.112D+03,0.470D+02,0.96280000D+00,0.00000000D+00
     .,0.44915670D+03,0.112D+03,0.480D+02,0.96280000D+00,0.00000000D+00
     .,0.57992340D+03,0.112D+03,0.490D+02,0.96280000D+00,0.00000000D+00
     .,0.51865180D+03,0.112D+03,0.500D+02,0.96280000D+00,0.00000000D+00
     .,0.44692300D+03,0.112D+03,0.510D+02,0.96280000D+00,0.00000000D+00
     .,0.40607280D+03,0.112D+03,0.520D+02,0.96280000D+00,0.00000000D+00
     .,0.35880520D+03,0.112D+03,0.530D+02,0.96280000D+00,0.00000000D+00
     .,0.31545810D+03,0.112D+03,0.540D+02,0.96280000D+00,0.00000000D+00
     .,0.17990180D+04,0.112D+03,0.550D+02,0.96280000D+00,0.00000000D+00
     .,0.15595050D+04,0.112D+03,0.560D+02,0.96280000D+00,0.00000000D+00
     .,0.13282510D+04,0.112D+03,0.570D+02,0.96280000D+00,0.00000000D+00
     .,0.53086500D+03,0.112D+03,0.580D+02,0.96280000D+00,0.27991000D+01
     .,0.13672714D+04,0.112D+03,0.590D+02,0.96280000D+00,0.00000000D+00
     .,0.13059000D+04,0.112D+03,0.600D+02,0.96280000D+00,0.00000000D+00
     .,0.12712883D+04,0.112D+03,0.610D+02,0.96280000D+00,0.00000000D+00
     .,0.12396749D+04,0.112D+03,0.620D+02,0.96280000D+00,0.00000000D+00
     .,0.12115825D+04,0.112D+03,0.630D+02,0.96280000D+00,0.00000000D+00
     .,0.91963290D+03,0.112D+03,0.640D+02,0.96280000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27101:  27200)=(/
     . 0.10898214D+04,0.112D+03,0.650D+02,0.96280000D+00,0.00000000D+00
     .,0.10451961D+04,0.112D+03,0.660D+02,0.96280000D+00,0.00000000D+00
     .,0.10842313D+04,0.112D+03,0.670D+02,0.96280000D+00,0.00000000D+00
     .,0.10603386D+04,0.112D+03,0.680D+02,0.96280000D+00,0.00000000D+00
     .,0.10383601D+04,0.112D+03,0.690D+02,0.96280000D+00,0.00000000D+00
     .,0.10277356D+04,0.112D+03,0.700D+02,0.96280000D+00,0.00000000D+00
     .,0.84553860D+03,0.112D+03,0.710D+02,0.96280000D+00,0.00000000D+00
     .,0.80500140D+03,0.112D+03,0.720D+02,0.96280000D+00,0.00000000D+00
     .,0.71971520D+03,0.112D+03,0.730D+02,0.96280000D+00,0.00000000D+00
     .,0.59743440D+03,0.112D+03,0.740D+02,0.96280000D+00,0.00000000D+00
     .,0.60309070D+03,0.112D+03,0.750D+02,0.96280000D+00,0.00000000D+00
     .,0.53662210D+03,0.112D+03,0.760D+02,0.96280000D+00,0.00000000D+00
     .,0.48407160D+03,0.112D+03,0.770D+02,0.96280000D+00,0.00000000D+00
     .,0.39524010D+03,0.112D+03,0.780D+02,0.96280000D+00,0.00000000D+00
     .,0.36670170D+03,0.112D+03,0.790D+02,0.96280000D+00,0.00000000D+00
     .,0.37485520D+03,0.112D+03,0.800D+02,0.96280000D+00,0.00000000D+00
     .,0.58953950D+03,0.112D+03,0.810D+02,0.96280000D+00,0.00000000D+00
     .,0.56172980D+03,0.112D+03,0.820D+02,0.96280000D+00,0.00000000D+00
     .,0.50092230D+03,0.112D+03,0.830D+02,0.96280000D+00,0.00000000D+00
     .,0.46935230D+03,0.112D+03,0.840D+02,0.96280000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27201:  27300)=(/
     . 0.42385000D+03,0.112D+03,0.850D+02,0.96280000D+00,0.00000000D+00
     .,0.38067930D+03,0.112D+03,0.860D+02,0.96280000D+00,0.00000000D+00
     .,0.16575070D+04,0.112D+03,0.870D+02,0.96280000D+00,0.00000000D+00
     .,0.15173457D+04,0.112D+03,0.880D+02,0.96280000D+00,0.00000000D+00
     .,0.13028376D+04,0.112D+03,0.890D+02,0.96280000D+00,0.00000000D+00
     .,0.11313898D+04,0.112D+03,0.900D+02,0.96280000D+00,0.00000000D+00
     .,0.11418668D+04,0.112D+03,0.910D+02,0.96280000D+00,0.00000000D+00
     .,0.11045083D+04,0.112D+03,0.920D+02,0.96280000D+00,0.00000000D+00
     .,0.11608135D+04,0.112D+03,0.930D+02,0.96280000D+00,0.00000000D+00
     .,0.11198466D+04,0.112D+03,0.940D+02,0.96280000D+00,0.00000000D+00
     .,0.54102100D+02,0.112D+03,0.101D+03,0.96280000D+00,0.00000000D+00
     .,0.19570570D+03,0.112D+03,0.103D+03,0.96280000D+00,0.98650000D+00
     .,0.24622270D+03,0.112D+03,0.104D+03,0.96280000D+00,0.98080000D+00
     .,0.17556460D+03,0.112D+03,0.105D+03,0.96280000D+00,0.97060000D+00
     .,0.12666570D+03,0.112D+03,0.106D+03,0.96280000D+00,0.98680000D+00
     .,0.83770300D+02,0.112D+03,0.107D+03,0.96280000D+00,0.99440000D+00
     .,0.58430300D+02,0.112D+03,0.108D+03,0.96280000D+00,0.99250000D+00
     .,0.37988400D+02,0.112D+03,0.109D+03,0.96280000D+00,0.99820000D+00
     .,0.28960820D+03,0.112D+03,0.111D+03,0.96280000D+00,0.96840000D+00
     .,0.45127080D+03,0.112D+03,0.112D+03,0.96280000D+00,0.96280000D+00
     ./)
      grimme_c6_parameters(  27301:  27400)=(/
     . 0.33104800D+02,0.113D+03,0.100D+01,0.96480000D+00,0.91180000D+00
     .,0.20515800D+02,0.113D+03,0.200D+01,0.96480000D+00,0.00000000D+00
     .,0.62753090D+03,0.113D+03,0.300D+01,0.96480000D+00,0.00000000D+00
     .,0.33473350D+03,0.113D+03,0.400D+01,0.96480000D+00,0.00000000D+00
     .,0.21388480D+03,0.113D+03,0.500D+01,0.96480000D+00,0.00000000D+00
     .,0.13832540D+03,0.113D+03,0.600D+01,0.96480000D+00,0.00000000D+00
     .,0.93354200D+02,0.113D+03,0.700D+01,0.96480000D+00,0.00000000D+00
     .,0.68798300D+02,0.113D+03,0.800D+01,0.96480000D+00,0.00000000D+00
     .,0.50857700D+02,0.113D+03,0.900D+01,0.96480000D+00,0.00000000D+00
     .,0.38315400D+02,0.113D+03,0.100D+02,0.96480000D+00,0.00000000D+00
     .,0.74634190D+03,0.113D+03,0.110D+02,0.96480000D+00,0.00000000D+00
     .,0.54102850D+03,0.113D+03,0.120D+02,0.96480000D+00,0.00000000D+00
     .,0.48623650D+03,0.113D+03,0.130D+02,0.96480000D+00,0.00000000D+00
     .,0.36962320D+03,0.113D+03,0.140D+02,0.96480000D+00,0.00000000D+00
     .,0.27892720D+03,0.113D+03,0.150D+02,0.96480000D+00,0.00000000D+00
     .,0.22621560D+03,0.113D+03,0.160D+02,0.96480000D+00,0.00000000D+00
     .,0.18054300D+03,0.113D+03,0.170D+02,0.96480000D+00,0.00000000D+00
     .,0.14457980D+03,0.113D+03,0.180D+02,0.96480000D+00,0.00000000D+00
     .,0.12332237D+04,0.113D+03,0.190D+02,0.96480000D+00,0.00000000D+00
     .,0.97304930D+03,0.113D+03,0.200D+02,0.96480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27401:  27500)=(/
     . 0.79522060D+03,0.113D+03,0.210D+02,0.96480000D+00,0.00000000D+00
     .,0.75945320D+03,0.113D+03,0.220D+02,0.96480000D+00,0.00000000D+00
     .,0.69091560D+03,0.113D+03,0.230D+02,0.96480000D+00,0.00000000D+00
     .,0.54224590D+03,0.113D+03,0.240D+02,0.96480000D+00,0.00000000D+00
     .,0.58914750D+03,0.113D+03,0.250D+02,0.96480000D+00,0.00000000D+00
     .,0.46004960D+03,0.113D+03,0.260D+02,0.96480000D+00,0.00000000D+00
     .,0.48229900D+03,0.113D+03,0.270D+02,0.96480000D+00,0.00000000D+00
     .,0.50035250D+03,0.113D+03,0.280D+02,0.96480000D+00,0.00000000D+00
     .,0.38199230D+03,0.113D+03,0.290D+02,0.96480000D+00,0.00000000D+00
     .,0.38514490D+03,0.113D+03,0.300D+02,0.96480000D+00,0.00000000D+00
     .,0.45995440D+03,0.113D+03,0.310D+02,0.96480000D+00,0.00000000D+00
     .,0.39466500D+03,0.113D+03,0.320D+02,0.96480000D+00,0.00000000D+00
     .,0.32772290D+03,0.113D+03,0.330D+02,0.96480000D+00,0.00000000D+00
     .,0.28884850D+03,0.113D+03,0.340D+02,0.96480000D+00,0.00000000D+00
     .,0.24796920D+03,0.113D+03,0.350D+02,0.96480000D+00,0.00000000D+00
     .,0.21169490D+03,0.113D+03,0.360D+02,0.96480000D+00,0.00000000D+00
     .,0.13752558D+04,0.113D+03,0.370D+02,0.96480000D+00,0.00000000D+00
     .,0.11602539D+04,0.113D+03,0.380D+02,0.96480000D+00,0.00000000D+00
     .,0.99637570D+03,0.113D+03,0.390D+02,0.96480000D+00,0.00000000D+00
     .,0.88385410D+03,0.113D+03,0.400D+02,0.96480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27501:  27600)=(/
     . 0.79860940D+03,0.113D+03,0.410D+02,0.96480000D+00,0.00000000D+00
     .,0.60591350D+03,0.113D+03,0.420D+02,0.96480000D+00,0.00000000D+00
     .,0.68054270D+03,0.113D+03,0.430D+02,0.96480000D+00,0.00000000D+00
     .,0.50852890D+03,0.113D+03,0.440D+02,0.96480000D+00,0.00000000D+00
     .,0.55700430D+03,0.113D+03,0.450D+02,0.96480000D+00,0.00000000D+00
     .,0.51341630D+03,0.113D+03,0.460D+02,0.96480000D+00,0.00000000D+00
     .,0.42799620D+03,0.113D+03,0.470D+02,0.96480000D+00,0.00000000D+00
     .,0.44880710D+03,0.113D+03,0.480D+02,0.96480000D+00,0.00000000D+00
     .,0.57434200D+03,0.113D+03,0.490D+02,0.96480000D+00,0.00000000D+00
     .,0.51984240D+03,0.113D+03,0.500D+02,0.96480000D+00,0.00000000D+00
     .,0.45284940D+03,0.113D+03,0.510D+02,0.96480000D+00,0.00000000D+00
     .,0.41405440D+03,0.113D+03,0.520D+02,0.96480000D+00,0.00000000D+00
     .,0.36827920D+03,0.113D+03,0.530D+02,0.96480000D+00,0.00000000D+00
     .,0.32576250D+03,0.113D+03,0.540D+02,0.96480000D+00,0.00000000D+00
     .,0.16731922D+04,0.113D+03,0.550D+02,0.96480000D+00,0.00000000D+00
     .,0.14872964D+04,0.113D+03,0.560D+02,0.96480000D+00,0.00000000D+00
     .,0.12815229D+04,0.113D+03,0.570D+02,0.96480000D+00,0.00000000D+00
     .,0.53656260D+03,0.113D+03,0.580D+02,0.96480000D+00,0.27991000D+01
     .,0.13086041D+04,0.113D+03,0.590D+02,0.96480000D+00,0.00000000D+00
     .,0.12526928D+04,0.113D+03,0.600D+02,0.96480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27601:  27700)=(/
     . 0.12202246D+04,0.113D+03,0.610D+02,0.96480000D+00,0.00000000D+00
     .,0.11905003D+04,0.113D+03,0.620D+02,0.96480000D+00,0.00000000D+00
     .,0.11641089D+04,0.113D+03,0.630D+02,0.96480000D+00,0.00000000D+00
     .,0.89395150D+03,0.113D+03,0.640D+02,0.96480000D+00,0.00000000D+00
     .,0.10381047D+04,0.113D+03,0.650D+02,0.96480000D+00,0.00000000D+00
     .,0.99738370D+03,0.113D+03,0.660D+02,0.96480000D+00,0.00000000D+00
     .,0.10450038D+04,0.113D+03,0.670D+02,0.96480000D+00,0.00000000D+00
     .,0.10223674D+04,0.113D+03,0.680D+02,0.96480000D+00,0.00000000D+00
     .,0.10016784D+04,0.113D+03,0.690D+02,0.96480000D+00,0.00000000D+00
     .,0.99098080D+03,0.113D+03,0.700D+02,0.96480000D+00,0.00000000D+00
     .,0.82160050D+03,0.113D+03,0.710D+02,0.96480000D+00,0.00000000D+00
     .,0.79184560D+03,0.113D+03,0.720D+02,0.96480000D+00,0.00000000D+00
     .,0.71274220D+03,0.113D+03,0.730D+02,0.96480000D+00,0.00000000D+00
     .,0.59416160D+03,0.113D+03,0.740D+02,0.96480000D+00,0.00000000D+00
     .,0.60157800D+03,0.113D+03,0.750D+02,0.96480000D+00,0.00000000D+00
     .,0.53838550D+03,0.113D+03,0.760D+02,0.96480000D+00,0.00000000D+00
     .,0.48789840D+03,0.113D+03,0.770D+02,0.96480000D+00,0.00000000D+00
     .,0.39997680D+03,0.113D+03,0.780D+02,0.96480000D+00,0.00000000D+00
     .,0.37172100D+03,0.113D+03,0.790D+02,0.96480000D+00,0.00000000D+00
     .,0.38105900D+03,0.113D+03,0.800D+02,0.96480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27701:  27800)=(/
     . 0.58469720D+03,0.113D+03,0.810D+02,0.96480000D+00,0.00000000D+00
     .,0.56268750D+03,0.113D+03,0.820D+02,0.96480000D+00,0.00000000D+00
     .,0.50686630D+03,0.113D+03,0.830D+02,0.96480000D+00,0.00000000D+00
     .,0.47758620D+03,0.113D+03,0.840D+02,0.96480000D+00,0.00000000D+00
     .,0.43409690D+03,0.113D+03,0.850D+02,0.96480000D+00,0.00000000D+00
     .,0.39211690D+03,0.113D+03,0.860D+02,0.96480000D+00,0.00000000D+00
     .,0.15558848D+04,0.113D+03,0.870D+02,0.96480000D+00,0.00000000D+00
     .,0.14554241D+04,0.113D+03,0.880D+02,0.96480000D+00,0.00000000D+00
     .,0.12633724D+04,0.113D+03,0.890D+02,0.96480000D+00,0.00000000D+00
     .,0.11100628D+04,0.113D+03,0.900D+02,0.96480000D+00,0.00000000D+00
     .,0.11130738D+04,0.113D+03,0.910D+02,0.96480000D+00,0.00000000D+00
     .,0.10770005D+04,0.113D+03,0.920D+02,0.96480000D+00,0.00000000D+00
     .,0.11238008D+04,0.113D+03,0.930D+02,0.96480000D+00,0.00000000D+00
     .,0.10856846D+04,0.113D+03,0.940D+02,0.96480000D+00,0.00000000D+00
     .,0.55263600D+02,0.113D+03,0.101D+03,0.96480000D+00,0.00000000D+00
     .,0.19307070D+03,0.113D+03,0.103D+03,0.96480000D+00,0.98650000D+00
     .,0.24376120D+03,0.113D+03,0.104D+03,0.96480000D+00,0.98080000D+00
     .,0.17772540D+03,0.113D+03,0.105D+03,0.96480000D+00,0.97060000D+00
     .,0.12969220D+03,0.113D+03,0.106D+03,0.96480000D+00,0.98680000D+00
     .,0.86872800D+02,0.113D+03,0.107D+03,0.96480000D+00,0.99440000D+00
     ./)
      grimme_c6_parameters(  27801:  27900)=(/
     . 0.61217500D+02,0.113D+03,0.108D+03,0.96480000D+00,0.99250000D+00
     .,0.40322000D+02,0.113D+03,0.109D+03,0.96480000D+00,0.99820000D+00
     .,0.28422510D+03,0.113D+03,0.111D+03,0.96480000D+00,0.96840000D+00
     .,0.44173220D+03,0.113D+03,0.112D+03,0.96480000D+00,0.96280000D+00
     .,0.43775750D+03,0.113D+03,0.113D+03,0.96480000D+00,0.96480000D+00
     .,0.27498900D+02,0.114D+03,0.100D+01,0.95070000D+00,0.91180000D+00
     .,0.17635600D+02,0.114D+03,0.200D+01,0.95070000D+00,0.00000000D+00
     .,0.45095830D+03,0.114D+03,0.300D+01,0.95070000D+00,0.00000000D+00
     .,0.25658810D+03,0.114D+03,0.400D+01,0.95070000D+00,0.00000000D+00
     .,0.17018910D+03,0.114D+03,0.500D+01,0.95070000D+00,0.00000000D+00
     .,0.11320460D+03,0.114D+03,0.600D+01,0.95070000D+00,0.00000000D+00
     .,0.78019000D+02,0.114D+03,0.700D+01,0.95070000D+00,0.00000000D+00
     .,0.58355700D+02,0.114D+03,0.800D+01,0.95070000D+00,0.00000000D+00
     .,0.43685500D+02,0.114D+03,0.900D+01,0.95070000D+00,0.00000000D+00
     .,0.33241600D+02,0.114D+03,0.100D+02,0.95070000D+00,0.00000000D+00
     .,0.53834120D+03,0.114D+03,0.110D+02,0.95070000D+00,0.00000000D+00
     .,0.40991740D+03,0.114D+03,0.120D+02,0.95070000D+00,0.00000000D+00
     .,0.37552330D+03,0.114D+03,0.130D+02,0.95070000D+00,0.00000000D+00
     .,0.29299940D+03,0.114D+03,0.140D+02,0.95070000D+00,0.00000000D+00
     .,0.22606570D+03,0.114D+03,0.150D+02,0.95070000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  27901:  28000)=(/
     . 0.18600510D+03,0.114D+03,0.160D+02,0.95070000D+00,0.00000000D+00
     .,0.15052310D+03,0.114D+03,0.170D+02,0.95070000D+00,0.00000000D+00
     .,0.12200120D+03,0.114D+03,0.180D+02,0.95070000D+00,0.00000000D+00
     .,0.88126240D+03,0.114D+03,0.190D+02,0.95070000D+00,0.00000000D+00
     .,0.72251110D+03,0.114D+03,0.200D+02,0.95070000D+00,0.00000000D+00
     .,0.59567250D+03,0.114D+03,0.210D+02,0.95070000D+00,0.00000000D+00
     .,0.57349880D+03,0.114D+03,0.220D+02,0.95070000D+00,0.00000000D+00
     .,0.52428080D+03,0.114D+03,0.230D+02,0.95070000D+00,0.00000000D+00
     .,0.41188790D+03,0.114D+03,0.240D+02,0.95070000D+00,0.00000000D+00
     .,0.45022340D+03,0.114D+03,0.250D+02,0.95070000D+00,0.00000000D+00
     .,0.35224080D+03,0.114D+03,0.260D+02,0.95070000D+00,0.00000000D+00
     .,0.37301250D+03,0.114D+03,0.270D+02,0.95070000D+00,0.00000000D+00
     .,0.38500480D+03,0.114D+03,0.280D+02,0.95070000D+00,0.00000000D+00
     .,0.29414060D+03,0.114D+03,0.290D+02,0.95070000D+00,0.00000000D+00
     .,0.30117090D+03,0.114D+03,0.300D+02,0.95070000D+00,0.00000000D+00
     .,0.35794110D+03,0.114D+03,0.310D+02,0.95070000D+00,0.00000000D+00
     .,0.31339110D+03,0.114D+03,0.320D+02,0.95070000D+00,0.00000000D+00
     .,0.26507110D+03,0.114D+03,0.330D+02,0.95070000D+00,0.00000000D+00
     .,0.23633230D+03,0.114D+03,0.340D+02,0.95070000D+00,0.00000000D+00
     .,0.20529760D+03,0.114D+03,0.350D+02,0.95070000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28001:  28100)=(/
     . 0.17718110D+03,0.114D+03,0.360D+02,0.95070000D+00,0.00000000D+00
     .,0.98604380D+03,0.114D+03,0.370D+02,0.95070000D+00,0.00000000D+00
     .,0.86034210D+03,0.114D+03,0.380D+02,0.95070000D+00,0.00000000D+00
     .,0.75038170D+03,0.114D+03,0.390D+02,0.95070000D+00,0.00000000D+00
     .,0.67218340D+03,0.114D+03,0.400D+02,0.95070000D+00,0.00000000D+00
     .,0.61131470D+03,0.114D+03,0.410D+02,0.95070000D+00,0.00000000D+00
     .,0.46910920D+03,0.114D+03,0.420D+02,0.95070000D+00,0.00000000D+00
     .,0.52464790D+03,0.114D+03,0.430D+02,0.95070000D+00,0.00000000D+00
     .,0.39698620D+03,0.114D+03,0.440D+02,0.95070000D+00,0.00000000D+00
     .,0.43472510D+03,0.114D+03,0.450D+02,0.95070000D+00,0.00000000D+00
     .,0.40236620D+03,0.114D+03,0.460D+02,0.95070000D+00,0.00000000D+00
     .,0.33466730D+03,0.114D+03,0.470D+02,0.95070000D+00,0.00000000D+00
     .,0.35359760D+03,0.114D+03,0.480D+02,0.95070000D+00,0.00000000D+00
     .,0.44659370D+03,0.114D+03,0.490D+02,0.95070000D+00,0.00000000D+00
     .,0.41089600D+03,0.114D+03,0.500D+02,0.95070000D+00,0.00000000D+00
     .,0.36378460D+03,0.114D+03,0.510D+02,0.95070000D+00,0.00000000D+00
     .,0.33592400D+03,0.114D+03,0.520D+02,0.95070000D+00,0.00000000D+00
     .,0.30198520D+03,0.114D+03,0.530D+02,0.95070000D+00,0.00000000D+00
     .,0.26983720D+03,0.114D+03,0.540D+02,0.95070000D+00,0.00000000D+00
     .,0.12005803D+04,0.114D+03,0.550D+02,0.95070000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28101:  28200)=(/
     . 0.10973980D+04,0.114D+03,0.560D+02,0.95070000D+00,0.00000000D+00
     .,0.96023320D+03,0.114D+03,0.570D+02,0.95070000D+00,0.00000000D+00
     .,0.42980740D+03,0.114D+03,0.580D+02,0.95070000D+00,0.27991000D+01
     .,0.97039570D+03,0.114D+03,0.590D+02,0.95070000D+00,0.00000000D+00
     .,0.93129170D+03,0.114D+03,0.600D+02,0.95070000D+00,0.00000000D+00
     .,0.90779700D+03,0.114D+03,0.610D+02,0.95070000D+00,0.00000000D+00
     .,0.88621930D+03,0.114D+03,0.620D+02,0.95070000D+00,0.00000000D+00
     .,0.86708440D+03,0.114D+03,0.630D+02,0.95070000D+00,0.00000000D+00
     .,0.67748060D+03,0.114D+03,0.640D+02,0.95070000D+00,0.00000000D+00
     .,0.76730550D+03,0.114D+03,0.650D+02,0.95070000D+00,0.00000000D+00
     .,0.73939750D+03,0.114D+03,0.660D+02,0.95070000D+00,0.00000000D+00
     .,0.78137480D+03,0.114D+03,0.670D+02,0.95070000D+00,0.00000000D+00
     .,0.76476680D+03,0.114D+03,0.680D+02,0.95070000D+00,0.00000000D+00
     .,0.74974130D+03,0.114D+03,0.690D+02,0.95070000D+00,0.00000000D+00
     .,0.74120300D+03,0.114D+03,0.700D+02,0.95070000D+00,0.00000000D+00
     .,0.62181690D+03,0.114D+03,0.710D+02,0.95070000D+00,0.00000000D+00
     .,0.60906080D+03,0.114D+03,0.720D+02,0.95070000D+00,0.00000000D+00
     .,0.55365420D+03,0.114D+03,0.730D+02,0.95070000D+00,0.00000000D+00
     .,0.46519420D+03,0.114D+03,0.740D+02,0.95070000D+00,0.00000000D+00
     .,0.47279230D+03,0.114D+03,0.750D+02,0.95070000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28201:  28300)=(/
     . 0.42679800D+03,0.114D+03,0.760D+02,0.95070000D+00,0.00000000D+00
     .,0.38949880D+03,0.114D+03,0.770D+02,0.95070000D+00,0.00000000D+00
     .,0.32171830D+03,0.114D+03,0.780D+02,0.95070000D+00,0.00000000D+00
     .,0.29988580D+03,0.114D+03,0.790D+02,0.95070000D+00,0.00000000D+00
     .,0.30842630D+03,0.114D+03,0.800D+02,0.95070000D+00,0.00000000D+00
     .,0.45658720D+03,0.114D+03,0.810D+02,0.95070000D+00,0.00000000D+00
     .,0.44500360D+03,0.114D+03,0.820D+02,0.95070000D+00,0.00000000D+00
     .,0.40670170D+03,0.114D+03,0.830D+02,0.95070000D+00,0.00000000D+00
     .,0.38646750D+03,0.114D+03,0.840D+02,0.95070000D+00,0.00000000D+00
     .,0.35486660D+03,0.114D+03,0.850D+02,0.95070000D+00,0.00000000D+00
     .,0.32354110D+03,0.114D+03,0.860D+02,0.95070000D+00,0.00000000D+00
     .,0.11298915D+04,0.114D+03,0.870D+02,0.95070000D+00,0.00000000D+00
     .,0.10825018D+04,0.114D+03,0.880D+02,0.95070000D+00,0.00000000D+00
     .,0.95314260D+03,0.114D+03,0.890D+02,0.95070000D+00,0.00000000D+00
     .,0.85147580D+03,0.114D+03,0.900D+02,0.95070000D+00,0.00000000D+00
     .,0.84679590D+03,0.114D+03,0.910D+02,0.95070000D+00,0.00000000D+00
     .,0.81968560D+03,0.114D+03,0.920D+02,0.95070000D+00,0.00000000D+00
     .,0.84655430D+03,0.114D+03,0.930D+02,0.95070000D+00,0.00000000D+00
     .,0.81936980D+03,0.114D+03,0.940D+02,0.95070000D+00,0.00000000D+00
     .,0.44903000D+02,0.114D+03,0.101D+03,0.95070000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28301:  28400)=(/
     . 0.14874780D+03,0.114D+03,0.103D+03,0.95070000D+00,0.98650000D+00
     .,0.18910900D+03,0.114D+03,0.104D+03,0.95070000D+00,0.98080000D+00
     .,0.14251230D+03,0.114D+03,0.105D+03,0.95070000D+00,0.97060000D+00
     .,0.10608060D+03,0.114D+03,0.106D+03,0.95070000D+00,0.98680000D+00
     .,0.72637300D+02,0.114D+03,0.107D+03,0.95070000D+00,0.99440000D+00
     .,0.52131100D+02,0.114D+03,0.108D+03,0.95070000D+00,0.99250000D+00
     .,0.35129000D+02,0.114D+03,0.109D+03,0.95070000D+00,0.99820000D+00
     .,0.21750490D+03,0.114D+03,0.111D+03,0.95070000D+00,0.96840000D+00
     .,0.33702500D+03,0.114D+03,0.112D+03,0.95070000D+00,0.96280000D+00
     .,0.33965160D+03,0.114D+03,0.113D+03,0.95070000D+00,0.96480000D+00
     .,0.27026500D+03,0.114D+03,0.114D+03,0.95070000D+00,0.95070000D+00
     .,0.23090800D+02,0.115D+03,0.100D+01,0.99470000D+00,0.91180000D+00
     .,0.15261900D+02,0.115D+03,0.200D+01,0.99470000D+00,0.00000000D+00
     .,0.33966930D+03,0.115D+03,0.300D+01,0.99470000D+00,0.00000000D+00
     .,0.20222820D+03,0.115D+03,0.400D+01,0.99470000D+00,0.00000000D+00
     .,0.13807740D+03,0.115D+03,0.500D+01,0.99470000D+00,0.00000000D+00
     .,0.93966300D+02,0.115D+03,0.600D+01,0.99470000D+00,0.00000000D+00
     .,0.65912700D+02,0.115D+03,0.700D+01,0.99470000D+00,0.00000000D+00
     .,0.49937400D+02,0.115D+03,0.800D+01,0.99470000D+00,0.00000000D+00
     .,0.37803500D+02,0.115D+03,0.900D+01,0.99470000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28401:  28500)=(/
     . 0.29028000D+02,0.115D+03,0.100D+02,0.99470000D+00,0.00000000D+00
     .,0.40671500D+03,0.115D+03,0.110D+02,0.99470000D+00,0.00000000D+00
     .,0.32041760D+03,0.115D+03,0.120D+02,0.99470000D+00,0.00000000D+00
     .,0.29780760D+03,0.115D+03,0.130D+02,0.99470000D+00,0.00000000D+00
     .,0.23698640D+03,0.115D+03,0.140D+02,0.99470000D+00,0.00000000D+00
     .,0.18606840D+03,0.115D+03,0.150D+02,0.99470000D+00,0.00000000D+00
     .,0.15492290D+03,0.115D+03,0.160D+02,0.99470000D+00,0.00000000D+00
     .,0.12683120D+03,0.115D+03,0.170D+02,0.99470000D+00,0.00000000D+00
     .,0.10386530D+03,0.115D+03,0.180D+02,0.99470000D+00,0.00000000D+00
     .,0.66311840D+03,0.115D+03,0.190D+02,0.99470000D+00,0.00000000D+00
     .,0.55742550D+03,0.115D+03,0.200D+02,0.99470000D+00,0.00000000D+00
     .,0.46235110D+03,0.115D+03,0.210D+02,0.99470000D+00,0.00000000D+00
     .,0.44795900D+03,0.115D+03,0.220D+02,0.99470000D+00,0.00000000D+00
     .,0.41101210D+03,0.115D+03,0.230D+02,0.99470000D+00,0.00000000D+00
     .,0.32359140D+03,0.115D+03,0.240D+02,0.99470000D+00,0.00000000D+00
     .,0.35484320D+03,0.115D+03,0.250D+02,0.99470000D+00,0.00000000D+00
     .,0.27840200D+03,0.115D+03,0.260D+02,0.99470000D+00,0.00000000D+00
     .,0.29657890D+03,0.115D+03,0.270D+02,0.99470000D+00,0.00000000D+00
     .,0.30491450D+03,0.115D+03,0.280D+02,0.99470000D+00,0.00000000D+00
     .,0.23348980D+03,0.115D+03,0.290D+02,0.99470000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28501:  28600)=(/
     . 0.24143800D+03,0.115D+03,0.300D+02,0.99470000D+00,0.00000000D+00
     .,0.28580720D+03,0.115D+03,0.310D+02,0.99470000D+00,0.00000000D+00
     .,0.25397440D+03,0.115D+03,0.320D+02,0.99470000D+00,0.00000000D+00
     .,0.21789200D+03,0.115D+03,0.330D+02,0.99470000D+00,0.00000000D+00
     .,0.19608060D+03,0.115D+03,0.340D+02,0.99470000D+00,0.00000000D+00
     .,0.17199100D+03,0.115D+03,0.350D+02,0.99470000D+00,0.00000000D+00
     .,0.14979330D+03,0.115D+03,0.360D+02,0.99470000D+00,0.00000000D+00
     .,0.74424750D+03,0.115D+03,0.370D+02,0.99470000D+00,0.00000000D+00
     .,0.66356560D+03,0.115D+03,0.380D+02,0.99470000D+00,0.00000000D+00
     .,0.58524670D+03,0.115D+03,0.390D+02,0.99470000D+00,0.00000000D+00
     .,0.52808410D+03,0.115D+03,0.400D+02,0.99470000D+00,0.00000000D+00
     .,0.48270360D+03,0.115D+03,0.410D+02,0.99470000D+00,0.00000000D+00
     .,0.37394270D+03,0.115D+03,0.420D+02,0.99470000D+00,0.00000000D+00
     .,0.41670800D+03,0.115D+03,0.430D+02,0.99470000D+00,0.00000000D+00
     .,0.31859120D+03,0.115D+03,0.440D+02,0.99470000D+00,0.00000000D+00
     .,0.34844490D+03,0.115D+03,0.450D+02,0.99470000D+00,0.00000000D+00
     .,0.32352760D+03,0.115D+03,0.460D+02,0.99470000D+00,0.00000000D+00
     .,0.26912200D+03,0.115D+03,0.470D+02,0.99470000D+00,0.00000000D+00
     .,0.28548020D+03,0.115D+03,0.480D+02,0.99470000D+00,0.00000000D+00
     .,0.35690690D+03,0.115D+03,0.490D+02,0.99470000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28601:  28700)=(/
     . 0.33217220D+03,0.115D+03,0.500D+02,0.99470000D+00,0.00000000D+00
     .,0.29765980D+03,0.115D+03,0.510D+02,0.99470000D+00,0.00000000D+00
     .,0.27698090D+03,0.115D+03,0.520D+02,0.99470000D+00,0.00000000D+00
     .,0.25110810D+03,0.115D+03,0.530D+02,0.99470000D+00,0.00000000D+00
     .,0.22622110D+03,0.115D+03,0.540D+02,0.99470000D+00,0.00000000D+00
     .,0.90729930D+03,0.115D+03,0.550D+02,0.99470000D+00,0.00000000D+00
     .,0.84401200D+03,0.115D+03,0.560D+02,0.99470000D+00,0.00000000D+00
     .,0.74659930D+03,0.115D+03,0.570D+02,0.99470000D+00,0.00000000D+00
     .,0.35115850D+03,0.115D+03,0.580D+02,0.99470000D+00,0.27991000D+01
     .,0.74914380D+03,0.115D+03,0.590D+02,0.99470000D+00,0.00000000D+00
     .,0.72014500D+03,0.115D+03,0.600D+02,0.99470000D+00,0.00000000D+00
     .,0.70229590D+03,0.115D+03,0.610D+02,0.99470000D+00,0.00000000D+00
     .,0.68586200D+03,0.115D+03,0.620D+02,0.99470000D+00,0.00000000D+00
     .,0.67130090D+03,0.115D+03,0.630D+02,0.99470000D+00,0.00000000D+00
     .,0.53154240D+03,0.115D+03,0.640D+02,0.99470000D+00,0.00000000D+00
     .,0.59201350D+03,0.115D+03,0.650D+02,0.99470000D+00,0.00000000D+00
     .,0.57174810D+03,0.115D+03,0.660D+02,0.99470000D+00,0.00000000D+00
     .,0.60649400D+03,0.115D+03,0.670D+02,0.99470000D+00,0.00000000D+00
     .,0.59374030D+03,0.115D+03,0.680D+02,0.99470000D+00,0.00000000D+00
     .,0.58229560D+03,0.115D+03,0.690D+02,0.99470000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28701:  28800)=(/
     . 0.57532620D+03,0.115D+03,0.700D+02,0.99470000D+00,0.00000000D+00
     .,0.48706190D+03,0.115D+03,0.710D+02,0.99470000D+00,0.00000000D+00
     .,0.48246160D+03,0.115D+03,0.720D+02,0.99470000D+00,0.00000000D+00
     .,0.44186160D+03,0.115D+03,0.730D+02,0.99470000D+00,0.00000000D+00
     .,0.37386540D+03,0.115D+03,0.740D+02,0.99470000D+00,0.00000000D+00
     .,0.38091200D+03,0.115D+03,0.750D+02,0.99470000D+00,0.00000000D+00
     .,0.34613260D+03,0.115D+03,0.760D+02,0.99470000D+00,0.00000000D+00
     .,0.31760850D+03,0.115D+03,0.770D+02,0.99470000D+00,0.00000000D+00
     .,0.26410910D+03,0.115D+03,0.780D+02,0.99470000D+00,0.00000000D+00
     .,0.24683080D+03,0.115D+03,0.790D+02,0.99470000D+00,0.00000000D+00
     .,0.25431280D+03,0.115D+03,0.800D+02,0.99470000D+00,0.00000000D+00
     .,0.36658420D+03,0.115D+03,0.810D+02,0.99470000D+00,0.00000000D+00
     .,0.36026310D+03,0.115D+03,0.820D+02,0.99470000D+00,0.00000000D+00
     .,0.33271860D+03,0.115D+03,0.830D+02,0.99470000D+00,0.00000000D+00
     .,0.31818410D+03,0.115D+03,0.840D+02,0.99470000D+00,0.00000000D+00
     .,0.29447100D+03,0.115D+03,0.850D+02,0.99470000D+00,0.00000000D+00
     .,0.27046770D+03,0.115D+03,0.860D+02,0.99470000D+00,0.00000000D+00
     .,0.86138240D+03,0.115D+03,0.870D+02,0.99470000D+00,0.00000000D+00
     .,0.83751280D+03,0.115D+03,0.880D+02,0.99470000D+00,0.00000000D+00
     .,0.74476320D+03,0.115D+03,0.890D+02,0.99470000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28801:  28900)=(/
     . 0.67356880D+03,0.115D+03,0.900D+02,0.99470000D+00,0.00000000D+00
     .,0.66625820D+03,0.115D+03,0.910D+02,0.99470000D+00,0.00000000D+00
     .,0.64514050D+03,0.115D+03,0.920D+02,0.99470000D+00,0.00000000D+00
     .,0.66128050D+03,0.115D+03,0.930D+02,0.99470000D+00,0.00000000D+00
     .,0.64087610D+03,0.115D+03,0.940D+02,0.99470000D+00,0.00000000D+00
     .,0.37023600D+02,0.115D+03,0.101D+03,0.99470000D+00,0.00000000D+00
     .,0.11774720D+03,0.115D+03,0.103D+03,0.99470000D+00,0.98650000D+00
     .,0.15060680D+03,0.115D+03,0.104D+03,0.99470000D+00,0.98080000D+00
     .,0.11638180D+03,0.115D+03,0.105D+03,0.99470000D+00,0.97060000D+00
     .,0.88076900D+02,0.115D+03,0.106D+03,0.99470000D+00,0.98680000D+00
     .,0.61428600D+02,0.115D+03,0.107D+03,0.99470000D+00,0.99440000D+00
     .,0.44777000D+02,0.115D+03,0.108D+03,0.99470000D+00,0.99250000D+00
     .,0.30768800D+02,0.115D+03,0.109D+03,0.99470000D+00,0.99820000D+00
     .,0.17144690D+03,0.115D+03,0.111D+03,0.99470000D+00,0.96840000D+00
     .,0.26503780D+03,0.115D+03,0.112D+03,0.99470000D+00,0.96280000D+00
     .,0.27035800D+03,0.115D+03,0.113D+03,0.99470000D+00,0.96480000D+00
     .,0.21928630D+03,0.115D+03,0.114D+03,0.99470000D+00,0.95070000D+00
     .,0.18062380D+03,0.115D+03,0.115D+03,0.99470000D+00,0.99470000D+00
     .,0.19866700D+02,0.116D+03,0.100D+01,0.99480000D+00,0.91180000D+00
     .,0.13459800D+02,0.116D+03,0.200D+01,0.99480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  28901:  29000)=(/
     . 0.27130110D+03,0.116D+03,0.300D+01,0.99480000D+00,0.00000000D+00
     .,0.16618070D+03,0.116D+03,0.400D+01,0.99480000D+00,0.00000000D+00
     .,0.11581680D+03,0.116D+03,0.500D+01,0.99480000D+00,0.00000000D+00
     .,0.80180400D+02,0.116D+03,0.600D+01,0.99480000D+00,0.00000000D+00
     .,0.57025500D+02,0.116D+03,0.700D+01,0.99480000D+00,0.00000000D+00
     .,0.43654800D+02,0.116D+03,0.800D+01,0.99480000D+00,0.00000000D+00
     .,0.33355000D+02,0.116D+03,0.900D+01,0.99480000D+00,0.00000000D+00
     .,0.25810700D+02,0.116D+03,0.100D+02,0.99480000D+00,0.00000000D+00
     .,0.32559690D+03,0.116D+03,0.110D+02,0.99480000D+00,0.00000000D+00
     .,0.26194370D+03,0.116D+03,0.120D+02,0.99480000D+00,0.00000000D+00
     .,0.24585680D+03,0.116D+03,0.130D+02,0.99480000D+00,0.00000000D+00
     .,0.19832660D+03,0.116D+03,0.140D+02,0.99480000D+00,0.00000000D+00
     .,0.15769710D+03,0.116D+03,0.150D+02,0.99480000D+00,0.00000000D+00
     .,0.13249220D+03,0.116D+03,0.160D+02,0.99480000D+00,0.00000000D+00
     .,0.10944860D+03,0.116D+03,0.170D+02,0.99480000D+00,0.00000000D+00
     .,0.90371600D+02,0.116D+03,0.180D+02,0.99480000D+00,0.00000000D+00
     .,0.53051920D+03,0.116D+03,0.190D+02,0.99480000D+00,0.00000000D+00
     .,0.45237450D+03,0.116D+03,0.200D+02,0.99480000D+00,0.00000000D+00
     .,0.37661420D+03,0.116D+03,0.210D+02,0.99480000D+00,0.00000000D+00
     .,0.36651510D+03,0.116D+03,0.220D+02,0.99480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29001:  29100)=(/
     . 0.33712500D+03,0.116D+03,0.230D+02,0.99480000D+00,0.00000000D+00
     .,0.26607620D+03,0.116D+03,0.240D+02,0.99480000D+00,0.00000000D+00
     .,0.29212570D+03,0.116D+03,0.250D+02,0.99480000D+00,0.00000000D+00
     .,0.22987760D+03,0.116D+03,0.260D+02,0.99480000D+00,0.00000000D+00
     .,0.24559880D+03,0.116D+03,0.270D+02,0.99480000D+00,0.00000000D+00
     .,0.25180970D+03,0.116D+03,0.280D+02,0.99480000D+00,0.00000000D+00
     .,0.19338650D+03,0.116D+03,0.290D+02,0.99480000D+00,0.00000000D+00
     .,0.20107040D+03,0.116D+03,0.300D+02,0.99480000D+00,0.00000000D+00
     .,0.23725630D+03,0.116D+03,0.310D+02,0.99480000D+00,0.00000000D+00
     .,0.21294370D+03,0.116D+03,0.320D+02,0.99480000D+00,0.00000000D+00
     .,0.18454670D+03,0.116D+03,0.330D+02,0.99480000D+00,0.00000000D+00
     .,0.16722640D+03,0.116D+03,0.340D+02,0.99480000D+00,0.00000000D+00
     .,0.14776790D+03,0.116D+03,0.350D+02,0.99480000D+00,0.00000000D+00
     .,0.12961230D+03,0.116D+03,0.360D+02,0.99480000D+00,0.00000000D+00
     .,0.59687630D+03,0.116D+03,0.370D+02,0.99480000D+00,0.00000000D+00
     .,0.53867240D+03,0.116D+03,0.380D+02,0.99480000D+00,0.00000000D+00
     .,0.47852040D+03,0.116D+03,0.390D+02,0.99480000D+00,0.00000000D+00
     .,0.43390360D+03,0.116D+03,0.400D+02,0.99480000D+00,0.00000000D+00
     .,0.39804190D+03,0.116D+03,0.410D+02,0.99480000D+00,0.00000000D+00
     .,0.31058610D+03,0.116D+03,0.420D+02,0.99480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29101:  29200)=(/
     . 0.34514340D+03,0.116D+03,0.430D+02,0.99480000D+00,0.00000000D+00
     .,0.26595280D+03,0.116D+03,0.440D+02,0.99480000D+00,0.00000000D+00
     .,0.29041460D+03,0.116D+03,0.450D+02,0.99480000D+00,0.00000000D+00
     .,0.27025240D+03,0.116D+03,0.460D+02,0.99480000D+00,0.00000000D+00
     .,0.22511810D+03,0.116D+03,0.470D+02,0.99480000D+00,0.00000000D+00
     .,0.23917840D+03,0.116D+03,0.480D+02,0.99480000D+00,0.00000000D+00
     .,0.29682140D+03,0.116D+03,0.490D+02,0.99480000D+00,0.00000000D+00
     .,0.27827870D+03,0.116D+03,0.500D+02,0.99480000D+00,0.00000000D+00
     .,0.25143440D+03,0.116D+03,0.510D+02,0.99480000D+00,0.00000000D+00
     .,0.23525190D+03,0.116D+03,0.520D+02,0.99480000D+00,0.00000000D+00
     .,0.21460020D+03,0.116D+03,0.530D+02,0.99480000D+00,0.00000000D+00
     .,0.19452370D+03,0.116D+03,0.540D+02,0.99480000D+00,0.00000000D+00
     .,0.72846530D+03,0.116D+03,0.550D+02,0.99480000D+00,0.00000000D+00
     .,0.68423530D+03,0.116D+03,0.560D+02,0.99480000D+00,0.00000000D+00
     .,0.60944200D+03,0.116D+03,0.570D+02,0.99480000D+00,0.00000000D+00
     .,0.29645810D+03,0.116D+03,0.580D+02,0.99480000D+00,0.27991000D+01
     .,0.60891190D+03,0.116D+03,0.590D+02,0.99480000D+00,0.00000000D+00
     .,0.58591340D+03,0.116D+03,0.600D+02,0.99480000D+00,0.00000000D+00
     .,0.57153970D+03,0.116D+03,0.610D+02,0.99480000D+00,0.00000000D+00
     .,0.55828160D+03,0.116D+03,0.620D+02,0.99480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29201:  29300)=(/
     . 0.54653950D+03,0.116D+03,0.630D+02,0.99480000D+00,0.00000000D+00
     .,0.43677850D+03,0.116D+03,0.640D+02,0.99480000D+00,0.00000000D+00
     .,0.48158940D+03,0.116D+03,0.650D+02,0.99480000D+00,0.00000000D+00
     .,0.46577580D+03,0.116D+03,0.660D+02,0.99480000D+00,0.00000000D+00
     .,0.49452850D+03,0.116D+03,0.670D+02,0.99480000D+00,0.00000000D+00
     .,0.48417910D+03,0.116D+03,0.680D+02,0.99480000D+00,0.00000000D+00
     .,0.47494430D+03,0.116D+03,0.690D+02,0.99480000D+00,0.00000000D+00
     .,0.46905670D+03,0.116D+03,0.700D+02,0.99480000D+00,0.00000000D+00
     .,0.39959520D+03,0.116D+03,0.710D+02,0.99480000D+00,0.00000000D+00
     .,0.39859150D+03,0.116D+03,0.720D+02,0.99480000D+00,0.00000000D+00
     .,0.36694770D+03,0.116D+03,0.730D+02,0.99480000D+00,0.00000000D+00
     .,0.31220810D+03,0.116D+03,0.740D+02,0.99480000D+00,0.00000000D+00
     .,0.31855560D+03,0.116D+03,0.750D+02,0.99480000D+00,0.00000000D+00
     .,0.29082630D+03,0.116D+03,0.760D+02,0.99480000D+00,0.00000000D+00
     .,0.26791140D+03,0.116D+03,0.770D+02,0.99480000D+00,0.00000000D+00
     .,0.22401000D+03,0.116D+03,0.780D+02,0.99480000D+00,0.00000000D+00
     .,0.20979980D+03,0.116D+03,0.790D+02,0.99480000D+00,0.00000000D+00
     .,0.21632530D+03,0.116D+03,0.800D+02,0.99480000D+00,0.00000000D+00
     .,0.30615090D+03,0.116D+03,0.810D+02,0.99480000D+00,0.00000000D+00
     .,0.30235050D+03,0.116D+03,0.820D+02,0.99480000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29301:  29400)=(/
     . 0.28117730D+03,0.116D+03,0.830D+02,0.99480000D+00,0.00000000D+00
     .,0.27007790D+03,0.116D+03,0.840D+02,0.99480000D+00,0.00000000D+00
     .,0.25135500D+03,0.116D+03,0.850D+02,0.99480000D+00,0.00000000D+00
     .,0.23212580D+03,0.116D+03,0.860D+02,0.99480000D+00,0.00000000D+00
     .,0.69553530D+03,0.116D+03,0.870D+02,0.99480000D+00,0.00000000D+00
     .,0.68165580D+03,0.116D+03,0.880D+02,0.99480000D+00,0.00000000D+00
     .,0.60993410D+03,0.116D+03,0.890D+02,0.99480000D+00,0.00000000D+00
     .,0.55624920D+03,0.116D+03,0.900D+02,0.99480000D+00,0.00000000D+00
     .,0.54849710D+03,0.116D+03,0.910D+02,0.99480000D+00,0.00000000D+00
     .,0.53125540D+03,0.116D+03,0.920D+02,0.99480000D+00,0.00000000D+00
     .,0.54187030D+03,0.116D+03,0.930D+02,0.99480000D+00,0.00000000D+00
     .,0.52557770D+03,0.116D+03,0.940D+02,0.99480000D+00,0.00000000D+00
     .,0.31412700D+02,0.116D+03,0.101D+03,0.99480000D+00,0.00000000D+00
     .,0.97084900D+02,0.116D+03,0.103D+03,0.99480000D+00,0.98650000D+00
     .,0.12475120D+03,0.116D+03,0.104D+03,0.99480000D+00,0.98080000D+00
     .,0.98113900D+02,0.116D+03,0.105D+03,0.99480000D+00,0.97060000D+00
     .,0.75203900D+02,0.116D+03,0.106D+03,0.99480000D+00,0.98680000D+00
     .,0.53208600D+02,0.116D+03,0.107D+03,0.99480000D+00,0.99440000D+00
     .,0.39268300D+02,0.116D+03,0.108D+03,0.99480000D+00,0.99250000D+00
     .,0.27411700D+02,0.116D+03,0.109D+03,0.99480000D+00,0.99820000D+00
     ./)
      grimme_c6_parameters(  29401:  29500)=(/
     . 0.14105990D+03,0.116D+03,0.111D+03,0.99480000D+00,0.96840000D+00
     .,0.21766290D+03,0.116D+03,0.112D+03,0.99480000D+00,0.96280000D+00
     .,0.22379420D+03,0.116D+03,0.113D+03,0.99480000D+00,0.96480000D+00
     .,0.18394830D+03,0.116D+03,0.114D+03,0.99480000D+00,0.95070000D+00
     .,0.15318230D+03,0.116D+03,0.115D+03,0.99480000D+00,0.99470000D+00
     .,0.13099650D+03,0.116D+03,0.116D+03,0.99480000D+00,0.99480000D+00
     .,0.16527300D+02,0.117D+03,0.100D+01,0.99720000D+00,0.91180000D+00
     .,0.11509200D+02,0.117D+03,0.200D+01,0.99720000D+00,0.00000000D+00
     .,0.20877430D+03,0.117D+03,0.300D+01,0.99720000D+00,0.00000000D+00
     .,0.13164980D+03,0.117D+03,0.400D+01,0.99720000D+00,0.00000000D+00
     .,0.93774300D+02,0.117D+03,0.500D+01,0.99720000D+00,0.00000000D+00
     .,0.66135400D+02,0.117D+03,0.600D+01,0.99720000D+00,0.00000000D+00
     .,0.47754000D+02,0.117D+03,0.700D+01,0.99720000D+00,0.00000000D+00
     .,0.36978300D+02,0.117D+03,0.800D+01,0.99720000D+00,0.00000000D+00
     .,0.28546800D+02,0.117D+03,0.900D+01,0.99720000D+00,0.00000000D+00
     .,0.22283200D+02,0.117D+03,0.100D+02,0.99720000D+00,0.00000000D+00
     .,0.25123260D+03,0.117D+03,0.110D+02,0.99720000D+00,0.00000000D+00
     .,0.20645210D+03,0.117D+03,0.120D+02,0.99720000D+00,0.00000000D+00
     .,0.19576470D+03,0.117D+03,0.130D+02,0.99720000D+00,0.00000000D+00
     .,0.16018790D+03,0.117D+03,0.140D+02,0.99720000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29501:  29600)=(/
     . 0.12909560D+03,0.117D+03,0.150D+02,0.99720000D+00,0.00000000D+00
     .,0.10952700D+03,0.117D+03,0.160D+02,0.99720000D+00,0.00000000D+00
     .,0.91366700D+02,0.117D+03,0.170D+02,0.99720000D+00,0.00000000D+00
     .,0.76125600D+02,0.117D+03,0.180D+02,0.99720000D+00,0.00000000D+00
     .,0.40951050D+03,0.117D+03,0.190D+02,0.99720000D+00,0.00000000D+00
     .,0.35409350D+03,0.117D+03,0.200D+02,0.99720000D+00,0.00000000D+00
     .,0.29590280D+03,0.117D+03,0.210D+02,0.99720000D+00,0.00000000D+00
     .,0.28935120D+03,0.117D+03,0.220D+02,0.99720000D+00,0.00000000D+00
     .,0.26685570D+03,0.117D+03,0.230D+02,0.99720000D+00,0.00000000D+00
     .,0.21129280D+03,0.117D+03,0.240D+02,0.99720000D+00,0.00000000D+00
     .,0.23214470D+03,0.117D+03,0.250D+02,0.99720000D+00,0.00000000D+00
     .,0.18336610D+03,0.117D+03,0.260D+02,0.99720000D+00,0.00000000D+00
     .,0.19637550D+03,0.117D+03,0.270D+02,0.99720000D+00,0.00000000D+00
     .,0.20075710D+03,0.117D+03,0.280D+02,0.99720000D+00,0.00000000D+00
     .,0.15477560D+03,0.117D+03,0.290D+02,0.99720000D+00,0.00000000D+00
     .,0.16173370D+03,0.117D+03,0.300D+02,0.99720000D+00,0.00000000D+00
     .,0.19011390D+03,0.117D+03,0.310D+02,0.99720000D+00,0.00000000D+00
     .,0.17239330D+03,0.117D+03,0.320D+02,0.99720000D+00,0.00000000D+00
     .,0.15099990D+03,0.117D+03,0.330D+02,0.99720000D+00,0.00000000D+00
     .,0.13784430D+03,0.117D+03,0.340D+02,0.99720000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29601:  29700)=(/
     . 0.12277630D+03,0.117D+03,0.350D+02,0.99720000D+00,0.00000000D+00
     .,0.10852260D+03,0.117D+03,0.360D+02,0.99720000D+00,0.00000000D+00
     .,0.46202520D+03,0.117D+03,0.370D+02,0.99720000D+00,0.00000000D+00
     .,0.42188670D+03,0.117D+03,0.380D+02,0.99720000D+00,0.00000000D+00
     .,0.37756420D+03,0.117D+03,0.390D+02,0.99720000D+00,0.00000000D+00
     .,0.34413180D+03,0.117D+03,0.400D+02,0.99720000D+00,0.00000000D+00
     .,0.31691100D+03,0.117D+03,0.410D+02,0.99720000D+00,0.00000000D+00
     .,0.24926710D+03,0.117D+03,0.420D+02,0.99720000D+00,0.00000000D+00
     .,0.27614550D+03,0.117D+03,0.430D+02,0.99720000D+00,0.00000000D+00
     .,0.21463800D+03,0.117D+03,0.440D+02,0.99720000D+00,0.00000000D+00
     .,0.23390310D+03,0.117D+03,0.450D+02,0.99720000D+00,0.00000000D+00
     .,0.21819030D+03,0.117D+03,0.460D+02,0.99720000D+00,0.00000000D+00
     .,0.18215470D+03,0.117D+03,0.470D+02,0.99720000D+00,0.00000000D+00
     .,0.19372730D+03,0.117D+03,0.480D+02,0.99720000D+00,0.00000000D+00
     .,0.23849880D+03,0.117D+03,0.490D+02,0.99720000D+00,0.00000000D+00
     .,0.22523810D+03,0.117D+03,0.500D+02,0.99720000D+00,0.00000000D+00
     .,0.20525120D+03,0.117D+03,0.510D+02,0.99720000D+00,0.00000000D+00
     .,0.19314490D+03,0.117D+03,0.520D+02,0.99720000D+00,0.00000000D+00
     .,0.17734580D+03,0.117D+03,0.530D+02,0.99720000D+00,0.00000000D+00
     .,0.16181190D+03,0.117D+03,0.540D+02,0.99720000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29701:  29800)=(/
     . 0.56460060D+03,0.117D+03,0.550D+02,0.99720000D+00,0.00000000D+00
     .,0.53526780D+03,0.117D+03,0.560D+02,0.99720000D+00,0.00000000D+00
     .,0.48012440D+03,0.117D+03,0.570D+02,0.99720000D+00,0.00000000D+00
     .,0.24192230D+03,0.117D+03,0.580D+02,0.99720000D+00,0.27991000D+01
     .,0.47771970D+03,0.117D+03,0.590D+02,0.99720000D+00,0.00000000D+00
     .,0.46012500D+03,0.117D+03,0.600D+02,0.99720000D+00,0.00000000D+00
     .,0.44895170D+03,0.117D+03,0.610D+02,0.99720000D+00,0.00000000D+00
     .,0.43862430D+03,0.117D+03,0.620D+02,0.99720000D+00,0.00000000D+00
     .,0.42948100D+03,0.117D+03,0.630D+02,0.99720000D+00,0.00000000D+00
     .,0.34664610D+03,0.117D+03,0.640D+02,0.99720000D+00,0.00000000D+00
     .,0.37839840D+03,0.117D+03,0.650D+02,0.99720000D+00,0.00000000D+00
     .,0.36651660D+03,0.117D+03,0.660D+02,0.99720000D+00,0.00000000D+00
     .,0.38919850D+03,0.117D+03,0.670D+02,0.99720000D+00,0.00000000D+00
     .,0.38108470D+03,0.117D+03,0.680D+02,0.99720000D+00,0.00000000D+00
     .,0.37388780D+03,0.117D+03,0.690D+02,0.99720000D+00,0.00000000D+00
     .,0.36907690D+03,0.117D+03,0.700D+02,0.99720000D+00,0.00000000D+00
     .,0.31653270D+03,0.117D+03,0.710D+02,0.99720000D+00,0.00000000D+00
     .,0.31792390D+03,0.117D+03,0.720D+02,0.99720000D+00,0.00000000D+00
     .,0.29429820D+03,0.117D+03,0.730D+02,0.99720000D+00,0.00000000D+00
     .,0.25196160D+03,0.117D+03,0.740D+02,0.99720000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29801:  29900)=(/
     . 0.25744470D+03,0.117D+03,0.750D+02,0.99720000D+00,0.00000000D+00
     .,0.23620650D+03,0.117D+03,0.760D+02,0.99720000D+00,0.00000000D+00
     .,0.21851340D+03,0.117D+03,0.770D+02,0.99720000D+00,0.00000000D+00
     .,0.18384350D+03,0.117D+03,0.780D+02,0.99720000D+00,0.00000000D+00
     .,0.17259550D+03,0.117D+03,0.790D+02,0.99720000D+00,0.00000000D+00
     .,0.17806050D+03,0.117D+03,0.800D+02,0.99720000D+00,0.00000000D+00
     .,0.24721900D+03,0.117D+03,0.810D+02,0.99720000D+00,0.00000000D+00
     .,0.24529500D+03,0.117D+03,0.820D+02,0.99720000D+00,0.00000000D+00
     .,0.22972670D+03,0.117D+03,0.830D+02,0.99720000D+00,0.00000000D+00
     .,0.22165670D+03,0.117D+03,0.840D+02,0.99720000D+00,0.00000000D+00
     .,0.20750080D+03,0.117D+03,0.850D+02,0.99720000D+00,0.00000000D+00
     .,0.19273160D+03,0.117D+03,0.860D+02,0.99720000D+00,0.00000000D+00
     .,0.54229530D+03,0.117D+03,0.870D+02,0.99720000D+00,0.00000000D+00
     .,0.53547060D+03,0.117D+03,0.880D+02,0.99720000D+00,0.00000000D+00
     .,0.48217720D+03,0.117D+03,0.890D+02,0.99720000D+00,0.00000000D+00
     .,0.44362620D+03,0.117D+03,0.900D+02,0.99720000D+00,0.00000000D+00
     .,0.43615260D+03,0.117D+03,0.910D+02,0.99720000D+00,0.00000000D+00
     .,0.42258040D+03,0.117D+03,0.920D+02,0.99720000D+00,0.00000000D+00
     .,0.42886190D+03,0.117D+03,0.930D+02,0.99720000D+00,0.00000000D+00
     .,0.41631150D+03,0.117D+03,0.940D+02,0.99720000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  29901:  30000)=(/
     . 0.25741400D+02,0.117D+03,0.101D+03,0.99720000D+00,0.00000000D+00
     .,0.77202300D+02,0.117D+03,0.103D+03,0.99720000D+00,0.98650000D+00
     .,0.99699500D+02,0.117D+03,0.104D+03,0.99720000D+00,0.98080000D+00
     .,0.79883300D+02,0.117D+03,0.105D+03,0.99720000D+00,0.97060000D+00
     .,0.62086400D+02,0.117D+03,0.106D+03,0.99720000D+00,0.98680000D+00
     .,0.44621700D+02,0.117D+03,0.107D+03,0.99720000D+00,0.99440000D+00
     .,0.33380100D+02,0.117D+03,0.108D+03,0.99720000D+00,0.99250000D+00
     .,0.23705900D+02,0.117D+03,0.109D+03,0.99720000D+00,0.99820000D+00
     .,0.11198290D+03,0.117D+03,0.111D+03,0.99720000D+00,0.96840000D+00
     .,0.17241480D+03,0.117D+03,0.112D+03,0.99720000D+00,0.96280000D+00
     .,0.17871270D+03,0.117D+03,0.113D+03,0.99720000D+00,0.96480000D+00
     .,0.14895590D+03,0.117D+03,0.114D+03,0.99720000D+00,0.95070000D+00
     .,0.12549300D+03,0.117D+03,0.115D+03,0.99720000D+00,0.99470000D+00
     .,0.10828930D+03,0.117D+03,0.116D+03,0.99720000D+00,0.99480000D+00
     .,0.90398500D+02,0.117D+03,0.117D+03,0.99720000D+00,0.99720000D+00
     .,0.29300000D+02,0.119D+03,0.100D+01,0.97670000D+00,0.91180000D+00
     .,0.18665500D+02,0.119D+03,0.200D+01,0.97670000D+00,0.00000000D+00
     .,0.56029540D+03,0.119D+03,0.300D+01,0.97670000D+00,0.00000000D+00
     .,0.29222240D+03,0.119D+03,0.400D+01,0.97670000D+00,0.00000000D+00
     .,0.18695660D+03,0.119D+03,0.500D+01,0.97670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30001:  30100)=(/
     . 0.12192920D+03,0.119D+03,0.600D+01,0.97670000D+00,0.00000000D+00
     .,0.83215300D+02,0.119D+03,0.700D+01,0.97670000D+00,0.00000000D+00
     .,0.61994800D+02,0.119D+03,0.800D+01,0.97670000D+00,0.00000000D+00
     .,0.46352000D+02,0.119D+03,0.900D+01,0.97670000D+00,0.00000000D+00
     .,0.35296900D+02,0.119D+03,0.100D+02,0.97670000D+00,0.00000000D+00
     .,0.66603570D+03,0.119D+03,0.110D+02,0.97670000D+00,0.00000000D+00
     .,0.47376610D+03,0.119D+03,0.120D+02,0.97670000D+00,0.00000000D+00
     .,0.42489260D+03,0.119D+03,0.130D+02,0.97670000D+00,0.00000000D+00
     .,0.32282330D+03,0.119D+03,0.140D+02,0.97670000D+00,0.00000000D+00
     .,0.24457290D+03,0.119D+03,0.150D+02,0.97670000D+00,0.00000000D+00
     .,0.19946720D+03,0.119D+03,0.160D+02,0.97670000D+00,0.00000000D+00
     .,0.16033040D+03,0.119D+03,0.170D+02,0.97670000D+00,0.00000000D+00
     .,0.12942830D+03,0.119D+03,0.180D+02,0.97670000D+00,0.00000000D+00
     .,0.11122277D+04,0.119D+03,0.190D+02,0.97670000D+00,0.00000000D+00
     .,0.86017710D+03,0.119D+03,0.200D+02,0.97670000D+00,0.00000000D+00
     .,0.70072810D+03,0.119D+03,0.210D+02,0.97670000D+00,0.00000000D+00
     .,0.66875460D+03,0.119D+03,0.220D+02,0.97670000D+00,0.00000000D+00
     .,0.60799510D+03,0.119D+03,0.230D+02,0.97670000D+00,0.00000000D+00
     .,0.47897440D+03,0.119D+03,0.240D+02,0.97670000D+00,0.00000000D+00
     .,0.51805830D+03,0.119D+03,0.250D+02,0.97670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30101:  30200)=(/
     . 0.40608760D+03,0.119D+03,0.260D+02,0.97670000D+00,0.00000000D+00
     .,0.42338090D+03,0.119D+03,0.270D+02,0.97670000D+00,0.00000000D+00
     .,0.43928450D+03,0.119D+03,0.280D+02,0.97670000D+00,0.00000000D+00
     .,0.33711170D+03,0.119D+03,0.290D+02,0.97670000D+00,0.00000000D+00
     .,0.33789860D+03,0.119D+03,0.300D+02,0.97670000D+00,0.00000000D+00
     .,0.40307450D+03,0.119D+03,0.310D+02,0.97670000D+00,0.00000000D+00
     .,0.34544340D+03,0.119D+03,0.320D+02,0.97670000D+00,0.00000000D+00
     .,0.28755350D+03,0.119D+03,0.330D+02,0.97670000D+00,0.00000000D+00
     .,0.25436700D+03,0.119D+03,0.340D+02,0.97670000D+00,0.00000000D+00
     .,0.21946470D+03,0.119D+03,0.350D+02,0.97670000D+00,0.00000000D+00
     .,0.18848190D+03,0.119D+03,0.360D+02,0.97670000D+00,0.00000000D+00
     .,0.12408631D+04,0.119D+03,0.370D+02,0.97670000D+00,0.00000000D+00
     .,0.10279671D+04,0.119D+03,0.380D+02,0.97670000D+00,0.00000000D+00
     .,0.87903460D+03,0.119D+03,0.390D+02,0.97670000D+00,0.00000000D+00
     .,0.77852380D+03,0.119D+03,0.400D+02,0.97670000D+00,0.00000000D+00
     .,0.70330600D+03,0.119D+03,0.410D+02,0.97670000D+00,0.00000000D+00
     .,0.53463030D+03,0.119D+03,0.420D+02,0.97670000D+00,0.00000000D+00
     .,0.59993020D+03,0.119D+03,0.430D+02,0.97670000D+00,0.00000000D+00
     .,0.44930300D+03,0.119D+03,0.440D+02,0.97670000D+00,0.00000000D+00
     .,0.49058070D+03,0.119D+03,0.450D+02,0.97670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30201:  30300)=(/
     . 0.45224640D+03,0.119D+03,0.460D+02,0.97670000D+00,0.00000000D+00
     .,0.37908360D+03,0.119D+03,0.470D+02,0.97670000D+00,0.00000000D+00
     .,0.39551350D+03,0.119D+03,0.480D+02,0.97670000D+00,0.00000000D+00
     .,0.50568380D+03,0.119D+03,0.490D+02,0.97670000D+00,0.00000000D+00
     .,0.45646130D+03,0.119D+03,0.500D+02,0.97670000D+00,0.00000000D+00
     .,0.39784160D+03,0.119D+03,0.510D+02,0.97670000D+00,0.00000000D+00
     .,0.36440900D+03,0.119D+03,0.520D+02,0.97670000D+00,0.00000000D+00
     .,0.32510680D+03,0.119D+03,0.530D+02,0.97670000D+00,0.00000000D+00
     .,0.28872750D+03,0.119D+03,0.540D+02,0.97670000D+00,0.00000000D+00
     .,0.15118898D+04,0.119D+03,0.550D+02,0.97670000D+00,0.00000000D+00
     .,0.13222619D+04,0.119D+03,0.560D+02,0.97670000D+00,0.00000000D+00
     .,0.11337749D+04,0.119D+03,0.570D+02,0.97670000D+00,0.00000000D+00
     .,0.47224550D+03,0.119D+03,0.580D+02,0.97670000D+00,0.27991000D+01
     .,0.11622835D+04,0.119D+03,0.590D+02,0.97670000D+00,0.00000000D+00
     .,0.11112638D+04,0.119D+03,0.600D+02,0.97670000D+00,0.00000000D+00
     .,0.10820865D+04,0.119D+03,0.610D+02,0.97670000D+00,0.00000000D+00
     .,0.10553891D+04,0.119D+03,0.620D+02,0.97670000D+00,0.00000000D+00
     .,0.10316716D+04,0.119D+03,0.630D+02,0.97670000D+00,0.00000000D+00
     .,0.79078540D+03,0.119D+03,0.640D+02,0.97670000D+00,0.00000000D+00
     .,0.92736720D+03,0.119D+03,0.650D+02,0.97670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30301:  30400)=(/
     . 0.89050560D+03,0.119D+03,0.660D+02,0.97670000D+00,0.00000000D+00
     .,0.92461970D+03,0.119D+03,0.670D+02,0.97670000D+00,0.00000000D+00
     .,0.90432570D+03,0.119D+03,0.680D+02,0.97670000D+00,0.00000000D+00
     .,0.88575380D+03,0.119D+03,0.690D+02,0.97670000D+00,0.00000000D+00
     .,0.87628990D+03,0.119D+03,0.700D+02,0.97670000D+00,0.00000000D+00
     .,0.72564410D+03,0.119D+03,0.710D+02,0.97670000D+00,0.00000000D+00
     .,0.69618310D+03,0.119D+03,0.720D+02,0.97670000D+00,0.00000000D+00
     .,0.62634420D+03,0.119D+03,0.730D+02,0.97670000D+00,0.00000000D+00
     .,0.52368920D+03,0.119D+03,0.740D+02,0.97670000D+00,0.00000000D+00
     .,0.52962490D+03,0.119D+03,0.750D+02,0.97670000D+00,0.00000000D+00
     .,0.47425390D+03,0.119D+03,0.760D+02,0.97670000D+00,0.00000000D+00
     .,0.43019640D+03,0.119D+03,0.770D+02,0.97670000D+00,0.00000000D+00
     .,0.35414110D+03,0.119D+03,0.780D+02,0.97670000D+00,0.00000000D+00
     .,0.32964710D+03,0.119D+03,0.790D+02,0.97670000D+00,0.00000000D+00
     .,0.33733350D+03,0.119D+03,0.800D+02,0.97670000D+00,0.00000000D+00
     .,0.51695330D+03,0.119D+03,0.810D+02,0.97670000D+00,0.00000000D+00
     .,0.49569810D+03,0.119D+03,0.820D+02,0.97670000D+00,0.00000000D+00
     .,0.44630330D+03,0.119D+03,0.830D+02,0.97670000D+00,0.00000000D+00
     .,0.42086840D+03,0.119D+03,0.840D+02,0.97670000D+00,0.00000000D+00
     .,0.38335330D+03,0.119D+03,0.850D+02,0.97670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30401:  30500)=(/
     . 0.34734370D+03,0.119D+03,0.860D+02,0.97670000D+00,0.00000000D+00
     .,0.14001686D+04,0.119D+03,0.870D+02,0.97670000D+00,0.00000000D+00
     .,0.12915073D+04,0.119D+03,0.880D+02,0.97670000D+00,0.00000000D+00
     .,0.11159288D+04,0.119D+03,0.890D+02,0.97670000D+00,0.00000000D+00
     .,0.97819280D+03,0.119D+03,0.900D+02,0.97670000D+00,0.00000000D+00
     .,0.98391310D+03,0.119D+03,0.910D+02,0.97670000D+00,0.00000000D+00
     .,0.95206270D+03,0.119D+03,0.920D+02,0.97670000D+00,0.00000000D+00
     .,0.99535270D+03,0.119D+03,0.930D+02,0.97670000D+00,0.00000000D+00
     .,0.96105430D+03,0.119D+03,0.940D+02,0.97670000D+00,0.00000000D+00
     .,0.48449900D+02,0.119D+03,0.101D+03,0.97670000D+00,0.00000000D+00
     .,0.16874120D+03,0.119D+03,0.103D+03,0.97670000D+00,0.98650000D+00
     .,0.21344440D+03,0.119D+03,0.104D+03,0.97670000D+00,0.98080000D+00
     .,0.15577810D+03,0.119D+03,0.105D+03,0.97670000D+00,0.97060000D+00
     .,0.11457230D+03,0.119D+03,0.106D+03,0.97670000D+00,0.98680000D+00
     .,0.77631700D+02,0.119D+03,0.107D+03,0.97670000D+00,0.99440000D+00
     .,0.55403200D+02,0.119D+03,0.108D+03,0.97670000D+00,0.99250000D+00
     .,0.37198200D+02,0.119D+03,0.109D+03,0.97670000D+00,0.99820000D+00
     .,0.24922000D+03,0.119D+03,0.111D+03,0.97670000D+00,0.96840000D+00
     .,0.38733490D+03,0.119D+03,0.112D+03,0.97670000D+00,0.96280000D+00
     .,0.38264220D+03,0.119D+03,0.113D+03,0.97670000D+00,0.96480000D+00
     ./)
      grimme_c6_parameters(  30501:  30600)=(/
     . 0.29694090D+03,0.119D+03,0.114D+03,0.97670000D+00,0.95070000D+00
     .,0.23721910D+03,0.119D+03,0.115D+03,0.97670000D+00,0.99470000D+00
     .,0.19738060D+03,0.119D+03,0.116D+03,0.97670000D+00,0.99480000D+00
     .,0.15873300D+03,0.119D+03,0.117D+03,0.97670000D+00,0.99720000D+00
     .,0.33802070D+03,0.119D+03,0.119D+03,0.97670000D+00,0.97670000D+00
     .,0.52987100D+02,0.120D+03,0.100D+01,0.98310000D+00,0.91180000D+00
     .,0.31879600D+02,0.120D+03,0.200D+01,0.98310000D+00,0.00000000D+00
     .,0.13100314D+04,0.120D+03,0.300D+01,0.98310000D+00,0.00000000D+00
     .,0.60256610D+03,0.120D+03,0.400D+01,0.98310000D+00,0.00000000D+00
     .,0.36268620D+03,0.120D+03,0.500D+01,0.98310000D+00,0.00000000D+00
     .,0.22596290D+03,0.120D+03,0.600D+01,0.98310000D+00,0.00000000D+00
     .,0.14897930D+03,0.120D+03,0.700D+01,0.98310000D+00,0.00000000D+00
     .,0.10827180D+03,0.120D+03,0.800D+01,0.98310000D+00,0.00000000D+00
     .,0.79221800D+02,0.120D+03,0.900D+01,0.98310000D+00,0.00000000D+00
     .,0.59277900D+02,0.120D+03,0.100D+02,0.98310000D+00,0.00000000D+00
     .,0.15457064D+04,0.120D+03,0.110D+02,0.98310000D+00,0.00000000D+00
     .,0.99724860D+03,0.120D+03,0.120D+02,0.98310000D+00,0.00000000D+00
     .,0.86695170D+03,0.120D+03,0.130D+02,0.98310000D+00,0.00000000D+00
     .,0.63004560D+03,0.120D+03,0.140D+02,0.98310000D+00,0.00000000D+00
     .,0.46026350D+03,0.120D+03,0.150D+02,0.98310000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30601:  30700)=(/
     . 0.36677110D+03,0.120D+03,0.160D+02,0.98310000D+00,0.00000000D+00
     .,0.28821820D+03,0.120D+03,0.170D+02,0.98310000D+00,0.00000000D+00
     .,0.22808920D+03,0.120D+03,0.180D+02,0.98310000D+00,0.00000000D+00
     .,0.26610830D+04,0.120D+03,0.190D+02,0.98310000D+00,0.00000000D+00
     .,0.18864221D+04,0.120D+03,0.200D+02,0.98310000D+00,0.00000000D+00
     .,0.15101427D+04,0.120D+03,0.210D+02,0.98310000D+00,0.00000000D+00
     .,0.14223244D+04,0.120D+03,0.220D+02,0.98310000D+00,0.00000000D+00
     .,0.12821610D+04,0.120D+03,0.230D+02,0.98310000D+00,0.00000000D+00
     .,0.10115955D+04,0.120D+03,0.240D+02,0.98310000D+00,0.00000000D+00
     .,0.10791532D+04,0.120D+03,0.250D+02,0.98310000D+00,0.00000000D+00
     .,0.84546860D+03,0.120D+03,0.260D+02,0.98310000D+00,0.00000000D+00
     .,0.86250360D+03,0.120D+03,0.270D+02,0.98310000D+00,0.00000000D+00
     .,0.90260140D+03,0.120D+03,0.280D+02,0.98310000D+00,0.00000000D+00
     .,0.69450580D+03,0.120D+03,0.290D+02,0.98310000D+00,0.00000000D+00
     .,0.67502990D+03,0.120D+03,0.300D+02,0.98310000D+00,0.00000000D+00
     .,0.81349430D+03,0.120D+03,0.310D+02,0.98310000D+00,0.00000000D+00
     .,0.67269170D+03,0.120D+03,0.320D+02,0.98310000D+00,0.00000000D+00
     .,0.54301230D+03,0.120D+03,0.330D+02,0.98310000D+00,0.00000000D+00
     .,0.47148220D+03,0.120D+03,0.340D+02,0.98310000D+00,0.00000000D+00
     .,0.39902260D+03,0.120D+03,0.350D+02,0.98310000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30701:  30800)=(/
     . 0.33664830D+03,0.120D+03,0.360D+02,0.98310000D+00,0.00000000D+00
     .,0.29580410D+04,0.120D+03,0.370D+02,0.98310000D+00,0.00000000D+00
     .,0.22654155D+04,0.120D+03,0.380D+02,0.98310000D+00,0.00000000D+00
     .,0.18821338D+04,0.120D+03,0.390D+02,0.98310000D+00,0.00000000D+00
     .,0.16379667D+04,0.120D+03,0.400D+02,0.98310000D+00,0.00000000D+00
     .,0.14638890D+04,0.120D+03,0.410D+02,0.98310000D+00,0.00000000D+00
     .,0.10926733D+04,0.120D+03,0.420D+02,0.98310000D+00,0.00000000D+00
     .,0.12349316D+04,0.120D+03,0.430D+02,0.98310000D+00,0.00000000D+00
     .,0.90575150D+03,0.120D+03,0.440D+02,0.98310000D+00,0.00000000D+00
     .,0.98637270D+03,0.120D+03,0.450D+02,0.98310000D+00,0.00000000D+00
     .,0.90244050D+03,0.120D+03,0.460D+02,0.98310000D+00,0.00000000D+00
     .,0.76261740D+03,0.120D+03,0.470D+02,0.98310000D+00,0.00000000D+00
     .,0.78166000D+03,0.120D+03,0.480D+02,0.98310000D+00,0.00000000D+00
     .,0.10241614D+04,0.120D+03,0.490D+02,0.98310000D+00,0.00000000D+00
     .,0.89641550D+03,0.120D+03,0.500D+02,0.98310000D+00,0.00000000D+00
     .,0.75979880D+03,0.120D+03,0.510D+02,0.98310000D+00,0.00000000D+00
     .,0.68470730D+03,0.120D+03,0.520D+02,0.98310000D+00,0.00000000D+00
     .,0.60026980D+03,0.120D+03,0.530D+02,0.98310000D+00,0.00000000D+00
     .,0.52435470D+03,0.120D+03,0.540D+02,0.98310000D+00,0.00000000D+00
     .,0.36192660D+04,0.120D+03,0.550D+02,0.98310000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30801:  30900)=(/
     . 0.29513362D+04,0.120D+03,0.560D+02,0.98310000D+00,0.00000000D+00
     .,0.24567601D+04,0.120D+03,0.570D+02,0.98310000D+00,0.00000000D+00
     .,0.90740120D+03,0.120D+03,0.580D+02,0.98310000D+00,0.27991000D+01
     .,0.25715319D+04,0.120D+03,0.590D+02,0.98310000D+00,0.00000000D+00
     .,0.24420495D+04,0.120D+03,0.600D+02,0.98310000D+00,0.00000000D+00
     .,0.23740445D+04,0.120D+03,0.610D+02,0.98310000D+00,0.00000000D+00
     .,0.23122147D+04,0.120D+03,0.620D+02,0.98310000D+00,0.00000000D+00
     .,0.22571993D+04,0.120D+03,0.630D+02,0.98310000D+00,0.00000000D+00
     .,0.16806338D+04,0.120D+03,0.640D+02,0.98310000D+00,0.00000000D+00
     .,0.20816173D+04,0.120D+03,0.650D+02,0.98310000D+00,0.00000000D+00
     .,0.19928728D+04,0.120D+03,0.660D+02,0.98310000D+00,0.00000000D+00
     .,0.20062958D+04,0.120D+03,0.670D+02,0.98310000D+00,0.00000000D+00
     .,0.19602391D+04,0.120D+03,0.680D+02,0.98310000D+00,0.00000000D+00
     .,0.19174640D+04,0.120D+03,0.690D+02,0.98310000D+00,0.00000000D+00
     .,0.18991306D+04,0.120D+03,0.700D+02,0.98310000D+00,0.00000000D+00
     .,0.15446852D+04,0.120D+03,0.710D+02,0.98310000D+00,0.00000000D+00
     .,0.14351503D+04,0.120D+03,0.720D+02,0.98310000D+00,0.00000000D+00
     .,0.12687518D+04,0.120D+03,0.730D+02,0.98310000D+00,0.00000000D+00
     .,0.10493296D+04,0.120D+03,0.740D+02,0.98310000D+00,0.00000000D+00
     .,0.10529922D+04,0.120D+03,0.750D+02,0.98310000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  30901:  31000)=(/
     . 0.92845210D+03,0.120D+03,0.760D+02,0.98310000D+00,0.00000000D+00
     .,0.83187520D+03,0.120D+03,0.770D+02,0.98310000D+00,0.00000000D+00
     .,0.67699020D+03,0.120D+03,0.780D+02,0.98310000D+00,0.00000000D+00
     .,0.62708530D+03,0.120D+03,0.790D+02,0.98310000D+00,0.00000000D+00
     .,0.63711120D+03,0.120D+03,0.800D+02,0.98310000D+00,0.00000000D+00
     .,0.10430556D+04,0.120D+03,0.810D+02,0.98310000D+00,0.00000000D+00
     .,0.97428450D+03,0.120D+03,0.820D+02,0.98310000D+00,0.00000000D+00
     .,0.85466400D+03,0.120D+03,0.830D+02,0.98310000D+00,0.00000000D+00
     .,0.79444910D+03,0.120D+03,0.840D+02,0.98310000D+00,0.00000000D+00
     .,0.71141430D+03,0.120D+03,0.850D+02,0.98310000D+00,0.00000000D+00
     .,0.63479210D+03,0.120D+03,0.860D+02,0.98310000D+00,0.00000000D+00
     .,0.32712563D+04,0.120D+03,0.870D+02,0.98310000D+00,0.00000000D+00
     .,0.28409447D+04,0.120D+03,0.880D+02,0.98310000D+00,0.00000000D+00
     .,0.23867637D+04,0.120D+03,0.890D+02,0.98310000D+00,0.00000000D+00
     .,0.20296245D+04,0.120D+03,0.900D+02,0.98310000D+00,0.00000000D+00
     .,0.20761172D+04,0.120D+03,0.910D+02,0.98310000D+00,0.00000000D+00
     .,0.20066915D+04,0.120D+03,0.920D+02,0.98310000D+00,0.00000000D+00
     .,0.21352269D+04,0.120D+03,0.930D+02,0.98310000D+00,0.00000000D+00
     .,0.20540131D+04,0.120D+03,0.940D+02,0.98310000D+00,0.00000000D+00
     .,0.90792700D+02,0.120D+03,0.101D+03,0.98310000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  31001:  31100)=(/
     . 0.34561200D+03,0.120D+03,0.103D+03,0.98310000D+00,0.98650000D+00
     .,0.43402840D+03,0.120D+03,0.104D+03,0.98310000D+00,0.98080000D+00
     .,0.29872640D+03,0.120D+03,0.105D+03,0.98310000D+00,0.97060000D+00
     .,0.21289570D+03,0.120D+03,0.106D+03,0.98310000D+00,0.98680000D+00
     .,0.13902190D+03,0.120D+03,0.107D+03,0.98310000D+00,0.99440000D+00
     .,0.96158400D+02,0.120D+03,0.108D+03,0.98310000D+00,0.99250000D+00
     .,0.62058000D+02,0.120D+03,0.109D+03,0.98310000D+00,0.99820000D+00
     .,0.51669170D+03,0.120D+03,0.111D+03,0.98310000D+00,0.96840000D+00
     .,0.80921820D+03,0.120D+03,0.112D+03,0.98310000D+00,0.96280000D+00
     .,0.77508320D+03,0.120D+03,0.113D+03,0.98310000D+00,0.96480000D+00
     .,0.57629620D+03,0.120D+03,0.114D+03,0.98310000D+00,0.95070000D+00
     .,0.44601700D+03,0.120D+03,0.115D+03,0.98310000D+00,0.99470000D+00
     .,0.36319510D+03,0.120D+03,0.116D+03,0.98310000D+00,0.99480000D+00
     .,0.28549050D+03,0.120D+03,0.117D+03,0.98310000D+00,0.99720000D+00
     .,0.68899110D+03,0.120D+03,0.119D+03,0.98310000D+00,0.97670000D+00
     .,0.15251891D+04,0.120D+03,0.120D+03,0.98310000D+00,0.98310000D+00
     .,0.29995300D+02,0.121D+03,0.100D+01,0.18627000D+01,0.91180000D+00
     .,0.19384100D+02,0.121D+03,0.200D+01,0.18627000D+01,0.00000000D+00
     .,0.50482680D+03,0.121D+03,0.300D+01,0.18627000D+01,0.00000000D+00
     .,0.28244200D+03,0.121D+03,0.400D+01,0.18627000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31101:  31200)=(/
     . 0.18614190D+03,0.121D+03,0.500D+01,0.18627000D+01,0.00000000D+00
     .,0.12363790D+03,0.121D+03,0.600D+01,0.18627000D+01,0.00000000D+00
     .,0.85340400D+02,0.121D+03,0.700D+01,0.18627000D+01,0.00000000D+00
     .,0.64007200D+02,0.121D+03,0.800D+01,0.18627000D+01,0.00000000D+00
     .,0.48093600D+02,0.121D+03,0.900D+01,0.18627000D+01,0.00000000D+00
     .,0.36746800D+02,0.121D+03,0.100D+02,0.18627000D+01,0.00000000D+00
     .,0.60249290D+03,0.121D+03,0.110D+02,0.18627000D+01,0.00000000D+00
     .,0.45276000D+03,0.121D+03,0.120D+02,0.18627000D+01,0.00000000D+00
     .,0.41290580D+03,0.121D+03,0.130D+02,0.18627000D+01,0.00000000D+00
     .,0.32058960D+03,0.121D+03,0.140D+02,0.18627000D+01,0.00000000D+00
     .,0.24673580D+03,0.121D+03,0.150D+02,0.18627000D+01,0.00000000D+00
     .,0.20296720D+03,0.121D+03,0.160D+02,0.18627000D+01,0.00000000D+00
     .,0.16436550D+03,0.121D+03,0.170D+02,0.18627000D+01,0.00000000D+00
     .,0.13344040D+03,0.121D+03,0.180D+02,0.18627000D+01,0.00000000D+00
     .,0.98858810D+03,0.121D+03,0.190D+02,0.18627000D+01,0.00000000D+00
     .,0.80323800D+03,0.121D+03,0.200D+02,0.18627000D+01,0.00000000D+00
     .,0.66067800D+03,0.121D+03,0.210D+02,0.18627000D+01,0.00000000D+00
     .,0.63504570D+03,0.121D+03,0.220D+02,0.18627000D+01,0.00000000D+00
     .,0.57995840D+03,0.121D+03,0.230D+02,0.18627000D+01,0.00000000D+00
     .,0.45620230D+03,0.121D+03,0.240D+02,0.18627000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31201:  31300)=(/
     . 0.49734740D+03,0.121D+03,0.250D+02,0.18627000D+01,0.00000000D+00
     .,0.38959740D+03,0.121D+03,0.260D+02,0.18627000D+01,0.00000000D+00
     .,0.41105720D+03,0.121D+03,0.270D+02,0.18627000D+01,0.00000000D+00
     .,0.42466930D+03,0.121D+03,0.280D+02,0.18627000D+01,0.00000000D+00
     .,0.32508500D+03,0.121D+03,0.290D+02,0.18627000D+01,0.00000000D+00
     .,0.33123100D+03,0.121D+03,0.300D+02,0.18627000D+01,0.00000000D+00
     .,0.39353000D+03,0.121D+03,0.310D+02,0.18627000D+01,0.00000000D+00
     .,0.34316790D+03,0.121D+03,0.320D+02,0.18627000D+01,0.00000000D+00
     .,0.28955820D+03,0.121D+03,0.330D+02,0.18627000D+01,0.00000000D+00
     .,0.25800840D+03,0.121D+03,0.340D+02,0.18627000D+01,0.00000000D+00
     .,0.22413750D+03,0.121D+03,0.350D+02,0.18627000D+01,0.00000000D+00
     .,0.19358680D+03,0.121D+03,0.360D+02,0.18627000D+01,0.00000000D+00
     .,0.11054608D+04,0.121D+03,0.370D+02,0.18627000D+01,0.00000000D+00
     .,0.95722710D+03,0.121D+03,0.380D+02,0.18627000D+01,0.00000000D+00
     .,0.83166790D+03,0.121D+03,0.390D+02,0.18627000D+01,0.00000000D+00
     .,0.74343180D+03,0.121D+03,0.400D+02,0.18627000D+01,0.00000000D+00
     .,0.67533140D+03,0.121D+03,0.410D+02,0.18627000D+01,0.00000000D+00
     .,0.51773400D+03,0.121D+03,0.420D+02,0.18627000D+01,0.00000000D+00
     .,0.57916230D+03,0.121D+03,0.430D+02,0.18627000D+01,0.00000000D+00
     .,0.43784320D+03,0.121D+03,0.440D+02,0.18627000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31301:  31400)=(/
     . 0.47895980D+03,0.121D+03,0.450D+02,0.18627000D+01,0.00000000D+00
     .,0.44308160D+03,0.121D+03,0.460D+02,0.18627000D+01,0.00000000D+00
     .,0.36949330D+03,0.121D+03,0.470D+02,0.18627000D+01,0.00000000D+00
     .,0.38918590D+03,0.121D+03,0.480D+02,0.18627000D+01,0.00000000D+00
     .,0.49219040D+03,0.121D+03,0.490D+02,0.18627000D+01,0.00000000D+00
     .,0.45113400D+03,0.121D+03,0.500D+02,0.18627000D+01,0.00000000D+00
     .,0.39831520D+03,0.121D+03,0.510D+02,0.18627000D+01,0.00000000D+00
     .,0.36739080D+03,0.121D+03,0.520D+02,0.18627000D+01,0.00000000D+00
     .,0.33004180D+03,0.121D+03,0.530D+02,0.18627000D+01,0.00000000D+00
     .,0.29487060D+03,0.121D+03,0.540D+02,0.18627000D+01,0.00000000D+00
     .,0.13445274D+04,0.121D+03,0.550D+02,0.18627000D+01,0.00000000D+00
     .,0.12227426D+04,0.121D+03,0.560D+02,0.18627000D+01,0.00000000D+00
     .,0.10658140D+04,0.121D+03,0.570D+02,0.18627000D+01,0.00000000D+00
     .,0.47118540D+03,0.121D+03,0.580D+02,0.18627000D+01,0.27991000D+01
     .,0.10799647D+04,0.121D+03,0.590D+02,0.18627000D+01,0.00000000D+00
     .,0.10362055D+04,0.121D+03,0.600D+02,0.18627000D+01,0.00000000D+00
     .,0.10098893D+04,0.121D+03,0.610D+02,0.18627000D+01,0.00000000D+00
     .,0.98572640D+03,0.121D+03,0.620D+02,0.18627000D+01,0.00000000D+00
     .,0.96428550D+03,0.121D+03,0.630D+02,0.18627000D+01,0.00000000D+00
     .,0.75078480D+03,0.121D+03,0.640D+02,0.18627000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31401:  31500)=(/
     . 0.85514710D+03,0.121D+03,0.650D+02,0.18627000D+01,0.00000000D+00
     .,0.82284200D+03,0.121D+03,0.660D+02,0.18627000D+01,0.00000000D+00
     .,0.86811040D+03,0.121D+03,0.670D+02,0.18627000D+01,0.00000000D+00
     .,0.84953940D+03,0.121D+03,0.680D+02,0.18627000D+01,0.00000000D+00
     .,0.83269610D+03,0.121D+03,0.690D+02,0.18627000D+01,0.00000000D+00
     .,0.82330890D+03,0.121D+03,0.700D+02,0.18627000D+01,0.00000000D+00
     .,0.68862420D+03,0.121D+03,0.710D+02,0.18627000D+01,0.00000000D+00
     .,0.67192580D+03,0.121D+03,0.720D+02,0.18627000D+01,0.00000000D+00
     .,0.60975150D+03,0.121D+03,0.730D+02,0.18627000D+01,0.00000000D+00
     .,0.51221050D+03,0.121D+03,0.740D+02,0.18627000D+01,0.00000000D+00
     .,0.52005780D+03,0.121D+03,0.750D+02,0.18627000D+01,0.00000000D+00
     .,0.46895650D+03,0.121D+03,0.760D+02,0.18627000D+01,0.00000000D+00
     .,0.42768450D+03,0.121D+03,0.770D+02,0.18627000D+01,0.00000000D+00
     .,0.35348450D+03,0.121D+03,0.780D+02,0.18627000D+01,0.00000000D+00
     .,0.32959850D+03,0.121D+03,0.790D+02,0.18627000D+01,0.00000000D+00
     .,0.33854780D+03,0.121D+03,0.800D+02,0.18627000D+01,0.00000000D+00
     .,0.50363930D+03,0.121D+03,0.810D+02,0.18627000D+01,0.00000000D+00
     .,0.48925410D+03,0.121D+03,0.820D+02,0.18627000D+01,0.00000000D+00
     .,0.44592310D+03,0.121D+03,0.830D+02,0.18627000D+01,0.00000000D+00
     .,0.42320630D+03,0.121D+03,0.840D+02,0.18627000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31501:  31600)=(/
     . 0.38821220D+03,0.121D+03,0.850D+02,0.18627000D+01,0.00000000D+00
     .,0.35380050D+03,0.121D+03,0.860D+02,0.18627000D+01,0.00000000D+00
     .,0.12630191D+04,0.121D+03,0.870D+02,0.18627000D+01,0.00000000D+00
     .,0.12039859D+04,0.121D+03,0.880D+02,0.18627000D+01,0.00000000D+00
     .,0.10563541D+04,0.121D+03,0.890D+02,0.18627000D+01,0.00000000D+00
     .,0.94062410D+03,0.121D+03,0.900D+02,0.18627000D+01,0.00000000D+00
     .,0.93765790D+03,0.121D+03,0.910D+02,0.18627000D+01,0.00000000D+00
     .,0.90769560D+03,0.121D+03,0.920D+02,0.18627000D+01,0.00000000D+00
     .,0.93986910D+03,0.121D+03,0.930D+02,0.18627000D+01,0.00000000D+00
     .,0.90928950D+03,0.121D+03,0.940D+02,0.18627000D+01,0.00000000D+00
     .,0.48975300D+02,0.121D+03,0.101D+03,0.18627000D+01,0.00000000D+00
     .,0.16364460D+03,0.121D+03,0.103D+03,0.18627000D+01,0.98650000D+00
     .,0.20781070D+03,0.121D+03,0.104D+03,0.18627000D+01,0.98080000D+00
     .,0.15582280D+03,0.121D+03,0.105D+03,0.18627000D+01,0.97060000D+00
     .,0.11597260D+03,0.121D+03,0.106D+03,0.18627000D+01,0.98680000D+00
     .,0.79538300D+02,0.121D+03,0.107D+03,0.18627000D+01,0.99440000D+00
     .,0.57261100D+02,0.121D+03,0.108D+03,0.18627000D+01,0.99250000D+00
     .,0.38809700D+02,0.121D+03,0.109D+03,0.18627000D+01,0.99820000D+00
     .,0.23997140D+03,0.121D+03,0.111D+03,0.18627000D+01,0.96840000D+00
     .,0.37177680D+03,0.121D+03,0.112D+03,0.18627000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters(  31601:  31700)=(/
     . 0.37318450D+03,0.121D+03,0.113D+03,0.18627000D+01,0.96480000D+00
     .,0.29561010D+03,0.121D+03,0.114D+03,0.18627000D+01,0.95070000D+00
     .,0.23937010D+03,0.121D+03,0.115D+03,0.18627000D+01,0.99470000D+00
     .,0.20076220D+03,0.121D+03,0.116D+03,0.18627000D+01,0.99480000D+00
     .,0.16268060D+03,0.121D+03,0.117D+03,0.18627000D+01,0.99720000D+00
     .,0.32770920D+03,0.121D+03,0.119D+03,0.18627000D+01,0.97670000D+00
     .,0.64070760D+03,0.121D+03,0.120D+03,0.18627000D+01,0.98310000D+00
     .,0.32450680D+03,0.121D+03,0.121D+03,0.18627000D+01,0.18627000D+01
     .,0.29000900D+02,0.122D+03,0.100D+01,0.18299000D+01,0.91180000D+00
     .,0.18808400D+02,0.122D+03,0.200D+01,0.18299000D+01,0.00000000D+00
     .,0.48829310D+03,0.122D+03,0.300D+01,0.18299000D+01,0.00000000D+00
     .,0.27202010D+03,0.122D+03,0.400D+01,0.18299000D+01,0.00000000D+00
     .,0.17950770D+03,0.122D+03,0.500D+01,0.18299000D+01,0.00000000D+00
     .,0.11943760D+03,0.122D+03,0.600D+01,0.18299000D+01,0.00000000D+00
     .,0.82583400D+02,0.122D+03,0.700D+01,0.18299000D+01,0.00000000D+00
     .,0.62030900D+02,0.122D+03,0.800D+01,0.18299000D+01,0.00000000D+00
     .,0.46676500D+02,0.122D+03,0.900D+01,0.18299000D+01,0.00000000D+00
     .,0.35711700D+02,0.122D+03,0.100D+02,0.18299000D+01,0.00000000D+00
     .,0.58252700D+03,0.122D+03,0.110D+02,0.18299000D+01,0.00000000D+00
     .,0.43610910D+03,0.122D+03,0.120D+02,0.18299000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31701:  31800)=(/
     . 0.39786180D+03,0.122D+03,0.130D+02,0.18299000D+01,0.00000000D+00
     .,0.30910810D+03,0.122D+03,0.140D+02,0.18299000D+01,0.00000000D+00
     .,0.23816440D+03,0.122D+03,0.150D+02,0.18299000D+01,0.00000000D+00
     .,0.19611280D+03,0.122D+03,0.160D+02,0.18299000D+01,0.00000000D+00
     .,0.15898920D+03,0.122D+03,0.170D+02,0.18299000D+01,0.00000000D+00
     .,0.12921800D+03,0.122D+03,0.180D+02,0.18299000D+01,0.00000000D+00
     .,0.96033760D+03,0.122D+03,0.190D+02,0.18299000D+01,0.00000000D+00
     .,0.77468630D+03,0.122D+03,0.200D+02,0.18299000D+01,0.00000000D+00
     .,0.63687060D+03,0.122D+03,0.210D+02,0.18299000D+01,0.00000000D+00
     .,0.61222250D+03,0.122D+03,0.220D+02,0.18299000D+01,0.00000000D+00
     .,0.55911570D+03,0.122D+03,0.230D+02,0.18299000D+01,0.00000000D+00
     .,0.44007620D+03,0.122D+03,0.240D+02,0.18299000D+01,0.00000000D+00
     .,0.47949690D+03,0.122D+03,0.250D+02,0.18299000D+01,0.00000000D+00
     .,0.37582420D+03,0.122D+03,0.260D+02,0.18299000D+01,0.00000000D+00
     .,0.39627480D+03,0.122D+03,0.270D+02,0.18299000D+01,0.00000000D+00
     .,0.40935550D+03,0.122D+03,0.280D+02,0.18299000D+01,0.00000000D+00
     .,0.31360260D+03,0.122D+03,0.290D+02,0.18299000D+01,0.00000000D+00
     .,0.31938340D+03,0.122D+03,0.300D+02,0.18299000D+01,0.00000000D+00
     .,0.37941090D+03,0.122D+03,0.310D+02,0.18299000D+01,0.00000000D+00
     .,0.33097100D+03,0.122D+03,0.320D+02,0.18299000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31801:  31900)=(/
     . 0.27949900D+03,0.122D+03,0.330D+02,0.18299000D+01,0.00000000D+00
     .,0.24922580D+03,0.122D+03,0.340D+02,0.18299000D+01,0.00000000D+00
     .,0.21669210D+03,0.122D+03,0.350D+02,0.18299000D+01,0.00000000D+00
     .,0.18732310D+03,0.122D+03,0.360D+02,0.18299000D+01,0.00000000D+00
     .,0.10741973D+04,0.122D+03,0.370D+02,0.18299000D+01,0.00000000D+00
     .,0.92365570D+03,0.122D+03,0.380D+02,0.18299000D+01,0.00000000D+00
     .,0.80203240D+03,0.122D+03,0.390D+02,0.18299000D+01,0.00000000D+00
     .,0.71686090D+03,0.122D+03,0.400D+02,0.18299000D+01,0.00000000D+00
     .,0.65128470D+03,0.122D+03,0.410D+02,0.18299000D+01,0.00000000D+00
     .,0.49950110D+03,0.122D+03,0.420D+02,0.18299000D+01,0.00000000D+00
     .,0.55872110D+03,0.122D+03,0.430D+02,0.18299000D+01,0.00000000D+00
     .,0.42257080D+03,0.122D+03,0.440D+02,0.18299000D+01,0.00000000D+00
     .,0.46203140D+03,0.122D+03,0.450D+02,0.18299000D+01,0.00000000D+00
     .,0.42745770D+03,0.122D+03,0.460D+02,0.18299000D+01,0.00000000D+00
     .,0.35672450D+03,0.122D+03,0.470D+02,0.18299000D+01,0.00000000D+00
     .,0.37552610D+03,0.122D+03,0.480D+02,0.18299000D+01,0.00000000D+00
     .,0.47481120D+03,0.122D+03,0.490D+02,0.18299000D+01,0.00000000D+00
     .,0.43519480D+03,0.122D+03,0.500D+02,0.18299000D+01,0.00000000D+00
     .,0.38444870D+03,0.122D+03,0.510D+02,0.18299000D+01,0.00000000D+00
     .,0.35477930D+03,0.122D+03,0.520D+02,0.18299000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  31901:  32000)=(/
     . 0.31891710D+03,0.122D+03,0.530D+02,0.18299000D+01,0.00000000D+00
     .,0.28513250D+03,0.122D+03,0.540D+02,0.18299000D+01,0.00000000D+00
     .,0.13086418D+04,0.122D+03,0.550D+02,0.18299000D+01,0.00000000D+00
     .,0.11809424D+04,0.122D+03,0.560D+02,0.18299000D+01,0.00000000D+00
     .,0.10284169D+04,0.122D+03,0.570D+02,0.18299000D+01,0.00000000D+00
     .,0.45482000D+03,0.122D+03,0.580D+02,0.18299000D+01,0.27991000D+01
     .,0.10433187D+04,0.122D+03,0.590D+02,0.18299000D+01,0.00000000D+00
     .,0.10002155D+04,0.122D+03,0.600D+02,0.18299000D+01,0.00000000D+00
     .,0.97472270D+03,0.122D+03,0.610D+02,0.18299000D+01,0.00000000D+00
     .,0.95132570D+03,0.122D+03,0.620D+02,0.18299000D+01,0.00000000D+00
     .,0.93056540D+03,0.122D+03,0.630D+02,0.18299000D+01,0.00000000D+00
     .,0.72458860D+03,0.122D+03,0.640D+02,0.18299000D+01,0.00000000D+00
     .,0.82779700D+03,0.122D+03,0.650D+02,0.18299000D+01,0.00000000D+00
     .,0.79723640D+03,0.122D+03,0.660D+02,0.18299000D+01,0.00000000D+00
     .,0.83746180D+03,0.122D+03,0.670D+02,0.18299000D+01,0.00000000D+00
     .,0.81949730D+03,0.122D+03,0.680D+02,0.18299000D+01,0.00000000D+00
     .,0.80320320D+03,0.122D+03,0.690D+02,0.18299000D+01,0.00000000D+00
     .,0.79414040D+03,0.122D+03,0.700D+02,0.18299000D+01,0.00000000D+00
     .,0.66477270D+03,0.122D+03,0.710D+02,0.18299000D+01,0.00000000D+00
     .,0.64787460D+03,0.122D+03,0.720D+02,0.18299000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32001:  32100)=(/
     . 0.58798130D+03,0.122D+03,0.730D+02,0.18299000D+01,0.00000000D+00
     .,0.49423570D+03,0.122D+03,0.740D+02,0.18299000D+01,0.00000000D+00
     .,0.50177330D+03,0.122D+03,0.750D+02,0.18299000D+01,0.00000000D+00
     .,0.45257260D+03,0.122D+03,0.760D+02,0.18299000D+01,0.00000000D+00
     .,0.41285580D+03,0.122D+03,0.770D+02,0.18299000D+01,0.00000000D+00
     .,0.34145400D+03,0.122D+03,0.780D+02,0.18299000D+01,0.00000000D+00
     .,0.31846190D+03,0.122D+03,0.790D+02,0.18299000D+01,0.00000000D+00
     .,0.32707700D+03,0.122D+03,0.800D+02,0.18299000D+01,0.00000000D+00
     .,0.48621160D+03,0.122D+03,0.810D+02,0.18299000D+01,0.00000000D+00
     .,0.47215520D+03,0.122D+03,0.820D+02,0.18299000D+01,0.00000000D+00
     .,0.43048050D+03,0.122D+03,0.830D+02,0.18299000D+01,0.00000000D+00
     .,0.40869510D+03,0.122D+03,0.840D+02,0.18299000D+01,0.00000000D+00
     .,0.37510290D+03,0.122D+03,0.850D+02,0.18299000D+01,0.00000000D+00
     .,0.34205750D+03,0.122D+03,0.860D+02,0.18299000D+01,0.00000000D+00
     .,0.12263970D+04,0.122D+03,0.870D+02,0.18299000D+01,0.00000000D+00
     .,0.11623660D+04,0.122D+03,0.880D+02,0.18299000D+01,0.00000000D+00
     .,0.10191422D+04,0.122D+03,0.890D+02,0.18299000D+01,0.00000000D+00
     .,0.90723670D+03,0.122D+03,0.900D+02,0.18299000D+01,0.00000000D+00
     .,0.90483310D+03,0.122D+03,0.910D+02,0.18299000D+01,0.00000000D+00
     .,0.87587480D+03,0.122D+03,0.920D+02,0.18299000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32101:  32200)=(/
     . 0.90696160D+03,0.122D+03,0.930D+02,0.18299000D+01,0.00000000D+00
     .,0.87736450D+03,0.122D+03,0.940D+02,0.18299000D+01,0.00000000D+00
     .,0.47275500D+02,0.122D+03,0.101D+03,0.18299000D+01,0.00000000D+00
     .,0.15766670D+03,0.122D+03,0.103D+03,0.18299000D+01,0.98650000D+00
     .,0.20036690D+03,0.122D+03,0.104D+03,0.18299000D+01,0.98080000D+00
     .,0.15035200D+03,0.122D+03,0.105D+03,0.18299000D+01,0.97060000D+00
     .,0.11205230D+03,0.122D+03,0.106D+03,0.18299000D+01,0.98680000D+00
     .,0.76983400D+02,0.122D+03,0.107D+03,0.18299000D+01,0.99440000D+00
     .,0.55516000D+02,0.122D+03,0.108D+03,0.18299000D+01,0.99250000D+00
     .,0.37722200D+02,0.122D+03,0.109D+03,0.18299000D+01,0.99820000D+00
     .,0.23126120D+03,0.122D+03,0.111D+03,0.18299000D+01,0.96840000D+00
     .,0.35836020D+03,0.122D+03,0.112D+03,0.18299000D+01,0.96280000D+00
     .,0.35964970D+03,0.122D+03,0.113D+03,0.18299000D+01,0.96480000D+00
     .,0.28509570D+03,0.122D+03,0.114D+03,0.18299000D+01,0.95070000D+00
     .,0.23107730D+03,0.122D+03,0.115D+03,0.18299000D+01,0.99470000D+00
     .,0.19398450D+03,0.122D+03,0.116D+03,0.18299000D+01,0.99480000D+00
     .,0.15736040D+03,0.122D+03,0.117D+03,0.18299000D+01,0.99720000D+00
     .,0.31625180D+03,0.122D+03,0.119D+03,0.18299000D+01,0.97670000D+00
     .,0.61943010D+03,0.122D+03,0.120D+03,0.18299000D+01,0.98310000D+00
     .,0.31292020D+03,0.122D+03,0.121D+03,0.18299000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters(  32201:  32300)=(/
     . 0.30199880D+03,0.122D+03,0.122D+03,0.18299000D+01,0.18299000D+01
     .,0.28406700D+02,0.123D+03,0.100D+01,0.19138000D+01,0.91180000D+00
     .,0.18435900D+02,0.123D+03,0.200D+01,0.19138000D+01,0.00000000D+00
     .,0.47914020D+03,0.123D+03,0.300D+01,0.19138000D+01,0.00000000D+00
     .,0.26670500D+03,0.123D+03,0.400D+01,0.19138000D+01,0.00000000D+00
     .,0.17589090D+03,0.123D+03,0.500D+01,0.19138000D+01,0.00000000D+00
     .,0.11700980D+03,0.123D+03,0.600D+01,0.19138000D+01,0.00000000D+00
     .,0.80914400D+02,0.123D+03,0.700D+01,0.19138000D+01,0.00000000D+00
     .,0.60793300D+02,0.123D+03,0.800D+01,0.19138000D+01,0.00000000D+00
     .,0.45763000D+02,0.123D+03,0.900D+01,0.19138000D+01,0.00000000D+00
     .,0.35029000D+02,0.123D+03,0.100D+02,0.19138000D+01,0.00000000D+00
     .,0.57164550D+03,0.123D+03,0.110D+02,0.19138000D+01,0.00000000D+00
     .,0.42771560D+03,0.123D+03,0.120D+02,0.19138000D+01,0.00000000D+00
     .,0.39004320D+03,0.123D+03,0.130D+02,0.19138000D+01,0.00000000D+00
     .,0.30289850D+03,0.123D+03,0.140D+02,0.19138000D+01,0.00000000D+00
     .,0.23331760D+03,0.123D+03,0.150D+02,0.19138000D+01,0.00000000D+00
     .,0.19211130D+03,0.123D+03,0.160D+02,0.19138000D+01,0.00000000D+00
     .,0.15575070D+03,0.123D+03,0.170D+02,0.19138000D+01,0.00000000D+00
     .,0.12660270D+03,0.123D+03,0.180D+02,0.19138000D+01,0.00000000D+00
     .,0.94198370D+03,0.123D+03,0.190D+02,0.19138000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32301:  32400)=(/
     . 0.76007180D+03,0.123D+03,0.200D+02,0.19138000D+01,0.00000000D+00
     .,0.62478010D+03,0.123D+03,0.210D+02,0.19138000D+01,0.00000000D+00
     .,0.60052210D+03,0.123D+03,0.220D+02,0.19138000D+01,0.00000000D+00
     .,0.54839080D+03,0.123D+03,0.230D+02,0.19138000D+01,0.00000000D+00
     .,0.43166830D+03,0.123D+03,0.240D+02,0.19138000D+01,0.00000000D+00
     .,0.47025290D+03,0.123D+03,0.250D+02,0.19138000D+01,0.00000000D+00
     .,0.36861360D+03,0.123D+03,0.260D+02,0.19138000D+01,0.00000000D+00
     .,0.38857290D+03,0.123D+03,0.270D+02,0.19138000D+01,0.00000000D+00
     .,0.40143290D+03,0.123D+03,0.280D+02,0.19138000D+01,0.00000000D+00
     .,0.30757630D+03,0.123D+03,0.290D+02,0.19138000D+01,0.00000000D+00
     .,0.31312860D+03,0.123D+03,0.300D+02,0.19138000D+01,0.00000000D+00
     .,0.37194270D+03,0.123D+03,0.310D+02,0.19138000D+01,0.00000000D+00
     .,0.32434350D+03,0.123D+03,0.320D+02,0.19138000D+01,0.00000000D+00
     .,0.27383520D+03,0.123D+03,0.330D+02,0.19138000D+01,0.00000000D+00
     .,0.24415540D+03,0.123D+03,0.340D+02,0.19138000D+01,0.00000000D+00
     .,0.21227920D+03,0.123D+03,0.350D+02,0.19138000D+01,0.00000000D+00
     .,0.18351710D+03,0.123D+03,0.360D+02,0.19138000D+01,0.00000000D+00
     .,0.10535834D+04,0.123D+03,0.370D+02,0.19138000D+01,0.00000000D+00
     .,0.90623640D+03,0.123D+03,0.380D+02,0.19138000D+01,0.00000000D+00
     .,0.78672550D+03,0.123D+03,0.390D+02,0.19138000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32401:  32500)=(/
     . 0.70307840D+03,0.123D+03,0.400D+02,0.19138000D+01,0.00000000D+00
     .,0.63870140D+03,0.123D+03,0.410D+02,0.19138000D+01,0.00000000D+00
     .,0.48981600D+03,0.123D+03,0.420D+02,0.19138000D+01,0.00000000D+00
     .,0.54789060D+03,0.123D+03,0.430D+02,0.19138000D+01,0.00000000D+00
     .,0.41435750D+03,0.123D+03,0.440D+02,0.19138000D+01,0.00000000D+00
     .,0.45302620D+03,0.123D+03,0.450D+02,0.19138000D+01,0.00000000D+00
     .,0.41911340D+03,0.123D+03,0.460D+02,0.19138000D+01,0.00000000D+00
     .,0.34982880D+03,0.123D+03,0.470D+02,0.19138000D+01,0.00000000D+00
     .,0.36818710D+03,0.123D+03,0.480D+02,0.19138000D+01,0.00000000D+00
     .,0.46556470D+03,0.123D+03,0.490D+02,0.19138000D+01,0.00000000D+00
     .,0.42659330D+03,0.123D+03,0.500D+02,0.19138000D+01,0.00000000D+00
     .,0.37675440D+03,0.123D+03,0.510D+02,0.19138000D+01,0.00000000D+00
     .,0.34763740D+03,0.123D+03,0.520D+02,0.19138000D+01,0.00000000D+00
     .,0.31247140D+03,0.123D+03,0.530D+02,0.19138000D+01,0.00000000D+00
     .,0.27936120D+03,0.123D+03,0.540D+02,0.19138000D+01,0.00000000D+00
     .,0.12831193D+04,0.123D+03,0.550D+02,0.19138000D+01,0.00000000D+00
     .,0.11586662D+04,0.123D+03,0.560D+02,0.19138000D+01,0.00000000D+00
     .,0.10088336D+04,0.123D+03,0.570D+02,0.19138000D+01,0.00000000D+00
     .,0.44575700D+03,0.123D+03,0.580D+02,0.19138000D+01,0.27991000D+01
     .,0.10235395D+04,0.123D+03,0.590D+02,0.19138000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32501:  32600)=(/
     . 0.98134570D+03,0.123D+03,0.600D+02,0.19138000D+01,0.00000000D+00
     .,0.95633210D+03,0.123D+03,0.610D+02,0.19138000D+01,0.00000000D+00
     .,0.93337380D+03,0.123D+03,0.620D+02,0.19138000D+01,0.00000000D+00
     .,0.91300140D+03,0.123D+03,0.630D+02,0.19138000D+01,0.00000000D+00
     .,0.71072370D+03,0.123D+03,0.640D+02,0.19138000D+01,0.00000000D+00
     .,0.81199050D+03,0.123D+03,0.650D+02,0.19138000D+01,0.00000000D+00
     .,0.78182720D+03,0.123D+03,0.660D+02,0.19138000D+01,0.00000000D+00
     .,0.82162740D+03,0.123D+03,0.670D+02,0.19138000D+01,0.00000000D+00
     .,0.80399890D+03,0.123D+03,0.680D+02,0.19138000D+01,0.00000000D+00
     .,0.78800640D+03,0.123D+03,0.690D+02,0.19138000D+01,0.00000000D+00
     .,0.77912190D+03,0.123D+03,0.700D+02,0.19138000D+01,0.00000000D+00
     .,0.65197940D+03,0.123D+03,0.710D+02,0.19138000D+01,0.00000000D+00
     .,0.63529960D+03,0.123D+03,0.720D+02,0.19138000D+01,0.00000000D+00
     .,0.57649460D+03,0.123D+03,0.730D+02,0.19138000D+01,0.00000000D+00
     .,0.48455830D+03,0.123D+03,0.740D+02,0.19138000D+01,0.00000000D+00
     .,0.49191200D+03,0.123D+03,0.750D+02,0.19138000D+01,0.00000000D+00
     .,0.44364130D+03,0.123D+03,0.760D+02,0.19138000D+01,0.00000000D+00
     .,0.40468640D+03,0.123D+03,0.770D+02,0.19138000D+01,0.00000000D+00
     .,0.33471530D+03,0.123D+03,0.780D+02,0.19138000D+01,0.00000000D+00
     .,0.31218730D+03,0.123D+03,0.790D+02,0.19138000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32601:  32700)=(/
     . 0.32060120D+03,0.123D+03,0.800D+02,0.19138000D+01,0.00000000D+00
     .,0.47675960D+03,0.123D+03,0.810D+02,0.19138000D+01,0.00000000D+00
     .,0.46287410D+03,0.123D+03,0.820D+02,0.19138000D+01,0.00000000D+00
     .,0.42191810D+03,0.123D+03,0.830D+02,0.19138000D+01,0.00000000D+00
     .,0.40051720D+03,0.123D+03,0.840D+02,0.19138000D+01,0.00000000D+00
     .,0.36755880D+03,0.123D+03,0.850D+02,0.19138000D+01,0.00000000D+00
     .,0.33516100D+03,0.123D+03,0.860D+02,0.19138000D+01,0.00000000D+00
     .,0.12027024D+04,0.123D+03,0.870D+02,0.19138000D+01,0.00000000D+00
     .,0.11403430D+04,0.123D+03,0.880D+02,0.19138000D+01,0.00000000D+00
     .,0.99965520D+03,0.123D+03,0.890D+02,0.19138000D+01,0.00000000D+00
     .,0.88972590D+03,0.123D+03,0.900D+02,0.19138000D+01,0.00000000D+00
     .,0.88748800D+03,0.123D+03,0.910D+02,0.19138000D+01,0.00000000D+00
     .,0.85909970D+03,0.123D+03,0.920D+02,0.19138000D+01,0.00000000D+00
     .,0.88977190D+03,0.123D+03,0.930D+02,0.19138000D+01,0.00000000D+00
     .,0.86071780D+03,0.123D+03,0.940D+02,0.19138000D+01,0.00000000D+00
     .,0.46308900D+02,0.123D+03,0.101D+03,0.19138000D+01,0.00000000D+00
     .,0.15457620D+03,0.123D+03,0.103D+03,0.19138000D+01,0.98650000D+00
     .,0.19640270D+03,0.123D+03,0.104D+03,0.19138000D+01,0.98080000D+00
     .,0.14731530D+03,0.123D+03,0.105D+03,0.19138000D+01,0.97060000D+00
     .,0.10977970D+03,0.123D+03,0.106D+03,0.19138000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  32701:  32800)=(/
     . 0.75430300D+02,0.123D+03,0.107D+03,0.19138000D+01,0.99440000D+00
     .,0.54410900D+02,0.123D+03,0.108D+03,0.19138000D+01,0.99250000D+00
     .,0.36996200D+02,0.123D+03,0.109D+03,0.19138000D+01,0.99820000D+00
     .,0.22678860D+03,0.123D+03,0.111D+03,0.19138000D+01,0.96840000D+00
     .,0.35139280D+03,0.123D+03,0.112D+03,0.19138000D+01,0.96280000D+00
     .,0.35255750D+03,0.123D+03,0.113D+03,0.19138000D+01,0.96480000D+00
     .,0.27935630D+03,0.123D+03,0.114D+03,0.19138000D+01,0.95070000D+00
     .,0.22637670D+03,0.123D+03,0.115D+03,0.19138000D+01,0.99470000D+00
     .,0.19002990D+03,0.123D+03,0.116D+03,0.19138000D+01,0.99480000D+00
     .,0.15415760D+03,0.123D+03,0.117D+03,0.19138000D+01,0.99720000D+00
     .,0.31011080D+03,0.123D+03,0.119D+03,0.19138000D+01,0.97670000D+00
     .,0.60755710D+03,0.123D+03,0.120D+03,0.19138000D+01,0.98310000D+00
     .,0.30673890D+03,0.123D+03,0.121D+03,0.19138000D+01,0.18627000D+01
     .,0.29600290D+03,0.123D+03,0.122D+03,0.19138000D+01,0.18299000D+01
     .,0.29014360D+03,0.123D+03,0.123D+03,0.19138000D+01,0.19138000D+01
     .,0.28056200D+02,0.124D+03,0.100D+01,0.18269000D+01,0.91180000D+00
     .,0.18175400D+02,0.124D+03,0.200D+01,0.18269000D+01,0.00000000D+00
     .,0.48059440D+03,0.124D+03,0.300D+01,0.18269000D+01,0.00000000D+00
     .,0.26540880D+03,0.124D+03,0.400D+01,0.18269000D+01,0.00000000D+00
     .,0.17437190D+03,0.124D+03,0.500D+01,0.18269000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32801:  32900)=(/
     . 0.11571820D+03,0.124D+03,0.600D+01,0.18269000D+01,0.00000000D+00
     .,0.79902400D+02,0.124D+03,0.700D+01,0.18269000D+01,0.00000000D+00
     .,0.59982900D+02,0.124D+03,0.800D+01,0.18269000D+01,0.00000000D+00
     .,0.45129000D+02,0.124D+03,0.900D+01,0.18269000D+01,0.00000000D+00
     .,0.34535000D+02,0.124D+03,0.100D+02,0.18269000D+01,0.00000000D+00
     .,0.57314360D+03,0.124D+03,0.110D+02,0.18269000D+01,0.00000000D+00
     .,0.42622760D+03,0.124D+03,0.120D+02,0.18269000D+01,0.00000000D+00
     .,0.38786950D+03,0.124D+03,0.130D+02,0.18269000D+01,0.00000000D+00
     .,0.30039280D+03,0.124D+03,0.140D+02,0.18269000D+01,0.00000000D+00
     .,0.23090900D+03,0.124D+03,0.150D+02,0.18269000D+01,0.00000000D+00
     .,0.18990520D+03,0.124D+03,0.160D+02,0.18269000D+01,0.00000000D+00
     .,0.15380570D+03,0.124D+03,0.170D+02,0.18269000D+01,0.00000000D+00
     .,0.12492650D+03,0.124D+03,0.180D+02,0.18269000D+01,0.00000000D+00
     .,0.94587000D+03,0.124D+03,0.190D+02,0.18269000D+01,0.00000000D+00
     .,0.75936840D+03,0.124D+03,0.200D+02,0.18269000D+01,0.00000000D+00
     .,0.62353320D+03,0.124D+03,0.210D+02,0.18269000D+01,0.00000000D+00
     .,0.59879810D+03,0.124D+03,0.220D+02,0.18269000D+01,0.00000000D+00
     .,0.54652440D+03,0.124D+03,0.230D+02,0.18269000D+01,0.00000000D+00
     .,0.43023530D+03,0.124D+03,0.240D+02,0.18269000D+01,0.00000000D+00
     .,0.46829610D+03,0.124D+03,0.250D+02,0.18269000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  32901:  33000)=(/
     . 0.36707850D+03,0.124D+03,0.260D+02,0.18269000D+01,0.00000000D+00
     .,0.38644860D+03,0.124D+03,0.270D+02,0.18269000D+01,0.00000000D+00
     .,0.39945300D+03,0.124D+03,0.280D+02,0.18269000D+01,0.00000000D+00
     .,0.30611810D+03,0.124D+03,0.290D+02,0.18269000D+01,0.00000000D+00
     .,0.31106030D+03,0.124D+03,0.300D+02,0.18269000D+01,0.00000000D+00
     .,0.36963020D+03,0.124D+03,0.310D+02,0.18269000D+01,0.00000000D+00
     .,0.32164040D+03,0.124D+03,0.320D+02,0.18269000D+01,0.00000000D+00
     .,0.27107700D+03,0.124D+03,0.330D+02,0.18269000D+01,0.00000000D+00
     .,0.24145850D+03,0.124D+03,0.340D+02,0.18269000D+01,0.00000000D+00
     .,0.20973930D+03,0.124D+03,0.350D+02,0.18269000D+01,0.00000000D+00
     .,0.18118190D+03,0.124D+03,0.360D+02,0.18269000D+01,0.00000000D+00
     .,0.10575718D+04,0.124D+03,0.370D+02,0.18269000D+01,0.00000000D+00
     .,0.90561870D+03,0.124D+03,0.380D+02,0.18269000D+01,0.00000000D+00
     .,0.78474890D+03,0.124D+03,0.390D+02,0.18269000D+01,0.00000000D+00
     .,0.70054320D+03,0.124D+03,0.400D+02,0.18269000D+01,0.00000000D+00
     .,0.63596390D+03,0.124D+03,0.410D+02,0.18269000D+01,0.00000000D+00
     .,0.48719110D+03,0.124D+03,0.420D+02,0.18269000D+01,0.00000000D+00
     .,0.54517240D+03,0.124D+03,0.430D+02,0.18269000D+01,0.00000000D+00
     .,0.41181870D+03,0.124D+03,0.440D+02,0.18269000D+01,0.00000000D+00
     .,0.45019430D+03,0.124D+03,0.450D+02,0.18269000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33001:  33100)=(/
     . 0.41632300D+03,0.124D+03,0.460D+02,0.18269000D+01,0.00000000D+00
     .,0.34767860D+03,0.124D+03,0.470D+02,0.18269000D+01,0.00000000D+00
     .,0.36555310D+03,0.124D+03,0.480D+02,0.18269000D+01,0.00000000D+00
     .,0.46283040D+03,0.124D+03,0.490D+02,0.18269000D+01,0.00000000D+00
     .,0.42332080D+03,0.124D+03,0.500D+02,0.18269000D+01,0.00000000D+00
     .,0.37325910D+03,0.124D+03,0.510D+02,0.18269000D+01,0.00000000D+00
     .,0.34409820D+03,0.124D+03,0.520D+02,0.18269000D+01,0.00000000D+00
     .,0.30900630D+03,0.124D+03,0.530D+02,0.18269000D+01,0.00000000D+00
     .,0.27604060D+03,0.124D+03,0.540D+02,0.18269000D+01,0.00000000D+00
     .,0.12879616D+04,0.124D+03,0.550D+02,0.18269000D+01,0.00000000D+00
     .,0.11586672D+04,0.124D+03,0.560D+02,0.18269000D+01,0.00000000D+00
     .,0.10069636D+04,0.124D+03,0.570D+02,0.18269000D+01,0.00000000D+00
     .,0.44178090D+03,0.124D+03,0.580D+02,0.18269000D+01,0.27991000D+01
     .,0.10229773D+04,0.124D+03,0.590D+02,0.18269000D+01,0.00000000D+00
     .,0.98048290D+03,0.124D+03,0.600D+02,0.18269000D+01,0.00000000D+00
     .,0.95540420D+03,0.124D+03,0.610D+02,0.18269000D+01,0.00000000D+00
     .,0.93239460D+03,0.124D+03,0.620D+02,0.18269000D+01,0.00000000D+00
     .,0.91197350D+03,0.124D+03,0.630D+02,0.18269000D+01,0.00000000D+00
     .,0.70857690D+03,0.124D+03,0.640D+02,0.18269000D+01,0.00000000D+00
     .,0.81204950D+03,0.124D+03,0.650D+02,0.18269000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33101:  33200)=(/
     . 0.78162600D+03,0.124D+03,0.660D+02,0.18269000D+01,0.00000000D+00
     .,0.82030710D+03,0.124D+03,0.670D+02,0.18269000D+01,0.00000000D+00
     .,0.80266090D+03,0.124D+03,0.680D+02,0.18269000D+01,0.00000000D+00
     .,0.78663360D+03,0.124D+03,0.690D+02,0.18269000D+01,0.00000000D+00
     .,0.77782320D+03,0.124D+03,0.700D+02,0.18269000D+01,0.00000000D+00
     .,0.65005720D+03,0.124D+03,0.710D+02,0.18269000D+01,0.00000000D+00
     .,0.63220990D+03,0.124D+03,0.720D+02,0.18269000D+01,0.00000000D+00
     .,0.57309450D+03,0.124D+03,0.730D+02,0.18269000D+01,0.00000000D+00
     .,0.48138140D+03,0.124D+03,0.740D+02,0.18269000D+01,0.00000000D+00
     .,0.48847190D+03,0.124D+03,0.750D+02,0.18269000D+01,0.00000000D+00
     .,0.44016550D+03,0.124D+03,0.760D+02,0.18269000D+01,0.00000000D+00
     .,0.40125220D+03,0.124D+03,0.770D+02,0.18269000D+01,0.00000000D+00
     .,0.33169650D+03,0.124D+03,0.780D+02,0.18269000D+01,0.00000000D+00
     .,0.30930750D+03,0.124D+03,0.790D+02,0.18269000D+01,0.00000000D+00
     .,0.31751490D+03,0.124D+03,0.800D+02,0.18269000D+01,0.00000000D+00
     .,0.47384960D+03,0.124D+03,0.810D+02,0.18269000D+01,0.00000000D+00
     .,0.45937430D+03,0.124D+03,0.820D+02,0.18269000D+01,0.00000000D+00
     .,0.41810440D+03,0.124D+03,0.830D+02,0.18269000D+01,0.00000000D+00
     .,0.39657360D+03,0.124D+03,0.840D+02,0.18269000D+01,0.00000000D+00
     .,0.36360680D+03,0.124D+03,0.850D+02,0.18269000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33201:  33300)=(/
     . 0.33130140D+03,0.124D+03,0.860D+02,0.18269000D+01,0.00000000D+00
     .,0.12054436D+04,0.124D+03,0.870D+02,0.18269000D+01,0.00000000D+00
     .,0.11392761D+04,0.124D+03,0.880D+02,0.18269000D+01,0.00000000D+00
     .,0.99702490D+03,0.124D+03,0.890D+02,0.18269000D+01,0.00000000D+00
     .,0.88576610D+03,0.124D+03,0.900D+02,0.18269000D+01,0.00000000D+00
     .,0.88442800D+03,0.124D+03,0.910D+02,0.18269000D+01,0.00000000D+00
     .,0.85610390D+03,0.124D+03,0.920D+02,0.18269000D+01,0.00000000D+00
     .,0.88770660D+03,0.124D+03,0.930D+02,0.18269000D+01,0.00000000D+00
     .,0.85853020D+03,0.124D+03,0.940D+02,0.18269000D+01,0.00000000D+00
     .,0.45817300D+02,0.124D+03,0.101D+03,0.18269000D+01,0.00000000D+00
     .,0.15375390D+03,0.124D+03,0.103D+03,0.18269000D+01,0.98650000D+00
     .,0.19523170D+03,0.124D+03,0.104D+03,0.18269000D+01,0.98080000D+00
     .,0.14594770D+03,0.124D+03,0.105D+03,0.18269000D+01,0.97060000D+00
     .,0.10858200D+03,0.124D+03,0.106D+03,0.18269000D+01,0.98680000D+00
     .,0.74489000D+02,0.124D+03,0.107D+03,0.18269000D+01,0.99440000D+00
     .,0.53673300D+02,0.124D+03,0.108D+03,0.18269000D+01,0.99250000D+00
     .,0.36459400D+02,0.124D+03,0.109D+03,0.18269000D+01,0.99820000D+00
     .,0.22578370D+03,0.124D+03,0.111D+03,0.18269000D+01,0.96840000D+00
     .,0.34993280D+03,0.124D+03,0.112D+03,0.18269000D+01,0.96280000D+00
     .,0.35042960D+03,0.124D+03,0.113D+03,0.18269000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  33301:  33400)=(/
     . 0.27695120D+03,0.124D+03,0.114D+03,0.18269000D+01,0.95070000D+00
     .,0.22403030D+03,0.124D+03,0.115D+03,0.18269000D+01,0.99470000D+00
     .,0.18785700D+03,0.124D+03,0.116D+03,0.18269000D+01,0.99480000D+00
     .,0.15223830D+03,0.124D+03,0.117D+03,0.18269000D+01,0.99720000D+00
     .,0.30839010D+03,0.124D+03,0.119D+03,0.18269000D+01,0.97670000D+00
     .,0.60707000D+03,0.124D+03,0.120D+03,0.18269000D+01,0.98310000D+00
     .,0.30430940D+03,0.124D+03,0.121D+03,0.18269000D+01,0.18627000D+01
     .,0.29365980D+03,0.124D+03,0.122D+03,0.18269000D+01,0.18299000D+01
     .,0.28786570D+03,0.124D+03,0.123D+03,0.18269000D+01,0.19138000D+01
     .,0.28569050D+03,0.124D+03,0.124D+03,0.18269000D+01,0.18269000D+01
     .,0.26181000D+02,0.125D+03,0.100D+01,0.16406000D+01,0.91180000D+00
     .,0.17152600D+02,0.125D+03,0.200D+01,0.16406000D+01,0.00000000D+00
     .,0.41608360D+03,0.125D+03,0.300D+01,0.16406000D+01,0.00000000D+00
     .,0.23896060D+03,0.125D+03,0.400D+01,0.16406000D+01,0.00000000D+00
     .,0.15984920D+03,0.125D+03,0.500D+01,0.16406000D+01,0.00000000D+00
     .,0.10733820D+03,0.125D+03,0.600D+01,0.16406000D+01,0.00000000D+00
     .,0.74699800D+02,0.125D+03,0.700D+01,0.16406000D+01,0.00000000D+00
     .,0.56362200D+02,0.125D+03,0.800D+01,0.16406000D+01,0.00000000D+00
     .,0.42576400D+02,0.125D+03,0.900D+01,0.16406000D+01,0.00000000D+00
     .,0.32680600D+02,0.125D+03,0.100D+02,0.16406000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33401:  33500)=(/
     . 0.49735820D+03,0.125D+03,0.110D+02,0.16406000D+01,0.00000000D+00
     .,0.38129680D+03,0.125D+03,0.120D+02,0.16406000D+01,0.00000000D+00
     .,0.35045220D+03,0.125D+03,0.130D+02,0.16406000D+01,0.00000000D+00
     .,0.27492570D+03,0.125D+03,0.140D+02,0.16406000D+01,0.00000000D+00
     .,0.21341010D+03,0.125D+03,0.150D+02,0.16406000D+01,0.00000000D+00
     .,0.17651650D+03,0.125D+03,0.160D+02,0.16406000D+01,0.00000000D+00
     .,0.14370010D+03,0.125D+03,0.170D+02,0.16406000D+01,0.00000000D+00
     .,0.11720570D+03,0.125D+03,0.180D+02,0.16406000D+01,0.00000000D+00
     .,0.81424680D+03,0.125D+03,0.190D+02,0.16406000D+01,0.00000000D+00
     .,0.67083370D+03,0.125D+03,0.200D+02,0.16406000D+01,0.00000000D+00
     .,0.55379310D+03,0.125D+03,0.210D+02,0.16406000D+01,0.00000000D+00
     .,0.53412660D+03,0.125D+03,0.220D+02,0.16406000D+01,0.00000000D+00
     .,0.48879470D+03,0.125D+03,0.230D+02,0.16406000D+01,0.00000000D+00
     .,0.38469310D+03,0.125D+03,0.240D+02,0.16406000D+01,0.00000000D+00
     .,0.42042070D+03,0.125D+03,0.250D+02,0.16406000D+01,0.00000000D+00
     .,0.32962730D+03,0.125D+03,0.260D+02,0.16406000D+01,0.00000000D+00
     .,0.34919410D+03,0.125D+03,0.270D+02,0.16406000D+01,0.00000000D+00
     .,0.36001720D+03,0.125D+03,0.280D+02,0.16406000D+01,0.00000000D+00
     .,0.27572060D+03,0.125D+03,0.290D+02,0.16406000D+01,0.00000000D+00
     .,0.28266670D+03,0.125D+03,0.300D+02,0.16406000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33501:  33600)=(/
     . 0.33506150D+03,0.125D+03,0.310D+02,0.16406000D+01,0.00000000D+00
     .,0.29451840D+03,0.125D+03,0.320D+02,0.16406000D+01,0.00000000D+00
     .,0.25028310D+03,0.125D+03,0.330D+02,0.16406000D+01,0.00000000D+00
     .,0.22398570D+03,0.125D+03,0.340D+02,0.16406000D+01,0.00000000D+00
     .,0.19545360D+03,0.125D+03,0.350D+02,0.16406000D+01,0.00000000D+00
     .,0.16950970D+03,0.125D+03,0.360D+02,0.16406000D+01,0.00000000D+00
     .,0.91194330D+03,0.125D+03,0.370D+02,0.16406000D+01,0.00000000D+00
     .,0.79901250D+03,0.125D+03,0.380D+02,0.16406000D+01,0.00000000D+00
     .,0.69867600D+03,0.125D+03,0.390D+02,0.16406000D+01,0.00000000D+00
     .,0.62707900D+03,0.125D+03,0.400D+02,0.16406000D+01,0.00000000D+00
     .,0.57118620D+03,0.125D+03,0.410D+02,0.16406000D+01,0.00000000D+00
     .,0.43993260D+03,0.125D+03,0.420D+02,0.16406000D+01,0.00000000D+00
     .,0.49132100D+03,0.125D+03,0.430D+02,0.16406000D+01,0.00000000D+00
     .,0.37334420D+03,0.125D+03,0.440D+02,0.16406000D+01,0.00000000D+00
     .,0.40836770D+03,0.125D+03,0.450D+02,0.16406000D+01,0.00000000D+00
     .,0.37842950D+03,0.125D+03,0.460D+02,0.16406000D+01,0.00000000D+00
     .,0.31534820D+03,0.125D+03,0.470D+02,0.16406000D+01,0.00000000D+00
     .,0.33315180D+03,0.125D+03,0.480D+02,0.16406000D+01,0.00000000D+00
     .,0.41907070D+03,0.125D+03,0.490D+02,0.16406000D+01,0.00000000D+00
     .,0.38661840D+03,0.125D+03,0.500D+02,0.16406000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33601:  33700)=(/
     . 0.34352050D+03,0.125D+03,0.510D+02,0.16406000D+01,0.00000000D+00
     .,0.31804850D+03,0.125D+03,0.520D+02,0.16406000D+01,0.00000000D+00
     .,0.28687200D+03,0.125D+03,0.530D+02,0.16406000D+01,0.00000000D+00
     .,0.25728030D+03,0.125D+03,0.540D+02,0.16406000D+01,0.00000000D+00
     .,0.11103588D+04,0.125D+03,0.550D+02,0.16406000D+01,0.00000000D+00
     .,0.10186688D+04,0.125D+03,0.560D+02,0.16406000D+01,0.00000000D+00
     .,0.89350560D+03,0.125D+03,0.570D+02,0.16406000D+01,0.00000000D+00
     .,0.40587370D+03,0.125D+03,0.580D+02,0.16406000D+01,0.27991000D+01
     .,0.90204820D+03,0.125D+03,0.590D+02,0.16406000D+01,0.00000000D+00
     .,0.86604420D+03,0.125D+03,0.600D+02,0.16406000D+01,0.00000000D+00
     .,0.84428560D+03,0.125D+03,0.610D+02,0.16406000D+01,0.00000000D+00
     .,0.82428300D+03,0.125D+03,0.620D+02,0.16406000D+01,0.00000000D+00
     .,0.80654320D+03,0.125D+03,0.630D+02,0.16406000D+01,0.00000000D+00
     .,0.63257430D+03,0.125D+03,0.640D+02,0.16406000D+01,0.00000000D+00
     .,0.71375520D+03,0.125D+03,0.650D+02,0.16406000D+01,0.00000000D+00
     .,0.68811250D+03,0.125D+03,0.660D+02,0.16406000D+01,0.00000000D+00
     .,0.72723780D+03,0.125D+03,0.670D+02,0.16406000D+01,0.00000000D+00
     .,0.71180010D+03,0.125D+03,0.680D+02,0.16406000D+01,0.00000000D+00
     .,0.69785650D+03,0.125D+03,0.690D+02,0.16406000D+01,0.00000000D+00
     .,0.68978470D+03,0.125D+03,0.700D+02,0.16406000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33701:  33800)=(/
     . 0.58012870D+03,0.125D+03,0.710D+02,0.16406000D+01,0.00000000D+00
     .,0.56940560D+03,0.125D+03,0.720D+02,0.16406000D+01,0.00000000D+00
     .,0.51879050D+03,0.125D+03,0.730D+02,0.16406000D+01,0.00000000D+00
     .,0.43720880D+03,0.125D+03,0.740D+02,0.16406000D+01,0.00000000D+00
     .,0.44459970D+03,0.125D+03,0.750D+02,0.16406000D+01,0.00000000D+00
     .,0.40230970D+03,0.125D+03,0.760D+02,0.16406000D+01,0.00000000D+00
     .,0.36794540D+03,0.125D+03,0.770D+02,0.16406000D+01,0.00000000D+00
     .,0.30505010D+03,0.125D+03,0.780D+02,0.16406000D+01,0.00000000D+00
     .,0.28480180D+03,0.125D+03,0.790D+02,0.16406000D+01,0.00000000D+00
     .,0.29291770D+03,0.125D+03,0.800D+02,0.16406000D+01,0.00000000D+00
     .,0.42959510D+03,0.125D+03,0.810D+02,0.16406000D+01,0.00000000D+00
     .,0.41941490D+03,0.125D+03,0.820D+02,0.16406000D+01,0.00000000D+00
     .,0.38444960D+03,0.125D+03,0.830D+02,0.16406000D+01,0.00000000D+00
     .,0.36605470D+03,0.125D+03,0.840D+02,0.16406000D+01,0.00000000D+00
     .,0.33709280D+03,0.125D+03,0.850D+02,0.16406000D+01,0.00000000D+00
     .,0.30829470D+03,0.125D+03,0.860D+02,0.16406000D+01,0.00000000D+00
     .,0.10472098D+04,0.125D+03,0.870D+02,0.16406000D+01,0.00000000D+00
     .,0.10062859D+04,0.125D+03,0.880D+02,0.16406000D+01,0.00000000D+00
     .,0.88823000D+03,0.125D+03,0.890D+02,0.16406000D+01,0.00000000D+00
     .,0.79631050D+03,0.125D+03,0.900D+02,0.16406000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  33801:  33900)=(/
     . 0.79125770D+03,0.125D+03,0.910D+02,0.16406000D+01,0.00000000D+00
     .,0.76609840D+03,0.125D+03,0.920D+02,0.16406000D+01,0.00000000D+00
     .,0.78992350D+03,0.125D+03,0.930D+02,0.16406000D+01,0.00000000D+00
     .,0.76480610D+03,0.125D+03,0.940D+02,0.16406000D+01,0.00000000D+00
     .,0.42392700D+02,0.125D+03,0.101D+03,0.16406000D+01,0.00000000D+00
     .,0.13874910D+03,0.125D+03,0.103D+03,0.16406000D+01,0.98650000D+00
     .,0.17668170D+03,0.125D+03,0.104D+03,0.16406000D+01,0.98080000D+00
     .,0.13421360D+03,0.125D+03,0.105D+03,0.16406000D+01,0.97060000D+00
     .,0.10064630D+03,0.125D+03,0.106D+03,0.16406000D+01,0.98680000D+00
     .,0.69621500D+02,0.125D+03,0.107D+03,0.16406000D+01,0.99440000D+00
     .,0.50485800D+02,0.125D+03,0.108D+03,0.16406000D+01,0.99250000D+00
     .,0.34548100D+02,0.125D+03,0.109D+03,0.16406000D+01,0.99820000D+00
     .,0.20296760D+03,0.125D+03,0.111D+03,0.16406000D+01,0.96840000D+00
     .,0.31401190D+03,0.125D+03,0.112D+03,0.16406000D+01,0.96280000D+00
     .,0.31732870D+03,0.125D+03,0.113D+03,0.16406000D+01,0.96480000D+00
     .,0.25388000D+03,0.125D+03,0.114D+03,0.16406000D+01,0.95070000D+00
     .,0.20709950D+03,0.125D+03,0.115D+03,0.16406000D+01,0.99470000D+00
     .,0.17457750D+03,0.125D+03,0.116D+03,0.16406000D+01,0.99480000D+00
     .,0.14221510D+03,0.125D+03,0.117D+03,0.16406000D+01,0.99720000D+00
     .,0.27872590D+03,0.125D+03,0.119D+03,0.16406000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters(  33901:  34000)=(/
     . 0.53581490D+03,0.125D+03,0.120D+03,0.16406000D+01,0.98310000D+00
     .,0.27819650D+03,0.125D+03,0.121D+03,0.16406000D+01,0.18627000D+01
     .,0.26846570D+03,0.125D+03,0.122D+03,0.16406000D+01,0.18299000D+01
     .,0.26311270D+03,0.125D+03,0.123D+03,0.16406000D+01,0.19138000D+01
     .,0.26077730D+03,0.125D+03,0.124D+03,0.16406000D+01,0.18269000D+01
     .,0.23955540D+03,0.125D+03,0.125D+03,0.16406000D+01,0.16406000D+01
     .,0.24345200D+02,0.126D+03,0.100D+01,0.16483000D+01,0.91180000D+00
     .,0.16056000D+02,0.126D+03,0.200D+01,0.16483000D+01,0.00000000D+00
     .,0.37921170D+03,0.126D+03,0.300D+01,0.16483000D+01,0.00000000D+00
     .,0.21947750D+03,0.126D+03,0.400D+01,0.16483000D+01,0.00000000D+00
     .,0.14762980D+03,0.126D+03,0.500D+01,0.16483000D+01,0.00000000D+00
     .,0.99588000D+02,0.126D+03,0.600D+01,0.16483000D+01,0.00000000D+00
     .,0.69563800D+02,0.126D+03,0.700D+01,0.16483000D+01,0.00000000D+00
     .,0.52635100D+02,0.126D+03,0.800D+01,0.16483000D+01,0.00000000D+00
     .,0.39862800D+02,0.126D+03,0.900D+01,0.16483000D+01,0.00000000D+00
     .,0.30664800D+02,0.126D+03,0.100D+02,0.16483000D+01,0.00000000D+00
     .,0.45354440D+03,0.126D+03,0.110D+02,0.16483000D+01,0.00000000D+00
     .,0.34971160D+03,0.126D+03,0.120D+02,0.16483000D+01,0.00000000D+00
     .,0.32227810D+03,0.126D+03,0.130D+02,0.16483000D+01,0.00000000D+00
     .,0.25376380D+03,0.126D+03,0.140D+02,0.16483000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34001:  34100)=(/
     . 0.19765690D+03,0.126D+03,0.150D+02,0.16483000D+01,0.00000000D+00
     .,0.16387940D+03,0.126D+03,0.160D+02,0.16483000D+01,0.00000000D+00
     .,0.13373240D+03,0.126D+03,0.170D+02,0.16483000D+01,0.00000000D+00
     .,0.10931550D+03,0.126D+03,0.180D+02,0.16483000D+01,0.00000000D+00
     .,0.74225200D+03,0.126D+03,0.190D+02,0.16483000D+01,0.00000000D+00
     .,0.61392330D+03,0.126D+03,0.200D+02,0.16483000D+01,0.00000000D+00
     .,0.50734010D+03,0.126D+03,0.210D+02,0.16483000D+01,0.00000000D+00
     .,0.48989960D+03,0.126D+03,0.220D+02,0.16483000D+01,0.00000000D+00
     .,0.44862620D+03,0.126D+03,0.230D+02,0.16483000D+01,0.00000000D+00
     .,0.35327090D+03,0.126D+03,0.240D+02,0.16483000D+01,0.00000000D+00
     .,0.38626020D+03,0.126D+03,0.250D+02,0.16483000D+01,0.00000000D+00
     .,0.30304800D+03,0.126D+03,0.260D+02,0.16483000D+01,0.00000000D+00
     .,0.32134480D+03,0.126D+03,0.270D+02,0.16483000D+01,0.00000000D+00
     .,0.33106140D+03,0.126D+03,0.280D+02,0.16483000D+01,0.00000000D+00
     .,0.25370380D+03,0.126D+03,0.290D+02,0.16483000D+01,0.00000000D+00
     .,0.26053410D+03,0.126D+03,0.300D+02,0.16483000D+01,0.00000000D+00
     .,0.30855290D+03,0.126D+03,0.310D+02,0.16483000D+01,0.00000000D+00
     .,0.27197110D+03,0.126D+03,0.320D+02,0.16483000D+01,0.00000000D+00
     .,0.23176180D+03,0.126D+03,0.330D+02,0.16483000D+01,0.00000000D+00
     .,0.20779480D+03,0.126D+03,0.340D+02,0.16483000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34101:  34200)=(/
     . 0.18168360D+03,0.126D+03,0.350D+02,0.16483000D+01,0.00000000D+00
     .,0.15786610D+03,0.126D+03,0.360D+02,0.16483000D+01,0.00000000D+00
     .,0.83179600D+03,0.126D+03,0.370D+02,0.16483000D+01,0.00000000D+00
     .,0.73123300D+03,0.126D+03,0.380D+02,0.16483000D+01,0.00000000D+00
     .,0.64066410D+03,0.126D+03,0.390D+02,0.16483000D+01,0.00000000D+00
     .,0.57577520D+03,0.126D+03,0.400D+02,0.16483000D+01,0.00000000D+00
     .,0.52495880D+03,0.126D+03,0.410D+02,0.16483000D+01,0.00000000D+00
     .,0.40508170D+03,0.126D+03,0.420D+02,0.16483000D+01,0.00000000D+00
     .,0.45208310D+03,0.126D+03,0.430D+02,0.16483000D+01,0.00000000D+00
     .,0.34423220D+03,0.126D+03,0.440D+02,0.16483000D+01,0.00000000D+00
     .,0.37640450D+03,0.126D+03,0.450D+02,0.16483000D+01,0.00000000D+00
     .,0.34902580D+03,0.126D+03,0.460D+02,0.16483000D+01,0.00000000D+00
     .,0.29090830D+03,0.126D+03,0.470D+02,0.16483000D+01,0.00000000D+00
     .,0.30752090D+03,0.126D+03,0.480D+02,0.16483000D+01,0.00000000D+00
     .,0.38606280D+03,0.126D+03,0.490D+02,0.16483000D+01,0.00000000D+00
     .,0.35691590D+03,0.126D+03,0.500D+02,0.16483000D+01,0.00000000D+00
     .,0.31786240D+03,0.126D+03,0.510D+02,0.16483000D+01,0.00000000D+00
     .,0.29473480D+03,0.126D+03,0.520D+02,0.16483000D+01,0.00000000D+00
     .,0.26629100D+03,0.126D+03,0.530D+02,0.16483000D+01,0.00000000D+00
     .,0.23921900D+03,0.126D+03,0.540D+02,0.16483000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34201:  34300)=(/
     . 0.10130459D+04,0.126D+03,0.550D+02,0.16483000D+01,0.00000000D+00
     .,0.93186100D+03,0.126D+03,0.560D+02,0.16483000D+01,0.00000000D+00
     .,0.81889940D+03,0.126D+03,0.570D+02,0.16483000D+01,0.00000000D+00
     .,0.37545680D+03,0.126D+03,0.580D+02,0.16483000D+01,0.27991000D+01
     .,0.82577350D+03,0.126D+03,0.590D+02,0.16483000D+01,0.00000000D+00
     .,0.79302390D+03,0.126D+03,0.600D+02,0.16483000D+01,0.00000000D+00
     .,0.77315750D+03,0.126D+03,0.610D+02,0.16483000D+01,0.00000000D+00
     .,0.75488610D+03,0.126D+03,0.620D+02,0.16483000D+01,0.00000000D+00
     .,0.73868360D+03,0.126D+03,0.630D+02,0.16483000D+01,0.00000000D+00
     .,0.58077730D+03,0.126D+03,0.640D+02,0.16483000D+01,0.00000000D+00
     .,0.65347520D+03,0.126D+03,0.650D+02,0.16483000D+01,0.00000000D+00
     .,0.63025330D+03,0.126D+03,0.660D+02,0.16483000D+01,0.00000000D+00
     .,0.66633780D+03,0.126D+03,0.670D+02,0.16483000D+01,0.00000000D+00
     .,0.65221550D+03,0.126D+03,0.680D+02,0.16483000D+01,0.00000000D+00
     .,0.63947820D+03,0.126D+03,0.690D+02,0.16483000D+01,0.00000000D+00
     .,0.63201230D+03,0.126D+03,0.700D+02,0.16483000D+01,0.00000000D+00
     .,0.53244100D+03,0.126D+03,0.710D+02,0.16483000D+01,0.00000000D+00
     .,0.52361220D+03,0.126D+03,0.720D+02,0.16483000D+01,0.00000000D+00
     .,0.47773970D+03,0.126D+03,0.730D+02,0.16483000D+01,0.00000000D+00
     .,0.40318600D+03,0.126D+03,0.740D+02,0.16483000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34301:  34400)=(/
     . 0.41018490D+03,0.126D+03,0.750D+02,0.16483000D+01,0.00000000D+00
     .,0.37164480D+03,0.126D+03,0.760D+02,0.16483000D+01,0.00000000D+00
     .,0.34026720D+03,0.126D+03,0.770D+02,0.16483000D+01,0.00000000D+00
     .,0.28250560D+03,0.126D+03,0.780D+02,0.16483000D+01,0.00000000D+00
     .,0.26390350D+03,0.126D+03,0.790D+02,0.16483000D+01,0.00000000D+00
     .,0.27150750D+03,0.126D+03,0.800D+02,0.16483000D+01,0.00000000D+00
     .,0.39615750D+03,0.126D+03,0.810D+02,0.16483000D+01,0.00000000D+00
     .,0.38734040D+03,0.126D+03,0.820D+02,0.16483000D+01,0.00000000D+00
     .,0.35575280D+03,0.126D+03,0.830D+02,0.16483000D+01,0.00000000D+00
     .,0.33914780D+03,0.126D+03,0.840D+02,0.16483000D+01,0.00000000D+00
     .,0.31279910D+03,0.126D+03,0.850D+02,0.16483000D+01,0.00000000D+00
     .,0.28650170D+03,0.126D+03,0.860D+02,0.16483000D+01,0.00000000D+00
     .,0.95682050D+03,0.126D+03,0.870D+02,0.16483000D+01,0.00000000D+00
     .,0.92149130D+03,0.126D+03,0.880D+02,0.16483000D+01,0.00000000D+00
     .,0.81480800D+03,0.126D+03,0.890D+02,0.16483000D+01,0.00000000D+00
     .,0.73215470D+03,0.126D+03,0.900D+02,0.16483000D+01,0.00000000D+00
     .,0.72684330D+03,0.126D+03,0.910D+02,0.16483000D+01,0.00000000D+00
     .,0.70377870D+03,0.126D+03,0.920D+02,0.16483000D+01,0.00000000D+00
     .,0.72468840D+03,0.126D+03,0.930D+02,0.16483000D+01,0.00000000D+00
     .,0.70180630D+03,0.126D+03,0.940D+02,0.16483000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34401:  34500)=(/
     . 0.39274200D+02,0.126D+03,0.101D+03,0.16483000D+01,0.00000000D+00
     .,0.12754920D+03,0.126D+03,0.103D+03,0.16483000D+01,0.98650000D+00
     .,0.16261080D+03,0.126D+03,0.104D+03,0.16483000D+01,0.98080000D+00
     .,0.12411700D+03,0.126D+03,0.105D+03,0.16483000D+01,0.97060000D+00
     .,0.93384800D+02,0.126D+03,0.106D+03,0.16483000D+01,0.98680000D+00
     .,0.64846800D+02,0.126D+03,0.107D+03,0.16483000D+01,0.99440000D+00
     .,0.47181600D+02,0.126D+03,0.108D+03,0.16483000D+01,0.99250000D+00
     .,0.32432100D+02,0.126D+03,0.109D+03,0.16483000D+01,0.99820000D+00
     .,0.18646690D+03,0.126D+03,0.111D+03,0.16483000D+01,0.96840000D+00
     .,0.28833710D+03,0.126D+03,0.112D+03,0.16483000D+01,0.96280000D+00
     .,0.29202470D+03,0.126D+03,0.113D+03,0.16483000D+01,0.96480000D+00
     .,0.23448430D+03,0.126D+03,0.114D+03,0.16483000D+01,0.95070000D+00
     .,0.19184290D+03,0.126D+03,0.115D+03,0.16483000D+01,0.99470000D+00
     .,0.16207500D+03,0.126D+03,0.116D+03,0.16483000D+01,0.99480000D+00
     .,0.13234800D+03,0.126D+03,0.117D+03,0.16483000D+01,0.99720000D+00
     .,0.25675790D+03,0.126D+03,0.119D+03,0.16483000D+01,0.97670000D+00
     .,0.49074810D+03,0.126D+03,0.120D+03,0.16483000D+01,0.98310000D+00
     .,0.25688890D+03,0.126D+03,0.121D+03,0.16483000D+01,0.18627000D+01
     .,0.24796360D+03,0.126D+03,0.122D+03,0.16483000D+01,0.18299000D+01
     .,0.24301480D+03,0.126D+03,0.123D+03,0.16483000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  34501:  34600)=(/
     . 0.24078340D+03,0.126D+03,0.124D+03,0.16483000D+01,0.18269000D+01
     .,0.22153400D+03,0.126D+03,0.125D+03,0.16483000D+01,0.16406000D+01
     .,0.20499250D+03,0.126D+03,0.126D+03,0.16483000D+01,0.16483000D+01
     .,0.23231000D+02,0.127D+03,0.100D+01,0.17149000D+01,0.91180000D+00
     .,0.15354500D+02,0.127D+03,0.200D+01,0.17149000D+01,0.00000000D+00
     .,0.36237460D+03,0.127D+03,0.300D+01,0.17149000D+01,0.00000000D+00
     .,0.20922270D+03,0.127D+03,0.400D+01,0.17149000D+01,0.00000000D+00
     .,0.14074280D+03,0.127D+03,0.500D+01,0.17149000D+01,0.00000000D+00
     .,0.95005100D+02,0.127D+03,0.600D+01,0.17149000D+01,0.00000000D+00
     .,0.66421800D+02,0.127D+03,0.700D+01,0.17149000D+01,0.00000000D+00
     .,0.50301600D+02,0.127D+03,0.800D+01,0.17149000D+01,0.00000000D+00
     .,0.38131300D+02,0.127D+03,0.900D+01,0.17149000D+01,0.00000000D+00
     .,0.29359800D+02,0.127D+03,0.100D+02,0.17149000D+01,0.00000000D+00
     .,0.43337360D+03,0.127D+03,0.110D+02,0.17149000D+01,0.00000000D+00
     .,0.33347670D+03,0.127D+03,0.120D+02,0.17149000D+01,0.00000000D+00
     .,0.30725400D+03,0.127D+03,0.130D+02,0.17149000D+01,0.00000000D+00
     .,0.24191590D+03,0.127D+03,0.140D+02,0.17149000D+01,0.00000000D+00
     .,0.18848520D+03,0.127D+03,0.150D+02,0.17149000D+01,0.00000000D+00
     .,0.15634230D+03,0.127D+03,0.160D+02,0.17149000D+01,0.00000000D+00
     .,0.12765130D+03,0.127D+03,0.170D+02,0.17149000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34601:  34700)=(/
     . 0.10440910D+03,0.127D+03,0.180D+02,0.17149000D+01,0.00000000D+00
     .,0.71018180D+03,0.127D+03,0.190D+02,0.17149000D+01,0.00000000D+00
     .,0.58595780D+03,0.127D+03,0.200D+02,0.17149000D+01,0.00000000D+00
     .,0.48407230D+03,0.127D+03,0.210D+02,0.17149000D+01,0.00000000D+00
     .,0.46739840D+03,0.127D+03,0.220D+02,0.17149000D+01,0.00000000D+00
     .,0.42799360D+03,0.127D+03,0.230D+02,0.17149000D+01,0.00000000D+00
     .,0.33714360D+03,0.127D+03,0.240D+02,0.17149000D+01,0.00000000D+00
     .,0.36847190D+03,0.127D+03,0.250D+02,0.17149000D+01,0.00000000D+00
     .,0.28919370D+03,0.127D+03,0.260D+02,0.17149000D+01,0.00000000D+00
     .,0.30649680D+03,0.127D+03,0.270D+02,0.17149000D+01,0.00000000D+00
     .,0.31577130D+03,0.127D+03,0.280D+02,0.17149000D+01,0.00000000D+00
     .,0.24210300D+03,0.127D+03,0.290D+02,0.17149000D+01,0.00000000D+00
     .,0.24848550D+03,0.127D+03,0.300D+02,0.17149000D+01,0.00000000D+00
     .,0.29424080D+03,0.127D+03,0.310D+02,0.17149000D+01,0.00000000D+00
     .,0.25932240D+03,0.127D+03,0.320D+02,0.17149000D+01,0.00000000D+00
     .,0.22102330D+03,0.127D+03,0.330D+02,0.17149000D+01,0.00000000D+00
     .,0.19822130D+03,0.127D+03,0.340D+02,0.17149000D+01,0.00000000D+00
     .,0.17337930D+03,0.127D+03,0.350D+02,0.17149000D+01,0.00000000D+00
     .,0.15071900D+03,0.127D+03,0.360D+02,0.17149000D+01,0.00000000D+00
     .,0.79588590D+03,0.127D+03,0.370D+02,0.17149000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34701:  34800)=(/
     . 0.69807620D+03,0.127D+03,0.380D+02,0.17149000D+01,0.00000000D+00
     .,0.61134030D+03,0.127D+03,0.390D+02,0.17149000D+01,0.00000000D+00
     .,0.54932940D+03,0.127D+03,0.400D+02,0.17149000D+01,0.00000000D+00
     .,0.50083550D+03,0.127D+03,0.410D+02,0.17149000D+01,0.00000000D+00
     .,0.38652450D+03,0.127D+03,0.420D+02,0.17149000D+01,0.00000000D+00
     .,0.43134780D+03,0.127D+03,0.430D+02,0.17149000D+01,0.00000000D+00
     .,0.32850150D+03,0.127D+03,0.440D+02,0.17149000D+01,0.00000000D+00
     .,0.35910570D+03,0.127D+03,0.450D+02,0.17149000D+01,0.00000000D+00
     .,0.33298960D+03,0.127D+03,0.460D+02,0.17149000D+01,0.00000000D+00
     .,0.27768230D+03,0.127D+03,0.470D+02,0.17149000D+01,0.00000000D+00
     .,0.29340740D+03,0.127D+03,0.480D+02,0.17149000D+01,0.00000000D+00
     .,0.36832240D+03,0.127D+03,0.490D+02,0.17149000D+01,0.00000000D+00
     .,0.34042650D+03,0.127D+03,0.500D+02,0.17149000D+01,0.00000000D+00
     .,0.30318560D+03,0.127D+03,0.510D+02,0.17149000D+01,0.00000000D+00
     .,0.28116330D+03,0.127D+03,0.520D+02,0.17149000D+01,0.00000000D+00
     .,0.25408770D+03,0.127D+03,0.530D+02,0.17149000D+01,0.00000000D+00
     .,0.22832560D+03,0.127D+03,0.540D+02,0.17149000D+01,0.00000000D+00
     .,0.96954620D+03,0.127D+03,0.550D+02,0.17149000D+01,0.00000000D+00
     .,0.88993460D+03,0.127D+03,0.560D+02,0.17149000D+01,0.00000000D+00
     .,0.78163500D+03,0.127D+03,0.570D+02,0.17149000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34801:  34900)=(/
     . 0.35816770D+03,0.127D+03,0.580D+02,0.17149000D+01,0.27991000D+01
     .,0.78858090D+03,0.127D+03,0.590D+02,0.17149000D+01,0.00000000D+00
     .,0.75717110D+03,0.127D+03,0.600D+02,0.17149000D+01,0.00000000D+00
     .,0.73817480D+03,0.127D+03,0.610D+02,0.17149000D+01,0.00000000D+00
     .,0.72070520D+03,0.127D+03,0.620D+02,0.17149000D+01,0.00000000D+00
     .,0.70521290D+03,0.127D+03,0.630D+02,0.17149000D+01,0.00000000D+00
     .,0.55434620D+03,0.127D+03,0.640D+02,0.17149000D+01,0.00000000D+00
     .,0.62444810D+03,0.127D+03,0.650D+02,0.17149000D+01,0.00000000D+00
     .,0.60226720D+03,0.127D+03,0.660D+02,0.17149000D+01,0.00000000D+00
     .,0.63603570D+03,0.127D+03,0.670D+02,0.17149000D+01,0.00000000D+00
     .,0.62253720D+03,0.127D+03,0.680D+02,0.17149000D+01,0.00000000D+00
     .,0.61036000D+03,0.127D+03,0.690D+02,0.17149000D+01,0.00000000D+00
     .,0.60323520D+03,0.127D+03,0.700D+02,0.17149000D+01,0.00000000D+00
     .,0.50816310D+03,0.127D+03,0.710D+02,0.17149000D+01,0.00000000D+00
     .,0.49947010D+03,0.127D+03,0.720D+02,0.17149000D+01,0.00000000D+00
     .,0.45568660D+03,0.127D+03,0.730D+02,0.17149000D+01,0.00000000D+00
     .,0.38467230D+03,0.127D+03,0.740D+02,0.17149000D+01,0.00000000D+00
     .,0.39131100D+03,0.127D+03,0.750D+02,0.17149000D+01,0.00000000D+00
     .,0.35455820D+03,0.127D+03,0.760D+02,0.17149000D+01,0.00000000D+00
     .,0.32464910D+03,0.127D+03,0.770D+02,0.17149000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  34901:  35000)=(/
     . 0.26963380D+03,0.127D+03,0.780D+02,0.17149000D+01,0.00000000D+00
     .,0.25191510D+03,0.127D+03,0.790D+02,0.17149000D+01,0.00000000D+00
     .,0.25913820D+03,0.127D+03,0.800D+02,0.17149000D+01,0.00000000D+00
     .,0.37809130D+03,0.127D+03,0.810D+02,0.17149000D+01,0.00000000D+00
     .,0.36955020D+03,0.127D+03,0.820D+02,0.17149000D+01,0.00000000D+00
     .,0.33939390D+03,0.127D+03,0.830D+02,0.17149000D+01,0.00000000D+00
     .,0.32357100D+03,0.127D+03,0.840D+02,0.17149000D+01,0.00000000D+00
     .,0.29847990D+03,0.127D+03,0.850D+02,0.17149000D+01,0.00000000D+00
     .,0.27345010D+03,0.127D+03,0.860D+02,0.17149000D+01,0.00000000D+00
     .,0.91516100D+03,0.127D+03,0.870D+02,0.17149000D+01,0.00000000D+00
     .,0.87983390D+03,0.127D+03,0.880D+02,0.17149000D+01,0.00000000D+00
     .,0.77761650D+03,0.127D+03,0.890D+02,0.17149000D+01,0.00000000D+00
     .,0.69856190D+03,0.127D+03,0.900D+02,0.17149000D+01,0.00000000D+00
     .,0.69371430D+03,0.127D+03,0.910D+02,0.17149000D+01,0.00000000D+00
     .,0.67170070D+03,0.127D+03,0.920D+02,0.17149000D+01,0.00000000D+00
     .,0.69179850D+03,0.127D+03,0.930D+02,0.17149000D+01,0.00000000D+00
     .,0.66991580D+03,0.127D+03,0.940D+02,0.17149000D+01,0.00000000D+00
     .,0.37449600D+02,0.127D+03,0.101D+03,0.17149000D+01,0.00000000D+00
     .,0.12160370D+03,0.127D+03,0.103D+03,0.17149000D+01,0.98650000D+00
     .,0.15505540D+03,0.127D+03,0.104D+03,0.17149000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters(  35001:  35100)=(/
     . 0.11835300D+03,0.127D+03,0.105D+03,0.17149000D+01,0.97060000D+00
     .,0.89099200D+02,0.127D+03,0.106D+03,0.17149000D+01,0.98680000D+00
     .,0.61925600D+02,0.127D+03,0.107D+03,0.17149000D+01,0.99440000D+00
     .,0.45100200D+02,0.127D+03,0.108D+03,0.17149000D+01,0.99250000D+00
     .,0.31051600D+02,0.127D+03,0.109D+03,0.17149000D+01,0.99820000D+00
     .,0.17783550D+03,0.127D+03,0.111D+03,0.17149000D+01,0.96840000D+00
     .,0.27498400D+03,0.127D+03,0.112D+03,0.17149000D+01,0.96280000D+00
     .,0.27841730D+03,0.127D+03,0.113D+03,0.17149000D+01,0.96480000D+00
     .,0.22355480D+03,0.127D+03,0.114D+03,0.17149000D+01,0.95070000D+00
     .,0.18295110D+03,0.127D+03,0.115D+03,0.17149000D+01,0.99470000D+00
     .,0.15462430D+03,0.127D+03,0.116D+03,0.17149000D+01,0.99480000D+00
     .,0.12633190D+03,0.127D+03,0.117D+03,0.17149000D+01,0.99720000D+00
     .,0.24501880D+03,0.127D+03,0.119D+03,0.17149000D+01,0.97670000D+00
     .,0.46868990D+03,0.127D+03,0.120D+03,0.17149000D+01,0.98310000D+00
     .,0.24500350D+03,0.127D+03,0.121D+03,0.17149000D+01,0.18627000D+01
     .,0.23653250D+03,0.127D+03,0.122D+03,0.17149000D+01,0.18299000D+01
     .,0.23181800D+03,0.127D+03,0.123D+03,0.17149000D+01,0.19138000D+01
     .,0.22970220D+03,0.127D+03,0.124D+03,0.17149000D+01,0.18269000D+01
     .,0.21130250D+03,0.127D+03,0.125D+03,0.17149000D+01,0.16406000D+01
     .,0.19554300D+03,0.127D+03,0.126D+03,0.17149000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters(  35101:  35200)=(/
     . 0.18654620D+03,0.127D+03,0.127D+03,0.17149000D+01,0.17149000D+01
     .,0.22682200D+02,0.128D+03,0.100D+01,0.17937000D+01,0.91180000D+00
     .,0.14983300D+02,0.128D+03,0.200D+01,0.17937000D+01,0.00000000D+00
     .,0.35596060D+03,0.128D+03,0.300D+01,0.17937000D+01,0.00000000D+00
     .,0.20490860D+03,0.128D+03,0.400D+01,0.17937000D+01,0.00000000D+00
     .,0.13762540D+03,0.128D+03,0.500D+01,0.17937000D+01,0.00000000D+00
     .,0.92810700D+02,0.128D+03,0.600D+01,0.17937000D+01,0.00000000D+00
     .,0.64851900D+02,0.128D+03,0.700D+01,0.17937000D+01,0.00000000D+00
     .,0.49099600D+02,0.128D+03,0.800D+01,0.17937000D+01,0.00000000D+00
     .,0.37215800D+02,0.128D+03,0.900D+01,0.17937000D+01,0.00000000D+00
     .,0.28655400D+02,0.128D+03,0.100D+02,0.17937000D+01,0.00000000D+00
     .,0.42564550D+03,0.128D+03,0.110D+02,0.17937000D+01,0.00000000D+00
     .,0.32678640D+03,0.128D+03,0.120D+02,0.17937000D+01,0.00000000D+00
     .,0.30082710D+03,0.128D+03,0.130D+02,0.17937000D+01,0.00000000D+00
     .,0.23659520D+03,0.128D+03,0.140D+02,0.17937000D+01,0.00000000D+00
     .,0.18418470D+03,0.128D+03,0.150D+02,0.17937000D+01,0.00000000D+00
     .,0.15270360D+03,0.128D+03,0.160D+02,0.17937000D+01,0.00000000D+00
     .,0.12463170D+03,0.128D+03,0.170D+02,0.17937000D+01,0.00000000D+00
     .,0.10191160D+03,0.128D+03,0.180D+02,0.17937000D+01,0.00000000D+00
     .,0.69776500D+03,0.128D+03,0.190D+02,0.17937000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  35201:  35300)=(/
     . 0.57475220D+03,0.128D+03,0.200D+02,0.17937000D+01,0.00000000D+00
     .,0.47462540D+03,0.128D+03,0.210D+02,0.17937000D+01,0.00000000D+00
     .,0.45811360D+03,0.128D+03,0.220D+02,0.17937000D+01,0.00000000D+00
     .,0.41940370D+03,0.128D+03,0.230D+02,0.17937000D+01,0.00000000D+00
     .,0.33038080D+03,0.128D+03,0.240D+02,0.17937000D+01,0.00000000D+00
     .,0.36096920D+03,0.128D+03,0.250D+02,0.17937000D+01,0.00000000D+00
     .,0.28330110D+03,0.128D+03,0.260D+02,0.17937000D+01,0.00000000D+00
     .,0.30010550D+03,0.128D+03,0.270D+02,0.17937000D+01,0.00000000D+00
     .,0.30925430D+03,0.128D+03,0.280D+02,0.17937000D+01,0.00000000D+00
     .,0.23712000D+03,0.128D+03,0.290D+02,0.17937000D+01,0.00000000D+00
     .,0.24319600D+03,0.128D+03,0.300D+02,0.17937000D+01,0.00000000D+00
     .,0.28800730D+03,0.128D+03,0.310D+02,0.17937000D+01,0.00000000D+00
     .,0.25361340D+03,0.128D+03,0.320D+02,0.17937000D+01,0.00000000D+00
     .,0.21600430D+03,0.128D+03,0.330D+02,0.17937000D+01,0.00000000D+00
     .,0.19364320D+03,0.128D+03,0.340D+02,0.17937000D+01,0.00000000D+00
     .,0.16931330D+03,0.128D+03,0.350D+02,0.17937000D+01,0.00000000D+00
     .,0.14714170D+03,0.128D+03,0.360D+02,0.17937000D+01,0.00000000D+00
     .,0.78184410D+03,0.128D+03,0.370D+02,0.17937000D+01,0.00000000D+00
     .,0.68477150D+03,0.128D+03,0.380D+02,0.17937000D+01,0.00000000D+00
     .,0.59926520D+03,0.128D+03,0.390D+02,0.17937000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  35301:  35400)=(/
     . 0.53824800D+03,0.128D+03,0.400D+02,0.17937000D+01,0.00000000D+00
     .,0.49059730D+03,0.128D+03,0.410D+02,0.17937000D+01,0.00000000D+00
     .,0.37845940D+03,0.128D+03,0.420D+02,0.17937000D+01,0.00000000D+00
     .,0.42241440D+03,0.128D+03,0.430D+02,0.17937000D+01,0.00000000D+00
     .,0.32155060D+03,0.128D+03,0.440D+02,0.17937000D+01,0.00000000D+00
     .,0.35149860D+03,0.128D+03,0.450D+02,0.17937000D+01,0.00000000D+00
     .,0.32588580D+03,0.128D+03,0.460D+02,0.17937000D+01,0.00000000D+00
     .,0.27180880D+03,0.128D+03,0.470D+02,0.17937000D+01,0.00000000D+00
     .,0.28709580D+03,0.128D+03,0.480D+02,0.17937000D+01,0.00000000D+00
     .,0.36057310D+03,0.128D+03,0.490D+02,0.17937000D+01,0.00000000D+00
     .,0.33303010D+03,0.128D+03,0.500D+02,0.17937000D+01,0.00000000D+00
     .,0.29640640D+03,0.128D+03,0.510D+02,0.17937000D+01,0.00000000D+00
     .,0.27477510D+03,0.128D+03,0.520D+02,0.17937000D+01,0.00000000D+00
     .,0.24822370D+03,0.128D+03,0.530D+02,0.17937000D+01,0.00000000D+00
     .,0.22298560D+03,0.128D+03,0.540D+02,0.17937000D+01,0.00000000D+00
     .,0.95234010D+03,0.128D+03,0.550D+02,0.17937000D+01,0.00000000D+00
     .,0.87316220D+03,0.128D+03,0.560D+02,0.17937000D+01,0.00000000D+00
     .,0.76636770D+03,0.128D+03,0.570D+02,0.17937000D+01,0.00000000D+00
     .,0.35020540D+03,0.128D+03,0.580D+02,0.17937000D+01,0.27991000D+01
     .,0.77355490D+03,0.128D+03,0.590D+02,0.17937000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  35401:  35500)=(/
     . 0.74267570D+03,0.128D+03,0.600D+02,0.17937000D+01,0.00000000D+00
     .,0.72402070D+03,0.128D+03,0.610D+02,0.17937000D+01,0.00000000D+00
     .,0.70686710D+03,0.128D+03,0.620D+02,0.17937000D+01,0.00000000D+00
     .,0.69165380D+03,0.128D+03,0.630D+02,0.17937000D+01,0.00000000D+00
     .,0.54327420D+03,0.128D+03,0.640D+02,0.17937000D+01,0.00000000D+00
     .,0.61263290D+03,0.128D+03,0.650D+02,0.17937000D+01,0.00000000D+00
     .,0.59076940D+03,0.128D+03,0.660D+02,0.17937000D+01,0.00000000D+00
     .,0.62369960D+03,0.128D+03,0.670D+02,0.17937000D+01,0.00000000D+00
     .,0.61045110D+03,0.128D+03,0.680D+02,0.17937000D+01,0.00000000D+00
     .,0.59849350D+03,0.128D+03,0.690D+02,0.17937000D+01,0.00000000D+00
     .,0.59152550D+03,0.128D+03,0.700D+02,0.17937000D+01,0.00000000D+00
     .,0.49802530D+03,0.128D+03,0.710D+02,0.17937000D+01,0.00000000D+00
     .,0.48915250D+03,0.128D+03,0.720D+02,0.17937000D+01,0.00000000D+00
     .,0.44609160D+03,0.128D+03,0.730D+02,0.17937000D+01,0.00000000D+00
     .,0.37646650D+03,0.128D+03,0.740D+02,0.17937000D+01,0.00000000D+00
     .,0.38290120D+03,0.128D+03,0.750D+02,0.17937000D+01,0.00000000D+00
     .,0.34682510D+03,0.128D+03,0.760D+02,0.17937000D+01,0.00000000D+00
     .,0.31748840D+03,0.128D+03,0.770D+02,0.17937000D+01,0.00000000D+00
     .,0.26363220D+03,0.128D+03,0.780D+02,0.17937000D+01,0.00000000D+00
     .,0.24629020D+03,0.128D+03,0.790D+02,0.17937000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  35501:  35600)=(/
     . 0.25331490D+03,0.128D+03,0.800D+02,0.17937000D+01,0.00000000D+00
     .,0.37009330D+03,0.128D+03,0.810D+02,0.17937000D+01,0.00000000D+00
     .,0.36153570D+03,0.128D+03,0.820D+02,0.17937000D+01,0.00000000D+00
     .,0.33183930D+03,0.128D+03,0.830D+02,0.17937000D+01,0.00000000D+00
     .,0.31626530D+03,0.128D+03,0.840D+02,0.17937000D+01,0.00000000D+00
     .,0.29163450D+03,0.128D+03,0.850D+02,0.17937000D+01,0.00000000D+00
     .,0.26709740D+03,0.128D+03,0.860D+02,0.17937000D+01,0.00000000D+00
     .,0.89847060D+03,0.128D+03,0.870D+02,0.17937000D+01,0.00000000D+00
     .,0.86294020D+03,0.128D+03,0.880D+02,0.17937000D+01,0.00000000D+00
     .,0.76220730D+03,0.128D+03,0.890D+02,0.17937000D+01,0.00000000D+00
     .,0.68424210D+03,0.128D+03,0.900D+02,0.17937000D+01,0.00000000D+00
     .,0.67974920D+03,0.128D+03,0.910D+02,0.17937000D+01,0.00000000D+00
     .,0.65817270D+03,0.128D+03,0.920D+02,0.17937000D+01,0.00000000D+00
     .,0.67818560D+03,0.128D+03,0.930D+02,0.17937000D+01,0.00000000D+00
     .,0.65668000D+03,0.128D+03,0.940D+02,0.17937000D+01,0.00000000D+00
     .,0.36590100D+02,0.128D+03,0.101D+03,0.17937000D+01,0.00000000D+00
     .,0.11907250D+03,0.128D+03,0.103D+03,0.17937000D+01,0.98650000D+00
     .,0.15177980D+03,0.128D+03,0.104D+03,0.17937000D+01,0.98080000D+00
     .,0.11570000D+03,0.128D+03,0.105D+03,0.17937000D+01,0.97060000D+00
     .,0.87043200D+02,0.128D+03,0.106D+03,0.17937000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  35601:  35700)=(/
     . 0.60460800D+02,0.128D+03,0.107D+03,0.17937000D+01,0.99440000D+00
     .,0.44017300D+02,0.128D+03,0.108D+03,0.17937000D+01,0.99250000D+00
     .,0.30300400D+02,0.128D+03,0.109D+03,0.17937000D+01,0.99820000D+00
     .,0.17420010D+03,0.128D+03,0.111D+03,0.17937000D+01,0.96840000D+00
     .,0.26937790D+03,0.128D+03,0.112D+03,0.17937000D+01,0.96280000D+00
     .,0.27254090D+03,0.128D+03,0.113D+03,0.17937000D+01,0.96480000D+00
     .,0.21860660D+03,0.128D+03,0.114D+03,0.17937000D+01,0.95070000D+00
     .,0.17877350D+03,0.128D+03,0.115D+03,0.17937000D+01,0.99470000D+00
     .,0.15102860D+03,0.128D+03,0.116D+03,0.17937000D+01,0.99480000D+00
     .,0.12334570D+03,0.128D+03,0.117D+03,0.17937000D+01,0.99720000D+00
     .,0.23988490D+03,0.128D+03,0.119D+03,0.17937000D+01,0.97670000D+00
     .,0.45968120D+03,0.128D+03,0.120D+03,0.17937000D+01,0.98310000D+00
     .,0.23965630D+03,0.128D+03,0.121D+03,0.17937000D+01,0.18627000D+01
     .,0.23136310D+03,0.128D+03,0.122D+03,0.17937000D+01,0.18299000D+01
     .,0.22676010D+03,0.128D+03,0.123D+03,0.17937000D+01,0.19138000D+01
     .,0.22471760D+03,0.128D+03,0.124D+03,0.17937000D+01,0.18269000D+01
     .,0.20661260D+03,0.128D+03,0.125D+03,0.17937000D+01,0.16406000D+01
     .,0.19117980D+03,0.128D+03,0.126D+03,0.17937000D+01,0.16483000D+01
     .,0.18238760D+03,0.128D+03,0.127D+03,0.17937000D+01,0.17149000D+01
     .,0.17833110D+03,0.128D+03,0.128D+03,0.17937000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters(  35701:  35800)=(/
     . 0.22155000D+02,0.129D+03,0.100D+01,0.95760000D+00,0.91180000D+00
     .,0.14514700D+02,0.129D+03,0.200D+01,0.95760000D+00,0.00000000D+00
     .,0.36743080D+03,0.129D+03,0.300D+01,0.95760000D+00,0.00000000D+00
     .,0.20593130D+03,0.129D+03,0.400D+01,0.95760000D+00,0.00000000D+00
     .,0.13637050D+03,0.129D+03,0.500D+01,0.95760000D+00,0.00000000D+00
     .,0.91102500D+02,0.129D+03,0.600D+01,0.95760000D+00,0.00000000D+00
     .,0.63270900D+02,0.129D+03,0.700D+01,0.95760000D+00,0.00000000D+00
     .,0.47723900D+02,0.129D+03,0.800D+01,0.95760000D+00,0.00000000D+00
     .,0.36074900D+02,0.129D+03,0.900D+01,0.95760000D+00,0.00000000D+00
     .,0.27728200D+02,0.129D+03,0.100D+02,0.95760000D+00,0.00000000D+00
     .,0.43871980D+03,0.129D+03,0.110D+02,0.95760000D+00,0.00000000D+00
     .,0.33000180D+03,0.129D+03,0.120D+02,0.95760000D+00,0.00000000D+00
     .,0.30146500D+03,0.129D+03,0.130D+02,0.95760000D+00,0.00000000D+00
     .,0.23475480D+03,0.129D+03,0.140D+02,0.95760000D+00,0.00000000D+00
     .,0.18132670D+03,0.129D+03,0.150D+02,0.95760000D+00,0.00000000D+00
     .,0.14964210D+03,0.129D+03,0.160D+02,0.95760000D+00,0.00000000D+00
     .,0.12163290D+03,0.129D+03,0.170D+02,0.95760000D+00,0.00000000D+00
     .,0.99139800D+02,0.129D+03,0.180D+02,0.95760000D+00,0.00000000D+00
     .,0.72200020D+03,0.129D+03,0.190D+02,0.95760000D+00,0.00000000D+00
     .,0.58537040D+03,0.129D+03,0.200D+02,0.95760000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  35801:  35900)=(/
     . 0.48164720D+03,0.129D+03,0.210D+02,0.95760000D+00,0.00000000D+00
     .,0.46339240D+03,0.129D+03,0.220D+02,0.95760000D+00,0.00000000D+00
     .,0.42341930D+03,0.129D+03,0.230D+02,0.95760000D+00,0.00000000D+00
     .,0.33350140D+03,0.129D+03,0.240D+02,0.95760000D+00,0.00000000D+00
     .,0.36341710D+03,0.129D+03,0.250D+02,0.95760000D+00,0.00000000D+00
     .,0.28510180D+03,0.129D+03,0.260D+02,0.95760000D+00,0.00000000D+00
     .,0.30073560D+03,0.129D+03,0.270D+02,0.95760000D+00,0.00000000D+00
     .,0.31051330D+03,0.129D+03,0.280D+02,0.95760000D+00,0.00000000D+00
     .,0.23812070D+03,0.129D+03,0.290D+02,0.95760000D+00,0.00000000D+00
     .,0.24268930D+03,0.129D+03,0.300D+02,0.95760000D+00,0.00000000D+00
     .,0.28785200D+03,0.129D+03,0.310D+02,0.95760000D+00,0.00000000D+00
     .,0.25153860D+03,0.129D+03,0.320D+02,0.95760000D+00,0.00000000D+00
     .,0.21283460D+03,0.129D+03,0.330D+02,0.95760000D+00,0.00000000D+00
     .,0.19007710D+03,0.129D+03,0.340D+02,0.95760000D+00,0.00000000D+00
     .,0.16558600D+03,0.129D+03,0.350D+02,0.95760000D+00,0.00000000D+00
     .,0.14345250D+03,0.129D+03,0.360D+02,0.95760000D+00,0.00000000D+00
     .,0.80787860D+03,0.129D+03,0.370D+02,0.95760000D+00,0.00000000D+00
     .,0.69786230D+03,0.129D+03,0.380D+02,0.95760000D+00,0.00000000D+00
     .,0.60685850D+03,0.129D+03,0.390D+02,0.95760000D+00,0.00000000D+00
     .,0.54294990D+03,0.129D+03,0.400D+02,0.95760000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  35901:  36000)=(/
     . 0.49363630D+03,0.129D+03,0.410D+02,0.95760000D+00,0.00000000D+00
     .,0.37922990D+03,0.129D+03,0.420D+02,0.95760000D+00,0.00000000D+00
     .,0.42391540D+03,0.129D+03,0.430D+02,0.95760000D+00,0.00000000D+00
     .,0.32125020D+03,0.129D+03,0.440D+02,0.95760000D+00,0.00000000D+00
     .,0.35112220D+03,0.129D+03,0.450D+02,0.95760000D+00,0.00000000D+00
     .,0.32504660D+03,0.129D+03,0.460D+02,0.95760000D+00,0.00000000D+00
     .,0.27146340D+03,0.129D+03,0.470D+02,0.95760000D+00,0.00000000D+00
     .,0.28581800D+03,0.129D+03,0.480D+02,0.95760000D+00,0.00000000D+00
     .,0.36066260D+03,0.129D+03,0.490D+02,0.95760000D+00,0.00000000D+00
     .,0.33100630D+03,0.129D+03,0.500D+02,0.95760000D+00,0.00000000D+00
     .,0.29285890D+03,0.129D+03,0.510D+02,0.95760000D+00,0.00000000D+00
     .,0.27055260D+03,0.129D+03,0.520D+02,0.95760000D+00,0.00000000D+00
     .,0.24354750D+03,0.129D+03,0.530D+02,0.95760000D+00,0.00000000D+00
     .,0.21809290D+03,0.129D+03,0.540D+02,0.95760000D+00,0.00000000D+00
     .,0.98359160D+03,0.129D+03,0.550D+02,0.95760000D+00,0.00000000D+00
     .,0.89168850D+03,0.129D+03,0.560D+02,0.95760000D+00,0.00000000D+00
     .,0.77770700D+03,0.129D+03,0.570D+02,0.95760000D+00,0.00000000D+00
     .,0.34643740D+03,0.129D+03,0.580D+02,0.95760000D+00,0.27991000D+01
     .,0.78837610D+03,0.129D+03,0.590D+02,0.95760000D+00,0.00000000D+00
     .,0.75615770D+03,0.129D+03,0.600D+02,0.95760000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  36001:  36100)=(/
     . 0.73695090D+03,0.129D+03,0.610D+02,0.95760000D+00,0.00000000D+00
     .,0.71931180D+03,0.129D+03,0.620D+02,0.95760000D+00,0.00000000D+00
     .,0.70365920D+03,0.129D+03,0.630D+02,0.95760000D+00,0.00000000D+00
     .,0.54891190D+03,0.129D+03,0.640D+02,0.95760000D+00,0.00000000D+00
     .,0.62523960D+03,0.129D+03,0.650D+02,0.95760000D+00,0.00000000D+00
     .,0.60214160D+03,0.129D+03,0.660D+02,0.95760000D+00,0.00000000D+00
     .,0.63352600D+03,0.129D+03,0.670D+02,0.95760000D+00,0.00000000D+00
     .,0.61995970D+03,0.129D+03,0.680D+02,0.95760000D+00,0.00000000D+00
     .,0.60766330D+03,0.129D+03,0.690D+02,0.95760000D+00,0.00000000D+00
     .,0.60075720D+03,0.129D+03,0.700D+02,0.95760000D+00,0.00000000D+00
     .,0.50338410D+03,0.129D+03,0.710D+02,0.95760000D+00,0.00000000D+00
     .,0.49122120D+03,0.129D+03,0.720D+02,0.95760000D+00,0.00000000D+00
     .,0.44629550D+03,0.129D+03,0.730D+02,0.95760000D+00,0.00000000D+00
     .,0.37560840D+03,0.129D+03,0.740D+02,0.95760000D+00,0.00000000D+00
     .,0.38145840D+03,0.129D+03,0.750D+02,0.95760000D+00,0.00000000D+00
     .,0.34444290D+03,0.129D+03,0.760D+02,0.95760000D+00,0.00000000D+00
     .,0.31453250D+03,0.129D+03,0.770D+02,0.95760000D+00,0.00000000D+00
     .,0.26057850D+03,0.129D+03,0.780D+02,0.95760000D+00,0.00000000D+00
     .,0.24322040D+03,0.129D+03,0.790D+02,0.95760000D+00,0.00000000D+00
     .,0.24982310D+03,0.129D+03,0.800D+02,0.95760000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  36101:  36200)=(/
     . 0.36971340D+03,0.129D+03,0.810D+02,0.95760000D+00,0.00000000D+00
     .,0.35938220D+03,0.129D+03,0.820D+02,0.95760000D+00,0.00000000D+00
     .,0.32809610D+03,0.129D+03,0.830D+02,0.95760000D+00,0.00000000D+00
     .,0.31175430D+03,0.129D+03,0.840D+02,0.95760000D+00,0.00000000D+00
     .,0.28648030D+03,0.129D+03,0.850D+02,0.95760000D+00,0.00000000D+00
     .,0.26159230D+03,0.129D+03,0.860D+02,0.95760000D+00,0.00000000D+00
     .,0.92344480D+03,0.129D+03,0.870D+02,0.95760000D+00,0.00000000D+00
     .,0.87838880D+03,0.129D+03,0.880D+02,0.95760000D+00,0.00000000D+00
     .,0.77137100D+03,0.129D+03,0.890D+02,0.95760000D+00,0.00000000D+00
     .,0.68798510D+03,0.129D+03,0.900D+02,0.95760000D+00,0.00000000D+00
     .,0.68576140D+03,0.129D+03,0.910D+02,0.95760000D+00,0.00000000D+00
     .,0.66390850D+03,0.129D+03,0.920D+02,0.95760000D+00,0.00000000D+00
     .,0.68694090D+03,0.129D+03,0.930D+02,0.95760000D+00,0.00000000D+00
     .,0.66465810D+03,0.129D+03,0.940D+02,0.95760000D+00,0.00000000D+00
     .,0.35987100D+02,0.129D+03,0.101D+03,0.95760000D+00,0.00000000D+00
     .,0.11943970D+03,0.129D+03,0.103D+03,0.95760000D+00,0.98650000D+00
     .,0.15184260D+03,0.129D+03,0.104D+03,0.95760000D+00,0.98080000D+00
     .,0.11434660D+03,0.129D+03,0.105D+03,0.95760000D+00,0.97060000D+00
     .,0.85473100D+02,0.129D+03,0.106D+03,0.95760000D+00,0.98680000D+00
     .,0.58990300D+02,0.129D+03,0.107D+03,0.95760000D+00,0.99440000D+00
     ./)
      grimme_c6_parameters(  36201:  36300)=(/
     . 0.42745800D+02,0.129D+03,0.108D+03,0.95760000D+00,0.99250000D+00
     .,0.29280800D+02,0.129D+03,0.109D+03,0.95760000D+00,0.99820000D+00
     .,0.17525310D+03,0.129D+03,0.111D+03,0.95760000D+00,0.96840000D+00
     .,0.27127550D+03,0.129D+03,0.112D+03,0.95760000D+00,0.96280000D+00
     .,0.27263840D+03,0.129D+03,0.113D+03,0.95760000D+00,0.96480000D+00
     .,0.21661540D+03,0.129D+03,0.114D+03,0.95760000D+00,0.95070000D+00
     .,0.17596280D+03,0.129D+03,0.115D+03,0.95760000D+00,0.99470000D+00
     .,0.14802440D+03,0.129D+03,0.116D+03,0.95760000D+00,0.99480000D+00
     .,0.12039270D+03,0.129D+03,0.117D+03,0.95760000D+00,0.99720000D+00
     .,0.24017910D+03,0.129D+03,0.119D+03,0.95760000D+00,0.97670000D+00
     .,0.46791560D+03,0.129D+03,0.120D+03,0.95760000D+00,0.98310000D+00
     .,0.23801280D+03,0.129D+03,0.121D+03,0.95760000D+00,0.18627000D+01
     .,0.22972260D+03,0.129D+03,0.122D+03,0.95760000D+00,0.18299000D+01
     .,0.22520200D+03,0.129D+03,0.123D+03,0.95760000D+00,0.19138000D+01
     .,0.22340090D+03,0.129D+03,0.124D+03,0.95760000D+00,0.18269000D+01
     .,0.20444800D+03,0.129D+03,0.125D+03,0.95760000D+00,0.16406000D+01
     .,0.18894450D+03,0.129D+03,0.126D+03,0.95760000D+00,0.16483000D+01
     .,0.18027190D+03,0.129D+03,0.127D+03,0.95760000D+00,0.17149000D+01
     .,0.17633580D+03,0.129D+03,0.128D+03,0.95760000D+00,0.17937000D+01
     .,0.17499690D+03,0.129D+03,0.129D+03,0.95760000D+00,0.95760000D+00
     ./)
      grimme_c6_parameters(  36301:  36400)=(/
     . 0.21213900D+02,0.130D+03,0.100D+01,0.19419000D+01,0.91180000D+00
     .,0.14118500D+02,0.130D+03,0.200D+01,0.19419000D+01,0.00000000D+00
     .,0.31788260D+03,0.130D+03,0.300D+01,0.19419000D+01,0.00000000D+00
     .,0.18730120D+03,0.130D+03,0.400D+01,0.19419000D+01,0.00000000D+00
     .,0.12724880D+03,0.130D+03,0.500D+01,0.19419000D+01,0.00000000D+00
     .,0.86470900D+02,0.130D+03,0.600D+01,0.19419000D+01,0.00000000D+00
     .,0.60733100D+02,0.130D+03,0.700D+01,0.19419000D+01,0.00000000D+00
     .,0.46135500D+02,0.130D+03,0.800D+01,0.19419000D+01,0.00000000D+00
     .,0.35062900D+02,0.130D+03,0.900D+01,0.19419000D+01,0.00000000D+00
     .,0.27052400D+02,0.130D+03,0.100D+02,0.19419000D+01,0.00000000D+00
     .,0.38065680D+03,0.130D+03,0.110D+02,0.19419000D+01,0.00000000D+00
     .,0.29754400D+03,0.130D+03,0.120D+02,0.19419000D+01,0.00000000D+00
     .,0.27562990D+03,0.130D+03,0.130D+02,0.19419000D+01,0.00000000D+00
     .,0.21852820D+03,0.130D+03,0.140D+02,0.19419000D+01,0.00000000D+00
     .,0.17118890D+03,0.130D+03,0.150D+02,0.19419000D+01,0.00000000D+00
     .,0.14245910D+03,0.130D+03,0.160D+02,0.19419000D+01,0.00000000D+00
     .,0.11666370D+03,0.130D+03,0.170D+02,0.19419000D+01,0.00000000D+00
     .,0.95658600D+02,0.130D+03,0.180D+02,0.19419000D+01,0.00000000D+00
     .,0.62148410D+03,0.130D+03,0.190D+02,0.19419000D+01,0.00000000D+00
     .,0.51951820D+03,0.130D+03,0.200D+02,0.19419000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  36401:  36500)=(/
     . 0.43036750D+03,0.130D+03,0.210D+02,0.19419000D+01,0.00000000D+00
     .,0.41653280D+03,0.130D+03,0.220D+02,0.19419000D+01,0.00000000D+00
     .,0.38196290D+03,0.130D+03,0.230D+02,0.19419000D+01,0.00000000D+00
     .,0.30093230D+03,0.130D+03,0.240D+02,0.19419000D+01,0.00000000D+00
     .,0.32951960D+03,0.130D+03,0.250D+02,0.19419000D+01,0.00000000D+00
     .,0.25872900D+03,0.130D+03,0.260D+02,0.19419000D+01,0.00000000D+00
     .,0.27503810D+03,0.130D+03,0.270D+02,0.19419000D+01,0.00000000D+00
     .,0.28296560D+03,0.130D+03,0.280D+02,0.19419000D+01,0.00000000D+00
     .,0.21695700D+03,0.130D+03,0.290D+02,0.19419000D+01,0.00000000D+00
     .,0.22366220D+03,0.130D+03,0.300D+02,0.19419000D+01,0.00000000D+00
     .,0.26447240D+03,0.130D+03,0.310D+02,0.19419000D+01,0.00000000D+00
     .,0.23434070D+03,0.130D+03,0.320D+02,0.19419000D+01,0.00000000D+00
     .,0.20064080D+03,0.130D+03,0.330D+02,0.19419000D+01,0.00000000D+00
     .,0.18041890D+03,0.130D+03,0.340D+02,0.19419000D+01,0.00000000D+00
     .,0.15822130D+03,0.130D+03,0.350D+02,0.19419000D+01,0.00000000D+00
     .,0.13785900D+03,0.130D+03,0.360D+02,0.19419000D+01,0.00000000D+00
     .,0.69720120D+03,0.130D+03,0.370D+02,0.19419000D+01,0.00000000D+00
     .,0.61859280D+03,0.130D+03,0.380D+02,0.19419000D+01,0.00000000D+00
     .,0.54431400D+03,0.130D+03,0.390D+02,0.19419000D+01,0.00000000D+00
     .,0.49050970D+03,0.130D+03,0.400D+02,0.19419000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  36501:  36600)=(/
     . 0.44803280D+03,0.130D+03,0.410D+02,0.19419000D+01,0.00000000D+00
     .,0.34683870D+03,0.130D+03,0.420D+02,0.19419000D+01,0.00000000D+00
     .,0.38662560D+03,0.130D+03,0.430D+02,0.19419000D+01,0.00000000D+00
     .,0.29543070D+03,0.130D+03,0.440D+02,0.19419000D+01,0.00000000D+00
     .,0.32298310D+03,0.130D+03,0.450D+02,0.19419000D+01,0.00000000D+00
     .,0.29983170D+03,0.130D+03,0.460D+02,0.19419000D+01,0.00000000D+00
     .,0.24983480D+03,0.130D+03,0.470D+02,0.19419000D+01,0.00000000D+00
     .,0.26457160D+03,0.130D+03,0.480D+02,0.19419000D+01,0.00000000D+00
     .,0.33095850D+03,0.130D+03,0.490D+02,0.19419000D+01,0.00000000D+00
     .,0.30726350D+03,0.130D+03,0.500D+02,0.19419000D+01,0.00000000D+00
     .,0.27478160D+03,0.130D+03,0.510D+02,0.19419000D+01,0.00000000D+00
     .,0.25542890D+03,0.130D+03,0.520D+02,0.19419000D+01,0.00000000D+00
     .,0.23140060D+03,0.130D+03,0.530D+02,0.19419000D+01,0.00000000D+00
     .,0.20840550D+03,0.130D+03,0.540D+02,0.19419000D+01,0.00000000D+00
     .,0.84934460D+03,0.130D+03,0.550D+02,0.19419000D+01,0.00000000D+00
     .,0.78727710D+03,0.130D+03,0.560D+02,0.19419000D+01,0.00000000D+00
     .,0.69479590D+03,0.130D+03,0.570D+02,0.19419000D+01,0.00000000D+00
     .,0.32433650D+03,0.130D+03,0.580D+02,0.19419000D+01,0.27991000D+01
     .,0.69872430D+03,0.130D+03,0.590D+02,0.19419000D+01,0.00000000D+00
     .,0.67147320D+03,0.130D+03,0.600D+02,0.19419000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  36601:  36700)=(/
     . 0.65477760D+03,0.130D+03,0.610D+02,0.19419000D+01,0.00000000D+00
     .,0.63940750D+03,0.130D+03,0.620D+02,0.19419000D+01,0.00000000D+00
     .,0.62578200D+03,0.130D+03,0.630D+02,0.19419000D+01,0.00000000D+00
     .,0.49442430D+03,0.130D+03,0.640D+02,0.19419000D+01,0.00000000D+00
     .,0.55258030D+03,0.130D+03,0.650D+02,0.19419000D+01,0.00000000D+00
     .,0.53339380D+03,0.130D+03,0.660D+02,0.19419000D+01,0.00000000D+00
     .,0.56508580D+03,0.130D+03,0.670D+02,0.19419000D+01,0.00000000D+00
     .,0.55316870D+03,0.130D+03,0.680D+02,0.19419000D+01,0.00000000D+00
     .,0.54245160D+03,0.130D+03,0.690D+02,0.19419000D+01,0.00000000D+00
     .,0.53600770D+03,0.130D+03,0.700D+02,0.19419000D+01,0.00000000D+00
     .,0.45307620D+03,0.130D+03,0.710D+02,0.19419000D+01,0.00000000D+00
     .,0.44744320D+03,0.130D+03,0.720D+02,0.19419000D+01,0.00000000D+00
     .,0.40933690D+03,0.130D+03,0.730D+02,0.19419000D+01,0.00000000D+00
     .,0.34623600D+03,0.130D+03,0.740D+02,0.19419000D+01,0.00000000D+00
     .,0.35258880D+03,0.130D+03,0.750D+02,0.19419000D+01,0.00000000D+00
     .,0.32019590D+03,0.130D+03,0.760D+02,0.19419000D+01,0.00000000D+00
     .,0.29371130D+03,0.130D+03,0.770D+02,0.19419000D+01,0.00000000D+00
     .,0.24437210D+03,0.130D+03,0.780D+02,0.19419000D+01,0.00000000D+00
     .,0.22847850D+03,0.130D+03,0.790D+02,0.19419000D+01,0.00000000D+00
     .,0.23524690D+03,0.130D+03,0.800D+02,0.19419000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  36701:  36800)=(/
     . 0.34006610D+03,0.130D+03,0.810D+02,0.19419000D+01,0.00000000D+00
     .,0.33355770D+03,0.130D+03,0.820D+02,0.19419000D+01,0.00000000D+00
     .,0.30748710D+03,0.130D+03,0.830D+02,0.19419000D+01,0.00000000D+00
     .,0.29376220D+03,0.130D+03,0.840D+02,0.19419000D+01,0.00000000D+00
     .,0.27163520D+03,0.130D+03,0.850D+02,0.19419000D+01,0.00000000D+00
     .,0.24938090D+03,0.130D+03,0.860D+02,0.19419000D+01,0.00000000D+00
     .,0.80499020D+03,0.130D+03,0.870D+02,0.19419000D+01,0.00000000D+00
     .,0.78026750D+03,0.130D+03,0.880D+02,0.19419000D+01,0.00000000D+00
     .,0.69268280D+03,0.130D+03,0.890D+02,0.19419000D+01,0.00000000D+00
     .,0.62529330D+03,0.130D+03,0.900D+02,0.19419000D+01,0.00000000D+00
     .,0.61943840D+03,0.130D+03,0.910D+02,0.19419000D+01,0.00000000D+00
     .,0.59985590D+03,0.130D+03,0.920D+02,0.19419000D+01,0.00000000D+00
     .,0.61596070D+03,0.130D+03,0.930D+02,0.19419000D+01,0.00000000D+00
     .,0.59681690D+03,0.130D+03,0.940D+02,0.19419000D+01,0.00000000D+00
     .,0.34031200D+02,0.130D+03,0.101D+03,0.19419000D+01,0.00000000D+00
     .,0.10901270D+03,0.130D+03,0.103D+03,0.19419000D+01,0.98650000D+00
     .,0.13924200D+03,0.130D+03,0.104D+03,0.19419000D+01,0.98080000D+00
     .,0.10720260D+03,0.130D+03,0.105D+03,0.19419000D+01,0.97060000D+00
     .,0.81068600D+02,0.130D+03,0.106D+03,0.19419000D+01,0.98680000D+00
     .,0.56614000D+02,0.130D+03,0.107D+03,0.19419000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters(  36801:  36900)=(/
     . 0.41386200D+02,0.130D+03,0.108D+03,0.19419000D+01,0.99250000D+00
     .,0.28629100D+02,0.130D+03,0.109D+03,0.19419000D+01,0.99820000D+00
     .,0.15912280D+03,0.130D+03,0.111D+03,0.19419000D+01,0.96840000D+00
     .,0.24580540D+03,0.130D+03,0.112D+03,0.19419000D+01,0.96280000D+00
     .,0.25007300D+03,0.130D+03,0.113D+03,0.19419000D+01,0.96480000D+00
     .,0.20213060D+03,0.130D+03,0.114D+03,0.19419000D+01,0.95070000D+00
     .,0.16618870D+03,0.130D+03,0.115D+03,0.19419000D+01,0.99470000D+00
     .,0.14088040D+03,0.130D+03,0.116D+03,0.19419000D+01,0.99480000D+00
     .,0.11545010D+03,0.130D+03,0.117D+03,0.19419000D+01,0.99720000D+00
     .,0.21998520D+03,0.130D+03,0.119D+03,0.19419000D+01,0.97670000D+00
     .,0.41556380D+03,0.130D+03,0.120D+03,0.19419000D+01,0.98310000D+00
     .,0.22124670D+03,0.130D+03,0.121D+03,0.19419000D+01,0.18627000D+01
     .,0.21361910D+03,0.130D+03,0.122D+03,0.19419000D+01,0.18299000D+01
     .,0.20934280D+03,0.130D+03,0.123D+03,0.19419000D+01,0.19138000D+01
     .,0.20729260D+03,0.130D+03,0.124D+03,0.19419000D+01,0.18269000D+01
     .,0.19131250D+03,0.130D+03,0.125D+03,0.19419000D+01,0.16406000D+01
     .,0.17720340D+03,0.130D+03,0.126D+03,0.19419000D+01,0.16483000D+01
     .,0.16904610D+03,0.130D+03,0.127D+03,0.19419000D+01,0.17149000D+01
     .,0.16523610D+03,0.130D+03,0.128D+03,0.19419000D+01,0.17937000D+01
     .,0.16292360D+03,0.130D+03,0.129D+03,0.19419000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters(  36901:  37000)=(/
     . 0.15345280D+03,0.130D+03,0.130D+03,0.19419000D+01,0.19419000D+01
     .,0.33251500D+02,0.131D+03,0.100D+01,0.96010000D+00,0.91180000D+00
     .,0.20987400D+02,0.131D+03,0.200D+01,0.96010000D+00,0.00000000D+00
     .,0.60281040D+03,0.131D+03,0.300D+01,0.96010000D+00,0.00000000D+00
     .,0.32666720D+03,0.131D+03,0.400D+01,0.96010000D+00,0.00000000D+00
     .,0.21127560D+03,0.131D+03,0.500D+01,0.96010000D+00,0.00000000D+00
     .,0.13814970D+03,0.131D+03,0.600D+01,0.96010000D+00,0.00000000D+00
     .,0.94132900D+02,0.131D+03,0.700D+01,0.96010000D+00,0.00000000D+00
     .,0.69903900D+02,0.131D+03,0.800D+01,0.96010000D+00,0.00000000D+00
     .,0.52047600D+02,0.131D+03,0.900D+01,0.96010000D+00,0.00000000D+00
     .,0.39458700D+02,0.131D+03,0.100D+02,0.96010000D+00,0.00000000D+00
     .,0.71775310D+03,0.131D+03,0.110D+02,0.96010000D+00,0.00000000D+00
     .,0.52642360D+03,0.131D+03,0.120D+02,0.96010000D+00,0.00000000D+00
     .,0.47573180D+03,0.131D+03,0.130D+02,0.96010000D+00,0.00000000D+00
     .,0.36461100D+03,0.131D+03,0.140D+02,0.96010000D+00,0.00000000D+00
     .,0.27735230D+03,0.131D+03,0.150D+02,0.96010000D+00,0.00000000D+00
     .,0.22627960D+03,0.131D+03,0.160D+02,0.96010000D+00,0.00000000D+00
     .,0.18171780D+03,0.131D+03,0.170D+02,0.96010000D+00,0.00000000D+00
     .,0.14638550D+03,0.131D+03,0.180D+02,0.96010000D+00,0.00000000D+00
     .,0.11848327D+04,0.131D+03,0.190D+02,0.96010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37001:  37100)=(/
     . 0.94258280D+03,0.131D+03,0.200D+02,0.96010000D+00,0.00000000D+00
     .,0.77197630D+03,0.131D+03,0.210D+02,0.96010000D+00,0.00000000D+00
     .,0.73902810D+03,0.131D+03,0.220D+02,0.96010000D+00,0.00000000D+00
     .,0.67328230D+03,0.131D+03,0.230D+02,0.96010000D+00,0.00000000D+00
     .,0.52900060D+03,0.131D+03,0.240D+02,0.96010000D+00,0.00000000D+00
     .,0.57532290D+03,0.131D+03,0.250D+02,0.96010000D+00,0.00000000D+00
     .,0.44990400D+03,0.131D+03,0.260D+02,0.96010000D+00,0.00000000D+00
     .,0.47264010D+03,0.131D+03,0.270D+02,0.96010000D+00,0.00000000D+00
     .,0.48954990D+03,0.131D+03,0.280D+02,0.96010000D+00,0.00000000D+00
     .,0.37425370D+03,0.131D+03,0.290D+02,0.96010000D+00,0.00000000D+00
     .,0.37873290D+03,0.131D+03,0.300D+02,0.96010000D+00,0.00000000D+00
     .,0.45140030D+03,0.131D+03,0.310D+02,0.96010000D+00,0.00000000D+00
     .,0.38973700D+03,0.131D+03,0.320D+02,0.96010000D+00,0.00000000D+00
     .,0.32572680D+03,0.131D+03,0.330D+02,0.96010000D+00,0.00000000D+00
     .,0.28839340D+03,0.131D+03,0.340D+02,0.96010000D+00,0.00000000D+00
     .,0.24882110D+03,0.131D+03,0.350D+02,0.96010000D+00,0.00000000D+00
     .,0.21348210D+03,0.131D+03,0.360D+02,0.96010000D+00,0.00000000D+00
     .,0.13227322D+04,0.131D+03,0.370D+02,0.96010000D+00,0.00000000D+00
     .,0.11239167D+04,0.131D+03,0.380D+02,0.96010000D+00,0.00000000D+00
     .,0.96907770D+03,0.131D+03,0.390D+02,0.96010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37101:  37200)=(/
     . 0.86203630D+03,0.131D+03,0.400D+02,0.96010000D+00,0.00000000D+00
     .,0.78048050D+03,0.131D+03,0.410D+02,0.96010000D+00,0.00000000D+00
     .,0.59457650D+03,0.131D+03,0.420D+02,0.96010000D+00,0.00000000D+00
     .,0.66676010D+03,0.131D+03,0.430D+02,0.96010000D+00,0.00000000D+00
     .,0.50051620D+03,0.131D+03,0.440D+02,0.96010000D+00,0.00000000D+00
     .,0.54783460D+03,0.131D+03,0.450D+02,0.96010000D+00,0.00000000D+00
     .,0.50566980D+03,0.131D+03,0.460D+02,0.96010000D+00,0.00000000D+00
     .,0.42174200D+03,0.131D+03,0.470D+02,0.96010000D+00,0.00000000D+00
     .,0.44286390D+03,0.131D+03,0.480D+02,0.96010000D+00,0.00000000D+00
     .,0.56415640D+03,0.131D+03,0.490D+02,0.96010000D+00,0.00000000D+00
     .,0.51303150D+03,0.131D+03,0.500D+02,0.96010000D+00,0.00000000D+00
     .,0.44930060D+03,0.131D+03,0.510D+02,0.96010000D+00,0.00000000D+00
     .,0.41227930D+03,0.131D+03,0.520D+02,0.96010000D+00,0.00000000D+00
     .,0.36821830D+03,0.131D+03,0.530D+02,0.96010000D+00,0.00000000D+00
     .,0.32708380D+03,0.131D+03,0.540D+02,0.96010000D+00,0.00000000D+00
     .,0.16098951D+04,0.131D+03,0.550D+02,0.96010000D+00,0.00000000D+00
     .,0.14393610D+04,0.131D+03,0.560D+02,0.96010000D+00,0.00000000D+00
     .,0.12450382D+04,0.131D+03,0.570D+02,0.96010000D+00,0.00000000D+00
     .,0.53206830D+03,0.131D+03,0.580D+02,0.96010000D+00,0.27991000D+01
     .,0.12682581D+04,0.131D+03,0.590D+02,0.96010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37201:  37300)=(/
     . 0.12147867D+04,0.131D+03,0.600D+02,0.96010000D+00,0.00000000D+00
     .,0.11834931D+04,0.131D+03,0.610D+02,0.96010000D+00,0.00000000D+00
     .,0.11548172D+04,0.131D+03,0.620D+02,0.96010000D+00,0.00000000D+00
     .,0.11293623D+04,0.131D+03,0.630D+02,0.96010000D+00,0.00000000D+00
     .,0.87169660D+03,0.131D+03,0.640D+02,0.96010000D+00,0.00000000D+00
     .,0.10061273D+04,0.131D+03,0.650D+02,0.96010000D+00,0.00000000D+00
     .,0.96741930D+03,0.131D+03,0.660D+02,0.96010000D+00,0.00000000D+00
     .,0.10147443D+04,0.131D+03,0.670D+02,0.96010000D+00,0.00000000D+00
     .,0.99283980D+03,0.131D+03,0.680D+02,0.96010000D+00,0.00000000D+00
     .,0.97287530D+03,0.131D+03,0.690D+02,0.96010000D+00,0.00000000D+00
     .,0.96226810D+03,0.131D+03,0.700D+02,0.96010000D+00,0.00000000D+00
     .,0.80056070D+03,0.131D+03,0.710D+02,0.96010000D+00,0.00000000D+00
     .,0.77479490D+03,0.131D+03,0.720D+02,0.96010000D+00,0.00000000D+00
     .,0.69954820D+03,0.131D+03,0.730D+02,0.96010000D+00,0.00000000D+00
     .,0.58500690D+03,0.131D+03,0.740D+02,0.96010000D+00,0.00000000D+00
     .,0.59290660D+03,0.131D+03,0.750D+02,0.96010000D+00,0.00000000D+00
     .,0.53219500D+03,0.131D+03,0.760D+02,0.96010000D+00,0.00000000D+00
     .,0.48350900D+03,0.131D+03,0.770D+02,0.96010000D+00,0.00000000D+00
     .,0.39773910D+03,0.131D+03,0.780D+02,0.96010000D+00,0.00000000D+00
     .,0.37015170D+03,0.131D+03,0.790D+02,0.96010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37301:  37400)=(/
     . 0.37970920D+03,0.131D+03,0.800D+02,0.96010000D+00,0.00000000D+00
     .,0.57562810D+03,0.131D+03,0.810D+02,0.96010000D+00,0.00000000D+00
     .,0.55583070D+03,0.131D+03,0.820D+02,0.96010000D+00,0.00000000D+00
     .,0.50298850D+03,0.131D+03,0.830D+02,0.96010000D+00,0.00000000D+00
     .,0.47531340D+03,0.131D+03,0.840D+02,0.96010000D+00,0.00000000D+00
     .,0.43366250D+03,0.131D+03,0.850D+02,0.96010000D+00,0.00000000D+00
     .,0.39318500D+03,0.131D+03,0.860D+02,0.96010000D+00,0.00000000D+00
     .,0.15014541D+04,0.131D+03,0.870D+02,0.96010000D+00,0.00000000D+00
     .,0.14115217D+04,0.131D+03,0.880D+02,0.96010000D+00,0.00000000D+00
     .,0.12297307D+04,0.131D+03,0.890D+02,0.96010000D+00,0.00000000D+00
     .,0.10857394D+04,0.131D+03,0.900D+02,0.96010000D+00,0.00000000D+00
     .,0.10865380D+04,0.131D+03,0.910D+02,0.96010000D+00,0.00000000D+00
     .,0.10514942D+04,0.131D+03,0.920D+02,0.96010000D+00,0.00000000D+00
     .,0.10941031D+04,0.131D+03,0.930D+02,0.96010000D+00,0.00000000D+00
     .,0.10575095D+04,0.131D+03,0.940D+02,0.96010000D+00,0.00000000D+00
     .,0.54991900D+02,0.131D+03,0.101D+03,0.96010000D+00,0.00000000D+00
     .,0.18876220D+03,0.131D+03,0.103D+03,0.96010000D+00,0.98650000D+00
     .,0.23890680D+03,0.131D+03,0.104D+03,0.96010000D+00,0.98080000D+00
     .,0.17609760D+03,0.131D+03,0.105D+03,0.96010000D+00,0.97060000D+00
     .,0.12956700D+03,0.131D+03,0.106D+03,0.96010000D+00,0.98680000D+00
     ./)
      grimme_c6_parameters(  37401:  37500)=(/
     . 0.87664500D+02,0.131D+03,0.107D+03,0.96010000D+00,0.99440000D+00
     .,0.62352200D+02,0.131D+03,0.108D+03,0.96010000D+00,0.99250000D+00
     .,0.41590900D+02,0.131D+03,0.109D+03,0.96010000D+00,0.99820000D+00
     .,0.27751430D+03,0.131D+03,0.111D+03,0.96010000D+00,0.96840000D+00
     .,0.43082970D+03,0.131D+03,0.112D+03,0.96010000D+00,0.96280000D+00
     .,0.42895210D+03,0.131D+03,0.113D+03,0.96010000D+00,0.96480000D+00
     .,0.33552060D+03,0.131D+03,0.114D+03,0.96010000D+00,0.95070000D+00
     .,0.26893700D+03,0.131D+03,0.115D+03,0.96010000D+00,0.99470000D+00
     .,0.22384530D+03,0.131D+03,0.116D+03,0.96010000D+00,0.99480000D+00
     .,0.17986830D+03,0.131D+03,0.117D+03,0.96010000D+00,0.99720000D+00
     .,0.37584950D+03,0.131D+03,0.119D+03,0.96010000D+00,0.97670000D+00
     .,0.75181440D+03,0.131D+03,0.120D+03,0.96010000D+00,0.98310000D+00
     .,0.36854170D+03,0.131D+03,0.121D+03,0.96010000D+00,0.18627000D+01
     .,0.35534980D+03,0.131D+03,0.122D+03,0.96010000D+00,0.18299000D+01
     .,0.34832930D+03,0.131D+03,0.123D+03,0.96010000D+00,0.19138000D+01
     .,0.34597960D+03,0.131D+03,0.124D+03,0.96010000D+00,0.18269000D+01
     .,0.31442440D+03,0.131D+03,0.125D+03,0.96010000D+00,0.16406000D+01
     .,0.28975880D+03,0.131D+03,0.126D+03,0.96010000D+00,0.16483000D+01
     .,0.27631300D+03,0.131D+03,0.127D+03,0.96010000D+00,0.17149000D+01
     .,0.27040230D+03,0.131D+03,0.128D+03,0.96010000D+00,0.17937000D+01
     ./)
      grimme_c6_parameters(  37501:  37600)=(/
     . 0.26973440D+03,0.131D+03,0.129D+03,0.96010000D+00,0.95760000D+00
     .,0.24870030D+03,0.131D+03,0.130D+03,0.96010000D+00,0.19419000D+01
     .,0.42164970D+03,0.131D+03,0.131D+03,0.96010000D+00,0.96010000D+00
     .,0.29952700D+02,0.132D+03,0.100D+01,0.94340000D+00,0.91180000D+00
     .,0.19376100D+02,0.132D+03,0.200D+01,0.94340000D+00,0.00000000D+00
     .,0.48401650D+03,0.132D+03,0.300D+01,0.94340000D+00,0.00000000D+00
     .,0.27657170D+03,0.132D+03,0.400D+01,0.94340000D+00,0.00000000D+00
     .,0.18420550D+03,0.132D+03,0.500D+01,0.94340000D+00,0.00000000D+00
     .,0.12305740D+03,0.132D+03,0.600D+01,0.94340000D+00,0.00000000D+00
     .,0.85162100D+02,0.132D+03,0.700D+01,0.94340000D+00,0.00000000D+00
     .,0.63924500D+02,0.132D+03,0.800D+01,0.94340000D+00,0.00000000D+00
     .,0.48023300D+02,0.132D+03,0.900D+01,0.94340000D+00,0.00000000D+00
     .,0.36661500D+02,0.132D+03,0.100D+02,0.94340000D+00,0.00000000D+00
     .,0.57808820D+03,0.132D+03,0.110D+02,0.94340000D+00,0.00000000D+00
     .,0.44152390D+03,0.132D+03,0.120D+02,0.94340000D+00,0.00000000D+00
     .,0.40516110D+03,0.132D+03,0.130D+02,0.94340000D+00,0.00000000D+00
     .,0.31697000D+03,0.132D+03,0.140D+02,0.94340000D+00,0.00000000D+00
     .,0.24526830D+03,0.132D+03,0.150D+02,0.94340000D+00,0.00000000D+00
     .,0.20228630D+03,0.132D+03,0.160D+02,0.94340000D+00,0.00000000D+00
     .,0.16412660D+03,0.132D+03,0.170D+02,0.94340000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37601:  37700)=(/
     . 0.13337940D+03,0.132D+03,0.180D+02,0.94340000D+00,0.00000000D+00
     .,0.94657560D+03,0.132D+03,0.190D+02,0.94340000D+00,0.00000000D+00
     .,0.77753610D+03,0.132D+03,0.200D+02,0.94340000D+00,0.00000000D+00
     .,0.64140640D+03,0.132D+03,0.210D+02,0.94340000D+00,0.00000000D+00
     .,0.61804010D+03,0.132D+03,0.220D+02,0.94340000D+00,0.00000000D+00
     .,0.56526390D+03,0.132D+03,0.230D+02,0.94340000D+00,0.00000000D+00
     .,0.44441960D+03,0.132D+03,0.240D+02,0.94340000D+00,0.00000000D+00
     .,0.48576480D+03,0.132D+03,0.250D+02,0.94340000D+00,0.00000000D+00
     .,0.38038530D+03,0.132D+03,0.260D+02,0.94340000D+00,0.00000000D+00
     .,0.40291460D+03,0.132D+03,0.270D+02,0.94340000D+00,0.00000000D+00
     .,0.41564390D+03,0.132D+03,0.280D+02,0.94340000D+00,0.00000000D+00
     .,0.31786240D+03,0.132D+03,0.290D+02,0.94340000D+00,0.00000000D+00
     .,0.32569280D+03,0.132D+03,0.300D+02,0.94340000D+00,0.00000000D+00
     .,0.38671290D+03,0.132D+03,0.310D+02,0.94340000D+00,0.00000000D+00
     .,0.33924040D+03,0.132D+03,0.320D+02,0.94340000D+00,0.00000000D+00
     .,0.28758470D+03,0.132D+03,0.330D+02,0.94340000D+00,0.00000000D+00
     .,0.25685170D+03,0.132D+03,0.340D+02,0.94340000D+00,0.00000000D+00
     .,0.22357440D+03,0.132D+03,0.350D+02,0.94340000D+00,0.00000000D+00
     .,0.19336340D+03,0.132D+03,0.360D+02,0.94340000D+00,0.00000000D+00
     .,0.10596044D+04,0.132D+03,0.370D+02,0.94340000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37701:  37800)=(/
     . 0.92600250D+03,0.132D+03,0.380D+02,0.94340000D+00,0.00000000D+00
     .,0.80859910D+03,0.132D+03,0.390D+02,0.94340000D+00,0.00000000D+00
     .,0.72498050D+03,0.132D+03,0.400D+02,0.94340000D+00,0.00000000D+00
     .,0.65980390D+03,0.132D+03,0.410D+02,0.94340000D+00,0.00000000D+00
     .,0.50715030D+03,0.132D+03,0.420D+02,0.94340000D+00,0.00000000D+00
     .,0.56682940D+03,0.132D+03,0.430D+02,0.94340000D+00,0.00000000D+00
     .,0.42969960D+03,0.132D+03,0.440D+02,0.94340000D+00,0.00000000D+00
     .,0.47030780D+03,0.132D+03,0.450D+02,0.94340000D+00,0.00000000D+00
     .,0.43552680D+03,0.132D+03,0.460D+02,0.94340000D+00,0.00000000D+00
     .,0.36250760D+03,0.132D+03,0.470D+02,0.94340000D+00,0.00000000D+00
     .,0.38302040D+03,0.132D+03,0.480D+02,0.94340000D+00,0.00000000D+00
     .,0.48291150D+03,0.132D+03,0.490D+02,0.94340000D+00,0.00000000D+00
     .,0.44490480D+03,0.132D+03,0.500D+02,0.94340000D+00,0.00000000D+00
     .,0.39458220D+03,0.132D+03,0.510D+02,0.94340000D+00,0.00000000D+00
     .,0.36482430D+03,0.132D+03,0.520D+02,0.94340000D+00,0.00000000D+00
     .,0.32847500D+03,0.132D+03,0.530D+02,0.94340000D+00,0.00000000D+00
     .,0.29399660D+03,0.132D+03,0.540D+02,0.94340000D+00,0.00000000D+00
     .,0.12903249D+04,0.132D+03,0.550D+02,0.94340000D+00,0.00000000D+00
     .,0.11809729D+04,0.132D+03,0.560D+02,0.94340000D+00,0.00000000D+00
     .,0.10344900D+04,0.132D+03,0.570D+02,0.94340000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37801:  37900)=(/
     . 0.46618800D+03,0.132D+03,0.580D+02,0.94340000D+00,0.27991000D+01
     .,0.10448624D+04,0.132D+03,0.590D+02,0.94340000D+00,0.00000000D+00
     .,0.10029138D+04,0.132D+03,0.600D+02,0.94340000D+00,0.00000000D+00
     .,0.97765230D+03,0.132D+03,0.610D+02,0.94340000D+00,0.00000000D+00
     .,0.95444310D+03,0.132D+03,0.620D+02,0.94340000D+00,0.00000000D+00
     .,0.93386150D+03,0.132D+03,0.630D+02,0.94340000D+00,0.00000000D+00
     .,0.73092270D+03,0.132D+03,0.640D+02,0.94340000D+00,0.00000000D+00
     .,0.82651040D+03,0.132D+03,0.650D+02,0.94340000D+00,0.00000000D+00
     .,0.79662990D+03,0.132D+03,0.660D+02,0.94340000D+00,0.00000000D+00
     .,0.84175260D+03,0.132D+03,0.670D+02,0.94340000D+00,0.00000000D+00
     .,0.82386870D+03,0.132D+03,0.680D+02,0.94340000D+00,0.00000000D+00
     .,0.80770310D+03,0.132D+03,0.690D+02,0.94340000D+00,0.00000000D+00
     .,0.79843800D+03,0.132D+03,0.700D+02,0.94340000D+00,0.00000000D+00
     .,0.67060970D+03,0.132D+03,0.710D+02,0.94340000D+00,0.00000000D+00
     .,0.65755650D+03,0.132D+03,0.720D+02,0.94340000D+00,0.00000000D+00
     .,0.59836780D+03,0.132D+03,0.730D+02,0.94340000D+00,0.00000000D+00
     .,0.50344310D+03,0.132D+03,0.740D+02,0.94340000D+00,0.00000000D+00
     .,0.51179750D+03,0.132D+03,0.750D+02,0.94340000D+00,0.00000000D+00
     .,0.46250420D+03,0.132D+03,0.760D+02,0.94340000D+00,0.00000000D+00
     .,0.42248760D+03,0.132D+03,0.770D+02,0.94340000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  37901:  38000)=(/
     . 0.34951600D+03,0.132D+03,0.780D+02,0.94340000D+00,0.00000000D+00
     .,0.32600720D+03,0.132D+03,0.790D+02,0.94340000D+00,0.00000000D+00
     .,0.33530450D+03,0.132D+03,0.800D+02,0.94340000D+00,0.00000000D+00
     .,0.49429340D+03,0.132D+03,0.810D+02,0.94340000D+00,0.00000000D+00
     .,0.48215480D+03,0.132D+03,0.820D+02,0.94340000D+00,0.00000000D+00
     .,0.44128680D+03,0.132D+03,0.830D+02,0.94340000D+00,0.00000000D+00
     .,0.41974070D+03,0.132D+03,0.840D+02,0.94340000D+00,0.00000000D+00
     .,0.38594190D+03,0.132D+03,0.850D+02,0.94340000D+00,0.00000000D+00
     .,0.35237490D+03,0.132D+03,0.860D+02,0.94340000D+00,0.00000000D+00
     .,0.12154454D+04,0.132D+03,0.870D+02,0.94340000D+00,0.00000000D+00
     .,0.11657107D+04,0.132D+03,0.880D+02,0.94340000D+00,0.00000000D+00
     .,0.10274859D+04,0.132D+03,0.890D+02,0.94340000D+00,0.00000000D+00
     .,0.91935170D+03,0.132D+03,0.900D+02,0.94340000D+00,0.00000000D+00
     .,0.91390230D+03,0.132D+03,0.910D+02,0.94340000D+00,0.00000000D+00
     .,0.88471530D+03,0.132D+03,0.920D+02,0.94340000D+00,0.00000000D+00
     .,0.91297050D+03,0.132D+03,0.930D+02,0.94340000D+00,0.00000000D+00
     .,0.88377800D+03,0.132D+03,0.940D+02,0.94340000D+00,0.00000000D+00
     .,0.48724700D+02,0.132D+03,0.101D+03,0.94340000D+00,0.00000000D+00
     .,0.16045020D+03,0.132D+03,0.103D+03,0.94340000D+00,0.98650000D+00
     .,0.20416900D+03,0.132D+03,0.104D+03,0.94340000D+00,0.98080000D+00
     ./)
      grimme_c6_parameters(  38001:  38100)=(/
     . 0.15444090D+03,0.132D+03,0.105D+03,0.94340000D+00,0.97060000D+00
     .,0.11534880D+03,0.132D+03,0.106D+03,0.94340000D+00,0.98680000D+00
     .,0.79327800D+02,0.132D+03,0.107D+03,0.94340000D+00,0.99440000D+00
     .,0.57175200D+02,0.132D+03,0.108D+03,0.94340000D+00,0.99250000D+00
     .,0.38758300D+02,0.132D+03,0.109D+03,0.94340000D+00,0.99820000D+00
     .,0.23460480D+03,0.132D+03,0.111D+03,0.94340000D+00,0.96840000D+00
     .,0.36333200D+03,0.132D+03,0.112D+03,0.94340000D+00,0.96280000D+00
     .,0.36665610D+03,0.132D+03,0.113D+03,0.94340000D+00,0.96480000D+00
     .,0.29253350D+03,0.132D+03,0.114D+03,0.94340000D+00,0.95070000D+00
     .,0.23795800D+03,0.132D+03,0.115D+03,0.94340000D+00,0.99470000D+00
     .,0.20005260D+03,0.132D+03,0.116D+03,0.94340000D+00,0.99480000D+00
     .,0.16242060D+03,0.132D+03,0.117D+03,0.94340000D+00,0.99720000D+00
     .,0.32115740D+03,0.132D+03,0.119D+03,0.94340000D+00,0.97670000D+00
     .,0.62067350D+03,0.132D+03,0.120D+03,0.94340000D+00,0.98310000D+00
     .,0.32013420D+03,0.132D+03,0.121D+03,0.94340000D+00,0.18627000D+01
     .,0.30883040D+03,0.132D+03,0.122D+03,0.94340000D+00,0.18299000D+01
     .,0.30262720D+03,0.132D+03,0.123D+03,0.94340000D+00,0.19138000D+01
     .,0.29997060D+03,0.132D+03,0.124D+03,0.94340000D+00,0.18269000D+01
     .,0.27526070D+03,0.132D+03,0.125D+03,0.94340000D+00,0.16406000D+01
     .,0.25437350D+03,0.132D+03,0.126D+03,0.94340000D+00,0.16483000D+01
     ./)
      grimme_c6_parameters(  38101:  38200)=(/
     . 0.24255720D+03,0.132D+03,0.127D+03,0.94340000D+00,0.17149000D+01
     .,0.23717370D+03,0.132D+03,0.128D+03,0.94340000D+00,0.17937000D+01
     .,0.23483270D+03,0.132D+03,0.129D+03,0.94340000D+00,0.95760000D+00
     .,0.21945080D+03,0.132D+03,0.130D+03,0.94340000D+00,0.19419000D+01
     .,0.36268320D+03,0.132D+03,0.131D+03,0.94340000D+00,0.96010000D+00
     .,0.31685210D+03,0.132D+03,0.132D+03,0.94340000D+00,0.94340000D+00
     .,0.27357400D+02,0.133D+03,0.100D+01,0.98890000D+00,0.91180000D+00
     .,0.18081600D+02,0.133D+03,0.200D+01,0.98890000D+00,0.00000000D+00
     .,0.40634270D+03,0.133D+03,0.300D+01,0.98890000D+00,0.00000000D+00
     .,0.24075590D+03,0.133D+03,0.400D+01,0.98890000D+00,0.00000000D+00
     .,0.16396550D+03,0.133D+03,0.500D+01,0.98890000D+00,0.00000000D+00
     .,0.11142570D+03,0.133D+03,0.600D+01,0.98890000D+00,0.00000000D+00
     .,0.78113800D+02,0.133D+03,0.700D+01,0.98890000D+00,0.00000000D+00
     .,0.59176400D+02,0.133D+03,0.800D+01,0.98890000D+00,0.00000000D+00
     .,0.44807900D+02,0.133D+03,0.900D+01,0.98890000D+00,0.00000000D+00
     .,0.34422600D+02,0.133D+03,0.100D+02,0.98890000D+00,0.00000000D+00
     .,0.48646380D+03,0.133D+03,0.110D+02,0.98890000D+00,0.00000000D+00
     .,0.38183960D+03,0.133D+03,0.120D+02,0.98890000D+00,0.00000000D+00
     .,0.35437060D+03,0.133D+03,0.130D+02,0.98890000D+00,0.00000000D+00
     .,0.28148930D+03,0.133D+03,0.140D+02,0.98890000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38201:  38300)=(/
     . 0.22071460D+03,0.133D+03,0.150D+02,0.98890000D+00,0.00000000D+00
     .,0.18364620D+03,0.133D+03,0.160D+02,0.98890000D+00,0.00000000D+00
     .,0.15027420D+03,0.133D+03,0.170D+02,0.98890000D+00,0.00000000D+00
     .,0.12303580D+03,0.133D+03,0.180D+02,0.98890000D+00,0.00000000D+00
     .,0.79363060D+03,0.133D+03,0.190D+02,0.98890000D+00,0.00000000D+00
     .,0.66532210D+03,0.133D+03,0.200D+02,0.98890000D+00,0.00000000D+00
     .,0.55149990D+03,0.133D+03,0.210D+02,0.98890000D+00,0.00000000D+00
     .,0.53402660D+03,0.133D+03,0.220D+02,0.98890000D+00,0.00000000D+00
     .,0.48982100D+03,0.133D+03,0.230D+02,0.98890000D+00,0.00000000D+00
     .,0.38565770D+03,0.133D+03,0.240D+02,0.98890000D+00,0.00000000D+00
     .,0.42268740D+03,0.133D+03,0.250D+02,0.98890000D+00,0.00000000D+00
     .,0.33163890D+03,0.133D+03,0.260D+02,0.98890000D+00,0.00000000D+00
     .,0.35300740D+03,0.133D+03,0.270D+02,0.98890000D+00,0.00000000D+00
     .,0.36305660D+03,0.133D+03,0.280D+02,0.98890000D+00,0.00000000D+00
     .,0.27805780D+03,0.133D+03,0.290D+02,0.98890000D+00,0.00000000D+00
     .,0.28717780D+03,0.133D+03,0.300D+02,0.98890000D+00,0.00000000D+00
     .,0.33996250D+03,0.133D+03,0.310D+02,0.98890000D+00,0.00000000D+00
     .,0.30168000D+03,0.133D+03,0.320D+02,0.98890000D+00,0.00000000D+00
     .,0.25852630D+03,0.133D+03,0.330D+02,0.98890000D+00,0.00000000D+00
     .,0.23250720D+03,0.133D+03,0.340D+02,0.98890000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38301:  38400)=(/
     . 0.20384000D+03,0.133D+03,0.350D+02,0.98890000D+00,0.00000000D+00
     .,0.17747160D+03,0.133D+03,0.360D+02,0.98890000D+00,0.00000000D+00
     .,0.89049310D+03,0.133D+03,0.370D+02,0.98890000D+00,0.00000000D+00
     .,0.79208160D+03,0.133D+03,0.380D+02,0.98890000D+00,0.00000000D+00
     .,0.69780370D+03,0.133D+03,0.390D+02,0.98890000D+00,0.00000000D+00
     .,0.62921900D+03,0.133D+03,0.400D+02,0.98890000D+00,0.00000000D+00
     .,0.57490090D+03,0.133D+03,0.410D+02,0.98890000D+00,0.00000000D+00
     .,0.44507990D+03,0.133D+03,0.420D+02,0.98890000D+00,0.00000000D+00
     .,0.49610230D+03,0.133D+03,0.430D+02,0.98890000D+00,0.00000000D+00
     .,0.37904270D+03,0.133D+03,0.440D+02,0.98890000D+00,0.00000000D+00
     .,0.41454110D+03,0.133D+03,0.450D+02,0.98890000D+00,0.00000000D+00
     .,0.38481520D+03,0.133D+03,0.460D+02,0.98890000D+00,0.00000000D+00
     .,0.32022310D+03,0.133D+03,0.470D+02,0.98890000D+00,0.00000000D+00
     .,0.33948140D+03,0.133D+03,0.480D+02,0.98890000D+00,0.00000000D+00
     .,0.42470080D+03,0.133D+03,0.490D+02,0.98890000D+00,0.00000000D+00
     .,0.39481650D+03,0.133D+03,0.500D+02,0.98890000D+00,0.00000000D+00
     .,0.35342450D+03,0.133D+03,0.510D+02,0.98890000D+00,0.00000000D+00
     .,0.32867560D+03,0.133D+03,0.520D+02,0.98890000D+00,0.00000000D+00
     .,0.29780640D+03,0.133D+03,0.530D+02,0.98890000D+00,0.00000000D+00
     .,0.26817000D+03,0.133D+03,0.540D+02,0.98890000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38401:  38500)=(/
     . 0.10853677D+04,0.133D+03,0.550D+02,0.98890000D+00,0.00000000D+00
     .,0.10077913D+04,0.133D+03,0.560D+02,0.98890000D+00,0.00000000D+00
     .,0.89047640D+03,0.133D+03,0.570D+02,0.98890000D+00,0.00000000D+00
     .,0.41703500D+03,0.133D+03,0.580D+02,0.98890000D+00,0.27991000D+01
     .,0.89428150D+03,0.133D+03,0.590D+02,0.98890000D+00,0.00000000D+00
     .,0.85952480D+03,0.133D+03,0.600D+02,0.98890000D+00,0.00000000D+00
     .,0.83818370D+03,0.133D+03,0.610D+02,0.98890000D+00,0.00000000D+00
     .,0.81853810D+03,0.133D+03,0.620D+02,0.98890000D+00,0.00000000D+00
     .,0.80112860D+03,0.133D+03,0.630D+02,0.98890000D+00,0.00000000D+00
     .,0.63358090D+03,0.133D+03,0.640D+02,0.98890000D+00,0.00000000D+00
     .,0.70687070D+03,0.133D+03,0.650D+02,0.98890000D+00,0.00000000D+00
     .,0.68251260D+03,0.133D+03,0.660D+02,0.98890000D+00,0.00000000D+00
     .,0.72360130D+03,0.133D+03,0.670D+02,0.98890000D+00,0.00000000D+00
     .,0.70836530D+03,0.133D+03,0.680D+02,0.98890000D+00,0.00000000D+00
     .,0.69468070D+03,0.133D+03,0.690D+02,0.98890000D+00,0.00000000D+00
     .,0.68640110D+03,0.133D+03,0.700D+02,0.98890000D+00,0.00000000D+00
     .,0.58061170D+03,0.133D+03,0.710D+02,0.98890000D+00,0.00000000D+00
     .,0.57440900D+03,0.133D+03,0.720D+02,0.98890000D+00,0.00000000D+00
     .,0.52573750D+03,0.133D+03,0.730D+02,0.98890000D+00,0.00000000D+00
     .,0.44464860D+03,0.133D+03,0.740D+02,0.98890000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38501:  38600)=(/
     . 0.45291770D+03,0.133D+03,0.750D+02,0.98890000D+00,0.00000000D+00
     .,0.41136690D+03,0.133D+03,0.760D+02,0.98890000D+00,0.00000000D+00
     .,0.37733280D+03,0.133D+03,0.770D+02,0.98890000D+00,0.00000000D+00
     .,0.31370400D+03,0.133D+03,0.780D+02,0.98890000D+00,0.00000000D+00
     .,0.29316560D+03,0.133D+03,0.790D+02,0.98890000D+00,0.00000000D+00
     .,0.30197230D+03,0.133D+03,0.800D+02,0.98890000D+00,0.00000000D+00
     .,0.43615840D+03,0.133D+03,0.810D+02,0.98890000D+00,0.00000000D+00
     .,0.42826390D+03,0.133D+03,0.820D+02,0.98890000D+00,0.00000000D+00
     .,0.39514950D+03,0.133D+03,0.830D+02,0.98890000D+00,0.00000000D+00
     .,0.37768730D+03,0.133D+03,0.840D+02,0.98890000D+00,0.00000000D+00
     .,0.34934070D+03,0.133D+03,0.850D+02,0.98890000D+00,0.00000000D+00
     .,0.32071970D+03,0.133D+03,0.860D+02,0.98890000D+00,0.00000000D+00
     .,0.10295399D+04,0.133D+03,0.870D+02,0.98890000D+00,0.00000000D+00
     .,0.99943950D+03,0.133D+03,0.880D+02,0.98890000D+00,0.00000000D+00
     .,0.88791120D+03,0.133D+03,0.890D+02,0.98890000D+00,0.00000000D+00
     .,0.80215530D+03,0.133D+03,0.900D+02,0.98890000D+00,0.00000000D+00
     .,0.79394730D+03,0.133D+03,0.910D+02,0.98890000D+00,0.00000000D+00
     .,0.76878210D+03,0.133D+03,0.920D+02,0.98890000D+00,0.00000000D+00
     .,0.78864020D+03,0.133D+03,0.930D+02,0.98890000D+00,0.00000000D+00
     .,0.76421100D+03,0.133D+03,0.940D+02,0.98890000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38601:  38700)=(/
     . 0.43906700D+02,0.133D+03,0.101D+03,0.98890000D+00,0.00000000D+00
     .,0.14013530D+03,0.133D+03,0.103D+03,0.98890000D+00,0.98650000D+00
     .,0.17913900D+03,0.133D+03,0.104D+03,0.98890000D+00,0.98080000D+00
     .,0.13814460D+03,0.133D+03,0.105D+03,0.98890000D+00,0.97060000D+00
     .,0.10445320D+03,0.133D+03,0.106D+03,0.98890000D+00,0.98680000D+00
     .,0.72807300D+02,0.133D+03,0.107D+03,0.98890000D+00,0.99440000D+00
     .,0.53064500D+02,0.133D+03,0.108D+03,0.98890000D+00,0.99250000D+00
     .,0.36472800D+02,0.133D+03,0.109D+03,0.98890000D+00,0.99820000D+00
     .,0.20419370D+03,0.133D+03,0.111D+03,0.98890000D+00,0.96840000D+00
     .,0.31566880D+03,0.133D+03,0.112D+03,0.98890000D+00,0.96280000D+00
     .,0.32160430D+03,0.133D+03,0.113D+03,0.98890000D+00,0.96480000D+00
     .,0.26040440D+03,0.133D+03,0.114D+03,0.98890000D+00,0.95070000D+00
     .,0.21425140D+03,0.133D+03,0.115D+03,0.98890000D+00,0.99470000D+00
     .,0.18159050D+03,0.133D+03,0.116D+03,0.98890000D+00,0.99480000D+00
     .,0.14869430D+03,0.133D+03,0.117D+03,0.98890000D+00,0.99720000D+00
     .,0.28230700D+03,0.133D+03,0.119D+03,0.98890000D+00,0.97670000D+00
     .,0.53224610D+03,0.133D+03,0.120D+03,0.98890000D+00,0.98310000D+00
     .,0.28445160D+03,0.133D+03,0.121D+03,0.98890000D+00,0.18627000D+01
     .,0.27459290D+03,0.133D+03,0.122D+03,0.98890000D+00,0.18299000D+01
     .,0.26902700D+03,0.133D+03,0.123D+03,0.98890000D+00,0.19138000D+01
     ./)
      grimme_c6_parameters(  38701:  38800)=(/
     . 0.26629390D+03,0.133D+03,0.124D+03,0.98890000D+00,0.18269000D+01
     .,0.24597130D+03,0.133D+03,0.125D+03,0.98890000D+00,0.16406000D+01
     .,0.22781130D+03,0.133D+03,0.126D+03,0.98890000D+00,0.16483000D+01
     .,0.21726350D+03,0.133D+03,0.127D+03,0.98890000D+00,0.17149000D+01
     .,0.21232210D+03,0.133D+03,0.128D+03,0.98890000D+00,0.17937000D+01
     .,0.20913220D+03,0.133D+03,0.129D+03,0.98890000D+00,0.95760000D+00
     .,0.19727710D+03,0.133D+03,0.130D+03,0.98890000D+00,0.19419000D+01
     .,0.31978710D+03,0.133D+03,0.131D+03,0.98890000D+00,0.96010000D+00
     .,0.28257170D+03,0.133D+03,0.132D+03,0.98890000D+00,0.94340000D+00
     .,0.25419240D+03,0.133D+03,0.133D+03,0.98890000D+00,0.98890000D+00
     .,0.25314900D+02,0.134D+03,0.100D+01,0.99010000D+00,0.91180000D+00
     .,0.17028000D+02,0.134D+03,0.200D+01,0.99010000D+00,0.00000000D+00
     .,0.35504500D+03,0.134D+03,0.300D+01,0.99010000D+00,0.00000000D+00
     .,0.21516710D+03,0.134D+03,0.400D+01,0.99010000D+00,0.00000000D+00
     .,0.14885900D+03,0.134D+03,0.500D+01,0.99010000D+00,0.00000000D+00
     .,0.10246200D+03,0.134D+03,0.600D+01,0.99010000D+00,0.00000000D+00
     .,0.72556700D+02,0.134D+03,0.700D+01,0.99010000D+00,0.00000000D+00
     .,0.55375200D+02,0.134D+03,0.800D+01,0.99010000D+00,0.00000000D+00
     .,0.42202700D+02,0.134D+03,0.900D+01,0.99010000D+00,0.00000000D+00
     .,0.32593500D+02,0.134D+03,0.100D+02,0.99010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38801:  38900)=(/
     . 0.42577330D+03,0.134D+03,0.110D+02,0.99010000D+00,0.00000000D+00
     .,0.33984270D+03,0.134D+03,0.120D+02,0.99010000D+00,0.00000000D+00
     .,0.31781330D+03,0.134D+03,0.130D+02,0.99010000D+00,0.00000000D+00
     .,0.25511530D+03,0.134D+03,0.140D+02,0.99010000D+00,0.00000000D+00
     .,0.20196030D+03,0.134D+03,0.150D+02,0.99010000D+00,0.00000000D+00
     .,0.16917120D+03,0.134D+03,0.160D+02,0.99010000D+00,0.00000000D+00
     .,0.13934530D+03,0.134D+03,0.170D+02,0.99010000D+00,0.00000000D+00
     .,0.11476770D+03,0.134D+03,0.180D+02,0.99010000D+00,0.00000000D+00
     .,0.69398180D+03,0.134D+03,0.190D+02,0.99010000D+00,0.00000000D+00
     .,0.58857630D+03,0.134D+03,0.200D+02,0.99010000D+00,0.00000000D+00
     .,0.48933050D+03,0.134D+03,0.210D+02,0.99010000D+00,0.00000000D+00
     .,0.47544530D+03,0.134D+03,0.220D+02,0.99010000D+00,0.00000000D+00
     .,0.43692930D+03,0.134D+03,0.230D+02,0.99010000D+00,0.00000000D+00
     .,0.34458580D+03,0.134D+03,0.240D+02,0.99010000D+00,0.00000000D+00
     .,0.37811330D+03,0.134D+03,0.250D+02,0.99010000D+00,0.00000000D+00
     .,0.29726970D+03,0.134D+03,0.260D+02,0.99010000D+00,0.00000000D+00
     .,0.31722330D+03,0.134D+03,0.270D+02,0.99010000D+00,0.00000000D+00
     .,0.32556670D+03,0.134D+03,0.280D+02,0.99010000D+00,0.00000000D+00
     .,0.24982100D+03,0.134D+03,0.290D+02,0.99010000D+00,0.00000000D+00
     .,0.25919160D+03,0.134D+03,0.300D+02,0.99010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  38901:  39000)=(/
     . 0.30612750D+03,0.134D+03,0.310D+02,0.99010000D+00,0.00000000D+00
     .,0.27376800D+03,0.134D+03,0.320D+02,0.99010000D+00,0.00000000D+00
     .,0.23642060D+03,0.134D+03,0.330D+02,0.99010000D+00,0.00000000D+00
     .,0.21372980D+03,0.134D+03,0.340D+02,0.99010000D+00,0.00000000D+00
     .,0.18840310D+03,0.134D+03,0.350D+02,0.99010000D+00,0.00000000D+00
     .,0.16488330D+03,0.134D+03,0.360D+02,0.99010000D+00,0.00000000D+00
     .,0.78009860D+03,0.134D+03,0.370D+02,0.99010000D+00,0.00000000D+00
     .,0.70080150D+03,0.134D+03,0.380D+02,0.99010000D+00,0.00000000D+00
     .,0.62089180D+03,0.134D+03,0.390D+02,0.99010000D+00,0.00000000D+00
     .,0.56200010D+03,0.134D+03,0.400D+02,0.99010000D+00,0.00000000D+00
     .,0.51489450D+03,0.134D+03,0.410D+02,0.99010000D+00,0.00000000D+00
     .,0.40077220D+03,0.134D+03,0.420D+02,0.99010000D+00,0.00000000D+00
     .,0.44579160D+03,0.134D+03,0.430D+02,0.99010000D+00,0.00000000D+00
     .,0.34259700D+03,0.134D+03,0.440D+02,0.99010000D+00,0.00000000D+00
     .,0.37429000D+03,0.134D+03,0.450D+02,0.99010000D+00,0.00000000D+00
     .,0.34804020D+03,0.134D+03,0.460D+02,0.99010000D+00,0.00000000D+00
     .,0.28983280D+03,0.134D+03,0.470D+02,0.99010000D+00,0.00000000D+00
     .,0.30772140D+03,0.134D+03,0.480D+02,0.99010000D+00,0.00000000D+00
     .,0.38283810D+03,0.134D+03,0.490D+02,0.99010000D+00,0.00000000D+00
     .,0.35796090D+03,0.134D+03,0.500D+02,0.99010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39001:  39100)=(/
     . 0.32248120D+03,0.134D+03,0.510D+02,0.99010000D+00,0.00000000D+00
     .,0.30115060D+03,0.134D+03,0.520D+02,0.99010000D+00,0.00000000D+00
     .,0.27413770D+03,0.134D+03,0.530D+02,0.99010000D+00,0.00000000D+00
     .,0.24798670D+03,0.134D+03,0.540D+02,0.99010000D+00,0.00000000D+00
     .,0.95163050D+03,0.134D+03,0.550D+02,0.99010000D+00,0.00000000D+00
     .,0.89062640D+03,0.134D+03,0.560D+02,0.99010000D+00,0.00000000D+00
     .,0.79124710D+03,0.134D+03,0.570D+02,0.99010000D+00,0.00000000D+00
     .,0.38031600D+03,0.134D+03,0.580D+02,0.99010000D+00,0.27991000D+01
     .,0.79188170D+03,0.134D+03,0.590D+02,0.99010000D+00,0.00000000D+00
     .,0.76169980D+03,0.134D+03,0.600D+02,0.99010000D+00,0.00000000D+00
     .,0.74294350D+03,0.134D+03,0.610D+02,0.99010000D+00,0.00000000D+00
     .,0.72565360D+03,0.134D+03,0.620D+02,0.99010000D+00,0.00000000D+00
     .,0.71033760D+03,0.134D+03,0.630D+02,0.99010000D+00,0.00000000D+00
     .,0.56579140D+03,0.134D+03,0.640D+02,0.99010000D+00,0.00000000D+00
     .,0.62617050D+03,0.134D+03,0.650D+02,0.99010000D+00,0.00000000D+00
     .,0.60528280D+03,0.134D+03,0.660D+02,0.99010000D+00,0.00000000D+00
     .,0.64237950D+03,0.134D+03,0.670D+02,0.99010000D+00,0.00000000D+00
     .,0.62891080D+03,0.134D+03,0.680D+02,0.99010000D+00,0.00000000D+00
     .,0.61686660D+03,0.134D+03,0.690D+02,0.99010000D+00,0.00000000D+00
     .,0.60931460D+03,0.134D+03,0.700D+02,0.99010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39101:  39200)=(/
     . 0.51790690D+03,0.134D+03,0.710D+02,0.99010000D+00,0.00000000D+00
     .,0.51523880D+03,0.134D+03,0.720D+02,0.99010000D+00,0.00000000D+00
     .,0.47346190D+03,0.134D+03,0.730D+02,0.99010000D+00,0.00000000D+00
     .,0.40207780D+03,0.134D+03,0.740D+02,0.99010000D+00,0.00000000D+00
     .,0.41003520D+03,0.134D+03,0.750D+02,0.99010000D+00,0.00000000D+00
     .,0.37374220D+03,0.134D+03,0.760D+02,0.99010000D+00,0.00000000D+00
     .,0.34383760D+03,0.134D+03,0.770D+02,0.99010000D+00,0.00000000D+00
     .,0.28699450D+03,0.134D+03,0.780D+02,0.99010000D+00,0.00000000D+00
     .,0.26861450D+03,0.134D+03,0.790D+02,0.99010000D+00,0.00000000D+00
     .,0.27687780D+03,0.134D+03,0.800D+02,0.99010000D+00,0.00000000D+00
     .,0.39433850D+03,0.134D+03,0.810D+02,0.99010000D+00,0.00000000D+00
     .,0.38873570D+03,0.134D+03,0.820D+02,0.99010000D+00,0.00000000D+00
     .,0.36061850D+03,0.134D+03,0.830D+02,0.99010000D+00,0.00000000D+00
     .,0.34584750D+03,0.134D+03,0.840D+02,0.99010000D+00,0.00000000D+00
     .,0.32125280D+03,0.134D+03,0.850D+02,0.99010000D+00,0.00000000D+00
     .,0.29613640D+03,0.134D+03,0.860D+02,0.99010000D+00,0.00000000D+00
     .,0.90670650D+03,0.134D+03,0.870D+02,0.99010000D+00,0.00000000D+00
     .,0.88597380D+03,0.134D+03,0.880D+02,0.99010000D+00,0.00000000D+00
     .,0.79097170D+03,0.134D+03,0.890D+02,0.99010000D+00,0.00000000D+00
     .,0.71920180D+03,0.134D+03,0.900D+02,0.99010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39201:  39300)=(/
     . 0.71002990D+03,0.134D+03,0.910D+02,0.99010000D+00,0.00000000D+00
     .,0.68765590D+03,0.134D+03,0.920D+02,0.99010000D+00,0.00000000D+00
     .,0.70268800D+03,0.134D+03,0.930D+02,0.99010000D+00,0.00000000D+00
     .,0.68135890D+03,0.134D+03,0.940D+02,0.99010000D+00,0.00000000D+00
     .,0.40211700D+02,0.134D+03,0.101D+03,0.99010000D+00,0.00000000D+00
     .,0.12555640D+03,0.134D+03,0.103D+03,0.99010000D+00,0.98650000D+00
     .,0.16106370D+03,0.134D+03,0.104D+03,0.99010000D+00,0.98080000D+00
     .,0.12588880D+03,0.134D+03,0.105D+03,0.99010000D+00,0.97060000D+00
     .,0.96087200D+02,0.134D+03,0.106D+03,0.99010000D+00,0.98680000D+00
     .,0.67679600D+02,0.134D+03,0.107D+03,0.99010000D+00,0.99440000D+00
     .,0.49766500D+02,0.134D+03,0.108D+03,0.99010000D+00,0.99250000D+00
     .,0.34588200D+02,0.134D+03,0.109D+03,0.99010000D+00,0.99820000D+00
     .,0.18260620D+03,0.134D+03,0.111D+03,0.99010000D+00,0.96840000D+00
     .,0.28192490D+03,0.134D+03,0.112D+03,0.99010000D+00,0.96280000D+00
     .,0.28901630D+03,0.134D+03,0.113D+03,0.99010000D+00,0.96480000D+00
     .,0.23642530D+03,0.134D+03,0.114D+03,0.99010000D+00,0.95070000D+00
     .,0.19613740D+03,0.134D+03,0.115D+03,0.99010000D+00,0.99470000D+00
     .,0.16726720D+03,0.134D+03,0.116D+03,0.99010000D+00,0.99480000D+00
     .,0.13787350D+03,0.134D+03,0.117D+03,0.99010000D+00,0.99720000D+00
     .,0.25453760D+03,0.134D+03,0.119D+03,0.99010000D+00,0.97670000D+00
     ./)
      grimme_c6_parameters(  39301:  39400)=(/
     . 0.47198210D+03,0.134D+03,0.120D+03,0.99010000D+00,0.98310000D+00
     .,0.25812950D+03,0.134D+03,0.121D+03,0.99010000D+00,0.18627000D+01
     .,0.24934370D+03,0.134D+03,0.122D+03,0.99010000D+00,0.18299000D+01
     .,0.24427270D+03,0.134D+03,0.123D+03,0.99010000D+00,0.19138000D+01
     .,0.24158030D+03,0.134D+03,0.124D+03,0.99010000D+00,0.18269000D+01
     .,0.22407570D+03,0.134D+03,0.125D+03,0.99010000D+00,0.16406000D+01
     .,0.20787480D+03,0.134D+03,0.126D+03,0.99010000D+00,0.16483000D+01
     .,0.19829930D+03,0.134D+03,0.127D+03,0.99010000D+00,0.17149000D+01
     .,0.19372130D+03,0.134D+03,0.128D+03,0.99010000D+00,0.17937000D+01
     .,0.19016850D+03,0.134D+03,0.129D+03,0.99010000D+00,0.95760000D+00
     .,0.18048120D+03,0.134D+03,0.130D+03,0.99010000D+00,0.19419000D+01
     .,0.28854930D+03,0.134D+03,0.131D+03,0.99010000D+00,0.96010000D+00
     .,0.25695230D+03,0.134D+03,0.132D+03,0.99010000D+00,0.94340000D+00
     .,0.23257840D+03,0.134D+03,0.133D+03,0.99010000D+00,0.98890000D+00
     .,0.21378620D+03,0.134D+03,0.134D+03,0.99010000D+00,0.99010000D+00
     .,0.22623000D+02,0.135D+03,0.100D+01,0.99740000D+00,0.91180000D+00
     .,0.15538700D+02,0.135D+03,0.200D+01,0.99740000D+00,0.00000000D+00
     .,0.29768350D+03,0.135D+03,0.300D+01,0.99740000D+00,0.00000000D+00
     .,0.18488320D+03,0.135D+03,0.400D+01,0.99740000D+00,0.00000000D+00
     .,0.13018810D+03,0.135D+03,0.500D+01,0.99740000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39401:  39500)=(/
     . 0.90934300D+02,0.135D+03,0.600D+01,0.99740000D+00,0.00000000D+00
     .,0.65154300D+02,0.135D+03,0.700D+01,0.99740000D+00,0.00000000D+00
     .,0.50163200D+02,0.135D+03,0.800D+01,0.99740000D+00,0.00000000D+00
     .,0.38529400D+02,0.135D+03,0.900D+01,0.99740000D+00,0.00000000D+00
     .,0.29950100D+02,0.135D+03,0.100D+02,0.99740000D+00,0.00000000D+00
     .,0.35772460D+03,0.135D+03,0.110D+02,0.99740000D+00,0.00000000D+00
     .,0.29072760D+03,0.135D+03,0.120D+02,0.99740000D+00,0.00000000D+00
     .,0.27418940D+03,0.135D+03,0.130D+02,0.99740000D+00,0.00000000D+00
     .,0.22268120D+03,0.135D+03,0.140D+02,0.99740000D+00,0.00000000D+00
     .,0.17819840D+03,0.135D+03,0.150D+02,0.99740000D+00,0.00000000D+00
     .,0.15042030D+03,0.135D+03,0.160D+02,0.99740000D+00,0.00000000D+00
     .,0.12484950D+03,0.135D+03,0.170D+02,0.99740000D+00,0.00000000D+00
     .,0.10354670D+03,0.135D+03,0.180D+02,0.99740000D+00,0.00000000D+00
     .,0.58289140D+03,0.135D+03,0.190D+02,0.99740000D+00,0.00000000D+00
     .,0.50041520D+03,0.135D+03,0.200D+02,0.99740000D+00,0.00000000D+00
     .,0.41736480D+03,0.135D+03,0.210D+02,0.99740000D+00,0.00000000D+00
     .,0.40709700D+03,0.135D+03,0.220D+02,0.99740000D+00,0.00000000D+00
     .,0.37492830D+03,0.135D+03,0.230D+02,0.99740000D+00,0.00000000D+00
     .,0.29636070D+03,0.135D+03,0.240D+02,0.99740000D+00,0.00000000D+00
     .,0.32549450D+03,0.135D+03,0.250D+02,0.99740000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39501:  39600)=(/
     . 0.25659390D+03,0.135D+03,0.260D+02,0.99740000D+00,0.00000000D+00
     .,0.27446200D+03,0.135D+03,0.270D+02,0.99740000D+00,0.00000000D+00
     .,0.28101540D+03,0.135D+03,0.280D+02,0.99740000D+00,0.00000000D+00
     .,0.21621400D+03,0.135D+03,0.290D+02,0.99740000D+00,0.00000000D+00
     .,0.22534570D+03,0.135D+03,0.300D+02,0.99740000D+00,0.00000000D+00
     .,0.26539390D+03,0.135D+03,0.310D+02,0.99740000D+00,0.00000000D+00
     .,0.23936360D+03,0.135D+03,0.320D+02,0.99740000D+00,0.00000000D+00
     .,0.20849570D+03,0.135D+03,0.330D+02,0.99740000D+00,0.00000000D+00
     .,0.18959740D+03,0.135D+03,0.340D+02,0.99740000D+00,0.00000000D+00
     .,0.16817910D+03,0.135D+03,0.350D+02,0.99740000D+00,0.00000000D+00
     .,0.14806890D+03,0.135D+03,0.360D+02,0.99740000D+00,0.00000000D+00
     .,0.65665740D+03,0.135D+03,0.370D+02,0.99740000D+00,0.00000000D+00
     .,0.59602140D+03,0.135D+03,0.380D+02,0.99740000D+00,0.00000000D+00
     .,0.53134260D+03,0.135D+03,0.390D+02,0.99740000D+00,0.00000000D+00
     .,0.48298730D+03,0.135D+03,0.400D+02,0.99740000D+00,0.00000000D+00
     .,0.44388480D+03,0.135D+03,0.410D+02,0.99740000D+00,0.00000000D+00
     .,0.34768000D+03,0.135D+03,0.420D+02,0.99740000D+00,0.00000000D+00
     .,0.38579860D+03,0.135D+03,0.430D+02,0.99740000D+00,0.00000000D+00
     .,0.29851740D+03,0.135D+03,0.440D+02,0.99740000D+00,0.00000000D+00
     .,0.32566500D+03,0.135D+03,0.450D+02,0.99740000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39601:  39700)=(/
     . 0.30341070D+03,0.135D+03,0.460D+02,0.99740000D+00,0.00000000D+00
     .,0.25300950D+03,0.135D+03,0.470D+02,0.99740000D+00,0.00000000D+00
     .,0.26894910D+03,0.135D+03,0.480D+02,0.99740000D+00,0.00000000D+00
     .,0.33247910D+03,0.135D+03,0.490D+02,0.99740000D+00,0.00000000D+00
     .,0.31279940D+03,0.135D+03,0.500D+02,0.99740000D+00,0.00000000D+00
     .,0.28377610D+03,0.135D+03,0.510D+02,0.99740000D+00,0.00000000D+00
     .,0.26623860D+03,0.135D+03,0.520D+02,0.99740000D+00,0.00000000D+00
     .,0.24362960D+03,0.135D+03,0.530D+02,0.99740000D+00,0.00000000D+00
     .,0.22153670D+03,0.135D+03,0.540D+02,0.99740000D+00,0.00000000D+00
     .,0.80186140D+03,0.135D+03,0.550D+02,0.99740000D+00,0.00000000D+00
     .,0.75662710D+03,0.135D+03,0.560D+02,0.99740000D+00,0.00000000D+00
     .,0.67619300D+03,0.135D+03,0.570D+02,0.99740000D+00,0.00000000D+00
     .,0.33452620D+03,0.135D+03,0.580D+02,0.99740000D+00,0.27991000D+01
     .,0.67428760D+03,0.135D+03,0.590D+02,0.99740000D+00,0.00000000D+00
     .,0.64912820D+03,0.135D+03,0.600D+02,0.99740000D+00,0.00000000D+00
     .,0.63328350D+03,0.135D+03,0.610D+02,0.99740000D+00,0.00000000D+00
     .,0.61865400D+03,0.135D+03,0.620D+02,0.99740000D+00,0.00000000D+00
     .,0.60569940D+03,0.135D+03,0.630D+02,0.99740000D+00,0.00000000D+00
     .,0.48634440D+03,0.135D+03,0.640D+02,0.99740000D+00,0.00000000D+00
     .,0.53364850D+03,0.135D+03,0.650D+02,0.99740000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39701:  39800)=(/
     . 0.51649050D+03,0.135D+03,0.660D+02,0.99740000D+00,0.00000000D+00
     .,0.54846290D+03,0.135D+03,0.670D+02,0.99740000D+00,0.00000000D+00
     .,0.53700790D+03,0.135D+03,0.680D+02,0.99740000D+00,0.00000000D+00
     .,0.52681470D+03,0.135D+03,0.690D+02,0.99740000D+00,0.00000000D+00
     .,0.52016740D+03,0.135D+03,0.700D+02,0.99740000D+00,0.00000000D+00
     .,0.44455160D+03,0.135D+03,0.710D+02,0.99740000D+00,0.00000000D+00
     .,0.44488510D+03,0.135D+03,0.720D+02,0.99740000D+00,0.00000000D+00
     .,0.41064300D+03,0.135D+03,0.730D+02,0.99740000D+00,0.00000000D+00
     .,0.35042340D+03,0.135D+03,0.740D+02,0.99740000D+00,0.00000000D+00
     .,0.35779320D+03,0.135D+03,0.750D+02,0.99740000D+00,0.00000000D+00
     .,0.32743170D+03,0.135D+03,0.760D+02,0.99740000D+00,0.00000000D+00
     .,0.30224750D+03,0.135D+03,0.770D+02,0.99740000D+00,0.00000000D+00
     .,0.25348160D+03,0.135D+03,0.780D+02,0.99740000D+00,0.00000000D+00
     .,0.23768320D+03,0.135D+03,0.790D+02,0.99740000D+00,0.00000000D+00
     .,0.24514110D+03,0.135D+03,0.800D+02,0.99740000D+00,0.00000000D+00
     .,0.34374040D+03,0.135D+03,0.810D+02,0.99740000D+00,0.00000000D+00
     .,0.34024220D+03,0.135D+03,0.820D+02,0.99740000D+00,0.00000000D+00
     .,0.31748380D+03,0.135D+03,0.830D+02,0.99740000D+00,0.00000000D+00
     .,0.30560970D+03,0.135D+03,0.840D+02,0.99740000D+00,0.00000000D+00
     .,0.28522290D+03,0.135D+03,0.850D+02,0.99740000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  39801:  39900)=(/
     . 0.26413340D+03,0.135D+03,0.860D+02,0.99740000D+00,0.00000000D+00
     .,0.76779060D+03,0.135D+03,0.870D+02,0.99740000D+00,0.00000000D+00
     .,0.75526170D+03,0.135D+03,0.880D+02,0.99740000D+00,0.00000000D+00
     .,0.67787670D+03,0.135D+03,0.890D+02,0.99740000D+00,0.00000000D+00
     .,0.62082600D+03,0.135D+03,0.900D+02,0.99740000D+00,0.00000000D+00
     .,0.61130750D+03,0.135D+03,0.910D+02,0.99740000D+00,0.00000000D+00
     .,0.59218710D+03,0.135D+03,0.920D+02,0.99740000D+00,0.00000000D+00
     .,0.60258350D+03,0.135D+03,0.930D+02,0.99740000D+00,0.00000000D+00
     .,0.58469980D+03,0.135D+03,0.940D+02,0.99740000D+00,0.00000000D+00
     .,0.35512300D+02,0.135D+03,0.101D+03,0.99740000D+00,0.00000000D+00
     .,0.10820480D+03,0.135D+03,0.103D+03,0.99740000D+00,0.98650000D+00
     .,0.13936170D+03,0.135D+03,0.104D+03,0.99740000D+00,0.98080000D+00
     .,0.11058020D+03,0.135D+03,0.105D+03,0.99740000D+00,0.97060000D+00
     .,0.85326500D+02,0.135D+03,0.106D+03,0.99740000D+00,0.98680000D+00
     .,0.60835900D+02,0.135D+03,0.107D+03,0.99740000D+00,0.99440000D+00
     .,0.45201900D+02,0.135D+03,0.108D+03,0.99740000D+00,0.99250000D+00
     .,0.31831300D+02,0.135D+03,0.109D+03,0.99740000D+00,0.99820000D+00
     .,0.15710050D+03,0.135D+03,0.111D+03,0.99740000D+00,0.96840000D+00
     .,0.24214760D+03,0.135D+03,0.112D+03,0.99740000D+00,0.96280000D+00
     .,0.24992480D+03,0.135D+03,0.113D+03,0.99740000D+00,0.96480000D+00
     ./)
      grimme_c6_parameters(  39901:  40000)=(/
     . 0.20678800D+03,0.135D+03,0.114D+03,0.99740000D+00,0.95070000D+00
     .,0.17315820D+03,0.135D+03,0.115D+03,0.99740000D+00,0.99470000D+00
     .,0.14872190D+03,0.135D+03,0.116D+03,0.99740000D+00,0.99480000D+00
     .,0.12352740D+03,0.135D+03,0.117D+03,0.99740000D+00,0.99720000D+00
     .,0.22116420D+03,0.135D+03,0.119D+03,0.99740000D+00,0.97670000D+00
     .,0.40253800D+03,0.135D+03,0.120D+03,0.99740000D+00,0.98310000D+00
     .,0.22577840D+03,0.135D+03,0.121D+03,0.99740000D+00,0.18627000D+01
     .,0.21827110D+03,0.135D+03,0.122D+03,0.99740000D+00,0.18299000D+01
     .,0.21382760D+03,0.135D+03,0.123D+03,0.99740000D+00,0.19138000D+01
     .,0.21128090D+03,0.135D+03,0.124D+03,0.99740000D+00,0.18269000D+01
     .,0.19683950D+03,0.135D+03,0.125D+03,0.99740000D+00,0.16406000D+01
     .,0.18295500D+03,0.135D+03,0.126D+03,0.99740000D+00,0.16483000D+01
     .,0.17459100D+03,0.135D+03,0.127D+03,0.99740000D+00,0.17149000D+01
     .,0.17050040D+03,0.135D+03,0.128D+03,0.99740000D+00,0.17937000D+01
     .,0.16678160D+03,0.135D+03,0.129D+03,0.99740000D+00,0.95760000D+00
     .,0.15930490D+03,0.135D+03,0.130D+03,0.99740000D+00,0.19419000D+01
     .,0.25072470D+03,0.135D+03,0.131D+03,0.99740000D+00,0.96010000D+00
     .,0.22517920D+03,0.135D+03,0.132D+03,0.99740000D+00,0.94340000D+00
     .,0.20523050D+03,0.135D+03,0.133D+03,0.99740000D+00,0.98890000D+00
     .,0.18964080D+03,0.135D+03,0.134D+03,0.99740000D+00,0.99010000D+00
     ./)
      grimme_c6_parameters(  40001:  40100)=(/
     . 0.16923750D+03,0.135D+03,0.135D+03,0.99740000D+00,0.99740000D+00
     .,0.35196300D+02,0.137D+03,0.100D+01,0.97380000D+00,0.91180000D+00
     .,0.22623100D+02,0.137D+03,0.200D+01,0.97380000D+00,0.00000000D+00
     .,0.65740760D+03,0.137D+03,0.300D+01,0.97380000D+00,0.00000000D+00
     .,0.34543780D+03,0.137D+03,0.400D+01,0.97380000D+00,0.00000000D+00
     .,0.22250810D+03,0.137D+03,0.500D+01,0.97380000D+00,0.00000000D+00
     .,0.14599740D+03,0.137D+03,0.600D+01,0.97380000D+00,0.00000000D+00
     .,0.10014180D+03,0.137D+03,0.700D+01,0.97380000D+00,0.00000000D+00
     .,0.74886800D+02,0.137D+03,0.800D+01,0.97380000D+00,0.00000000D+00
     .,0.56177900D+02,0.137D+03,0.900D+01,0.97380000D+00,0.00000000D+00
     .,0.42895700D+02,0.137D+03,0.100D+02,0.97380000D+00,0.00000000D+00
     .,0.78185270D+03,0.137D+03,0.110D+02,0.97380000D+00,0.00000000D+00
     .,0.55913370D+03,0.137D+03,0.120D+02,0.97380000D+00,0.00000000D+00
     .,0.50299330D+03,0.137D+03,0.130D+02,0.97380000D+00,0.00000000D+00
     .,0.38390840D+03,0.137D+03,0.140D+02,0.97380000D+00,0.00000000D+00
     .,0.29216040D+03,0.137D+03,0.150D+02,0.97380000D+00,0.00000000D+00
     .,0.23905720D+03,0.137D+03,0.160D+02,0.97380000D+00,0.00000000D+00
     .,0.19278770D+03,0.137D+03,0.170D+02,0.97380000D+00,0.00000000D+00
     .,0.15610100D+03,0.137D+03,0.180D+02,0.97380000D+00,0.00000000D+00
     .,0.13058840D+04,0.137D+03,0.190D+02,0.97380000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40101:  40200)=(/
     . 0.10130706D+04,0.137D+03,0.200D+02,0.97380000D+00,0.00000000D+00
     .,0.82610410D+03,0.137D+03,0.210D+02,0.97380000D+00,0.00000000D+00
     .,0.78941170D+03,0.137D+03,0.220D+02,0.97380000D+00,0.00000000D+00
     .,0.71821250D+03,0.137D+03,0.230D+02,0.97380000D+00,0.00000000D+00
     .,0.56618560D+03,0.137D+03,0.240D+02,0.97380000D+00,0.00000000D+00
     .,0.61264440D+03,0.137D+03,0.250D+02,0.97380000D+00,0.00000000D+00
     .,0.48062360D+03,0.137D+03,0.260D+02,0.97380000D+00,0.00000000D+00
     .,0.50159400D+03,0.137D+03,0.270D+02,0.97380000D+00,0.00000000D+00
     .,0.51998260D+03,0.137D+03,0.280D+02,0.97380000D+00,0.00000000D+00
     .,0.39935340D+03,0.137D+03,0.290D+02,0.97380000D+00,0.00000000D+00
     .,0.40105480D+03,0.137D+03,0.300D+02,0.97380000D+00,0.00000000D+00
     .,0.47797370D+03,0.137D+03,0.310D+02,0.97380000D+00,0.00000000D+00
     .,0.41103890D+03,0.137D+03,0.320D+02,0.97380000D+00,0.00000000D+00
     .,0.34339780D+03,0.137D+03,0.330D+02,0.97380000D+00,0.00000000D+00
     .,0.30453120D+03,0.137D+03,0.340D+02,0.97380000D+00,0.00000000D+00
     .,0.26345920D+03,0.137D+03,0.350D+02,0.97380000D+00,0.00000000D+00
     .,0.22685900D+03,0.137D+03,0.360D+02,0.97380000D+00,0.00000000D+00
     .,0.14577817D+04,0.137D+03,0.370D+02,0.97380000D+00,0.00000000D+00
     .,0.12108108D+04,0.137D+03,0.380D+02,0.97380000D+00,0.00000000D+00
     .,0.10374434D+04,0.137D+03,0.390D+02,0.97380000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40201:  40300)=(/
     . 0.92013580D+03,0.137D+03,0.400D+02,0.97380000D+00,0.00000000D+00
     .,0.83213680D+03,0.137D+03,0.410D+02,0.97380000D+00,0.00000000D+00
     .,0.63394710D+03,0.137D+03,0.420D+02,0.97380000D+00,0.00000000D+00
     .,0.71077790D+03,0.137D+03,0.430D+02,0.97380000D+00,0.00000000D+00
     .,0.53361350D+03,0.137D+03,0.440D+02,0.97380000D+00,0.00000000D+00
     .,0.58237420D+03,0.137D+03,0.450D+02,0.97380000D+00,0.00000000D+00
     .,0.53725650D+03,0.137D+03,0.460D+02,0.97380000D+00,0.00000000D+00
     .,0.45047140D+03,0.137D+03,0.470D+02,0.97380000D+00,0.00000000D+00
     .,0.47031190D+03,0.137D+03,0.480D+02,0.97380000D+00,0.00000000D+00
     .,0.59989870D+03,0.137D+03,0.490D+02,0.97380000D+00,0.00000000D+00
     .,0.54287770D+03,0.137D+03,0.500D+02,0.97380000D+00,0.00000000D+00
     .,0.47456410D+03,0.137D+03,0.510D+02,0.97380000D+00,0.00000000D+00
     .,0.43555550D+03,0.137D+03,0.520D+02,0.97380000D+00,0.00000000D+00
     .,0.38946840D+03,0.137D+03,0.530D+02,0.97380000D+00,0.00000000D+00
     .,0.34667910D+03,0.137D+03,0.540D+02,0.97380000D+00,0.00000000D+00
     .,0.17768880D+04,0.137D+03,0.550D+02,0.97380000D+00,0.00000000D+00
     .,0.15569958D+04,0.137D+03,0.560D+02,0.97380000D+00,0.00000000D+00
     .,0.13375010D+04,0.137D+03,0.570D+02,0.97380000D+00,0.00000000D+00
     .,0.56314800D+03,0.137D+03,0.580D+02,0.97380000D+00,0.27991000D+01
     .,0.13695245D+04,0.137D+03,0.590D+02,0.97380000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40301:  40400)=(/
     . 0.13097014D+04,0.137D+03,0.600D+02,0.97380000D+00,0.00000000D+00
     .,0.12753968D+04,0.137D+03,0.610D+02,0.97380000D+00,0.00000000D+00
     .,0.12439950D+04,0.137D+03,0.620D+02,0.97380000D+00,0.00000000D+00
     .,0.12161018D+04,0.137D+03,0.630D+02,0.97380000D+00,0.00000000D+00
     .,0.93460820D+03,0.137D+03,0.640D+02,0.97380000D+00,0.00000000D+00
     .,0.10930934D+04,0.137D+03,0.650D+02,0.97380000D+00,0.00000000D+00
     .,0.10500925D+04,0.137D+03,0.660D+02,0.97380000D+00,0.00000000D+00
     .,0.10903500D+04,0.137D+03,0.670D+02,0.97380000D+00,0.00000000D+00
     .,0.10664469D+04,0.137D+03,0.680D+02,0.97380000D+00,0.00000000D+00
     .,0.10446045D+04,0.137D+03,0.690D+02,0.97380000D+00,0.00000000D+00
     .,0.10333196D+04,0.137D+03,0.700D+02,0.97380000D+00,0.00000000D+00
     .,0.85724780D+03,0.137D+03,0.710D+02,0.97380000D+00,0.00000000D+00
     .,0.82420500D+03,0.137D+03,0.720D+02,0.97380000D+00,0.00000000D+00
     .,0.74273970D+03,0.137D+03,0.730D+02,0.97380000D+00,0.00000000D+00
     .,0.62209770D+03,0.137D+03,0.740D+02,0.97380000D+00,0.00000000D+00
     .,0.62947280D+03,0.137D+03,0.750D+02,0.97380000D+00,0.00000000D+00
     .,0.56455160D+03,0.137D+03,0.760D+02,0.97380000D+00,0.00000000D+00
     .,0.51279660D+03,0.137D+03,0.770D+02,0.97380000D+00,0.00000000D+00
     .,0.42290190D+03,0.137D+03,0.780D+02,0.97380000D+00,0.00000000D+00
     .,0.39392880D+03,0.137D+03,0.790D+02,0.97380000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40401:  40500)=(/
     . 0.40326450D+03,0.137D+03,0.800D+02,0.97380000D+00,0.00000000D+00
     .,0.61404690D+03,0.137D+03,0.810D+02,0.97380000D+00,0.00000000D+00
     .,0.58982750D+03,0.137D+03,0.820D+02,0.97380000D+00,0.00000000D+00
     .,0.53239070D+03,0.137D+03,0.830D+02,0.97380000D+00,0.00000000D+00
     .,0.50286730D+03,0.137D+03,0.840D+02,0.97380000D+00,0.00000000D+00
     .,0.45900050D+03,0.137D+03,0.850D+02,0.97380000D+00,0.00000000D+00
     .,0.41673210D+03,0.137D+03,0.860D+02,0.97380000D+00,0.00000000D+00
     .,0.16476456D+04,0.137D+03,0.870D+02,0.97380000D+00,0.00000000D+00
     .,0.15223656D+04,0.137D+03,0.880D+02,0.97380000D+00,0.00000000D+00
     .,0.13176426D+04,0.137D+03,0.890D+02,0.97380000D+00,0.00000000D+00
     .,0.11578649D+04,0.137D+03,0.900D+02,0.97380000D+00,0.00000000D+00
     .,0.11634976D+04,0.137D+03,0.910D+02,0.97380000D+00,0.00000000D+00
     .,0.11259076D+04,0.137D+03,0.920D+02,0.97380000D+00,0.00000000D+00
     .,0.11753584D+04,0.137D+03,0.930D+02,0.97380000D+00,0.00000000D+00
     .,0.11351209D+04,0.137D+03,0.940D+02,0.97380000D+00,0.00000000D+00
     .,0.57903900D+02,0.137D+03,0.101D+03,0.97380000D+00,0.00000000D+00
     .,0.19967710D+03,0.137D+03,0.103D+03,0.97380000D+00,0.98650000D+00
     .,0.25295740D+03,0.137D+03,0.104D+03,0.97380000D+00,0.98080000D+00
     .,0.18572060D+03,0.137D+03,0.105D+03,0.97380000D+00,0.97060000D+00
     .,0.13721250D+03,0.137D+03,0.106D+03,0.97380000D+00,0.98680000D+00
     ./)
      grimme_c6_parameters(  40501:  40600)=(/
     . 0.93458400D+02,0.137D+03,0.107D+03,0.97380000D+00,0.99440000D+00
     .,0.67004500D+02,0.137D+03,0.108D+03,0.97380000D+00,0.99250000D+00
     .,0.45248900D+02,0.137D+03,0.109D+03,0.97380000D+00,0.99820000D+00
     .,0.29467950D+03,0.137D+03,0.111D+03,0.97380000D+00,0.96840000D+00
     .,0.45778310D+03,0.137D+03,0.112D+03,0.97380000D+00,0.96280000D+00
     .,0.45336360D+03,0.137D+03,0.113D+03,0.97380000D+00,0.96480000D+00
     .,0.35341420D+03,0.137D+03,0.114D+03,0.97380000D+00,0.95070000D+00
     .,0.28343680D+03,0.137D+03,0.115D+03,0.97380000D+00,0.99470000D+00
     .,0.23654670D+03,0.137D+03,0.116D+03,0.97380000D+00,0.99480000D+00
     .,0.19086020D+03,0.137D+03,0.117D+03,0.97380000D+00,0.99720000D+00
     .,0.40103710D+03,0.137D+03,0.119D+03,0.97380000D+00,0.97670000D+00
     .,0.81234890D+03,0.137D+03,0.120D+03,0.97380000D+00,0.98310000D+00
     .,0.38990570D+03,0.137D+03,0.121D+03,0.97380000D+00,0.18627000D+01
     .,0.37639190D+03,0.137D+03,0.122D+03,0.97380000D+00,0.18299000D+01
     .,0.36906490D+03,0.137D+03,0.123D+03,0.97380000D+00,0.19138000D+01
     .,0.36686860D+03,0.137D+03,0.124D+03,0.97380000D+00,0.18269000D+01
     .,0.33222150D+03,0.137D+03,0.125D+03,0.97380000D+00,0.16406000D+01
     .,0.30627200D+03,0.137D+03,0.126D+03,0.97380000D+00,0.16483000D+01
     .,0.29229920D+03,0.137D+03,0.127D+03,0.97380000D+00,0.17149000D+01
     .,0.28612410D+03,0.137D+03,0.128D+03,0.97380000D+00,0.17937000D+01
     ./)
      grimme_c6_parameters(  40601:  40700)=(/
     . 0.28601310D+03,0.137D+03,0.129D+03,0.97380000D+00,0.95760000D+00
     .,0.26273320D+03,0.137D+03,0.130D+03,0.97380000D+00,0.19419000D+01
     .,0.44607980D+03,0.137D+03,0.131D+03,0.97380000D+00,0.96010000D+00
     .,0.38250120D+03,0.137D+03,0.132D+03,0.97380000D+00,0.94340000D+00
     .,0.33721600D+03,0.137D+03,0.133D+03,0.97380000D+00,0.98890000D+00
     .,0.30472790D+03,0.137D+03,0.134D+03,0.97380000D+00,0.99010000D+00
     .,0.26546470D+03,0.137D+03,0.135D+03,0.97380000D+00,0.99740000D+00
     .,0.47625910D+03,0.137D+03,0.137D+03,0.97380000D+00,0.97380000D+00
     .,0.64406500D+02,0.138D+03,0.100D+01,0.98010000D+00,0.91180000D+00
     .,0.38833300D+02,0.138D+03,0.200D+01,0.98010000D+00,0.00000000D+00
     .,0.16182465D+04,0.138D+03,0.300D+01,0.98010000D+00,0.00000000D+00
     .,0.73479260D+03,0.138D+03,0.400D+01,0.98010000D+00,0.00000000D+00
     .,0.44112610D+03,0.138D+03,0.500D+01,0.98010000D+00,0.00000000D+00
     .,0.27470310D+03,0.138D+03,0.600D+01,0.98010000D+00,0.00000000D+00
     .,0.18119730D+03,0.138D+03,0.700D+01,0.98010000D+00,0.00000000D+00
     .,0.13178460D+03,0.138D+03,0.800D+01,0.98010000D+00,0.00000000D+00
     .,0.96508000D+02,0.138D+03,0.900D+01,0.98010000D+00,0.00000000D+00
     .,0.72270300D+02,0.138D+03,0.100D+02,0.98010000D+00,0.00000000D+00
     .,0.19079592D+04,0.138D+03,0.110D+02,0.98010000D+00,0.00000000D+00
     .,0.12181274D+04,0.138D+03,0.120D+02,0.98010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40701:  40800)=(/
     . 0.10570218D+04,0.138D+03,0.130D+02,0.98010000D+00,0.00000000D+00
     .,0.76638470D+03,0.138D+03,0.140D+02,0.98010000D+00,0.00000000D+00
     .,0.55938210D+03,0.138D+03,0.150D+02,0.98010000D+00,0.00000000D+00
     .,0.44578600D+03,0.138D+03,0.160D+02,0.98010000D+00,0.00000000D+00
     .,0.35042730D+03,0.138D+03,0.170D+02,0.98010000D+00,0.00000000D+00
     .,0.27747590D+03,0.138D+03,0.180D+02,0.98010000D+00,0.00000000D+00
     .,0.33022504D+04,0.138D+03,0.190D+02,0.98010000D+00,0.00000000D+00
     .,0.23148420D+04,0.138D+03,0.200D+02,0.98010000D+00,0.00000000D+00
     .,0.18497319D+04,0.138D+03,0.210D+02,0.98010000D+00,0.00000000D+00
     .,0.17407410D+04,0.138D+03,0.220D+02,0.98010000D+00,0.00000000D+00
     .,0.15682263D+04,0.138D+03,0.230D+02,0.98010000D+00,0.00000000D+00
     .,0.12385036D+04,0.138D+03,0.240D+02,0.98010000D+00,0.00000000D+00
     .,0.13188096D+04,0.138D+03,0.250D+02,0.98010000D+00,0.00000000D+00
     .,0.10340602D+04,0.138D+03,0.260D+02,0.98010000D+00,0.00000000D+00
     .,0.10522336D+04,0.138D+03,0.270D+02,0.98010000D+00,0.00000000D+00
     .,0.11016666D+04,0.138D+03,0.280D+02,0.98010000D+00,0.00000000D+00
     .,0.84879520D+03,0.138D+03,0.290D+02,0.98010000D+00,0.00000000D+00
     .,0.82251670D+03,0.138D+03,0.300D+02,0.98010000D+00,0.00000000D+00
     .,0.99191230D+03,0.138D+03,0.310D+02,0.98010000D+00,0.00000000D+00
     .,0.81848870D+03,0.138D+03,0.320D+02,0.98010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40801:  40900)=(/
     . 0.66009280D+03,0.138D+03,0.330D+02,0.98010000D+00,0.00000000D+00
     .,0.57308500D+03,0.138D+03,0.340D+02,0.98010000D+00,0.00000000D+00
     .,0.48506500D+03,0.138D+03,0.350D+02,0.98010000D+00,0.00000000D+00
     .,0.40937610D+03,0.138D+03,0.360D+02,0.98010000D+00,0.00000000D+00
     .,0.36709261D+04,0.138D+03,0.370D+02,0.98010000D+00,0.00000000D+00
     .,0.27824577D+04,0.138D+03,0.380D+02,0.98010000D+00,0.00000000D+00
     .,0.23056086D+04,0.138D+03,0.390D+02,0.98010000D+00,0.00000000D+00
     .,0.20037829D+04,0.138D+03,0.400D+02,0.98010000D+00,0.00000000D+00
     .,0.17897638D+04,0.138D+03,0.410D+02,0.98010000D+00,0.00000000D+00
     .,0.13350700D+04,0.138D+03,0.420D+02,0.98010000D+00,0.00000000D+00
     .,0.15092981D+04,0.138D+03,0.430D+02,0.98010000D+00,0.00000000D+00
     .,0.11061259D+04,0.138D+03,0.440D+02,0.98010000D+00,0.00000000D+00
     .,0.12034301D+04,0.138D+03,0.450D+02,0.98010000D+00,0.00000000D+00
     .,0.11005370D+04,0.138D+03,0.460D+02,0.98010000D+00,0.00000000D+00
     .,0.93160220D+03,0.138D+03,0.470D+02,0.98010000D+00,0.00000000D+00
     .,0.95275330D+03,0.138D+03,0.480D+02,0.98010000D+00,0.00000000D+00
     .,0.12501173D+04,0.138D+03,0.490D+02,0.98010000D+00,0.00000000D+00
     .,0.10916636D+04,0.138D+03,0.500D+02,0.98010000D+00,0.00000000D+00
     .,0.92413690D+03,0.138D+03,0.510D+02,0.98010000D+00,0.00000000D+00
     .,0.83250600D+03,0.138D+03,0.520D+02,0.98010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  40901:  41000)=(/
     . 0.72971760D+03,0.138D+03,0.530D+02,0.98010000D+00,0.00000000D+00
     .,0.63746600D+03,0.138D+03,0.540D+02,0.98010000D+00,0.00000000D+00
     .,0.44969846D+04,0.138D+03,0.550D+02,0.98010000D+00,0.00000000D+00
     .,0.36314540D+04,0.138D+03,0.560D+02,0.98010000D+00,0.00000000D+00
     .,0.30140781D+04,0.138D+03,0.570D+02,0.98010000D+00,0.00000000D+00
     .,0.11044325D+04,0.138D+03,0.580D+02,0.98010000D+00,0.27991000D+01
     .,0.31621198D+04,0.138D+03,0.590D+02,0.98010000D+00,0.00000000D+00
     .,0.29999283D+04,0.138D+03,0.600D+02,0.98010000D+00,0.00000000D+00
     .,0.29157949D+04,0.138D+03,0.610D+02,0.98010000D+00,0.00000000D+00
     .,0.28393501D+04,0.138D+03,0.620D+02,0.98010000D+00,0.00000000D+00
     .,0.27713234D+04,0.138D+03,0.630D+02,0.98010000D+00,0.00000000D+00
     .,0.20594692D+04,0.138D+03,0.640D+02,0.98010000D+00,0.00000000D+00
     .,0.25668729D+04,0.138D+03,0.650D+02,0.98010000D+00,0.00000000D+00
     .,0.24578402D+04,0.138D+03,0.660D+02,0.98010000D+00,0.00000000D+00
     .,0.24609470D+04,0.138D+03,0.670D+02,0.98010000D+00,0.00000000D+00
     .,0.24041111D+04,0.138D+03,0.680D+02,0.98010000D+00,0.00000000D+00
     .,0.23512803D+04,0.138D+03,0.690D+02,0.98010000D+00,0.00000000D+00
     .,0.23289369D+04,0.138D+03,0.700D+02,0.98010000D+00,0.00000000D+00
     .,0.18927447D+04,0.138D+03,0.710D+02,0.98010000D+00,0.00000000D+00
     .,0.17529565D+04,0.138D+03,0.720D+02,0.98010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  41001:  41100)=(/
     . 0.15479897D+04,0.138D+03,0.730D+02,0.98010000D+00,0.00000000D+00
     .,0.12804929D+04,0.138D+03,0.740D+02,0.98010000D+00,0.00000000D+00
     .,0.12840434D+04,0.138D+03,0.750D+02,0.98010000D+00,0.00000000D+00
     .,0.11312913D+04,0.138D+03,0.760D+02,0.98010000D+00,0.00000000D+00
     .,0.10131095D+04,0.138D+03,0.770D+02,0.98010000D+00,0.00000000D+00
     .,0.82466090D+03,0.138D+03,0.780D+02,0.98010000D+00,0.00000000D+00
     .,0.76388530D+03,0.138D+03,0.790D+02,0.98010000D+00,0.00000000D+00
     .,0.77550460D+03,0.138D+03,0.800D+02,0.98010000D+00,0.00000000D+00
     .,0.12742283D+04,0.138D+03,0.810D+02,0.98010000D+00,0.00000000D+00
     .,0.11873359D+04,0.138D+03,0.820D+02,0.98010000D+00,0.00000000D+00
     .,0.10400523D+04,0.138D+03,0.830D+02,0.98010000D+00,0.00000000D+00
     .,0.96630350D+03,0.138D+03,0.840D+02,0.98010000D+00,0.00000000D+00
     .,0.86500840D+03,0.138D+03,0.850D+02,0.98010000D+00,0.00000000D+00
     .,0.77178770D+03,0.138D+03,0.860D+02,0.98010000D+00,0.00000000D+00
     .,0.40533897D+04,0.138D+03,0.870D+02,0.98010000D+00,0.00000000D+00
     .,0.34910837D+04,0.138D+03,0.880D+02,0.98010000D+00,0.00000000D+00
     .,0.29248174D+04,0.138D+03,0.890D+02,0.98010000D+00,0.00000000D+00
     .,0.24812627D+04,0.138D+03,0.900D+02,0.98010000D+00,0.00000000D+00
     .,0.25425532D+04,0.138D+03,0.910D+02,0.98010000D+00,0.00000000D+00
     .,0.24572393D+04,0.138D+03,0.920D+02,0.98010000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  41101:  41200)=(/
     . 0.26180036D+04,0.138D+03,0.930D+02,0.98010000D+00,0.00000000D+00
     .,0.25175053D+04,0.138D+03,0.940D+02,0.98010000D+00,0.00000000D+00
     .,0.11032750D+03,0.138D+03,0.101D+03,0.98010000D+00,0.00000000D+00
     .,0.42146100D+03,0.138D+03,0.103D+03,0.98010000D+00,0.98650000D+00
     .,0.52954940D+03,0.138D+03,0.104D+03,0.98010000D+00,0.98080000D+00
     .,0.36336070D+03,0.138D+03,0.105D+03,0.98010000D+00,0.97060000D+00
     .,0.25898850D+03,0.138D+03,0.106D+03,0.98010000D+00,0.98680000D+00
     .,0.16917720D+03,0.138D+03,0.107D+03,0.98010000D+00,0.99440000D+00
     .,0.11710180D+03,0.138D+03,0.108D+03,0.98010000D+00,0.99250000D+00
     .,0.75675800D+02,0.138D+03,0.109D+03,0.98010000D+00,0.99820000D+00
     .,0.63083040D+03,0.138D+03,0.111D+03,0.98010000D+00,0.96840000D+00
     .,0.98878570D+03,0.138D+03,0.112D+03,0.98010000D+00,0.96280000D+00
     .,0.94475350D+03,0.138D+03,0.113D+03,0.98010000D+00,0.96480000D+00
     .,0.70100090D+03,0.138D+03,0.114D+03,0.98010000D+00,0.95070000D+00
     .,0.54212620D+03,0.138D+03,0.115D+03,0.98010000D+00,0.99470000D+00
     .,0.44147190D+03,0.138D+03,0.116D+03,0.98010000D+00,0.99480000D+00
     .,0.34712550D+03,0.138D+03,0.117D+03,0.98010000D+00,0.99720000D+00
     .,0.84199830D+03,0.138D+03,0.119D+03,0.98010000D+00,0.97670000D+00
     .,0.18769417D+04,0.138D+03,0.120D+03,0.98010000D+00,0.98310000D+00
     .,0.77994880D+03,0.138D+03,0.121D+03,0.98010000D+00,0.18627000D+01
     ./)
      grimme_c6_parameters(  41201:  41300)=(/
     . 0.75467530D+03,0.138D+03,0.122D+03,0.98010000D+00,0.18299000D+01
     .,0.74017630D+03,0.138D+03,0.123D+03,0.98010000D+00,0.19138000D+01
     .,0.73983150D+03,0.138D+03,0.124D+03,0.98010000D+00,0.18269000D+01
     .,0.65184050D+03,0.138D+03,0.125D+03,0.98010000D+00,0.16406000D+01
     .,0.59697670D+03,0.138D+03,0.126D+03,0.98010000D+00,0.16483000D+01
     .,0.57030240D+03,0.138D+03,0.127D+03,0.98010000D+00,0.17149000D+01
     .,0.55938830D+03,0.138D+03,0.128D+03,0.98010000D+00,0.17937000D+01
     .,0.56991510D+03,0.138D+03,0.129D+03,0.98010000D+00,0.95760000D+00
     .,0.50526080D+03,0.138D+03,0.130D+03,0.98010000D+00,0.19419000D+01
     .,0.91623120D+03,0.138D+03,0.131D+03,0.98010000D+00,0.96010000D+00
     .,0.75505840D+03,0.138D+03,0.132D+03,0.98010000D+00,0.94340000D+00
     .,0.64702200D+03,0.138D+03,0.133D+03,0.98010000D+00,0.98890000D+00
     .,0.57371350D+03,0.138D+03,0.134D+03,0.98010000D+00,0.99010000D+00
     .,0.48934610D+03,0.138D+03,0.135D+03,0.98010000D+00,0.99740000D+00
     .,0.99279700D+03,0.138D+03,0.137D+03,0.98010000D+00,0.97380000D+00
     .,0.23126602D+04,0.138D+03,0.138D+03,0.98010000D+00,0.98010000D+00
     .,0.51235600D+02,0.139D+03,0.100D+01,0.19153000D+01,0.91180000D+00
     .,0.31988900D+02,0.139D+03,0.200D+01,0.19153000D+01,0.00000000D+00
     .,0.10745875D+04,0.139D+03,0.300D+01,0.19153000D+01,0.00000000D+00
     .,0.53251100D+03,0.139D+03,0.400D+01,0.19153000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  41301:  41400)=(/
     . 0.33413510D+03,0.139D+03,0.500D+01,0.19153000D+01,0.00000000D+00
     .,0.21477600D+03,0.139D+03,0.600D+01,0.19153000D+01,0.00000000D+00
     .,0.14492070D+03,0.139D+03,0.700D+01,0.19153000D+01,0.00000000D+00
     .,0.10704380D+03,0.139D+03,0.800D+01,0.19153000D+01,0.00000000D+00
     .,0.79407600D+02,0.139D+03,0.900D+01,0.19153000D+01,0.00000000D+00
     .,0.60062800D+02,0.139D+03,0.100D+02,0.19153000D+01,0.00000000D+00
     .,0.12727028D+04,0.139D+03,0.110D+02,0.19153000D+01,0.00000000D+00
     .,0.86937390D+03,0.139D+03,0.120D+02,0.19153000D+01,0.00000000D+00
     .,0.77186060D+03,0.139D+03,0.130D+02,0.19153000D+01,0.00000000D+00
     .,0.57805500D+03,0.139D+03,0.140D+02,0.19153000D+01,0.00000000D+00
     .,0.43301710D+03,0.139D+03,0.150D+02,0.19153000D+01,0.00000000D+00
     .,0.35057750D+03,0.139D+03,0.160D+02,0.19153000D+01,0.00000000D+00
     .,0.27973550D+03,0.139D+03,0.170D+02,0.19153000D+01,0.00000000D+00
     .,0.22431260D+03,0.139D+03,0.180D+02,0.19153000D+01,0.00000000D+00
     .,0.21637031D+04,0.139D+03,0.190D+02,0.19153000D+01,0.00000000D+00
     .,0.16036362D+04,0.139D+03,0.200D+02,0.19153000D+01,0.00000000D+00
     .,0.12972964D+04,0.139D+03,0.210D+02,0.19153000D+01,0.00000000D+00
     .,0.12323433D+04,0.139D+03,0.220D+02,0.19153000D+01,0.00000000D+00
     .,0.11169531D+04,0.139D+03,0.230D+02,0.19153000D+01,0.00000000D+00
     .,0.88060690D+03,0.139D+03,0.240D+02,0.19153000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  41401:  41500)=(/
     . 0.94758340D+03,0.139D+03,0.250D+02,0.19153000D+01,0.00000000D+00
     .,0.74266410D+03,0.139D+03,0.260D+02,0.19153000D+01,0.00000000D+00
     .,0.76821070D+03,0.139D+03,0.270D+02,0.19153000D+01,0.00000000D+00
     .,0.79937100D+03,0.139D+03,0.280D+02,0.19153000D+01,0.00000000D+00
     .,0.61409830D+03,0.139D+03,0.290D+02,0.19153000D+01,0.00000000D+00
     .,0.60904990D+03,0.139D+03,0.300D+02,0.19153000D+01,0.00000000D+00
     .,0.72958130D+03,0.139D+03,0.310D+02,0.19153000D+01,0.00000000D+00
     .,0.61799850D+03,0.139D+03,0.320D+02,0.19153000D+01,0.00000000D+00
     .,0.50955030D+03,0.139D+03,0.330D+02,0.19153000D+01,0.00000000D+00
     .,0.44813810D+03,0.139D+03,0.340D+02,0.19153000D+01,0.00000000D+00
     .,0.38429010D+03,0.139D+03,0.350D+02,0.19153000D+01,0.00000000D+00
     .,0.32813160D+03,0.139D+03,0.360D+02,0.19153000D+01,0.00000000D+00
     .,0.24114577D+04,0.139D+03,0.370D+02,0.19153000D+01,0.00000000D+00
     .,0.19209295D+04,0.139D+03,0.380D+02,0.19153000D+01,0.00000000D+00
     .,0.16243636D+04,0.139D+03,0.390D+02,0.19153000D+01,0.00000000D+00
     .,0.14293576D+04,0.139D+03,0.400D+02,0.19153000D+01,0.00000000D+00
     .,0.12864770D+04,0.139D+03,0.410D+02,0.19153000D+01,0.00000000D+00
     .,0.97159590D+03,0.139D+03,0.420D+02,0.19153000D+01,0.00000000D+00
     .,0.10932424D+04,0.139D+03,0.430D+02,0.19153000D+01,0.00000000D+00
     .,0.81262860D+03,0.139D+03,0.440D+02,0.19153000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  41501:  41600)=(/
     . 0.88627500D+03,0.139D+03,0.450D+02,0.19153000D+01,0.00000000D+00
     .,0.81484020D+03,0.139D+03,0.460D+02,0.19153000D+01,0.00000000D+00
     .,0.68497960D+03,0.139D+03,0.470D+02,0.19153000D+01,0.00000000D+00
     .,0.71021720D+03,0.139D+03,0.480D+02,0.19153000D+01,0.00000000D+00
     .,0.91615920D+03,0.139D+03,0.490D+02,0.19153000D+01,0.00000000D+00
     .,0.81841300D+03,0.139D+03,0.500D+02,0.19153000D+01,0.00000000D+00
     .,0.70709330D+03,0.139D+03,0.510D+02,0.19153000D+01,0.00000000D+00
     .,0.64444940D+03,0.139D+03,0.520D+02,0.19153000D+01,0.00000000D+00
     .,0.57184320D+03,0.139D+03,0.530D+02,0.19153000D+01,0.00000000D+00
     .,0.50522620D+03,0.139D+03,0.540D+02,0.19153000D+01,0.00000000D+00
     .,0.29502475D+04,0.139D+03,0.550D+02,0.19153000D+01,0.00000000D+00
     .,0.24856310D+04,0.139D+03,0.560D+02,0.19153000D+01,0.00000000D+00
     .,0.21057491D+04,0.139D+03,0.570D+02,0.19153000D+01,0.00000000D+00
     .,0.84084100D+03,0.139D+03,0.580D+02,0.19153000D+01,0.27991000D+01
     .,0.21783229D+04,0.139D+03,0.590D+02,0.19153000D+01,0.00000000D+00
     .,0.20748807D+04,0.139D+03,0.600D+02,0.19153000D+01,0.00000000D+00
     .,0.20189224D+04,0.139D+03,0.610D+02,0.19153000D+01,0.00000000D+00
     .,0.19678827D+04,0.139D+03,0.620D+02,0.19153000D+01,0.00000000D+00
     .,0.19225226D+04,0.139D+03,0.630D+02,0.19153000D+01,0.00000000D+00
     .,0.14581969D+04,0.139D+03,0.640D+02,0.19153000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  41601:  41700)=(/
     . 0.17521144D+04,0.139D+03,0.650D+02,0.19153000D+01,0.00000000D+00
     .,0.16830549D+04,0.139D+03,0.660D+02,0.19153000D+01,0.00000000D+00
     .,0.17170123D+04,0.139D+03,0.670D+02,0.19153000D+01,0.00000000D+00
     .,0.16785781D+04,0.139D+03,0.680D+02,0.19153000D+01,0.00000000D+00
     .,0.16432139D+04,0.139D+03,0.690D+02,0.19153000D+01,0.00000000D+00
     .,0.16263339D+04,0.139D+03,0.700D+02,0.19153000D+01,0.00000000D+00
     .,0.13398149D+04,0.139D+03,0.710D+02,0.19153000D+01,0.00000000D+00
     .,0.12689492D+04,0.139D+03,0.720D+02,0.19153000D+01,0.00000000D+00
     .,0.11346407D+04,0.139D+03,0.730D+02,0.19153000D+01,0.00000000D+00
     .,0.94540990D+03,0.139D+03,0.740D+02,0.19153000D+01,0.00000000D+00
     .,0.95356340D+03,0.139D+03,0.750D+02,0.19153000D+01,0.00000000D+00
     .,0.84938170D+03,0.139D+03,0.760D+02,0.19153000D+01,0.00000000D+00
     .,0.76730030D+03,0.139D+03,0.770D+02,0.19153000D+01,0.00000000D+00
     .,0.62916050D+03,0.139D+03,0.780D+02,0.19153000D+01,0.00000000D+00
     .,0.58463530D+03,0.139D+03,0.790D+02,0.19153000D+01,0.00000000D+00
     .,0.59694450D+03,0.139D+03,0.800D+02,0.19153000D+01,0.00000000D+00
     .,0.93562990D+03,0.139D+03,0.810D+02,0.19153000D+01,0.00000000D+00
     .,0.88887560D+03,0.139D+03,0.820D+02,0.19153000D+01,0.00000000D+00
     .,0.79367010D+03,0.139D+03,0.830D+02,0.19153000D+01,0.00000000D+00
     .,0.74514710D+03,0.139D+03,0.840D+02,0.19153000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  41701:  41800)=(/
     . 0.67518420D+03,0.139D+03,0.850D+02,0.19153000D+01,0.00000000D+00
     .,0.60886250D+03,0.139D+03,0.860D+02,0.19153000D+01,0.00000000D+00
     .,0.26980970D+04,0.139D+03,0.870D+02,0.19153000D+01,0.00000000D+00
     .,0.24134225D+04,0.139D+03,0.880D+02,0.19153000D+01,0.00000000D+00
     .,0.20622685D+04,0.139D+03,0.890D+02,0.19153000D+01,0.00000000D+00
     .,0.17871863D+04,0.139D+03,0.900D+02,0.19153000D+01,0.00000000D+00
     .,0.18092861D+04,0.139D+03,0.910D+02,0.19153000D+01,0.00000000D+00
     .,0.17497379D+04,0.139D+03,0.920D+02,0.19153000D+01,0.00000000D+00
     .,0.18406901D+04,0.139D+03,0.930D+02,0.19153000D+01,0.00000000D+00
     .,0.17746391D+04,0.139D+03,0.940D+02,0.19153000D+01,0.00000000D+00
     .,0.85681500D+02,0.139D+03,0.101D+03,0.19153000D+01,0.00000000D+00
     .,0.30688620D+03,0.139D+03,0.103D+03,0.19153000D+01,0.98650000D+00
     .,0.38765640D+03,0.139D+03,0.104D+03,0.19153000D+01,0.98080000D+00
     .,0.27740500D+03,0.139D+03,0.105D+03,0.19153000D+01,0.97060000D+00
     .,0.20197440D+03,0.139D+03,0.106D+03,0.19153000D+01,0.98680000D+00
     .,0.13518390D+03,0.139D+03,0.107D+03,0.19153000D+01,0.99440000D+00
     .,0.95445800D+02,0.139D+03,0.108D+03,0.19153000D+01,0.99250000D+00
     .,0.63188900D+02,0.139D+03,0.109D+03,0.19153000D+01,0.99820000D+00
     .,0.45499280D+03,0.139D+03,0.111D+03,0.19153000D+01,0.96840000D+00
     .,0.70969610D+03,0.139D+03,0.112D+03,0.19153000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters(  41801:  41900)=(/
     . 0.69347320D+03,0.139D+03,0.113D+03,0.19153000D+01,0.96480000D+00
     .,0.53081800D+03,0.139D+03,0.114D+03,0.19153000D+01,0.95070000D+00
     .,0.41987180D+03,0.139D+03,0.115D+03,0.19153000D+01,0.99470000D+00
     .,0.34697100D+03,0.139D+03,0.116D+03,0.19153000D+01,0.99480000D+00
     .,0.27697730D+03,0.139D+03,0.117D+03,0.19153000D+01,0.99720000D+00
     .,0.61384630D+03,0.139D+03,0.119D+03,0.19153000D+01,0.97670000D+00
     .,0.12935159D+04,0.139D+03,0.120D+03,0.19153000D+01,0.98310000D+00
     .,0.58631350D+03,0.139D+03,0.121D+03,0.19153000D+01,0.18627000D+01
     .,0.56686700D+03,0.139D+03,0.122D+03,0.19153000D+01,0.18299000D+01
     .,0.55572150D+03,0.139D+03,0.123D+03,0.19153000D+01,0.19138000D+01
     .,0.55347640D+03,0.139D+03,0.124D+03,0.19153000D+01,0.18269000D+01
     .,0.49633310D+03,0.139D+03,0.125D+03,0.19153000D+01,0.16406000D+01
     .,0.45638780D+03,0.139D+03,0.126D+03,0.19153000D+01,0.16483000D+01
     .,0.43567010D+03,0.139D+03,0.127D+03,0.19153000D+01,0.17149000D+01
     .,0.42674050D+03,0.139D+03,0.128D+03,0.19153000D+01,0.17937000D+01
     .,0.42937430D+03,0.139D+03,0.129D+03,0.19153000D+01,0.95760000D+00
     .,0.38958110D+03,0.139D+03,0.130D+03,0.19153000D+01,0.19419000D+01
     .,0.67825900D+03,0.139D+03,0.131D+03,0.19153000D+01,0.96010000D+00
     .,0.57321390D+03,0.139D+03,0.132D+03,0.19153000D+01,0.94340000D+00
     .,0.50000710D+03,0.139D+03,0.133D+03,0.19153000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters(  41901:  42000)=(/
     . 0.44848720D+03,0.139D+03,0.134D+03,0.19153000D+01,0.99010000D+00
     .,0.38738760D+03,0.139D+03,0.135D+03,0.19153000D+01,0.99740000D+00
     .,0.72686130D+03,0.139D+03,0.137D+03,0.19153000D+01,0.97380000D+00
     .,0.15865402D+04,0.139D+03,0.138D+03,0.19153000D+01,0.98010000D+00
     .,0.11322983D+04,0.139D+03,0.139D+03,0.19153000D+01,0.19153000D+01
     .,0.39666900D+02,0.140D+03,0.100D+01,0.19355000D+01,0.91180000D+00
     .,0.25703700D+02,0.140D+03,0.200D+01,0.19355000D+01,0.00000000D+00
     .,0.67848100D+03,0.140D+03,0.300D+01,0.19355000D+01,0.00000000D+00
     .,0.37401350D+03,0.140D+03,0.400D+01,0.19355000D+01,0.00000000D+00
     .,0.24601470D+03,0.140D+03,0.500D+01,0.19355000D+01,0.00000000D+00
     .,0.16345480D+03,0.140D+03,0.600D+01,0.19355000D+01,0.00000000D+00
     .,0.11293390D+03,0.140D+03,0.700D+01,0.19355000D+01,0.00000000D+00
     .,0.84787600D+02,0.140D+03,0.800D+01,0.19355000D+01,0.00000000D+00
     .,0.63768000D+02,0.140D+03,0.900D+01,0.19355000D+01,0.00000000D+00
     .,0.48760000D+02,0.140D+03,0.100D+02,0.19355000D+01,0.00000000D+00
     .,0.80899730D+03,0.140D+03,0.110D+02,0.19355000D+01,0.00000000D+00
     .,0.60055110D+03,0.140D+03,0.120D+02,0.19355000D+01,0.00000000D+00
     .,0.54671760D+03,0.140D+03,0.130D+02,0.19355000D+01,0.00000000D+00
     .,0.42369920D+03,0.140D+03,0.140D+02,0.19355000D+01,0.00000000D+00
     .,0.32600870D+03,0.140D+03,0.150D+02,0.19355000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42001:  42100)=(/
     . 0.26830770D+03,0.140D+03,0.160D+02,0.19355000D+01,0.00000000D+00
     .,0.21743220D+03,0.140D+03,0.170D+02,0.19355000D+01,0.00000000D+00
     .,0.17666900D+03,0.140D+03,0.180D+02,0.19355000D+01,0.00000000D+00
     .,0.13359899D+04,0.140D+03,0.190D+02,0.19355000D+01,0.00000000D+00
     .,0.10709104D+04,0.140D+03,0.200D+02,0.19355000D+01,0.00000000D+00
     .,0.87901650D+03,0.140D+03,0.210D+02,0.19355000D+01,0.00000000D+00
     .,0.84415650D+03,0.140D+03,0.220D+02,0.19355000D+01,0.00000000D+00
     .,0.77041850D+03,0.140D+03,0.230D+02,0.19355000D+01,0.00000000D+00
     .,0.60670400D+03,0.140D+03,0.240D+02,0.19355000D+01,0.00000000D+00
     .,0.66010050D+03,0.140D+03,0.250D+02,0.19355000D+01,0.00000000D+00
     .,0.51758120D+03,0.140D+03,0.260D+02,0.19355000D+01,0.00000000D+00
     .,0.54466430D+03,0.140D+03,0.270D+02,0.19355000D+01,0.00000000D+00
     .,0.56293440D+03,0.140D+03,0.280D+02,0.19355000D+01,0.00000000D+00
     .,0.43155440D+03,0.140D+03,0.290D+02,0.19355000D+01,0.00000000D+00
     .,0.43840800D+03,0.140D+03,0.300D+02,0.19355000D+01,0.00000000D+00
     .,0.52118020D+03,0.140D+03,0.310D+02,0.19355000D+01,0.00000000D+00
     .,0.45369050D+03,0.140D+03,0.320D+02,0.19355000D+01,0.00000000D+00
     .,0.38264580D+03,0.140D+03,0.330D+02,0.19355000D+01,0.00000000D+00
     .,0.34103380D+03,0.140D+03,0.340D+02,0.19355000D+01,0.00000000D+00
     .,0.29639440D+03,0.140D+03,0.350D+02,0.19355000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42101:  42200)=(/
     . 0.25615010D+03,0.140D+03,0.360D+02,0.19355000D+01,0.00000000D+00
     .,0.14937993D+04,0.140D+03,0.370D+02,0.19355000D+01,0.00000000D+00
     .,0.12775813D+04,0.140D+03,0.380D+02,0.19355000D+01,0.00000000D+00
     .,0.11066630D+04,0.140D+03,0.390D+02,0.19355000D+01,0.00000000D+00
     .,0.98782570D+03,0.140D+03,0.400D+02,0.19355000D+01,0.00000000D+00
     .,0.89679520D+03,0.140D+03,0.410D+02,0.19355000D+01,0.00000000D+00
     .,0.68718480D+03,0.140D+03,0.420D+02,0.19355000D+01,0.00000000D+00
     .,0.76884280D+03,0.140D+03,0.430D+02,0.19355000D+01,0.00000000D+00
     .,0.58090070D+03,0.140D+03,0.440D+02,0.19355000D+01,0.00000000D+00
     .,0.63480240D+03,0.140D+03,0.450D+02,0.19355000D+01,0.00000000D+00
     .,0.58702020D+03,0.140D+03,0.460D+02,0.19355000D+01,0.00000000D+00
     .,0.49038170D+03,0.140D+03,0.470D+02,0.19355000D+01,0.00000000D+00
     .,0.51538610D+03,0.140D+03,0.480D+02,0.19355000D+01,0.00000000D+00
     .,0.65256540D+03,0.140D+03,0.490D+02,0.19355000D+01,0.00000000D+00
     .,0.59689190D+03,0.140D+03,0.500D+02,0.19355000D+01,0.00000000D+00
     .,0.52654260D+03,0.140D+03,0.510D+02,0.19355000D+01,0.00000000D+00
     .,0.48561760D+03,0.140D+03,0.520D+02,0.19355000D+01,0.00000000D+00
     .,0.43630460D+03,0.140D+03,0.530D+02,0.19355000D+01,0.00000000D+00
     .,0.38993850D+03,0.140D+03,0.540D+02,0.19355000D+01,0.00000000D+00
     .,0.18190406D+04,0.140D+03,0.550D+02,0.19355000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42201:  42300)=(/
     . 0.16353622D+04,0.140D+03,0.560D+02,0.19355000D+01,0.00000000D+00
     .,0.14206192D+04,0.140D+03,0.570D+02,0.19355000D+01,0.00000000D+00
     .,0.62328410D+03,0.140D+03,0.580D+02,0.19355000D+01,0.27991000D+01
     .,0.14429680D+04,0.140D+03,0.590D+02,0.19355000D+01,0.00000000D+00
     .,0.13832190D+04,0.140D+03,0.600D+02,0.19355000D+01,0.00000000D+00
     .,0.13477804D+04,0.140D+03,0.610D+02,0.19355000D+01,0.00000000D+00
     .,0.13152670D+04,0.140D+03,0.620D+02,0.19355000D+01,0.00000000D+00
     .,0.12864106D+04,0.140D+03,0.630D+02,0.19355000D+01,0.00000000D+00
     .,0.99936150D+03,0.140D+03,0.640D+02,0.19355000D+01,0.00000000D+00
     .,0.11461276D+04,0.140D+03,0.650D+02,0.19355000D+01,0.00000000D+00
     .,0.11025614D+04,0.140D+03,0.660D+02,0.19355000D+01,0.00000000D+00
     .,0.11568729D+04,0.140D+03,0.670D+02,0.19355000D+01,0.00000000D+00
     .,0.11319421D+04,0.140D+03,0.680D+02,0.19355000D+01,0.00000000D+00
     .,0.11093035D+04,0.140D+03,0.690D+02,0.19355000D+01,0.00000000D+00
     .,0.10968681D+04,0.140D+03,0.700D+02,0.19355000D+01,0.00000000D+00
     .,0.91629250D+03,0.140D+03,0.710D+02,0.19355000D+01,0.00000000D+00
     .,0.89141000D+03,0.140D+03,0.720D+02,0.19355000D+01,0.00000000D+00
     .,0.80810660D+03,0.140D+03,0.730D+02,0.19355000D+01,0.00000000D+00
     .,0.67904580D+03,0.140D+03,0.740D+02,0.19355000D+01,0.00000000D+00
     .,0.68897190D+03,0.140D+03,0.750D+02,0.19355000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42301:  42400)=(/
     . 0.62088940D+03,0.140D+03,0.760D+02,0.19355000D+01,0.00000000D+00
     .,0.56604620D+03,0.140D+03,0.770D+02,0.19355000D+01,0.00000000D+00
     .,0.46802460D+03,0.140D+03,0.780D+02,0.19355000D+01,0.00000000D+00
     .,0.43643220D+03,0.140D+03,0.790D+02,0.19355000D+01,0.00000000D+00
     .,0.44796630D+03,0.140D+03,0.800D+02,0.19355000D+01,0.00000000D+00
     .,0.66836720D+03,0.140D+03,0.810D+02,0.19355000D+01,0.00000000D+00
     .,0.64781650D+03,0.140D+03,0.820D+02,0.19355000D+01,0.00000000D+00
     .,0.58976480D+03,0.140D+03,0.830D+02,0.19355000D+01,0.00000000D+00
     .,0.55956430D+03,0.140D+03,0.840D+02,0.19355000D+01,0.00000000D+00
     .,0.51325740D+03,0.140D+03,0.850D+02,0.19355000D+01,0.00000000D+00
     .,0.46784580D+03,0.140D+03,0.860D+02,0.19355000D+01,0.00000000D+00
     .,0.17028592D+04,0.140D+03,0.870D+02,0.19355000D+01,0.00000000D+00
     .,0.16078178D+04,0.140D+03,0.880D+02,0.19355000D+01,0.00000000D+00
     .,0.14061219D+04,0.140D+03,0.890D+02,0.19355000D+01,0.00000000D+00
     .,0.12490250D+04,0.140D+03,0.900D+02,0.19355000D+01,0.00000000D+00
     .,0.12473212D+04,0.140D+03,0.910D+02,0.19355000D+01,0.00000000D+00
     .,0.12073349D+04,0.140D+03,0.920D+02,0.19355000D+01,0.00000000D+00
     .,0.12519154D+04,0.140D+03,0.930D+02,0.19355000D+01,0.00000000D+00
     .,0.12106981D+04,0.140D+03,0.940D+02,0.19355000D+01,0.00000000D+00
     .,0.64706800D+02,0.140D+03,0.101D+03,0.19355000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42401:  42500)=(/
     . 0.21671700D+03,0.140D+03,0.103D+03,0.19355000D+01,0.98650000D+00
     .,0.27536440D+03,0.140D+03,0.104D+03,0.19355000D+01,0.98080000D+00
     .,0.20600140D+03,0.140D+03,0.105D+03,0.19355000D+01,0.97060000D+00
     .,0.15342290D+03,0.140D+03,0.106D+03,0.19355000D+01,0.98680000D+00
     .,0.10531510D+03,0.140D+03,0.107D+03,0.19355000D+01,0.99440000D+00
     .,0.75899400D+02,0.140D+03,0.108D+03,0.19355000D+01,0.99250000D+00
     .,0.51515800D+02,0.140D+03,0.109D+03,0.19355000D+01,0.99820000D+00
     .,0.31816780D+03,0.140D+03,0.111D+03,0.19355000D+01,0.96840000D+00
     .,0.49330570D+03,0.140D+03,0.112D+03,0.19355000D+01,0.96280000D+00
     .,0.49402450D+03,0.140D+03,0.113D+03,0.19355000D+01,0.96480000D+00
     .,0.39071920D+03,0.140D+03,0.114D+03,0.19355000D+01,0.95070000D+00
     .,0.31631690D+03,0.140D+03,0.115D+03,0.19355000D+01,0.99470000D+00
     .,0.26540890D+03,0.140D+03,0.116D+03,0.19355000D+01,0.99480000D+00
     .,0.21521010D+03,0.140D+03,0.117D+03,0.19355000D+01,0.99720000D+00
     .,0.43506490D+03,0.140D+03,0.119D+03,0.19355000D+01,0.97670000D+00
     .,0.85671310D+03,0.140D+03,0.120D+03,0.19355000D+01,0.98310000D+00
     .,0.42930190D+03,0.140D+03,0.121D+03,0.19355000D+01,0.18627000D+01
     .,0.41420300D+03,0.140D+03,0.122D+03,0.19355000D+01,0.18299000D+01
     .,0.40602230D+03,0.140D+03,0.123D+03,0.19355000D+01,0.19138000D+01
     .,0.40292000D+03,0.140D+03,0.124D+03,0.19355000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters(  42501:  42600)=(/
     . 0.36779370D+03,0.140D+03,0.125D+03,0.19355000D+01,0.16406000D+01
     .,0.33962780D+03,0.140D+03,0.126D+03,0.19355000D+01,0.16483000D+01
     .,0.32399210D+03,0.140D+03,0.127D+03,0.19355000D+01,0.17149000D+01
     .,0.31694170D+03,0.140D+03,0.128D+03,0.19355000D+01,0.17937000D+01
     .,0.31499080D+03,0.140D+03,0.129D+03,0.19355000D+01,0.95760000D+00
     .,0.29240050D+03,0.140D+03,0.130D+03,0.19355000D+01,0.19419000D+01
     .,0.48787590D+03,0.140D+03,0.131D+03,0.19355000D+01,0.96010000D+00
     .,0.42320760D+03,0.140D+03,0.132D+03,0.19355000D+01,0.94340000D+00
     .,0.37591790D+03,0.140D+03,0.133D+03,0.19355000D+01,0.98890000D+00
     .,0.34120400D+03,0.140D+03,0.134D+03,0.19355000D+01,0.99010000D+00
     .,0.29856340D+03,0.140D+03,0.135D+03,0.19355000D+01,0.99740000D+00
     .,0.51769610D+03,0.140D+03,0.137D+03,0.19355000D+01,0.97380000D+00
     .,0.10443401D+04,0.140D+03,0.138D+03,0.19355000D+01,0.98010000D+00
     .,0.78082120D+03,0.140D+03,0.139D+03,0.19355000D+01,0.19153000D+01
     .,0.56867890D+03,0.140D+03,0.140D+03,0.19355000D+01,0.19355000D+01
     .,0.40030400D+02,0.141D+03,0.100D+01,0.19545000D+01,0.91180000D+00
     .,0.25953400D+02,0.141D+03,0.200D+01,0.19545000D+01,0.00000000D+00
     .,0.68410400D+03,0.141D+03,0.300D+01,0.19545000D+01,0.00000000D+00
     .,0.37796930D+03,0.141D+03,0.400D+01,0.19545000D+01,0.00000000D+00
     .,0.24842660D+03,0.141D+03,0.500D+01,0.19545000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42601:  42700)=(/
     . 0.16499800D+03,0.141D+03,0.600D+01,0.19545000D+01,0.00000000D+00
     .,0.11399890D+03,0.141D+03,0.700D+01,0.19545000D+01,0.00000000D+00
     .,0.85602400D+02,0.141D+03,0.800D+01,0.19545000D+01,0.00000000D+00
     .,0.64401000D+02,0.141D+03,0.900D+01,0.19545000D+01,0.00000000D+00
     .,0.49263500D+02,0.141D+03,0.100D+02,0.19545000D+01,0.00000000D+00
     .,0.81603170D+03,0.141D+03,0.110D+02,0.19545000D+01,0.00000000D+00
     .,0.60700730D+03,0.141D+03,0.120D+02,0.19545000D+01,0.00000000D+00
     .,0.55235500D+03,0.141D+03,0.130D+02,0.19545000D+01,0.00000000D+00
     .,0.42788370D+03,0.141D+03,0.140D+02,0.19545000D+01,0.00000000D+00
     .,0.32909470D+03,0.141D+03,0.150D+02,0.19545000D+01,0.00000000D+00
     .,0.27080590D+03,0.141D+03,0.160D+02,0.19545000D+01,0.00000000D+00
     .,0.21944620D+03,0.141D+03,0.170D+02,0.19545000D+01,0.00000000D+00
     .,0.17831830D+03,0.141D+03,0.180D+02,0.19545000D+01,0.00000000D+00
     .,0.13433714D+04,0.141D+03,0.190D+02,0.19545000D+01,0.00000000D+00
     .,0.10819930D+04,0.141D+03,0.200D+02,0.19545000D+01,0.00000000D+00
     .,0.88833560D+03,0.141D+03,0.210D+02,0.19545000D+01,0.00000000D+00
     .,0.85304640D+03,0.141D+03,0.220D+02,0.19545000D+01,0.00000000D+00
     .,0.77852660D+03,0.141D+03,0.230D+02,0.19545000D+01,0.00000000D+00
     .,0.61302240D+03,0.141D+03,0.240D+02,0.19545000D+01,0.00000000D+00
     .,0.66703050D+03,0.141D+03,0.250D+02,0.19545000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42701:  42800)=(/
     . 0.52300200D+03,0.141D+03,0.260D+02,0.19545000D+01,0.00000000D+00
     .,0.55040920D+03,0.141D+03,0.270D+02,0.19545000D+01,0.00000000D+00
     .,0.56890880D+03,0.141D+03,0.280D+02,0.19545000D+01,0.00000000D+00
     .,0.43610420D+03,0.141D+03,0.290D+02,0.19545000D+01,0.00000000D+00
     .,0.44298860D+03,0.141D+03,0.300D+02,0.19545000D+01,0.00000000D+00
     .,0.52649640D+03,0.141D+03,0.310D+02,0.19545000D+01,0.00000000D+00
     .,0.45819200D+03,0.141D+03,0.320D+02,0.19545000D+01,0.00000000D+00
     .,0.38630910D+03,0.141D+03,0.330D+02,0.19545000D+01,0.00000000D+00
     .,0.34424250D+03,0.141D+03,0.340D+02,0.19545000D+01,0.00000000D+00
     .,0.29915350D+03,0.141D+03,0.350D+02,0.19545000D+01,0.00000000D+00
     .,0.25853040D+03,0.141D+03,0.360D+02,0.19545000D+01,0.00000000D+00
     .,0.15017789D+04,0.141D+03,0.370D+02,0.19545000D+01,0.00000000D+00
     .,0.12904826D+04,0.141D+03,0.380D+02,0.19545000D+01,0.00000000D+00
     .,0.11181402D+04,0.141D+03,0.390D+02,0.19545000D+01,0.00000000D+00
     .,0.99812240D+03,0.141D+03,0.400D+02,0.19545000D+01,0.00000000D+00
     .,0.90608010D+03,0.141D+03,0.410D+02,0.19545000D+01,0.00000000D+00
     .,0.69429830D+03,0.141D+03,0.420D+02,0.19545000D+01,0.00000000D+00
     .,0.77673680D+03,0.141D+03,0.430D+02,0.19545000D+01,0.00000000D+00
     .,0.58689450D+03,0.141D+03,0.440D+02,0.19545000D+01,0.00000000D+00
     .,0.64141640D+03,0.141D+03,0.450D+02,0.19545000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42801:  42900)=(/
     . 0.59314140D+03,0.141D+03,0.460D+02,0.19545000D+01,0.00000000D+00
     .,0.49548000D+03,0.141D+03,0.470D+02,0.19545000D+01,0.00000000D+00
     .,0.52076290D+03,0.141D+03,0.480D+02,0.19545000D+01,0.00000000D+00
     .,0.65928650D+03,0.141D+03,0.490D+02,0.19545000D+01,0.00000000D+00
     .,0.60296920D+03,0.141D+03,0.500D+02,0.19545000D+01,0.00000000D+00
     .,0.53174240D+03,0.141D+03,0.510D+02,0.19545000D+01,0.00000000D+00
     .,0.49032060D+03,0.141D+03,0.520D+02,0.19545000D+01,0.00000000D+00
     .,0.44045990D+03,0.141D+03,0.530D+02,0.19545000D+01,0.00000000D+00
     .,0.39361210D+03,0.141D+03,0.540D+02,0.19545000D+01,0.00000000D+00
     .,0.18264461D+04,0.141D+03,0.550D+02,0.19545000D+01,0.00000000D+00
     .,0.16509334D+04,0.141D+03,0.560D+02,0.19545000D+01,0.00000000D+00
     .,0.14348956D+04,0.141D+03,0.570D+02,0.19545000D+01,0.00000000D+00
     .,0.62949770D+03,0.141D+03,0.580D+02,0.19545000D+01,0.27991000D+01
     .,0.14565113D+04,0.141D+03,0.590D+02,0.19545000D+01,0.00000000D+00
     .,0.13970298D+04,0.141D+03,0.600D+02,0.19545000D+01,0.00000000D+00
     .,0.13613178D+04,0.141D+03,0.610D+02,0.19545000D+01,0.00000000D+00
     .,0.13285415D+04,0.141D+03,0.620D+02,0.19545000D+01,0.00000000D+00
     .,0.12994488D+04,0.141D+03,0.630D+02,0.19545000D+01,0.00000000D+00
     .,0.10094419D+04,0.141D+03,0.640D+02,0.19545000D+01,0.00000000D+00
     .,0.11553947D+04,0.141D+03,0.650D+02,0.19545000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  42901:  43000)=(/
     . 0.11106913D+04,0.141D+03,0.660D+02,0.19545000D+01,0.00000000D+00
     .,0.11688393D+04,0.141D+03,0.670D+02,0.19545000D+01,0.00000000D+00
     .,0.11436857D+04,0.141D+03,0.680D+02,0.19545000D+01,0.00000000D+00
     .,0.11208436D+04,0.141D+03,0.690D+02,0.19545000D+01,0.00000000D+00
     .,0.11082791D+04,0.141D+03,0.700D+02,0.19545000D+01,0.00000000D+00
     .,0.92522660D+03,0.141D+03,0.710D+02,0.19545000D+01,0.00000000D+00
     .,0.90068080D+03,0.141D+03,0.720D+02,0.19545000D+01,0.00000000D+00
     .,0.81649740D+03,0.141D+03,0.730D+02,0.19545000D+01,0.00000000D+00
     .,0.68598560D+03,0.141D+03,0.740D+02,0.19545000D+01,0.00000000D+00
     .,0.69600400D+03,0.141D+03,0.750D+02,0.19545000D+01,0.00000000D+00
     .,0.62720650D+03,0.141D+03,0.760D+02,0.19545000D+01,0.00000000D+00
     .,0.57177930D+03,0.141D+03,0.770D+02,0.19545000D+01,0.00000000D+00
     .,0.47276430D+03,0.141D+03,0.780D+02,0.19545000D+01,0.00000000D+00
     .,0.44085970D+03,0.141D+03,0.790D+02,0.19545000D+01,0.00000000D+00
     .,0.45247610D+03,0.141D+03,0.800D+02,0.19545000D+01,0.00000000D+00
     .,0.67515180D+03,0.141D+03,0.810D+02,0.19545000D+01,0.00000000D+00
     .,0.65444510D+03,0.141D+03,0.820D+02,0.19545000D+01,0.00000000D+00
     .,0.59566400D+03,0.141D+03,0.830D+02,0.19545000D+01,0.00000000D+00
     .,0.56506480D+03,0.141D+03,0.840D+02,0.19545000D+01,0.00000000D+00
     .,0.51821240D+03,0.141D+03,0.850D+02,0.19545000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43001:  43100)=(/
     . 0.47230580D+03,0.141D+03,0.860D+02,0.19545000D+01,0.00000000D+00
     .,0.17127050D+04,0.141D+03,0.870D+02,0.19545000D+01,0.00000000D+00
     .,0.16235376D+04,0.141D+03,0.880D+02,0.19545000D+01,0.00000000D+00
     .,0.14203983D+04,0.141D+03,0.890D+02,0.19545000D+01,0.00000000D+00
     .,0.12619867D+04,0.141D+03,0.900D+02,0.19545000D+01,0.00000000D+00
     .,0.12600147D+04,0.141D+03,0.910D+02,0.19545000D+01,0.00000000D+00
     .,0.12197064D+04,0.141D+03,0.920D+02,0.19545000D+01,0.00000000D+00
     .,0.12648378D+04,0.141D+03,0.930D+02,0.19545000D+01,0.00000000D+00
     .,0.12232638D+04,0.141D+03,0.940D+02,0.19545000D+01,0.00000000D+00
     .,0.65312900D+02,0.141D+03,0.101D+03,0.19545000D+01,0.00000000D+00
     .,0.21897060D+03,0.141D+03,0.103D+03,0.19545000D+01,0.98650000D+00
     .,0.27808810D+03,0.141D+03,0.104D+03,0.19545000D+01,0.98080000D+00
     .,0.20799430D+03,0.141D+03,0.105D+03,0.19545000D+01,0.97060000D+00
     .,0.15487640D+03,0.141D+03,0.106D+03,0.19545000D+01,0.98680000D+00
     .,0.10631410D+03,0.141D+03,0.107D+03,0.19545000D+01,0.99440000D+00
     .,0.76634700D+02,0.141D+03,0.108D+03,0.19545000D+01,0.99250000D+00
     .,0.52041200D+02,0.141D+03,0.109D+03,0.19545000D+01,0.99820000D+00
     .,0.32153780D+03,0.141D+03,0.111D+03,0.19545000D+01,0.96840000D+00
     .,0.49834860D+03,0.141D+03,0.112D+03,0.19545000D+01,0.96280000D+00
     .,0.49907610D+03,0.141D+03,0.113D+03,0.19545000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  43101:  43200)=(/
     . 0.39454030D+03,0.141D+03,0.114D+03,0.19545000D+01,0.95070000D+00
     .,0.31930990D+03,0.141D+03,0.115D+03,0.19545000D+01,0.99470000D+00
     .,0.26788580D+03,0.141D+03,0.116D+03,0.19545000D+01,0.99480000D+00
     .,0.21720780D+03,0.141D+03,0.117D+03,0.19545000D+01,0.99720000D+00
     .,0.43952280D+03,0.141D+03,0.119D+03,0.19545000D+01,0.97670000D+00
     .,0.86414110D+03,0.141D+03,0.120D+03,0.19545000D+01,0.98310000D+00
     .,0.43378650D+03,0.141D+03,0.121D+03,0.19545000D+01,0.18627000D+01
     .,0.41830680D+03,0.141D+03,0.122D+03,0.19545000D+01,0.18299000D+01
     .,0.41010330D+03,0.141D+03,0.123D+03,0.19545000D+01,0.19138000D+01
     .,0.40698940D+03,0.141D+03,0.124D+03,0.19545000D+01,0.18269000D+01
     .,0.37146910D+03,0.141D+03,0.125D+03,0.19545000D+01,0.16406000D+01
     .,0.34300120D+03,0.141D+03,0.126D+03,0.19545000D+01,0.16483000D+01
     .,0.32719950D+03,0.141D+03,0.127D+03,0.19545000D+01,0.17149000D+01
     .,0.32009600D+03,0.141D+03,0.128D+03,0.19545000D+01,0.17937000D+01
     .,0.31821360D+03,0.141D+03,0.129D+03,0.19545000D+01,0.95760000D+00
     .,0.29527620D+03,0.141D+03,0.130D+03,0.19545000D+01,0.19419000D+01
     .,0.49283160D+03,0.141D+03,0.131D+03,0.19545000D+01,0.96010000D+00
     .,0.42736220D+03,0.141D+03,0.132D+03,0.19545000D+01,0.94340000D+00
     .,0.37950970D+03,0.141D+03,0.133D+03,0.19545000D+01,0.98890000D+00
     .,0.34441690D+03,0.141D+03,0.134D+03,0.19545000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters(  43201:  43300)=(/
     . 0.30134630D+03,0.141D+03,0.135D+03,0.19545000D+01,0.99740000D+00
     .,0.52294490D+03,0.141D+03,0.137D+03,0.19545000D+01,0.97380000D+00
     .,0.10528629D+04,0.141D+03,0.138D+03,0.19545000D+01,0.98010000D+00
     .,0.78749500D+03,0.141D+03,0.139D+03,0.19545000D+01,0.19153000D+01
     .,0.57445910D+03,0.141D+03,0.140D+03,0.19545000D+01,0.19355000D+01
     .,0.58058240D+03,0.141D+03,0.141D+03,0.19545000D+01,0.19545000D+01
     .,0.37547800D+02,0.142D+03,0.100D+01,0.19420000D+01,0.91180000D+00
     .,0.24553000D+02,0.142D+03,0.200D+01,0.19420000D+01,0.00000000D+00
     .,0.62818170D+03,0.142D+03,0.300D+01,0.19420000D+01,0.00000000D+00
     .,0.34918970D+03,0.142D+03,0.400D+01,0.19420000D+01,0.00000000D+00
     .,0.23104490D+03,0.142D+03,0.500D+01,0.19420000D+01,0.00000000D+00
     .,0.15432880D+03,0.142D+03,0.600D+01,0.19420000D+01,0.00000000D+00
     .,0.10713040D+03,0.142D+03,0.700D+01,0.19420000D+01,0.00000000D+00
     .,0.80736000D+02,0.142D+03,0.800D+01,0.19420000D+01,0.00000000D+00
     .,0.60941400D+02,0.142D+03,0.900D+01,0.19420000D+01,0.00000000D+00
     .,0.46749800D+02,0.142D+03,0.100D+02,0.19420000D+01,0.00000000D+00
     .,0.74949740D+03,0.142D+03,0.110D+02,0.19420000D+01,0.00000000D+00
     .,0.55988560D+03,0.142D+03,0.120D+02,0.19420000D+01,0.00000000D+00
     .,0.51108100D+03,0.142D+03,0.130D+02,0.19420000D+01,0.00000000D+00
     .,0.39766020D+03,0.142D+03,0.140D+02,0.19420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43301:  43400)=(/
     . 0.30713840D+03,0.142D+03,0.150D+02,0.19420000D+01,0.00000000D+00
     .,0.25349850D+03,0.142D+03,0.160D+02,0.19420000D+01,0.00000000D+00
     .,0.20604590D+03,0.142D+03,0.170D+02,0.19420000D+01,0.00000000D+00
     .,0.16790140D+03,0.142D+03,0.180D+02,0.19420000D+01,0.00000000D+00
     .,0.12379643D+04,0.142D+03,0.190D+02,0.19420000D+01,0.00000000D+00
     .,0.99601570D+03,0.142D+03,0.200D+02,0.19420000D+01,0.00000000D+00
     .,0.81851610D+03,0.142D+03,0.210D+02,0.19420000D+01,0.00000000D+00
     .,0.78705650D+03,0.142D+03,0.220D+02,0.19420000D+01,0.00000000D+00
     .,0.71884690D+03,0.142D+03,0.230D+02,0.19420000D+01,0.00000000D+00
     .,0.56643000D+03,0.142D+03,0.240D+02,0.19420000D+01,0.00000000D+00
     .,0.61659930D+03,0.142D+03,0.250D+02,0.19420000D+01,0.00000000D+00
     .,0.48385370D+03,0.142D+03,0.260D+02,0.19420000D+01,0.00000000D+00
     .,0.50969990D+03,0.142D+03,0.270D+02,0.19420000D+01,0.00000000D+00
     .,0.52637950D+03,0.142D+03,0.280D+02,0.19420000D+01,0.00000000D+00
     .,0.40384000D+03,0.142D+03,0.290D+02,0.19420000D+01,0.00000000D+00
     .,0.41098660D+03,0.142D+03,0.300D+02,0.19420000D+01,0.00000000D+00
     .,0.48798580D+03,0.142D+03,0.310D+02,0.19420000D+01,0.00000000D+00
     .,0.42607030D+03,0.142D+03,0.320D+02,0.19420000D+01,0.00000000D+00
     .,0.36044960D+03,0.142D+03,0.330D+02,0.19420000D+01,0.00000000D+00
     .,0.32194150D+03,0.142D+03,0.340D+02,0.19420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43401:  43500)=(/
     . 0.28047020D+03,0.142D+03,0.350D+02,0.19420000D+01,0.00000000D+00
     .,0.24296840D+03,0.142D+03,0.360D+02,0.19420000D+01,0.00000000D+00
     .,0.13851228D+04,0.142D+03,0.370D+02,0.19420000D+01,0.00000000D+00
     .,0.11881982D+04,0.142D+03,0.380D+02,0.19420000D+01,0.00000000D+00
     .,0.10314745D+04,0.142D+03,0.390D+02,0.19420000D+01,0.00000000D+00
     .,0.92206600D+03,0.142D+03,0.400D+02,0.19420000D+01,0.00000000D+00
     .,0.83798490D+03,0.142D+03,0.410D+02,0.19420000D+01,0.00000000D+00
     .,0.64347210D+03,0.142D+03,0.420D+02,0.19420000D+01,0.00000000D+00
     .,0.71936590D+03,0.142D+03,0.430D+02,0.19420000D+01,0.00000000D+00
     .,0.54480750D+03,0.142D+03,0.440D+02,0.19420000D+01,0.00000000D+00
     .,0.59515030D+03,0.142D+03,0.450D+02,0.19420000D+01,0.00000000D+00
     .,0.55075570D+03,0.142D+03,0.460D+02,0.19420000D+01,0.00000000D+00
     .,0.46023670D+03,0.142D+03,0.470D+02,0.19420000D+01,0.00000000D+00
     .,0.48402860D+03,0.142D+03,0.480D+02,0.19420000D+01,0.00000000D+00
     .,0.61139110D+03,0.142D+03,0.490D+02,0.19420000D+01,0.00000000D+00
     .,0.56051040D+03,0.142D+03,0.500D+02,0.19420000D+01,0.00000000D+00
     .,0.49569480D+03,0.142D+03,0.510D+02,0.19420000D+01,0.00000000D+00
     .,0.45793020D+03,0.142D+03,0.520D+02,0.19420000D+01,0.00000000D+00
     .,0.41222750D+03,0.142D+03,0.530D+02,0.19420000D+01,0.00000000D+00
     .,0.36915310D+03,0.142D+03,0.540D+02,0.19420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43501:  43600)=(/
     . 0.16877490D+04,0.142D+03,0.550D+02,0.19420000D+01,0.00000000D+00
     .,0.15201317D+04,0.142D+03,0.560D+02,0.19420000D+01,0.00000000D+00
     .,0.13232583D+04,0.142D+03,0.570D+02,0.19420000D+01,0.00000000D+00
     .,0.58664300D+03,0.142D+03,0.580D+02,0.19420000D+01,0.27991000D+01
     .,0.13428116D+04,0.142D+03,0.590D+02,0.19420000D+01,0.00000000D+00
     .,0.12872763D+04,0.142D+03,0.600D+02,0.19420000D+01,0.00000000D+00
     .,0.12544039D+04,0.142D+03,0.610D+02,0.19420000D+01,0.00000000D+00
     .,0.12242314D+04,0.142D+03,0.620D+02,0.19420000D+01,0.00000000D+00
     .,0.11974564D+04,0.142D+03,0.630D+02,0.19420000D+01,0.00000000D+00
     .,0.93283320D+03,0.142D+03,0.640D+02,0.19420000D+01,0.00000000D+00
     .,0.10667077D+04,0.142D+03,0.650D+02,0.19420000D+01,0.00000000D+00
     .,0.10271026D+04,0.142D+03,0.660D+02,0.19420000D+01,0.00000000D+00
     .,0.10774205D+04,0.142D+03,0.670D+02,0.19420000D+01,0.00000000D+00
     .,0.10542484D+04,0.142D+03,0.680D+02,0.19420000D+01,0.00000000D+00
     .,0.10332364D+04,0.142D+03,0.690D+02,0.19420000D+01,0.00000000D+00
     .,0.10215311D+04,0.142D+03,0.700D+02,0.19420000D+01,0.00000000D+00
     .,0.85524570D+03,0.142D+03,0.710D+02,0.19420000D+01,0.00000000D+00
     .,0.83345230D+03,0.142D+03,0.720D+02,0.19420000D+01,0.00000000D+00
     .,0.75675320D+03,0.142D+03,0.730D+02,0.19420000D+01,0.00000000D+00
     .,0.63690770D+03,0.142D+03,0.740D+02,0.19420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43601:  43700)=(/
     . 0.64654950D+03,0.142D+03,0.750D+02,0.19420000D+01,0.00000000D+00
     .,0.58352570D+03,0.142D+03,0.760D+02,0.19420000D+01,0.00000000D+00
     .,0.53265790D+03,0.142D+03,0.770D+02,0.19420000D+01,0.00000000D+00
     .,0.44119610D+03,0.142D+03,0.780D+02,0.19420000D+01,0.00000000D+00
     .,0.41171360D+03,0.142D+03,0.790D+02,0.19420000D+01,0.00000000D+00
     .,0.42271910D+03,0.142D+03,0.800D+02,0.19420000D+01,0.00000000D+00
     .,0.62693260D+03,0.142D+03,0.810D+02,0.19420000D+01,0.00000000D+00
     .,0.60866200D+03,0.142D+03,0.820D+02,0.19420000D+01,0.00000000D+00
     .,0.55532550D+03,0.142D+03,0.830D+02,0.19420000D+01,0.00000000D+00
     .,0.52759970D+03,0.142D+03,0.840D+02,0.19420000D+01,0.00000000D+00
     .,0.48478900D+03,0.142D+03,0.850D+02,0.19420000D+01,0.00000000D+00
     .,0.44266740D+03,0.142D+03,0.860D+02,0.19420000D+01,0.00000000D+00
     .,0.15815449D+04,0.142D+03,0.870D+02,0.19420000D+01,0.00000000D+00
     .,0.14962077D+04,0.142D+03,0.880D+02,0.19420000D+01,0.00000000D+00
     .,0.13112088D+04,0.142D+03,0.890D+02,0.19420000D+01,0.00000000D+00
     .,0.11676309D+04,0.142D+03,0.900D+02,0.19420000D+01,0.00000000D+00
     .,0.11649288D+04,0.142D+03,0.910D+02,0.19420000D+01,0.00000000D+00
     .,0.11276927D+04,0.142D+03,0.920D+02,0.19420000D+01,0.00000000D+00
     .,0.11676383D+04,0.142D+03,0.930D+02,0.19420000D+01,0.00000000D+00
     .,0.11294830D+04,0.142D+03,0.940D+02,0.19420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43701:  43800)=(/
     . 0.60977300D+02,0.142D+03,0.101D+03,0.19420000D+01,0.00000000D+00
     .,0.20251730D+03,0.142D+03,0.103D+03,0.19420000D+01,0.98650000D+00
     .,0.25760880D+03,0.142D+03,0.104D+03,0.19420000D+01,0.98080000D+00
     .,0.19375570D+03,0.142D+03,0.105D+03,0.19420000D+01,0.97060000D+00
     .,0.14487380D+03,0.142D+03,0.106D+03,0.19420000D+01,0.98680000D+00
     .,0.99938100D+02,0.142D+03,0.107D+03,0.19420000D+01,0.99440000D+00
     .,0.72352000D+02,0.142D+03,0.108D+03,0.19420000D+01,0.99250000D+00
     .,0.49416600D+02,0.142D+03,0.109D+03,0.19420000D+01,0.99820000D+00
     .,0.29717130D+03,0.142D+03,0.111D+03,0.19420000D+01,0.96840000D+00
     .,0.46042340D+03,0.142D+03,0.112D+03,0.19420000D+01,0.96280000D+00
     .,0.46216780D+03,0.142D+03,0.113D+03,0.19420000D+01,0.96480000D+00
     .,0.36695490D+03,0.142D+03,0.114D+03,0.19420000D+01,0.95070000D+00
     .,0.29806610D+03,0.142D+03,0.115D+03,0.19420000D+01,0.99470000D+00
     .,0.25075730D+03,0.142D+03,0.116D+03,0.19420000D+01,0.99480000D+00
     .,0.20393970D+03,0.142D+03,0.117D+03,0.19420000D+01,0.99720000D+00
     .,0.40759060D+03,0.142D+03,0.119D+03,0.19420000D+01,0.97670000D+00
     .,0.79747730D+03,0.142D+03,0.120D+03,0.19420000D+01,0.98310000D+00
     .,0.40315400D+03,0.142D+03,0.121D+03,0.19420000D+01,0.18627000D+01
     .,0.38917870D+03,0.142D+03,0.122D+03,0.19420000D+01,0.18299000D+01
     .,0.38148040D+03,0.142D+03,0.123D+03,0.19420000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  43801:  43900)=(/
     . 0.37844740D+03,0.142D+03,0.124D+03,0.19420000D+01,0.18269000D+01
     .,0.34604230D+03,0.142D+03,0.125D+03,0.19420000D+01,0.16406000D+01
     .,0.31976370D+03,0.142D+03,0.126D+03,0.19420000D+01,0.16483000D+01
     .,0.30508870D+03,0.142D+03,0.127D+03,0.19420000D+01,0.17149000D+01
     .,0.29841290D+03,0.142D+03,0.128D+03,0.19420000D+01,0.17937000D+01
     .,0.29619890D+03,0.142D+03,0.129D+03,0.19420000D+01,0.95760000D+00
     .,0.27560550D+03,0.142D+03,0.130D+03,0.19420000D+01,0.19419000D+01
     .,0.45716410D+03,0.142D+03,0.131D+03,0.19420000D+01,0.96010000D+00
     .,0.39775920D+03,0.142D+03,0.132D+03,0.19420000D+01,0.94340000D+00
     .,0.35418680D+03,0.142D+03,0.133D+03,0.19420000D+01,0.98890000D+00
     .,0.32209780D+03,0.142D+03,0.134D+03,0.19420000D+01,0.99010000D+00
     .,0.28249330D+03,0.142D+03,0.135D+03,0.19420000D+01,0.99740000D+00
     .,0.48541290D+03,0.142D+03,0.137D+03,0.19420000D+01,0.97380000D+00
     .,0.97212330D+03,0.142D+03,0.138D+03,0.19420000D+01,0.98010000D+00
     .,0.73014460D+03,0.142D+03,0.139D+03,0.19420000D+01,0.19153000D+01
     .,0.53401080D+03,0.142D+03,0.140D+03,0.19420000D+01,0.19355000D+01
     .,0.53935320D+03,0.142D+03,0.141D+03,0.19420000D+01,0.19545000D+01
     .,0.50200730D+03,0.142D+03,0.142D+03,0.19420000D+01,0.19420000D+01
     .,0.41338500D+02,0.143D+03,0.100D+01,0.16682000D+01,0.91180000D+00
     .,0.26621700D+02,0.143D+03,0.200D+01,0.16682000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  43901:  44000)=(/
     . 0.76378140D+03,0.143D+03,0.300D+01,0.16682000D+01,0.00000000D+00
     .,0.40277270D+03,0.143D+03,0.400D+01,0.16682000D+01,0.00000000D+00
     .,0.26037960D+03,0.143D+03,0.500D+01,0.16682000D+01,0.00000000D+00
     .,0.17125810D+03,0.143D+03,0.600D+01,0.16682000D+01,0.00000000D+00
     .,0.11764790D+03,0.143D+03,0.700D+01,0.16682000D+01,0.00000000D+00
     .,0.88060900D+02,0.143D+03,0.800D+01,0.16682000D+01,0.00000000D+00
     .,0.66109300D+02,0.143D+03,0.900D+01,0.16682000D+01,0.00000000D+00
     .,0.50508700D+02,0.143D+03,0.100D+02,0.16682000D+01,0.00000000D+00
     .,0.90840250D+03,0.143D+03,0.110D+02,0.16682000D+01,0.00000000D+00
     .,0.65125640D+03,0.143D+03,0.120D+02,0.16682000D+01,0.00000000D+00
     .,0.58698620D+03,0.143D+03,0.130D+02,0.16682000D+01,0.00000000D+00
     .,0.44911910D+03,0.143D+03,0.140D+02,0.16682000D+01,0.00000000D+00
     .,0.34248830D+03,0.143D+03,0.150D+02,0.16682000D+01,0.00000000D+00
     .,0.28056130D+03,0.143D+03,0.160D+02,0.16682000D+01,0.00000000D+00
     .,0.22648330D+03,0.143D+03,0.170D+02,0.16682000D+01,0.00000000D+00
     .,0.18352050D+03,0.143D+03,0.180D+02,0.16682000D+01,0.00000000D+00
     .,0.15188755D+04,0.143D+03,0.190D+02,0.16682000D+01,0.00000000D+00
     .,0.11783302D+04,0.143D+03,0.200D+02,0.16682000D+01,0.00000000D+00
     .,0.96136570D+03,0.143D+03,0.210D+02,0.16682000D+01,0.00000000D+00
     .,0.91930990D+03,0.143D+03,0.220D+02,0.16682000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44001:  44100)=(/
     . 0.83673410D+03,0.143D+03,0.230D+02,0.16682000D+01,0.00000000D+00
     .,0.65972010D+03,0.143D+03,0.240D+02,0.16682000D+01,0.00000000D+00
     .,0.71418300D+03,0.143D+03,0.250D+02,0.16682000D+01,0.00000000D+00
     .,0.56036480D+03,0.143D+03,0.260D+02,0.16682000D+01,0.00000000D+00
     .,0.58529350D+03,0.143D+03,0.270D+02,0.16682000D+01,0.00000000D+00
     .,0.60647400D+03,0.143D+03,0.280D+02,0.16682000D+01,0.00000000D+00
     .,0.46581470D+03,0.143D+03,0.290D+02,0.16682000D+01,0.00000000D+00
     .,0.46845290D+03,0.143D+03,0.300D+02,0.16682000D+01,0.00000000D+00
     .,0.55815220D+03,0.143D+03,0.310D+02,0.16682000D+01,0.00000000D+00
     .,0.48089260D+03,0.143D+03,0.320D+02,0.16682000D+01,0.00000000D+00
     .,0.40245400D+03,0.143D+03,0.330D+02,0.16682000D+01,0.00000000D+00
     .,0.35725110D+03,0.143D+03,0.340D+02,0.16682000D+01,0.00000000D+00
     .,0.30935300D+03,0.143D+03,0.350D+02,0.16682000D+01,0.00000000D+00
     .,0.26657770D+03,0.143D+03,0.360D+02,0.16682000D+01,0.00000000D+00
     .,0.16961214D+04,0.143D+03,0.370D+02,0.16682000D+01,0.00000000D+00
     .,0.14083895D+04,0.143D+03,0.380D+02,0.16682000D+01,0.00000000D+00
     .,0.12079868D+04,0.143D+03,0.390D+02,0.16682000D+01,0.00000000D+00
     .,0.10721935D+04,0.143D+03,0.400D+02,0.16682000D+01,0.00000000D+00
     .,0.97020700D+03,0.143D+03,0.410D+02,0.16682000D+01,0.00000000D+00
     .,0.73979150D+03,0.143D+03,0.420D+02,0.16682000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44101:  44200)=(/
     . 0.82924080D+03,0.143D+03,0.430D+02,0.16682000D+01,0.00000000D+00
     .,0.62313860D+03,0.143D+03,0.440D+02,0.16682000D+01,0.00000000D+00
     .,0.68005240D+03,0.143D+03,0.450D+02,0.16682000D+01,0.00000000D+00
     .,0.62758100D+03,0.143D+03,0.460D+02,0.16682000D+01,0.00000000D+00
     .,0.52609770D+03,0.143D+03,0.470D+02,0.16682000D+01,0.00000000D+00
     .,0.54963380D+03,0.143D+03,0.480D+02,0.16682000D+01,0.00000000D+00
     .,0.70042290D+03,0.143D+03,0.490D+02,0.16682000D+01,0.00000000D+00
     .,0.63478310D+03,0.143D+03,0.500D+02,0.16682000D+01,0.00000000D+00
     .,0.55577940D+03,0.143D+03,0.510D+02,0.16682000D+01,0.00000000D+00
     .,0.51056820D+03,0.143D+03,0.520D+02,0.16682000D+01,0.00000000D+00
     .,0.45697070D+03,0.143D+03,0.530D+02,0.16682000D+01,0.00000000D+00
     .,0.40709700D+03,0.143D+03,0.540D+02,0.16682000D+01,0.00000000D+00
     .,0.20688557D+04,0.143D+03,0.550D+02,0.16682000D+01,0.00000000D+00
     .,0.18110626D+04,0.143D+03,0.560D+02,0.16682000D+01,0.00000000D+00
     .,0.15570674D+04,0.143D+03,0.570D+02,0.16682000D+01,0.00000000D+00
     .,0.65923480D+03,0.143D+03,0.580D+02,0.16682000D+01,0.27991000D+01
     .,0.15936331D+04,0.143D+03,0.590D+02,0.16682000D+01,0.00000000D+00
     .,0.15238714D+04,0.143D+03,0.600D+02,0.16682000D+01,0.00000000D+00
     .,0.14839817D+04,0.143D+03,0.610D+02,0.16682000D+01,0.00000000D+00
     .,0.14474665D+04,0.143D+03,0.620D+02,0.16682000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44201:  44300)=(/
     . 0.14150358D+04,0.143D+03,0.630D+02,0.16682000D+01,0.00000000D+00
     .,0.10889839D+04,0.143D+03,0.640D+02,0.16682000D+01,0.00000000D+00
     .,0.12727235D+04,0.143D+03,0.650D+02,0.16682000D+01,0.00000000D+00
     .,0.12232739D+04,0.143D+03,0.660D+02,0.16682000D+01,0.00000000D+00
     .,0.12689174D+04,0.143D+03,0.670D+02,0.16682000D+01,0.00000000D+00
     .,0.12411151D+04,0.143D+03,0.680D+02,0.16682000D+01,0.00000000D+00
     .,0.12157298D+04,0.143D+03,0.690D+02,0.16682000D+01,0.00000000D+00
     .,0.12025314D+04,0.143D+03,0.700D+02,0.16682000D+01,0.00000000D+00
     .,0.99886140D+03,0.143D+03,0.710D+02,0.16682000D+01,0.00000000D+00
     .,0.96131920D+03,0.143D+03,0.720D+02,0.16682000D+01,0.00000000D+00
     .,0.86700540D+03,0.143D+03,0.730D+02,0.16682000D+01,0.00000000D+00
     .,0.72670660D+03,0.143D+03,0.740D+02,0.16682000D+01,0.00000000D+00
     .,0.73557240D+03,0.143D+03,0.750D+02,0.16682000D+01,0.00000000D+00
     .,0.66018700D+03,0.143D+03,0.760D+02,0.16682000D+01,0.00000000D+00
     .,0.60002740D+03,0.143D+03,0.770D+02,0.16682000D+01,0.00000000D+00
     .,0.49511760D+03,0.143D+03,0.780D+02,0.16682000D+01,0.00000000D+00
     .,0.46130260D+03,0.143D+03,0.790D+02,0.16682000D+01,0.00000000D+00
     .,0.47242330D+03,0.143D+03,0.800D+02,0.16682000D+01,0.00000000D+00
     .,0.71722290D+03,0.143D+03,0.810D+02,0.16682000D+01,0.00000000D+00
     .,0.68964350D+03,0.143D+03,0.820D+02,0.16682000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44301:  44400)=(/
     . 0.62335390D+03,0.143D+03,0.830D+02,0.16682000D+01,0.00000000D+00
     .,0.58927250D+03,0.143D+03,0.840D+02,0.16682000D+01,0.00000000D+00
     .,0.53837470D+03,0.143D+03,0.850D+02,0.16682000D+01,0.00000000D+00
     .,0.48918620D+03,0.143D+03,0.860D+02,0.16682000D+01,0.00000000D+00
     .,0.19184029D+04,0.143D+03,0.870D+02,0.16682000D+01,0.00000000D+00
     .,0.17715639D+04,0.143D+03,0.880D+02,0.16682000D+01,0.00000000D+00
     .,0.15346792D+04,0.143D+03,0.890D+02,0.16682000D+01,0.00000000D+00
     .,0.13502400D+04,0.143D+03,0.900D+02,0.16682000D+01,0.00000000D+00
     .,0.13560504D+04,0.143D+03,0.910D+02,0.16682000D+01,0.00000000D+00
     .,0.13122121D+04,0.143D+03,0.920D+02,0.16682000D+01,0.00000000D+00
     .,0.13686610D+04,0.143D+03,0.930D+02,0.16682000D+01,0.00000000D+00
     .,0.13219594D+04,0.143D+03,0.940D+02,0.16682000D+01,0.00000000D+00
     .,0.67892400D+02,0.143D+03,0.101D+03,0.16682000D+01,0.00000000D+00
     .,0.23295390D+03,0.143D+03,0.103D+03,0.16682000D+01,0.98650000D+00
     .,0.29538160D+03,0.143D+03,0.104D+03,0.16682000D+01,0.98080000D+00
     .,0.21747620D+03,0.143D+03,0.105D+03,0.16682000D+01,0.97060000D+00
     .,0.16092230D+03,0.143D+03,0.106D+03,0.16682000D+01,0.98680000D+00
     .,0.10977550D+03,0.143D+03,0.107D+03,0.16682000D+01,0.99440000D+00
     .,0.78792000D+02,0.143D+03,0.108D+03,0.16682000D+01,0.99250000D+00
     .,0.53288000D+02,0.143D+03,0.109D+03,0.16682000D+01,0.99820000D+00
     ./)
      grimme_c6_parameters(  44401:  44500)=(/
     . 0.34355920D+03,0.143D+03,0.111D+03,0.16682000D+01,0.96840000D+00
     .,0.53370850D+03,0.143D+03,0.112D+03,0.16682000D+01,0.96280000D+00
     .,0.52930430D+03,0.143D+03,0.113D+03,0.16682000D+01,0.96480000D+00
     .,0.41359910D+03,0.143D+03,0.114D+03,0.16682000D+01,0.95070000D+00
     .,0.33227830D+03,0.143D+03,0.115D+03,0.16682000D+01,0.99470000D+00
     .,0.27760020D+03,0.143D+03,0.116D+03,0.16682000D+01,0.99480000D+00
     .,0.22420950D+03,0.143D+03,0.117D+03,0.16682000D+01,0.99720000D+00
     .,0.46809770D+03,0.143D+03,0.119D+03,0.16682000D+01,0.97670000D+00
     .,0.94599430D+03,0.143D+03,0.120D+03,0.16682000D+01,0.98310000D+00
     .,0.45591090D+03,0.143D+03,0.121D+03,0.16682000D+01,0.18627000D+01
     .,0.44025610D+03,0.143D+03,0.122D+03,0.16682000D+01,0.18299000D+01
     .,0.43163910D+03,0.143D+03,0.123D+03,0.16682000D+01,0.19138000D+01
     .,0.42896620D+03,0.143D+03,0.124D+03,0.16682000D+01,0.18269000D+01
     .,0.38890660D+03,0.143D+03,0.125D+03,0.16682000D+01,0.16406000D+01
     .,0.35865620D+03,0.143D+03,0.126D+03,0.16682000D+01,0.16483000D+01
     .,0.34229790D+03,0.143D+03,0.127D+03,0.16682000D+01,0.17149000D+01
     .,0.33502870D+03,0.143D+03,0.128D+03,0.16682000D+01,0.17937000D+01
     .,0.33456150D+03,0.143D+03,0.129D+03,0.16682000D+01,0.95760000D+00
     .,0.30788150D+03,0.143D+03,0.130D+03,0.16682000D+01,0.19419000D+01
     .,0.52114410D+03,0.143D+03,0.131D+03,0.16682000D+01,0.96010000D+00
     ./)
      grimme_c6_parameters(  44501:  44600)=(/
     . 0.44771310D+03,0.143D+03,0.132D+03,0.16682000D+01,0.94340000D+00
     .,0.39524720D+03,0.143D+03,0.133D+03,0.16682000D+01,0.98890000D+00
     .,0.35747370D+03,0.143D+03,0.134D+03,0.16682000D+01,0.99010000D+00
     .,0.31169010D+03,0.143D+03,0.135D+03,0.16682000D+01,0.99740000D+00
     .,0.55612550D+03,0.143D+03,0.137D+03,0.16682000D+01,0.97380000D+00
     .,0.11562604D+04,0.143D+03,0.138D+03,0.16682000D+01,0.98010000D+00
     .,0.84837270D+03,0.143D+03,0.139D+03,0.16682000D+01,0.19153000D+01
     .,0.60533890D+03,0.143D+03,0.140D+03,0.16682000D+01,0.19355000D+01
     .,0.61127640D+03,0.143D+03,0.141D+03,0.16682000D+01,0.19545000D+01
     .,0.56776700D+03,0.143D+03,0.142D+03,0.16682000D+01,0.19420000D+01
     .,0.64971430D+03,0.143D+03,0.143D+03,0.16682000D+01,0.16682000D+01
     .,0.33187500D+02,0.144D+03,0.100D+01,0.18584000D+01,0.91180000D+00
     .,0.22061600D+02,0.144D+03,0.200D+01,0.18584000D+01,0.00000000D+00
     .,0.51733300D+03,0.144D+03,0.300D+01,0.18584000D+01,0.00000000D+00
     .,0.29751860D+03,0.144D+03,0.400D+01,0.18584000D+01,0.00000000D+00
     .,0.20032990D+03,0.144D+03,0.500D+01,0.18584000D+01,0.00000000D+00
     .,0.13555170D+03,0.144D+03,0.600D+01,0.18584000D+01,0.00000000D+00
     .,0.95019000D+02,0.144D+03,0.700D+01,0.18584000D+01,0.00000000D+00
     .,0.72117300D+02,0.144D+03,0.800D+01,0.18584000D+01,0.00000000D+00
     .,0.54778100D+02,0.144D+03,0.900D+01,0.18584000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44601:  44700)=(/
     . 0.42243200D+02,0.144D+03,0.100D+02,0.18584000D+01,0.00000000D+00
     .,0.61866690D+03,0.144D+03,0.110D+02,0.18584000D+01,0.00000000D+00
     .,0.47441800D+03,0.144D+03,0.120D+02,0.18584000D+01,0.00000000D+00
     .,0.43702090D+03,0.144D+03,0.130D+02,0.18584000D+01,0.00000000D+00
     .,0.34421130D+03,0.144D+03,0.140D+02,0.18584000D+01,0.00000000D+00
     .,0.26854160D+03,0.144D+03,0.150D+02,0.18584000D+01,0.00000000D+00
     .,0.22308830D+03,0.144D+03,0.160D+02,0.18584000D+01,0.00000000D+00
     .,0.18247210D+03,0.144D+03,0.170D+02,0.18584000D+01,0.00000000D+00
     .,0.14952220D+03,0.144D+03,0.180D+02,0.18584000D+01,0.00000000D+00
     .,0.10157997D+04,0.144D+03,0.190D+02,0.18584000D+01,0.00000000D+00
     .,0.83526920D+03,0.144D+03,0.200D+02,0.18584000D+01,0.00000000D+00
     .,0.68960880D+03,0.144D+03,0.210D+02,0.18584000D+01,0.00000000D+00
     .,0.66581430D+03,0.144D+03,0.220D+02,0.18584000D+01,0.00000000D+00
     .,0.60961590D+03,0.144D+03,0.230D+02,0.18584000D+01,0.00000000D+00
     .,0.48063820D+03,0.144D+03,0.240D+02,0.18584000D+01,0.00000000D+00
     .,0.52477480D+03,0.144D+03,0.250D+02,0.18584000D+01,0.00000000D+00
     .,0.41224680D+03,0.144D+03,0.260D+02,0.18584000D+01,0.00000000D+00
     .,0.43640540D+03,0.144D+03,0.270D+02,0.18584000D+01,0.00000000D+00
     .,0.44958060D+03,0.144D+03,0.280D+02,0.18584000D+01,0.00000000D+00
     .,0.34510430D+03,0.144D+03,0.290D+02,0.18584000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44701:  44800)=(/
     . 0.35378800D+03,0.144D+03,0.300D+02,0.18584000D+01,0.00000000D+00
     .,0.41885730D+03,0.144D+03,0.310D+02,0.18584000D+01,0.00000000D+00
     .,0.36917340D+03,0.144D+03,0.320D+02,0.18584000D+01,0.00000000D+00
     .,0.31492530D+03,0.144D+03,0.330D+02,0.18584000D+01,0.00000000D+00
     .,0.28273020D+03,0.144D+03,0.340D+02,0.18584000D+01,0.00000000D+00
     .,0.24762030D+03,0.144D+03,0.350D+02,0.18584000D+01,0.00000000D+00
     .,0.21556830D+03,0.144D+03,0.360D+02,0.18584000D+01,0.00000000D+00
     .,0.11385265D+04,0.144D+03,0.370D+02,0.18584000D+01,0.00000000D+00
     .,0.99561160D+03,0.144D+03,0.380D+02,0.18584000D+01,0.00000000D+00
     .,0.87126000D+03,0.144D+03,0.390D+02,0.18584000D+01,0.00000000D+00
     .,0.78271660D+03,0.144D+03,0.400D+02,0.18584000D+01,0.00000000D+00
     .,0.71364770D+03,0.144D+03,0.410D+02,0.18584000D+01,0.00000000D+00
     .,0.55112400D+03,0.144D+03,0.420D+02,0.18584000D+01,0.00000000D+00
     .,0.61481850D+03,0.144D+03,0.430D+02,0.18584000D+01,0.00000000D+00
     .,0.46856950D+03,0.144D+03,0.440D+02,0.18584000D+01,0.00000000D+00
     .,0.51183150D+03,0.144D+03,0.450D+02,0.18584000D+01,0.00000000D+00
     .,0.47463690D+03,0.144D+03,0.460D+02,0.18584000D+01,0.00000000D+00
     .,0.39627420D+03,0.144D+03,0.470D+02,0.18584000D+01,0.00000000D+00
     .,0.41825790D+03,0.144D+03,0.480D+02,0.18584000D+01,0.00000000D+00
     .,0.52482360D+03,0.144D+03,0.490D+02,0.18584000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44801:  44900)=(/
     . 0.48488550D+03,0.144D+03,0.500D+02,0.18584000D+01,0.00000000D+00
     .,0.43198650D+03,0.144D+03,0.510D+02,0.18584000D+01,0.00000000D+00
     .,0.40083190D+03,0.144D+03,0.520D+02,0.18584000D+01,0.00000000D+00
     .,0.36253740D+03,0.144D+03,0.530D+02,0.18584000D+01,0.00000000D+00
     .,0.32611570D+03,0.144D+03,0.540D+02,0.18584000D+01,0.00000000D+00
     .,0.13871242D+04,0.144D+03,0.550D+02,0.18584000D+01,0.00000000D+00
     .,0.12701002D+04,0.144D+03,0.560D+02,0.18584000D+01,0.00000000D+00
     .,0.11145962D+04,0.144D+03,0.570D+02,0.18584000D+01,0.00000000D+00
     .,0.51058640D+03,0.144D+03,0.580D+02,0.18584000D+01,0.27991000D+01
     .,0.11251127D+04,0.144D+03,0.590D+02,0.18584000D+01,0.00000000D+00
     .,0.10801628D+04,0.144D+03,0.600D+02,0.18584000D+01,0.00000000D+00
     .,0.10529974D+04,0.144D+03,0.610D+02,0.18584000D+01,0.00000000D+00
     .,0.10280158D+04,0.144D+03,0.620D+02,0.18584000D+01,0.00000000D+00
     .,0.10058586D+04,0.144D+03,0.630D+02,0.18584000D+01,0.00000000D+00
     .,0.79051760D+03,0.144D+03,0.640D+02,0.18584000D+01,0.00000000D+00
     .,0.89187640D+03,0.144D+03,0.650D+02,0.18584000D+01,0.00000000D+00
     .,0.85997290D+03,0.144D+03,0.660D+02,0.18584000D+01,0.00000000D+00
     .,0.90692140D+03,0.144D+03,0.670D+02,0.18584000D+01,0.00000000D+00
     .,0.88762020D+03,0.144D+03,0.680D+02,0.18584000D+01,0.00000000D+00
     .,0.87020630D+03,0.144D+03,0.690D+02,0.18584000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  44901:  45000)=(/
     . 0.86003450D+03,0.144D+03,0.700D+02,0.18584000D+01,0.00000000D+00
     .,0.72429040D+03,0.144D+03,0.710D+02,0.18584000D+01,0.00000000D+00
     .,0.71147790D+03,0.144D+03,0.720D+02,0.18584000D+01,0.00000000D+00
     .,0.64914710D+03,0.144D+03,0.730D+02,0.18584000D+01,0.00000000D+00
     .,0.54842120D+03,0.144D+03,0.740D+02,0.18584000D+01,0.00000000D+00
     .,0.55775610D+03,0.144D+03,0.750D+02,0.18584000D+01,0.00000000D+00
     .,0.50549330D+03,0.144D+03,0.760D+02,0.18584000D+01,0.00000000D+00
     .,0.46298700D+03,0.144D+03,0.770D+02,0.18584000D+01,0.00000000D+00
     .,0.38491460D+03,0.144D+03,0.780D+02,0.18584000D+01,0.00000000D+00
     .,0.35974270D+03,0.144D+03,0.790D+02,0.18584000D+01,0.00000000D+00
     .,0.36989520D+03,0.144D+03,0.800D+02,0.18584000D+01,0.00000000D+00
     .,0.53929820D+03,0.144D+03,0.810D+02,0.18584000D+01,0.00000000D+00
     .,0.52677380D+03,0.144D+03,0.820D+02,0.18584000D+01,0.00000000D+00
     .,0.48381430D+03,0.144D+03,0.830D+02,0.18584000D+01,0.00000000D+00
     .,0.46139360D+03,0.144D+03,0.840D+02,0.18584000D+01,0.00000000D+00
     .,0.42587210D+03,0.144D+03,0.850D+02,0.18584000D+01,0.00000000D+00
     .,0.39047110D+03,0.144D+03,0.860D+02,0.18584000D+01,0.00000000D+00
     .,0.13086904D+04,0.144D+03,0.870D+02,0.18584000D+01,0.00000000D+00
     .,0.12553593D+04,0.144D+03,0.880D+02,0.18584000D+01,0.00000000D+00
     .,0.11084934D+04,0.144D+03,0.890D+02,0.18584000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  45001:  45100)=(/
     . 0.99548230D+03,0.144D+03,0.900D+02,0.18584000D+01,0.00000000D+00
     .,0.98913640D+03,0.144D+03,0.910D+02,0.18584000D+01,0.00000000D+00
     .,0.95777810D+03,0.144D+03,0.920D+02,0.18584000D+01,0.00000000D+00
     .,0.98673520D+03,0.144D+03,0.930D+02,0.18584000D+01,0.00000000D+00
     .,0.95542490D+03,0.144D+03,0.940D+02,0.18584000D+01,0.00000000D+00
     .,0.53364800D+02,0.144D+03,0.101D+03,0.18584000D+01,0.00000000D+00
     .,0.17297080D+03,0.144D+03,0.103D+03,0.18584000D+01,0.98650000D+00
     .,0.22067460D+03,0.144D+03,0.104D+03,0.18584000D+01,0.98080000D+00
     .,0.16859440D+03,0.144D+03,0.105D+03,0.18584000D+01,0.97060000D+00
     .,0.12721250D+03,0.144D+03,0.106D+03,0.18584000D+01,0.98680000D+00
     .,0.88661300D+02,0.144D+03,0.107D+03,0.18584000D+01,0.99440000D+00
     .,0.64744800D+02,0.144D+03,0.108D+03,0.18584000D+01,0.99250000D+00
     .,0.44708700D+02,0.144D+03,0.109D+03,0.18584000D+01,0.99820000D+00
     .,0.25309000D+03,0.144D+03,0.111D+03,0.18584000D+01,0.96840000D+00
     .,0.39136060D+03,0.144D+03,0.112D+03,0.18584000D+01,0.96280000D+00
     .,0.39606340D+03,0.144D+03,0.113D+03,0.18584000D+01,0.96480000D+00
     .,0.31817950D+03,0.144D+03,0.114D+03,0.18584000D+01,0.95070000D+00
     .,0.26070120D+03,0.144D+03,0.115D+03,0.18584000D+01,0.99470000D+00
     .,0.22064770D+03,0.144D+03,0.116D+03,0.18584000D+01,0.99480000D+00
     .,0.18059160D+03,0.144D+03,0.117D+03,0.18584000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters(  45101:  45200)=(/
     . 0.34947530D+03,0.144D+03,0.119D+03,0.18584000D+01,0.97670000D+00
     .,0.66876460D+03,0.144D+03,0.120D+03,0.18584000D+01,0.98310000D+00
     .,0.34907020D+03,0.144D+03,0.121D+03,0.18584000D+01,0.18627000D+01
     .,0.33705530D+03,0.144D+03,0.122D+03,0.18584000D+01,0.18299000D+01
     .,0.33035670D+03,0.144D+03,0.123D+03,0.18584000D+01,0.19138000D+01
     .,0.32735530D+03,0.144D+03,0.124D+03,0.18584000D+01,0.18269000D+01
     .,0.30103970D+03,0.144D+03,0.125D+03,0.18584000D+01,0.16406000D+01
     .,0.27865260D+03,0.144D+03,0.126D+03,0.18584000D+01,0.16483000D+01
     .,0.26587520D+03,0.144D+03,0.127D+03,0.18584000D+01,0.17149000D+01
     .,0.25994720D+03,0.144D+03,0.128D+03,0.18584000D+01,0.17937000D+01
     .,0.25694800D+03,0.144D+03,0.129D+03,0.18584000D+01,0.95760000D+00
     .,0.24091240D+03,0.144D+03,0.130D+03,0.18584000D+01,0.19419000D+01
     .,0.39335710D+03,0.144D+03,0.131D+03,0.18584000D+01,0.96010000D+00
     .,0.34538720D+03,0.144D+03,0.132D+03,0.18584000D+01,0.94340000D+00
     .,0.30960350D+03,0.144D+03,0.133D+03,0.18584000D+01,0.98890000D+00
     .,0.28284600D+03,0.144D+03,0.134D+03,0.18584000D+01,0.99010000D+00
     .,0.24934040D+03,0.144D+03,0.135D+03,0.18584000D+01,0.99740000D+00
     .,0.41708310D+03,0.144D+03,0.137D+03,0.18584000D+01,0.97380000D+00
     .,0.81419750D+03,0.144D+03,0.138D+03,0.18584000D+01,0.98010000D+00
     .,0.62130580D+03,0.144D+03,0.139D+03,0.18584000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters(  45201:  45300)=(/
     . 0.46191410D+03,0.144D+03,0.140D+03,0.18584000D+01,0.19355000D+01
     .,0.46653580D+03,0.144D+03,0.141D+03,0.18584000D+01,0.19545000D+01
     .,0.43510620D+03,0.144D+03,0.142D+03,0.18584000D+01,0.19420000D+01
     .,0.48832640D+03,0.144D+03,0.143D+03,0.18584000D+01,0.16682000D+01
     .,0.37926550D+03,0.144D+03,0.144D+03,0.18584000D+01,0.18584000D+01
     .,0.31102400D+02,0.145D+03,0.100D+01,0.19003000D+01,0.91180000D+00
     .,0.20777600D+02,0.145D+03,0.200D+01,0.19003000D+01,0.00000000D+00
     .,0.48243420D+03,0.145D+03,0.300D+01,0.19003000D+01,0.00000000D+00
     .,0.27741740D+03,0.145D+03,0.400D+01,0.19003000D+01,0.00000000D+00
     .,0.18713270D+03,0.145D+03,0.500D+01,0.19003000D+01,0.00000000D+00
     .,0.12690850D+03,0.145D+03,0.600D+01,0.19003000D+01,0.00000000D+00
     .,0.89165900D+02,0.145D+03,0.700D+01,0.19003000D+01,0.00000000D+00
     .,0.67811400D+02,0.145D+03,0.800D+01,0.19003000D+01,0.00000000D+00
     .,0.51611700D+02,0.145D+03,0.900D+01,0.19003000D+01,0.00000000D+00
     .,0.39876200D+02,0.145D+03,0.100D+02,0.19003000D+01,0.00000000D+00
     .,0.57701810D+03,0.145D+03,0.110D+02,0.19003000D+01,0.00000000D+00
     .,0.44233810D+03,0.145D+03,0.120D+02,0.19003000D+01,0.00000000D+00
     .,0.40769990D+03,0.145D+03,0.130D+02,0.19003000D+01,0.00000000D+00
     .,0.32145940D+03,0.145D+03,0.140D+02,0.19003000D+01,0.00000000D+00
     .,0.25114770D+03,0.145D+03,0.150D+02,0.19003000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  45301:  45400)=(/
     . 0.20890670D+03,0.145D+03,0.160D+02,0.19003000D+01,0.00000000D+00
     .,0.17111870D+03,0.145D+03,0.170D+02,0.19003000D+01,0.00000000D+00
     .,0.14042730D+03,0.145D+03,0.180D+02,0.19003000D+01,0.00000000D+00
     .,0.94851400D+03,0.145D+03,0.190D+02,0.19003000D+01,0.00000000D+00
     .,0.77905470D+03,0.145D+03,0.200D+02,0.19003000D+01,0.00000000D+00
     .,0.64318930D+03,0.145D+03,0.210D+02,0.19003000D+01,0.00000000D+00
     .,0.62118070D+03,0.145D+03,0.220D+02,0.19003000D+01,0.00000000D+00
     .,0.56883480D+03,0.145D+03,0.230D+02,0.19003000D+01,0.00000000D+00
     .,0.44875270D+03,0.145D+03,0.240D+02,0.19003000D+01,0.00000000D+00
     .,0.48979330D+03,0.145D+03,0.250D+02,0.19003000D+01,0.00000000D+00
     .,0.38501530D+03,0.145D+03,0.260D+02,0.19003000D+01,0.00000000D+00
     .,0.40745740D+03,0.145D+03,0.270D+02,0.19003000D+01,0.00000000D+00
     .,0.41967090D+03,0.145D+03,0.280D+02,0.19003000D+01,0.00000000D+00
     .,0.32239880D+03,0.145D+03,0.290D+02,0.19003000D+01,0.00000000D+00
     .,0.33047130D+03,0.145D+03,0.300D+02,0.19003000D+01,0.00000000D+00
     .,0.39105080D+03,0.145D+03,0.310D+02,0.19003000D+01,0.00000000D+00
     .,0.34491000D+03,0.145D+03,0.320D+02,0.19003000D+01,0.00000000D+00
     .,0.29454210D+03,0.145D+03,0.330D+02,0.19003000D+01,0.00000000D+00
     .,0.26467170D+03,0.145D+03,0.340D+02,0.19003000D+01,0.00000000D+00
     .,0.23205800D+03,0.145D+03,0.350D+02,0.19003000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  45401:  45500)=(/
     . 0.20225670D+03,0.145D+03,0.360D+02,0.19003000D+01,0.00000000D+00
     .,0.10633477D+04,0.145D+03,0.370D+02,0.19003000D+01,0.00000000D+00
     .,0.92882550D+03,0.145D+03,0.380D+02,0.19003000D+01,0.00000000D+00
     .,0.81293380D+03,0.145D+03,0.390D+02,0.19003000D+01,0.00000000D+00
     .,0.73049700D+03,0.145D+03,0.400D+02,0.19003000D+01,0.00000000D+00
     .,0.66622590D+03,0.145D+03,0.410D+02,0.19003000D+01,0.00000000D+00
     .,0.51491280D+03,0.145D+03,0.420D+02,0.19003000D+01,0.00000000D+00
     .,0.57424560D+03,0.145D+03,0.430D+02,0.19003000D+01,0.00000000D+00
     .,0.43804260D+03,0.145D+03,0.440D+02,0.19003000D+01,0.00000000D+00
     .,0.47828480D+03,0.145D+03,0.450D+02,0.19003000D+01,0.00000000D+00
     .,0.44362800D+03,0.145D+03,0.460D+02,0.19003000D+01,0.00000000D+00
     .,0.37063780D+03,0.145D+03,0.470D+02,0.19003000D+01,0.00000000D+00
     .,0.39106750D+03,0.145D+03,0.480D+02,0.19003000D+01,0.00000000D+00
     .,0.49033250D+03,0.145D+03,0.490D+02,0.19003000D+01,0.00000000D+00
     .,0.45317940D+03,0.145D+03,0.500D+02,0.19003000D+01,0.00000000D+00
     .,0.40403840D+03,0.145D+03,0.510D+02,0.19003000D+01,0.00000000D+00
     .,0.37513030D+03,0.145D+03,0.520D+02,0.19003000D+01,0.00000000D+00
     .,0.33956200D+03,0.145D+03,0.530D+02,0.19003000D+01,0.00000000D+00
     .,0.30572010D+03,0.145D+03,0.540D+02,0.19003000D+01,0.00000000D+00
     .,0.12958507D+04,0.145D+03,0.550D+02,0.19003000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  45501:  45600)=(/
     . 0.11851747D+04,0.145D+03,0.560D+02,0.19003000D+01,0.00000000D+00
     .,0.10401066D+04,0.145D+03,0.570D+02,0.19003000D+01,0.00000000D+00
     .,0.47759450D+03,0.145D+03,0.580D+02,0.19003000D+01,0.27991000D+01
     .,0.10500763D+04,0.145D+03,0.590D+02,0.19003000D+01,0.00000000D+00
     .,0.10080521D+04,0.145D+03,0.600D+02,0.19003000D+01,0.00000000D+00
     .,0.98268750D+03,0.145D+03,0.610D+02,0.19003000D+01,0.00000000D+00
     .,0.95935980D+03,0.145D+03,0.620D+02,0.19003000D+01,0.00000000D+00
     .,0.93866880D+03,0.145D+03,0.630D+02,0.19003000D+01,0.00000000D+00
     .,0.73813170D+03,0.145D+03,0.640D+02,0.19003000D+01,0.00000000D+00
     .,0.83296700D+03,0.145D+03,0.650D+02,0.19003000D+01,0.00000000D+00
     .,0.80325110D+03,0.145D+03,0.660D+02,0.19003000D+01,0.00000000D+00
     .,0.84631030D+03,0.145D+03,0.670D+02,0.19003000D+01,0.00000000D+00
     .,0.82828260D+03,0.145D+03,0.680D+02,0.19003000D+01,0.00000000D+00
     .,0.81202140D+03,0.145D+03,0.690D+02,0.19003000D+01,0.00000000D+00
     .,0.80250260D+03,0.145D+03,0.700D+02,0.19003000D+01,0.00000000D+00
     .,0.67613200D+03,0.145D+03,0.710D+02,0.19003000D+01,0.00000000D+00
     .,0.66419530D+03,0.145D+03,0.720D+02,0.19003000D+01,0.00000000D+00
     .,0.60624630D+03,0.145D+03,0.730D+02,0.19003000D+01,0.00000000D+00
     .,0.51256560D+03,0.145D+03,0.740D+02,0.19003000D+01,0.00000000D+00
     .,0.52130610D+03,0.145D+03,0.750D+02,0.19003000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  45601:  45700)=(/
     . 0.47268090D+03,0.145D+03,0.760D+02,0.19003000D+01,0.00000000D+00
     .,0.43312920D+03,0.145D+03,0.770D+02,0.19003000D+01,0.00000000D+00
     .,0.36041730D+03,0.145D+03,0.780D+02,0.19003000D+01,0.00000000D+00
     .,0.33697140D+03,0.145D+03,0.790D+02,0.19003000D+01,0.00000000D+00
     .,0.34645260D+03,0.145D+03,0.800D+02,0.19003000D+01,0.00000000D+00
     .,0.50424040D+03,0.145D+03,0.810D+02,0.19003000D+01,0.00000000D+00
     .,0.49256890D+03,0.145D+03,0.820D+02,0.19003000D+01,0.00000000D+00
     .,0.45264510D+03,0.145D+03,0.830D+02,0.19003000D+01,0.00000000D+00
     .,0.43185880D+03,0.145D+03,0.840D+02,0.19003000D+01,0.00000000D+00
     .,0.39887680D+03,0.145D+03,0.850D+02,0.19003000D+01,0.00000000D+00
     .,0.36599140D+03,0.145D+03,0.860D+02,0.19003000D+01,0.00000000D+00
     .,0.12224485D+04,0.145D+03,0.870D+02,0.19003000D+01,0.00000000D+00
     .,0.11715378D+04,0.145D+03,0.880D+02,0.19003000D+01,0.00000000D+00
     .,0.10345633D+04,0.145D+03,0.890D+02,0.19003000D+01,0.00000000D+00
     .,0.92953190D+03,0.145D+03,0.900D+02,0.19003000D+01,0.00000000D+00
     .,0.92366730D+03,0.145D+03,0.910D+02,0.19003000D+01,0.00000000D+00
     .,0.89441350D+03,0.145D+03,0.920D+02,0.19003000D+01,0.00000000D+00
     .,0.92128530D+03,0.145D+03,0.930D+02,0.19003000D+01,0.00000000D+00
     .,0.89206410D+03,0.145D+03,0.940D+02,0.19003000D+01,0.00000000D+00
     .,0.49909000D+02,0.145D+03,0.101D+03,0.19003000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  45701:  45800)=(/
     . 0.16134990D+03,0.145D+03,0.103D+03,0.19003000D+01,0.98650000D+00
     .,0.20595300D+03,0.145D+03,0.104D+03,0.19003000D+01,0.98080000D+00
     .,0.15759490D+03,0.145D+03,0.105D+03,0.19003000D+01,0.97060000D+00
     .,0.11912650D+03,0.145D+03,0.106D+03,0.19003000D+01,0.98680000D+00
     .,0.83222700D+02,0.145D+03,0.107D+03,0.19003000D+01,0.99440000D+00
     .,0.60915900D+02,0.145D+03,0.108D+03,0.19003000D+01,0.99250000D+00
     .,0.42208400D+02,0.145D+03,0.109D+03,0.19003000D+01,0.99820000D+00
     .,0.23614440D+03,0.145D+03,0.111D+03,0.19003000D+01,0.96840000D+00
     .,0.36507050D+03,0.145D+03,0.112D+03,0.19003000D+01,0.96280000D+00
     .,0.36958140D+03,0.145D+03,0.113D+03,0.19003000D+01,0.96480000D+00
     .,0.29723390D+03,0.145D+03,0.114D+03,0.19003000D+01,0.95070000D+00
     .,0.24384390D+03,0.145D+03,0.115D+03,0.19003000D+01,0.99470000D+00
     .,0.20662580D+03,0.145D+03,0.116D+03,0.19003000D+01,0.99480000D+00
     .,0.16935840D+03,0.145D+03,0.117D+03,0.19003000D+01,0.99720000D+00
     .,0.32659470D+03,0.145D+03,0.119D+03,0.19003000D+01,0.97670000D+00
     .,0.62428500D+03,0.145D+03,0.120D+03,0.19003000D+01,0.98310000D+00
     .,0.32625030D+03,0.145D+03,0.121D+03,0.19003000D+01,0.18627000D+01
     .,0.31509820D+03,0.145D+03,0.122D+03,0.19003000D+01,0.18299000D+01
     .,0.30884820D+03,0.145D+03,0.123D+03,0.19003000D+01,0.19138000D+01
     .,0.30603400D+03,0.145D+03,0.124D+03,0.19003000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters(  45801:  45900)=(/
     . 0.28151340D+03,0.145D+03,0.125D+03,0.19003000D+01,0.16406000D+01
     .,0.26065670D+03,0.145D+03,0.126D+03,0.19003000D+01,0.16483000D+01
     .,0.24873880D+03,0.145D+03,0.127D+03,0.19003000D+01,0.17149000D+01
     .,0.24319090D+03,0.145D+03,0.128D+03,0.19003000D+01,0.17937000D+01
     .,0.24032600D+03,0.145D+03,0.129D+03,0.19003000D+01,0.95760000D+00
     .,0.22543980D+03,0.145D+03,0.130D+03,0.19003000D+01,0.19419000D+01
     .,0.36731970D+03,0.145D+03,0.131D+03,0.19003000D+01,0.96010000D+00
     .,0.32278160D+03,0.145D+03,0.132D+03,0.19003000D+01,0.94340000D+00
     .,0.28959340D+03,0.145D+03,0.133D+03,0.19003000D+01,0.98890000D+00
     .,0.26478150D+03,0.145D+03,0.134D+03,0.19003000D+01,0.99010000D+00
     .,0.23366080D+03,0.145D+03,0.135D+03,0.19003000D+01,0.99740000D+00
     .,0.38991830D+03,0.145D+03,0.137D+03,0.19003000D+01,0.97380000D+00
     .,0.76024370D+03,0.145D+03,0.138D+03,0.19003000D+01,0.98010000D+00
     .,0.58041450D+03,0.145D+03,0.139D+03,0.19003000D+01,0.19153000D+01
     .,0.43182880D+03,0.145D+03,0.140D+03,0.19003000D+01,0.19355000D+01
     .,0.43614400D+03,0.145D+03,0.141D+03,0.19003000D+01,0.19545000D+01
     .,0.40693380D+03,0.145D+03,0.142D+03,0.19003000D+01,0.19420000D+01
     .,0.45656180D+03,0.145D+03,0.143D+03,0.19003000D+01,0.16682000D+01
     .,0.35492820D+03,0.145D+03,0.144D+03,0.19003000D+01,0.18584000D+01
     .,0.33224250D+03,0.145D+03,0.145D+03,0.19003000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters(  45901:  46000)=(/
     . 0.28966100D+02,0.146D+03,0.100D+01,0.18630000D+01,0.91180000D+00
     .,0.19468900D+02,0.146D+03,0.200D+01,0.18630000D+01,0.00000000D+00
     .,0.44391060D+03,0.146D+03,0.300D+01,0.18630000D+01,0.00000000D+00
     .,0.25623270D+03,0.146D+03,0.400D+01,0.18630000D+01,0.00000000D+00
     .,0.17343600D+03,0.146D+03,0.500D+01,0.18630000D+01,0.00000000D+00
     .,0.11801370D+03,0.146D+03,0.600D+01,0.18630000D+01,0.00000000D+00
     .,0.83171000D+02,0.146D+03,0.700D+01,0.18630000D+01,0.00000000D+00
     .,0.63412500D+02,0.146D+03,0.800D+01,0.18630000D+01,0.00000000D+00
     .,0.48382400D+02,0.146D+03,0.900D+01,0.18630000D+01,0.00000000D+00
     .,0.37464700D+02,0.146D+03,0.100D+02,0.18630000D+01,0.00000000D+00
     .,0.53116760D+03,0.146D+03,0.110D+02,0.18630000D+01,0.00000000D+00
     .,0.40830220D+03,0.146D+03,0.120D+02,0.18630000D+01,0.00000000D+00
     .,0.37687760D+03,0.146D+03,0.130D+02,0.18630000D+01,0.00000000D+00
     .,0.29781740D+03,0.146D+03,0.140D+02,0.18630000D+01,0.00000000D+00
     .,0.23321060D+03,0.146D+03,0.150D+02,0.18630000D+01,0.00000000D+00
     .,0.19433730D+03,0.146D+03,0.160D+02,0.18630000D+01,0.00000000D+00
     .,0.15949140D+03,0.146D+03,0.170D+02,0.18630000D+01,0.00000000D+00
     .,0.13113380D+03,0.146D+03,0.180D+02,0.18630000D+01,0.00000000D+00
     .,0.87329840D+03,0.146D+03,0.190D+02,0.18630000D+01,0.00000000D+00
     .,0.71849830D+03,0.146D+03,0.200D+02,0.18630000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  46001:  46100)=(/
     . 0.59349940D+03,0.146D+03,0.210D+02,0.18630000D+01,0.00000000D+00
     .,0.57359720D+03,0.146D+03,0.220D+02,0.18630000D+01,0.00000000D+00
     .,0.52547320D+03,0.146D+03,0.230D+02,0.18630000D+01,0.00000000D+00
     .,0.41479180D+03,0.146D+03,0.240D+02,0.18630000D+01,0.00000000D+00
     .,0.45273530D+03,0.146D+03,0.250D+02,0.18630000D+01,0.00000000D+00
     .,0.35613440D+03,0.146D+03,0.260D+02,0.18630000D+01,0.00000000D+00
     .,0.37699280D+03,0.146D+03,0.270D+02,0.18630000D+01,0.00000000D+00
     .,0.38812000D+03,0.146D+03,0.280D+02,0.18630000D+01,0.00000000D+00
     .,0.29838940D+03,0.146D+03,0.290D+02,0.18630000D+01,0.00000000D+00
     .,0.30606330D+03,0.146D+03,0.300D+02,0.18630000D+01,0.00000000D+00
     .,0.36187800D+03,0.146D+03,0.310D+02,0.18630000D+01,0.00000000D+00
     .,0.31969460D+03,0.146D+03,0.320D+02,0.18630000D+01,0.00000000D+00
     .,0.27350100D+03,0.146D+03,0.330D+02,0.18630000D+01,0.00000000D+00
     .,0.24609210D+03,0.146D+03,0.340D+02,0.18630000D+01,0.00000000D+00
     .,0.21609450D+03,0.146D+03,0.350D+02,0.18630000D+01,0.00000000D+00
     .,0.18863390D+03,0.146D+03,0.360D+02,0.18630000D+01,0.00000000D+00
     .,0.97940320D+03,0.146D+03,0.370D+02,0.18630000D+01,0.00000000D+00
     .,0.85671690D+03,0.146D+03,0.380D+02,0.18630000D+01,0.00000000D+00
     .,0.75059330D+03,0.146D+03,0.390D+02,0.18630000D+01,0.00000000D+00
     .,0.67499290D+03,0.146D+03,0.400D+02,0.18630000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  46101:  46200)=(/
     . 0.61597590D+03,0.146D+03,0.410D+02,0.18630000D+01,0.00000000D+00
     .,0.47670900D+03,0.146D+03,0.420D+02,0.18630000D+01,0.00000000D+00
     .,0.53137000D+03,0.146D+03,0.430D+02,0.18630000D+01,0.00000000D+00
     .,0.40593980D+03,0.146D+03,0.440D+02,0.18630000D+01,0.00000000D+00
     .,0.44306590D+03,0.146D+03,0.450D+02,0.18630000D+01,0.00000000D+00
     .,0.41113610D+03,0.146D+03,0.460D+02,0.18630000D+01,0.00000000D+00
     .,0.34367070D+03,0.146D+03,0.470D+02,0.18630000D+01,0.00000000D+00
     .,0.36264320D+03,0.146D+03,0.480D+02,0.18630000D+01,0.00000000D+00
     .,0.45405760D+03,0.146D+03,0.490D+02,0.18630000D+01,0.00000000D+00
     .,0.42012680D+03,0.146D+03,0.500D+02,0.18630000D+01,0.00000000D+00
     .,0.37509950D+03,0.146D+03,0.510D+02,0.18630000D+01,0.00000000D+00
     .,0.34860740D+03,0.146D+03,0.520D+02,0.18630000D+01,0.00000000D+00
     .,0.31592880D+03,0.146D+03,0.530D+02,0.18630000D+01,0.00000000D+00
     .,0.28479640D+03,0.146D+03,0.540D+02,0.18630000D+01,0.00000000D+00
     .,0.11937040D+04,0.146D+03,0.550D+02,0.18630000D+01,0.00000000D+00
     .,0.10930044D+04,0.146D+03,0.560D+02,0.18630000D+01,0.00000000D+00
     .,0.96013460D+03,0.146D+03,0.570D+02,0.18630000D+01,0.00000000D+00
     .,0.44336290D+03,0.146D+03,0.580D+02,0.18630000D+01,0.27991000D+01
     .,0.96887580D+03,0.146D+03,0.590D+02,0.18630000D+01,0.00000000D+00
     .,0.93022500D+03,0.146D+03,0.600D+02,0.18630000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  46201:  46300)=(/
     . 0.90685110D+03,0.146D+03,0.610D+02,0.18630000D+01,0.00000000D+00
     .,0.88534770D+03,0.146D+03,0.620D+02,0.18630000D+01,0.00000000D+00
     .,0.86627480D+03,0.146D+03,0.630D+02,0.18630000D+01,0.00000000D+00
     .,0.68220730D+03,0.146D+03,0.640D+02,0.18630000D+01,0.00000000D+00
     .,0.76879040D+03,0.146D+03,0.650D+02,0.18630000D+01,0.00000000D+00
     .,0.74151490D+03,0.146D+03,0.660D+02,0.18630000D+01,0.00000000D+00
     .,0.78120400D+03,0.146D+03,0.670D+02,0.18630000D+01,0.00000000D+00
     .,0.76457050D+03,0.146D+03,0.680D+02,0.18630000D+01,0.00000000D+00
     .,0.74957790D+03,0.146D+03,0.690D+02,0.18630000D+01,0.00000000D+00
     .,0.74073920D+03,0.146D+03,0.700D+02,0.18630000D+01,0.00000000D+00
     .,0.62471570D+03,0.146D+03,0.710D+02,0.18630000D+01,0.00000000D+00
     .,0.61425310D+03,0.146D+03,0.720D+02,0.18630000D+01,0.00000000D+00
     .,0.56115170D+03,0.146D+03,0.730D+02,0.18630000D+01,0.00000000D+00
     .,0.47494930D+03,0.146D+03,0.740D+02,0.18630000D+01,0.00000000D+00
     .,0.48315690D+03,0.146D+03,0.750D+02,0.18630000D+01,0.00000000D+00
     .,0.43846770D+03,0.146D+03,0.760D+02,0.18630000D+01,0.00000000D+00
     .,0.40208340D+03,0.146D+03,0.770D+02,0.18630000D+01,0.00000000D+00
     .,0.33498540D+03,0.146D+03,0.780D+02,0.18630000D+01,0.00000000D+00
     .,0.31334830D+03,0.146D+03,0.790D+02,0.18630000D+01,0.00000000D+00
     .,0.32218840D+03,0.146D+03,0.800D+02,0.18630000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  46301:  46400)=(/
     . 0.46735710D+03,0.146D+03,0.810D+02,0.18630000D+01,0.00000000D+00
     .,0.45686740D+03,0.146D+03,0.820D+02,0.18630000D+01,0.00000000D+00
     .,0.42032740D+03,0.146D+03,0.830D+02,0.18630000D+01,0.00000000D+00
     .,0.40133490D+03,0.146D+03,0.840D+02,0.18630000D+01,0.00000000D+00
     .,0.37107280D+03,0.146D+03,0.850D+02,0.18630000D+01,0.00000000D+00
     .,0.34084580D+03,0.146D+03,0.860D+02,0.18630000D+01,0.00000000D+00
     .,0.11269549D+04,0.146D+03,0.870D+02,0.18630000D+01,0.00000000D+00
     .,0.10810405D+04,0.146D+03,0.880D+02,0.18630000D+01,0.00000000D+00
     .,0.95553590D+03,0.146D+03,0.890D+02,0.18630000D+01,0.00000000D+00
     .,0.85969500D+03,0.146D+03,0.900D+02,0.18630000D+01,0.00000000D+00
     .,0.85393730D+03,0.146D+03,0.910D+02,0.18630000D+01,0.00000000D+00
     .,0.82694450D+03,0.146D+03,0.920D+02,0.18630000D+01,0.00000000D+00
     .,0.85119160D+03,0.146D+03,0.930D+02,0.18630000D+01,0.00000000D+00
     .,0.82429470D+03,0.146D+03,0.940D+02,0.18630000D+01,0.00000000D+00
     .,0.46348900D+02,0.146D+03,0.101D+03,0.18630000D+01,0.00000000D+00
     .,0.14912090D+03,0.146D+03,0.103D+03,0.18630000D+01,0.98650000D+00
     .,0.19048260D+03,0.146D+03,0.104D+03,0.18630000D+01,0.98080000D+00
     .,0.14620200D+03,0.146D+03,0.105D+03,0.18630000D+01,0.97060000D+00
     .,0.11079460D+03,0.146D+03,0.106D+03,0.18630000D+01,0.98680000D+00
     .,0.77647900D+02,0.146D+03,0.107D+03,0.18630000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters(  46401:  46500)=(/
     . 0.57004900D+02,0.146D+03,0.108D+03,0.18630000D+01,0.99250000D+00
     .,0.39663600D+02,0.146D+03,0.109D+03,0.18630000D+01,0.99820000D+00
     .,0.21823330D+03,0.146D+03,0.111D+03,0.18630000D+01,0.96840000D+00
     .,0.33722560D+03,0.146D+03,0.112D+03,0.18630000D+01,0.96280000D+00
     .,0.34179460D+03,0.146D+03,0.113D+03,0.18630000D+01,0.96480000D+00
     .,0.27549250D+03,0.146D+03,0.114D+03,0.18630000D+01,0.95070000D+00
     .,0.22646050D+03,0.146D+03,0.115D+03,0.18630000D+01,0.99470000D+00
     .,0.19221720D+03,0.146D+03,0.116D+03,0.18630000D+01,0.99480000D+00
     .,0.15785240D+03,0.146D+03,0.117D+03,0.18630000D+01,0.99720000D+00
     .,0.30246350D+03,0.146D+03,0.119D+03,0.18630000D+01,0.97670000D+00
     .,0.57613740D+03,0.146D+03,0.120D+03,0.18630000D+01,0.98310000D+00
     .,0.30248980D+03,0.146D+03,0.121D+03,0.18630000D+01,0.18627000D+01
     .,0.29221350D+03,0.146D+03,0.122D+03,0.18630000D+01,0.18299000D+01
     .,0.28642780D+03,0.146D+03,0.123D+03,0.18630000D+01,0.19138000D+01
     .,0.28377850D+03,0.146D+03,0.124D+03,0.18630000D+01,0.18269000D+01
     .,0.26126350D+03,0.146D+03,0.125D+03,0.18630000D+01,0.16406000D+01
     .,0.24201470D+03,0.146D+03,0.126D+03,0.18630000D+01,0.16483000D+01
     .,0.23097880D+03,0.146D+03,0.127D+03,0.18630000D+01,0.17149000D+01
     .,0.22581650D+03,0.146D+03,0.128D+03,0.18630000D+01,0.17937000D+01
     .,0.22301540D+03,0.146D+03,0.129D+03,0.18630000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters(  46501:  46600)=(/
     . 0.20945460D+03,0.146D+03,0.130D+03,0.18630000D+01,0.19419000D+01
     .,0.34006750D+03,0.146D+03,0.131D+03,0.18630000D+01,0.96010000D+00
     .,0.29932800D+03,0.146D+03,0.132D+03,0.18630000D+01,0.94340000D+00
     .,0.26894270D+03,0.146D+03,0.133D+03,0.18630000D+01,0.98890000D+00
     .,0.24619370D+03,0.146D+03,0.134D+03,0.18630000D+01,0.99010000D+00
     .,0.21757380D+03,0.146D+03,0.135D+03,0.18630000D+01,0.99740000D+00
     .,0.36130470D+03,0.146D+03,0.137D+03,0.18630000D+01,0.97380000D+00
     .,0.70165500D+03,0.146D+03,0.138D+03,0.18630000D+01,0.98010000D+00
     .,0.53685660D+03,0.146D+03,0.139D+03,0.18630000D+01,0.19153000D+01
     .,0.40042090D+03,0.146D+03,0.140D+03,0.18630000D+01,0.19355000D+01
     .,0.40443000D+03,0.146D+03,0.141D+03,0.18630000D+01,0.19545000D+01
     .,0.37755350D+03,0.146D+03,0.142D+03,0.18630000D+01,0.19420000D+01
     .,0.42312790D+03,0.146D+03,0.143D+03,0.18630000D+01,0.16682000D+01
     .,0.32968260D+03,0.146D+03,0.144D+03,0.18630000D+01,0.18584000D+01
     .,0.30870590D+03,0.146D+03,0.145D+03,0.18630000D+01,0.19003000D+01
     .,0.28695190D+03,0.146D+03,0.146D+03,0.18630000D+01,0.18630000D+01
     .,0.27951800D+02,0.147D+03,0.100D+01,0.96790000D+00,0.91180000D+00
     .,0.18773100D+02,0.147D+03,0.200D+01,0.96790000D+00,0.00000000D+00
     .,0.43260780D+03,0.147D+03,0.300D+01,0.96790000D+00,0.00000000D+00
     .,0.24865730D+03,0.147D+03,0.400D+01,0.96790000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  46601:  46700)=(/
     . 0.16783500D+03,0.147D+03,0.500D+01,0.96790000D+00,0.00000000D+00
     .,0.11399930D+03,0.147D+03,0.600D+01,0.96790000D+00,0.00000000D+00
     .,0.80266300D+02,0.147D+03,0.700D+01,0.96790000D+00,0.00000000D+00
     .,0.61174800D+02,0.147D+03,0.800D+01,0.96790000D+00,0.00000000D+00
     .,0.46672600D+02,0.147D+03,0.900D+01,0.96790000D+00,0.00000000D+00
     .,0.36148600D+02,0.147D+03,0.100D+02,0.96790000D+00,0.00000000D+00
     .,0.51756800D+03,0.147D+03,0.110D+02,0.96790000D+00,0.00000000D+00
     .,0.39661250D+03,0.147D+03,0.120D+02,0.96790000D+00,0.00000000D+00
     .,0.36552690D+03,0.147D+03,0.130D+02,0.96790000D+00,0.00000000D+00
     .,0.28828630D+03,0.147D+03,0.140D+02,0.96790000D+00,0.00000000D+00
     .,0.22539450D+03,0.147D+03,0.150D+02,0.96790000D+00,0.00000000D+00
     .,0.18765970D+03,0.147D+03,0.160D+02,0.96790000D+00,0.00000000D+00
     .,0.15390320D+03,0.147D+03,0.170D+02,0.96790000D+00,0.00000000D+00
     .,0.12648250D+03,0.147D+03,0.180D+02,0.96790000D+00,0.00000000D+00
     .,0.85100880D+03,0.147D+03,0.190D+02,0.96790000D+00,0.00000000D+00
     .,0.69886180D+03,0.147D+03,0.200D+02,0.96790000D+00,0.00000000D+00
     .,0.57696360D+03,0.147D+03,0.210D+02,0.96790000D+00,0.00000000D+00
     .,0.55728800D+03,0.147D+03,0.220D+02,0.96790000D+00,0.00000000D+00
     .,0.51036440D+03,0.147D+03,0.230D+02,0.96790000D+00,0.00000000D+00
     .,0.40283830D+03,0.147D+03,0.240D+02,0.96790000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  46701:  46800)=(/
     . 0.43950990D+03,0.147D+03,0.250D+02,0.96790000D+00,0.00000000D+00
     .,0.34569950D+03,0.147D+03,0.260D+02,0.96790000D+00,0.00000000D+00
     .,0.36569250D+03,0.147D+03,0.270D+02,0.96790000D+00,0.00000000D+00
     .,0.37662810D+03,0.147D+03,0.280D+02,0.96790000D+00,0.00000000D+00
     .,0.28955800D+03,0.147D+03,0.290D+02,0.96790000D+00,0.00000000D+00
     .,0.29667280D+03,0.147D+03,0.300D+02,0.96790000D+00,0.00000000D+00
     .,0.35080100D+03,0.147D+03,0.310D+02,0.96790000D+00,0.00000000D+00
     .,0.30945430D+03,0.147D+03,0.320D+02,0.96790000D+00,0.00000000D+00
     .,0.26439570D+03,0.147D+03,0.330D+02,0.96790000D+00,0.00000000D+00
     .,0.23772170D+03,0.147D+03,0.340D+02,0.96790000D+00,0.00000000D+00
     .,0.20860440D+03,0.147D+03,0.350D+02,0.96790000D+00,0.00000000D+00
     .,0.18200160D+03,0.147D+03,0.360D+02,0.96790000D+00,0.00000000D+00
     .,0.95413200D+03,0.147D+03,0.370D+02,0.96790000D+00,0.00000000D+00
     .,0.83331680D+03,0.147D+03,0.380D+02,0.96790000D+00,0.00000000D+00
     .,0.72933160D+03,0.147D+03,0.390D+02,0.96790000D+00,0.00000000D+00
     .,0.65543290D+03,0.147D+03,0.400D+02,0.96790000D+00,0.00000000D+00
     .,0.59785280D+03,0.147D+03,0.410D+02,0.96790000D+00,0.00000000D+00
     .,0.46233830D+03,0.147D+03,0.420D+02,0.96790000D+00,0.00000000D+00
     .,0.51549530D+03,0.147D+03,0.430D+02,0.96790000D+00,0.00000000D+00
     .,0.39350880D+03,0.147D+03,0.440D+02,0.96790000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  46801:  46900)=(/
     . 0.42951430D+03,0.147D+03,0.450D+02,0.96790000D+00,0.00000000D+00
     .,0.39846620D+03,0.147D+03,0.460D+02,0.96790000D+00,0.00000000D+00
     .,0.33315830D+03,0.147D+03,0.470D+02,0.96790000D+00,0.00000000D+00
     .,0.35137120D+03,0.147D+03,0.480D+02,0.96790000D+00,0.00000000D+00
     .,0.44027330D+03,0.147D+03,0.490D+02,0.96790000D+00,0.00000000D+00
     .,0.40690290D+03,0.147D+03,0.500D+02,0.96790000D+00,0.00000000D+00
     .,0.36287400D+03,0.147D+03,0.510D+02,0.96790000D+00,0.00000000D+00
     .,0.33701310D+03,0.147D+03,0.520D+02,0.96790000D+00,0.00000000D+00
     .,0.30521220D+03,0.147D+03,0.530D+02,0.96790000D+00,0.00000000D+00
     .,0.27497440D+03,0.147D+03,0.540D+02,0.96790000D+00,0.00000000D+00
     .,0.11625520D+04,0.147D+03,0.550D+02,0.96790000D+00,0.00000000D+00
     .,0.10633544D+04,0.147D+03,0.560D+02,0.96790000D+00,0.00000000D+00
     .,0.93316800D+03,0.147D+03,0.570D+02,0.96790000D+00,0.00000000D+00
     .,0.42899800D+03,0.147D+03,0.580D+02,0.96790000D+00,0.27991000D+01
     .,0.94235470D+03,0.147D+03,0.590D+02,0.96790000D+00,0.00000000D+00
     .,0.90466880D+03,0.147D+03,0.600D+02,0.96790000D+00,0.00000000D+00
     .,0.88190710D+03,0.147D+03,0.610D+02,0.96790000D+00,0.00000000D+00
     .,0.86096980D+03,0.147D+03,0.620D+02,0.96790000D+00,0.00000000D+00
     .,0.84239660D+03,0.147D+03,0.630D+02,0.96790000D+00,0.00000000D+00
     .,0.66260290D+03,0.147D+03,0.640D+02,0.96790000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  46901:  47000)=(/
     . 0.74772470D+03,0.147D+03,0.650D+02,0.96790000D+00,0.00000000D+00
     .,0.72101030D+03,0.147D+03,0.660D+02,0.96790000D+00,0.00000000D+00
     .,0.75950840D+03,0.147D+03,0.670D+02,0.96790000D+00,0.00000000D+00
     .,0.74332210D+03,0.147D+03,0.680D+02,0.96790000D+00,0.00000000D+00
     .,0.72872030D+03,0.147D+03,0.690D+02,0.96790000D+00,0.00000000D+00
     .,0.72016540D+03,0.147D+03,0.700D+02,0.96790000D+00,0.00000000D+00
     .,0.60683130D+03,0.147D+03,0.710D+02,0.96790000D+00,0.00000000D+00
     .,0.59598520D+03,0.147D+03,0.720D+02,0.96790000D+00,0.00000000D+00
     .,0.54409850D+03,0.147D+03,0.730D+02,0.96790000D+00,0.00000000D+00
     .,0.46026700D+03,0.147D+03,0.740D+02,0.96790000D+00,0.00000000D+00
     .,0.46810840D+03,0.147D+03,0.750D+02,0.96790000D+00,0.00000000D+00
     .,0.42458230D+03,0.147D+03,0.760D+02,0.96790000D+00,0.00000000D+00
     .,0.38918700D+03,0.147D+03,0.770D+02,0.96790000D+00,0.00000000D+00
     .,0.32412400D+03,0.147D+03,0.780D+02,0.96790000D+00,0.00000000D+00
     .,0.30315550D+03,0.147D+03,0.790D+02,0.96790000D+00,0.00000000D+00
     .,0.31163540D+03,0.147D+03,0.800D+02,0.96790000D+00,0.00000000D+00
     .,0.45304550D+03,0.147D+03,0.810D+02,0.96790000D+00,0.00000000D+00
     .,0.44250950D+03,0.147D+03,0.820D+02,0.96790000D+00,0.00000000D+00
     .,0.40670840D+03,0.147D+03,0.830D+02,0.96790000D+00,0.00000000D+00
     .,0.38810010D+03,0.147D+03,0.840D+02,0.96790000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  47001:  47100)=(/
     . 0.35859540D+03,0.147D+03,0.850D+02,0.96790000D+00,0.00000000D+00
     .,0.32919900D+03,0.147D+03,0.860D+02,0.96790000D+00,0.00000000D+00
     .,0.10968369D+04,0.147D+03,0.870D+02,0.96790000D+00,0.00000000D+00
     .,0.10511515D+04,0.147D+03,0.880D+02,0.96790000D+00,0.00000000D+00
     .,0.92833020D+03,0.147D+03,0.890D+02,0.96790000D+00,0.00000000D+00
     .,0.83431790D+03,0.147D+03,0.900D+02,0.96790000D+00,0.00000000D+00
     .,0.82919230D+03,0.147D+03,0.910D+02,0.96790000D+00,0.00000000D+00
     .,0.80298090D+03,0.147D+03,0.920D+02,0.96790000D+00,0.00000000D+00
     .,0.82716130D+03,0.147D+03,0.930D+02,0.96790000D+00,0.00000000D+00
     .,0.80093320D+03,0.147D+03,0.940D+02,0.96790000D+00,0.00000000D+00
     .,0.44783500D+02,0.147D+03,0.101D+03,0.96790000D+00,0.00000000D+00
     .,0.14465630D+03,0.147D+03,0.103D+03,0.96790000D+00,0.98650000D+00
     .,0.18465300D+03,0.147D+03,0.104D+03,0.96790000D+00,0.98080000D+00
     .,0.14140600D+03,0.147D+03,0.105D+03,0.96790000D+00,0.97060000D+00
     .,0.10702860D+03,0.147D+03,0.106D+03,0.96790000D+00,0.98680000D+00
     .,0.74935400D+02,0.147D+03,0.107D+03,0.96790000D+00,0.99440000D+00
     .,0.54985600D+02,0.147D+03,0.108D+03,0.96790000D+00,0.99250000D+00
     .,0.38253900D+02,0.147D+03,0.109D+03,0.96790000D+00,0.99820000D+00
     .,0.21184190D+03,0.147D+03,0.111D+03,0.96790000D+00,0.96840000D+00
     .,0.32735090D+03,0.147D+03,0.112D+03,0.96790000D+00,0.96280000D+00
     ./)
      grimme_c6_parameters(  47101:  47200)=(/
     . 0.33138320D+03,0.147D+03,0.113D+03,0.96790000D+00,0.96480000D+00
     .,0.26660080D+03,0.147D+03,0.114D+03,0.96790000D+00,0.95070000D+00
     .,0.21886170D+03,0.147D+03,0.115D+03,0.96790000D+00,0.99470000D+00
     .,0.18561970D+03,0.147D+03,0.116D+03,0.96790000D+00,0.99480000D+00
     .,0.15232700D+03,0.147D+03,0.117D+03,0.96790000D+00,0.99720000D+00
     .,0.29329110D+03,0.147D+03,0.119D+03,0.96790000D+00,0.97670000D+00
     .,0.56012980D+03,0.147D+03,0.120D+03,0.96790000D+00,0.98310000D+00
     .,0.29290630D+03,0.147D+03,0.121D+03,0.96790000D+00,0.18627000D+01
     .,0.28293320D+03,0.147D+03,0.122D+03,0.96790000D+00,0.18299000D+01
     .,0.27735250D+03,0.147D+03,0.123D+03,0.96790000D+00,0.19138000D+01
     .,0.27484520D+03,0.147D+03,0.124D+03,0.96790000D+00,0.18269000D+01
     .,0.25282980D+03,0.147D+03,0.125D+03,0.96790000D+00,0.16406000D+01
     .,0.23415110D+03,0.147D+03,0.126D+03,0.96790000D+00,0.16483000D+01
     .,0.22348050D+03,0.147D+03,0.127D+03,0.96790000D+00,0.17149000D+01
     .,0.21850750D+03,0.147D+03,0.128D+03,0.96790000D+00,0.17937000D+01
     .,0.21595810D+03,0.147D+03,0.129D+03,0.96790000D+00,0.95760000D+00
     .,0.20256850D+03,0.147D+03,0.130D+03,0.96790000D+00,0.19419000D+01
     .,0.32953870D+03,0.147D+03,0.131D+03,0.96790000D+00,0.96010000D+00
     .,0.28964110D+03,0.147D+03,0.132D+03,0.96790000D+00,0.94340000D+00
     .,0.25997060D+03,0.147D+03,0.133D+03,0.96790000D+00,0.98890000D+00
     ./)
      grimme_c6_parameters(  47201:  47300)=(/
     . 0.23782380D+03,0.147D+03,0.134D+03,0.96790000D+00,0.99010000D+00
     .,0.21004110D+03,0.147D+03,0.135D+03,0.96790000D+00,0.99740000D+00
     .,0.35022950D+03,0.147D+03,0.137D+03,0.96790000D+00,0.97380000D+00
     .,0.68218170D+03,0.147D+03,0.138D+03,0.96790000D+00,0.98010000D+00
     .,0.52087240D+03,0.147D+03,0.139D+03,0.96790000D+00,0.19153000D+01
     .,0.38773360D+03,0.147D+03,0.140D+03,0.96790000D+00,0.19355000D+01
     .,0.39166370D+03,0.147D+03,0.141D+03,0.96790000D+00,0.19545000D+01
     .,0.36552610D+03,0.147D+03,0.142D+03,0.96790000D+00,0.19420000D+01
     .,0.41006670D+03,0.147D+03,0.143D+03,0.96790000D+00,0.16682000D+01
     .,0.31896650D+03,0.147D+03,0.144D+03,0.96790000D+00,0.18584000D+01
     .,0.29866780D+03,0.147D+03,0.145D+03,0.96790000D+00,0.19003000D+01
     .,0.27760230D+03,0.147D+03,0.146D+03,0.96790000D+00,0.18630000D+01
     .,0.26861300D+03,0.147D+03,0.147D+03,0.96790000D+00,0.96790000D+00
     .,0.27928100D+02,0.148D+03,0.100D+01,0.19539000D+01,0.91180000D+00
     .,0.18860700D+02,0.148D+03,0.200D+01,0.19539000D+01,0.00000000D+00
     .,0.40844290D+03,0.148D+03,0.300D+01,0.19539000D+01,0.00000000D+00
     .,0.24209500D+03,0.148D+03,0.400D+01,0.19539000D+01,0.00000000D+00
     .,0.16565870D+03,0.148D+03,0.500D+01,0.19539000D+01,0.00000000D+00
     .,0.11343690D+03,0.148D+03,0.600D+01,0.19539000D+01,0.00000000D+00
     .,0.80249200D+02,0.148D+03,0.700D+01,0.19539000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  47301:  47400)=(/
     . 0.61323400D+02,0.148D+03,0.800D+01,0.19539000D+01,0.00000000D+00
     .,0.46869200D+02,0.148D+03,0.900D+01,0.19539000D+01,0.00000000D+00
     .,0.36340100D+02,0.148D+03,0.100D+02,0.19539000D+01,0.00000000D+00
     .,0.48951290D+03,0.148D+03,0.110D+02,0.19539000D+01,0.00000000D+00
     .,0.38417280D+03,0.148D+03,0.120D+02,0.19539000D+01,0.00000000D+00
     .,0.35686540D+03,0.148D+03,0.130D+02,0.19539000D+01,0.00000000D+00
     .,0.28421390D+03,0.148D+03,0.140D+02,0.19539000D+01,0.00000000D+00
     .,0.22377830D+03,0.148D+03,0.150D+02,0.19539000D+01,0.00000000D+00
     .,0.18701630D+03,0.148D+03,0.160D+02,0.19539000D+01,0.00000000D+00
     .,0.15385920D+03,0.148D+03,0.170D+02,0.19539000D+01,0.00000000D+00
     .,0.12673560D+03,0.148D+03,0.180D+02,0.19539000D+01,0.00000000D+00
     .,0.80025930D+03,0.148D+03,0.190D+02,0.19539000D+01,0.00000000D+00
     .,0.67026330D+03,0.148D+03,0.200D+02,0.19539000D+01,0.00000000D+00
     .,0.55566790D+03,0.148D+03,0.210D+02,0.19539000D+01,0.00000000D+00
     .,0.53855020D+03,0.148D+03,0.220D+02,0.19539000D+01,0.00000000D+00
     .,0.49422370D+03,0.148D+03,0.230D+02,0.19539000D+01,0.00000000D+00
     .,0.38999530D+03,0.148D+03,0.240D+02,0.19539000D+01,0.00000000D+00
     .,0.42685790D+03,0.148D+03,0.250D+02,0.19539000D+01,0.00000000D+00
     .,0.33576420D+03,0.148D+03,0.260D+02,0.19539000D+01,0.00000000D+00
     .,0.35691720D+03,0.148D+03,0.270D+02,0.19539000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  47401:  47500)=(/
     . 0.36686680D+03,0.148D+03,0.280D+02,0.19539000D+01,0.00000000D+00
     .,0.28186750D+03,0.148D+03,0.290D+02,0.19539000D+01,0.00000000D+00
     .,0.29078950D+03,0.148D+03,0.300D+02,0.19539000D+01,0.00000000D+00
     .,0.34329430D+03,0.148D+03,0.310D+02,0.19539000D+01,0.00000000D+00
     .,0.30514680D+03,0.148D+03,0.320D+02,0.19539000D+01,0.00000000D+00
     .,0.26228400D+03,0.148D+03,0.330D+02,0.19539000D+01,0.00000000D+00
     .,0.23657790D+03,0.148D+03,0.340D+02,0.19539000D+01,0.00000000D+00
     .,0.20821130D+03,0.148D+03,0.350D+02,0.19539000D+01,0.00000000D+00
     .,0.18208670D+03,0.148D+03,0.360D+02,0.19539000D+01,0.00000000D+00
     .,0.89853420D+03,0.148D+03,0.370D+02,0.19539000D+01,0.00000000D+00
     .,0.79845280D+03,0.148D+03,0.380D+02,0.19539000D+01,0.00000000D+00
     .,0.70379920D+03,0.148D+03,0.390D+02,0.19539000D+01,0.00000000D+00
     .,0.63513700D+03,0.148D+03,0.400D+02,0.19539000D+01,0.00000000D+00
     .,0.58084120D+03,0.148D+03,0.410D+02,0.19539000D+01,0.00000000D+00
     .,0.45097760D+03,0.148D+03,0.420D+02,0.19539000D+01,0.00000000D+00
     .,0.50211680D+03,0.148D+03,0.430D+02,0.19539000D+01,0.00000000D+00
     .,0.38494360D+03,0.148D+03,0.440D+02,0.19539000D+01,0.00000000D+00
     .,0.42037460D+03,0.148D+03,0.450D+02,0.19539000D+01,0.00000000D+00
     .,0.39057700D+03,0.148D+03,0.460D+02,0.19539000D+01,0.00000000D+00
     .,0.32596620D+03,0.148D+03,0.470D+02,0.19539000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  47501:  47600)=(/
     . 0.34505990D+03,0.148D+03,0.480D+02,0.19539000D+01,0.00000000D+00
     .,0.43036070D+03,0.148D+03,0.490D+02,0.19539000D+01,0.00000000D+00
     .,0.40034740D+03,0.148D+03,0.500D+02,0.19539000D+01,0.00000000D+00
     .,0.35905550D+03,0.148D+03,0.510D+02,0.19539000D+01,0.00000000D+00
     .,0.33449170D+03,0.148D+03,0.520D+02,0.19539000D+01,0.00000000D+00
     .,0.30384100D+03,0.148D+03,0.530D+02,0.19539000D+01,0.00000000D+00
     .,0.27444070D+03,0.148D+03,0.540D+02,0.19539000D+01,0.00000000D+00
     .,0.10949943D+04,0.148D+03,0.550D+02,0.19539000D+01,0.00000000D+00
     .,0.10161802D+04,0.148D+03,0.560D+02,0.19539000D+01,0.00000000D+00
     .,0.89820920D+03,0.148D+03,0.570D+02,0.19539000D+01,0.00000000D+00
     .,0.42389100D+03,0.148D+03,0.580D+02,0.19539000D+01,0.27991000D+01
     .,0.90262940D+03,0.148D+03,0.590D+02,0.19539000D+01,0.00000000D+00
     .,0.86759380D+03,0.148D+03,0.600D+02,0.19539000D+01,0.00000000D+00
     .,0.84606160D+03,0.148D+03,0.610D+02,0.19539000D+01,0.00000000D+00
     .,0.82622610D+03,0.148D+03,0.620D+02,0.19539000D+01,0.00000000D+00
     .,0.80864130D+03,0.148D+03,0.630D+02,0.19539000D+01,0.00000000D+00
     .,0.64073930D+03,0.148D+03,0.640D+02,0.19539000D+01,0.00000000D+00
     .,0.71462060D+03,0.148D+03,0.650D+02,0.19539000D+01,0.00000000D+00
     .,0.69004230D+03,0.148D+03,0.660D+02,0.19539000D+01,0.00000000D+00
     .,0.73042860D+03,0.148D+03,0.670D+02,0.19539000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  47601:  47700)=(/
     . 0.71501980D+03,0.148D+03,0.680D+02,0.19539000D+01,0.00000000D+00
     .,0.70118290D+03,0.148D+03,0.690D+02,0.19539000D+01,0.00000000D+00
     .,0.69275040D+03,0.148D+03,0.700D+02,0.19539000D+01,0.00000000D+00
     .,0.58668300D+03,0.148D+03,0.710D+02,0.19539000D+01,0.00000000D+00
     .,0.58027960D+03,0.148D+03,0.720D+02,0.19539000D+01,0.00000000D+00
     .,0.53179240D+03,0.148D+03,0.730D+02,0.19539000D+01,0.00000000D+00
     .,0.45093600D+03,0.148D+03,0.740D+02,0.19539000D+01,0.00000000D+00
     .,0.45935930D+03,0.148D+03,0.750D+02,0.19539000D+01,0.00000000D+00
     .,0.41790820D+03,0.148D+03,0.760D+02,0.19539000D+01,0.00000000D+00
     .,0.38396000D+03,0.148D+03,0.770D+02,0.19539000D+01,0.00000000D+00
     .,0.32036400D+03,0.148D+03,0.780D+02,0.19539000D+01,0.00000000D+00
     .,0.29986260D+03,0.148D+03,0.790D+02,0.19539000D+01,0.00000000D+00
     .,0.30870590D+03,0.148D+03,0.800D+02,0.19539000D+01,0.00000000D+00
     .,0.44321180D+03,0.148D+03,0.810D+02,0.19539000D+01,0.00000000D+00
     .,0.43519640D+03,0.148D+03,0.820D+02,0.19539000D+01,0.00000000D+00
     .,0.40209000D+03,0.148D+03,0.830D+02,0.19539000D+01,0.00000000D+00
     .,0.38476220D+03,0.148D+03,0.840D+02,0.19539000D+01,0.00000000D+00
     .,0.35659780D+03,0.148D+03,0.850D+02,0.19539000D+01,0.00000000D+00
     .,0.32818400D+03,0.148D+03,0.860D+02,0.19539000D+01,0.00000000D+00
     .,0.10391920D+04,0.148D+03,0.870D+02,0.19539000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  47701:  47800)=(/
     . 0.10081792D+04,0.148D+03,0.880D+02,0.19539000D+01,0.00000000D+00
     .,0.89630090D+03,0.148D+03,0.890D+02,0.19539000D+01,0.00000000D+00
     .,0.81114820D+03,0.148D+03,0.900D+02,0.19539000D+01,0.00000000D+00
     .,0.80315200D+03,0.148D+03,0.910D+02,0.19539000D+01,0.00000000D+00
     .,0.77787630D+03,0.148D+03,0.920D+02,0.19539000D+01,0.00000000D+00
     .,0.79775990D+03,0.148D+03,0.930D+02,0.19539000D+01,0.00000000D+00
     .,0.77311930D+03,0.148D+03,0.940D+02,0.19539000D+01,0.00000000D+00
     .,0.44500600D+02,0.148D+03,0.101D+03,0.19539000D+01,0.00000000D+00
     .,0.14109010D+03,0.148D+03,0.103D+03,0.19539000D+01,0.98650000D+00
     .,0.18052070D+03,0.148D+03,0.104D+03,0.19539000D+01,0.98080000D+00
     .,0.13987930D+03,0.148D+03,0.105D+03,0.19539000D+01,0.97060000D+00
     .,0.10643320D+03,0.148D+03,0.106D+03,0.19539000D+01,0.98680000D+00
     .,0.74892500D+02,0.148D+03,0.107D+03,0.19539000D+01,0.99440000D+00
     .,0.55139200D+02,0.148D+03,0.108D+03,0.19539000D+01,0.99250000D+00
     .,0.38490600D+02,0.148D+03,0.109D+03,0.19539000D+01,0.99820000D+00
     .,0.20596470D+03,0.148D+03,0.111D+03,0.19539000D+01,0.96840000D+00
     .,0.31790020D+03,0.148D+03,0.112D+03,0.19539000D+01,0.96280000D+00
     .,0.32408300D+03,0.148D+03,0.113D+03,0.19539000D+01,0.96480000D+00
     .,0.26314380D+03,0.148D+03,0.114D+03,0.19539000D+01,0.95070000D+00
     .,0.21731990D+03,0.148D+03,0.115D+03,0.19539000D+01,0.99470000D+00
     ./)
      grimme_c6_parameters(  47801:  47900)=(/
     . 0.18495220D+03,0.148D+03,0.116D+03,0.19539000D+01,0.99480000D+00
     .,0.15226460D+03,0.148D+03,0.117D+03,0.19539000D+01,0.99720000D+00
     .,0.28627350D+03,0.148D+03,0.119D+03,0.19539000D+01,0.97670000D+00
     .,0.53708890D+03,0.148D+03,0.120D+03,0.19539000D+01,0.98310000D+00
     .,0.28838750D+03,0.148D+03,0.121D+03,0.19539000D+01,0.18627000D+01
     .,0.27858690D+03,0.148D+03,0.122D+03,0.19539000D+01,0.18299000D+01
     .,0.27303310D+03,0.148D+03,0.123D+03,0.19539000D+01,0.19138000D+01
     .,0.27028900D+03,0.148D+03,0.124D+03,0.19539000D+01,0.18269000D+01
     .,0.24982010D+03,0.148D+03,0.125D+03,0.19539000D+01,0.16406000D+01
     .,0.23161700D+03,0.148D+03,0.126D+03,0.19539000D+01,0.16483000D+01
     .,0.22102480D+03,0.148D+03,0.127D+03,0.19539000D+01,0.17149000D+01
     .,0.21602110D+03,0.148D+03,0.128D+03,0.19539000D+01,0.17937000D+01
     .,0.21274680D+03,0.148D+03,0.129D+03,0.19539000D+01,0.95760000D+00
     .,0.20082240D+03,0.148D+03,0.130D+03,0.19539000D+01,0.19419000D+01
     .,0.32310800D+03,0.148D+03,0.131D+03,0.19539000D+01,0.96010000D+00
     .,0.28605510D+03,0.148D+03,0.132D+03,0.19539000D+01,0.94340000D+00
     .,0.25796890D+03,0.148D+03,0.133D+03,0.19539000D+01,0.98890000D+00
     .,0.23666040D+03,0.148D+03,0.134D+03,0.19539000D+01,0.99010000D+00
     .,0.20960830D+03,0.148D+03,0.135D+03,0.19539000D+01,0.99740000D+00
     .,0.34234100D+03,0.148D+03,0.137D+03,0.19539000D+01,0.97380000D+00
     ./)
      grimme_c6_parameters(  47901:  48000)=(/
     . 0.65327820D+03,0.148D+03,0.138D+03,0.19539000D+01,0.98010000D+00
     .,0.50567470D+03,0.148D+03,0.139D+03,0.19539000D+01,0.19153000D+01
     .,0.38134050D+03,0.148D+03,0.140D+03,0.19539000D+01,0.19355000D+01
     .,0.38512060D+03,0.148D+03,0.141D+03,0.19539000D+01,0.19545000D+01
     .,0.35990590D+03,0.148D+03,0.142D+03,0.19539000D+01,0.19420000D+01
     .,0.40123820D+03,0.148D+03,0.143D+03,0.19539000D+01,0.16682000D+01
     .,0.31533650D+03,0.148D+03,0.144D+03,0.19539000D+01,0.18584000D+01
     .,0.29530360D+03,0.148D+03,0.145D+03,0.19539000D+01,0.19003000D+01
     .,0.27461540D+03,0.148D+03,0.146D+03,0.19539000D+01,0.18630000D+01
     .,0.26554500D+03,0.148D+03,0.147D+03,0.19539000D+01,0.96790000D+00
     .,0.26345080D+03,0.148D+03,0.148D+03,0.19539000D+01,0.19539000D+01
     .,0.42282700D+02,0.149D+03,0.100D+01,0.96330000D+00,0.91180000D+00
     .,0.27023600D+02,0.149D+03,0.200D+01,0.96330000D+00,0.00000000D+00
     .,0.76925140D+03,0.149D+03,0.300D+01,0.96330000D+00,0.00000000D+00
     .,0.41349650D+03,0.149D+03,0.400D+01,0.96330000D+00,0.00000000D+00
     .,0.26747500D+03,0.149D+03,0.500D+01,0.96330000D+00,0.00000000D+00
     .,0.17545850D+03,0.149D+03,0.600D+01,0.96330000D+00,0.00000000D+00
     .,0.12012790D+03,0.149D+03,0.700D+01,0.96330000D+00,0.00000000D+00
     .,0.89652000D+02,0.149D+03,0.800D+01,0.96330000D+00,0.00000000D+00
     .,0.67123200D+02,0.149D+03,0.900D+01,0.96330000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48001:  48100)=(/
     . 0.51174700D+02,0.149D+03,0.100D+02,0.96330000D+00,0.00000000D+00
     .,0.91594130D+03,0.149D+03,0.110D+02,0.96330000D+00,0.00000000D+00
     .,0.66728440D+03,0.149D+03,0.120D+02,0.96330000D+00,0.00000000D+00
     .,0.60241430D+03,0.149D+03,0.130D+02,0.96330000D+00,0.00000000D+00
     .,0.46150930D+03,0.149D+03,0.140D+02,0.96330000D+00,0.00000000D+00
     .,0.35151570D+03,0.149D+03,0.150D+02,0.96330000D+00,0.00000000D+00
     .,0.28739220D+03,0.149D+03,0.160D+02,0.96330000D+00,0.00000000D+00
     .,0.23145540D+03,0.149D+03,0.170D+02,0.96330000D+00,0.00000000D+00
     .,0.18709160D+03,0.149D+03,0.180D+02,0.96330000D+00,0.00000000D+00
     .,0.15173687D+04,0.149D+03,0.190D+02,0.96330000D+00,0.00000000D+00
     .,0.11989287D+04,0.149D+03,0.200D+02,0.96330000D+00,0.00000000D+00
     .,0.98084640D+03,0.149D+03,0.210D+02,0.96330000D+00,0.00000000D+00
     .,0.93876410D+03,0.149D+03,0.220D+02,0.96330000D+00,0.00000000D+00
     .,0.85507440D+03,0.149D+03,0.230D+02,0.96330000D+00,0.00000000D+00
     .,0.67285260D+03,0.149D+03,0.240D+02,0.96330000D+00,0.00000000D+00
     .,0.73052210D+03,0.149D+03,0.250D+02,0.96330000D+00,0.00000000D+00
     .,0.57217290D+03,0.149D+03,0.260D+02,0.96330000D+00,0.00000000D+00
     .,0.59982550D+03,0.149D+03,0.270D+02,0.96330000D+00,0.00000000D+00
     .,0.62133050D+03,0.149D+03,0.280D+02,0.96330000D+00,0.00000000D+00
     .,0.47601650D+03,0.149D+03,0.290D+02,0.96330000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48101:  48200)=(/
     . 0.48059720D+03,0.149D+03,0.300D+02,0.96330000D+00,0.00000000D+00
     .,0.57226580D+03,0.149D+03,0.310D+02,0.96330000D+00,0.00000000D+00
     .,0.49379840D+03,0.149D+03,0.320D+02,0.96330000D+00,0.00000000D+00
     .,0.41301260D+03,0.149D+03,0.330D+02,0.96330000D+00,0.00000000D+00
     .,0.36615190D+03,0.149D+03,0.340D+02,0.96330000D+00,0.00000000D+00
     .,0.31652310D+03,0.149D+03,0.350D+02,0.96330000D+00,0.00000000D+00
     .,0.27222880D+03,0.149D+03,0.360D+02,0.96330000D+00,0.00000000D+00
     .,0.16942091D+04,0.149D+03,0.370D+02,0.96330000D+00,0.00000000D+00
     .,0.14306640D+04,0.149D+03,0.380D+02,0.96330000D+00,0.00000000D+00
     .,0.12316979D+04,0.149D+03,0.390D+02,0.96330000D+00,0.00000000D+00
     .,0.10950419D+04,0.149D+03,0.400D+02,0.96330000D+00,0.00000000D+00
     .,0.99140130D+03,0.149D+03,0.410D+02,0.96330000D+00,0.00000000D+00
     .,0.75589180D+03,0.149D+03,0.420D+02,0.96330000D+00,0.00000000D+00
     .,0.84735570D+03,0.149D+03,0.430D+02,0.96330000D+00,0.00000000D+00
     .,0.63674800D+03,0.149D+03,0.440D+02,0.96330000D+00,0.00000000D+00
     .,0.69613210D+03,0.149D+03,0.450D+02,0.96330000D+00,0.00000000D+00
     .,0.64264560D+03,0.149D+03,0.460D+02,0.96330000D+00,0.00000000D+00
     .,0.53720580D+03,0.149D+03,0.470D+02,0.96330000D+00,0.00000000D+00
     .,0.56303120D+03,0.149D+03,0.480D+02,0.96330000D+00,0.00000000D+00
     .,0.71679570D+03,0.149D+03,0.490D+02,0.96330000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48201:  48300)=(/
     . 0.65114030D+03,0.149D+03,0.500D+02,0.96330000D+00,0.00000000D+00
     .,0.57030150D+03,0.149D+03,0.510D+02,0.96330000D+00,0.00000000D+00
     .,0.52361310D+03,0.149D+03,0.520D+02,0.96330000D+00,0.00000000D+00
     .,0.46816800D+03,0.149D+03,0.530D+02,0.96330000D+00,0.00000000D+00
     .,0.41650530D+03,0.149D+03,0.540D+02,0.96330000D+00,0.00000000D+00
     .,0.20626273D+04,0.149D+03,0.550D+02,0.96330000D+00,0.00000000D+00
     .,0.18342595D+04,0.149D+03,0.560D+02,0.96330000D+00,0.00000000D+00
     .,0.15838792D+04,0.149D+03,0.570D+02,0.96330000D+00,0.00000000D+00
     .,0.67579110D+03,0.149D+03,0.580D+02,0.96330000D+00,0.27991000D+01
     .,0.16159882D+04,0.149D+03,0.590D+02,0.96330000D+00,0.00000000D+00
     .,0.15472492D+04,0.149D+03,0.600D+02,0.96330000D+00,0.00000000D+00
     .,0.15072236D+04,0.149D+03,0.610D+02,0.96330000D+00,0.00000000D+00
     .,0.14705492D+04,0.149D+03,0.620D+02,0.96330000D+00,0.00000000D+00
     .,0.14379844D+04,0.149D+03,0.630D+02,0.96330000D+00,0.00000000D+00
     .,0.11092250D+04,0.149D+03,0.640D+02,0.96330000D+00,0.00000000D+00
     .,0.12845648D+04,0.149D+03,0.650D+02,0.96330000D+00,0.00000000D+00
     .,0.12348582D+04,0.149D+03,0.660D+02,0.96330000D+00,0.00000000D+00
     .,0.12913513D+04,0.149D+03,0.670D+02,0.96330000D+00,0.00000000D+00
     .,0.12633503D+04,0.149D+03,0.680D+02,0.96330000D+00,0.00000000D+00
     .,0.12378116D+04,0.149D+03,0.690D+02,0.96330000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48301:  48400)=(/
     . 0.12243143D+04,0.149D+03,0.700D+02,0.96330000D+00,0.00000000D+00
     .,0.10181407D+04,0.149D+03,0.710D+02,0.96330000D+00,0.00000000D+00
     .,0.98356470D+03,0.149D+03,0.720D+02,0.96330000D+00,0.00000000D+00
     .,0.88792510D+03,0.149D+03,0.730D+02,0.96330000D+00,0.00000000D+00
     .,0.74340350D+03,0.149D+03,0.740D+02,0.96330000D+00,0.00000000D+00
     .,0.75315120D+03,0.149D+03,0.750D+02,0.96330000D+00,0.00000000D+00
     .,0.67623400D+03,0.149D+03,0.760D+02,0.96330000D+00,0.00000000D+00
     .,0.61465820D+03,0.149D+03,0.770D+02,0.96330000D+00,0.00000000D+00
     .,0.50654420D+03,0.149D+03,0.780D+02,0.96330000D+00,0.00000000D+00
     .,0.47177480D+03,0.149D+03,0.790D+02,0.96330000D+00,0.00000000D+00
     .,0.48363130D+03,0.149D+03,0.800D+02,0.96330000D+00,0.00000000D+00
     .,0.73258080D+03,0.149D+03,0.810D+02,0.96330000D+00,0.00000000D+00
     .,0.70644460D+03,0.149D+03,0.820D+02,0.96330000D+00,0.00000000D+00
     .,0.63913150D+03,0.149D+03,0.830D+02,0.96330000D+00,0.00000000D+00
     .,0.60410820D+03,0.149D+03,0.840D+02,0.96330000D+00,0.00000000D+00
     .,0.55158440D+03,0.149D+03,0.850D+02,0.96330000D+00,0.00000000D+00
     .,0.50067860D+03,0.149D+03,0.860D+02,0.96330000D+00,0.00000000D+00
     .,0.19210063D+04,0.149D+03,0.870D+02,0.96330000D+00,0.00000000D+00
     .,0.17975569D+04,0.149D+03,0.880D+02,0.96330000D+00,0.00000000D+00
     .,0.15637265D+04,0.149D+03,0.890D+02,0.96330000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48401:  48500)=(/
     . 0.13796361D+04,0.149D+03,0.900D+02,0.96330000D+00,0.00000000D+00
     .,0.13822903D+04,0.149D+03,0.910D+02,0.96330000D+00,0.00000000D+00
     .,0.13377839D+04,0.149D+03,0.920D+02,0.96330000D+00,0.00000000D+00
     .,0.13931101D+04,0.149D+03,0.930D+02,0.96330000D+00,0.00000000D+00
     .,0.13462697D+04,0.149D+03,0.940D+02,0.96330000D+00,0.00000000D+00
     .,0.69675400D+02,0.149D+03,0.101D+03,0.96330000D+00,0.00000000D+00
     .,0.23904190D+03,0.149D+03,0.103D+03,0.96330000D+00,0.98650000D+00
     .,0.30266780D+03,0.149D+03,0.104D+03,0.96330000D+00,0.98080000D+00
     .,0.22316290D+03,0.149D+03,0.105D+03,0.96330000D+00,0.97060000D+00
     .,0.16468120D+03,0.149D+03,0.106D+03,0.96330000D+00,0.98680000D+00
     .,0.11197070D+03,0.149D+03,0.107D+03,0.96330000D+00,0.99440000D+00
     .,0.80098600D+02,0.149D+03,0.108D+03,0.96330000D+00,0.99250000D+00
     .,0.53936400D+02,0.149D+03,0.109D+03,0.96330000D+00,0.99820000D+00
     .,0.35200740D+03,0.149D+03,0.111D+03,0.96330000D+00,0.96840000D+00
     .,0.54627620D+03,0.149D+03,0.112D+03,0.96330000D+00,0.96280000D+00
     .,0.54321880D+03,0.149D+03,0.113D+03,0.96330000D+00,0.96480000D+00
     .,0.42482930D+03,0.149D+03,0.114D+03,0.96330000D+00,0.95070000D+00
     .,0.34093960D+03,0.149D+03,0.115D+03,0.96330000D+00,0.99470000D+00
     .,0.28433500D+03,0.149D+03,0.116D+03,0.96330000D+00,0.99480000D+00
     .,0.22912290D+03,0.149D+03,0.117D+03,0.96330000D+00,0.99720000D+00
     ./)
      grimme_c6_parameters(  48501:  48600)=(/
     . 0.47801410D+03,0.149D+03,0.119D+03,0.96330000D+00,0.97670000D+00
     .,0.95798970D+03,0.149D+03,0.120D+03,0.96330000D+00,0.98310000D+00
     .,0.46767000D+03,0.149D+03,0.121D+03,0.96330000D+00,0.18627000D+01
     .,0.45116580D+03,0.149D+03,0.122D+03,0.96330000D+00,0.18299000D+01
     .,0.44234200D+03,0.149D+03,0.123D+03,0.96330000D+00,0.19138000D+01
     .,0.43947280D+03,0.149D+03,0.124D+03,0.96330000D+00,0.18269000D+01
     .,0.39910790D+03,0.149D+03,0.125D+03,0.96330000D+00,0.16406000D+01
     .,0.36795920D+03,0.149D+03,0.126D+03,0.96330000D+00,0.16483000D+01
     .,0.35103000D+03,0.149D+03,0.127D+03,0.96330000D+00,0.17149000D+01
     .,0.34356200D+03,0.149D+03,0.128D+03,0.96330000D+00,0.17937000D+01
     .,0.34289310D+03,0.149D+03,0.129D+03,0.96330000D+00,0.95760000D+00
     .,0.31591660D+03,0.149D+03,0.130D+03,0.96330000D+00,0.19419000D+01
     .,0.53451270D+03,0.149D+03,0.131D+03,0.96330000D+00,0.96010000D+00
     .,0.45962850D+03,0.149D+03,0.132D+03,0.96330000D+00,0.94340000D+00
     .,0.40554530D+03,0.149D+03,0.133D+03,0.96330000D+00,0.98890000D+00
     .,0.36636520D+03,0.149D+03,0.134D+03,0.96330000D+00,0.99010000D+00
     .,0.31893050D+03,0.149D+03,0.135D+03,0.96330000D+00,0.99740000D+00
     .,0.56760020D+03,0.149D+03,0.137D+03,0.96330000D+00,0.97380000D+00
     .,0.11685036D+04,0.149D+03,0.138D+03,0.96330000D+00,0.98010000D+00
     .,0.86288330D+03,0.149D+03,0.139D+03,0.96330000D+00,0.19153000D+01
     ./)
      grimme_c6_parameters(  48601:  48700)=(/
     . 0.61965370D+03,0.149D+03,0.140D+03,0.96330000D+00,0.19355000D+01
     .,0.62602540D+03,0.149D+03,0.141D+03,0.96330000D+00,0.19545000D+01
     .,0.58105490D+03,0.149D+03,0.142D+03,0.96330000D+00,0.19420000D+01
     .,0.66303800D+03,0.149D+03,0.143D+03,0.96330000D+00,0.16682000D+01
     .,0.50016280D+03,0.149D+03,0.144D+03,0.96330000D+00,0.18584000D+01
     .,0.46737710D+03,0.149D+03,0.145D+03,0.96330000D+00,0.19003000D+01
     .,0.43299730D+03,0.149D+03,0.146D+03,0.96330000D+00,0.18630000D+01
     .,0.41968680D+03,0.149D+03,0.147D+03,0.96330000D+00,0.96790000D+00
     .,0.41115760D+03,0.149D+03,0.148D+03,0.96330000D+00,0.19539000D+01
     .,0.67899200D+03,0.149D+03,0.149D+03,0.96330000D+00,0.96330000D+00
     .,0.39050000D+02,0.150D+03,0.100D+01,0.95140000D+00,0.91180000D+00
     .,0.25410500D+02,0.150D+03,0.200D+01,0.95140000D+00,0.00000000D+00
     .,0.64241900D+03,0.150D+03,0.300D+01,0.95140000D+00,0.00000000D+00
     .,0.36274340D+03,0.150D+03,0.400D+01,0.95140000D+00,0.00000000D+00
     .,0.24059340D+03,0.150D+03,0.500D+01,0.95140000D+00,0.00000000D+00
     .,0.16058760D+03,0.150D+03,0.600D+01,0.95140000D+00,0.00000000D+00
     .,0.11127680D+03,0.150D+03,0.700D+01,0.95140000D+00,0.00000000D+00
     .,0.83712000D+02,0.150D+03,0.800D+01,0.95140000D+00,0.00000000D+00
     .,0.63080600D+02,0.150D+03,0.900D+01,0.95140000D+00,0.00000000D+00
     .,0.48325800D+02,0.150D+03,0.100D+02,0.95140000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48701:  48800)=(/
     . 0.76709550D+03,0.150D+03,0.110D+02,0.95140000D+00,0.00000000D+00
     .,0.58045000D+03,0.150D+03,0.120D+02,0.95140000D+00,0.00000000D+00
     .,0.53107940D+03,0.150D+03,0.130D+02,0.95140000D+00,0.00000000D+00
     .,0.41414030D+03,0.150D+03,0.140D+02,0.95140000D+00,0.00000000D+00
     .,0.31993070D+03,0.150D+03,0.150D+02,0.95140000D+00,0.00000000D+00
     .,0.26382770D+03,0.150D+03,0.160D+02,0.95140000D+00,0.00000000D+00
     .,0.21417230D+03,0.150D+03,0.170D+02,0.95140000D+00,0.00000000D+00
     .,0.17426390D+03,0.150D+03,0.180D+02,0.95140000D+00,0.00000000D+00
     .,0.12595964D+04,0.150D+03,0.190D+02,0.95140000D+00,0.00000000D+00
     .,0.10266097D+04,0.150D+03,0.200D+02,0.95140000D+00,0.00000000D+00
     .,0.84554470D+03,0.150D+03,0.210D+02,0.95140000D+00,0.00000000D+00
     .,0.81389640D+03,0.150D+03,0.220D+02,0.95140000D+00,0.00000000D+00
     .,0.74392530D+03,0.150D+03,0.230D+02,0.95140000D+00,0.00000000D+00
     .,0.58540690D+03,0.150D+03,0.240D+02,0.95140000D+00,0.00000000D+00
     .,0.63875870D+03,0.150D+03,0.250D+02,0.95140000D+00,0.00000000D+00
     .,0.50063040D+03,0.150D+03,0.260D+02,0.95140000D+00,0.00000000D+00
     .,0.52899650D+03,0.150D+03,0.270D+02,0.95140000D+00,0.00000000D+00
     .,0.54604730D+03,0.150D+03,0.280D+02,0.95140000D+00,0.00000000D+00
     .,0.41817300D+03,0.150D+03,0.290D+02,0.95140000D+00,0.00000000D+00
     .,0.42710250D+03,0.150D+03,0.300D+02,0.95140000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48801:  48900)=(/
     . 0.50688380D+03,0.150D+03,0.310D+02,0.95140000D+00,0.00000000D+00
     .,0.44348920D+03,0.150D+03,0.320D+02,0.95140000D+00,0.00000000D+00
     .,0.37536940D+03,0.150D+03,0.330D+02,0.95140000D+00,0.00000000D+00
     .,0.33511820D+03,0.150D+03,0.340D+02,0.95140000D+00,0.00000000D+00
     .,0.29171790D+03,0.150D+03,0.350D+02,0.95140000D+00,0.00000000D+00
     .,0.25244080D+03,0.150D+03,0.360D+02,0.95140000D+00,0.00000000D+00
     .,0.14095386D+04,0.150D+03,0.370D+02,0.95140000D+00,0.00000000D+00
     .,0.12233073D+04,0.150D+03,0.380D+02,0.95140000D+00,0.00000000D+00
     .,0.10654342D+04,0.150D+03,0.390D+02,0.95140000D+00,0.00000000D+00
     .,0.95393220D+03,0.150D+03,0.400D+02,0.95140000D+00,0.00000000D+00
     .,0.86754750D+03,0.150D+03,0.410D+02,0.95140000D+00,0.00000000D+00
     .,0.66641970D+03,0.150D+03,0.420D+02,0.95140000D+00,0.00000000D+00
     .,0.74499930D+03,0.150D+03,0.430D+02,0.95140000D+00,0.00000000D+00
     .,0.56445890D+03,0.150D+03,0.440D+02,0.95140000D+00,0.00000000D+00
     .,0.61737910D+03,0.150D+03,0.450D+02,0.95140000D+00,0.00000000D+00
     .,0.57156020D+03,0.150D+03,0.460D+02,0.95140000D+00,0.00000000D+00
     .,0.47659660D+03,0.150D+03,0.470D+02,0.95140000D+00,0.00000000D+00
     .,0.50255130D+03,0.150D+03,0.480D+02,0.95140000D+00,0.00000000D+00
     .,0.63411950D+03,0.150D+03,0.490D+02,0.95140000D+00,0.00000000D+00
     .,0.58276930D+03,0.150D+03,0.500D+02,0.95140000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  48901:  49000)=(/
     . 0.51594670D+03,0.150D+03,0.510D+02,0.95140000D+00,0.00000000D+00
     .,0.47668110D+03,0.150D+03,0.520D+02,0.95140000D+00,0.00000000D+00
     .,0.42899630D+03,0.150D+03,0.530D+02,0.95140000D+00,0.00000000D+00
     .,0.38394570D+03,0.150D+03,0.540D+02,0.95140000D+00,0.00000000D+00
     .,0.17161526D+04,0.150D+03,0.550D+02,0.95140000D+00,0.00000000D+00
     .,0.15618289D+04,0.150D+03,0.560D+02,0.95140000D+00,0.00000000D+00
     .,0.13644290D+04,0.150D+03,0.570D+02,0.95140000D+00,0.00000000D+00
     .,0.61000420D+03,0.150D+03,0.580D+02,0.95140000D+00,0.27991000D+01
     .,0.13811677D+04,0.150D+03,0.590D+02,0.95140000D+00,0.00000000D+00
     .,0.13251151D+04,0.150D+03,0.600D+02,0.95140000D+00,0.00000000D+00
     .,0.12915707D+04,0.150D+03,0.610D+02,0.95140000D+00,0.00000000D+00
     .,0.12607608D+04,0.150D+03,0.620D+02,0.95140000D+00,0.00000000D+00
     .,0.12334280D+04,0.150D+03,0.630D+02,0.95140000D+00,0.00000000D+00
     .,0.96322340D+03,0.150D+03,0.640D+02,0.95140000D+00,0.00000000D+00
     .,0.10940703D+04,0.150D+03,0.650D+02,0.95140000D+00,0.00000000D+00
     .,0.10539748D+04,0.150D+03,0.660D+02,0.95140000D+00,0.00000000D+00
     .,0.11110005D+04,0.150D+03,0.670D+02,0.95140000D+00,0.00000000D+00
     .,0.10872901D+04,0.150D+03,0.680D+02,0.95140000D+00,0.00000000D+00
     .,0.10658196D+04,0.150D+03,0.690D+02,0.95140000D+00,0.00000000D+00
     .,0.10536773D+04,0.150D+03,0.700D+02,0.95140000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49001:  49100)=(/
     . 0.88359210D+03,0.150D+03,0.710D+02,0.95140000D+00,0.00000000D+00
     .,0.86380750D+03,0.150D+03,0.720D+02,0.95140000D+00,0.00000000D+00
     .,0.78517710D+03,0.150D+03,0.730D+02,0.95140000D+00,0.00000000D+00
     .,0.66055390D+03,0.150D+03,0.740D+02,0.95140000D+00,0.00000000D+00
     .,0.67110130D+03,0.150D+03,0.750D+02,0.95140000D+00,0.00000000D+00
     .,0.60606460D+03,0.150D+03,0.760D+02,0.95140000D+00,0.00000000D+00
     .,0.55342010D+03,0.150D+03,0.770D+02,0.95140000D+00,0.00000000D+00
     .,0.45807960D+03,0.150D+03,0.780D+02,0.95140000D+00,0.00000000D+00
     .,0.42739480D+03,0.150D+03,0.790D+02,0.95140000D+00,0.00000000D+00
     .,0.43923750D+03,0.150D+03,0.800D+02,0.95140000D+00,0.00000000D+00
     .,0.64947520D+03,0.150D+03,0.810D+02,0.95140000D+00,0.00000000D+00
     .,0.63216060D+03,0.150D+03,0.820D+02,0.95140000D+00,0.00000000D+00
     .,0.57757500D+03,0.150D+03,0.830D+02,0.95140000D+00,0.00000000D+00
     .,0.54893280D+03,0.150D+03,0.840D+02,0.95140000D+00,0.00000000D+00
     .,0.50441400D+03,0.150D+03,0.850D+02,0.95140000D+00,0.00000000D+00
     .,0.46043530D+03,0.150D+03,0.860D+02,0.95140000D+00,0.00000000D+00
     .,0.16132050D+04,0.150D+03,0.870D+02,0.95140000D+00,0.00000000D+00
     .,0.15396549D+04,0.150D+03,0.880D+02,0.95140000D+00,0.00000000D+00
     .,0.13539743D+04,0.150D+03,0.890D+02,0.95140000D+00,0.00000000D+00
     .,0.12088936D+04,0.150D+03,0.900D+02,0.95140000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49101:  49200)=(/
     . 0.12037043D+04,0.150D+03,0.910D+02,0.95140000D+00,0.00000000D+00
     .,0.11652987D+04,0.150D+03,0.920D+02,0.95140000D+00,0.00000000D+00
     .,0.12045686D+04,0.150D+03,0.930D+02,0.95140000D+00,0.00000000D+00
     .,0.11657062D+04,0.150D+03,0.940D+02,0.95140000D+00,0.00000000D+00
     .,0.63518900D+02,0.150D+03,0.101D+03,0.95140000D+00,0.00000000D+00
     .,0.21038150D+03,0.150D+03,0.103D+03,0.95140000D+00,0.98650000D+00
     .,0.26750360D+03,0.150D+03,0.104D+03,0.95140000D+00,0.98080000D+00
     .,0.20167580D+03,0.150D+03,0.105D+03,0.95140000D+00,0.97060000D+00
     .,0.15060400D+03,0.150D+03,0.106D+03,0.95140000D+00,0.98680000D+00
     .,0.10370700D+03,0.150D+03,0.107D+03,0.95140000D+00,0.99440000D+00
     .,0.74928900D+02,0.150D+03,0.108D+03,0.95140000D+00,0.99250000D+00
     .,0.51049200D+02,0.150D+03,0.109D+03,0.95140000D+00,0.99820000D+00
     .,0.30824700D+03,0.150D+03,0.111D+03,0.95140000D+00,0.96840000D+00
     .,0.47728480D+03,0.150D+03,0.112D+03,0.95140000D+00,0.96280000D+00
     .,0.48037350D+03,0.150D+03,0.113D+03,0.95140000D+00,0.96480000D+00
     .,0.38212550D+03,0.150D+03,0.114D+03,0.95140000D+00,0.95070000D+00
     .,0.31042380D+03,0.150D+03,0.115D+03,0.95140000D+00,0.99470000D+00
     .,0.26094970D+03,0.150D+03,0.116D+03,0.95140000D+00,0.99480000D+00
     .,0.21197090D+03,0.150D+03,0.117D+03,0.95140000D+00,0.99720000D+00
     .,0.42200550D+03,0.150D+03,0.119D+03,0.95140000D+00,0.97670000D+00
     ./)
      grimme_c6_parameters(  49201:  49300)=(/
     . 0.81999260D+03,0.150D+03,0.120D+03,0.95140000D+00,0.98310000D+00
     .,0.41914320D+03,0.150D+03,0.121D+03,0.95140000D+00,0.18627000D+01
     .,0.40443780D+03,0.150D+03,0.122D+03,0.95140000D+00,0.18299000D+01
     .,0.39640790D+03,0.150D+03,0.123D+03,0.95140000D+00,0.19138000D+01
     .,0.39312150D+03,0.150D+03,0.124D+03,0.95140000D+00,0.18269000D+01
     .,0.36011140D+03,0.150D+03,0.125D+03,0.95140000D+00,0.16406000D+01
     .,0.33275950D+03,0.150D+03,0.126D+03,0.95140000D+00,0.16483000D+01
     .,0.31739780D+03,0.150D+03,0.127D+03,0.95140000D+00,0.17149000D+01
     .,0.31042370D+03,0.150D+03,0.128D+03,0.95140000D+00,0.17937000D+01
     .,0.30781940D+03,0.150D+03,0.129D+03,0.95140000D+00,0.95760000D+00
     .,0.28694640D+03,0.150D+03,0.130D+03,0.95140000D+00,0.19419000D+01
     .,0.47510140D+03,0.150D+03,0.131D+03,0.95140000D+00,0.96010000D+00
     .,0.41406130D+03,0.150D+03,0.132D+03,0.95140000D+00,0.94340000D+00
     .,0.36881960D+03,0.150D+03,0.133D+03,0.95140000D+00,0.98890000D+00
     .,0.33526670D+03,0.150D+03,0.134D+03,0.95140000D+00,0.99010000D+00
     .,0.29382390D+03,0.150D+03,0.135D+03,0.95140000D+00,0.99740000D+00
     .,0.50249860D+03,0.150D+03,0.137D+03,0.95140000D+00,0.97380000D+00
     .,0.99819190D+03,0.150D+03,0.138D+03,0.95140000D+00,0.98010000D+00
     .,0.75411460D+03,0.150D+03,0.139D+03,0.95140000D+00,0.19153000D+01
     .,0.55441070D+03,0.150D+03,0.140D+03,0.95140000D+00,0.19355000D+01
     ./)
      grimme_c6_parameters(  49301:  49400)=(/
     . 0.55998500D+03,0.150D+03,0.141D+03,0.95140000D+00,0.19545000D+01
     .,0.52115630D+03,0.150D+03,0.142D+03,0.95140000D+00,0.19420000D+01
     .,0.58793550D+03,0.150D+03,0.143D+03,0.95140000D+00,0.16682000D+01
     .,0.45216820D+03,0.150D+03,0.144D+03,0.95140000D+00,0.18584000D+01
     .,0.42274380D+03,0.150D+03,0.145D+03,0.95140000D+00,0.19003000D+01
     .,0.39214710D+03,0.150D+03,0.146D+03,0.95140000D+00,0.18630000D+01
     .,0.37963350D+03,0.150D+03,0.147D+03,0.95140000D+00,0.96790000D+00
     .,0.37434300D+03,0.150D+03,0.148D+03,0.95140000D+00,0.19539000D+01
     .,0.60309650D+03,0.150D+03,0.149D+03,0.95140000D+00,0.96330000D+00
     .,0.54204390D+03,0.150D+03,0.150D+03,0.95140000D+00,0.95140000D+00
     .,0.37118600D+02,0.151D+03,0.100D+01,0.97490000D+00,0.91180000D+00
     .,0.24506800D+02,0.151D+03,0.200D+01,0.97490000D+00,0.00000000D+00
     .,0.56950200D+03,0.151D+03,0.300D+01,0.97490000D+00,0.00000000D+00
     .,0.33206650D+03,0.151D+03,0.400D+01,0.97490000D+00,0.00000000D+00
     .,0.22424380D+03,0.151D+03,0.500D+01,0.97490000D+00,0.00000000D+00
     .,0.15163340D+03,0.151D+03,0.600D+01,0.97490000D+00,0.00000000D+00
     .,0.10605380D+03,0.151D+03,0.700D+01,0.97490000D+00,0.00000000D+00
     .,0.80289900D+02,0.151D+03,0.800D+01,0.97490000D+00,0.00000000D+00
     .,0.60817400D+02,0.151D+03,0.900D+01,0.97490000D+00,0.00000000D+00
     .,0.46777500D+02,0.151D+03,0.100D+02,0.97490000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49401:  49500)=(/
     . 0.68136500D+03,0.151D+03,0.110D+02,0.97490000D+00,0.00000000D+00
     .,0.52835450D+03,0.151D+03,0.120D+02,0.97490000D+00,0.00000000D+00
     .,0.48798470D+03,0.151D+03,0.130D+02,0.97490000D+00,0.00000000D+00
     .,0.38531020D+03,0.151D+03,0.140D+02,0.97490000D+00,0.00000000D+00
     .,0.30075580D+03,0.151D+03,0.150D+02,0.97490000D+00,0.00000000D+00
     .,0.24964690D+03,0.151D+03,0.160D+02,0.97490000D+00,0.00000000D+00
     .,0.20391030D+03,0.151D+03,0.170D+02,0.97490000D+00,0.00000000D+00
     .,0.16677960D+03,0.151D+03,0.180D+02,0.97490000D+00,0.00000000D+00
     .,0.11139369D+04,0.151D+03,0.190D+02,0.97490000D+00,0.00000000D+00
     .,0.92532660D+03,0.151D+03,0.200D+02,0.97490000D+00,0.00000000D+00
     .,0.76543030D+03,0.151D+03,0.210D+02,0.97490000D+00,0.00000000D+00
     .,0.73977510D+03,0.151D+03,0.220D+02,0.97490000D+00,0.00000000D+00
     .,0.67780140D+03,0.151D+03,0.230D+02,0.97490000D+00,0.00000000D+00
     .,0.53372530D+03,0.151D+03,0.240D+02,0.97490000D+00,0.00000000D+00
     .,0.58400790D+03,0.151D+03,0.250D+02,0.97490000D+00,0.00000000D+00
     .,0.45821350D+03,0.151D+03,0.260D+02,0.97490000D+00,0.00000000D+00
     .,0.48646450D+03,0.151D+03,0.270D+02,0.97490000D+00,0.00000000D+00
     .,0.50090110D+03,0.151D+03,0.280D+02,0.97490000D+00,0.00000000D+00
     .,0.38380100D+03,0.151D+03,0.290D+02,0.97490000D+00,0.00000000D+00
     .,0.39484340D+03,0.151D+03,0.300D+02,0.97490000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49501:  49600)=(/
     . 0.46751190D+03,0.151D+03,0.310D+02,0.97490000D+00,0.00000000D+00
     .,0.41296610D+03,0.151D+03,0.320D+02,0.97490000D+00,0.00000000D+00
     .,0.35254270D+03,0.151D+03,0.330D+02,0.97490000D+00,0.00000000D+00
     .,0.31639840D+03,0.151D+03,0.340D+02,0.97490000D+00,0.00000000D+00
     .,0.27688560D+03,0.151D+03,0.350D+02,0.97490000D+00,0.00000000D+00
     .,0.24075150D+03,0.151D+03,0.360D+02,0.97490000D+00,0.00000000D+00
     .,0.12488109D+04,0.151D+03,0.370D+02,0.97490000D+00,0.00000000D+00
     .,0.11019644D+04,0.151D+03,0.380D+02,0.97490000D+00,0.00000000D+00
     .,0.96716720D+03,0.151D+03,0.390D+02,0.97490000D+00,0.00000000D+00
     .,0.87013340D+03,0.151D+03,0.400D+02,0.97490000D+00,0.00000000D+00
     .,0.79387710D+03,0.151D+03,0.410D+02,0.97490000D+00,0.00000000D+00
     .,0.61324700D+03,0.151D+03,0.420D+02,0.97490000D+00,0.00000000D+00
     .,0.68412920D+03,0.151D+03,0.430D+02,0.97490000D+00,0.00000000D+00
     .,0.52150710D+03,0.151D+03,0.440D+02,0.97490000D+00,0.00000000D+00
     .,0.57027900D+03,0.151D+03,0.450D+02,0.97490000D+00,0.00000000D+00
     .,0.52899540D+03,0.151D+03,0.460D+02,0.97490000D+00,0.00000000D+00
     .,0.44070410D+03,0.151D+03,0.470D+02,0.97490000D+00,0.00000000D+00
     .,0.46629410D+03,0.151D+03,0.480D+02,0.97490000D+00,0.00000000D+00
     .,0.58471100D+03,0.151D+03,0.490D+02,0.97490000D+00,0.00000000D+00
     .,0.54152090D+03,0.151D+03,0.500D+02,0.97490000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49601:  49700)=(/
     . 0.48305960D+03,0.151D+03,0.510D+02,0.97490000D+00,0.00000000D+00
     .,0.44833330D+03,0.151D+03,0.520D+02,0.97490000D+00,0.00000000D+00
     .,0.40544000D+03,0.151D+03,0.530D+02,0.97490000D+00,0.00000000D+00
     .,0.36450640D+03,0.151D+03,0.540D+02,0.97490000D+00,0.00000000D+00
     .,0.15212386D+04,0.151D+03,0.550D+02,0.97490000D+00,0.00000000D+00
     .,0.14035743D+04,0.151D+03,0.560D+02,0.97490000D+00,0.00000000D+00
     .,0.12355723D+04,0.151D+03,0.570D+02,0.97490000D+00,0.00000000D+00
     .,0.57038460D+03,0.151D+03,0.580D+02,0.97490000D+00,0.27991000D+01
     .,0.12443690D+04,0.151D+03,0.590D+02,0.97490000D+00,0.00000000D+00
     .,0.11953394D+04,0.151D+03,0.600D+02,0.97490000D+00,0.00000000D+00
     .,0.11654811D+04,0.151D+03,0.610D+02,0.97490000D+00,0.00000000D+00
     .,0.11380116D+04,0.151D+03,0.620D+02,0.97490000D+00,0.00000000D+00
     .,0.11136574D+04,0.151D+03,0.630D+02,0.97490000D+00,0.00000000D+00
     .,0.87723370D+03,0.151D+03,0.640D+02,0.97490000D+00,0.00000000D+00
     .,0.98436690D+03,0.151D+03,0.650D+02,0.97490000D+00,0.00000000D+00
     .,0.94971600D+03,0.151D+03,0.660D+02,0.97490000D+00,0.00000000D+00
     .,0.10050059D+04,0.151D+03,0.670D+02,0.97490000D+00,0.00000000D+00
     .,0.98375110D+03,0.151D+03,0.680D+02,0.97490000D+00,0.00000000D+00
     .,0.96460520D+03,0.151D+03,0.690D+02,0.97490000D+00,0.00000000D+00
     .,0.95326960D+03,0.151D+03,0.700D+02,0.97490000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49701:  49800)=(/
     . 0.80412310D+03,0.151D+03,0.710D+02,0.97490000D+00,0.00000000D+00
     .,0.79227200D+03,0.151D+03,0.720D+02,0.97490000D+00,0.00000000D+00
     .,0.72359370D+03,0.151D+03,0.730D+02,0.97490000D+00,0.00000000D+00
     .,0.61110290D+03,0.151D+03,0.740D+02,0.97490000D+00,0.00000000D+00
     .,0.62195650D+03,0.151D+03,0.750D+02,0.97490000D+00,0.00000000D+00
     .,0.56397010D+03,0.151D+03,0.760D+02,0.97490000D+00,0.00000000D+00
     .,0.51667170D+03,0.151D+03,0.770D+02,0.97490000D+00,0.00000000D+00
     .,0.42917250D+03,0.151D+03,0.780D+02,0.97490000D+00,0.00000000D+00
     .,0.40097810D+03,0.151D+03,0.790D+02,0.97490000D+00,0.00000000D+00
     .,0.41268870D+03,0.151D+03,0.800D+02,0.97490000D+00,0.00000000D+00
     .,0.60016760D+03,0.151D+03,0.810D+02,0.97490000D+00,0.00000000D+00
     .,0.58760720D+03,0.151D+03,0.820D+02,0.97490000D+00,0.00000000D+00
     .,0.54048320D+03,0.151D+03,0.830D+02,0.97490000D+00,0.00000000D+00
     .,0.51568470D+03,0.151D+03,0.840D+02,0.97490000D+00,0.00000000D+00
     .,0.47605910D+03,0.151D+03,0.850D+02,0.97490000D+00,0.00000000D+00
     .,0.43636860D+03,0.151D+03,0.860D+02,0.97490000D+00,0.00000000D+00
     .,0.14387730D+04,0.151D+03,0.870D+02,0.97490000D+00,0.00000000D+00
     .,0.13892118D+04,0.151D+03,0.880D+02,0.97490000D+00,0.00000000D+00
     .,0.12302614D+04,0.151D+03,0.890D+02,0.97490000D+00,0.00000000D+00
     .,0.11073931D+04,0.151D+03,0.900D+02,0.97490000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  49801:  49900)=(/
     . 0.10983173D+04,0.151D+03,0.910D+02,0.97490000D+00,0.00000000D+00
     .,0.10634833D+04,0.151D+03,0.920D+02,0.97490000D+00,0.00000000D+00
     .,0.10937836D+04,0.151D+03,0.930D+02,0.97490000D+00,0.00000000D+00
     .,0.10594592D+04,0.151D+03,0.940D+02,0.97490000D+00,0.00000000D+00
     .,0.59779600D+02,0.151D+03,0.101D+03,0.97490000D+00,0.00000000D+00
     .,0.19308010D+03,0.151D+03,0.103D+03,0.97490000D+00,0.98650000D+00
     .,0.24635800D+03,0.151D+03,0.104D+03,0.97490000D+00,0.98080000D+00
     .,0.18865770D+03,0.151D+03,0.105D+03,0.97490000D+00,0.97060000D+00
     .,0.14217370D+03,0.151D+03,0.106D+03,0.97490000D+00,0.98680000D+00
     .,0.98858300D+02,0.151D+03,0.107D+03,0.97490000D+00,0.99440000D+00
     .,0.71981600D+02,0.151D+03,0.108D+03,0.97490000D+00,0.99250000D+00
     .,0.49497000D+02,0.151D+03,0.109D+03,0.97490000D+00,0.99820000D+00
     .,0.28199230D+03,0.151D+03,0.111D+03,0.97490000D+00,0.96840000D+00
     .,0.43599230D+03,0.151D+03,0.112D+03,0.97490000D+00,0.96280000D+00
     .,0.44239460D+03,0.151D+03,0.113D+03,0.97490000D+00,0.96480000D+00
     .,0.35616810D+03,0.151D+03,0.114D+03,0.97490000D+00,0.95070000D+00
     .,0.29192250D+03,0.151D+03,0.115D+03,0.97490000D+00,0.99470000D+00
     .,0.24688440D+03,0.151D+03,0.116D+03,0.97490000D+00,0.99480000D+00
     .,0.20178980D+03,0.151D+03,0.117D+03,0.97490000D+00,0.99720000D+00
     .,0.38878440D+03,0.151D+03,0.119D+03,0.97490000D+00,0.97670000D+00
     ./)
      grimme_c6_parameters(  49901:  50000)=(/
     . 0.73983800D+03,0.151D+03,0.120D+03,0.97490000D+00,0.98310000D+00
     .,0.38986450D+03,0.151D+03,0.121D+03,0.97490000D+00,0.18627000D+01
     .,0.37633360D+03,0.151D+03,0.122D+03,0.97490000D+00,0.18299000D+01
     .,0.36879080D+03,0.151D+03,0.123D+03,0.97490000D+00,0.19138000D+01
     .,0.36529400D+03,0.151D+03,0.124D+03,0.97490000D+00,0.18269000D+01
     .,0.33651780D+03,0.151D+03,0.125D+03,0.97490000D+00,0.16406000D+01
     .,0.31148590D+03,0.151D+03,0.126D+03,0.97490000D+00,0.16483000D+01
     .,0.29711100D+03,0.151D+03,0.127D+03,0.97490000D+00,0.17149000D+01
     .,0.29044330D+03,0.151D+03,0.128D+03,0.97490000D+00,0.17937000D+01
     .,0.28674360D+03,0.151D+03,0.129D+03,0.97490000D+00,0.95760000D+00
     .,0.26942080D+03,0.151D+03,0.130D+03,0.97490000D+00,0.19419000D+01
     .,0.43926920D+03,0.151D+03,0.131D+03,0.97490000D+00,0.96010000D+00
     .,0.38642600D+03,0.151D+03,0.132D+03,0.97490000D+00,0.94340000D+00
     .,0.34656560D+03,0.151D+03,0.133D+03,0.97490000D+00,0.98890000D+00
     .,0.31651250D+03,0.151D+03,0.134D+03,0.97490000D+00,0.99010000D+00
     .,0.27880760D+03,0.151D+03,0.135D+03,0.97490000D+00,0.99740000D+00
     .,0.46396320D+03,0.151D+03,0.137D+03,0.97490000D+00,0.97380000D+00
     .,0.89977960D+03,0.151D+03,0.138D+03,0.97490000D+00,0.98010000D+00
     .,0.69024350D+03,0.151D+03,0.139D+03,0.97490000D+00,0.19153000D+01
     .,0.51535410D+03,0.151D+03,0.140D+03,0.97490000D+00,0.19355000D+01
     ./)
      grimme_c6_parameters(  50001:  50100)=(/
     . 0.52041820D+03,0.151D+03,0.141D+03,0.97490000D+00,0.19545000D+01
     .,0.48533740D+03,0.151D+03,0.142D+03,0.97490000D+00,0.19420000D+01
     .,0.54348220D+03,0.151D+03,0.143D+03,0.97490000D+00,0.16682000D+01
     .,0.42337510D+03,0.151D+03,0.144D+03,0.97490000D+00,0.18584000D+01
     .,0.39603590D+03,0.151D+03,0.145D+03,0.97490000D+00,0.19003000D+01
     .,0.36774930D+03,0.151D+03,0.146D+03,0.97490000D+00,0.18630000D+01
     .,0.35570800D+03,0.151D+03,0.147D+03,0.97490000D+00,0.96790000D+00
     .,0.35221320D+03,0.151D+03,0.148D+03,0.97490000D+00,0.19539000D+01
     .,0.55762720D+03,0.151D+03,0.149D+03,0.97490000D+00,0.96330000D+00
     .,0.50519000D+03,0.151D+03,0.150D+03,0.97490000D+00,0.95140000D+00
     .,0.47347030D+03,0.151D+03,0.151D+03,0.97490000D+00,0.97490000D+00
     .,0.35486100D+02,0.152D+03,0.100D+01,0.98110000D+00,0.91180000D+00
     .,0.23710000D+02,0.152D+03,0.200D+01,0.98110000D+00,0.00000000D+00
     .,0.51945180D+03,0.152D+03,0.300D+01,0.98110000D+00,0.00000000D+00
     .,0.30894260D+03,0.152D+03,0.400D+01,0.98110000D+00,0.00000000D+00
     .,0.21127990D+03,0.152D+03,0.500D+01,0.98110000D+00,0.00000000D+00
     .,0.14426000D+03,0.152D+03,0.600D+01,0.98110000D+00,0.00000000D+00
     .,0.10163150D+03,0.152D+03,0.700D+01,0.98110000D+00,0.00000000D+00
     .,0.77336500D+02,0.152D+03,0.800D+01,0.98110000D+00,0.00000000D+00
     .,0.58833200D+02,0.152D+03,0.900D+01,0.98110000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50101:  50200)=(/
     . 0.45404400D+02,0.152D+03,0.100D+02,0.98110000D+00,0.00000000D+00
     .,0.62230990D+03,0.152D+03,0.110D+02,0.98110000D+00,0.00000000D+00
     .,0.48978200D+03,0.152D+03,0.120D+02,0.98110000D+00,0.00000000D+00
     .,0.45524770D+03,0.152D+03,0.130D+02,0.98110000D+00,0.00000000D+00
     .,0.36255610D+03,0.152D+03,0.140D+02,0.98110000D+00,0.00000000D+00
     .,0.28512390D+03,0.152D+03,0.150D+02,0.98110000D+00,0.00000000D+00
     .,0.23785710D+03,0.152D+03,0.160D+02,0.98110000D+00,0.00000000D+00
     .,0.19521310D+03,0.152D+03,0.170D+02,0.98110000D+00,0.00000000D+00
     .,0.16033310D+03,0.152D+03,0.180D+02,0.98110000D+00,0.00000000D+00
     .,0.10157738D+04,0.152D+03,0.190D+02,0.98110000D+00,0.00000000D+00
     .,0.85290360D+03,0.152D+03,0.200D+02,0.98110000D+00,0.00000000D+00
     .,0.70737690D+03,0.152D+03,0.210D+02,0.98110000D+00,0.00000000D+00
     .,0.68556870D+03,0.152D+03,0.220D+02,0.98110000D+00,0.00000000D+00
     .,0.62913900D+03,0.152D+03,0.230D+02,0.98110000D+00,0.00000000D+00
     .,0.49588010D+03,0.152D+03,0.240D+02,0.98110000D+00,0.00000000D+00
     .,0.54334380D+03,0.152D+03,0.250D+02,0.98110000D+00,0.00000000D+00
     .,0.42683610D+03,0.152D+03,0.260D+02,0.98110000D+00,0.00000000D+00
     .,0.45431700D+03,0.152D+03,0.270D+02,0.98110000D+00,0.00000000D+00
     .,0.46700090D+03,0.152D+03,0.280D+02,0.98110000D+00,0.00000000D+00
     .,0.35818700D+03,0.152D+03,0.290D+02,0.98110000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50201:  50300)=(/
     . 0.37006740D+03,0.152D+03,0.300D+02,0.98110000D+00,0.00000000D+00
     .,0.43744170D+03,0.152D+03,0.310D+02,0.98110000D+00,0.00000000D+00
     .,0.38889460D+03,0.152D+03,0.320D+02,0.98110000D+00,0.00000000D+00
     .,0.33402630D+03,0.152D+03,0.330D+02,0.98110000D+00,0.00000000D+00
     .,0.30096170D+03,0.152D+03,0.340D+02,0.98110000D+00,0.00000000D+00
     .,0.26444460D+03,0.152D+03,0.350D+02,0.98110000D+00,0.00000000D+00
     .,0.23079470D+03,0.152D+03,0.360D+02,0.98110000D+00,0.00000000D+00
     .,0.11403397D+04,0.152D+03,0.370D+02,0.98110000D+00,0.00000000D+00
     .,0.10156122D+04,0.152D+03,0.380D+02,0.98110000D+00,0.00000000D+00
     .,0.89573040D+03,0.152D+03,0.390D+02,0.98110000D+00,0.00000000D+00
     .,0.80842520D+03,0.152D+03,0.400D+02,0.98110000D+00,0.00000000D+00
     .,0.73920970D+03,0.152D+03,0.410D+02,0.98110000D+00,0.00000000D+00
     .,0.57337000D+03,0.152D+03,0.420D+02,0.98110000D+00,0.00000000D+00
     .,0.63864620D+03,0.152D+03,0.430D+02,0.98110000D+00,0.00000000D+00
     .,0.48901000D+03,0.152D+03,0.440D+02,0.98110000D+00,0.00000000D+00
     .,0.53445110D+03,0.152D+03,0.450D+02,0.98110000D+00,0.00000000D+00
     .,0.49643130D+03,0.152D+03,0.460D+02,0.98110000D+00,0.00000000D+00
     .,0.41359130D+03,0.152D+03,0.470D+02,0.98110000D+00,0.00000000D+00
     .,0.43835340D+03,0.152D+03,0.480D+02,0.98110000D+00,0.00000000D+00
     .,0.54729130D+03,0.152D+03,0.490D+02,0.98110000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50301:  50400)=(/
     . 0.50938490D+03,0.152D+03,0.500D+02,0.98110000D+00,0.00000000D+00
     .,0.45675890D+03,0.152D+03,0.510D+02,0.98110000D+00,0.00000000D+00
     .,0.42531520D+03,0.152D+03,0.520D+02,0.98110000D+00,0.00000000D+00
     .,0.38599880D+03,0.152D+03,0.530D+02,0.98110000D+00,0.00000000D+00
     .,0.34821640D+03,0.152D+03,0.540D+02,0.98110000D+00,0.00000000D+00
     .,0.13899562D+04,0.152D+03,0.550D+02,0.98110000D+00,0.00000000D+00
     .,0.12920505D+04,0.152D+03,0.560D+02,0.98110000D+00,0.00000000D+00
     .,0.11428009D+04,0.152D+03,0.570D+02,0.98110000D+00,0.00000000D+00
     .,0.53897800D+03,0.152D+03,0.580D+02,0.98110000D+00,0.27991000D+01
     .,0.11473718D+04,0.152D+03,0.590D+02,0.98110000D+00,0.00000000D+00
     .,0.11029411D+04,0.152D+03,0.600D+02,0.98110000D+00,0.00000000D+00
     .,0.10755989D+04,0.152D+03,0.610D+02,0.98110000D+00,0.00000000D+00
     .,0.10504168D+04,0.152D+03,0.620D+02,0.98110000D+00,0.00000000D+00
     .,0.10280990D+04,0.152D+03,0.630D+02,0.98110000D+00,0.00000000D+00
     .,0.81457180D+03,0.152D+03,0.640D+02,0.98110000D+00,0.00000000D+00
     .,0.90749290D+03,0.152D+03,0.650D+02,0.98110000D+00,0.00000000D+00
     .,0.87640540D+03,0.152D+03,0.660D+02,0.98110000D+00,0.00000000D+00
     .,0.92881650D+03,0.152D+03,0.670D+02,0.98110000D+00,0.00000000D+00
     .,0.90926160D+03,0.152D+03,0.680D+02,0.98110000D+00,0.00000000D+00
     .,0.89171060D+03,0.152D+03,0.690D+02,0.98110000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50401:  50500)=(/
     . 0.88100370D+03,0.152D+03,0.700D+02,0.98110000D+00,0.00000000D+00
     .,0.74613080D+03,0.152D+03,0.710D+02,0.98110000D+00,0.00000000D+00
     .,0.73873540D+03,0.152D+03,0.720D+02,0.98110000D+00,0.00000000D+00
     .,0.67688650D+03,0.152D+03,0.730D+02,0.98110000D+00,0.00000000D+00
     .,0.57338870D+03,0.152D+03,0.740D+02,0.98110000D+00,0.00000000D+00
     .,0.58418960D+03,0.152D+03,0.750D+02,0.98110000D+00,0.00000000D+00
     .,0.53122090D+03,0.152D+03,0.760D+02,0.98110000D+00,0.00000000D+00
     .,0.48779780D+03,0.152D+03,0.770D+02,0.98110000D+00,0.00000000D+00
     .,0.40633480D+03,0.152D+03,0.780D+02,0.98110000D+00,0.00000000D+00
     .,0.38005290D+03,0.152D+03,0.790D+02,0.98110000D+00,0.00000000D+00
     .,0.39145330D+03,0.152D+03,0.800D+02,0.98110000D+00,0.00000000D+00
     .,0.56288150D+03,0.152D+03,0.810D+02,0.98110000D+00,0.00000000D+00
     .,0.55306450D+03,0.152D+03,0.820D+02,0.98110000D+00,0.00000000D+00
     .,0.51099880D+03,0.152D+03,0.830D+02,0.98110000D+00,0.00000000D+00
     .,0.48888150D+03,0.152D+03,0.840D+02,0.98110000D+00,0.00000000D+00
     .,0.45282060D+03,0.152D+03,0.850D+02,0.98110000D+00,0.00000000D+00
     .,0.41635580D+03,0.152D+03,0.860D+02,0.98110000D+00,0.00000000D+00
     .,0.13196282D+04,0.152D+03,0.870D+02,0.98110000D+00,0.00000000D+00
     .,0.12821564D+04,0.152D+03,0.880D+02,0.98110000D+00,0.00000000D+00
     .,0.11403381D+04,0.152D+03,0.890D+02,0.98110000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50501:  50600)=(/
     . 0.10319646D+04,0.152D+03,0.900D+02,0.98110000D+00,0.00000000D+00
     .,0.10211167D+04,0.152D+03,0.910D+02,0.98110000D+00,0.00000000D+00
     .,0.98886570D+03,0.152D+03,0.920D+02,0.98110000D+00,0.00000000D+00
     .,0.10136901D+04,0.152D+03,0.930D+02,0.98110000D+00,0.00000000D+00
     .,0.98242950D+03,0.152D+03,0.940D+02,0.98110000D+00,0.00000000D+00
     .,0.56715600D+02,0.152D+03,0.101D+03,0.98110000D+00,0.00000000D+00
     .,0.17998120D+03,0.152D+03,0.103D+03,0.98110000D+00,0.98650000D+00
     .,0.23026410D+03,0.152D+03,0.104D+03,0.98110000D+00,0.98080000D+00
     .,0.17825090D+03,0.152D+03,0.105D+03,0.98110000D+00,0.97060000D+00
     .,0.13527200D+03,0.152D+03,0.106D+03,0.98110000D+00,0.98680000D+00
     .,0.94770500D+02,0.152D+03,0.107D+03,0.98110000D+00,0.99440000D+00
     .,0.69431700D+02,0.152D+03,0.108D+03,0.98110000D+00,0.99250000D+00
     .,0.48103700D+02,0.152D+03,0.109D+03,0.98110000D+00,0.99820000D+00
     .,0.26236970D+03,0.152D+03,0.111D+03,0.98110000D+00,0.96840000D+00
     .,0.40525290D+03,0.152D+03,0.112D+03,0.98110000D+00,0.96280000D+00
     .,0.41338560D+03,0.152D+03,0.113D+03,0.98110000D+00,0.96480000D+00
     .,0.33559140D+03,0.152D+03,0.114D+03,0.98110000D+00,0.95070000D+00
     .,0.27683720D+03,0.152D+03,0.115D+03,0.98110000D+00,0.99470000D+00
     .,0.23520590D+03,0.152D+03,0.116D+03,0.98110000D+00,0.99480000D+00
     .,0.19317040D+03,0.152D+03,0.117D+03,0.98110000D+00,0.99720000D+00
     ./)
      grimme_c6_parameters(  50601:  50700)=(/
     . 0.36384820D+03,0.152D+03,0.119D+03,0.98110000D+00,0.97670000D+00
     .,0.68296210D+03,0.152D+03,0.120D+03,0.98110000D+00,0.98310000D+00
     .,0.36699000D+03,0.152D+03,0.121D+03,0.98110000D+00,0.18627000D+01
     .,0.35440290D+03,0.152D+03,0.122D+03,0.98110000D+00,0.18299000D+01
     .,0.34726480D+03,0.152D+03,0.123D+03,0.98110000D+00,0.19138000D+01
     .,0.34370870D+03,0.152D+03,0.124D+03,0.98110000D+00,0.18269000D+01
     .,0.31777500D+03,0.152D+03,0.125D+03,0.98110000D+00,0.16406000D+01
     .,0.29450790D+03,0.152D+03,0.126D+03,0.98110000D+00,0.16483000D+01
     .,0.28094820D+03,0.152D+03,0.127D+03,0.98110000D+00,0.17149000D+01
     .,0.27455800D+03,0.152D+03,0.128D+03,0.98110000D+00,0.17937000D+01
     .,0.27027830D+03,0.152D+03,0.129D+03,0.98110000D+00,0.95760000D+00
     .,0.25527130D+03,0.152D+03,0.130D+03,0.98110000D+00,0.19419000D+01
     .,0.41170180D+03,0.152D+03,0.131D+03,0.98110000D+00,0.96010000D+00
     .,0.36448820D+03,0.152D+03,0.132D+03,0.98110000D+00,0.94340000D+00
     .,0.32849090D+03,0.152D+03,0.133D+03,0.98110000D+00,0.98890000D+00
     .,0.30105670D+03,0.152D+03,0.134D+03,0.98110000D+00,0.99010000D+00
     .,0.26622780D+03,0.152D+03,0.135D+03,0.98110000D+00,0.99740000D+00
     .,0.43493910D+03,0.152D+03,0.137D+03,0.98110000D+00,0.97380000D+00
     .,0.83036610D+03,0.152D+03,0.138D+03,0.98110000D+00,0.98010000D+00
     .,0.64326970D+03,0.152D+03,0.139D+03,0.98110000D+00,0.19153000D+01
     ./)
      grimme_c6_parameters(  50701:  50800)=(/
     . 0.48508560D+03,0.152D+03,0.140D+03,0.98110000D+00,0.19355000D+01
     .,0.48977500D+03,0.152D+03,0.141D+03,0.98110000D+00,0.19545000D+01
     .,0.45747170D+03,0.152D+03,0.142D+03,0.98110000D+00,0.19420000D+01
     .,0.50987810D+03,0.152D+03,0.143D+03,0.98110000D+00,0.16682000D+01
     .,0.40053650D+03,0.152D+03,0.144D+03,0.98110000D+00,0.18584000D+01
     .,0.37486560D+03,0.152D+03,0.145D+03,0.98110000D+00,0.19003000D+01
     .,0.34838020D+03,0.152D+03,0.146D+03,0.98110000D+00,0.18630000D+01
     .,0.33677710D+03,0.152D+03,0.147D+03,0.98110000D+00,0.96790000D+00
     .,0.33432410D+03,0.152D+03,0.148D+03,0.98110000D+00,0.19539000D+01
     .,0.52288630D+03,0.152D+03,0.149D+03,0.98110000D+00,0.96330000D+00
     .,0.47620870D+03,0.152D+03,0.150D+03,0.98110000D+00,0.95140000D+00
     .,0.44801730D+03,0.152D+03,0.151D+03,0.98110000D+00,0.97490000D+00
     .,0.42510150D+03,0.152D+03,0.152D+03,0.98110000D+00,0.98110000D+00
     .,0.32815100D+02,0.153D+03,0.100D+01,0.99680000D+00,0.91180000D+00
     .,0.22271700D+02,0.153D+03,0.200D+01,0.99680000D+00,0.00000000D+00
     .,0.45439540D+03,0.153D+03,0.300D+01,0.99680000D+00,0.00000000D+00
     .,0.27643090D+03,0.153D+03,0.400D+01,0.99680000D+00,0.00000000D+00
     .,0.19192730D+03,0.153D+03,0.500D+01,0.99680000D+00,0.00000000D+00
     .,0.13262510D+03,0.153D+03,0.600D+01,0.99680000D+00,0.00000000D+00
     .,0.94299100D+02,0.153D+03,0.700D+01,0.99680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50801:  50900)=(/
     . 0.72235800D+02,0.153D+03,0.800D+01,0.99680000D+00,0.00000000D+00
     .,0.55268900D+02,0.153D+03,0.900D+01,0.99680000D+00,0.00000000D+00
     .,0.42851200D+02,0.153D+03,0.100D+02,0.99680000D+00,0.00000000D+00
     .,0.54528550D+03,0.153D+03,0.110D+02,0.99680000D+00,0.00000000D+00
     .,0.43644520D+03,0.153D+03,0.120D+02,0.99680000D+00,0.00000000D+00
     .,0.40871490D+03,0.153D+03,0.130D+02,0.99680000D+00,0.00000000D+00
     .,0.32881570D+03,0.153D+03,0.140D+02,0.99680000D+00,0.00000000D+00
     .,0.26094460D+03,0.153D+03,0.150D+02,0.99680000D+00,0.00000000D+00
     .,0.21904300D+03,0.153D+03,0.160D+02,0.99680000D+00,0.00000000D+00
     .,0.18086040D+03,0.153D+03,0.170D+02,0.99680000D+00,0.00000000D+00
     .,0.14934300D+03,0.153D+03,0.180D+02,0.99680000D+00,0.00000000D+00
     .,0.88900260D+03,0.153D+03,0.190D+02,0.99680000D+00,0.00000000D+00
     .,0.75534780D+03,0.153D+03,0.200D+02,0.99680000D+00,0.00000000D+00
     .,0.62833170D+03,0.153D+03,0.210D+02,0.99680000D+00,0.00000000D+00
     .,0.61099490D+03,0.153D+03,0.220D+02,0.99680000D+00,0.00000000D+00
     .,0.56176430D+03,0.153D+03,0.230D+02,0.99680000D+00,0.00000000D+00
     .,0.44344010D+03,0.153D+03,0.240D+02,0.99680000D+00,0.00000000D+00
     .,0.48650250D+03,0.153D+03,0.250D+02,0.99680000D+00,0.00000000D+00
     .,0.38289000D+03,0.153D+03,0.260D+02,0.99680000D+00,0.00000000D+00
     .,0.40860640D+03,0.153D+03,0.270D+02,0.99680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  50901:  51000)=(/
     . 0.41915920D+03,0.153D+03,0.280D+02,0.99680000D+00,0.00000000D+00
     .,0.32203460D+03,0.153D+03,0.290D+02,0.99680000D+00,0.00000000D+00
     .,0.33424140D+03,0.153D+03,0.300D+02,0.99680000D+00,0.00000000D+00
     .,0.39422890D+03,0.153D+03,0.310D+02,0.99680000D+00,0.00000000D+00
     .,0.35311560D+03,0.153D+03,0.320D+02,0.99680000D+00,0.00000000D+00
     .,0.30552140D+03,0.153D+03,0.330D+02,0.99680000D+00,0.00000000D+00
     .,0.27661090D+03,0.153D+03,0.340D+02,0.99680000D+00,0.00000000D+00
     .,0.24427520D+03,0.153D+03,0.350D+02,0.99680000D+00,0.00000000D+00
     .,0.21420040D+03,0.153D+03,0.360D+02,0.99680000D+00,0.00000000D+00
     .,0.99978710D+03,0.153D+03,0.370D+02,0.99680000D+00,0.00000000D+00
     .,0.89949300D+03,0.153D+03,0.380D+02,0.99680000D+00,0.00000000D+00
     .,0.79779010D+03,0.153D+03,0.390D+02,0.99680000D+00,0.00000000D+00
     .,0.72272400D+03,0.153D+03,0.400D+02,0.99680000D+00,0.00000000D+00
     .,0.66260680D+03,0.153D+03,0.410D+02,0.99680000D+00,0.00000000D+00
     .,0.51659320D+03,0.153D+03,0.420D+02,0.99680000D+00,0.00000000D+00
     .,0.57428050D+03,0.153D+03,0.430D+02,0.99680000D+00,0.00000000D+00
     .,0.44217100D+03,0.153D+03,0.440D+02,0.99680000D+00,0.00000000D+00
     .,0.48282170D+03,0.153D+03,0.450D+02,0.99680000D+00,0.00000000D+00
     .,0.44920610D+03,0.153D+03,0.460D+02,0.99680000D+00,0.00000000D+00
     .,0.37444670D+03,0.153D+03,0.470D+02,0.99680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51001:  51100)=(/
     . 0.39749790D+03,0.153D+03,0.480D+02,0.99680000D+00,0.00000000D+00
     .,0.49366250D+03,0.153D+03,0.490D+02,0.99680000D+00,0.00000000D+00
     .,0.46207160D+03,0.153D+03,0.500D+02,0.99680000D+00,0.00000000D+00
     .,0.41687150D+03,0.153D+03,0.510D+02,0.99680000D+00,0.00000000D+00
     .,0.38970290D+03,0.153D+03,0.520D+02,0.99680000D+00,0.00000000D+00
     .,0.35521750D+03,0.153D+03,0.530D+02,0.99680000D+00,0.00000000D+00
     .,0.32180290D+03,0.153D+03,0.540D+02,0.99680000D+00,0.00000000D+00
     .,0.12196272D+04,0.153D+03,0.550D+02,0.99680000D+00,0.00000000D+00
     .,0.11429378D+04,0.153D+03,0.560D+02,0.99680000D+00,0.00000000D+00
     .,0.10164155D+04,0.153D+03,0.570D+02,0.99680000D+00,0.00000000D+00
     .,0.49161500D+03,0.153D+03,0.580D+02,0.99680000D+00,0.27991000D+01
     .,0.10169588D+04,0.153D+03,0.590D+02,0.99680000D+00,0.00000000D+00
     .,0.97834710D+03,0.153D+03,0.600D+02,0.99680000D+00,0.00000000D+00
     .,0.95429670D+03,0.153D+03,0.610D+02,0.99680000D+00,0.00000000D+00
     .,0.93211660D+03,0.153D+03,0.620D+02,0.99680000D+00,0.00000000D+00
     .,0.91246710D+03,0.153D+03,0.630D+02,0.99680000D+00,0.00000000D+00
     .,0.72800530D+03,0.153D+03,0.640D+02,0.99680000D+00,0.00000000D+00
     .,0.80453430D+03,0.153D+03,0.650D+02,0.99680000D+00,0.00000000D+00
     .,0.77785480D+03,0.153D+03,0.660D+02,0.99680000D+00,0.00000000D+00
     .,0.82536440D+03,0.153D+03,0.670D+02,0.99680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51101:  51200)=(/
     . 0.80806540D+03,0.153D+03,0.680D+02,0.99680000D+00,0.00000000D+00
     .,0.79260610D+03,0.153D+03,0.690D+02,0.99680000D+00,0.00000000D+00
     .,0.78284050D+03,0.153D+03,0.700D+02,0.99680000D+00,0.00000000D+00
     .,0.66614790D+03,0.153D+03,0.710D+02,0.99680000D+00,0.00000000D+00
     .,0.66319200D+03,0.153D+03,0.720D+02,0.99680000D+00,0.00000000D+00
     .,0.61001430D+03,0.153D+03,0.730D+02,0.99680000D+00,0.00000000D+00
     .,0.51873530D+03,0.153D+03,0.740D+02,0.99680000D+00,0.00000000D+00
     .,0.52912210D+03,0.153D+03,0.750D+02,0.99680000D+00,0.00000000D+00
     .,0.48278010D+03,0.153D+03,0.760D+02,0.99680000D+00,0.00000000D+00
     .,0.44456400D+03,0.153D+03,0.770D+02,0.99680000D+00,0.00000000D+00
     .,0.37168100D+03,0.153D+03,0.780D+02,0.99680000D+00,0.00000000D+00
     .,0.34813080D+03,0.153D+03,0.790D+02,0.99680000D+00,0.00000000D+00
     .,0.35883830D+03,0.153D+03,0.800D+02,0.99680000D+00,0.00000000D+00
     .,0.50911500D+03,0.153D+03,0.810D+02,0.99680000D+00,0.00000000D+00
     .,0.50219660D+03,0.153D+03,0.820D+02,0.99680000D+00,0.00000000D+00
     .,0.46641830D+03,0.153D+03,0.830D+02,0.99680000D+00,0.00000000D+00
     .,0.44766490D+03,0.153D+03,0.840D+02,0.99680000D+00,0.00000000D+00
     .,0.41630430D+03,0.153D+03,0.850D+02,0.99680000D+00,0.00000000D+00
     .,0.38423110D+03,0.153D+03,0.860D+02,0.99680000D+00,0.00000000D+00
     .,0.11630702D+04,0.153D+03,0.870D+02,0.99680000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51201:  51300)=(/
     . 0.11376470D+04,0.153D+03,0.880D+02,0.99680000D+00,0.00000000D+00
     .,0.10167803D+04,0.153D+03,0.890D+02,0.99680000D+00,0.00000000D+00
     .,0.92598120D+03,0.153D+03,0.900D+02,0.99680000D+00,0.00000000D+00
     .,0.91390750D+03,0.153D+03,0.910D+02,0.99680000D+00,0.00000000D+00
     .,0.88520210D+03,0.153D+03,0.920D+02,0.99680000D+00,0.00000000D+00
     .,0.90396880D+03,0.153D+03,0.930D+02,0.99680000D+00,0.00000000D+00
     .,0.87665190D+03,0.153D+03,0.940D+02,0.99680000D+00,0.00000000D+00
     .,0.51949600D+02,0.153D+03,0.101D+03,0.99680000D+00,0.00000000D+00
     .,0.16143030D+03,0.153D+03,0.103D+03,0.99680000D+00,0.98650000D+00
     .,0.20721850D+03,0.153D+03,0.104D+03,0.99680000D+00,0.98080000D+00
     .,0.16249390D+03,0.153D+03,0.105D+03,0.99680000D+00,0.97060000D+00
     .,0.12439580D+03,0.153D+03,0.106D+03,0.99680000D+00,0.98680000D+00
     .,0.87986900D+02,0.153D+03,0.107D+03,0.99680000D+00,0.99440000D+00
     .,0.64976400D+02,0.153D+03,0.108D+03,0.99680000D+00,0.99250000D+00
     .,0.45461800D+02,0.153D+03,0.109D+03,0.99680000D+00,0.99820000D+00
     .,0.23487760D+03,0.153D+03,0.111D+03,0.99680000D+00,0.96840000D+00
     .,0.36232580D+03,0.153D+03,0.112D+03,0.99680000D+00,0.96280000D+00
     .,0.37186150D+03,0.153D+03,0.113D+03,0.99680000D+00,0.96480000D+00
     .,0.30487150D+03,0.153D+03,0.114D+03,0.99680000D+00,0.95070000D+00
     .,0.25346770D+03,0.153D+03,0.115D+03,0.99680000D+00,0.99470000D+00
     ./)
      grimme_c6_parameters(  51301:  51400)=(/
     . 0.21658660D+03,0.153D+03,0.116D+03,0.99680000D+00,0.99480000D+00
     .,0.17895810D+03,0.153D+03,0.117D+03,0.99680000D+00,0.99720000D+00
     .,0.32822070D+03,0.153D+03,0.119D+03,0.99680000D+00,0.97670000D+00
     .,0.60618590D+03,0.153D+03,0.120D+03,0.99680000D+00,0.98310000D+00
     .,0.33318010D+03,0.153D+03,0.121D+03,0.99680000D+00,0.18627000D+01
     .,0.32194330D+03,0.153D+03,0.122D+03,0.99680000D+00,0.18299000D+01
     .,0.31543490D+03,0.153D+03,0.123D+03,0.99680000D+00,0.19138000D+01
     .,0.31193950D+03,0.153D+03,0.124D+03,0.99680000D+00,0.18269000D+01
     .,0.28957840D+03,0.153D+03,0.125D+03,0.99680000D+00,0.16406000D+01
     .,0.26879340D+03,0.153D+03,0.126D+03,0.99680000D+00,0.16483000D+01
     .,0.25647210D+03,0.153D+03,0.127D+03,0.99680000D+00,0.17149000D+01
     .,0.25055360D+03,0.153D+03,0.128D+03,0.99680000D+00,0.17937000D+01
     .,0.24584350D+03,0.153D+03,0.129D+03,0.99680000D+00,0.95760000D+00
     .,0.23356320D+03,0.153D+03,0.130D+03,0.99680000D+00,0.19419000D+01
     .,0.37176550D+03,0.153D+03,0.131D+03,0.99680000D+00,0.96010000D+00
     .,0.33159870D+03,0.153D+03,0.132D+03,0.99680000D+00,0.94340000D+00
     .,0.30060430D+03,0.153D+03,0.133D+03,0.99680000D+00,0.98890000D+00
     .,0.27668620D+03,0.153D+03,0.134D+03,0.99680000D+00,0.99010000D+00
     .,0.24586470D+03,0.153D+03,0.135D+03,0.99680000D+00,0.99740000D+00
     .,0.39318090D+03,0.153D+03,0.137D+03,0.99680000D+00,0.97380000D+00
     ./)
      grimme_c6_parameters(  51401:  51500)=(/
     . 0.73690210D+03,0.153D+03,0.138D+03,0.99680000D+00,0.98010000D+00
     .,0.57738050D+03,0.153D+03,0.139D+03,0.99680000D+00,0.19153000D+01
     .,0.44044740D+03,0.153D+03,0.140D+03,0.99680000D+00,0.19355000D+01
     .,0.44464020D+03,0.153D+03,0.141D+03,0.99680000D+00,0.19545000D+01
     .,0.41612070D+03,0.153D+03,0.142D+03,0.99680000D+00,0.19420000D+01
     .,0.46132230D+03,0.153D+03,0.143D+03,0.99680000D+00,0.16682000D+01
     .,0.36592820D+03,0.153D+03,0.144D+03,0.99680000D+00,0.18584000D+01
     .,0.34272790D+03,0.153D+03,0.145D+03,0.99680000D+00,0.19003000D+01
     .,0.31886290D+03,0.153D+03,0.146D+03,0.99680000D+00,0.18630000D+01
     .,0.30804750D+03,0.153D+03,0.147D+03,0.99680000D+00,0.96790000D+00
     .,0.30665490D+03,0.153D+03,0.148D+03,0.99680000D+00,0.19539000D+01
     .,0.47264410D+03,0.153D+03,0.149D+03,0.99680000D+00,0.96330000D+00
     .,0.43305890D+03,0.153D+03,0.150D+03,0.99680000D+00,0.95140000D+00
     .,0.40924850D+03,0.153D+03,0.151D+03,0.99680000D+00,0.97490000D+00
     .,0.38959960D+03,0.153D+03,0.152D+03,0.99680000D+00,0.98110000D+00
     .,0.35849950D+03,0.153D+03,0.153D+03,0.99680000D+00,0.99680000D+00
     .,0.42305800D+02,0.155D+03,0.100D+01,0.99090000D+00,0.91180000D+00
     .,0.27469500D+02,0.155D+03,0.200D+01,0.99090000D+00,0.00000000D+00
     .,0.73291200D+03,0.155D+03,0.300D+01,0.99090000D+00,0.00000000D+00
     .,0.39940200D+03,0.155D+03,0.400D+01,0.99090000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51501:  51600)=(/
     . 0.26223870D+03,0.155D+03,0.500D+01,0.99090000D+00,0.00000000D+00
     .,0.17427180D+03,0.155D+03,0.600D+01,0.99090000D+00,0.00000000D+00
     .,0.12049820D+03,0.155D+03,0.700D+01,0.99090000D+00,0.00000000D+00
     .,0.90530300D+02,0.155D+03,0.800D+01,0.99090000D+00,0.00000000D+00
     .,0.68123900D+02,0.155D+03,0.900D+01,0.99090000D+00,0.00000000D+00
     .,0.52104100D+02,0.155D+03,0.100D+02,0.99090000D+00,0.00000000D+00
     .,0.87326650D+03,0.155D+03,0.110D+02,0.99090000D+00,0.00000000D+00
     .,0.64218460D+03,0.155D+03,0.120D+02,0.99090000D+00,0.00000000D+00
     .,0.58368500D+03,0.155D+03,0.130D+02,0.99090000D+00,0.00000000D+00
     .,0.45161710D+03,0.155D+03,0.140D+02,0.99090000D+00,0.00000000D+00
     .,0.34740300D+03,0.155D+03,0.150D+02,0.99090000D+00,0.00000000D+00
     .,0.28604180D+03,0.155D+03,0.160D+02,0.99090000D+00,0.00000000D+00
     .,0.23194830D+03,0.155D+03,0.170D+02,0.99090000D+00,0.00000000D+00
     .,0.18859500D+03,0.155D+03,0.180D+02,0.99090000D+00,0.00000000D+00
     .,0.14495860D+04,0.155D+03,0.190D+02,0.99090000D+00,0.00000000D+00
     .,0.11498295D+04,0.155D+03,0.200D+02,0.99090000D+00,0.00000000D+00
     .,0.94227450D+03,0.155D+03,0.210D+02,0.99090000D+00,0.00000000D+00
     .,0.90422250D+03,0.155D+03,0.220D+02,0.99090000D+00,0.00000000D+00
     .,0.82477800D+03,0.155D+03,0.230D+02,0.99090000D+00,0.00000000D+00
     .,0.65006270D+03,0.155D+03,0.240D+02,0.99090000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51601:  51700)=(/
     . 0.70614120D+03,0.155D+03,0.250D+02,0.99090000D+00,0.00000000D+00
     .,0.55409250D+03,0.155D+03,0.260D+02,0.99090000D+00,0.00000000D+00
     .,0.58184580D+03,0.155D+03,0.270D+02,0.99090000D+00,0.00000000D+00
     .,0.60158080D+03,0.155D+03,0.280D+02,0.99090000D+00,0.00000000D+00
     .,0.46170190D+03,0.155D+03,0.290D+02,0.99090000D+00,0.00000000D+00
     .,0.46787310D+03,0.155D+03,0.300D+02,0.99090000D+00,0.00000000D+00
     .,0.55650160D+03,0.155D+03,0.310D+02,0.99090000D+00,0.00000000D+00
     .,0.48371170D+03,0.155D+03,0.320D+02,0.99090000D+00,0.00000000D+00
     .,0.40779580D+03,0.155D+03,0.330D+02,0.99090000D+00,0.00000000D+00
     .,0.36352860D+03,0.155D+03,0.340D+02,0.99090000D+00,0.00000000D+00
     .,0.31607000D+03,0.155D+03,0.350D+02,0.99090000D+00,0.00000000D+00
     .,0.27329990D+03,0.155D+03,0.360D+02,0.99090000D+00,0.00000000D+00
     .,0.16207604D+04,0.155D+03,0.370D+02,0.99090000D+00,0.00000000D+00
     .,0.13728515D+04,0.155D+03,0.380D+02,0.99090000D+00,0.00000000D+00
     .,0.11863885D+04,0.155D+03,0.390D+02,0.99090000D+00,0.00000000D+00
     .,0.10577660D+04,0.155D+03,0.400D+02,0.99090000D+00,0.00000000D+00
     .,0.95979080D+03,0.155D+03,0.410D+02,0.99090000D+00,0.00000000D+00
     .,0.73514980D+03,0.155D+03,0.420D+02,0.99090000D+00,0.00000000D+00
     .,0.82258290D+03,0.155D+03,0.430D+02,0.99090000D+00,0.00000000D+00
     .,0.62119680D+03,0.155D+03,0.440D+02,0.99090000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51701:  51800)=(/
     . 0.67827670D+03,0.155D+03,0.450D+02,0.99090000D+00,0.00000000D+00
     .,0.62700570D+03,0.155D+03,0.460D+02,0.99090000D+00,0.00000000D+00
     .,0.52450750D+03,0.155D+03,0.470D+02,0.99090000D+00,0.00000000D+00
     .,0.55025650D+03,0.155D+03,0.480D+02,0.99090000D+00,0.00000000D+00
     .,0.69737450D+03,0.155D+03,0.490D+02,0.99090000D+00,0.00000000D+00
     .,0.63676120D+03,0.155D+03,0.500D+02,0.99090000D+00,0.00000000D+00
     .,0.56125330D+03,0.155D+03,0.510D+02,0.99090000D+00,0.00000000D+00
     .,0.51758070D+03,0.155D+03,0.520D+02,0.99090000D+00,0.00000000D+00
     .,0.46507030D+03,0.155D+03,0.530D+02,0.99090000D+00,0.00000000D+00
     .,0.41576900D+03,0.155D+03,0.540D+02,0.99090000D+00,0.00000000D+00
     .,0.19759738D+04,0.155D+03,0.550D+02,0.99090000D+00,0.00000000D+00
     .,0.17600602D+04,0.155D+03,0.560D+02,0.99090000D+00,0.00000000D+00
     .,0.15249399D+04,0.155D+03,0.570D+02,0.99090000D+00,0.00000000D+00
     .,0.66483460D+03,0.155D+03,0.580D+02,0.99090000D+00,0.27991000D+01
     .,0.15520845D+04,0.155D+03,0.590D+02,0.99090000D+00,0.00000000D+00
     .,0.14864897D+04,0.155D+03,0.600D+02,0.99090000D+00,0.00000000D+00
     .,0.14481464D+04,0.155D+03,0.610D+02,0.99090000D+00,0.00000000D+00
     .,0.14129908D+04,0.155D+03,0.620D+02,0.99090000D+00,0.00000000D+00
     .,0.13817863D+04,0.155D+03,0.630D+02,0.99090000D+00,0.00000000D+00
     .,0.10715717D+04,0.155D+03,0.640D+02,0.99090000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51801:  51900)=(/
     . 0.12355701D+04,0.155D+03,0.650D+02,0.99090000D+00,0.00000000D+00
     .,0.11888012D+04,0.155D+03,0.660D+02,0.99090000D+00,0.00000000D+00
     .,0.12416267D+04,0.155D+03,0.670D+02,0.99090000D+00,0.00000000D+00
     .,0.12147181D+04,0.155D+03,0.680D+02,0.99090000D+00,0.00000000D+00
     .,0.11902611D+04,0.155D+03,0.690D+02,0.99090000D+00,0.00000000D+00
     .,0.11769746D+04,0.155D+03,0.700D+02,0.99090000D+00,0.00000000D+00
     .,0.98243040D+03,0.155D+03,0.710D+02,0.99090000D+00,0.00000000D+00
     .,0.95327210D+03,0.155D+03,0.720D+02,0.99090000D+00,0.00000000D+00
     .,0.86345810D+03,0.155D+03,0.730D+02,0.99090000D+00,0.00000000D+00
     .,0.72569910D+03,0.155D+03,0.740D+02,0.99090000D+00,0.00000000D+00
     .,0.73587000D+03,0.155D+03,0.750D+02,0.99090000D+00,0.00000000D+00
     .,0.66279760D+03,0.155D+03,0.760D+02,0.99090000D+00,0.00000000D+00
     .,0.60405240D+03,0.155D+03,0.770D+02,0.99090000D+00,0.00000000D+00
     .,0.49959380D+03,0.155D+03,0.780D+02,0.99090000D+00,0.00000000D+00
     .,0.46588050D+03,0.155D+03,0.790D+02,0.99090000D+00,0.00000000D+00
     .,0.47788590D+03,0.155D+03,0.800D+02,0.99090000D+00,0.00000000D+00
     .,0.71477590D+03,0.155D+03,0.810D+02,0.99090000D+00,0.00000000D+00
     .,0.69152340D+03,0.155D+03,0.820D+02,0.99090000D+00,0.00000000D+00
     .,0.62890510D+03,0.155D+03,0.830D+02,0.99090000D+00,0.00000000D+00
     .,0.59653870D+03,0.155D+03,0.840D+02,0.99090000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  51901:  52000)=(/
     . 0.54712200D+03,0.155D+03,0.850D+02,0.99090000D+00,0.00000000D+00
     .,0.49878710D+03,0.155D+03,0.860D+02,0.99090000D+00,0.00000000D+00
     .,0.18443405D+04,0.155D+03,0.870D+02,0.99090000D+00,0.00000000D+00
     .,0.17284117D+04,0.155D+03,0.880D+02,0.99090000D+00,0.00000000D+00
     .,0.15078114D+04,0.155D+03,0.890D+02,0.99090000D+00,0.00000000D+00
     .,0.13366572D+04,0.155D+03,0.900D+02,0.99090000D+00,0.00000000D+00
     .,0.13367673D+04,0.155D+03,0.910D+02,0.99090000D+00,0.00000000D+00
     .,0.12938174D+04,0.155D+03,0.920D+02,0.99090000D+00,0.00000000D+00
     .,0.13431115D+04,0.155D+03,0.930D+02,0.99090000D+00,0.00000000D+00
     .,0.12984675D+04,0.155D+03,0.940D+02,0.99090000D+00,0.00000000D+00
     .,0.68953700D+02,0.155D+03,0.101D+03,0.99090000D+00,0.00000000D+00
     .,0.23141650D+03,0.155D+03,0.103D+03,0.99090000D+00,0.98650000D+00
     .,0.29414590D+03,0.155D+03,0.104D+03,0.99090000D+00,0.98080000D+00
     .,0.21963870D+03,0.155D+03,0.105D+03,0.99090000D+00,0.97060000D+00
     .,0.16367150D+03,0.155D+03,0.106D+03,0.99090000D+00,0.98680000D+00
     .,0.11242780D+03,0.155D+03,0.107D+03,0.99090000D+00,0.99440000D+00
     .,0.81084500D+02,0.155D+03,0.108D+03,0.99090000D+00,0.99250000D+00
     .,0.55078600D+02,0.155D+03,0.109D+03,0.99090000D+00,0.99820000D+00
     .,0.34006240D+03,0.155D+03,0.111D+03,0.99090000D+00,0.96840000D+00
     .,0.52756300D+03,0.155D+03,0.112D+03,0.99090000D+00,0.96280000D+00
     ./)
      grimme_c6_parameters(  52001:  52100)=(/
     . 0.52732820D+03,0.155D+03,0.113D+03,0.99090000D+00,0.96480000D+00
     .,0.41648610D+03,0.155D+03,0.114D+03,0.99090000D+00,0.95070000D+00
     .,0.33711350D+03,0.155D+03,0.115D+03,0.99090000D+00,0.99470000D+00
     .,0.28296690D+03,0.155D+03,0.116D+03,0.99090000D+00,0.99480000D+00
     .,0.22958370D+03,0.155D+03,0.117D+03,0.99090000D+00,0.99720000D+00
     .,0.46551820D+03,0.155D+03,0.119D+03,0.99090000D+00,0.97670000D+00
     .,0.92179340D+03,0.155D+03,0.120D+03,0.99090000D+00,0.98310000D+00
     .,0.45790120D+03,0.155D+03,0.121D+03,0.99090000D+00,0.18627000D+01
     .,0.44205470D+03,0.155D+03,0.122D+03,0.99090000D+00,0.18299000D+01
     .,0.43331390D+03,0.155D+03,0.123D+03,0.99090000D+00,0.19138000D+01
     .,0.43010400D+03,0.155D+03,0.124D+03,0.99090000D+00,0.18269000D+01
     .,0.39208310D+03,0.155D+03,0.125D+03,0.99090000D+00,0.16406000D+01
     .,0.36204550D+03,0.155D+03,0.126D+03,0.99090000D+00,0.16483000D+01
     .,0.34544700D+03,0.155D+03,0.127D+03,0.99090000D+00,0.17149000D+01
     .,0.33794540D+03,0.155D+03,0.128D+03,0.99090000D+00,0.17937000D+01
     .,0.33608210D+03,0.155D+03,0.129D+03,0.99090000D+00,0.95760000D+00
     .,0.31158000D+03,0.155D+03,0.130D+03,0.99090000D+00,0.19419000D+01
     .,0.52074900D+03,0.155D+03,0.131D+03,0.99090000D+00,0.96010000D+00
     .,0.45117170D+03,0.155D+03,0.132D+03,0.99090000D+00,0.94340000D+00
     .,0.40064390D+03,0.155D+03,0.133D+03,0.99090000D+00,0.98890000D+00
     ./)
      grimme_c6_parameters(  52101:  52200)=(/
     . 0.36372020D+03,0.155D+03,0.134D+03,0.99090000D+00,0.99010000D+00
     .,0.31838270D+03,0.155D+03,0.135D+03,0.99090000D+00,0.99740000D+00
     .,0.55397800D+03,0.155D+03,0.137D+03,0.99090000D+00,0.97380000D+00
     .,0.11249345D+04,0.155D+03,0.138D+03,0.99090000D+00,0.98010000D+00
     .,0.83761350D+03,0.155D+03,0.139D+03,0.99090000D+00,0.19153000D+01
     .,0.60719510D+03,0.155D+03,0.140D+03,0.99090000D+00,0.19355000D+01
     .,0.61320100D+03,0.155D+03,0.141D+03,0.99090000D+00,0.19545000D+01
     .,0.57026210D+03,0.155D+03,0.142D+03,0.99090000D+00,0.19420000D+01
     .,0.64766860D+03,0.155D+03,0.143D+03,0.99090000D+00,0.16682000D+01
     .,0.49283010D+03,0.155D+03,0.144D+03,0.99090000D+00,0.18584000D+01
     .,0.46081940D+03,0.155D+03,0.145D+03,0.99090000D+00,0.19003000D+01
     .,0.42732470D+03,0.155D+03,0.146D+03,0.99090000D+00,0.18630000D+01
     .,0.41377960D+03,0.155D+03,0.147D+03,0.99090000D+00,0.96790000D+00
     .,0.40654590D+03,0.155D+03,0.148D+03,0.99090000D+00,0.19539000D+01
     .,0.66184230D+03,0.155D+03,0.149D+03,0.99090000D+00,0.96330000D+00
     .,0.59127640D+03,0.155D+03,0.150D+03,0.99090000D+00,0.95140000D+00
     .,0.54930440D+03,0.155D+03,0.151D+03,0.99090000D+00,0.97490000D+00
     .,0.51701090D+03,0.155D+03,0.152D+03,0.99090000D+00,0.98110000D+00
     .,0.46948180D+03,0.155D+03,0.153D+03,0.99090000D+00,0.99680000D+00
     .,0.64909240D+03,0.155D+03,0.155D+03,0.99090000D+00,0.99090000D+00
     ./)
      grimme_c6_parameters(  52201:  52300)=(/
     . 0.83014100D+02,0.156D+03,0.100D+01,0.97970000D+00,0.91180000D+00
     .,0.49923200D+02,0.156D+03,0.200D+01,0.97970000D+00,0.00000000D+00
     .,0.21804015D+04,0.156D+03,0.300D+01,0.97970000D+00,0.00000000D+00
     .,0.96110490D+03,0.156D+03,0.400D+01,0.97970000D+00,0.00000000D+00
     .,0.57230020D+03,0.156D+03,0.500D+01,0.97970000D+00,0.00000000D+00
     .,0.35484660D+03,0.156D+03,0.600D+01,0.97970000D+00,0.00000000D+00
     .,0.23350060D+03,0.156D+03,0.700D+01,0.97970000D+00,0.00000000D+00
     .,0.16960300D+03,0.156D+03,0.800D+01,0.97970000D+00,0.00000000D+00
     .,0.12408020D+03,0.156D+03,0.900D+01,0.97970000D+00,0.00000000D+00
     .,0.92849400D+02,0.156D+03,0.100D+02,0.97970000D+00,0.00000000D+00
     .,0.25659398D+04,0.156D+03,0.110D+02,0.97970000D+00,0.00000000D+00
     .,0.15996001D+04,0.156D+03,0.120D+02,0.97970000D+00,0.00000000D+00
     .,0.13814389D+04,0.156D+03,0.130D+02,0.97970000D+00,0.00000000D+00
     .,0.99489260D+03,0.156D+03,0.140D+02,0.97970000D+00,0.00000000D+00
     .,0.72325040D+03,0.156D+03,0.150D+02,0.97970000D+00,0.00000000D+00
     .,0.57533170D+03,0.156D+03,0.160D+02,0.97970000D+00,0.00000000D+00
     .,0.45158250D+03,0.156D+03,0.170D+02,0.97970000D+00,0.00000000D+00
     .,0.35719350D+03,0.156D+03,0.180D+02,0.97970000D+00,0.00000000D+00
     .,0.44958369D+04,0.156D+03,0.190D+02,0.97970000D+00,0.00000000D+00
     .,0.30704624D+04,0.156D+03,0.200D+02,0.97970000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  52301:  52400)=(/
     . 0.24434277D+04,0.156D+03,0.210D+02,0.97970000D+00,0.00000000D+00
     .,0.22946062D+04,0.156D+03,0.220D+02,0.97970000D+00,0.00000000D+00
     .,0.20640309D+04,0.156D+03,0.230D+02,0.97970000D+00,0.00000000D+00
     .,0.16327022D+04,0.156D+03,0.240D+02,0.97970000D+00,0.00000000D+00
     .,0.17320375D+04,0.156D+03,0.250D+02,0.97970000D+00,0.00000000D+00
     .,0.13596156D+04,0.156D+03,0.260D+02,0.97970000D+00,0.00000000D+00
     .,0.13759674D+04,0.156D+03,0.270D+02,0.97970000D+00,0.00000000D+00
     .,0.14425133D+04,0.156D+03,0.280D+02,0.97970000D+00,0.00000000D+00
     .,0.11138541D+04,0.156D+03,0.290D+02,0.97970000D+00,0.00000000D+00
     .,0.10720643D+04,0.156D+03,0.300D+02,0.97970000D+00,0.00000000D+00
     .,0.12954563D+04,0.156D+03,0.310D+02,0.97970000D+00,0.00000000D+00
     .,0.10627315D+04,0.156D+03,0.320D+02,0.97970000D+00,0.00000000D+00
     .,0.85391570D+03,0.156D+03,0.330D+02,0.97970000D+00,0.00000000D+00
     .,0.74014960D+03,0.156D+03,0.340D+02,0.97970000D+00,0.00000000D+00
     .,0.62555040D+03,0.156D+03,0.350D+02,0.97970000D+00,0.00000000D+00
     .,0.52735210D+03,0.156D+03,0.360D+02,0.97970000D+00,0.00000000D+00
     .,0.49979230D+04,0.156D+03,0.370D+02,0.97970000D+00,0.00000000D+00
     .,0.36976569D+04,0.156D+03,0.380D+02,0.97970000D+00,0.00000000D+00
     .,0.30451620D+04,0.156D+03,0.390D+02,0.97970000D+00,0.00000000D+00
     .,0.26376782D+04,0.156D+03,0.400D+02,0.97970000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  52401:  52500)=(/
     . 0.23521278D+04,0.156D+03,0.410D+02,0.97970000D+00,0.00000000D+00
     .,0.17503829D+04,0.156D+03,0.420D+02,0.97970000D+00,0.00000000D+00
     .,0.19809508D+04,0.156D+03,0.430D+02,0.97970000D+00,0.00000000D+00
     .,0.14476221D+04,0.156D+03,0.440D+02,0.97970000D+00,0.00000000D+00
     .,0.15723023D+04,0.156D+03,0.450D+02,0.97970000D+00,0.00000000D+00
     .,0.14360400D+04,0.156D+03,0.460D+02,0.97970000D+00,0.00000000D+00
     .,0.12194904D+04,0.156D+03,0.470D+02,0.97970000D+00,0.00000000D+00
     .,0.12412980D+04,0.156D+03,0.480D+02,0.97970000D+00,0.00000000D+00
     .,0.16356158D+04,0.156D+03,0.490D+02,0.97970000D+00,0.00000000D+00
     .,0.14200022D+04,0.156D+03,0.500D+02,0.97970000D+00,0.00000000D+00
     .,0.11973790D+04,0.156D+03,0.510D+02,0.97970000D+00,0.00000000D+00
     .,0.10767503D+04,0.156D+03,0.520D+02,0.97970000D+00,0.00000000D+00
     .,0.94225240D+03,0.156D+03,0.530D+02,0.97970000D+00,0.00000000D+00
     .,0.82205680D+03,0.156D+03,0.540D+02,0.97970000D+00,0.00000000D+00
     .,0.61419784D+04,0.156D+03,0.550D+02,0.97970000D+00,0.00000000D+00
     .,0.48451776D+04,0.156D+03,0.560D+02,0.97970000D+00,0.00000000D+00
     .,0.39942273D+04,0.156D+03,0.570D+02,0.97970000D+00,0.00000000D+00
     .,0.14330469D+04,0.156D+03,0.580D+02,0.97970000D+00,0.27991000D+01
     .,0.42139225D+04,0.156D+03,0.590D+02,0.97970000D+00,0.00000000D+00
     .,0.39873600D+04,0.156D+03,0.600D+02,0.97970000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  52501:  52600)=(/
     . 0.38737284D+04,0.156D+03,0.610D+02,0.97970000D+00,0.00000000D+00
     .,0.37706523D+04,0.156D+03,0.620D+02,0.97970000D+00,0.00000000D+00
     .,0.36789146D+04,0.156D+03,0.630D+02,0.97970000D+00,0.00000000D+00
     .,0.27207653D+04,0.156D+03,0.640D+02,0.97970000D+00,0.00000000D+00
     .,0.34419852D+04,0.156D+03,0.650D+02,0.97970000D+00,0.00000000D+00
     .,0.32989422D+04,0.156D+03,0.660D+02,0.97970000D+00,0.00000000D+00
     .,0.32598698D+04,0.156D+03,0.670D+02,0.97970000D+00,0.00000000D+00
     .,0.31836011D+04,0.156D+03,0.680D+02,0.97970000D+00,0.00000000D+00
     .,0.31125536D+04,0.156D+03,0.690D+02,0.97970000D+00,0.00000000D+00
     .,0.30835002D+04,0.156D+03,0.700D+02,0.97970000D+00,0.00000000D+00
     .,0.25019262D+04,0.156D+03,0.710D+02,0.97970000D+00,0.00000000D+00
     .,0.22987008D+04,0.156D+03,0.720D+02,0.97970000D+00,0.00000000D+00
     .,0.20237991D+04,0.156D+03,0.730D+02,0.97970000D+00,0.00000000D+00
     .,0.16732640D+04,0.156D+03,0.740D+02,0.97970000D+00,0.00000000D+00
     .,0.16751136D+04,0.156D+03,0.750D+02,0.97970000D+00,0.00000000D+00
     .,0.14722933D+04,0.156D+03,0.760D+02,0.97970000D+00,0.00000000D+00
     .,0.13162117D+04,0.156D+03,0.770D+02,0.97970000D+00,0.00000000D+00
     .,0.10706911D+04,0.156D+03,0.780D+02,0.97970000D+00,0.00000000D+00
     .,0.99139190D+03,0.156D+03,0.790D+02,0.97970000D+00,0.00000000D+00
     .,0.10048014D+04,0.156D+03,0.800D+02,0.97970000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  52601:  52700)=(/
     . 0.16688986D+04,0.156D+03,0.810D+02,0.97970000D+00,0.00000000D+00
     .,0.15461030D+04,0.156D+03,0.820D+02,0.97970000D+00,0.00000000D+00
     .,0.13487488D+04,0.156D+03,0.830D+02,0.97970000D+00,0.00000000D+00
     .,0.12508513D+04,0.156D+03,0.840D+02,0.97970000D+00,0.00000000D+00
     .,0.11176702D+04,0.156D+03,0.850D+02,0.97970000D+00,0.00000000D+00
     .,0.99586790D+03,0.156D+03,0.860D+02,0.97970000D+00,0.00000000D+00
     .,0.54979393D+04,0.156D+03,0.870D+02,0.97970000D+00,0.00000000D+00
     .,0.46433162D+04,0.156D+03,0.880D+02,0.97970000D+00,0.00000000D+00
     .,0.38656041D+04,0.156D+03,0.890D+02,0.97970000D+00,0.00000000D+00
     .,0.32597257D+04,0.156D+03,0.900D+02,0.97970000D+00,0.00000000D+00
     .,0.33538826D+04,0.156D+03,0.910D+02,0.97970000D+00,0.00000000D+00
     .,0.32402913D+04,0.156D+03,0.920D+02,0.97970000D+00,0.00000000D+00
     .,0.34630576D+04,0.156D+03,0.930D+02,0.97970000D+00,0.00000000D+00
     .,0.33272478D+04,0.156D+03,0.940D+02,0.97970000D+00,0.00000000D+00
     .,0.14256800D+03,0.156D+03,0.101D+03,0.97970000D+00,0.00000000D+00
     .,0.55107920D+03,0.156D+03,0.103D+03,0.97970000D+00,0.98650000D+00
     .,0.69284150D+03,0.156D+03,0.104D+03,0.97970000D+00,0.98080000D+00
     .,0.47105030D+03,0.156D+03,0.105D+03,0.97970000D+00,0.97060000D+00
     .,0.33492070D+03,0.156D+03,0.106D+03,0.97970000D+00,0.98680000D+00
     .,0.21815960D+03,0.156D+03,0.107D+03,0.97970000D+00,0.99440000D+00
     ./)
      grimme_c6_parameters(  52701:  52800)=(/
     . 0.15070560D+03,0.156D+03,0.108D+03,0.97970000D+00,0.99250000D+00
     .,0.97192600D+02,0.156D+03,0.109D+03,0.97970000D+00,0.99820000D+00
     .,0.82695650D+03,0.156D+03,0.111D+03,0.97970000D+00,0.96840000D+00
     .,0.12989425D+04,0.156D+03,0.112D+03,0.97970000D+00,0.96280000D+00
     .,0.12335817D+04,0.156D+03,0.113D+03,0.97970000D+00,0.96480000D+00
     .,0.90965670D+03,0.156D+03,0.114D+03,0.97970000D+00,0.95070000D+00
     .,0.70099830D+03,0.156D+03,0.115D+03,0.97970000D+00,0.99470000D+00
     .,0.56985090D+03,0.156D+03,0.116D+03,0.97970000D+00,0.99480000D+00
     .,0.44736800D+03,0.156D+03,0.117D+03,0.97970000D+00,0.99720000D+00
     .,0.11041068D+04,0.156D+03,0.119D+03,0.97970000D+00,0.97670000D+00
     .,0.25056537D+04,0.156D+03,0.120D+03,0.97970000D+00,0.98310000D+00
     .,0.10130298D+04,0.156D+03,0.121D+03,0.97970000D+00,0.18627000D+01
     .,0.98236380D+03,0.156D+03,0.122D+03,0.97970000D+00,0.18299000D+01
     .,0.96327250D+03,0.156D+03,0.123D+03,0.97970000D+00,0.19138000D+01
     .,0.96365340D+03,0.156D+03,0.124D+03,0.97970000D+00,0.18269000D+01
     .,0.84521190D+03,0.156D+03,0.125D+03,0.97970000D+00,0.16406000D+01
     .,0.77366980D+03,0.156D+03,0.126D+03,0.97970000D+00,0.16483000D+01
     .,0.73950900D+03,0.156D+03,0.127D+03,0.97970000D+00,0.17149000D+01
     .,0.72552030D+03,0.156D+03,0.128D+03,0.97970000D+00,0.17937000D+01
     .,0.74098720D+03,0.156D+03,0.129D+03,0.97970000D+00,0.95760000D+00
     ./)
      grimme_c6_parameters(  52801:  52900)=(/
     . 0.65373360D+03,0.156D+03,0.130D+03,0.97970000D+00,0.19419000D+01
     .,0.11948773D+04,0.156D+03,0.131D+03,0.97970000D+00,0.96010000D+00
     .,0.97957420D+03,0.156D+03,0.132D+03,0.97970000D+00,0.94340000D+00
     .,0.83693640D+03,0.156D+03,0.133D+03,0.97970000D+00,0.98890000D+00
     .,0.74102200D+03,0.156D+03,0.134D+03,0.97970000D+00,0.99010000D+00
     .,0.63113970D+03,0.156D+03,0.135D+03,0.97970000D+00,0.99740000D+00
     .,0.13013999D+04,0.156D+03,0.137D+03,0.97970000D+00,0.97380000D+00
     .,0.30957594D+04,0.156D+03,0.138D+03,0.97970000D+00,0.98010000D+00
     .,0.21010372D+04,0.156D+03,0.139D+03,0.97970000D+00,0.19153000D+01
     .,0.13604000D+04,0.156D+03,0.140D+03,0.97970000D+00,0.19355000D+01
     .,0.13693825D+04,0.156D+03,0.141D+03,0.97970000D+00,0.19545000D+01
     .,0.12660803D+04,0.156D+03,0.142D+03,0.97970000D+00,0.19420000D+01
     .,0.15162134D+04,0.156D+03,0.143D+03,0.97970000D+00,0.16682000D+01
     .,0.10564422D+04,0.156D+03,0.144D+03,0.97970000D+00,0.18584000D+01
     .,0.98676430D+03,0.156D+03,0.145D+03,0.97970000D+00,0.19003000D+01
     .,0.91052680D+03,0.156D+03,0.146D+03,0.97970000D+00,0.18630000D+01
     .,0.88540390D+03,0.156D+03,0.147D+03,0.97970000D+00,0.96790000D+00
     .,0.84515800D+03,0.156D+03,0.148D+03,0.97970000D+00,0.19539000D+01
     .,0.15259278D+04,0.156D+03,0.149D+03,0.97970000D+00,0.96330000D+00
     .,0.12966408D+04,0.156D+03,0.150D+03,0.97970000D+00,0.95140000D+00
     ./)
      grimme_c6_parameters(  52901:  53000)=(/
     . 0.11653603D+04,0.156D+03,0.151D+03,0.97970000D+00,0.97490000D+00
     .,0.10738698D+04,0.156D+03,0.152D+03,0.97970000D+00,0.98110000D+00
     .,0.95154100D+03,0.156D+03,0.153D+03,0.97970000D+00,0.99680000D+00
     .,0.14690705D+04,0.156D+03,0.155D+03,0.97970000D+00,0.99090000D+00
     .,0.41717842D+04,0.156D+03,0.156D+03,0.97970000D+00,0.97970000D+00
     .,0.64690600D+02,0.157D+03,0.100D+01,0.19373000D+01,0.91180000D+00
     .,0.40332900D+02,0.157D+03,0.200D+01,0.19373000D+01,0.00000000D+00
     .,0.13841283D+04,0.157D+03,0.300D+01,0.19373000D+01,0.00000000D+00
     .,0.67673740D+03,0.157D+03,0.400D+01,0.19373000D+01,0.00000000D+00
     .,0.42308150D+03,0.157D+03,0.500D+01,0.19373000D+01,0.00000000D+00
     .,0.27142480D+03,0.157D+03,0.600D+01,0.19373000D+01,0.00000000D+00
     .,0.18293910D+03,0.157D+03,0.700D+01,0.19373000D+01,0.00000000D+00
     .,0.13503220D+03,0.157D+03,0.800D+01,0.19373000D+01,0.00000000D+00
     .,0.10010900D+03,0.157D+03,0.900D+01,0.19373000D+01,0.00000000D+00
     .,0.75679100D+02,0.157D+03,0.100D+02,0.19373000D+01,0.00000000D+00
     .,0.16377878D+04,0.157D+03,0.110D+02,0.19373000D+01,0.00000000D+00
     .,0.11067221D+04,0.157D+03,0.120D+02,0.19373000D+01,0.00000000D+00
     .,0.98043760D+03,0.157D+03,0.130D+02,0.19373000D+01,0.00000000D+00
     .,0.73212110D+03,0.157D+03,0.140D+02,0.19373000D+01,0.00000000D+00
     .,0.54746530D+03,0.157D+03,0.150D+02,0.19373000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53001:  53100)=(/
     . 0.44287990D+03,0.157D+03,0.160D+02,0.19373000D+01,0.00000000D+00
     .,0.35314670D+03,0.157D+03,0.170D+02,0.19373000D+01,0.00000000D+00
     .,0.28303510D+03,0.157D+03,0.180D+02,0.19373000D+01,0.00000000D+00
     .,0.28009569D+04,0.157D+03,0.190D+02,0.19373000D+01,0.00000000D+00
     .,0.20504253D+04,0.157D+03,0.200D+02,0.19373000D+01,0.00000000D+00
     .,0.16557011D+04,0.157D+03,0.210D+02,0.19373000D+01,0.00000000D+00
     .,0.15712363D+04,0.157D+03,0.220D+02,0.19373000D+01,0.00000000D+00
     .,0.14231173D+04,0.157D+03,0.230D+02,0.19373000D+01,0.00000000D+00
     .,0.11226576D+04,0.157D+03,0.240D+02,0.19373000D+01,0.00000000D+00
     .,0.12061393D+04,0.157D+03,0.250D+02,0.19373000D+01,0.00000000D+00
     .,0.94568080D+03,0.157D+03,0.260D+02,0.19373000D+01,0.00000000D+00
     .,0.97598360D+03,0.157D+03,0.270D+02,0.19373000D+01,0.00000000D+00
     .,0.10161745D+04,0.157D+03,0.280D+02,0.19373000D+01,0.00000000D+00
     .,0.78128810D+03,0.157D+03,0.290D+02,0.19373000D+01,0.00000000D+00
     .,0.77266500D+03,0.157D+03,0.300D+02,0.19373000D+01,0.00000000D+00
     .,0.92637230D+03,0.157D+03,0.310D+02,0.19373000D+01,0.00000000D+00
     .,0.78274010D+03,0.157D+03,0.320D+02,0.19373000D+01,0.00000000D+00
     .,0.64435600D+03,0.157D+03,0.330D+02,0.19373000D+01,0.00000000D+00
     .,0.56629200D+03,0.157D+03,0.340D+02,0.19373000D+01,0.00000000D+00
     .,0.48529550D+03,0.157D+03,0.350D+02,0.19373000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53101:  53200)=(/
     . 0.41416640D+03,0.157D+03,0.360D+02,0.19373000D+01,0.00000000D+00
     .,0.31215559D+04,0.157D+03,0.370D+02,0.19373000D+01,0.00000000D+00
     .,0.24580845D+04,0.157D+03,0.380D+02,0.19373000D+01,0.00000000D+00
     .,0.20727978D+04,0.157D+03,0.390D+02,0.19373000D+01,0.00000000D+00
     .,0.18212145D+04,0.157D+03,0.400D+02,0.19373000D+01,0.00000000D+00
     .,0.16379243D+04,0.157D+03,0.410D+02,0.19373000D+01,0.00000000D+00
     .,0.12356226D+04,0.157D+03,0.420D+02,0.19373000D+01,0.00000000D+00
     .,0.13909989D+04,0.157D+03,0.430D+02,0.19373000D+01,0.00000000D+00
     .,0.10325864D+04,0.157D+03,0.440D+02,0.19373000D+01,0.00000000D+00
     .,0.11254492D+04,0.157D+03,0.450D+02,0.19373000D+01,0.00000000D+00
     .,0.10341628D+04,0.157D+03,0.460D+02,0.19373000D+01,0.00000000D+00
     .,0.87041020D+03,0.157D+03,0.470D+02,0.19373000D+01,0.00000000D+00
     .,0.90076730D+03,0.157D+03,0.480D+02,0.19373000D+01,0.00000000D+00
     .,0.11640480D+04,0.157D+03,0.490D+02,0.19373000D+01,0.00000000D+00
     .,0.10373050D+04,0.157D+03,0.500D+02,0.19373000D+01,0.00000000D+00
     .,0.89470260D+03,0.157D+03,0.510D+02,0.19373000D+01,0.00000000D+00
     .,0.81481140D+03,0.157D+03,0.520D+02,0.19373000D+01,0.00000000D+00
     .,0.72249320D+03,0.157D+03,0.530D+02,0.19373000D+01,0.00000000D+00
     .,0.63795900D+03,0.157D+03,0.540D+02,0.19373000D+01,0.00000000D+00
     .,0.38250881D+04,0.157D+03,0.550D+02,0.19373000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53201:  53300)=(/
     . 0.31862921D+04,0.157D+03,0.560D+02,0.19373000D+01,0.00000000D+00
     .,0.26909591D+04,0.157D+03,0.570D+02,0.19373000D+01,0.00000000D+00
     .,0.10645933D+04,0.157D+03,0.580D+02,0.19373000D+01,0.27991000D+01
     .,0.27909891D+04,0.157D+03,0.590D+02,0.19373000D+01,0.00000000D+00
     .,0.26551171D+04,0.157D+03,0.600D+02,0.19373000D+01,0.00000000D+00
     .,0.25829722D+04,0.157D+03,0.610D+02,0.19373000D+01,0.00000000D+00
     .,0.25172239D+04,0.157D+03,0.620D+02,0.19373000D+01,0.00000000D+00
     .,0.24587886D+04,0.157D+03,0.630D+02,0.19373000D+01,0.00000000D+00
     .,0.18607370D+04,0.157D+03,0.640D+02,0.19373000D+01,0.00000000D+00
     .,0.22509654D+04,0.157D+03,0.650D+02,0.19373000D+01,0.00000000D+00
     .,0.21634599D+04,0.157D+03,0.660D+02,0.19373000D+01,0.00000000D+00
     .,0.21938636D+04,0.157D+03,0.670D+02,0.19373000D+01,0.00000000D+00
     .,0.21444704D+04,0.157D+03,0.680D+02,0.19373000D+01,0.00000000D+00
     .,0.20989702D+04,0.157D+03,0.690D+02,0.19373000D+01,0.00000000D+00
     .,0.20775774D+04,0.157D+03,0.700D+02,0.19373000D+01,0.00000000D+00
     .,0.17103545D+04,0.157D+03,0.710D+02,0.19373000D+01,0.00000000D+00
     .,0.16140907D+04,0.157D+03,0.720D+02,0.19373000D+01,0.00000000D+00
     .,0.14413394D+04,0.157D+03,0.730D+02,0.19373000D+01,0.00000000D+00
     .,0.12005662D+04,0.157D+03,0.740D+02,0.19373000D+01,0.00000000D+00
     .,0.12100818D+04,0.157D+03,0.750D+02,0.19373000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53301:  53400)=(/
     . 0.10767583D+04,0.157D+03,0.760D+02,0.19373000D+01,0.00000000D+00
     .,0.97197370D+03,0.157D+03,0.770D+02,0.19373000D+01,0.00000000D+00
     .,0.79670010D+03,0.157D+03,0.780D+02,0.19373000D+01,0.00000000D+00
     .,0.74016750D+03,0.157D+03,0.790D+02,0.19373000D+01,0.00000000D+00
     .,0.75524870D+03,0.157D+03,0.800D+02,0.19373000D+01,0.00000000D+00
     .,0.11891662D+04,0.157D+03,0.810D+02,0.19373000D+01,0.00000000D+00
     .,0.11270513D+04,0.157D+03,0.820D+02,0.19373000D+01,0.00000000D+00
     .,0.10045839D+04,0.157D+03,0.830D+02,0.19373000D+01,0.00000000D+00
     .,0.94243520D+03,0.157D+03,0.840D+02,0.19373000D+01,0.00000000D+00
     .,0.85327010D+03,0.157D+03,0.850D+02,0.19373000D+01,0.00000000D+00
     .,0.76899820D+03,0.157D+03,0.860D+02,0.19373000D+01,0.00000000D+00
     .,0.34855386D+04,0.157D+03,0.870D+02,0.19373000D+01,0.00000000D+00
     .,0.30892071D+04,0.157D+03,0.880D+02,0.19373000D+01,0.00000000D+00
     .,0.26322561D+04,0.157D+03,0.890D+02,0.19373000D+01,0.00000000D+00
     .,0.22749680D+04,0.157D+03,0.900D+02,0.19373000D+01,0.00000000D+00
     .,0.23071665D+04,0.157D+03,0.910D+02,0.19373000D+01,0.00000000D+00
     .,0.22309267D+04,0.157D+03,0.920D+02,0.19373000D+01,0.00000000D+00
     .,0.23502253D+04,0.157D+03,0.930D+02,0.19373000D+01,0.00000000D+00
     .,0.22650122D+04,0.157D+03,0.940D+02,0.19373000D+01,0.00000000D+00
     .,0.10830590D+03,0.157D+03,0.101D+03,0.19373000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53401:  53500)=(/
     . 0.38990700D+03,0.157D+03,0.103D+03,0.19373000D+01,0.98650000D+00
     .,0.49258240D+03,0.157D+03,0.104D+03,0.19373000D+01,0.98080000D+00
     .,0.35111660D+03,0.157D+03,0.105D+03,0.19373000D+01,0.97060000D+00
     .,0.25535340D+03,0.157D+03,0.106D+03,0.19373000D+01,0.98680000D+00
     .,0.17069380D+03,0.157D+03,0.107D+03,0.19373000D+01,0.99440000D+00
     .,0.12040040D+03,0.157D+03,0.108D+03,0.19373000D+01,0.99250000D+00
     .,0.79615100D+02,0.157D+03,0.109D+03,0.19373000D+01,0.99820000D+00
     .,0.57870070D+03,0.157D+03,0.111D+03,0.19373000D+01,0.96840000D+00
     .,0.90345630D+03,0.157D+03,0.112D+03,0.19373000D+01,0.96280000D+00
     .,0.88049000D+03,0.157D+03,0.113D+03,0.19373000D+01,0.96480000D+00
     .,0.67215910D+03,0.157D+03,0.114D+03,0.19373000D+01,0.95070000D+00
     .,0.53085730D+03,0.157D+03,0.115D+03,0.19373000D+01,0.99470000D+00
     .,0.43834960D+03,0.157D+03,0.116D+03,0.19373000D+01,0.99480000D+00
     .,0.34967640D+03,0.157D+03,0.117D+03,0.19373000D+01,0.99720000D+00
     .,0.78068060D+03,0.157D+03,0.119D+03,0.19373000D+01,0.97670000D+00
     .,0.16583459D+04,0.157D+03,0.120D+03,0.19373000D+01,0.98310000D+00
     .,0.74263980D+03,0.157D+03,0.121D+03,0.19373000D+01,0.18627000D+01
     .,0.71867820D+03,0.157D+03,0.122D+03,0.19373000D+01,0.18299000D+01
     .,0.70447310D+03,0.157D+03,0.123D+03,0.19373000D+01,0.19138000D+01
     .,0.70187680D+03,0.157D+03,0.124D+03,0.19373000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters(  53501:  53600)=(/
     . 0.62823400D+03,0.157D+03,0.125D+03,0.19373000D+01,0.16406000D+01
     .,0.57752630D+03,0.157D+03,0.126D+03,0.19373000D+01,0.16483000D+01
     .,0.55142260D+03,0.157D+03,0.127D+03,0.19373000D+01,0.17149000D+01
     .,0.54016790D+03,0.157D+03,0.128D+03,0.19373000D+01,0.17937000D+01
     .,0.54406610D+03,0.157D+03,0.129D+03,0.19373000D+01,0.95760000D+00
     .,0.49263420D+03,0.157D+03,0.130D+03,0.19373000D+01,0.19419000D+01
     .,0.86066320D+03,0.157D+03,0.131D+03,0.19373000D+01,0.96010000D+00
     .,0.72574740D+03,0.157D+03,0.132D+03,0.19373000D+01,0.94340000D+00
     .,0.63226020D+03,0.157D+03,0.133D+03,0.19373000D+01,0.98890000D+00
     .,0.56675130D+03,0.157D+03,0.134D+03,0.19373000D+01,0.99010000D+00
     .,0.48922910D+03,0.157D+03,0.135D+03,0.19373000D+01,0.99740000D+00
     .,0.92422030D+03,0.157D+03,0.137D+03,0.19373000D+01,0.97380000D+00
     .,0.20365362D+04,0.157D+03,0.138D+03,0.19373000D+01,0.98010000D+00
     .,0.14462394D+04,0.157D+03,0.139D+03,0.19373000D+01,0.19153000D+01
     .,0.99010590D+03,0.157D+03,0.140D+03,0.19373000D+01,0.19355000D+01
     .,0.99792220D+03,0.157D+03,0.141D+03,0.19373000D+01,0.19545000D+01
     .,0.92583590D+03,0.157D+03,0.142D+03,0.19373000D+01,0.19420000D+01
     .,0.10787908D+04,0.157D+03,0.143D+03,0.19373000D+01,0.16682000D+01
     .,0.78658860D+03,0.157D+03,0.144D+03,0.19373000D+01,0.18584000D+01
     .,0.73489180D+03,0.157D+03,0.145D+03,0.19373000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters(  53601:  53700)=(/
     . 0.67965720D+03,0.157D+03,0.146D+03,0.19373000D+01,0.18630000D+01
     .,0.65947100D+03,0.157D+03,0.147D+03,0.19373000D+01,0.96790000D+00
     .,0.63938320D+03,0.157D+03,0.148D+03,0.19373000D+01,0.19539000D+01
     .,0.10954590D+04,0.157D+03,0.149D+03,0.19373000D+01,0.96330000D+00
     .,0.95522580D+03,0.157D+03,0.150D+03,0.19373000D+01,0.95140000D+00
     .,0.87322870D+03,0.157D+03,0.151D+03,0.19373000D+01,0.97490000D+00
     .,0.81328280D+03,0.157D+03,0.152D+03,0.19373000D+01,0.98110000D+00
     .,0.72949490D+03,0.157D+03,0.153D+03,0.19373000D+01,0.99680000D+00
     .,0.10633274D+04,0.157D+03,0.155D+03,0.19373000D+01,0.99090000D+00
     .,0.27055816D+04,0.157D+03,0.156D+03,0.19373000D+01,0.97970000D+00
     .,0.18500003D+04,0.157D+03,0.157D+03,0.19373000D+01,0.19373000D+01
     .,0.43220200D+02,0.159D+03,0.100D+01,0.29425000D+01,0.91180000D+00
     .,0.28506000D+02,0.159D+03,0.200D+01,0.29425000D+01,0.00000000D+00
     .,0.68024790D+03,0.159D+03,0.300D+01,0.29425000D+01,0.00000000D+00
     .,0.39079830D+03,0.159D+03,0.400D+01,0.29425000D+01,0.00000000D+00
     .,0.26231920D+03,0.159D+03,0.500D+01,0.29425000D+01,0.00000000D+00
     .,0.17683390D+03,0.159D+03,0.600D+01,0.29425000D+01,0.00000000D+00
     .,0.12349550D+03,0.159D+03,0.700D+01,0.29425000D+01,0.00000000D+00
     .,0.93432700D+02,0.159D+03,0.800D+01,0.29425000D+01,0.00000000D+00
     .,0.70748100D+02,0.159D+03,0.900D+01,0.29425000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53701:  53800)=(/
     . 0.54406100D+02,0.159D+03,0.100D+02,0.29425000D+01,0.00000000D+00
     .,0.81323530D+03,0.159D+03,0.110D+02,0.29425000D+01,0.00000000D+00
     .,0.62332230D+03,0.159D+03,0.120D+02,0.29425000D+01,0.00000000D+00
     .,0.57359020D+03,0.159D+03,0.130D+02,0.29425000D+01,0.00000000D+00
     .,0.45092530D+03,0.159D+03,0.140D+02,0.29425000D+01,0.00000000D+00
     .,0.35095780D+03,0.159D+03,0.150D+02,0.29425000D+01,0.00000000D+00
     .,0.29093690D+03,0.159D+03,0.160D+02,0.29425000D+01,0.00000000D+00
     .,0.23740720D+03,0.159D+03,0.170D+02,0.29425000D+01,0.00000000D+00
     .,0.19406980D+03,0.159D+03,0.180D+02,0.29425000D+01,0.00000000D+00
     .,0.13337958D+04,0.159D+03,0.190D+02,0.29425000D+01,0.00000000D+00
     .,0.10971659D+04,0.159D+03,0.200D+02,0.29425000D+01,0.00000000D+00
     .,0.90572410D+03,0.159D+03,0.210D+02,0.29425000D+01,0.00000000D+00
     .,0.87400660D+03,0.159D+03,0.220D+02,0.29425000D+01,0.00000000D+00
     .,0.80001520D+03,0.159D+03,0.230D+02,0.29425000D+01,0.00000000D+00
     .,0.63019610D+03,0.159D+03,0.240D+02,0.29425000D+01,0.00000000D+00
     .,0.68836930D+03,0.159D+03,0.250D+02,0.29425000D+01,0.00000000D+00
     .,0.54023110D+03,0.159D+03,0.260D+02,0.29425000D+01,0.00000000D+00
     .,0.57207380D+03,0.159D+03,0.270D+02,0.29425000D+01,0.00000000D+00
     .,0.58956950D+03,0.159D+03,0.280D+02,0.29425000D+01,0.00000000D+00
     .,0.45203420D+03,0.159D+03,0.290D+02,0.29425000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53801:  53900)=(/
     . 0.46341480D+03,0.159D+03,0.300D+02,0.29425000D+01,0.00000000D+00
     .,0.54906920D+03,0.159D+03,0.310D+02,0.29425000D+01,0.00000000D+00
     .,0.48331740D+03,0.159D+03,0.320D+02,0.29425000D+01,0.00000000D+00
     .,0.41155330D+03,0.159D+03,0.330D+02,0.29425000D+01,0.00000000D+00
     .,0.36892060D+03,0.159D+03,0.340D+02,0.29425000D+01,0.00000000D+00
     .,0.32252720D+03,0.159D+03,0.350D+02,0.29425000D+01,0.00000000D+00
     .,0.28024380D+03,0.159D+03,0.360D+02,0.29425000D+01,0.00000000D+00
     .,0.14944074D+04,0.159D+03,0.370D+02,0.29425000D+01,0.00000000D+00
     .,0.13073665D+04,0.159D+03,0.380D+02,0.29425000D+01,0.00000000D+00
     .,0.11435524D+04,0.159D+03,0.390D+02,0.29425000D+01,0.00000000D+00
     .,0.10268226D+04,0.159D+03,0.400D+02,0.29425000D+01,0.00000000D+00
     .,0.93574670D+03,0.159D+03,0.410D+02,0.29425000D+01,0.00000000D+00
     .,0.72166730D+03,0.159D+03,0.420D+02,0.29425000D+01,0.00000000D+00
     .,0.80551110D+03,0.159D+03,0.430D+02,0.29425000D+01,0.00000000D+00
     .,0.61296820D+03,0.159D+03,0.440D+02,0.29425000D+01,0.00000000D+00
     .,0.66999170D+03,0.159D+03,0.450D+02,0.29425000D+01,0.00000000D+00
     .,0.62106870D+03,0.159D+03,0.460D+02,0.29425000D+01,0.00000000D+00
     .,0.51802070D+03,0.159D+03,0.470D+02,0.29425000D+01,0.00000000D+00
     .,0.54699380D+03,0.159D+03,0.480D+02,0.29425000D+01,0.00000000D+00
     .,0.68726670D+03,0.159D+03,0.490D+02,0.29425000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  53901:  54000)=(/
     . 0.63451560D+03,0.159D+03,0.500D+02,0.29425000D+01,0.00000000D+00
     .,0.56457530D+03,0.159D+03,0.510D+02,0.29425000D+01,0.00000000D+00
     .,0.52332050D+03,0.159D+03,0.520D+02,0.29425000D+01,0.00000000D+00
     .,0.47270040D+03,0.159D+03,0.530D+02,0.29425000D+01,0.00000000D+00
     .,0.42459150D+03,0.159D+03,0.540D+02,0.29425000D+01,0.00000000D+00
     .,0.18204201D+04,0.159D+03,0.550D+02,0.29425000D+01,0.00000000D+00
     .,0.16674685D+04,0.159D+03,0.560D+02,0.29425000D+01,0.00000000D+00
     .,0.14628142D+04,0.159D+03,0.570D+02,0.29425000D+01,0.00000000D+00
     .,0.66720180D+03,0.159D+03,0.580D+02,0.29425000D+01,0.27991000D+01
     .,0.14767389D+04,0.159D+03,0.590D+02,0.29425000D+01,0.00000000D+00
     .,0.14176855D+04,0.159D+03,0.600D+02,0.29425000D+01,0.00000000D+00
     .,0.13820320D+04,0.159D+03,0.610D+02,0.29425000D+01,0.00000000D+00
     .,0.13492524D+04,0.159D+03,0.620D+02,0.29425000D+01,0.00000000D+00
     .,0.13201809D+04,0.159D+03,0.630D+02,0.29425000D+01,0.00000000D+00
     .,0.10364403D+04,0.159D+03,0.640D+02,0.29425000D+01,0.00000000D+00
     .,0.11696897D+04,0.159D+03,0.650D+02,0.29425000D+01,0.00000000D+00
     .,0.11277999D+04,0.159D+03,0.660D+02,0.29425000D+01,0.00000000D+00
     .,0.11902918D+04,0.159D+03,0.670D+02,0.29425000D+01,0.00000000D+00
     .,0.11649825D+04,0.159D+03,0.680D+02,0.29425000D+01,0.00000000D+00
     .,0.11421370D+04,0.159D+03,0.690D+02,0.29425000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54001:  54100)=(/
     . 0.11288548D+04,0.159D+03,0.700D+02,0.29425000D+01,0.00000000D+00
     .,0.95004210D+03,0.159D+03,0.710D+02,0.29425000D+01,0.00000000D+00
     .,0.93285060D+03,0.159D+03,0.720D+02,0.29425000D+01,0.00000000D+00
     .,0.85051620D+03,0.159D+03,0.730D+02,0.29425000D+01,0.00000000D+00
     .,0.71766720D+03,0.159D+03,0.740D+02,0.29425000D+01,0.00000000D+00
     .,0.72982300D+03,0.159D+03,0.750D+02,0.29425000D+01,0.00000000D+00
     .,0.66090480D+03,0.159D+03,0.760D+02,0.29425000D+01,0.00000000D+00
     .,0.60487530D+03,0.159D+03,0.770D+02,0.29425000D+01,0.00000000D+00
     .,0.50215100D+03,0.159D+03,0.780D+02,0.29425000D+01,0.00000000D+00
     .,0.46904220D+03,0.159D+03,0.790D+02,0.29425000D+01,0.00000000D+00
     .,0.48234510D+03,0.159D+03,0.800D+02,0.29425000D+01,0.00000000D+00
     .,0.70537820D+03,0.159D+03,0.810D+02,0.29425000D+01,0.00000000D+00
     .,0.68881010D+03,0.159D+03,0.820D+02,0.29425000D+01,0.00000000D+00
     .,0.63203130D+03,0.159D+03,0.830D+02,0.29425000D+01,0.00000000D+00
     .,0.60229480D+03,0.159D+03,0.840D+02,0.29425000D+01,0.00000000D+00
     .,0.55531140D+03,0.159D+03,0.850D+02,0.29425000D+01,0.00000000D+00
     .,0.50853060D+03,0.159D+03,0.860D+02,0.29425000D+01,0.00000000D+00
     .,0.17169108D+04,0.159D+03,0.870D+02,0.29425000D+01,0.00000000D+00
     .,0.16476121D+04,0.159D+03,0.880D+02,0.29425000D+01,0.00000000D+00
     .,0.14543881D+04,0.159D+03,0.890D+02,0.29425000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54101:  54200)=(/
     . 0.13048970D+04,0.159D+03,0.900D+02,0.29425000D+01,0.00000000D+00
     .,0.12966238D+04,0.159D+03,0.910D+02,0.29425000D+01,0.00000000D+00
     .,0.12554359D+04,0.159D+03,0.920D+02,0.29425000D+01,0.00000000D+00
     .,0.12939094D+04,0.159D+03,0.930D+02,0.29425000D+01,0.00000000D+00
     .,0.12527870D+04,0.159D+03,0.940D+02,0.29425000D+01,0.00000000D+00
     .,0.69734100D+02,0.159D+03,0.101D+03,0.29425000D+01,0.00000000D+00
     .,0.22705790D+03,0.159D+03,0.103D+03,0.29425000D+01,0.98650000D+00
     .,0.28944340D+03,0.159D+03,0.104D+03,0.29425000D+01,0.98080000D+00
     .,0.22051700D+03,0.159D+03,0.105D+03,0.29425000D+01,0.97060000D+00
     .,0.16588050D+03,0.159D+03,0.106D+03,0.29425000D+01,0.98680000D+00
     .,0.11516050D+03,0.159D+03,0.107D+03,0.29425000D+01,0.99440000D+00
     .,0.83776500D+02,0.159D+03,0.108D+03,0.29425000D+01,0.99250000D+00
     .,0.57559900D+02,0.159D+03,0.109D+03,0.29425000D+01,0.99820000D+00
     .,0.33214950D+03,0.159D+03,0.111D+03,0.29425000D+01,0.96840000D+00
     .,0.51379560D+03,0.159D+03,0.112D+03,0.29425000D+01,0.96280000D+00
     .,0.51961650D+03,0.159D+03,0.113D+03,0.29425000D+01,0.96480000D+00
     .,0.41662720D+03,0.159D+03,0.114D+03,0.29425000D+01,0.95070000D+00
     .,0.34064700D+03,0.159D+03,0.115D+03,0.29425000D+01,0.99470000D+00
     .,0.28774490D+03,0.159D+03,0.116D+03,0.29425000D+01,0.99480000D+00
     .,0.23495440D+03,0.159D+03,0.117D+03,0.29425000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters(  54201:  54300)=(/
     . 0.45743380D+03,0.159D+03,0.119D+03,0.29425000D+01,0.97670000D+00
     .,0.87755280D+03,0.159D+03,0.120D+03,0.29425000D+01,0.98310000D+00
     .,0.45670870D+03,0.159D+03,0.121D+03,0.29425000D+01,0.18627000D+01
     .,0.44087260D+03,0.159D+03,0.122D+03,0.29425000D+01,0.18299000D+01
     .,0.43208390D+03,0.159D+03,0.123D+03,0.29425000D+01,0.19138000D+01
     .,0.42819360D+03,0.159D+03,0.124D+03,0.29425000D+01,0.18269000D+01
     .,0.39355560D+03,0.159D+03,0.125D+03,0.29425000D+01,0.16406000D+01
     .,0.36411700D+03,0.159D+03,0.126D+03,0.29425000D+01,0.16483000D+01
     .,0.34735660D+03,0.159D+03,0.127D+03,0.29425000D+01,0.17149000D+01
     .,0.33962320D+03,0.159D+03,0.128D+03,0.29425000D+01,0.17937000D+01
     .,0.33586060D+03,0.159D+03,0.129D+03,0.29425000D+01,0.95760000D+00
     .,0.31461930D+03,0.159D+03,0.130D+03,0.29425000D+01,0.19419000D+01
     .,0.51545120D+03,0.159D+03,0.131D+03,0.29425000D+01,0.96010000D+00
     .,0.45195710D+03,0.159D+03,0.132D+03,0.29425000D+01,0.94340000D+00
     .,0.40453400D+03,0.159D+03,0.133D+03,0.29425000D+01,0.98890000D+00
     .,0.36906970D+03,0.159D+03,0.134D+03,0.29425000D+01,0.99010000D+00
     .,0.32478940D+03,0.159D+03,0.135D+03,0.29425000D+01,0.99740000D+00
     .,0.54559170D+03,0.159D+03,0.137D+03,0.29425000D+01,0.97380000D+00
     .,0.10680684D+04,0.159D+03,0.138D+03,0.29425000D+01,0.98010000D+00
     .,0.81406370D+03,0.159D+03,0.139D+03,0.29425000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters(  54301:  54400)=(/
     . 0.60412500D+03,0.159D+03,0.140D+03,0.29425000D+01,0.19355000D+01
     .,0.61013660D+03,0.159D+03,0.141D+03,0.29425000D+01,0.19545000D+01
     .,0.56871480D+03,0.159D+03,0.142D+03,0.29425000D+01,0.19420000D+01
     .,0.63873760D+03,0.159D+03,0.143D+03,0.29425000D+01,0.16682000D+01
     .,0.49520560D+03,0.159D+03,0.144D+03,0.29425000D+01,0.18584000D+01
     .,0.46324120D+03,0.159D+03,0.145D+03,0.29425000D+01,0.19003000D+01
     .,0.43008630D+03,0.159D+03,0.146D+03,0.29425000D+01,0.18630000D+01
     .,0.41612810D+03,0.159D+03,0.147D+03,0.29425000D+01,0.96790000D+00
     .,0.41129410D+03,0.159D+03,0.148D+03,0.29425000D+01,0.19539000D+01
     .,0.65474970D+03,0.159D+03,0.149D+03,0.29425000D+01,0.96330000D+00
     .,0.59136710D+03,0.159D+03,0.150D+03,0.29425000D+01,0.95140000D+00
     .,0.55320050D+03,0.159D+03,0.151D+03,0.29425000D+01,0.97490000D+00
     .,0.52290670D+03,0.159D+03,0.152D+03,0.29425000D+01,0.98110000D+00
     .,0.47714300D+03,0.159D+03,0.153D+03,0.29425000D+01,0.99680000D+00
     .,0.64438580D+03,0.159D+03,0.155D+03,0.29425000D+01,0.99090000D+00
     .,0.13856402D+04,0.159D+03,0.156D+03,0.29425000D+01,0.97970000D+00
     .,0.10306163D+04,0.159D+03,0.157D+03,0.29425000D+01,0.19373000D+01
     .,0.64702500D+03,0.159D+03,0.159D+03,0.29425000D+01,0.29425000D+01
     .,0.42334300D+02,0.160D+03,0.100D+01,0.29455000D+01,0.91180000D+00
     .,0.27932400D+02,0.160D+03,0.200D+01,0.29455000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54401:  54500)=(/
     . 0.66553290D+03,0.160D+03,0.300D+01,0.29455000D+01,0.00000000D+00
     .,0.38257600D+03,0.160D+03,0.400D+01,0.29455000D+01,0.00000000D+00
     .,0.25686460D+03,0.160D+03,0.500D+01,0.29455000D+01,0.00000000D+00
     .,0.17319330D+03,0.160D+03,0.600D+01,0.29455000D+01,0.00000000D+00
     .,0.12097590D+03,0.160D+03,0.700D+01,0.29455000D+01,0.00000000D+00
     .,0.91540700D+02,0.160D+03,0.800D+01,0.29455000D+01,0.00000000D+00
     .,0.69326100D+02,0.160D+03,0.900D+01,0.29455000D+01,0.00000000D+00
     .,0.53320100D+02,0.160D+03,0.100D+02,0.29455000D+01,0.00000000D+00
     .,0.79568730D+03,0.160D+03,0.110D+02,0.29455000D+01,0.00000000D+00
     .,0.61016250D+03,0.160D+03,0.120D+02,0.29455000D+01,0.00000000D+00
     .,0.56154980D+03,0.160D+03,0.130D+02,0.29455000D+01,0.00000000D+00
     .,0.44153690D+03,0.160D+03,0.140D+02,0.29455000D+01,0.00000000D+00
     .,0.34370190D+03,0.160D+03,0.150D+02,0.29455000D+01,0.00000000D+00
     .,0.28495290D+03,0.160D+03,0.160D+02,0.29455000D+01,0.00000000D+00
     .,0.23255130D+03,0.160D+03,0.170D+02,0.29455000D+01,0.00000000D+00
     .,0.19012240D+03,0.160D+03,0.180D+02,0.29455000D+01,0.00000000D+00
     .,0.13047563D+04,0.160D+03,0.190D+02,0.29455000D+01,0.00000000D+00
     .,0.10738235D+04,0.160D+03,0.200D+02,0.29455000D+01,0.00000000D+00
     .,0.88652660D+03,0.160D+03,0.210D+02,0.29455000D+01,0.00000000D+00
     .,0.85553540D+03,0.160D+03,0.220D+02,0.29455000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54501:  54600)=(/
     . 0.78313860D+03,0.160D+03,0.230D+02,0.29455000D+01,0.00000000D+00
     .,0.61691000D+03,0.160D+03,0.240D+02,0.29455000D+01,0.00000000D+00
     .,0.67388620D+03,0.160D+03,0.250D+02,0.29455000D+01,0.00000000D+00
     .,0.52887800D+03,0.160D+03,0.260D+02,0.29455000D+01,0.00000000D+00
     .,0.56009170D+03,0.160D+03,0.270D+02,0.29455000D+01,0.00000000D+00
     .,0.57719940D+03,0.160D+03,0.280D+02,0.29455000D+01,0.00000000D+00
     .,0.44255790D+03,0.160D+03,0.290D+02,0.29455000D+01,0.00000000D+00
     .,0.45374620D+03,0.160D+03,0.300D+02,0.29455000D+01,0.00000000D+00
     .,0.53757900D+03,0.160D+03,0.310D+02,0.29455000D+01,0.00000000D+00
     .,0.47326730D+03,0.160D+03,0.320D+02,0.29455000D+01,0.00000000D+00
     .,0.40304410D+03,0.160D+03,0.330D+02,0.29455000D+01,0.00000000D+00
     .,0.36132220D+03,0.160D+03,0.340D+02,0.29455000D+01,0.00000000D+00
     .,0.31591320D+03,0.160D+03,0.350D+02,0.29455000D+01,0.00000000D+00
     .,0.27452240D+03,0.160D+03,0.360D+02,0.29455000D+01,0.00000000D+00
     .,0.14619055D+04,0.160D+03,0.370D+02,0.29455000D+01,0.00000000D+00
     .,0.12795273D+04,0.160D+03,0.380D+02,0.29455000D+01,0.00000000D+00
     .,0.11193527D+04,0.160D+03,0.390D+02,0.29455000D+01,0.00000000D+00
     .,0.10051742D+04,0.160D+03,0.400D+02,0.29455000D+01,0.00000000D+00
     .,0.91606480D+03,0.160D+03,0.410D+02,0.29455000D+01,0.00000000D+00
     .,0.70655730D+03,0.160D+03,0.420D+02,0.29455000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54601:  54700)=(/
     . 0.78861510D+03,0.160D+03,0.430D+02,0.29455000D+01,0.00000000D+00
     .,0.60017770D+03,0.160D+03,0.440D+02,0.29455000D+01,0.00000000D+00
     .,0.65600920D+03,0.160D+03,0.450D+02,0.29455000D+01,0.00000000D+00
     .,0.60812890D+03,0.160D+03,0.460D+02,0.29455000D+01,0.00000000D+00
     .,0.50722690D+03,0.160D+03,0.470D+02,0.29455000D+01,0.00000000D+00
     .,0.53562280D+03,0.160D+03,0.480D+02,0.29455000D+01,0.00000000D+00
     .,0.67289960D+03,0.160D+03,0.490D+02,0.29455000D+01,0.00000000D+00
     .,0.62132160D+03,0.160D+03,0.500D+02,0.29455000D+01,0.00000000D+00
     .,0.55289340D+03,0.160D+03,0.510D+02,0.29455000D+01,0.00000000D+00
     .,0.51252450D+03,0.160D+03,0.520D+02,0.29455000D+01,0.00000000D+00
     .,0.46298250D+03,0.160D+03,0.530D+02,0.29455000D+01,0.00000000D+00
     .,0.41589380D+03,0.160D+03,0.540D+02,0.29455000D+01,0.00000000D+00
     .,0.17807379D+04,0.160D+03,0.550D+02,0.29455000D+01,0.00000000D+00
     .,0.16318559D+04,0.160D+03,0.560D+02,0.29455000D+01,0.00000000D+00
     .,0.14317796D+04,0.160D+03,0.570D+02,0.29455000D+01,0.00000000D+00
     .,0.65338750D+03,0.160D+03,0.580D+02,0.29455000D+01,0.27991000D+01
     .,0.14452611D+04,0.160D+03,0.590D+02,0.29455000D+01,0.00000000D+00
     .,0.13875284D+04,0.160D+03,0.600D+02,0.29455000D+01,0.00000000D+00
     .,0.13526449D+04,0.160D+03,0.610D+02,0.29455000D+01,0.00000000D+00
     .,0.13205717D+04,0.160D+03,0.620D+02,0.29455000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54701:  54800)=(/
     . 0.12921268D+04,0.160D+03,0.630D+02,0.29455000D+01,0.00000000D+00
     .,0.10145593D+04,0.160D+03,0.640D+02,0.29455000D+01,0.00000000D+00
     .,0.11446770D+04,0.160D+03,0.650D+02,0.29455000D+01,0.00000000D+00
     .,0.11036788D+04,0.160D+03,0.660D+02,0.29455000D+01,0.00000000D+00
     .,0.11650450D+04,0.160D+03,0.670D+02,0.29455000D+01,0.00000000D+00
     .,0.11402779D+04,0.160D+03,0.680D+02,0.29455000D+01,0.00000000D+00
     .,0.11179234D+04,0.160D+03,0.690D+02,0.29455000D+01,0.00000000D+00
     .,0.11049164D+04,0.160D+03,0.700D+02,0.29455000D+01,0.00000000D+00
     .,0.92996320D+03,0.160D+03,0.710D+02,0.29455000D+01,0.00000000D+00
     .,0.91326380D+03,0.160D+03,0.720D+02,0.29455000D+01,0.00000000D+00
     .,0.83272290D+03,0.160D+03,0.730D+02,0.29455000D+01,0.00000000D+00
     .,0.70269660D+03,0.160D+03,0.740D+02,0.29455000D+01,0.00000000D+00
     .,0.71461940D+03,0.160D+03,0.750D+02,0.29455000D+01,0.00000000D+00
     .,0.64718140D+03,0.160D+03,0.760D+02,0.29455000D+01,0.00000000D+00
     .,0.59234880D+03,0.160D+03,0.770D+02,0.29455000D+01,0.00000000D+00
     .,0.49178730D+03,0.160D+03,0.780D+02,0.29455000D+01,0.00000000D+00
     .,0.45937630D+03,0.160D+03,0.790D+02,0.29455000D+01,0.00000000D+00
     .,0.47241230D+03,0.160D+03,0.800D+02,0.29455000D+01,0.00000000D+00
     .,0.69065930D+03,0.160D+03,0.810D+02,0.29455000D+01,0.00000000D+00
     .,0.67450000D+03,0.160D+03,0.820D+02,0.29455000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  54801:  54900)=(/
     . 0.61895970D+03,0.160D+03,0.830D+02,0.29455000D+01,0.00000000D+00
     .,0.58986940D+03,0.160D+03,0.840D+02,0.29455000D+01,0.00000000D+00
     .,0.54389180D+03,0.160D+03,0.850D+02,0.29455000D+01,0.00000000D+00
     .,0.49810570D+03,0.160D+03,0.860D+02,0.29455000D+01,0.00000000D+00
     .,0.16797710D+04,0.160D+03,0.870D+02,0.29455000D+01,0.00000000D+00
     .,0.16125437D+04,0.160D+03,0.880D+02,0.29455000D+01,0.00000000D+00
     .,0.14236214D+04,0.160D+03,0.890D+02,0.29455000D+01,0.00000000D+00
     .,0.12774745D+04,0.160D+03,0.900D+02,0.29455000D+01,0.00000000D+00
     .,0.12692909D+04,0.160D+03,0.910D+02,0.29455000D+01,0.00000000D+00
     .,0.12289809D+04,0.160D+03,0.920D+02,0.29455000D+01,0.00000000D+00
     .,0.12665506D+04,0.160D+03,0.930D+02,0.29455000D+01,0.00000000D+00
     .,0.12263194D+04,0.160D+03,0.940D+02,0.29455000D+01,0.00000000D+00
     .,0.68293100D+02,0.160D+03,0.101D+03,0.29455000D+01,0.00000000D+00
     .,0.22228830D+03,0.160D+03,0.103D+03,0.29455000D+01,0.98650000D+00
     .,0.28337150D+03,0.160D+03,0.104D+03,0.29455000D+01,0.98080000D+00
     .,0.21594380D+03,0.160D+03,0.105D+03,0.29455000D+01,0.97060000D+00
     .,0.16246650D+03,0.160D+03,0.106D+03,0.29455000D+01,0.98680000D+00
     .,0.11281340D+03,0.160D+03,0.107D+03,0.29455000D+01,0.99440000D+00
     .,0.82084900D+02,0.160D+03,0.108D+03,0.29455000D+01,0.99250000D+00
     .,0.56411700D+02,0.160D+03,0.109D+03,0.29455000D+01,0.99820000D+00
     ./)
      grimme_c6_parameters(  54901:  55000)=(/
     . 0.32516360D+03,0.160D+03,0.111D+03,0.29455000D+01,0.96840000D+00
     .,0.50296550D+03,0.160D+03,0.112D+03,0.29455000D+01,0.96280000D+00
     .,0.50872500D+03,0.160D+03,0.113D+03,0.29455000D+01,0.96480000D+00
     .,0.40796290D+03,0.160D+03,0.114D+03,0.29455000D+01,0.95070000D+00
     .,0.33360650D+03,0.160D+03,0.115D+03,0.29455000D+01,0.99470000D+00
     .,0.28182650D+03,0.160D+03,0.116D+03,0.29455000D+01,0.99480000D+00
     .,0.23014880D+03,0.160D+03,0.117D+03,0.29455000D+01,0.99720000D+00
     .,0.44786360D+03,0.160D+03,0.119D+03,0.29455000D+01,0.97670000D+00
     .,0.85883830D+03,0.160D+03,0.120D+03,0.29455000D+01,0.98310000D+00
     .,0.44722200D+03,0.160D+03,0.121D+03,0.29455000D+01,0.18627000D+01
     .,0.43170970D+03,0.160D+03,0.122D+03,0.29455000D+01,0.18299000D+01
     .,0.42310550D+03,0.160D+03,0.123D+03,0.29455000D+01,0.19138000D+01
     .,0.41928980D+03,0.160D+03,0.124D+03,0.29455000D+01,0.18269000D+01
     .,0.38540430D+03,0.160D+03,0.125D+03,0.29455000D+01,0.16406000D+01
     .,0.35658500D+03,0.160D+03,0.126D+03,0.29455000D+01,0.16483000D+01
     .,0.34017190D+03,0.160D+03,0.127D+03,0.29455000D+01,0.17149000D+01
     .,0.33259710D+03,0.160D+03,0.128D+03,0.29455000D+01,0.17937000D+01
     .,0.32889540D+03,0.160D+03,0.129D+03,0.29455000D+01,0.95760000D+00
     .,0.30812510D+03,0.160D+03,0.130D+03,0.29455000D+01,0.19419000D+01
     .,0.50468300D+03,0.160D+03,0.131D+03,0.29455000D+01,0.96010000D+00
     ./)
      grimme_c6_parameters(  55001:  55100)=(/
     . 0.44257280D+03,0.160D+03,0.132D+03,0.29455000D+01,0.94340000D+00
     .,0.39617290D+03,0.160D+03,0.133D+03,0.29455000D+01,0.98890000D+00
     .,0.36146790D+03,0.160D+03,0.134D+03,0.29455000D+01,0.99010000D+00
     .,0.31812780D+03,0.160D+03,0.135D+03,0.29455000D+01,0.99740000D+00
     .,0.53419470D+03,0.160D+03,0.137D+03,0.29455000D+01,0.97380000D+00
     .,0.10452541D+04,0.160D+03,0.138D+03,0.29455000D+01,0.98010000D+00
     .,0.79688440D+03,0.160D+03,0.139D+03,0.29455000D+01,0.19153000D+01
     .,0.59156300D+03,0.160D+03,0.140D+03,0.29455000D+01,0.19355000D+01
     .,0.59746030D+03,0.160D+03,0.141D+03,0.29455000D+01,0.19545000D+01
     .,0.55690660D+03,0.160D+03,0.142D+03,0.29455000D+01,0.19420000D+01
     .,0.62539660D+03,0.160D+03,0.143D+03,0.29455000D+01,0.16682000D+01
     .,0.48497040D+03,0.160D+03,0.144D+03,0.29455000D+01,0.18584000D+01
     .,0.45367340D+03,0.160D+03,0.145D+03,0.29455000D+01,0.19003000D+01
     .,0.42121350D+03,0.160D+03,0.146D+03,0.29455000D+01,0.18630000D+01
     .,0.40754200D+03,0.160D+03,0.147D+03,0.29455000D+01,0.96790000D+00
     .,0.40282810D+03,0.160D+03,0.148D+03,0.29455000D+01,0.19539000D+01
     .,0.64108970D+03,0.160D+03,0.149D+03,0.29455000D+01,0.96330000D+00
     .,0.57909510D+03,0.160D+03,0.150D+03,0.29455000D+01,0.95140000D+00
     .,0.54176140D+03,0.160D+03,0.151D+03,0.29455000D+01,0.97490000D+00
     .,0.51212090D+03,0.160D+03,0.152D+03,0.29455000D+01,0.98110000D+00
     ./)
      grimme_c6_parameters(  55101:  55200)=(/
     . 0.46733270D+03,0.160D+03,0.153D+03,0.29455000D+01,0.99680000D+00
     .,0.63096990D+03,0.160D+03,0.155D+03,0.29455000D+01,0.99090000D+00
     .,0.13558874D+04,0.160D+03,0.156D+03,0.29455000D+01,0.97970000D+00
     .,0.10088176D+04,0.160D+03,0.157D+03,0.29455000D+01,0.19373000D+01
     .,0.63363330D+03,0.160D+03,0.159D+03,0.29455000D+01,0.29425000D+01
     .,0.62052060D+03,0.160D+03,0.160D+03,0.29455000D+01,0.29455000D+01
     .,0.41035600D+02,0.161D+03,0.100D+01,0.29413000D+01,0.91180000D+00
     .,0.27115000D+02,0.161D+03,0.200D+01,0.29413000D+01,0.00000000D+00
     .,0.64218080D+03,0.161D+03,0.300D+01,0.29413000D+01,0.00000000D+00
     .,0.36981420D+03,0.161D+03,0.400D+01,0.29413000D+01,0.00000000D+00
     .,0.24860710D+03,0.161D+03,0.500D+01,0.29413000D+01,0.00000000D+00
     .,0.16779680D+03,0.161D+03,0.600D+01,0.29413000D+01,0.00000000D+00
     .,0.11730260D+03,0.161D+03,0.700D+01,0.29413000D+01,0.00000000D+00
     .,0.88815900D+02,0.161D+03,0.800D+01,0.29413000D+01,0.00000000D+00
     .,0.67299900D+02,0.161D+03,0.900D+01,0.29413000D+01,0.00000000D+00
     .,0.51786000D+02,0.161D+03,0.100D+02,0.29413000D+01,0.00000000D+00
     .,0.76786760D+03,0.161D+03,0.110D+02,0.29413000D+01,0.00000000D+00
     .,0.58961410D+03,0.161D+03,0.120D+02,0.29413000D+01,0.00000000D+00
     .,0.54296830D+03,0.161D+03,0.130D+02,0.29413000D+01,0.00000000D+00
     .,0.42728580D+03,0.161D+03,0.140D+02,0.29413000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  55201:  55300)=(/
     . 0.33286240D+03,0.161D+03,0.150D+02,0.29413000D+01,0.00000000D+00
     .,0.27611290D+03,0.161D+03,0.160D+02,0.29413000D+01,0.00000000D+00
     .,0.22545620D+03,0.161D+03,0.170D+02,0.29413000D+01,0.00000000D+00
     .,0.18441100D+03,0.161D+03,0.180D+02,0.29413000D+01,0.00000000D+00
     .,0.12590280D+04,0.161D+03,0.190D+02,0.29413000D+01,0.00000000D+00
     .,0.10371340D+04,0.161D+03,0.200D+02,0.29413000D+01,0.00000000D+00
     .,0.85644340D+03,0.161D+03,0.210D+02,0.29413000D+01,0.00000000D+00
     .,0.82672570D+03,0.161D+03,0.220D+02,0.29413000D+01,0.00000000D+00
     .,0.75688430D+03,0.161D+03,0.230D+02,0.29413000D+01,0.00000000D+00
     .,0.59629710D+03,0.161D+03,0.240D+02,0.29413000D+01,0.00000000D+00
     .,0.65144380D+03,0.161D+03,0.250D+02,0.29413000D+01,0.00000000D+00
     .,0.51133840D+03,0.161D+03,0.260D+02,0.29413000D+01,0.00000000D+00
     .,0.54164010D+03,0.161D+03,0.270D+02,0.29413000D+01,0.00000000D+00
     .,0.55809040D+03,0.161D+03,0.280D+02,0.29413000D+01,0.00000000D+00
     .,0.42796300D+03,0.161D+03,0.290D+02,0.29413000D+01,0.00000000D+00
     .,0.43895460D+03,0.161D+03,0.300D+02,0.29413000D+01,0.00000000D+00
     .,0.51995360D+03,0.161D+03,0.310D+02,0.29413000D+01,0.00000000D+00
     .,0.45803850D+03,0.161D+03,0.320D+02,0.29413000D+01,0.00000000D+00
     .,0.39031610D+03,0.161D+03,0.330D+02,0.29413000D+01,0.00000000D+00
     .,0.35005540D+03,0.161D+03,0.340D+02,0.29413000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  55301:  55400)=(/
     . 0.30619590D+03,0.161D+03,0.350D+02,0.29413000D+01,0.00000000D+00
     .,0.26618930D+03,0.161D+03,0.360D+02,0.29413000D+01,0.00000000D+00
     .,0.14108565D+04,0.161D+03,0.370D+02,0.29413000D+01,0.00000000D+00
     .,0.12358086D+04,0.161D+03,0.380D+02,0.29413000D+01,0.00000000D+00
     .,0.10815963D+04,0.161D+03,0.390D+02,0.29413000D+01,0.00000000D+00
     .,0.97156440D+03,0.161D+03,0.400D+02,0.29413000D+01,0.00000000D+00
     .,0.88562820D+03,0.161D+03,0.410D+02,0.29413000D+01,0.00000000D+00
     .,0.68336810D+03,0.161D+03,0.420D+02,0.29413000D+01,0.00000000D+00
     .,0.76261340D+03,0.161D+03,0.430D+02,0.29413000D+01,0.00000000D+00
     .,0.58065630D+03,0.161D+03,0.440D+02,0.29413000D+01,0.00000000D+00
     .,0.63462930D+03,0.161D+03,0.450D+02,0.29413000D+01,0.00000000D+00
     .,0.58839190D+03,0.161D+03,0.460D+02,0.29413000D+01,0.00000000D+00
     .,0.49078330D+03,0.161D+03,0.470D+02,0.29413000D+01,0.00000000D+00
     .,0.51833560D+03,0.161D+03,0.480D+02,0.29413000D+01,0.00000000D+00
     .,0.65088900D+03,0.161D+03,0.490D+02,0.29413000D+01,0.00000000D+00
     .,0.60128620D+03,0.161D+03,0.500D+02,0.29413000D+01,0.00000000D+00
     .,0.53534260D+03,0.161D+03,0.510D+02,0.29413000D+01,0.00000000D+00
     .,0.49642060D+03,0.161D+03,0.520D+02,0.29413000D+01,0.00000000D+00
     .,0.44860200D+03,0.161D+03,0.530D+02,0.29413000D+01,0.00000000D+00
     .,0.40312330D+03,0.161D+03,0.540D+02,0.29413000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  55401:  55500)=(/
     . 0.17186565D+04,0.161D+03,0.550D+02,0.29413000D+01,0.00000000D+00
     .,0.15759396D+04,0.161D+03,0.560D+02,0.29413000D+01,0.00000000D+00
     .,0.13833184D+04,0.161D+03,0.570D+02,0.29413000D+01,0.00000000D+00
     .,0.63260690D+03,0.161D+03,0.580D+02,0.29413000D+01,0.27991000D+01
     .,0.13959648D+04,0.161D+03,0.590D+02,0.29413000D+01,0.00000000D+00
     .,0.13402848D+04,0.161D+03,0.600D+02,0.29413000D+01,0.00000000D+00
     .,0.13066123D+04,0.161D+03,0.610D+02,0.29413000D+01,0.00000000D+00
     .,0.12756493D+04,0.161D+03,0.620D+02,0.29413000D+01,0.00000000D+00
     .,0.12481896D+04,0.161D+03,0.630D+02,0.29413000D+01,0.00000000D+00
     .,0.98061140D+03,0.161D+03,0.640D+02,0.29413000D+01,0.00000000D+00
     .,0.11056577D+04,0.161D+03,0.650D+02,0.29413000D+01,0.00000000D+00
     .,0.10661553D+04,0.161D+03,0.660D+02,0.29413000D+01,0.00000000D+00
     .,0.11255430D+04,0.161D+03,0.670D+02,0.29413000D+01,0.00000000D+00
     .,0.11016251D+04,0.161D+03,0.680D+02,0.29413000D+01,0.00000000D+00
     .,0.10800441D+04,0.161D+03,0.690D+02,0.29413000D+01,0.00000000D+00
     .,0.10674513D+04,0.161D+03,0.700D+02,0.29413000D+01,0.00000000D+00
     .,0.89877880D+03,0.161D+03,0.710D+02,0.29413000D+01,0.00000000D+00
     .,0.88303380D+03,0.161D+03,0.720D+02,0.29413000D+01,0.00000000D+00
     .,0.80541670D+03,0.161D+03,0.730D+02,0.29413000D+01,0.00000000D+00
     .,0.67986960D+03,0.161D+03,0.740D+02,0.29413000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  55501:  55600)=(/
     . 0.69147700D+03,0.161D+03,0.750D+02,0.29413000D+01,0.00000000D+00
     .,0.62640460D+03,0.161D+03,0.760D+02,0.29413000D+01,0.00000000D+00
     .,0.57347180D+03,0.161D+03,0.770D+02,0.29413000D+01,0.00000000D+00
     .,0.47626530D+03,0.161D+03,0.780D+02,0.29413000D+01,0.00000000D+00
     .,0.44493320D+03,0.161D+03,0.790D+02,0.29413000D+01,0.00000000D+00
     .,0.45759140D+03,0.161D+03,0.800D+02,0.29413000D+01,0.00000000D+00
     .,0.66821650D+03,0.161D+03,0.810D+02,0.29413000D+01,0.00000000D+00
     .,0.65280350D+03,0.161D+03,0.820D+02,0.29413000D+01,0.00000000D+00
     .,0.59931800D+03,0.161D+03,0.830D+02,0.29413000D+01,0.00000000D+00
     .,0.57130760D+03,0.161D+03,0.840D+02,0.29413000D+01,0.00000000D+00
     .,0.52695800D+03,0.161D+03,0.850D+02,0.29413000D+01,0.00000000D+00
     .,0.48275550D+03,0.161D+03,0.860D+02,0.29413000D+01,0.00000000D+00
     .,0.16217509D+04,0.161D+03,0.870D+02,0.29413000D+01,0.00000000D+00
     .,0.15576603D+04,0.161D+03,0.880D+02,0.29413000D+01,0.00000000D+00
     .,0.13757224D+04,0.161D+03,0.890D+02,0.29413000D+01,0.00000000D+00
     .,0.12351334D+04,0.161D+03,0.900D+02,0.29413000D+01,0.00000000D+00
     .,0.12269612D+04,0.161D+03,0.910D+02,0.29413000D+01,0.00000000D+00
     .,0.11880136D+04,0.161D+03,0.920D+02,0.29413000D+01,0.00000000D+00
     .,0.12239539D+04,0.161D+03,0.930D+02,0.29413000D+01,0.00000000D+00
     .,0.11851389D+04,0.161D+03,0.940D+02,0.29413000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  55601:  55700)=(/
     . 0.66143900D+02,0.161D+03,0.101D+03,0.29413000D+01,0.00000000D+00
     .,0.21491570D+03,0.161D+03,0.103D+03,0.29413000D+01,0.98650000D+00
     .,0.27404530D+03,0.161D+03,0.104D+03,0.29413000D+01,0.98080000D+00
     .,0.20906270D+03,0.161D+03,0.105D+03,0.29413000D+01,0.97060000D+00
     .,0.15740780D+03,0.161D+03,0.106D+03,0.29413000D+01,0.98680000D+00
     .,0.10939440D+03,0.161D+03,0.107D+03,0.29413000D+01,0.99440000D+00
     .,0.79656600D+02,0.161D+03,0.108D+03,0.29413000D+01,0.99250000D+00
     .,0.54794700D+02,0.161D+03,0.109D+03,0.29413000D+01,0.99820000D+00
     .,0.31433160D+03,0.161D+03,0.111D+03,0.29413000D+01,0.96840000D+00
     .,0.48615820D+03,0.161D+03,0.112D+03,0.29413000D+01,0.96280000D+00
     .,0.49197000D+03,0.161D+03,0.113D+03,0.29413000D+01,0.96480000D+00
     .,0.39485010D+03,0.161D+03,0.114D+03,0.29413000D+01,0.95070000D+00
     .,0.32309660D+03,0.161D+03,0.115D+03,0.29413000D+01,0.99470000D+00
     .,0.27308190D+03,0.161D+03,0.116D+03,0.29413000D+01,0.99480000D+00
     .,0.22312610D+03,0.161D+03,0.117D+03,0.29413000D+01,0.99720000D+00
     .,0.43320740D+03,0.161D+03,0.119D+03,0.29413000D+01,0.97670000D+00
     .,0.82964080D+03,0.161D+03,0.120D+03,0.29413000D+01,0.98310000D+00
     .,0.43282760D+03,0.161D+03,0.121D+03,0.29413000D+01,0.18627000D+01
     .,0.41783600D+03,0.161D+03,0.122D+03,0.29413000D+01,0.18299000D+01
     .,0.40950580D+03,0.161D+03,0.123D+03,0.29413000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  55701:  55800)=(/
     . 0.40578350D+03,0.161D+03,0.124D+03,0.29413000D+01,0.18269000D+01
     .,0.37312230D+03,0.161D+03,0.125D+03,0.29413000D+01,0.16406000D+01
     .,0.34526760D+03,0.161D+03,0.126D+03,0.29413000D+01,0.16483000D+01
     .,0.32938120D+03,0.161D+03,0.127D+03,0.29413000D+01,0.17149000D+01
     .,0.32203750D+03,0.161D+03,0.128D+03,0.29413000D+01,0.17937000D+01
     .,0.31836420D+03,0.161D+03,0.129D+03,0.29413000D+01,0.95760000D+00
     .,0.29841060D+03,0.161D+03,0.130D+03,0.29413000D+01,0.19419000D+01
     .,0.48821620D+03,0.161D+03,0.131D+03,0.29413000D+01,0.96010000D+00
     .,0.42840160D+03,0.161D+03,0.132D+03,0.29413000D+01,0.94340000D+00
     .,0.38367750D+03,0.161D+03,0.133D+03,0.29413000D+01,0.98890000D+00
     .,0.35019520D+03,0.161D+03,0.134D+03,0.29413000D+01,0.99010000D+00
     .,0.30833610D+03,0.161D+03,0.135D+03,0.29413000D+01,0.99740000D+00
     .,0.51680260D+03,0.161D+03,0.137D+03,0.29413000D+01,0.97380000D+00
     .,0.10097020D+04,0.161D+03,0.138D+03,0.29413000D+01,0.98010000D+00
     .,0.77048950D+03,0.161D+03,0.139D+03,0.29413000D+01,0.19153000D+01
     .,0.57252260D+03,0.161D+03,0.140D+03,0.29413000D+01,0.19355000D+01
     .,0.57822130D+03,0.161D+03,0.141D+03,0.29413000D+01,0.19545000D+01
     .,0.53906400D+03,0.161D+03,0.142D+03,0.29413000D+01,0.19420000D+01
     .,0.60508290D+03,0.161D+03,0.143D+03,0.29413000D+01,0.16682000D+01
     .,0.46961340D+03,0.161D+03,0.144D+03,0.29413000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters(  55801:  55900)=(/
     . 0.43933610D+03,0.161D+03,0.145D+03,0.29413000D+01,0.19003000D+01
     .,0.40794200D+03,0.161D+03,0.146D+03,0.29413000D+01,0.18630000D+01
     .,0.39468140D+03,0.161D+03,0.147D+03,0.29413000D+01,0.96790000D+00
     .,0.39021360D+03,0.161D+03,0.148D+03,0.29413000D+01,0.19539000D+01
     .,0.62022960D+03,0.161D+03,0.149D+03,0.29413000D+01,0.96330000D+00
     .,0.56054060D+03,0.161D+03,0.150D+03,0.29413000D+01,0.95140000D+00
     .,0.52460280D+03,0.161D+03,0.151D+03,0.29413000D+01,0.97490000D+00
     .,0.49603960D+03,0.161D+03,0.152D+03,0.29413000D+01,0.98110000D+00
     .,0.45281350D+03,0.161D+03,0.153D+03,0.29413000D+01,0.99680000D+00
     .,0.61065170D+03,0.161D+03,0.155D+03,0.29413000D+01,0.99090000D+00
     .,0.13096071D+04,0.161D+03,0.156D+03,0.29413000D+01,0.97970000D+00
     .,0.97534290D+03,0.161D+03,0.157D+03,0.29413000D+01,0.19373000D+01
     .,0.61350220D+03,0.161D+03,0.159D+03,0.29413000D+01,0.29425000D+01
     .,0.60081010D+03,0.161D+03,0.160D+03,0.29413000D+01,0.29455000D+01
     .,0.58174350D+03,0.161D+03,0.161D+03,0.29413000D+01,0.29413000D+01
     .,0.41118600D+02,0.162D+03,0.100D+01,0.29300000D+01,0.91180000D+00
     .,0.27091000D+02,0.162D+03,0.200D+01,0.29300000D+01,0.00000000D+00
     .,0.65371250D+03,0.162D+03,0.300D+01,0.29300000D+01,0.00000000D+00
     .,0.37335380D+03,0.162D+03,0.400D+01,0.29300000D+01,0.00000000D+00
     .,0.25006900D+03,0.162D+03,0.500D+01,0.29300000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  55901:  56000)=(/
     . 0.16835070D+03,0.162D+03,0.600D+01,0.29300000D+01,0.00000000D+00
     .,0.11747400D+03,0.162D+03,0.700D+01,0.29300000D+01,0.00000000D+00
     .,0.88833200D+02,0.162D+03,0.800D+01,0.29300000D+01,0.00000000D+00
     .,0.67241500D+02,0.162D+03,0.900D+01,0.29300000D+01,0.00000000D+00
     .,0.51697700D+02,0.162D+03,0.100D+02,0.29300000D+01,0.00000000D+00
     .,0.78120500D+03,0.162D+03,0.110D+02,0.29300000D+01,0.00000000D+00
     .,0.59600220D+03,0.162D+03,0.120D+02,0.29300000D+01,0.00000000D+00
     .,0.54777420D+03,0.162D+03,0.130D+02,0.29300000D+01,0.00000000D+00
     .,0.42994940D+03,0.162D+03,0.140D+02,0.29300000D+01,0.00000000D+00
     .,0.33425170D+03,0.162D+03,0.150D+02,0.29300000D+01,0.00000000D+00
     .,0.27691160D+03,0.162D+03,0.160D+02,0.29300000D+01,0.00000000D+00
     .,0.22583700D+03,0.162D+03,0.170D+02,0.29300000D+01,0.00000000D+00
     .,0.18453320D+03,0.162D+03,0.180D+02,0.29300000D+01,0.00000000D+00
     .,0.12836315D+04,0.162D+03,0.190D+02,0.29300000D+01,0.00000000D+00
     .,0.10509848D+04,0.162D+03,0.200D+02,0.29300000D+01,0.00000000D+00
     .,0.86692280D+03,0.162D+03,0.210D+02,0.29300000D+01,0.00000000D+00
     .,0.83609940D+03,0.162D+03,0.220D+02,0.29300000D+01,0.00000000D+00
     .,0.76505120D+03,0.162D+03,0.230D+02,0.29300000D+01,0.00000000D+00
     .,0.60271130D+03,0.162D+03,0.240D+02,0.29300000D+01,0.00000000D+00
     .,0.65796350D+03,0.162D+03,0.250D+02,0.29300000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56001:  56100)=(/
     . 0.51637700D+03,0.162D+03,0.260D+02,0.29300000D+01,0.00000000D+00
     .,0.54633630D+03,0.162D+03,0.270D+02,0.29300000D+01,0.00000000D+00
     .,0.56322550D+03,0.162D+03,0.280D+02,0.29300000D+01,0.00000000D+00
     .,0.43190330D+03,0.162D+03,0.290D+02,0.29300000D+01,0.00000000D+00
     .,0.44225450D+03,0.162D+03,0.300D+02,0.29300000D+01,0.00000000D+00
     .,0.52416760D+03,0.162D+03,0.310D+02,0.29300000D+01,0.00000000D+00
     .,0.46081790D+03,0.162D+03,0.320D+02,0.29300000D+01,0.00000000D+00
     .,0.39201390D+03,0.162D+03,0.330D+02,0.29300000D+01,0.00000000D+00
     .,0.35121820D+03,0.162D+03,0.340D+02,0.29300000D+01,0.00000000D+00
     .,0.30689590D+03,0.162D+03,0.350D+02,0.29300000D+01,0.00000000D+00
     .,0.26654940D+03,0.162D+03,0.360D+02,0.29300000D+01,0.00000000D+00
     .,0.14379300D+04,0.162D+03,0.370D+02,0.29300000D+01,0.00000000D+00
     .,0.12526342D+04,0.162D+03,0.380D+02,0.29300000D+01,0.00000000D+00
     .,0.10942695D+04,0.162D+03,0.390D+02,0.29300000D+01,0.00000000D+00
     .,0.98185530D+03,0.162D+03,0.400D+02,0.29300000D+01,0.00000000D+00
     .,0.89439170D+03,0.162D+03,0.410D+02,0.29300000D+01,0.00000000D+00
     .,0.68930910D+03,0.162D+03,0.420D+02,0.29300000D+01,0.00000000D+00
     .,0.76959900D+03,0.162D+03,0.430D+02,0.29300000D+01,0.00000000D+00
     .,0.58520650D+03,0.162D+03,0.440D+02,0.29300000D+01,0.00000000D+00
     .,0.63957050D+03,0.162D+03,0.450D+02,0.29300000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56101:  56200)=(/
     . 0.59271510D+03,0.162D+03,0.460D+02,0.29300000D+01,0.00000000D+00
     .,0.49454430D+03,0.162D+03,0.470D+02,0.29300000D+01,0.00000000D+00
     .,0.52185710D+03,0.162D+03,0.480D+02,0.29300000D+01,0.00000000D+00
     .,0.65623190D+03,0.162D+03,0.490D+02,0.29300000D+01,0.00000000D+00
     .,0.60519030D+03,0.162D+03,0.500D+02,0.29300000D+01,0.00000000D+00
     .,0.53798990D+03,0.162D+03,0.510D+02,0.29300000D+01,0.00000000D+00
     .,0.49842910D+03,0.162D+03,0.520D+02,0.29300000D+01,0.00000000D+00
     .,0.44999200D+03,0.162D+03,0.530D+02,0.29300000D+01,0.00000000D+00
     .,0.40401740D+03,0.162D+03,0.540D+02,0.29300000D+01,0.00000000D+00
     .,0.17521410D+04,0.162D+03,0.550D+02,0.29300000D+01,0.00000000D+00
     .,0.15986396D+04,0.162D+03,0.560D+02,0.29300000D+01,0.00000000D+00
     .,0.14005068D+04,0.162D+03,0.570D+02,0.29300000D+01,0.00000000D+00
     .,0.63591570D+03,0.162D+03,0.580D+02,0.29300000D+01,0.27991000D+01
     .,0.14152709D+04,0.162D+03,0.590D+02,0.29300000D+01,0.00000000D+00
     .,0.13581904D+04,0.162D+03,0.600D+02,0.29300000D+01,0.00000000D+00
     .,0.13239329D+04,0.162D+03,0.610D+02,0.29300000D+01,0.00000000D+00
     .,0.12924475D+04,0.162D+03,0.620D+02,0.29300000D+01,0.00000000D+00
     .,0.12645213D+04,0.162D+03,0.630D+02,0.29300000D+01,0.00000000D+00
     .,0.99151760D+03,0.162D+03,0.640D+02,0.29300000D+01,0.00000000D+00
     .,0.11218549D+04,0.162D+03,0.650D+02,0.29300000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56201:  56300)=(/
     . 0.10816001D+04,0.162D+03,0.660D+02,0.29300000D+01,0.00000000D+00
     .,0.11396825D+04,0.162D+03,0.670D+02,0.29300000D+01,0.00000000D+00
     .,0.11153978D+04,0.162D+03,0.680D+02,0.29300000D+01,0.00000000D+00
     .,0.10934602D+04,0.162D+03,0.690D+02,0.29300000D+01,0.00000000D+00
     .,0.10807974D+04,0.162D+03,0.700D+02,0.29300000D+01,0.00000000D+00
     .,0.90896190D+03,0.162D+03,0.710D+02,0.29300000D+01,0.00000000D+00
     .,0.89127890D+03,0.162D+03,0.720D+02,0.29300000D+01,0.00000000D+00
     .,0.81208250D+03,0.162D+03,0.730D+02,0.29300000D+01,0.00000000D+00
     .,0.68499030D+03,0.162D+03,0.740D+02,0.29300000D+01,0.00000000D+00
     .,0.69640000D+03,0.162D+03,0.750D+02,0.29300000D+01,0.00000000D+00
     .,0.63031370D+03,0.162D+03,0.760D+02,0.29300000D+01,0.00000000D+00
     .,0.57665350D+03,0.162D+03,0.770D+02,0.29300000D+01,0.00000000D+00
     .,0.47857310D+03,0.162D+03,0.780D+02,0.29300000D+01,0.00000000D+00
     .,0.44696260D+03,0.162D+03,0.790D+02,0.29300000D+01,0.00000000D+00
     .,0.45952800D+03,0.162D+03,0.800D+02,0.29300000D+01,0.00000000D+00
     .,0.67346620D+03,0.162D+03,0.810D+02,0.29300000D+01,0.00000000D+00
     .,0.65702270D+03,0.162D+03,0.820D+02,0.29300000D+01,0.00000000D+00
     .,0.60234550D+03,0.162D+03,0.830D+02,0.29300000D+01,0.00000000D+00
     .,0.57374780D+03,0.162D+03,0.840D+02,0.29300000D+01,0.00000000D+00
     .,0.52872700D+03,0.162D+03,0.850D+02,0.29300000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56301:  56400)=(/
     . 0.48398270D+03,0.162D+03,0.860D+02,0.29300000D+01,0.00000000D+00
     .,0.16501361D+04,0.162D+03,0.870D+02,0.29300000D+01,0.00000000D+00
     .,0.15785123D+04,0.162D+03,0.880D+02,0.29300000D+01,0.00000000D+00
     .,0.13916728D+04,0.162D+03,0.890D+02,0.29300000D+01,0.00000000D+00
     .,0.12470771D+04,0.162D+03,0.900D+02,0.29300000D+01,0.00000000D+00
     .,0.12400445D+04,0.162D+03,0.910D+02,0.29300000D+01,0.00000000D+00
     .,0.12006028D+04,0.162D+03,0.920D+02,0.29300000D+01,0.00000000D+00
     .,0.12383187D+04,0.162D+03,0.930D+02,0.29300000D+01,0.00000000D+00
     .,0.11987720D+04,0.162D+03,0.940D+02,0.29300000D+01,0.00000000D+00
     .,0.66405700D+02,0.162D+03,0.101D+03,0.29300000D+01,0.00000000D+00
     .,0.21686950D+03,0.162D+03,0.103D+03,0.29300000D+01,0.98650000D+00
     .,0.27638280D+03,0.162D+03,0.104D+03,0.29300000D+01,0.98080000D+00
     .,0.21014480D+03,0.162D+03,0.105D+03,0.29300000D+01,0.97060000D+00
     .,0.15794060D+03,0.162D+03,0.106D+03,0.29300000D+01,0.98680000D+00
     .,0.10955230D+03,0.162D+03,0.107D+03,0.29300000D+01,0.99440000D+00
     .,0.79647700D+02,0.162D+03,0.108D+03,0.29300000D+01,0.99250000D+00
     .,0.54685200D+02,0.162D+03,0.109D+03,0.29300000D+01,0.99820000D+00
     .,0.31740960D+03,0.162D+03,0.111D+03,0.29300000D+01,0.96840000D+00
     .,0.49113850D+03,0.162D+03,0.112D+03,0.29300000D+01,0.96280000D+00
     .,0.49609590D+03,0.162D+03,0.113D+03,0.29300000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  56401:  56500)=(/
     . 0.39717520D+03,0.162D+03,0.114D+03,0.29300000D+01,0.95070000D+00
     .,0.32442460D+03,0.162D+03,0.115D+03,0.29300000D+01,0.99470000D+00
     .,0.27388040D+03,0.162D+03,0.116D+03,0.29300000D+01,0.99480000D+00
     .,0.22350790D+03,0.162D+03,0.117D+03,0.29300000D+01,0.99720000D+00
     .,0.43688540D+03,0.162D+03,0.119D+03,0.29300000D+01,0.97670000D+00
     .,0.84105190D+03,0.162D+03,0.120D+03,0.29300000D+01,0.98310000D+00
     .,0.43551720D+03,0.162D+03,0.121D+03,0.29300000D+01,0.18627000D+01
     .,0.42046710D+03,0.162D+03,0.122D+03,0.29300000D+01,0.18299000D+01
     .,0.41208740D+03,0.162D+03,0.123D+03,0.29300000D+01,0.19138000D+01
     .,0.40844600D+03,0.162D+03,0.124D+03,0.29300000D+01,0.18269000D+01
     .,0.37510510D+03,0.162D+03,0.125D+03,0.29300000D+01,0.16406000D+01
     .,0.34698680D+03,0.162D+03,0.126D+03,0.29300000D+01,0.16483000D+01
     .,0.33102820D+03,0.162D+03,0.127D+03,0.29300000D+01,0.17149000D+01
     .,0.32367720D+03,0.162D+03,0.128D+03,0.29300000D+01,0.17937000D+01
     .,0.32026840D+03,0.162D+03,0.129D+03,0.29300000D+01,0.95760000D+00
     .,0.29970920D+03,0.162D+03,0.130D+03,0.29300000D+01,0.19419000D+01
     .,0.49191570D+03,0.162D+03,0.131D+03,0.29300000D+01,0.96010000D+00
     .,0.43081190D+03,0.162D+03,0.132D+03,0.29300000D+01,0.94340000D+00
     .,0.38530990D+03,0.162D+03,0.133D+03,0.29300000D+01,0.98890000D+00
     .,0.35136440D+03,0.162D+03,0.134D+03,0.29300000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters(  56501:  56600)=(/
     . 0.30905750D+03,0.162D+03,0.135D+03,0.29300000D+01,0.99740000D+00
     .,0.52097030D+03,0.162D+03,0.137D+03,0.29300000D+01,0.97380000D+00
     .,0.10240101D+04,0.162D+03,0.138D+03,0.29300000D+01,0.98010000D+00
     .,0.77856140D+03,0.162D+03,0.139D+03,0.29300000D+01,0.19153000D+01
     .,0.57624530D+03,0.162D+03,0.140D+03,0.29300000D+01,0.19355000D+01
     .,0.58193050D+03,0.162D+03,0.141D+03,0.29300000D+01,0.19545000D+01
     .,0.54238030D+03,0.162D+03,0.142D+03,0.29300000D+01,0.19420000D+01
     .,0.60986550D+03,0.162D+03,0.143D+03,0.29300000D+01,0.16682000D+01
     .,0.47194410D+03,0.162D+03,0.144D+03,0.29300000D+01,0.18584000D+01
     .,0.44147690D+03,0.162D+03,0.145D+03,0.29300000D+01,0.19003000D+01
     .,0.40984440D+03,0.162D+03,0.146D+03,0.29300000D+01,0.18630000D+01
     .,0.39658040D+03,0.162D+03,0.147D+03,0.29300000D+01,0.96790000D+00
     .,0.39174910D+03,0.162D+03,0.148D+03,0.29300000D+01,0.19539000D+01
     .,0.62494310D+03,0.162D+03,0.149D+03,0.29300000D+01,0.96330000D+00
     .,0.56383860D+03,0.162D+03,0.150D+03,0.29300000D+01,0.95140000D+00
     .,0.52709190D+03,0.162D+03,0.151D+03,0.29300000D+01,0.97490000D+00
     .,0.49801930D+03,0.162D+03,0.152D+03,0.29300000D+01,0.98110000D+00
     .,0.45422360D+03,0.162D+03,0.153D+03,0.29300000D+01,0.99680000D+00
     .,0.61477890D+03,0.162D+03,0.155D+03,0.29300000D+01,0.99090000D+00
     .,0.13297509D+04,0.162D+03,0.156D+03,0.29300000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters(  56601:  56700)=(/
     . 0.98604390D+03,0.162D+03,0.157D+03,0.29300000D+01,0.19373000D+01
     .,0.61665720D+03,0.162D+03,0.159D+03,0.29300000D+01,0.29425000D+01
     .,0.60388680D+03,0.162D+03,0.160D+03,0.29300000D+01,0.29455000D+01
     .,0.58467880D+03,0.162D+03,0.161D+03,0.29300000D+01,0.29413000D+01
     .,0.58778910D+03,0.162D+03,0.162D+03,0.29300000D+01,0.29300000D+01
     .,0.39256400D+02,0.163D+03,0.100D+01,0.18286000D+01,0.91180000D+00
     .,0.25691300D+02,0.163D+03,0.200D+01,0.18286000D+01,0.00000000D+00
     .,0.65368460D+03,0.163D+03,0.300D+01,0.18286000D+01,0.00000000D+00
     .,0.36511120D+03,0.163D+03,0.400D+01,0.18286000D+01,0.00000000D+00
     .,0.24163430D+03,0.163D+03,0.500D+01,0.18286000D+01,0.00000000D+00
     .,0.16139330D+03,0.163D+03,0.600D+01,0.18286000D+01,0.00000000D+00
     .,0.11205120D+03,0.163D+03,0.700D+01,0.18286000D+01,0.00000000D+00
     .,0.84473100D+02,0.163D+03,0.800D+01,0.18286000D+01,0.00000000D+00
     .,0.63799600D+02,0.163D+03,0.900D+01,0.18286000D+01,0.00000000D+00
     .,0.48980900D+02,0.163D+03,0.100D+02,0.18286000D+01,0.00000000D+00
     .,0.78026740D+03,0.163D+03,0.110D+02,0.18286000D+01,0.00000000D+00
     .,0.58523670D+03,0.163D+03,0.120D+02,0.18286000D+01,0.00000000D+00
     .,0.53437570D+03,0.163D+03,0.130D+02,0.18286000D+01,0.00000000D+00
     .,0.41591500D+03,0.163D+03,0.140D+02,0.18286000D+01,0.00000000D+00
     .,0.32121200D+03,0.163D+03,0.150D+02,0.18286000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56701:  56800)=(/
     . 0.26508690D+03,0.163D+03,0.160D+02,0.18286000D+01,0.00000000D+00
     .,0.21546030D+03,0.163D+03,0.170D+02,0.18286000D+01,0.00000000D+00
     .,0.17559080D+03,0.163D+03,0.180D+02,0.18286000D+01,0.00000000D+00
     .,0.12856965D+04,0.163D+03,0.190D+02,0.18286000D+01,0.00000000D+00
     .,0.10394662D+04,0.163D+03,0.200D+02,0.18286000D+01,0.00000000D+00
     .,0.85482160D+03,0.163D+03,0.210D+02,0.18286000D+01,0.00000000D+00
     .,0.82218100D+03,0.163D+03,0.220D+02,0.18286000D+01,0.00000000D+00
     .,0.75108930D+03,0.163D+03,0.230D+02,0.18286000D+01,0.00000000D+00
     .,0.59166600D+03,0.163D+03,0.240D+02,0.18286000D+01,0.00000000D+00
     .,0.64444210D+03,0.163D+03,0.250D+02,0.18286000D+01,0.00000000D+00
     .,0.50560640D+03,0.163D+03,0.260D+02,0.18286000D+01,0.00000000D+00
     .,0.53300400D+03,0.163D+03,0.270D+02,0.18286000D+01,0.00000000D+00
     .,0.55039520D+03,0.163D+03,0.280D+02,0.18286000D+01,0.00000000D+00
     .,0.42213760D+03,0.163D+03,0.290D+02,0.18286000D+01,0.00000000D+00
     .,0.42993040D+03,0.163D+03,0.300D+02,0.18286000D+01,0.00000000D+00
     .,0.51021570D+03,0.163D+03,0.310D+02,0.18286000D+01,0.00000000D+00
     .,0.44563750D+03,0.163D+03,0.320D+02,0.18286000D+01,0.00000000D+00
     .,0.37699910D+03,0.163D+03,0.330D+02,0.18286000D+01,0.00000000D+00
     .,0.33669100D+03,0.163D+03,0.340D+02,0.18286000D+01,0.00000000D+00
     .,0.29330360D+03,0.163D+03,0.350D+02,0.18286000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56801:  56900)=(/
     . 0.25408590D+03,0.163D+03,0.360D+02,0.18286000D+01,0.00000000D+00
     .,0.14385445D+04,0.163D+03,0.370D+02,0.18286000D+01,0.00000000D+00
     .,0.12395504D+04,0.163D+03,0.380D+02,0.18286000D+01,0.00000000D+00
     .,0.10770858D+04,0.163D+03,0.390D+02,0.18286000D+01,0.00000000D+00
     .,0.96327150D+03,0.163D+03,0.400D+02,0.18286000D+01,0.00000000D+00
     .,0.87559310D+03,0.163D+03,0.410D+02,0.18286000D+01,0.00000000D+00
     .,0.67249140D+03,0.163D+03,0.420D+02,0.18286000D+01,0.00000000D+00
     .,0.75175670D+03,0.163D+03,0.430D+02,0.18286000D+01,0.00000000D+00
     .,0.56950600D+03,0.163D+03,0.440D+02,0.18286000D+01,0.00000000D+00
     .,0.62232140D+03,0.163D+03,0.450D+02,0.18286000D+01,0.00000000D+00
     .,0.57599650D+03,0.163D+03,0.460D+02,0.18286000D+01,0.00000000D+00
     .,0.48115240D+03,0.163D+03,0.470D+02,0.18286000D+01,0.00000000D+00
     .,0.50633030D+03,0.163D+03,0.480D+02,0.18286000D+01,0.00000000D+00
     .,0.63922390D+03,0.163D+03,0.490D+02,0.18286000D+01,0.00000000D+00
     .,0.58633170D+03,0.163D+03,0.500D+02,0.18286000D+01,0.00000000D+00
     .,0.51859750D+03,0.163D+03,0.510D+02,0.18286000D+01,0.00000000D+00
     .,0.47906490D+03,0.163D+03,0.520D+02,0.18286000D+01,0.00000000D+00
     .,0.43122670D+03,0.163D+03,0.530D+02,0.18286000D+01,0.00000000D+00
     .,0.38614600D+03,0.163D+03,0.540D+02,0.18286000D+01,0.00000000D+00
     .,0.17518319D+04,0.163D+03,0.550D+02,0.18286000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  56901:  57000)=(/
     . 0.15845929D+04,0.163D+03,0.560D+02,0.18286000D+01,0.00000000D+00
     .,0.13809239D+04,0.163D+03,0.570D+02,0.18286000D+01,0.00000000D+00
     .,0.61365370D+03,0.163D+03,0.580D+02,0.18286000D+01,0.27991000D+01
     .,0.14003880D+04,0.163D+03,0.590D+02,0.18286000D+01,0.00000000D+00
     .,0.13429247D+04,0.163D+03,0.600D+02,0.18286000D+01,0.00000000D+00
     .,0.13087424D+04,0.163D+03,0.610D+02,0.18286000D+01,0.00000000D+00
     .,0.12773568D+04,0.163D+03,0.620D+02,0.18286000D+01,0.00000000D+00
     .,0.12495054D+04,0.163D+03,0.630D+02,0.18286000D+01,0.00000000D+00
     .,0.97406900D+03,0.163D+03,0.640D+02,0.18286000D+01,0.00000000D+00
     .,0.11111877D+04,0.163D+03,0.650D+02,0.18286000D+01,0.00000000D+00
     .,0.10699921D+04,0.163D+03,0.660D+02,0.18286000D+01,0.00000000D+00
     .,0.11246771D+04,0.163D+03,0.670D+02,0.18286000D+01,0.00000000D+00
     .,0.11005512D+04,0.163D+03,0.680D+02,0.18286000D+01,0.00000000D+00
     .,0.10786794D+04,0.163D+03,0.690D+02,0.18286000D+01,0.00000000D+00
     .,0.10664387D+04,0.163D+03,0.700D+02,0.18286000D+01,0.00000000D+00
     .,0.89316870D+03,0.163D+03,0.710D+02,0.18286000D+01,0.00000000D+00
     .,0.87110070D+03,0.163D+03,0.720D+02,0.18286000D+01,0.00000000D+00
     .,0.79118140D+03,0.163D+03,0.730D+02,0.18286000D+01,0.00000000D+00
     .,0.66583170D+03,0.163D+03,0.740D+02,0.18286000D+01,0.00000000D+00
     .,0.67605760D+03,0.163D+03,0.750D+02,0.18286000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57001:  57100)=(/
     . 0.61029470D+03,0.163D+03,0.760D+02,0.18286000D+01,0.00000000D+00
     .,0.55718050D+03,0.163D+03,0.770D+02,0.18286000D+01,0.00000000D+00
     .,0.46153520D+03,0.163D+03,0.780D+02,0.18286000D+01,0.00000000D+00
     .,0.43073110D+03,0.163D+03,0.790D+02,0.18286000D+01,0.00000000D+00
     .,0.44232070D+03,0.163D+03,0.800D+02,0.18286000D+01,0.00000000D+00
     .,0.65532760D+03,0.163D+03,0.810D+02,0.18286000D+01,0.00000000D+00
     .,0.63664300D+03,0.163D+03,0.820D+02,0.18286000D+01,0.00000000D+00
     .,0.58099830D+03,0.163D+03,0.830D+02,0.18286000D+01,0.00000000D+00
     .,0.55199550D+03,0.163D+03,0.840D+02,0.18286000D+01,0.00000000D+00
     .,0.50719420D+03,0.163D+03,0.850D+02,0.18286000D+01,0.00000000D+00
     .,0.46310600D+03,0.163D+03,0.860D+02,0.18286000D+01,0.00000000D+00
     .,0.16436058D+04,0.163D+03,0.870D+02,0.18286000D+01,0.00000000D+00
     .,0.15604236D+04,0.163D+03,0.880D+02,0.18286000D+01,0.00000000D+00
     .,0.13690464D+04,0.163D+03,0.890D+02,0.18286000D+01,0.00000000D+00
     .,0.12201277D+04,0.163D+03,0.900D+02,0.18286000D+01,0.00000000D+00
     .,0.12166738D+04,0.163D+03,0.910D+02,0.18286000D+01,0.00000000D+00
     .,0.11778612D+04,0.163D+03,0.920D+02,0.18286000D+01,0.00000000D+00
     .,0.12191450D+04,0.163D+03,0.930D+02,0.18286000D+01,0.00000000D+00
     .,0.11794690D+04,0.163D+03,0.940D+02,0.18286000D+01,0.00000000D+00
     .,0.63762900D+02,0.163D+03,0.101D+03,0.18286000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57101:  57200)=(/
     . 0.21174000D+03,0.163D+03,0.103D+03,0.18286000D+01,0.98650000D+00
     .,0.26923050D+03,0.163D+03,0.104D+03,0.18286000D+01,0.98080000D+00
     .,0.20261480D+03,0.163D+03,0.105D+03,0.18286000D+01,0.97060000D+00
     .,0.15147130D+03,0.163D+03,0.106D+03,0.18286000D+01,0.98680000D+00
     .,0.10450970D+03,0.163D+03,0.107D+03,0.18286000D+01,0.99440000D+00
     .,0.75690800D+02,0.163D+03,0.108D+03,0.18286000D+01,0.99250000D+00
     .,0.51755700D+02,0.163D+03,0.109D+03,0.18286000D+01,0.99820000D+00
     .,0.31068640D+03,0.163D+03,0.111D+03,0.18286000D+01,0.96840000D+00
     .,0.48112160D+03,0.163D+03,0.112D+03,0.18286000D+01,0.96280000D+00
     .,0.48324150D+03,0.163D+03,0.113D+03,0.18286000D+01,0.96480000D+00
     .,0.38377640D+03,0.163D+03,0.114D+03,0.18286000D+01,0.95070000D+00
     .,0.31171580D+03,0.163D+03,0.115D+03,0.18286000D+01,0.99470000D+00
     .,0.26222190D+03,0.163D+03,0.116D+03,0.18286000D+01,0.99480000D+00
     .,0.21326140D+03,0.163D+03,0.117D+03,0.18286000D+01,0.99720000D+00
     .,0.42593700D+03,0.163D+03,0.119D+03,0.18286000D+01,0.97670000D+00
     .,0.83127500D+03,0.163D+03,0.120D+03,0.18286000D+01,0.98310000D+00
     .,0.42169690D+03,0.163D+03,0.121D+03,0.18286000D+01,0.18627000D+01
     .,0.40700940D+03,0.163D+03,0.122D+03,0.18286000D+01,0.18299000D+01
     .,0.39898160D+03,0.163D+03,0.123D+03,0.18286000D+01,0.19138000D+01
     .,0.39579870D+03,0.163D+03,0.124D+03,0.18286000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters(  57201:  57300)=(/
     . 0.36204930D+03,0.163D+03,0.125D+03,0.18286000D+01,0.16406000D+01
     .,0.33456150D+03,0.163D+03,0.126D+03,0.18286000D+01,0.16483000D+01
     .,0.31919930D+03,0.163D+03,0.127D+03,0.18286000D+01,0.17149000D+01
     .,0.31222210D+03,0.163D+03,0.128D+03,0.18286000D+01,0.17937000D+01
     .,0.30989590D+03,0.163D+03,0.129D+03,0.18286000D+01,0.95760000D+00
     .,0.28840040D+03,0.163D+03,0.130D+03,0.18286000D+01,0.19419000D+01
     .,0.47803960D+03,0.163D+03,0.131D+03,0.18286000D+01,0.96010000D+00
     .,0.41601900D+03,0.163D+03,0.132D+03,0.18286000D+01,0.94340000D+00
     .,0.37044180D+03,0.163D+03,0.133D+03,0.18286000D+01,0.98890000D+00
     .,0.33685390D+03,0.163D+03,0.134D+03,0.18286000D+01,0.99010000D+00
     .,0.29542100D+03,0.163D+03,0.135D+03,0.18286000D+01,0.99740000D+00
     .,0.50722850D+03,0.163D+03,0.137D+03,0.18286000D+01,0.97380000D+00
     .,0.10128078D+04,0.163D+03,0.138D+03,0.18286000D+01,0.98010000D+00
     .,0.76200330D+03,0.163D+03,0.139D+03,0.18286000D+01,0.19153000D+01
     .,0.55829510D+03,0.163D+03,0.140D+03,0.18286000D+01,0.19355000D+01
     .,0.56398160D+03,0.163D+03,0.141D+03,0.18286000D+01,0.19545000D+01
     .,0.52490850D+03,0.163D+03,0.142D+03,0.18286000D+01,0.19420000D+01
     .,0.59323860D+03,0.163D+03,0.143D+03,0.18286000D+01,0.16682000D+01
     .,0.45513890D+03,0.163D+03,0.144D+03,0.18286000D+01,0.18584000D+01
     .,0.42567220D+03,0.163D+03,0.145D+03,0.18286000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters(  57301:  57400)=(/
     . 0.39496580D+03,0.163D+03,0.146D+03,0.18286000D+01,0.18630000D+01
     .,0.38242790D+03,0.163D+03,0.147D+03,0.18286000D+01,0.96790000D+00
     .,0.37661900D+03,0.163D+03,0.148D+03,0.18286000D+01,0.19539000D+01
     .,0.60761490D+03,0.163D+03,0.149D+03,0.18286000D+01,0.96330000D+00
     .,0.54518900D+03,0.163D+03,0.150D+03,0.18286000D+01,0.95140000D+00
     .,0.50775680D+03,0.163D+03,0.151D+03,0.18286000D+01,0.97490000D+00
     .,0.47858010D+03,0.163D+03,0.152D+03,0.18286000D+01,0.98110000D+00
     .,0.43529630D+03,0.163D+03,0.153D+03,0.18286000D+01,0.99680000D+00
     .,0.59594990D+03,0.163D+03,0.155D+03,0.18286000D+01,0.99090000D+00
     .,0.13176067D+04,0.163D+03,0.156D+03,0.18286000D+01,0.97970000D+00
     .,0.96582370D+03,0.163D+03,0.157D+03,0.18286000D+01,0.19373000D+01
     .,0.59490700D+03,0.163D+03,0.159D+03,0.18286000D+01,0.29425000D+01
     .,0.58256410D+03,0.163D+03,0.160D+03,0.18286000D+01,0.29455000D+01
     .,0.56390150D+03,0.163D+03,0.161D+03,0.18286000D+01,0.29413000D+01
     .,0.56731710D+03,0.163D+03,0.162D+03,0.18286000D+01,0.29300000D+01
     .,0.54902810D+03,0.163D+03,0.163D+03,0.18286000D+01,0.18286000D+01
     .,0.41327500D+02,0.164D+03,0.100D+01,0.28732000D+01,0.91180000D+00
     .,0.27159500D+02,0.164D+03,0.200D+01,0.28732000D+01,0.00000000D+00
     .,0.65909240D+03,0.164D+03,0.300D+01,0.28732000D+01,0.00000000D+00
     .,0.37646100D+03,0.164D+03,0.400D+01,0.28732000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57401:  57500)=(/
     . 0.25184240D+03,0.164D+03,0.500D+01,0.28732000D+01,0.00000000D+00
     .,0.16931590D+03,0.164D+03,0.600D+01,0.28732000D+01,0.00000000D+00
     .,0.11799770D+03,0.164D+03,0.700D+01,0.28732000D+01,0.00000000D+00
     .,0.89135900D+02,0.164D+03,0.800D+01,0.28732000D+01,0.00000000D+00
     .,0.67403000D+02,0.164D+03,0.900D+01,0.28732000D+01,0.00000000D+00
     .,0.51775600D+02,0.164D+03,0.100D+02,0.28732000D+01,0.00000000D+00
     .,0.78761870D+03,0.164D+03,0.110D+02,0.28732000D+01,0.00000000D+00
     .,0.60103840D+03,0.164D+03,0.120D+02,0.28732000D+01,0.00000000D+00
     .,0.55215450D+03,0.164D+03,0.130D+02,0.28732000D+01,0.00000000D+00
     .,0.43306620D+03,0.164D+03,0.140D+02,0.28732000D+01,0.00000000D+00
     .,0.33637000D+03,0.164D+03,0.150D+02,0.28732000D+01,0.00000000D+00
     .,0.27845510D+03,0.164D+03,0.160D+02,0.28732000D+01,0.00000000D+00
     .,0.22691090D+03,0.164D+03,0.170D+02,0.28732000D+01,0.00000000D+00
     .,0.18526210D+03,0.164D+03,0.180D+02,0.28732000D+01,0.00000000D+00
     .,0.12927733D+04,0.164D+03,0.190D+02,0.28732000D+01,0.00000000D+00
     .,0.10597192D+04,0.164D+03,0.200D+02,0.28732000D+01,0.00000000D+00
     .,0.87413140D+03,0.164D+03,0.210D+02,0.28732000D+01,0.00000000D+00
     .,0.84288400D+03,0.164D+03,0.220D+02,0.28732000D+01,0.00000000D+00
     .,0.77118400D+03,0.164D+03,0.230D+02,0.28732000D+01,0.00000000D+00
     .,0.60734870D+03,0.164D+03,0.240D+02,0.28732000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57501:  57600)=(/
     . 0.66313130D+03,0.164D+03,0.250D+02,0.28732000D+01,0.00000000D+00
     .,0.52025690D+03,0.164D+03,0.260D+02,0.28732000D+01,0.00000000D+00
     .,0.55050450D+03,0.164D+03,0.270D+02,0.28732000D+01,0.00000000D+00
     .,0.56760260D+03,0.164D+03,0.280D+02,0.28732000D+01,0.00000000D+00
     .,0.43508290D+03,0.164D+03,0.290D+02,0.28732000D+01,0.00000000D+00
     .,0.44549820D+03,0.164D+03,0.300D+02,0.28732000D+01,0.00000000D+00
     .,0.52813050D+03,0.164D+03,0.310D+02,0.28732000D+01,0.00000000D+00
     .,0.46406710D+03,0.164D+03,0.320D+02,0.28732000D+01,0.00000000D+00
     .,0.39450330D+03,0.164D+03,0.330D+02,0.28732000D+01,0.00000000D+00
     .,0.35325210D+03,0.164D+03,0.340D+02,0.28732000D+01,0.00000000D+00
     .,0.30847630D+03,0.164D+03,0.350D+02,0.28732000D+01,0.00000000D+00
     .,0.26774640D+03,0.164D+03,0.360D+02,0.28732000D+01,0.00000000D+00
     .,0.14479360D+04,0.164D+03,0.370D+02,0.28732000D+01,0.00000000D+00
     .,0.12628491D+04,0.164D+03,0.380D+02,0.28732000D+01,0.00000000D+00
     .,0.11030742D+04,0.164D+03,0.390D+02,0.28732000D+01,0.00000000D+00
     .,0.98959400D+03,0.164D+03,0.400D+02,0.28732000D+01,0.00000000D+00
     .,0.90127470D+03,0.164D+03,0.410D+02,0.28732000D+01,0.00000000D+00
     .,0.69429580D+03,0.164D+03,0.420D+02,0.28732000D+01,0.00000000D+00
     .,0.77529730D+03,0.164D+03,0.430D+02,0.28732000D+01,0.00000000D+00
     .,0.58924130D+03,0.164D+03,0.440D+02,0.28732000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57601:  57700)=(/
     . 0.64413130D+03,0.164D+03,0.450D+02,0.28732000D+01,0.00000000D+00
     .,0.59686540D+03,0.164D+03,0.460D+02,0.28732000D+01,0.00000000D+00
     .,0.49784100D+03,0.164D+03,0.470D+02,0.28732000D+01,0.00000000D+00
     .,0.52541210D+03,0.164D+03,0.480D+02,0.28732000D+01,0.00000000D+00
     .,0.66098150D+03,0.164D+03,0.490D+02,0.28732000D+01,0.00000000D+00
     .,0.60940140D+03,0.164D+03,0.500D+02,0.28732000D+01,0.00000000D+00
     .,0.54146000D+03,0.164D+03,0.510D+02,0.28732000D+01,0.00000000D+00
     .,0.50144410D+03,0.164D+03,0.520D+02,0.28732000D+01,0.00000000D+00
     .,0.45249160D+03,0.164D+03,0.530D+02,0.28732000D+01,0.00000000D+00
     .,0.40604790D+03,0.164D+03,0.540D+02,0.28732000D+01,0.00000000D+00
     .,0.17636917D+04,0.164D+03,0.550D+02,0.28732000D+01,0.00000000D+00
     .,0.16113765D+04,0.164D+03,0.560D+02,0.28732000D+01,0.00000000D+00
     .,0.14116458D+04,0.164D+03,0.570D+02,0.28732000D+01,0.00000000D+00
     .,0.63999700D+03,0.164D+03,0.580D+02,0.28732000D+01,0.27991000D+01
     .,0.14263405D+04,0.164D+03,0.590D+02,0.28732000D+01,0.00000000D+00
     .,0.13689945D+04,0.164D+03,0.600D+02,0.28732000D+01,0.00000000D+00
     .,0.13344823D+04,0.164D+03,0.610D+02,0.28732000D+01,0.00000000D+00
     .,0.13027626D+04,0.164D+03,0.620D+02,0.28732000D+01,0.00000000D+00
     .,0.12746283D+04,0.164D+03,0.630D+02,0.28732000D+01,0.00000000D+00
     .,0.99906170D+03,0.164D+03,0.640D+02,0.28732000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57701:  57800)=(/
     . 0.11300310D+04,0.164D+03,0.650D+02,0.28732000D+01,0.00000000D+00
     .,0.10892614D+04,0.164D+03,0.660D+02,0.28732000D+01,0.00000000D+00
     .,0.11488304D+04,0.164D+03,0.670D+02,0.28732000D+01,0.00000000D+00
     .,0.11243657D+04,0.164D+03,0.680D+02,0.28732000D+01,0.00000000D+00
     .,0.11022614D+04,0.164D+03,0.690D+02,0.28732000D+01,0.00000000D+00
     .,0.10895200D+04,0.164D+03,0.700D+02,0.28732000D+01,0.00000000D+00
     .,0.91593800D+03,0.164D+03,0.710D+02,0.28732000D+01,0.00000000D+00
     .,0.89812800D+03,0.164D+03,0.720D+02,0.28732000D+01,0.00000000D+00
     .,0.81811890D+03,0.164D+03,0.730D+02,0.28732000D+01,0.00000000D+00
     .,0.68977370D+03,0.164D+03,0.740D+02,0.28732000D+01,0.00000000D+00
     .,0.70124130D+03,0.164D+03,0.750D+02,0.28732000D+01,0.00000000D+00
     .,0.63451700D+03,0.164D+03,0.760D+02,0.28732000D+01,0.00000000D+00
     .,0.58034520D+03,0.164D+03,0.770D+02,0.28732000D+01,0.00000000D+00
     .,0.48140120D+03,0.164D+03,0.780D+02,0.28732000D+01,0.00000000D+00
     .,0.44951810D+03,0.164D+03,0.790D+02,0.28732000D+01,0.00000000D+00
     .,0.46216400D+03,0.164D+03,0.800D+02,0.28732000D+01,0.00000000D+00
     .,0.67804940D+03,0.164D+03,0.810D+02,0.28732000D+01,0.00000000D+00
     .,0.66143650D+03,0.164D+03,0.820D+02,0.28732000D+01,0.00000000D+00
     .,0.60616090D+03,0.164D+03,0.830D+02,0.28732000D+01,0.00000000D+00
     .,0.57721150D+03,0.164D+03,0.840D+02,0.28732000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  57801:  57900)=(/
     . 0.53169500D+03,0.164D+03,0.850D+02,0.28732000D+01,0.00000000D+00
     .,0.48648120D+03,0.164D+03,0.860D+02,0.28732000D+01,0.00000000D+00
     .,0.16615027D+04,0.164D+03,0.870D+02,0.28732000D+01,0.00000000D+00
     .,0.15910020D+04,0.164D+03,0.880D+02,0.28732000D+01,0.00000000D+00
     .,0.14026190D+04,0.164D+03,0.890D+02,0.28732000D+01,0.00000000D+00
     .,0.12565351D+04,0.164D+03,0.900D+02,0.28732000D+01,0.00000000D+00
     .,0.12494197D+04,0.164D+03,0.910D+02,0.28732000D+01,0.00000000D+00
     .,0.12096721D+04,0.164D+03,0.920D+02,0.28732000D+01,0.00000000D+00
     .,0.12478750D+04,0.164D+03,0.930D+02,0.28732000D+01,0.00000000D+00
     .,0.12080168D+04,0.164D+03,0.940D+02,0.28732000D+01,0.00000000D+00
     .,0.66823500D+02,0.164D+03,0.101D+03,0.28732000D+01,0.00000000D+00
     .,0.21861950D+03,0.164D+03,0.103D+03,0.28732000D+01,0.98650000D+00
     .,0.27850800D+03,0.164D+03,0.104D+03,0.28732000D+01,0.98080000D+00
     .,0.21154850D+03,0.164D+03,0.105D+03,0.28732000D+01,0.97060000D+00
     .,0.15883010D+03,0.164D+03,0.106D+03,0.28732000D+01,0.98680000D+00
     .,0.11002650D+03,0.164D+03,0.107D+03,0.28732000D+01,0.99440000D+00
     .,0.79894900D+02,0.164D+03,0.108D+03,0.28732000D+01,0.99250000D+00
     .,0.54760000D+02,0.164D+03,0.109D+03,0.28732000D+01,0.99820000D+00
     .,0.31995720D+03,0.164D+03,0.111D+03,0.28732000D+01,0.96840000D+00
     .,0.49511470D+03,0.164D+03,0.112D+03,0.28732000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters(  57901:  58000)=(/
     . 0.49998200D+03,0.164D+03,0.113D+03,0.28732000D+01,0.96480000D+00
     .,0.39998160D+03,0.164D+03,0.114D+03,0.28732000D+01,0.95070000D+00
     .,0.32645920D+03,0.164D+03,0.115D+03,0.28732000D+01,0.99470000D+00
     .,0.27540540D+03,0.164D+03,0.116D+03,0.28732000D+01,0.99480000D+00
     .,0.22456980D+03,0.164D+03,0.117D+03,0.28732000D+01,0.99720000D+00
     .,0.43997650D+03,0.164D+03,0.119D+03,0.28732000D+01,0.97670000D+00
     .,0.84744860D+03,0.164D+03,0.120D+03,0.28732000D+01,0.98310000D+00
     .,0.43855500D+03,0.164D+03,0.121D+03,0.28732000D+01,0.18627000D+01
     .,0.42330690D+03,0.164D+03,0.122D+03,0.28732000D+01,0.18299000D+01
     .,0.41487410D+03,0.164D+03,0.123D+03,0.28732000D+01,0.19138000D+01
     .,0.41122300D+03,0.164D+03,0.124D+03,0.28732000D+01,0.18269000D+01
     .,0.37757470D+03,0.164D+03,0.125D+03,0.28732000D+01,0.16406000D+01
     .,0.34920950D+03,0.164D+03,0.126D+03,0.28732000D+01,0.16483000D+01
     .,0.33312400D+03,0.164D+03,0.127D+03,0.28732000D+01,0.17149000D+01
     .,0.32573280D+03,0.164D+03,0.128D+03,0.28732000D+01,0.17937000D+01
     .,0.32237280D+03,0.164D+03,0.129D+03,0.28732000D+01,0.95760000D+00
     .,0.30155830D+03,0.164D+03,0.130D+03,0.28732000D+01,0.19419000D+01
     .,0.49556680D+03,0.164D+03,0.131D+03,0.28732000D+01,0.96010000D+00
     .,0.43376750D+03,0.164D+03,0.132D+03,0.28732000D+01,0.94340000D+00
     .,0.38773360D+03,0.164D+03,0.133D+03,0.28732000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters(  58001:  58100)=(/
     . 0.35339890D+03,0.164D+03,0.134D+03,0.28732000D+01,0.99010000D+00
     .,0.31065690D+03,0.164D+03,0.135D+03,0.28732000D+01,0.99740000D+00
     .,0.52453740D+03,0.164D+03,0.137D+03,0.28732000D+01,0.97380000D+00
     .,0.10315808D+04,0.164D+03,0.138D+03,0.28732000D+01,0.98010000D+00
     .,0.78404790D+03,0.164D+03,0.139D+03,0.28732000D+01,0.19153000D+01
     .,0.58016290D+03,0.164D+03,0.140D+03,0.28732000D+01,0.19355000D+01
     .,0.58594010D+03,0.164D+03,0.141D+03,0.28732000D+01,0.19545000D+01
     .,0.54592550D+03,0.164D+03,0.142D+03,0.28732000D+01,0.19420000D+01
     .,0.61398170D+03,0.164D+03,0.143D+03,0.28732000D+01,0.16682000D+01
     .,0.47485900D+03,0.164D+03,0.144D+03,0.28732000D+01,0.18584000D+01
     .,0.44414170D+03,0.164D+03,0.145D+03,0.28732000D+01,0.19003000D+01
     .,0.41225320D+03,0.164D+03,0.146D+03,0.28732000D+01,0.18630000D+01
     .,0.39892850D+03,0.164D+03,0.147D+03,0.28732000D+01,0.96790000D+00
     .,0.39401610D+03,0.164D+03,0.148D+03,0.28732000D+01,0.19539000D+01
     .,0.62938940D+03,0.164D+03,0.149D+03,0.28732000D+01,0.96330000D+00
     .,0.56763680D+03,0.164D+03,0.150D+03,0.28732000D+01,0.95140000D+00
     .,0.53044640D+03,0.164D+03,0.151D+03,0.28732000D+01,0.97490000D+00
     .,0.50102050D+03,0.164D+03,0.152D+03,0.28732000D+01,0.98110000D+00
     .,0.45675320D+03,0.164D+03,0.153D+03,0.28732000D+01,0.99680000D+00
     .,0.61885080D+03,0.164D+03,0.155D+03,0.28732000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters(  58101:  58200)=(/
     . 0.13390290D+04,0.164D+03,0.156D+03,0.28732000D+01,0.97970000D+00
     .,0.99282930D+03,0.164D+03,0.157D+03,0.28732000D+01,0.19373000D+01
     .,0.62058810D+03,0.164D+03,0.159D+03,0.28732000D+01,0.29425000D+01
     .,0.60773400D+03,0.164D+03,0.160D+03,0.28732000D+01,0.29455000D+01
     .,0.58838130D+03,0.164D+03,0.161D+03,0.28732000D+01,0.29413000D+01
     .,0.59153680D+03,0.164D+03,0.162D+03,0.28732000D+01,0.29300000D+01
     .,0.57104500D+03,0.164D+03,0.163D+03,0.28732000D+01,0.18286000D+01
     .,0.59536280D+03,0.164D+03,0.164D+03,0.28732000D+01,0.28732000D+01
     .,0.38915000D+02,0.165D+03,0.100D+01,0.29086000D+01,0.91180000D+00
     .,0.25669500D+02,0.165D+03,0.200D+01,0.29086000D+01,0.00000000D+00
     .,0.61281660D+03,0.165D+03,0.300D+01,0.29086000D+01,0.00000000D+00
     .,0.35207530D+03,0.165D+03,0.400D+01,0.29086000D+01,0.00000000D+00
     .,0.23626590D+03,0.165D+03,0.500D+01,0.29086000D+01,0.00000000D+00
     .,0.15924220D+03,0.165D+03,0.600D+01,0.29086000D+01,0.00000000D+00
     .,0.11120430D+03,0.165D+03,0.700D+01,0.29086000D+01,0.00000000D+00
     .,0.84136300D+02,0.165D+03,0.800D+01,0.29086000D+01,0.00000000D+00
     .,0.63715200D+02,0.165D+03,0.900D+01,0.29086000D+01,0.00000000D+00
     .,0.49005000D+02,0.165D+03,0.100D+02,0.29086000D+01,0.00000000D+00
     .,0.73264570D+03,0.165D+03,0.110D+02,0.29086000D+01,0.00000000D+00
     .,0.56159910D+03,0.165D+03,0.120D+02,0.29086000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  58201:  58300)=(/
     . 0.51672630D+03,0.165D+03,0.130D+02,0.29086000D+01,0.00000000D+00
     .,0.40615220D+03,0.165D+03,0.140D+02,0.29086000D+01,0.00000000D+00
     .,0.31605550D+03,0.165D+03,0.150D+02,0.29086000D+01,0.00000000D+00
     .,0.26197720D+03,0.165D+03,0.160D+02,0.29086000D+01,0.00000000D+00
     .,0.21376170D+03,0.165D+03,0.170D+02,0.29086000D+01,0.00000000D+00
     .,0.17473800D+03,0.165D+03,0.180D+02,0.29086000D+01,0.00000000D+00
     .,0.12013307D+04,0.165D+03,0.190D+02,0.29086000D+01,0.00000000D+00
     .,0.98850950D+03,0.165D+03,0.200D+02,0.29086000D+01,0.00000000D+00
     .,0.81603910D+03,0.165D+03,0.210D+02,0.29086000D+01,0.00000000D+00
     .,0.78743780D+03,0.165D+03,0.220D+02,0.29086000D+01,0.00000000D+00
     .,0.72076790D+03,0.165D+03,0.230D+02,0.29086000D+01,0.00000000D+00
     .,0.56775360D+03,0.165D+03,0.240D+02,0.29086000D+01,0.00000000D+00
     .,0.62017110D+03,0.165D+03,0.250D+02,0.29086000D+01,0.00000000D+00
     .,0.48669710D+03,0.165D+03,0.260D+02,0.29086000D+01,0.00000000D+00
     .,0.51538390D+03,0.165D+03,0.270D+02,0.29086000D+01,0.00000000D+00
     .,0.53115950D+03,0.165D+03,0.280D+02,0.29086000D+01,0.00000000D+00
     .,0.40724140D+03,0.165D+03,0.290D+02,0.29086000D+01,0.00000000D+00
     .,0.41747630D+03,0.165D+03,0.300D+02,0.29086000D+01,0.00000000D+00
     .,0.49461700D+03,0.165D+03,0.310D+02,0.29086000D+01,0.00000000D+00
     .,0.43533390D+03,0.165D+03,0.320D+02,0.29086000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  58301:  58400)=(/
     . 0.37064210D+03,0.165D+03,0.330D+02,0.29086000D+01,0.00000000D+00
     .,0.33221730D+03,0.165D+03,0.340D+02,0.29086000D+01,0.00000000D+00
     .,0.29041790D+03,0.165D+03,0.350D+02,0.29086000D+01,0.00000000D+00
     .,0.25233250D+03,0.165D+03,0.360D+02,0.29086000D+01,0.00000000D+00
     .,0.13459552D+04,0.165D+03,0.370D+02,0.29086000D+01,0.00000000D+00
     .,0.11778523D+04,0.165D+03,0.380D+02,0.29086000D+01,0.00000000D+00
     .,0.10302577D+04,0.165D+03,0.390D+02,0.29086000D+01,0.00000000D+00
     .,0.92507300D+03,0.165D+03,0.400D+02,0.29086000D+01,0.00000000D+00
     .,0.84300140D+03,0.165D+03,0.410D+02,0.29086000D+01,0.00000000D+00
     .,0.65010950D+03,0.165D+03,0.420D+02,0.29086000D+01,0.00000000D+00
     .,0.72565600D+03,0.165D+03,0.430D+02,0.29086000D+01,0.00000000D+00
     .,0.55217930D+03,0.165D+03,0.440D+02,0.29086000D+01,0.00000000D+00
     .,0.60356690D+03,0.165D+03,0.450D+02,0.29086000D+01,0.00000000D+00
     .,0.55949210D+03,0.165D+03,0.460D+02,0.29086000D+01,0.00000000D+00
     .,0.46665970D+03,0.165D+03,0.470D+02,0.29086000D+01,0.00000000D+00
     .,0.49276250D+03,0.165D+03,0.480D+02,0.29086000D+01,0.00000000D+00
     .,0.61913660D+03,0.165D+03,0.490D+02,0.29086000D+01,0.00000000D+00
     .,0.57157510D+03,0.165D+03,0.500D+02,0.29086000D+01,0.00000000D+00
     .,0.50851710D+03,0.165D+03,0.510D+02,0.29086000D+01,0.00000000D+00
     .,0.47131940D+03,0.165D+03,0.520D+02,0.29086000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  58401:  58500)=(/
     . 0.42569420D+03,0.165D+03,0.530D+02,0.29086000D+01,0.00000000D+00
     .,0.38234290D+03,0.165D+03,0.540D+02,0.29086000D+01,0.00000000D+00
     .,0.16393995D+04,0.165D+03,0.550D+02,0.29086000D+01,0.00000000D+00
     .,0.15021922D+04,0.165D+03,0.560D+02,0.29086000D+01,0.00000000D+00
     .,0.13178387D+04,0.165D+03,0.570D+02,0.29086000D+01,0.00000000D+00
     .,0.60095180D+03,0.165D+03,0.580D+02,0.29086000D+01,0.27991000D+01
     .,0.13303810D+04,0.165D+03,0.590D+02,0.29086000D+01,0.00000000D+00
     .,0.12772241D+04,0.165D+03,0.600D+02,0.29086000D+01,0.00000000D+00
     .,0.12451109D+04,0.165D+03,0.610D+02,0.29086000D+01,0.00000000D+00
     .,0.12155853D+04,0.165D+03,0.620D+02,0.29086000D+01,0.00000000D+00
     .,0.11893991D+04,0.165D+03,0.630D+02,0.29086000D+01,0.00000000D+00
     .,0.93372280D+03,0.165D+03,0.640D+02,0.29086000D+01,0.00000000D+00
     .,0.10536587D+04,0.165D+03,0.650D+02,0.29086000D+01,0.00000000D+00
     .,0.10158840D+04,0.165D+03,0.660D+02,0.29086000D+01,0.00000000D+00
     .,0.10723978D+04,0.165D+03,0.670D+02,0.29086000D+01,0.00000000D+00
     .,0.10495999D+04,0.165D+03,0.680D+02,0.29086000D+01,0.00000000D+00
     .,0.10290199D+04,0.165D+03,0.690D+02,0.29086000D+01,0.00000000D+00
     .,0.10170572D+04,0.165D+03,0.700D+02,0.29086000D+01,0.00000000D+00
     .,0.85590310D+03,0.165D+03,0.710D+02,0.29086000D+01,0.00000000D+00
     .,0.84038840D+03,0.165D+03,0.720D+02,0.29086000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  58501:  58600)=(/
     . 0.76618830D+03,0.165D+03,0.730D+02,0.29086000D+01,0.00000000D+00
     .,0.64647490D+03,0.165D+03,0.740D+02,0.29086000D+01,0.00000000D+00
     .,0.65742490D+03,0.165D+03,0.750D+02,0.29086000D+01,0.00000000D+00
     .,0.59532710D+03,0.165D+03,0.760D+02,0.29086000D+01,0.00000000D+00
     .,0.54484580D+03,0.165D+03,0.770D+02,0.29086000D+01,0.00000000D+00
     .,0.45230750D+03,0.165D+03,0.780D+02,0.29086000D+01,0.00000000D+00
     .,0.42248760D+03,0.165D+03,0.790D+02,0.29086000D+01,0.00000000D+00
     .,0.43446390D+03,0.165D+03,0.800D+02,0.29086000D+01,0.00000000D+00
     .,0.63542770D+03,0.165D+03,0.810D+02,0.29086000D+01,0.00000000D+00
     .,0.62048770D+03,0.165D+03,0.820D+02,0.29086000D+01,0.00000000D+00
     .,0.56929560D+03,0.165D+03,0.830D+02,0.29086000D+01,0.00000000D+00
     .,0.54247560D+03,0.165D+03,0.840D+02,0.29086000D+01,0.00000000D+00
     .,0.50012070D+03,0.165D+03,0.850D+02,0.29086000D+01,0.00000000D+00
     .,0.45795880D+03,0.165D+03,0.860D+02,0.29086000D+01,0.00000000D+00
     .,0.15463042D+04,0.165D+03,0.870D+02,0.29086000D+01,0.00000000D+00
     .,0.14842932D+04,0.165D+03,0.880D+02,0.29086000D+01,0.00000000D+00
     .,0.13102595D+04,0.165D+03,0.890D+02,0.29086000D+01,0.00000000D+00
     .,0.11755520D+04,0.165D+03,0.900D+02,0.29086000D+01,0.00000000D+00
     .,0.11681093D+04,0.165D+03,0.910D+02,0.29086000D+01,0.00000000D+00
     .,0.11310127D+04,0.165D+03,0.920D+02,0.29086000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  58601:  58700)=(/
     . 0.11657289D+04,0.165D+03,0.930D+02,0.29086000D+01,0.00000000D+00
     .,0.11286850D+04,0.165D+03,0.940D+02,0.29086000D+01,0.00000000D+00
     .,0.62797100D+02,0.165D+03,0.101D+03,0.29086000D+01,0.00000000D+00
     .,0.20455140D+03,0.165D+03,0.103D+03,0.29086000D+01,0.98650000D+00
     .,0.26072450D+03,0.165D+03,0.104D+03,0.29086000D+01,0.98080000D+00
     .,0.19860250D+03,0.165D+03,0.105D+03,0.29086000D+01,0.97060000D+00
     .,0.14938110D+03,0.165D+03,0.106D+03,0.29086000D+01,0.98680000D+00
     .,0.10370340D+03,0.165D+03,0.107D+03,0.29086000D+01,0.99440000D+00
     .,0.75446500D+02,0.165D+03,0.108D+03,0.29086000D+01,0.99250000D+00
     .,0.51841400D+02,0.165D+03,0.109D+03,0.29086000D+01,0.99820000D+00
     .,0.29924680D+03,0.165D+03,0.111D+03,0.29086000D+01,0.96840000D+00
     .,0.46288270D+03,0.165D+03,0.112D+03,0.29086000D+01,0.96280000D+00
     .,0.46808680D+03,0.165D+03,0.113D+03,0.29086000D+01,0.96480000D+00
     .,0.37524590D+03,0.165D+03,0.114D+03,0.29086000D+01,0.95070000D+00
     .,0.30676780D+03,0.165D+03,0.115D+03,0.29086000D+01,0.99470000D+00
     .,0.25910430D+03,0.165D+03,0.116D+03,0.29086000D+01,0.99480000D+00
     .,0.21155470D+03,0.165D+03,0.117D+03,0.29086000D+01,0.99720000D+00
     .,0.41206550D+03,0.165D+03,0.119D+03,0.29086000D+01,0.97670000D+00
     .,0.79052270D+03,0.165D+03,0.120D+03,0.29086000D+01,0.98310000D+00
     .,0.41139690D+03,0.165D+03,0.121D+03,0.29086000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters(  58701:  58800)=(/
     . 0.39711900D+03,0.165D+03,0.122D+03,0.29086000D+01,0.18299000D+01
     .,0.38920800D+03,0.165D+03,0.123D+03,0.29086000D+01,0.19138000D+01
     .,0.38571070D+03,0.165D+03,0.124D+03,0.29086000D+01,0.18269000D+01
     .,0.35449400D+03,0.165D+03,0.125D+03,0.29086000D+01,0.16406000D+01
     .,0.32797050D+03,0.165D+03,0.126D+03,0.29086000D+01,0.16483000D+01
     .,0.31287350D+03,0.165D+03,0.127D+03,0.29086000D+01,0.17149000D+01
     .,0.30591120D+03,0.165D+03,0.128D+03,0.29086000D+01,0.17937000D+01
     .,0.30254470D+03,0.165D+03,0.129D+03,0.29086000D+01,0.95760000D+00
     .,0.28337650D+03,0.165D+03,0.130D+03,0.29086000D+01,0.19419000D+01
     .,0.46432020D+03,0.165D+03,0.131D+03,0.29086000D+01,0.96010000D+00
     .,0.40707180D+03,0.165D+03,0.132D+03,0.29086000D+01,0.94340000D+00
     .,0.36431690D+03,0.165D+03,0.133D+03,0.29086000D+01,0.98890000D+00
     .,0.33235190D+03,0.165D+03,0.134D+03,0.29086000D+01,0.99010000D+00
     .,0.29245640D+03,0.165D+03,0.135D+03,0.29086000D+01,0.99740000D+00
     .,0.49146210D+03,0.165D+03,0.137D+03,0.29086000D+01,0.97380000D+00
     .,0.96209720D+03,0.165D+03,0.138D+03,0.29086000D+01,0.98010000D+00
     .,0.73326220D+03,0.165D+03,0.139D+03,0.29086000D+01,0.19153000D+01
     .,0.54416190D+03,0.165D+03,0.140D+03,0.29086000D+01,0.19355000D+01
     .,0.54959500D+03,0.165D+03,0.141D+03,0.29086000D+01,0.19545000D+01
     .,0.51226070D+03,0.165D+03,0.142D+03,0.29086000D+01,0.19420000D+01
     ./)
      grimme_c6_parameters(  58801:  58900)=(/
     . 0.57535150D+03,0.165D+03,0.143D+03,0.29086000D+01,0.16682000D+01
     .,0.44604100D+03,0.165D+03,0.144D+03,0.29086000D+01,0.18584000D+01
     .,0.41725200D+03,0.165D+03,0.145D+03,0.29086000D+01,0.19003000D+01
     .,0.38739090D+03,0.165D+03,0.146D+03,0.29086000D+01,0.18630000D+01
     .,0.37483220D+03,0.165D+03,0.147D+03,0.29086000D+01,0.96790000D+00
     .,0.37045920D+03,0.165D+03,0.148D+03,0.29086000D+01,0.19539000D+01
     .,0.58983000D+03,0.165D+03,0.149D+03,0.29086000D+01,0.96330000D+00
     .,0.53268550D+03,0.165D+03,0.150D+03,0.29086000D+01,0.95140000D+00
     .,0.49826300D+03,0.165D+03,0.151D+03,0.29086000D+01,0.97490000D+00
     .,0.47094350D+03,0.165D+03,0.152D+03,0.29086000D+01,0.98110000D+00
     .,0.42969450D+03,0.165D+03,0.153D+03,0.29086000D+01,0.99680000D+00
     .,0.58038410D+03,0.165D+03,0.155D+03,0.29086000D+01,0.99090000D+00
     .,0.12480182D+04,0.165D+03,0.156D+03,0.29086000D+01,0.97970000D+00
     .,0.92827050D+03,0.165D+03,0.157D+03,0.29086000D+01,0.19373000D+01
     .,0.58277730D+03,0.165D+03,0.159D+03,0.29086000D+01,0.29425000D+01
     .,0.57071750D+03,0.165D+03,0.160D+03,0.29086000D+01,0.29455000D+01
     .,0.55258430D+03,0.165D+03,0.161D+03,0.29086000D+01,0.29413000D+01
     .,0.55542950D+03,0.165D+03,0.162D+03,0.29086000D+01,0.29300000D+01
     .,0.53587600D+03,0.165D+03,0.163D+03,0.29086000D+01,0.18286000D+01
     .,0.55897620D+03,0.165D+03,0.164D+03,0.29086000D+01,0.28732000D+01
     ./)
      grimme_c6_parameters(  58901:  59000)=(/
     . 0.52491950D+03,0.165D+03,0.165D+03,0.29086000D+01,0.29086000D+01
     .,0.39396700D+02,0.166D+03,0.100D+01,0.28965000D+01,0.91180000D+00
     .,0.25865800D+02,0.166D+03,0.200D+01,0.28965000D+01,0.00000000D+00
     .,0.63848500D+03,0.166D+03,0.300D+01,0.28965000D+01,0.00000000D+00
     .,0.36118220D+03,0.166D+03,0.400D+01,0.28965000D+01,0.00000000D+00
     .,0.24078360D+03,0.166D+03,0.500D+01,0.28965000D+01,0.00000000D+00
     .,0.16156910D+03,0.166D+03,0.600D+01,0.28965000D+01,0.00000000D+00
     .,0.11248360D+03,0.166D+03,0.700D+01,0.28965000D+01,0.00000000D+00
     .,0.84928800D+02,0.166D+03,0.800D+01,0.28965000D+01,0.00000000D+00
     .,0.64205600D+02,0.166D+03,0.900D+01,0.28965000D+01,0.00000000D+00
     .,0.49316600D+02,0.166D+03,0.100D+02,0.28965000D+01,0.00000000D+00
     .,0.76254390D+03,0.166D+03,0.110D+02,0.28965000D+01,0.00000000D+00
     .,0.57748050D+03,0.166D+03,0.120D+02,0.28965000D+01,0.00000000D+00
     .,0.52942090D+03,0.166D+03,0.130D+02,0.28965000D+01,0.00000000D+00
     .,0.41417170D+03,0.166D+03,0.140D+02,0.28965000D+01,0.00000000D+00
     .,0.32113630D+03,0.166D+03,0.150D+02,0.28965000D+01,0.00000000D+00
     .,0.26561240D+03,0.166D+03,0.160D+02,0.28965000D+01,0.00000000D+00
     .,0.21629400D+03,0.166D+03,0.170D+02,0.28965000D+01,0.00000000D+00
     .,0.17651170D+03,0.166D+03,0.180D+02,0.28965000D+01,0.00000000D+00
     .,0.12553434D+04,0.166D+03,0.190D+02,0.28965000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59001:  59100)=(/
     . 0.10213342D+04,0.166D+03,0.200D+02,0.28965000D+01,0.00000000D+00
     .,0.84137840D+03,0.166D+03,0.210D+02,0.28965000D+01,0.00000000D+00
     .,0.81057120D+03,0.166D+03,0.220D+02,0.28965000D+01,0.00000000D+00
     .,0.74119950D+03,0.166D+03,0.230D+02,0.28965000D+01,0.00000000D+00
     .,0.58388160D+03,0.166D+03,0.240D+02,0.28965000D+01,0.00000000D+00
     .,0.63684280D+03,0.166D+03,0.250D+02,0.28965000D+01,0.00000000D+00
     .,0.49970290D+03,0.166D+03,0.260D+02,0.28965000D+01,0.00000000D+00
     .,0.52794350D+03,0.166D+03,0.270D+02,0.28965000D+01,0.00000000D+00
     .,0.54462440D+03,0.166D+03,0.280D+02,0.28965000D+01,0.00000000D+00
     .,0.41763490D+03,0.166D+03,0.290D+02,0.28965000D+01,0.00000000D+00
     .,0.42675460D+03,0.166D+03,0.300D+02,0.28965000D+01,0.00000000D+00
     .,0.50613150D+03,0.166D+03,0.310D+02,0.28965000D+01,0.00000000D+00
     .,0.44382260D+03,0.166D+03,0.320D+02,0.28965000D+01,0.00000000D+00
     .,0.37672490D+03,0.166D+03,0.330D+02,0.28965000D+01,0.00000000D+00
     .,0.33707580D+03,0.166D+03,0.340D+02,0.28965000D+01,0.00000000D+00
     .,0.29415100D+03,0.166D+03,0.350D+02,0.28965000D+01,0.00000000D+00
     .,0.25518090D+03,0.166D+03,0.360D+02,0.28965000D+01,0.00000000D+00
     .,0.14056043D+04,0.166D+03,0.370D+02,0.28965000D+01,0.00000000D+00
     .,0.12176072D+04,0.166D+03,0.380D+02,0.28965000D+01,0.00000000D+00
     .,0.10613052D+04,0.166D+03,0.390D+02,0.28965000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59101:  59200)=(/
     . 0.95099220D+03,0.166D+03,0.400D+02,0.28965000D+01,0.00000000D+00
     .,0.86553240D+03,0.166D+03,0.410D+02,0.28965000D+01,0.00000000D+00
     .,0.66608950D+03,0.166D+03,0.420D+02,0.28965000D+01,0.00000000D+00
     .,0.74408720D+03,0.166D+03,0.430D+02,0.28965000D+01,0.00000000D+00
     .,0.56489840D+03,0.166D+03,0.440D+02,0.28965000D+01,0.00000000D+00
     .,0.61735350D+03,0.166D+03,0.450D+02,0.28965000D+01,0.00000000D+00
     .,0.57182020D+03,0.166D+03,0.460D+02,0.28965000D+01,0.00000000D+00
     .,0.47729120D+03,0.166D+03,0.470D+02,0.28965000D+01,0.00000000D+00
     .,0.50312050D+03,0.166D+03,0.480D+02,0.28965000D+01,0.00000000D+00
     .,0.63374930D+03,0.166D+03,0.490D+02,0.28965000D+01,0.00000000D+00
     .,0.58321300D+03,0.166D+03,0.500D+02,0.28965000D+01,0.00000000D+00
     .,0.51742880D+03,0.166D+03,0.510D+02,0.28965000D+01,0.00000000D+00
     .,0.47882440D+03,0.166D+03,0.520D+02,0.28965000D+01,0.00000000D+00
     .,0.43176670D+03,0.166D+03,0.530D+02,0.28965000D+01,0.00000000D+00
     .,0.38721870D+03,0.166D+03,0.540D+02,0.28965000D+01,0.00000000D+00
     .,0.17128830D+04,0.166D+03,0.550D+02,0.28965000D+01,0.00000000D+00
     .,0.15552120D+04,0.166D+03,0.560D+02,0.28965000D+01,0.00000000D+00
     .,0.13593802D+04,0.166D+03,0.570D+02,0.28965000D+01,0.00000000D+00
     .,0.61183610D+03,0.166D+03,0.580D+02,0.28965000D+01,0.27991000D+01
     .,0.13758472D+04,0.166D+03,0.590D+02,0.28965000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59201:  59300)=(/
     . 0.13197747D+04,0.166D+03,0.600D+02,0.28965000D+01,0.00000000D+00
     .,0.12863433D+04,0.166D+03,0.610D+02,0.28965000D+01,0.00000000D+00
     .,0.12556329D+04,0.166D+03,0.620D+02,0.28965000D+01,0.00000000D+00
     .,0.12283897D+04,0.166D+03,0.630D+02,0.28965000D+01,0.00000000D+00
     .,0.96089950D+03,0.166D+03,0.640D+02,0.28965000D+01,0.00000000D+00
     .,0.10913776D+04,0.166D+03,0.650D+02,0.28965000D+01,0.00000000D+00
     .,0.10518609D+04,0.166D+03,0.660D+02,0.28965000D+01,0.00000000D+00
     .,0.11064740D+04,0.166D+03,0.670D+02,0.28965000D+01,0.00000000D+00
     .,0.10828259D+04,0.166D+03,0.680D+02,0.28965000D+01,0.00000000D+00
     .,0.10614329D+04,0.166D+03,0.690D+02,0.28965000D+01,0.00000000D+00
     .,0.10492440D+04,0.166D+03,0.700D+02,0.28965000D+01,0.00000000D+00
     .,0.88106130D+03,0.166D+03,0.710D+02,0.28965000D+01,0.00000000D+00
     .,0.86194390D+03,0.166D+03,0.720D+02,0.28965000D+01,0.00000000D+00
     .,0.78433470D+03,0.166D+03,0.730D+02,0.28965000D+01,0.00000000D+00
     .,0.66095780D+03,0.166D+03,0.740D+02,0.28965000D+01,0.00000000D+00
     .,0.67162740D+03,0.166D+03,0.750D+02,0.28965000D+01,0.00000000D+00
     .,0.60723190D+03,0.166D+03,0.760D+02,0.28965000D+01,0.00000000D+00
     .,0.55505840D+03,0.166D+03,0.770D+02,0.28965000D+01,0.00000000D+00
     .,0.46025170D+03,0.166D+03,0.780D+02,0.28965000D+01,0.00000000D+00
     .,0.42970270D+03,0.166D+03,0.790D+02,0.28965000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59301:  59400)=(/
     . 0.44159570D+03,0.166D+03,0.800D+02,0.28965000D+01,0.00000000D+00
     .,0.65009130D+03,0.166D+03,0.810D+02,0.28965000D+01,0.00000000D+00
     .,0.63314710D+03,0.166D+03,0.820D+02,0.28965000D+01,0.00000000D+00
     .,0.57941850D+03,0.166D+03,0.830D+02,0.28965000D+01,0.00000000D+00
     .,0.55135470D+03,0.166D+03,0.840D+02,0.28965000D+01,0.00000000D+00
     .,0.50749380D+03,0.166D+03,0.850D+02,0.28965000D+01,0.00000000D+00
     .,0.46406150D+03,0.166D+03,0.860D+02,0.28965000D+01,0.00000000D+00
     .,0.16099709D+04,0.166D+03,0.870D+02,0.28965000D+01,0.00000000D+00
     .,0.15338391D+04,0.166D+03,0.880D+02,0.28965000D+01,0.00000000D+00
     .,0.13494846D+04,0.166D+03,0.890D+02,0.28965000D+01,0.00000000D+00
     .,0.12065102D+04,0.166D+03,0.900D+02,0.28965000D+01,0.00000000D+00
     .,0.12011049D+04,0.166D+03,0.910D+02,0.28965000D+01,0.00000000D+00
     .,0.11628261D+04,0.166D+03,0.920D+02,0.28965000D+01,0.00000000D+00
     .,0.12010327D+04,0.166D+03,0.930D+02,0.28965000D+01,0.00000000D+00
     .,0.11623643D+04,0.166D+03,0.940D+02,0.28965000D+01,0.00000000D+00
     .,0.63781600D+02,0.166D+03,0.101D+03,0.28965000D+01,0.00000000D+00
     .,0.20966850D+03,0.166D+03,0.103D+03,0.28965000D+01,0.98650000D+00
     .,0.26699220D+03,0.166D+03,0.104D+03,0.28965000D+01,0.98080000D+00
     .,0.20215950D+03,0.166D+03,0.105D+03,0.28965000D+01,0.97060000D+00
     .,0.15159630D+03,0.166D+03,0.106D+03,0.28965000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  59401:  59500)=(/
     . 0.10489910D+03,0.166D+03,0.107D+03,0.28965000D+01,0.99440000D+00
     .,0.76120900D+02,0.166D+03,0.108D+03,0.28965000D+01,0.99250000D+00
     .,0.52145400D+02,0.166D+03,0.109D+03,0.28965000D+01,0.99820000D+00
     .,0.30714640D+03,0.166D+03,0.111D+03,0.28965000D+01,0.96840000D+00
     .,0.47548270D+03,0.166D+03,0.112D+03,0.28965000D+01,0.96280000D+00
     .,0.47919230D+03,0.166D+03,0.113D+03,0.28965000D+01,0.96480000D+00
     .,0.38242860D+03,0.166D+03,0.114D+03,0.28965000D+01,0.95070000D+00
     .,0.31166960D+03,0.166D+03,0.115D+03,0.28965000D+01,0.99470000D+00
     .,0.26271630D+03,0.166D+03,0.116D+03,0.28965000D+01,0.99480000D+00
     .,0.21407020D+03,0.166D+03,0.117D+03,0.28965000D+01,0.99720000D+00
     .,0.42205350D+03,0.166D+03,0.119D+03,0.28965000D+01,0.97670000D+00
     .,0.81742610D+03,0.166D+03,0.120D+03,0.28965000D+01,0.98310000D+00
     .,0.41957740D+03,0.166D+03,0.121D+03,0.28965000D+01,0.18627000D+01
     .,0.40507580D+03,0.166D+03,0.122D+03,0.28965000D+01,0.18299000D+01
     .,0.39701800D+03,0.166D+03,0.123D+03,0.28965000D+01,0.19138000D+01
     .,0.39363860D+03,0.166D+03,0.124D+03,0.28965000D+01,0.18269000D+01
     .,0.36094370D+03,0.166D+03,0.125D+03,0.28965000D+01,0.16406000D+01
     .,0.33374440D+03,0.166D+03,0.126D+03,0.28965000D+01,0.16483000D+01
     .,0.31840100D+03,0.166D+03,0.127D+03,0.28965000D+01,0.17149000D+01
     .,0.31136890D+03,0.166D+03,0.128D+03,0.28965000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters(  59501:  59600)=(/
     . 0.30844670D+03,0.166D+03,0.129D+03,0.28965000D+01,0.95760000D+00
     .,0.28804090D+03,0.166D+03,0.130D+03,0.28965000D+01,0.19419000D+01
     .,0.47467810D+03,0.166D+03,0.131D+03,0.28965000D+01,0.96010000D+00
     .,0.41468730D+03,0.166D+03,0.132D+03,0.28965000D+01,0.94340000D+00
     .,0.37023680D+03,0.166D+03,0.133D+03,0.28965000D+01,0.98890000D+00
     .,0.33722390D+03,0.166D+03,0.134D+03,0.28965000D+01,0.99010000D+00
     .,0.29624340D+03,0.166D+03,0.135D+03,0.28965000D+01,0.99740000D+00
     .,0.50300950D+03,0.166D+03,0.137D+03,0.28965000D+01,0.97380000D+00
     .,0.99563320D+03,0.166D+03,0.138D+03,0.28965000D+01,0.98010000D+00
     .,0.75368720D+03,0.166D+03,0.139D+03,0.28965000D+01,0.19153000D+01
     .,0.55531660D+03,0.166D+03,0.140D+03,0.28965000D+01,0.19355000D+01
     .,0.56079120D+03,0.166D+03,0.141D+03,0.28965000D+01,0.19545000D+01
     .,0.52244060D+03,0.166D+03,0.142D+03,0.28965000D+01,0.19420000D+01
     .,0.58868540D+03,0.166D+03,0.143D+03,0.28965000D+01,0.16682000D+01
     .,0.45392960D+03,0.166D+03,0.144D+03,0.28965000D+01,0.18584000D+01
     .,0.42457780D+03,0.166D+03,0.145D+03,0.28965000D+01,0.19003000D+01
     .,0.39405630D+03,0.166D+03,0.146D+03,0.28965000D+01,0.18630000D+01
     .,0.38138420D+03,0.166D+03,0.147D+03,0.28965000D+01,0.96790000D+00
     .,0.37631210D+03,0.166D+03,0.148D+03,0.28965000D+01,0.19539000D+01
     .,0.60308050D+03,0.166D+03,0.149D+03,0.28965000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters(  59601:  59700)=(/
     . 0.54294040D+03,0.166D+03,0.150D+03,0.28965000D+01,0.95140000D+00
     .,0.50681590D+03,0.166D+03,0.151D+03,0.28965000D+01,0.97490000D+00
     .,0.47839610D+03,0.166D+03,0.152D+03,0.28965000D+01,0.98110000D+00
     .,0.43583490D+03,0.166D+03,0.153D+03,0.28965000D+01,0.99680000D+00
     .,0.59259730D+03,0.166D+03,0.155D+03,0.28965000D+01,0.99090000D+00
     .,0.12943501D+04,0.166D+03,0.156D+03,0.28965000D+01,0.97970000D+00
     .,0.95498290D+03,0.166D+03,0.157D+03,0.28965000D+01,0.19373000D+01
     .,0.59324060D+03,0.166D+03,0.159D+03,0.28965000D+01,0.29425000D+01
     .,0.58094220D+03,0.166D+03,0.160D+03,0.28965000D+01,0.29455000D+01
     .,0.56241030D+03,0.166D+03,0.161D+03,0.28965000D+01,0.29413000D+01
     .,0.56558410D+03,0.166D+03,0.162D+03,0.28965000D+01,0.29300000D+01
     .,0.54641960D+03,0.166D+03,0.163D+03,0.28965000D+01,0.18286000D+01
     .,0.56923180D+03,0.166D+03,0.164D+03,0.28965000D+01,0.28732000D+01
     .,0.53434800D+03,0.166D+03,0.165D+03,0.28965000D+01,0.29086000D+01
     .,0.54443560D+03,0.166D+03,0.166D+03,0.28965000D+01,0.28965000D+01
     .,0.37029500D+02,0.167D+03,0.100D+01,0.29242000D+01,0.91180000D+00
     .,0.24480600D+02,0.167D+03,0.200D+01,0.29242000D+01,0.00000000D+00
     .,0.57574990D+03,0.167D+03,0.300D+01,0.29242000D+01,0.00000000D+00
     .,0.33286460D+03,0.167D+03,0.400D+01,0.29242000D+01,0.00000000D+00
     .,0.22408560D+03,0.167D+03,0.500D+01,0.29242000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59701:  59800)=(/
     . 0.15136070D+03,0.167D+03,0.600D+01,0.29242000D+01,0.00000000D+00
     .,0.10585820D+03,0.167D+03,0.700D+01,0.29242000D+01,0.00000000D+00
     .,0.80170400D+02,0.167D+03,0.800D+01,0.29242000D+01,0.00000000D+00
     .,0.60759800D+02,0.167D+03,0.900D+01,0.29242000D+01,0.00000000D+00
     .,0.46759500D+02,0.167D+03,0.100D+02,0.29242000D+01,0.00000000D+00
     .,0.68859100D+03,0.167D+03,0.110D+02,0.29242000D+01,0.00000000D+00
     .,0.53038700D+03,0.167D+03,0.120D+02,0.29242000D+01,0.00000000D+00
     .,0.48884720D+03,0.167D+03,0.130D+02,0.29242000D+01,0.00000000D+00
     .,0.38509520D+03,0.167D+03,0.140D+02,0.29242000D+01,0.00000000D+00
     .,0.30019740D+03,0.167D+03,0.150D+02,0.29242000D+01,0.00000000D+00
     .,0.24909840D+03,0.167D+03,0.160D+02,0.29242000D+01,0.00000000D+00
     .,0.20345290D+03,0.167D+03,0.170D+02,0.29242000D+01,0.00000000D+00
     .,0.16644660D+03,0.167D+03,0.180D+02,0.29242000D+01,0.00000000D+00
     .,0.11279480D+04,0.167D+03,0.190D+02,0.29242000D+01,0.00000000D+00
     .,0.93174430D+03,0.167D+03,0.200D+02,0.29242000D+01,0.00000000D+00
     .,0.76983360D+03,0.167D+03,0.210D+02,0.29242000D+01,0.00000000D+00
     .,0.74340690D+03,0.167D+03,0.220D+02,0.29242000D+01,0.00000000D+00
     .,0.68076970D+03,0.167D+03,0.230D+02,0.29242000D+01,0.00000000D+00
     .,0.53627310D+03,0.167D+03,0.240D+02,0.29242000D+01,0.00000000D+00
     .,0.58613150D+03,0.167D+03,0.250D+02,0.29242000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59801:  59900)=(/
     . 0.46004150D+03,0.167D+03,0.260D+02,0.29242000D+01,0.00000000D+00
     .,0.48762020D+03,0.167D+03,0.270D+02,0.29242000D+01,0.00000000D+00
     .,0.50232060D+03,0.167D+03,0.280D+02,0.29242000D+01,0.00000000D+00
     .,0.38513270D+03,0.167D+03,0.290D+02,0.29242000D+01,0.00000000D+00
     .,0.39536540D+03,0.167D+03,0.300D+02,0.29242000D+01,0.00000000D+00
     .,0.46822770D+03,0.167D+03,0.310D+02,0.29242000D+01,0.00000000D+00
     .,0.41281620D+03,0.167D+03,0.320D+02,0.29242000D+01,0.00000000D+00
     .,0.35198750D+03,0.167D+03,0.330D+02,0.29242000D+01,0.00000000D+00
     .,0.31577010D+03,0.167D+03,0.340D+02,0.29242000D+01,0.00000000D+00
     .,0.27627680D+03,0.167D+03,0.350D+02,0.29242000D+01,0.00000000D+00
     .,0.24022750D+03,0.167D+03,0.360D+02,0.29242000D+01,0.00000000D+00
     .,0.12641518D+04,0.167D+03,0.370D+02,0.29242000D+01,0.00000000D+00
     .,0.11100442D+04,0.167D+03,0.380D+02,0.29242000D+01,0.00000000D+00
     .,0.97238640D+03,0.167D+03,0.390D+02,0.29242000D+01,0.00000000D+00
     .,0.87389940D+03,0.167D+03,0.400D+02,0.29242000D+01,0.00000000D+00
     .,0.79683270D+03,0.167D+03,0.410D+02,0.29242000D+01,0.00000000D+00
     .,0.61510520D+03,0.167D+03,0.420D+02,0.29242000D+01,0.00000000D+00
     .,0.68633810D+03,0.167D+03,0.430D+02,0.29242000D+01,0.00000000D+00
     .,0.52281640D+03,0.167D+03,0.440D+02,0.29242000D+01,0.00000000D+00
     .,0.57148280D+03,0.167D+03,0.450D+02,0.29242000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  59901:  60000)=(/
     . 0.52993880D+03,0.167D+03,0.460D+02,0.29242000D+01,0.00000000D+00
     .,0.44189760D+03,0.167D+03,0.470D+02,0.29242000D+01,0.00000000D+00
     .,0.46694330D+03,0.167D+03,0.480D+02,0.29242000D+01,0.00000000D+00
     .,0.58603950D+03,0.167D+03,0.490D+02,0.29242000D+01,0.00000000D+00
     .,0.54179100D+03,0.167D+03,0.500D+02,0.29242000D+01,0.00000000D+00
     .,0.48265820D+03,0.167D+03,0.510D+02,0.29242000D+01,0.00000000D+00
     .,0.44769600D+03,0.167D+03,0.520D+02,0.29242000D+01,0.00000000D+00
     .,0.40468130D+03,0.167D+03,0.530D+02,0.29242000D+01,0.00000000D+00
     .,0.36373600D+03,0.167D+03,0.540D+02,0.29242000D+01,0.00000000D+00
     .,0.15398453D+04,0.167D+03,0.550D+02,0.29242000D+01,0.00000000D+00
     .,0.14149943D+04,0.167D+03,0.560D+02,0.29242000D+01,0.00000000D+00
     .,0.12431883D+04,0.167D+03,0.570D+02,0.29242000D+01,0.00000000D+00
     .,0.57024510D+03,0.167D+03,0.580D+02,0.29242000D+01,0.27991000D+01
     .,0.12537691D+04,0.167D+03,0.590D+02,0.29242000D+01,0.00000000D+00
     .,0.12039727D+04,0.167D+03,0.600D+02,0.29242000D+01,0.00000000D+00
     .,0.11737842D+04,0.167D+03,0.610D+02,0.29242000D+01,0.00000000D+00
     .,0.11460194D+04,0.167D+03,0.620D+02,0.29242000D+01,0.00000000D+00
     .,0.11213978D+04,0.167D+03,0.630D+02,0.29242000D+01,0.00000000D+00
     .,0.88175490D+03,0.167D+03,0.640D+02,0.29242000D+01,0.00000000D+00
     .,0.99262670D+03,0.167D+03,0.650D+02,0.29242000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60001:  60100)=(/
     . 0.95731530D+03,0.167D+03,0.660D+02,0.29242000D+01,0.00000000D+00
     .,0.10114677D+04,0.167D+03,0.670D+02,0.29242000D+01,0.00000000D+00
     .,0.99000700D+03,0.167D+03,0.680D+02,0.29242000D+01,0.00000000D+00
     .,0.97065280D+03,0.167D+03,0.690D+02,0.29242000D+01,0.00000000D+00
     .,0.95930580D+03,0.167D+03,0.700D+02,0.29242000D+01,0.00000000D+00
     .,0.80819030D+03,0.167D+03,0.710D+02,0.29242000D+01,0.00000000D+00
     .,0.79471630D+03,0.167D+03,0.720D+02,0.29242000D+01,0.00000000D+00
     .,0.72517730D+03,0.167D+03,0.730D+02,0.29242000D+01,0.00000000D+00
     .,0.61226400D+03,0.167D+03,0.740D+02,0.29242000D+01,0.00000000D+00
     .,0.62284620D+03,0.167D+03,0.750D+02,0.29242000D+01,0.00000000D+00
     .,0.56442200D+03,0.167D+03,0.760D+02,0.29242000D+01,0.00000000D+00
     .,0.51685750D+03,0.167D+03,0.770D+02,0.29242000D+01,0.00000000D+00
     .,0.42931700D+03,0.167D+03,0.780D+02,0.29242000D+01,0.00000000D+00
     .,0.40110390D+03,0.167D+03,0.790D+02,0.29242000D+01,0.00000000D+00
     .,0.41259070D+03,0.167D+03,0.800D+02,0.29242000D+01,0.00000000D+00
     .,0.60165160D+03,0.167D+03,0.810D+02,0.29242000D+01,0.00000000D+00
     .,0.58816150D+03,0.167D+03,0.820D+02,0.29242000D+01,0.00000000D+00
     .,0.54028410D+03,0.167D+03,0.830D+02,0.29242000D+01,0.00000000D+00
     .,0.51517620D+03,0.167D+03,0.840D+02,0.29242000D+01,0.00000000D+00
     .,0.47532260D+03,0.167D+03,0.850D+02,0.29242000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60101:  60200)=(/
     . 0.43554890D+03,0.167D+03,0.860D+02,0.29242000D+01,0.00000000D+00
     .,0.14541544D+04,0.167D+03,0.870D+02,0.29242000D+01,0.00000000D+00
     .,0.13992062D+04,0.167D+03,0.880D+02,0.29242000D+01,0.00000000D+00
     .,0.12368406D+04,0.167D+03,0.890D+02,0.29242000D+01,0.00000000D+00
     .,0.11113608D+04,0.167D+03,0.900D+02,0.29242000D+01,0.00000000D+00
     .,0.11034821D+04,0.167D+03,0.910D+02,0.29242000D+01,0.00000000D+00
     .,0.10684783D+04,0.167D+03,0.920D+02,0.29242000D+01,0.00000000D+00
     .,0.11002364D+04,0.167D+03,0.930D+02,0.29242000D+01,0.00000000D+00
     .,0.10654625D+04,0.167D+03,0.940D+02,0.29242000D+01,0.00000000D+00
     .,0.59658600D+02,0.167D+03,0.101D+03,0.29242000D+01,0.00000000D+00
     .,0.19347380D+03,0.167D+03,0.103D+03,0.29242000D+01,0.98650000D+00
     .,0.24674640D+03,0.167D+03,0.104D+03,0.29242000D+01,0.98080000D+00
     .,0.18847650D+03,0.167D+03,0.105D+03,0.29242000D+01,0.97060000D+00
     .,0.14197970D+03,0.167D+03,0.106D+03,0.29242000D+01,0.98680000D+00
     .,0.98721200D+02,0.167D+03,0.107D+03,0.29242000D+01,0.99440000D+00
     .,0.71910400D+02,0.167D+03,0.108D+03,0.29242000D+01,0.99250000D+00
     .,0.49479300D+02,0.167D+03,0.109D+03,0.29242000D+01,0.99820000D+00
     .,0.28286510D+03,0.167D+03,0.111D+03,0.29242000D+01,0.96840000D+00
     .,0.43742550D+03,0.167D+03,0.112D+03,0.29242000D+01,0.96280000D+00
     .,0.44300780D+03,0.167D+03,0.113D+03,0.29242000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  60201:  60300)=(/
     . 0.35589820D+03,0.167D+03,0.114D+03,0.29242000D+01,0.95070000D+00
     .,0.29139070D+03,0.167D+03,0.115D+03,0.29242000D+01,0.99470000D+00
     .,0.24635930D+03,0.167D+03,0.116D+03,0.29242000D+01,0.99480000D+00
     .,0.20134780D+03,0.167D+03,0.117D+03,0.29242000D+01,0.99720000D+00
     .,0.38995180D+03,0.167D+03,0.119D+03,0.29242000D+01,0.97670000D+00
     .,0.74517810D+03,0.167D+03,0.120D+03,0.29242000D+01,0.98310000D+00
     .,0.39002770D+03,0.167D+03,0.121D+03,0.29242000D+01,0.18627000D+01
     .,0.37650890D+03,0.167D+03,0.122D+03,0.29242000D+01,0.18299000D+01
     .,0.36899410D+03,0.167D+03,0.123D+03,0.29242000D+01,0.19138000D+01
     .,0.36559720D+03,0.167D+03,0.124D+03,0.29242000D+01,0.18269000D+01
     .,0.33635820D+03,0.167D+03,0.125D+03,0.29242000D+01,0.16406000D+01
     .,0.31127980D+03,0.167D+03,0.126D+03,0.29242000D+01,0.16483000D+01
     .,0.29694730D+03,0.167D+03,0.127D+03,0.29242000D+01,0.17149000D+01
     .,0.29031390D+03,0.167D+03,0.128D+03,0.29242000D+01,0.17937000D+01
     .,0.28689270D+03,0.167D+03,0.129D+03,0.29242000D+01,0.95760000D+00
     .,0.26909650D+03,0.167D+03,0.130D+03,0.29242000D+01,0.19419000D+01
     .,0.43973990D+03,0.167D+03,0.131D+03,0.29242000D+01,0.96010000D+00
     .,0.38616340D+03,0.167D+03,0.132D+03,0.29242000D+01,0.94340000D+00
     .,0.34600850D+03,0.167D+03,0.133D+03,0.29242000D+01,0.98890000D+00
     .,0.31589290D+03,0.167D+03,0.134D+03,0.29242000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters(  60301:  60400)=(/
     . 0.27820320D+03,0.167D+03,0.135D+03,0.29242000D+01,0.99740000D+00
     .,0.46526060D+03,0.167D+03,0.137D+03,0.29242000D+01,0.97380000D+00
     .,0.90671060D+03,0.167D+03,0.138D+03,0.29242000D+01,0.98010000D+00
     .,0.69306070D+03,0.167D+03,0.139D+03,0.29242000D+01,0.19153000D+01
     .,0.51580860D+03,0.167D+03,0.140D+03,0.29242000D+01,0.19355000D+01
     .,0.52093800D+03,0.167D+03,0.141D+03,0.29242000D+01,0.19545000D+01
     .,0.48572140D+03,0.167D+03,0.142D+03,0.29242000D+01,0.19420000D+01
     .,0.54479060D+03,0.167D+03,0.143D+03,0.29242000D+01,0.16682000D+01
     .,0.42334180D+03,0.167D+03,0.144D+03,0.29242000D+01,0.18584000D+01
     .,0.39604750D+03,0.167D+03,0.145D+03,0.29242000D+01,0.19003000D+01
     .,0.36776460D+03,0.167D+03,0.146D+03,0.29242000D+01,0.18630000D+01
     .,0.35578930D+03,0.167D+03,0.147D+03,0.29242000D+01,0.96790000D+00
     .,0.35190760D+03,0.167D+03,0.148D+03,0.29242000D+01,0.19539000D+01
     .,0.55857850D+03,0.167D+03,0.149D+03,0.29242000D+01,0.96330000D+00
     .,0.50519270D+03,0.167D+03,0.150D+03,0.29242000D+01,0.95140000D+00
     .,0.47300760D+03,0.167D+03,0.151D+03,0.29242000D+01,0.97490000D+00
     .,0.44736060D+03,0.167D+03,0.152D+03,0.29242000D+01,0.98110000D+00
     .,0.40847930D+03,0.167D+03,0.153D+03,0.29242000D+01,0.99680000D+00
     .,0.55005480D+03,0.167D+03,0.155D+03,0.29242000D+01,0.99090000D+00
     .,0.11754332D+04,0.167D+03,0.156D+03,0.29242000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters(  60401:  60500)=(/
     . 0.87714780D+03,0.167D+03,0.157D+03,0.29242000D+01,0.19373000D+01
     .,0.55304140D+03,0.167D+03,0.159D+03,0.29242000D+01,0.29425000D+01
     .,0.54160480D+03,0.167D+03,0.160D+03,0.29242000D+01,0.29455000D+01
     .,0.52443100D+03,0.167D+03,0.161D+03,0.29242000D+01,0.29413000D+01
     .,0.52702430D+03,0.167D+03,0.162D+03,0.29242000D+01,0.29300000D+01
     .,0.50812970D+03,0.167D+03,0.163D+03,0.29242000D+01,0.18286000D+01
     .,0.53036160D+03,0.167D+03,0.164D+03,0.29242000D+01,0.28732000D+01
     .,0.49813190D+03,0.167D+03,0.165D+03,0.29242000D+01,0.29086000D+01
     .,0.50688950D+03,0.167D+03,0.166D+03,0.29242000D+01,0.28965000D+01
     .,0.47279500D+03,0.167D+03,0.167D+03,0.29242000D+01,0.29242000D+01
     .,0.36008400D+02,0.168D+03,0.100D+01,0.29282000D+01,0.91180000D+00
     .,0.23828900D+02,0.168D+03,0.200D+01,0.29282000D+01,0.00000000D+00
     .,0.55724540D+03,0.168D+03,0.300D+01,0.29282000D+01,0.00000000D+00
     .,0.32288400D+03,0.168D+03,0.400D+01,0.29282000D+01,0.00000000D+00
     .,0.21762790D+03,0.168D+03,0.500D+01,0.29282000D+01,0.00000000D+00
     .,0.14712440D+03,0.168D+03,0.600D+01,0.29282000D+01,0.00000000D+00
     .,0.10295880D+03,0.168D+03,0.700D+01,0.29282000D+01,0.00000000D+00
     .,0.78007900D+02,0.168D+03,0.800D+01,0.29282000D+01,0.00000000D+00
     .,0.59142300D+02,0.168D+03,0.900D+01,0.29282000D+01,0.00000000D+00
     .,0.45527900D+02,0.168D+03,0.100D+02,0.29282000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60501:  60600)=(/
     . 0.66655340D+03,0.168D+03,0.110D+02,0.29282000D+01,0.00000000D+00
     .,0.51428720D+03,0.168D+03,0.120D+02,0.29282000D+01,0.00000000D+00
     .,0.47430950D+03,0.168D+03,0.130D+02,0.29282000D+01,0.00000000D+00
     .,0.37395400D+03,0.168D+03,0.140D+02,0.29282000D+01,0.00000000D+00
     .,0.29171000D+03,0.168D+03,0.150D+02,0.29282000D+01,0.00000000D+00
     .,0.24215880D+03,0.168D+03,0.160D+02,0.29282000D+01,0.00000000D+00
     .,0.19786420D+03,0.168D+03,0.170D+02,0.29282000D+01,0.00000000D+00
     .,0.16193000D+03,0.168D+03,0.180D+02,0.29282000D+01,0.00000000D+00
     .,0.10915091D+04,0.168D+03,0.190D+02,0.29282000D+01,0.00000000D+00
     .,0.90284450D+03,0.168D+03,0.200D+02,0.29282000D+01,0.00000000D+00
     .,0.74618100D+03,0.168D+03,0.210D+02,0.29282000D+01,0.00000000D+00
     .,0.72076670D+03,0.168D+03,0.220D+02,0.29282000D+01,0.00000000D+00
     .,0.66014630D+03,0.168D+03,0.230D+02,0.29282000D+01,0.00000000D+00
     .,0.52004920D+03,0.168D+03,0.240D+02,0.29282000D+01,0.00000000D+00
     .,0.56851110D+03,0.168D+03,0.250D+02,0.29282000D+01,0.00000000D+00
     .,0.44624320D+03,0.168D+03,0.260D+02,0.29282000D+01,0.00000000D+00
     .,0.47314860D+03,0.168D+03,0.270D+02,0.29282000D+01,0.00000000D+00
     .,0.48733120D+03,0.168D+03,0.280D+02,0.29282000D+01,0.00000000D+00
     .,0.37365280D+03,0.168D+03,0.290D+02,0.29282000D+01,0.00000000D+00
     .,0.38376960D+03,0.168D+03,0.300D+02,0.29282000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60601:  60700)=(/
     . 0.45441890D+03,0.168D+03,0.310D+02,0.29282000D+01,0.00000000D+00
     .,0.40089710D+03,0.168D+03,0.320D+02,0.29282000D+01,0.00000000D+00
     .,0.34201700D+03,0.168D+03,0.330D+02,0.29282000D+01,0.00000000D+00
     .,0.30693000D+03,0.168D+03,0.340D+02,0.29282000D+01,0.00000000D+00
     .,0.26863470D+03,0.168D+03,0.350D+02,0.29282000D+01,0.00000000D+00
     .,0.23365510D+03,0.168D+03,0.360D+02,0.29282000D+01,0.00000000D+00
     .,0.12234668D+04,0.168D+03,0.370D+02,0.29282000D+01,0.00000000D+00
     .,0.10755659D+04,0.168D+03,0.380D+02,0.29282000D+01,0.00000000D+00
     .,0.94268540D+03,0.168D+03,0.390D+02,0.29282000D+01,0.00000000D+00
     .,0.84748690D+03,0.168D+03,0.400D+02,0.29282000D+01,0.00000000D+00
     .,0.77291870D+03,0.168D+03,0.410D+02,0.29282000D+01,0.00000000D+00
     .,0.59687070D+03,0.168D+03,0.420D+02,0.29282000D+01,0.00000000D+00
     .,0.66589970D+03,0.168D+03,0.430D+02,0.29282000D+01,0.00000000D+00
     .,0.50745680D+03,0.168D+03,0.440D+02,0.29282000D+01,0.00000000D+00
     .,0.55468820D+03,0.168D+03,0.450D+02,0.29282000D+01,0.00000000D+00
     .,0.51443460D+03,0.168D+03,0.460D+02,0.29282000D+01,0.00000000D+00
     .,0.42894240D+03,0.168D+03,0.470D+02,0.29282000D+01,0.00000000D+00
     .,0.45336080D+03,0.168D+03,0.480D+02,0.29282000D+01,0.00000000D+00
     .,0.56875080D+03,0.168D+03,0.490D+02,0.29282000D+01,0.00000000D+00
     .,0.52608060D+03,0.168D+03,0.500D+02,0.29282000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60701:  60800)=(/
     . 0.46889680D+03,0.168D+03,0.510D+02,0.29282000D+01,0.00000000D+00
     .,0.43506030D+03,0.168D+03,0.520D+02,0.29282000D+01,0.00000000D+00
     .,0.39338290D+03,0.168D+03,0.530D+02,0.29282000D+01,0.00000000D+00
     .,0.35368410D+03,0.168D+03,0.540D+02,0.29282000D+01,0.00000000D+00
     .,0.14903329D+04,0.168D+03,0.550D+02,0.29282000D+01,0.00000000D+00
     .,0.13708120D+04,0.168D+03,0.560D+02,0.29282000D+01,0.00000000D+00
     .,0.12050073D+04,0.168D+03,0.570D+02,0.29282000D+01,0.00000000D+00
     .,0.55393560D+03,0.168D+03,0.580D+02,0.29282000D+01,0.27991000D+01
     .,0.12148410D+04,0.168D+03,0.590D+02,0.29282000D+01,0.00000000D+00
     .,0.11666903D+04,0.168D+03,0.600D+02,0.29282000D+01,0.00000000D+00
     .,0.11374645D+04,0.168D+03,0.610D+02,0.29282000D+01,0.00000000D+00
     .,0.11105819D+04,0.168D+03,0.620D+02,0.29282000D+01,0.00000000D+00
     .,0.10867437D+04,0.168D+03,0.630D+02,0.29282000D+01,0.00000000D+00
     .,0.85501380D+03,0.168D+03,0.640D+02,0.29282000D+01,0.00000000D+00
     .,0.96171480D+03,0.168D+03,0.650D+02,0.29282000D+01,0.00000000D+00
     .,0.92760080D+03,0.168D+03,0.660D+02,0.29282000D+01,0.00000000D+00
     .,0.98034030D+03,0.168D+03,0.670D+02,0.29282000D+01,0.00000000D+00
     .,0.95955360D+03,0.168D+03,0.680D+02,0.29282000D+01,0.00000000D+00
     .,0.94081400D+03,0.168D+03,0.690D+02,0.29282000D+01,0.00000000D+00
     .,0.92979290D+03,0.168D+03,0.700D+02,0.29282000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60801:  60900)=(/
     . 0.78364610D+03,0.168D+03,0.710D+02,0.29282000D+01,0.00000000D+00
     .,0.77098740D+03,0.168D+03,0.720D+02,0.29282000D+01,0.00000000D+00
     .,0.70375210D+03,0.168D+03,0.730D+02,0.29282000D+01,0.00000000D+00
     .,0.59432800D+03,0.168D+03,0.740D+02,0.29282000D+01,0.00000000D+00
     .,0.60467390D+03,0.168D+03,0.750D+02,0.29282000D+01,0.00000000D+00
     .,0.54810470D+03,0.168D+03,0.760D+02,0.29282000D+01,0.00000000D+00
     .,0.50202620D+03,0.168D+03,0.770D+02,0.29282000D+01,0.00000000D+00
     .,0.41709650D+03,0.168D+03,0.780D+02,0.29282000D+01,0.00000000D+00
     .,0.38972370D+03,0.168D+03,0.790D+02,0.29282000D+01,0.00000000D+00
     .,0.40092380D+03,0.168D+03,0.800D+02,0.29282000D+01,0.00000000D+00
     .,0.58398610D+03,0.168D+03,0.810D+02,0.29282000D+01,0.00000000D+00
     .,0.57111950D+03,0.168D+03,0.820D+02,0.29282000D+01,0.00000000D+00
     .,0.52486410D+03,0.168D+03,0.830D+02,0.29282000D+01,0.00000000D+00
     .,0.50060050D+03,0.168D+03,0.840D+02,0.29282000D+01,0.00000000D+00
     .,0.46201380D+03,0.168D+03,0.850D+02,0.29282000D+01,0.00000000D+00
     .,0.42346810D+03,0.168D+03,0.860D+02,0.29282000D+01,0.00000000D+00
     .,0.14079944D+04,0.168D+03,0.870D+02,0.29282000D+01,0.00000000D+00
     .,0.13558908D+04,0.168D+03,0.880D+02,0.29282000D+01,0.00000000D+00
     .,0.11991383D+04,0.168D+03,0.890D+02,0.29282000D+01,0.00000000D+00
     .,0.10780836D+04,0.168D+03,0.900D+02,0.29282000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  60901:  61000)=(/
     . 0.10701540D+04,0.168D+03,0.910D+02,0.29282000D+01,0.00000000D+00
     .,0.10362222D+04,0.168D+03,0.920D+02,0.29282000D+01,0.00000000D+00
     .,0.10666560D+04,0.168D+03,0.930D+02,0.29282000D+01,0.00000000D+00
     .,0.10330090D+04,0.168D+03,0.940D+02,0.29282000D+01,0.00000000D+00
     .,0.57976000D+02,0.168D+03,0.101D+03,0.29282000D+01,0.00000000D+00
     .,0.18770500D+03,0.168D+03,0.103D+03,0.29282000D+01,0.98650000D+00
     .,0.23944310D+03,0.168D+03,0.104D+03,0.29282000D+01,0.98080000D+00
     .,0.18308850D+03,0.168D+03,0.105D+03,0.29282000D+01,0.97060000D+00
     .,0.13800410D+03,0.168D+03,0.106D+03,0.29282000D+01,0.98680000D+00
     .,0.96019300D+02,0.168D+03,0.107D+03,0.29282000D+01,0.99440000D+00
     .,0.69979100D+02,0.168D+03,0.108D+03,0.29282000D+01,0.99250000D+00
     .,0.48180500D+02,0.168D+03,0.109D+03,0.29282000D+01,0.99820000D+00
     .,0.27437320D+03,0.168D+03,0.111D+03,0.29282000D+01,0.96840000D+00
     .,0.42424930D+03,0.168D+03,0.112D+03,0.29282000D+01,0.96280000D+00
     .,0.42989820D+03,0.168D+03,0.113D+03,0.29282000D+01,0.96480000D+00
     .,0.34564250D+03,0.168D+03,0.114D+03,0.29282000D+01,0.95070000D+00
     .,0.28315870D+03,0.168D+03,0.115D+03,0.29282000D+01,0.99470000D+00
     .,0.23949360D+03,0.168D+03,0.116D+03,0.29282000D+01,0.99480000D+00
     .,0.19581550D+03,0.168D+03,0.117D+03,0.29282000D+01,0.99720000D+00
     .,0.37842050D+03,0.168D+03,0.119D+03,0.29282000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters(  61001:  61100)=(/
     . 0.72211110D+03,0.168D+03,0.120D+03,0.29282000D+01,0.98310000D+00
     .,0.37874080D+03,0.168D+03,0.121D+03,0.29282000D+01,0.18627000D+01
     .,0.36562310D+03,0.168D+03,0.122D+03,0.29282000D+01,0.18299000D+01
     .,0.35832130D+03,0.168D+03,0.123D+03,0.29282000D+01,0.19138000D+01
     .,0.35499450D+03,0.168D+03,0.124D+03,0.29282000D+01,0.18269000D+01
     .,0.32672790D+03,0.168D+03,0.125D+03,0.29282000D+01,0.16406000D+01
     .,0.30240170D+03,0.168D+03,0.126D+03,0.29282000D+01,0.16483000D+01
     .,0.28847830D+03,0.168D+03,0.127D+03,0.29282000D+01,0.17149000D+01
     .,0.28202540D+03,0.168D+03,0.128D+03,0.29282000D+01,0.17937000D+01
     .,0.27862110D+03,0.168D+03,0.129D+03,0.29282000D+01,0.95760000D+00
     .,0.26147450D+03,0.168D+03,0.130D+03,0.29282000D+01,0.19419000D+01
     .,0.42684110D+03,0.168D+03,0.131D+03,0.29282000D+01,0.96010000D+00
     .,0.37506910D+03,0.168D+03,0.132D+03,0.29282000D+01,0.94340000D+00
     .,0.33621830D+03,0.168D+03,0.133D+03,0.29282000D+01,0.98890000D+00
     .,0.30704780D+03,0.168D+03,0.134D+03,0.29282000D+01,0.99010000D+00
     .,0.27050300D+03,0.168D+03,0.135D+03,0.29282000D+01,0.99740000D+00
     .,0.45156840D+03,0.168D+03,0.137D+03,0.29282000D+01,0.97380000D+00
     .,0.87858370D+03,0.168D+03,0.138D+03,0.29282000D+01,0.98010000D+00
     .,0.67226710D+03,0.168D+03,0.139D+03,0.29282000D+01,0.19153000D+01
     .,0.50085680D+03,0.168D+03,0.140D+03,0.29282000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters(  61101:  61200)=(/
     . 0.50582970D+03,0.168D+03,0.141D+03,0.29282000D+01,0.19545000D+01
     .,0.47170110D+03,0.168D+03,0.142D+03,0.29282000D+01,0.19420000D+01
     .,0.52880060D+03,0.168D+03,0.143D+03,0.29282000D+01,0.16682000D+01
     .,0.41127310D+03,0.168D+03,0.144D+03,0.29282000D+01,0.18584000D+01
     .,0.38477140D+03,0.168D+03,0.145D+03,0.29282000D+01,0.19003000D+01
     .,0.35731920D+03,0.168D+03,0.146D+03,0.29282000D+01,0.18630000D+01
     .,0.34566580D+03,0.168D+03,0.147D+03,0.29282000D+01,0.96790000D+00
     .,0.34198940D+03,0.168D+03,0.148D+03,0.29282000D+01,0.19539000D+01
     .,0.54219990D+03,0.168D+03,0.149D+03,0.29282000D+01,0.96330000D+00
     .,0.49064160D+03,0.168D+03,0.150D+03,0.29282000D+01,0.95140000D+00
     .,0.45955210D+03,0.168D+03,0.151D+03,0.29282000D+01,0.97490000D+00
     .,0.43474240D+03,0.168D+03,0.152D+03,0.29282000D+01,0.98110000D+00
     .,0.39707280D+03,0.168D+03,0.153D+03,0.29282000D+01,0.99680000D+00
     .,0.53408180D+03,0.168D+03,0.155D+03,0.29282000D+01,0.99090000D+00
     .,0.11387329D+04,0.168D+03,0.156D+03,0.29282000D+01,0.97970000D+00
     .,0.85075470D+03,0.168D+03,0.157D+03,0.29282000D+01,0.19373000D+01
     .,0.53723990D+03,0.168D+03,0.159D+03,0.29282000D+01,0.29425000D+01
     .,0.52613310D+03,0.168D+03,0.160D+03,0.29282000D+01,0.29455000D+01
     .,0.50946310D+03,0.168D+03,0.161D+03,0.29282000D+01,0.29413000D+01
     .,0.51194390D+03,0.168D+03,0.162D+03,0.29282000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters(  61201:  61300)=(/
     . 0.49346840D+03,0.168D+03,0.163D+03,0.29282000D+01,0.18286000D+01
     .,0.51517330D+03,0.168D+03,0.164D+03,0.29282000D+01,0.28732000D+01
     .,0.48389820D+03,0.168D+03,0.165D+03,0.29282000D+01,0.29086000D+01
     .,0.49233800D+03,0.168D+03,0.166D+03,0.29282000D+01,0.28965000D+01
     .,0.45931550D+03,0.168D+03,0.167D+03,0.29282000D+01,0.29242000D+01
     .,0.44623140D+03,0.168D+03,0.168D+03,0.29282000D+01,0.29282000D+01
     .,0.35748000D+02,0.169D+03,0.100D+01,0.29246000D+01,0.91180000D+00
     .,0.23629700D+02,0.169D+03,0.200D+01,0.29246000D+01,0.00000000D+00
     .,0.55525980D+03,0.169D+03,0.300D+01,0.29246000D+01,0.00000000D+00
     .,0.32123930D+03,0.169D+03,0.400D+01,0.29246000D+01,0.00000000D+00
     .,0.21630990D+03,0.169D+03,0.500D+01,0.29246000D+01,0.00000000D+00
     .,0.14611730D+03,0.169D+03,0.600D+01,0.29246000D+01,0.00000000D+00
     .,0.10218880D+03,0.169D+03,0.700D+01,0.29246000D+01,0.00000000D+00
     .,0.77387400D+02,0.169D+03,0.800D+01,0.29246000D+01,0.00000000D+00
     .,0.58646500D+02,0.169D+03,0.900D+01,0.29246000D+01,0.00000000D+00
     .,0.45129800D+02,0.169D+03,0.100D+02,0.29246000D+01,0.00000000D+00
     .,0.66409940D+03,0.169D+03,0.110D+02,0.29246000D+01,0.00000000D+00
     .,0.51180090D+03,0.169D+03,0.120D+02,0.29246000D+01,0.00000000D+00
     .,0.47179450D+03,0.169D+03,0.130D+02,0.29246000D+01,0.00000000D+00
     .,0.37172710D+03,0.169D+03,0.140D+02,0.29246000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  61301:  61400)=(/
     . 0.28980090D+03,0.169D+03,0.150D+02,0.29246000D+01,0.00000000D+00
     .,0.24047400D+03,0.169D+03,0.160D+02,0.29246000D+01,0.00000000D+00
     .,0.19640620D+03,0.169D+03,0.170D+02,0.29246000D+01,0.00000000D+00
     .,0.16067610D+03,0.169D+03,0.180D+02,0.29246000D+01,0.00000000D+00
     .,0.10876970D+04,0.169D+03,0.190D+02,0.29246000D+01,0.00000000D+00
     .,0.89886340D+03,0.169D+03,0.200D+02,0.29246000D+01,0.00000000D+00
     .,0.74273900D+03,0.169D+03,0.210D+02,0.29246000D+01,0.00000000D+00
     .,0.71728970D+03,0.169D+03,0.220D+02,0.29246000D+01,0.00000000D+00
     .,0.65688060D+03,0.169D+03,0.230D+02,0.29246000D+01,0.00000000D+00
     .,0.51743220D+03,0.169D+03,0.240D+02,0.29246000D+01,0.00000000D+00
     .,0.56559590D+03,0.169D+03,0.250D+02,0.29246000D+01,0.00000000D+00
     .,0.44390510D+03,0.169D+03,0.260D+02,0.29246000D+01,0.00000000D+00
     .,0.47058200D+03,0.169D+03,0.270D+02,0.29246000D+01,0.00000000D+00
     .,0.48475110D+03,0.169D+03,0.280D+02,0.29246000D+01,0.00000000D+00
     .,0.37163760D+03,0.169D+03,0.290D+02,0.29246000D+01,0.00000000D+00
     .,0.38158090D+03,0.169D+03,0.300D+02,0.29246000D+01,0.00000000D+00
     .,0.45190020D+03,0.169D+03,0.310D+02,0.29246000D+01,0.00000000D+00
     .,0.39847870D+03,0.169D+03,0.320D+02,0.29246000D+01,0.00000000D+00
     .,0.33979060D+03,0.169D+03,0.330D+02,0.29246000D+01,0.00000000D+00
     .,0.30483420D+03,0.169D+03,0.340D+02,0.29246000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  61401:  61500)=(/
     . 0.26670930D+03,0.169D+03,0.350D+02,0.29246000D+01,0.00000000D+00
     .,0.23190470D+03,0.169D+03,0.360D+02,0.29246000D+01,0.00000000D+00
     .,0.12190706D+04,0.169D+03,0.370D+02,0.29246000D+01,0.00000000D+00
     .,0.10708351D+04,0.169D+03,0.380D+02,0.29246000D+01,0.00000000D+00
     .,0.93818730D+03,0.169D+03,0.390D+02,0.29246000D+01,0.00000000D+00
     .,0.84323610D+03,0.169D+03,0.400D+02,0.29246000D+01,0.00000000D+00
     .,0.76891010D+03,0.169D+03,0.410D+02,0.29246000D+01,0.00000000D+00
     .,0.59357780D+03,0.169D+03,0.420D+02,0.29246000D+01,0.00000000D+00
     .,0.66231090D+03,0.169D+03,0.430D+02,0.29246000D+01,0.00000000D+00
     .,0.50453730D+03,0.169D+03,0.440D+02,0.29246000D+01,0.00000000D+00
     .,0.55152390D+03,0.169D+03,0.450D+02,0.29246000D+01,0.00000000D+00
     .,0.51144340D+03,0.169D+03,0.460D+02,0.29246000D+01,0.00000000D+00
     .,0.42643750D+03,0.169D+03,0.470D+02,0.29246000D+01,0.00000000D+00
     .,0.45065890D+03,0.169D+03,0.480D+02,0.29246000D+01,0.00000000D+00
     .,0.56556470D+03,0.169D+03,0.490D+02,0.29246000D+01,0.00000000D+00
     .,0.52293560D+03,0.169D+03,0.500D+02,0.29246000D+01,0.00000000D+00
     .,0.46590590D+03,0.169D+03,0.510D+02,0.29246000D+01,0.00000000D+00
     .,0.43217320D+03,0.169D+03,0.520D+02,0.29246000D+01,0.00000000D+00
     .,0.39065890D+03,0.169D+03,0.530D+02,0.29246000D+01,0.00000000D+00
     .,0.35113440D+03,0.169D+03,0.540D+02,0.29246000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  61501:  61600)=(/
     . 0.14849661D+04,0.169D+03,0.550D+02,0.29246000D+01,0.00000000D+00
     .,0.13649240D+04,0.169D+03,0.560D+02,0.29246000D+01,0.00000000D+00
     .,0.11993874D+04,0.169D+03,0.570D+02,0.29246000D+01,0.00000000D+00
     .,0.55042640D+03,0.169D+03,0.580D+02,0.29246000D+01,0.27991000D+01
     .,0.12094663D+04,0.169D+03,0.590D+02,0.29246000D+01,0.00000000D+00
     .,0.11614494D+04,0.169D+03,0.600D+02,0.29246000D+01,0.00000000D+00
     .,0.11323365D+04,0.169D+03,0.610D+02,0.29246000D+01,0.00000000D+00
     .,0.11055604D+04,0.169D+03,0.620D+02,0.29246000D+01,0.00000000D+00
     .,0.10818160D+04,0.169D+03,0.630D+02,0.29246000D+01,0.00000000D+00
     .,0.85075460D+03,0.169D+03,0.640D+02,0.29246000D+01,0.00000000D+00
     .,0.95749480D+03,0.169D+03,0.650D+02,0.29246000D+01,0.00000000D+00
     .,0.92347850D+03,0.169D+03,0.660D+02,0.29246000D+01,0.00000000D+00
     .,0.97580850D+03,0.169D+03,0.670D+02,0.29246000D+01,0.00000000D+00
     .,0.95511040D+03,0.169D+03,0.680D+02,0.29246000D+01,0.00000000D+00
     .,0.93644570D+03,0.169D+03,0.690D+02,0.29246000D+01,0.00000000D+00
     .,0.92549440D+03,0.169D+03,0.700D+02,0.29246000D+01,0.00000000D+00
     .,0.77979590D+03,0.169D+03,0.710D+02,0.29246000D+01,0.00000000D+00
     .,0.76690850D+03,0.169D+03,0.720D+02,0.29246000D+01,0.00000000D+00
     .,0.69985110D+03,0.169D+03,0.730D+02,0.29246000D+01,0.00000000D+00
     .,0.59088900D+03,0.169D+03,0.740D+02,0.29246000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  61601:  61700)=(/
     . 0.60112600D+03,0.169D+03,0.750D+02,0.29246000D+01,0.00000000D+00
     .,0.54476460D+03,0.169D+03,0.760D+02,0.29246000D+01,0.00000000D+00
     .,0.49887240D+03,0.169D+03,0.770D+02,0.29246000D+01,0.00000000D+00
     .,0.41437420D+03,0.169D+03,0.780D+02,0.29246000D+01,0.00000000D+00
     .,0.38714220D+03,0.169D+03,0.790D+02,0.29246000D+01,0.00000000D+00
     .,0.39824650D+03,0.169D+03,0.800D+02,0.29246000D+01,0.00000000D+00
     .,0.58061670D+03,0.169D+03,0.810D+02,0.29246000D+01,0.00000000D+00
     .,0.56766880D+03,0.169D+03,0.820D+02,0.29246000D+01,0.00000000D+00
     .,0.52151170D+03,0.169D+03,0.830D+02,0.29246000D+01,0.00000000D+00
     .,0.49729730D+03,0.169D+03,0.840D+02,0.29246000D+01,0.00000000D+00
     .,0.45884250D+03,0.169D+03,0.850D+02,0.29246000D+01,0.00000000D+00
     .,0.42045390D+03,0.169D+03,0.860D+02,0.29246000D+01,0.00000000D+00
     .,0.14024613D+04,0.169D+03,0.870D+02,0.29246000D+01,0.00000000D+00
     .,0.13497931D+04,0.169D+03,0.880D+02,0.29246000D+01,0.00000000D+00
     .,0.11933412D+04,0.169D+03,0.890D+02,0.29246000D+01,0.00000000D+00
     .,0.10724182D+04,0.169D+03,0.900D+02,0.29246000D+01,0.00000000D+00
     .,0.10647199D+04,0.169D+03,0.910D+02,0.29246000D+01,0.00000000D+00
     .,0.10309456D+04,0.169D+03,0.920D+02,0.29246000D+01,0.00000000D+00
     .,0.10614860D+04,0.169D+03,0.930D+02,0.29246000D+01,0.00000000D+00
     .,0.10279565D+04,0.169D+03,0.940D+02,0.29246000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  61701:  61800)=(/
     . 0.57593700D+02,0.169D+03,0.101D+03,0.29246000D+01,0.00000000D+00
     .,0.18672100D+03,0.169D+03,0.103D+03,0.29246000D+01,0.98650000D+00
     .,0.23814200D+03,0.169D+03,0.104D+03,0.29246000D+01,0.98080000D+00
     .,0.18193830D+03,0.169D+03,0.105D+03,0.29246000D+01,0.97060000D+00
     .,0.13705810D+03,0.169D+03,0.106D+03,0.29246000D+01,0.98680000D+00
     .,0.95297900D+02,0.169D+03,0.107D+03,0.29246000D+01,0.99440000D+00
     .,0.69413700D+02,0.169D+03,0.108D+03,0.29246000D+01,0.99250000D+00
     .,0.47755100D+02,0.169D+03,0.109D+03,0.29246000D+01,0.99820000D+00
     .,0.27296680D+03,0.169D+03,0.111D+03,0.29246000D+01,0.96840000D+00
     .,0.42211770D+03,0.169D+03,0.112D+03,0.29246000D+01,0.96280000D+00
     .,0.42756550D+03,0.169D+03,0.113D+03,0.29246000D+01,0.96480000D+00
     .,0.34354750D+03,0.169D+03,0.114D+03,0.29246000D+01,0.95070000D+00
     .,0.28129780D+03,0.169D+03,0.115D+03,0.29246000D+01,0.99470000D+00
     .,0.23782830D+03,0.169D+03,0.116D+03,0.29246000D+01,0.99480000D+00
     .,0.19437320D+03,0.169D+03,0.117D+03,0.29246000D+01,0.99720000D+00
     .,0.37630470D+03,0.169D+03,0.119D+03,0.29246000D+01,0.97670000D+00
     .,0.71887190D+03,0.169D+03,0.120D+03,0.29246000D+01,0.98310000D+00
     .,0.37645520D+03,0.169D+03,0.121D+03,0.29246000D+01,0.18627000D+01
     .,0.36340760D+03,0.169D+03,0.122D+03,0.29246000D+01,0.18299000D+01
     .,0.35615030D+03,0.169D+03,0.123D+03,0.29246000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  61801:  61900)=(/
     . 0.35286320D+03,0.169D+03,0.124D+03,0.29246000D+01,0.18269000D+01
     .,0.32467610D+03,0.169D+03,0.125D+03,0.29246000D+01,0.16406000D+01
     .,0.30047150D+03,0.169D+03,0.126D+03,0.29246000D+01,0.16483000D+01
     .,0.28663320D+03,0.169D+03,0.127D+03,0.29246000D+01,0.17149000D+01
     .,0.28022740D+03,0.169D+03,0.128D+03,0.29246000D+01,0.17937000D+01
     .,0.27690380D+03,0.169D+03,0.129D+03,0.29246000D+01,0.95760000D+00
     .,0.25976130D+03,0.169D+03,0.130D+03,0.29246000D+01,0.19419000D+01
     .,0.42442030D+03,0.169D+03,0.131D+03,0.29246000D+01,0.96010000D+00
     .,0.37275950D+03,0.169D+03,0.132D+03,0.29246000D+01,0.94340000D+00
     .,0.33401900D+03,0.169D+03,0.133D+03,0.29246000D+01,0.98890000D+00
     .,0.30495200D+03,0.169D+03,0.134D+03,0.29246000D+01,0.99010000D+00
     .,0.26856840D+03,0.169D+03,0.135D+03,0.29246000D+01,0.99740000D+00
     .,0.44898400D+03,0.169D+03,0.137D+03,0.29246000D+01,0.97380000D+00
     .,0.87467070D+03,0.169D+03,0.138D+03,0.29246000D+01,0.98010000D+00
     .,0.66876560D+03,0.169D+03,0.139D+03,0.29246000D+01,0.19153000D+01
     .,0.49783950D+03,0.169D+03,0.140D+03,0.29246000D+01,0.19355000D+01
     .,0.50278080D+03,0.169D+03,0.141D+03,0.29246000D+01,0.19545000D+01
     .,0.46880410D+03,0.169D+03,0.142D+03,0.29246000D+01,0.19420000D+01
     .,0.52574810D+03,0.169D+03,0.143D+03,0.29246000D+01,0.16682000D+01
     .,0.40862370D+03,0.169D+03,0.144D+03,0.29246000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters(  61901:  62000)=(/
     . 0.38227390D+03,0.169D+03,0.145D+03,0.29246000D+01,0.19003000D+01
     .,0.35497280D+03,0.169D+03,0.146D+03,0.29246000D+01,0.18630000D+01
     .,0.34340860D+03,0.169D+03,0.147D+03,0.29246000D+01,0.96790000D+00
     .,0.33969190D+03,0.169D+03,0.148D+03,0.29246000D+01,0.19539000D+01
     .,0.53908680D+03,0.169D+03,0.149D+03,0.29246000D+01,0.96330000D+00
     .,0.48762850D+03,0.169D+03,0.150D+03,0.29246000D+01,0.95140000D+00
     .,0.45659480D+03,0.169D+03,0.151D+03,0.29246000D+01,0.97490000D+00
     .,0.43185070D+03,0.169D+03,0.152D+03,0.29246000D+01,0.98110000D+00
     .,0.39432570D+03,0.169D+03,0.153D+03,0.29246000D+01,0.99680000D+00
     .,0.53087060D+03,0.169D+03,0.155D+03,0.29246000D+01,0.99090000D+00
     .,0.11338329D+04,0.169D+03,0.156D+03,0.29246000D+01,0.97970000D+00
     .,0.84637940D+03,0.169D+03,0.157D+03,0.29246000D+01,0.19373000D+01
     .,0.53382250D+03,0.169D+03,0.159D+03,0.29246000D+01,0.29425000D+01
     .,0.52278360D+03,0.169D+03,0.160D+03,0.29246000D+01,0.29455000D+01
     .,0.50620810D+03,0.169D+03,0.161D+03,0.29246000D+01,0.29413000D+01
     .,0.50870480D+03,0.169D+03,0.162D+03,0.29246000D+01,0.29300000D+01
     .,0.49043340D+03,0.169D+03,0.163D+03,0.29246000D+01,0.18286000D+01
     .,0.51192810D+03,0.169D+03,0.164D+03,0.29246000D+01,0.28732000D+01
     .,0.48082180D+03,0.169D+03,0.165D+03,0.29246000D+01,0.29086000D+01
     .,0.48926080D+03,0.169D+03,0.166D+03,0.29246000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters(  62001:  62100)=(/
     . 0.45637280D+03,0.169D+03,0.167D+03,0.29246000D+01,0.29242000D+01
     .,0.44336390D+03,0.169D+03,0.168D+03,0.29246000D+01,0.29282000D+01
     .,0.44052280D+03,0.169D+03,0.169D+03,0.29246000D+01,0.29246000D+01
     .,0.37398600D+02,0.170D+03,0.100D+01,0.28482000D+01,0.91180000D+00
     .,0.24543500D+02,0.170D+03,0.200D+01,0.28482000D+01,0.00000000D+00
     .,0.59236510D+03,0.170D+03,0.300D+01,0.28482000D+01,0.00000000D+00
     .,0.34023850D+03,0.170D+03,0.400D+01,0.28482000D+01,0.00000000D+00
     .,0.22788020D+03,0.170D+03,0.500D+01,0.28482000D+01,0.00000000D+00
     .,0.15321460D+03,0.170D+03,0.600D+01,0.28482000D+01,0.00000000D+00
     .,0.10673400D+03,0.170D+03,0.700D+01,0.28482000D+01,0.00000000D+00
     .,0.80586300D+02,0.170D+03,0.800D+01,0.28482000D+01,0.00000000D+00
     .,0.60903100D+02,0.170D+03,0.900D+01,0.28482000D+01,0.00000000D+00
     .,0.46756900D+02,0.170D+03,0.100D+02,0.28482000D+01,0.00000000D+00
     .,0.70806290D+03,0.170D+03,0.110D+02,0.28482000D+01,0.00000000D+00
     .,0.54277630D+03,0.170D+03,0.120D+02,0.28482000D+01,0.00000000D+00
     .,0.49910710D+03,0.170D+03,0.130D+02,0.28482000D+01,0.00000000D+00
     .,0.39184510D+03,0.170D+03,0.140D+02,0.28482000D+01,0.00000000D+00
     .,0.30444600D+03,0.170D+03,0.150D+02,0.28482000D+01,0.00000000D+00
     .,0.25199750D+03,0.170D+03,0.160D+02,0.28482000D+01,0.00000000D+00
     .,0.20529690D+03,0.170D+03,0.170D+02,0.28482000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  62101:  62200)=(/
     . 0.16755260D+03,0.170D+03,0.180D+02,0.28482000D+01,0.00000000D+00
     .,0.11600767D+04,0.170D+03,0.190D+02,0.28482000D+01,0.00000000D+00
     .,0.95507870D+03,0.170D+03,0.200D+02,0.28482000D+01,0.00000000D+00
     .,0.78843250D+03,0.170D+03,0.210D+02,0.28482000D+01,0.00000000D+00
     .,0.76056390D+03,0.170D+03,0.220D+02,0.28482000D+01,0.00000000D+00
     .,0.69606330D+03,0.170D+03,0.230D+02,0.28482000D+01,0.00000000D+00
     .,0.54795880D+03,0.170D+03,0.240D+02,0.28482000D+01,0.00000000D+00
     .,0.59876220D+03,0.170D+03,0.250D+02,0.28482000D+01,0.00000000D+00
     .,0.46957880D+03,0.170D+03,0.260D+02,0.28482000D+01,0.00000000D+00
     .,0.49740630D+03,0.170D+03,0.270D+02,0.28482000D+01,0.00000000D+00
     .,0.51274730D+03,0.170D+03,0.280D+02,0.28482000D+01,0.00000000D+00
     .,0.39280830D+03,0.170D+03,0.290D+02,0.28482000D+01,0.00000000D+00
     .,0.40272690D+03,0.170D+03,0.300D+02,0.28482000D+01,0.00000000D+00
     .,0.47737550D+03,0.170D+03,0.310D+02,0.28482000D+01,0.00000000D+00
     .,0.41982970D+03,0.170D+03,0.320D+02,0.28482000D+01,0.00000000D+00
     .,0.35702170D+03,0.170D+03,0.330D+02,0.28482000D+01,0.00000000D+00
     .,0.31968520D+03,0.170D+03,0.340D+02,0.28482000D+01,0.00000000D+00
     .,0.27912740D+03,0.170D+03,0.350D+02,0.28482000D+01,0.00000000D+00
     .,0.24221470D+03,0.170D+03,0.360D+02,0.28482000D+01,0.00000000D+00
     .,0.12994482D+04,0.170D+03,0.370D+02,0.28482000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  62201:  62300)=(/
     . 0.11377525D+04,0.170D+03,0.380D+02,0.28482000D+01,0.00000000D+00
     .,0.99498690D+03,0.170D+03,0.390D+02,0.28482000D+01,0.00000000D+00
     .,0.89315950D+03,0.170D+03,0.400D+02,0.28482000D+01,0.00000000D+00
     .,0.81367980D+03,0.170D+03,0.410D+02,0.28482000D+01,0.00000000D+00
     .,0.62696020D+03,0.170D+03,0.420D+02,0.28482000D+01,0.00000000D+00
     .,0.70006760D+03,0.170D+03,0.430D+02,0.28482000D+01,0.00000000D+00
     .,0.53219550D+03,0.170D+03,0.440D+02,0.28482000D+01,0.00000000D+00
     .,0.58198660D+03,0.170D+03,0.450D+02,0.28482000D+01,0.00000000D+00
     .,0.53936520D+03,0.170D+03,0.460D+02,0.28482000D+01,0.00000000D+00
     .,0.44956060D+03,0.170D+03,0.470D+02,0.28482000D+01,0.00000000D+00
     .,0.47487730D+03,0.170D+03,0.480D+02,0.28482000D+01,0.00000000D+00
     .,0.59714660D+03,0.170D+03,0.490D+02,0.28482000D+01,0.00000000D+00
     .,0.55105660D+03,0.170D+03,0.500D+02,0.28482000D+01,0.00000000D+00
     .,0.48986860D+03,0.170D+03,0.510D+02,0.28482000D+01,0.00000000D+00
     .,0.45372430D+03,0.170D+03,0.520D+02,0.28482000D+01,0.00000000D+00
     .,0.40944070D+03,0.170D+03,0.530D+02,0.28482000D+01,0.00000000D+00
     .,0.36738410D+03,0.170D+03,0.540D+02,0.28482000D+01,0.00000000D+00
     .,0.15825500D+04,0.170D+03,0.550D+02,0.28482000D+01,0.00000000D+00
     .,0.14507794D+04,0.170D+03,0.560D+02,0.28482000D+01,0.00000000D+00
     .,0.12725822D+04,0.170D+03,0.570D+02,0.28482000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  62301:  62400)=(/
     . 0.57883400D+03,0.170D+03,0.580D+02,0.28482000D+01,0.27991000D+01
     .,0.12846682D+04,0.170D+03,0.590D+02,0.28482000D+01,0.00000000D+00
     .,0.12333365D+04,0.170D+03,0.600D+02,0.28482000D+01,0.00000000D+00
     .,0.12023371D+04,0.170D+03,0.610D+02,0.28482000D+01,0.00000000D+00
     .,0.11738392D+04,0.170D+03,0.620D+02,0.28482000D+01,0.00000000D+00
     .,0.11485655D+04,0.170D+03,0.630D+02,0.28482000D+01,0.00000000D+00
     .,0.90112100D+03,0.170D+03,0.640D+02,0.28482000D+01,0.00000000D+00
     .,0.10169049D+04,0.170D+03,0.650D+02,0.28482000D+01,0.00000000D+00
     .,0.98043260D+03,0.170D+03,0.660D+02,0.28482000D+01,0.00000000D+00
     .,0.10356000D+04,0.170D+03,0.670D+02,0.28482000D+01,0.00000000D+00
     .,0.10136038D+04,0.170D+03,0.680D+02,0.28482000D+01,0.00000000D+00
     .,0.99374150D+03,0.170D+03,0.690D+02,0.28482000D+01,0.00000000D+00
     .,0.98222660D+03,0.170D+03,0.700D+02,0.28482000D+01,0.00000000D+00
     .,0.82628510D+03,0.170D+03,0.710D+02,0.28482000D+01,0.00000000D+00
     .,0.81115710D+03,0.170D+03,0.720D+02,0.28482000D+01,0.00000000D+00
     .,0.73922210D+03,0.170D+03,0.730D+02,0.28482000D+01,0.00000000D+00
     .,0.62322500D+03,0.170D+03,0.740D+02,0.28482000D+01,0.00000000D+00
     .,0.63376790D+03,0.170D+03,0.750D+02,0.28482000D+01,0.00000000D+00
     .,0.57362030D+03,0.170D+03,0.760D+02,0.28482000D+01,0.00000000D+00
     .,0.52473400D+03,0.170D+03,0.770D+02,0.28482000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  62401:  62500)=(/
     . 0.43520090D+03,0.170D+03,0.780D+02,0.28482000D+01,0.00000000D+00
     .,0.40635950D+03,0.170D+03,0.790D+02,0.28482000D+01,0.00000000D+00
     .,0.41792020D+03,0.170D+03,0.800D+02,0.28482000D+01,0.00000000D+00
     .,0.61237220D+03,0.170D+03,0.810D+02,0.28482000D+01,0.00000000D+00
     .,0.59791090D+03,0.170D+03,0.820D+02,0.28482000D+01,0.00000000D+00
     .,0.54826140D+03,0.170D+03,0.830D+02,0.28482000D+01,0.00000000D+00
     .,0.52217940D+03,0.170D+03,0.840D+02,0.28482000D+01,0.00000000D+00
     .,0.48105700D+03,0.170D+03,0.850D+02,0.28482000D+01,0.00000000D+00
     .,0.44014200D+03,0.170D+03,0.860D+02,0.28482000D+01,0.00000000D+00
     .,0.14924670D+04,0.170D+03,0.870D+02,0.28482000D+01,0.00000000D+00
     .,0.14332640D+04,0.170D+03,0.880D+02,0.28482000D+01,0.00000000D+00
     .,0.12650809D+04,0.170D+03,0.890D+02,0.28482000D+01,0.00000000D+00
     .,0.11344175D+04,0.170D+03,0.900D+02,0.28482000D+01,0.00000000D+00
     .,0.11272049D+04,0.170D+03,0.910D+02,0.28482000D+01,0.00000000D+00
     .,0.10913656D+04,0.170D+03,0.920D+02,0.28482000D+01,0.00000000D+00
     .,0.11251094D+04,0.170D+03,0.930D+02,0.28482000D+01,0.00000000D+00
     .,0.10893370D+04,0.170D+03,0.940D+02,0.28482000D+01,0.00000000D+00
     .,0.60487100D+02,0.170D+03,0.101D+03,0.28482000D+01,0.00000000D+00
     .,0.19759460D+03,0.170D+03,0.103D+03,0.28482000D+01,0.98650000D+00
     .,0.25172230D+03,0.170D+03,0.104D+03,0.28482000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters(  62501:  62600)=(/
     . 0.19141090D+03,0.170D+03,0.105D+03,0.28482000D+01,0.97060000D+00
     .,0.14369300D+03,0.170D+03,0.106D+03,0.28482000D+01,0.98680000D+00
     .,0.99505900D+02,0.170D+03,0.107D+03,0.28482000D+01,0.99440000D+00
     .,0.72218200D+02,0.170D+03,0.108D+03,0.28482000D+01,0.99250000D+00
     .,0.49450200D+02,0.170D+03,0.109D+03,0.28482000D+01,0.99820000D+00
     .,0.28901230D+03,0.170D+03,0.111D+03,0.28482000D+01,0.96840000D+00
     .,0.44716520D+03,0.170D+03,0.112D+03,0.28482000D+01,0.96280000D+00
     .,0.45200550D+03,0.170D+03,0.113D+03,0.28482000D+01,0.96480000D+00
     .,0.36191400D+03,0.170D+03,0.114D+03,0.28482000D+01,0.95070000D+00
     .,0.29546110D+03,0.170D+03,0.115D+03,0.28482000D+01,0.99470000D+00
     .,0.24922870D+03,0.170D+03,0.116D+03,0.28482000D+01,0.99480000D+00
     .,0.20317400D+03,0.170D+03,0.117D+03,0.28482000D+01,0.99720000D+00
     .,0.39728560D+03,0.170D+03,0.119D+03,0.28482000D+01,0.97670000D+00
     .,0.76326450D+03,0.170D+03,0.120D+03,0.28482000D+01,0.98310000D+00
     .,0.39658450D+03,0.170D+03,0.121D+03,0.28482000D+01,0.18627000D+01
     .,0.38275050D+03,0.170D+03,0.122D+03,0.28482000D+01,0.18299000D+01
     .,0.37510830D+03,0.170D+03,0.123D+03,0.28482000D+01,0.19138000D+01
     .,0.37175280D+03,0.170D+03,0.124D+03,0.28482000D+01,0.18269000D+01
     .,0.34156320D+03,0.170D+03,0.125D+03,0.28482000D+01,0.16406000D+01
     .,0.31590920D+03,0.170D+03,0.126D+03,0.28482000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters(  62601:  62700)=(/
     . 0.30132730D+03,0.170D+03,0.127D+03,0.28482000D+01,0.17149000D+01
     .,0.29462620D+03,0.170D+03,0.128D+03,0.28482000D+01,0.17937000D+01
     .,0.29146390D+03,0.170D+03,0.129D+03,0.28482000D+01,0.95760000D+00
     .,0.27284960D+03,0.170D+03,0.130D+03,0.28482000D+01,0.19419000D+01
     .,0.44803280D+03,0.170D+03,0.131D+03,0.28482000D+01,0.96010000D+00
     .,0.39245010D+03,0.170D+03,0.132D+03,0.28482000D+01,0.94340000D+00
     .,0.35089060D+03,0.170D+03,0.133D+03,0.28482000D+01,0.98890000D+00
     .,0.31981290D+03,0.170D+03,0.134D+03,0.28482000D+01,0.99010000D+00
     .,0.28109900D+03,0.170D+03,0.135D+03,0.28482000D+01,0.99740000D+00
     .,0.47364740D+03,0.170D+03,0.137D+03,0.28482000D+01,0.97380000D+00
     .,0.92871230D+03,0.170D+03,0.138D+03,0.28482000D+01,0.98010000D+00
     .,0.70739100D+03,0.170D+03,0.139D+03,0.28482000D+01,0.19153000D+01
     .,0.52442450D+03,0.170D+03,0.140D+03,0.28482000D+01,0.19355000D+01
     .,0.52963760D+03,0.170D+03,0.141D+03,0.28482000D+01,0.19545000D+01
     .,0.49348140D+03,0.170D+03,0.142D+03,0.28482000D+01,0.19420000D+01
     .,0.55447820D+03,0.170D+03,0.143D+03,0.28482000D+01,0.16682000D+01
     .,0.42941670D+03,0.170D+03,0.144D+03,0.28482000D+01,0.18584000D+01
     .,0.40159420D+03,0.170D+03,0.145D+03,0.28482000D+01,0.19003000D+01
     .,0.37273910D+03,0.170D+03,0.146D+03,0.28482000D+01,0.18630000D+01
     .,0.36066920D+03,0.170D+03,0.147D+03,0.28482000D+01,0.96790000D+00
     ./)
      grimme_c6_parameters(  62701:  62800)=(/
     . 0.35642060D+03,0.170D+03,0.148D+03,0.28482000D+01,0.19539000D+01
     .,0.56876740D+03,0.170D+03,0.149D+03,0.28482000D+01,0.96330000D+00
     .,0.51338040D+03,0.170D+03,0.150D+03,0.28482000D+01,0.95140000D+00
     .,0.47992240D+03,0.170D+03,0.151D+03,0.28482000D+01,0.97490000D+00
     .,0.45334590D+03,0.170D+03,0.152D+03,0.28482000D+01,0.98110000D+00
     .,0.41330020D+03,0.170D+03,0.153D+03,0.28482000D+01,0.99680000D+00
     .,0.55918680D+03,0.170D+03,0.155D+03,0.28482000D+01,0.99090000D+00
     .,0.12045119D+04,0.170D+03,0.156D+03,0.28482000D+01,0.97970000D+00
     .,0.89547410D+03,0.170D+03,0.157D+03,0.28482000D+01,0.19373000D+01
     .,0.56128730D+03,0.170D+03,0.159D+03,0.28482000D+01,0.29425000D+01
     .,0.54966430D+03,0.170D+03,0.160D+03,0.28482000D+01,0.29455000D+01
     .,0.53216530D+03,0.170D+03,0.161D+03,0.28482000D+01,0.29413000D+01
     .,0.53496580D+03,0.170D+03,0.162D+03,0.28482000D+01,0.29300000D+01
     .,0.51624120D+03,0.170D+03,0.163D+03,0.28482000D+01,0.18286000D+01
     .,0.53845600D+03,0.170D+03,0.164D+03,0.28482000D+01,0.28732000D+01
     .,0.50556900D+03,0.170D+03,0.165D+03,0.28482000D+01,0.29086000D+01
     .,0.51473030D+03,0.170D+03,0.166D+03,0.28482000D+01,0.28965000D+01
     .,0.47973200D+03,0.170D+03,0.167D+03,0.28482000D+01,0.29242000D+01
     .,0.46600690D+03,0.170D+03,0.168D+03,0.28482000D+01,0.29282000D+01
     .,0.46306960D+03,0.170D+03,0.169D+03,0.28482000D+01,0.29246000D+01
     ./)
      grimme_c6_parameters(  62801:  62900)=(/
     . 0.48707530D+03,0.170D+03,0.170D+03,0.28482000D+01,0.28482000D+01
     .,0.34601200D+02,0.171D+03,0.100D+01,0.29219000D+01,0.91180000D+00
     .,0.22892600D+02,0.171D+03,0.200D+01,0.29219000D+01,0.00000000D+00
     .,0.53345810D+03,0.171D+03,0.300D+01,0.29219000D+01,0.00000000D+00
     .,0.30982450D+03,0.171D+03,0.400D+01,0.29219000D+01,0.00000000D+00
     .,0.20900590D+03,0.171D+03,0.500D+01,0.29219000D+01,0.00000000D+00
     .,0.14134580D+03,0.171D+03,0.600D+01,0.29219000D+01,0.00000000D+00
     .,0.98922300D+02,0.171D+03,0.700D+01,0.29219000D+01,0.00000000D+00
     .,0.74945100D+02,0.171D+03,0.800D+01,0.29219000D+01,0.00000000D+00
     .,0.56812400D+02,0.171D+03,0.900D+01,0.29219000D+01,0.00000000D+00
     .,0.43726300D+02,0.171D+03,0.100D+02,0.29219000D+01,0.00000000D+00
     .,0.63816340D+03,0.171D+03,0.110D+02,0.29219000D+01,0.00000000D+00
     .,0.49328830D+03,0.171D+03,0.120D+02,0.29219000D+01,0.00000000D+00
     .,0.45519600D+03,0.171D+03,0.130D+02,0.29219000D+01,0.00000000D+00
     .,0.35911410D+03,0.171D+03,0.140D+02,0.29219000D+01,0.00000000D+00
     .,0.28024060D+03,0.171D+03,0.150D+02,0.29219000D+01,0.00000000D+00
     .,0.23266870D+03,0.171D+03,0.160D+02,0.29219000D+01,0.00000000D+00
     .,0.19012190D+03,0.171D+03,0.170D+02,0.29219000D+01,0.00000000D+00
     .,0.15559160D+03,0.171D+03,0.180D+02,0.29219000D+01,0.00000000D+00
     .,0.10444701D+04,0.171D+03,0.190D+02,0.29219000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  62901:  63000)=(/
     . 0.86528290D+03,0.171D+03,0.200D+02,0.29219000D+01,0.00000000D+00
     .,0.71536520D+03,0.171D+03,0.210D+02,0.29219000D+01,0.00000000D+00
     .,0.69115730D+03,0.171D+03,0.220D+02,0.29219000D+01,0.00000000D+00
     .,0.63311630D+03,0.171D+03,0.230D+02,0.29219000D+01,0.00000000D+00
     .,0.49870530D+03,0.171D+03,0.240D+02,0.29219000D+01,0.00000000D+00
     .,0.54533910D+03,0.171D+03,0.250D+02,0.29219000D+01,0.00000000D+00
     .,0.42801770D+03,0.171D+03,0.260D+02,0.29219000D+01,0.00000000D+00
     .,0.45401590D+03,0.171D+03,0.270D+02,0.29219000D+01,0.00000000D+00
     .,0.46756420D+03,0.171D+03,0.280D+02,0.29219000D+01,0.00000000D+00
     .,0.35843930D+03,0.171D+03,0.290D+02,0.29219000D+01,0.00000000D+00
     .,0.36835200D+03,0.171D+03,0.300D+02,0.29219000D+01,0.00000000D+00
     .,0.43614550D+03,0.171D+03,0.310D+02,0.29219000D+01,0.00000000D+00
     .,0.38497400D+03,0.171D+03,0.320D+02,0.29219000D+01,0.00000000D+00
     .,0.32854540D+03,0.171D+03,0.330D+02,0.29219000D+01,0.00000000D+00
     .,0.29488120D+03,0.171D+03,0.340D+02,0.29219000D+01,0.00000000D+00
     .,0.25811290D+03,0.171D+03,0.350D+02,0.29219000D+01,0.00000000D+00
     .,0.22451100D+03,0.171D+03,0.360D+02,0.29219000D+01,0.00000000D+00
     .,0.11708400D+04,0.171D+03,0.370D+02,0.29219000D+01,0.00000000D+00
     .,0.10307165D+04,0.171D+03,0.380D+02,0.29219000D+01,0.00000000D+00
     .,0.90385210D+03,0.171D+03,0.390D+02,0.29219000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  63001:  63100)=(/
     . 0.81281250D+03,0.171D+03,0.400D+02,0.29219000D+01,0.00000000D+00
     .,0.74141830D+03,0.171D+03,0.410D+02,0.29219000D+01,0.00000000D+00
     .,0.57266250D+03,0.171D+03,0.420D+02,0.29219000D+01,0.00000000D+00
     .,0.63884880D+03,0.171D+03,0.430D+02,0.29219000D+01,0.00000000D+00
     .,0.48694650D+03,0.171D+03,0.440D+02,0.29219000D+01,0.00000000D+00
     .,0.53231850D+03,0.171D+03,0.450D+02,0.29219000D+01,0.00000000D+00
     .,0.49373180D+03,0.171D+03,0.460D+02,0.29219000D+01,0.00000000D+00
     .,0.41158220D+03,0.171D+03,0.470D+02,0.29219000D+01,0.00000000D+00
     .,0.43515940D+03,0.171D+03,0.480D+02,0.29219000D+01,0.00000000D+00
     .,0.54577490D+03,0.171D+03,0.490D+02,0.29219000D+01,0.00000000D+00
     .,0.50506710D+03,0.171D+03,0.500D+02,0.29219000D+01,0.00000000D+00
     .,0.45032940D+03,0.171D+03,0.510D+02,0.29219000D+01,0.00000000D+00
     .,0.41790250D+03,0.171D+03,0.520D+02,0.29219000D+01,0.00000000D+00
     .,0.37792070D+03,0.171D+03,0.530D+02,0.29219000D+01,0.00000000D+00
     .,0.33981250D+03,0.171D+03,0.540D+02,0.29219000D+01,0.00000000D+00
     .,0.14262370D+04,0.171D+03,0.550D+02,0.29219000D+01,0.00000000D+00
     .,0.13133618D+04,0.171D+03,0.560D+02,0.29219000D+01,0.00000000D+00
     .,0.11551299D+04,0.171D+03,0.570D+02,0.29219000D+01,0.00000000D+00
     .,0.53193250D+03,0.171D+03,0.580D+02,0.29219000D+01,0.27991000D+01
     .,0.11640997D+04,0.171D+03,0.590D+02,0.29219000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  63101:  63200)=(/
     . 0.11180647D+04,0.171D+03,0.600D+02,0.29219000D+01,0.00000000D+00
     .,0.10900872D+04,0.171D+03,0.610D+02,0.29219000D+01,0.00000000D+00
     .,0.10643505D+04,0.171D+03,0.620D+02,0.29219000D+01,0.00000000D+00
     .,0.10415296D+04,0.171D+03,0.630D+02,0.29219000D+01,0.00000000D+00
     .,0.81984680D+03,0.171D+03,0.640D+02,0.29219000D+01,0.00000000D+00
     .,0.92133410D+03,0.171D+03,0.650D+02,0.29219000D+01,0.00000000D+00
     .,0.88874530D+03,0.171D+03,0.660D+02,0.29219000D+01,0.00000000D+00
     .,0.93968880D+03,0.171D+03,0.670D+02,0.29219000D+01,0.00000000D+00
     .,0.91978180D+03,0.171D+03,0.680D+02,0.29219000D+01,0.00000000D+00
     .,0.90184110D+03,0.171D+03,0.690D+02,0.29219000D+01,0.00000000D+00
     .,0.89126080D+03,0.171D+03,0.700D+02,0.29219000D+01,0.00000000D+00
     .,0.75143080D+03,0.171D+03,0.710D+02,0.29219000D+01,0.00000000D+00
     .,0.73969160D+03,0.171D+03,0.720D+02,0.29219000D+01,0.00000000D+00
     .,0.67535320D+03,0.171D+03,0.730D+02,0.29219000D+01,0.00000000D+00
     .,0.57039690D+03,0.171D+03,0.740D+02,0.29219000D+01,0.00000000D+00
     .,0.58039830D+03,0.171D+03,0.750D+02,0.29219000D+01,0.00000000D+00
     .,0.52619340D+03,0.171D+03,0.760D+02,0.29219000D+01,0.00000000D+00
     .,0.48201740D+03,0.171D+03,0.770D+02,0.29219000D+01,0.00000000D+00
     .,0.40048290D+03,0.171D+03,0.780D+02,0.29219000D+01,0.00000000D+00
     .,0.37420390D+03,0.171D+03,0.790D+02,0.29219000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  63201:  63300)=(/
     . 0.38500720D+03,0.171D+03,0.800D+02,0.29219000D+01,0.00000000D+00
     .,0.56037600D+03,0.171D+03,0.810D+02,0.29219000D+01,0.00000000D+00
     .,0.54825190D+03,0.171D+03,0.820D+02,0.29219000D+01,0.00000000D+00
     .,0.50402540D+03,0.171D+03,0.830D+02,0.29219000D+01,0.00000000D+00
     .,0.48080590D+03,0.171D+03,0.840D+02,0.29219000D+01,0.00000000D+00
     .,0.44381570D+03,0.171D+03,0.850D+02,0.29219000D+01,0.00000000D+00
     .,0.40683040D+03,0.171D+03,0.860D+02,0.29219000D+01,0.00000000D+00
     .,0.13480198D+04,0.171D+03,0.870D+02,0.29219000D+01,0.00000000D+00
     .,0.12994057D+04,0.171D+03,0.880D+02,0.29219000D+01,0.00000000D+00
     .,0.11497484D+04,0.171D+03,0.890D+02,0.29219000D+01,0.00000000D+00
     .,0.10341669D+04,0.171D+03,0.900D+02,0.29219000D+01,0.00000000D+00
     .,0.10262543D+04,0.171D+03,0.910D+02,0.29219000D+01,0.00000000D+00
     .,0.99371920D+03,0.171D+03,0.920D+02,0.29219000D+01,0.00000000D+00
     .,0.10225738D+04,0.171D+03,0.930D+02,0.29219000D+01,0.00000000D+00
     .,0.99038000D+03,0.171D+03,0.940D+02,0.29219000D+01,0.00000000D+00
     .,0.55700800D+02,0.171D+03,0.101D+03,0.29219000D+01,0.00000000D+00
     .,0.18012920D+03,0.171D+03,0.103D+03,0.29219000D+01,0.98650000D+00
     .,0.22980950D+03,0.171D+03,0.104D+03,0.29219000D+01,0.98080000D+00
     .,0.17585020D+03,0.171D+03,0.105D+03,0.29219000D+01,0.97060000D+00
     .,0.13257550D+03,0.171D+03,0.106D+03,0.29219000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  63301:  63400)=(/
     . 0.92251200D+02,0.171D+03,0.107D+03,0.29219000D+01,0.99440000D+00
     .,0.67230800D+02,0.171D+03,0.108D+03,0.29219000D+01,0.99250000D+00
     .,0.46277200D+02,0.171D+03,0.109D+03,0.29219000D+01,0.99820000D+00
     .,0.26322190D+03,0.171D+03,0.111D+03,0.29219000D+01,0.96840000D+00
     .,0.40699260D+03,0.171D+03,0.112D+03,0.29219000D+01,0.96280000D+00
     .,0.41261700D+03,0.171D+03,0.113D+03,0.29219000D+01,0.96480000D+00
     .,0.33194510D+03,0.171D+03,0.114D+03,0.29219000D+01,0.95070000D+00
     .,0.27202390D+03,0.171D+03,0.115D+03,0.29219000D+01,0.99470000D+00
     .,0.23010400D+03,0.171D+03,0.116D+03,0.29219000D+01,0.99480000D+00
     .,0.18815090D+03,0.171D+03,0.117D+03,0.29219000D+01,0.99720000D+00
     .,0.36307990D+03,0.171D+03,0.119D+03,0.29219000D+01,0.97670000D+00
     .,0.69200830D+03,0.171D+03,0.120D+03,0.29219000D+01,0.98310000D+00
     .,0.36363190D+03,0.171D+03,0.121D+03,0.29219000D+01,0.18627000D+01
     .,0.35103090D+03,0.171D+03,0.122D+03,0.29219000D+01,0.18299000D+01
     .,0.34401120D+03,0.171D+03,0.123D+03,0.29219000D+01,0.19138000D+01
     .,0.34078980D+03,0.171D+03,0.124D+03,0.29219000D+01,0.18269000D+01
     .,0.31376160D+03,0.171D+03,0.125D+03,0.29219000D+01,0.16406000D+01
     .,0.29041450D+03,0.171D+03,0.126D+03,0.29219000D+01,0.16483000D+01
     .,0.27703380D+03,0.171D+03,0.127D+03,0.29219000D+01,0.17149000D+01
     .,0.27082780D+03,0.171D+03,0.128D+03,0.29219000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters(  63401:  63500)=(/
     . 0.26748920D+03,0.171D+03,0.129D+03,0.29219000D+01,0.95760000D+00
     .,0.25114070D+03,0.171D+03,0.130D+03,0.29219000D+01,0.19419000D+01
     .,0.40972790D+03,0.171D+03,0.131D+03,0.29219000D+01,0.96010000D+00
     .,0.36020340D+03,0.171D+03,0.132D+03,0.29219000D+01,0.94340000D+00
     .,0.32297840D+03,0.171D+03,0.133D+03,0.29219000D+01,0.98890000D+00
     .,0.29499200D+03,0.171D+03,0.134D+03,0.29219000D+01,0.99010000D+00
     .,0.25990550D+03,0.171D+03,0.135D+03,0.29219000D+01,0.99740000D+00
     .,0.43329230D+03,0.171D+03,0.137D+03,0.29219000D+01,0.97380000D+00
     .,0.84185430D+03,0.171D+03,0.138D+03,0.29219000D+01,0.98010000D+00
     .,0.64480130D+03,0.171D+03,0.139D+03,0.29219000D+01,0.19153000D+01
     .,0.48082360D+03,0.171D+03,0.140D+03,0.29219000D+01,0.19355000D+01
     .,0.48558420D+03,0.171D+03,0.141D+03,0.29219000D+01,0.19545000D+01
     .,0.45284900D+03,0.171D+03,0.142D+03,0.29219000D+01,0.19420000D+01
     .,0.50743830D+03,0.171D+03,0.143D+03,0.29219000D+01,0.16682000D+01
     .,0.39493050D+03,0.171D+03,0.144D+03,0.29219000D+01,0.18584000D+01
     .,0.36947180D+03,0.171D+03,0.145D+03,0.29219000D+01,0.19003000D+01
     .,0.34311040D+03,0.171D+03,0.146D+03,0.29219000D+01,0.18630000D+01
     .,0.33190160D+03,0.171D+03,0.147D+03,0.29219000D+01,0.96790000D+00
     .,0.32846280D+03,0.171D+03,0.148D+03,0.29219000D+01,0.19539000D+01
     .,0.52037630D+03,0.171D+03,0.149D+03,0.29219000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters(  63501:  63600)=(/
     . 0.47110690D+03,0.171D+03,0.150D+03,0.29219000D+01,0.95140000D+00
     .,0.44137250D+03,0.171D+03,0.151D+03,0.29219000D+01,0.97490000D+00
     .,0.41760220D+03,0.171D+03,0.152D+03,0.29219000D+01,0.98110000D+00
     .,0.38146630D+03,0.171D+03,0.153D+03,0.29219000D+01,0.99680000D+00
     .,0.51266580D+03,0.171D+03,0.155D+03,0.29219000D+01,0.99090000D+00
     .,0.10908422D+04,0.171D+03,0.156D+03,0.29219000D+01,0.97970000D+00
     .,0.81591040D+03,0.171D+03,0.157D+03,0.29219000D+01,0.19373000D+01
     .,0.51590750D+03,0.171D+03,0.159D+03,0.29219000D+01,0.29425000D+01
     .,0.50524280D+03,0.171D+03,0.160D+03,0.29219000D+01,0.29455000D+01
     .,0.48924070D+03,0.171D+03,0.161D+03,0.29219000D+01,0.29413000D+01
     .,0.49159590D+03,0.171D+03,0.162D+03,0.29219000D+01,0.29300000D+01
     .,0.47374820D+03,0.171D+03,0.163D+03,0.29219000D+01,0.18286000D+01
     .,0.49470080D+03,0.171D+03,0.164D+03,0.29219000D+01,0.28732000D+01
     .,0.46468280D+03,0.171D+03,0.165D+03,0.29219000D+01,0.29086000D+01
     .,0.47273450D+03,0.171D+03,0.166D+03,0.29219000D+01,0.28965000D+01
     .,0.44109990D+03,0.171D+03,0.167D+03,0.29219000D+01,0.29242000D+01
     .,0.42854250D+03,0.171D+03,0.168D+03,0.29219000D+01,0.29282000D+01
     .,0.42578520D+03,0.171D+03,0.169D+03,0.29219000D+01,0.29246000D+01
     .,0.44751580D+03,0.171D+03,0.170D+03,0.29219000D+01,0.28482000D+01
     .,0.41156650D+03,0.171D+03,0.171D+03,0.29219000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters(  63601:  63700)=(/
     . 0.45346600D+02,0.172D+03,0.100D+01,0.19254000D+01,0.91180000D+00
     .,0.28998600D+02,0.172D+03,0.200D+01,0.19254000D+01,0.00000000D+00
     .,0.83344750D+03,0.172D+03,0.300D+01,0.19254000D+01,0.00000000D+00
     .,0.44256360D+03,0.172D+03,0.400D+01,0.19254000D+01,0.00000000D+00
     .,0.28628310D+03,0.172D+03,0.500D+01,0.19254000D+01,0.00000000D+00
     .,0.18798820D+03,0.172D+03,0.600D+01,0.19254000D+01,0.00000000D+00
     .,0.12879820D+03,0.172D+03,0.700D+01,0.19254000D+01,0.00000000D+00
     .,0.96142400D+02,0.172D+03,0.800D+01,0.19254000D+01,0.00000000D+00
     .,0.71959700D+02,0.172D+03,0.900D+01,0.19254000D+01,0.00000000D+00
     .,0.54816700D+02,0.172D+03,0.100D+02,0.19254000D+01,0.00000000D+00
     .,0.99134020D+03,0.172D+03,0.110D+02,0.19254000D+01,0.00000000D+00
     .,0.71475720D+03,0.172D+03,0.120D+02,0.19254000D+01,0.00000000D+00
     .,0.64492820D+03,0.172D+03,0.130D+02,0.19254000D+01,0.00000000D+00
     .,0.49384800D+03,0.172D+03,0.140D+02,0.19254000D+01,0.00000000D+00
     .,0.37640650D+03,0.172D+03,0.150D+02,0.19254000D+01,0.00000000D+00
     .,0.30798130D+03,0.172D+03,0.160D+02,0.19254000D+01,0.00000000D+00
     .,0.24821220D+03,0.172D+03,0.170D+02,0.19254000D+01,0.00000000D+00
     .,0.20073430D+03,0.172D+03,0.180D+02,0.19254000D+01,0.00000000D+00
     .,0.16539476D+04,0.172D+03,0.190D+02,0.19254000D+01,0.00000000D+00
     .,0.12894650D+04,0.172D+03,0.200D+02,0.19254000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  63701:  63800)=(/
     . 0.10530789D+04,0.172D+03,0.210D+02,0.19254000D+01,0.00000000D+00
     .,0.10073778D+04,0.172D+03,0.220D+02,0.19254000D+01,0.00000000D+00
     .,0.91714520D+03,0.172D+03,0.230D+02,0.19254000D+01,0.00000000D+00
     .,0.72238490D+03,0.172D+03,0.240D+02,0.19254000D+01,0.00000000D+00
     .,0.78308020D+03,0.172D+03,0.250D+02,0.19254000D+01,0.00000000D+00
     .,0.61378620D+03,0.172D+03,0.260D+02,0.19254000D+01,0.00000000D+00
     .,0.64219290D+03,0.172D+03,0.270D+02,0.19254000D+01,0.00000000D+00
     .,0.66532650D+03,0.172D+03,0.280D+02,0.19254000D+01,0.00000000D+00
     .,0.51028620D+03,0.172D+03,0.290D+02,0.19254000D+01,0.00000000D+00
     .,0.51419020D+03,0.172D+03,0.300D+02,0.19254000D+01,0.00000000D+00
     .,0.61287020D+03,0.172D+03,0.310D+02,0.19254000D+01,0.00000000D+00
     .,0.52847210D+03,0.172D+03,0.320D+02,0.19254000D+01,0.00000000D+00
     .,0.44218700D+03,0.172D+03,0.330D+02,0.19254000D+01,0.00000000D+00
     .,0.39224560D+03,0.172D+03,0.340D+02,0.19254000D+01,0.00000000D+00
     .,0.33928530D+03,0.172D+03,0.350D+02,0.19254000D+01,0.00000000D+00
     .,0.29196450D+03,0.172D+03,0.360D+02,0.19254000D+01,0.00000000D+00
     .,0.18469699D+04,0.172D+03,0.370D+02,0.19254000D+01,0.00000000D+00
     .,0.15403424D+04,0.172D+03,0.380D+02,0.19254000D+01,0.00000000D+00
     .,0.13230311D+04,0.172D+03,0.390D+02,0.19254000D+01,0.00000000D+00
     .,0.11750345D+04,0.172D+03,0.400D+02,0.19254000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  63801:  63900)=(/
     . 0.10634756D+04,0.172D+03,0.410D+02,0.19254000D+01,0.00000000D+00
     .,0.81065520D+03,0.172D+03,0.420D+02,0.19254000D+01,0.00000000D+00
     .,0.90884210D+03,0.172D+03,0.430D+02,0.19254000D+01,0.00000000D+00
     .,0.68268070D+03,0.172D+03,0.440D+02,0.19254000D+01,0.00000000D+00
     .,0.74565500D+03,0.172D+03,0.450D+02,0.19254000D+01,0.00000000D+00
     .,0.68814480D+03,0.172D+03,0.460D+02,0.19254000D+01,0.00000000D+00
     .,0.57595500D+03,0.172D+03,0.470D+02,0.19254000D+01,0.00000000D+00
     .,0.60264510D+03,0.172D+03,0.480D+02,0.19254000D+01,0.00000000D+00
     .,0.76801030D+03,0.172D+03,0.490D+02,0.19254000D+01,0.00000000D+00
     .,0.69681050D+03,0.172D+03,0.500D+02,0.19254000D+01,0.00000000D+00
     .,0.61025270D+03,0.172D+03,0.510D+02,0.19254000D+01,0.00000000D+00
     .,0.56048120D+03,0.172D+03,0.520D+02,0.19254000D+01,0.00000000D+00
     .,0.50136210D+03,0.172D+03,0.530D+02,0.19254000D+01,0.00000000D+00
     .,0.44626410D+03,0.172D+03,0.540D+02,0.19254000D+01,0.00000000D+00
     .,0.22528586D+04,0.172D+03,0.550D+02,0.19254000D+01,0.00000000D+00
     .,0.19789909D+04,0.172D+03,0.560D+02,0.19254000D+01,0.00000000D+00
     .,0.17040270D+04,0.172D+03,0.570D+02,0.19254000D+01,0.00000000D+00
     .,0.72344560D+03,0.172D+03,0.580D+02,0.19254000D+01,0.27991000D+01
     .,0.17420729D+04,0.172D+03,0.590D+02,0.19254000D+01,0.00000000D+00
     .,0.16661615D+04,0.172D+03,0.600D+02,0.19254000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  63901:  64000)=(/
     . 0.16226978D+04,0.172D+03,0.610D+02,0.19254000D+01,0.00000000D+00
     .,0.15829071D+04,0.172D+03,0.620D+02,0.19254000D+01,0.00000000D+00
     .,0.15475750D+04,0.172D+03,0.630D+02,0.19254000D+01,0.00000000D+00
     .,0.11920226D+04,0.172D+03,0.640D+02,0.19254000D+01,0.00000000D+00
     .,0.13894684D+04,0.172D+03,0.650D+02,0.19254000D+01,0.00000000D+00
     .,0.13360613D+04,0.172D+03,0.660D+02,0.19254000D+01,0.00000000D+00
     .,0.13884173D+04,0.172D+03,0.670D+02,0.19254000D+01,0.00000000D+00
     .,0.13581065D+04,0.172D+03,0.680D+02,0.19254000D+01,0.00000000D+00
     .,0.13304473D+04,0.172D+03,0.690D+02,0.19254000D+01,0.00000000D+00
     .,0.13159859D+04,0.172D+03,0.700D+02,0.19254000D+01,0.00000000D+00
     .,0.10939351D+04,0.172D+03,0.710D+02,0.19254000D+01,0.00000000D+00
     .,0.10543108D+04,0.172D+03,0.720D+02,0.19254000D+01,0.00000000D+00
     .,0.95118510D+03,0.172D+03,0.730D+02,0.19254000D+01,0.00000000D+00
     .,0.79676620D+03,0.172D+03,0.740D+02,0.19254000D+01,0.00000000D+00
     .,0.80679990D+03,0.172D+03,0.750D+02,0.19254000D+01,0.00000000D+00
     .,0.72412960D+03,0.172D+03,0.760D+02,0.19254000D+01,0.00000000D+00
     .,0.65806160D+03,0.172D+03,0.770D+02,0.19254000D+01,0.00000000D+00
     .,0.54245470D+03,0.172D+03,0.780D+02,0.19254000D+01,0.00000000D+00
     .,0.50520370D+03,0.172D+03,0.790D+02,0.19254000D+01,0.00000000D+00
     .,0.51767100D+03,0.172D+03,0.800D+02,0.19254000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  64001:  64100)=(/
     . 0.78562040D+03,0.172D+03,0.810D+02,0.19254000D+01,0.00000000D+00
     .,0.75633770D+03,0.172D+03,0.820D+02,0.19254000D+01,0.00000000D+00
     .,0.68397230D+03,0.172D+03,0.830D+02,0.19254000D+01,0.00000000D+00
     .,0.64657460D+03,0.172D+03,0.840D+02,0.19254000D+01,0.00000000D+00
     .,0.59053860D+03,0.172D+03,0.850D+02,0.19254000D+01,0.00000000D+00
     .,0.53625670D+03,0.172D+03,0.860D+02,0.19254000D+01,0.00000000D+00
     .,0.20908542D+04,0.172D+03,0.870D+02,0.19254000D+01,0.00000000D+00
     .,0.19370166D+04,0.172D+03,0.880D+02,0.19254000D+01,0.00000000D+00
     .,0.16804201D+04,0.172D+03,0.890D+02,0.19254000D+01,0.00000000D+00
     .,0.14797956D+04,0.172D+03,0.900D+02,0.19254000D+01,0.00000000D+00
     .,0.14847146D+04,0.172D+03,0.910D+02,0.19254000D+01,0.00000000D+00
     .,0.14366817D+04,0.172D+03,0.920D+02,0.19254000D+01,0.00000000D+00
     .,0.14973302D+04,0.172D+03,0.930D+02,0.19254000D+01,0.00000000D+00
     .,0.14464901D+04,0.172D+03,0.940D+02,0.19254000D+01,0.00000000D+00
     .,0.74629200D+02,0.172D+03,0.101D+03,0.19254000D+01,0.00000000D+00
     .,0.25592080D+03,0.172D+03,0.103D+03,0.19254000D+01,0.98650000D+00
     .,0.32443230D+03,0.172D+03,0.104D+03,0.19254000D+01,0.98080000D+00
     .,0.23897670D+03,0.172D+03,0.105D+03,0.19254000D+01,0.97060000D+00
     .,0.17654080D+03,0.172D+03,0.106D+03,0.19254000D+01,0.98680000D+00
     .,0.12010680D+03,0.172D+03,0.107D+03,0.19254000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters(  64101:  64200)=(/
     . 0.85937000D+02,0.172D+03,0.108D+03,0.19254000D+01,0.99250000D+00
     .,0.57827200D+02,0.172D+03,0.109D+03,0.19254000D+01,0.99820000D+00
     .,0.37699540D+03,0.172D+03,0.111D+03,0.19254000D+01,0.96840000D+00
     .,0.58570530D+03,0.172D+03,0.112D+03,0.19254000D+01,0.96280000D+00
     .,0.58157180D+03,0.172D+03,0.113D+03,0.19254000D+01,0.96480000D+00
     .,0.45471270D+03,0.172D+03,0.114D+03,0.19254000D+01,0.95070000D+00
     .,0.36512350D+03,0.172D+03,0.115D+03,0.19254000D+01,0.99470000D+00
     .,0.30470560D+03,0.172D+03,0.116D+03,0.19254000D+01,0.99480000D+00
     .,0.24570480D+03,0.172D+03,0.117D+03,0.19254000D+01,0.99720000D+00
     .,0.51281530D+03,0.172D+03,0.119D+03,0.19254000D+01,0.97670000D+00
     .,0.10341456D+04,0.172D+03,0.120D+03,0.19254000D+01,0.98310000D+00
     .,0.50045280D+03,0.172D+03,0.121D+03,0.19254000D+01,0.18627000D+01
     .,0.48316910D+03,0.172D+03,0.122D+03,0.19254000D+01,0.18299000D+01
     .,0.47364140D+03,0.172D+03,0.123D+03,0.19254000D+01,0.19138000D+01
     .,0.47060760D+03,0.172D+03,0.124D+03,0.19254000D+01,0.18269000D+01
     .,0.42699780D+03,0.172D+03,0.125D+03,0.19254000D+01,0.16406000D+01
     .,0.39370530D+03,0.172D+03,0.126D+03,0.19254000D+01,0.16483000D+01
     .,0.37565220D+03,0.172D+03,0.127D+03,0.19254000D+01,0.17149000D+01
     .,0.36764140D+03,0.172D+03,0.128D+03,0.19254000D+01,0.17937000D+01
     .,0.36693480D+03,0.172D+03,0.129D+03,0.19254000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters(  64201:  64300)=(/
     . 0.33796290D+03,0.172D+03,0.130D+03,0.19254000D+01,0.19419000D+01
     .,0.57232270D+03,0.172D+03,0.131D+03,0.19254000D+01,0.96010000D+00
     .,0.49197380D+03,0.172D+03,0.132D+03,0.19254000D+01,0.94340000D+00
     .,0.43422870D+03,0.172D+03,0.133D+03,0.19254000D+01,0.98890000D+00
     .,0.39247750D+03,0.172D+03,0.134D+03,0.19254000D+01,0.99010000D+00
     .,0.34185570D+03,0.172D+03,0.135D+03,0.19254000D+01,0.99740000D+00
     .,0.60910480D+03,0.172D+03,0.137D+03,0.19254000D+01,0.97380000D+00
     .,0.12632459D+04,0.172D+03,0.138D+03,0.19254000D+01,0.98010000D+00
     .,0.92911650D+03,0.172D+03,0.139D+03,0.19254000D+01,0.19153000D+01
     .,0.66400370D+03,0.172D+03,0.140D+03,0.19254000D+01,0.19355000D+01
     .,0.67040190D+03,0.172D+03,0.141D+03,0.19254000D+01,0.19545000D+01
     .,0.62262030D+03,0.172D+03,0.142D+03,0.19254000D+01,0.19420000D+01
     .,0.71174240D+03,0.172D+03,0.143D+03,0.19254000D+01,0.16682000D+01
     .,0.53554020D+03,0.172D+03,0.144D+03,0.19254000D+01,0.18584000D+01
     .,0.50050420D+03,0.172D+03,0.145D+03,0.19254000D+01,0.19003000D+01
     .,0.46368240D+03,0.172D+03,0.146D+03,0.19254000D+01,0.18630000D+01
     .,0.44930820D+03,0.172D+03,0.147D+03,0.19254000D+01,0.96790000D+00
     .,0.43997740D+03,0.172D+03,0.148D+03,0.19254000D+01,0.19539000D+01
     .,0.72721640D+03,0.172D+03,0.149D+03,0.19254000D+01,0.96330000D+00
     .,0.64540420D+03,0.172D+03,0.150D+03,0.19254000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters(  64301:  64400)=(/
     . 0.59673110D+03,0.172D+03,0.151D+03,0.19254000D+01,0.97490000D+00
     .,0.55972270D+03,0.172D+03,0.152D+03,0.19254000D+01,0.98110000D+00
     .,0.50615680D+03,0.172D+03,0.153D+03,0.19254000D+01,0.99680000D+00
     .,0.71003790D+03,0.172D+03,0.155D+03,0.19254000D+01,0.99090000D+00
     .,0.16551217D+04,0.172D+03,0.156D+03,0.19254000D+01,0.97970000D+00
     .,0.11811130D+04,0.172D+03,0.157D+03,0.19254000D+01,0.19373000D+01
     .,0.70092550D+03,0.172D+03,0.159D+03,0.19254000D+01,0.29425000D+01
     .,0.68627630D+03,0.172D+03,0.160D+03,0.19254000D+01,0.29455000D+01
     .,0.66395860D+03,0.172D+03,0.161D+03,0.19254000D+01,0.29413000D+01
     .,0.66917280D+03,0.172D+03,0.162D+03,0.19254000D+01,0.29300000D+01
     .,0.65059990D+03,0.172D+03,0.163D+03,0.19254000D+01,0.18286000D+01
     .,0.67380220D+03,0.172D+03,0.164D+03,0.19254000D+01,0.28732000D+01
     .,0.63135970D+03,0.172D+03,0.165D+03,0.19254000D+01,0.29086000D+01
     .,0.64587040D+03,0.172D+03,0.166D+03,0.19254000D+01,0.28965000D+01
     .,0.59787350D+03,0.172D+03,0.167D+03,0.19254000D+01,0.29242000D+01
     .,0.58033350D+03,0.172D+03,0.168D+03,0.19254000D+01,0.29282000D+01
     .,0.57700390D+03,0.172D+03,0.169D+03,0.19254000D+01,0.29246000D+01
     .,0.60871420D+03,0.172D+03,0.170D+03,0.19254000D+01,0.28482000D+01
     .,0.55695720D+03,0.172D+03,0.171D+03,0.19254000D+01,0.29219000D+01
     .,0.78038720D+03,0.172D+03,0.172D+03,0.19254000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters(  64401:  64500)=(/
     . 0.42599100D+02,0.173D+03,0.100D+01,0.19459000D+01,0.91180000D+00
     .,0.27620800D+02,0.173D+03,0.200D+01,0.19459000D+01,0.00000000D+00
     .,0.73880890D+03,0.173D+03,0.300D+01,0.19459000D+01,0.00000000D+00
     .,0.40322390D+03,0.173D+03,0.400D+01,0.19459000D+01,0.00000000D+00
     .,0.26458080D+03,0.173D+03,0.500D+01,0.19459000D+01,0.00000000D+00
     .,0.17562680D+03,0.173D+03,0.600D+01,0.19459000D+01,0.00000000D+00
     .,0.12132320D+03,0.173D+03,0.700D+01,0.19459000D+01,0.00000000D+00
     .,0.91102500D+02,0.173D+03,0.800D+01,0.19459000D+01,0.00000000D+00
     .,0.68542500D+02,0.173D+03,0.900D+01,0.19459000D+01,0.00000000D+00
     .,0.52435800D+02,0.173D+03,0.100D+02,0.19459000D+01,0.00000000D+00
     .,0.88035320D+03,0.173D+03,0.110D+02,0.19459000D+01,0.00000000D+00
     .,0.64829810D+03,0.173D+03,0.120D+02,0.19459000D+01,0.00000000D+00
     .,0.58923010D+03,0.173D+03,0.130D+02,0.19459000D+01,0.00000000D+00
     .,0.45575650D+03,0.173D+03,0.140D+02,0.19459000D+01,0.00000000D+00
     .,0.35031540D+03,0.173D+03,0.150D+02,0.19459000D+01,0.00000000D+00
     .,0.28821970D+03,0.173D+03,0.160D+02,0.19459000D+01,0.00000000D+00
     .,0.23353600D+03,0.173D+03,0.170D+02,0.19459000D+01,0.00000000D+00
     .,0.18976410D+03,0.173D+03,0.180D+02,0.19459000D+01,0.00000000D+00
     .,0.14604707D+04,0.173D+03,0.190D+02,0.19459000D+01,0.00000000D+00
     .,0.11597504D+04,0.173D+03,0.200D+02,0.19459000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  64501:  64600)=(/
     . 0.95068620D+03,0.173D+03,0.210D+02,0.19459000D+01,0.00000000D+00
     .,0.91232910D+03,0.173D+03,0.220D+02,0.19459000D+01,0.00000000D+00
     .,0.83223310D+03,0.173D+03,0.230D+02,0.19459000D+01,0.00000000D+00
     .,0.65570910D+03,0.173D+03,0.240D+02,0.19459000D+01,0.00000000D+00
     .,0.71259280D+03,0.173D+03,0.250D+02,0.19459000D+01,0.00000000D+00
     .,0.55895410D+03,0.173D+03,0.260D+02,0.19459000D+01,0.00000000D+00
     .,0.58724740D+03,0.173D+03,0.270D+02,0.19459000D+01,0.00000000D+00
     .,0.60719280D+03,0.173D+03,0.280D+02,0.19459000D+01,0.00000000D+00
     .,0.46580690D+03,0.173D+03,0.290D+02,0.19459000D+01,0.00000000D+00
     .,0.47225470D+03,0.173D+03,0.300D+02,0.19459000D+01,0.00000000D+00
     .,0.56160790D+03,0.173D+03,0.310D+02,0.19459000D+01,0.00000000D+00
     .,0.48807900D+03,0.173D+03,0.320D+02,0.19459000D+01,0.00000000D+00
     .,0.41125650D+03,0.173D+03,0.330D+02,0.19459000D+01,0.00000000D+00
     .,0.36640670D+03,0.173D+03,0.340D+02,0.19459000D+01,0.00000000D+00
     .,0.31837520D+03,0.173D+03,0.350D+02,0.19459000D+01,0.00000000D+00
     .,0.27512740D+03,0.173D+03,0.360D+02,0.19459000D+01,0.00000000D+00
     .,0.16328526D+04,0.173D+03,0.370D+02,0.19459000D+01,0.00000000D+00
     .,0.13843496D+04,0.173D+03,0.380D+02,0.19459000D+01,0.00000000D+00
     .,0.11967064D+04,0.173D+03,0.390D+02,0.19459000D+01,0.00000000D+00
     .,0.10670698D+04,0.173D+03,0.400D+02,0.19459000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  64601:  64700)=(/
     . 0.96823440D+03,0.173D+03,0.410D+02,0.19459000D+01,0.00000000D+00
     .,0.74142020D+03,0.173D+03,0.420D+02,0.19459000D+01,0.00000000D+00
     .,0.82976170D+03,0.173D+03,0.430D+02,0.19459000D+01,0.00000000D+00
     .,0.62645270D+03,0.173D+03,0.440D+02,0.19459000D+01,0.00000000D+00
     .,0.68426530D+03,0.173D+03,0.450D+02,0.19459000D+01,0.00000000D+00
     .,0.63255740D+03,0.173D+03,0.460D+02,0.19459000D+01,0.00000000D+00
     .,0.52892880D+03,0.173D+03,0.470D+02,0.19459000D+01,0.00000000D+00
     .,0.55516740D+03,0.173D+03,0.480D+02,0.19459000D+01,0.00000000D+00
     .,0.70365600D+03,0.173D+03,0.490D+02,0.19459000D+01,0.00000000D+00
     .,0.64257250D+03,0.173D+03,0.500D+02,0.19459000D+01,0.00000000D+00
     .,0.56623950D+03,0.173D+03,0.510D+02,0.19459000D+01,0.00000000D+00
     .,0.52199830D+03,0.173D+03,0.520D+02,0.19459000D+01,0.00000000D+00
     .,0.46882570D+03,0.173D+03,0.530D+02,0.19459000D+01,0.00000000D+00
     .,0.41891390D+03,0.173D+03,0.540D+02,0.19459000D+01,0.00000000D+00
     .,0.19906514D+04,0.173D+03,0.550D+02,0.19459000D+01,0.00000000D+00
     .,0.17742433D+04,0.173D+03,0.560D+02,0.19459000D+01,0.00000000D+00
     .,0.15377374D+04,0.173D+03,0.570D+02,0.19459000D+01,0.00000000D+00
     .,0.67054450D+03,0.173D+03,0.580D+02,0.19459000D+01,0.27991000D+01
     .,0.15650227D+04,0.173D+03,0.590D+02,0.19459000D+01,0.00000000D+00
     .,0.14988909D+04,0.173D+03,0.600D+02,0.19459000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  64701:  64800)=(/
     . 0.14602740D+04,0.173D+03,0.610D+02,0.19459000D+01,0.00000000D+00
     .,0.14248668D+04,0.173D+03,0.620D+02,0.19459000D+01,0.00000000D+00
     .,0.13934393D+04,0.173D+03,0.630D+02,0.19459000D+01,0.00000000D+00
     .,0.10807361D+04,0.173D+03,0.640D+02,0.19459000D+01,0.00000000D+00
     .,0.12454654D+04,0.173D+03,0.650D+02,0.19459000D+01,0.00000000D+00
     .,0.11985562D+04,0.173D+03,0.660D+02,0.19459000D+01,0.00000000D+00
     .,0.12522798D+04,0.173D+03,0.670D+02,0.19459000D+01,0.00000000D+00
     .,0.12251780D+04,0.173D+03,0.680D+02,0.19459000D+01,0.00000000D+00
     .,0.12005428D+04,0.173D+03,0.690D+02,0.19459000D+01,0.00000000D+00
     .,0.11871547D+04,0.173D+03,0.700D+02,0.19459000D+01,0.00000000D+00
     .,0.99115750D+03,0.173D+03,0.710D+02,0.19459000D+01,0.00000000D+00
     .,0.96178800D+03,0.173D+03,0.720D+02,0.19459000D+01,0.00000000D+00
     .,0.87115170D+03,0.173D+03,0.730D+02,0.19459000D+01,0.00000000D+00
     .,0.73191440D+03,0.173D+03,0.740D+02,0.19459000D+01,0.00000000D+00
     .,0.74227510D+03,0.173D+03,0.750D+02,0.19459000D+01,0.00000000D+00
     .,0.66851880D+03,0.173D+03,0.760D+02,0.19459000D+01,0.00000000D+00
     .,0.60921920D+03,0.173D+03,0.770D+02,0.19459000D+01,0.00000000D+00
     .,0.50370150D+03,0.173D+03,0.780D+02,0.19459000D+01,0.00000000D+00
     .,0.46968660D+03,0.173D+03,0.790D+02,0.19459000D+01,0.00000000D+00
     .,0.48188500D+03,0.173D+03,0.800D+02,0.19459000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  64801:  64900)=(/
     . 0.72091450D+03,0.173D+03,0.810D+02,0.19459000D+01,0.00000000D+00
     .,0.69765140D+03,0.173D+03,0.820D+02,0.19459000D+01,0.00000000D+00
     .,0.63443450D+03,0.173D+03,0.830D+02,0.19459000D+01,0.00000000D+00
     .,0.60166450D+03,0.173D+03,0.840D+02,0.19459000D+01,0.00000000D+00
     .,0.55163790D+03,0.173D+03,0.850D+02,0.19459000D+01,0.00000000D+00
     .,0.50269970D+03,0.173D+03,0.860D+02,0.19459000D+01,0.00000000D+00
     .,0.18580508D+04,0.173D+03,0.870D+02,0.19459000D+01,0.00000000D+00
     .,0.17424506D+04,0.173D+03,0.880D+02,0.19459000D+01,0.00000000D+00
     .,0.15208103D+04,0.173D+03,0.890D+02,0.19459000D+01,0.00000000D+00
     .,0.13484147D+04,0.173D+03,0.900D+02,0.19459000D+01,0.00000000D+00
     .,0.13482588D+04,0.173D+03,0.910D+02,0.19459000D+01,0.00000000D+00
     .,0.13049404D+04,0.173D+03,0.920D+02,0.19459000D+01,0.00000000D+00
     .,0.13545615D+04,0.173D+03,0.930D+02,0.19459000D+01,0.00000000D+00
     .,0.13096099D+04,0.173D+03,0.940D+02,0.19459000D+01,0.00000000D+00
     .,0.69517200D+02,0.173D+03,0.101D+03,0.19459000D+01,0.00000000D+00
     .,0.23360750D+03,0.173D+03,0.103D+03,0.19459000D+01,0.98650000D+00
     .,0.29681730D+03,0.173D+03,0.104D+03,0.19459000D+01,0.98080000D+00
     .,0.22150850D+03,0.173D+03,0.105D+03,0.19459000D+01,0.97060000D+00
     .,0.16489220D+03,0.173D+03,0.106D+03,0.19459000D+01,0.98680000D+00
     .,0.11316000D+03,0.173D+03,0.107D+03,0.19459000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters(  64901:  65000)=(/
     . 0.81561000D+02,0.173D+03,0.108D+03,0.19459000D+01,0.99250000D+00
     .,0.55390500D+02,0.173D+03,0.109D+03,0.19459000D+01,0.99820000D+00
     .,0.34328010D+03,0.173D+03,0.111D+03,0.19459000D+01,0.96840000D+00
     .,0.53247660D+03,0.173D+03,0.112D+03,0.19459000D+01,0.96280000D+00
     .,0.53228640D+03,0.173D+03,0.113D+03,0.19459000D+01,0.96480000D+00
     .,0.42023260D+03,0.173D+03,0.114D+03,0.19459000D+01,0.95070000D+00
     .,0.33991220D+03,0.173D+03,0.115D+03,0.19459000D+01,0.99470000D+00
     .,0.28511970D+03,0.173D+03,0.116D+03,0.19459000D+01,0.99480000D+00
     .,0.23115710D+03,0.173D+03,0.117D+03,0.19459000D+01,0.99720000D+00
     .,0.46941050D+03,0.173D+03,0.119D+03,0.19459000D+01,0.97670000D+00
     .,0.92943790D+03,0.173D+03,0.120D+03,0.19459000D+01,0.98310000D+00
     .,0.46193760D+03,0.173D+03,0.121D+03,0.19459000D+01,0.18627000D+01
     .,0.44595790D+03,0.173D+03,0.122D+03,0.19459000D+01,0.18299000D+01
     .,0.43713970D+03,0.173D+03,0.123D+03,0.19459000D+01,0.19138000D+01
     .,0.43391220D+03,0.173D+03,0.124D+03,0.19459000D+01,0.18269000D+01
     .,0.39561160D+03,0.173D+03,0.125D+03,0.19459000D+01,0.16406000D+01
     .,0.36527420D+03,0.173D+03,0.126D+03,0.19459000D+01,0.16483000D+01
     .,0.34851570D+03,0.173D+03,0.127D+03,0.19459000D+01,0.17149000D+01
     .,0.34095800D+03,0.173D+03,0.128D+03,0.19459000D+01,0.17937000D+01
     .,0.33910500D+03,0.173D+03,0.129D+03,0.19459000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters(  65001:  65100)=(/
     . 0.31436170D+03,0.173D+03,0.130D+03,0.19459000D+01,0.19419000D+01
     .,0.52550400D+03,0.173D+03,0.131D+03,0.19459000D+01,0.96010000D+00
     .,0.45518330D+03,0.173D+03,0.132D+03,0.19459000D+01,0.94340000D+00
     .,0.40401890D+03,0.173D+03,0.133D+03,0.19459000D+01,0.98890000D+00
     .,0.36659830D+03,0.173D+03,0.134D+03,0.19459000D+01,0.99010000D+00
     .,0.32071300D+03,0.173D+03,0.135D+03,0.19459000D+01,0.99740000D+00
     .,0.55849190D+03,0.173D+03,0.137D+03,0.19459000D+01,0.97380000D+00
     .,0.11339963D+04,0.173D+03,0.138D+03,0.19459000D+01,0.98010000D+00
     .,0.84472340D+03,0.173D+03,0.139D+03,0.19459000D+01,0.19153000D+01
     .,0.61231920D+03,0.173D+03,0.140D+03,0.19459000D+01,0.19355000D+01
     .,0.61833280D+03,0.173D+03,0.141D+03,0.19459000D+01,0.19545000D+01
     .,0.57504470D+03,0.173D+03,0.142D+03,0.19459000D+01,0.19420000D+01
     .,0.65304060D+03,0.173D+03,0.143D+03,0.19459000D+01,0.16682000D+01
     .,0.49697040D+03,0.173D+03,0.144D+03,0.19459000D+01,0.18584000D+01
     .,0.46466380D+03,0.173D+03,0.145D+03,0.19459000D+01,0.19003000D+01
     .,0.43087120D+03,0.173D+03,0.146D+03,0.19459000D+01,0.18630000D+01
     .,0.41726470D+03,0.173D+03,0.147D+03,0.19459000D+01,0.96790000D+00
     .,0.41002790D+03,0.173D+03,0.148D+03,0.19459000D+01,0.19539000D+01
     .,0.66780870D+03,0.173D+03,0.149D+03,0.19459000D+01,0.96330000D+00
     .,0.59661500D+03,0.173D+03,0.150D+03,0.19459000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters(  65101:  65200)=(/
     . 0.55414990D+03,0.173D+03,0.151D+03,0.19459000D+01,0.97490000D+00
     .,0.52141070D+03,0.173D+03,0.152D+03,0.19459000D+01,0.98110000D+00
     .,0.47327510D+03,0.173D+03,0.153D+03,0.19459000D+01,0.99680000D+00
     .,0.65424880D+03,0.173D+03,0.155D+03,0.19459000D+01,0.99090000D+00
     .,0.14806088D+04,0.173D+03,0.156D+03,0.19459000D+01,0.97970000D+00
     .,0.10722142D+04,0.173D+03,0.157D+03,0.19459000D+01,0.19373000D+01
     .,0.64990970D+03,0.173D+03,0.159D+03,0.19459000D+01,0.29425000D+01
     .,0.63638010D+03,0.173D+03,0.160D+03,0.19459000D+01,0.29455000D+01
     .,0.61587840D+03,0.173D+03,0.161D+03,0.19459000D+01,0.29413000D+01
     .,0.62006220D+03,0.173D+03,0.162D+03,0.19459000D+01,0.29300000D+01
     .,0.60108450D+03,0.173D+03,0.163D+03,0.19459000D+01,0.18286000D+01
     .,0.62420110D+03,0.173D+03,0.164D+03,0.19459000D+01,0.28732000D+01
     .,0.58539210D+03,0.173D+03,0.165D+03,0.19459000D+01,0.29086000D+01
     .,0.59771440D+03,0.173D+03,0.166D+03,0.19459000D+01,0.28965000D+01
     .,0.55479820D+03,0.173D+03,0.167D+03,0.19459000D+01,0.29242000D+01
     .,0.53868740D+03,0.173D+03,0.168D+03,0.19459000D+01,0.29282000D+01
     .,0.53545990D+03,0.173D+03,0.169D+03,0.19459000D+01,0.29246000D+01
     .,0.56410720D+03,0.173D+03,0.170D+03,0.19459000D+01,0.28482000D+01
     .,0.51709820D+03,0.173D+03,0.171D+03,0.19459000D+01,0.29219000D+01
     .,0.71609920D+03,0.173D+03,0.172D+03,0.19459000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters(  65201:  65300)=(/
     . 0.65975010D+03,0.173D+03,0.173D+03,0.19459000D+01,0.19459000D+01
     .,0.39353000D+02,0.174D+03,0.100D+01,0.19292000D+01,0.91180000D+00
     .,0.25891600D+02,0.174D+03,0.200D+01,0.19292000D+01,0.00000000D+00
     .,0.64222390D+03,0.174D+03,0.300D+01,0.19292000D+01,0.00000000D+00
     .,0.36075580D+03,0.174D+03,0.400D+01,0.19292000D+01,0.00000000D+00
     .,0.24029820D+03,0.174D+03,0.500D+01,0.19292000D+01,0.00000000D+00
     .,0.16132870D+03,0.174D+03,0.600D+01,0.19292000D+01,0.00000000D+00
     .,0.11241380D+03,0.174D+03,0.700D+01,0.19292000D+01,0.00000000D+00
     .,0.84942800D+02,0.174D+03,0.800D+01,0.19292000D+01,0.00000000D+00
     .,0.64260400D+02,0.174D+03,0.900D+01,0.19292000D+01,0.00000000D+00
     .,0.49383000D+02,0.174D+03,0.100D+02,0.19292000D+01,0.00000000D+00
     .,0.76674770D+03,0.174D+03,0.110D+02,0.19292000D+01,0.00000000D+00
     .,0.57730020D+03,0.174D+03,0.120D+02,0.19292000D+01,0.00000000D+00
     .,0.52875590D+03,0.174D+03,0.130D+02,0.19292000D+01,0.00000000D+00
     .,0.41330440D+03,0.174D+03,0.140D+02,0.19292000D+01,0.00000000D+00
     .,0.32049320D+03,0.174D+03,0.150D+02,0.19292000D+01,0.00000000D+00
     .,0.26521130D+03,0.174D+03,0.160D+02,0.19292000D+01,0.00000000D+00
     .,0.21610340D+03,0.174D+03,0.170D+02,0.19292000D+01,0.00000000D+00
     .,0.17647630D+03,0.174D+03,0.180D+02,0.19292000D+01,0.00000000D+00
     .,0.12652105D+04,0.174D+03,0.190D+02,0.19292000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  65301:  65400)=(/
     . 0.10237513D+04,0.174D+03,0.200D+02,0.19292000D+01,0.00000000D+00
     .,0.84249870D+03,0.174D+03,0.210D+02,0.19292000D+01,0.00000000D+00
     .,0.81128040D+03,0.174D+03,0.220D+02,0.19292000D+01,0.00000000D+00
     .,0.74159550D+03,0.174D+03,0.230D+02,0.19292000D+01,0.00000000D+00
     .,0.58457670D+03,0.174D+03,0.240D+02,0.19292000D+01,0.00000000D+00
     .,0.63689720D+03,0.174D+03,0.250D+02,0.19292000D+01,0.00000000D+00
     .,0.50004450D+03,0.174D+03,0.260D+02,0.19292000D+01,0.00000000D+00
     .,0.52755830D+03,0.174D+03,0.270D+02,0.19292000D+01,0.00000000D+00
     .,0.54433150D+03,0.174D+03,0.280D+02,0.19292000D+01,0.00000000D+00
     .,0.41776790D+03,0.174D+03,0.290D+02,0.19292000D+01,0.00000000D+00
     .,0.42620470D+03,0.174D+03,0.300D+02,0.19292000D+01,0.00000000D+00
     .,0.50560850D+03,0.174D+03,0.310D+02,0.19292000D+01,0.00000000D+00
     .,0.44299990D+03,0.174D+03,0.320D+02,0.19292000D+01,0.00000000D+00
     .,0.37599840D+03,0.174D+03,0.330D+02,0.19292000D+01,0.00000000D+00
     .,0.33652400D+03,0.174D+03,0.340D+02,0.19292000D+01,0.00000000D+00
     .,0.29379580D+03,0.174D+03,0.350D+02,0.19292000D+01,0.00000000D+00
     .,0.25500680D+03,0.174D+03,0.360D+02,0.19292000D+01,0.00000000D+00
     .,0.14165256D+04,0.174D+03,0.370D+02,0.19292000D+01,0.00000000D+00
     .,0.12211434D+04,0.174D+03,0.380D+02,0.19292000D+01,0.00000000D+00
     .,0.10628100D+04,0.174D+03,0.390D+02,0.19292000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  65401:  65500)=(/
     . 0.95167080D+03,0.174D+03,0.400D+02,0.19292000D+01,0.00000000D+00
     .,0.86588950D+03,0.174D+03,0.410D+02,0.19292000D+01,0.00000000D+00
     .,0.66629380D+03,0.174D+03,0.420D+02,0.19292000D+01,0.00000000D+00
     .,0.74429510D+03,0.174D+03,0.430D+02,0.19292000D+01,0.00000000D+00
     .,0.56498080D+03,0.174D+03,0.440D+02,0.19292000D+01,0.00000000D+00
     .,0.61707470D+03,0.174D+03,0.450D+02,0.19292000D+01,0.00000000D+00
     .,0.57145890D+03,0.174D+03,0.460D+02,0.19292000D+01,0.00000000D+00
     .,0.47746470D+03,0.174D+03,0.470D+02,0.19292000D+01,0.00000000D+00
     .,0.50269480D+03,0.174D+03,0.480D+02,0.19292000D+01,0.00000000D+00
     .,0.63350610D+03,0.174D+03,0.490D+02,0.19292000D+01,0.00000000D+00
     .,0.58238420D+03,0.174D+03,0.500D+02,0.19292000D+01,0.00000000D+00
     .,0.51649490D+03,0.174D+03,0.510D+02,0.19292000D+01,0.00000000D+00
     .,0.47798250D+03,0.174D+03,0.520D+02,0.19292000D+01,0.00000000D+00
     .,0.43109430D+03,0.174D+03,0.530D+02,0.19292000D+01,0.00000000D+00
     .,0.38674400D+03,0.174D+03,0.540D+02,0.19292000D+01,0.00000000D+00
     .,0.17264733D+04,0.174D+03,0.550D+02,0.19292000D+01,0.00000000D+00
     .,0.15612112D+04,0.174D+03,0.560D+02,0.19292000D+01,0.00000000D+00
     .,0.13624276D+04,0.174D+03,0.570D+02,0.19292000D+01,0.00000000D+00
     .,0.61099070D+03,0.174D+03,0.580D+02,0.19292000D+01,0.27991000D+01
     .,0.13802768D+04,0.174D+03,0.590D+02,0.19292000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  65501:  65600)=(/
     . 0.13236943D+04,0.174D+03,0.600D+02,0.19292000D+01,0.00000000D+00
     .,0.12900298D+04,0.174D+03,0.610D+02,0.19292000D+01,0.00000000D+00
     .,0.12591135D+04,0.174D+03,0.620D+02,0.19292000D+01,0.00000000D+00
     .,0.12316839D+04,0.174D+03,0.630D+02,0.19292000D+01,0.00000000D+00
     .,0.96239750D+03,0.174D+03,0.640D+02,0.19292000D+01,0.00000000D+00
     .,0.10962341D+04,0.174D+03,0.650D+02,0.19292000D+01,0.00000000D+00
     .,0.10560748D+04,0.174D+03,0.660D+02,0.19292000D+01,0.00000000D+00
     .,0.11088832D+04,0.174D+03,0.670D+02,0.19292000D+01,0.00000000D+00
     .,0.10850974D+04,0.174D+03,0.680D+02,0.19292000D+01,0.00000000D+00
     .,0.10635675D+04,0.174D+03,0.690D+02,0.19292000D+01,0.00000000D+00
     .,0.10513822D+04,0.174D+03,0.700D+02,0.19292000D+01,0.00000000D+00
     .,0.88206880D+03,0.174D+03,0.710D+02,0.19292000D+01,0.00000000D+00
     .,0.86187340D+03,0.174D+03,0.720D+02,0.19292000D+01,0.00000000D+00
     .,0.78390750D+03,0.174D+03,0.730D+02,0.19292000D+01,0.00000000D+00
     .,0.66076360D+03,0.174D+03,0.740D+02,0.19292000D+01,0.00000000D+00
     .,0.67117640D+03,0.174D+03,0.750D+02,0.19292000D+01,0.00000000D+00
     .,0.60666990D+03,0.174D+03,0.760D+02,0.19292000D+01,0.00000000D+00
     .,0.55447220D+03,0.174D+03,0.770D+02,0.19292000D+01,0.00000000D+00
     .,0.45992100D+03,0.174D+03,0.780D+02,0.19292000D+01,0.00000000D+00
     .,0.42942760D+03,0.174D+03,0.790D+02,0.19292000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  65601:  65700)=(/
     . 0.44112500D+03,0.174D+03,0.800D+02,0.19292000D+01,0.00000000D+00
     .,0.65021480D+03,0.174D+03,0.810D+02,0.19292000D+01,0.00000000D+00
     .,0.63255270D+03,0.174D+03,0.820D+02,0.19292000D+01,0.00000000D+00
     .,0.57855330D+03,0.174D+03,0.830D+02,0.19292000D+01,0.00000000D+00
     .,0.55048090D+03,0.174D+03,0.840D+02,0.19292000D+01,0.00000000D+00
     .,0.50671990D+03,0.174D+03,0.850D+02,0.19292000D+01,0.00000000D+00
     .,0.46345510D+03,0.174D+03,0.860D+02,0.19292000D+01,0.00000000D+00
     .,0.16209287D+04,0.174D+03,0.870D+02,0.19292000D+01,0.00000000D+00
     .,0.15387012D+04,0.174D+03,0.880D+02,0.19292000D+01,0.00000000D+00
     .,0.13515716D+04,0.174D+03,0.890D+02,0.19292000D+01,0.00000000D+00
     .,0.12069993D+04,0.174D+03,0.900D+02,0.19292000D+01,0.00000000D+00
     .,0.12026346D+04,0.174D+03,0.910D+02,0.19292000D+01,0.00000000D+00
     .,0.11642737D+04,0.174D+03,0.920D+02,0.19292000D+01,0.00000000D+00
     .,0.12034096D+04,0.174D+03,0.930D+02,0.19292000D+01,0.00000000D+00
     .,0.11644393D+04,0.174D+03,0.940D+02,0.19292000D+01,0.00000000D+00
     .,0.63655000D+02,0.174D+03,0.101D+03,0.19292000D+01,0.00000000D+00
     .,0.20943010D+03,0.174D+03,0.103D+03,0.19292000D+01,0.98650000D+00
     .,0.26676230D+03,0.174D+03,0.104D+03,0.19292000D+01,0.98080000D+00
     .,0.20180580D+03,0.174D+03,0.105D+03,0.19292000D+01,0.97060000D+00
     .,0.15143990D+03,0.174D+03,0.106D+03,0.19292000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  65701:  65800)=(/
     . 0.10487960D+03,0.174D+03,0.107D+03,0.19292000D+01,0.99440000D+00
     .,0.76174700D+02,0.174D+03,0.108D+03,0.19292000D+01,0.99250000D+00
     .,0.52233500D+02,0.174D+03,0.109D+03,0.19292000D+01,0.99820000D+00
     .,0.30698940D+03,0.174D+03,0.111D+03,0.19292000D+01,0.96840000D+00
     .,0.47538840D+03,0.174D+03,0.112D+03,0.19292000D+01,0.96280000D+00
     .,0.47855460D+03,0.174D+03,0.113D+03,0.19292000D+01,0.96480000D+00
     .,0.38166000D+03,0.174D+03,0.114D+03,0.19292000D+01,0.95070000D+00
     .,0.31107370D+03,0.174D+03,0.115D+03,0.19292000D+01,0.99470000D+00
     .,0.26232930D+03,0.174D+03,0.116D+03,0.19292000D+01,0.99480000D+00
     .,0.21388550D+03,0.174D+03,0.117D+03,0.19292000D+01,0.99720000D+00
     .,0.42224100D+03,0.174D+03,0.119D+03,0.19292000D+01,0.97670000D+00
     .,0.82019820D+03,0.174D+03,0.120D+03,0.19292000D+01,0.98310000D+00
     .,0.41903830D+03,0.174D+03,0.121D+03,0.19292000D+01,0.18627000D+01
     .,0.40459180D+03,0.174D+03,0.122D+03,0.19292000D+01,0.18299000D+01
     .,0.39656360D+03,0.174D+03,0.123D+03,0.19292000D+01,0.19138000D+01
     .,0.39324210D+03,0.174D+03,0.124D+03,0.19292000D+01,0.18269000D+01
     .,0.36030430D+03,0.174D+03,0.125D+03,0.19292000D+01,0.16406000D+01
     .,0.33316370D+03,0.174D+03,0.126D+03,0.19292000D+01,0.16483000D+01
     .,0.31788470D+03,0.174D+03,0.127D+03,0.19292000D+01,0.17149000D+01
     .,0.31087480D+03,0.174D+03,0.128D+03,0.19292000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters(  65801:  65900)=(/
     . 0.30807170D+03,0.174D+03,0.129D+03,0.19292000D+01,0.95760000D+00
     .,0.28748760D+03,0.174D+03,0.130D+03,0.19292000D+01,0.19419000D+01
     .,0.47409680D+03,0.174D+03,0.131D+03,0.19292000D+01,0.96010000D+00
     .,0.41391720D+03,0.174D+03,0.132D+03,0.19292000D+01,0.94340000D+00
     .,0.36953950D+03,0.174D+03,0.133D+03,0.19292000D+01,0.98890000D+00
     .,0.33667770D+03,0.174D+03,0.134D+03,0.19292000D+01,0.99010000D+00
     .,0.29588320D+03,0.174D+03,0.135D+03,0.19292000D+01,0.99740000D+00
     .,0.50328860D+03,0.174D+03,0.137D+03,0.19292000D+01,0.97380000D+00
     .,0.99960180D+03,0.174D+03,0.138D+03,0.19292000D+01,0.98010000D+00
     .,0.75469660D+03,0.174D+03,0.139D+03,0.19292000D+01,0.19153000D+01
     .,0.55497370D+03,0.174D+03,0.140D+03,0.19292000D+01,0.19355000D+01
     .,0.56047340D+03,0.174D+03,0.141D+03,0.19292000D+01,0.19545000D+01
     .,0.52208970D+03,0.174D+03,0.142D+03,0.19292000D+01,0.19420000D+01
     .,0.58893300D+03,0.174D+03,0.143D+03,0.19292000D+01,0.16682000D+01
     .,0.45342630D+03,0.174D+03,0.144D+03,0.19292000D+01,0.18584000D+01
     .,0.42417090D+03,0.174D+03,0.145D+03,0.19292000D+01,0.19003000D+01
     .,0.39371240D+03,0.174D+03,0.146D+03,0.19292000D+01,0.18630000D+01
     .,0.38104950D+03,0.174D+03,0.147D+03,0.19292000D+01,0.96790000D+00
     .,0.37575480D+03,0.174D+03,0.148D+03,0.19292000D+01,0.19539000D+01
     .,0.60266490D+03,0.174D+03,0.149D+03,0.19292000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters(  65901:  66000)=(/
     . 0.54210550D+03,0.174D+03,0.150D+03,0.19292000D+01,0.95140000D+00
     .,0.50590030D+03,0.174D+03,0.151D+03,0.19292000D+01,0.97490000D+00
     .,0.47755630D+03,0.174D+03,0.152D+03,0.19292000D+01,0.98110000D+00
     .,0.43515150D+03,0.174D+03,0.153D+03,0.19292000D+01,0.99680000D+00
     .,0.59256180D+03,0.174D+03,0.155D+03,0.19292000D+01,0.99090000D+00
     .,0.13007753D+04,0.174D+03,0.156D+03,0.19292000D+01,0.97970000D+00
     .,0.95659970D+03,0.174D+03,0.157D+03,0.19292000D+01,0.19373000D+01
     .,0.59241900D+03,0.174D+03,0.159D+03,0.19292000D+01,0.29425000D+01
     .,0.58013530D+03,0.174D+03,0.160D+03,0.19292000D+01,0.29455000D+01
     .,0.56163190D+03,0.174D+03,0.161D+03,0.19292000D+01,0.29413000D+01
     .,0.56485240D+03,0.174D+03,0.162D+03,0.19292000D+01,0.29300000D+01
     .,0.54591020D+03,0.174D+03,0.163D+03,0.19292000D+01,0.18286000D+01
     .,0.56845330D+03,0.174D+03,0.164D+03,0.19292000D+01,0.28732000D+01
     .,0.53359460D+03,0.174D+03,0.165D+03,0.19292000D+01,0.29086000D+01
     .,0.54379510D+03,0.174D+03,0.166D+03,0.19292000D+01,0.28965000D+01
     .,0.50613240D+03,0.174D+03,0.167D+03,0.19292000D+01,0.29242000D+01
     .,0.49159050D+03,0.174D+03,0.168D+03,0.19292000D+01,0.29282000D+01
     .,0.48851540D+03,0.174D+03,0.169D+03,0.19292000D+01,0.29246000D+01
     .,0.51389840D+03,0.174D+03,0.170D+03,0.19292000D+01,0.28482000D+01
     .,0.47198590D+03,0.174D+03,0.171D+03,0.19292000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters(  66001:  66100)=(/
     . 0.64582280D+03,0.174D+03,0.172D+03,0.19292000D+01,0.19254000D+01
     .,0.59747460D+03,0.174D+03,0.173D+03,0.19292000D+01,0.19459000D+01
     .,0.54340360D+03,0.174D+03,0.174D+03,0.19292000D+01,0.19292000D+01
     .,0.39390200D+02,0.175D+03,0.100D+01,0.18104000D+01,0.91180000D+00
     .,0.25661400D+02,0.175D+03,0.200D+01,0.18104000D+01,0.00000000D+00
     .,0.67790210D+03,0.175D+03,0.300D+01,0.18104000D+01,0.00000000D+00
     .,0.37113480D+03,0.175D+03,0.400D+01,0.18104000D+01,0.00000000D+00
     .,0.24394890D+03,0.175D+03,0.500D+01,0.18104000D+01,0.00000000D+00
     .,0.16225790D+03,0.175D+03,0.600D+01,0.18104000D+01,0.00000000D+00
     .,0.11232650D+03,0.175D+03,0.700D+01,0.18104000D+01,0.00000000D+00
     .,0.84509400D+02,0.175D+03,0.800D+01,0.18104000D+01,0.00000000D+00
     .,0.63709900D+02,0.175D+03,0.900D+01,0.18104000D+01,0.00000000D+00
     .,0.48832900D+02,0.175D+03,0.100D+02,0.18104000D+01,0.00000000D+00
     .,0.80810000D+03,0.175D+03,0.110D+02,0.18104000D+01,0.00000000D+00
     .,0.59653470D+03,0.175D+03,0.120D+02,0.18104000D+01,0.00000000D+00
     .,0.54254110D+03,0.175D+03,0.130D+02,0.18104000D+01,0.00000000D+00
     .,0.42013030D+03,0.175D+03,0.140D+02,0.18104000D+01,0.00000000D+00
     .,0.32333970D+03,0.175D+03,0.150D+02,0.18104000D+01,0.00000000D+00
     .,0.26632530D+03,0.175D+03,0.160D+02,0.18104000D+01,0.00000000D+00
     .,0.21607690D+03,0.175D+03,0.170D+02,0.18104000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  66101:  66200)=(/
     . 0.17582140D+03,0.175D+03,0.180D+02,0.18104000D+01,0.00000000D+00
     .,0.13393807D+04,0.175D+03,0.190D+02,0.18104000D+01,0.00000000D+00
     .,0.10664078D+04,0.175D+03,0.200D+02,0.18104000D+01,0.00000000D+00
     .,0.87454390D+03,0.175D+03,0.210D+02,0.18104000D+01,0.00000000D+00
     .,0.83959150D+03,0.175D+03,0.220D+02,0.18104000D+01,0.00000000D+00
     .,0.76607010D+03,0.175D+03,0.230D+02,0.18104000D+01,0.00000000D+00
     .,0.60376280D+03,0.175D+03,0.240D+02,0.18104000D+01,0.00000000D+00
     .,0.65618380D+03,0.175D+03,0.250D+02,0.18104000D+01,0.00000000D+00
     .,0.51491990D+03,0.175D+03,0.260D+02,0.18104000D+01,0.00000000D+00
     .,0.54109810D+03,0.175D+03,0.270D+02,0.18104000D+01,0.00000000D+00
     .,0.55933980D+03,0.175D+03,0.280D+02,0.18104000D+01,0.00000000D+00
     .,0.42928690D+03,0.175D+03,0.290D+02,0.18104000D+01,0.00000000D+00
     .,0.43539440D+03,0.175D+03,0.300D+02,0.18104000D+01,0.00000000D+00
     .,0.51743050D+03,0.175D+03,0.310D+02,0.18104000D+01,0.00000000D+00
     .,0.45007850D+03,0.175D+03,0.320D+02,0.18104000D+01,0.00000000D+00
     .,0.37961010D+03,0.175D+03,0.330D+02,0.18104000D+01,0.00000000D+00
     .,0.33848080D+03,0.175D+03,0.340D+02,0.18104000D+01,0.00000000D+00
     .,0.29439730D+03,0.175D+03,0.350D+02,0.18104000D+01,0.00000000D+00
     .,0.25467830D+03,0.175D+03,0.360D+02,0.18104000D+01,0.00000000D+00
     .,0.14977174D+04,0.175D+03,0.370D+02,0.18104000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  66201:  66300)=(/
     . 0.12728662D+04,0.175D+03,0.380D+02,0.18104000D+01,0.00000000D+00
     .,0.11011436D+04,0.175D+03,0.390D+02,0.18104000D+01,0.00000000D+00
     .,0.98233900D+03,0.175D+03,0.400D+02,0.18104000D+01,0.00000000D+00
     .,0.89165750D+03,0.175D+03,0.410D+02,0.18104000D+01,0.00000000D+00
     .,0.68333990D+03,0.175D+03,0.420D+02,0.18104000D+01,0.00000000D+00
     .,0.76450150D+03,0.175D+03,0.430D+02,0.18104000D+01,0.00000000D+00
     .,0.57773560D+03,0.175D+03,0.440D+02,0.18104000D+01,0.00000000D+00
     .,0.63093880D+03,0.175D+03,0.450D+02,0.18104000D+01,0.00000000D+00
     .,0.58342570D+03,0.175D+03,0.460D+02,0.18104000D+01,0.00000000D+00
     .,0.48800010D+03,0.175D+03,0.470D+02,0.18104000D+01,0.00000000D+00
     .,0.51225330D+03,0.175D+03,0.480D+02,0.18104000D+01,0.00000000D+00
     .,0.64862950D+03,0.175D+03,0.490D+02,0.18104000D+01,0.00000000D+00
     .,0.59271140D+03,0.175D+03,0.500D+02,0.18104000D+01,0.00000000D+00
     .,0.52269700D+03,0.175D+03,0.510D+02,0.18104000D+01,0.00000000D+00
     .,0.48212230D+03,0.175D+03,0.520D+02,0.18104000D+01,0.00000000D+00
     .,0.43331830D+03,0.175D+03,0.530D+02,0.18104000D+01,0.00000000D+00
     .,0.38749410D+03,0.175D+03,0.540D+02,0.18104000D+01,0.00000000D+00
     .,0.18253618D+04,0.175D+03,0.550D+02,0.18104000D+01,0.00000000D+00
     .,0.16308213D+04,0.175D+03,0.560D+02,0.18104000D+01,0.00000000D+00
     .,0.14145400D+04,0.175D+03,0.570D+02,0.18104000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  66301:  66400)=(/
     . 0.61899030D+03,0.175D+03,0.580D+02,0.18104000D+01,0.27991000D+01
     .,0.14389986D+04,0.175D+03,0.590D+02,0.18104000D+01,0.00000000D+00
     .,0.13785166D+04,0.175D+03,0.600D+02,0.18104000D+01,0.00000000D+00
     .,0.13430628D+04,0.175D+03,0.610D+02,0.18104000D+01,0.00000000D+00
     .,0.13105457D+04,0.175D+03,0.620D+02,0.18104000D+01,0.00000000D+00
     .,0.12816825D+04,0.175D+03,0.630D+02,0.18104000D+01,0.00000000D+00
     .,0.99495010D+03,0.175D+03,0.640D+02,0.18104000D+01,0.00000000D+00
     .,0.11448282D+04,0.175D+03,0.650D+02,0.18104000D+01,0.00000000D+00
     .,0.11017061D+04,0.175D+03,0.660D+02,0.18104000D+01,0.00000000D+00
     .,0.11520955D+04,0.175D+03,0.670D+02,0.18104000D+01,0.00000000D+00
     .,0.11271846D+04,0.175D+03,0.680D+02,0.18104000D+01,0.00000000D+00
     .,0.11045493D+04,0.175D+03,0.690D+02,0.18104000D+01,0.00000000D+00
     .,0.10921865D+04,0.175D+03,0.700D+02,0.18104000D+01,0.00000000D+00
     .,0.91229470D+03,0.175D+03,0.710D+02,0.18104000D+01,0.00000000D+00
     .,0.88587570D+03,0.175D+03,0.720D+02,0.18104000D+01,0.00000000D+00
     .,0.80282330D+03,0.175D+03,0.730D+02,0.18104000D+01,0.00000000D+00
     .,0.67490990D+03,0.175D+03,0.740D+02,0.18104000D+01,0.00000000D+00
     .,0.68456550D+03,0.175D+03,0.750D+02,0.18104000D+01,0.00000000D+00
     .,0.61687960D+03,0.175D+03,0.760D+02,0.18104000D+01,0.00000000D+00
     .,0.56243030D+03,0.175D+03,0.770D+02,0.18104000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  66401:  66500)=(/
     . 0.46538980D+03,0.175D+03,0.780D+02,0.18104000D+01,0.00000000D+00
     .,0.43411300D+03,0.175D+03,0.790D+02,0.18104000D+01,0.00000000D+00
     .,0.44539470D+03,0.175D+03,0.800D+02,0.18104000D+01,0.00000000D+00
     .,0.66487270D+03,0.175D+03,0.810D+02,0.18104000D+01,0.00000000D+00
     .,0.64374060D+03,0.175D+03,0.820D+02,0.18104000D+01,0.00000000D+00
     .,0.58578780D+03,0.175D+03,0.830D+02,0.18104000D+01,0.00000000D+00
     .,0.55576230D+03,0.175D+03,0.840D+02,0.18104000D+01,0.00000000D+00
     .,0.50986150D+03,0.175D+03,0.850D+02,0.18104000D+01,0.00000000D+00
     .,0.46493840D+03,0.175D+03,0.860D+02,0.18104000D+01,0.00000000D+00
     .,0.17053318D+04,0.175D+03,0.870D+02,0.18104000D+01,0.00000000D+00
     .,0.16022866D+04,0.175D+03,0.880D+02,0.18104000D+01,0.00000000D+00
     .,0.13995346D+04,0.175D+03,0.890D+02,0.18104000D+01,0.00000000D+00
     .,0.12420205D+04,0.175D+03,0.900D+02,0.18104000D+01,0.00000000D+00
     .,0.12414957D+04,0.175D+03,0.910D+02,0.18104000D+01,0.00000000D+00
     .,0.12016927D+04,0.175D+03,0.920D+02,0.18104000D+01,0.00000000D+00
     .,0.12468949D+04,0.175D+03,0.930D+02,0.18104000D+01,0.00000000D+00
     .,0.12056353D+04,0.175D+03,0.940D+02,0.18104000D+01,0.00000000D+00
     .,0.64164300D+02,0.175D+03,0.101D+03,0.18104000D+01,0.00000000D+00
     .,0.21507820D+03,0.175D+03,0.103D+03,0.18104000D+01,0.98650000D+00
     .,0.27332730D+03,0.175D+03,0.104D+03,0.18104000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters(  66501:  66600)=(/
     . 0.20434870D+03,0.175D+03,0.105D+03,0.18104000D+01,0.97060000D+00
     .,0.15235770D+03,0.175D+03,0.106D+03,0.18104000D+01,0.98680000D+00
     .,0.10479180D+03,0.175D+03,0.107D+03,0.18104000D+01,0.99440000D+00
     .,0.75702000D+02,0.175D+03,0.108D+03,0.18104000D+01,0.99250000D+00
     .,0.51588100D+02,0.175D+03,0.109D+03,0.18104000D+01,0.99820000D+00
     .,0.31607860D+03,0.175D+03,0.111D+03,0.18104000D+01,0.96840000D+00
     .,0.49005630D+03,0.175D+03,0.112D+03,0.18104000D+01,0.96280000D+00
     .,0.49022120D+03,0.175D+03,0.113D+03,0.18104000D+01,0.96480000D+00
     .,0.38746930D+03,0.175D+03,0.114D+03,0.18104000D+01,0.95070000D+00
     .,0.31376610D+03,0.175D+03,0.115D+03,0.18104000D+01,0.99470000D+00
     .,0.26346580D+03,0.175D+03,0.116D+03,0.18104000D+01,0.99480000D+00
     .,0.21388020D+03,0.175D+03,0.117D+03,0.18104000D+01,0.99720000D+00
     .,0.43270980D+03,0.175D+03,0.119D+03,0.18104000D+01,0.97670000D+00
     .,0.85443090D+03,0.175D+03,0.120D+03,0.18104000D+01,0.98310000D+00
     .,0.42613390D+03,0.175D+03,0.121D+03,0.18104000D+01,0.18627000D+01
     .,0.41139560D+03,0.175D+03,0.122D+03,0.18104000D+01,0.18299000D+01
     .,0.40328980D+03,0.175D+03,0.123D+03,0.18104000D+01,0.19138000D+01
     .,0.40028790D+03,0.175D+03,0.124D+03,0.18104000D+01,0.18269000D+01
     .,0.36513690D+03,0.175D+03,0.125D+03,0.18104000D+01,0.16406000D+01
     .,0.33722470D+03,0.175D+03,0.126D+03,0.18104000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters(  66601:  66700)=(/
     . 0.32177920D+03,0.175D+03,0.127D+03,0.18104000D+01,0.17149000D+01
     .,0.31479940D+03,0.175D+03,0.128D+03,0.18104000D+01,0.17937000D+01
     .,0.31300420D+03,0.175D+03,0.129D+03,0.18104000D+01,0.95760000D+00
     .,0.29033450D+03,0.175D+03,0.130D+03,0.18104000D+01,0.19419000D+01
     .,0.48428840D+03,0.175D+03,0.131D+03,0.18104000D+01,0.96010000D+00
     .,0.41985020D+03,0.175D+03,0.132D+03,0.18104000D+01,0.94340000D+00
     .,0.37295910D+03,0.175D+03,0.133D+03,0.18104000D+01,0.98890000D+00
     .,0.33865860D+03,0.175D+03,0.134D+03,0.18104000D+01,0.99010000D+00
     .,0.29654870D+03,0.175D+03,0.135D+03,0.18104000D+01,0.99740000D+00
     .,0.51497470D+03,0.175D+03,0.137D+03,0.18104000D+01,0.97380000D+00
     .,0.10423341D+04,0.175D+03,0.138D+03,0.18104000D+01,0.98010000D+00
     .,0.77762370D+03,0.175D+03,0.139D+03,0.18104000D+01,0.19153000D+01
     .,0.56481820D+03,0.175D+03,0.140D+03,0.18104000D+01,0.19355000D+01
     .,0.57045940D+03,0.175D+03,0.141D+03,0.18104000D+01,0.19545000D+01
     .,0.53064150D+03,0.175D+03,0.142D+03,0.18104000D+01,0.19420000D+01
     .,0.60213570D+03,0.175D+03,0.143D+03,0.18104000D+01,0.16682000D+01
     .,0.45894910D+03,0.175D+03,0.144D+03,0.18104000D+01,0.18584000D+01
     .,0.42920470D+03,0.175D+03,0.145D+03,0.18104000D+01,0.19003000D+01
     .,0.39810440D+03,0.175D+03,0.146D+03,0.18104000D+01,0.18630000D+01
     .,0.38554200D+03,0.175D+03,0.147D+03,0.18104000D+01,0.96790000D+00
     ./)
      grimme_c6_parameters(  66701:  66800)=(/
     . 0.37894250D+03,0.175D+03,0.148D+03,0.18104000D+01,0.19539000D+01
     .,0.61575540D+03,0.175D+03,0.149D+03,0.18104000D+01,0.96330000D+00
     .,0.55049820D+03,0.175D+03,0.150D+03,0.18104000D+01,0.95140000D+00
     .,0.51159560D+03,0.175D+03,0.151D+03,0.18104000D+01,0.97490000D+00
     .,0.48159190D+03,0.175D+03,0.152D+03,0.18104000D+01,0.98110000D+00
     .,0.43741870D+03,0.175D+03,0.153D+03,0.18104000D+01,0.99680000D+00
     .,0.60346930D+03,0.175D+03,0.155D+03,0.18104000D+01,0.99090000D+00
     .,0.13601123D+04,0.175D+03,0.156D+03,0.18104000D+01,0.97970000D+00
     .,0.98679870D+03,0.175D+03,0.157D+03,0.18104000D+01,0.19373000D+01
     .,0.59998280D+03,0.175D+03,0.159D+03,0.18104000D+01,0.29425000D+01
     .,0.58750600D+03,0.175D+03,0.160D+03,0.18104000D+01,0.29455000D+01
     .,0.56861140D+03,0.175D+03,0.161D+03,0.18104000D+01,0.29413000D+01
     .,0.57238360D+03,0.175D+03,0.162D+03,0.18104000D+01,0.29300000D+01
     .,0.55475530D+03,0.175D+03,0.163D+03,0.18104000D+01,0.18286000D+01
     .,0.57615700D+03,0.175D+03,0.164D+03,0.18104000D+01,0.28732000D+01
     .,0.54043300D+03,0.175D+03,0.165D+03,0.18104000D+01,0.29086000D+01
     .,0.55166610D+03,0.175D+03,0.166D+03,0.18104000D+01,0.28965000D+01
     .,0.51223480D+03,0.175D+03,0.167D+03,0.18104000D+01,0.29242000D+01
     .,0.49737970D+03,0.175D+03,0.168D+03,0.18104000D+01,0.29282000D+01
     .,0.49437500D+03,0.175D+03,0.169D+03,0.18104000D+01,0.29246000D+01
     ./)
      grimme_c6_parameters(  66801:  66900)=(/
     . 0.52066780D+03,0.175D+03,0.170D+03,0.18104000D+01,0.28482000D+01
     .,0.47743820D+03,0.175D+03,0.171D+03,0.18104000D+01,0.29219000D+01
     .,0.66008460D+03,0.175D+03,0.172D+03,0.18104000D+01,0.19254000D+01
     .,0.60852880D+03,0.175D+03,0.173D+03,0.18104000D+01,0.19459000D+01
     .,0.55146290D+03,0.175D+03,0.174D+03,0.18104000D+01,0.19292000D+01
     .,0.56143380D+03,0.175D+03,0.175D+03,0.18104000D+01,0.18104000D+01
     .,0.35464600D+02,0.176D+03,0.100D+01,0.18858000D+01,0.91180000D+00
     .,0.23812500D+02,0.176D+03,0.200D+01,0.18858000D+01,0.00000000D+00
     .,0.53066030D+03,0.176D+03,0.300D+01,0.18858000D+01,0.00000000D+00
     .,0.31052240D+03,0.176D+03,0.400D+01,0.18858000D+01,0.00000000D+00
     .,0.21141050D+03,0.176D+03,0.500D+01,0.18858000D+01,0.00000000D+00
     .,0.14424940D+03,0.176D+03,0.600D+01,0.18858000D+01,0.00000000D+00
     .,0.10174200D+03,0.176D+03,0.700D+01,0.18858000D+01,0.00000000D+00
     .,0.77553600D+02,0.176D+03,0.800D+01,0.18858000D+01,0.00000000D+00
     .,0.59120400D+02,0.176D+03,0.900D+01,0.18858000D+01,0.00000000D+00
     .,0.45720500D+02,0.176D+03,0.100D+02,0.18858000D+01,0.00000000D+00
     .,0.63530720D+03,0.176D+03,0.110D+02,0.18858000D+01,0.00000000D+00
     .,0.49355920D+03,0.176D+03,0.120D+02,0.18858000D+01,0.00000000D+00
     .,0.45721240D+03,0.176D+03,0.130D+02,0.18858000D+01,0.00000000D+00
     .,0.36283630D+03,0.176D+03,0.140D+02,0.18858000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  66901:  67000)=(/
     . 0.28491700D+03,0.176D+03,0.150D+02,0.18858000D+01,0.00000000D+00
     .,0.23770450D+03,0.176D+03,0.160D+02,0.18858000D+01,0.00000000D+00
     .,0.19521900D+03,0.176D+03,0.170D+02,0.18858000D+01,0.00000000D+00
     .,0.16053010D+03,0.176D+03,0.180D+02,0.18858000D+01,0.00000000D+00
     .,0.10420654D+04,0.176D+03,0.190D+02,0.18858000D+01,0.00000000D+00
     .,0.86452710D+03,0.176D+03,0.200D+02,0.18858000D+01,0.00000000D+00
     .,0.71543320D+03,0.176D+03,0.210D+02,0.18858000D+01,0.00000000D+00
     .,0.69243390D+03,0.176D+03,0.220D+02,0.18858000D+01,0.00000000D+00
     .,0.63488380D+03,0.176D+03,0.230D+02,0.18858000D+01,0.00000000D+00
     .,0.50093670D+03,0.176D+03,0.240D+02,0.18858000D+01,0.00000000D+00
     .,0.54765220D+03,0.176D+03,0.250D+02,0.18858000D+01,0.00000000D+00
     .,0.43064570D+03,0.176D+03,0.260D+02,0.18858000D+01,0.00000000D+00
     .,0.45696500D+03,0.176D+03,0.270D+02,0.18858000D+01,0.00000000D+00
     .,0.47005570D+03,0.176D+03,0.280D+02,0.18858000D+01,0.00000000D+00
     .,0.36110090D+03,0.176D+03,0.290D+02,0.18858000D+01,0.00000000D+00
     .,0.37162530D+03,0.176D+03,0.300D+02,0.18858000D+01,0.00000000D+00
     .,0.43932630D+03,0.176D+03,0.310D+02,0.18858000D+01,0.00000000D+00
     .,0.38941390D+03,0.176D+03,0.320D+02,0.18858000D+01,0.00000000D+00
     .,0.33396020D+03,0.176D+03,0.330D+02,0.18858000D+01,0.00000000D+00
     .,0.30083180D+03,0.176D+03,0.340D+02,0.18858000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67001:  67100)=(/
     . 0.26438450D+03,0.176D+03,0.350D+02,0.18858000D+01,0.00000000D+00
     .,0.23089140D+03,0.176D+03,0.360D+02,0.18858000D+01,0.00000000D+00
     .,0.11693798D+04,0.176D+03,0.370D+02,0.18858000D+01,0.00000000D+00
     .,0.10303644D+04,0.176D+03,0.380D+02,0.18858000D+01,0.00000000D+00
     .,0.90555540D+03,0.176D+03,0.390D+02,0.18858000D+01,0.00000000D+00
     .,0.81580510D+03,0.176D+03,0.400D+02,0.18858000D+01,0.00000000D+00
     .,0.74526460D+03,0.176D+03,0.410D+02,0.18858000D+01,0.00000000D+00
     .,0.57758390D+03,0.176D+03,0.420D+02,0.18858000D+01,0.00000000D+00
     .,0.64348640D+03,0.176D+03,0.430D+02,0.18858000D+01,0.00000000D+00
     .,0.49230820D+03,0.176D+03,0.440D+02,0.18858000D+01,0.00000000D+00
     .,0.53754740D+03,0.176D+03,0.450D+02,0.18858000D+01,0.00000000D+00
     .,0.49907810D+03,0.176D+03,0.460D+02,0.18858000D+01,0.00000000D+00
     .,0.41664440D+03,0.176D+03,0.470D+02,0.18858000D+01,0.00000000D+00
     .,0.44047370D+03,0.176D+03,0.480D+02,0.18858000D+01,0.00000000D+00
     .,0.55060050D+03,0.176D+03,0.490D+02,0.18858000D+01,0.00000000D+00
     .,0.51094940D+03,0.176D+03,0.500D+02,0.18858000D+01,0.00000000D+00
     .,0.45728590D+03,0.176D+03,0.510D+02,0.18858000D+01,0.00000000D+00
     .,0.42551160D+03,0.176D+03,0.520D+02,0.18858000D+01,0.00000000D+00
     .,0.38604100D+03,0.176D+03,0.530D+02,0.18858000D+01,0.00000000D+00
     .,0.34827200D+03,0.176D+03,0.540D+02,0.18858000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67101:  67200)=(/
     . 0.14257528D+04,0.176D+03,0.550D+02,0.18858000D+01,0.00000000D+00
     .,0.13130562D+04,0.176D+03,0.560D+02,0.18858000D+01,0.00000000D+00
     .,0.11570873D+04,0.176D+03,0.570D+02,0.18858000D+01,0.00000000D+00
     .,0.54014830D+03,0.176D+03,0.580D+02,0.18858000D+01,0.27991000D+01
     .,0.11649532D+04,0.176D+03,0.590D+02,0.18858000D+01,0.00000000D+00
     .,0.11189840D+04,0.176D+03,0.600D+02,0.18858000D+01,0.00000000D+00
     .,0.10910275D+04,0.176D+03,0.610D+02,0.18858000D+01,0.00000000D+00
     .,0.10652955D+04,0.176D+03,0.620D+02,0.18858000D+01,0.00000000D+00
     .,0.10424806D+04,0.176D+03,0.630D+02,0.18858000D+01,0.00000000D+00
     .,0.82351360D+03,0.176D+03,0.640D+02,0.18858000D+01,0.00000000D+00
     .,0.92339310D+03,0.176D+03,0.650D+02,0.18858000D+01,0.00000000D+00
     .,0.89129600D+03,0.176D+03,0.660D+02,0.18858000D+01,0.00000000D+00
     .,0.94085810D+03,0.176D+03,0.670D+02,0.18858000D+01,0.00000000D+00
     .,0.92091700D+03,0.176D+03,0.680D+02,0.18858000D+01,0.00000000D+00
     .,0.90298170D+03,0.176D+03,0.690D+02,0.18858000D+01,0.00000000D+00
     .,0.89222740D+03,0.176D+03,0.700D+02,0.18858000D+01,0.00000000D+00
     .,0.75415480D+03,0.176D+03,0.710D+02,0.18858000D+01,0.00000000D+00
     .,0.74392130D+03,0.176D+03,0.720D+02,0.18858000D+01,0.00000000D+00
     .,0.68068180D+03,0.176D+03,0.730D+02,0.18858000D+01,0.00000000D+00
     .,0.57655350D+03,0.176D+03,0.740D+02,0.18858000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67201:  67300)=(/
     . 0.58693470D+03,0.176D+03,0.750D+02,0.18858000D+01,0.00000000D+00
     .,0.53325550D+03,0.176D+03,0.760D+02,0.18858000D+01,0.00000000D+00
     .,0.48940580D+03,0.176D+03,0.770D+02,0.18858000D+01,0.00000000D+00
     .,0.40785710D+03,0.176D+03,0.780D+02,0.18858000D+01,0.00000000D+00
     .,0.38154050D+03,0.176D+03,0.790D+02,0.18858000D+01,0.00000000D+00
     .,0.39259340D+03,0.176D+03,0.800D+02,0.18858000D+01,0.00000000D+00
     .,0.56672940D+03,0.176D+03,0.810D+02,0.18858000D+01,0.00000000D+00
     .,0.55534130D+03,0.176D+03,0.820D+02,0.18858000D+01,0.00000000D+00
     .,0.51207880D+03,0.176D+03,0.830D+02,0.18858000D+01,0.00000000D+00
     .,0.48950850D+03,0.176D+03,0.840D+02,0.18858000D+01,0.00000000D+00
     .,0.45312570D+03,0.176D+03,0.850D+02,0.18858000D+01,0.00000000D+00
     .,0.41656370D+03,0.176D+03,0.860D+02,0.18858000D+01,0.00000000D+00
     .,0.13491716D+04,0.176D+03,0.870D+02,0.18858000D+01,0.00000000D+00
     .,0.13007391D+04,0.176D+03,0.880D+02,0.18858000D+01,0.00000000D+00
     .,0.11529664D+04,0.176D+03,0.890D+02,0.18858000D+01,0.00000000D+00
     .,0.10402935D+04,0.176D+03,0.900D+02,0.18858000D+01,0.00000000D+00
     .,0.10315219D+04,0.176D+03,0.910D+02,0.18858000D+01,0.00000000D+00
     .,0.99893380D+03,0.176D+03,0.920D+02,0.18858000D+01,0.00000000D+00
     .,0.10261425D+04,0.176D+03,0.930D+02,0.18858000D+01,0.00000000D+00
     .,0.99407460D+03,0.176D+03,0.940D+02,0.18858000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67301:  67400)=(/
     . 0.56656700D+02,0.176D+03,0.101D+03,0.18858000D+01,0.00000000D+00
     .,0.18083220D+03,0.176D+03,0.103D+03,0.18858000D+01,0.98650000D+00
     .,0.23124090D+03,0.176D+03,0.104D+03,0.18858000D+01,0.98080000D+00
     .,0.17834690D+03,0.176D+03,0.105D+03,0.18858000D+01,0.97060000D+00
     .,0.13537830D+03,0.176D+03,0.106D+03,0.18858000D+01,0.98680000D+00
     .,0.94961200D+02,0.176D+03,0.107D+03,0.18858000D+01,0.99440000D+00
     .,0.69708000D+02,0.176D+03,0.108D+03,0.18858000D+01,0.99250000D+00
     .,0.48438300D+02,0.176D+03,0.109D+03,0.18858000D+01,0.99820000D+00
     .,0.26414790D+03,0.176D+03,0.111D+03,0.18858000D+01,0.96840000D+00
     .,0.40811310D+03,0.176D+03,0.112D+03,0.18858000D+01,0.96280000D+00
     .,0.41494650D+03,0.176D+03,0.113D+03,0.18858000D+01,0.96480000D+00
     .,0.33578860D+03,0.176D+03,0.114D+03,0.18858000D+01,0.95070000D+00
     .,0.27667050D+03,0.176D+03,0.115D+03,0.18858000D+01,0.99470000D+00
     .,0.23508600D+03,0.176D+03,0.116D+03,0.18858000D+01,0.99480000D+00
     .,0.19319560D+03,0.176D+03,0.117D+03,0.18858000D+01,0.99720000D+00
     .,0.36655110D+03,0.176D+03,0.119D+03,0.18858000D+01,0.97670000D+00
     .,0.69317420D+03,0.176D+03,0.120D+03,0.18858000D+01,0.98310000D+00
     .,0.36802850D+03,0.176D+03,0.121D+03,0.18858000D+01,0.18627000D+01
     .,0.35552300D+03,0.176D+03,0.122D+03,0.18858000D+01,0.18299000D+01
     .,0.34841720D+03,0.176D+03,0.123D+03,0.18858000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  67401:  67500)=(/
     . 0.34501650D+03,0.176D+03,0.124D+03,0.18858000D+01,0.18269000D+01
     .,0.31830430D+03,0.176D+03,0.125D+03,0.18858000D+01,0.16406000D+01
     .,0.29495420D+03,0.176D+03,0.126D+03,0.18858000D+01,0.16483000D+01
     .,0.28145410D+03,0.176D+03,0.127D+03,0.18858000D+01,0.17149000D+01
     .,0.27510220D+03,0.176D+03,0.128D+03,0.18858000D+01,0.17937000D+01
     .,0.27123140D+03,0.176D+03,0.129D+03,0.18858000D+01,0.95760000D+00
     .,0.25547700D+03,0.176D+03,0.130D+03,0.18858000D+01,0.19419000D+01
     .,0.41318390D+03,0.176D+03,0.131D+03,0.18858000D+01,0.96010000D+00
     .,0.36483360D+03,0.176D+03,0.132D+03,0.18858000D+01,0.94340000D+00
     .,0.32842530D+03,0.176D+03,0.133D+03,0.18858000D+01,0.98890000D+00
     .,0.30094220D+03,0.176D+03,0.134D+03,0.18858000D+01,0.99010000D+00
     .,0.26617570D+03,0.176D+03,0.135D+03,0.18858000D+01,0.99740000D+00
     .,0.43809620D+03,0.176D+03,0.137D+03,0.18858000D+01,0.97380000D+00
     .,0.84371770D+03,0.176D+03,0.138D+03,0.18858000D+01,0.98010000D+00
     .,0.64942160D+03,0.176D+03,0.139D+03,0.18858000D+01,0.19153000D+01
     .,0.48694320D+03,0.176D+03,0.140D+03,0.18858000D+01,0.19355000D+01
     .,0.49170440D+03,0.176D+03,0.141D+03,0.18858000D+01,0.19545000D+01
     .,0.45926500D+03,0.176D+03,0.142D+03,0.18858000D+01,0.19420000D+01
     .,0.51329930D+03,0.176D+03,0.143D+03,0.18858000D+01,0.16682000D+01
     .,0.40162410D+03,0.176D+03,0.144D+03,0.18858000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters(  67501:  67600)=(/
     . 0.37601550D+03,0.176D+03,0.145D+03,0.18858000D+01,0.19003000D+01
     .,0.34951790D+03,0.176D+03,0.146D+03,0.18858000D+01,0.18630000D+01
     .,0.33798580D+03,0.176D+03,0.147D+03,0.18858000D+01,0.96790000D+00
     .,0.33491410D+03,0.176D+03,0.148D+03,0.18858000D+01,0.19539000D+01
     .,0.52556660D+03,0.176D+03,0.149D+03,0.18858000D+01,0.96330000D+00
     .,0.47735010D+03,0.176D+03,0.150D+03,0.18858000D+01,0.95140000D+00
     .,0.44845320D+03,0.176D+03,0.151D+03,0.18858000D+01,0.97490000D+00
     .,0.42527250D+03,0.176D+03,0.152D+03,0.18858000D+01,0.98110000D+00
     .,0.38963030D+03,0.176D+03,0.153D+03,0.18858000D+01,0.99680000D+00
     .,0.51948750D+03,0.176D+03,0.155D+03,0.18858000D+01,0.99090000D+00
     .,0.10935492D+04,0.176D+03,0.156D+03,0.18858000D+01,0.97970000D+00
     .,0.82179670D+03,0.176D+03,0.157D+03,0.18858000D+01,0.19373000D+01
     .,0.52402380D+03,0.176D+03,0.159D+03,0.18858000D+01,0.29425000D+01
     .,0.51321590D+03,0.176D+03,0.160D+03,0.18858000D+01,0.29455000D+01
     .,0.49708550D+03,0.176D+03,0.161D+03,0.18858000D+01,0.29413000D+01
     .,0.49923160D+03,0.176D+03,0.162D+03,0.18858000D+01,0.29300000D+01
     .,0.48040280D+03,0.176D+03,0.163D+03,0.18858000D+01,0.18286000D+01
     .,0.50216590D+03,0.176D+03,0.164D+03,0.18858000D+01,0.28732000D+01
     .,0.47197170D+03,0.176D+03,0.165D+03,0.18858000D+01,0.29086000D+01
     .,0.47976830D+03,0.176D+03,0.166D+03,0.18858000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters(  67601:  67700)=(/
     . 0.44820990D+03,0.176D+03,0.167D+03,0.18858000D+01,0.29242000D+01
     .,0.43552800D+03,0.176D+03,0.168D+03,0.18858000D+01,0.29282000D+01
     .,0.43264200D+03,0.176D+03,0.169D+03,0.18858000D+01,0.29246000D+01
     .,0.45417000D+03,0.176D+03,0.170D+03,0.18858000D+01,0.28482000D+01
     .,0.41827710D+03,0.176D+03,0.171D+03,0.18858000D+01,0.29219000D+01
     .,0.56287830D+03,0.176D+03,0.172D+03,0.18858000D+01,0.19254000D+01
     .,0.52375380D+03,0.176D+03,0.173D+03,0.18858000D+01,0.19459000D+01
     .,0.47921590D+03,0.176D+03,0.174D+03,0.18858000D+01,0.19292000D+01
     .,0.48386730D+03,0.176D+03,0.175D+03,0.18858000D+01,0.18104000D+01
     .,0.42619030D+03,0.176D+03,0.176D+03,0.18858000D+01,0.18858000D+01
     .,0.33511700D+02,0.177D+03,0.100D+01,0.18648000D+01,0.91180000D+00
     .,0.22677900D+02,0.177D+03,0.200D+01,0.18648000D+01,0.00000000D+00
     .,0.49147210D+03,0.177D+03,0.300D+01,0.18648000D+01,0.00000000D+00
     .,0.28982980D+03,0.177D+03,0.400D+01,0.18648000D+01,0.00000000D+00
     .,0.19838070D+03,0.177D+03,0.500D+01,0.18648000D+01,0.00000000D+00
     .,0.13600690D+03,0.177D+03,0.600D+01,0.18648000D+01,0.00000000D+00
     .,0.96324300D+02,0.177D+03,0.700D+01,0.18648000D+01,0.00000000D+00
     .,0.73663400D+02,0.177D+03,0.800D+01,0.18648000D+01,0.00000000D+00
     .,0.56326800D+02,0.177D+03,0.900D+01,0.18648000D+01,0.00000000D+00
     .,0.43677300D+02,0.177D+03,0.100D+02,0.18648000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67701:  67800)=(/
     . 0.58883180D+03,0.177D+03,0.110D+02,0.18648000D+01,0.00000000D+00
     .,0.46010610D+03,0.177D+03,0.120D+02,0.18648000D+01,0.00000000D+00
     .,0.42726470D+03,0.177D+03,0.130D+02,0.18648000D+01,0.00000000D+00
     .,0.34027370D+03,0.177D+03,0.140D+02,0.18648000D+01,0.00000000D+00
     .,0.26810830D+03,0.177D+03,0.150D+02,0.18648000D+01,0.00000000D+00
     .,0.22424930D+03,0.177D+03,0.160D+02,0.18648000D+01,0.00000000D+00
     .,0.18465170D+03,0.177D+03,0.170D+02,0.18648000D+01,0.00000000D+00
     .,0.15222030D+03,0.177D+03,0.180D+02,0.18648000D+01,0.00000000D+00
     .,0.96506260D+03,0.177D+03,0.190D+02,0.18648000D+01,0.00000000D+00
     .,0.80438060D+03,0.177D+03,0.200D+02,0.18648000D+01,0.00000000D+00
     .,0.66634240D+03,0.177D+03,0.210D+02,0.18648000D+01,0.00000000D+00
     .,0.64567380D+03,0.177D+03,0.220D+02,0.18648000D+01,0.00000000D+00
     .,0.59240830D+03,0.177D+03,0.230D+02,0.18648000D+01,0.00000000D+00
     .,0.46775860D+03,0.177D+03,0.240D+02,0.18648000D+01,0.00000000D+00
     .,0.51152360D+03,0.177D+03,0.250D+02,0.18648000D+01,0.00000000D+00
     .,0.40259270D+03,0.177D+03,0.260D+02,0.18648000D+01,0.00000000D+00
     .,0.42750640D+03,0.177D+03,0.270D+02,0.18648000D+01,0.00000000D+00
     .,0.43943760D+03,0.177D+03,0.280D+02,0.18648000D+01,0.00000000D+00
     .,0.33788310D+03,0.177D+03,0.290D+02,0.18648000D+01,0.00000000D+00
     .,0.34820520D+03,0.177D+03,0.300D+02,0.18648000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67801:  67900)=(/
     . 0.41118360D+03,0.177D+03,0.310D+02,0.18648000D+01,0.00000000D+00
     .,0.36542010D+03,0.177D+03,0.320D+02,0.18648000D+01,0.00000000D+00
     .,0.31422920D+03,0.177D+03,0.330D+02,0.18648000D+01,0.00000000D+00
     .,0.28359750D+03,0.177D+03,0.340D+02,0.18648000D+01,0.00000000D+00
     .,0.24976170D+03,0.177D+03,0.350D+02,0.18648000D+01,0.00000000D+00
     .,0.21857530D+03,0.177D+03,0.360D+02,0.18648000D+01,0.00000000D+00
     .,0.10836129D+04,0.177D+03,0.370D+02,0.18648000D+01,0.00000000D+00
     .,0.95871100D+03,0.177D+03,0.380D+02,0.18648000D+01,0.00000000D+00
     .,0.84420740D+03,0.177D+03,0.390D+02,0.18648000D+01,0.00000000D+00
     .,0.76153710D+03,0.177D+03,0.400D+02,0.18648000D+01,0.00000000D+00
     .,0.69635620D+03,0.177D+03,0.410D+02,0.18648000D+01,0.00000000D+00
     .,0.54076150D+03,0.177D+03,0.420D+02,0.18648000D+01,0.00000000D+00
     .,0.60199360D+03,0.177D+03,0.430D+02,0.18648000D+01,0.00000000D+00
     .,0.46158650D+03,0.177D+03,0.440D+02,0.18648000D+01,0.00000000D+00
     .,0.50378310D+03,0.177D+03,0.450D+02,0.18648000D+01,0.00000000D+00
     .,0.46803160D+03,0.177D+03,0.460D+02,0.18648000D+01,0.00000000D+00
     .,0.39092010D+03,0.177D+03,0.470D+02,0.18648000D+01,0.00000000D+00
     .,0.41343530D+03,0.177D+03,0.480D+02,0.18648000D+01,0.00000000D+00
     .,0.51570310D+03,0.177D+03,0.490D+02,0.18648000D+01,0.00000000D+00
     .,0.47948370D+03,0.177D+03,0.500D+02,0.18648000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  67901:  68000)=(/
     . 0.43006080D+03,0.177D+03,0.510D+02,0.18648000D+01,0.00000000D+00
     .,0.40076390D+03,0.177D+03,0.520D+02,0.18648000D+01,0.00000000D+00
     .,0.36420700D+03,0.177D+03,0.530D+02,0.18648000D+01,0.00000000D+00
     .,0.32914390D+03,0.177D+03,0.540D+02,0.18648000D+01,0.00000000D+00
     .,0.13211273D+04,0.177D+03,0.550D+02,0.18648000D+01,0.00000000D+00
     .,0.12211564D+04,0.177D+03,0.560D+02,0.18648000D+01,0.00000000D+00
     .,0.10781412D+04,0.177D+03,0.570D+02,0.18648000D+01,0.00000000D+00
     .,0.50792020D+03,0.177D+03,0.580D+02,0.18648000D+01,0.27991000D+01
     .,0.10842087D+04,0.177D+03,0.590D+02,0.18648000D+01,0.00000000D+00
     .,0.10418248D+04,0.177D+03,0.600D+02,0.18648000D+01,0.00000000D+00
     .,0.10158802D+04,0.177D+03,0.610D+02,0.18648000D+01,0.00000000D+00
     .,0.99198570D+03,0.177D+03,0.620D+02,0.18648000D+01,0.00000000D+00
     .,0.97080130D+03,0.177D+03,0.630D+02,0.18648000D+01,0.00000000D+00
     .,0.76877680D+03,0.177D+03,0.640D+02,0.18648000D+01,0.00000000D+00
     .,0.85938870D+03,0.177D+03,0.650D+02,0.18648000D+01,0.00000000D+00
     .,0.82970230D+03,0.177D+03,0.660D+02,0.18648000D+01,0.00000000D+00
     .,0.87655810D+03,0.177D+03,0.670D+02,0.18648000D+01,0.00000000D+00
     .,0.85800850D+03,0.177D+03,0.680D+02,0.18648000D+01,0.00000000D+00
     .,0.84134750D+03,0.177D+03,0.690D+02,0.18648000D+01,0.00000000D+00
     .,0.83123230D+03,0.177D+03,0.700D+02,0.18648000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68001:  68100)=(/
     . 0.70368220D+03,0.177D+03,0.710D+02,0.18648000D+01,0.00000000D+00
     .,0.69544610D+03,0.177D+03,0.720D+02,0.18648000D+01,0.00000000D+00
     .,0.63722330D+03,0.177D+03,0.730D+02,0.18648000D+01,0.00000000D+00
     .,0.54056670D+03,0.177D+03,0.740D+02,0.18648000D+01,0.00000000D+00
     .,0.55051890D+03,0.177D+03,0.750D+02,0.18648000D+01,0.00000000D+00
     .,0.50082420D+03,0.177D+03,0.760D+02,0.18648000D+01,0.00000000D+00
     .,0.46015330D+03,0.177D+03,0.770D+02,0.18648000D+01,0.00000000D+00
     .,0.38410330D+03,0.177D+03,0.780D+02,0.18648000D+01,0.00000000D+00
     .,0.35955540D+03,0.177D+03,0.790D+02,0.18648000D+01,0.00000000D+00
     .,0.37003820D+03,0.177D+03,0.800D+02,0.18648000D+01,0.00000000D+00
     .,0.53143810D+03,0.177D+03,0.810D+02,0.18648000D+01,0.00000000D+00
     .,0.52144650D+03,0.177D+03,0.820D+02,0.18648000D+01,0.00000000D+00
     .,0.48170840D+03,0.177D+03,0.830D+02,0.18648000D+01,0.00000000D+00
     .,0.46101200D+03,0.177D+03,0.840D+02,0.18648000D+01,0.00000000D+00
     .,0.42739750D+03,0.177D+03,0.850D+02,0.18648000D+01,0.00000000D+00
     .,0.39350690D+03,0.177D+03,0.860D+02,0.18648000D+01,0.00000000D+00
     .,0.12524472D+04,0.177D+03,0.870D+02,0.18648000D+01,0.00000000D+00
     .,0.12109999D+04,0.177D+03,0.880D+02,0.18648000D+01,0.00000000D+00
     .,0.10753003D+04,0.177D+03,0.890D+02,0.18648000D+01,0.00000000D+00
     .,0.97245520D+03,0.177D+03,0.900D+02,0.18648000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68101:  68200)=(/
     . 0.96345570D+03,0.177D+03,0.910D+02,0.18648000D+01,0.00000000D+00
     .,0.93311220D+03,0.177D+03,0.920D+02,0.18648000D+01,0.00000000D+00
     .,0.95733480D+03,0.177D+03,0.930D+02,0.18648000D+01,0.00000000D+00
     .,0.92763110D+03,0.177D+03,0.940D+02,0.18648000D+01,0.00000000D+00
     .,0.53325500D+02,0.177D+03,0.101D+03,0.18648000D+01,0.00000000D+00
     .,0.16893310D+03,0.177D+03,0.103D+03,0.18648000D+01,0.98650000D+00
     .,0.21625690D+03,0.177D+03,0.104D+03,0.18648000D+01,0.98080000D+00
     .,0.16758690D+03,0.177D+03,0.105D+03,0.18648000D+01,0.97060000D+00
     .,0.12766650D+03,0.177D+03,0.106D+03,0.18648000D+01,0.98680000D+00
     .,0.89935700D+02,0.177D+03,0.107D+03,0.18648000D+01,0.99440000D+00
     .,0.66274300D+02,0.177D+03,0.108D+03,0.18648000D+01,0.99250000D+00
     .,0.46290900D+02,0.177D+03,0.109D+03,0.18648000D+01,0.99820000D+00
     .,0.24667920D+03,0.177D+03,0.111D+03,0.18648000D+01,0.96840000D+00
     .,0.38086140D+03,0.177D+03,0.112D+03,0.18648000D+01,0.96280000D+00
     .,0.38803830D+03,0.177D+03,0.113D+03,0.18648000D+01,0.96480000D+00
     .,0.31510570D+03,0.177D+03,0.114D+03,0.18648000D+01,0.95070000D+00
     .,0.26039720D+03,0.177D+03,0.115D+03,0.18648000D+01,0.99470000D+00
     .,0.22177880D+03,0.177D+03,0.116D+03,0.18648000D+01,0.99480000D+00
     .,0.18273850D+03,0.177D+03,0.117D+03,0.18648000D+01,0.99720000D+00
     .,0.34334310D+03,0.177D+03,0.119D+03,0.18648000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters(  68201:  68300)=(/
     . 0.64530690D+03,0.177D+03,0.120D+03,0.18648000D+01,0.98310000D+00
     .,0.34546620D+03,0.177D+03,0.121D+03,0.18648000D+01,0.18627000D+01
     .,0.33378450D+03,0.177D+03,0.122D+03,0.18648000D+01,0.18299000D+01
     .,0.32712730D+03,0.177D+03,0.123D+03,0.18648000D+01,0.19138000D+01
     .,0.32385110D+03,0.177D+03,0.124D+03,0.18648000D+01,0.18269000D+01
     .,0.29919940D+03,0.177D+03,0.125D+03,0.18648000D+01,0.16406000D+01
     .,0.27742410D+03,0.177D+03,0.126D+03,0.18648000D+01,0.16483000D+01
     .,0.26476150D+03,0.177D+03,0.127D+03,0.18648000D+01,0.17149000D+01
     .,0.25876330D+03,0.177D+03,0.128D+03,0.18648000D+01,0.17937000D+01
     .,0.25485680D+03,0.177D+03,0.129D+03,0.18648000D+01,0.95760000D+00
     .,0.24052350D+03,0.177D+03,0.130D+03,0.18648000D+01,0.19419000D+01
     .,0.38698910D+03,0.177D+03,0.131D+03,0.18648000D+01,0.96010000D+00
     .,0.34259940D+03,0.177D+03,0.132D+03,0.18648000D+01,0.94340000D+00
     .,0.30908100D+03,0.177D+03,0.133D+03,0.18648000D+01,0.98890000D+00
     .,0.28369920D+03,0.177D+03,0.134D+03,0.18648000D+01,0.99010000D+00
     .,0.25143160D+03,0.177D+03,0.135D+03,0.18648000D+01,0.99740000D+00
     .,0.41068500D+03,0.177D+03,0.137D+03,0.18648000D+01,0.97380000D+00
     .,0.78537910D+03,0.177D+03,0.138D+03,0.18648000D+01,0.98010000D+00
     .,0.60690870D+03,0.177D+03,0.139D+03,0.18648000D+01,0.19153000D+01
     .,0.45710620D+03,0.177D+03,0.140D+03,0.18648000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters(  68301:  68400)=(/
     . 0.46161660D+03,0.177D+03,0.141D+03,0.18648000D+01,0.19545000D+01
     .,0.43145100D+03,0.177D+03,0.142D+03,0.18648000D+01,0.19420000D+01
     .,0.48128810D+03,0.177D+03,0.143D+03,0.18648000D+01,0.16682000D+01
     .,0.37795500D+03,0.177D+03,0.144D+03,0.18648000D+01,0.18584000D+01
     .,0.35398970D+03,0.177D+03,0.145D+03,0.18648000D+01,0.19003000D+01
     .,0.32921750D+03,0.177D+03,0.146D+03,0.18648000D+01,0.18630000D+01
     .,0.31831050D+03,0.177D+03,0.147D+03,0.18648000D+01,0.96790000D+00
     .,0.31569280D+03,0.177D+03,0.148D+03,0.18648000D+01,0.19539000D+01
     .,0.49262420D+03,0.177D+03,0.149D+03,0.18648000D+01,0.96330000D+00
     .,0.44836200D+03,0.177D+03,0.150D+03,0.18648000D+01,0.95140000D+00
     .,0.42188850D+03,0.177D+03,0.151D+03,0.18648000D+01,0.97490000D+00
     .,0.40057160D+03,0.177D+03,0.152D+03,0.18648000D+01,0.98110000D+00
     .,0.36757650D+03,0.177D+03,0.153D+03,0.18648000D+01,0.99680000D+00
     .,0.48764860D+03,0.177D+03,0.155D+03,0.18648000D+01,0.99090000D+00
     .,0.10171183D+04,0.177D+03,0.156D+03,0.18648000D+01,0.97970000D+00
     .,0.76771820D+03,0.177D+03,0.157D+03,0.18648000D+01,0.19373000D+01
     .,0.49283570D+03,0.177D+03,0.159D+03,0.18648000D+01,0.29425000D+01
     .,0.48268880D+03,0.177D+03,0.160D+03,0.18648000D+01,0.29455000D+01
     .,0.46758270D+03,0.177D+03,0.161D+03,0.18648000D+01,0.29413000D+01
     .,0.46943970D+03,0.177D+03,0.162D+03,0.18648000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters(  68401:  68500)=(/
     . 0.45134990D+03,0.177D+03,0.163D+03,0.18648000D+01,0.18286000D+01
     .,0.47210950D+03,0.177D+03,0.164D+03,0.18648000D+01,0.28732000D+01
     .,0.44388260D+03,0.177D+03,0.165D+03,0.18648000D+01,0.29086000D+01
     .,0.45095330D+03,0.177D+03,0.166D+03,0.18648000D+01,0.28965000D+01
     .,0.42164500D+03,0.177D+03,0.167D+03,0.18648000D+01,0.29242000D+01
     .,0.40975870D+03,0.177D+03,0.168D+03,0.18648000D+01,0.29282000D+01
     .,0.40699850D+03,0.177D+03,0.169D+03,0.18648000D+01,0.29246000D+01
     .,0.42696980D+03,0.177D+03,0.170D+03,0.18648000D+01,0.28482000D+01
     .,0.39353520D+03,0.177D+03,0.171D+03,0.18648000D+01,0.29219000D+01
     .,0.52755310D+03,0.177D+03,0.172D+03,0.18648000D+01,0.19254000D+01
     .,0.49159800D+03,0.177D+03,0.173D+03,0.18648000D+01,0.19459000D+01
     .,0.45048000D+03,0.177D+03,0.174D+03,0.18648000D+01,0.19292000D+01
     .,0.45433550D+03,0.177D+03,0.175D+03,0.18648000D+01,0.18104000D+01
     .,0.40148890D+03,0.177D+03,0.176D+03,0.18648000D+01,0.18858000D+01
     .,0.37849390D+03,0.177D+03,0.177D+03,0.18648000D+01,0.18648000D+01
     .,0.32091700D+02,0.178D+03,0.100D+01,0.19188000D+01,0.91180000D+00
     .,0.21833800D+02,0.178D+03,0.200D+01,0.19188000D+01,0.00000000D+00
     .,0.46520110D+03,0.178D+03,0.300D+01,0.19188000D+01,0.00000000D+00
     .,0.27545630D+03,0.178D+03,0.400D+01,0.19188000D+01,0.00000000D+00
     .,0.18914850D+03,0.178D+03,0.500D+01,0.19188000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68501:  68600)=(/
     . 0.13007010D+03,0.178D+03,0.600D+01,0.19188000D+01,0.00000000D+00
     .,0.92371000D+02,0.178D+03,0.700D+01,0.19188000D+01,0.00000000D+00
     .,0.70797500D+02,0.178D+03,0.800D+01,0.19188000D+01,0.00000000D+00
     .,0.54251600D+02,0.178D+03,0.900D+01,0.19188000D+01,0.00000000D+00
     .,0.42149900D+02,0.178D+03,0.100D+02,0.19188000D+01,0.00000000D+00
     .,0.55760480D+03,0.178D+03,0.110D+02,0.19188000D+01,0.00000000D+00
     .,0.43700990D+03,0.178D+03,0.120D+02,0.19188000D+01,0.00000000D+00
     .,0.40638720D+03,0.178D+03,0.130D+02,0.19188000D+01,0.00000000D+00
     .,0.32432370D+03,0.178D+03,0.140D+02,0.19188000D+01,0.00000000D+00
     .,0.25607430D+03,0.178D+03,0.150D+02,0.19188000D+01,0.00000000D+00
     .,0.21453080D+03,0.178D+03,0.160D+02,0.19188000D+01,0.00000000D+00
     .,0.17695160D+03,0.178D+03,0.170D+02,0.19188000D+01,0.00000000D+00
     .,0.14611660D+03,0.178D+03,0.180D+02,0.19188000D+01,0.00000000D+00
     .,0.91385330D+03,0.178D+03,0.190D+02,0.19188000D+01,0.00000000D+00
     .,0.76327990D+03,0.178D+03,0.200D+02,0.19188000D+01,0.00000000D+00
     .,0.63264330D+03,0.178D+03,0.210D+02,0.19188000D+01,0.00000000D+00
     .,0.61344560D+03,0.178D+03,0.220D+02,0.19188000D+01,0.00000000D+00
     .,0.56306260D+03,0.178D+03,0.230D+02,0.19188000D+01,0.00000000D+00
     .,0.44482350D+03,0.178D+03,0.240D+02,0.19188000D+01,0.00000000D+00
     .,0.48647550D+03,0.178D+03,0.250D+02,0.19188000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68601:  68700)=(/
     . 0.38312130D+03,0.178D+03,0.260D+02,0.19188000D+01,0.00000000D+00
     .,0.40695490D+03,0.178D+03,0.270D+02,0.19188000D+01,0.00000000D+00
     .,0.41813480D+03,0.178D+03,0.280D+02,0.19188000D+01,0.00000000D+00
     .,0.32172230D+03,0.178D+03,0.290D+02,0.19188000D+01,0.00000000D+00
     .,0.33177490D+03,0.178D+03,0.300D+02,0.19188000D+01,0.00000000D+00
     .,0.39148440D+03,0.178D+03,0.310D+02,0.19188000D+01,0.00000000D+00
     .,0.34844170D+03,0.178D+03,0.320D+02,0.19188000D+01,0.00000000D+00
     .,0.30012110D+03,0.178D+03,0.330D+02,0.19188000D+01,0.00000000D+00
     .,0.27118850D+03,0.178D+03,0.340D+02,0.19188000D+01,0.00000000D+00
     .,0.23915510D+03,0.178D+03,0.350D+02,0.19188000D+01,0.00000000D+00
     .,0.20957880D+03,0.178D+03,0.360D+02,0.19188000D+01,0.00000000D+00
     .,0.10265038D+04,0.178D+03,0.370D+02,0.19188000D+01,0.00000000D+00
     .,0.90978800D+03,0.178D+03,0.380D+02,0.19188000D+01,0.00000000D+00
     .,0.80197930D+03,0.178D+03,0.390D+02,0.19188000D+01,0.00000000D+00
     .,0.72399270D+03,0.178D+03,0.400D+02,0.19188000D+01,0.00000000D+00
     .,0.66240900D+03,0.178D+03,0.410D+02,0.19188000D+01,0.00000000D+00
     .,0.51504420D+03,0.178D+03,0.420D+02,0.19188000D+01,0.00000000D+00
     .,0.57309040D+03,0.178D+03,0.430D+02,0.19188000D+01,0.00000000D+00
     .,0.44003780D+03,0.178D+03,0.440D+02,0.19188000D+01,0.00000000D+00
     .,0.48010810D+03,0.178D+03,0.450D+02,0.19188000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68701:  68800)=(/
     . 0.44621570D+03,0.178D+03,0.460D+02,0.19188000D+01,0.00000000D+00
     .,0.37286390D+03,0.178D+03,0.470D+02,0.19188000D+01,0.00000000D+00
     .,0.39438550D+03,0.178D+03,0.480D+02,0.19188000D+01,0.00000000D+00
     .,0.49129160D+03,0.178D+03,0.490D+02,0.19188000D+01,0.00000000D+00
     .,0.45727960D+03,0.178D+03,0.500D+02,0.19188000D+01,0.00000000D+00
     .,0.41067770D+03,0.178D+03,0.510D+02,0.19188000D+01,0.00000000D+00
     .,0.38304320D+03,0.178D+03,0.520D+02,0.19188000D+01,0.00000000D+00
     .,0.34847210D+03,0.178D+03,0.530D+02,0.19188000D+01,0.00000000D+00
     .,0.31527170D+03,0.178D+03,0.540D+02,0.19188000D+01,0.00000000D+00
     .,0.12516079D+04,0.178D+03,0.550D+02,0.19188000D+01,0.00000000D+00
     .,0.11586040D+04,0.178D+03,0.560D+02,0.19188000D+01,0.00000000D+00
     .,0.10239496D+04,0.178D+03,0.570D+02,0.19188000D+01,0.00000000D+00
     .,0.48500190D+03,0.178D+03,0.580D+02,0.19188000D+01,0.27991000D+01
     .,0.10291720D+04,0.178D+03,0.590D+02,0.19188000D+01,0.00000000D+00
     .,0.98909200D+03,0.178D+03,0.600D+02,0.19188000D+01,0.00000000D+00
     .,0.96450040D+03,0.178D+03,0.610D+02,0.19188000D+01,0.00000000D+00
     .,0.94184450D+03,0.178D+03,0.620D+02,0.19188000D+01,0.00000000D+00
     .,0.92175840D+03,0.178D+03,0.630D+02,0.19188000D+01,0.00000000D+00
     .,0.73100210D+03,0.178D+03,0.640D+02,0.19188000D+01,0.00000000D+00
     .,0.81592560D+03,0.178D+03,0.650D+02,0.19188000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68801:  68900)=(/
     . 0.78790030D+03,0.178D+03,0.660D+02,0.19188000D+01,0.00000000D+00
     .,0.83246930D+03,0.178D+03,0.670D+02,0.19188000D+01,0.00000000D+00
     .,0.81486390D+03,0.178D+03,0.680D+02,0.19188000D+01,0.00000000D+00
     .,0.79906290D+03,0.178D+03,0.690D+02,0.19188000D+01,0.00000000D+00
     .,0.78940200D+03,0.178D+03,0.700D+02,0.19188000D+01,0.00000000D+00
     .,0.66892220D+03,0.178D+03,0.710D+02,0.19188000D+01,0.00000000D+00
     .,0.66171440D+03,0.178D+03,0.720D+02,0.19188000D+01,0.00000000D+00
     .,0.60682340D+03,0.178D+03,0.730D+02,0.19188000D+01,0.00000000D+00
     .,0.51528520D+03,0.178D+03,0.740D+02,0.19188000D+01,0.00000000D+00
     .,0.52488810D+03,0.178D+03,0.750D+02,0.19188000D+01,0.00000000D+00
     .,0.47789070D+03,0.178D+03,0.760D+02,0.19188000D+01,0.00000000D+00
     .,0.43938870D+03,0.178D+03,0.770D+02,0.19188000D+01,0.00000000D+00
     .,0.36716870D+03,0.178D+03,0.780D+02,0.19188000D+01,0.00000000D+00
     .,0.34385620D+03,0.178D+03,0.790D+02,0.19188000D+01,0.00000000D+00
     .,0.35390700D+03,0.178D+03,0.800D+02,0.19188000D+01,0.00000000D+00
     .,0.50669330D+03,0.178D+03,0.810D+02,0.19188000D+01,0.00000000D+00
     .,0.49751750D+03,0.178D+03,0.820D+02,0.19188000D+01,0.00000000D+00
     .,0.46009860D+03,0.178D+03,0.830D+02,0.19188000D+01,0.00000000D+00
     .,0.44063800D+03,0.178D+03,0.840D+02,0.19188000D+01,0.00000000D+00
     .,0.40889250D+03,0.178D+03,0.850D+02,0.19188000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  68901:  69000)=(/
     . 0.37682880D+03,0.178D+03,0.860D+02,0.19188000D+01,0.00000000D+00
     .,0.11875608D+04,0.178D+03,0.870D+02,0.19188000D+01,0.00000000D+00
     .,0.11496435D+04,0.178D+03,0.880D+02,0.19188000D+01,0.00000000D+00
     .,0.10218132D+04,0.178D+03,0.890D+02,0.19188000D+01,0.00000000D+00
     .,0.92532050D+03,0.178D+03,0.900D+02,0.19188000D+01,0.00000000D+00
     .,0.91638160D+03,0.178D+03,0.910D+02,0.19188000D+01,0.00000000D+00
     .,0.88757730D+03,0.178D+03,0.920D+02,0.19188000D+01,0.00000000D+00
     .,0.90998500D+03,0.178D+03,0.930D+02,0.19188000D+01,0.00000000D+00
     .,0.88186200D+03,0.178D+03,0.940D+02,0.19188000D+01,0.00000000D+00
     .,0.50936600D+02,0.178D+03,0.101D+03,0.19188000D+01,0.00000000D+00
     .,0.16064720D+03,0.178D+03,0.103D+03,0.19188000D+01,0.98650000D+00
     .,0.20578590D+03,0.178D+03,0.104D+03,0.19188000D+01,0.98080000D+00
     .,0.15992840D+03,0.178D+03,0.105D+03,0.19188000D+01,0.97060000D+00
     .,0.12211080D+03,0.178D+03,0.106D+03,0.19188000D+01,0.98680000D+00
     .,0.86265500D+02,0.178D+03,0.107D+03,0.19188000D+01,0.99440000D+00
     .,0.63736400D+02,0.178D+03,0.108D+03,0.19188000D+01,0.99250000D+00
     .,0.44679200D+02,0.178D+03,0.109D+03,0.19188000D+01,0.99820000D+00
     .,0.23456040D+03,0.178D+03,0.111D+03,0.19188000D+01,0.96840000D+00
     .,0.36198670D+03,0.178D+03,0.112D+03,0.19188000D+01,0.96280000D+00
     .,0.36923330D+03,0.178D+03,0.113D+03,0.19188000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  69001:  69100)=(/
     . 0.30045310D+03,0.178D+03,0.114D+03,0.19188000D+01,0.95070000D+00
     .,0.24874070D+03,0.178D+03,0.115D+03,0.19188000D+01,0.99470000D+00
     .,0.21216920D+03,0.178D+03,0.116D+03,0.19188000D+01,0.99480000D+00
     .,0.17511990D+03,0.178D+03,0.117D+03,0.19188000D+01,0.99720000D+00
     .,0.32711390D+03,0.178D+03,0.119D+03,0.19188000D+01,0.97670000D+00
     .,0.61266150D+03,0.178D+03,0.120D+03,0.19188000D+01,0.98310000D+00
     .,0.32950500D+03,0.178D+03,0.121D+03,0.19188000D+01,0.18627000D+01
     .,0.31842170D+03,0.178D+03,0.122D+03,0.19188000D+01,0.18299000D+01
     .,0.31208150D+03,0.178D+03,0.123D+03,0.19188000D+01,0.19138000D+01
     .,0.30891510D+03,0.178D+03,0.124D+03,0.19188000D+01,0.18269000D+01
     .,0.28562920D+03,0.178D+03,0.125D+03,0.19188000D+01,0.16406000D+01
     .,0.26494780D+03,0.178D+03,0.126D+03,0.19188000D+01,0.16483000D+01
     .,0.25288280D+03,0.178D+03,0.127D+03,0.19188000D+01,0.17149000D+01
     .,0.24714320D+03,0.178D+03,0.128D+03,0.19188000D+01,0.17937000D+01
     .,0.24327100D+03,0.178D+03,0.129D+03,0.19188000D+01,0.95760000D+00
     .,0.22984390D+03,0.178D+03,0.130D+03,0.19188000D+01,0.19419000D+01
     .,0.36860280D+03,0.178D+03,0.131D+03,0.19188000D+01,0.96010000D+00
     .,0.32682470D+03,0.178D+03,0.132D+03,0.19188000D+01,0.94340000D+00
     .,0.29524020D+03,0.178D+03,0.133D+03,0.19188000D+01,0.98890000D+00
     .,0.27128510D+03,0.178D+03,0.134D+03,0.19188000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters(  69101:  69200)=(/
     . 0.24074110D+03,0.178D+03,0.135D+03,0.19188000D+01,0.99740000D+00
     .,0.39146850D+03,0.178D+03,0.137D+03,0.19188000D+01,0.97380000D+00
     .,0.74566370D+03,0.178D+03,0.138D+03,0.19188000D+01,0.98010000D+00
     .,0.57749450D+03,0.178D+03,0.139D+03,0.19188000D+01,0.19153000D+01
     .,0.43601580D+03,0.178D+03,0.140D+03,0.19188000D+01,0.19355000D+01
     .,0.44033040D+03,0.178D+03,0.141D+03,0.19188000D+01,0.19545000D+01
     .,0.41176280D+03,0.178D+03,0.142D+03,0.19188000D+01,0.19420000D+01
     .,0.45883330D+03,0.178D+03,0.143D+03,0.19188000D+01,0.16682000D+01
     .,0.36109350D+03,0.178D+03,0.144D+03,0.19188000D+01,0.18584000D+01
     .,0.33829080D+03,0.178D+03,0.145D+03,0.19188000D+01,0.19003000D+01
     .,0.31473130D+03,0.178D+03,0.146D+03,0.19188000D+01,0.18630000D+01
     .,0.30428650D+03,0.178D+03,0.147D+03,0.19188000D+01,0.96790000D+00
     .,0.30192540D+03,0.178D+03,0.148D+03,0.19188000D+01,0.19539000D+01
     .,0.46950870D+03,0.178D+03,0.149D+03,0.19188000D+01,0.96330000D+00
     .,0.42783570D+03,0.178D+03,0.150D+03,0.19188000D+01,0.95140000D+00
     .,0.40295210D+03,0.178D+03,0.151D+03,0.19188000D+01,0.97490000D+00
     .,0.38287770D+03,0.178D+03,0.152D+03,0.19188000D+01,0.98110000D+00
     .,0.35168470D+03,0.178D+03,0.153D+03,0.19188000D+01,0.99680000D+00
     .,0.46516200D+03,0.178D+03,0.155D+03,0.19188000D+01,0.99090000D+00
     .,0.96540540D+03,0.178D+03,0.156D+03,0.19188000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters(  69201:  69300)=(/
     . 0.73040540D+03,0.178D+03,0.157D+03,0.19188000D+01,0.19373000D+01
     .,0.47064590D+03,0.178D+03,0.159D+03,0.19188000D+01,0.29425000D+01
     .,0.46096660D+03,0.178D+03,0.160D+03,0.19188000D+01,0.29455000D+01
     .,0.44658000D+03,0.178D+03,0.161D+03,0.19188000D+01,0.29413000D+01
     .,0.44826620D+03,0.178D+03,0.162D+03,0.19188000D+01,0.29300000D+01
     .,0.43078610D+03,0.178D+03,0.163D+03,0.19188000D+01,0.18286000D+01
     .,0.45075260D+03,0.178D+03,0.164D+03,0.19188000D+01,0.28732000D+01
     .,0.42390040D+03,0.178D+03,0.165D+03,0.19188000D+01,0.29086000D+01
     .,0.43051250D+03,0.178D+03,0.166D+03,0.19188000D+01,0.28965000D+01
     .,0.40272530D+03,0.178D+03,0.167D+03,0.19188000D+01,0.29242000D+01
     .,0.39139780D+03,0.178D+03,0.168D+03,0.19188000D+01,0.29282000D+01
     .,0.38873440D+03,0.178D+03,0.169D+03,0.19188000D+01,0.29246000D+01
     .,0.40763660D+03,0.178D+03,0.170D+03,0.19188000D+01,0.28482000D+01
     .,0.37590100D+03,0.178D+03,0.171D+03,0.19188000D+01,0.29219000D+01
     .,0.50277570D+03,0.178D+03,0.172D+03,0.19188000D+01,0.19254000D+01
     .,0.46891240D+03,0.178D+03,0.173D+03,0.19188000D+01,0.19459000D+01
     .,0.43008890D+03,0.178D+03,0.174D+03,0.19188000D+01,0.19292000D+01
     .,0.43348520D+03,0.178D+03,0.175D+03,0.19188000D+01,0.18104000D+01
     .,0.38382310D+03,0.178D+03,0.176D+03,0.19188000D+01,0.18858000D+01
     .,0.36201210D+03,0.178D+03,0.177D+03,0.19188000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters(  69301:  69400)=(/
     . 0.34636100D+03,0.178D+03,0.178D+03,0.19188000D+01,0.19188000D+01
     .,0.30675700D+02,0.179D+03,0.100D+01,0.98460000D+00,0.91180000D+00
     .,0.20941000D+02,0.179D+03,0.200D+01,0.98460000D+00,0.00000000D+00
     .,0.44619080D+03,0.179D+03,0.300D+01,0.98460000D+00,0.00000000D+00
     .,0.26322300D+03,0.179D+03,0.400D+01,0.98460000D+00,0.00000000D+00
     .,0.18065820D+03,0.179D+03,0.500D+01,0.98460000D+00,0.00000000D+00
     .,0.12431330D+03,0.179D+03,0.600D+01,0.98460000D+00,0.00000000D+00
     .,0.88391500D+02,0.179D+03,0.700D+01,0.98460000D+00,0.00000000D+00
     .,0.67837200D+02,0.179D+03,0.800D+01,0.98460000D+00,0.00000000D+00
     .,0.52061000D+02,0.179D+03,0.900D+01,0.98460000D+00,0.00000000D+00
     .,0.40509200D+02,0.179D+03,0.100D+02,0.98460000D+00,0.00000000D+00
     .,0.53480760D+03,0.179D+03,0.110D+02,0.98460000D+00,0.00000000D+00
     .,0.41788500D+03,0.179D+03,0.120D+02,0.98460000D+00,0.00000000D+00
     .,0.38834460D+03,0.179D+03,0.130D+02,0.98460000D+00,0.00000000D+00
     .,0.30976480D+03,0.179D+03,0.140D+02,0.98460000D+00,0.00000000D+00
     .,0.24460550D+03,0.179D+03,0.150D+02,0.98460000D+00,0.00000000D+00
     .,0.20502050D+03,0.179D+03,0.160D+02,0.98460000D+00,0.00000000D+00
     .,0.16922710D+03,0.179D+03,0.170D+02,0.98460000D+00,0.00000000D+00
     .,0.13986320D+03,0.179D+03,0.180D+02,0.98460000D+00,0.00000000D+00
     .,0.87757830D+03,0.179D+03,0.190D+02,0.98460000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  69401:  69500)=(/
     . 0.73094660D+03,0.179D+03,0.200D+02,0.98460000D+00,0.00000000D+00
     .,0.60554530D+03,0.179D+03,0.210D+02,0.98460000D+00,0.00000000D+00
     .,0.58704740D+03,0.179D+03,0.220D+02,0.98460000D+00,0.00000000D+00
     .,0.53875790D+03,0.179D+03,0.230D+02,0.98460000D+00,0.00000000D+00
     .,0.42583430D+03,0.179D+03,0.240D+02,0.98460000D+00,0.00000000D+00
     .,0.46540030D+03,0.179D+03,0.250D+02,0.98460000D+00,0.00000000D+00
     .,0.36671160D+03,0.179D+03,0.260D+02,0.98460000D+00,0.00000000D+00
     .,0.38919570D+03,0.179D+03,0.270D+02,0.98460000D+00,0.00000000D+00
     .,0.39992890D+03,0.179D+03,0.280D+02,0.98460000D+00,0.00000000D+00
     .,0.30793520D+03,0.179D+03,0.290D+02,0.98460000D+00,0.00000000D+00
     .,0.31723870D+03,0.179D+03,0.300D+02,0.98460000D+00,0.00000000D+00
     .,0.37421180D+03,0.179D+03,0.310D+02,0.98460000D+00,0.00000000D+00
     .,0.33290660D+03,0.179D+03,0.320D+02,0.98460000D+00,0.00000000D+00
     .,0.28673520D+03,0.179D+03,0.330D+02,0.98460000D+00,0.00000000D+00
     .,0.25915840D+03,0.179D+03,0.340D+02,0.98460000D+00,0.00000000D+00
     .,0.22864850D+03,0.179D+03,0.350D+02,0.98460000D+00,0.00000000D+00
     .,0.20049290D+03,0.179D+03,0.360D+02,0.98460000D+00,0.00000000D+00
     .,0.98572350D+03,0.179D+03,0.370D+02,0.98460000D+00,0.00000000D+00
     .,0.87147550D+03,0.179D+03,0.380D+02,0.98460000D+00,0.00000000D+00
     .,0.76763160D+03,0.179D+03,0.390D+02,0.98460000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  69501:  69600)=(/
     . 0.69275660D+03,0.179D+03,0.400D+02,0.98460000D+00,0.00000000D+00
     .,0.63375930D+03,0.179D+03,0.410D+02,0.98460000D+00,0.00000000D+00
     .,0.49282900D+03,0.179D+03,0.420D+02,0.98460000D+00,0.00000000D+00
     .,0.54833760D+03,0.179D+03,0.430D+02,0.98460000D+00,0.00000000D+00
     .,0.42110840D+03,0.179D+03,0.440D+02,0.98460000D+00,0.00000000D+00
     .,0.45928620D+03,0.179D+03,0.450D+02,0.98460000D+00,0.00000000D+00
     .,0.42686340D+03,0.179D+03,0.460D+02,0.98460000D+00,0.00000000D+00
     .,0.35697430D+03,0.179D+03,0.470D+02,0.98460000D+00,0.00000000D+00
     .,0.37730490D+03,0.179D+03,0.480D+02,0.98460000D+00,0.00000000D+00
     .,0.46998930D+03,0.179D+03,0.490D+02,0.98460000D+00,0.00000000D+00
     .,0.43719460D+03,0.179D+03,0.500D+02,0.98460000D+00,0.00000000D+00
     .,0.39255510D+03,0.179D+03,0.510D+02,0.98460000D+00,0.00000000D+00
     .,0.36615260D+03,0.179D+03,0.520D+02,0.98460000D+00,0.00000000D+00
     .,0.33316950D+03,0.179D+03,0.530D+02,0.98460000D+00,0.00000000D+00
     .,0.30152720D+03,0.179D+03,0.540D+02,0.98460000D+00,0.00000000D+00
     .,0.12018793D+04,0.179D+03,0.550D+02,0.98460000D+00,0.00000000D+00
     .,0.11102792D+04,0.179D+03,0.560D+02,0.98460000D+00,0.00000000D+00
     .,0.98044160D+03,0.179D+03,0.570D+02,0.98460000D+00,0.00000000D+00
     .,0.46371250D+03,0.179D+03,0.580D+02,0.98460000D+00,0.27991000D+01
     .,0.98614070D+03,0.179D+03,0.590D+02,0.98460000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  69601:  69700)=(/
     . 0.94759800D+03,0.179D+03,0.600D+02,0.98460000D+00,0.00000000D+00
     .,0.92399680D+03,0.179D+03,0.610D+02,0.98460000D+00,0.00000000D+00
     .,0.90225470D+03,0.179D+03,0.620D+02,0.98460000D+00,0.00000000D+00
     .,0.88297590D+03,0.179D+03,0.630D+02,0.98460000D+00,0.00000000D+00
     .,0.69990580D+03,0.179D+03,0.640D+02,0.98460000D+00,0.00000000D+00
     .,0.78232470D+03,0.179D+03,0.650D+02,0.98460000D+00,0.00000000D+00
     .,0.75533300D+03,0.179D+03,0.660D+02,0.98460000D+00,0.00000000D+00
     .,0.79726220D+03,0.179D+03,0.670D+02,0.98460000D+00,0.00000000D+00
     .,0.78037200D+03,0.179D+03,0.680D+02,0.98460000D+00,0.00000000D+00
     .,0.76520560D+03,0.179D+03,0.690D+02,0.98460000D+00,0.00000000D+00
     .,0.75596270D+03,0.179D+03,0.700D+02,0.98460000D+00,0.00000000D+00
     .,0.64035930D+03,0.179D+03,0.710D+02,0.98460000D+00,0.00000000D+00
     .,0.63292020D+03,0.179D+03,0.720D+02,0.98460000D+00,0.00000000D+00
     .,0.58031360D+03,0.179D+03,0.730D+02,0.98460000D+00,0.00000000D+00
     .,0.49290480D+03,0.179D+03,0.740D+02,0.98460000D+00,0.00000000D+00
     .,0.50200340D+03,0.179D+03,0.750D+02,0.98460000D+00,0.00000000D+00
     .,0.45704880D+03,0.179D+03,0.760D+02,0.98460000D+00,0.00000000D+00
     .,0.42025190D+03,0.179D+03,0.770D+02,0.98460000D+00,0.00000000D+00
     .,0.35135070D+03,0.179D+03,0.780D+02,0.98460000D+00,0.00000000D+00
     .,0.32911380D+03,0.179D+03,0.790D+02,0.98460000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  69701:  69800)=(/
     . 0.33864570D+03,0.179D+03,0.800D+02,0.98460000D+00,0.00000000D+00
     .,0.48495430D+03,0.179D+03,0.810D+02,0.98460000D+00,0.00000000D+00
     .,0.47588520D+03,0.179D+03,0.820D+02,0.98460000D+00,0.00000000D+00
     .,0.43996460D+03,0.179D+03,0.830D+02,0.98460000D+00,0.00000000D+00
     .,0.42133170D+03,0.179D+03,0.840D+02,0.98460000D+00,0.00000000D+00
     .,0.39100970D+03,0.179D+03,0.850D+02,0.98460000D+00,0.00000000D+00
     .,0.36042890D+03,0.179D+03,0.860D+02,0.98460000D+00,0.00000000D+00
     .,0.11396407D+04,0.179D+03,0.870D+02,0.98460000D+00,0.00000000D+00
     .,0.11012980D+04,0.179D+03,0.880D+02,0.98460000D+00,0.00000000D+00
     .,0.97817100D+03,0.179D+03,0.890D+02,0.98460000D+00,0.00000000D+00
     .,0.88538660D+03,0.179D+03,0.900D+02,0.98460000D+00,0.00000000D+00
     .,0.87728480D+03,0.179D+03,0.910D+02,0.98460000D+00,0.00000000D+00
     .,0.84972830D+03,0.179D+03,0.920D+02,0.98460000D+00,0.00000000D+00
     .,0.87157240D+03,0.179D+03,0.930D+02,0.98460000D+00,0.00000000D+00
     .,0.84456390D+03,0.179D+03,0.940D+02,0.98460000D+00,0.00000000D+00
     .,0.48647800D+02,0.179D+03,0.101D+03,0.98460000D+00,0.00000000D+00
     .,0.15352370D+03,0.179D+03,0.103D+03,0.98460000D+00,0.98650000D+00
     .,0.19665700D+03,0.179D+03,0.104D+03,0.98460000D+00,0.98080000D+00
     .,0.15278290D+03,0.179D+03,0.105D+03,0.98460000D+00,0.97060000D+00
     .,0.11673350D+03,0.179D+03,0.106D+03,0.98460000D+00,0.98680000D+00
     ./)
      grimme_c6_parameters(  69801:  69900)=(/
     . 0.82569800D+02,0.179D+03,0.107D+03,0.98460000D+00,0.99440000D+00
     .,0.61097100D+02,0.179D+03,0.108D+03,0.98460000D+00,0.99250000D+00
     .,0.42933900D+02,0.179D+03,0.109D+03,0.98460000D+00,0.99820000D+00
     .,0.22431640D+03,0.179D+03,0.111D+03,0.98460000D+00,0.96840000D+00
     .,0.34612620D+03,0.179D+03,0.112D+03,0.98460000D+00,0.96280000D+00
     .,0.35282440D+03,0.179D+03,0.113D+03,0.98460000D+00,0.96480000D+00
     .,0.28698060D+03,0.179D+03,0.114D+03,0.98460000D+00,0.95070000D+00
     .,0.23761790D+03,0.179D+03,0.115D+03,0.98460000D+00,0.99470000D+00
     .,0.20277280D+03,0.179D+03,0.116D+03,0.98460000D+00,0.99480000D+00
     .,0.16748190D+03,0.179D+03,0.117D+03,0.98460000D+00,0.99720000D+00
     .,0.31303240D+03,0.179D+03,0.119D+03,0.98460000D+00,0.97670000D+00
     .,0.58698040D+03,0.179D+03,0.120D+03,0.98460000D+00,0.98310000D+00
     .,0.31500110D+03,0.179D+03,0.121D+03,0.98460000D+00,0.18627000D+01
     .,0.30444790D+03,0.179D+03,0.122D+03,0.98460000D+00,0.18299000D+01
     .,0.29841150D+03,0.179D+03,0.123D+03,0.98460000D+00,0.19138000D+01
     .,0.29542220D+03,0.179D+03,0.124D+03,0.98460000D+00,0.18269000D+01
     .,0.27304550D+03,0.179D+03,0.125D+03,0.98460000D+00,0.16406000D+01
     .,0.25329860D+03,0.179D+03,0.126D+03,0.98460000D+00,0.16483000D+01
     .,0.24179700D+03,0.179D+03,0.127D+03,0.98460000D+00,0.17149000D+01
     .,0.23632330D+03,0.179D+03,0.128D+03,0.98460000D+00,0.17937000D+01
     ./)
      grimme_c6_parameters(  69901:  70000)=(/
     . 0.23269810D+03,0.179D+03,0.129D+03,0.98460000D+00,0.95760000D+00
     .,0.21974110D+03,0.179D+03,0.130D+03,0.98460000D+00,0.19419000D+01
     .,0.35230670D+03,0.179D+03,0.131D+03,0.98460000D+00,0.96010000D+00
     .,0.31225540D+03,0.179D+03,0.132D+03,0.98460000D+00,0.94340000D+00
     .,0.28208180D+03,0.179D+03,0.133D+03,0.98460000D+00,0.98890000D+00
     .,0.25925510D+03,0.179D+03,0.134D+03,0.98460000D+00,0.99010000D+00
     .,0.23016390D+03,0.179D+03,0.135D+03,0.98460000D+00,0.99740000D+00
     .,0.37464460D+03,0.179D+03,0.137D+03,0.98460000D+00,0.97380000D+00
     .,0.71461700D+03,0.179D+03,0.138D+03,0.98460000D+00,0.98010000D+00
     .,0.55272720D+03,0.179D+03,0.139D+03,0.98460000D+00,0.19153000D+01
     .,0.41693630D+03,0.179D+03,0.140D+03,0.98460000D+00,0.19355000D+01
     .,0.42109580D+03,0.179D+03,0.141D+03,0.98460000D+00,0.19545000D+01
     .,0.39381950D+03,0.179D+03,0.142D+03,0.98460000D+00,0.19420000D+01
     .,0.43907200D+03,0.179D+03,0.143D+03,0.98460000D+00,0.16682000D+01
     .,0.34535640D+03,0.179D+03,0.144D+03,0.98460000D+00,0.18584000D+01
     .,0.32361650D+03,0.179D+03,0.145D+03,0.98460000D+00,0.19003000D+01
     .,0.30113910D+03,0.179D+03,0.146D+03,0.98460000D+00,0.18630000D+01
     .,0.29118100D+03,0.179D+03,0.147D+03,0.98460000D+00,0.96790000D+00
     .,0.28880380D+03,0.179D+03,0.148D+03,0.98460000D+00,0.19539000D+01
     .,0.44908360D+03,0.179D+03,0.149D+03,0.98460000D+00,0.96330000D+00
     ./)
      grimme_c6_parameters(  70001:  70100)=(/
     . 0.40902650D+03,0.179D+03,0.150D+03,0.98460000D+00,0.95140000D+00
     .,0.38517040D+03,0.179D+03,0.151D+03,0.98460000D+00,0.97490000D+00
     .,0.36599200D+03,0.179D+03,0.152D+03,0.98460000D+00,0.98110000D+00
     .,0.33623370D+03,0.179D+03,0.153D+03,0.98460000D+00,0.99680000D+00
     .,0.44489470D+03,0.179D+03,0.155D+03,0.98460000D+00,0.99090000D+00
     .,0.92564640D+03,0.179D+03,0.156D+03,0.98460000D+00,0.97970000D+00
     .,0.69919040D+03,0.179D+03,0.157D+03,0.98460000D+00,0.19373000D+01
     .,0.44999540D+03,0.179D+03,0.159D+03,0.98460000D+00,0.29425000D+01
     .,0.44074490D+03,0.179D+03,0.160D+03,0.98460000D+00,0.29455000D+01
     .,0.42699740D+03,0.179D+03,0.161D+03,0.98460000D+00,0.29413000D+01
     .,0.42862430D+03,0.179D+03,0.162D+03,0.98460000D+00,0.29300000D+01
     .,0.41203450D+03,0.179D+03,0.163D+03,0.98460000D+00,0.18286000D+01
     .,0.43096490D+03,0.179D+03,0.164D+03,0.98460000D+00,0.28732000D+01
     .,0.40531130D+03,0.179D+03,0.165D+03,0.98460000D+00,0.29086000D+01
     .,0.41167450D+03,0.179D+03,0.166D+03,0.98460000D+00,0.28965000D+01
     .,0.38504690D+03,0.179D+03,0.167D+03,0.98460000D+00,0.29242000D+01
     .,0.37421380D+03,0.179D+03,0.168D+03,0.98460000D+00,0.29282000D+01
     .,0.37166190D+03,0.179D+03,0.169D+03,0.98460000D+00,0.29246000D+01
     .,0.38968240D+03,0.179D+03,0.170D+03,0.98460000D+00,0.28482000D+01
     .,0.35937430D+03,0.179D+03,0.171D+03,0.98460000D+00,0.29219000D+01
     ./)
      grimme_c6_parameters(  70101:  70200)=(/
     . 0.48090340D+03,0.179D+03,0.172D+03,0.98460000D+00,0.19254000D+01
     .,0.44847840D+03,0.179D+03,0.173D+03,0.98460000D+00,0.19459000D+01
     .,0.41133730D+03,0.179D+03,0.174D+03,0.98460000D+00,0.19292000D+01
     .,0.41467050D+03,0.179D+03,0.175D+03,0.98460000D+00,0.18104000D+01
     .,0.36709540D+03,0.179D+03,0.176D+03,0.98460000D+00,0.18858000D+01
     .,0.34630750D+03,0.179D+03,0.177D+03,0.98460000D+00,0.18648000D+01
     .,0.33139460D+03,0.179D+03,0.178D+03,0.98460000D+00,0.19188000D+01
     .,0.31715610D+03,0.179D+03,0.179D+03,0.98460000D+00,0.98460000D+00
     .,0.29920300D+02,0.180D+03,0.100D+01,0.19896000D+01,0.91180000D+00
     .,0.20585200D+02,0.180D+03,0.200D+01,0.19896000D+01,0.00000000D+00
     .,0.41310610D+03,0.180D+03,0.300D+01,0.19896000D+01,0.00000000D+00
     .,0.25030210D+03,0.180D+03,0.400D+01,0.19896000D+01,0.00000000D+00
     .,0.17402940D+03,0.180D+03,0.500D+01,0.19896000D+01,0.00000000D+00
     .,0.12076050D+03,0.180D+03,0.600D+01,0.19896000D+01,0.00000000D+00
     .,0.86338200D+02,0.180D+03,0.700D+01,0.19896000D+01,0.00000000D+00
     .,0.66493700D+02,0.180D+03,0.800D+01,0.19896000D+01,0.00000000D+00
     .,0.51170200D+02,0.180D+03,0.900D+01,0.19896000D+01,0.00000000D+00
     .,0.39897400D+02,0.180D+03,0.100D+02,0.19896000D+01,0.00000000D+00
     .,0.49600030D+03,0.180D+03,0.110D+02,0.19896000D+01,0.00000000D+00
     .,0.39561740D+03,0.180D+03,0.120D+02,0.19896000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  70201:  70300)=(/
     . 0.37029810D+03,0.180D+03,0.130D+02,0.19896000D+01,0.00000000D+00
     .,0.29804830D+03,0.180D+03,0.140D+02,0.19896000D+01,0.00000000D+00
     .,0.23698310D+03,0.180D+03,0.150D+02,0.19896000D+01,0.00000000D+00
     .,0.19943500D+03,0.180D+03,0.160D+02,0.19896000D+01,0.00000000D+00
     .,0.16520990D+03,0.180D+03,0.170D+02,0.19896000D+01,0.00000000D+00
     .,0.13693730D+03,0.180D+03,0.180D+02,0.19896000D+01,0.00000000D+00
     .,0.81050400D+03,0.180D+03,0.190D+02,0.19896000D+01,0.00000000D+00
     .,0.68633430D+03,0.180D+03,0.200D+02,0.19896000D+01,0.00000000D+00
     .,0.57063520D+03,0.180D+03,0.210D+02,0.19896000D+01,0.00000000D+00
     .,0.55496780D+03,0.180D+03,0.220D+02,0.19896000D+01,0.00000000D+00
     .,0.51028000D+03,0.180D+03,0.230D+02,0.19896000D+01,0.00000000D+00
     .,0.40344500D+03,0.180D+03,0.240D+02,0.19896000D+01,0.00000000D+00
     .,0.44199080D+03,0.180D+03,0.250D+02,0.19896000D+01,0.00000000D+00
     .,0.34847560D+03,0.180D+03,0.260D+02,0.19896000D+01,0.00000000D+00
     .,0.37126550D+03,0.180D+03,0.270D+02,0.19896000D+01,0.00000000D+00
     .,0.38080390D+03,0.180D+03,0.280D+02,0.19896000D+01,0.00000000D+00
     .,0.29324220D+03,0.180D+03,0.290D+02,0.19896000D+01,0.00000000D+00
     .,0.30381440D+03,0.180D+03,0.300D+02,0.19896000D+01,0.00000000D+00
     .,0.35775570D+03,0.180D+03,0.310D+02,0.19896000D+01,0.00000000D+00
     .,0.32047320D+03,0.180D+03,0.320D+02,0.19896000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  70301:  70400)=(/
     . 0.27762260D+03,0.180D+03,0.330D+02,0.19896000D+01,0.00000000D+00
     .,0.25175200D+03,0.180D+03,0.340D+02,0.19896000D+01,0.00000000D+00
     .,0.22282360D+03,0.180D+03,0.350D+02,0.19896000D+01,0.00000000D+00
     .,0.19592110D+03,0.180D+03,0.360D+02,0.19896000D+01,0.00000000D+00
     .,0.91174980D+03,0.180D+03,0.370D+02,0.19896000D+01,0.00000000D+00
     .,0.81778560D+03,0.180D+03,0.380D+02,0.19896000D+01,0.00000000D+00
     .,0.72486420D+03,0.180D+03,0.390D+02,0.19896000D+01,0.00000000D+00
     .,0.65664200D+03,0.180D+03,0.400D+02,0.19896000D+01,0.00000000D+00
     .,0.60218630D+03,0.180D+03,0.410D+02,0.19896000D+01,0.00000000D+00
     .,0.47017490D+03,0.180D+03,0.420D+02,0.19896000D+01,0.00000000D+00
     .,0.52236590D+03,0.180D+03,0.430D+02,0.19896000D+01,0.00000000D+00
     .,0.40291110D+03,0.180D+03,0.440D+02,0.19896000D+01,0.00000000D+00
     .,0.43946430D+03,0.180D+03,0.450D+02,0.19896000D+01,0.00000000D+00
     .,0.40902800D+03,0.180D+03,0.460D+02,0.19896000D+01,0.00000000D+00
     .,0.34173120D+03,0.180D+03,0.470D+02,0.19896000D+01,0.00000000D+00
     .,0.36219820D+03,0.180D+03,0.480D+02,0.19896000D+01,0.00000000D+00
     .,0.44915100D+03,0.180D+03,0.490D+02,0.19896000D+01,0.00000000D+00
     .,0.42020430D+03,0.180D+03,0.500D+02,0.19896000D+01,0.00000000D+00
     .,0.37928220D+03,0.180D+03,0.510D+02,0.19896000D+01,0.00000000D+00
     .,0.35482940D+03,0.180D+03,0.520D+02,0.19896000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  70401:  70500)=(/
     . 0.32385100D+03,0.180D+03,0.530D+02,0.19896000D+01,0.00000000D+00
     .,0.29389350D+03,0.180D+03,0.540D+02,0.19896000D+01,0.00000000D+00
     .,0.11120309D+04,0.180D+03,0.550D+02,0.19896000D+01,0.00000000D+00
     .,0.10396919D+04,0.180D+03,0.560D+02,0.19896000D+01,0.00000000D+00
     .,0.92389520D+03,0.180D+03,0.570D+02,0.19896000D+01,0.00000000D+00
     .,0.44756220D+03,0.180D+03,0.580D+02,0.19896000D+01,0.27991000D+01
     .,0.92541710D+03,0.180D+03,0.590D+02,0.19896000D+01,0.00000000D+00
     .,0.89016940D+03,0.180D+03,0.600D+02,0.19896000D+01,0.00000000D+00
     .,0.86825330D+03,0.180D+03,0.610D+02,0.19896000D+01,0.00000000D+00
     .,0.84803530D+03,0.180D+03,0.620D+02,0.19896000D+01,0.00000000D+00
     .,0.83011710D+03,0.180D+03,0.630D+02,0.19896000D+01,0.00000000D+00
     .,0.66249390D+03,0.180D+03,0.640D+02,0.19896000D+01,0.00000000D+00
     .,0.73314800D+03,0.180D+03,0.650D+02,0.19896000D+01,0.00000000D+00
     .,0.70872400D+03,0.180D+03,0.660D+02,0.19896000D+01,0.00000000D+00
     .,0.75071540D+03,0.180D+03,0.670D+02,0.19896000D+01,0.00000000D+00
     .,0.73493810D+03,0.180D+03,0.680D+02,0.19896000D+01,0.00000000D+00
     .,0.72083100D+03,0.180D+03,0.690D+02,0.19896000D+01,0.00000000D+00
     .,0.71192400D+03,0.180D+03,0.700D+02,0.19896000D+01,0.00000000D+00
     .,0.60586800D+03,0.180D+03,0.710D+02,0.19896000D+01,0.00000000D+00
     .,0.60248380D+03,0.180D+03,0.720D+02,0.19896000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  70501:  70600)=(/
     . 0.55437230D+03,0.180D+03,0.730D+02,0.19896000D+01,0.00000000D+00
     .,0.47211020D+03,0.180D+03,0.740D+02,0.19896000D+01,0.00000000D+00
     .,0.48147760D+03,0.180D+03,0.750D+02,0.19896000D+01,0.00000000D+00
     .,0.43962380D+03,0.180D+03,0.760D+02,0.19896000D+01,0.00000000D+00
     .,0.40514540D+03,0.180D+03,0.770D+02,0.19896000D+01,0.00000000D+00
     .,0.33947380D+03,0.180D+03,0.780D+02,0.19896000D+01,0.00000000D+00
     .,0.31826990D+03,0.180D+03,0.790D+02,0.19896000D+01,0.00000000D+00
     .,0.32785490D+03,0.180D+03,0.800D+02,0.19896000D+01,0.00000000D+00
     .,0.46406660D+03,0.180D+03,0.810D+02,0.19896000D+01,0.00000000D+00
     .,0.45741320D+03,0.180D+03,0.820D+02,0.19896000D+01,0.00000000D+00
     .,0.42489250D+03,0.180D+03,0.830D+02,0.19896000D+01,0.00000000D+00
     .,0.40796160D+03,0.180D+03,0.840D+02,0.19896000D+01,0.00000000D+00
     .,0.37973280D+03,0.180D+03,0.850D+02,0.19896000D+01,0.00000000D+00
     .,0.35093490D+03,0.180D+03,0.860D+02,0.19896000D+01,0.00000000D+00
     .,0.10599693D+04,0.180D+03,0.870D+02,0.19896000D+01,0.00000000D+00
     .,0.10346573D+04,0.180D+03,0.880D+02,0.19896000D+01,0.00000000D+00
     .,0.92429380D+03,0.180D+03,0.890D+02,0.19896000D+01,0.00000000D+00
     .,0.84192530D+03,0.180D+03,0.900D+02,0.19896000D+01,0.00000000D+00
     .,0.83161820D+03,0.180D+03,0.910D+02,0.19896000D+01,0.00000000D+00
     .,0.80561970D+03,0.180D+03,0.920D+02,0.19896000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  70601:  70700)=(/
     . 0.82308290D+03,0.180D+03,0.930D+02,0.19896000D+01,0.00000000D+00
     .,0.79816520D+03,0.180D+03,0.940D+02,0.19896000D+01,0.00000000D+00
     .,0.47166200D+02,0.180D+03,0.101D+03,0.19896000D+01,0.00000000D+00
     .,0.14625750D+03,0.180D+03,0.103D+03,0.19896000D+01,0.98650000D+00
     .,0.18779790D+03,0.180D+03,0.104D+03,0.19896000D+01,0.98080000D+00
     .,0.14752400D+03,0.180D+03,0.105D+03,0.19896000D+01,0.97060000D+00
     .,0.11336050D+03,0.180D+03,0.106D+03,0.19896000D+01,0.98680000D+00
     .,0.80647100D+02,0.180D+03,0.107D+03,0.19896000D+01,0.99440000D+00
     .,0.59931300D+02,0.180D+03,0.108D+03,0.19896000D+01,0.99250000D+00
     .,0.42319500D+02,0.180D+03,0.109D+03,0.19896000D+01,0.99820000D+00
     .,0.21316680D+03,0.180D+03,0.111D+03,0.19896000D+01,0.96840000D+00
     .,0.32853430D+03,0.180D+03,0.112D+03,0.19896000D+01,0.96280000D+00
     .,0.33698220D+03,0.180D+03,0.113D+03,0.19896000D+01,0.96480000D+00
     .,0.27645860D+03,0.180D+03,0.114D+03,0.19896000D+01,0.95070000D+00
     .,0.23025850D+03,0.180D+03,0.115D+03,0.19896000D+01,0.99470000D+00
     .,0.19722520D+03,0.180D+03,0.116D+03,0.19896000D+01,0.99480000D+00
     .,0.16349210D+03,0.180D+03,0.117D+03,0.19896000D+01,0.99720000D+00
     .,0.29887190D+03,0.180D+03,0.119D+03,0.19896000D+01,0.97670000D+00
     .,0.55142200D+03,0.180D+03,0.120D+03,0.19896000D+01,0.98310000D+00
     .,0.30295130D+03,0.180D+03,0.121D+03,0.19896000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters(  70701:  70800)=(/
     . 0.29286460D+03,0.180D+03,0.122D+03,0.19896000D+01,0.18299000D+01
     .,0.28701690D+03,0.180D+03,0.123D+03,0.19896000D+01,0.19138000D+01
     .,0.28389530D+03,0.180D+03,0.124D+03,0.19896000D+01,0.18269000D+01
     .,0.26347450D+03,0.180D+03,0.125D+03,0.19896000D+01,0.16406000D+01
     .,0.24469520D+03,0.180D+03,0.126D+03,0.19896000D+01,0.16483000D+01
     .,0.23357610D+03,0.180D+03,0.127D+03,0.19896000D+01,0.17149000D+01
     .,0.22821280D+03,0.180D+03,0.128D+03,0.19896000D+01,0.17937000D+01
     .,0.22401780D+03,0.180D+03,0.129D+03,0.19896000D+01,0.95760000D+00
     .,0.21272240D+03,0.180D+03,0.130D+03,0.19896000D+01,0.19419000D+01
     .,0.33741410D+03,0.180D+03,0.131D+03,0.19896000D+01,0.96010000D+00
     .,0.30105020D+03,0.180D+03,0.132D+03,0.19896000D+01,0.94340000D+00
     .,0.27320270D+03,0.180D+03,0.133D+03,0.19896000D+01,0.98890000D+00
     .,0.25183060D+03,0.180D+03,0.134D+03,0.19896000D+01,0.99010000D+00
     .,0.22426200D+03,0.180D+03,0.135D+03,0.19896000D+01,0.99740000D+00
     .,0.35823720D+03,0.180D+03,0.137D+03,0.19896000D+01,0.97380000D+00
     .,0.67072660D+03,0.180D+03,0.138D+03,0.19896000D+01,0.98010000D+00
     .,0.52511790D+03,0.180D+03,0.139D+03,0.19896000D+01,0.19153000D+01
     .,0.40071700D+03,0.180D+03,0.140D+03,0.19896000D+01,0.19355000D+01
     .,0.40464840D+03,0.180D+03,0.141D+03,0.19896000D+01,0.19545000D+01
     .,0.37897070D+03,0.180D+03,0.142D+03,0.19896000D+01,0.19420000D+01
     ./)
      grimme_c6_parameters(  70801:  70900)=(/
     . 0.42021610D+03,0.180D+03,0.143D+03,0.19896000D+01,0.16682000D+01
     .,0.33359820D+03,0.180D+03,0.144D+03,0.19896000D+01,0.18584000D+01
     .,0.31269220D+03,0.180D+03,0.145D+03,0.19896000D+01,0.19003000D+01
     .,0.29116220D+03,0.180D+03,0.146D+03,0.19896000D+01,0.18630000D+01
     .,0.28137530D+03,0.180D+03,0.147D+03,0.19896000D+01,0.96790000D+00
     .,0.27990990D+03,0.180D+03,0.148D+03,0.19896000D+01,0.19539000D+01
     .,0.43003950D+03,0.180D+03,0.149D+03,0.19896000D+01,0.96330000D+00
     .,0.39395270D+03,0.180D+03,0.150D+03,0.19896000D+01,0.95140000D+00
     .,0.37239970D+03,0.180D+03,0.151D+03,0.19896000D+01,0.97490000D+00
     .,0.35473990D+03,0.180D+03,0.152D+03,0.19896000D+01,0.98110000D+00
     .,0.32681510D+03,0.180D+03,0.153D+03,0.19896000D+01,0.99680000D+00
     .,0.42730670D+03,0.180D+03,0.155D+03,0.19896000D+01,0.99090000D+00
     .,0.86655170D+03,0.180D+03,0.156D+03,0.19896000D+01,0.97970000D+00
     .,0.66355950D+03,0.180D+03,0.157D+03,0.19896000D+01,0.19373000D+01
     .,0.43445080D+03,0.180D+03,0.159D+03,0.19896000D+01,0.29425000D+01
     .,0.42554240D+03,0.180D+03,0.160D+03,0.19896000D+01,0.29455000D+01
     .,0.41237370D+03,0.180D+03,0.161D+03,0.19896000D+01,0.29413000D+01
     .,0.41361800D+03,0.180D+03,0.162D+03,0.19896000D+01,0.29300000D+01
     .,0.39655650D+03,0.180D+03,0.163D+03,0.19896000D+01,0.18286000D+01
     .,0.41578790D+03,0.180D+03,0.164D+03,0.19896000D+01,0.28732000D+01
     ./)
      grimme_c6_parameters(  70901:  71000)=(/
     . 0.39129420D+03,0.180D+03,0.165D+03,0.19896000D+01,0.29086000D+01
     .,0.39685720D+03,0.180D+03,0.166D+03,0.19896000D+01,0.28965000D+01
     .,0.37198460D+03,0.180D+03,0.167D+03,0.19896000D+01,0.29242000D+01
     .,0.36161110D+03,0.180D+03,0.168D+03,0.19896000D+01,0.29282000D+01
     .,0.35907550D+03,0.180D+03,0.169D+03,0.19896000D+01,0.29246000D+01
     .,0.37609030D+03,0.180D+03,0.170D+03,0.19896000D+01,0.28482000D+01
     .,0.34734250D+03,0.180D+03,0.171D+03,0.19896000D+01,0.29219000D+01
     .,0.46039360D+03,0.180D+03,0.172D+03,0.19896000D+01,0.19254000D+01
     .,0.43075880D+03,0.180D+03,0.173D+03,0.19896000D+01,0.19459000D+01
     .,0.39639370D+03,0.180D+03,0.174D+03,0.19896000D+01,0.19292000D+01
     .,0.39843040D+03,0.180D+03,0.175D+03,0.19896000D+01,0.18104000D+01
     .,0.35538470D+03,0.180D+03,0.176D+03,0.19896000D+01,0.18858000D+01
     .,0.33559480D+03,0.180D+03,0.177D+03,0.19896000D+01,0.18648000D+01
     .,0.32133060D+03,0.180D+03,0.178D+03,0.19896000D+01,0.19188000D+01
     .,0.30747100D+03,0.180D+03,0.179D+03,0.19896000D+01,0.98460000D+00
     .,0.29886160D+03,0.180D+03,0.180D+03,0.19896000D+01,0.19896000D+01
     .,0.45657800D+02,0.181D+03,0.100D+01,0.92670000D+00,0.91180000D+00
     .,0.29528900D+02,0.181D+03,0.200D+01,0.92670000D+00,0.00000000D+00
     .,0.81893710D+03,0.181D+03,0.300D+01,0.92670000D+00,0.00000000D+00
     .,0.44031470D+03,0.181D+03,0.400D+01,0.92670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  71001:  71100)=(/
     . 0.28625250D+03,0.181D+03,0.500D+01,0.92670000D+00,0.00000000D+00
     .,0.18889680D+03,0.181D+03,0.600D+01,0.92670000D+00,0.00000000D+00
     .,0.13007910D+03,0.181D+03,0.700D+01,0.92670000D+00,0.00000000D+00
     .,0.97551000D+02,0.181D+03,0.800D+01,0.92670000D+00,0.00000000D+00
     .,0.73378400D+02,0.181D+03,0.900D+01,0.92670000D+00,0.00000000D+00
     .,0.56174600D+02,0.181D+03,0.100D+02,0.92670000D+00,0.00000000D+00
     .,0.97532750D+03,0.181D+03,0.110D+02,0.92670000D+00,0.00000000D+00
     .,0.71024040D+03,0.181D+03,0.120D+02,0.92670000D+00,0.00000000D+00
     .,0.64228990D+03,0.181D+03,0.130D+02,0.92670000D+00,0.00000000D+00
     .,0.49356290D+03,0.181D+03,0.140D+02,0.92670000D+00,0.00000000D+00
     .,0.37740890D+03,0.181D+03,0.150D+02,0.92670000D+00,0.00000000D+00
     .,0.30961610D+03,0.181D+03,0.160D+02,0.92670000D+00,0.00000000D+00
     .,0.25028720D+03,0.181D+03,0.170D+02,0.92670000D+00,0.00000000D+00
     .,0.20307020D+03,0.181D+03,0.180D+02,0.92670000D+00,0.00000000D+00
     .,0.16199398D+04,0.181D+03,0.190D+02,0.92670000D+00,0.00000000D+00
     .,0.12768842D+04,0.181D+03,0.200D+02,0.92670000D+00,0.00000000D+00
     .,0.10446215D+04,0.181D+03,0.210D+02,0.92670000D+00,0.00000000D+00
     .,0.10005590D+04,0.181D+03,0.220D+02,0.92670000D+00,0.00000000D+00
     .,0.91170000D+03,0.181D+03,0.230D+02,0.92670000D+00,0.00000000D+00
     .,0.71835580D+03,0.181D+03,0.240D+02,0.92670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  71101:  71200)=(/
     . 0.77938520D+03,0.181D+03,0.250D+02,0.92670000D+00,0.00000000D+00
     .,0.61131150D+03,0.181D+03,0.260D+02,0.92670000D+00,0.00000000D+00
     .,0.64053000D+03,0.181D+03,0.270D+02,0.92670000D+00,0.00000000D+00
     .,0.66311020D+03,0.181D+03,0.280D+02,0.92670000D+00,0.00000000D+00
     .,0.50888790D+03,0.181D+03,0.290D+02,0.92670000D+00,0.00000000D+00
     .,0.51381200D+03,0.181D+03,0.300D+02,0.92670000D+00,0.00000000D+00
     .,0.61125030D+03,0.181D+03,0.310D+02,0.92670000D+00,0.00000000D+00
     .,0.52855090D+03,0.181D+03,0.320D+02,0.92670000D+00,0.00000000D+00
     .,0.44341250D+03,0.181D+03,0.330D+02,0.92670000D+00,0.00000000D+00
     .,0.39408000D+03,0.181D+03,0.340D+02,0.92670000D+00,0.00000000D+00
     .,0.34165520D+03,0.181D+03,0.350D+02,0.92670000D+00,0.00000000D+00
     .,0.29473510D+03,0.181D+03,0.360D+02,0.92670000D+00,0.00000000D+00
     .,0.18096860D+04,0.181D+03,0.370D+02,0.92670000D+00,0.00000000D+00
     .,0.15245549D+04,0.181D+03,0.380D+02,0.92670000D+00,0.00000000D+00
     .,0.13131378D+04,0.181D+03,0.390D+02,0.92670000D+00,0.00000000D+00
     .,0.11682143D+04,0.181D+03,0.400D+02,0.92670000D+00,0.00000000D+00
     .,0.10584151D+04,0.181D+03,0.410D+02,0.92670000D+00,0.00000000D+00
     .,0.80855780D+03,0.181D+03,0.420D+02,0.92670000D+00,0.00000000D+00
     .,0.90569280D+03,0.181D+03,0.430D+02,0.92670000D+00,0.00000000D+00
     .,0.68207110D+03,0.181D+03,0.440D+02,0.92670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  71201:  71300)=(/
     . 0.74493760D+03,0.181D+03,0.450D+02,0.92670000D+00,0.00000000D+00
     .,0.68807030D+03,0.181D+03,0.460D+02,0.92670000D+00,0.00000000D+00
     .,0.57599280D+03,0.181D+03,0.470D+02,0.92670000D+00,0.00000000D+00
     .,0.60330050D+03,0.181D+03,0.480D+02,0.92670000D+00,0.00000000D+00
     .,0.76665730D+03,0.181D+03,0.490D+02,0.92670000D+00,0.00000000D+00
     .,0.69724530D+03,0.181D+03,0.500D+02,0.92670000D+00,0.00000000D+00
     .,0.61199840D+03,0.181D+03,0.510D+02,0.92670000D+00,0.00000000D+00
     .,0.56288000D+03,0.181D+03,0.520D+02,0.92670000D+00,0.00000000D+00
     .,0.50438410D+03,0.181D+03,0.530D+02,0.92670000D+00,0.00000000D+00
     .,0.44980100D+03,0.181D+03,0.540D+02,0.92670000D+00,0.00000000D+00
     .,0.22046359D+04,0.181D+03,0.550D+02,0.92670000D+00,0.00000000D+00
     .,0.19557490D+04,0.181D+03,0.560D+02,0.92670000D+00,0.00000000D+00
     .,0.16891285D+04,0.181D+03,0.570D+02,0.92670000D+00,0.00000000D+00
     .,0.72531910D+03,0.181D+03,0.580D+02,0.92670000D+00,0.27991000D+01
     .,0.17235094D+04,0.181D+03,0.590D+02,0.92670000D+00,0.00000000D+00
     .,0.16499797D+04,0.181D+03,0.600D+02,0.92670000D+00,0.00000000D+00
     .,0.16072448D+04,0.181D+03,0.610D+02,0.92670000D+00,0.00000000D+00
     .,0.15680817D+04,0.181D+03,0.620D+02,0.92670000D+00,0.00000000D+00
     .,0.15333057D+04,0.181D+03,0.630D+02,0.92670000D+00,0.00000000D+00
     .,0.11844744D+04,0.181D+03,0.640D+02,0.92670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  71301:  71400)=(/
     . 0.13721977D+04,0.181D+03,0.650D+02,0.92670000D+00,0.00000000D+00
     .,0.13193709D+04,0.181D+03,0.660D+02,0.92670000D+00,0.00000000D+00
     .,0.13768441D+04,0.181D+03,0.670D+02,0.92670000D+00,0.00000000D+00
     .,0.13469267D+04,0.181D+03,0.680D+02,0.92670000D+00,0.00000000D+00
     .,0.13196608D+04,0.181D+03,0.690D+02,0.92670000D+00,0.00000000D+00
     .,0.13051597D+04,0.181D+03,0.700D+02,0.92670000D+00,0.00000000D+00
     .,0.10865229D+04,0.181D+03,0.710D+02,0.92670000D+00,0.00000000D+00
     .,0.10501050D+04,0.181D+03,0.720D+02,0.92670000D+00,0.00000000D+00
     .,0.94898330D+03,0.181D+03,0.730D+02,0.92670000D+00,0.00000000D+00
     .,0.79601210D+03,0.181D+03,0.740D+02,0.92670000D+00,0.00000000D+00
     .,0.80654170D+03,0.181D+03,0.750D+02,0.92670000D+00,0.00000000D+00
     .,0.72504930D+03,0.181D+03,0.760D+02,0.92670000D+00,0.00000000D+00
     .,0.65978220D+03,0.181D+03,0.770D+02,0.92670000D+00,0.00000000D+00
     .,0.54489940D+03,0.181D+03,0.780D+02,0.92670000D+00,0.00000000D+00
     .,0.50792100D+03,0.181D+03,0.790D+02,0.92670000D+00,0.00000000D+00
     .,0.52062730D+03,0.181D+03,0.800D+02,0.92670000D+00,0.00000000D+00
     .,0.78494960D+03,0.181D+03,0.810D+02,0.92670000D+00,0.00000000D+00
     .,0.75725660D+03,0.181D+03,0.820D+02,0.92670000D+00,0.00000000D+00
     .,0.68621680D+03,0.181D+03,0.830D+02,0.92670000D+00,0.00000000D+00
     .,0.64945010D+03,0.181D+03,0.840D+02,0.92670000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  71401:  71500)=(/
     . 0.59409560D+03,0.181D+03,0.850D+02,0.92670000D+00,0.00000000D+00
     .,0.54036210D+03,0.181D+03,0.860D+02,0.92670000D+00,0.00000000D+00
     .,0.20530994D+04,0.181D+03,0.870D+02,0.92670000D+00,0.00000000D+00
     .,0.19172106D+04,0.181D+03,0.880D+02,0.92670000D+00,0.00000000D+00
     .,0.16681370D+04,0.181D+03,0.890D+02,0.92670000D+00,0.00000000D+00
     .,0.14735523D+04,0.181D+03,0.900D+02,0.92670000D+00,0.00000000D+00
     .,0.14764021D+04,0.181D+03,0.910D+02,0.92670000D+00,0.00000000D+00
     .,0.14289400D+04,0.181D+03,0.920D+02,0.92670000D+00,0.00000000D+00
     .,0.14871204D+04,0.181D+03,0.930D+02,0.92670000D+00,0.00000000D+00
     .,0.14371768D+04,0.181D+03,0.940D+02,0.92670000D+00,0.00000000D+00
     .,0.74826500D+02,0.181D+03,0.101D+03,0.92670000D+00,0.00000000D+00
     .,0.25479910D+03,0.181D+03,0.103D+03,0.92670000D+00,0.98650000D+00
     .,0.32309330D+03,0.181D+03,0.104D+03,0.92670000D+00,0.98080000D+00
     .,0.23925450D+03,0.181D+03,0.105D+03,0.92670000D+00,0.97060000D+00
     .,0.17739330D+03,0.181D+03,0.106D+03,0.92670000D+00,0.98680000D+00
     .,0.12133560D+03,0.181D+03,0.107D+03,0.92670000D+00,0.99440000D+00
     .,0.87298300D+02,0.181D+03,0.108D+03,0.92670000D+00,0.99250000D+00
     .,0.59255000D+02,0.181D+03,0.109D+03,0.92670000D+00,0.99820000D+00
     .,0.37528460D+03,0.181D+03,0.111D+03,0.92670000D+00,0.96840000D+00
     .,0.58220680D+03,0.181D+03,0.112D+03,0.92670000D+00,0.96280000D+00
     ./)
      grimme_c6_parameters(  71501:  71600)=(/
     . 0.57956000D+03,0.181D+03,0.113D+03,0.92670000D+00,0.96480000D+00
     .,0.45468720D+03,0.181D+03,0.114D+03,0.92670000D+00,0.95070000D+00
     .,0.36616070D+03,0.181D+03,0.115D+03,0.92670000D+00,0.99470000D+00
     .,0.30633030D+03,0.181D+03,0.116D+03,0.92670000D+00,0.99480000D+00
     .,0.24776880D+03,0.181D+03,0.117D+03,0.92670000D+00,0.99720000D+00
     .,0.51164600D+03,0.181D+03,0.119D+03,0.92670000D+00,0.97670000D+00
     .,0.10224025D+04,0.181D+03,0.120D+03,0.92670000D+00,0.98310000D+00
     .,0.50090730D+03,0.181D+03,0.121D+03,0.92670000D+00,0.18627000D+01
     .,0.48349150D+03,0.181D+03,0.122D+03,0.92670000D+00,0.18299000D+01
     .,0.47405210D+03,0.181D+03,0.123D+03,0.92670000D+00,0.19138000D+01
     .,0.47089950D+03,0.181D+03,0.124D+03,0.92670000D+00,0.18269000D+01
     .,0.42804350D+03,0.181D+03,0.125D+03,0.92670000D+00,0.16406000D+01
     .,0.39493390D+03,0.181D+03,0.126D+03,0.92670000D+00,0.16483000D+01
     .,0.37686900D+03,0.181D+03,0.127D+03,0.92670000D+00,0.17149000D+01
     .,0.36882120D+03,0.181D+03,0.128D+03,0.92670000D+00,0.17937000D+01
     .,0.36776620D+03,0.181D+03,0.129D+03,0.92670000D+00,0.95760000D+00
     .,0.33940980D+03,0.181D+03,0.130D+03,0.92670000D+00,0.19419000D+01
     .,0.57125400D+03,0.181D+03,0.131D+03,0.92670000D+00,0.96010000D+00
     .,0.49237270D+03,0.181D+03,0.132D+03,0.92670000D+00,0.94340000D+00
     .,0.43551000D+03,0.181D+03,0.133D+03,0.92670000D+00,0.98890000D+00
     ./)
      grimme_c6_parameters(  71601:  71700)=(/
     . 0.39431080D+03,0.181D+03,0.134D+03,0.92670000D+00,0.99010000D+00
     .,0.34421330D+03,0.181D+03,0.135D+03,0.92670000D+00,0.99740000D+00
     .,0.60811700D+03,0.181D+03,0.137D+03,0.92670000D+00,0.97380000D+00
     .,0.12478398D+04,0.181D+03,0.138D+03,0.92670000D+00,0.98010000D+00
     .,0.92281660D+03,0.181D+03,0.139D+03,0.92670000D+00,0.19153000D+01
     .,0.66415540D+03,0.181D+03,0.140D+03,0.92670000D+00,0.19355000D+01
     .,0.67092560D+03,0.181D+03,0.141D+03,0.92670000D+00,0.19545000D+01
     .,0.62334490D+03,0.181D+03,0.142D+03,0.92670000D+00,0.19420000D+01
     .,0.71055610D+03,0.181D+03,0.143D+03,0.92670000D+00,0.16682000D+01
     .,0.53741150D+03,0.181D+03,0.144D+03,0.92670000D+00,0.18584000D+01
     .,0.50247720D+03,0.181D+03,0.145D+03,0.92670000D+00,0.19003000D+01
     .,0.46583490D+03,0.181D+03,0.146D+03,0.92670000D+00,0.18630000D+01
     .,0.45142980D+03,0.181D+03,0.147D+03,0.92670000D+00,0.96790000D+00
     .,0.44250690D+03,0.181D+03,0.148D+03,0.92670000D+00,0.19539000D+01
     .,0.72660300D+03,0.181D+03,0.149D+03,0.92670000D+00,0.96330000D+00
     .,0.64640140D+03,0.181D+03,0.150D+03,0.92670000D+00,0.95140000D+00
     .,0.59861930D+03,0.181D+03,0.151D+03,0.92670000D+00,0.97490000D+00
     .,0.56215510D+03,0.181D+03,0.152D+03,0.92670000D+00,0.98110000D+00
     .,0.50917420D+03,0.181D+03,0.153D+03,0.92670000D+00,0.99680000D+00
     .,0.70976410D+03,0.181D+03,0.155D+03,0.92670000D+00,0.99090000D+00
     ./)
      grimme_c6_parameters(  71701:  71800)=(/
     . 0.16307553D+04,0.181D+03,0.156D+03,0.92670000D+00,0.97970000D+00
     .,0.11718156D+04,0.181D+03,0.157D+03,0.92670000D+00,0.19373000D+01
     .,0.70286450D+03,0.181D+03,0.159D+03,0.92670000D+00,0.29425000D+01
     .,0.68822190D+03,0.181D+03,0.160D+03,0.92670000D+00,0.29455000D+01
     .,0.66593910D+03,0.181D+03,0.161D+03,0.92670000D+00,0.29413000D+01
     .,0.67082470D+03,0.181D+03,0.162D+03,0.92670000D+00,0.29300000D+01
     .,0.65173940D+03,0.181D+03,0.163D+03,0.92670000D+00,0.18286000D+01
     .,0.67537850D+03,0.181D+03,0.164D+03,0.92670000D+00,0.28732000D+01
     .,0.63315820D+03,0.181D+03,0.165D+03,0.92670000D+00,0.29086000D+01
     .,0.64713510D+03,0.181D+03,0.166D+03,0.92670000D+00,0.28965000D+01
     .,0.59975110D+03,0.181D+03,0.167D+03,0.92670000D+00,0.29242000D+01
     .,0.58222680D+03,0.181D+03,0.168D+03,0.92670000D+00,0.29282000D+01
     .,0.57881040D+03,0.181D+03,0.169D+03,0.92670000D+00,0.29246000D+01
     .,0.61017640D+03,0.181D+03,0.170D+03,0.92670000D+00,0.28482000D+01
     .,0.55877490D+03,0.181D+03,0.171D+03,0.92670000D+00,0.29219000D+01
     .,0.77870390D+03,0.181D+03,0.172D+03,0.92670000D+00,0.19254000D+01
     .,0.71593350D+03,0.181D+03,0.173D+03,0.92670000D+00,0.19459000D+01
     .,0.64697310D+03,0.181D+03,0.174D+03,0.92670000D+00,0.19292000D+01
     .,0.66039260D+03,0.181D+03,0.175D+03,0.92670000D+00,0.18104000D+01
     .,0.56540350D+03,0.181D+03,0.176D+03,0.92670000D+00,0.18858000D+01
     ./)
      grimme_c6_parameters(  71801:  71900)=(/
     . 0.53044050D+03,0.181D+03,0.177D+03,0.92670000D+00,0.18648000D+01
     .,0.50586340D+03,0.181D+03,0.178D+03,0.92670000D+00,0.19188000D+01
     .,0.48403950D+03,0.181D+03,0.179D+03,0.92670000D+00,0.98460000D+00
     .,0.46395530D+03,0.181D+03,0.180D+03,0.92670000D+00,0.19896000D+01
     .,0.77861880D+03,0.181D+03,0.181D+03,0.92670000D+00,0.92670000D+00
     .,0.42434000D+02,0.182D+03,0.100D+01,0.93830000D+00,0.91180000D+00
     .,0.27907300D+02,0.182D+03,0.200D+01,0.93830000D+00,0.00000000D+00
     .,0.68807560D+03,0.182D+03,0.300D+01,0.93830000D+00,0.00000000D+00
     .,0.38943570D+03,0.182D+03,0.400D+01,0.93830000D+00,0.00000000D+00
     .,0.25945980D+03,0.182D+03,0.500D+01,0.93830000D+00,0.00000000D+00
     .,0.17407890D+03,0.182D+03,0.600D+01,0.93830000D+00,0.00000000D+00
     .,0.12124080D+03,0.182D+03,0.700D+01,0.93830000D+00,0.00000000D+00
     .,0.91603500D+02,0.182D+03,0.800D+01,0.93830000D+00,0.00000000D+00
     .,0.69320700D+02,0.182D+03,0.900D+01,0.93830000D+00,0.00000000D+00
     .,0.53310500D+02,0.182D+03,0.100D+02,0.93830000D+00,0.00000000D+00
     .,0.82197960D+03,0.182D+03,0.110D+02,0.93830000D+00,0.00000000D+00
     .,0.62284710D+03,0.182D+03,0.120D+02,0.93830000D+00,0.00000000D+00
     .,0.57078670D+03,0.182D+03,0.130D+02,0.93830000D+00,0.00000000D+00
     .,0.44634760D+03,0.182D+03,0.140D+02,0.93830000D+00,0.00000000D+00
     .,0.34597620D+03,0.182D+03,0.150D+02,0.93830000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  71901:  72000)=(/
     . 0.28614180D+03,0.182D+03,0.160D+02,0.93830000D+00,0.00000000D+00
     .,0.23303850D+03,0.182D+03,0.170D+02,0.93830000D+00,0.00000000D+00
     .,0.19023650D+03,0.182D+03,0.180D+02,0.93830000D+00,0.00000000D+00
     .,0.13514635D+04,0.182D+03,0.190D+02,0.93830000D+00,0.00000000D+00
     .,0.11015257D+04,0.182D+03,0.200D+02,0.93830000D+00,0.00000000D+00
     .,0.90751920D+03,0.182D+03,0.210D+02,0.93830000D+00,0.00000000D+00
     .,0.87424690D+03,0.182D+03,0.220D+02,0.93830000D+00,0.00000000D+00
     .,0.79942710D+03,0.182D+03,0.230D+02,0.93830000D+00,0.00000000D+00
     .,0.62978200D+03,0.182D+03,0.240D+02,0.93830000D+00,0.00000000D+00
     .,0.68687860D+03,0.182D+03,0.250D+02,0.93830000D+00,0.00000000D+00
     .,0.53901900D+03,0.182D+03,0.260D+02,0.93830000D+00,0.00000000D+00
     .,0.56943390D+03,0.182D+03,0.270D+02,0.93830000D+00,0.00000000D+00
     .,0.58746310D+03,0.182D+03,0.280D+02,0.93830000D+00,0.00000000D+00
     .,0.45054860D+03,0.182D+03,0.290D+02,0.93830000D+00,0.00000000D+00
     .,0.46028610D+03,0.182D+03,0.300D+02,0.93830000D+00,0.00000000D+00
     .,0.54568040D+03,0.182D+03,0.310D+02,0.93830000D+00,0.00000000D+00
     .,0.47836640D+03,0.182D+03,0.320D+02,0.93830000D+00,0.00000000D+00
     .,0.40593740D+03,0.182D+03,0.330D+02,0.93830000D+00,0.00000000D+00
     .,0.36317430D+03,0.182D+03,0.340D+02,0.93830000D+00,0.00000000D+00
     .,0.31692710D+03,0.182D+03,0.350D+02,0.93830000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72001:  72100)=(/
     . 0.27497470D+03,0.182D+03,0.360D+02,0.93830000D+00,0.00000000D+00
     .,0.15131000D+04,0.182D+03,0.370D+02,0.93830000D+00,0.00000000D+00
     .,0.13130553D+04,0.182D+03,0.380D+02,0.93830000D+00,0.00000000D+00
     .,0.11445456D+04,0.182D+03,0.390D+02,0.93830000D+00,0.00000000D+00
     .,0.10255674D+04,0.182D+03,0.400D+02,0.93830000D+00,0.00000000D+00
     .,0.93337410D+03,0.182D+03,0.410D+02,0.93830000D+00,0.00000000D+00
     .,0.71832310D+03,0.182D+03,0.420D+02,0.93830000D+00,0.00000000D+00
     .,0.80242420D+03,0.182D+03,0.430D+02,0.93830000D+00,0.00000000D+00
     .,0.60924720D+03,0.182D+03,0.440D+02,0.93830000D+00,0.00000000D+00
     .,0.66583460D+03,0.182D+03,0.450D+02,0.93830000D+00,0.00000000D+00
     .,0.61675520D+03,0.182D+03,0.460D+02,0.93830000D+00,0.00000000D+00
     .,0.51489300D+03,0.182D+03,0.470D+02,0.93830000D+00,0.00000000D+00
     .,0.54271640D+03,0.182D+03,0.480D+02,0.93830000D+00,0.00000000D+00
     .,0.68352170D+03,0.182D+03,0.490D+02,0.93830000D+00,0.00000000D+00
     .,0.62890890D+03,0.182D+03,0.500D+02,0.93830000D+00,0.00000000D+00
     .,0.55784160D+03,0.182D+03,0.510D+02,0.93830000D+00,0.00000000D+00
     .,0.51614750D+03,0.182D+03,0.520D+02,0.93830000D+00,0.00000000D+00
     .,0.46537870D+03,0.182D+03,0.530D+02,0.93830000D+00,0.00000000D+00
     .,0.41735550D+03,0.182D+03,0.540D+02,0.93830000D+00,0.00000000D+00
     .,0.18427711D+04,0.182D+03,0.550D+02,0.93830000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72101:  72200)=(/
     . 0.16767003D+04,0.182D+03,0.560D+02,0.93830000D+00,0.00000000D+00
     .,0.14657704D+04,0.182D+03,0.570D+02,0.93830000D+00,0.00000000D+00
     .,0.65962730D+03,0.182D+03,0.580D+02,0.93830000D+00,0.27991000D+01
     .,0.14834234D+04,0.182D+03,0.590D+02,0.93830000D+00,0.00000000D+00
     .,0.14232913D+04,0.182D+03,0.600D+02,0.93830000D+00,0.00000000D+00
     .,0.13872742D+04,0.182D+03,0.610D+02,0.93830000D+00,0.00000000D+00
     .,0.13541823D+04,0.182D+03,0.620D+02,0.93830000D+00,0.00000000D+00
     .,0.13248237D+04,0.182D+03,0.630D+02,0.93830000D+00,0.00000000D+00
     .,0.10362745D+04,0.182D+03,0.640D+02,0.93830000D+00,0.00000000D+00
     .,0.11761635D+04,0.182D+03,0.650D+02,0.93830000D+00,0.00000000D+00
     .,0.11332571D+04,0.182D+03,0.660D+02,0.93830000D+00,0.00000000D+00
     .,0.11934379D+04,0.182D+03,0.670D+02,0.93830000D+00,0.00000000D+00
     .,0.11679468D+04,0.182D+03,0.680D+02,0.93830000D+00,0.00000000D+00
     .,0.11448817D+04,0.182D+03,0.690D+02,0.93830000D+00,0.00000000D+00
     .,0.11317397D+04,0.182D+03,0.700D+02,0.93830000D+00,0.00000000D+00
     .,0.95008080D+03,0.182D+03,0.710D+02,0.93830000D+00,0.00000000D+00
     .,0.92948800D+03,0.182D+03,0.720D+02,0.93830000D+00,0.00000000D+00
     .,0.84577140D+03,0.182D+03,0.730D+02,0.93830000D+00,0.00000000D+00
     .,0.71270800D+03,0.182D+03,0.740D+02,0.93830000D+00,0.00000000D+00
     .,0.72421000D+03,0.182D+03,0.750D+02,0.93830000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72201:  72300)=(/
     . 0.65478150D+03,0.182D+03,0.760D+02,0.93830000D+00,0.00000000D+00
     .,0.59854060D+03,0.182D+03,0.770D+02,0.93830000D+00,0.00000000D+00
     .,0.49639040D+03,0.182D+03,0.780D+02,0.93830000D+00,0.00000000D+00
     .,0.46349930D+03,0.182D+03,0.790D+02,0.93830000D+00,0.00000000D+00
     .,0.47629930D+03,0.182D+03,0.800D+02,0.93830000D+00,0.00000000D+00
     .,0.70116210D+03,0.182D+03,0.810D+02,0.93830000D+00,0.00000000D+00
     .,0.68285450D+03,0.182D+03,0.820D+02,0.93830000D+00,0.00000000D+00
     .,0.62480060D+03,0.182D+03,0.830D+02,0.93830000D+00,0.00000000D+00
     .,0.59446280D+03,0.182D+03,0.840D+02,0.93830000D+00,0.00000000D+00
     .,0.54711560D+03,0.182D+03,0.850D+02,0.93830000D+00,0.00000000D+00
     .,0.50027110D+03,0.182D+03,0.860D+02,0.93830000D+00,0.00000000D+00
     .,0.17331333D+04,0.182D+03,0.870D+02,0.93830000D+00,0.00000000D+00
     .,0.16537357D+04,0.182D+03,0.880D+02,0.93830000D+00,0.00000000D+00
     .,0.14552479D+04,0.182D+03,0.890D+02,0.93830000D+00,0.00000000D+00
     .,0.13011870D+04,0.182D+03,0.900D+02,0.93830000D+00,0.00000000D+00
     .,0.12953664D+04,0.182D+03,0.910D+02,0.93830000D+00,0.00000000D+00
     .,0.12541422D+04,0.182D+03,0.920D+02,0.93830000D+00,0.00000000D+00
     .,0.12955258D+04,0.182D+03,0.930D+02,0.93830000D+00,0.00000000D+00
     .,0.12538462D+04,0.182D+03,0.940D+02,0.93830000D+00,0.00000000D+00
     .,0.68700900D+02,0.182D+03,0.101D+03,0.93830000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72301:  72400)=(/
     . 0.22605860D+03,0.182D+03,0.103D+03,0.93830000D+00,0.98650000D+00
     .,0.28775870D+03,0.182D+03,0.104D+03,0.93830000D+00,0.98080000D+00
     .,0.21782360D+03,0.182D+03,0.105D+03,0.93830000D+00,0.97060000D+00
     .,0.16333240D+03,0.182D+03,0.106D+03,0.93830000D+00,0.98680000D+00
     .,0.11306740D+03,0.182D+03,0.107D+03,0.93830000D+00,0.99440000D+00
     .,0.82111500D+02,0.182D+03,0.108D+03,0.93830000D+00,0.99250000D+00
     .,0.56344500D+02,0.182D+03,0.109D+03,0.93830000D+00,0.99820000D+00
     .,0.33128460D+03,0.182D+03,0.111D+03,0.93830000D+00,0.96840000D+00
     .,0.51267930D+03,0.182D+03,0.112D+03,0.93830000D+00,0.96280000D+00
     .,0.51659790D+03,0.182D+03,0.113D+03,0.93830000D+00,0.96480000D+00
     .,0.41211230D+03,0.182D+03,0.114D+03,0.93830000D+00,0.95070000D+00
     .,0.33577950D+03,0.182D+03,0.115D+03,0.93830000D+00,0.99470000D+00
     .,0.28302980D+03,0.182D+03,0.116D+03,0.93830000D+00,0.99480000D+00
     .,0.23064950D+03,0.182D+03,0.117D+03,0.93830000D+00,0.99720000D+00
     .,0.45512070D+03,0.182D+03,0.119D+03,0.93830000D+00,0.97670000D+00
     .,0.88099550D+03,0.182D+03,0.120D+03,0.93830000D+00,0.98310000D+00
     .,0.45242230D+03,0.182D+03,0.121D+03,0.93830000D+00,0.18627000D+01
     .,0.43671780D+03,0.182D+03,0.122D+03,0.93830000D+00,0.18299000D+01
     .,0.42807670D+03,0.182D+03,0.123D+03,0.93830000D+00,0.19138000D+01
     .,0.42446770D+03,0.182D+03,0.124D+03,0.93830000D+00,0.18269000D+01
     ./)
      grimme_c6_parameters(  72401:  72500)=(/
     . 0.38917610D+03,0.182D+03,0.125D+03,0.93830000D+00,0.16406000D+01
     .,0.35985440D+03,0.182D+03,0.126D+03,0.93830000D+00,0.16483000D+01
     .,0.34332520D+03,0.182D+03,0.127D+03,0.93830000D+00,0.17149000D+01
     .,0.33576340D+03,0.182D+03,0.128D+03,0.93830000D+00,0.17937000D+01
     .,0.33269860D+03,0.182D+03,0.129D+03,0.93830000D+00,0.95760000D+00
     .,0.31058260D+03,0.182D+03,0.130D+03,0.93830000D+00,0.19419000D+01
     .,0.51174530D+03,0.182D+03,0.131D+03,0.93830000D+00,0.96010000D+00
     .,0.44693270D+03,0.182D+03,0.132D+03,0.93830000D+00,0.94340000D+00
     .,0.39894250D+03,0.182D+03,0.133D+03,0.93830000D+00,0.98890000D+00
     .,0.36333700D+03,0.182D+03,0.134D+03,0.93830000D+00,0.99010000D+00
     .,0.31918450D+03,0.182D+03,0.135D+03,0.93830000D+00,0.99740000D+00
     .,0.54238170D+03,0.182D+03,0.137D+03,0.93830000D+00,0.97380000D+00
     .,0.10728240D+04,0.182D+03,0.138D+03,0.93830000D+00,0.98010000D+00
     .,0.81213110D+03,0.182D+03,0.139D+03,0.93830000D+00,0.19153000D+01
     .,0.59868520D+03,0.182D+03,0.140D+03,0.93830000D+00,0.19355000D+01
     .,0.60472750D+03,0.182D+03,0.141D+03,0.93830000D+00,0.19545000D+01
     .,0.56326320D+03,0.182D+03,0.142D+03,0.93830000D+00,0.19420000D+01
     .,0.63469440D+03,0.182D+03,0.143D+03,0.93830000D+00,0.16682000D+01
     .,0.48944530D+03,0.182D+03,0.144D+03,0.93830000D+00,0.18584000D+01
     .,0.45783760D+03,0.182D+03,0.145D+03,0.93830000D+00,0.19003000D+01
     ./)
      grimme_c6_parameters(  72501:  72600)=(/
     . 0.42497290D+03,0.182D+03,0.146D+03,0.93830000D+00,0.18630000D+01
     .,0.41137260D+03,0.182D+03,0.147D+03,0.93830000D+00,0.96790000D+00
     .,0.40583020D+03,0.182D+03,0.148D+03,0.93830000D+00,0.19539000D+01
     .,0.65042200D+03,0.182D+03,0.149D+03,0.93830000D+00,0.96330000D+00
     .,0.58543790D+03,0.182D+03,0.150D+03,0.93830000D+00,0.95140000D+00
     .,0.54638190D+03,0.182D+03,0.151D+03,0.93830000D+00,0.97490000D+00
     .,0.51567690D+03,0.182D+03,0.152D+03,0.93830000D+00,0.98110000D+00
     .,0.46975780D+03,0.182D+03,0.153D+03,0.93830000D+00,0.99680000D+00
     .,0.63871850D+03,0.182D+03,0.155D+03,0.93830000D+00,0.99090000D+00
     .,0.13938082D+04,0.182D+03,0.156D+03,0.93830000D+00,0.97970000D+00
     .,0.10287291D+04,0.182D+03,0.157D+03,0.93830000D+00,0.19373000D+01
     .,0.63957980D+03,0.182D+03,0.159D+03,0.93830000D+00,0.29425000D+01
     .,0.62632970D+03,0.182D+03,0.160D+03,0.93830000D+00,0.29455000D+01
     .,0.60635080D+03,0.182D+03,0.161D+03,0.93830000D+00,0.29413000D+01
     .,0.60975710D+03,0.182D+03,0.162D+03,0.93830000D+00,0.29300000D+01
     .,0.58924030D+03,0.182D+03,0.163D+03,0.93830000D+00,0.18286000D+01
     .,0.61369780D+03,0.182D+03,0.164D+03,0.93830000D+00,0.28732000D+01
     .,0.57611550D+03,0.182D+03,0.165D+03,0.93830000D+00,0.29086000D+01
     .,0.58697030D+03,0.182D+03,0.166D+03,0.93830000D+00,0.28965000D+01
     .,0.54649440D+03,0.182D+03,0.167D+03,0.93830000D+00,0.29242000D+01
     ./)
      grimme_c6_parameters(  72601:  72700)=(/
     . 0.53080340D+03,0.182D+03,0.168D+03,0.93830000D+00,0.29282000D+01
     .,0.52748330D+03,0.182D+03,0.169D+03,0.93830000D+00,0.29246000D+01
     .,0.55493190D+03,0.182D+03,0.170D+03,0.93830000D+00,0.28482000D+01
     .,0.50965210D+03,0.182D+03,0.171D+03,0.93830000D+00,0.29219000D+01
     .,0.69621110D+03,0.182D+03,0.172D+03,0.93830000D+00,0.19254000D+01
     .,0.64434370D+03,0.182D+03,0.173D+03,0.93830000D+00,0.19459000D+01
     .,0.58625070D+03,0.182D+03,0.174D+03,0.93830000D+00,0.19292000D+01
     .,0.59480320D+03,0.182D+03,0.175D+03,0.93830000D+00,0.18104000D+01
     .,0.51723940D+03,0.182D+03,0.176D+03,0.93830000D+00,0.18858000D+01
     .,0.48623500D+03,0.182D+03,0.177D+03,0.93830000D+00,0.18648000D+01
     .,0.46424430D+03,0.182D+03,0.178D+03,0.93830000D+00,0.19188000D+01
     .,0.44400340D+03,0.182D+03,0.179D+03,0.93830000D+00,0.98460000D+00
     .,0.42798590D+03,0.182D+03,0.180D+03,0.93830000D+00,0.19896000D+01
     .,0.69795700D+03,0.182D+03,0.181D+03,0.93830000D+00,0.92670000D+00
     .,0.63299910D+03,0.182D+03,0.182D+03,0.93830000D+00,0.93830000D+00
     .,0.41596400D+02,0.183D+03,0.100D+01,0.98200000D+00,0.91180000D+00
     .,0.27609300D+02,0.183D+03,0.200D+01,0.98200000D+00,0.00000000D+00
     .,0.63913910D+03,0.183D+03,0.300D+01,0.98200000D+00,0.00000000D+00
     .,0.37140510D+03,0.183D+03,0.400D+01,0.98200000D+00,0.00000000D+00
     .,0.25081810D+03,0.183D+03,0.500D+01,0.98200000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72701:  72800)=(/
     . 0.16984210D+03,0.183D+03,0.600D+01,0.98200000D+00,0.00000000D+00
     .,0.11903470D+03,0.183D+03,0.700D+01,0.98200000D+00,0.00000000D+00
     .,0.90305200D+02,0.183D+03,0.800D+01,0.98200000D+00,0.00000000D+00
     .,0.68559300D+02,0.183D+03,0.900D+01,0.98200000D+00,0.00000000D+00
     .,0.52850100D+02,0.183D+03,0.100D+02,0.98200000D+00,0.00000000D+00
     .,0.76472640D+03,0.183D+03,0.110D+02,0.98200000D+00,0.00000000D+00
     .,0.59132420D+03,0.183D+03,0.120D+02,0.98200000D+00,0.00000000D+00
     .,0.54586550D+03,0.183D+03,0.130D+02,0.98200000D+00,0.00000000D+00
     .,0.43092720D+03,0.183D+03,0.140D+02,0.98200000D+00,0.00000000D+00
     .,0.33654820D+03,0.183D+03,0.150D+02,0.98200000D+00,0.00000000D+00
     .,0.27961500D+03,0.183D+03,0.160D+02,0.98200000D+00,0.00000000D+00
     .,0.22867090D+03,0.183D+03,0.170D+02,0.98200000D+00,0.00000000D+00
     .,0.18730610D+03,0.183D+03,0.180D+02,0.98200000D+00,0.00000000D+00
     .,0.12519864D+04,0.183D+03,0.190D+02,0.98200000D+00,0.00000000D+00
     .,0.10371898D+04,0.183D+03,0.200D+02,0.98200000D+00,0.00000000D+00
     .,0.85756950D+03,0.183D+03,0.210D+02,0.98200000D+00,0.00000000D+00
     .,0.82873520D+03,0.183D+03,0.220D+02,0.98200000D+00,0.00000000D+00
     .,0.75924150D+03,0.183D+03,0.230D+02,0.98200000D+00,0.00000000D+00
     .,0.59825830D+03,0.183D+03,0.240D+02,0.98200000D+00,0.00000000D+00
     .,0.65412160D+03,0.183D+03,0.250D+02,0.98200000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72801:  72900)=(/
     . 0.51359410D+03,0.183D+03,0.260D+02,0.98200000D+00,0.00000000D+00
     .,0.54475080D+03,0.183D+03,0.270D+02,0.98200000D+00,0.00000000D+00
     .,0.56093530D+03,0.183D+03,0.280D+02,0.98200000D+00,0.00000000D+00
     .,0.43021600D+03,0.183D+03,0.290D+02,0.98200000D+00,0.00000000D+00
     .,0.44212850D+03,0.183D+03,0.300D+02,0.98200000D+00,0.00000000D+00
     .,0.52324780D+03,0.183D+03,0.310D+02,0.98200000D+00,0.00000000D+00
     .,0.46207160D+03,0.183D+03,0.320D+02,0.98200000D+00,0.00000000D+00
     .,0.39458520D+03,0.183D+03,0.330D+02,0.98200000D+00,0.00000000D+00
     .,0.35432910D+03,0.183D+03,0.340D+02,0.98200000D+00,0.00000000D+00
     .,0.31033860D+03,0.183D+03,0.350D+02,0.98200000D+00,0.00000000D+00
     .,0.27012000D+03,0.183D+03,0.360D+02,0.98200000D+00,0.00000000D+00
     .,0.14036411D+04,0.183D+03,0.370D+02,0.98200000D+00,0.00000000D+00
     .,0.12355778D+04,0.183D+03,0.380D+02,0.98200000D+00,0.00000000D+00
     .,0.10837333D+04,0.183D+03,0.390D+02,0.98200000D+00,0.00000000D+00
     .,0.97477890D+03,0.183D+03,0.400D+02,0.98200000D+00,0.00000000D+00
     .,0.88933630D+03,0.183D+03,0.410D+02,0.98200000D+00,0.00000000D+00
     .,0.68726090D+03,0.183D+03,0.420D+02,0.98200000D+00,0.00000000D+00
     .,0.76655860D+03,0.183D+03,0.430D+02,0.98200000D+00,0.00000000D+00
     .,0.58463360D+03,0.183D+03,0.440D+02,0.98200000D+00,0.00000000D+00
     .,0.63898360D+03,0.183D+03,0.450D+02,0.98200000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  72901:  73000)=(/
     . 0.59276900D+03,0.183D+03,0.460D+02,0.98200000D+00,0.00000000D+00
     .,0.49433450D+03,0.183D+03,0.470D+02,0.98200000D+00,0.00000000D+00
     .,0.52259600D+03,0.183D+03,0.480D+02,0.98200000D+00,0.00000000D+00
     .,0.65509190D+03,0.183D+03,0.490D+02,0.98200000D+00,0.00000000D+00
     .,0.60640770D+03,0.183D+03,0.500D+02,0.98200000D+00,0.00000000D+00
     .,0.54093950D+03,0.183D+03,0.510D+02,0.98200000D+00,0.00000000D+00
     .,0.50216500D+03,0.183D+03,0.520D+02,0.98200000D+00,0.00000000D+00
     .,0.45432770D+03,0.183D+03,0.530D+02,0.98200000D+00,0.00000000D+00
     .,0.40872120D+03,0.183D+03,0.540D+02,0.98200000D+00,0.00000000D+00
     .,0.17098764D+04,0.183D+03,0.550D+02,0.98200000D+00,0.00000000D+00
     .,0.15744445D+04,0.183D+03,0.560D+02,0.98200000D+00,0.00000000D+00
     .,0.13849862D+04,0.183D+03,0.570D+02,0.98200000D+00,0.00000000D+00
     .,0.63893210D+03,0.183D+03,0.580D+02,0.98200000D+00,0.27991000D+01
     .,0.13958040D+04,0.183D+03,0.590D+02,0.98200000D+00,0.00000000D+00
     .,0.13406235D+04,0.183D+03,0.600D+02,0.98200000D+00,0.00000000D+00
     .,0.13070810D+04,0.183D+03,0.610D+02,0.98200000D+00,0.00000000D+00
     .,0.12762220D+04,0.183D+03,0.620D+02,0.98200000D+00,0.00000000D+00
     .,0.12488582D+04,0.183D+03,0.630D+02,0.98200000D+00,0.00000000D+00
     .,0.98347160D+03,0.183D+03,0.640D+02,0.98200000D+00,0.00000000D+00
     .,0.11050192D+04,0.183D+03,0.650D+02,0.98200000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  73001:  73100)=(/
     . 0.10659790D+04,0.183D+03,0.660D+02,0.98200000D+00,0.00000000D+00
     .,0.11267767D+04,0.183D+03,0.670D+02,0.98200000D+00,0.00000000D+00
     .,0.11029019D+04,0.183D+03,0.680D+02,0.98200000D+00,0.00000000D+00
     .,0.10813880D+04,0.183D+03,0.690D+02,0.98200000D+00,0.00000000D+00
     .,0.10686785D+04,0.183D+03,0.700D+02,0.98200000D+00,0.00000000D+00
     .,0.90128220D+03,0.183D+03,0.710D+02,0.98200000D+00,0.00000000D+00
     .,0.88729660D+03,0.183D+03,0.720D+02,0.98200000D+00,0.00000000D+00
     .,0.81034560D+03,0.183D+03,0.730D+02,0.98200000D+00,0.00000000D+00
     .,0.68471570D+03,0.183D+03,0.740D+02,0.98200000D+00,0.00000000D+00
     .,0.69676070D+03,0.183D+03,0.750D+02,0.98200000D+00,0.00000000D+00
     .,0.63189030D+03,0.183D+03,0.760D+02,0.98200000D+00,0.00000000D+00
     .,0.57901680D+03,0.183D+03,0.770D+02,0.98200000D+00,0.00000000D+00
     .,0.48134860D+03,0.183D+03,0.780D+02,0.98200000D+00,0.00000000D+00
     .,0.44988030D+03,0.183D+03,0.790D+02,0.98200000D+00,0.00000000D+00
     .,0.46287080D+03,0.183D+03,0.800D+02,0.98200000D+00,0.00000000D+00
     .,0.67290150D+03,0.183D+03,0.810D+02,0.98200000D+00,0.00000000D+00
     .,0.65843910D+03,0.183D+03,0.820D+02,0.98200000D+00,0.00000000D+00
     .,0.60554990D+03,0.183D+03,0.830D+02,0.98200000D+00,0.00000000D+00
     .,0.57780740D+03,0.183D+03,0.840D+02,0.98200000D+00,0.00000000D+00
     .,0.53356470D+03,0.183D+03,0.850D+02,0.98200000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  73101:  73200)=(/
     . 0.48931160D+03,0.183D+03,0.860D+02,0.98200000D+00,0.00000000D+00
     .,0.16162977D+04,0.183D+03,0.870D+02,0.98200000D+00,0.00000000D+00
     .,0.15578929D+04,0.183D+03,0.880D+02,0.98200000D+00,0.00000000D+00
     .,0.13787984D+04,0.183D+03,0.890D+02,0.98200000D+00,0.00000000D+00
     .,0.12407328D+04,0.183D+03,0.900D+02,0.98200000D+00,0.00000000D+00
     .,0.12312018D+04,0.183D+03,0.910D+02,0.98200000D+00,0.00000000D+00
     .,0.11922019D+04,0.183D+03,0.920D+02,0.98200000D+00,0.00000000D+00
     .,0.12266358D+04,0.183D+03,0.930D+02,0.98200000D+00,0.00000000D+00
     .,0.11880528D+04,0.183D+03,0.940D+02,0.98200000D+00,0.00000000D+00
     .,0.66885700D+02,0.183D+03,0.101D+03,0.98200000D+00,0.00000000D+00
     .,0.21599080D+03,0.183D+03,0.103D+03,0.98200000D+00,0.98650000D+00
     .,0.27562110D+03,0.183D+03,0.104D+03,0.98200000D+00,0.98080000D+00
     .,0.21110780D+03,0.183D+03,0.105D+03,0.98200000D+00,0.97060000D+00
     .,0.15930450D+03,0.183D+03,0.106D+03,0.98200000D+00,0.98680000D+00
     .,0.11100780D+03,0.183D+03,0.107D+03,0.98200000D+00,0.99440000D+00
     .,0.81023800D+02,0.183D+03,0.108D+03,0.98200000D+00,0.99250000D+00
     .,0.55921600D+02,0.183D+03,0.109D+03,0.98200000D+00,0.99820000D+00
     .,0.31569470D+03,0.183D+03,0.111D+03,0.98200000D+00,0.96840000D+00
     .,0.48798840D+03,0.183D+03,0.112D+03,0.98200000D+00,0.96280000D+00
     .,0.49488070D+03,0.183D+03,0.113D+03,0.98200000D+00,0.96480000D+00
     ./)
      grimme_c6_parameters(  73201:  73300)=(/
     . 0.39838950D+03,0.183D+03,0.114D+03,0.98200000D+00,0.95070000D+00
     .,0.32670150D+03,0.183D+03,0.115D+03,0.98200000D+00,0.99470000D+00
     .,0.27653670D+03,0.183D+03,0.116D+03,0.98200000D+00,0.99480000D+00
     .,0.22630380D+03,0.183D+03,0.117D+03,0.98200000D+00,0.99720000D+00
     .,0.43578520D+03,0.183D+03,0.119D+03,0.98200000D+00,0.97670000D+00
     .,0.82978660D+03,0.183D+03,0.120D+03,0.98200000D+00,0.98310000D+00
     .,0.43655630D+03,0.183D+03,0.121D+03,0.98200000D+00,0.18627000D+01
     .,0.42148580D+03,0.183D+03,0.122D+03,0.98200000D+00,0.18299000D+01
     .,0.41307940D+03,0.183D+03,0.123D+03,0.98200000D+00,0.19138000D+01
     .,0.40921130D+03,0.183D+03,0.124D+03,0.98200000D+00,0.18269000D+01
     .,0.37685240D+03,0.183D+03,0.125D+03,0.98200000D+00,0.16406000D+01
     .,0.34888250D+03,0.183D+03,0.126D+03,0.98200000D+00,0.16483000D+01
     .,0.33284050D+03,0.183D+03,0.127D+03,0.98200000D+00,0.17149000D+01
     .,0.32538910D+03,0.183D+03,0.128D+03,0.98200000D+00,0.17937000D+01
     .,0.32133350D+03,0.183D+03,0.129D+03,0.98200000D+00,0.95760000D+00
     .,0.30179750D+03,0.183D+03,0.130D+03,0.98200000D+00,0.19419000D+01
     .,0.49162320D+03,0.183D+03,0.131D+03,0.98200000D+00,0.96010000D+00
     .,0.43241530D+03,0.183D+03,0.132D+03,0.98200000D+00,0.94340000D+00
     .,0.38792100D+03,0.183D+03,0.133D+03,0.98200000D+00,0.98890000D+00
     .,0.35446370D+03,0.183D+03,0.134D+03,0.98200000D+00,0.99010000D+00
     ./)
      grimme_c6_parameters(  73301:  73400)=(/
     . 0.31248750D+03,0.183D+03,0.135D+03,0.98200000D+00,0.99740000D+00
     .,0.52015670D+03,0.183D+03,0.137D+03,0.98200000D+00,0.97380000D+00
     .,0.10095291D+04,0.183D+03,0.138D+03,0.98200000D+00,0.98010000D+00
     .,0.77362030D+03,0.183D+03,0.139D+03,0.98200000D+00,0.19153000D+01
     .,0.57727760D+03,0.183D+03,0.140D+03,0.98200000D+00,0.19355000D+01
     .,0.58300940D+03,0.183D+03,0.141D+03,0.98200000D+00,0.19545000D+01
     .,0.54383670D+03,0.183D+03,0.142D+03,0.98200000D+00,0.19420000D+01
     .,0.60923200D+03,0.183D+03,0.143D+03,0.98200000D+00,0.16682000D+01
     .,0.47449870D+03,0.183D+03,0.144D+03,0.98200000D+00,0.18584000D+01
     .,0.44399260D+03,0.183D+03,0.145D+03,0.98200000D+00,0.19003000D+01
     .,0.41240560D+03,0.183D+03,0.146D+03,0.98200000D+00,0.18630000D+01
     .,0.39894980D+03,0.183D+03,0.147D+03,0.98200000D+00,0.96790000D+00
     .,0.39486670D+03,0.183D+03,0.148D+03,0.98200000D+00,0.19539000D+01
     .,0.62469100D+03,0.183D+03,0.149D+03,0.98200000D+00,0.96330000D+00
     .,0.56575460D+03,0.183D+03,0.150D+03,0.98200000D+00,0.95140000D+00
     .,0.53022150D+03,0.183D+03,0.151D+03,0.98200000D+00,0.97490000D+00
     .,0.50181220D+03,0.183D+03,0.152D+03,0.98200000D+00,0.98110000D+00
     .,0.45858080D+03,0.183D+03,0.153D+03,0.98200000D+00,0.99680000D+00
     .,0.61548530D+03,0.183D+03,0.155D+03,0.98200000D+00,0.99090000D+00
     .,0.13081372D+04,0.183D+03,0.156D+03,0.98200000D+00,0.97970000D+00
     ./)
      grimme_c6_parameters(  73401:  73500)=(/
     . 0.97887630D+03,0.183D+03,0.157D+03,0.98200000D+00,0.19373000D+01
     .,0.61971040D+03,0.183D+03,0.159D+03,0.98200000D+00,0.29425000D+01
     .,0.60690590D+03,0.183D+03,0.160D+03,0.98200000D+00,0.29455000D+01
     .,0.58770740D+03,0.183D+03,0.161D+03,0.98200000D+00,0.29413000D+01
     .,0.59049670D+03,0.183D+03,0.162D+03,0.98200000D+00,0.29300000D+01
     .,0.56898830D+03,0.183D+03,0.163D+03,0.98200000D+00,0.18286000D+01
     .,0.59417810D+03,0.183D+03,0.164D+03,0.98200000D+00,0.28732000D+01
     .,0.55818530D+03,0.183D+03,0.165D+03,0.98200000D+00,0.29086000D+01
     .,0.56779730D+03,0.183D+03,0.166D+03,0.98200000D+00,0.28965000D+01
     .,0.52988060D+03,0.183D+03,0.167D+03,0.98200000D+00,0.29242000D+01
     .,0.51480880D+03,0.183D+03,0.168D+03,0.98200000D+00,0.29282000D+01
     .,0.51148010D+03,0.183D+03,0.169D+03,0.98200000D+00,0.29246000D+01
     .,0.53747970D+03,0.183D+03,0.170D+03,0.98200000D+00,0.28482000D+01
     .,0.49440600D+03,0.183D+03,0.171D+03,0.98200000D+00,0.29219000D+01
     .,0.66852110D+03,0.183D+03,0.172D+03,0.98200000D+00,0.19254000D+01
     .,0.62087010D+03,0.183D+03,0.173D+03,0.98200000D+00,0.19459000D+01
     .,0.56690460D+03,0.183D+03,0.174D+03,0.98200000D+00,0.19292000D+01
     .,0.57334500D+03,0.183D+03,0.175D+03,0.98200000D+00,0.18104000D+01
     .,0.50267320D+03,0.183D+03,0.176D+03,0.98200000D+00,0.18858000D+01
     .,0.47305980D+03,0.183D+03,0.177D+03,0.98200000D+00,0.18648000D+01
     ./)
      grimme_c6_parameters(  73501:  73600)=(/
     . 0.45195060D+03,0.183D+03,0.178D+03,0.98200000D+00,0.19188000D+01
     .,0.43215130D+03,0.183D+03,0.179D+03,0.98200000D+00,0.98460000D+00
     .,0.41777890D+03,0.183D+03,0.180D+03,0.98200000D+00,0.19896000D+01
     .,0.67100110D+03,0.183D+03,0.181D+03,0.98200000D+00,0.92670000D+00
     .,0.61223660D+03,0.183D+03,0.182D+03,0.98200000D+00,0.93830000D+00
     .,0.59404570D+03,0.183D+03,0.183D+03,0.98200000D+00,0.98200000D+00
     .,0.40784000D+02,0.184D+03,0.100D+01,0.98150000D+00,0.91180000D+00
     .,0.27292700D+02,0.184D+03,0.200D+01,0.98150000D+00,0.00000000D+00
     .,0.60378280D+03,0.184D+03,0.300D+01,0.98150000D+00,0.00000000D+00
     .,0.35667730D+03,0.184D+03,0.400D+01,0.98150000D+00,0.00000000D+00
     .,0.24325530D+03,0.184D+03,0.500D+01,0.98150000D+00,0.00000000D+00
     .,0.16591800D+03,0.184D+03,0.600D+01,0.98150000D+00,0.00000000D+00
     .,0.11689210D+03,0.184D+03,0.700D+01,0.98150000D+00,0.00000000D+00
     .,0.88996000D+02,0.184D+03,0.800D+01,0.98150000D+00,0.00000000D+00
     .,0.67762500D+02,0.184D+03,0.900D+01,0.98150000D+00,0.00000000D+00
     .,0.52352000D+02,0.184D+03,0.100D+02,0.98150000D+00,0.00000000D+00
     .,0.72318320D+03,0.184D+03,0.110D+02,0.98150000D+00,0.00000000D+00
     .,0.56618910D+03,0.184D+03,0.120D+02,0.98150000D+00,0.00000000D+00
     .,0.52532650D+03,0.184D+03,0.130D+02,0.98150000D+00,0.00000000D+00
     .,0.41751820D+03,0.184D+03,0.140D+02,0.98150000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  73601:  73700)=(/
     . 0.32794200D+03,0.184D+03,0.150D+02,0.98150000D+00,0.00000000D+00
     .,0.27346760D+03,0.184D+03,0.160D+02,0.98150000D+00,0.00000000D+00
     .,0.22441640D+03,0.184D+03,0.170D+02,0.98150000D+00,0.00000000D+00
     .,0.18436010D+03,0.184D+03,0.180D+02,0.98150000D+00,0.00000000D+00
     .,0.11819863D+04,0.184D+03,0.190D+02,0.98150000D+00,0.00000000D+00
     .,0.98827090D+03,0.184D+03,0.200D+02,0.98150000D+00,0.00000000D+00
     .,0.81891600D+03,0.184D+03,0.210D+02,0.98150000D+00,0.00000000D+00
     .,0.79312700D+03,0.184D+03,0.220D+02,0.98150000D+00,0.00000000D+00
     .,0.72754910D+03,0.184D+03,0.230D+02,0.98150000D+00,0.00000000D+00
     .,0.57361570D+03,0.184D+03,0.240D+02,0.98150000D+00,0.00000000D+00
     .,0.62798280D+03,0.184D+03,0.250D+02,0.98150000D+00,0.00000000D+00
     .,0.49346120D+03,0.184D+03,0.260D+02,0.98150000D+00,0.00000000D+00
     .,0.52458090D+03,0.184D+03,0.270D+02,0.98150000D+00,0.00000000D+00
     .,0.53944100D+03,0.184D+03,0.280D+02,0.98150000D+00,0.00000000D+00
     .,0.41395970D+03,0.184D+03,0.290D+02,0.98150000D+00,0.00000000D+00
     .,0.42696110D+03,0.184D+03,0.300D+02,0.98150000D+00,0.00000000D+00
     .,0.50466270D+03,0.184D+03,0.310D+02,0.98150000D+00,0.00000000D+00
     .,0.44793420D+03,0.184D+03,0.320D+02,0.98150000D+00,0.00000000D+00
     .,0.38430870D+03,0.184D+03,0.330D+02,0.98150000D+00,0.00000000D+00
     .,0.34611240D+03,0.184D+03,0.340D+02,0.98150000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  73701:  73800)=(/
     . 0.30404010D+03,0.184D+03,0.350D+02,0.98150000D+00,0.00000000D+00
     .,0.26534650D+03,0.184D+03,0.360D+02,0.98150000D+00,0.00000000D+00
     .,0.13265708D+04,0.184D+03,0.370D+02,0.98150000D+00,0.00000000D+00
     .,0.11770902D+04,0.184D+03,0.380D+02,0.98150000D+00,0.00000000D+00
     .,0.10365660D+04,0.184D+03,0.390D+02,0.98150000D+00,0.00000000D+00
     .,0.93473590D+03,0.184D+03,0.400D+02,0.98150000D+00,0.00000000D+00
     .,0.85428840D+03,0.184D+03,0.410D+02,0.98150000D+00,0.00000000D+00
     .,0.66224370D+03,0.184D+03,0.420D+02,0.98150000D+00,0.00000000D+00
     .,0.73778930D+03,0.184D+03,0.430D+02,0.98150000D+00,0.00000000D+00
     .,0.56459860D+03,0.184D+03,0.440D+02,0.98150000D+00,0.00000000D+00
     .,0.61691080D+03,0.184D+03,0.450D+02,0.98150000D+00,0.00000000D+00
     .,0.57289550D+03,0.184D+03,0.460D+02,0.98150000D+00,0.00000000D+00
     .,0.47765720D+03,0.184D+03,0.470D+02,0.98150000D+00,0.00000000D+00
     .,0.50575670D+03,0.184D+03,0.480D+02,0.98150000D+00,0.00000000D+00
     .,0.63186020D+03,0.184D+03,0.490D+02,0.98150000D+00,0.00000000D+00
     .,0.58725260D+03,0.184D+03,0.500D+02,0.98150000D+00,0.00000000D+00
     .,0.52598230D+03,0.184D+03,0.510D+02,0.98150000D+00,0.00000000D+00
     .,0.48950040D+03,0.184D+03,0.520D+02,0.98150000D+00,0.00000000D+00
     .,0.44405350D+03,0.184D+03,0.530D+02,0.98150000D+00,0.00000000D+00
     .,0.40048270D+03,0.184D+03,0.540D+02,0.98150000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  73801:  73900)=(/
     . 0.16166889D+04,0.184D+03,0.550D+02,0.98150000D+00,0.00000000D+00
     .,0.14983060D+04,0.184D+03,0.560D+02,0.98150000D+00,0.00000000D+00
     .,0.13231799D+04,0.184D+03,0.570D+02,0.98150000D+00,0.00000000D+00
     .,0.62088910D+03,0.184D+03,0.580D+02,0.98150000D+00,0.27991000D+01
     .,0.13300657D+04,0.184D+03,0.590D+02,0.98150000D+00,0.00000000D+00
     .,0.12782459D+04,0.184D+03,0.600D+02,0.98150000D+00,0.00000000D+00
     .,0.12464709D+04,0.184D+03,0.610D+02,0.98150000D+00,0.00000000D+00
     .,0.12172125D+04,0.184D+03,0.620D+02,0.98150000D+00,0.00000000D+00
     .,0.11912765D+04,0.184D+03,0.630D+02,0.98150000D+00,0.00000000D+00
     .,0.94248920D+03,0.184D+03,0.640D+02,0.98150000D+00,0.00000000D+00
     .,0.10526025D+04,0.184D+03,0.650D+02,0.98150000D+00,0.00000000D+00
     .,0.10162272D+04,0.184D+03,0.660D+02,0.98150000D+00,0.00000000D+00
     .,0.10758235D+04,0.184D+03,0.670D+02,0.98150000D+00,0.00000000D+00
     .,0.10531221D+04,0.184D+03,0.680D+02,0.98150000D+00,0.00000000D+00
     .,0.10327245D+04,0.184D+03,0.690D+02,0.98150000D+00,0.00000000D+00
     .,0.10203815D+04,0.184D+03,0.700D+02,0.98150000D+00,0.00000000D+00
     .,0.86329250D+03,0.184D+03,0.710D+02,0.98150000D+00,0.00000000D+00
     .,0.85331590D+03,0.184D+03,0.720D+02,0.98150000D+00,0.00000000D+00
     .,0.78130510D+03,0.184D+03,0.730D+02,0.98150000D+00,0.00000000D+00
     .,0.66165650D+03,0.184D+03,0.740D+02,0.98150000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  73901:  74000)=(/
     . 0.67388930D+03,0.184D+03,0.750D+02,0.98150000D+00,0.00000000D+00
     .,0.61248620D+03,0.184D+03,0.760D+02,0.98150000D+00,0.00000000D+00
     .,0.56223340D+03,0.184D+03,0.770D+02,0.98150000D+00,0.00000000D+00
     .,0.46834590D+03,0.184D+03,0.780D+02,0.98150000D+00,0.00000000D+00
     .,0.43807020D+03,0.184D+03,0.790D+02,0.98150000D+00,0.00000000D+00
     .,0.45102990D+03,0.184D+03,0.800D+02,0.98150000D+00,0.00000000D+00
     .,0.64993220D+03,0.184D+03,0.810D+02,0.98150000D+00,0.00000000D+00
     .,0.63784100D+03,0.184D+03,0.820D+02,0.98150000D+00,0.00000000D+00
     .,0.58869220D+03,0.184D+03,0.830D+02,0.98150000D+00,0.00000000D+00
     .,0.56290490D+03,0.184D+03,0.840D+02,0.98150000D+00,0.00000000D+00
     .,0.52111770D+03,0.184D+03,0.850D+02,0.98150000D+00,0.00000000D+00
     .,0.47899830D+03,0.184D+03,0.860D+02,0.98150000D+00,0.00000000D+00
     .,0.15330137D+04,0.184D+03,0.870D+02,0.98150000D+00,0.00000000D+00
     .,0.14856837D+04,0.184D+03,0.880D+02,0.98150000D+00,0.00000000D+00
     .,0.13195792D+04,0.184D+03,0.890D+02,0.98150000D+00,0.00000000D+00
     .,0.11925537D+04,0.184D+03,0.900D+02,0.98150000D+00,0.00000000D+00
     .,0.11810674D+04,0.184D+03,0.910D+02,0.98150000D+00,0.00000000D+00
     .,0.11437723D+04,0.184D+03,0.920D+02,0.98150000D+00,0.00000000D+00
     .,0.11736700D+04,0.184D+03,0.930D+02,0.98150000D+00,0.00000000D+00
     .,0.11372796D+04,0.184D+03,0.940D+02,0.98150000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  74001:  74100)=(/
     . 0.65214600D+02,0.184D+03,0.101D+03,0.98150000D+00,0.00000000D+00
     .,0.20772960D+03,0.184D+03,0.103D+03,0.98150000D+00,0.98650000D+00
     .,0.26561960D+03,0.184D+03,0.104D+03,0.98150000D+00,0.98080000D+00
     .,0.20516820D+03,0.184D+03,0.105D+03,0.98150000D+00,0.97060000D+00
     .,0.15561880D+03,0.184D+03,0.106D+03,0.98150000D+00,0.98680000D+00
     .,0.10902870D+03,0.184D+03,0.107D+03,0.98150000D+00,0.99440000D+00
     .,0.79923000D+02,0.184D+03,0.108D+03,0.98150000D+00,0.99250000D+00
     .,0.55445000D+02,0.184D+03,0.109D+03,0.98150000D+00,0.99820000D+00
     .,0.30313050D+03,0.184D+03,0.111D+03,0.98150000D+00,0.96840000D+00
     .,0.46821060D+03,0.184D+03,0.112D+03,0.98150000D+00,0.96280000D+00
     .,0.47685900D+03,0.184D+03,0.113D+03,0.98150000D+00,0.96480000D+00
     .,0.38638850D+03,0.184D+03,0.114D+03,0.98150000D+00,0.95070000D+00
     .,0.31841620D+03,0.184D+03,0.115D+03,0.98150000D+00,0.99470000D+00
     .,0.27043650D+03,0.184D+03,0.116D+03,0.98150000D+00,0.99480000D+00
     .,0.22208000D+03,0.184D+03,0.117D+03,0.98150000D+00,0.99720000D+00
     .,0.42021160D+03,0.184D+03,0.119D+03,0.98150000D+00,0.97670000D+00
     .,0.79141640D+03,0.184D+03,0.120D+03,0.98150000D+00,0.98310000D+00
     .,0.42299690D+03,0.184D+03,0.121D+03,0.98150000D+00,0.18627000D+01
     .,0.40851000D+03,0.184D+03,0.122D+03,0.98150000D+00,0.18299000D+01
     .,0.40032420D+03,0.184D+03,0.123D+03,0.98150000D+00,0.19138000D+01
     ./)
      grimme_c6_parameters(  74101:  74200)=(/
     . 0.39632850D+03,0.184D+03,0.124D+03,0.98150000D+00,0.18269000D+01
     .,0.36605400D+03,0.184D+03,0.125D+03,0.98150000D+00,0.16406000D+01
     .,0.33920620D+03,0.184D+03,0.126D+03,0.98150000D+00,0.16483000D+01
     .,0.32362470D+03,0.184D+03,0.127D+03,0.98150000D+00,0.17149000D+01
     .,0.31630020D+03,0.184D+03,0.128D+03,0.98150000D+00,0.17937000D+01
     .,0.31163550D+03,0.184D+03,0.129D+03,0.98150000D+00,0.95760000D+00
     .,0.29390630D+03,0.184D+03,0.130D+03,0.98150000D+00,0.19419000D+01
     .,0.47478450D+03,0.184D+03,0.131D+03,0.98150000D+00,0.96010000D+00
     .,0.41970260D+03,0.184D+03,0.132D+03,0.98150000D+00,0.94340000D+00
     .,0.37792620D+03,0.184D+03,0.133D+03,0.98150000D+00,0.98890000D+00
     .,0.34623010D+03,0.184D+03,0.134D+03,0.98150000D+00,0.99010000D+00
     .,0.30609970D+03,0.184D+03,0.135D+03,0.98150000D+00,0.99740000D+00
     .,0.50220180D+03,0.184D+03,0.137D+03,0.98150000D+00,0.97380000D+00
     .,0.96252050D+03,0.184D+03,0.138D+03,0.98150000D+00,0.98010000D+00
     .,0.74349910D+03,0.184D+03,0.139D+03,0.98150000D+00,0.19153000D+01
     .,0.55925120D+03,0.184D+03,0.140D+03,0.98150000D+00,0.19355000D+01
     .,0.56472600D+03,0.184D+03,0.141D+03,0.98150000D+00,0.19545000D+01
     .,0.52739750D+03,0.184D+03,0.142D+03,0.98150000D+00,0.19420000D+01
     .,0.58857680D+03,0.184D+03,0.143D+03,0.98150000D+00,0.16682000D+01
     .,0.46147450D+03,0.184D+03,0.144D+03,0.98150000D+00,0.18584000D+01
     ./)
      grimme_c6_parameters(  74201:  74300)=(/
     . 0.43195260D+03,0.184D+03,0.145D+03,0.98150000D+00,0.19003000D+01
     .,0.40145890D+03,0.184D+03,0.146D+03,0.98150000D+00,0.18630000D+01
     .,0.38817970D+03,0.184D+03,0.147D+03,0.98150000D+00,0.96790000D+00
     .,0.38501900D+03,0.184D+03,0.148D+03,0.98150000D+00,0.19539000D+01
     .,0.60340750D+03,0.184D+03,0.149D+03,0.98150000D+00,0.96330000D+00
     .,0.54877650D+03,0.184D+03,0.150D+03,0.98150000D+00,0.95140000D+00
     .,0.51584790D+03,0.184D+03,0.151D+03,0.98150000D+00,0.97490000D+00
     .,0.48923280D+03,0.184D+03,0.152D+03,0.98150000D+00,0.98110000D+00
     .,0.44819060D+03,0.184D+03,0.153D+03,0.98150000D+00,0.99680000D+00
     .,0.59616690D+03,0.184D+03,0.155D+03,0.98150000D+00,0.99090000D+00
     .,0.12455740D+04,0.184D+03,0.156D+03,0.98150000D+00,0.97970000D+00
     .,0.94022950D+03,0.184D+03,0.157D+03,0.98150000D+00,0.19373000D+01
     .,0.60235500D+03,0.184D+03,0.159D+03,0.98150000D+00,0.29425000D+01
     .,0.58993220D+03,0.184D+03,0.160D+03,0.98150000D+00,0.29455000D+01
     .,0.57139080D+03,0.184D+03,0.161D+03,0.98150000D+00,0.29413000D+01
     .,0.57376380D+03,0.184D+03,0.162D+03,0.98150000D+00,0.29300000D+01
     .,0.55177910D+03,0.184D+03,0.163D+03,0.98150000D+00,0.18286000D+01
     .,0.57720750D+03,0.184D+03,0.164D+03,0.98150000D+00,0.28732000D+01
     .,0.54252310D+03,0.184D+03,0.165D+03,0.98150000D+00,0.29086000D+01
     .,0.55128420D+03,0.184D+03,0.166D+03,0.98150000D+00,0.28965000D+01
     ./)
      grimme_c6_parameters(  74301:  74400)=(/
     . 0.51527560D+03,0.184D+03,0.167D+03,0.98150000D+00,0.29242000D+01
     .,0.50071660D+03,0.184D+03,0.168D+03,0.98150000D+00,0.29282000D+01
     .,0.49739780D+03,0.184D+03,0.169D+03,0.98150000D+00,0.29246000D+01
     .,0.52220000D+03,0.184D+03,0.170D+03,0.98150000D+00,0.28482000D+01
     .,0.48093310D+03,0.184D+03,0.171D+03,0.98150000D+00,0.29219000D+01
     .,0.64584430D+03,0.184D+03,0.172D+03,0.98150000D+00,0.19254000D+01
     .,0.60127470D+03,0.184D+03,0.173D+03,0.98150000D+00,0.19459000D+01
     .,0.55039340D+03,0.184D+03,0.174D+03,0.98150000D+00,0.19292000D+01
     .,0.55542350D+03,0.184D+03,0.175D+03,0.98150000D+00,0.18104000D+01
     .,0.48976750D+03,0.184D+03,0.176D+03,0.98150000D+00,0.18858000D+01
     .,0.46132380D+03,0.184D+03,0.177D+03,0.98150000D+00,0.18648000D+01
     .,0.44097230D+03,0.184D+03,0.178D+03,0.98150000D+00,0.19188000D+01
     .,0.42163540D+03,0.184D+03,0.179D+03,0.98150000D+00,0.98460000D+00
     .,0.40842210D+03,0.184D+03,0.180D+03,0.98150000D+00,0.19896000D+01
     .,0.64879600D+03,0.184D+03,0.181D+03,0.98150000D+00,0.92670000D+00
     .,0.59436400D+03,0.184D+03,0.182D+03,0.98150000D+00,0.93830000D+00
     .,0.57797360D+03,0.184D+03,0.183D+03,0.98150000D+00,0.98200000D+00
     .,0.56324630D+03,0.184D+03,0.184D+03,0.98150000D+00,0.98150000D+00
     .,0.38512100D+02,0.185D+03,0.100D+01,0.99540000D+00,0.91180000D+00
     .,0.26111100D+02,0.185D+03,0.200D+01,0.99540000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  74401:  74500)=(/
     . 0.54178230D+03,0.185D+03,0.300D+01,0.99540000D+00,0.00000000D+00
     .,0.32704600D+03,0.185D+03,0.400D+01,0.99540000D+00,0.00000000D+00
     .,0.22612850D+03,0.185D+03,0.500D+01,0.99540000D+00,0.00000000D+00
     .,0.15586820D+03,0.185D+03,0.600D+01,0.99540000D+00,0.00000000D+00
     .,0.11068200D+03,0.185D+03,0.700D+01,0.99540000D+00,0.00000000D+00
     .,0.84740100D+02,0.185D+03,0.800D+01,0.99540000D+00,0.00000000D+00
     .,0.64828700D+02,0.185D+03,0.900D+01,0.99540000D+00,0.00000000D+00
     .,0.50274100D+02,0.185D+03,0.100D+02,0.99540000D+00,0.00000000D+00
     .,0.64991410D+03,0.185D+03,0.110D+02,0.99540000D+00,0.00000000D+00
     .,0.51713720D+03,0.185D+03,0.120D+02,0.99540000D+00,0.00000000D+00
     .,0.48314350D+03,0.185D+03,0.130D+02,0.99540000D+00,0.00000000D+00
     .,0.38756890D+03,0.185D+03,0.140D+02,0.99540000D+00,0.00000000D+00
     .,0.30689040D+03,0.185D+03,0.150D+02,0.99540000D+00,0.00000000D+00
     .,0.25730000D+03,0.185D+03,0.160D+02,0.99540000D+00,0.00000000D+00
     .,0.21224570D+03,0.185D+03,0.170D+02,0.99540000D+00,0.00000000D+00
     .,0.17515290D+03,0.185D+03,0.180D+02,0.99540000D+00,0.00000000D+00
     .,0.10605365D+04,0.185D+03,0.190D+02,0.99540000D+00,0.00000000D+00
     .,0.89715640D+03,0.185D+03,0.200D+02,0.99540000D+00,0.00000000D+00
     .,0.74554500D+03,0.185D+03,0.210D+02,0.99540000D+00,0.00000000D+00
     .,0.72428050D+03,0.185D+03,0.220D+02,0.99540000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  74501:  74600)=(/
     . 0.66556000D+03,0.185D+03,0.230D+02,0.99540000D+00,0.00000000D+00
     .,0.52534660D+03,0.185D+03,0.240D+02,0.99540000D+00,0.00000000D+00
     .,0.57594770D+03,0.185D+03,0.250D+02,0.99540000D+00,0.00000000D+00
     .,0.45323530D+03,0.185D+03,0.260D+02,0.99540000D+00,0.00000000D+00
     .,0.48311010D+03,0.185D+03,0.270D+02,0.99540000D+00,0.00000000D+00
     .,0.49587210D+03,0.185D+03,0.280D+02,0.99540000D+00,0.00000000D+00
     .,0.38099950D+03,0.185D+03,0.290D+02,0.99540000D+00,0.00000000D+00
     .,0.39473600D+03,0.185D+03,0.300D+02,0.99540000D+00,0.00000000D+00
     .,0.46567730D+03,0.185D+03,0.310D+02,0.99540000D+00,0.00000000D+00
     .,0.41619670D+03,0.185D+03,0.320D+02,0.99540000D+00,0.00000000D+00
     .,0.35943220D+03,0.185D+03,0.330D+02,0.99540000D+00,0.00000000D+00
     .,0.32508320D+03,0.185D+03,0.340D+02,0.99540000D+00,0.00000000D+00
     .,0.28681650D+03,0.185D+03,0.350D+02,0.99540000D+00,0.00000000D+00
     .,0.25132750D+03,0.185D+03,0.360D+02,0.99540000D+00,0.00000000D+00
     .,0.11921368D+04,0.185D+03,0.370D+02,0.99540000D+00,0.00000000D+00
     .,0.10684888D+04,0.185D+03,0.380D+02,0.99540000D+00,0.00000000D+00
     .,0.94594700D+03,0.185D+03,0.390D+02,0.99540000D+00,0.00000000D+00
     .,0.85598480D+03,0.185D+03,0.400D+02,0.99540000D+00,0.00000000D+00
     .,0.78421710D+03,0.185D+03,0.410D+02,0.99540000D+00,0.00000000D+00
     .,0.61069650D+03,0.185D+03,0.420D+02,0.99540000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  74601:  74700)=(/
     . 0.67919130D+03,0.185D+03,0.430D+02,0.99540000D+00,0.00000000D+00
     .,0.52232000D+03,0.185D+03,0.440D+02,0.99540000D+00,0.00000000D+00
     .,0.57034140D+03,0.185D+03,0.450D+02,0.99540000D+00,0.00000000D+00
     .,0.53043260D+03,0.185D+03,0.460D+02,0.99540000D+00,0.00000000D+00
     .,0.44233610D+03,0.185D+03,0.470D+02,0.99540000D+00,0.00000000D+00
     .,0.46916940D+03,0.185D+03,0.480D+02,0.99540000D+00,0.00000000D+00
     .,0.58336540D+03,0.185D+03,0.490D+02,0.99540000D+00,0.00000000D+00
     .,0.54506230D+03,0.185D+03,0.500D+02,0.99540000D+00,0.00000000D+00
     .,0.49091940D+03,0.185D+03,0.510D+02,0.99540000D+00,0.00000000D+00
     .,0.45847770D+03,0.185D+03,0.520D+02,0.99540000D+00,0.00000000D+00
     .,0.41750700D+03,0.185D+03,0.530D+02,0.99540000D+00,0.00000000D+00
     .,0.37792660D+03,0.185D+03,0.540D+02,0.99540000D+00,0.00000000D+00
     .,0.14538408D+04,0.185D+03,0.550D+02,0.99540000D+00,0.00000000D+00
     .,0.13583391D+04,0.185D+03,0.560D+02,0.99540000D+00,0.00000000D+00
     .,0.12057906D+04,0.185D+03,0.570D+02,0.99540000D+00,0.00000000D+00
     .,0.57911420D+03,0.185D+03,0.580D+02,0.99540000D+00,0.27991000D+01
     .,0.12080329D+04,0.185D+03,0.590D+02,0.99540000D+00,0.00000000D+00
     .,0.11618576D+04,0.185D+03,0.600D+02,0.99540000D+00,0.00000000D+00
     .,0.11332140D+04,0.185D+03,0.610D+02,0.99540000D+00,0.00000000D+00
     .,0.11068065D+04,0.185D+03,0.620D+02,0.99540000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  74701:  74800)=(/
     . 0.10834069D+04,0.185D+03,0.630D+02,0.99540000D+00,0.00000000D+00
     .,0.86266010D+03,0.185D+03,0.640D+02,0.99540000D+00,0.00000000D+00
     .,0.95596420D+03,0.185D+03,0.650D+02,0.99540000D+00,0.00000000D+00
     .,0.92391610D+03,0.185D+03,0.660D+02,0.99540000D+00,0.00000000D+00
     .,0.97957880D+03,0.185D+03,0.670D+02,0.99540000D+00,0.00000000D+00
     .,0.95900710D+03,0.185D+03,0.680D+02,0.99540000D+00,0.00000000D+00
     .,0.94059640D+03,0.185D+03,0.690D+02,0.99540000D+00,0.00000000D+00
     .,0.92908800D+03,0.185D+03,0.700D+02,0.99540000D+00,0.00000000D+00
     .,0.78950440D+03,0.185D+03,0.710D+02,0.99540000D+00,0.00000000D+00
     .,0.78448200D+03,0.185D+03,0.720D+02,0.99540000D+00,0.00000000D+00
     .,0.72081970D+03,0.185D+03,0.730D+02,0.99540000D+00,0.00000000D+00
     .,0.61248290D+03,0.185D+03,0.740D+02,0.99540000D+00,0.00000000D+00
     .,0.62450880D+03,0.185D+03,0.750D+02,0.99540000D+00,0.00000000D+00
     .,0.56934740D+03,0.185D+03,0.760D+02,0.99540000D+00,0.00000000D+00
     .,0.52395200D+03,0.185D+03,0.770D+02,0.99540000D+00,0.00000000D+00
     .,0.43782610D+03,0.185D+03,0.780D+02,0.99540000D+00,0.00000000D+00
     .,0.41001810D+03,0.185D+03,0.790D+02,0.99540000D+00,0.00000000D+00
     .,0.42247690D+03,0.185D+03,0.800D+02,0.99540000D+00,0.00000000D+00
     .,0.60141130D+03,0.185D+03,0.810D+02,0.99540000D+00,0.00000000D+00
     .,0.59244910D+03,0.185D+03,0.820D+02,0.99540000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  74801:  74900)=(/
     . 0.54942480D+03,0.185D+03,0.830D+02,0.99540000D+00,0.00000000D+00
     .,0.52688570D+03,0.185D+03,0.840D+02,0.99540000D+00,0.00000000D+00
     .,0.48951330D+03,0.185D+03,0.850D+02,0.99540000D+00,0.00000000D+00
     .,0.45144550D+03,0.185D+03,0.860D+02,0.99540000D+00,0.00000000D+00
     .,0.13844068D+04,0.185D+03,0.870D+02,0.99540000D+00,0.00000000D+00
     .,0.13507426D+04,0.185D+03,0.880D+02,0.99540000D+00,0.00000000D+00
     .,0.12053587D+04,0.185D+03,0.890D+02,0.99540000D+00,0.00000000D+00
     .,0.10957307D+04,0.185D+03,0.900D+02,0.99540000D+00,0.00000000D+00
     .,0.10824781D+04,0.185D+03,0.910D+02,0.99540000D+00,0.00000000D+00
     .,0.10484614D+04,0.185D+03,0.920D+02,0.99540000D+00,0.00000000D+00
     .,0.10720311D+04,0.185D+03,0.930D+02,0.99540000D+00,0.00000000D+00
     .,0.10394256D+04,0.185D+03,0.940D+02,0.99540000D+00,0.00000000D+00
     .,0.61075700D+02,0.185D+03,0.101D+03,0.99540000D+00,0.00000000D+00
     .,0.19088070D+03,0.185D+03,0.103D+03,0.99540000D+00,0.98650000D+00
     .,0.24479400D+03,0.185D+03,0.104D+03,0.99540000D+00,0.98080000D+00
     .,0.19130870D+03,0.185D+03,0.105D+03,0.99540000D+00,0.97060000D+00
     .,0.14621180D+03,0.185D+03,0.106D+03,0.99540000D+00,0.98680000D+00
     .,0.10328040D+03,0.185D+03,0.107D+03,0.99540000D+00,0.99440000D+00
     .,0.76218600D+02,0.185D+03,0.108D+03,0.99540000D+00,0.99250000D+00
     .,0.53309200D+02,0.185D+03,0.109D+03,0.99540000D+00,0.99820000D+00
     ./)
      grimme_c6_parameters(  74901:  75000)=(/
     . 0.27800940D+03,0.185D+03,0.111D+03,0.99540000D+00,0.96840000D+00
     .,0.42891920D+03,0.185D+03,0.112D+03,0.99540000D+00,0.96280000D+00
     .,0.43934570D+03,0.185D+03,0.113D+03,0.99540000D+00,0.96480000D+00
     .,0.35920390D+03,0.185D+03,0.114D+03,0.99540000D+00,0.95070000D+00
     .,0.29808060D+03,0.185D+03,0.115D+03,0.99540000D+00,0.99470000D+00
     .,0.25442840D+03,0.185D+03,0.116D+03,0.99540000D+00,0.99480000D+00
     .,0.21002330D+03,0.185D+03,0.117D+03,0.99540000D+00,0.99720000D+00
     .,0.38791110D+03,0.185D+03,0.119D+03,0.99540000D+00,0.97670000D+00
     .,0.71971410D+03,0.185D+03,0.120D+03,0.99540000D+00,0.98310000D+00
     .,0.39289950D+03,0.185D+03,0.121D+03,0.99540000D+00,0.18627000D+01
     .,0.37962690D+03,0.185D+03,0.122D+03,0.99540000D+00,0.18299000D+01
     .,0.37198630D+03,0.185D+03,0.123D+03,0.99540000D+00,0.19138000D+01
     .,0.36797730D+03,0.185D+03,0.124D+03,0.99540000D+00,0.18269000D+01
     .,0.34117250D+03,0.185D+03,0.125D+03,0.99540000D+00,0.16406000D+01
     .,0.31658390D+03,0.185D+03,0.126D+03,0.99540000D+00,0.16483000D+01
     .,0.30208580D+03,0.185D+03,0.127D+03,0.99540000D+00,0.17149000D+01
     .,0.29515410D+03,0.185D+03,0.128D+03,0.99540000D+00,0.17937000D+01
     .,0.28991570D+03,0.185D+03,0.129D+03,0.99540000D+00,0.95760000D+00
     .,0.27492600D+03,0.185D+03,0.130D+03,0.99540000D+00,0.19419000D+01
     .,0.43890000D+03,0.185D+03,0.131D+03,0.99540000D+00,0.96010000D+00
     ./)
      grimme_c6_parameters(  75001:  75100)=(/
     . 0.39064520D+03,0.185D+03,0.132D+03,0.99540000D+00,0.94340000D+00
     .,0.35361220D+03,0.185D+03,0.133D+03,0.99540000D+00,0.98890000D+00
     .,0.32517910D+03,0.185D+03,0.134D+03,0.99540000D+00,0.99010000D+00
     .,0.28869910D+03,0.185D+03,0.135D+03,0.99540000D+00,0.99740000D+00
     .,0.46445980D+03,0.185D+03,0.137D+03,0.99540000D+00,0.97380000D+00
     .,0.87507120D+03,0.185D+03,0.138D+03,0.99540000D+00,0.98010000D+00
     .,0.68319770D+03,0.185D+03,0.139D+03,0.99540000D+00,0.19153000D+01
     .,0.51943980D+03,0.185D+03,0.140D+03,0.99540000D+00,0.19355000D+01
     .,0.52444490D+03,0.185D+03,0.141D+03,0.99540000D+00,0.19545000D+01
     .,0.49061730D+03,0.185D+03,0.142D+03,0.99540000D+00,0.19420000D+01
     .,0.54479300D+03,0.185D+03,0.143D+03,0.99540000D+00,0.16682000D+01
     .,0.43100110D+03,0.185D+03,0.144D+03,0.99540000D+00,0.18584000D+01
     .,0.40366930D+03,0.185D+03,0.145D+03,0.99540000D+00,0.19003000D+01
     .,0.37552180D+03,0.185D+03,0.146D+03,0.99540000D+00,0.18630000D+01
     .,0.36288510D+03,0.185D+03,0.147D+03,0.99540000D+00,0.96790000D+00
     .,0.36089310D+03,0.185D+03,0.148D+03,0.99540000D+00,0.19539000D+01
     .,0.55818460D+03,0.185D+03,0.149D+03,0.99540000D+00,0.96330000D+00
     .,0.51050570D+03,0.185D+03,0.150D+03,0.99540000D+00,0.95140000D+00
     .,0.48183620D+03,0.185D+03,0.151D+03,0.99540000D+00,0.97490000D+00
     .,0.45832530D+03,0.185D+03,0.152D+03,0.99540000D+00,0.98110000D+00
     ./)
      grimme_c6_parameters(  75101:  75200)=(/
     . 0.42136600D+03,0.185D+03,0.153D+03,0.99540000D+00,0.99680000D+00
     .,0.55369970D+03,0.185D+03,0.155D+03,0.99540000D+00,0.99090000D+00
     .,0.11306124D+04,0.185D+03,0.156D+03,0.99540000D+00,0.97970000D+00
     .,0.86338050D+03,0.185D+03,0.157D+03,0.99540000D+00,0.19373000D+01
     .,0.56202230D+03,0.185D+03,0.159D+03,0.99540000D+00,0.29425000D+01
     .,0.55046390D+03,0.185D+03,0.160D+03,0.99540000D+00,0.29455000D+01
     .,0.53332520D+03,0.185D+03,0.161D+03,0.99540000D+00,0.29413000D+01
     .,0.53511070D+03,0.185D+03,0.162D+03,0.99540000D+00,0.29300000D+01
     .,0.51328320D+03,0.185D+03,0.163D+03,0.99540000D+00,0.18286000D+01
     .,0.53811960D+03,0.185D+03,0.164D+03,0.99540000D+00,0.28732000D+01
     .,0.50616170D+03,0.185D+03,0.165D+03,0.99540000D+00,0.29086000D+01
     .,0.51361300D+03,0.185D+03,0.166D+03,0.99540000D+00,0.28965000D+01
     .,0.48106970D+03,0.185D+03,0.167D+03,0.99540000D+00,0.29242000D+01
     .,0.46760130D+03,0.185D+03,0.168D+03,0.99540000D+00,0.29282000D+01
     .,0.46439200D+03,0.185D+03,0.169D+03,0.99540000D+00,0.29246000D+01
     .,0.48688020D+03,0.185D+03,0.170D+03,0.99540000D+00,0.28482000D+01
     .,0.44918810D+03,0.185D+03,0.171D+03,0.99540000D+00,0.29219000D+01
     .,0.59761830D+03,0.185D+03,0.172D+03,0.99540000D+00,0.19254000D+01
     .,0.55826740D+03,0.185D+03,0.173D+03,0.99540000D+00,0.19459000D+01
     .,0.51282040D+03,0.185D+03,0.174D+03,0.99540000D+00,0.19292000D+01
     ./)
      grimme_c6_parameters(  75201:  75300)=(/
     . 0.51597410D+03,0.185D+03,0.175D+03,0.99540000D+00,0.18104000D+01
     .,0.45859230D+03,0.185D+03,0.176D+03,0.99540000D+00,0.18858000D+01
     .,0.43254320D+03,0.185D+03,0.177D+03,0.99540000D+00,0.18648000D+01
     .,0.41380590D+03,0.185D+03,0.178D+03,0.99540000D+00,0.19188000D+01
     .,0.39569230D+03,0.185D+03,0.179D+03,0.99540000D+00,0.98460000D+00
     .,0.38429790D+03,0.185D+03,0.180D+03,0.99540000D+00,0.19896000D+01
     .,0.60117960D+03,0.185D+03,0.181D+03,0.99540000D+00,0.92670000D+00
     .,0.55369590D+03,0.185D+03,0.182D+03,0.99540000D+00,0.93830000D+00
     .,0.54001160D+03,0.185D+03,0.183D+03,0.99540000D+00,0.98200000D+00
     .,0.52742780D+03,0.185D+03,0.184D+03,0.99540000D+00,0.98150000D+00
     .,0.49544740D+03,0.185D+03,0.185D+03,0.99540000D+00,0.99540000D+00
     .,0.47701600D+02,0.187D+03,0.100D+01,0.97050000D+00,0.91180000D+00
     .,0.30982700D+02,0.187D+03,0.200D+01,0.97050000D+00,0.00000000D+00
     .,0.82128980D+03,0.187D+03,0.300D+01,0.97050000D+00,0.00000000D+00
     .,0.44907760D+03,0.187D+03,0.400D+01,0.97050000D+00,0.00000000D+00
     .,0.29529920D+03,0.187D+03,0.500D+01,0.97050000D+00,0.00000000D+00
     .,0.19640820D+03,0.187D+03,0.600D+01,0.97050000D+00,0.00000000D+00
     .,0.13586190D+03,0.187D+03,0.700D+01,0.97050000D+00,0.00000000D+00
     .,0.10209130D+03,0.187D+03,0.800D+01,0.97050000D+00,0.00000000D+00
     .,0.76828100D+02,0.187D+03,0.900D+01,0.97050000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  75301:  75400)=(/
     . 0.58759900D+02,0.187D+03,0.100D+02,0.97050000D+00,0.00000000D+00
     .,0.97872720D+03,0.187D+03,0.110D+02,0.97050000D+00,0.00000000D+00
     .,0.72162860D+03,0.187D+03,0.120D+02,0.97050000D+00,0.00000000D+00
     .,0.65646580D+03,0.187D+03,0.130D+02,0.97050000D+00,0.00000000D+00
     .,0.50848770D+03,0.187D+03,0.140D+02,0.97050000D+00,0.00000000D+00
     .,0.39145280D+03,0.187D+03,0.150D+02,0.97050000D+00,0.00000000D+00
     .,0.32243460D+03,0.187D+03,0.160D+02,0.97050000D+00,0.00000000D+00
     .,0.26153630D+03,0.187D+03,0.170D+02,0.97050000D+00,0.00000000D+00
     .,0.21269100D+03,0.187D+03,0.180D+02,0.97050000D+00,0.00000000D+00
     .,0.16235241D+04,0.187D+03,0.190D+02,0.97050000D+00,0.00000000D+00
     .,0.12906007D+04,0.187D+03,0.200D+02,0.97050000D+00,0.00000000D+00
     .,0.10581233D+04,0.187D+03,0.210D+02,0.97050000D+00,0.00000000D+00
     .,0.10157559D+04,0.187D+03,0.220D+02,0.97050000D+00,0.00000000D+00
     .,0.92671700D+03,0.187D+03,0.230D+02,0.97050000D+00,0.00000000D+00
     .,0.73034690D+03,0.187D+03,0.240D+02,0.97050000D+00,0.00000000D+00
     .,0.79366630D+03,0.187D+03,0.250D+02,0.97050000D+00,0.00000000D+00
     .,0.62273900D+03,0.187D+03,0.260D+02,0.97050000D+00,0.00000000D+00
     .,0.65432150D+03,0.187D+03,0.270D+02,0.97050000D+00,0.00000000D+00
     .,0.67636930D+03,0.187D+03,0.280D+02,0.97050000D+00,0.00000000D+00
     .,0.51902340D+03,0.187D+03,0.290D+02,0.97050000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  75401:  75500)=(/
     . 0.52639910D+03,0.187D+03,0.300D+02,0.97050000D+00,0.00000000D+00
     .,0.62602660D+03,0.187D+03,0.310D+02,0.97050000D+00,0.00000000D+00
     .,0.54461780D+03,0.187D+03,0.320D+02,0.97050000D+00,0.00000000D+00
     .,0.45945110D+03,0.187D+03,0.330D+02,0.97050000D+00,0.00000000D+00
     .,0.40971550D+03,0.187D+03,0.340D+02,0.97050000D+00,0.00000000D+00
     .,0.35633240D+03,0.187D+03,0.350D+02,0.97050000D+00,0.00000000D+00
     .,0.30818050D+03,0.187D+03,0.360D+02,0.97050000D+00,0.00000000D+00
     .,0.18154672D+04,0.187D+03,0.370D+02,0.97050000D+00,0.00000000D+00
     .,0.15407355D+04,0.187D+03,0.380D+02,0.97050000D+00,0.00000000D+00
     .,0.13325023D+04,0.187D+03,0.390D+02,0.97050000D+00,0.00000000D+00
     .,0.11885781D+04,0.187D+03,0.400D+02,0.97050000D+00,0.00000000D+00
     .,0.10787813D+04,0.187D+03,0.410D+02,0.97050000D+00,0.00000000D+00
     .,0.82661910D+03,0.187D+03,0.420D+02,0.97050000D+00,0.00000000D+00
     .,0.92479920D+03,0.187D+03,0.430D+02,0.97050000D+00,0.00000000D+00
     .,0.69868860D+03,0.187D+03,0.440D+02,0.97050000D+00,0.00000000D+00
     .,0.76296140D+03,0.187D+03,0.450D+02,0.97050000D+00,0.00000000D+00
     .,0.70540290D+03,0.187D+03,0.460D+02,0.97050000D+00,0.00000000D+00
     .,0.58992230D+03,0.187D+03,0.470D+02,0.97050000D+00,0.00000000D+00
     .,0.61917780D+03,0.187D+03,0.480D+02,0.97050000D+00,0.00000000D+00
     .,0.78433640D+03,0.187D+03,0.490D+02,0.97050000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  75501:  75600)=(/
     . 0.71671230D+03,0.187D+03,0.500D+02,0.97050000D+00,0.00000000D+00
     .,0.63213270D+03,0.187D+03,0.510D+02,0.97050000D+00,0.00000000D+00
     .,0.58314470D+03,0.187D+03,0.520D+02,0.97050000D+00,0.00000000D+00
     .,0.52415300D+03,0.187D+03,0.530D+02,0.97050000D+00,0.00000000D+00
     .,0.46871230D+03,0.187D+03,0.540D+02,0.97050000D+00,0.00000000D+00
     .,0.22133513D+04,0.187D+03,0.550D+02,0.97050000D+00,0.00000000D+00
     .,0.19746939D+04,0.187D+03,0.560D+02,0.97050000D+00,0.00000000D+00
     .,0.17122469D+04,0.187D+03,0.570D+02,0.97050000D+00,0.00000000D+00
     .,0.74865870D+03,0.187D+03,0.580D+02,0.97050000D+00,0.27991000D+01
     .,0.17417523D+04,0.187D+03,0.590D+02,0.97050000D+00,0.00000000D+00
     .,0.16683774D+04,0.187D+03,0.600D+02,0.97050000D+00,0.00000000D+00
     .,0.16254063D+04,0.187D+03,0.610D+02,0.97050000D+00,0.00000000D+00
     .,0.15860020D+04,0.187D+03,0.620D+02,0.97050000D+00,0.00000000D+00
     .,0.15510288D+04,0.187D+03,0.630D+02,0.97050000D+00,0.00000000D+00
     .,0.12037458D+04,0.187D+03,0.640D+02,0.97050000D+00,0.00000000D+00
     .,0.13861364D+04,0.187D+03,0.650D+02,0.97050000D+00,0.00000000D+00
     .,0.13338527D+04,0.187D+03,0.660D+02,0.97050000D+00,0.00000000D+00
     .,0.13939911D+04,0.187D+03,0.670D+02,0.97050000D+00,0.00000000D+00
     .,0.13638159D+04,0.187D+03,0.680D+02,0.97050000D+00,0.00000000D+00
     .,0.13364029D+04,0.187D+03,0.690D+02,0.97050000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  75601:  75700)=(/
     . 0.13214462D+04,0.187D+03,0.700D+02,0.97050000D+00,0.00000000D+00
     .,0.11036008D+04,0.187D+03,0.710D+02,0.97050000D+00,0.00000000D+00
     .,0.10717256D+04,0.187D+03,0.720D+02,0.97050000D+00,0.00000000D+00
     .,0.97115790D+03,0.187D+03,0.730D+02,0.97050000D+00,0.00000000D+00
     .,0.81639790D+03,0.187D+03,0.740D+02,0.97050000D+00,0.00000000D+00
     .,0.82799830D+03,0.187D+03,0.750D+02,0.97050000D+00,0.00000000D+00
     .,0.74602310D+03,0.187D+03,0.760D+02,0.97050000D+00,0.00000000D+00
     .,0.68007030D+03,0.187D+03,0.770D+02,0.97050000D+00,0.00000000D+00
     .,0.56255190D+03,0.187D+03,0.780D+02,0.97050000D+00,0.00000000D+00
     .,0.52462170D+03,0.187D+03,0.790D+02,0.97050000D+00,0.00000000D+00
     .,0.53824540D+03,0.187D+03,0.800D+02,0.97050000D+00,0.00000000D+00
     .,0.80393350D+03,0.187D+03,0.810D+02,0.97050000D+00,0.00000000D+00
     .,0.77827560D+03,0.187D+03,0.820D+02,0.97050000D+00,0.00000000D+00
     .,0.70823270D+03,0.187D+03,0.830D+02,0.97050000D+00,0.00000000D+00
     .,0.67199770D+03,0.187D+03,0.840D+02,0.97050000D+00,0.00000000D+00
     .,0.61653950D+03,0.187D+03,0.850D+02,0.97050000D+00,0.00000000D+00
     .,0.56222180D+03,0.187D+03,0.860D+02,0.97050000D+00,0.00000000D+00
     .,0.20671766D+04,0.187D+03,0.870D+02,0.97050000D+00,0.00000000D+00
     .,0.19399392D+04,0.187D+03,0.880D+02,0.97050000D+00,0.00000000D+00
     .,0.16935702D+04,0.187D+03,0.890D+02,0.97050000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  75701:  75800)=(/
     . 0.15024640D+04,0.187D+03,0.900D+02,0.97050000D+00,0.00000000D+00
     .,0.15019252D+04,0.187D+03,0.910D+02,0.97050000D+00,0.00000000D+00
     .,0.14536878D+04,0.187D+03,0.920D+02,0.97050000D+00,0.00000000D+00
     .,0.15083332D+04,0.187D+03,0.930D+02,0.97050000D+00,0.00000000D+00
     .,0.14583342D+04,0.187D+03,0.940D+02,0.97050000D+00,0.00000000D+00
     .,0.77705500D+02,0.187D+03,0.101D+03,0.97050000D+00,0.00000000D+00
     .,0.26024430D+03,0.187D+03,0.103D+03,0.97050000D+00,0.98650000D+00
     .,0.33086670D+03,0.187D+03,0.104D+03,0.97050000D+00,0.98080000D+00
     .,0.24738310D+03,0.187D+03,0.105D+03,0.97050000D+00,0.97060000D+00
     .,0.18444310D+03,0.187D+03,0.106D+03,0.97050000D+00,0.98680000D+00
     .,0.12675340D+03,0.187D+03,0.107D+03,0.97050000D+00,0.99440000D+00
     .,0.91438800D+02,0.187D+03,0.108D+03,0.97050000D+00,0.99250000D+00
     .,0.62121900D+02,0.187D+03,0.109D+03,0.97050000D+00,0.99820000D+00
     .,0.38227080D+03,0.187D+03,0.111D+03,0.97050000D+00,0.96840000D+00
     .,0.59297950D+03,0.187D+03,0.112D+03,0.97050000D+00,0.96280000D+00
     .,0.59319050D+03,0.187D+03,0.113D+03,0.97050000D+00,0.96480000D+00
     .,0.46899060D+03,0.187D+03,0.114D+03,0.97050000D+00,0.95070000D+00
     .,0.37986120D+03,0.187D+03,0.115D+03,0.97050000D+00,0.99470000D+00
     .,0.31896080D+03,0.187D+03,0.116D+03,0.97050000D+00,0.99480000D+00
     .,0.25886520D+03,0.187D+03,0.117D+03,0.97050000D+00,0.99720000D+00
     ./)
      grimme_c6_parameters(  75801:  75900)=(/
     . 0.52346900D+03,0.187D+03,0.119D+03,0.97050000D+00,0.97670000D+00
     .,0.10345424D+04,0.187D+03,0.120D+03,0.97050000D+00,0.98310000D+00
     .,0.51544090D+03,0.187D+03,0.121D+03,0.97050000D+00,0.18627000D+01
     .,0.49759520D+03,0.187D+03,0.122D+03,0.97050000D+00,0.18299000D+01
     .,0.48774150D+03,0.187D+03,0.123D+03,0.97050000D+00,0.19138000D+01
     .,0.48406800D+03,0.187D+03,0.124D+03,0.97050000D+00,0.18269000D+01
     .,0.44152590D+03,0.187D+03,0.125D+03,0.97050000D+00,0.16406000D+01
     .,0.40774620D+03,0.187D+03,0.126D+03,0.97050000D+00,0.16483000D+01
     .,0.38903940D+03,0.187D+03,0.127D+03,0.97050000D+00,0.17149000D+01
     .,0.38057220D+03,0.187D+03,0.128D+03,0.97050000D+00,0.17937000D+01
     .,0.37831310D+03,0.187D+03,0.129D+03,0.97050000D+00,0.95760000D+00
     .,0.35099820D+03,0.187D+03,0.130D+03,0.97050000D+00,0.19419000D+01
     .,0.58593320D+03,0.187D+03,0.131D+03,0.97050000D+00,0.96010000D+00
     .,0.50806740D+03,0.187D+03,0.132D+03,0.97050000D+00,0.94340000D+00
     .,0.45140640D+03,0.187D+03,0.133D+03,0.97050000D+00,0.98890000D+00
     .,0.40992700D+03,0.187D+03,0.134D+03,0.97050000D+00,0.99010000D+00
     .,0.35893240D+03,0.187D+03,0.135D+03,0.97050000D+00,0.99740000D+00
     .,0.62302850D+03,0.187D+03,0.137D+03,0.97050000D+00,0.97380000D+00
     .,0.12623248D+04,0.187D+03,0.138D+03,0.97050000D+00,0.98010000D+00
     .,0.94131820D+03,0.187D+03,0.139D+03,0.97050000D+00,0.19153000D+01
     ./)
      grimme_c6_parameters(  75901:  76000)=(/
     . 0.68339070D+03,0.187D+03,0.140D+03,0.97050000D+00,0.19355000D+01
     .,0.69013390D+03,0.187D+03,0.141D+03,0.97050000D+00,0.19545000D+01
     .,0.64188840D+03,0.187D+03,0.142D+03,0.97050000D+00,0.19420000D+01
     .,0.72847950D+03,0.187D+03,0.143D+03,0.97050000D+00,0.16682000D+01
     .,0.55498020D+03,0.187D+03,0.144D+03,0.97050000D+00,0.18584000D+01
     .,0.51892730D+03,0.187D+03,0.145D+03,0.97050000D+00,0.19003000D+01
     .,0.48122640D+03,0.187D+03,0.146D+03,0.97050000D+00,0.18630000D+01
     .,0.46593230D+03,0.187D+03,0.147D+03,0.97050000D+00,0.96790000D+00
     .,0.45799090D+03,0.187D+03,0.148D+03,0.97050000D+00,0.19539000D+01
     .,0.74456260D+03,0.187D+03,0.149D+03,0.97050000D+00,0.96330000D+00
     .,0.66567970D+03,0.187D+03,0.150D+03,0.97050000D+00,0.95140000D+00
     .,0.61872370D+03,0.187D+03,0.151D+03,0.97050000D+00,0.97490000D+00
     .,0.58251630D+03,0.187D+03,0.152D+03,0.97050000D+00,0.98110000D+00
     .,0.52912450D+03,0.187D+03,0.153D+03,0.97050000D+00,0.99680000D+00
     .,0.73044860D+03,0.187D+03,0.155D+03,0.97050000D+00,0.99090000D+00
     .,0.16478674D+04,0.187D+03,0.156D+03,0.97050000D+00,0.97970000D+00
     .,0.11947861D+04,0.187D+03,0.157D+03,0.97050000D+00,0.19373000D+01
     .,0.72565350D+03,0.187D+03,0.159D+03,0.97050000D+00,0.29425000D+01
     .,0.71054890D+03,0.187D+03,0.160D+03,0.97050000D+00,0.29455000D+01
     .,0.68768570D+03,0.187D+03,0.161D+03,0.97050000D+00,0.29413000D+01
     ./)
      grimme_c6_parameters(  76001:  76100)=(/
     . 0.69226220D+03,0.187D+03,0.162D+03,0.97050000D+00,0.29300000D+01
     .,0.67081490D+03,0.187D+03,0.163D+03,0.97050000D+00,0.18286000D+01
     .,0.69684430D+03,0.187D+03,0.164D+03,0.97050000D+00,0.28732000D+01
     .,0.65357440D+03,0.187D+03,0.165D+03,0.97050000D+00,0.29086000D+01
     .,0.66719620D+03,0.187D+03,0.166D+03,0.97050000D+00,0.28965000D+01
     .,0.61947600D+03,0.187D+03,0.167D+03,0.97050000D+00,0.29242000D+01
     .,0.60150620D+03,0.187D+03,0.168D+03,0.97050000D+00,0.29282000D+01
     .,0.59787770D+03,0.187D+03,0.169D+03,0.97050000D+00,0.29246000D+01
     .,0.62970880D+03,0.187D+03,0.170D+03,0.97050000D+00,0.28482000D+01
     .,0.57740830D+03,0.187D+03,0.171D+03,0.97050000D+00,0.29219000D+01
     .,0.79873450D+03,0.187D+03,0.172D+03,0.97050000D+00,0.19254000D+01
     .,0.73626140D+03,0.187D+03,0.173D+03,0.97050000D+00,0.19459000D+01
     .,0.66710040D+03,0.187D+03,0.174D+03,0.97050000D+00,0.19292000D+01
     .,0.67912190D+03,0.187D+03,0.175D+03,0.97050000D+00,0.18104000D+01
     .,0.58515020D+03,0.187D+03,0.176D+03,0.97050000D+00,0.18858000D+01
     .,0.54932980D+03,0.187D+03,0.177D+03,0.97050000D+00,0.18648000D+01
     .,0.52401710D+03,0.187D+03,0.178D+03,0.97050000D+00,0.19188000D+01
     .,0.50114870D+03,0.187D+03,0.179D+03,0.97050000D+00,0.98460000D+00
     .,0.48150990D+03,0.187D+03,0.180D+03,0.97050000D+00,0.19896000D+01
     .,0.79848790D+03,0.187D+03,0.181D+03,0.97050000D+00,0.92670000D+00
     ./)
      grimme_c6_parameters(  76101:  76200)=(/
     . 0.71909940D+03,0.187D+03,0.182D+03,0.97050000D+00,0.93830000D+00
     .,0.69321150D+03,0.187D+03,0.183D+03,0.97050000D+00,0.98200000D+00
     .,0.67161670D+03,0.187D+03,0.184D+03,0.97050000D+00,0.98150000D+00
     .,0.62396020D+03,0.187D+03,0.185D+03,0.97050000D+00,0.99540000D+00
     .,0.82204820D+03,0.187D+03,0.187D+03,0.97050000D+00,0.97050000D+00
     .,0.83609000D+02,0.188D+03,0.100D+01,0.96620000D+00,0.91180000D+00
     .,0.50796500D+02,0.188D+03,0.200D+01,0.96620000D+00,0.00000000D+00
     .,0.20637836D+04,0.188D+03,0.300D+01,0.96620000D+00,0.00000000D+00
     .,0.94042740D+03,0.188D+03,0.400D+01,0.96620000D+00,0.00000000D+00
     .,0.56781070D+03,0.188D+03,0.500D+01,0.96620000D+00,0.00000000D+00
     .,0.35548600D+03,0.188D+03,0.600D+01,0.96620000D+00,0.00000000D+00
     .,0.23551600D+03,0.188D+03,0.700D+01,0.96620000D+00,0.00000000D+00
     .,0.17184720D+03,0.188D+03,0.800D+01,0.96620000D+00,0.00000000D+00
     .,0.12619530D+03,0.188D+03,0.900D+01,0.96620000D+00,0.00000000D+00
     .,0.94703500D+02,0.188D+03,0.100D+02,0.96620000D+00,0.00000000D+00
     .,0.24334034D+04,0.188D+03,0.110D+02,0.96620000D+00,0.00000000D+00
     .,0.15570501D+04,0.188D+03,0.120D+02,0.96620000D+00,0.00000000D+00
     .,0.13544541D+04,0.188D+03,0.130D+02,0.96620000D+00,0.00000000D+00
     .,0.98580450D+03,0.188D+03,0.140D+02,0.96620000D+00,0.00000000D+00
     .,0.72244190D+03,0.188D+03,0.150D+02,0.96620000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  76201:  76300)=(/
     . 0.57742680D+03,0.188D+03,0.160D+02,0.96620000D+00,0.00000000D+00
     .,0.45525930D+03,0.188D+03,0.170D+02,0.96620000D+00,0.00000000D+00
     .,0.36144930D+03,0.188D+03,0.180D+02,0.96620000D+00,0.00000000D+00
     .,0.42189528D+04,0.188D+03,0.190D+02,0.96620000D+00,0.00000000D+00
     .,0.29555781D+04,0.188D+03,0.200D+02,0.96620000D+00,0.00000000D+00
     .,0.23628855D+04,0.188D+03,0.210D+02,0.96620000D+00,0.00000000D+00
     .,0.22256317D+04,0.188D+03,0.220D+02,0.96620000D+00,0.00000000D+00
     .,0.20060593D+04,0.188D+03,0.230D+02,0.96620000D+00,0.00000000D+00
     .,0.15850984D+04,0.188D+03,0.240D+02,0.96620000D+00,0.00000000D+00
     .,0.16883164D+04,0.188D+03,0.250D+02,0.96620000D+00,0.00000000D+00
     .,0.13245409D+04,0.188D+03,0.260D+02,0.96620000D+00,0.00000000D+00
     .,0.13487863D+04,0.188D+03,0.270D+02,0.96620000D+00,0.00000000D+00
     .,0.14111951D+04,0.188D+03,0.280D+02,0.96620000D+00,0.00000000D+00
     .,0.10878878D+04,0.188D+03,0.290D+02,0.96620000D+00,0.00000000D+00
     .,0.10558450D+04,0.188D+03,0.300D+02,0.96620000D+00,0.00000000D+00
     .,0.12726682D+04,0.188D+03,0.310D+02,0.96620000D+00,0.00000000D+00
     .,0.10532146D+04,0.188D+03,0.320D+02,0.96620000D+00,0.00000000D+00
     .,0.85217950D+03,0.188D+03,0.330D+02,0.96620000D+00,0.00000000D+00
     .,0.74155110D+03,0.188D+03,0.340D+02,0.96620000D+00,0.00000000D+00
     .,0.62920990D+03,0.188D+03,0.350D+02,0.96620000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  76301:  76400)=(/
     . 0.53228900D+03,0.188D+03,0.360D+02,0.96620000D+00,0.00000000D+00
     .,0.46920594D+04,0.188D+03,0.370D+02,0.96620000D+00,0.00000000D+00
     .,0.35533992D+04,0.188D+03,0.380D+02,0.96620000D+00,0.00000000D+00
     .,0.29477908D+04,0.188D+03,0.390D+02,0.96620000D+00,0.00000000D+00
     .,0.25643290D+04,0.188D+03,0.400D+02,0.96620000D+00,0.00000000D+00
     .,0.22922709D+04,0.188D+03,0.410D+02,0.96620000D+00,0.00000000D+00
     .,0.17126002D+04,0.188D+03,0.420D+02,0.96620000D+00,0.00000000D+00
     .,0.19349917D+04,0.188D+03,0.430D+02,0.96620000D+00,0.00000000D+00
     .,0.14205909D+04,0.188D+03,0.440D+02,0.96620000D+00,0.00000000D+00
     .,0.15449801D+04,0.188D+03,0.450D+02,0.96620000D+00,0.00000000D+00
     .,0.14136504D+04,0.188D+03,0.460D+02,0.96620000D+00,0.00000000D+00
     .,0.11968365D+04,0.188D+03,0.470D+02,0.96620000D+00,0.00000000D+00
     .,0.12247085D+04,0.188D+03,0.480D+02,0.96620000D+00,0.00000000D+00
     .,0.16042050D+04,0.188D+03,0.490D+02,0.96620000D+00,0.00000000D+00
     .,0.14037977D+04,0.188D+03,0.500D+02,0.96620000D+00,0.00000000D+00
     .,0.11915335D+04,0.188D+03,0.510D+02,0.96620000D+00,0.00000000D+00
     .,0.10753755D+04,0.188D+03,0.520D+02,0.96620000D+00,0.00000000D+00
     .,0.94459510D+03,0.188D+03,0.530D+02,0.96620000D+00,0.00000000D+00
     .,0.82692720D+03,0.188D+03,0.540D+02,0.96620000D+00,0.00000000D+00
     .,0.57528877D+04,0.188D+03,0.550D+02,0.96620000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  76401:  76500)=(/
     . 0.46383134D+04,0.188D+03,0.560D+02,0.96620000D+00,0.00000000D+00
     .,0.38532093D+04,0.188D+03,0.570D+02,0.96620000D+00,0.00000000D+00
     .,0.14235132D+04,0.188D+03,0.580D+02,0.96620000D+00,0.27991000D+01
     .,0.40407923D+04,0.188D+03,0.590D+02,0.96620000D+00,0.00000000D+00
     .,0.38327972D+04,0.188D+03,0.600D+02,0.96620000D+00,0.00000000D+00
     .,0.37253298D+04,0.188D+03,0.610D+02,0.96620000D+00,0.00000000D+00
     .,0.36276787D+04,0.188D+03,0.620D+02,0.96620000D+00,0.00000000D+00
     .,0.35407934D+04,0.188D+03,0.630D+02,0.96620000D+00,0.00000000D+00
     .,0.26359841D+04,0.188D+03,0.640D+02,0.96620000D+00,0.00000000D+00
     .,0.32830964D+04,0.188D+03,0.650D+02,0.96620000D+00,0.00000000D+00
     .,0.31457261D+04,0.188D+03,0.660D+02,0.96620000D+00,0.00000000D+00
     .,0.31446702D+04,0.188D+03,0.670D+02,0.96620000D+00,0.00000000D+00
     .,0.30720386D+04,0.188D+03,0.680D+02,0.96620000D+00,0.00000000D+00
     .,0.30045907D+04,0.188D+03,0.690D+02,0.96620000D+00,0.00000000D+00
     .,0.29758018D+04,0.188D+03,0.700D+02,0.96620000D+00,0.00000000D+00
     .,0.24223257D+04,0.188D+03,0.710D+02,0.96620000D+00,0.00000000D+00
     .,0.22460574D+04,0.188D+03,0.720D+02,0.96620000D+00,0.00000000D+00
     .,0.19858562D+04,0.188D+03,0.730D+02,0.96620000D+00,0.00000000D+00
     .,0.16449966D+04,0.188D+03,0.740D+02,0.96620000D+00,0.00000000D+00
     .,0.16502454D+04,0.188D+03,0.750D+02,0.96620000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  76501:  76600)=(/
     . 0.14557663D+04,0.188D+03,0.760D+02,0.96620000D+00,0.00000000D+00
     .,0.13051372D+04,0.188D+03,0.770D+02,0.96620000D+00,0.00000000D+00
     .,0.10638806D+04,0.188D+03,0.780D+02,0.96620000D+00,0.00000000D+00
     .,0.98600810D+03,0.188D+03,0.790D+02,0.96620000D+00,0.00000000D+00
     .,0.10014312D+04,0.188D+03,0.800D+02,0.96620000D+00,0.00000000D+00
     .,0.16367789D+04,0.188D+03,0.810D+02,0.96620000D+00,0.00000000D+00
     .,0.15272655D+04,0.188D+03,0.820D+02,0.96620000D+00,0.00000000D+00
     .,0.13408219D+04,0.188D+03,0.830D+02,0.96620000D+00,0.00000000D+00
     .,0.12476338D+04,0.188D+03,0.840D+02,0.96620000D+00,0.00000000D+00
     .,0.11190260D+04,0.188D+03,0.850D+02,0.96620000D+00,0.00000000D+00
     .,0.10003262D+04,0.188D+03,0.860D+02,0.96620000D+00,0.00000000D+00
     .,0.51851636D+04,0.188D+03,0.870D+02,0.96620000D+00,0.00000000D+00
     .,0.44613947D+04,0.188D+03,0.880D+02,0.96620000D+00,0.00000000D+00
     .,0.37411085D+04,0.188D+03,0.890D+02,0.96620000D+00,0.00000000D+00
     .,0.31788167D+04,0.188D+03,0.900D+02,0.96620000D+00,0.00000000D+00
     .,0.32553913D+04,0.188D+03,0.910D+02,0.96620000D+00,0.00000000D+00
     .,0.31461615D+04,0.188D+03,0.920D+02,0.96620000D+00,0.00000000D+00
     .,0.33483818D+04,0.188D+03,0.930D+02,0.96620000D+00,0.00000000D+00
     .,0.32202388D+04,0.188D+03,0.940D+02,0.96620000D+00,0.00000000D+00
     .,0.14255890D+03,0.188D+03,0.101D+03,0.96620000D+00,0.00000000D+00
     ./)
      grimme_c6_parameters(  76601:  76700)=(/
     . 0.53986610D+03,0.188D+03,0.103D+03,0.96620000D+00,0.98650000D+00
     .,0.67929310D+03,0.188D+03,0.104D+03,0.96620000D+00,0.98080000D+00
     .,0.46840690D+03,0.188D+03,0.105D+03,0.96620000D+00,0.97060000D+00
     .,0.33516710D+03,0.188D+03,0.106D+03,0.96620000D+00,0.98680000D+00
     .,0.21993730D+03,0.188D+03,0.107D+03,0.96620000D+00,0.99440000D+00
     .,0.15284480D+03,0.188D+03,0.108D+03,0.96620000D+00,0.99250000D+00
     .,0.99280200D+02,0.188D+03,0.109D+03,0.96620000D+00,0.99820000D+00
     .,0.80746090D+03,0.188D+03,0.111D+03,0.96620000D+00,0.96840000D+00
     .,0.12655466D+04,0.188D+03,0.112D+03,0.96620000D+00,0.96280000D+00
     .,0.12114303D+04,0.188D+03,0.113D+03,0.96620000D+00,0.96480000D+00
     .,0.90234430D+03,0.188D+03,0.114D+03,0.96620000D+00,0.95070000D+00
     .,0.70028070D+03,0.188D+03,0.115D+03,0.96620000D+00,0.99470000D+00
     .,0.57180250D+03,0.188D+03,0.116D+03,0.96620000D+00,0.99480000D+00
     .,0.45094310D+03,0.188D+03,0.117D+03,0.96620000D+00,0.99720000D+00
     .,0.10806042D+04,0.188D+03,0.119D+03,0.96620000D+00,0.97670000D+00
     .,0.24004019D+04,0.188D+03,0.120D+03,0.96620000D+00,0.98310000D+00
     .,0.10031278D+04,0.188D+03,0.121D+03,0.96620000D+00,0.18627000D+01
     .,0.97117090D+03,0.188D+03,0.122D+03,0.96620000D+00,0.18299000D+01
     .,0.95238070D+03,0.188D+03,0.123D+03,0.96620000D+00,0.19138000D+01
     .,0.95158400D+03,0.188D+03,0.124D+03,0.96620000D+00,0.18269000D+01
     ./)
      grimme_c6_parameters(  76701:  76800)=(/
     . 0.83982780D+03,0.188D+03,0.125D+03,0.96620000D+00,0.16406000D+01
     .,0.76965310D+03,0.188D+03,0.126D+03,0.96620000D+00,0.16483000D+01
     .,0.73532570D+03,0.188D+03,0.127D+03,0.96620000D+00,0.17149000D+01
     .,0.72111550D+03,0.188D+03,0.128D+03,0.96620000D+00,0.17937000D+01
     .,0.73354280D+03,0.188D+03,0.129D+03,0.96620000D+00,0.95760000D+00
     .,0.65214040D+03,0.188D+03,0.130D+03,0.96620000D+00,0.19419000D+01
     .,0.11763896D+04,0.188D+03,0.131D+03,0.96620000D+00,0.96010000D+00
     .,0.97240690D+03,0.188D+03,0.132D+03,0.96620000D+00,0.94340000D+00
     .,0.83549110D+03,0.188D+03,0.133D+03,0.96620000D+00,0.98890000D+00
     .,0.74234170D+03,0.188D+03,0.134D+03,0.96620000D+00,0.99010000D+00
     .,0.63468070D+03,0.188D+03,0.135D+03,0.96620000D+00,0.99740000D+00
     .,0.12751297D+04,0.188D+03,0.137D+03,0.96620000D+00,0.97380000D+00
     .,0.29585401D+04,0.188D+03,0.138D+03,0.96620000D+00,0.98010000D+00
     .,0.20352098D+04,0.188D+03,0.139D+03,0.96620000D+00,0.19153000D+01
     .,0.13434836D+04,0.188D+03,0.140D+03,0.96620000D+00,0.19355000D+01
     .,0.13539176D+04,0.188D+03,0.141D+03,0.96620000D+00,0.19545000D+01
     .,0.12515281D+04,0.188D+03,0.142D+03,0.96620000D+00,0.19420000D+01
     .,0.14858293D+04,0.188D+03,0.143D+03,0.96620000D+00,0.16682000D+01
     .,0.10500362D+04,0.188D+03,0.144D+03,0.96620000D+00,0.18584000D+01
     .,0.98072260D+03,0.188D+03,0.145D+03,0.96620000D+00,0.19003000D+01
     ./)
      grimme_c6_parameters(  76801:  76900)=(/
     . 0.90551290D+03,0.188D+03,0.146D+03,0.96620000D+00,0.18630000D+01
     .,0.88003940D+03,0.188D+03,0.147D+03,0.96620000D+00,0.96790000D+00
     .,0.84398030D+03,0.188D+03,0.148D+03,0.96620000D+00,0.19539000D+01
     .,0.15005632D+04,0.188D+03,0.149D+03,0.96620000D+00,0.96330000D+00
     .,0.12849412D+04,0.188D+03,0.150D+03,0.96620000D+00,0.95140000D+00
     .,0.11605961D+04,0.188D+03,0.151D+03,0.96620000D+00,0.97490000D+00
     .,0.10727423D+04,0.188D+03,0.152D+03,0.96620000D+00,0.98110000D+00
     .,0.95386310D+03,0.188D+03,0.153D+03,0.96620000D+00,0.99680000D+00
     .,0.14475205D+04,0.188D+03,0.155D+03,0.96620000D+00,0.99090000D+00
     .,0.39627043D+04,0.188D+03,0.156D+03,0.96620000D+00,0.97970000D+00
     .,0.26130493D+04,0.188D+03,0.157D+03,0.96620000D+00,0.19373000D+01
     .,0.13768762D+04,0.188D+03,0.159D+03,0.96620000D+00,0.29425000D+01
     .,0.13474829D+04,0.188D+03,0.160D+03,0.96620000D+00,0.29455000D+01
     .,0.13018447D+04,0.188D+03,0.161D+03,0.96620000D+00,0.29413000D+01
     .,0.13198844D+04,0.188D+03,0.162D+03,0.96620000D+00,0.29300000D+01
     .,0.13036758D+04,0.188D+03,0.163D+03,0.96620000D+00,0.18286000D+01
     .,0.13293323D+04,0.188D+03,0.164D+03,0.96620000D+00,0.28732000D+01
     .,0.12401840D+04,0.188D+03,0.165D+03,0.96620000D+00,0.29086000D+01
     .,0.12827144D+04,0.188D+03,0.166D+03,0.96620000D+00,0.28965000D+01
     .,0.11691884D+04,0.188D+03,0.167D+03,0.96620000D+00,0.29242000D+01
     ./)
      grimme_c6_parameters(  76901:  77000)=(/
     . 0.11330697D+04,0.188D+03,0.168D+03,0.96620000D+00,0.29282000D+01
     .,0.11279011D+04,0.188D+03,0.169D+03,0.96620000D+00,0.29246000D+01
     .,0.11968168D+04,0.188D+03,0.170D+03,0.96620000D+00,0.28482000D+01
     .,0.10857933D+04,0.188D+03,0.171D+03,0.96620000D+00,0.29219000D+01
     .,0.16232598D+04,0.188D+03,0.172D+03,0.96620000D+00,0.19254000D+01
     .,0.14589496D+04,0.188D+03,0.173D+03,0.96620000D+00,0.19459000D+01
     .,0.12878783D+04,0.188D+03,0.174D+03,0.96620000D+00,0.19292000D+01
     .,0.13411577D+04,0.188D+03,0.175D+03,0.96620000D+00,0.18104000D+01
     .,0.10896139D+04,0.188D+03,0.176D+03,0.96620000D+00,0.18858000D+01
     .,0.10148760D+04,0.188D+03,0.177D+03,0.96620000D+00,0.18648000D+01
     .,0.96392390D+03,0.188D+03,0.178D+03,0.96620000D+00,0.19188000D+01
     .,0.92374840D+03,0.188D+03,0.179D+03,0.96620000D+00,0.98460000D+00
     .,0.86831320D+03,0.188D+03,0.180D+03,0.96620000D+00,0.19896000D+01
     .,0.16036402D+04,0.188D+03,0.181D+03,0.96620000D+00,0.92670000D+00
     .,0.13818325D+04,0.188D+03,0.182D+03,0.96620000D+00,0.93830000D+00
     .,0.13022054D+04,0.188D+03,0.183D+03,0.96620000D+00,0.98200000D+00
     .,0.12430479D+04,0.188D+03,0.184D+03,0.96620000D+00,0.98150000D+00
     .,0.11320728D+04,0.188D+03,0.185D+03,0.96620000D+00,0.99540000D+00
     .,0.16245332D+04,0.188D+03,0.187D+03,0.96620000D+00,0.97050000D+00
     .,0.37875943D+04,0.188D+03,0.188D+03,0.96620000D+00,0.96620000D+00
     ./)
      grimme_c6_parameters(  77001:  77100)=(/
     . 0.51107300D+02,0.189D+03,0.100D+01,0.29070000D+01,0.91180000D+00
     .,0.33639800D+02,0.189D+03,0.200D+01,0.29070000D+01,0.00000000D+00
     .,0.80602430D+03,0.189D+03,0.300D+01,0.29070000D+01,0.00000000D+00
     .,0.46302300D+03,0.189D+03,0.400D+01,0.29070000D+01,0.00000000D+00
     .,0.31058590D+03,0.189D+03,0.500D+01,0.29070000D+01,0.00000000D+00
     .,0.20918580D+03,0.189D+03,0.600D+01,0.29070000D+01,0.00000000D+00
     .,0.14595370D+03,0.189D+03,0.700D+01,0.29070000D+01,0.00000000D+00
     .,0.11033330D+03,0.189D+03,0.800D+01,0.29070000D+01,0.00000000D+00
     .,0.83476100D+02,0.189D+03,0.900D+01,0.29070000D+01,0.00000000D+00
     .,0.64144300D+02,0.189D+03,0.100D+02,0.29070000D+01,0.00000000D+00
     .,0.96353500D+03,0.189D+03,0.110D+02,0.29070000D+01,0.00000000D+00
     .,0.73854190D+03,0.189D+03,0.120D+02,0.29070000D+01,0.00000000D+00
     .,0.67947260D+03,0.189D+03,0.130D+02,0.29070000D+01,0.00000000D+00
     .,0.53394560D+03,0.189D+03,0.140D+02,0.29070000D+01,0.00000000D+00
     .,0.41534530D+03,0.189D+03,0.150D+02,0.29070000D+01,0.00000000D+00
     .,0.34413770D+03,0.189D+03,0.160D+02,0.29070000D+01,0.00000000D+00
     .,0.28065670D+03,0.189D+03,0.170D+02,0.29070000D+01,0.00000000D+00
     .,0.22928490D+03,0.189D+03,0.180D+02,0.29070000D+01,0.00000000D+00
     .,0.15796611D+04,0.189D+03,0.190D+02,0.29070000D+01,0.00000000D+00
     .,0.12998428D+04,0.189D+03,0.200D+02,0.29070000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  77101:  77200)=(/
     . 0.10730233D+04,0.189D+03,0.210D+02,0.29070000D+01,0.00000000D+00
     .,0.10353252D+04,0.189D+03,0.220D+02,0.29070000D+01,0.00000000D+00
     .,0.94761900D+03,0.189D+03,0.230D+02,0.29070000D+01,0.00000000D+00
     .,0.74630200D+03,0.189D+03,0.240D+02,0.29070000D+01,0.00000000D+00
     .,0.81529190D+03,0.189D+03,0.250D+02,0.29070000D+01,0.00000000D+00
     .,0.63968180D+03,0.189D+03,0.260D+02,0.29070000D+01,0.00000000D+00
     .,0.67745550D+03,0.189D+03,0.270D+02,0.29070000D+01,0.00000000D+00
     .,0.69823130D+03,0.189D+03,0.280D+02,0.29070000D+01,0.00000000D+00
     .,0.53518630D+03,0.189D+03,0.290D+02,0.29070000D+01,0.00000000D+00
     .,0.54868120D+03,0.189D+03,0.300D+02,0.29070000D+01,0.00000000D+00
     .,0.65023470D+03,0.189D+03,0.310D+02,0.29070000D+01,0.00000000D+00
     .,0.57221090D+03,0.189D+03,0.320D+02,0.29070000D+01,0.00000000D+00
     .,0.48704720D+03,0.189D+03,0.330D+02,0.29070000D+01,0.00000000D+00
     .,0.43643770D+03,0.189D+03,0.340D+02,0.29070000D+01,0.00000000D+00
     .,0.38138700D+03,0.189D+03,0.350D+02,0.29070000D+01,0.00000000D+00
     .,0.33123010D+03,0.189D+03,0.360D+02,0.29070000D+01,0.00000000D+00
     .,0.17697228D+04,0.189D+03,0.370D+02,0.29070000D+01,0.00000000D+00
     .,0.15487458D+04,0.189D+03,0.380D+02,0.29070000D+01,0.00000000D+00
     .,0.13545806D+04,0.189D+03,0.390D+02,0.29070000D+01,0.00000000D+00
     .,0.12161834D+04,0.189D+03,0.400D+02,0.29070000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  77201:  77300)=(/
     . 0.11081864D+04,0.189D+03,0.410D+02,0.29070000D+01,0.00000000D+00
     .,0.85438760D+03,0.189D+03,0.420D+02,0.29070000D+01,0.00000000D+00
     .,0.95376820D+03,0.189D+03,0.430D+02,0.29070000D+01,0.00000000D+00
     .,0.72552720D+03,0.189D+03,0.440D+02,0.29070000D+01,0.00000000D+00
     .,0.79314780D+03,0.189D+03,0.450D+02,0.29070000D+01,0.00000000D+00
     .,0.73516550D+03,0.189D+03,0.460D+02,0.29070000D+01,0.00000000D+00
     .,0.61302710D+03,0.189D+03,0.470D+02,0.29070000D+01,0.00000000D+00
     .,0.64739340D+03,0.189D+03,0.480D+02,0.29070000D+01,0.00000000D+00
     .,0.81366740D+03,0.189D+03,0.490D+02,0.29070000D+01,0.00000000D+00
     .,0.75110850D+03,0.189D+03,0.500D+02,0.29070000D+01,0.00000000D+00
     .,0.66812780D+03,0.189D+03,0.510D+02,0.29070000D+01,0.00000000D+00
     .,0.61915920D+03,0.189D+03,0.520D+02,0.29070000D+01,0.00000000D+00
     .,0.55909410D+03,0.189D+03,0.530D+02,0.29070000D+01,0.00000000D+00
     .,0.50201500D+03,0.189D+03,0.540D+02,0.29070000D+01,0.00000000D+00
     .,0.21555972D+04,0.189D+03,0.550D+02,0.29070000D+01,0.00000000D+00
     .,0.19751996D+04,0.189D+03,0.560D+02,0.29070000D+01,0.00000000D+00
     .,0.17327032D+04,0.189D+03,0.570D+02,0.29070000D+01,0.00000000D+00
     .,0.78954030D+03,0.189D+03,0.580D+02,0.29070000D+01,0.27991000D+01
     .,0.17491123D+04,0.189D+03,0.590D+02,0.29070000D+01,0.00000000D+00
     .,0.16792118D+04,0.189D+03,0.600D+02,0.29070000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  77301:  77400)=(/
     . 0.16369858D+04,0.189D+03,0.610D+02,0.29070000D+01,0.00000000D+00
     .,0.15981651D+04,0.189D+03,0.620D+02,0.29070000D+01,0.00000000D+00
     .,0.15637364D+04,0.189D+03,0.630D+02,0.29070000D+01,0.00000000D+00
     .,0.12273570D+04,0.189D+03,0.640D+02,0.29070000D+01,0.00000000D+00
     .,0.13851029D+04,0.189D+03,0.650D+02,0.29070000D+01,0.00000000D+00
     .,0.13354249D+04,0.189D+03,0.660D+02,0.29070000D+01,0.00000000D+00
     .,0.14098902D+04,0.189D+03,0.670D+02,0.29070000D+01,0.00000000D+00
     .,0.13799203D+04,0.189D+03,0.680D+02,0.29070000D+01,0.00000000D+00
     .,0.13528654D+04,0.189D+03,0.690D+02,0.29070000D+01,0.00000000D+00
     .,0.13371510D+04,0.189D+03,0.700D+02,0.29070000D+01,0.00000000D+00
     .,0.11251350D+04,0.189D+03,0.710D+02,0.29070000D+01,0.00000000D+00
     .,0.11047547D+04,0.189D+03,0.720D+02,0.29070000D+01,0.00000000D+00
     .,0.10070882D+04,0.189D+03,0.730D+02,0.29070000D+01,0.00000000D+00
     .,0.84953530D+03,0.189D+03,0.740D+02,0.29070000D+01,0.00000000D+00
     .,0.86391120D+03,0.189D+03,0.750D+02,0.29070000D+01,0.00000000D+00
     .,0.78218420D+03,0.189D+03,0.760D+02,0.29070000D+01,0.00000000D+00
     .,0.71574490D+03,0.189D+03,0.770D+02,0.29070000D+01,0.00000000D+00
     .,0.59397880D+03,0.189D+03,0.780D+02,0.29070000D+01,0.00000000D+00
     .,0.55473410D+03,0.189D+03,0.790D+02,0.29070000D+01,0.00000000D+00
     .,0.57048480D+03,0.189D+03,0.800D+02,0.29070000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  77401:  77500)=(/
     . 0.83486440D+03,0.189D+03,0.810D+02,0.29070000D+01,0.00000000D+00
     .,0.81522210D+03,0.189D+03,0.820D+02,0.29070000D+01,0.00000000D+00
     .,0.74786620D+03,0.189D+03,0.830D+02,0.29070000D+01,0.00000000D+00
     .,0.71256000D+03,0.189D+03,0.840D+02,0.29070000D+01,0.00000000D+00
     .,0.65680530D+03,0.189D+03,0.850D+02,0.29070000D+01,0.00000000D+00
     .,0.60129860D+03,0.189D+03,0.860D+02,0.29070000D+01,0.00000000D+00
     .,0.20330823D+04,0.189D+03,0.870D+02,0.29070000D+01,0.00000000D+00
     .,0.19515778D+04,0.189D+03,0.880D+02,0.29070000D+01,0.00000000D+00
     .,0.17226039D+04,0.189D+03,0.890D+02,0.29070000D+01,0.00000000D+00
     .,0.15452383D+04,0.189D+03,0.900D+02,0.29070000D+01,0.00000000D+00
     .,0.15354151D+04,0.189D+03,0.910D+02,0.29070000D+01,0.00000000D+00
     .,0.14866193D+04,0.189D+03,0.920D+02,0.29070000D+01,0.00000000D+00
     .,0.15322963D+04,0.189D+03,0.930D+02,0.29070000D+01,0.00000000D+00
     .,0.14835856D+04,0.189D+03,0.940D+02,0.29070000D+01,0.00000000D+00
     .,0.82527300D+02,0.189D+03,0.101D+03,0.29070000D+01,0.00000000D+00
     .,0.26898140D+03,0.189D+03,0.103D+03,0.29070000D+01,0.98650000D+00
     .,0.34282380D+03,0.189D+03,0.104D+03,0.29070000D+01,0.98080000D+00
     .,0.26102340D+03,0.189D+03,0.105D+03,0.29070000D+01,0.97060000D+00
     .,0.19621380D+03,0.189D+03,0.106D+03,0.29070000D+01,0.98680000D+00
     .,0.13608950D+03,0.189D+03,0.107D+03,0.29070000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters(  77501:  77600)=(/
     . 0.98908000D+02,0.189D+03,0.108D+03,0.29070000D+01,0.99250000D+00
     .,0.67858600D+02,0.189D+03,0.109D+03,0.29070000D+01,0.99820000D+00
     .,0.39343830D+03,0.189D+03,0.111D+03,0.29070000D+01,0.96840000D+00
     .,0.60867090D+03,0.189D+03,0.112D+03,0.29070000D+01,0.96280000D+00
     .,0.61547850D+03,0.189D+03,0.113D+03,0.29070000D+01,0.96480000D+00
     .,0.49327920D+03,0.189D+03,0.114D+03,0.29070000D+01,0.95070000D+00
     .,0.40312400D+03,0.189D+03,0.115D+03,0.29070000D+01,0.99470000D+00
     .,0.34035860D+03,0.189D+03,0.116D+03,0.29070000D+01,0.99480000D+00
     .,0.27775450D+03,0.189D+03,0.117D+03,0.29070000D+01,0.99720000D+00
     .,0.54150520D+03,0.189D+03,0.119D+03,0.29070000D+01,0.97670000D+00
     .,0.10393542D+04,0.189D+03,0.120D+03,0.29070000D+01,0.98310000D+00
     .,0.54062540D+03,0.189D+03,0.121D+03,0.29070000D+01,0.18627000D+01
     .,0.52182910D+03,0.189D+03,0.122D+03,0.29070000D+01,0.18299000D+01
     .,0.51141880D+03,0.189D+03,0.123D+03,0.29070000D+01,0.19138000D+01
     .,0.50681950D+03,0.189D+03,0.124D+03,0.29070000D+01,0.18269000D+01
     .,0.46576900D+03,0.189D+03,0.125D+03,0.29070000D+01,0.16406000D+01
     .,0.43087900D+03,0.189D+03,0.126D+03,0.29070000D+01,0.16483000D+01
     .,0.41102320D+03,0.189D+03,0.127D+03,0.29070000D+01,0.17149000D+01
     .,0.40187340D+03,0.189D+03,0.128D+03,0.29070000D+01,0.17937000D+01
     .,0.39745630D+03,0.189D+03,0.129D+03,0.29070000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters(  77601:  77700)=(/
     . 0.37225130D+03,0.189D+03,0.130D+03,0.29070000D+01,0.19419000D+01
     .,0.61037340D+03,0.189D+03,0.131D+03,0.29070000D+01,0.96010000D+00
     .,0.53502330D+03,0.189D+03,0.132D+03,0.29070000D+01,0.94340000D+00
     .,0.47872210D+03,0.189D+03,0.133D+03,0.29070000D+01,0.98890000D+00
     .,0.43661290D+03,0.189D+03,0.134D+03,0.29070000D+01,0.99010000D+00
     .,0.38406800D+03,0.189D+03,0.135D+03,0.29070000D+01,0.99740000D+00
     .,0.64577530D+03,0.189D+03,0.137D+03,0.29070000D+01,0.97380000D+00
     .,0.12648795D+04,0.189D+03,0.138D+03,0.29070000D+01,0.98010000D+00
     .,0.96384860D+03,0.189D+03,0.139D+03,0.29070000D+01,0.19153000D+01
     .,0.71506360D+03,0.189D+03,0.140D+03,0.29070000D+01,0.19355000D+01
     .,0.72218160D+03,0.189D+03,0.141D+03,0.29070000D+01,0.19545000D+01
     .,0.67303520D+03,0.189D+03,0.142D+03,0.29070000D+01,0.19420000D+01
     .,0.75600910D+03,0.189D+03,0.143D+03,0.29070000D+01,0.16682000D+01
     .,0.58589660D+03,0.189D+03,0.144D+03,0.29070000D+01,0.18584000D+01
     .,0.54801980D+03,0.189D+03,0.145D+03,0.29070000D+01,0.19003000D+01
     .,0.50873460D+03,0.189D+03,0.146D+03,0.29070000D+01,0.18630000D+01
     .,0.49222520D+03,0.189D+03,0.147D+03,0.29070000D+01,0.96790000D+00
     .,0.48648840D+03,0.189D+03,0.148D+03,0.29070000D+01,0.19539000D+01
     .,0.77511410D+03,0.189D+03,0.149D+03,0.29070000D+01,0.96330000D+00
     .,0.69994150D+03,0.189D+03,0.150D+03,0.29070000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters(  77701:  77800)=(/
     . 0.65463420D+03,0.189D+03,0.151D+03,0.29070000D+01,0.97490000D+00
     .,0.61866240D+03,0.189D+03,0.152D+03,0.29070000D+01,0.98110000D+00
     .,0.56435520D+03,0.189D+03,0.153D+03,0.29070000D+01,0.99680000D+00
     .,0.76265600D+03,0.189D+03,0.155D+03,0.29070000D+01,0.99090000D+00
     .,0.16407829D+04,0.189D+03,0.156D+03,0.29070000D+01,0.97970000D+00
     .,0.12201975D+04,0.189D+03,0.157D+03,0.29070000D+01,0.19373000D+01
     .,0.76564160D+03,0.189D+03,0.159D+03,0.29070000D+01,0.29425000D+01
     .,0.74979030D+03,0.189D+03,0.160D+03,0.29070000D+01,0.29455000D+01
     .,0.72595040D+03,0.189D+03,0.161D+03,0.29070000D+01,0.29413000D+01
     .,0.72971000D+03,0.189D+03,0.162D+03,0.29070000D+01,0.29300000D+01
     .,0.70402290D+03,0.189D+03,0.163D+03,0.29070000D+01,0.18286000D+01
     .,0.73440270D+03,0.189D+03,0.164D+03,0.29070000D+01,0.28732000D+01
     .,0.68961450D+03,0.189D+03,0.165D+03,0.29070000D+01,0.29086000D+01
     .,0.70203220D+03,0.189D+03,0.166D+03,0.29070000D+01,0.28965000D+01
     .,0.65440840D+03,0.189D+03,0.167D+03,0.29070000D+01,0.29242000D+01
     .,0.63570180D+03,0.189D+03,0.168D+03,0.29070000D+01,0.29282000D+01
     .,0.63167050D+03,0.189D+03,0.169D+03,0.29070000D+01,0.29246000D+01
     .,0.66425610D+03,0.189D+03,0.170D+03,0.29070000D+01,0.28482000D+01
     .,0.61046730D+03,0.189D+03,0.171D+03,0.29070000D+01,0.29219000D+01
     .,0.82974450D+03,0.189D+03,0.172D+03,0.29070000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters(  77801:  77900)=(/
     . 0.76921560D+03,0.189D+03,0.173D+03,0.29070000D+01,0.19459000D+01
     .,0.70102290D+03,0.189D+03,0.174D+03,0.29070000D+01,0.19292000D+01
     .,0.71006080D+03,0.189D+03,0.175D+03,0.29070000D+01,0.18104000D+01
     .,0.61988720D+03,0.189D+03,0.176D+03,0.29070000D+01,0.18858000D+01
     .,0.58290540D+03,0.189D+03,0.177D+03,0.29070000D+01,0.18648000D+01
     .,0.55659850D+03,0.189D+03,0.178D+03,0.29070000D+01,0.19188000D+01
     .,0.53213080D+03,0.189D+03,0.179D+03,0.29070000D+01,0.98460000D+00
     .,0.51369080D+03,0.189D+03,0.180D+03,0.29070000D+01,0.19896000D+01
     .,0.83188530D+03,0.189D+03,0.181D+03,0.29070000D+01,0.92670000D+00
     .,0.75684580D+03,0.189D+03,0.182D+03,0.29070000D+01,0.93830000D+00
     .,0.73324790D+03,0.189D+03,0.183D+03,0.29070000D+01,0.98200000D+00
     .,0.71262070D+03,0.189D+03,0.184D+03,0.29070000D+01,0.98150000D+00
     .,0.66475080D+03,0.189D+03,0.185D+03,0.29070000D+01,0.99540000D+00
     .,0.85884400D+03,0.189D+03,0.187D+03,0.29070000D+01,0.97050000D+00
     .,0.16304211D+04,0.189D+03,0.188D+03,0.29070000D+01,0.96620000D+00
     .,0.90604480D+03,0.189D+03,0.189D+03,0.29070000D+01,0.29070000D+01
     .,0.58042000D+02,0.190D+03,0.100D+01,0.28844000D+01,0.91180000D+00
     .,0.37717100D+02,0.190D+03,0.200D+01,0.28844000D+01,0.00000000D+00
     .,0.10088719D+04,0.190D+03,0.300D+01,0.28844000D+01,0.00000000D+00
     .,0.54842030D+03,0.190D+03,0.400D+01,0.28844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  77901:  78000)=(/
     . 0.36005530D+03,0.190D+03,0.500D+01,0.28844000D+01,0.00000000D+00
     .,0.23921200D+03,0.190D+03,0.600D+01,0.28844000D+01,0.00000000D+00
     .,0.16541170D+03,0.190D+03,0.700D+01,0.28844000D+01,0.00000000D+00
     .,0.12432800D+03,0.190D+03,0.800D+01,0.28844000D+01,0.00000000D+00
     .,0.93640800D+02,0.190D+03,0.900D+01,0.28844000D+01,0.00000000D+00
     .,0.71718500D+02,0.190D+03,0.100D+02,0.28844000D+01,0.00000000D+00
     .,0.12017562D+04,0.190D+03,0.110D+02,0.28844000D+01,0.00000000D+00
     .,0.88196280D+03,0.190D+03,0.120D+02,0.28844000D+01,0.00000000D+00
     .,0.80168460D+03,0.190D+03,0.130D+02,0.28844000D+01,0.00000000D+00
     .,0.62020400D+03,0.190D+03,0.140D+02,0.28844000D+01,0.00000000D+00
     .,0.47697090D+03,0.190D+03,0.150D+02,0.28844000D+01,0.00000000D+00
     .,0.39262180D+03,0.190D+03,0.160D+02,0.28844000D+01,0.00000000D+00
     .,0.31831370D+03,0.190D+03,0.170D+02,0.28844000D+01,0.00000000D+00
     .,0.25881200D+03,0.190D+03,0.180D+02,0.28844000D+01,0.00000000D+00
     .,0.20007417D+04,0.190D+03,0.190D+02,0.28844000D+01,0.00000000D+00
     .,0.15795049D+04,0.190D+03,0.200D+02,0.28844000D+01,0.00000000D+00
     .,0.12941588D+04,0.190D+03,0.210D+02,0.28844000D+01,0.00000000D+00
     .,0.12419423D+04,0.190D+03,0.220D+02,0.28844000D+01,0.00000000D+00
     .,0.11328667D+04,0.190D+03,0.230D+02,0.28844000D+01,0.00000000D+00
     .,0.89296930D+03,0.190D+03,0.240D+02,0.28844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  78001:  78100)=(/
     . 0.96999930D+03,0.190D+03,0.250D+02,0.28844000D+01,0.00000000D+00
     .,0.76115260D+03,0.190D+03,0.260D+02,0.28844000D+01,0.00000000D+00
     .,0.79925150D+03,0.190D+03,0.270D+02,0.28844000D+01,0.00000000D+00
     .,0.82638550D+03,0.190D+03,0.280D+02,0.28844000D+01,0.00000000D+00
     .,0.63431240D+03,0.190D+03,0.290D+02,0.28844000D+01,0.00000000D+00
     .,0.64280130D+03,0.190D+03,0.300D+02,0.28844000D+01,0.00000000D+00
     .,0.76433880D+03,0.190D+03,0.310D+02,0.28844000D+01,0.00000000D+00
     .,0.66430070D+03,0.190D+03,0.320D+02,0.28844000D+01,0.00000000D+00
     .,0.55996260D+03,0.190D+03,0.330D+02,0.28844000D+01,0.00000000D+00
     .,0.49907290D+03,0.190D+03,0.340D+02,0.28844000D+01,0.00000000D+00
     .,0.43384090D+03,0.190D+03,0.350D+02,0.28844000D+01,0.00000000D+00
     .,0.37508740D+03,0.190D+03,0.360D+02,0.28844000D+01,0.00000000D+00
     .,0.22372776D+04,0.190D+03,0.370D+02,0.28844000D+01,0.00000000D+00
     .,0.18860887D+04,0.190D+03,0.380D+02,0.28844000D+01,0.00000000D+00
     .,0.16294376D+04,0.190D+03,0.390D+02,0.28844000D+01,0.00000000D+00
     .,0.14526448D+04,0.190D+03,0.400D+02,0.28844000D+01,0.00000000D+00
     .,0.13181488D+04,0.190D+03,0.410D+02,0.28844000D+01,0.00000000D+00
     .,0.10095160D+04,0.190D+03,0.420D+02,0.28844000D+01,0.00000000D+00
     .,0.11298359D+04,0.190D+03,0.430D+02,0.28844000D+01,0.00000000D+00
     .,0.85313360D+03,0.190D+03,0.440D+02,0.28844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  78101:  78200)=(/
     . 0.93156900D+03,0.190D+03,0.450D+02,0.28844000D+01,0.00000000D+00
     .,0.86120120D+03,0.190D+03,0.460D+02,0.28844000D+01,0.00000000D+00
     .,0.72051370D+03,0.190D+03,0.470D+02,0.28844000D+01,0.00000000D+00
     .,0.75592110D+03,0.190D+03,0.480D+02,0.28844000D+01,0.00000000D+00
     .,0.95811210D+03,0.190D+03,0.490D+02,0.28844000D+01,0.00000000D+00
     .,0.87479670D+03,0.190D+03,0.500D+02,0.28844000D+01,0.00000000D+00
     .,0.77106630D+03,0.190D+03,0.510D+02,0.28844000D+01,0.00000000D+00
     .,0.71100220D+03,0.190D+03,0.520D+02,0.28844000D+01,0.00000000D+00
     .,0.63878920D+03,0.190D+03,0.530D+02,0.28844000D+01,0.00000000D+00
     .,0.57099520D+03,0.190D+03,0.540D+02,0.28844000D+01,0.00000000D+00
     .,0.27306836D+04,0.190D+03,0.550D+02,0.28844000D+01,0.00000000D+00
     .,0.24191244D+04,0.190D+03,0.560D+02,0.28844000D+01,0.00000000D+00
     .,0.20947841D+04,0.190D+03,0.570D+02,0.28844000D+01,0.00000000D+00
     .,0.91310340D+03,0.190D+03,0.580D+02,0.28844000D+01,0.27991000D+01
     .,0.21341663D+04,0.190D+03,0.590D+02,0.28844000D+01,0.00000000D+00
     .,0.20426932D+04,0.190D+03,0.600D+02,0.28844000D+01,0.00000000D+00
     .,0.19899080D+04,0.190D+03,0.610D+02,0.28844000D+01,0.00000000D+00
     .,0.19415270D+04,0.190D+03,0.620D+02,0.28844000D+01,0.00000000D+00
     .,0.18985844D+04,0.190D+03,0.630D+02,0.28844000D+01,0.00000000D+00
     .,0.14723209D+04,0.190D+03,0.640D+02,0.28844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  78201:  78300)=(/
     . 0.17011137D+04,0.190D+03,0.650D+02,0.28844000D+01,0.00000000D+00
     .,0.16379975D+04,0.190D+03,0.660D+02,0.28844000D+01,0.00000000D+00
     .,0.17057192D+04,0.190D+03,0.670D+02,0.28844000D+01,0.00000000D+00
     .,0.16687205D+04,0.190D+03,0.680D+02,0.28844000D+01,0.00000000D+00
     .,0.16350831D+04,0.190D+03,0.690D+02,0.28844000D+01,0.00000000D+00
     .,0.16168530D+04,0.190D+03,0.700D+02,0.28844000D+01,0.00000000D+00
     .,0.13505554D+04,0.190D+03,0.710D+02,0.28844000D+01,0.00000000D+00
     .,0.13091260D+04,0.190D+03,0.720D+02,0.28844000D+01,0.00000000D+00
     .,0.11857100D+04,0.190D+03,0.730D+02,0.28844000D+01,0.00000000D+00
     .,0.99656680D+03,0.190D+03,0.740D+02,0.28844000D+01,0.00000000D+00
     .,0.10106039D+04,0.190D+03,0.750D+02,0.28844000D+01,0.00000000D+00
     .,0.91025670D+03,0.190D+03,0.760D+02,0.28844000D+01,0.00000000D+00
     .,0.82962710D+03,0.190D+03,0.770D+02,0.28844000D+01,0.00000000D+00
     .,0.68620440D+03,0.190D+03,0.780D+02,0.28844000D+01,0.00000000D+00
     .,0.63997490D+03,0.190D+03,0.790D+02,0.28844000D+01,0.00000000D+00
     .,0.65657070D+03,0.190D+03,0.800D+02,0.28844000D+01,0.00000000D+00
     .,0.98206910D+03,0.190D+03,0.810D+02,0.28844000D+01,0.00000000D+00
     .,0.95002070D+03,0.190D+03,0.820D+02,0.28844000D+01,0.00000000D+00
     .,0.86404130D+03,0.190D+03,0.830D+02,0.28844000D+01,0.00000000D+00
     .,0.81955770D+03,0.190D+03,0.840D+02,0.28844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  78301:  78400)=(/
     . 0.75162660D+03,0.190D+03,0.850D+02,0.28844000D+01,0.00000000D+00
     .,0.68516600D+03,0.190D+03,0.860D+02,0.28844000D+01,0.00000000D+00
     .,0.25440695D+04,0.190D+03,0.870D+02,0.28844000D+01,0.00000000D+00
     .,0.23748028D+04,0.190D+03,0.880D+02,0.28844000D+01,0.00000000D+00
     .,0.20713967D+04,0.190D+03,0.890D+02,0.28844000D+01,0.00000000D+00
     .,0.18359296D+04,0.190D+03,0.900D+02,0.28844000D+01,0.00000000D+00
     .,0.18365610D+04,0.190D+03,0.910D+02,0.28844000D+01,0.00000000D+00
     .,0.17774636D+04,0.190D+03,0.920D+02,0.28844000D+01,0.00000000D+00
     .,0.18453202D+04,0.190D+03,0.930D+02,0.28844000D+01,0.00000000D+00
     .,0.17839174D+04,0.190D+03,0.940D+02,0.28844000D+01,0.00000000D+00
     .,0.94641800D+02,0.190D+03,0.101D+03,0.28844000D+01,0.00000000D+00
     .,0.31781250D+03,0.190D+03,0.103D+03,0.28844000D+01,0.98650000D+00
     .,0.40399690D+03,0.190D+03,0.104D+03,0.28844000D+01,0.98080000D+00
     .,0.30152640D+03,0.190D+03,0.105D+03,0.28844000D+01,0.97060000D+00
     .,0.22458760D+03,0.190D+03,0.106D+03,0.28844000D+01,0.98680000D+00
     .,0.15426790D+03,0.190D+03,0.107D+03,0.28844000D+01,0.99440000D+00
     .,0.11130120D+03,0.190D+03,0.108D+03,0.28844000D+01,0.99250000D+00
     .,0.75746100D+02,0.190D+03,0.109D+03,0.28844000D+01,0.99820000D+00
     .,0.46715670D+03,0.190D+03,0.111D+03,0.28844000D+01,0.96840000D+00
     .,0.72473020D+03,0.190D+03,0.112D+03,0.28844000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters(  78401:  78500)=(/
     . 0.72426630D+03,0.190D+03,0.113D+03,0.28844000D+01,0.96480000D+00
     .,0.57194340D+03,0.190D+03,0.114D+03,0.28844000D+01,0.95070000D+00
     .,0.46283220D+03,0.190D+03,0.115D+03,0.28844000D+01,0.99470000D+00
     .,0.38840280D+03,0.190D+03,0.116D+03,0.28844000D+01,0.99480000D+00
     .,0.31507380D+03,0.190D+03,0.117D+03,0.28844000D+01,0.99720000D+00
     .,0.63924470D+03,0.190D+03,0.119D+03,0.28844000D+01,0.97670000D+00
     .,0.12682110D+04,0.190D+03,0.120D+03,0.28844000D+01,0.98310000D+00
     .,0.62863700D+03,0.190D+03,0.121D+03,0.28844000D+01,0.18627000D+01
     .,0.60726950D+03,0.190D+03,0.122D+03,0.28844000D+01,0.18299000D+01
     .,0.59522520D+03,0.190D+03,0.123D+03,0.28844000D+01,0.19138000D+01
     .,0.59085660D+03,0.190D+03,0.124D+03,0.28844000D+01,0.18269000D+01
     .,0.53866860D+03,0.190D+03,0.125D+03,0.28844000D+01,0.16406000D+01
     .,0.49744160D+03,0.190D+03,0.126D+03,0.28844000D+01,0.16483000D+01
     .,0.47468740D+03,0.190D+03,0.127D+03,0.28844000D+01,0.17149000D+01
     .,0.46439490D+03,0.190D+03,0.128D+03,0.28844000D+01,0.17937000D+01
     .,0.46183290D+03,0.190D+03,0.129D+03,0.28844000D+01,0.95760000D+00
     .,0.42819990D+03,0.190D+03,0.130D+03,0.28844000D+01,0.19419000D+01
     .,0.71520850D+03,0.190D+03,0.131D+03,0.28844000D+01,0.96010000D+00
     .,0.61960740D+03,0.190D+03,0.132D+03,0.28844000D+01,0.94340000D+00
     .,0.55013410D+03,0.190D+03,0.133D+03,0.28844000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters(  78501:  78600)=(/
     . 0.49933630D+03,0.190D+03,0.134D+03,0.28844000D+01,0.99010000D+00
     .,0.43701980D+03,0.190D+03,0.135D+03,0.28844000D+01,0.99740000D+00
     .,0.76067450D+03,0.190D+03,0.137D+03,0.28844000D+01,0.97380000D+00
     .,0.15482877D+04,0.190D+03,0.138D+03,0.28844000D+01,0.98010000D+00
     .,0.11522222D+04,0.190D+03,0.139D+03,0.28844000D+01,0.19153000D+01
     .,0.83361520D+03,0.190D+03,0.140D+03,0.28844000D+01,0.19355000D+01
     .,0.84145560D+03,0.190D+03,0.141D+03,0.28844000D+01,0.19545000D+01
     .,0.78311230D+03,0.190D+03,0.142D+03,0.28844000D+01,0.19420000D+01
     .,0.88973240D+03,0.190D+03,0.143D+03,0.28844000D+01,0.16682000D+01
     .,0.67685180D+03,0.190D+03,0.144D+03,0.28844000D+01,0.18584000D+01
     .,0.63296580D+03,0.190D+03,0.145D+03,0.28844000D+01,0.19003000D+01
     .,0.58702360D+03,0.190D+03,0.146D+03,0.28844000D+01,0.18630000D+01
     .,0.56847740D+03,0.190D+03,0.147D+03,0.28844000D+01,0.96790000D+00
     .,0.55862930D+03,0.190D+03,0.148D+03,0.28844000D+01,0.19539000D+01
     .,0.90926210D+03,0.190D+03,0.149D+03,0.28844000D+01,0.96330000D+00
     .,0.81233800D+03,0.190D+03,0.150D+03,0.28844000D+01,0.95140000D+00
     .,0.75464760D+03,0.190D+03,0.151D+03,0.28844000D+01,0.97490000D+00
     .,0.71021200D+03,0.190D+03,0.152D+03,0.28844000D+01,0.98110000D+00
     .,0.64484300D+03,0.190D+03,0.153D+03,0.28844000D+01,0.99680000D+00
     .,0.89097610D+03,0.190D+03,0.155D+03,0.28844000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters(  78601:  78700)=(/
     . 0.20249316D+04,0.190D+03,0.156D+03,0.28844000D+01,0.97970000D+00
     .,0.14635069D+04,0.190D+03,0.157D+03,0.28844000D+01,0.19373000D+01
     .,0.88503310D+03,0.190D+03,0.159D+03,0.28844000D+01,0.29425000D+01
     .,0.86659780D+03,0.190D+03,0.160D+03,0.28844000D+01,0.29455000D+01
     .,0.83870440D+03,0.190D+03,0.161D+03,0.28844000D+01,0.29413000D+01
     .,0.84447740D+03,0.190D+03,0.162D+03,0.28844000D+01,0.29300000D+01
     .,0.81850700D+03,0.190D+03,0.163D+03,0.28844000D+01,0.18286000D+01
     .,0.84998270D+03,0.190D+03,0.164D+03,0.28844000D+01,0.28732000D+01
     .,0.79715610D+03,0.190D+03,0.165D+03,0.28844000D+01,0.29086000D+01
     .,0.81406210D+03,0.190D+03,0.166D+03,0.28844000D+01,0.28965000D+01
     .,0.75550250D+03,0.190D+03,0.167D+03,0.28844000D+01,0.29242000D+01
     .,0.73357320D+03,0.190D+03,0.168D+03,0.28844000D+01,0.29282000D+01
     .,0.72916890D+03,0.190D+03,0.169D+03,0.28844000D+01,0.29246000D+01
     .,0.76808740D+03,0.190D+03,0.170D+03,0.28844000D+01,0.28482000D+01
     .,0.70415860D+03,0.190D+03,0.171D+03,0.28844000D+01,0.29219000D+01
     .,0.97550990D+03,0.190D+03,0.172D+03,0.28844000D+01,0.19254000D+01
     .,0.89859560D+03,0.190D+03,0.173D+03,0.28844000D+01,0.19459000D+01
     .,0.81374230D+03,0.190D+03,0.174D+03,0.28844000D+01,0.19292000D+01
     .,0.82881920D+03,0.190D+03,0.175D+03,0.28844000D+01,0.18104000D+01
     .,0.71350780D+03,0.190D+03,0.176D+03,0.28844000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters(  78701:  78800)=(/
     . 0.66976280D+03,0.190D+03,0.177D+03,0.28844000D+01,0.18648000D+01
     .,0.63893520D+03,0.190D+03,0.178D+03,0.28844000D+01,0.19188000D+01
     .,0.61116560D+03,0.190D+03,0.179D+03,0.28844000D+01,0.98460000D+00
     .,0.58708670D+03,0.190D+03,0.180D+03,0.28844000D+01,0.19896000D+01
     .,0.97511530D+03,0.190D+03,0.181D+03,0.28844000D+01,0.92670000D+00
     .,0.87752310D+03,0.190D+03,0.182D+03,0.28844000D+01,0.93830000D+00
     .,0.84561490D+03,0.190D+03,0.183D+03,0.28844000D+01,0.98200000D+00
     .,0.81904220D+03,0.190D+03,0.184D+03,0.28844000D+01,0.98150000D+00
     .,0.76065040D+03,0.190D+03,0.185D+03,0.28844000D+01,0.99540000D+00
     .,0.10026461D+04,0.190D+03,0.187D+03,0.28844000D+01,0.97050000D+00
     .,0.19926647D+04,0.190D+03,0.188D+03,0.28844000D+01,0.96620000D+00
     .,0.10474302D+04,0.190D+03,0.189D+03,0.28844000D+01,0.29070000D+01
     .,0.12245933D+04,0.190D+03,0.190D+03,0.28844000D+01,0.28844000D+01
     .,0.52264500D+02,0.191D+03,0.100D+01,0.28738000D+01,0.91180000D+00
     .,0.34332900D+02,0.191D+03,0.200D+01,0.28738000D+01,0.00000000D+00
     .,0.89070150D+03,0.191D+03,0.300D+01,0.28738000D+01,0.00000000D+00
     .,0.48502270D+03,0.191D+03,0.400D+01,0.28738000D+01,0.00000000D+00
     .,0.32084970D+03,0.191D+03,0.500D+01,0.28738000D+01,0.00000000D+00
     .,0.21465050D+03,0.191D+03,0.600D+01,0.28738000D+01,0.00000000D+00
     .,0.14930470D+03,0.191D+03,0.700D+01,0.28738000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  78801:  78900)=(/
     . 0.11273380D+03,0.191D+03,0.800D+01,0.28738000D+01,0.00000000D+00
     .,0.85262100D+02,0.191D+03,0.900D+01,0.28738000D+01,0.00000000D+00
     .,0.65533100D+02,0.191D+03,0.100D+02,0.28738000D+01,0.00000000D+00
     .,0.10608040D+04,0.191D+03,0.110D+02,0.28738000D+01,0.00000000D+00
     .,0.77888060D+03,0.191D+03,0.120D+02,0.28738000D+01,0.00000000D+00
     .,0.71034880D+03,0.191D+03,0.130D+02,0.28738000D+01,0.00000000D+00
     .,0.55219130D+03,0.191D+03,0.140D+02,0.28738000D+01,0.00000000D+00
     .,0.42680750D+03,0.191D+03,0.150D+02,0.28738000D+01,0.00000000D+00
     .,0.35264770D+03,0.191D+03,0.160D+02,0.28738000D+01,0.00000000D+00
     .,0.28699980D+03,0.191D+03,0.170D+02,0.28738000D+01,0.00000000D+00
     .,0.23418470D+03,0.191D+03,0.180D+02,0.28738000D+01,0.00000000D+00
     .,0.17789468D+04,0.191D+03,0.190D+02,0.28738000D+01,0.00000000D+00
     .,0.13939683D+04,0.191D+03,0.200D+02,0.28738000D+01,0.00000000D+00
     .,0.11425935D+04,0.191D+03,0.210D+02,0.28738000D+01,0.00000000D+00
     .,0.10979705D+04,0.191D+03,0.220D+02,0.28738000D+01,0.00000000D+00
     .,0.10022471D+04,0.191D+03,0.230D+02,0.28738000D+01,0.00000000D+00
     .,0.79096650D+03,0.191D+03,0.240D+02,0.28738000D+01,0.00000000D+00
     .,0.85910440D+03,0.191D+03,0.250D+02,0.28738000D+01,0.00000000D+00
     .,0.67498040D+03,0.191D+03,0.260D+02,0.28738000D+01,0.00000000D+00
     .,0.70900470D+03,0.191D+03,0.270D+02,0.28738000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  78901:  79000)=(/
     . 0.73240820D+03,0.191D+03,0.280D+02,0.28738000D+01,0.00000000D+00
     .,0.56299640D+03,0.191D+03,0.290D+02,0.28738000D+01,0.00000000D+00
     .,0.57131500D+03,0.191D+03,0.300D+02,0.28738000D+01,0.00000000D+00
     .,0.67870160D+03,0.191D+03,0.310D+02,0.28738000D+01,0.00000000D+00
     .,0.59190790D+03,0.191D+03,0.320D+02,0.28738000D+01,0.00000000D+00
     .,0.50094070D+03,0.191D+03,0.330D+02,0.28738000D+01,0.00000000D+00
     .,0.44774380D+03,0.191D+03,0.340D+02,0.28738000D+01,0.00000000D+00
     .,0.39043140D+03,0.191D+03,0.350D+02,0.28738000D+01,0.00000000D+00
     .,0.33858330D+03,0.191D+03,0.360D+02,0.28738000D+01,0.00000000D+00
     .,0.19913447D+04,0.191D+03,0.370D+02,0.28738000D+01,0.00000000D+00
     .,0.16656547D+04,0.191D+03,0.380D+02,0.28738000D+01,0.00000000D+00
     .,0.14407783D+04,0.191D+03,0.390D+02,0.28738000D+01,0.00000000D+00
     .,0.12860297D+04,0.191D+03,0.400D+02,0.28738000D+01,0.00000000D+00
     .,0.11683462D+04,0.191D+03,0.410D+02,0.28738000D+01,0.00000000D+00
     .,0.89688390D+03,0.191D+03,0.420D+02,0.28738000D+01,0.00000000D+00
     .,0.10030323D+04,0.191D+03,0.430D+02,0.28738000D+01,0.00000000D+00
     .,0.75931940D+03,0.191D+03,0.440D+02,0.28738000D+01,0.00000000D+00
     .,0.82841280D+03,0.191D+03,0.450D+02,0.28738000D+01,0.00000000D+00
     .,0.76640860D+03,0.191D+03,0.460D+02,0.28738000D+01,0.00000000D+00
     .,0.64182000D+03,0.191D+03,0.470D+02,0.28738000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  79001:  79100)=(/
     . 0.67342870D+03,0.191D+03,0.480D+02,0.28738000D+01,0.00000000D+00
     .,0.85158740D+03,0.191D+03,0.490D+02,0.28738000D+01,0.00000000D+00
     .,0.77929980D+03,0.191D+03,0.500D+02,0.28738000D+01,0.00000000D+00
     .,0.68907930D+03,0.191D+03,0.510D+02,0.28738000D+01,0.00000000D+00
     .,0.63681840D+03,0.191D+03,0.520D+02,0.28738000D+01,0.00000000D+00
     .,0.57361210D+03,0.191D+03,0.530D+02,0.28738000D+01,0.00000000D+00
     .,0.51407080D+03,0.191D+03,0.540D+02,0.28738000D+01,0.00000000D+00
     .,0.24381558D+04,0.191D+03,0.550D+02,0.28738000D+01,0.00000000D+00
     .,0.21382977D+04,0.191D+03,0.560D+02,0.28738000D+01,0.00000000D+00
     .,0.18526946D+04,0.191D+03,0.570D+02,0.28738000D+01,0.00000000D+00
     .,0.81584440D+03,0.191D+03,0.580D+02,0.28738000D+01,0.27991000D+01
     .,0.18889925D+04,0.191D+03,0.590D+02,0.28738000D+01,0.00000000D+00
     .,0.18057716D+04,0.191D+03,0.600D+02,0.28738000D+01,0.00000000D+00
     .,0.17590005D+04,0.191D+03,0.610D+02,0.28738000D+01,0.00000000D+00
     .,0.17161451D+04,0.191D+03,0.620D+02,0.28738000D+01,0.00000000D+00
     .,0.16781174D+04,0.191D+03,0.630D+02,0.28738000D+01,0.00000000D+00
     .,0.13048651D+04,0.191D+03,0.640D+02,0.28738000D+01,0.00000000D+00
     .,0.15104078D+04,0.191D+03,0.650D+02,0.28738000D+01,0.00000000D+00
     .,0.14576760D+04,0.191D+03,0.660D+02,0.28738000D+01,0.00000000D+00
     .,0.15075770D+04,0.191D+03,0.670D+02,0.28738000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  79101:  79200)=(/
     . 0.14748115D+04,0.191D+03,0.680D+02,0.28738000D+01,0.00000000D+00
     .,0.14450628D+04,0.191D+03,0.690D+02,0.28738000D+01,0.00000000D+00
     .,0.14287766D+04,0.191D+03,0.700D+02,0.28738000D+01,0.00000000D+00
     .,0.11975147D+04,0.191D+03,0.710D+02,0.28738000D+01,0.00000000D+00
     .,0.11607498D+04,0.191D+03,0.720D+02,0.28738000D+01,0.00000000D+00
     .,0.10529859D+04,0.191D+03,0.730D+02,0.28738000D+01,0.00000000D+00
     .,0.88698680D+03,0.191D+03,0.740D+02,0.28738000D+01,0.00000000D+00
     .,0.89986720D+03,0.191D+03,0.750D+02,0.28738000D+01,0.00000000D+00
     .,0.81184020D+03,0.191D+03,0.760D+02,0.28738000D+01,0.00000000D+00
     .,0.74102110D+03,0.191D+03,0.770D+02,0.28738000D+01,0.00000000D+00
     .,0.61428030D+03,0.191D+03,0.780D+02,0.28738000D+01,0.00000000D+00
     .,0.57339400D+03,0.191D+03,0.790D+02,0.28738000D+01,0.00000000D+00
     .,0.58842050D+03,0.191D+03,0.800D+02,0.28738000D+01,0.00000000D+00
     .,0.87453780D+03,0.191D+03,0.810D+02,0.28738000D+01,0.00000000D+00
     .,0.84698840D+03,0.191D+03,0.820D+02,0.28738000D+01,0.00000000D+00
     .,0.77232730D+03,0.191D+03,0.830D+02,0.28738000D+01,0.00000000D+00
     .,0.73386420D+03,0.191D+03,0.840D+02,0.28738000D+01,0.00000000D+00
     .,0.67459880D+03,0.191D+03,0.850D+02,0.28738000D+01,0.00000000D+00
     .,0.61636260D+03,0.191D+03,0.860D+02,0.28738000D+01,0.00000000D+00
     .,0.22655221D+04,0.191D+03,0.870D+02,0.28738000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  79201:  79300)=(/
     . 0.21000716D+04,0.191D+03,0.880D+02,0.28738000D+01,0.00000000D+00
     .,0.18334406D+04,0.191D+03,0.890D+02,0.28738000D+01,0.00000000D+00
     .,0.16280585D+04,0.191D+03,0.900D+02,0.28738000D+01,0.00000000D+00
     .,0.16281996D+04,0.191D+03,0.910D+02,0.28738000D+01,0.00000000D+00
     .,0.15757649D+04,0.191D+03,0.920D+02,0.28738000D+01,0.00000000D+00
     .,0.16336303D+04,0.191D+03,0.930D+02,0.28738000D+01,0.00000000D+00
     .,0.15794150D+04,0.191D+03,0.940D+02,0.28738000D+01,0.00000000D+00
     .,0.84723800D+02,0.191D+03,0.101D+03,0.28738000D+01,0.00000000D+00
     .,0.28145990D+03,0.191D+03,0.103D+03,0.28738000D+01,0.98650000D+00
     .,0.35859140D+03,0.191D+03,0.104D+03,0.28738000D+01,0.98080000D+00
     .,0.26924380D+03,0.191D+03,0.105D+03,0.28738000D+01,0.97060000D+00
     .,0.20157990D+03,0.191D+03,0.106D+03,0.28738000D+01,0.98680000D+00
     .,0.13931210D+03,0.191D+03,0.107D+03,0.28738000D+01,0.99440000D+00
     .,0.10105790D+03,0.191D+03,0.108D+03,0.28738000D+01,0.99250000D+00
     .,0.69270700D+02,0.191D+03,0.109D+03,0.28738000D+01,0.99820000D+00
     .,0.41351280D+03,0.191D+03,0.111D+03,0.28738000D+01,0.96840000D+00
     .,0.64146750D+03,0.191D+03,0.112D+03,0.28738000D+01,0.96280000D+00
     .,0.64236160D+03,0.191D+03,0.113D+03,0.28738000D+01,0.96480000D+00
     .,0.50971630D+03,0.191D+03,0.114D+03,0.28738000D+01,0.95070000D+00
     .,0.41427030D+03,0.191D+03,0.115D+03,0.28738000D+01,0.99470000D+00
     ./)
      grimme_c6_parameters(  79301:  79400)=(/
     . 0.34884970D+03,0.191D+03,0.116D+03,0.28738000D+01,0.99480000D+00
     .,0.28407250D+03,0.191D+03,0.117D+03,0.28738000D+01,0.99720000D+00
     .,0.56838310D+03,0.191D+03,0.119D+03,0.28738000D+01,0.97670000D+00
     .,0.11243632D+04,0.191D+03,0.120D+03,0.28738000D+01,0.98310000D+00
     .,0.55973470D+03,0.191D+03,0.121D+03,0.28738000D+01,0.18627000D+01
     .,0.54164230D+03,0.191D+03,0.122D+03,0.28738000D+01,0.18299000D+01
     .,0.53075760D+03,0.191D+03,0.123D+03,0.28738000D+01,0.19138000D+01
     .,0.52667650D+03,0.191D+03,0.124D+03,0.28738000D+01,0.18269000D+01
     .,0.48098950D+03,0.191D+03,0.125D+03,0.28738000D+01,0.16406000D+01
     .,0.44458610D+03,0.191D+03,0.126D+03,0.28738000D+01,0.16483000D+01
     .,0.42438350D+03,0.191D+03,0.127D+03,0.28738000D+01,0.17149000D+01
     .,0.41509660D+03,0.191D+03,0.128D+03,0.28738000D+01,0.17937000D+01
     .,0.41210000D+03,0.191D+03,0.129D+03,0.28738000D+01,0.95760000D+00
     .,0.38322820D+03,0.191D+03,0.130D+03,0.28738000D+01,0.19419000D+01
     .,0.63562870D+03,0.191D+03,0.131D+03,0.28738000D+01,0.96010000D+00
     .,0.55267960D+03,0.191D+03,0.132D+03,0.28738000D+01,0.94340000D+00
     .,0.49229290D+03,0.191D+03,0.133D+03,0.28738000D+01,0.98890000D+00
     .,0.44797180D+03,0.191D+03,0.134D+03,0.28738000D+01,0.99010000D+00
     .,0.39323670D+03,0.191D+03,0.135D+03,0.28738000D+01,0.99740000D+00
     .,0.67715660D+03,0.191D+03,0.137D+03,0.28738000D+01,0.97380000D+00
     ./)
      grimme_c6_parameters(  79401:  79500)=(/
     . 0.13743437D+04,0.191D+03,0.138D+03,0.28738000D+01,0.98010000D+00
     .,0.10260397D+04,0.191D+03,0.139D+03,0.28738000D+01,0.19153000D+01
     .,0.74279230D+03,0.191D+03,0.140D+03,0.28738000D+01,0.19355000D+01
     .,0.74895660D+03,0.191D+03,0.141D+03,0.28738000D+01,0.19545000D+01
     .,0.69892350D+03,0.191D+03,0.142D+03,0.28738000D+01,0.19420000D+01
     .,0.79275350D+03,0.191D+03,0.143D+03,0.28738000D+01,0.16682000D+01
     .,0.60535870D+03,0.191D+03,0.144D+03,0.28738000D+01,0.18584000D+01
     .,0.56644570D+03,0.191D+03,0.145D+03,0.28738000D+01,0.19003000D+01
     .,0.52569600D+03,0.191D+03,0.146D+03,0.28738000D+01,0.18630000D+01
     .,0.50889220D+03,0.191D+03,0.147D+03,0.28738000D+01,0.96790000D+00
     .,0.50075690D+03,0.191D+03,0.148D+03,0.28738000D+01,0.19539000D+01
     .,0.80885400D+03,0.191D+03,0.149D+03,0.28738000D+01,0.96330000D+00
     .,0.72462440D+03,0.191D+03,0.150D+03,0.28738000D+01,0.95140000D+00
     .,0.67473780D+03,0.191D+03,0.151D+03,0.28738000D+01,0.97490000D+00
     .,0.63619670D+03,0.191D+03,0.152D+03,0.28738000D+01,0.98110000D+00
     .,0.57901430D+03,0.191D+03,0.153D+03,0.28738000D+01,0.99680000D+00
     .,0.79465520D+03,0.191D+03,0.155D+03,0.28738000D+01,0.99090000D+00
     .,0.18031914D+04,0.191D+03,0.156D+03,0.28738000D+01,0.97970000D+00
     .,0.13050880D+04,0.191D+03,0.157D+03,0.28738000D+01,0.19373000D+01
     .,0.79095680D+03,0.191D+03,0.159D+03,0.28738000D+01,0.29425000D+01
     ./)
      grimme_c6_parameters(  79501:  79600)=(/
     . 0.77448190D+03,0.191D+03,0.160D+03,0.28738000D+01,0.29455000D+01
     .,0.74970660D+03,0.191D+03,0.161D+03,0.28738000D+01,0.29413000D+01
     .,0.75473340D+03,0.191D+03,0.162D+03,0.28738000D+01,0.29300000D+01
     .,0.73034120D+03,0.191D+03,0.163D+03,0.28738000D+01,0.18286000D+01
     .,0.75925810D+03,0.191D+03,0.164D+03,0.28738000D+01,0.28732000D+01
     .,0.71236590D+03,0.191D+03,0.165D+03,0.28738000D+01,0.29086000D+01
     .,0.72723060D+03,0.191D+03,0.166D+03,0.28738000D+01,0.28965000D+01
     .,0.67539950D+03,0.191D+03,0.167D+03,0.28738000D+01,0.29242000D+01
     .,0.65589880D+03,0.191D+03,0.168D+03,0.28738000D+01,0.29282000D+01
     .,0.65187600D+03,0.191D+03,0.169D+03,0.28738000D+01,0.29246000D+01
     .,0.68605020D+03,0.191D+03,0.170D+03,0.28738000D+01,0.28482000D+01
     .,0.62962830D+03,0.191D+03,0.171D+03,0.28738000D+01,0.29219000D+01
     .,0.86895920D+03,0.191D+03,0.172D+03,0.28738000D+01,0.19254000D+01
     .,0.80143340D+03,0.191D+03,0.173D+03,0.28738000D+01,0.19459000D+01
     .,0.72695200D+03,0.191D+03,0.174D+03,0.28738000D+01,0.19292000D+01
     .,0.73934260D+03,0.191D+03,0.175D+03,0.28738000D+01,0.18104000D+01
     .,0.63931090D+03,0.191D+03,0.176D+03,0.28738000D+01,0.18858000D+01
     .,0.60057540D+03,0.191D+03,0.177D+03,0.28738000D+01,0.18648000D+01
     .,0.57328530D+03,0.191D+03,0.178D+03,0.28738000D+01,0.19188000D+01
     .,0.54847560D+03,0.191D+03,0.179D+03,0.28738000D+01,0.98460000D+00
     ./)
      grimme_c6_parameters(  79601:  79700)=(/
     . 0.52767310D+03,0.191D+03,0.180D+03,0.28738000D+01,0.19896000D+01
     .,0.86865890D+03,0.191D+03,0.181D+03,0.28738000D+01,0.92670000D+00
     .,0.78363670D+03,0.191D+03,0.182D+03,0.28738000D+01,0.93830000D+00
     .,0.75634500D+03,0.191D+03,0.183D+03,0.28738000D+01,0.98200000D+00
     .,0.73358480D+03,0.191D+03,0.184D+03,0.28738000D+01,0.98150000D+00
     .,0.68269100D+03,0.191D+03,0.185D+03,0.28738000D+01,0.99540000D+00
     .,0.89435100D+03,0.191D+03,0.187D+03,0.28738000D+01,0.97050000D+00
     .,0.17716049D+04,0.191D+03,0.188D+03,0.28738000D+01,0.96620000D+00
     .,0.93586320D+03,0.191D+03,0.189D+03,0.28738000D+01,0.29070000D+01
     .,0.10934914D+04,0.191D+03,0.190D+03,0.28738000D+01,0.28844000D+01
     .,0.98037580D+03,0.191D+03,0.191D+03,0.28738000D+01,0.28738000D+01
     .,0.46755900D+02,0.192D+03,0.100D+01,0.28878000D+01,0.91180000D+00
     .,0.31074600D+02,0.192D+03,0.200D+01,0.28878000D+01,0.00000000D+00
     .,0.73198050D+03,0.192D+03,0.300D+01,0.28878000D+01,0.00000000D+00
     .,0.41975640D+03,0.192D+03,0.400D+01,0.28878000D+01,0.00000000D+00
     .,0.28243120D+03,0.192D+03,0.500D+01,0.28878000D+01,0.00000000D+00
     .,0.19102230D+03,0.192D+03,0.600D+01,0.28878000D+01,0.00000000D+00
     .,0.13387230D+03,0.192D+03,0.700D+01,0.28878000D+01,0.00000000D+00
     .,0.10159960D+03,0.192D+03,0.800D+01,0.28878000D+01,0.00000000D+00
     .,0.77176400D+02,0.192D+03,0.900D+01,0.28878000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  79701:  79800)=(/
     . 0.59527100D+02,0.192D+03,0.100D+02,0.28878000D+01,0.00000000D+00
     .,0.87518610D+03,0.192D+03,0.110D+02,0.28878000D+01,0.00000000D+00
     .,0.66958510D+03,0.192D+03,0.120D+02,0.28878000D+01,0.00000000D+00
     .,0.61654260D+03,0.192D+03,0.130D+02,0.28878000D+01,0.00000000D+00
     .,0.48533720D+03,0.192D+03,0.140D+02,0.28878000D+01,0.00000000D+00
     .,0.37850250D+03,0.192D+03,0.150D+02,0.28878000D+01,0.00000000D+00
     .,0.31437000D+03,0.192D+03,0.160D+02,0.28878000D+01,0.00000000D+00
     .,0.25708750D+03,0.192D+03,0.170D+02,0.28878000D+01,0.00000000D+00
     .,0.21063660D+03,0.192D+03,0.180D+02,0.28878000D+01,0.00000000D+00
     .,0.14387994D+04,0.192D+03,0.190D+02,0.28878000D+01,0.00000000D+00
     .,0.11798248D+04,0.192D+03,0.200D+02,0.28878000D+01,0.00000000D+00
     .,0.97372410D+03,0.192D+03,0.210D+02,0.28878000D+01,0.00000000D+00
     .,0.93993750D+03,0.192D+03,0.220D+02,0.28878000D+01,0.00000000D+00
     .,0.86049210D+03,0.192D+03,0.230D+02,0.28878000D+01,0.00000000D+00
     .,0.67850520D+03,0.192D+03,0.240D+02,0.28878000D+01,0.00000000D+00
     .,0.74061370D+03,0.192D+03,0.250D+02,0.28878000D+01,0.00000000D+00
     .,0.58183780D+03,0.192D+03,0.260D+02,0.28878000D+01,0.00000000D+00
     .,0.61569900D+03,0.192D+03,0.270D+02,0.28878000D+01,0.00000000D+00
     .,0.63436640D+03,0.192D+03,0.280D+02,0.28878000D+01,0.00000000D+00
     .,0.48701500D+03,0.192D+03,0.290D+02,0.28878000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  79801:  79900)=(/
     . 0.49903190D+03,0.192D+03,0.300D+02,0.28878000D+01,0.00000000D+00
     .,0.59084610D+03,0.192D+03,0.310D+02,0.28878000D+01,0.00000000D+00
     .,0.52052680D+03,0.192D+03,0.320D+02,0.28878000D+01,0.00000000D+00
     .,0.44390020D+03,0.192D+03,0.330D+02,0.28878000D+01,0.00000000D+00
     .,0.39844930D+03,0.192D+03,0.340D+02,0.28878000D+01,0.00000000D+00
     .,0.34891220D+03,0.192D+03,0.350D+02,0.28878000D+01,0.00000000D+00
     .,0.30370810D+03,0.192D+03,0.360D+02,0.28878000D+01,0.00000000D+00
     .,0.16125430D+04,0.192D+03,0.370D+02,0.28878000D+01,0.00000000D+00
     .,0.14064978D+04,0.192D+03,0.380D+02,0.28878000D+01,0.00000000D+00
     .,0.12301136D+04,0.192D+03,0.390D+02,0.28878000D+01,0.00000000D+00
     .,0.11047666D+04,0.192D+03,0.400D+02,0.28878000D+01,0.00000000D+00
     .,0.10071282D+04,0.192D+03,0.410D+02,0.28878000D+01,0.00000000D+00
     .,0.77757670D+03,0.192D+03,0.420D+02,0.28878000D+01,0.00000000D+00
     .,0.86755080D+03,0.192D+03,0.430D+02,0.28878000D+01,0.00000000D+00
     .,0.66100390D+03,0.192D+03,0.440D+02,0.28878000D+01,0.00000000D+00
     .,0.72198170D+03,0.192D+03,0.450D+02,0.28878000D+01,0.00000000D+00
     .,0.66945830D+03,0.192D+03,0.460D+02,0.28878000D+01,0.00000000D+00
     .,0.55904400D+03,0.192D+03,0.470D+02,0.28878000D+01,0.00000000D+00
     .,0.58989000D+03,0.192D+03,0.480D+02,0.28878000D+01,0.00000000D+00
     .,0.74043240D+03,0.192D+03,0.490D+02,0.28878000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  79901:  80000)=(/
     . 0.68380180D+03,0.192D+03,0.500D+02,0.28878000D+01,0.00000000D+00
     .,0.60902530D+03,0.192D+03,0.510D+02,0.28878000D+01,0.00000000D+00
     .,0.56501830D+03,0.192D+03,0.520D+02,0.28878000D+01,0.00000000D+00
     .,0.51096120D+03,0.192D+03,0.530D+02,0.28878000D+01,0.00000000D+00
     .,0.45956760D+03,0.192D+03,0.540D+02,0.28878000D+01,0.00000000D+00
     .,0.19652428D+04,0.192D+03,0.550D+02,0.28878000D+01,0.00000000D+00
     .,0.17949059D+04,0.192D+03,0.560D+02,0.28878000D+01,0.00000000D+00
     .,0.15740959D+04,0.192D+03,0.570D+02,0.28878000D+01,0.00000000D+00
     .,0.71985720D+03,0.192D+03,0.580D+02,0.28878000D+01,0.27991000D+01
     .,0.15898595D+04,0.192D+03,0.590D+02,0.28878000D+01,0.00000000D+00
     .,0.15259822D+04,0.192D+03,0.600D+02,0.28878000D+01,0.00000000D+00
     .,0.14875408D+04,0.192D+03,0.610D+02,0.28878000D+01,0.00000000D+00
     .,0.14521965D+04,0.192D+03,0.620D+02,0.28878000D+01,0.00000000D+00
     .,0.14208475D+04,0.192D+03,0.630D+02,0.28878000D+01,0.00000000D+00
     .,0.11161138D+04,0.192D+03,0.640D+02,0.28878000D+01,0.00000000D+00
     .,0.12609766D+04,0.192D+03,0.650D+02,0.28878000D+01,0.00000000D+00
     .,0.12159398D+04,0.192D+03,0.660D+02,0.28878000D+01,0.00000000D+00
     .,0.12808410D+04,0.192D+03,0.670D+02,0.28878000D+01,0.00000000D+00
     .,0.12535493D+04,0.192D+03,0.680D+02,0.28878000D+01,0.00000000D+00
     .,0.12289183D+04,0.192D+03,0.690D+02,0.28878000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  80001:  80100)=(/
     . 0.12145773D+04,0.192D+03,0.700D+02,0.28878000D+01,0.00000000D+00
     .,0.10226803D+04,0.192D+03,0.710D+02,0.28878000D+01,0.00000000D+00
     .,0.10038975D+04,0.192D+03,0.720D+02,0.28878000D+01,0.00000000D+00
     .,0.91571760D+03,0.192D+03,0.730D+02,0.28878000D+01,0.00000000D+00
     .,0.77355940D+03,0.192D+03,0.740D+02,0.28878000D+01,0.00000000D+00
     .,0.78664370D+03,0.192D+03,0.750D+02,0.28878000D+01,0.00000000D+00
     .,0.71280370D+03,0.192D+03,0.760D+02,0.28878000D+01,0.00000000D+00
     .,0.65278320D+03,0.192D+03,0.770D+02,0.28878000D+01,0.00000000D+00
     .,0.54266550D+03,0.192D+03,0.780D+02,0.28878000D+01,0.00000000D+00
     .,0.50716770D+03,0.192D+03,0.790D+02,0.28878000D+01,0.00000000D+00
     .,0.52145390D+03,0.192D+03,0.800D+02,0.28878000D+01,0.00000000D+00
     .,0.76086200D+03,0.192D+03,0.810D+02,0.28878000D+01,0.00000000D+00
     .,0.74290150D+03,0.192D+03,0.820D+02,0.28878000D+01,0.00000000D+00
     .,0.68212270D+03,0.192D+03,0.830D+02,0.28878000D+01,0.00000000D+00
     .,0.65042490D+03,0.192D+03,0.840D+02,0.28878000D+01,0.00000000D+00
     .,0.60026280D+03,0.192D+03,0.850D+02,0.28878000D+01,0.00000000D+00
     .,0.55029950D+03,0.192D+03,0.860D+02,0.28878000D+01,0.00000000D+00
     .,0.18525059D+04,0.192D+03,0.870D+02,0.28878000D+01,0.00000000D+00
     .,0.17734791D+04,0.192D+03,0.880D+02,0.28878000D+01,0.00000000D+00
     .,0.15651457D+04,0.192D+03,0.890D+02,0.28878000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  80101:  80200)=(/
     . 0.14048813D+04,0.192D+03,0.900D+02,0.28878000D+01,0.00000000D+00
     .,0.13963790D+04,0.192D+03,0.910D+02,0.28878000D+01,0.00000000D+00
     .,0.13520713D+04,0.192D+03,0.920D+02,0.28878000D+01,0.00000000D+00
     .,0.13933621D+04,0.192D+03,0.930D+02,0.28878000D+01,0.00000000D+00
     .,0.13490495D+04,0.192D+03,0.940D+02,0.28878000D+01,0.00000000D+00
     .,0.75206600D+02,0.192D+03,0.101D+03,0.28878000D+01,0.00000000D+00
     .,0.24403010D+03,0.192D+03,0.103D+03,0.28878000D+01,0.98650000D+00
     .,0.31132040D+03,0.192D+03,0.104D+03,0.28878000D+01,0.98080000D+00
     .,0.23766340D+03,0.192D+03,0.105D+03,0.28878000D+01,0.97060000D+00
     .,0.17925610D+03,0.192D+03,0.106D+03,0.28878000D+01,0.98680000D+00
     .,0.12489310D+03,0.192D+03,0.107D+03,0.28878000D+01,0.99440000D+00
     .,0.91186300D+02,0.192D+03,0.108D+03,0.28878000D+01,0.99250000D+00
     .,0.62986700D+02,0.192D+03,0.109D+03,0.28878000D+01,0.99820000D+00
     .,0.35715820D+03,0.192D+03,0.111D+03,0.28878000D+01,0.96840000D+00
     .,0.55232750D+03,0.192D+03,0.112D+03,0.28878000D+01,0.96280000D+00
     .,0.55871280D+03,0.192D+03,0.113D+03,0.28878000D+01,0.96480000D+00
     .,0.44861130D+03,0.192D+03,0.114D+03,0.28878000D+01,0.95070000D+00
     .,0.36744990D+03,0.192D+03,0.115D+03,0.28878000D+01,0.99470000D+00
     .,0.31093340D+03,0.192D+03,0.116D+03,0.28878000D+01,0.99480000D+00
     .,0.25443970D+03,0.192D+03,0.117D+03,0.28878000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters(  80201:  80300)=(/
     . 0.49305900D+03,0.192D+03,0.119D+03,0.28878000D+01,0.97670000D+00
     .,0.94512240D+03,0.192D+03,0.120D+03,0.28878000D+01,0.98310000D+00
     .,0.49217970D+03,0.192D+03,0.121D+03,0.28878000D+01,0.18627000D+01
     .,0.47531010D+03,0.192D+03,0.122D+03,0.28878000D+01,0.18299000D+01
     .,0.46586480D+03,0.192D+03,0.123D+03,0.28878000D+01,0.19138000D+01
     .,0.46166860D+03,0.192D+03,0.124D+03,0.28878000D+01,0.18269000D+01
     .,0.42443750D+03,0.192D+03,0.125D+03,0.28878000D+01,0.16406000D+01
     .,0.39286320D+03,0.192D+03,0.126D+03,0.28878000D+01,0.16483000D+01
     .,0.37486590D+03,0.192D+03,0.127D+03,0.28878000D+01,0.17149000D+01
     .,0.36651980D+03,0.192D+03,0.128D+03,0.28878000D+01,0.17937000D+01
     .,0.36235940D+03,0.192D+03,0.129D+03,0.28878000D+01,0.95760000D+00
     .,0.33963850D+03,0.192D+03,0.130D+03,0.28878000D+01,0.19419000D+01
     .,0.55481070D+03,0.192D+03,0.131D+03,0.28878000D+01,0.96010000D+00
     .,0.48695430D+03,0.192D+03,0.132D+03,0.28878000D+01,0.94340000D+00
     .,0.43639410D+03,0.192D+03,0.133D+03,0.28878000D+01,0.98890000D+00
     .,0.39861480D+03,0.192D+03,0.134D+03,0.28878000D+01,0.99010000D+00
     .,0.35133960D+03,0.192D+03,0.135D+03,0.28878000D+01,0.99740000D+00
     .,0.58839800D+03,0.192D+03,0.137D+03,0.28878000D+01,0.97380000D+00
     .,0.11509048D+04,0.192D+03,0.138D+03,0.28878000D+01,0.98010000D+00
     .,0.87728230D+03,0.192D+03,0.139D+03,0.28878000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters(  80301:  80400)=(/
     . 0.65137000D+03,0.192D+03,0.140D+03,0.28878000D+01,0.19355000D+01
     .,0.65782330D+03,0.192D+03,0.141D+03,0.28878000D+01,0.19545000D+01
     .,0.61355160D+03,0.192D+03,0.142D+03,0.28878000D+01,0.19420000D+01
     .,0.68895110D+03,0.192D+03,0.143D+03,0.28878000D+01,0.16682000D+01
     .,0.53468200D+03,0.192D+03,0.144D+03,0.28878000D+01,0.18584000D+01
     .,0.50038440D+03,0.192D+03,0.145D+03,0.28878000D+01,0.19003000D+01
     .,0.46479060D+03,0.192D+03,0.146D+03,0.28878000D+01,0.18630000D+01
     .,0.44970340D+03,0.192D+03,0.147D+03,0.28878000D+01,0.96790000D+00
     .,0.44450890D+03,0.192D+03,0.148D+03,0.28878000D+01,0.19539000D+01
     .,0.70553710D+03,0.192D+03,0.149D+03,0.28878000D+01,0.96330000D+00
     .,0.63759540D+03,0.192D+03,0.150D+03,0.28878000D+01,0.95140000D+00
     .,0.59686560D+03,0.192D+03,0.151D+03,0.28878000D+01,0.97490000D+00
     .,0.56459640D+03,0.192D+03,0.152D+03,0.28878000D+01,0.98110000D+00
     .,0.51574020D+03,0.192D+03,0.153D+03,0.28878000D+01,0.99680000D+00
     .,0.69501880D+03,0.192D+03,0.155D+03,0.28878000D+01,0.99090000D+00
     .,0.14942771D+04,0.192D+03,0.156D+03,0.28878000D+01,0.97970000D+00
     .,0.11109199D+04,0.192D+03,0.157D+03,0.28878000D+01,0.19373000D+01
     .,0.69816140D+03,0.192D+03,0.159D+03,0.28878000D+01,0.29425000D+01
     .,0.68372500D+03,0.192D+03,0.160D+03,0.28878000D+01,0.29455000D+01
     .,0.66206630D+03,0.192D+03,0.161D+03,0.28878000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters(  80401:  80500)=(/
     . 0.66540380D+03,0.192D+03,0.162D+03,0.28878000D+01,0.29300000D+01
     .,0.64179300D+03,0.192D+03,0.163D+03,0.28878000D+01,0.18286000D+01
     .,0.66949760D+03,0.192D+03,0.164D+03,0.28878000D+01,0.28732000D+01
     .,0.62884090D+03,0.192D+03,0.165D+03,0.28878000D+01,0.29086000D+01
     .,0.64005220D+03,0.192D+03,0.166D+03,0.28878000D+01,0.28965000D+01
     .,0.59680940D+03,0.192D+03,0.167D+03,0.28878000D+01,0.29242000D+01
     .,0.57978670D+03,0.192D+03,0.168D+03,0.28878000D+01,0.29282000D+01
     .,0.57605760D+03,0.192D+03,0.169D+03,0.28878000D+01,0.29246000D+01
     .,0.60540230D+03,0.192D+03,0.170D+03,0.28878000D+01,0.28482000D+01
     .,0.55673610D+03,0.192D+03,0.171D+03,0.28878000D+01,0.29219000D+01
     .,0.75552630D+03,0.192D+03,0.172D+03,0.28878000D+01,0.19254000D+01
     .,0.70091760D+03,0.192D+03,0.173D+03,0.28878000D+01,0.19459000D+01
     .,0.63934100D+03,0.192D+03,0.174D+03,0.28878000D+01,0.19292000D+01
     .,0.64727080D+03,0.192D+03,0.175D+03,0.28878000D+01,0.18104000D+01
     .,0.56614580D+03,0.192D+03,0.176D+03,0.28878000D+01,0.18858000D+01
     .,0.53275200D+03,0.192D+03,0.177D+03,0.28878000D+01,0.18648000D+01
     .,0.50897860D+03,0.192D+03,0.178D+03,0.28878000D+01,0.19188000D+01
     .,0.48681770D+03,0.192D+03,0.179D+03,0.28878000D+01,0.98460000D+00
     .,0.47017820D+03,0.192D+03,0.180D+03,0.28878000D+01,0.19896000D+01
     .,0.75808150D+03,0.192D+03,0.181D+03,0.28878000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters(  80501:  80600)=(/
     . 0.69014330D+03,0.192D+03,0.182D+03,0.28878000D+01,0.93830000D+00
     .,0.66895140D+03,0.192D+03,0.183D+03,0.28878000D+01,0.98200000D+00
     .,0.65052430D+03,0.192D+03,0.184D+03,0.28878000D+01,0.98150000D+00
     .,0.60748900D+03,0.192D+03,0.185D+03,0.28878000D+01,0.99540000D+00
     .,0.78264720D+03,0.192D+03,0.187D+03,0.28878000D+01,0.97050000D+00
     .,0.14842630D+04,0.192D+03,0.188D+03,0.28878000D+01,0.96620000D+00
     .,0.82601520D+03,0.192D+03,0.189D+03,0.28878000D+01,0.29070000D+01
     .,0.95479790D+03,0.192D+03,0.190D+03,0.28878000D+01,0.28844000D+01
     .,0.85410020D+03,0.192D+03,0.191D+03,0.28878000D+01,0.28738000D+01
     .,0.75386170D+03,0.192D+03,0.192D+03,0.28878000D+01,0.28878000D+01
     .,0.45123600D+02,0.193D+03,0.100D+01,0.29095000D+01,0.91180000D+00
     .,0.30097800D+02,0.193D+03,0.200D+01,0.29095000D+01,0.00000000D+00
     .,0.69501280D+03,0.193D+03,0.300D+01,0.29095000D+01,0.00000000D+00
     .,0.40190350D+03,0.193D+03,0.400D+01,0.29095000D+01,0.00000000D+00
     .,0.27145390D+03,0.193D+03,0.500D+01,0.29095000D+01,0.00000000D+00
     .,0.18410950D+03,0.193D+03,0.600D+01,0.29095000D+01,0.00000000D+00
     .,0.12930040D+03,0.193D+03,0.700D+01,0.29095000D+01,0.00000000D+00
     .,0.98281200D+02,0.193D+03,0.800D+01,0.29095000D+01,0.00000000D+00
     .,0.74758400D+02,0.193D+03,0.900D+01,0.29095000D+01,0.00000000D+00
     .,0.57729000D+02,0.193D+03,0.100D+02,0.29095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  80601:  80700)=(/
     . 0.83149520D+03,0.193D+03,0.110D+02,0.29095000D+01,0.00000000D+00
     .,0.64031040D+03,0.193D+03,0.120D+02,0.29095000D+01,0.00000000D+00
     .,0.59077440D+03,0.193D+03,0.130D+02,0.29095000D+01,0.00000000D+00
     .,0.46630230D+03,0.193D+03,0.140D+02,0.29095000D+01,0.00000000D+00
     .,0.36444330D+03,0.193D+03,0.150D+02,0.29095000D+01,0.00000000D+00
     .,0.30311500D+03,0.193D+03,0.160D+02,0.29095000D+01,0.00000000D+00
     .,0.24821860D+03,0.193D+03,0.170D+02,0.29095000D+01,0.00000000D+00
     .,0.20361560D+03,0.193D+03,0.180D+02,0.29095000D+01,0.00000000D+00
     .,0.13643503D+04,0.193D+03,0.190D+02,0.29095000D+01,0.00000000D+00
     .,0.11254292D+04,0.193D+03,0.200D+02,0.29095000D+01,0.00000000D+00
     .,0.92988130D+03,0.193D+03,0.210D+02,0.29095000D+01,0.00000000D+00
     .,0.89845340D+03,0.193D+03,0.220D+02,0.29095000D+01,0.00000000D+00
     .,0.82298300D+03,0.193D+03,0.230D+02,0.29095000D+01,0.00000000D+00
     .,0.64899350D+03,0.193D+03,0.240D+02,0.29095000D+01,0.00000000D+00
     .,0.70890860D+03,0.193D+03,0.250D+02,0.29095000D+01,0.00000000D+00
     .,0.55705720D+03,0.193D+03,0.260D+02,0.29095000D+01,0.00000000D+00
     .,0.59015540D+03,0.193D+03,0.270D+02,0.29095000D+01,0.00000000D+00
     .,0.60771500D+03,0.193D+03,0.280D+02,0.29095000D+01,0.00000000D+00
     .,0.46659660D+03,0.193D+03,0.290D+02,0.29095000D+01,0.00000000D+00
     .,0.47890520D+03,0.193D+03,0.300D+02,0.29095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  80701:  80800)=(/
     . 0.56662400D+03,0.193D+03,0.310D+02,0.29095000D+01,0.00000000D+00
     .,0.50022560D+03,0.193D+03,0.320D+02,0.29095000D+01,0.00000000D+00
     .,0.42735080D+03,0.193D+03,0.330D+02,0.29095000D+01,0.00000000D+00
     .,0.38401570D+03,0.193D+03,0.340D+02,0.29095000D+01,0.00000000D+00
     .,0.33665520D+03,0.193D+03,0.350D+02,0.29095000D+01,0.00000000D+00
     .,0.29334880D+03,0.193D+03,0.360D+02,0.29095000D+01,0.00000000D+00
     .,0.15296978D+04,0.193D+03,0.370D+02,0.29095000D+01,0.00000000D+00
     .,0.13413275D+04,0.193D+03,0.380D+02,0.29095000D+01,0.00000000D+00
     .,0.11753725D+04,0.193D+03,0.390D+02,0.29095000D+01,0.00000000D+00
     .,0.10568235D+04,0.193D+03,0.400D+02,0.29095000D+01,0.00000000D+00
     .,0.96412660D+03,0.193D+03,0.410D+02,0.29095000D+01,0.00000000D+00
     .,0.74533540D+03,0.193D+03,0.420D+02,0.29095000D+01,0.00000000D+00
     .,0.83117090D+03,0.193D+03,0.430D+02,0.29095000D+01,0.00000000D+00
     .,0.63418960D+03,0.193D+03,0.440D+02,0.29095000D+01,0.00000000D+00
     .,0.69270260D+03,0.193D+03,0.450D+02,0.29095000D+01,0.00000000D+00
     .,0.64261150D+03,0.193D+03,0.460D+02,0.29095000D+01,0.00000000D+00
     .,0.53650370D+03,0.193D+03,0.470D+02,0.29095000D+01,0.00000000D+00
     .,0.56657800D+03,0.193D+03,0.480D+02,0.29095000D+01,0.00000000D+00
     .,0.71009360D+03,0.193D+03,0.490D+02,0.29095000D+01,0.00000000D+00
     .,0.65692100D+03,0.193D+03,0.500D+02,0.29095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  80801:  80900)=(/
     . 0.58601680D+03,0.193D+03,0.510D+02,0.29095000D+01,0.00000000D+00
     .,0.54418120D+03,0.193D+03,0.520D+02,0.29095000D+01,0.00000000D+00
     .,0.49261320D+03,0.193D+03,0.530D+02,0.29095000D+01,0.00000000D+00
     .,0.44348890D+03,0.193D+03,0.540D+02,0.29095000D+01,0.00000000D+00
     .,0.18638860D+04,0.193D+03,0.550D+02,0.29095000D+01,0.00000000D+00
     .,0.17104153D+04,0.193D+03,0.560D+02,0.29095000D+01,0.00000000D+00
     .,0.15029787D+04,0.193D+03,0.570D+02,0.29095000D+01,0.00000000D+00
     .,0.69246950D+03,0.193D+03,0.580D+02,0.29095000D+01,0.27991000D+01
     .,0.15160160D+04,0.193D+03,0.590D+02,0.29095000D+01,0.00000000D+00
     .,0.14557245D+04,0.193D+03,0.600D+02,0.29095000D+01,0.00000000D+00
     .,0.14191992D+04,0.193D+03,0.610D+02,0.29095000D+01,0.00000000D+00
     .,0.13855997D+04,0.193D+03,0.620D+02,0.29095000D+01,0.00000000D+00
     .,0.13558015D+04,0.193D+03,0.630D+02,0.29095000D+01,0.00000000D+00
     .,0.10671944D+04,0.193D+03,0.640D+02,0.29095000D+01,0.00000000D+00
     .,0.12015530D+04,0.193D+03,0.650D+02,0.29095000D+01,0.00000000D+00
     .,0.11589243D+04,0.193D+03,0.660D+02,0.29095000D+01,0.00000000D+00
     .,0.12228454D+04,0.193D+03,0.670D+02,0.29095000D+01,0.00000000D+00
     .,0.11968607D+04,0.193D+03,0.680D+02,0.29095000D+01,0.00000000D+00
     .,0.11734369D+04,0.193D+03,0.690D+02,0.29095000D+01,0.00000000D+00
     .,0.11596457D+04,0.193D+03,0.700D+02,0.29095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  80901:  81000)=(/
     . 0.97768160D+03,0.193D+03,0.710D+02,0.29095000D+01,0.00000000D+00
     .,0.96156840D+03,0.193D+03,0.720D+02,0.29095000D+01,0.00000000D+00
     .,0.87807320D+03,0.193D+03,0.730D+02,0.29095000D+01,0.00000000D+00
     .,0.74236820D+03,0.193D+03,0.740D+02,0.29095000D+01,0.00000000D+00
     .,0.75524290D+03,0.193D+03,0.750D+02,0.29095000D+01,0.00000000D+00
     .,0.68498790D+03,0.193D+03,0.760D+02,0.29095000D+01,0.00000000D+00
     .,0.62777710D+03,0.193D+03,0.770D+02,0.29095000D+01,0.00000000D+00
     .,0.52230280D+03,0.193D+03,0.780D+02,0.29095000D+01,0.00000000D+00
     .,0.48830230D+03,0.193D+03,0.790D+02,0.29095000D+01,0.00000000D+00
     .,0.50221500D+03,0.193D+03,0.800D+02,0.29095000D+01,0.00000000D+00
     .,0.73000580D+03,0.193D+03,0.810D+02,0.29095000D+01,0.00000000D+00
     .,0.71376740D+03,0.193D+03,0.820D+02,0.29095000D+01,0.00000000D+00
     .,0.65632120D+03,0.193D+03,0.830D+02,0.29095000D+01,0.00000000D+00
     .,0.62632590D+03,0.193D+03,0.840D+02,0.29095000D+01,0.00000000D+00
     .,0.57857790D+03,0.193D+03,0.850D+02,0.29095000D+01,0.00000000D+00
     .,0.53088320D+03,0.193D+03,0.860D+02,0.29095000D+01,0.00000000D+00
     .,0.17602462D+04,0.193D+03,0.870D+02,0.29095000D+01,0.00000000D+00
     .,0.16917254D+04,0.193D+03,0.880D+02,0.29095000D+01,0.00000000D+00
     .,0.14957351D+04,0.193D+03,0.890D+02,0.29095000D+01,0.00000000D+00
     .,0.13452345D+04,0.193D+03,0.900D+02,0.29095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  81001:  81100)=(/
     . 0.13357938D+04,0.193D+03,0.910D+02,0.29095000D+01,0.00000000D+00
     .,0.12935031D+04,0.193D+03,0.920D+02,0.29095000D+01,0.00000000D+00
     .,0.13314737D+04,0.193D+03,0.930D+02,0.29095000D+01,0.00000000D+00
     .,0.12894340D+04,0.193D+03,0.940D+02,0.29095000D+01,0.00000000D+00
     .,0.72427200D+02,0.193D+03,0.101D+03,0.29095000D+01,0.00000000D+00
     .,0.23377270D+03,0.193D+03,0.103D+03,0.29095000D+01,0.98650000D+00
     .,0.29840760D+03,0.193D+03,0.104D+03,0.29095000D+01,0.98080000D+00
     .,0.22859970D+03,0.193D+03,0.105D+03,0.29095000D+01,0.97060000D+00
     .,0.17275920D+03,0.193D+03,0.106D+03,0.29095000D+01,0.98680000D+00
     .,0.12063570D+03,0.193D+03,0.107D+03,0.29095000D+01,0.99440000D+00
     .,0.88243900D+02,0.193D+03,0.108D+03,0.29095000D+01,0.99250000D+00
     .,0.61099300D+02,0.193D+03,0.109D+03,0.29095000D+01,0.99820000D+00
     .,0.34193020D+03,0.193D+03,0.111D+03,0.29095000D+01,0.96840000D+00
     .,0.52851140D+03,0.193D+03,0.112D+03,0.29095000D+01,0.96280000D+00
     .,0.53561950D+03,0.193D+03,0.113D+03,0.29095000D+01,0.96480000D+00
     .,0.43117410D+03,0.193D+03,0.114D+03,0.29095000D+01,0.95070000D+00
     .,0.35382780D+03,0.193D+03,0.115D+03,0.29095000D+01,0.99470000D+00
     .,0.29979380D+03,0.193D+03,0.116D+03,0.29095000D+01,0.99480000D+00
     .,0.24565840D+03,0.193D+03,0.117D+03,0.29095000D+01,0.99720000D+00
     .,0.47272210D+03,0.193D+03,0.119D+03,0.29095000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters(  81101:  81200)=(/
     . 0.90129920D+03,0.193D+03,0.120D+03,0.29095000D+01,0.98310000D+00
     .,0.47293970D+03,0.193D+03,0.121D+03,0.29095000D+01,0.18627000D+01
     .,0.45672220D+03,0.193D+03,0.122D+03,0.29095000D+01,0.18299000D+01
     .,0.44764490D+03,0.193D+03,0.123D+03,0.29095000D+01,0.19138000D+01
     .,0.44350180D+03,0.193D+03,0.124D+03,0.29095000D+01,0.18269000D+01
     .,0.40825230D+03,0.193D+03,0.125D+03,0.29095000D+01,0.16406000D+01
     .,0.37802020D+03,0.193D+03,0.126D+03,0.29095000D+01,0.16483000D+01
     .,0.36070350D+03,0.193D+03,0.127D+03,0.29095000D+01,0.17149000D+01
     .,0.35264190D+03,0.193D+03,0.128D+03,0.29095000D+01,0.17937000D+01
     .,0.34833050D+03,0.193D+03,0.129D+03,0.29095000D+01,0.95760000D+00
     .,0.32702340D+03,0.193D+03,0.130D+03,0.29095000D+01,0.19419000D+01
     .,0.53235460D+03,0.193D+03,0.131D+03,0.29095000D+01,0.96010000D+00
     .,0.46817890D+03,0.193D+03,0.132D+03,0.29095000D+01,0.94340000D+00
     .,0.42016770D+03,0.193D+03,0.133D+03,0.29095000D+01,0.98890000D+00
     .,0.38416910D+03,0.193D+03,0.134D+03,0.29095000D+01,0.99010000D+00
     .,0.33897840D+03,0.193D+03,0.135D+03,0.29095000D+01,0.99740000D+00
     .,0.56438650D+03,0.193D+03,0.137D+03,0.29095000D+01,0.97380000D+00
     .,0.10971255D+04,0.193D+03,0.138D+03,0.29095000D+01,0.98010000D+00
     .,0.83943700D+03,0.193D+03,0.139D+03,0.29095000D+01,0.19153000D+01
     .,0.62573340D+03,0.193D+03,0.140D+03,0.29095000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters(  81201:  81300)=(/
     . 0.63197490D+03,0.193D+03,0.141D+03,0.29095000D+01,0.19545000D+01
     .,0.58965940D+03,0.193D+03,0.142D+03,0.29095000D+01,0.19420000D+01
     .,0.66095050D+03,0.193D+03,0.143D+03,0.29095000D+01,0.16682000D+01
     .,0.51451210D+03,0.193D+03,0.144D+03,0.29095000D+01,0.18584000D+01
     .,0.48157200D+03,0.193D+03,0.145D+03,0.29095000D+01,0.19003000D+01
     .,0.44743080D+03,0.193D+03,0.146D+03,0.29095000D+01,0.18630000D+01
     .,0.43285140D+03,0.193D+03,0.147D+03,0.29095000D+01,0.96790000D+00
     .,0.42822300D+03,0.193D+03,0.148D+03,0.29095000D+01,0.19539000D+01
     .,0.67704980D+03,0.193D+03,0.149D+03,0.29095000D+01,0.96330000D+00
     .,0.61292050D+03,0.193D+03,0.150D+03,0.29095000D+01,0.95140000D+00
     .,0.57443630D+03,0.193D+03,0.151D+03,0.29095000D+01,0.97490000D+00
     .,0.54380490D+03,0.193D+03,0.152D+03,0.29095000D+01,0.98110000D+00
     .,0.49721050D+03,0.193D+03,0.153D+03,0.29095000D+01,0.99680000D+00
     .,0.66750050D+03,0.193D+03,0.155D+03,0.29095000D+01,0.99090000D+00
     .,0.14228735D+04,0.193D+03,0.156D+03,0.29095000D+01,0.97970000D+00
     .,0.10625153D+04,0.193D+03,0.157D+03,0.29095000D+01,0.19373000D+01
     .,0.67166460D+03,0.193D+03,0.159D+03,0.29095000D+01,0.29425000D+01
     .,0.65779210D+03,0.193D+03,0.160D+03,0.29095000D+01,0.29455000D+01
     .,0.63700760D+03,0.193D+03,0.161D+03,0.29095000D+01,0.29413000D+01
     .,0.64004320D+03,0.193D+03,0.162D+03,0.29095000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters(  81301:  81400)=(/
     . 0.61687680D+03,0.193D+03,0.163D+03,0.29095000D+01,0.18286000D+01
     .,0.64393890D+03,0.193D+03,0.164D+03,0.29095000D+01,0.28732000D+01
     .,0.60497690D+03,0.193D+03,0.165D+03,0.29095000D+01,0.29086000D+01
     .,0.61545730D+03,0.193D+03,0.166D+03,0.29095000D+01,0.28965000D+01
     .,0.57428150D+03,0.193D+03,0.167D+03,0.29095000D+01,0.29242000D+01
     .,0.55794580D+03,0.193D+03,0.168D+03,0.29095000D+01,0.29282000D+01
     .,0.55432010D+03,0.193D+03,0.169D+03,0.29095000D+01,0.29246000D+01
     .,0.58234520D+03,0.193D+03,0.170D+03,0.29095000D+01,0.28482000D+01
     .,0.53579050D+03,0.193D+03,0.171D+03,0.29095000D+01,0.29219000D+01
     .,0.72482070D+03,0.193D+03,0.172D+03,0.29095000D+01,0.19254000D+01
     .,0.67316650D+03,0.193D+03,0.173D+03,0.29095000D+01,0.19459000D+01
     .,0.61471110D+03,0.193D+03,0.174D+03,0.29095000D+01,0.19292000D+01
     .,0.62176580D+03,0.193D+03,0.175D+03,0.29095000D+01,0.18104000D+01
     .,0.54516120D+03,0.193D+03,0.176D+03,0.29095000D+01,0.18858000D+01
     .,0.51320580D+03,0.193D+03,0.177D+03,0.29095000D+01,0.18648000D+01
     .,0.49042130D+03,0.193D+03,0.178D+03,0.29095000D+01,0.19188000D+01
     .,0.46907220D+03,0.193D+03,0.179D+03,0.29095000D+01,0.98460000D+00
     .,0.45340690D+03,0.193D+03,0.180D+03,0.29095000D+01,0.19896000D+01
     .,0.72771340D+03,0.193D+03,0.181D+03,0.29095000D+01,0.92670000D+00
     .,0.66365960D+03,0.193D+03,0.182D+03,0.29095000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters(  81401:  81500)=(/
     . 0.64384950D+03,0.193D+03,0.183D+03,0.29095000D+01,0.98200000D+00
     .,0.62649490D+03,0.193D+03,0.184D+03,0.29095000D+01,0.98150000D+00
     .,0.58554410D+03,0.193D+03,0.185D+03,0.29095000D+01,0.99540000D+00
     .,0.75173280D+03,0.193D+03,0.187D+03,0.29095000D+01,0.97050000D+00
     .,0.14153925D+04,0.193D+03,0.188D+03,0.29095000D+01,0.96620000D+00
     .,0.79462310D+03,0.193D+03,0.189D+03,0.29095000D+01,0.29070000D+01
     .,0.91695930D+03,0.193D+03,0.190D+03,0.29095000D+01,0.28844000D+01
     .,0.82052080D+03,0.193D+03,0.191D+03,0.29095000D+01,0.28738000D+01
     .,0.72537300D+03,0.193D+03,0.192D+03,0.29095000D+01,0.28878000D+01
     .,0.69816440D+03,0.193D+03,0.193D+03,0.29095000D+01,0.29095000D+01
     .,0.52391900D+02,0.194D+03,0.100D+01,0.19209000D+01,0.91180000D+00
     .,0.33861500D+02,0.194D+03,0.200D+01,0.19209000D+01,0.00000000D+00
     .,0.97720270D+03,0.194D+03,0.300D+01,0.19209000D+01,0.00000000D+00
     .,0.51120280D+03,0.194D+03,0.400D+01,0.19209000D+01,0.00000000D+00
     .,0.33002550D+03,0.194D+03,0.500D+01,0.19209000D+01,0.00000000D+00
     .,0.21709250D+03,0.194D+03,0.600D+01,0.19209000D+01,0.00000000D+00
     .,0.14929170D+03,0.194D+03,0.700D+01,0.19209000D+01,0.00000000D+00
     .,0.11190540D+03,0.194D+03,0.800D+01,0.19209000D+01,0.00000000D+00
     .,0.84162800D+02,0.194D+03,0.900D+01,0.19209000D+01,0.00000000D+00
     .,0.64433300D+02,0.194D+03,0.100D+02,0.19209000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  81501:  81600)=(/
     . 0.11617208D+04,0.194D+03,0.110D+02,0.19209000D+01,0.00000000D+00
     .,0.82748750D+03,0.194D+03,0.120D+02,0.19209000D+01,0.00000000D+00
     .,0.74501090D+03,0.194D+03,0.130D+02,0.19209000D+01,0.00000000D+00
     .,0.56932030D+03,0.194D+03,0.140D+02,0.19209000D+01,0.00000000D+00
     .,0.43398740D+03,0.194D+03,0.150D+02,0.19209000D+01,0.00000000D+00
     .,0.35559410D+03,0.194D+03,0.160D+02,0.19209000D+01,0.00000000D+00
     .,0.28720610D+03,0.194D+03,0.170D+02,0.19209000D+01,0.00000000D+00
     .,0.23291960D+03,0.194D+03,0.180D+02,0.19209000D+01,0.00000000D+00
     .,0.19509820D+04,0.194D+03,0.190D+02,0.19209000D+01,0.00000000D+00
     .,0.15010394D+04,0.194D+03,0.200D+02,0.19209000D+01,0.00000000D+00
     .,0.12234261D+04,0.194D+03,0.210D+02,0.19209000D+01,0.00000000D+00
     .,0.11694190D+04,0.194D+03,0.220D+02,0.19209000D+01,0.00000000D+00
     .,0.10640685D+04,0.194D+03,0.230D+02,0.19209000D+01,0.00000000D+00
     .,0.83949690D+03,0.194D+03,0.240D+02,0.19209000D+01,0.00000000D+00
     .,0.90788740D+03,0.194D+03,0.250D+02,0.19209000D+01,0.00000000D+00
     .,0.71275770D+03,0.194D+03,0.260D+02,0.19209000D+01,0.00000000D+00
     .,0.74344550D+03,0.194D+03,0.270D+02,0.19209000D+01,0.00000000D+00
     .,0.77054070D+03,0.194D+03,0.280D+02,0.19209000D+01,0.00000000D+00
     .,0.59237050D+03,0.194D+03,0.290D+02,0.19209000D+01,0.00000000D+00
     .,0.59475930D+03,0.194D+03,0.300D+02,0.19209000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  81601:  81700)=(/
     . 0.70853630D+03,0.194D+03,0.310D+02,0.19209000D+01,0.00000000D+00
     .,0.60979120D+03,0.194D+03,0.320D+02,0.19209000D+01,0.00000000D+00
     .,0.51011170D+03,0.194D+03,0.330D+02,0.19209000D+01,0.00000000D+00
     .,0.45283130D+03,0.194D+03,0.340D+02,0.19209000D+01,0.00000000D+00
     .,0.39222240D+03,0.194D+03,0.350D+02,0.19209000D+01,0.00000000D+00
     .,0.33815470D+03,0.194D+03,0.360D+02,0.19209000D+01,0.00000000D+00
     .,0.21787996D+04,0.194D+03,0.370D+02,0.19209000D+01,0.00000000D+00
     .,0.17950359D+04,0.194D+03,0.380D+02,0.19209000D+01,0.00000000D+00
     .,0.15372794D+04,0.194D+03,0.390D+02,0.19209000D+01,0.00000000D+00
     .,0.13634850D+04,0.194D+03,0.400D+02,0.19209000D+01,0.00000000D+00
     .,0.12334617D+04,0.194D+03,0.410D+02,0.19209000D+01,0.00000000D+00
     .,0.94031770D+03,0.194D+03,0.420D+02,0.19209000D+01,0.00000000D+00
     .,0.10541841D+04,0.194D+03,0.430D+02,0.19209000D+01,0.00000000D+00
     .,0.79200470D+03,0.194D+03,0.440D+02,0.19209000D+01,0.00000000D+00
     .,0.86390680D+03,0.194D+03,0.450D+02,0.19209000D+01,0.00000000D+00
     .,0.79715370D+03,0.194D+03,0.460D+02,0.19209000D+01,0.00000000D+00
     .,0.66898050D+03,0.194D+03,0.470D+02,0.19209000D+01,0.00000000D+00
     .,0.69811240D+03,0.194D+03,0.480D+02,0.19209000D+01,0.00000000D+00
     .,0.89002560D+03,0.194D+03,0.490D+02,0.19209000D+01,0.00000000D+00
     .,0.80567160D+03,0.194D+03,0.500D+02,0.19209000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  81701:  81800)=(/
     . 0.70498790D+03,0.194D+03,0.510D+02,0.19209000D+01,0.00000000D+00
     .,0.64753750D+03,0.194D+03,0.520D+02,0.19209000D+01,0.00000000D+00
     .,0.57956520D+03,0.194D+03,0.530D+02,0.19209000D+01,0.00000000D+00
     .,0.51640770D+03,0.194D+03,0.540D+02,0.19209000D+01,0.00000000D+00
     .,0.26607475D+04,0.194D+03,0.550D+02,0.19209000D+01,0.00000000D+00
     .,0.23107445D+04,0.194D+03,0.560D+02,0.19209000D+01,0.00000000D+00
     .,0.19831026D+04,0.194D+03,0.570D+02,0.19209000D+01,0.00000000D+00
     .,0.83646730D+03,0.194D+03,0.580D+02,0.19209000D+01,0.27991000D+01
     .,0.20333939D+04,0.194D+03,0.590D+02,0.19209000D+01,0.00000000D+00
     .,0.19427158D+04,0.194D+03,0.600D+02,0.19209000D+01,0.00000000D+00
     .,0.18916327D+04,0.194D+03,0.610D+02,0.19209000D+01,0.00000000D+00
     .,0.18448932D+04,0.194D+03,0.620D+02,0.19209000D+01,0.00000000D+00
     .,0.18033780D+04,0.194D+03,0.630D+02,0.19209000D+01,0.00000000D+00
     .,0.13864919D+04,0.194D+03,0.640D+02,0.19209000D+01,0.00000000D+00
     .,0.16271471D+04,0.194D+03,0.650D+02,0.19209000D+01,0.00000000D+00
     .,0.15648029D+04,0.194D+03,0.660D+02,0.19209000D+01,0.00000000D+00
     .,0.16162873D+04,0.194D+03,0.670D+02,0.19209000D+01,0.00000000D+00
     .,0.15807484D+04,0.194D+03,0.680D+02,0.19209000D+01,0.00000000D+00
     .,0.15482741D+04,0.194D+03,0.690D+02,0.19209000D+01,0.00000000D+00
     .,0.15315185D+04,0.194D+03,0.700D+02,0.19209000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  81801:  81900)=(/
     . 0.12721137D+04,0.194D+03,0.710D+02,0.19209000D+01,0.00000000D+00
     .,0.12215252D+04,0.194D+03,0.720D+02,0.19209000D+01,0.00000000D+00
     .,0.11011039D+04,0.194D+03,0.730D+02,0.19209000D+01,0.00000000D+00
     .,0.92310550D+03,0.194D+03,0.740D+02,0.19209000D+01,0.00000000D+00
     .,0.93407850D+03,0.194D+03,0.750D+02,0.19209000D+01,0.00000000D+00
     .,0.83812920D+03,0.194D+03,0.760D+02,0.19209000D+01,0.00000000D+00
     .,0.76168140D+03,0.194D+03,0.770D+02,0.19209000D+01,0.00000000D+00
     .,0.62877650D+03,0.194D+03,0.780D+02,0.19209000D+01,0.00000000D+00
     .,0.58595420D+03,0.194D+03,0.790D+02,0.19209000D+01,0.00000000D+00
     .,0.59987110D+03,0.194D+03,0.800D+02,0.19209000D+01,0.00000000D+00
     .,0.91189380D+03,0.194D+03,0.810D+02,0.19209000D+01,0.00000000D+00
     .,0.87576580D+03,0.194D+03,0.820D+02,0.19209000D+01,0.00000000D+00
     .,0.79106510D+03,0.194D+03,0.830D+02,0.19209000D+01,0.00000000D+00
     .,0.74764610D+03,0.194D+03,0.840D+02,0.19209000D+01,0.00000000D+00
     .,0.68300400D+03,0.194D+03,0.850D+02,0.19209000D+01,0.00000000D+00
     .,0.62065460D+03,0.194D+03,0.860D+02,0.19209000D+01,0.00000000D+00
     .,0.24608767D+04,0.194D+03,0.870D+02,0.19209000D+01,0.00000000D+00
     .,0.22584201D+04,0.194D+03,0.880D+02,0.19209000D+01,0.00000000D+00
     .,0.19536369D+04,0.194D+03,0.890D+02,0.19209000D+01,0.00000000D+00
     .,0.17167267D+04,0.194D+03,0.900D+02,0.19209000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  81901:  82000)=(/
     . 0.17259338D+04,0.194D+03,0.910D+02,0.19209000D+01,0.00000000D+00
     .,0.16700620D+04,0.194D+03,0.920D+02,0.19209000D+01,0.00000000D+00
     .,0.17432351D+04,0.194D+03,0.930D+02,0.19209000D+01,0.00000000D+00
     .,0.16834151D+04,0.194D+03,0.940D+02,0.19209000D+01,0.00000000D+00
     .,0.86005200D+02,0.194D+03,0.101D+03,0.19209000D+01,0.00000000D+00
     .,0.29568750D+03,0.194D+03,0.103D+03,0.19209000D+01,0.98650000D+00
     .,0.37496860D+03,0.194D+03,0.104D+03,0.19209000D+01,0.98080000D+00
     .,0.27566970D+03,0.194D+03,0.105D+03,0.19209000D+01,0.97060000D+00
     .,0.20403100D+03,0.194D+03,0.106D+03,0.19209000D+01,0.98680000D+00
     .,0.13932300D+03,0.194D+03,0.107D+03,0.19209000D+01,0.99440000D+00
     .,0.10015200D+03,0.194D+03,0.108D+03,0.19209000D+01,0.99250000D+00
     .,0.67951400D+02,0.194D+03,0.109D+03,0.19209000D+01,0.99820000D+00
     .,0.43651000D+03,0.194D+03,0.111D+03,0.19209000D+01,0.96840000D+00
     .,0.67820670D+03,0.194D+03,0.112D+03,0.19209000D+01,0.96280000D+00
     .,0.67169720D+03,0.194D+03,0.113D+03,0.19209000D+01,0.96480000D+00
     .,0.52429270D+03,0.194D+03,0.114D+03,0.19209000D+01,0.95070000D+00
     .,0.42107980D+03,0.194D+03,0.115D+03,0.19209000D+01,0.99470000D+00
     .,0.35186230D+03,0.194D+03,0.116D+03,0.19209000D+01,0.99480000D+00
     .,0.28433720D+03,0.194D+03,0.117D+03,0.19209000D+01,0.99720000D+00
     .,0.59504560D+03,0.194D+03,0.119D+03,0.19209000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters(  82001:  82100)=(/
     . 0.12074896D+04,0.194D+03,0.120D+03,0.19209000D+01,0.98310000D+00
     .,0.57829290D+03,0.194D+03,0.121D+03,0.19209000D+01,0.18627000D+01
     .,0.55886520D+03,0.194D+03,0.122D+03,0.19209000D+01,0.18299000D+01
     .,0.54792340D+03,0.194D+03,0.123D+03,0.19209000D+01,0.19138000D+01
     .,0.54465600D+03,0.194D+03,0.124D+03,0.19209000D+01,0.18269000D+01
     .,0.49339110D+03,0.194D+03,0.125D+03,0.19209000D+01,0.16406000D+01
     .,0.45504230D+03,0.194D+03,0.126D+03,0.19209000D+01,0.16483000D+01
     .,0.43439050D+03,0.194D+03,0.127D+03,0.19209000D+01,0.17149000D+01
     .,0.42520030D+03,0.194D+03,0.128D+03,0.19209000D+01,0.17937000D+01
     .,0.42483420D+03,0.194D+03,0.129D+03,0.19209000D+01,0.95760000D+00
     .,0.39059480D+03,0.194D+03,0.130D+03,0.19209000D+01,0.19419000D+01
     .,0.66138520D+03,0.194D+03,0.131D+03,0.19209000D+01,0.96010000D+00
     .,0.56767290D+03,0.194D+03,0.132D+03,0.19209000D+01,0.94340000D+00
     .,0.50098750D+03,0.194D+03,0.133D+03,0.19209000D+01,0.98890000D+00
     .,0.45312420D+03,0.194D+03,0.134D+03,0.19209000D+01,0.99010000D+00
     .,0.39518880D+03,0.194D+03,0.135D+03,0.19209000D+01,0.99740000D+00
     .,0.70695870D+03,0.194D+03,0.137D+03,0.19209000D+01,0.97380000D+00
     .,0.14771099D+04,0.194D+03,0.138D+03,0.19209000D+01,0.98010000D+00
     .,0.10809253D+04,0.194D+03,0.139D+03,0.19209000D+01,0.19153000D+01
     .,0.76828830D+03,0.194D+03,0.140D+03,0.19209000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters(  82101:  82200)=(/
     . 0.77551800D+03,0.194D+03,0.141D+03,0.19209000D+01,0.19545000D+01
     .,0.72086910D+03,0.194D+03,0.142D+03,0.19209000D+01,0.19420000D+01
     .,0.82604480D+03,0.194D+03,0.143D+03,0.19209000D+01,0.16682000D+01
     .,0.61978620D+03,0.194D+03,0.144D+03,0.19209000D+01,0.18584000D+01
     .,0.57963490D+03,0.194D+03,0.145D+03,0.19209000D+01,0.19003000D+01
     .,0.53729800D+03,0.194D+03,0.146D+03,0.19209000D+01,0.18630000D+01
     .,0.52079250D+03,0.194D+03,0.147D+03,0.19209000D+01,0.96790000D+00
     .,0.50925590D+03,0.194D+03,0.148D+03,0.19209000D+01,0.19539000D+01
     .,0.84221840D+03,0.194D+03,0.149D+03,0.19209000D+01,0.96330000D+00
     .,0.74608910D+03,0.194D+03,0.150D+03,0.19209000D+01,0.95140000D+00
     .,0.68936250D+03,0.194D+03,0.151D+03,0.19209000D+01,0.97490000D+00
     .,0.64664990D+03,0.194D+03,0.152D+03,0.19209000D+01,0.98110000D+00
     .,0.58507090D+03,0.194D+03,0.153D+03,0.19209000D+01,0.99680000D+00
     .,0.82245460D+03,0.194D+03,0.155D+03,0.19209000D+01,0.99090000D+00
     .,0.19411744D+04,0.194D+03,0.156D+03,0.19209000D+01,0.97970000D+00
     .,0.13757929D+04,0.194D+03,0.157D+03,0.19209000D+01,0.19373000D+01
     .,0.81046870D+03,0.194D+03,0.159D+03,0.19209000D+01,0.29425000D+01
     .,0.79353070D+03,0.194D+03,0.160D+03,0.19209000D+01,0.29455000D+01
     .,0.76776280D+03,0.194D+03,0.161D+03,0.19209000D+01,0.29413000D+01
     .,0.77400610D+03,0.194D+03,0.162D+03,0.19209000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters(  82201:  82300)=(/
     . 0.75318700D+03,0.194D+03,0.163D+03,0.19209000D+01,0.18286000D+01
     .,0.77907900D+03,0.194D+03,0.164D+03,0.19209000D+01,0.28732000D+01
     .,0.73004770D+03,0.194D+03,0.165D+03,0.19209000D+01,0.29086000D+01
     .,0.74727740D+03,0.194D+03,0.166D+03,0.19209000D+01,0.28965000D+01
     .,0.69119800D+03,0.194D+03,0.167D+03,0.19209000D+01,0.29242000D+01
     .,0.67089470D+03,0.194D+03,0.168D+03,0.19209000D+01,0.29282000D+01
     .,0.66702610D+03,0.194D+03,0.169D+03,0.19209000D+01,0.29246000D+01
     .,0.70343090D+03,0.194D+03,0.170D+03,0.19209000D+01,0.28482000D+01
     .,0.64373580D+03,0.194D+03,0.171D+03,0.19209000D+01,0.29219000D+01
     .,0.90452750D+03,0.194D+03,0.172D+03,0.19209000D+01,0.19254000D+01
     .,0.82941860D+03,0.194D+03,0.173D+03,0.19209000D+01,0.19459000D+01
     .,0.74766610D+03,0.194D+03,0.174D+03,0.19209000D+01,0.19292000D+01
     .,0.76481820D+03,0.194D+03,0.175D+03,0.19209000D+01,0.18104000D+01
     .,0.65146000D+03,0.194D+03,0.176D+03,0.19209000D+01,0.18858000D+01
     .,0.61088630D+03,0.194D+03,0.177D+03,0.19209000D+01,0.18648000D+01
     .,0.58248590D+03,0.194D+03,0.178D+03,0.19209000D+01,0.19188000D+01
     .,0.55757750D+03,0.194D+03,0.179D+03,0.19209000D+01,0.98460000D+00
     .,0.53344460D+03,0.194D+03,0.180D+03,0.19209000D+01,0.19896000D+01
     .,0.90297300D+03,0.194D+03,0.181D+03,0.19209000D+01,0.92670000D+00
     .,0.80572640D+03,0.194D+03,0.182D+03,0.19209000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters(  82301:  82400)=(/
     . 0.77305280D+03,0.194D+03,0.183D+03,0.19209000D+01,0.98200000D+00
     .,0.74671410D+03,0.194D+03,0.184D+03,0.19209000D+01,0.98150000D+00
     .,0.69111280D+03,0.194D+03,0.185D+03,0.19209000D+01,0.99540000D+00
     .,0.92497250D+03,0.194D+03,0.187D+03,0.19209000D+01,0.97050000D+00
     .,0.18985076D+04,0.194D+03,0.188D+03,0.19209000D+01,0.96620000D+00
     .,0.95915900D+03,0.194D+03,0.189D+03,0.19209000D+01,0.29070000D+01
     .,0.11307742D+04,0.194D+03,0.190D+03,0.19209000D+01,0.28844000D+01
     .,0.10088729D+04,0.194D+03,0.191D+03,0.19209000D+01,0.28738000D+01
     .,0.87461490D+03,0.194D+03,0.192D+03,0.19209000D+01,0.28878000D+01
     .,0.83895690D+03,0.194D+03,0.193D+03,0.19209000D+01,0.29095000D+01
     .,0.10512468D+04,0.194D+03,0.194D+03,0.19209000D+01,0.19209000D+01
     .,0.12593100D+02,0.204D+03,0.100D+01,0.19697000D+01,0.91180000D+00
     .,0.81628000D+01,0.204D+03,0.200D+01,0.19697000D+01,0.00000000D+00
     .,0.19470360D+03,0.204D+03,0.300D+01,0.19697000D+01,0.00000000D+00
     .,0.11396770D+03,0.204D+03,0.400D+01,0.19697000D+01,0.00000000D+00
     .,0.76723000D+02,0.204D+03,0.500D+01,0.19697000D+01,0.00000000D+00
     .,0.51562800D+02,0.204D+03,0.600D+01,0.19697000D+01,0.00000000D+00
     .,0.35790200D+02,0.204D+03,0.700D+01,0.19697000D+01,0.00000000D+00
     .,0.26895400D+02,0.204D+03,0.800D+01,0.19697000D+01,0.00000000D+00
     .,0.20208300D+02,0.204D+03,0.900D+01,0.19697000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  82401:  82500)=(/
     . 0.15417600D+02,0.204D+03,0.100D+02,0.19697000D+01,0.00000000D+00
     .,0.23280600D+03,0.204D+03,0.110D+02,0.19697000D+01,0.00000000D+00
     .,0.18116530D+03,0.204D+03,0.120D+02,0.19697000D+01,0.00000000D+00
     .,0.16729290D+03,0.204D+03,0.130D+02,0.19697000D+01,0.00000000D+00
     .,0.13189200D+03,0.204D+03,0.140D+02,0.19697000D+01,0.00000000D+00
     .,0.10261760D+03,0.204D+03,0.150D+02,0.19697000D+01,0.00000000D+00
     .,0.84869100D+02,0.204D+03,0.160D+02,0.19697000D+01,0.00000000D+00
     .,0.69006900D+02,0.204D+03,0.170D+02,0.19697000D+01,0.00000000D+00
     .,0.56151700D+02,0.204D+03,0.180D+02,0.19697000D+01,0.00000000D+00
     .,0.37942250D+03,0.204D+03,0.190D+02,0.19697000D+01,0.00000000D+00
     .,0.31651020D+03,0.204D+03,0.200D+02,0.19697000D+01,0.00000000D+00
     .,0.26194430D+03,0.204D+03,0.210D+02,0.19697000D+01,0.00000000D+00
     .,0.25305430D+03,0.204D+03,0.220D+02,0.19697000D+01,0.00000000D+00
     .,0.23180650D+03,0.204D+03,0.230D+02,0.19697000D+01,0.00000000D+00
     .,0.18215580D+03,0.204D+03,0.240D+02,0.19697000D+01,0.00000000D+00
     .,0.19964260D+03,0.204D+03,0.250D+02,0.19697000D+01,0.00000000D+00
     .,0.15628450D+03,0.204D+03,0.260D+02,0.19697000D+01,0.00000000D+00
     .,0.16621660D+03,0.204D+03,0.270D+02,0.19697000D+01,0.00000000D+00
     .,0.17120430D+03,0.204D+03,0.280D+02,0.19697000D+01,0.00000000D+00
     .,0.13080120D+03,0.204D+03,0.290D+02,0.19697000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  82501:  82600)=(/
     . 0.13479330D+03,0.204D+03,0.300D+02,0.19697000D+01,0.00000000D+00
     .,0.15992730D+03,0.204D+03,0.310D+02,0.19697000D+01,0.00000000D+00
     .,0.14114890D+03,0.204D+03,0.320D+02,0.19697000D+01,0.00000000D+00
     .,0.12022240D+03,0.204D+03,0.330D+02,0.19697000D+01,0.00000000D+00
     .,0.10763710D+03,0.204D+03,0.340D+02,0.19697000D+01,0.00000000D+00
     .,0.93891100D+02,0.204D+03,0.350D+02,0.19697000D+01,0.00000000D+00
     .,0.81330600D+02,0.204D+03,0.360D+02,0.19697000D+01,0.00000000D+00
     .,0.42517040D+03,0.204D+03,0.370D+02,0.19697000D+01,0.00000000D+00
     .,0.37664680D+03,0.204D+03,0.380D+02,0.19697000D+01,0.00000000D+00
     .,0.33071900D+03,0.204D+03,0.390D+02,0.19697000D+01,0.00000000D+00
     .,0.29747500D+03,0.204D+03,0.400D+02,0.19697000D+01,0.00000000D+00
     .,0.27126060D+03,0.204D+03,0.410D+02,0.19697000D+01,0.00000000D+00
     .,0.20909590D+03,0.204D+03,0.420D+02,0.19697000D+01,0.00000000D+00
     .,0.23346060D+03,0.204D+03,0.430D+02,0.19697000D+01,0.00000000D+00
     .,0.17751740D+03,0.204D+03,0.440D+02,0.19697000D+01,0.00000000D+00
     .,0.19439840D+03,0.204D+03,0.450D+02,0.19697000D+01,0.00000000D+00
     .,0.18021780D+03,0.204D+03,0.460D+02,0.19697000D+01,0.00000000D+00
     .,0.14971980D+03,0.204D+03,0.470D+02,0.19697000D+01,0.00000000D+00
     .,0.15869370D+03,0.204D+03,0.480D+02,0.19697000D+01,0.00000000D+00
     .,0.19941110D+03,0.204D+03,0.490D+02,0.19697000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  82601:  82700)=(/
     . 0.18468490D+03,0.204D+03,0.500D+02,0.19697000D+01,0.00000000D+00
     .,0.16453480D+03,0.204D+03,0.510D+02,0.19697000D+01,0.00000000D+00
     .,0.15249560D+03,0.204D+03,0.520D+02,0.19697000D+01,0.00000000D+00
     .,0.13761920D+03,0.204D+03,0.530D+02,0.19697000D+01,0.00000000D+00
     .,0.12340700D+03,0.204D+03,0.540D+02,0.19697000D+01,0.00000000D+00
     .,0.51787260D+03,0.204D+03,0.550D+02,0.19697000D+01,0.00000000D+00
     .,0.47936610D+03,0.204D+03,0.560D+02,0.19697000D+01,0.00000000D+00
     .,0.42227540D+03,0.204D+03,0.570D+02,0.19697000D+01,0.00000000D+00
     .,0.19417280D+03,0.204D+03,0.580D+02,0.19697000D+01,0.27991000D+01
     .,0.42478830D+03,0.204D+03,0.590D+02,0.19697000D+01,0.00000000D+00
     .,0.40812030D+03,0.204D+03,0.600D+02,0.19697000D+01,0.00000000D+00
     .,0.39794790D+03,0.204D+03,0.610D+02,0.19697000D+01,0.00000000D+00
     .,0.38859250D+03,0.204D+03,0.620D+02,0.19697000D+01,0.00000000D+00
     .,0.38030110D+03,0.204D+03,0.630D+02,0.19697000D+01,0.00000000D+00
     .,0.29932330D+03,0.204D+03,0.640D+02,0.19697000D+01,0.00000000D+00
     .,0.33536650D+03,0.204D+03,0.650D+02,0.19697000D+01,0.00000000D+00
     .,0.32359410D+03,0.204D+03,0.660D+02,0.19697000D+01,0.00000000D+00
     .,0.34328500D+03,0.204D+03,0.670D+02,0.19697000D+01,0.00000000D+00
     .,0.33605070D+03,0.204D+03,0.680D+02,0.19697000D+01,0.00000000D+00
     .,0.32953550D+03,0.204D+03,0.690D+02,0.19697000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  82701:  82800)=(/
     . 0.32568440D+03,0.204D+03,0.700D+02,0.19697000D+01,0.00000000D+00
     .,0.27459690D+03,0.204D+03,0.710D+02,0.19697000D+01,0.00000000D+00
     .,0.27080850D+03,0.204D+03,0.720D+02,0.19697000D+01,0.00000000D+00
     .,0.24715510D+03,0.204D+03,0.730D+02,0.19697000D+01,0.00000000D+00
     .,0.20829050D+03,0.204D+03,0.740D+02,0.19697000D+01,0.00000000D+00
     .,0.21201830D+03,0.204D+03,0.750D+02,0.19697000D+01,0.00000000D+00
     .,0.19203170D+03,0.204D+03,0.760D+02,0.19697000D+01,0.00000000D+00
     .,0.17571480D+03,0.204D+03,0.770D+02,0.19697000D+01,0.00000000D+00
     .,0.14552190D+03,0.204D+03,0.780D+02,0.19697000D+01,0.00000000D+00
     .,0.13578630D+03,0.204D+03,0.790D+02,0.19697000D+01,0.00000000D+00
     .,0.13983510D+03,0.204D+03,0.800D+02,0.19697000D+01,0.00000000D+00
     .,0.20418140D+03,0.204D+03,0.810D+02,0.19697000D+01,0.00000000D+00
     .,0.20002350D+03,0.204D+03,0.820D+02,0.19697000D+01,0.00000000D+00
     .,0.18383790D+03,0.204D+03,0.830D+02,0.19697000D+01,0.00000000D+00
     .,0.17525160D+03,0.204D+03,0.840D+02,0.19697000D+01,0.00000000D+00
     .,0.16152400D+03,0.204D+03,0.850D+02,0.19697000D+01,0.00000000D+00
     .,0.14775410D+03,0.204D+03,0.860D+02,0.19697000D+01,0.00000000D+00
     .,0.49003150D+03,0.204D+03,0.870D+02,0.19697000D+01,0.00000000D+00
     .,0.47451000D+03,0.204D+03,0.880D+02,0.19697000D+01,0.00000000D+00
     .,0.42036790D+03,0.204D+03,0.890D+02,0.19697000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  82801:  82900)=(/
     . 0.37811690D+03,0.204D+03,0.900D+02,0.19697000D+01,0.00000000D+00
     .,0.37472790D+03,0.204D+03,0.910D+02,0.19697000D+01,0.00000000D+00
     .,0.36278690D+03,0.204D+03,0.920D+02,0.19697000D+01,0.00000000D+00
     .,0.37304730D+03,0.204D+03,0.930D+02,0.19697000D+01,0.00000000D+00
     .,0.36135530D+03,0.204D+03,0.940D+02,0.19697000D+01,0.00000000D+00
     .,0.20403900D+02,0.204D+03,0.101D+03,0.19697000D+01,0.00000000D+00
     .,0.66200900D+02,0.204D+03,0.103D+03,0.19697000D+01,0.98650000D+00
     .,0.84400000D+02,0.204D+03,0.104D+03,0.19697000D+01,0.98080000D+00
     .,0.64430100D+02,0.204D+03,0.105D+03,0.19697000D+01,0.97060000D+00
     .,0.48307200D+02,0.204D+03,0.106D+03,0.19697000D+01,0.98680000D+00
     .,0.33327400D+02,0.204D+03,0.107D+03,0.19697000D+01,0.99440000D+00
     .,0.24059200D+02,0.204D+03,0.108D+03,0.19697000D+01,0.99250000D+00
     .,0.16318500D+02,0.204D+03,0.109D+03,0.19697000D+01,0.99820000D+00
     .,0.96512500D+02,0.204D+03,0.111D+03,0.19697000D+01,0.96840000D+00
     .,0.14938320D+03,0.204D+03,0.112D+03,0.19697000D+01,0.96280000D+00
     .,0.15159310D+03,0.204D+03,0.113D+03,0.19697000D+01,0.96480000D+00
     .,0.12183330D+03,0.204D+03,0.114D+03,0.19697000D+01,0.95070000D+00
     .,0.99565600D+02,0.204D+03,0.115D+03,0.19697000D+01,0.99470000D+00
     .,0.83918100D+02,0.204D+03,0.116D+03,0.19697000D+01,0.99480000D+00
     .,0.68280600D+02,0.204D+03,0.117D+03,0.19697000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters(  82901:  83000)=(/
     . 0.13247510D+03,0.204D+03,0.119D+03,0.19697000D+01,0.97670000D+00
     .,0.25257780D+03,0.204D+03,0.120D+03,0.19697000D+01,0.98310000D+00
     .,0.13298680D+03,0.204D+03,0.121D+03,0.19697000D+01,0.18627000D+01
     .,0.12828620D+03,0.204D+03,0.122D+03,0.19697000D+01,0.18299000D+01
     .,0.12567780D+03,0.204D+03,0.123D+03,0.19697000D+01,0.19138000D+01
     .,0.12446450D+03,0.204D+03,0.124D+03,0.19697000D+01,0.18269000D+01
     .,0.11464650D+03,0.204D+03,0.125D+03,0.19697000D+01,0.16406000D+01
     .,0.10602860D+03,0.204D+03,0.126D+03,0.19697000D+01,0.16483000D+01
     .,0.10108010D+03,0.204D+03,0.127D+03,0.19697000D+01,0.17149000D+01
     .,0.98800400D+02,0.204D+03,0.128D+03,0.19697000D+01,0.17937000D+01
     .,0.97534000D+02,0.204D+03,0.129D+03,0.19697000D+01,0.95760000D+00
     .,0.91622700D+02,0.204D+03,0.130D+03,0.19697000D+01,0.19419000D+01
     .,0.15021480D+03,0.204D+03,0.131D+03,0.19697000D+01,0.96010000D+00
     .,0.13199340D+03,0.204D+03,0.132D+03,0.19697000D+01,0.94340000D+00
     .,0.11815200D+03,0.204D+03,0.133D+03,0.19697000D+01,0.98890000D+00
     .,0.10767130D+03,0.204D+03,0.134D+03,0.19697000D+01,0.99010000D+00
     .,0.94551500D+02,0.204D+03,0.135D+03,0.19697000D+01,0.99740000D+00
     .,0.15794790D+03,0.204D+03,0.137D+03,0.19697000D+01,0.97380000D+00
     .,0.30694330D+03,0.204D+03,0.138D+03,0.19697000D+01,0.98010000D+00
     .,0.23552320D+03,0.204D+03,0.139D+03,0.19697000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters(  83001:  83100)=(/
     . 0.17565640D+03,0.204D+03,0.140D+03,0.19697000D+01,0.19355000D+01
     .,0.17733570D+03,0.204D+03,0.141D+03,0.19697000D+01,0.19545000D+01
     .,0.16520660D+03,0.204D+03,0.142D+03,0.19697000D+01,0.19420000D+01
     .,0.18502440D+03,0.204D+03,0.143D+03,0.19697000D+01,0.16682000D+01
     .,0.14388510D+03,0.204D+03,0.144D+03,0.19697000D+01,0.18584000D+01
     .,0.13445760D+03,0.204D+03,0.145D+03,0.19697000D+01,0.19003000D+01
     .,0.12471510D+03,0.204D+03,0.146D+03,0.19697000D+01,0.18630000D+01
     .,0.12059750D+03,0.204D+03,0.147D+03,0.19697000D+01,0.96790000D+00
     .,0.11946230D+03,0.204D+03,0.148D+03,0.19697000D+01,0.19539000D+01
     .,0.19013130D+03,0.204D+03,0.149D+03,0.19697000D+01,0.96330000D+00
     .,0.17217670D+03,0.204D+03,0.150D+03,0.19697000D+01,0.95140000D+00
     .,0.16122340D+03,0.204D+03,0.151D+03,0.19697000D+01,0.97490000D+00
     .,0.15238060D+03,0.204D+03,0.152D+03,0.19697000D+01,0.98110000D+00
     .,0.13892730D+03,0.204D+03,0.153D+03,0.19697000D+01,0.99680000D+00
     .,0.18713180D+03,0.204D+03,0.155D+03,0.19697000D+01,0.99090000D+00
     .,0.39721940D+03,0.204D+03,0.156D+03,0.19697000D+01,0.97970000D+00
     .,0.29790180D+03,0.204D+03,0.157D+03,0.19697000D+01,0.19373000D+01
     .,0.18828490D+03,0.204D+03,0.159D+03,0.19697000D+01,0.29425000D+01
     .,0.18438050D+03,0.204D+03,0.160D+03,0.19697000D+01,0.29455000D+01
     .,0.17850850D+03,0.204D+03,0.161D+03,0.19697000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters(  83101:  83200)=(/
     . 0.17939000D+03,0.204D+03,0.162D+03,0.19697000D+01,0.29300000D+01
     .,0.17278660D+03,0.204D+03,0.163D+03,0.19697000D+01,0.18286000D+01
     .,0.18061150D+03,0.204D+03,0.164D+03,0.19697000D+01,0.28732000D+01
     .,0.16957170D+03,0.204D+03,0.165D+03,0.19697000D+01,0.29086000D+01
     .,0.17251880D+03,0.204D+03,0.166D+03,0.19697000D+01,0.28965000D+01
     .,0.16096160D+03,0.204D+03,0.167D+03,0.19697000D+01,0.29242000D+01
     .,0.15637090D+03,0.204D+03,0.168D+03,0.19697000D+01,0.29282000D+01
     .,0.15538670D+03,0.204D+03,0.169D+03,0.19697000D+01,0.29246000D+01
     .,0.16348550D+03,0.204D+03,0.170D+03,0.19697000D+01,0.28482000D+01
     .,0.15021190D+03,0.204D+03,0.171D+03,0.19697000D+01,0.29219000D+01
     .,0.20349990D+03,0.204D+03,0.172D+03,0.19697000D+01,0.19254000D+01
     .,0.18878180D+03,0.204D+03,0.173D+03,0.19697000D+01,0.19459000D+01
     .,0.17212060D+03,0.204D+03,0.174D+03,0.19697000D+01,0.19292000D+01
     .,0.17412660D+03,0.204D+03,0.175D+03,0.19697000D+01,0.18104000D+01
     .,0.15226480D+03,0.204D+03,0.176D+03,0.19697000D+01,0.18858000D+01
     .,0.14305840D+03,0.204D+03,0.177D+03,0.19697000D+01,0.18648000D+01
     .,0.13650000D+03,0.204D+03,0.178D+03,0.19697000D+01,0.19188000D+01
     .,0.13034490D+03,0.204D+03,0.179D+03,0.19697000D+01,0.98460000D+00
     .,0.12597100D+03,0.204D+03,0.180D+03,0.19697000D+01,0.19896000D+01
     .,0.20371920D+03,0.204D+03,0.181D+03,0.19697000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters(  83201:  83300)=(/
     . 0.18586380D+03,0.204D+03,0.182D+03,0.19697000D+01,0.93830000D+00
     .,0.18030690D+03,0.204D+03,0.183D+03,0.19697000D+01,0.98200000D+00
     .,0.17530470D+03,0.204D+03,0.184D+03,0.19697000D+01,0.98150000D+00
     .,0.16350870D+03,0.204D+03,0.185D+03,0.19697000D+01,0.99540000D+00
     .,0.21081250D+03,0.204D+03,0.187D+03,0.19697000D+01,0.97050000D+00
     .,0.39575600D+03,0.204D+03,0.188D+03,0.19697000D+01,0.96620000D+00
     .,0.22289780D+03,0.204D+03,0.189D+03,0.19697000D+01,0.29070000D+01
     .,0.25694260D+03,0.204D+03,0.190D+03,0.19697000D+01,0.28844000D+01
     .,0.22939980D+03,0.204D+03,0.191D+03,0.19697000D+01,0.28738000D+01
     .,0.20281970D+03,0.204D+03,0.192D+03,0.19697000D+01,0.28878000D+01
     .,0.19512320D+03,0.204D+03,0.193D+03,0.19697000D+01,0.29095000D+01
     .,0.23441020D+03,0.204D+03,0.194D+03,0.19697000D+01,0.19209000D+01
     .,0.55136400D+02,0.204D+03,0.204D+03,0.19697000D+01,0.19697000D+01
     .,0.12495200D+02,0.205D+03,0.100D+01,0.19441000D+01,0.91180000D+00
     .,0.82586000D+01,0.205D+03,0.200D+01,0.19441000D+01,0.00000000D+00
     .,0.18876110D+03,0.205D+03,0.300D+01,0.19441000D+01,0.00000000D+00
     .,0.11041850D+03,0.205D+03,0.400D+01,0.19441000D+01,0.00000000D+00
     .,0.74986500D+02,0.205D+03,0.500D+01,0.19441000D+01,0.00000000D+00
     .,0.50909000D+02,0.205D+03,0.600D+01,0.19441000D+01,0.00000000D+00
     .,0.35677800D+02,0.205D+03,0.700D+01,0.19441000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  83301:  83400)=(/
     . 0.27024700D+02,0.205D+03,0.800D+01,0.19441000D+01,0.00000000D+00
     .,0.20459200D+02,0.205D+03,0.900D+01,0.19441000D+01,0.00000000D+00
     .,0.15712700D+02,0.205D+03,0.100D+02,0.19441000D+01,0.00000000D+00
     .,0.22578430D+03,0.205D+03,0.110D+02,0.19441000D+01,0.00000000D+00
     .,0.17539140D+03,0.205D+03,0.120D+02,0.19441000D+01,0.00000000D+00
     .,0.16244730D+03,0.205D+03,0.130D+02,0.19441000D+01,0.00000000D+00
     .,0.12874590D+03,0.205D+03,0.140D+02,0.19441000D+01,0.00000000D+00
     .,0.10084320D+03,0.205D+03,0.150D+02,0.19441000D+01,0.00000000D+00
     .,0.83884700D+02,0.205D+03,0.160D+02,0.19441000D+01,0.00000000D+00
     .,0.68633100D+02,0.205D+03,0.170D+02,0.19441000D+01,0.00000000D+00
     .,0.56192600D+02,0.205D+03,0.180D+02,0.19441000D+01,0.00000000D+00
     .,0.37015350D+03,0.205D+03,0.190D+02,0.19441000D+01,0.00000000D+00
     .,0.30690780D+03,0.205D+03,0.200D+02,0.19441000D+01,0.00000000D+00
     .,0.25395340D+03,0.205D+03,0.210D+02,0.19441000D+01,0.00000000D+00
     .,0.24566470D+03,0.205D+03,0.220D+02,0.19441000D+01,0.00000000D+00
     .,0.22517830D+03,0.205D+03,0.230D+02,0.19441000D+01,0.00000000D+00
     .,0.17740000D+03,0.205D+03,0.240D+02,0.19441000D+01,0.00000000D+00
     .,0.19413780D+03,0.205D+03,0.250D+02,0.19441000D+01,0.00000000D+00
     .,0.15238870D+03,0.205D+03,0.260D+02,0.19441000D+01,0.00000000D+00
     .,0.16187200D+03,0.205D+03,0.270D+02,0.19441000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  83401:  83500)=(/
     . 0.16656140D+03,0.205D+03,0.280D+02,0.19441000D+01,0.00000000D+00
     .,0.12766860D+03,0.205D+03,0.290D+02,0.19441000D+01,0.00000000D+00
     .,0.13152520D+03,0.205D+03,0.300D+02,0.19441000D+01,0.00000000D+00
     .,0.15580800D+03,0.205D+03,0.310D+02,0.19441000D+01,0.00000000D+00
     .,0.13799560D+03,0.205D+03,0.320D+02,0.19441000D+01,0.00000000D+00
     .,0.11813540D+03,0.205D+03,0.330D+02,0.19441000D+01,0.00000000D+00
     .,0.10621400D+03,0.205D+03,0.340D+02,0.19441000D+01,0.00000000D+00
     .,0.93100300D+02,0.205D+03,0.350D+02,0.19441000D+01,0.00000000D+00
     .,0.81051800D+02,0.205D+03,0.360D+02,0.19441000D+01,0.00000000D+00
     .,0.41522010D+03,0.205D+03,0.370D+02,0.19441000D+01,0.00000000D+00
     .,0.36565710D+03,0.205D+03,0.380D+02,0.19441000D+01,0.00000000D+00
     .,0.32126520D+03,0.205D+03,0.390D+02,0.19441000D+01,0.00000000D+00
     .,0.28928690D+03,0.205D+03,0.400D+02,0.19441000D+01,0.00000000D+00
     .,0.26412850D+03,0.205D+03,0.410D+02,0.19441000D+01,0.00000000D+00
     .,0.20430920D+03,0.205D+03,0.420D+02,0.19441000D+01,0.00000000D+00
     .,0.22779590D+03,0.205D+03,0.430D+02,0.19441000D+01,0.00000000D+00
     .,0.17387670D+03,0.205D+03,0.440D+02,0.19441000D+01,0.00000000D+00
     .,0.19004450D+03,0.205D+03,0.450D+02,0.19441000D+01,0.00000000D+00
     .,0.17633810D+03,0.205D+03,0.460D+02,0.19441000D+01,0.00000000D+00
     .,0.14690170D+03,0.205D+03,0.470D+02,0.19441000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  83501:  83600)=(/
     . 0.15547780D+03,0.205D+03,0.480D+02,0.19441000D+01,0.00000000D+00
     .,0.19476490D+03,0.205D+03,0.490D+02,0.19441000D+01,0.00000000D+00
     .,0.18069960D+03,0.205D+03,0.500D+02,0.19441000D+01,0.00000000D+00
     .,0.16155700D+03,0.205D+03,0.510D+02,0.19441000D+01,0.00000000D+00
     .,0.15017540D+03,0.205D+03,0.520D+02,0.19441000D+01,0.00000000D+00
     .,0.13602390D+03,0.205D+03,0.530D+02,0.19441000D+01,0.00000000D+00
     .,0.12246340D+03,0.205D+03,0.540D+02,0.19441000D+01,0.00000000D+00
     .,0.50650540D+03,0.205D+03,0.550D+02,0.19441000D+01,0.00000000D+00
     .,0.46597660D+03,0.205D+03,0.560D+02,0.19441000D+01,0.00000000D+00
     .,0.41051230D+03,0.205D+03,0.570D+02,0.19441000D+01,0.00000000D+00
     .,0.19074630D+03,0.205D+03,0.580D+02,0.19441000D+01,0.27991000D+01
     .,0.41312090D+03,0.205D+03,0.590D+02,0.19441000D+01,0.00000000D+00
     .,0.39675810D+03,0.205D+03,0.600D+02,0.19441000D+01,0.00000000D+00
     .,0.38683630D+03,0.205D+03,0.610D+02,0.19441000D+01,0.00000000D+00
     .,0.37770920D+03,0.205D+03,0.620D+02,0.19441000D+01,0.00000000D+00
     .,0.36961950D+03,0.205D+03,0.630D+02,0.19441000D+01,0.00000000D+00
     .,0.29164910D+03,0.205D+03,0.640D+02,0.19441000D+01,0.00000000D+00
     .,0.32723330D+03,0.205D+03,0.650D+02,0.19441000D+01,0.00000000D+00
     .,0.31588750D+03,0.205D+03,0.660D+02,0.19441000D+01,0.00000000D+00
     .,0.33355970D+03,0.205D+03,0.670D+02,0.19441000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  83601:  83700)=(/
     . 0.32649630D+03,0.205D+03,0.680D+02,0.19441000D+01,0.00000000D+00
     .,0.32014370D+03,0.205D+03,0.690D+02,0.19441000D+01,0.00000000D+00
     .,0.31635220D+03,0.205D+03,0.700D+02,0.19441000D+01,0.00000000D+00
     .,0.26724090D+03,0.205D+03,0.710D+02,0.19441000D+01,0.00000000D+00
     .,0.26368480D+03,0.205D+03,0.720D+02,0.19441000D+01,0.00000000D+00
     .,0.24107990D+03,0.205D+03,0.730D+02,0.19441000D+01,0.00000000D+00
     .,0.20385670D+03,0.205D+03,0.740D+02,0.19441000D+01,0.00000000D+00
     .,0.20752370D+03,0.205D+03,0.750D+02,0.19441000D+01,0.00000000D+00
     .,0.18834080D+03,0.205D+03,0.760D+02,0.19441000D+01,0.00000000D+00
     .,0.17266610D+03,0.205D+03,0.770D+02,0.19441000D+01,0.00000000D+00
     .,0.14353170D+03,0.205D+03,0.780D+02,0.19441000D+01,0.00000000D+00
     .,0.13411890D+03,0.205D+03,0.790D+02,0.19441000D+01,0.00000000D+00
     .,0.13806770D+03,0.205D+03,0.800D+02,0.19441000D+01,0.00000000D+00
     .,0.20008980D+03,0.205D+03,0.810D+02,0.19441000D+01,0.00000000D+00
     .,0.19608950D+03,0.205D+03,0.820D+02,0.19441000D+01,0.00000000D+00
     .,0.18068820D+03,0.205D+03,0.830D+02,0.19441000D+01,0.00000000D+00
     .,0.17261360D+03,0.205D+03,0.840D+02,0.19441000D+01,0.00000000D+00
     .,0.15958520D+03,0.205D+03,0.850D+02,0.19441000D+01,0.00000000D+00
     .,0.14647210D+03,0.205D+03,0.860D+02,0.19441000D+01,0.00000000D+00
     .,0.47896760D+03,0.205D+03,0.870D+02,0.19441000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  83701:  83800)=(/
     . 0.46147150D+03,0.205D+03,0.880D+02,0.19441000D+01,0.00000000D+00
     .,0.40883210D+03,0.205D+03,0.890D+02,0.19441000D+01,0.00000000D+00
     .,0.36846880D+03,0.205D+03,0.900D+02,0.19441000D+01,0.00000000D+00
     .,0.36524790D+03,0.205D+03,0.910D+02,0.19441000D+01,0.00000000D+00
     .,0.35364010D+03,0.205D+03,0.920D+02,0.19441000D+01,0.00000000D+00
     .,0.36328030D+03,0.205D+03,0.930D+02,0.19441000D+01,0.00000000D+00
     .,0.35190410D+03,0.205D+03,0.940D+02,0.19441000D+01,0.00000000D+00
     .,0.20059700D+02,0.205D+03,0.101D+03,0.19441000D+01,0.00000000D+00
     .,0.64255300D+02,0.205D+03,0.103D+03,0.19441000D+01,0.98650000D+00
     .,0.82143000D+02,0.205D+03,0.104D+03,0.19441000D+01,0.98080000D+00
     .,0.63168500D+02,0.205D+03,0.105D+03,0.19441000D+01,0.97060000D+00
     .,0.47746200D+02,0.205D+03,0.106D+03,0.19441000D+01,0.98680000D+00
     .,0.33267700D+02,0.205D+03,0.107D+03,0.19441000D+01,0.99440000D+00
     .,0.24241600D+02,0.205D+03,0.108D+03,0.19441000D+01,0.99250000D+00
     .,0.16653100D+02,0.205D+03,0.109D+03,0.19441000D+01,0.99820000D+00
     .,0.93715900D+02,0.205D+03,0.111D+03,0.19441000D+01,0.96840000D+00
     .,0.14497830D+03,0.205D+03,0.112D+03,0.19441000D+01,0.96280000D+00
     .,0.14737660D+03,0.205D+03,0.113D+03,0.19441000D+01,0.96480000D+00
     .,0.11908890D+03,0.205D+03,0.114D+03,0.19441000D+01,0.95070000D+00
     .,0.97894700D+02,0.205D+03,0.115D+03,0.19441000D+01,0.99470000D+00
     ./)
      grimme_c6_parameters(  83801:  83900)=(/
     . 0.82949700D+02,0.205D+03,0.116D+03,0.19441000D+01,0.99480000D+00
     .,0.67913200D+02,0.205D+03,0.117D+03,0.19441000D+01,0.99720000D+00
     .,0.12959630D+03,0.205D+03,0.119D+03,0.19441000D+01,0.97670000D+00
     .,0.24594980D+03,0.205D+03,0.120D+03,0.19441000D+01,0.98310000D+00
     .,0.13017250D+03,0.205D+03,0.121D+03,0.19441000D+01,0.18627000D+01
     .,0.12570170D+03,0.205D+03,0.122D+03,0.19441000D+01,0.18299000D+01
     .,0.12315290D+03,0.205D+03,0.123D+03,0.19441000D+01,0.19138000D+01
     .,0.12193400D+03,0.205D+03,0.124D+03,0.19441000D+01,0.18269000D+01
     .,0.11246480D+03,0.205D+03,0.125D+03,0.19441000D+01,0.16406000D+01
     .,0.10414370D+03,0.205D+03,0.126D+03,0.19441000D+01,0.16483000D+01
     .,0.99334300D+02,0.205D+03,0.127D+03,0.19441000D+01,0.17149000D+01
     .,0.97081600D+02,0.205D+03,0.128D+03,0.19441000D+01,0.17937000D+01
     .,0.95700700D+02,0.205D+03,0.129D+03,0.19441000D+01,0.95760000D+00
     .,0.90135100D+02,0.205D+03,0.130D+03,0.19441000D+01,0.19419000D+01
     .,0.14648900D+03,0.205D+03,0.131D+03,0.19441000D+01,0.96010000D+00
     .,0.12922270D+03,0.205D+03,0.132D+03,0.19441000D+01,0.94340000D+00
     .,0.11615350D+03,0.205D+03,0.133D+03,0.19441000D+01,0.98890000D+00
     .,0.10624910D+03,0.205D+03,0.134D+03,0.19441000D+01,0.99010000D+00
     .,0.93737400D+02,0.205D+03,0.135D+03,0.19441000D+01,0.99740000D+00
     .,0.15478270D+03,0.205D+03,0.137D+03,0.19441000D+01,0.97380000D+00
     ./)
      grimme_c6_parameters(  83901:  84000)=(/
     . 0.29929140D+03,0.205D+03,0.138D+03,0.19441000D+01,0.98010000D+00
     .,0.23013840D+03,0.205D+03,0.139D+03,0.19441000D+01,0.19153000D+01
     .,0.17218100D+03,0.205D+03,0.140D+03,0.19441000D+01,0.19355000D+01
     .,0.17379460D+03,0.205D+03,0.141D+03,0.19441000D+01,0.19545000D+01
     .,0.16219830D+03,0.205D+03,0.142D+03,0.19441000D+01,0.19420000D+01
     .,0.18138850D+03,0.205D+03,0.143D+03,0.19441000D+01,0.16682000D+01
     .,0.14162010D+03,0.205D+03,0.144D+03,0.19441000D+01,0.18584000D+01
     .,0.13247760D+03,0.205D+03,0.145D+03,0.19441000D+01,0.19003000D+01
     .,0.12302270D+03,0.205D+03,0.146D+03,0.19441000D+01,0.18630000D+01
     .,0.11892360D+03,0.205D+03,0.147D+03,0.19441000D+01,0.96790000D+00
     .,0.11788430D+03,0.205D+03,0.148D+03,0.19441000D+01,0.19539000D+01
     .,0.18585760D+03,0.205D+03,0.149D+03,0.19441000D+01,0.96330000D+00
     .,0.16872480D+03,0.205D+03,0.150D+03,0.19441000D+01,0.95140000D+00
     .,0.15840370D+03,0.205D+03,0.151D+03,0.19441000D+01,0.97490000D+00
     .,0.15008700D+03,0.205D+03,0.152D+03,0.19441000D+01,0.98110000D+00
     .,0.13730200D+03,0.205D+03,0.153D+03,0.19441000D+01,0.99680000D+00
     .,0.18365680D+03,0.205D+03,0.155D+03,0.19441000D+01,0.99090000D+00
     .,0.38802680D+03,0.205D+03,0.156D+03,0.19441000D+01,0.97970000D+00
     .,0.29127440D+03,0.205D+03,0.157D+03,0.19441000D+01,0.19373000D+01
     .,0.18501940D+03,0.205D+03,0.159D+03,0.19441000D+01,0.29425000D+01
     ./)
      grimme_c6_parameters(  84001:  84100)=(/
     . 0.18119130D+03,0.205D+03,0.160D+03,0.19441000D+01,0.29455000D+01
     .,0.17546970D+03,0.205D+03,0.161D+03,0.19441000D+01,0.29413000D+01
     .,0.17626590D+03,0.205D+03,0.162D+03,0.19441000D+01,0.29300000D+01
     .,0.16958240D+03,0.205D+03,0.163D+03,0.19441000D+01,0.18286000D+01
     .,0.17736130D+03,0.205D+03,0.164D+03,0.19441000D+01,0.28732000D+01
     .,0.16662020D+03,0.205D+03,0.165D+03,0.19441000D+01,0.29086000D+01
     .,0.16942280D+03,0.205D+03,0.166D+03,0.19441000D+01,0.28965000D+01
     .,0.15821700D+03,0.205D+03,0.167D+03,0.19441000D+01,0.29242000D+01
     .,0.15373020D+03,0.205D+03,0.168D+03,0.19441000D+01,0.29282000D+01
     .,0.15273000D+03,0.205D+03,0.169D+03,0.19441000D+01,0.29246000D+01
     .,0.16046200D+03,0.205D+03,0.170D+03,0.19441000D+01,0.28482000D+01
     .,0.14766360D+03,0.205D+03,0.171D+03,0.19441000D+01,0.29219000D+01
     .,0.19919290D+03,0.205D+03,0.172D+03,0.19441000D+01,0.19254000D+01
     .,0.18514520D+03,0.205D+03,0.173D+03,0.19441000D+01,0.19459000D+01
     .,0.16918110D+03,0.205D+03,0.174D+03,0.19441000D+01,0.19292000D+01
     .,0.17089180D+03,0.205D+03,0.175D+03,0.19441000D+01,0.18104000D+01
     .,0.15017550D+03,0.205D+03,0.176D+03,0.19441000D+01,0.18858000D+01
     .,0.14130850D+03,0.205D+03,0.177D+03,0.19441000D+01,0.18648000D+01
     .,0.13497080D+03,0.205D+03,0.178D+03,0.19441000D+01,0.19188000D+01
     .,0.12897340D+03,0.205D+03,0.179D+03,0.19441000D+01,0.98460000D+00
     ./)
      grimme_c6_parameters(  84101:  84200)=(/
     . 0.12481680D+03,0.205D+03,0.180D+03,0.19441000D+01,0.19896000D+01
     .,0.19964430D+03,0.205D+03,0.181D+03,0.19441000D+01,0.92670000D+00
     .,0.18252700D+03,0.205D+03,0.182D+03,0.19441000D+01,0.93830000D+00
     .,0.17734000D+03,0.205D+03,0.183D+03,0.19441000D+01,0.98200000D+00
     .,0.17270710D+03,0.205D+03,0.184D+03,0.19441000D+01,0.98150000D+00
     .,0.16153370D+03,0.205D+03,0.185D+03,0.19441000D+01,0.99540000D+00
     .,0.20689790D+03,0.205D+03,0.187D+03,0.19441000D+01,0.97050000D+00
     .,0.38645800D+03,0.205D+03,0.188D+03,0.19441000D+01,0.96620000D+00
     .,0.21894300D+03,0.205D+03,0.189D+03,0.19441000D+01,0.29070000D+01
     .,0.25214850D+03,0.205D+03,0.190D+03,0.19441000D+01,0.28844000D+01
     .,0.22571000D+03,0.205D+03,0.191D+03,0.19441000D+01,0.28738000D+01
     .,0.19962770D+03,0.205D+03,0.192D+03,0.19441000D+01,0.28878000D+01
     .,0.19215040D+03,0.205D+03,0.193D+03,0.19441000D+01,0.29095000D+01
     .,0.23000030D+03,0.205D+03,0.194D+03,0.19441000D+01,0.19209000D+01
     .,0.53991900D+02,0.205D+03,0.204D+03,0.19441000D+01,0.19697000D+01
     .,0.53112800D+02,0.205D+03,0.205D+03,0.19441000D+01,0.19441000D+01
     .,0.94203000D+01,0.206D+03,0.100D+01,0.19985000D+01,0.91180000D+00
     .,0.65027000D+01,0.206D+03,0.200D+01,0.19985000D+01,0.00000000D+00
     .,0.12377070D+03,0.206D+03,0.300D+01,0.19985000D+01,0.00000000D+00
     .,0.76755200D+02,0.206D+03,0.400D+01,0.19985000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  84201:  84300)=(/
     . 0.54085400D+02,0.206D+03,0.500D+01,0.19985000D+01,0.00000000D+00
     .,0.37841900D+02,0.206D+03,0.600D+01,0.19985000D+01,0.00000000D+00
     .,0.27170400D+02,0.206D+03,0.700D+01,0.19985000D+01,0.00000000D+00
     .,0.20959700D+02,0.206D+03,0.800D+01,0.19985000D+01,0.00000000D+00
     .,0.16131200D+02,0.206D+03,0.900D+01,0.19985000D+01,0.00000000D+00
     .,0.12562900D+02,0.206D+03,0.100D+02,0.19985000D+01,0.00000000D+00
     .,0.14876180D+03,0.206D+03,0.110D+02,0.19985000D+01,0.00000000D+00
     .,0.12073860D+03,0.206D+03,0.120D+02,0.19985000D+01,0.00000000D+00
     .,0.11385600D+03,0.206D+03,0.130D+02,0.19985000D+01,0.00000000D+00
     .,0.92493100D+02,0.206D+03,0.140D+02,0.19985000D+01,0.00000000D+00
     .,0.74078400D+02,0.206D+03,0.150D+02,0.19985000D+01,0.00000000D+00
     .,0.62595300D+02,0.206D+03,0.160D+02,0.19985000D+01,0.00000000D+00
     .,0.52020800D+02,0.206D+03,0.170D+02,0.19985000D+01,0.00000000D+00
     .,0.43206400D+02,0.206D+03,0.180D+02,0.19985000D+01,0.00000000D+00
     .,0.24263660D+03,0.206D+03,0.190D+02,0.19985000D+01,0.00000000D+00
     .,0.20802230D+03,0.206D+03,0.200D+02,0.19985000D+01,0.00000000D+00
     .,0.17346300D+03,0.206D+03,0.210D+02,0.19985000D+01,0.00000000D+00
     .,0.16920640D+03,0.206D+03,0.220D+02,0.19985000D+01,0.00000000D+00
     .,0.15583870D+03,0.206D+03,0.230D+02,0.19985000D+01,0.00000000D+00
     .,0.12325910D+03,0.206D+03,0.240D+02,0.19985000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  84301:  84400)=(/
     . 0.13529940D+03,0.206D+03,0.250D+02,0.19985000D+01,0.00000000D+00
     .,0.10673260D+03,0.206D+03,0.260D+02,0.19985000D+01,0.00000000D+00
     .,0.11409130D+03,0.206D+03,0.270D+02,0.19985000D+01,0.00000000D+00
     .,0.11680720D+03,0.206D+03,0.280D+02,0.19985000D+01,0.00000000D+00
     .,0.89951500D+02,0.206D+03,0.290D+02,0.19985000D+01,0.00000000D+00
     .,0.93687000D+02,0.206D+03,0.300D+02,0.19985000D+01,0.00000000D+00
     .,0.11027700D+03,0.206D+03,0.310D+02,0.19985000D+01,0.00000000D+00
     .,0.99469800D+02,0.206D+03,0.320D+02,0.19985000D+01,0.00000000D+00
     .,0.86689500D+02,0.206D+03,0.330D+02,0.19985000D+01,0.00000000D+00
     .,0.78883800D+02,0.206D+03,0.340D+02,0.19985000D+01,0.00000000D+00
     .,0.70035200D+02,0.206D+03,0.350D+02,0.19985000D+01,0.00000000D+00
     .,0.61725400D+02,0.206D+03,0.360D+02,0.19985000D+01,0.00000000D+00
     .,0.27337570D+03,0.206D+03,0.370D+02,0.19985000D+01,0.00000000D+00
     .,0.24782850D+03,0.206D+03,0.380D+02,0.19985000D+01,0.00000000D+00
     .,0.22088300D+03,0.206D+03,0.390D+02,0.19985000D+01,0.00000000D+00
     .,0.20078170D+03,0.206D+03,0.400D+02,0.19985000D+01,0.00000000D+00
     .,0.18454770D+03,0.206D+03,0.410D+02,0.19985000D+01,0.00000000D+00
     .,0.14463550D+03,0.206D+03,0.420D+02,0.19985000D+01,0.00000000D+00
     .,0.16045200D+03,0.206D+03,0.430D+02,0.19985000D+01,0.00000000D+00
     .,0.12423890D+03,0.206D+03,0.440D+02,0.19985000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  84401:  84500)=(/
     . 0.13547600D+03,0.206D+03,0.450D+02,0.19985000D+01,0.00000000D+00
     .,0.12623620D+03,0.206D+03,0.460D+02,0.19985000D+01,0.00000000D+00
     .,0.10535720D+03,0.206D+03,0.470D+02,0.19985000D+01,0.00000000D+00
     .,0.11192520D+03,0.206D+03,0.480D+02,0.19985000D+01,0.00000000D+00
     .,0.13828310D+03,0.206D+03,0.490D+02,0.19985000D+01,0.00000000D+00
     .,0.13007660D+03,0.206D+03,0.500D+02,0.19985000D+01,0.00000000D+00
     .,0.11803370D+03,0.206D+03,0.510D+02,0.19985000D+01,0.00000000D+00
     .,0.11077470D+03,0.206D+03,0.520D+02,0.19985000D+01,0.00000000D+00
     .,0.10142160D+03,0.206D+03,0.530D+02,0.19985000D+01,0.00000000D+00
     .,0.92287600D+02,0.206D+03,0.540D+02,0.19985000D+01,0.00000000D+00
     .,0.33381300D+03,0.206D+03,0.550D+02,0.19985000D+01,0.00000000D+00
     .,0.31468370D+03,0.206D+03,0.560D+02,0.19985000D+01,0.00000000D+00
     .,0.28115040D+03,0.206D+03,0.570D+02,0.19985000D+01,0.00000000D+00
     .,0.13918110D+03,0.206D+03,0.580D+02,0.19985000D+01,0.27991000D+01
     .,0.28046490D+03,0.206D+03,0.590D+02,0.19985000D+01,0.00000000D+00
     .,0.26998650D+03,0.206D+03,0.600D+02,0.19985000D+01,0.00000000D+00
     .,0.26339220D+03,0.206D+03,0.610D+02,0.19985000D+01,0.00000000D+00
     .,0.25730290D+03,0.206D+03,0.620D+02,0.19985000D+01,0.00000000D+00
     .,0.25190990D+03,0.206D+03,0.630D+02,0.19985000D+01,0.00000000D+00
     .,0.20229780D+03,0.206D+03,0.640D+02,0.19985000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  84501:  84600)=(/
     . 0.22209340D+03,0.206D+03,0.650D+02,0.19985000D+01,0.00000000D+00
     .,0.21493990D+03,0.206D+03,0.660D+02,0.19985000D+01,0.00000000D+00
     .,0.22808570D+03,0.206D+03,0.670D+02,0.19985000D+01,0.00000000D+00
     .,0.22331660D+03,0.206D+03,0.680D+02,0.19985000D+01,0.00000000D+00
     .,0.21907220D+03,0.206D+03,0.690D+02,0.19985000D+01,0.00000000D+00
     .,0.21630440D+03,0.206D+03,0.700D+02,0.19985000D+01,0.00000000D+00
     .,0.18487050D+03,0.206D+03,0.710D+02,0.19985000D+01,0.00000000D+00
     .,0.18493620D+03,0.206D+03,0.720D+02,0.19985000D+01,0.00000000D+00
     .,0.17072850D+03,0.206D+03,0.730D+02,0.19985000D+01,0.00000000D+00
     .,0.14577740D+03,0.206D+03,0.740D+02,0.19985000D+01,0.00000000D+00
     .,0.14883210D+03,0.206D+03,0.750D+02,0.19985000D+01,0.00000000D+00
     .,0.13624100D+03,0.206D+03,0.760D+02,0.19985000D+01,0.00000000D+00
     .,0.12580040D+03,0.206D+03,0.770D+02,0.19985000D+01,0.00000000D+00
     .,0.10559200D+03,0.206D+03,0.780D+02,0.19985000D+01,0.00000000D+00
     .,0.99045400D+02,0.206D+03,0.790D+02,0.19985000D+01,0.00000000D+00
     .,0.10212660D+03,0.206D+03,0.800D+02,0.19985000D+01,0.00000000D+00
     .,0.14307200D+03,0.206D+03,0.810D+02,0.19985000D+01,0.00000000D+00
     .,0.14157460D+03,0.206D+03,0.820D+02,0.19985000D+01,0.00000000D+00
     .,0.13211550D+03,0.206D+03,0.830D+02,0.19985000D+01,0.00000000D+00
     .,0.12719520D+03,0.206D+03,0.840D+02,0.19985000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  84601:  84700)=(/
     . 0.11875500D+03,0.206D+03,0.850D+02,0.19985000D+01,0.00000000D+00
     .,0.11003140D+03,0.206D+03,0.860D+02,0.19985000D+01,0.00000000D+00
     .,0.31957380D+03,0.206D+03,0.870D+02,0.19985000D+01,0.00000000D+00
     .,0.31409480D+03,0.206D+03,0.880D+02,0.19985000D+01,0.00000000D+00
     .,0.28185090D+03,0.206D+03,0.890D+02,0.19985000D+01,0.00000000D+00
     .,0.25814870D+03,0.206D+03,0.900D+02,0.19985000D+01,0.00000000D+00
     .,0.25426850D+03,0.206D+03,0.910D+02,0.19985000D+01,0.00000000D+00
     .,0.24632970D+03,0.206D+03,0.920D+02,0.19985000D+01,0.00000000D+00
     .,0.25069380D+03,0.206D+03,0.930D+02,0.19985000D+01,0.00000000D+00
     .,0.24324780D+03,0.206D+03,0.940D+02,0.19985000D+01,0.00000000D+00
     .,0.14762300D+02,0.206D+03,0.101D+03,0.19985000D+01,0.00000000D+00
     .,0.44932000D+02,0.206D+03,0.103D+03,0.19985000D+01,0.98650000D+00
     .,0.57880500D+02,0.206D+03,0.104D+03,0.19985000D+01,0.98080000D+00
     .,0.45963200D+02,0.206D+03,0.105D+03,0.19985000D+01,0.97060000D+00
     .,0.35521900D+02,0.206D+03,0.106D+03,0.19985000D+01,0.98680000D+00
     .,0.25382700D+02,0.206D+03,0.107D+03,0.19985000D+01,0.99440000D+00
     .,0.18903400D+02,0.206D+03,0.108D+03,0.19985000D+01,0.99250000D+00
     .,0.13352900D+02,0.206D+03,0.109D+03,0.19985000D+01,0.99820000D+00
     .,0.65273900D+02,0.206D+03,0.111D+03,0.19985000D+01,0.96840000D+00
     .,0.10058170D+03,0.206D+03,0.112D+03,0.19985000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters(  84701:  84800)=(/
     . 0.10379070D+03,0.206D+03,0.113D+03,0.19985000D+01,0.96480000D+00
     .,0.85906800D+02,0.206D+03,0.114D+03,0.19985000D+01,0.95070000D+00
     .,0.71991400D+02,0.206D+03,0.115D+03,0.19985000D+01,0.99470000D+00
     .,0.61891600D+02,0.206D+03,0.116D+03,0.19985000D+01,0.99480000D+00
     .,0.51472100D+02,0.206D+03,0.117D+03,0.19985000D+01,0.99720000D+00
     .,0.92024000D+02,0.206D+03,0.119D+03,0.19985000D+01,0.97670000D+00
     .,0.16741450D+03,0.206D+03,0.120D+03,0.19985000D+01,0.98310000D+00
     .,0.93891100D+02,0.206D+03,0.121D+03,0.19985000D+01,0.18627000D+01
     .,0.90783800D+02,0.206D+03,0.122D+03,0.19985000D+01,0.18299000D+01
     .,0.88942900D+02,0.206D+03,0.123D+03,0.19985000D+01,0.19138000D+01
     .,0.87888900D+02,0.206D+03,0.124D+03,0.19985000D+01,0.18269000D+01
     .,0.81873100D+02,0.206D+03,0.125D+03,0.19985000D+01,0.16406000D+01
     .,0.76113200D+02,0.206D+03,0.126D+03,0.19985000D+01,0.16483000D+01
     .,0.72644300D+02,0.206D+03,0.127D+03,0.19985000D+01,0.17149000D+01
     .,0.70944400D+02,0.206D+03,0.128D+03,0.19985000D+01,0.17937000D+01
     .,0.69405800D+02,0.206D+03,0.129D+03,0.19985000D+01,0.95760000D+00
     .,0.66283800D+02,0.206D+03,0.130D+03,0.19985000D+01,0.19419000D+01
     .,0.10418810D+03,0.206D+03,0.131D+03,0.19985000D+01,0.96010000D+00
     .,0.93589300D+02,0.206D+03,0.132D+03,0.19985000D+01,0.94340000D+00
     .,0.85337900D+02,0.206D+03,0.133D+03,0.19985000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters(  84801:  84900)=(/
     . 0.78902900D+02,0.206D+03,0.134D+03,0.19985000D+01,0.99010000D+00
     .,0.70474400D+02,0.206D+03,0.135D+03,0.19985000D+01,0.99740000D+00
     .,0.11048560D+03,0.206D+03,0.137D+03,0.19985000D+01,0.97380000D+00
     .,0.20357060D+03,0.206D+03,0.138D+03,0.19985000D+01,0.98010000D+00
     .,0.16111150D+03,0.206D+03,0.139D+03,0.19985000D+01,0.19153000D+01
     .,0.12419200D+03,0.206D+03,0.140D+03,0.19985000D+01,0.19355000D+01
     .,0.12536250D+03,0.206D+03,0.141D+03,0.19985000D+01,0.19545000D+01
     .,0.11755240D+03,0.206D+03,0.142D+03,0.19985000D+01,0.19420000D+01
     .,0.12970790D+03,0.206D+03,0.143D+03,0.19985000D+01,0.16682000D+01
     .,0.10379560D+03,0.206D+03,0.144D+03,0.19985000D+01,0.18584000D+01
     .,0.97296100D+02,0.206D+03,0.145D+03,0.19985000D+01,0.19003000D+01
     .,0.90624900D+02,0.206D+03,0.146D+03,0.19985000D+01,0.18630000D+01
     .,0.87495100D+02,0.206D+03,0.147D+03,0.19985000D+01,0.96790000D+00
     .,0.87291500D+02,0.206D+03,0.148D+03,0.19985000D+01,0.19539000D+01
     .,0.13265050D+03,0.206D+03,0.149D+03,0.19985000D+01,0.96330000D+00
     .,0.12220300D+03,0.206D+03,0.150D+03,0.19985000D+01,0.95140000D+00
     .,0.11597420D+03,0.206D+03,0.151D+03,0.19985000D+01,0.97490000D+00
     .,0.11077110D+03,0.206D+03,0.152D+03,0.19985000D+01,0.98110000D+00
     .,0.10234890D+03,0.206D+03,0.153D+03,0.19985000D+01,0.99680000D+00
     .,0.13246620D+03,0.206D+03,0.155D+03,0.19985000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters(  84901:  85000)=(/
     . 0.26261810D+03,0.206D+03,0.156D+03,0.19985000D+01,0.97970000D+00
     .,0.20348290D+03,0.206D+03,0.157D+03,0.19985000D+01,0.19373000D+01
     .,0.13513800D+03,0.206D+03,0.159D+03,0.19985000D+01,0.29425000D+01
     .,0.13236910D+03,0.206D+03,0.160D+03,0.19985000D+01,0.29455000D+01
     .,0.12830130D+03,0.206D+03,0.161D+03,0.19985000D+01,0.29413000D+01
     .,0.12859630D+03,0.206D+03,0.162D+03,0.19985000D+01,0.29300000D+01
     .,0.12294040D+03,0.206D+03,0.163D+03,0.19985000D+01,0.18286000D+01
     .,0.12924610D+03,0.206D+03,0.164D+03,0.19985000D+01,0.28732000D+01
     .,0.12168990D+03,0.206D+03,0.165D+03,0.19985000D+01,0.29086000D+01
     .,0.12326190D+03,0.206D+03,0.166D+03,0.19985000D+01,0.28965000D+01
     .,0.11576120D+03,0.206D+03,0.167D+03,0.19985000D+01,0.29242000D+01
     .,0.11255880D+03,0.206D+03,0.168D+03,0.19985000D+01,0.29282000D+01
     .,0.11174980D+03,0.206D+03,0.169D+03,0.19985000D+01,0.29246000D+01
     .,0.11693130D+03,0.206D+03,0.170D+03,0.19985000D+01,0.28482000D+01
     .,0.10814300D+03,0.206D+03,0.171D+03,0.19985000D+01,0.29219000D+01
     .,0.14218370D+03,0.206D+03,0.172D+03,0.19985000D+01,0.19254000D+01
     .,0.13342480D+03,0.206D+03,0.173D+03,0.19985000D+01,0.19459000D+01
     .,0.12313620D+03,0.206D+03,0.174D+03,0.19985000D+01,0.19292000D+01
     .,0.12340630D+03,0.206D+03,0.175D+03,0.19985000D+01,0.18104000D+01
     .,0.11082750D+03,0.206D+03,0.176D+03,0.19985000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters(  85001:  85100)=(/
     . 0.10472640D+03,0.206D+03,0.177D+03,0.19985000D+01,0.18648000D+01
     .,0.10030120D+03,0.206D+03,0.178D+03,0.19985000D+01,0.19188000D+01
     .,0.95922700D+02,0.206D+03,0.179D+03,0.19985000D+01,0.98460000D+00
     .,0.93462800D+02,0.206D+03,0.180D+03,0.19985000D+01,0.19896000D+01
     .,0.14324960D+03,0.206D+03,0.181D+03,0.19985000D+01,0.92670000D+00
     .,0.13282830D+03,0.206D+03,0.182D+03,0.19985000D+01,0.93830000D+00
     .,0.13004040D+03,0.206D+03,0.183D+03,0.19985000D+01,0.98200000D+00
     .,0.12739760D+03,0.206D+03,0.184D+03,0.19985000D+01,0.98150000D+00
     .,0.12019670D+03,0.206D+03,0.185D+03,0.19985000D+01,0.99540000D+00
     .,0.14932790D+03,0.206D+03,0.187D+03,0.19985000D+01,0.97050000D+00
     .,0.26405250D+03,0.206D+03,0.188D+03,0.19985000D+01,0.96620000D+00
     .,0.15978300D+03,0.206D+03,0.189D+03,0.19985000D+01,0.29070000D+01
     .,0.18182240D+03,0.206D+03,0.190D+03,0.19985000D+01,0.28844000D+01
     .,0.16366940D+03,0.206D+03,0.191D+03,0.19985000D+01,0.28738000D+01
     .,0.14625060D+03,0.206D+03,0.192D+03,0.19985000D+01,0.28878000D+01
     .,0.14111910D+03,0.206D+03,0.193D+03,0.19985000D+01,0.29095000D+01
     .,0.16450530D+03,0.206D+03,0.194D+03,0.19985000D+01,0.19209000D+01
     .,0.39281400D+02,0.206D+03,0.204D+03,0.19985000D+01,0.19697000D+01
     .,0.38983400D+02,0.206D+03,0.205D+03,0.19985000D+01,0.19441000D+01
     .,0.29360200D+02,0.206D+03,0.206D+03,0.19985000D+01,0.19985000D+01
     ./)
      grimme_c6_parameters(  85101:  85200)=(/
     . 0.76610000D+01,0.207D+03,0.100D+01,0.20143000D+01,0.91180000D+00
     .,0.54559000D+01,0.207D+03,0.200D+01,0.20143000D+01,0.00000000D+00
     .,0.94006000D+02,0.207D+03,0.300D+01,0.20143000D+01,0.00000000D+00
     .,0.59598300D+02,0.207D+03,0.400D+01,0.20143000D+01,0.00000000D+00
     .,0.42834800D+02,0.207D+03,0.500D+01,0.20143000D+01,0.00000000D+00
     .,0.30530500D+02,0.207D+03,0.600D+01,0.20143000D+01,0.00000000D+00
     .,0.22279400D+02,0.207D+03,0.700D+01,0.20143000D+01,0.00000000D+00
     .,0.17409300D+02,0.207D+03,0.800D+01,0.20143000D+01,0.00000000D+00
     .,0.13561300D+02,0.207D+03,0.900D+01,0.20143000D+01,0.00000000D+00
     .,0.10674000D+02,0.207D+03,0.100D+02,0.20143000D+01,0.00000000D+00
     .,0.11330310D+03,0.207D+03,0.110D+02,0.20143000D+01,0.00000000D+00
     .,0.93413000D+02,0.207D+03,0.120D+02,0.20143000D+01,0.00000000D+00
     .,0.88840700D+02,0.207D+03,0.130D+02,0.20143000D+01,0.00000000D+00
     .,0.73085800D+02,0.207D+03,0.140D+02,0.20143000D+01,0.00000000D+00
     .,0.59285900D+02,0.207D+03,0.150D+02,0.20143000D+01,0.00000000D+00
     .,0.50594600D+02,0.207D+03,0.160D+02,0.20143000D+01,0.00000000D+00
     .,0.42481600D+02,0.207D+03,0.170D+02,0.20143000D+01,0.00000000D+00
     .,0.35633400D+02,0.207D+03,0.180D+02,0.20143000D+01,0.00000000D+00
     .,0.18521810D+03,0.207D+03,0.190D+02,0.20143000D+01,0.00000000D+00
     .,0.16027500D+03,0.207D+03,0.200D+02,0.20143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  85201:  85300)=(/
     . 0.13403140D+03,0.207D+03,0.210D+02,0.20143000D+01,0.00000000D+00
     .,0.13130150D+03,0.207D+03,0.220D+02,0.20143000D+01,0.00000000D+00
     .,0.12121190D+03,0.207D+03,0.230D+02,0.20143000D+01,0.00000000D+00
     .,0.96254700D+02,0.207D+03,0.240D+02,0.20143000D+01,0.00000000D+00
     .,0.10560800D+03,0.207D+03,0.250D+02,0.20143000D+01,0.00000000D+00
     .,0.83691600D+02,0.207D+03,0.260D+02,0.20143000D+01,0.00000000D+00
     .,0.89534500D+02,0.207D+03,0.270D+02,0.20143000D+01,0.00000000D+00
     .,0.91429500D+02,0.207D+03,0.280D+02,0.20143000D+01,0.00000000D+00
     .,0.70763900D+02,0.207D+03,0.290D+02,0.20143000D+01,0.00000000D+00
     .,0.73921000D+02,0.207D+03,0.300D+02,0.20143000D+01,0.00000000D+00
     .,0.86619400D+02,0.207D+03,0.310D+02,0.20143000D+01,0.00000000D+00
     .,0.78823500D+02,0.207D+03,0.320D+02,0.20143000D+01,0.00000000D+00
     .,0.69377000D+02,0.207D+03,0.330D+02,0.20143000D+01,0.00000000D+00
     .,0.63591900D+02,0.207D+03,0.340D+02,0.20143000D+01,0.00000000D+00
     .,0.56918700D+02,0.207D+03,0.350D+02,0.20143000D+01,0.00000000D+00
     .,0.50574600D+02,0.207D+03,0.360D+02,0.20143000D+01,0.00000000D+00
     .,0.20923780D+03,0.207D+03,0.370D+02,0.20143000D+01,0.00000000D+00
     .,0.19112680D+03,0.207D+03,0.380D+02,0.20143000D+01,0.00000000D+00
     .,0.17135740D+03,0.207D+03,0.390D+02,0.20143000D+01,0.00000000D+00
     .,0.15645400D+03,0.207D+03,0.400D+02,0.20143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  85301:  85400)=(/
     . 0.14431220D+03,0.207D+03,0.410D+02,0.20143000D+01,0.00000000D+00
     .,0.11400040D+03,0.207D+03,0.420D+02,0.20143000D+01,0.00000000D+00
     .,0.12608010D+03,0.207D+03,0.430D+02,0.20143000D+01,0.00000000D+00
     .,0.98472800D+02,0.207D+03,0.440D+02,0.20143000D+01,0.00000000D+00
     .,0.10710840D+03,0.207D+03,0.450D+02,0.20143000D+01,0.00000000D+00
     .,0.10003700D+03,0.207D+03,0.460D+02,0.20143000D+01,0.00000000D+00
     .,0.83787500D+02,0.207D+03,0.470D+02,0.20143000D+01,0.00000000D+00
     .,0.88985800D+02,0.207D+03,0.480D+02,0.20143000D+01,0.00000000D+00
     .,0.10908250D+03,0.207D+03,0.490D+02,0.20143000D+01,0.00000000D+00
     .,0.10321130D+03,0.207D+03,0.500D+02,0.20143000D+01,0.00000000D+00
     .,0.94365400D+02,0.207D+03,0.510D+02,0.20143000D+01,0.00000000D+00
     .,0.89035900D+02,0.207D+03,0.520D+02,0.20143000D+01,0.00000000D+00
     .,0.82037400D+02,0.207D+03,0.530D+02,0.20143000D+01,0.00000000D+00
     .,0.75142700D+02,0.207D+03,0.540D+02,0.20143000D+01,0.00000000D+00
     .,0.25574990D+03,0.207D+03,0.550D+02,0.20143000D+01,0.00000000D+00
     .,0.24255280D+03,0.207D+03,0.560D+02,0.20143000D+01,0.00000000D+00
     .,0.21789480D+03,0.207D+03,0.570D+02,0.20143000D+01,0.00000000D+00
     .,0.11128270D+03,0.207D+03,0.580D+02,0.20143000D+01,0.27991000D+01
     .,0.21678200D+03,0.207D+03,0.590D+02,0.20143000D+01,0.00000000D+00
     .,0.20883570D+03,0.207D+03,0.600D+02,0.20143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  85401:  85500)=(/
     . 0.20377290D+03,0.207D+03,0.610D+02,0.20143000D+01,0.00000000D+00
     .,0.19908850D+03,0.207D+03,0.620D+02,0.20143000D+01,0.00000000D+00
     .,0.19493970D+03,0.207D+03,0.630D+02,0.20143000D+01,0.00000000D+00
     .,0.15792210D+03,0.207D+03,0.640D+02,0.20143000D+01,0.00000000D+00
     .,0.17208570D+03,0.207D+03,0.650D+02,0.20143000D+01,0.00000000D+00
     .,0.16673560D+03,0.207D+03,0.660D+02,0.20143000D+01,0.00000000D+00
     .,0.17670260D+03,0.207D+03,0.670D+02,0.20143000D+01,0.00000000D+00
     .,0.17301200D+03,0.207D+03,0.680D+02,0.20143000D+01,0.00000000D+00
     .,0.16974290D+03,0.207D+03,0.690D+02,0.20143000D+01,0.00000000D+00
     .,0.16752470D+03,0.207D+03,0.700D+02,0.20143000D+01,0.00000000D+00
     .,0.14402080D+03,0.207D+03,0.710D+02,0.20143000D+01,0.00000000D+00
     .,0.14479850D+03,0.207D+03,0.720D+02,0.20143000D+01,0.00000000D+00
     .,0.13433990D+03,0.207D+03,0.730D+02,0.20143000D+01,0.00000000D+00
     .,0.11544060D+03,0.207D+03,0.740D+02,0.20143000D+01,0.00000000D+00
     .,0.11798450D+03,0.207D+03,0.750D+02,0.20143000D+01,0.00000000D+00
     .,0.10851360D+03,0.207D+03,0.760D+02,0.20143000D+01,0.00000000D+00
     .,0.10061040D+03,0.207D+03,0.770D+02,0.20143000D+01,0.00000000D+00
     .,0.85019700D+02,0.207D+03,0.780D+02,0.20143000D+01,0.00000000D+00
     .,0.79962500D+02,0.207D+03,0.790D+02,0.20143000D+01,0.00000000D+00
     .,0.82454000D+02,0.207D+03,0.800D+02,0.20143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  85501:  85600)=(/
     . 0.11348820D+03,0.207D+03,0.810D+02,0.20143000D+01,0.00000000D+00
     .,0.11268290D+03,0.207D+03,0.820D+02,0.20143000D+01,0.00000000D+00
     .,0.10579110D+03,0.207D+03,0.830D+02,0.20143000D+01,0.00000000D+00
     .,0.10226460D+03,0.207D+03,0.840D+02,0.20143000D+01,0.00000000D+00
     .,0.96007100D+02,0.207D+03,0.850D+02,0.20143000D+01,0.00000000D+00
     .,0.89458900D+02,0.207D+03,0.860D+02,0.20143000D+01,0.00000000D+00
     .,0.24600480D+03,0.207D+03,0.870D+02,0.20143000D+01,0.00000000D+00
     .,0.24292720D+03,0.207D+03,0.880D+02,0.20143000D+01,0.00000000D+00
     .,0.21910640D+03,0.207D+03,0.890D+02,0.20143000D+01,0.00000000D+00
     .,0.20223940D+03,0.207D+03,0.900D+02,0.20143000D+01,0.00000000D+00
     .,0.19881690D+03,0.207D+03,0.910D+02,0.20143000D+01,0.00000000D+00
     .,0.19268400D+03,0.207D+03,0.920D+02,0.20143000D+01,0.00000000D+00
     .,0.19532220D+03,0.207D+03,0.930D+02,0.20143000D+01,0.00000000D+00
     .,0.18964690D+03,0.207D+03,0.940D+02,0.20143000D+01,0.00000000D+00
     .,0.11821400D+02,0.207D+03,0.101D+03,0.20143000D+01,0.00000000D+00
     .,0.35019400D+02,0.207D+03,0.103D+03,0.20143000D+01,0.98650000D+00
     .,0.45316400D+02,0.207D+03,0.104D+03,0.20143000D+01,0.98080000D+00
     .,0.36606300D+02,0.207D+03,0.105D+03,0.20143000D+01,0.97060000D+00
     .,0.28693800D+02,0.207D+03,0.106D+03,0.20143000D+01,0.98680000D+00
     .,0.20850100D+02,0.207D+03,0.107D+03,0.20143000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters(  85601:  85700)=(/
     . 0.15763100D+02,0.207D+03,0.108D+03,0.20143000D+01,0.99250000D+00
     .,0.11357100D+02,0.207D+03,0.109D+03,0.20143000D+01,0.99820000D+00
     .,0.50867200D+02,0.207D+03,0.111D+03,0.20143000D+01,0.96840000D+00
     .,0.78176000D+02,0.207D+03,0.112D+03,0.20143000D+01,0.96280000D+00
     .,0.81202600D+02,0.207D+03,0.113D+03,0.20143000D+01,0.96480000D+00
     .,0.68050400D+02,0.207D+03,0.114D+03,0.20143000D+01,0.95070000D+00
     .,0.57663200D+02,0.207D+03,0.115D+03,0.20143000D+01,0.99470000D+00
     .,0.50029800D+02,0.207D+03,0.116D+03,0.20143000D+01,0.99480000D+00
     .,0.42036700D+02,0.207D+03,0.117D+03,0.20143000D+01,0.99720000D+00
     .,0.72681800D+02,0.207D+03,0.119D+03,0.20143000D+01,0.97670000D+00
     .,0.12958410D+03,0.207D+03,0.120D+03,0.20143000D+01,0.98310000D+00
     .,0.74558700D+02,0.207D+03,0.121D+03,0.20143000D+01,0.18627000D+01
     .,0.72182800D+02,0.207D+03,0.122D+03,0.20143000D+01,0.18299000D+01
     .,0.70734700D+02,0.207D+03,0.123D+03,0.20143000D+01,0.19138000D+01
     .,0.69847100D+02,0.207D+03,0.124D+03,0.20143000D+01,0.18269000D+01
     .,0.65341500D+02,0.207D+03,0.125D+03,0.20143000D+01,0.16406000D+01
     .,0.60892000D+02,0.207D+03,0.126D+03,0.20143000D+01,0.16483000D+01
     .,0.58161100D+02,0.207D+03,0.127D+03,0.20143000D+01,0.17149000D+01
     .,0.56786800D+02,0.207D+03,0.128D+03,0.20143000D+01,0.17937000D+01
     .,0.55378900D+02,0.207D+03,0.129D+03,0.20143000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters(  85701:  85800)=(/
     . 0.53207000D+02,0.207D+03,0.130D+03,0.20143000D+01,0.19419000D+01
     .,0.82040200D+02,0.207D+03,0.131D+03,0.20143000D+01,0.96010000D+00
     .,0.74362700D+02,0.207D+03,0.132D+03,0.20143000D+01,0.94340000D+00
     .,0.68347700D+02,0.207D+03,0.133D+03,0.20143000D+01,0.98890000D+00
     .,0.63607400D+02,0.207D+03,0.134D+03,0.20143000D+01,0.99010000D+00
     .,0.57257800D+02,0.207D+03,0.135D+03,0.20143000D+01,0.99740000D+00
     .,0.87544700D+02,0.207D+03,0.137D+03,0.20143000D+01,0.97380000D+00
     .,0.15768360D+03,0.207D+03,0.138D+03,0.20143000D+01,0.98010000D+00
     .,0.12634700D+03,0.207D+03,0.139D+03,0.20143000D+01,0.19153000D+01
     .,0.98716500D+02,0.207D+03,0.140D+03,0.20143000D+01,0.19355000D+01
     .,0.99662500D+02,0.207D+03,0.141D+03,0.20143000D+01,0.19545000D+01
     .,0.93743400D+02,0.207D+03,0.142D+03,0.20143000D+01,0.19420000D+01
     .,0.10285060D+03,0.207D+03,0.143D+03,0.20143000D+01,0.16682000D+01
     .,0.83274400D+02,0.207D+03,0.144D+03,0.20143000D+01,0.18584000D+01
     .,0.78197600D+02,0.207D+03,0.145D+03,0.20143000D+01,0.19003000D+01
     .,0.72996500D+02,0.207D+03,0.146D+03,0.20143000D+01,0.18630000D+01
     .,0.70450900D+02,0.207D+03,0.147D+03,0.20143000D+01,0.96790000D+00
     .,0.70442000D+02,0.207D+03,0.148D+03,0.20143000D+01,0.19539000D+01
     .,0.10489720D+03,0.207D+03,0.149D+03,0.20143000D+01,0.96330000D+00
     .,0.97282600D+02,0.207D+03,0.150D+03,0.20143000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters(  85801:  85900)=(/
     . 0.92826200D+02,0.207D+03,0.151D+03,0.20143000D+01,0.97490000D+00
     .,0.89058200D+02,0.207D+03,0.152D+03,0.20143000D+01,0.98110000D+00
     .,0.82771300D+02,0.207D+03,0.153D+03,0.20143000D+01,0.99680000D+00
     .,0.10537260D+03,0.207D+03,0.155D+03,0.20143000D+01,0.99090000D+00
     .,0.20323960D+03,0.207D+03,0.156D+03,0.20143000D+01,0.97970000D+00
     .,0.15949680D+03,0.207D+03,0.157D+03,0.20143000D+01,0.19373000D+01
     .,0.10811590D+03,0.207D+03,0.159D+03,0.20143000D+01,0.29425000D+01
     .,0.10591500D+03,0.207D+03,0.160D+03,0.20143000D+01,0.29455000D+01
     .,0.10271500D+03,0.207D+03,0.161D+03,0.20143000D+01,0.29413000D+01
     .,0.10283980D+03,0.207D+03,0.162D+03,0.20143000D+01,0.29300000D+01
     .,0.98062800D+02,0.207D+03,0.163D+03,0.20143000D+01,0.18286000D+01
     .,0.10326480D+03,0.207D+03,0.164D+03,0.20143000D+01,0.28732000D+01
     .,0.97359100D+02,0.207D+03,0.165D+03,0.20143000D+01,0.29086000D+01
     .,0.98444500D+02,0.207D+03,0.166D+03,0.20143000D+01,0.28965000D+01
     .,0.92693900D+02,0.207D+03,0.167D+03,0.20143000D+01,0.29242000D+01
     .,0.90162700D+02,0.207D+03,0.168D+03,0.20143000D+01,0.29282000D+01
     .,0.89477400D+02,0.207D+03,0.169D+03,0.20143000D+01,0.29246000D+01
     .,0.93380800D+02,0.207D+03,0.170D+03,0.20143000D+01,0.28482000D+01
     .,0.86620200D+02,0.207D+03,0.171D+03,0.20143000D+01,0.29219000D+01
     .,0.11247170D+03,0.207D+03,0.172D+03,0.20143000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters(  85901:  86000)=(/
     . 0.10607460D+03,0.207D+03,0.173D+03,0.20143000D+01,0.19459000D+01
     .,0.98419900D+02,0.207D+03,0.174D+03,0.20143000D+01,0.19292000D+01
     .,0.98272000D+02,0.207D+03,0.175D+03,0.20143000D+01,0.18104000D+01
     .,0.89250800D+02,0.207D+03,0.176D+03,0.20143000D+01,0.18858000D+01
     .,0.84579000D+02,0.207D+03,0.177D+03,0.20143000D+01,0.18648000D+01
     .,0.81163500D+02,0.207D+03,0.178D+03,0.20143000D+01,0.19188000D+01
     .,0.77711500D+02,0.207D+03,0.179D+03,0.20143000D+01,0.98460000D+00
     .,0.75948200D+02,0.207D+03,0.180D+03,0.20143000D+01,0.19896000D+01
     .,0.11375630D+03,0.207D+03,0.181D+03,0.20143000D+01,0.92670000D+00
     .,0.10614180D+03,0.207D+03,0.182D+03,0.20143000D+01,0.93830000D+00
     .,0.10427680D+03,0.207D+03,0.183D+03,0.20143000D+01,0.98200000D+00
     .,0.10247400D+03,0.207D+03,0.184D+03,0.20143000D+01,0.98150000D+00
     .,0.97157900D+02,0.207D+03,0.185D+03,0.20143000D+01,0.99540000D+00
     .,0.11880190D+03,0.207D+03,0.187D+03,0.20143000D+01,0.97050000D+00
     .,0.20507880D+03,0.207D+03,0.188D+03,0.20143000D+01,0.96620000D+00
     .,0.12774120D+03,0.207D+03,0.189D+03,0.20143000D+01,0.29070000D+01
     .,0.14466290D+03,0.207D+03,0.190D+03,0.20143000D+01,0.28844000D+01
     .,0.13073320D+03,0.207D+03,0.191D+03,0.20143000D+01,0.28738000D+01
     .,0.11732470D+03,0.207D+03,0.192D+03,0.20143000D+01,0.28878000D+01
     .,0.11335810D+03,0.207D+03,0.193D+03,0.20143000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters(  86001:  86100)=(/
     . 0.13059750D+03,0.207D+03,0.194D+03,0.20143000D+01,0.19209000D+01
     .,0.31240700D+02,0.207D+03,0.204D+03,0.20143000D+01,0.19697000D+01
     .,0.31222100D+02,0.207D+03,0.205D+03,0.20143000D+01,0.19441000D+01
     .,0.23896500D+02,0.207D+03,0.206D+03,0.20143000D+01,0.19985000D+01
     .,0.19676800D+02,0.207D+03,0.207D+03,0.20143000D+01,0.20143000D+01
     .,0.53717000D+01,0.208D+03,0.100D+01,0.19887000D+01,0.91180000D+00
     .,0.40179000D+01,0.208D+03,0.200D+01,0.19887000D+01,0.00000000D+00
     .,0.58670300D+02,0.208D+03,0.300D+01,0.19887000D+01,0.00000000D+00
     .,0.38702700D+02,0.208D+03,0.400D+01,0.19887000D+01,0.00000000D+00
     .,0.28771300D+02,0.208D+03,0.500D+01,0.19887000D+01,0.00000000D+00
     .,0.21142800D+02,0.208D+03,0.600D+01,0.19887000D+01,0.00000000D+00
     .,0.15836400D+02,0.208D+03,0.700D+01,0.19887000D+01,0.00000000D+00
     .,0.12627700D+02,0.208D+03,0.800D+01,0.19887000D+01,0.00000000D+00
     .,0.10022200D+02,0.208D+03,0.900D+01,0.19887000D+01,0.00000000D+00
     .,0.80175000D+01,0.208D+03,0.100D+02,0.19887000D+01,0.00000000D+00
     .,0.71099900D+02,0.208D+03,0.110D+02,0.19887000D+01,0.00000000D+00
     .,0.60298300D+02,0.208D+03,0.120D+02,0.19887000D+01,0.00000000D+00
     .,0.58195100D+02,0.208D+03,0.130D+02,0.19887000D+01,0.00000000D+00
     .,0.48906600D+02,0.208D+03,0.140D+02,0.19887000D+01,0.00000000D+00
     .,0.40516700D+02,0.208D+03,0.150D+02,0.19887000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  86101:  86200)=(/
     . 0.35137700D+02,0.208D+03,0.160D+02,0.19887000D+01,0.00000000D+00
     .,0.29991800D+02,0.208D+03,0.170D+02,0.19887000D+01,0.00000000D+00
     .,0.25551400D+02,0.208D+03,0.180D+02,0.19887000D+01,0.00000000D+00
     .,0.11670690D+03,0.208D+03,0.190D+02,0.19887000D+01,0.00000000D+00
     .,0.10271260D+03,0.208D+03,0.200D+02,0.19887000D+01,0.00000000D+00
     .,0.86336500D+02,0.208D+03,0.210D+02,0.19887000D+01,0.00000000D+00
     .,0.85221900D+02,0.208D+03,0.220D+02,0.19887000D+01,0.00000000D+00
     .,0.79000300D+02,0.208D+03,0.230D+02,0.19887000D+01,0.00000000D+00
     .,0.63186700D+02,0.208D+03,0.240D+02,0.19887000D+01,0.00000000D+00
     .,0.69259800D+02,0.208D+03,0.250D+02,0.19887000D+01,0.00000000D+00
     .,0.55335600D+02,0.208D+03,0.260D+02,0.19887000D+01,0.00000000D+00
     .,0.59268800D+02,0.208D+03,0.270D+02,0.19887000D+01,0.00000000D+00
     .,0.60257500D+02,0.208D+03,0.280D+02,0.19887000D+01,0.00000000D+00
     .,0.47058500D+02,0.208D+03,0.290D+02,0.19887000D+01,0.00000000D+00
     .,0.49389700D+02,0.208D+03,0.300D+02,0.19887000D+01,0.00000000D+00
     .,0.57401600D+02,0.208D+03,0.310D+02,0.19887000D+01,0.00000000D+00
     .,0.53011000D+02,0.208D+03,0.320D+02,0.19887000D+01,0.00000000D+00
     .,0.47420200D+02,0.208D+03,0.330D+02,0.19887000D+01,0.00000000D+00
     .,0.43981900D+02,0.208D+03,0.340D+02,0.19887000D+01,0.00000000D+00
     .,0.39882100D+02,0.208D+03,0.350D+02,0.19887000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  86201:  86300)=(/
     . 0.35896100D+02,0.208D+03,0.360D+02,0.19887000D+01,0.00000000D+00
     .,0.13248790D+03,0.208D+03,0.370D+02,0.19887000D+01,0.00000000D+00
     .,0.12269280D+03,0.208D+03,0.380D+02,0.19887000D+01,0.00000000D+00
     .,0.11116060D+03,0.208D+03,0.390D+02,0.19887000D+01,0.00000000D+00
     .,0.10228360D+03,0.208D+03,0.400D+02,0.19887000D+01,0.00000000D+00
     .,0.94928100D+02,0.208D+03,0.410D+02,0.19887000D+01,0.00000000D+00
     .,0.76023900D+02,0.208D+03,0.420D+02,0.19887000D+01,0.00000000D+00
     .,0.83640900D+02,0.208D+03,0.430D+02,0.19887000D+01,0.00000000D+00
     .,0.66302500D+02,0.208D+03,0.440D+02,0.19887000D+01,0.00000000D+00
     .,0.71807100D+02,0.208D+03,0.450D+02,0.19887000D+01,0.00000000D+00
     .,0.67335400D+02,0.208D+03,0.460D+02,0.19887000D+01,0.00000000D+00
     .,0.56751100D+02,0.208D+03,0.470D+02,0.19887000D+01,0.00000000D+00
     .,0.60233400D+02,0.208D+03,0.480D+02,0.19887000D+01,0.00000000D+00
     .,0.72857100D+02,0.208D+03,0.490D+02,0.19887000D+01,0.00000000D+00
     .,0.69604600D+02,0.208D+03,0.500D+02,0.19887000D+01,0.00000000D+00
     .,0.64429100D+02,0.208D+03,0.510D+02,0.19887000D+01,0.00000000D+00
     .,0.61315900D+02,0.208D+03,0.520D+02,0.19887000D+01,0.00000000D+00
     .,0.57073800D+02,0.208D+03,0.530D+02,0.19887000D+01,0.00000000D+00
     .,0.52826900D+02,0.208D+03,0.540D+02,0.19887000D+01,0.00000000D+00
     .,0.16220010D+03,0.208D+03,0.550D+02,0.19887000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  86301:  86400)=(/
     . 0.15554370D+03,0.208D+03,0.560D+02,0.19887000D+01,0.00000000D+00
     .,0.14109330D+03,0.208D+03,0.570D+02,0.19887000D+01,0.00000000D+00
     .,0.75991000D+02,0.208D+03,0.580D+02,0.19887000D+01,0.27991000D+01
     .,0.13974720D+03,0.208D+03,0.590D+02,0.19887000D+01,0.00000000D+00
     .,0.13480190D+03,0.208D+03,0.600D+02,0.19887000D+01,0.00000000D+00
     .,0.13157850D+03,0.208D+03,0.610D+02,0.19887000D+01,0.00000000D+00
     .,0.12858460D+03,0.208D+03,0.620D+02,0.19887000D+01,0.00000000D+00
     .,0.12593290D+03,0.208D+03,0.630D+02,0.19887000D+01,0.00000000D+00
     .,0.10360070D+03,0.208D+03,0.640D+02,0.19887000D+01,0.00000000D+00
     .,0.11142770D+03,0.208D+03,0.650D+02,0.19887000D+01,0.00000000D+00
     .,0.10818200D+03,0.208D+03,0.660D+02,0.19887000D+01,0.00000000D+00
     .,0.11438200D+03,0.208D+03,0.670D+02,0.19887000D+01,0.00000000D+00
     .,0.11199780D+03,0.208D+03,0.680D+02,0.19887000D+01,0.00000000D+00
     .,0.10990310D+03,0.208D+03,0.690D+02,0.19887000D+01,0.00000000D+00
     .,0.10838260D+03,0.208D+03,0.700D+02,0.19887000D+01,0.00000000D+00
     .,0.94143100D+02,0.208D+03,0.710D+02,0.19887000D+01,0.00000000D+00
     .,0.95450600D+02,0.208D+03,0.720D+02,0.19887000D+01,0.00000000D+00
     .,0.89314200D+02,0.208D+03,0.730D+02,0.19887000D+01,0.00000000D+00
     .,0.77589500D+02,0.208D+03,0.740D+02,0.19887000D+01,0.00000000D+00
     .,0.79439800D+02,0.208D+03,0.750D+02,0.19887000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  86401:  86500)=(/
     . 0.73642700D+02,0.208D+03,0.760D+02,0.19887000D+01,0.00000000D+00
     .,0.68748100D+02,0.208D+03,0.770D+02,0.19887000D+01,0.00000000D+00
     .,0.58749700D+02,0.208D+03,0.780D+02,0.19887000D+01,0.00000000D+00
     .,0.55502000D+02,0.208D+03,0.790D+02,0.19887000D+01,0.00000000D+00
     .,0.57232800D+02,0.208D+03,0.800D+02,0.19887000D+01,0.00000000D+00
     .,0.76523500D+02,0.208D+03,0.810D+02,0.19887000D+01,0.00000000D+00
     .,0.76401300D+02,0.208D+03,0.820D+02,0.19887000D+01,0.00000000D+00
     .,0.72435200D+02,0.208D+03,0.830D+02,0.19887000D+01,0.00000000D+00
     .,0.70476900D+02,0.208D+03,0.840D+02,0.19887000D+01,0.00000000D+00
     .,0.66750400D+02,0.208D+03,0.850D+02,0.19887000D+01,0.00000000D+00
     .,0.62757800D+02,0.208D+03,0.860D+02,0.19887000D+01,0.00000000D+00
     .,0.15736950D+03,0.208D+03,0.870D+02,0.19887000D+01,0.00000000D+00
     .,0.15673170D+03,0.208D+03,0.880D+02,0.19887000D+01,0.00000000D+00
     .,0.14266360D+03,0.208D+03,0.890D+02,0.19887000D+01,0.00000000D+00
     .,0.13347620D+03,0.208D+03,0.900D+02,0.19887000D+01,0.00000000D+00
     .,0.13079990D+03,0.208D+03,0.910D+02,0.19887000D+01,0.00000000D+00
     .,0.12685500D+03,0.208D+03,0.920D+02,0.19887000D+01,0.00000000D+00
     .,0.12772950D+03,0.208D+03,0.930D+02,0.19887000D+01,0.00000000D+00
     .,0.12416310D+03,0.208D+03,0.940D+02,0.19887000D+01,0.00000000D+00
     .,0.80848000D+01,0.208D+03,0.101D+03,0.19887000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  86501:  86600)=(/
     . 0.22893000D+02,0.208D+03,0.103D+03,0.19887000D+01,0.98650000D+00
     .,0.29852300D+02,0.208D+03,0.104D+03,0.19887000D+01,0.98080000D+00
     .,0.24818500D+02,0.208D+03,0.105D+03,0.19887000D+01,0.97060000D+00
     .,0.19909000D+02,0.208D+03,0.106D+03,0.19887000D+01,0.98680000D+00
     .,0.14860000D+02,0.208D+03,0.107D+03,0.19887000D+01,0.99440000D+00
     .,0.11500900D+02,0.208D+03,0.108D+03,0.19887000D+01,0.99250000D+00
     .,0.85397000D+01,0.208D+03,0.109D+03,0.19887000D+01,0.99820000D+00
     .,0.33263600D+02,0.208D+03,0.111D+03,0.19887000D+01,0.96840000D+00
     .,0.50866900D+02,0.208D+03,0.112D+03,0.19887000D+01,0.96280000D+00
     .,0.53436500D+02,0.208D+03,0.113D+03,0.19887000D+01,0.96480000D+00
     .,0.45727300D+02,0.208D+03,0.114D+03,0.19887000D+01,0.95070000D+00
     .,0.39461700D+02,0.208D+03,0.115D+03,0.19887000D+01,0.99470000D+00
     .,0.34751000D+02,0.208D+03,0.116D+03,0.19887000D+01,0.99480000D+00
     .,0.29682200D+02,0.208D+03,0.117D+03,0.19887000D+01,0.99720000D+00
     .,0.48638000D+02,0.208D+03,0.119D+03,0.19887000D+01,0.97670000D+00
     .,0.83727900D+02,0.208D+03,0.120D+03,0.19887000D+01,0.98310000D+00
     .,0.50337300D+02,0.208D+03,0.121D+03,0.19887000D+01,0.18627000D+01
     .,0.48839600D+02,0.208D+03,0.122D+03,0.19887000D+01,0.18299000D+01
     .,0.47881500D+02,0.208D+03,0.123D+03,0.19887000D+01,0.19138000D+01
     .,0.47229700D+02,0.208D+03,0.124D+03,0.19887000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters(  86601:  86700)=(/
     . 0.44488800D+02,0.208D+03,0.125D+03,0.19887000D+01,0.16406000D+01
     .,0.41627000D+02,0.208D+03,0.126D+03,0.19887000D+01,0.16483000D+01
     .,0.39813100D+02,0.208D+03,0.127D+03,0.19887000D+01,0.17149000D+01
     .,0.38859700D+02,0.208D+03,0.128D+03,0.19887000D+01,0.17937000D+01
     .,0.37708300D+02,0.208D+03,0.129D+03,0.19887000D+01,0.95760000D+00
     .,0.36576400D+02,0.208D+03,0.130D+03,0.19887000D+01,0.19419000D+01
     .,0.54596400D+02,0.208D+03,0.131D+03,0.19887000D+01,0.96010000D+00
     .,0.50234300D+02,0.208D+03,0.132D+03,0.19887000D+01,0.94340000D+00
     .,0.46775300D+02,0.208D+03,0.133D+03,0.19887000D+01,0.98890000D+00
     .,0.43993100D+02,0.208D+03,0.134D+03,0.19887000D+01,0.99010000D+00
     .,0.40100200D+02,0.208D+03,0.135D+03,0.19887000D+01,0.99740000D+00
     .,0.58901500D+02,0.208D+03,0.137D+03,0.19887000D+01,0.97380000D+00
     .,0.10201160D+03,0.208D+03,0.138D+03,0.19887000D+01,0.98010000D+00
     .,0.83510800D+02,0.208D+03,0.139D+03,0.19887000D+01,0.19153000D+01
     .,0.66749800D+02,0.208D+03,0.140D+03,0.19887000D+01,0.19355000D+01
     .,0.67412800D+02,0.208D+03,0.141D+03,0.19887000D+01,0.19545000D+01
     .,0.63740200D+02,0.208D+03,0.142D+03,0.19887000D+01,0.19420000D+01
     .,0.69283800D+02,0.208D+03,0.143D+03,0.19887000D+01,0.16682000D+01
     .,0.57192800D+02,0.208D+03,0.144D+03,0.19887000D+01,0.18584000D+01
     .,0.53867000D+02,0.208D+03,0.145D+03,0.19887000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters(  86701:  86800)=(/
     . 0.50470900D+02,0.208D+03,0.146D+03,0.19887000D+01,0.18630000D+01
     .,0.48691200D+02,0.208D+03,0.147D+03,0.19887000D+01,0.96790000D+00
     .,0.48849700D+02,0.208D+03,0.148D+03,0.19887000D+01,0.19539000D+01
     .,0.70351100D+02,0.208D+03,0.149D+03,0.19887000D+01,0.96330000D+00
     .,0.65963500D+02,0.208D+03,0.150D+03,0.19887000D+01,0.95140000D+00
     .,0.63497200D+02,0.208D+03,0.151D+03,0.19887000D+01,0.97490000D+00
     .,0.61358500D+02,0.208D+03,0.152D+03,0.19887000D+01,0.98110000D+00
     .,0.57565500D+02,0.208D+03,0.153D+03,0.19887000D+01,0.99680000D+00
     .,0.71326900D+02,0.208D+03,0.155D+03,0.19887000D+01,0.99090000D+00
     .,0.13126330D+03,0.208D+03,0.156D+03,0.19887000D+01,0.97970000D+00
     .,0.10532360D+03,0.208D+03,0.157D+03,0.19887000D+01,0.19373000D+01
     .,0.73903200D+02,0.208D+03,0.159D+03,0.19887000D+01,0.29425000D+01
     .,0.72415600D+02,0.208D+03,0.160D+03,0.19887000D+01,0.29455000D+01
     .,0.70289800D+02,0.208D+03,0.161D+03,0.19887000D+01,0.29413000D+01
     .,0.70251100D+02,0.208D+03,0.162D+03,0.19887000D+01,0.29300000D+01
     .,0.66716600D+02,0.208D+03,0.163D+03,0.19887000D+01,0.18286000D+01
     .,0.70433100D+02,0.208D+03,0.164D+03,0.19887000D+01,0.28732000D+01
     .,0.66555900D+02,0.208D+03,0.165D+03,0.19887000D+01,0.29086000D+01
     .,0.67106000D+02,0.208D+03,0.166D+03,0.19887000D+01,0.28965000D+01
     .,0.63452700D+02,0.208D+03,0.167D+03,0.19887000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters(  86801:  86900)=(/
     . 0.61756800D+02,0.208D+03,0.168D+03,0.19887000D+01,0.29282000D+01
     .,0.61245400D+02,0.208D+03,0.169D+03,0.19887000D+01,0.29246000D+01
     .,0.63639600D+02,0.208D+03,0.170D+03,0.19887000D+01,0.28482000D+01
     .,0.59322400D+02,0.208D+03,0.171D+03,0.19887000D+01,0.29219000D+01
     .,0.75441200D+02,0.208D+03,0.172D+03,0.19887000D+01,0.19254000D+01
     .,0.71752400D+02,0.208D+03,0.173D+03,0.19887000D+01,0.19459000D+01
     .,0.67168700D+02,0.208D+03,0.174D+03,0.19887000D+01,0.19292000D+01
     .,0.66668200D+02,0.208D+03,0.175D+03,0.19887000D+01,0.18104000D+01
     .,0.61667600D+02,0.208D+03,0.176D+03,0.19887000D+01,0.18858000D+01
     .,0.58716200D+02,0.208D+03,0.177D+03,0.19887000D+01,0.18648000D+01
     .,0.56528500D+02,0.208D+03,0.178D+03,0.19887000D+01,0.19188000D+01
     .,0.54235200D+02,0.208D+03,0.179D+03,0.19887000D+01,0.98460000D+00
     .,0.53255600D+02,0.208D+03,0.180D+03,0.19887000D+01,0.19896000D+01
     .,0.76842400D+02,0.208D+03,0.181D+03,0.19887000D+01,0.92670000D+00
     .,0.72435300D+02,0.208D+03,0.182D+03,0.19887000D+01,0.93830000D+00
     .,0.71560300D+02,0.208D+03,0.183D+03,0.19887000D+01,0.98200000D+00
     .,0.70670800D+02,0.208D+03,0.184D+03,0.19887000D+01,0.98150000D+00
     .,0.67531900D+02,0.208D+03,0.185D+03,0.19887000D+01,0.99540000D+00
     .,0.80432600D+02,0.208D+03,0.187D+03,0.19887000D+01,0.97050000D+00
     .,0.13328520D+03,0.208D+03,0.188D+03,0.19887000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters(  86901:  87000)=(/
     . 0.87210800D+02,0.208D+03,0.189D+03,0.19887000D+01,0.29070000D+01
     .,0.97994500D+02,0.208D+03,0.190D+03,0.19887000D+01,0.28844000D+01
     .,0.89142100D+02,0.208D+03,0.191D+03,0.19887000D+01,0.28738000D+01
     .,0.80572400D+02,0.208D+03,0.192D+03,0.19887000D+01,0.28878000D+01
     .,0.78019000D+02,0.208D+03,0.193D+03,0.19887000D+01,0.29095000D+01
     .,0.88176800D+02,0.208D+03,0.194D+03,0.19887000D+01,0.19209000D+01
     .,0.21128200D+02,0.208D+03,0.204D+03,0.19887000D+01,0.19697000D+01
     .,0.21364800D+02,0.208D+03,0.205D+03,0.19887000D+01,0.19441000D+01
     .,0.16785500D+02,0.208D+03,0.206D+03,0.19887000D+01,0.19985000D+01
     .,0.14080700D+02,0.208D+03,0.207D+03,0.19887000D+01,0.20143000D+01
     .,0.10370800D+02,0.208D+03,0.208D+03,0.19887000D+01,0.19887000D+01
     .,0.21837000D+02,0.212D+03,0.100D+01,0.19496000D+01,0.91180000D+00
     .,0.13849600D+02,0.212D+03,0.200D+01,0.19496000D+01,0.00000000D+00
     .,0.37081900D+03,0.212D+03,0.300D+01,0.19496000D+01,0.00000000D+00
     .,0.20867690D+03,0.212D+03,0.400D+01,0.19496000D+01,0.00000000D+00
     .,0.13699320D+03,0.212D+03,0.500D+01,0.19496000D+01,0.00000000D+00
     .,0.90330500D+02,0.212D+03,0.600D+01,0.19496000D+01,0.00000000D+00
     .,0.61837200D+02,0.212D+03,0.700D+01,0.19496000D+01,0.00000000D+00
     .,0.46034700D+02,0.212D+03,0.800D+01,0.19496000D+01,0.00000000D+00
     .,0.34331400D+02,0.212D+03,0.900D+01,0.19496000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  87001:  87100)=(/
     . 0.26053300D+02,0.212D+03,0.100D+02,0.19496000D+01,0.00000000D+00
     .,0.44240190D+03,0.212D+03,0.110D+02,0.19496000D+01,0.00000000D+00
     .,0.33424930D+03,0.212D+03,0.120D+02,0.19496000D+01,0.00000000D+00
     .,0.30473370D+03,0.212D+03,0.130D+02,0.19496000D+01,0.00000000D+00
     .,0.23613880D+03,0.212D+03,0.140D+02,0.19496000D+01,0.00000000D+00
     .,0.18098430D+03,0.212D+03,0.150D+02,0.19496000D+01,0.00000000D+00
     .,0.14821300D+03,0.212D+03,0.160D+02,0.19496000D+01,0.00000000D+00
     .,0.11939110D+03,0.212D+03,0.170D+02,0.19496000D+01,0.00000000D+00
     .,0.96381300D+02,0.212D+03,0.180D+02,0.19496000D+01,0.00000000D+00
     .,0.72363460D+03,0.212D+03,0.190D+02,0.19496000D+01,0.00000000D+00
     .,0.59087370D+03,0.212D+03,0.200D+02,0.19496000D+01,0.00000000D+00
     .,0.48646530D+03,0.212D+03,0.210D+02,0.19496000D+01,0.00000000D+00
     .,0.46745060D+03,0.212D+03,0.220D+02,0.19496000D+01,0.00000000D+00
     .,0.42688150D+03,0.212D+03,0.230D+02,0.19496000D+01,0.00000000D+00
     .,0.33501180D+03,0.212D+03,0.240D+02,0.19496000D+01,0.00000000D+00
     .,0.36600240D+03,0.212D+03,0.250D+02,0.19496000D+01,0.00000000D+00
     .,0.28599690D+03,0.212D+03,0.260D+02,0.19496000D+01,0.00000000D+00
     .,0.30245180D+03,0.212D+03,0.270D+02,0.19496000D+01,0.00000000D+00
     .,0.31258620D+03,0.212D+03,0.280D+02,0.19496000D+01,0.00000000D+00
     .,0.23853700D+03,0.212D+03,0.290D+02,0.19496000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  87101:  87200)=(/
     . 0.24356630D+03,0.212D+03,0.300D+02,0.19496000D+01,0.00000000D+00
     .,0.28974250D+03,0.212D+03,0.310D+02,0.19496000D+01,0.00000000D+00
     .,0.25239640D+03,0.212D+03,0.320D+02,0.19496000D+01,0.00000000D+00
     .,0.21233920D+03,0.212D+03,0.330D+02,0.19496000D+01,0.00000000D+00
     .,0.18862140D+03,0.212D+03,0.340D+02,0.19496000D+01,0.00000000D+00
     .,0.16322210D+03,0.212D+03,0.350D+02,0.19496000D+01,0.00000000D+00
     .,0.14036050D+03,0.212D+03,0.360D+02,0.19496000D+01,0.00000000D+00
     .,0.80885370D+03,0.212D+03,0.370D+02,0.19496000D+01,0.00000000D+00
     .,0.70339060D+03,0.212D+03,0.380D+02,0.19496000D+01,0.00000000D+00
     .,0.61169610D+03,0.212D+03,0.390D+02,0.19496000D+01,0.00000000D+00
     .,0.54679350D+03,0.212D+03,0.400D+02,0.19496000D+01,0.00000000D+00
     .,0.49648070D+03,0.212D+03,0.410D+02,0.19496000D+01,0.00000000D+00
     .,0.37976260D+03,0.212D+03,0.420D+02,0.19496000D+01,0.00000000D+00
     .,0.42526560D+03,0.212D+03,0.430D+02,0.19496000D+01,0.00000000D+00
     .,0.32066780D+03,0.212D+03,0.440D+02,0.19496000D+01,0.00000000D+00
     .,0.35143020D+03,0.212D+03,0.450D+02,0.19496000D+01,0.00000000D+00
     .,0.32495510D+03,0.212D+03,0.460D+02,0.19496000D+01,0.00000000D+00
     .,0.27016330D+03,0.212D+03,0.470D+02,0.19496000D+01,0.00000000D+00
     .,0.28521610D+03,0.212D+03,0.480D+02,0.19496000D+01,0.00000000D+00
     .,0.36138350D+03,0.212D+03,0.490D+02,0.19496000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  87201:  87300)=(/
     . 0.33128280D+03,0.212D+03,0.500D+02,0.19496000D+01,0.00000000D+00
     .,0.29202460D+03,0.212D+03,0.510D+02,0.19496000D+01,0.00000000D+00
     .,0.26885950D+03,0.212D+03,0.520D+02,0.19496000D+01,0.00000000D+00
     .,0.24089430D+03,0.212D+03,0.530D+02,0.19496000D+01,0.00000000D+00
     .,0.21454790D+03,0.212D+03,0.540D+02,0.19496000D+01,0.00000000D+00
     .,0.98395840D+03,0.212D+03,0.550D+02,0.19496000D+01,0.00000000D+00
     .,0.89740290D+03,0.212D+03,0.560D+02,0.19496000D+01,0.00000000D+00
     .,0.78313020D+03,0.212D+03,0.570D+02,0.19496000D+01,0.00000000D+00
     .,0.34513820D+03,0.212D+03,0.580D+02,0.19496000D+01,0.27991000D+01
     .,0.79290630D+03,0.212D+03,0.590D+02,0.19496000D+01,0.00000000D+00
     .,0.76073520D+03,0.212D+03,0.600D+02,0.19496000D+01,0.00000000D+00
     .,0.74148810D+03,0.212D+03,0.610D+02,0.19496000D+01,0.00000000D+00
     .,0.72382090D+03,0.212D+03,0.620D+02,0.19496000D+01,0.00000000D+00
     .,0.70814950D+03,0.212D+03,0.630D+02,0.19496000D+01,0.00000000D+00
     .,0.55111930D+03,0.212D+03,0.640D+02,0.19496000D+01,0.00000000D+00
     .,0.62646370D+03,0.212D+03,0.650D+02,0.19496000D+01,0.00000000D+00
     .,0.60329280D+03,0.212D+03,0.660D+02,0.19496000D+01,0.00000000D+00
     .,0.63781980D+03,0.212D+03,0.670D+02,0.19496000D+01,0.00000000D+00
     .,0.62424880D+03,0.212D+03,0.680D+02,0.19496000D+01,0.00000000D+00
     .,0.61193920D+03,0.212D+03,0.690D+02,0.19496000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  87301:  87400)=(/
     . 0.60508430D+03,0.212D+03,0.700D+02,0.19496000D+01,0.00000000D+00
     .,0.50623650D+03,0.212D+03,0.710D+02,0.19496000D+01,0.00000000D+00
     .,0.49422900D+03,0.212D+03,0.720D+02,0.19496000D+01,0.00000000D+00
     .,0.44819920D+03,0.212D+03,0.730D+02,0.19496000D+01,0.00000000D+00
     .,0.37559750D+03,0.212D+03,0.740D+02,0.19496000D+01,0.00000000D+00
     .,0.38147930D+03,0.212D+03,0.750D+02,0.19496000D+01,0.00000000D+00
     .,0.34361070D+03,0.212D+03,0.760D+02,0.19496000D+01,0.00000000D+00
     .,0.31299940D+03,0.212D+03,0.770D+02,0.19496000D+01,0.00000000D+00
     .,0.25789210D+03,0.212D+03,0.780D+02,0.19496000D+01,0.00000000D+00
     .,0.24017810D+03,0.212D+03,0.790D+02,0.19496000D+01,0.00000000D+00
     .,0.24690090D+03,0.212D+03,0.800D+02,0.19496000D+01,0.00000000D+00
     .,0.36875940D+03,0.212D+03,0.810D+02,0.19496000D+01,0.00000000D+00
     .,0.35855060D+03,0.212D+03,0.820D+02,0.19496000D+01,0.00000000D+00
     .,0.32650440D+03,0.212D+03,0.830D+02,0.19496000D+01,0.00000000D+00
     .,0.30951770D+03,0.212D+03,0.840D+02,0.19496000D+01,0.00000000D+00
     .,0.28334810D+03,0.212D+03,0.850D+02,0.19496000D+01,0.00000000D+00
     .,0.25758240D+03,0.212D+03,0.860D+02,0.19496000D+01,0.00000000D+00
     .,0.92425730D+03,0.212D+03,0.870D+02,0.19496000D+01,0.00000000D+00
     .,0.88381110D+03,0.212D+03,0.880D+02,0.19496000D+01,0.00000000D+00
     .,0.77640740D+03,0.212D+03,0.890D+02,0.19496000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  87401:  87500)=(/
     . 0.69112710D+03,0.212D+03,0.900D+02,0.19496000D+01,0.00000000D+00
     .,0.68830150D+03,0.212D+03,0.910D+02,0.19496000D+01,0.00000000D+00
     .,0.66622690D+03,0.212D+03,0.920D+02,0.19496000D+01,0.00000000D+00
     .,0.68965180D+03,0.212D+03,0.930D+02,0.19496000D+01,0.00000000D+00
     .,0.66729490D+03,0.212D+03,0.940D+02,0.19496000D+01,0.00000000D+00
     .,0.35919000D+02,0.212D+03,0.101D+03,0.19496000D+01,0.00000000D+00
     .,0.12078080D+03,0.212D+03,0.103D+03,0.19496000D+01,0.98650000D+00
     .,0.15315750D+03,0.212D+03,0.104D+03,0.19496000D+01,0.98080000D+00
     .,0.11441900D+03,0.212D+03,0.105D+03,0.19496000D+01,0.97060000D+00
     .,0.84617800D+02,0.212D+03,0.106D+03,0.19496000D+01,0.98680000D+00
     .,0.57539800D+02,0.212D+03,0.107D+03,0.19496000D+01,0.99440000D+00
     .,0.41060500D+02,0.212D+03,0.108D+03,0.19496000D+01,0.99250000D+00
     .,0.27484100D+02,0.212D+03,0.109D+03,0.19496000D+01,0.99820000D+00
     .,0.17686830D+03,0.212D+03,0.111D+03,0.19496000D+01,0.96840000D+00
     .,0.27415900D+03,0.212D+03,0.112D+03,0.19496000D+01,0.96280000D+00
     .,0.27526090D+03,0.212D+03,0.113D+03,0.19496000D+01,0.96480000D+00
     .,0.21754710D+03,0.212D+03,0.114D+03,0.19496000D+01,0.95070000D+00
     .,0.17550060D+03,0.212D+03,0.115D+03,0.19496000D+01,0.99470000D+00
     .,0.14658490D+03,0.212D+03,0.116D+03,0.19496000D+01,0.99480000D+00
     .,0.11815670D+03,0.212D+03,0.117D+03,0.19496000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters(  87501:  87600)=(/
     . 0.24017250D+03,0.212D+03,0.119D+03,0.19496000D+01,0.97670000D+00
     .,0.47030590D+03,0.212D+03,0.120D+03,0.19496000D+01,0.98310000D+00
     .,0.23815400D+03,0.212D+03,0.121D+03,0.19496000D+01,0.18627000D+01
     .,0.22957540D+03,0.212D+03,0.122D+03,0.19496000D+01,0.18299000D+01
     .,0.22498220D+03,0.212D+03,0.123D+03,0.19496000D+01,0.19138000D+01
     .,0.22318550D+03,0.212D+03,0.124D+03,0.19496000D+01,0.18269000D+01
     .,0.20404460D+03,0.212D+03,0.125D+03,0.19496000D+01,0.16406000D+01
     .,0.18825250D+03,0.212D+03,0.126D+03,0.19496000D+01,0.16483000D+01
     .,0.17945530D+03,0.212D+03,0.127D+03,0.19496000D+01,0.17149000D+01
     .,0.17553430D+03,0.212D+03,0.128D+03,0.19496000D+01,0.17937000D+01
     .,0.17436190D+03,0.212D+03,0.129D+03,0.19496000D+01,0.95760000D+00
     .,0.16200320D+03,0.212D+03,0.130D+03,0.19496000D+01,0.19419000D+01
     .,0.27124200D+03,0.212D+03,0.131D+03,0.19496000D+01,0.96010000D+00
     .,0.23526700D+03,0.212D+03,0.132D+03,0.19496000D+01,0.94340000D+00
     .,0.20852360D+03,0.212D+03,0.133D+03,0.19496000D+01,0.98890000D+00
     .,0.18870250D+03,0.212D+03,0.134D+03,0.19496000D+01,0.99010000D+00
     .,0.16443830D+03,0.212D+03,0.135D+03,0.19496000D+01,0.99740000D+00
     .,0.28542190D+03,0.212D+03,0.137D+03,0.19496000D+01,0.97380000D+00
     .,0.57194480D+03,0.212D+03,0.138D+03,0.19496000D+01,0.98010000D+00
     .,0.43039400D+03,0.212D+03,0.139D+03,0.19496000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters(  87601:  87700)=(/
     . 0.31464020D+03,0.212D+03,0.140D+03,0.19496000D+01,0.19355000D+01
     .,0.31779230D+03,0.212D+03,0.141D+03,0.19496000D+01,0.19545000D+01
     .,0.29518160D+03,0.212D+03,0.142D+03,0.19496000D+01,0.19420000D+01
     .,0.33381660D+03,0.212D+03,0.143D+03,0.19496000D+01,0.16682000D+01
     .,0.25522890D+03,0.212D+03,0.144D+03,0.19496000D+01,0.18584000D+01
     .,0.23831870D+03,0.212D+03,0.145D+03,0.19496000D+01,0.19003000D+01
     .,0.22073750D+03,0.212D+03,0.146D+03,0.19496000D+01,0.18630000D+01
     .,0.21374770D+03,0.212D+03,0.147D+03,0.19496000D+01,0.96790000D+00
     .,0.21054980D+03,0.212D+03,0.148D+03,0.19496000D+01,0.19539000D+01
     .,0.34330980D+03,0.212D+03,0.149D+03,0.19496000D+01,0.96330000D+00
     .,0.30754750D+03,0.212D+03,0.150D+03,0.19496000D+01,0.95140000D+00
     .,0.28572510D+03,0.212D+03,0.151D+03,0.19496000D+01,0.97490000D+00
     .,0.26854180D+03,0.212D+03,0.152D+03,0.19496000D+01,0.98110000D+00
     .,0.24320970D+03,0.212D+03,0.153D+03,0.19496000D+01,0.99680000D+00
     .,0.33524300D+03,0.212D+03,0.155D+03,0.19496000D+01,0.99090000D+00
     .,0.74236730D+03,0.212D+03,0.156D+03,0.19496000D+01,0.97970000D+00
     .,0.54507520D+03,0.212D+03,0.157D+03,0.19496000D+01,0.19373000D+01
     .,0.33446520D+03,0.212D+03,0.159D+03,0.19496000D+01,0.29425000D+01
     .,0.32749910D+03,0.212D+03,0.160D+03,0.19496000D+01,0.29455000D+01
     .,0.31689690D+03,0.212D+03,0.161D+03,0.19496000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters(  87701:  87800)=(/
     . 0.31894850D+03,0.212D+03,0.162D+03,0.19496000D+01,0.29300000D+01
     .,0.30882190D+03,0.212D+03,0.163D+03,0.19496000D+01,0.18286000D+01
     .,0.32130770D+03,0.212D+03,0.164D+03,0.19496000D+01,0.28732000D+01
     .,0.30127990D+03,0.212D+03,0.165D+03,0.19496000D+01,0.29086000D+01
     .,0.30734770D+03,0.212D+03,0.166D+03,0.19496000D+01,0.28965000D+01
     .,0.28559620D+03,0.212D+03,0.167D+03,0.19496000D+01,0.29242000D+01
     .,0.27731030D+03,0.212D+03,0.168D+03,0.19496000D+01,0.29282000D+01
     .,0.27568110D+03,0.212D+03,0.169D+03,0.19496000D+01,0.29246000D+01
     .,0.29074100D+03,0.212D+03,0.170D+03,0.19496000D+01,0.28482000D+01
     .,0.26629260D+03,0.212D+03,0.171D+03,0.19496000D+01,0.29219000D+01
     .,0.36710790D+03,0.212D+03,0.172D+03,0.19496000D+01,0.19254000D+01
     .,0.33846150D+03,0.212D+03,0.173D+03,0.19496000D+01,0.19459000D+01
     .,0.30662140D+03,0.212D+03,0.174D+03,0.19496000D+01,0.19292000D+01
     .,0.31198680D+03,0.212D+03,0.175D+03,0.19496000D+01,0.18104000D+01
     .,0.26878310D+03,0.212D+03,0.176D+03,0.19496000D+01,0.18858000D+01
     .,0.25196650D+03,0.212D+03,0.177D+03,0.19496000D+01,0.18648000D+01
     .,0.24010400D+03,0.212D+03,0.178D+03,0.19496000D+01,0.19188000D+01
     .,0.22934010D+03,0.212D+03,0.179D+03,0.19496000D+01,0.98460000D+00
     .,0.22047400D+03,0.212D+03,0.180D+03,0.19496000D+01,0.19896000D+01
     .,0.36691360D+03,0.212D+03,0.181D+03,0.19496000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters(  87801:  87900)=(/
     . 0.33131350D+03,0.212D+03,0.182D+03,0.19496000D+01,0.93830000D+00
     .,0.31955040D+03,0.212D+03,0.183D+03,0.19496000D+01,0.98200000D+00
     .,0.30934230D+03,0.212D+03,0.184D+03,0.19496000D+01,0.98150000D+00
     .,0.28680210D+03,0.212D+03,0.185D+03,0.19496000D+01,0.99540000D+00
     .,0.37742160D+03,0.212D+03,0.187D+03,0.19496000D+01,0.97050000D+00
     .,0.73519780D+03,0.212D+03,0.188D+03,0.19496000D+01,0.96620000D+00
     .,0.39606860D+03,0.212D+03,0.189D+03,0.19496000D+01,0.29070000D+01
     .,0.46056730D+03,0.212D+03,0.190D+03,0.19496000D+01,0.28844000D+01
     .,0.40974230D+03,0.212D+03,0.191D+03,0.19496000D+01,0.28738000D+01
     .,0.35990110D+03,0.212D+03,0.192D+03,0.19496000D+01,0.28878000D+01
     .,0.34571200D+03,0.212D+03,0.193D+03,0.19496000D+01,0.29095000D+01
     .,0.42322520D+03,0.212D+03,0.194D+03,0.19496000D+01,0.19209000D+01
     .,0.97810100D+02,0.212D+03,0.204D+03,0.19496000D+01,0.19697000D+01
     .,0.95357500D+02,0.212D+03,0.205D+03,0.19496000D+01,0.19441000D+01
     .,0.68298400D+02,0.212D+03,0.206D+03,0.19496000D+01,0.19985000D+01
     .,0.53880300D+02,0.212D+03,0.207D+03,0.19496000D+01,0.20143000D+01
     .,0.35966500D+02,0.212D+03,0.208D+03,0.19496000D+01,0.19887000D+01
     .,0.17556160D+03,0.212D+03,0.212D+03,0.19496000D+01,0.19496000D+01
     .,0.26352400D+02,0.213D+03,0.100D+01,0.19311000D+01,0.91180000D+00
     .,0.16703100D+02,0.213D+03,0.200D+01,0.19311000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  87901:  88000)=(/
     . 0.45636130D+03,0.213D+03,0.300D+01,0.19311000D+01,0.00000000D+00
     .,0.25306490D+03,0.213D+03,0.400D+01,0.19311000D+01,0.00000000D+00
     .,0.16559380D+03,0.213D+03,0.500D+01,0.19311000D+01,0.00000000D+00
     .,0.10905410D+03,0.213D+03,0.600D+01,0.19311000D+01,0.00000000D+00
     .,0.74611700D+02,0.213D+03,0.700D+01,0.19311000D+01,0.00000000D+00
     .,0.55525000D+02,0.213D+03,0.800D+01,0.19311000D+01,0.00000000D+00
     .,0.41391400D+02,0.213D+03,0.900D+01,0.19311000D+01,0.00000000D+00
     .,0.31394400D+02,0.213D+03,0.100D+02,0.19311000D+01,0.00000000D+00
     .,0.54393780D+03,0.213D+03,0.110D+02,0.19311000D+01,0.00000000D+00
     .,0.40606870D+03,0.213D+03,0.120D+02,0.19311000D+01,0.00000000D+00
     .,0.36938290D+03,0.213D+03,0.130D+02,0.19311000D+01,0.00000000D+00
     .,0.28548250D+03,0.213D+03,0.140D+02,0.19311000D+01,0.00000000D+00
     .,0.21853020D+03,0.213D+03,0.150D+02,0.19311000D+01,0.00000000D+00
     .,0.17889260D+03,0.213D+03,0.160D+02,0.19311000D+01,0.00000000D+00
     .,0.14406690D+03,0.213D+03,0.170D+02,0.19311000D+01,0.00000000D+00
     .,0.11628170D+03,0.213D+03,0.180D+02,0.19311000D+01,0.00000000D+00
     .,0.89462280D+03,0.213D+03,0.190D+02,0.19311000D+01,0.00000000D+00
     .,0.72140890D+03,0.213D+03,0.200D+02,0.19311000D+01,0.00000000D+00
     .,0.59270500D+03,0.213D+03,0.210D+02,0.19311000D+01,0.00000000D+00
     .,0.56890770D+03,0.213D+03,0.220D+02,0.19311000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  88001:  88100)=(/
     . 0.51913280D+03,0.213D+03,0.230D+02,0.19311000D+01,0.00000000D+00
     .,0.40772880D+03,0.213D+03,0.240D+02,0.19311000D+01,0.00000000D+00
     .,0.44462830D+03,0.213D+03,0.250D+02,0.19311000D+01,0.00000000D+00
     .,0.34763940D+03,0.213D+03,0.260D+02,0.19311000D+01,0.00000000D+00
     .,0.36672360D+03,0.213D+03,0.270D+02,0.19311000D+01,0.00000000D+00
     .,0.37922800D+03,0.213D+03,0.280D+02,0.19311000D+01,0.00000000D+00
     .,0.28968240D+03,0.213D+03,0.290D+02,0.19311000D+01,0.00000000D+00
     .,0.29490170D+03,0.213D+03,0.300D+02,0.19311000D+01,0.00000000D+00
     .,0.35111920D+03,0.213D+03,0.310D+02,0.19311000D+01,0.00000000D+00
     .,0.30516430D+03,0.213D+03,0.320D+02,0.19311000D+01,0.00000000D+00
     .,0.25642310D+03,0.213D+03,0.330D+02,0.19311000D+01,0.00000000D+00
     .,0.22769360D+03,0.213D+03,0.340D+02,0.19311000D+01,0.00000000D+00
     .,0.19697430D+03,0.213D+03,0.350D+02,0.19311000D+01,0.00000000D+00
     .,0.16935470D+03,0.213D+03,0.360D+02,0.19311000D+01,0.00000000D+00
     .,0.99974000D+03,0.213D+03,0.370D+02,0.19311000D+01,0.00000000D+00
     .,0.85956780D+03,0.213D+03,0.380D+02,0.19311000D+01,0.00000000D+00
     .,0.74518010D+03,0.213D+03,0.390D+02,0.19311000D+01,0.00000000D+00
     .,0.66503860D+03,0.213D+03,0.400D+02,0.19311000D+01,0.00000000D+00
     .,0.60335750D+03,0.213D+03,0.410D+02,0.19311000D+01,0.00000000D+00
     .,0.46105860D+03,0.213D+03,0.420D+02,0.19311000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  88101:  88200)=(/
     . 0.51647660D+03,0.213D+03,0.430D+02,0.19311000D+01,0.00000000D+00
     .,0.38899560D+03,0.213D+03,0.440D+02,0.19311000D+01,0.00000000D+00
     .,0.42598370D+03,0.213D+03,0.450D+02,0.19311000D+01,0.00000000D+00
     .,0.39367760D+03,0.213D+03,0.460D+02,0.19311000D+01,0.00000000D+00
     .,0.32774720D+03,0.213D+03,0.470D+02,0.19311000D+01,0.00000000D+00
     .,0.34529970D+03,0.213D+03,0.480D+02,0.19311000D+01,0.00000000D+00
     .,0.43824740D+03,0.213D+03,0.490D+02,0.19311000D+01,0.00000000D+00
     .,0.40078940D+03,0.213D+03,0.500D+02,0.19311000D+01,0.00000000D+00
     .,0.35278490D+03,0.213D+03,0.510D+02,0.19311000D+01,0.00000000D+00
     .,0.32462780D+03,0.213D+03,0.520D+02,0.19311000D+01,0.00000000D+00
     .,0.29073780D+03,0.213D+03,0.530D+02,0.19311000D+01,0.00000000D+00
     .,0.25886870D+03,0.213D+03,0.540D+02,0.19311000D+01,0.00000000D+00
     .,0.12173141D+04,0.213D+03,0.550D+02,0.19311000D+01,0.00000000D+00
     .,0.10987485D+04,0.213D+03,0.560D+02,0.19311000D+01,0.00000000D+00
     .,0.95554880D+03,0.213D+03,0.570D+02,0.19311000D+01,0.00000000D+00
     .,0.41722080D+03,0.213D+03,0.580D+02,0.19311000D+01,0.27991000D+01
     .,0.96973660D+03,0.213D+03,0.590D+02,0.19311000D+01,0.00000000D+00
     .,0.92960420D+03,0.213D+03,0.600D+02,0.19311000D+01,0.00000000D+00
     .,0.90588600D+03,0.213D+03,0.610D+02,0.19311000D+01,0.00000000D+00
     .,0.88413220D+03,0.213D+03,0.620D+02,0.19311000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  88201:  88300)=(/
     . 0.86483220D+03,0.213D+03,0.630D+02,0.19311000D+01,0.00000000D+00
     .,0.67129000D+03,0.213D+03,0.640D+02,0.19311000D+01,0.00000000D+00
     .,0.76813130D+03,0.213D+03,0.650D+02,0.19311000D+01,0.00000000D+00
     .,0.73945380D+03,0.213D+03,0.660D+02,0.19311000D+01,0.00000000D+00
     .,0.77813230D+03,0.213D+03,0.670D+02,0.19311000D+01,0.00000000D+00
     .,0.76146230D+03,0.213D+03,0.680D+02,0.19311000D+01,0.00000000D+00
     .,0.74632100D+03,0.213D+03,0.690D+02,0.19311000D+01,0.00000000D+00
     .,0.73802330D+03,0.213D+03,0.700D+02,0.19311000D+01,0.00000000D+00
     .,0.61647150D+03,0.213D+03,0.710D+02,0.19311000D+01,0.00000000D+00
     .,0.60003080D+03,0.213D+03,0.720D+02,0.19311000D+01,0.00000000D+00
     .,0.54344620D+03,0.213D+03,0.730D+02,0.19311000D+01,0.00000000D+00
     .,0.45533130D+03,0.213D+03,0.740D+02,0.19311000D+01,0.00000000D+00
     .,0.46211940D+03,0.213D+03,0.750D+02,0.19311000D+01,0.00000000D+00
     .,0.41585260D+03,0.213D+03,0.760D+02,0.19311000D+01,0.00000000D+00
     .,0.37855240D+03,0.213D+03,0.770D+02,0.19311000D+01,0.00000000D+00
     .,0.31184500D+03,0.213D+03,0.780D+02,0.19311000D+01,0.00000000D+00
     .,0.29037770D+03,0.213D+03,0.790D+02,0.19311000D+01,0.00000000D+00
     .,0.29830060D+03,0.213D+03,0.800D+02,0.19311000D+01,0.00000000D+00
     .,0.44739490D+03,0.213D+03,0.810D+02,0.19311000D+01,0.00000000D+00
     .,0.43398370D+03,0.213D+03,0.820D+02,0.19311000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  88301:  88400)=(/
     . 0.39457020D+03,0.213D+03,0.830D+02,0.19311000D+01,0.00000000D+00
     .,0.37381510D+03,0.213D+03,0.840D+02,0.19311000D+01,0.00000000D+00
     .,0.34202110D+03,0.213D+03,0.850D+02,0.19311000D+01,0.00000000D+00
     .,0.31081620D+03,0.213D+03,0.860D+02,0.19311000D+01,0.00000000D+00
     .,0.11397020D+04,0.213D+03,0.870D+02,0.19311000D+01,0.00000000D+00
     .,0.10803973D+04,0.213D+03,0.880D+02,0.19311000D+01,0.00000000D+00
     .,0.94598830D+03,0.213D+03,0.890D+02,0.19311000D+01,0.00000000D+00
     .,0.83976740D+03,0.213D+03,0.900D+02,0.19311000D+01,0.00000000D+00
     .,0.83781840D+03,0.213D+03,0.910D+02,0.19311000D+01,0.00000000D+00
     .,0.81085380D+03,0.213D+03,0.920D+02,0.19311000D+01,0.00000000D+00
     .,0.84069890D+03,0.213D+03,0.930D+02,0.19311000D+01,0.00000000D+00
     .,0.81310950D+03,0.213D+03,0.940D+02,0.19311000D+01,0.00000000D+00
     .,0.43366100D+02,0.213D+03,0.101D+03,0.19311000D+01,0.00000000D+00
     .,0.14644260D+03,0.213D+03,0.103D+03,0.19311000D+01,0.98650000D+00
     .,0.18573100D+03,0.213D+03,0.104D+03,0.19311000D+01,0.98080000D+00
     .,0.13828380D+03,0.213D+03,0.105D+03,0.19311000D+01,0.97060000D+00
     .,0.10220950D+03,0.213D+03,0.106D+03,0.19311000D+01,0.98680000D+00
     .,0.69450100D+02,0.213D+03,0.107D+03,0.19311000D+01,0.99440000D+00
     .,0.49531900D+02,0.213D+03,0.108D+03,0.19311000D+01,0.99250000D+00
     .,0.33126500D+02,0.213D+03,0.109D+03,0.19311000D+01,0.99820000D+00
     ./)
      grimme_c6_parameters(  88401:  88500)=(/
     . 0.21467960D+03,0.213D+03,0.111D+03,0.19311000D+01,0.96840000D+00
     .,0.33305050D+03,0.213D+03,0.112D+03,0.19311000D+01,0.96280000D+00
     .,0.33353410D+03,0.213D+03,0.113D+03,0.19311000D+01,0.96480000D+00
     .,0.26297700D+03,0.213D+03,0.114D+03,0.19311000D+01,0.95070000D+00
     .,0.21192050D+03,0.213D+03,0.115D+03,0.19311000D+01,0.99470000D+00
     .,0.17693650D+03,0.213D+03,0.116D+03,0.19311000D+01,0.99480000D+00
     .,0.14258060D+03,0.213D+03,0.117D+03,0.19311000D+01,0.99720000D+00
     .,0.29160280D+03,0.213D+03,0.119D+03,0.19311000D+01,0.97670000D+00
     .,0.57547210D+03,0.213D+03,0.120D+03,0.19311000D+01,0.98310000D+00
     .,0.28808340D+03,0.213D+03,0.121D+03,0.19311000D+01,0.18627000D+01
     .,0.27780740D+03,0.213D+03,0.122D+03,0.19311000D+01,0.18299000D+01
     .,0.27224960D+03,0.213D+03,0.123D+03,0.19311000D+01,0.19138000D+01
     .,0.27016230D+03,0.213D+03,0.124D+03,0.19311000D+01,0.18269000D+01
     .,0.24655880D+03,0.213D+03,0.125D+03,0.19311000D+01,0.16406000D+01
     .,0.22743270D+03,0.213D+03,0.126D+03,0.19311000D+01,0.16483000D+01
     .,0.21683930D+03,0.213D+03,0.127D+03,0.19311000D+01,0.17149000D+01
     .,0.21211940D+03,0.213D+03,0.128D+03,0.19311000D+01,0.17937000D+01
     .,0.21090190D+03,0.213D+03,0.129D+03,0.19311000D+01,0.95760000D+00
     .,0.19559730D+03,0.213D+03,0.130D+03,0.19311000D+01,0.19419000D+01
     .,0.32851000D+03,0.213D+03,0.131D+03,0.19311000D+01,0.96010000D+00
     ./)
      grimme_c6_parameters(  88501:  88600)=(/
     . 0.28437390D+03,0.213D+03,0.132D+03,0.19311000D+01,0.94340000D+00
     .,0.25181270D+03,0.213D+03,0.133D+03,0.19311000D+01,0.98890000D+00
     .,0.22779820D+03,0.213D+03,0.134D+03,0.19311000D+01,0.99010000D+00
     .,0.19844730D+03,0.213D+03,0.135D+03,0.19311000D+01,0.99740000D+00
     .,0.34649590D+03,0.213D+03,0.137D+03,0.19311000D+01,0.97380000D+00
     .,0.70067460D+03,0.213D+03,0.138D+03,0.19311000D+01,0.98010000D+00
     .,0.52422670D+03,0.213D+03,0.139D+03,0.19311000D+01,0.19153000D+01
     .,0.38103090D+03,0.213D+03,0.140D+03,0.19311000D+01,0.19355000D+01
     .,0.38476780D+03,0.213D+03,0.141D+03,0.19311000D+01,0.19545000D+01
     .,0.35735760D+03,0.213D+03,0.142D+03,0.19311000D+01,0.19420000D+01
     .,0.40520110D+03,0.213D+03,0.143D+03,0.19311000D+01,0.16682000D+01
     .,0.30854590D+03,0.213D+03,0.144D+03,0.19311000D+01,0.18584000D+01
     .,0.28812910D+03,0.213D+03,0.145D+03,0.19311000D+01,0.19003000D+01
     .,0.26684840D+03,0.213D+03,0.146D+03,0.19311000D+01,0.18630000D+01
     .,0.25840650D+03,0.213D+03,0.147D+03,0.19311000D+01,0.96790000D+00
     .,0.25422360D+03,0.213D+03,0.148D+03,0.19311000D+01,0.19539000D+01
     .,0.41600330D+03,0.213D+03,0.149D+03,0.19311000D+01,0.96330000D+00
     .,0.37187790D+03,0.213D+03,0.150D+03,0.19311000D+01,0.95140000D+00
     .,0.34513030D+03,0.213D+03,0.151D+03,0.19311000D+01,0.97490000D+00
     .,0.32423490D+03,0.213D+03,0.152D+03,0.19311000D+01,0.98110000D+00
     ./)
      grimme_c6_parameters(  88601:  88700)=(/
     . 0.29353370D+03,0.213D+03,0.153D+03,0.19311000D+01,0.99680000D+00
     .,0.40637240D+03,0.213D+03,0.155D+03,0.19311000D+01,0.99090000D+00
     .,0.91183210D+03,0.213D+03,0.156D+03,0.19311000D+01,0.97970000D+00
     .,0.66459040D+03,0.213D+03,0.157D+03,0.19311000D+01,0.19373000D+01
     .,0.40429100D+03,0.213D+03,0.159D+03,0.19311000D+01,0.29425000D+01
     .,0.39585770D+03,0.213D+03,0.160D+03,0.19311000D+01,0.29455000D+01
     .,0.38302380D+03,0.213D+03,0.161D+03,0.19311000D+01,0.29413000D+01
     .,0.38563610D+03,0.213D+03,0.162D+03,0.19311000D+01,0.29300000D+01
     .,0.37369250D+03,0.213D+03,0.163D+03,0.19311000D+01,0.18286000D+01
     .,0.38845580D+03,0.213D+03,0.164D+03,0.19311000D+01,0.28732000D+01
     .,0.36415710D+03,0.213D+03,0.165D+03,0.19311000D+01,0.29086000D+01
     .,0.37174820D+03,0.213D+03,0.166D+03,0.19311000D+01,0.28965000D+01
     .,0.34511820D+03,0.213D+03,0.167D+03,0.19311000D+01,0.29242000D+01
     .,0.33507830D+03,0.213D+03,0.168D+03,0.19311000D+01,0.29282000D+01
     .,0.33312390D+03,0.213D+03,0.169D+03,0.19311000D+01,0.29246000D+01
     .,0.35137350D+03,0.213D+03,0.170D+03,0.19311000D+01,0.28482000D+01
     .,0.32173170D+03,0.213D+03,0.171D+03,0.19311000D+01,0.29219000D+01
     .,0.44538150D+03,0.213D+03,0.172D+03,0.19311000D+01,0.19254000D+01
     .,0.41012060D+03,0.213D+03,0.173D+03,0.19311000D+01,0.19459000D+01
     .,0.37108910D+03,0.213D+03,0.174D+03,0.19311000D+01,0.19292000D+01
     ./)
      grimme_c6_parameters(  88701:  88800)=(/
     . 0.37797370D+03,0.213D+03,0.175D+03,0.19311000D+01,0.18104000D+01
     .,0.32478730D+03,0.213D+03,0.176D+03,0.19311000D+01,0.18858000D+01
     .,0.30440310D+03,0.213D+03,0.177D+03,0.19311000D+01,0.18648000D+01
     .,0.29003910D+03,0.213D+03,0.178D+03,0.19311000D+01,0.19188000D+01
     .,0.27707890D+03,0.213D+03,0.179D+03,0.19311000D+01,0.98460000D+00
     .,0.26611650D+03,0.213D+03,0.180D+03,0.19311000D+01,0.19896000D+01
     .,0.44475260D+03,0.213D+03,0.181D+03,0.19311000D+01,0.92670000D+00
     .,0.40065540D+03,0.213D+03,0.182D+03,0.19311000D+01,0.93830000D+00
     .,0.38605640D+03,0.213D+03,0.183D+03,0.19311000D+01,0.98200000D+00
     .,0.37356510D+03,0.213D+03,0.184D+03,0.19311000D+01,0.98150000D+00
     .,0.34618570D+03,0.213D+03,0.185D+03,0.19311000D+01,0.99540000D+00
     .,0.45742940D+03,0.213D+03,0.187D+03,0.19311000D+01,0.97050000D+00
     .,0.90069660D+03,0.213D+03,0.188D+03,0.19311000D+01,0.96620000D+00
     .,0.47874300D+03,0.213D+03,0.189D+03,0.19311000D+01,0.29070000D+01
     .,0.55821910D+03,0.213D+03,0.190D+03,0.19311000D+01,0.28844000D+01
     .,0.49675560D+03,0.213D+03,0.191D+03,0.19311000D+01,0.28738000D+01
     .,0.43513510D+03,0.213D+03,0.192D+03,0.19311000D+01,0.28878000D+01
     .,0.41782680D+03,0.213D+03,0.193D+03,0.19311000D+01,0.29095000D+01
     .,0.51393660D+03,0.213D+03,0.194D+03,0.19311000D+01,0.19209000D+01
     .,0.11812330D+03,0.213D+03,0.204D+03,0.19311000D+01,0.19697000D+01
     ./)
      grimme_c6_parameters(  88801:  88900)=(/
     . 0.11524800D+03,0.213D+03,0.205D+03,0.19311000D+01,0.19441000D+01
     .,0.82430300D+02,0.213D+03,0.206D+03,0.19311000D+01,0.19985000D+01
     .,0.65016400D+02,0.213D+03,0.207D+03,0.19311000D+01,0.20143000D+01
     .,0.43378800D+02,0.213D+03,0.208D+03,0.19311000D+01,0.19887000D+01
     .,0.21219710D+03,0.213D+03,0.212D+03,0.19311000D+01,0.19496000D+01
     .,0.25674970D+03,0.213D+03,0.213D+03,0.19311000D+01,0.19311000D+01
     .,0.25702100D+02,0.214D+03,0.100D+01,0.19435000D+01,0.91180000D+00
     .,0.16580600D+02,0.214D+03,0.200D+01,0.19435000D+01,0.00000000D+00
     .,0.41243230D+03,0.214D+03,0.300D+01,0.19435000D+01,0.00000000D+00
     .,0.23689910D+03,0.214D+03,0.400D+01,0.19435000D+01,0.00000000D+00
     .,0.15801650D+03,0.214D+03,0.500D+01,0.19435000D+01,0.00000000D+00
     .,0.10557130D+03,0.214D+03,0.600D+01,0.19435000D+01,0.00000000D+00
     .,0.73007300D+02,0.214D+03,0.700D+01,0.19435000D+01,0.00000000D+00
     .,0.54744300D+02,0.214D+03,0.800D+01,0.19435000D+01,0.00000000D+00
     .,0.41072800D+02,0.214D+03,0.900D+01,0.19435000D+01,0.00000000D+00
     .,0.31310700D+02,0.214D+03,0.100D+02,0.19435000D+01,0.00000000D+00
     .,0.49265620D+03,0.214D+03,0.110D+02,0.19435000D+01,0.00000000D+00
     .,0.37783600D+03,0.214D+03,0.120D+02,0.19435000D+01,0.00000000D+00
     .,0.34711540D+03,0.214D+03,0.130D+02,0.19435000D+01,0.00000000D+00
     .,0.27188440D+03,0.214D+03,0.140D+02,0.19435000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  88901:  89000)=(/
     . 0.21048400D+03,0.214D+03,0.150D+02,0.19435000D+01,0.00000000D+00
     .,0.17357980D+03,0.214D+03,0.160D+02,0.19435000D+01,0.00000000D+00
     .,0.14078240D+03,0.214D+03,0.170D+02,0.19435000D+01,0.00000000D+00
     .,0.11433480D+03,0.214D+03,0.180D+02,0.19435000D+01,0.00000000D+00
     .,0.80549240D+03,0.214D+03,0.190D+02,0.19435000D+01,0.00000000D+00
     .,0.66409770D+03,0.214D+03,0.200D+02,0.19435000D+01,0.00000000D+00
     .,0.54821150D+03,0.214D+03,0.210D+02,0.19435000D+01,0.00000000D+00
     .,0.52845930D+03,0.214D+03,0.220D+02,0.19435000D+01,0.00000000D+00
     .,0.48345990D+03,0.214D+03,0.230D+02,0.19435000D+01,0.00000000D+00
     .,0.37993850D+03,0.214D+03,0.240D+02,0.19435000D+01,0.00000000D+00
     .,0.41561120D+03,0.214D+03,0.250D+02,0.19435000D+01,0.00000000D+00
     .,0.32531170D+03,0.214D+03,0.260D+02,0.19435000D+01,0.00000000D+00
     .,0.34494790D+03,0.214D+03,0.270D+02,0.19435000D+01,0.00000000D+00
     .,0.35576410D+03,0.214D+03,0.280D+02,0.19435000D+01,0.00000000D+00
     .,0.27189110D+03,0.214D+03,0.290D+02,0.19435000D+01,0.00000000D+00
     .,0.27896960D+03,0.214D+03,0.300D+02,0.19435000D+01,0.00000000D+00
     .,0.33128490D+03,0.214D+03,0.310D+02,0.19435000D+01,0.00000000D+00
     .,0.29090920D+03,0.214D+03,0.320D+02,0.19435000D+01,0.00000000D+00
     .,0.24673790D+03,0.214D+03,0.330D+02,0.19435000D+01,0.00000000D+00
     .,0.22038060D+03,0.214D+03,0.340D+02,0.19435000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  89001:  89100)=(/
     . 0.19179920D+03,0.214D+03,0.350D+02,0.19435000D+01,0.00000000D+00
     .,0.16582300D+03,0.214D+03,0.360D+02,0.19435000D+01,0.00000000D+00
     .,0.90177390D+03,0.214D+03,0.370D+02,0.19435000D+01,0.00000000D+00
     .,0.79067650D+03,0.214D+03,0.380D+02,0.19435000D+01,0.00000000D+00
     .,0.69120290D+03,0.214D+03,0.390D+02,0.19435000D+01,0.00000000D+00
     .,0.62007920D+03,0.214D+03,0.400D+02,0.19435000D+01,0.00000000D+00
     .,0.56449010D+03,0.214D+03,0.410D+02,0.19435000D+01,0.00000000D+00
     .,0.43396780D+03,0.214D+03,0.420D+02,0.19435000D+01,0.00000000D+00
     .,0.48500980D+03,0.214D+03,0.430D+02,0.19435000D+01,0.00000000D+00
     .,0.36773060D+03,0.214D+03,0.440D+02,0.19435000D+01,0.00000000D+00
     .,0.40262390D+03,0.214D+03,0.450D+02,0.19435000D+01,0.00000000D+00
     .,0.37288980D+03,0.214D+03,0.460D+02,0.19435000D+01,0.00000000D+00
     .,0.31011860D+03,0.214D+03,0.470D+02,0.19435000D+01,0.00000000D+00
     .,0.32796220D+03,0.214D+03,0.480D+02,0.19435000D+01,0.00000000D+00
     .,0.41337540D+03,0.214D+03,0.490D+02,0.19435000D+01,0.00000000D+00
     .,0.38122300D+03,0.214D+03,0.500D+02,0.19435000D+01,0.00000000D+00
     .,0.33831890D+03,0.214D+03,0.510D+02,0.19435000D+01,0.00000000D+00
     .,0.31287500D+03,0.214D+03,0.520D+02,0.19435000D+01,0.00000000D+00
     .,0.28172560D+03,0.214D+03,0.530D+02,0.19435000D+01,0.00000000D+00
     .,0.25213370D+03,0.214D+03,0.540D+02,0.19435000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  89101:  89200)=(/
     . 0.10981239D+04,0.214D+03,0.550D+02,0.19435000D+01,0.00000000D+00
     .,0.10078503D+04,0.214D+03,0.560D+02,0.19435000D+01,0.00000000D+00
     .,0.88388150D+03,0.214D+03,0.570D+02,0.19435000D+01,0.00000000D+00
     .,0.39958530D+03,0.214D+03,0.580D+02,0.19435000D+01,0.27991000D+01
     .,0.89190420D+03,0.214D+03,0.590D+02,0.19435000D+01,0.00000000D+00
     .,0.85628170D+03,0.214D+03,0.600D+02,0.19435000D+01,0.00000000D+00
     .,0.83476410D+03,0.214D+03,0.610D+02,0.19435000D+01,0.00000000D+00
     .,0.81499180D+03,0.214D+03,0.620D+02,0.19435000D+01,0.00000000D+00
     .,0.79746090D+03,0.214D+03,0.630D+02,0.19435000D+01,0.00000000D+00
     .,0.62473210D+03,0.214D+03,0.640D+02,0.19435000D+01,0.00000000D+00
     .,0.70500060D+03,0.214D+03,0.650D+02,0.19435000D+01,0.00000000D+00
     .,0.67965440D+03,0.214D+03,0.660D+02,0.19435000D+01,0.00000000D+00
     .,0.71903230D+03,0.214D+03,0.670D+02,0.19435000D+01,0.00000000D+00
     .,0.70378810D+03,0.214D+03,0.680D+02,0.19435000D+01,0.00000000D+00
     .,0.69001840D+03,0.214D+03,0.690D+02,0.19435000D+01,0.00000000D+00
     .,0.68208270D+03,0.214D+03,0.700D+02,0.19435000D+01,0.00000000D+00
     .,0.57324330D+03,0.214D+03,0.710D+02,0.19435000D+01,0.00000000D+00
     .,0.56278660D+03,0.214D+03,0.720D+02,0.19435000D+01,0.00000000D+00
     .,0.51235040D+03,0.214D+03,0.730D+02,0.19435000D+01,0.00000000D+00
     .,0.43105180D+03,0.214D+03,0.740D+02,0.19435000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  89201:  89300)=(/
     . 0.43832130D+03,0.214D+03,0.750D+02,0.19435000D+01,0.00000000D+00
     .,0.39619890D+03,0.214D+03,0.760D+02,0.19435000D+01,0.00000000D+00
     .,0.36196280D+03,0.214D+03,0.770D+02,0.19435000D+01,0.00000000D+00
     .,0.29935640D+03,0.214D+03,0.780D+02,0.19435000D+01,0.00000000D+00
     .,0.27918270D+03,0.214D+03,0.790D+02,0.19435000D+01,0.00000000D+00
     .,0.28724760D+03,0.214D+03,0.800D+02,0.19435000D+01,0.00000000D+00
     .,0.42296870D+03,0.214D+03,0.810D+02,0.19435000D+01,0.00000000D+00
     .,0.41296020D+03,0.214D+03,0.820D+02,0.19435000D+01,0.00000000D+00
     .,0.37820780D+03,0.214D+03,0.830D+02,0.19435000D+01,0.00000000D+00
     .,0.35984120D+03,0.214D+03,0.840D+02,0.19435000D+01,0.00000000D+00
     .,0.33092490D+03,0.214D+03,0.850D+02,0.19435000D+01,0.00000000D+00
     .,0.30214620D+03,0.214D+03,0.860D+02,0.19435000D+01,0.00000000D+00
     .,0.10353860D+04,0.214D+03,0.870D+02,0.19435000D+01,0.00000000D+00
     .,0.99537320D+03,0.214D+03,0.880D+02,0.19435000D+01,0.00000000D+00
     .,0.87825500D+03,0.214D+03,0.890D+02,0.19435000D+01,0.00000000D+00
     .,0.78653170D+03,0.214D+03,0.900D+02,0.19435000D+01,0.00000000D+00
     .,0.78131330D+03,0.214D+03,0.910D+02,0.19435000D+01,0.00000000D+00
     .,0.75635270D+03,0.214D+03,0.920D+02,0.19435000D+01,0.00000000D+00
     .,0.77996360D+03,0.214D+03,0.930D+02,0.19435000D+01,0.00000000D+00
     .,0.75512290D+03,0.214D+03,0.940D+02,0.19435000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  89301:  89400)=(/
     . 0.41822200D+02,0.214D+03,0.101D+03,0.19435000D+01,0.00000000D+00
     .,0.13744580D+03,0.214D+03,0.103D+03,0.19435000D+01,0.98650000D+00
     .,0.17493150D+03,0.214D+03,0.104D+03,0.19435000D+01,0.98080000D+00
     .,0.13248310D+03,0.214D+03,0.105D+03,0.19435000D+01,0.97060000D+00
     .,0.98927800D+02,0.214D+03,0.106D+03,0.19435000D+01,0.98680000D+00
     .,0.67982000D+02,0.214D+03,0.107D+03,0.19435000D+01,0.99440000D+00
     .,0.48939100D+02,0.214D+03,0.108D+03,0.19435000D+01,0.99250000D+00
     .,0.33107500D+02,0.214D+03,0.109D+03,0.19435000D+01,0.99820000D+00
     .,0.20080380D+03,0.214D+03,0.111D+03,0.19435000D+01,0.96840000D+00
     .,0.31098970D+03,0.214D+03,0.112D+03,0.19435000D+01,0.96280000D+00
     .,0.31418090D+03,0.214D+03,0.113D+03,0.19435000D+01,0.96480000D+00
     .,0.25093760D+03,0.214D+03,0.114D+03,0.19435000D+01,0.95070000D+00
     .,0.20419980D+03,0.214D+03,0.115D+03,0.19435000D+01,0.99470000D+00
     .,0.17165370D+03,0.214D+03,0.116D+03,0.19435000D+01,0.99480000D+00
     .,0.13931250D+03,0.214D+03,0.117D+03,0.19435000D+01,0.99720000D+00
     .,0.27480560D+03,0.214D+03,0.119D+03,0.19435000D+01,0.97670000D+00
     .,0.52989460D+03,0.214D+03,0.120D+03,0.19435000D+01,0.98310000D+00
     .,0.27434930D+03,0.214D+03,0.121D+03,0.19435000D+01,0.18627000D+01
     .,0.26463020D+03,0.214D+03,0.122D+03,0.19435000D+01,0.18299000D+01
     .,0.25929250D+03,0.214D+03,0.123D+03,0.19435000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  89401:  89500)=(/
     . 0.25696820D+03,0.214D+03,0.124D+03,0.19435000D+01,0.18269000D+01
     .,0.23596760D+03,0.214D+03,0.125D+03,0.19435000D+01,0.16406000D+01
     .,0.21806460D+03,0.214D+03,0.126D+03,0.19435000D+01,0.16483000D+01
     .,0.20790840D+03,0.214D+03,0.127D+03,0.19435000D+01,0.17149000D+01
     .,0.20327770D+03,0.214D+03,0.128D+03,0.19435000D+01,0.17937000D+01
     .,0.20115730D+03,0.214D+03,0.129D+03,0.19435000D+01,0.95760000D+00
     .,0.18816130D+03,0.214D+03,0.130D+03,0.19435000D+01,0.19419000D+01
     .,0.31077040D+03,0.214D+03,0.131D+03,0.19435000D+01,0.96010000D+00
     .,0.27174380D+03,0.214D+03,0.132D+03,0.19435000D+01,0.94340000D+00
     .,0.24243590D+03,0.214D+03,0.133D+03,0.19435000D+01,0.98890000D+00
     .,0.22046240D+03,0.214D+03,0.134D+03,0.19435000D+01,0.99010000D+00
     .,0.19317380D+03,0.214D+03,0.135D+03,0.19435000D+01,0.99740000D+00
     .,0.32730800D+03,0.214D+03,0.137D+03,0.19435000D+01,0.97380000D+00
     .,0.64440170D+03,0.214D+03,0.138D+03,0.19435000D+01,0.98010000D+00
     .,0.49021540D+03,0.214D+03,0.139D+03,0.19435000D+01,0.19153000D+01
     .,0.36256720D+03,0.214D+03,0.140D+03,0.19435000D+01,0.19355000D+01
     .,0.36609840D+03,0.214D+03,0.141D+03,0.19435000D+01,0.19545000D+01
     .,0.34073580D+03,0.214D+03,0.142D+03,0.19435000D+01,0.19420000D+01
     .,0.38317340D+03,0.214D+03,0.143D+03,0.19435000D+01,0.16682000D+01
     .,0.29596310D+03,0.214D+03,0.144D+03,0.19435000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters(  89501:  89600)=(/
     . 0.27654270D+03,0.214D+03,0.145D+03,0.19435000D+01,0.19003000D+01
     .,0.25641330D+03,0.214D+03,0.146D+03,0.19435000D+01,0.18630000D+01
     .,0.24807500D+03,0.214D+03,0.147D+03,0.19435000D+01,0.96790000D+00
     .,0.24516140D+03,0.214D+03,0.148D+03,0.19435000D+01,0.19539000D+01
     .,0.39356170D+03,0.214D+03,0.149D+03,0.19435000D+01,0.96330000D+00
     .,0.35486870D+03,0.214D+03,0.150D+03,0.19435000D+01,0.95140000D+00
     .,0.33134490D+03,0.214D+03,0.151D+03,0.19435000D+01,0.97490000D+00
     .,0.31259390D+03,0.214D+03,0.152D+03,0.19435000D+01,0.98110000D+00
     .,0.28440960D+03,0.214D+03,0.153D+03,0.19435000D+01,0.99680000D+00
     .,0.38643270D+03,0.214D+03,0.155D+03,0.19435000D+01,0.99090000D+00
     .,0.83548010D+03,0.214D+03,0.156D+03,0.19435000D+01,0.97970000D+00
     .,0.62051600D+03,0.214D+03,0.157D+03,0.19435000D+01,0.19373000D+01
     .,0.38738880D+03,0.214D+03,0.159D+03,0.19435000D+01,0.29425000D+01
     .,0.37934290D+03,0.214D+03,0.160D+03,0.19435000D+01,0.29455000D+01
     .,0.36719680D+03,0.214D+03,0.161D+03,0.19435000D+01,0.29413000D+01
     .,0.36922530D+03,0.214D+03,0.162D+03,0.19435000D+01,0.29300000D+01
     .,0.35636770D+03,0.214D+03,0.163D+03,0.19435000D+01,0.18286000D+01
     .,0.37178190D+03,0.214D+03,0.164D+03,0.19435000D+01,0.28732000D+01
     .,0.34890330D+03,0.214D+03,0.165D+03,0.19435000D+01,0.29086000D+01
     .,0.35535340D+03,0.214D+03,0.166D+03,0.19435000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters(  89601:  89700)=(/
     . 0.33101430D+03,0.214D+03,0.167D+03,0.19435000D+01,0.29242000D+01
     .,0.32151310D+03,0.214D+03,0.168D+03,0.19435000D+01,0.29282000D+01
     .,0.31953220D+03,0.214D+03,0.169D+03,0.19435000D+01,0.29246000D+01
     .,0.33642390D+03,0.214D+03,0.170D+03,0.19435000D+01,0.28482000D+01
     .,0.30879300D+03,0.214D+03,0.171D+03,0.19435000D+01,0.29219000D+01
     .,0.42124260D+03,0.214D+03,0.172D+03,0.19435000D+01,0.19254000D+01
     .,0.38987130D+03,0.214D+03,0.173D+03,0.19435000D+01,0.19459000D+01
     .,0.35462710D+03,0.214D+03,0.174D+03,0.19435000D+01,0.19292000D+01
     .,0.35955640D+03,0.214D+03,0.175D+03,0.19435000D+01,0.18104000D+01
     .,0.31268360D+03,0.214D+03,0.176D+03,0.19435000D+01,0.18858000D+01
     .,0.29359280D+03,0.214D+03,0.177D+03,0.19435000D+01,0.18648000D+01
     .,0.28003950D+03,0.214D+03,0.178D+03,0.19435000D+01,0.19188000D+01
     .,0.26748530D+03,0.214D+03,0.179D+03,0.19435000D+01,0.98460000D+00
     .,0.25798760D+03,0.214D+03,0.180D+03,0.19435000D+01,0.19896000D+01
     .,0.42147770D+03,0.214D+03,0.181D+03,0.19435000D+01,0.92670000D+00
     .,0.38292490D+03,0.214D+03,0.182D+03,0.19435000D+01,0.93830000D+00
     .,0.37065420D+03,0.214D+03,0.183D+03,0.19435000D+01,0.98200000D+00
     .,0.35983420D+03,0.214D+03,0.184D+03,0.19435000D+01,0.98150000D+00
     .,0.33497230D+03,0.214D+03,0.185D+03,0.19435000D+01,0.99540000D+00
     .,0.43520780D+03,0.214D+03,0.187D+03,0.19435000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters(  89701:  89800)=(/
     . 0.83000970D+03,0.214D+03,0.188D+03,0.19435000D+01,0.96620000D+00
     .,0.45862090D+03,0.214D+03,0.189D+03,0.19435000D+01,0.29070000D+01
     .,0.53065480D+03,0.214D+03,0.190D+03,0.19435000D+01,0.28844000D+01
     .,0.47329240D+03,0.214D+03,0.191D+03,0.19435000D+01,0.28738000D+01
     .,0.41725880D+03,0.214D+03,0.192D+03,0.19435000D+01,0.28878000D+01
     .,0.40119370D+03,0.214D+03,0.193D+03,0.19435000D+01,0.29095000D+01
     .,0.48568000D+03,0.214D+03,0.194D+03,0.19435000D+01,0.19209000D+01
     .,0.11328200D+03,0.214D+03,0.204D+03,0.19435000D+01,0.19697000D+01
     .,0.11084470D+03,0.214D+03,0.205D+03,0.19435000D+01,0.19441000D+01
     .,0.80261900D+02,0.214D+03,0.206D+03,0.19435000D+01,0.19985000D+01
     .,0.63715100D+02,0.214D+03,0.207D+03,0.19435000D+01,0.20143000D+01
     .,0.42967900D+02,0.214D+03,0.208D+03,0.19435000D+01,0.19887000D+01
     .,0.20177580D+03,0.214D+03,0.212D+03,0.19435000D+01,0.19496000D+01
     .,0.24384070D+03,0.214D+03,0.213D+03,0.19435000D+01,0.19311000D+01
     .,0.23312540D+03,0.214D+03,0.214D+03,0.19435000D+01,0.19435000D+01
     .,0.22742900D+02,0.215D+03,0.100D+01,0.20102000D+01,0.91180000D+00
     .,0.15024500D+02,0.215D+03,0.200D+01,0.20102000D+01,0.00000000D+00
     .,0.33746620D+03,0.215D+03,0.300D+01,0.20102000D+01,0.00000000D+00
     .,0.19995760D+03,0.215D+03,0.400D+01,0.20102000D+01,0.00000000D+00
     .,0.13624020D+03,0.215D+03,0.500D+01,0.20102000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  89801:  89900)=(/
     . 0.92608000D+02,0.215D+03,0.600D+01,0.20102000D+01,0.00000000D+00
     .,0.64920900D+02,0.215D+03,0.700D+01,0.20102000D+01,0.00000000D+00
     .,0.49172900D+02,0.215D+03,0.800D+01,0.20102000D+01,0.00000000D+00
     .,0.37220500D+02,0.215D+03,0.900D+01,0.20102000D+01,0.00000000D+00
     .,0.28580500D+02,0.215D+03,0.100D+02,0.20102000D+01,0.00000000D+00
     .,0.40398020D+03,0.215D+03,0.110D+02,0.20102000D+01,0.00000000D+00
     .,0.31708240D+03,0.215D+03,0.120D+02,0.20102000D+01,0.00000000D+00
     .,0.29434030D+03,0.215D+03,0.130D+02,0.20102000D+01,0.00000000D+00
     .,0.23387520D+03,0.215D+03,0.140D+02,0.20102000D+01,0.00000000D+00
     .,0.18343220D+03,0.215D+03,0.150D+02,0.20102000D+01,0.00000000D+00
     .,0.15264700D+03,0.215D+03,0.160D+02,0.20102000D+01,0.00000000D+00
     .,0.12491620D+03,0.215D+03,0.170D+02,0.20102000D+01,0.00000000D+00
     .,0.10227010D+03,0.215D+03,0.180D+02,0.20102000D+01,0.00000000D+00
     .,0.65923940D+03,0.215D+03,0.190D+02,0.20102000D+01,0.00000000D+00
     .,0.55248890D+03,0.215D+03,0.200D+02,0.20102000D+01,0.00000000D+00
     .,0.45796080D+03,0.215D+03,0.210D+02,0.20102000D+01,0.00000000D+00
     .,0.44347230D+03,0.215D+03,0.220D+02,0.20102000D+01,0.00000000D+00
     .,0.40676720D+03,0.215D+03,0.230D+02,0.20102000D+01,0.00000000D+00
     .,0.32027340D+03,0.215D+03,0.240D+02,0.20102000D+01,0.00000000D+00
     .,0.35102240D+03,0.215D+03,0.250D+02,0.20102000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  89901:  90000)=(/
     . 0.27541380D+03,0.215D+03,0.260D+02,0.20102000D+01,0.00000000D+00
     .,0.29316610D+03,0.215D+03,0.270D+02,0.20102000D+01,0.00000000D+00
     .,0.30149740D+03,0.215D+03,0.280D+02,0.20102000D+01,0.00000000D+00
     .,0.23090910D+03,0.215D+03,0.290D+02,0.20102000D+01,0.00000000D+00
     .,0.23850630D+03,0.215D+03,0.300D+02,0.20102000D+01,0.00000000D+00
     .,0.28238710D+03,0.215D+03,0.310D+02,0.20102000D+01,0.00000000D+00
     .,0.25064010D+03,0.215D+03,0.320D+02,0.20102000D+01,0.00000000D+00
     .,0.21483630D+03,0.215D+03,0.330D+02,0.20102000D+01,0.00000000D+00
     .,0.19324100D+03,0.215D+03,0.340D+02,0.20102000D+01,0.00000000D+00
     .,0.16943130D+03,0.215D+03,0.350D+02,0.20102000D+01,0.00000000D+00
     .,0.14751930D+03,0.215D+03,0.360D+02,0.20102000D+01,0.00000000D+00
     .,0.73972690D+03,0.215D+03,0.370D+02,0.20102000D+01,0.00000000D+00
     .,0.65778770D+03,0.215D+03,0.380D+02,0.20102000D+01,0.00000000D+00
     .,0.57951050D+03,0.215D+03,0.390D+02,0.20102000D+01,0.00000000D+00
     .,0.52257210D+03,0.215D+03,0.400D+02,0.20102000D+01,0.00000000D+00
     .,0.47747720D+03,0.215D+03,0.410D+02,0.20102000D+01,0.00000000D+00
     .,0.36967940D+03,0.215D+03,0.420D+02,0.20102000D+01,0.00000000D+00
     .,0.41204130D+03,0.215D+03,0.430D+02,0.20102000D+01,0.00000000D+00
     .,0.31482970D+03,0.215D+03,0.440D+02,0.20102000D+01,0.00000000D+00
     .,0.34429870D+03,0.215D+03,0.450D+02,0.20102000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  90001:  90100)=(/
     . 0.31960770D+03,0.215D+03,0.460D+02,0.20102000D+01,0.00000000D+00
     .,0.26595030D+03,0.215D+03,0.470D+02,0.20102000D+01,0.00000000D+00
     .,0.28194690D+03,0.215D+03,0.480D+02,0.20102000D+01,0.00000000D+00
     .,0.35272470D+03,0.215D+03,0.490D+02,0.20102000D+01,0.00000000D+00
     .,0.32794600D+03,0.215D+03,0.500D+02,0.20102000D+01,0.00000000D+00
     .,0.29361680D+03,0.215D+03,0.510D+02,0.20102000D+01,0.00000000D+00
     .,0.27309200D+03,0.215D+03,0.520D+02,0.20102000D+01,0.00000000D+00
     .,0.24747320D+03,0.215D+03,0.530D+02,0.20102000D+01,0.00000000D+00
     .,0.22286600D+03,0.215D+03,0.540D+02,0.20102000D+01,0.00000000D+00
     .,0.90172930D+03,0.215D+03,0.550D+02,0.20102000D+01,0.00000000D+00
     .,0.83699700D+03,0.215D+03,0.560D+02,0.20102000D+01,0.00000000D+00
     .,0.73956740D+03,0.215D+03,0.570D+02,0.20102000D+01,0.00000000D+00
     .,0.34646750D+03,0.215D+03,0.580D+02,0.20102000D+01,0.27991000D+01
     .,0.74267020D+03,0.215D+03,0.590D+02,0.20102000D+01,0.00000000D+00
     .,0.71379130D+03,0.215D+03,0.600D+02,0.20102000D+01,0.00000000D+00
     .,0.69606280D+03,0.215D+03,0.610D+02,0.20102000D+01,0.00000000D+00
     .,0.67974330D+03,0.215D+03,0.620D+02,0.20102000D+01,0.00000000D+00
     .,0.66528190D+03,0.215D+03,0.630D+02,0.20102000D+01,0.00000000D+00
     .,0.52618270D+03,0.215D+03,0.640D+02,0.20102000D+01,0.00000000D+00
     .,0.58709720D+03,0.215D+03,0.650D+02,0.20102000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  90101:  90200)=(/
     . 0.56687340D+03,0.215D+03,0.660D+02,0.20102000D+01,0.00000000D+00
     .,0.60088550D+03,0.215D+03,0.670D+02,0.20102000D+01,0.00000000D+00
     .,0.58822970D+03,0.215D+03,0.680D+02,0.20102000D+01,0.00000000D+00
     .,0.57686430D+03,0.215D+03,0.690D+02,0.20102000D+01,0.00000000D+00
     .,0.56998510D+03,0.215D+03,0.700D+02,0.20102000D+01,0.00000000D+00
     .,0.48216270D+03,0.215D+03,0.710D+02,0.20102000D+01,0.00000000D+00
     .,0.47707590D+03,0.215D+03,0.720D+02,0.20102000D+01,0.00000000D+00
     .,0.43667570D+03,0.215D+03,0.730D+02,0.20102000D+01,0.00000000D+00
     .,0.36935120D+03,0.215D+03,0.740D+02,0.20102000D+01,0.00000000D+00
     .,0.37621900D+03,0.215D+03,0.750D+02,0.20102000D+01,0.00000000D+00
     .,0.34171560D+03,0.215D+03,0.760D+02,0.20102000D+01,0.00000000D+00
     .,0.31344980D+03,0.215D+03,0.770D+02,0.20102000D+01,0.00000000D+00
     .,0.26059070D+03,0.215D+03,0.780D+02,0.20102000D+01,0.00000000D+00
     .,0.24352110D+03,0.215D+03,0.790D+02,0.20102000D+01,0.00000000D+00
     .,0.25084270D+03,0.215D+03,0.800D+02,0.20102000D+01,0.00000000D+00
     .,0.36225560D+03,0.215D+03,0.810D+02,0.20102000D+01,0.00000000D+00
     .,0.35571630D+03,0.215D+03,0.820D+02,0.20102000D+01,0.00000000D+00
     .,0.32825370D+03,0.215D+03,0.830D+02,0.20102000D+01,0.00000000D+00
     .,0.31378020D+03,0.215D+03,0.840D+02,0.20102000D+01,0.00000000D+00
     .,0.29026290D+03,0.215D+03,0.850D+02,0.20102000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  90201:  90300)=(/
     . 0.26650630D+03,0.215D+03,0.860D+02,0.20102000D+01,0.00000000D+00
     .,0.85532140D+03,0.215D+03,0.870D+02,0.20102000D+01,0.00000000D+00
     .,0.83008340D+03,0.215D+03,0.880D+02,0.20102000D+01,0.00000000D+00
     .,0.73740950D+03,0.215D+03,0.890D+02,0.20102000D+01,0.00000000D+00
     .,0.66621410D+03,0.215D+03,0.900D+02,0.20102000D+01,0.00000000D+00
     .,0.65937380D+03,0.215D+03,0.910D+02,0.20102000D+01,0.00000000D+00
     .,0.63846460D+03,0.215D+03,0.920D+02,0.20102000D+01,0.00000000D+00
     .,0.65489730D+03,0.215D+03,0.930D+02,0.20102000D+01,0.00000000D+00
     .,0.63460740D+03,0.215D+03,0.940D+02,0.20102000D+01,0.00000000D+00
     .,0.36493600D+02,0.215D+03,0.101D+03,0.20102000D+01,0.00000000D+00
     .,0.11639410D+03,0.215D+03,0.103D+03,0.20102000D+01,0.98650000D+00
     .,0.14881940D+03,0.215D+03,0.104D+03,0.20102000D+01,0.98080000D+00
     .,0.11479680D+03,0.215D+03,0.105D+03,0.20102000D+01,0.97060000D+00
     .,0.86812800D+02,0.215D+03,0.106D+03,0.20102000D+01,0.98680000D+00
     .,0.60508500D+02,0.215D+03,0.107D+03,0.20102000D+01,0.99440000D+00
     .,0.44090400D+02,0.215D+03,0.108D+03,0.20102000D+01,0.99250000D+00
     .,0.30289400D+02,0.215D+03,0.109D+03,0.20102000D+01,0.99820000D+00
     .,0.16956980D+03,0.215D+03,0.111D+03,0.20102000D+01,0.96840000D+00
     .,0.26216960D+03,0.215D+03,0.112D+03,0.20102000D+01,0.96280000D+00
     .,0.26714040D+03,0.215D+03,0.113D+03,0.20102000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  90301:  90400)=(/
     . 0.21636930D+03,0.215D+03,0.114D+03,0.20102000D+01,0.95070000D+00
     .,0.17806220D+03,0.215D+03,0.115D+03,0.20102000D+01,0.99470000D+00
     .,0.15093640D+03,0.215D+03,0.116D+03,0.20102000D+01,0.99480000D+00
     .,0.12360110D+03,0.215D+03,0.117D+03,0.20102000D+01,0.99720000D+00
     .,0.23449210D+03,0.215D+03,0.119D+03,0.20102000D+01,0.97670000D+00
     .,0.44207020D+03,0.215D+03,0.120D+03,0.20102000D+01,0.98310000D+00
     .,0.23629650D+03,0.215D+03,0.121D+03,0.20102000D+01,0.18627000D+01
     .,0.22810870D+03,0.215D+03,0.122D+03,0.20102000D+01,0.18299000D+01
     .,0.22347840D+03,0.215D+03,0.123D+03,0.20102000D+01,0.19138000D+01
     .,0.22119860D+03,0.215D+03,0.124D+03,0.20102000D+01,0.18269000D+01
     .,0.20433190D+03,0.215D+03,0.125D+03,0.20102000D+01,0.16406000D+01
     .,0.18924970D+03,0.215D+03,0.126D+03,0.20102000D+01,0.16483000D+01
     .,0.18048460D+03,0.215D+03,0.127D+03,0.20102000D+01,0.17149000D+01
     .,0.17637500D+03,0.215D+03,0.128D+03,0.20102000D+01,0.17937000D+01
     .,0.17370060D+03,0.215D+03,0.129D+03,0.20102000D+01,0.95760000D+00
     .,0.16388840D+03,0.215D+03,0.130D+03,0.20102000D+01,0.19419000D+01
     .,0.26564070D+03,0.215D+03,0.131D+03,0.20102000D+01,0.96010000D+00
     .,0.23477850D+03,0.215D+03,0.132D+03,0.20102000D+01,0.94340000D+00
     .,0.21123800D+03,0.215D+03,0.133D+03,0.20102000D+01,0.98890000D+00
     .,0.19329960D+03,0.215D+03,0.134D+03,0.20102000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters(  90401:  90500)=(/
     . 0.17058580D+03,0.215D+03,0.135D+03,0.20102000D+01,0.99740000D+00
     .,0.28011830D+03,0.215D+03,0.137D+03,0.20102000D+01,0.97380000D+00
     .,0.53743520D+03,0.215D+03,0.138D+03,0.20102000D+01,0.98010000D+00
     .,0.41535780D+03,0.215D+03,0.139D+03,0.20102000D+01,0.19153000D+01
     .,0.31230500D+03,0.215D+03,0.140D+03,0.20102000D+01,0.19355000D+01
     .,0.31527630D+03,0.215D+03,0.141D+03,0.20102000D+01,0.19545000D+01
     .,0.29424360D+03,0.215D+03,0.142D+03,0.20102000D+01,0.19420000D+01
     .,0.32833170D+03,0.215D+03,0.143D+03,0.20102000D+01,0.16682000D+01
     .,0.25720590D+03,0.215D+03,0.144D+03,0.20102000D+01,0.18584000D+01
     .,0.24057510D+03,0.215D+03,0.145D+03,0.20102000D+01,0.19003000D+01
     .,0.22341250D+03,0.215D+03,0.146D+03,0.20102000D+01,0.18630000D+01
     .,0.21594190D+03,0.215D+03,0.147D+03,0.20102000D+01,0.96790000D+00
     .,0.21429840D+03,0.215D+03,0.148D+03,0.20102000D+01,0.19539000D+01
     .,0.33682850D+03,0.215D+03,0.149D+03,0.20102000D+01,0.96330000D+00
     .,0.30637120D+03,0.215D+03,0.150D+03,0.20102000D+01,0.95140000D+00
     .,0.28792660D+03,0.215D+03,0.151D+03,0.20102000D+01,0.97490000D+00
     .,0.27294170D+03,0.215D+03,0.152D+03,0.20102000D+01,0.98110000D+00
     .,0.24979920D+03,0.215D+03,0.153D+03,0.20102000D+01,0.99680000D+00
     .,0.33288760D+03,0.215D+03,0.155D+03,0.20102000D+01,0.99090000D+00
     .,0.69526390D+03,0.215D+03,0.156D+03,0.20102000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters(  90501:  90600)=(/
     . 0.52525150D+03,0.215D+03,0.157D+03,0.20102000D+01,0.19373000D+01
     .,0.33608240D+03,0.215D+03,0.159D+03,0.20102000D+01,0.29425000D+01
     .,0.32913430D+03,0.215D+03,0.160D+03,0.20102000D+01,0.29455000D+01
     .,0.31875390D+03,0.215D+03,0.161D+03,0.20102000D+01,0.29413000D+01
     .,0.32010570D+03,0.215D+03,0.162D+03,0.20102000D+01,0.29300000D+01
     .,0.30771680D+03,0.215D+03,0.163D+03,0.20102000D+01,0.18286000D+01
     .,0.32211770D+03,0.215D+03,0.164D+03,0.20102000D+01,0.28732000D+01
     .,0.30266100D+03,0.215D+03,0.165D+03,0.20102000D+01,0.29086000D+01
     .,0.30757360D+03,0.215D+03,0.166D+03,0.20102000D+01,0.28965000D+01
     .,0.28745570D+03,0.215D+03,0.167D+03,0.20102000D+01,0.29242000D+01
     .,0.27932320D+03,0.215D+03,0.168D+03,0.20102000D+01,0.29282000D+01
     .,0.27749490D+03,0.215D+03,0.169D+03,0.20102000D+01,0.29246000D+01
     .,0.29150550D+03,0.215D+03,0.170D+03,0.20102000D+01,0.28482000D+01
     .,0.26832640D+03,0.215D+03,0.171D+03,0.20102000D+01,0.29219000D+01
     .,0.36072920D+03,0.215D+03,0.172D+03,0.20102000D+01,0.19254000D+01
     .,0.33564790D+03,0.215D+03,0.173D+03,0.20102000D+01,0.19459000D+01
     .,0.30701360D+03,0.215D+03,0.174D+03,0.20102000D+01,0.19292000D+01
     .,0.30982750D+03,0.215D+03,0.175D+03,0.20102000D+01,0.18104000D+01
     .,0.27286500D+03,0.215D+03,0.176D+03,0.20102000D+01,0.18858000D+01
     .,0.25678780D+03,0.215D+03,0.177D+03,0.20102000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters(  90601:  90700)=(/
     . 0.24528060D+03,0.215D+03,0.178D+03,0.20102000D+01,0.19188000D+01
     .,0.23433320D+03,0.215D+03,0.179D+03,0.20102000D+01,0.98460000D+00
     .,0.22697090D+03,0.215D+03,0.180D+03,0.20102000D+01,0.19896000D+01
     .,0.36172460D+03,0.215D+03,0.181D+03,0.20102000D+01,0.92670000D+00
     .,0.33138450D+03,0.215D+03,0.182D+03,0.20102000D+01,0.93830000D+00
     .,0.32226070D+03,0.215D+03,0.183D+03,0.20102000D+01,0.98200000D+00
     .,0.31398590D+03,0.215D+03,0.184D+03,0.20102000D+01,0.98150000D+00
     .,0.29381590D+03,0.215D+03,0.185D+03,0.20102000D+01,0.99540000D+00
     .,0.37507170D+03,0.215D+03,0.187D+03,0.20102000D+01,0.97050000D+00
     .,0.69405520D+03,0.215D+03,0.188D+03,0.20102000D+01,0.96620000D+00
     .,0.39772110D+03,0.215D+03,0.189D+03,0.20102000D+01,0.29070000D+01
     .,0.45702730D+03,0.215D+03,0.190D+03,0.20102000D+01,0.28844000D+01
     .,0.40899300D+03,0.215D+03,0.191D+03,0.20102000D+01,0.28738000D+01
     .,0.36253380D+03,0.215D+03,0.192D+03,0.20102000D+01,0.28878000D+01
     .,0.34905070D+03,0.215D+03,0.193D+03,0.20102000D+01,0.29095000D+01
     .,0.41613190D+03,0.215D+03,0.194D+03,0.20102000D+01,0.19209000D+01
     .,0.98185900D+02,0.215D+03,0.204D+03,0.20102000D+01,0.19697000D+01
     .,0.96532400D+02,0.215D+03,0.205D+03,0.20102000D+01,0.19441000D+01
     .,0.70926900D+02,0.215D+03,0.206D+03,0.20102000D+01,0.19985000D+01
     .,0.56798100D+02,0.215D+03,0.207D+03,0.20102000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters(  90701:  90800)=(/
     . 0.38857800D+02,0.215D+03,0.208D+03,0.20102000D+01,0.19887000D+01
     .,0.17322270D+03,0.215D+03,0.212D+03,0.20102000D+01,0.19496000D+01
     .,0.20920610D+03,0.215D+03,0.213D+03,0.20102000D+01,0.19311000D+01
     .,0.20144650D+03,0.215D+03,0.214D+03,0.20102000D+01,0.19435000D+01
     .,0.17555340D+03,0.215D+03,0.215D+03,0.20102000D+01,0.20102000D+01
     .,0.19472900D+02,0.216D+03,0.100D+01,0.19903000D+01,0.91180000D+00
     .,0.13209000D+02,0.216D+03,0.200D+01,0.19903000D+01,0.00000000D+00
     .,0.26554640D+03,0.216D+03,0.300D+01,0.19903000D+01,0.00000000D+00
     .,0.16268750D+03,0.216D+03,0.400D+01,0.19903000D+01,0.00000000D+00
     .,0.11343240D+03,0.216D+03,0.500D+01,0.19903000D+01,0.00000000D+00
     .,0.78572900D+02,0.216D+03,0.600D+01,0.19903000D+01,0.00000000D+00
     .,0.55913600D+02,0.216D+03,0.700D+01,0.19903000D+01,0.00000000D+00
     .,0.42824500D+02,0.216D+03,0.800D+01,0.19903000D+01,0.00000000D+00
     .,0.32736500D+02,0.216D+03,0.900D+01,0.19903000D+01,0.00000000D+00
     .,0.25343500D+02,0.216D+03,0.100D+02,0.19903000D+01,0.00000000D+00
     .,0.31871200D+03,0.216D+03,0.110D+02,0.19903000D+01,0.00000000D+00
     .,0.25643150D+03,0.216D+03,0.120D+02,0.19903000D+01,0.00000000D+00
     .,0.24071650D+03,0.216D+03,0.130D+02,0.19903000D+01,0.00000000D+00
     .,0.19423140D+03,0.216D+03,0.140D+02,0.19903000D+01,0.00000000D+00
     .,0.15449350D+03,0.216D+03,0.150D+02,0.19903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  90801:  90900)=(/
     . 0.12984130D+03,0.216D+03,0.160D+02,0.19903000D+01,0.00000000D+00
     .,0.10729640D+03,0.216D+03,0.170D+02,0.19903000D+01,0.00000000D+00
     .,0.88626800D+02,0.216D+03,0.180D+02,0.19903000D+01,0.00000000D+00
     .,0.51938020D+03,0.216D+03,0.190D+02,0.19903000D+01,0.00000000D+00
     .,0.44287350D+03,0.216D+03,0.200D+02,0.19903000D+01,0.00000000D+00
     .,0.36871310D+03,0.216D+03,0.210D+02,0.19903000D+01,0.00000000D+00
     .,0.35885540D+03,0.216D+03,0.220D+02,0.19903000D+01,0.00000000D+00
     .,0.33009380D+03,0.216D+03,0.230D+02,0.19903000D+01,0.00000000D+00
     .,0.26056470D+03,0.216D+03,0.240D+02,0.19903000D+01,0.00000000D+00
     .,0.28605270D+03,0.216D+03,0.250D+02,0.19903000D+01,0.00000000D+00
     .,0.22513570D+03,0.216D+03,0.260D+02,0.19903000D+01,0.00000000D+00
     .,0.24051750D+03,0.216D+03,0.270D+02,0.19903000D+01,0.00000000D+00
     .,0.24658640D+03,0.216D+03,0.280D+02,0.19903000D+01,0.00000000D+00
     .,0.18941220D+03,0.216D+03,0.290D+02,0.19903000D+01,0.00000000D+00
     .,0.19693310D+03,0.216D+03,0.300D+02,0.19903000D+01,0.00000000D+00
     .,0.23234090D+03,0.216D+03,0.310D+02,0.19903000D+01,0.00000000D+00
     .,0.20856850D+03,0.216D+03,0.320D+02,0.19903000D+01,0.00000000D+00
     .,0.18080070D+03,0.216D+03,0.330D+02,0.19903000D+01,0.00000000D+00
     .,0.16386810D+03,0.216D+03,0.340D+02,0.19903000D+01,0.00000000D+00
     .,0.14483870D+03,0.216D+03,0.350D+02,0.19903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  90901:  91000)=(/
     . 0.12707910D+03,0.216D+03,0.360D+02,0.19903000D+01,0.00000000D+00
     .,0.58437840D+03,0.216D+03,0.370D+02,0.19903000D+01,0.00000000D+00
     .,0.52738380D+03,0.216D+03,0.380D+02,0.19903000D+01,0.00000000D+00
     .,0.46852690D+03,0.216D+03,0.390D+02,0.19903000D+01,0.00000000D+00
     .,0.42487480D+03,0.216D+03,0.400D+02,0.19903000D+01,0.00000000D+00
     .,0.38978890D+03,0.216D+03,0.410D+02,0.19903000D+01,0.00000000D+00
     .,0.30421090D+03,0.216D+03,0.420D+02,0.19903000D+01,0.00000000D+00
     .,0.33802960D+03,0.216D+03,0.430D+02,0.19903000D+01,0.00000000D+00
     .,0.26053350D+03,0.216D+03,0.440D+02,0.19903000D+01,0.00000000D+00
     .,0.28446820D+03,0.216D+03,0.450D+02,0.19903000D+01,0.00000000D+00
     .,0.26473450D+03,0.216D+03,0.460D+02,0.19903000D+01,0.00000000D+00
     .,0.22055850D+03,0.216D+03,0.470D+02,0.19903000D+01,0.00000000D+00
     .,0.23431540D+03,0.216D+03,0.480D+02,0.19903000D+01,0.00000000D+00
     .,0.29072550D+03,0.216D+03,0.490D+02,0.19903000D+01,0.00000000D+00
     .,0.27258810D+03,0.216D+03,0.500D+02,0.19903000D+01,0.00000000D+00
     .,0.24633500D+03,0.216D+03,0.510D+02,0.19903000D+01,0.00000000D+00
     .,0.23051370D+03,0.216D+03,0.520D+02,0.19903000D+01,0.00000000D+00
     .,0.21031760D+03,0.216D+03,0.530D+02,0.19903000D+01,0.00000000D+00
     .,0.19068220D+03,0.216D+03,0.540D+02,0.19903000D+01,0.00000000D+00
     .,0.71322290D+03,0.216D+03,0.550D+02,0.19903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  91001:  91100)=(/
     . 0.66991060D+03,0.216D+03,0.560D+02,0.19903000D+01,0.00000000D+00
     .,0.59671860D+03,0.216D+03,0.570D+02,0.19903000D+01,0.00000000D+00
     .,0.29045550D+03,0.216D+03,0.580D+02,0.19903000D+01,0.27991000D+01
     .,0.59619860D+03,0.216D+03,0.590D+02,0.19903000D+01,0.00000000D+00
     .,0.57368400D+03,0.216D+03,0.600D+02,0.19903000D+01,0.00000000D+00
     .,0.55961080D+03,0.216D+03,0.610D+02,0.19903000D+01,0.00000000D+00
     .,0.54662920D+03,0.216D+03,0.620D+02,0.19903000D+01,0.00000000D+00
     .,0.53513180D+03,0.216D+03,0.630D+02,0.19903000D+01,0.00000000D+00
     .,0.42773380D+03,0.216D+03,0.640D+02,0.19903000D+01,0.00000000D+00
     .,0.47158580D+03,0.216D+03,0.650D+02,0.19903000D+01,0.00000000D+00
     .,0.45610620D+03,0.216D+03,0.660D+02,0.19903000D+01,0.00000000D+00
     .,0.48421010D+03,0.216D+03,0.670D+02,0.19903000D+01,0.00000000D+00
     .,0.47407530D+03,0.216D+03,0.680D+02,0.19903000D+01,0.00000000D+00
     .,0.46503260D+03,0.216D+03,0.690D+02,0.19903000D+01,0.00000000D+00
     .,0.45926340D+03,0.216D+03,0.700D+02,0.19903000D+01,0.00000000D+00
     .,0.39129390D+03,0.216D+03,0.710D+02,0.19903000D+01,0.00000000D+00
     .,0.39032880D+03,0.216D+03,0.720D+02,0.19903000D+01,0.00000000D+00
     .,0.35937970D+03,0.216D+03,0.730D+02,0.19903000D+01,0.00000000D+00
     .,0.30582610D+03,0.216D+03,0.740D+02,0.19903000D+01,0.00000000D+00
     .,0.31204680D+03,0.216D+03,0.750D+02,0.19903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  91101:  91200)=(/
     . 0.28491830D+03,0.216D+03,0.760D+02,0.19903000D+01,0.00000000D+00
     .,0.26249830D+03,0.216D+03,0.770D+02,0.19903000D+01,0.00000000D+00
     .,0.21953350D+03,0.216D+03,0.780D+02,0.19903000D+01,0.00000000D+00
     .,0.20562600D+03,0.216D+03,0.790D+02,0.19903000D+01,0.00000000D+00
     .,0.21201590D+03,0.216D+03,0.800D+02,0.19903000D+01,0.00000000D+00
     .,0.29991980D+03,0.216D+03,0.810D+02,0.19903000D+01,0.00000000D+00
     .,0.29620520D+03,0.216D+03,0.820D+02,0.19903000D+01,0.00000000D+00
     .,0.27549690D+03,0.216D+03,0.830D+02,0.19903000D+01,0.00000000D+00
     .,0.26464810D+03,0.216D+03,0.840D+02,0.19903000D+01,0.00000000D+00
     .,0.24633950D+03,0.216D+03,0.850D+02,0.19903000D+01,0.00000000D+00
     .,0.22753380D+03,0.216D+03,0.860D+02,0.19903000D+01,0.00000000D+00
     .,0.68102410D+03,0.216D+03,0.870D+02,0.19903000D+01,0.00000000D+00
     .,0.66741950D+03,0.216D+03,0.880D+02,0.19903000D+01,0.00000000D+00
     .,0.59723200D+03,0.216D+03,0.890D+02,0.19903000D+01,0.00000000D+00
     .,0.54474490D+03,0.216D+03,0.900D+02,0.19903000D+01,0.00000000D+00
     .,0.53715360D+03,0.216D+03,0.910D+02,0.19903000D+01,0.00000000D+00
     .,0.52027520D+03,0.216D+03,0.920D+02,0.19903000D+01,0.00000000D+00
     .,0.53064210D+03,0.216D+03,0.930D+02,0.19903000D+01,0.00000000D+00
     .,0.51469140D+03,0.216D+03,0.940D+02,0.19903000D+01,0.00000000D+00
     .,0.30774700D+02,0.216D+03,0.101D+03,0.19903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  91201:  91300)=(/
     . 0.95053100D+02,0.216D+03,0.103D+03,0.19903000D+01,0.98650000D+00
     .,0.12215340D+03,0.216D+03,0.104D+03,0.19903000D+01,0.98080000D+00
     .,0.96110000D+02,0.216D+03,0.105D+03,0.19903000D+01,0.97060000D+00
     .,0.73700600D+02,0.216D+03,0.106D+03,0.19903000D+01,0.98680000D+00
     .,0.52175300D+02,0.216D+03,0.107D+03,0.19903000D+01,0.99440000D+00
     .,0.38527600D+02,0.216D+03,0.108D+03,0.19903000D+01,0.99250000D+00
     .,0.26916300D+02,0.216D+03,0.109D+03,0.19903000D+01,0.99820000D+00
     .,0.13811660D+03,0.216D+03,0.111D+03,0.19903000D+01,0.96840000D+00
     .,0.21310360D+03,0.216D+03,0.112D+03,0.19903000D+01,0.96280000D+00
     .,0.21912850D+03,0.216D+03,0.113D+03,0.19903000D+01,0.96480000D+00
     .,0.18016220D+03,0.216D+03,0.114D+03,0.19903000D+01,0.95070000D+00
     .,0.15007480D+03,0.216D+03,0.115D+03,0.19903000D+01,0.99470000D+00
     .,0.12837640D+03,0.216D+03,0.116D+03,0.19903000D+01,0.99480000D+00
     .,0.10616060D+03,0.216D+03,0.117D+03,0.19903000D+01,0.99720000D+00
     .,0.19334120D+03,0.216D+03,0.119D+03,0.19903000D+01,0.97670000D+00
     .,0.35561610D+03,0.216D+03,0.120D+03,0.19903000D+01,0.98310000D+00
     .,0.19666010D+03,0.216D+03,0.121D+03,0.19903000D+01,0.18627000D+01
     .,0.19002900D+03,0.216D+03,0.122D+03,0.19903000D+01,0.18299000D+01
     .,0.18615760D+03,0.216D+03,0.123D+03,0.19903000D+01,0.19138000D+01
     .,0.18402800D+03,0.216D+03,0.124D+03,0.19903000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters(  91301:  91400)=(/
     . 0.17103060D+03,0.216D+03,0.125D+03,0.19903000D+01,0.16406000D+01
     .,0.15879330D+03,0.216D+03,0.126D+03,0.19903000D+01,0.16483000D+01
     .,0.15149830D+03,0.216D+03,0.127D+03,0.19903000D+01,0.17149000D+01
     .,0.14797530D+03,0.216D+03,0.128D+03,0.19903000D+01,0.17937000D+01
     .,0.14502500D+03,0.216D+03,0.129D+03,0.19903000D+01,0.95760000D+00
     .,0.13803960D+03,0.216D+03,0.130D+03,0.19903000D+01,0.19419000D+01
     .,0.21921940D+03,0.216D+03,0.131D+03,0.19903000D+01,0.96010000D+00
     .,0.19595580D+03,0.216D+03,0.132D+03,0.19903000D+01,0.94340000D+00
     .,0.17790880D+03,0.216D+03,0.133D+03,0.19903000D+01,0.98890000D+00
     .,0.16390830D+03,0.216D+03,0.134D+03,0.19903000D+01,0.99010000D+00
     .,0.14577240D+03,0.216D+03,0.135D+03,0.19903000D+01,0.99740000D+00
     .,0.23172650D+03,0.216D+03,0.137D+03,0.19903000D+01,0.97380000D+00
     .,0.43227830D+03,0.216D+03,0.138D+03,0.19903000D+01,0.98010000D+00
     .,0.33980820D+03,0.216D+03,0.139D+03,0.19903000D+01,0.19153000D+01
     .,0.25999910D+03,0.216D+03,0.140D+03,0.19903000D+01,0.19355000D+01
     .,0.26242950D+03,0.216D+03,0.141D+03,0.19903000D+01,0.19545000D+01
     .,0.24567190D+03,0.216D+03,0.142D+03,0.19903000D+01,0.19420000D+01
     .,0.27194340D+03,0.216D+03,0.143D+03,0.19903000D+01,0.16682000D+01
     .,0.21620660D+03,0.216D+03,0.144D+03,0.19903000D+01,0.18584000D+01
     .,0.20248030D+03,0.216D+03,0.145D+03,0.19903000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters(  91401:  91500)=(/
     . 0.18837520D+03,0.216D+03,0.146D+03,0.19903000D+01,0.18630000D+01
     .,0.18191000D+03,0.216D+03,0.147D+03,0.19903000D+01,0.96790000D+00
     .,0.18125820D+03,0.216D+03,0.148D+03,0.19903000D+01,0.19539000D+01
     .,0.27850870D+03,0.216D+03,0.149D+03,0.19903000D+01,0.96330000D+00
     .,0.25563360D+03,0.216D+03,0.150D+03,0.19903000D+01,0.95140000D+00
     .,0.24188440D+03,0.216D+03,0.151D+03,0.19903000D+01,0.97490000D+00
     .,0.23047020D+03,0.216D+03,0.152D+03,0.19903000D+01,0.98110000D+00
     .,0.21226280D+03,0.216D+03,0.153D+03,0.19903000D+01,0.99680000D+00
     .,0.27721210D+03,0.216D+03,0.155D+03,0.19903000D+01,0.99090000D+00
     .,0.55799180D+03,0.216D+03,0.156D+03,0.19903000D+01,0.97970000D+00
     .,0.42930150D+03,0.216D+03,0.157D+03,0.19903000D+01,0.19373000D+01
     .,0.28192380D+03,0.216D+03,0.159D+03,0.19903000D+01,0.29425000D+01
     .,0.27612630D+03,0.216D+03,0.160D+03,0.19903000D+01,0.29455000D+01
     .,0.26756270D+03,0.216D+03,0.161D+03,0.19903000D+01,0.29413000D+01
     .,0.26833820D+03,0.216D+03,0.162D+03,0.19903000D+01,0.29300000D+01
     .,0.25690680D+03,0.216D+03,0.163D+03,0.19903000D+01,0.18286000D+01
     .,0.26982370D+03,0.216D+03,0.164D+03,0.19903000D+01,0.28732000D+01
     .,0.25386320D+03,0.216D+03,0.165D+03,0.19903000D+01,0.29086000D+01
     .,0.25739270D+03,0.216D+03,0.166D+03,0.19903000D+01,0.28965000D+01
     .,0.24138000D+03,0.216D+03,0.167D+03,0.19903000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters(  91501:  91600)=(/
     . 0.23465510D+03,0.216D+03,0.168D+03,0.19903000D+01,0.29282000D+01
     .,0.23302060D+03,0.216D+03,0.169D+03,0.19903000D+01,0.29246000D+01
     .,0.24417040D+03,0.216D+03,0.170D+03,0.19903000D+01,0.28482000D+01
     .,0.22545330D+03,0.216D+03,0.171D+03,0.19903000D+01,0.29219000D+01
     .,0.29846420D+03,0.216D+03,0.172D+03,0.19903000D+01,0.19254000D+01
     .,0.27931410D+03,0.216D+03,0.173D+03,0.19903000D+01,0.19459000D+01
     .,0.25702350D+03,0.216D+03,0.174D+03,0.19903000D+01,0.19292000D+01
     .,0.25811720D+03,0.216D+03,0.175D+03,0.19903000D+01,0.18104000D+01
     .,0.23037700D+03,0.216D+03,0.176D+03,0.19903000D+01,0.18858000D+01
     .,0.21735740D+03,0.216D+03,0.177D+03,0.19903000D+01,0.18648000D+01
     .,0.20795360D+03,0.216D+03,0.178D+03,0.19903000D+01,0.19188000D+01
     .,0.19875510D+03,0.216D+03,0.179D+03,0.19903000D+01,0.98460000D+00
     .,0.19332900D+03,0.216D+03,0.180D+03,0.19903000D+01,0.19896000D+01
     .,0.30009690D+03,0.216D+03,0.181D+03,0.19903000D+01,0.92670000D+00
     .,0.27730190D+03,0.216D+03,0.182D+03,0.19903000D+01,0.93830000D+00
     .,0.27095850D+03,0.216D+03,0.183D+03,0.19903000D+01,0.98200000D+00
     .,0.26500160D+03,0.216D+03,0.184D+03,0.19903000D+01,0.98150000D+00
     .,0.24934960D+03,0.216D+03,0.185D+03,0.19903000D+01,0.99540000D+00
     .,0.31247270D+03,0.216D+03,0.187D+03,0.19903000D+01,0.97050000D+00
     .,0.55992810D+03,0.216D+03,0.188D+03,0.19903000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters(  91601:  91700)=(/
     . 0.33346380D+03,0.216D+03,0.189D+03,0.19903000D+01,0.29070000D+01
     .,0.38050360D+03,0.216D+03,0.190D+03,0.19903000D+01,0.28844000D+01
     .,0.34179510D+03,0.216D+03,0.191D+03,0.19903000D+01,0.28738000D+01
     .,0.30467440D+03,0.216D+03,0.192D+03,0.19903000D+01,0.28878000D+01
     .,0.29376970D+03,0.216D+03,0.193D+03,0.19903000D+01,0.29095000D+01
     .,0.34471170D+03,0.216D+03,0.194D+03,0.19903000D+01,0.19209000D+01
     .,0.82197300D+02,0.216D+03,0.204D+03,0.19903000D+01,0.19697000D+01
     .,0.81269300D+02,0.216D+03,0.205D+03,0.19903000D+01,0.19441000D+01
     .,0.60669000D+02,0.216D+03,0.206D+03,0.19903000D+01,0.19985000D+01
     .,0.49062900D+02,0.216D+03,0.207D+03,0.19903000D+01,0.20143000D+01
     .,0.34104200D+02,0.216D+03,0.208D+03,0.19903000D+01,0.19887000D+01
     .,0.14355230D+03,0.216D+03,0.212D+03,0.19903000D+01,0.19496000D+01
     .,0.17327790D+03,0.216D+03,0.213D+03,0.19903000D+01,0.19311000D+01
     .,0.16813020D+03,0.216D+03,0.214D+03,0.19903000D+01,0.19435000D+01
     .,0.14787500D+03,0.216D+03,0.215D+03,0.19903000D+01,0.20102000D+01
     .,0.12581090D+03,0.216D+03,0.216D+03,0.19903000D+01,0.19903000D+01
     .,0.30678300D+02,0.220D+03,0.100D+01,0.19349000D+01,0.91180000D+00
     .,0.19724700D+02,0.220D+03,0.200D+01,0.19349000D+01,0.00000000D+00
     .,0.52531960D+03,0.220D+03,0.300D+01,0.19349000D+01,0.00000000D+00
     .,0.29170210D+03,0.220D+03,0.400D+01,0.19349000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  91701:  91800)=(/
     . 0.19141350D+03,0.220D+03,0.500D+01,0.19349000D+01,0.00000000D+00
     .,0.12668360D+03,0.220D+03,0.600D+01,0.19349000D+01,0.00000000D+00
     .,0.87190600D+02,0.220D+03,0.700D+01,0.19349000D+01,0.00000000D+00
     .,0.65252500D+02,0.220D+03,0.800D+01,0.19349000D+01,0.00000000D+00
     .,0.48933100D+02,0.220D+03,0.900D+01,0.19349000D+01,0.00000000D+00
     .,0.37325800D+02,0.220D+03,0.100D+02,0.19349000D+01,0.00000000D+00
     .,0.62655260D+03,0.220D+03,0.110D+02,0.19349000D+01,0.00000000D+00
     .,0.46815270D+03,0.220D+03,0.120D+02,0.19349000D+01,0.00000000D+00
     .,0.42605680D+03,0.220D+03,0.130D+02,0.19349000D+01,0.00000000D+00
     .,0.32981710D+03,0.220D+03,0.140D+02,0.19349000D+01,0.00000000D+00
     .,0.25315190D+03,0.220D+03,0.150D+02,0.19349000D+01,0.00000000D+00
     .,0.20785310D+03,0.220D+03,0.160D+02,0.19349000D+01,0.00000000D+00
     .,0.16800650D+03,0.220D+03,0.170D+02,0.19349000D+01,0.00000000D+00
     .,0.13616380D+03,0.220D+03,0.180D+02,0.19349000D+01,0.00000000D+00
     .,0.10305394D+04,0.220D+03,0.190D+02,0.19349000D+01,0.00000000D+00
     .,0.83223790D+03,0.220D+03,0.200D+02,0.19349000D+01,0.00000000D+00
     .,0.68387860D+03,0.220D+03,0.210D+02,0.19349000D+01,0.00000000D+00
     .,0.65674740D+03,0.220D+03,0.220D+02,0.19349000D+01,0.00000000D+00
     .,0.59945210D+03,0.220D+03,0.230D+02,0.19349000D+01,0.00000000D+00
     .,0.47138320D+03,0.220D+03,0.240D+02,0.19349000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  91801:  91900)=(/
     . 0.51365160D+03,0.220D+03,0.250D+02,0.19349000D+01,0.00000000D+00
     .,0.40218720D+03,0.220D+03,0.260D+02,0.19349000D+01,0.00000000D+00
     .,0.42395230D+03,0.220D+03,0.270D+02,0.19349000D+01,0.00000000D+00
     .,0.43824820D+03,0.220D+03,0.280D+02,0.19349000D+01,0.00000000D+00
     .,0.33535920D+03,0.220D+03,0.290D+02,0.19349000D+01,0.00000000D+00
     .,0.34119230D+03,0.220D+03,0.300D+02,0.19349000D+01,0.00000000D+00
     .,0.40564880D+03,0.220D+03,0.310D+02,0.19349000D+01,0.00000000D+00
     .,0.35293360D+03,0.220D+03,0.320D+02,0.19349000D+01,0.00000000D+00
     .,0.29714260D+03,0.220D+03,0.330D+02,0.19349000D+01,0.00000000D+00
     .,0.26437900D+03,0.220D+03,0.340D+02,0.19349000D+01,0.00000000D+00
     .,0.22931470D+03,0.220D+03,0.350D+02,0.19349000D+01,0.00000000D+00
     .,0.19776450D+03,0.220D+03,0.360D+02,0.19349000D+01,0.00000000D+00
     .,0.11520197D+04,0.220D+03,0.370D+02,0.19349000D+01,0.00000000D+00
     .,0.99191430D+03,0.220D+03,0.380D+02,0.19349000D+01,0.00000000D+00
     .,0.86032290D+03,0.220D+03,0.390D+02,0.19349000D+01,0.00000000D+00
     .,0.76820000D+03,0.220D+03,0.400D+02,0.19349000D+01,0.00000000D+00
     .,0.69731480D+03,0.220D+03,0.410D+02,0.19349000D+01,0.00000000D+00
     .,0.53379780D+03,0.220D+03,0.420D+02,0.19349000D+01,0.00000000D+00
     .,0.59749150D+03,0.220D+03,0.430D+02,0.19349000D+01,0.00000000D+00
     .,0.45095970D+03,0.220D+03,0.440D+02,0.19349000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  91901:  92000)=(/
     . 0.49339260D+03,0.220D+03,0.450D+02,0.19349000D+01,0.00000000D+00
     .,0.45620630D+03,0.220D+03,0.460D+02,0.19349000D+01,0.00000000D+00
     .,0.38042830D+03,0.220D+03,0.470D+02,0.19349000D+01,0.00000000D+00
     .,0.40045350D+03,0.220D+03,0.480D+02,0.19349000D+01,0.00000000D+00
     .,0.50726050D+03,0.220D+03,0.490D+02,0.19349000D+01,0.00000000D+00
     .,0.46411930D+03,0.220D+03,0.500D+02,0.19349000D+01,0.00000000D+00
     .,0.40901730D+03,0.220D+03,0.510D+02,0.19349000D+01,0.00000000D+00
     .,0.37680930D+03,0.220D+03,0.520D+02,0.19349000D+01,0.00000000D+00
     .,0.33804940D+03,0.220D+03,0.530D+02,0.19349000D+01,0.00000000D+00
     .,0.30162730D+03,0.220D+03,0.540D+02,0.19349000D+01,0.00000000D+00
     .,0.14021290D+04,0.220D+03,0.550D+02,0.19349000D+01,0.00000000D+00
     .,0.12678490D+04,0.220D+03,0.560D+02,0.19349000D+01,0.00000000D+00
     .,0.11031556D+04,0.220D+03,0.570D+02,0.19349000D+01,0.00000000D+00
     .,0.48397150D+03,0.220D+03,0.580D+02,0.19349000D+01,0.27991000D+01
     .,0.11194842D+04,0.220D+03,0.590D+02,0.19349000D+01,0.00000000D+00
     .,0.10733952D+04,0.220D+03,0.600D+02,0.19349000D+01,0.00000000D+00
     .,0.10460388D+04,0.220D+03,0.610D+02,0.19349000D+01,0.00000000D+00
     .,0.10209351D+04,0.220D+03,0.620D+02,0.19349000D+01,0.00000000D+00
     .,0.99865850D+03,0.220D+03,0.630D+02,0.19349000D+01,0.00000000D+00
     .,0.77606950D+03,0.220D+03,0.640D+02,0.19349000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  92001:  92100)=(/
     . 0.88704210D+03,0.220D+03,0.650D+02,0.19349000D+01,0.00000000D+00
     .,0.85381990D+03,0.220D+03,0.660D+02,0.19349000D+01,0.00000000D+00
     .,0.89865150D+03,0.220D+03,0.670D+02,0.19349000D+01,0.00000000D+00
     .,0.87938870D+03,0.220D+03,0.680D+02,0.19349000D+01,0.00000000D+00
     .,0.86189750D+03,0.220D+03,0.690D+02,0.19349000D+01,0.00000000D+00
     .,0.85225470D+03,0.220D+03,0.700D+02,0.19349000D+01,0.00000000D+00
     .,0.71226080D+03,0.220D+03,0.710D+02,0.19349000D+01,0.00000000D+00
     .,0.69344710D+03,0.220D+03,0.720D+02,0.19349000D+01,0.00000000D+00
     .,0.62855660D+03,0.220D+03,0.730D+02,0.19349000D+01,0.00000000D+00
     .,0.52745270D+03,0.220D+03,0.740D+02,0.19349000D+01,0.00000000D+00
     .,0.53533140D+03,0.220D+03,0.750D+02,0.19349000D+01,0.00000000D+00
     .,0.48222940D+03,0.220D+03,0.760D+02,0.19349000D+01,0.00000000D+00
     .,0.43941270D+03,0.220D+03,0.770D+02,0.19349000D+01,0.00000000D+00
     .,0.36278720D+03,0.220D+03,0.780D+02,0.19349000D+01,0.00000000D+00
     .,0.33812750D+03,0.220D+03,0.790D+02,0.19349000D+01,0.00000000D+00
     .,0.34721000D+03,0.220D+03,0.800D+02,0.19349000D+01,0.00000000D+00
     .,0.51871070D+03,0.220D+03,0.810D+02,0.19349000D+01,0.00000000D+00
     .,0.50321870D+03,0.220D+03,0.820D+02,0.19349000D+01,0.00000000D+00
     .,0.45790780D+03,0.220D+03,0.830D+02,0.19349000D+01,0.00000000D+00
     .,0.43414870D+03,0.220D+03,0.840D+02,0.19349000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  92101:  92200)=(/
     . 0.39775460D+03,0.220D+03,0.850D+02,0.19349000D+01,0.00000000D+00
     .,0.36206750D+03,0.220D+03,0.860D+02,0.19349000D+01,0.00000000D+00
     .,0.13139837D+04,0.220D+03,0.870D+02,0.19349000D+01,0.00000000D+00
     .,0.12471871D+04,0.220D+03,0.880D+02,0.19349000D+01,0.00000000D+00
     .,0.10925678D+04,0.220D+03,0.890D+02,0.19349000D+01,0.00000000D+00
     .,0.97093620D+03,0.220D+03,0.900D+02,0.19349000D+01,0.00000000D+00
     .,0.96877080D+03,0.220D+03,0.910D+02,0.19349000D+01,0.00000000D+00
     .,0.93774220D+03,0.220D+03,0.920D+02,0.19349000D+01,0.00000000D+00
     .,0.97203520D+03,0.220D+03,0.930D+02,0.19349000D+01,0.00000000D+00
     .,0.94020330D+03,0.220D+03,0.940D+02,0.19349000D+01,0.00000000D+00
     .,0.50236800D+02,0.220D+03,0.101D+03,0.19349000D+01,0.00000000D+00
     .,0.16890090D+03,0.220D+03,0.103D+03,0.19349000D+01,0.98650000D+00
     .,0.21431710D+03,0.220D+03,0.104D+03,0.19349000D+01,0.98080000D+00
     .,0.16007340D+03,0.220D+03,0.105D+03,0.19349000D+01,0.97060000D+00
     .,0.11882550D+03,0.220D+03,0.106D+03,0.19349000D+01,0.98680000D+00
     .,0.81252500D+02,0.220D+03,0.107D+03,0.19349000D+01,0.99440000D+00
     .,0.58342300D+02,0.220D+03,0.108D+03,0.19349000D+01,0.99250000D+00
     .,0.39404800D+02,0.220D+03,0.109D+03,0.19349000D+01,0.99820000D+00
     .,0.24782230D+03,0.220D+03,0.111D+03,0.19349000D+01,0.96840000D+00
     .,0.38413080D+03,0.220D+03,0.112D+03,0.19349000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters(  92201:  92300)=(/
     . 0.38485550D+03,0.220D+03,0.113D+03,0.19349000D+01,0.96480000D+00
     .,0.30397250D+03,0.220D+03,0.114D+03,0.19349000D+01,0.95070000D+00
     .,0.24556540D+03,0.220D+03,0.115D+03,0.19349000D+01,0.99470000D+00
     .,0.20560060D+03,0.220D+03,0.116D+03,0.19349000D+01,0.99480000D+00
     .,0.16628780D+03,0.220D+03,0.117D+03,0.19349000D+01,0.99720000D+00
     .,0.33777950D+03,0.220D+03,0.119D+03,0.19349000D+01,0.97670000D+00
     .,0.66406200D+03,0.220D+03,0.120D+03,0.19349000D+01,0.98310000D+00
     .,0.33367800D+03,0.220D+03,0.121D+03,0.19349000D+01,0.18627000D+01
     .,0.32184410D+03,0.220D+03,0.122D+03,0.19349000D+01,0.18299000D+01
     .,0.31546860D+03,0.220D+03,0.123D+03,0.19349000D+01,0.19138000D+01
     .,0.31305380D+03,0.220D+03,0.124D+03,0.19349000D+01,0.18269000D+01
     .,0.28580680D+03,0.220D+03,0.125D+03,0.19349000D+01,0.16406000D+01
     .,0.26379300D+03,0.220D+03,0.126D+03,0.19349000D+01,0.16483000D+01
     .,0.25158410D+03,0.220D+03,0.127D+03,0.19349000D+01,0.17149000D+01
     .,0.24611560D+03,0.220D+03,0.128D+03,0.19349000D+01,0.17937000D+01
     .,0.24467160D+03,0.220D+03,0.129D+03,0.19349000D+01,0.95760000D+00
     .,0.22701180D+03,0.220D+03,0.130D+03,0.19349000D+01,0.19419000D+01
     .,0.37966500D+03,0.220D+03,0.131D+03,0.19349000D+01,0.96010000D+00
     .,0.32905540D+03,0.220D+03,0.132D+03,0.19349000D+01,0.94340000D+00
     .,0.29186010D+03,0.220D+03,0.133D+03,0.19349000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters(  92301:  92400)=(/
     . 0.26450720D+03,0.220D+03,0.134D+03,0.19349000D+01,0.99010000D+00
     .,0.23101070D+03,0.220D+03,0.135D+03,0.19349000D+01,0.99740000D+00
     .,0.40165720D+03,0.220D+03,0.137D+03,0.19349000D+01,0.97380000D+00
     .,0.80869090D+03,0.220D+03,0.138D+03,0.19349000D+01,0.98010000D+00
     .,0.60584530D+03,0.220D+03,0.139D+03,0.19349000D+01,0.19153000D+01
     .,0.44149510D+03,0.220D+03,0.140D+03,0.19349000D+01,0.19355000D+01
     .,0.44598950D+03,0.220D+03,0.141D+03,0.19349000D+01,0.19545000D+01
     .,0.41448110D+03,0.220D+03,0.142D+03,0.19349000D+01,0.19420000D+01
     .,0.46957520D+03,0.220D+03,0.143D+03,0.19349000D+01,0.16682000D+01
     .,0.35837320D+03,0.220D+03,0.144D+03,0.19349000D+01,0.18584000D+01
     .,0.33488270D+03,0.220D+03,0.145D+03,0.19349000D+01,0.19003000D+01
     .,0.31039090D+03,0.220D+03,0.146D+03,0.19349000D+01,0.18630000D+01
     .,0.30060940D+03,0.220D+03,0.147D+03,0.19349000D+01,0.96790000D+00
     .,0.29569410D+03,0.220D+03,0.148D+03,0.19349000D+01,0.19539000D+01
     .,0.48167290D+03,0.220D+03,0.149D+03,0.19349000D+01,0.96330000D+00
     .,0.43088530D+03,0.220D+03,0.150D+03,0.19349000D+01,0.95140000D+00
     .,0.40023370D+03,0.220D+03,0.151D+03,0.19349000D+01,0.97490000D+00
     .,0.37637060D+03,0.220D+03,0.152D+03,0.19349000D+01,0.98110000D+00
     .,0.34127320D+03,0.220D+03,0.153D+03,0.19349000D+01,0.99680000D+00
     .,0.47105090D+03,0.220D+03,0.155D+03,0.19349000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters(  92401:  92500)=(/
     . 0.10519461D+04,0.220D+03,0.156D+03,0.19349000D+01,0.97970000D+00
     .,0.76794120D+03,0.220D+03,0.157D+03,0.19349000D+01,0.19373000D+01
     .,0.46904980D+03,0.220D+03,0.159D+03,0.19349000D+01,0.29425000D+01
     .,0.45929190D+03,0.220D+03,0.160D+03,0.19349000D+01,0.29455000D+01
     .,0.44446290D+03,0.220D+03,0.161D+03,0.19349000D+01,0.29413000D+01
     .,0.44738260D+03,0.220D+03,0.162D+03,0.19349000D+01,0.29300000D+01
     .,0.43352520D+03,0.220D+03,0.163D+03,0.19349000D+01,0.18286000D+01
     .,0.45052800D+03,0.220D+03,0.164D+03,0.19349000D+01,0.28732000D+01
     .,0.42251560D+03,0.220D+03,0.165D+03,0.19349000D+01,0.29086000D+01
     .,0.43117490D+03,0.220D+03,0.166D+03,0.19349000D+01,0.28965000D+01
     .,0.40047540D+03,0.220D+03,0.167D+03,0.19349000D+01,0.29242000D+01
     .,0.38885070D+03,0.220D+03,0.168D+03,0.19349000D+01,0.29282000D+01
     .,0.38653820D+03,0.220D+03,0.169D+03,0.19349000D+01,0.29246000D+01
     .,0.40739760D+03,0.220D+03,0.170D+03,0.19349000D+01,0.28482000D+01
     .,0.37332130D+03,0.220D+03,0.171D+03,0.19349000D+01,0.29219000D+01
     .,0.51554770D+03,0.220D+03,0.172D+03,0.19349000D+01,0.19254000D+01
     .,0.47526240D+03,0.220D+03,0.173D+03,0.19349000D+01,0.19459000D+01
     .,0.43058420D+03,0.220D+03,0.174D+03,0.19349000D+01,0.19292000D+01
     .,0.43832070D+03,0.220D+03,0.175D+03,0.19349000D+01,0.18104000D+01
     .,0.37753700D+03,0.220D+03,0.176D+03,0.19349000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters(  92501:  92600)=(/
     . 0.35420050D+03,0.220D+03,0.177D+03,0.19349000D+01,0.18648000D+01
     .,0.33773330D+03,0.220D+03,0.178D+03,0.19349000D+01,0.19188000D+01
     .,0.32285240D+03,0.220D+03,0.179D+03,0.19349000D+01,0.98460000D+00
     .,0.31020900D+03,0.220D+03,0.180D+03,0.19349000D+01,0.19896000D+01
     .,0.51564400D+03,0.220D+03,0.181D+03,0.19349000D+01,0.92670000D+00
     .,0.46487620D+03,0.220D+03,0.182D+03,0.19349000D+01,0.93830000D+00
     .,0.44812230D+03,0.220D+03,0.183D+03,0.19349000D+01,0.98200000D+00
     .,0.43387110D+03,0.220D+03,0.184D+03,0.19349000D+01,0.98150000D+00
     .,0.40255590D+03,0.220D+03,0.185D+03,0.19349000D+01,0.99540000D+00
     .,0.53018890D+03,0.220D+03,0.187D+03,0.19349000D+01,0.97050000D+00
     .,0.10398007D+04,0.220D+03,0.188D+03,0.19349000D+01,0.96620000D+00
     .,0.55526920D+03,0.220D+03,0.189D+03,0.19349000D+01,0.29070000D+01
     .,0.64689110D+03,0.220D+03,0.190D+03,0.19349000D+01,0.28844000D+01
     .,0.57609270D+03,0.220D+03,0.191D+03,0.19349000D+01,0.28738000D+01
     .,0.50534480D+03,0.220D+03,0.192D+03,0.19349000D+01,0.28878000D+01
     .,0.48542450D+03,0.220D+03,0.193D+03,0.19349000D+01,0.29095000D+01
     .,0.59584710D+03,0.220D+03,0.194D+03,0.19349000D+01,0.19209000D+01
     .,0.13659980D+03,0.220D+03,0.204D+03,0.19349000D+01,0.19697000D+01
     .,0.13359950D+03,0.220D+03,0.205D+03,0.19349000D+01,0.19441000D+01
     .,0.96055300D+02,0.220D+03,0.206D+03,0.19349000D+01,0.19985000D+01
     ./)
      grimme_c6_parameters(  92601:  92700)=(/
     . 0.76136500D+02,0.220D+03,0.207D+03,0.19349000D+01,0.20143000D+01
     .,0.51242500D+02,0.220D+03,0.208D+03,0.19349000D+01,0.19887000D+01
     .,0.24509830D+03,0.220D+03,0.212D+03,0.19349000D+01,0.19496000D+01
     .,0.29655720D+03,0.220D+03,0.213D+03,0.19349000D+01,0.19311000D+01
     .,0.28198140D+03,0.220D+03,0.214D+03,0.19349000D+01,0.19435000D+01
     .,0.24244540D+03,0.220D+03,0.215D+03,0.19349000D+01,0.20102000D+01
     .,0.20138950D+03,0.220D+03,0.216D+03,0.19349000D+01,0.19903000D+01
     .,0.34333430D+03,0.220D+03,0.220D+03,0.19349000D+01,0.19349000D+01
     .,0.29861500D+02,0.221D+03,0.100D+01,0.28999000D+01,0.91180000D+00
     .,0.19430400D+02,0.221D+03,0.200D+01,0.28999000D+01,0.00000000D+00
     .,0.48195860D+03,0.221D+03,0.300D+01,0.28999000D+01,0.00000000D+00
     .,0.27500610D+03,0.221D+03,0.400D+01,0.28999000D+01,0.00000000D+00
     .,0.18324130D+03,0.221D+03,0.500D+01,0.28999000D+01,0.00000000D+00
     .,0.12261150D+03,0.221D+03,0.600D+01,0.28999000D+01,0.00000000D+00
     .,0.85046400D+02,0.221D+03,0.700D+01,0.28999000D+01,0.00000000D+00
     .,0.63983900D+02,0.221D+03,0.800D+01,0.28999000D+01,0.00000000D+00
     .,0.48189200D+02,0.221D+03,0.900D+01,0.28999000D+01,0.00000000D+00
     .,0.36880000D+02,0.221D+03,0.100D+02,0.28999000D+01,0.00000000D+00
     .,0.57574000D+03,0.221D+03,0.110D+02,0.28999000D+01,0.00000000D+00
     .,0.43920300D+03,0.221D+03,0.120D+02,0.28999000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  92701:  92800)=(/
     . 0.40293570D+03,0.221D+03,0.130D+02,0.28999000D+01,0.00000000D+00
     .,0.31526550D+03,0.221D+03,0.140D+02,0.28999000D+01,0.00000000D+00
     .,0.24412340D+03,0.221D+03,0.150D+02,0.28999000D+01,0.00000000D+00
     .,0.20154660D+03,0.221D+03,0.160D+02,0.28999000D+01,0.00000000D+00
     .,0.16374820D+03,0.221D+03,0.170D+02,0.28999000D+01,0.00000000D+00
     .,0.13328650D+03,0.221D+03,0.180D+02,0.28999000D+01,0.00000000D+00
     .,0.94339620D+03,0.221D+03,0.190D+02,0.28999000D+01,0.00000000D+00
     .,0.77413680D+03,0.221D+03,0.200D+02,0.28999000D+01,0.00000000D+00
     .,0.63848690D+03,0.221D+03,0.210D+02,0.28999000D+01,0.00000000D+00
     .,0.61524940D+03,0.221D+03,0.220D+02,0.28999000D+01,0.00000000D+00
     .,0.56271800D+03,0.221D+03,0.230D+02,0.28999000D+01,0.00000000D+00
     .,0.44267360D+03,0.221D+03,0.240D+02,0.28999000D+01,0.00000000D+00
     .,0.48359930D+03,0.221D+03,0.250D+02,0.28999000D+01,0.00000000D+00
     .,0.37893660D+03,0.221D+03,0.260D+02,0.28999000D+01,0.00000000D+00
     .,0.40112950D+03,0.221D+03,0.270D+02,0.28999000D+01,0.00000000D+00
     .,0.41378410D+03,0.221D+03,0.280D+02,0.28999000D+01,0.00000000D+00
     .,0.31671020D+03,0.221D+03,0.290D+02,0.28999000D+01,0.00000000D+00
     .,0.32428910D+03,0.221D+03,0.300D+02,0.28999000D+01,0.00000000D+00
     .,0.38481720D+03,0.221D+03,0.310D+02,0.28999000D+01,0.00000000D+00
     .,0.33757610D+03,0.221D+03,0.320D+02,0.28999000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  92801:  92900)=(/
     . 0.28630450D+03,0.221D+03,0.330D+02,0.28999000D+01,0.00000000D+00
     .,0.25587020D+03,0.221D+03,0.340D+02,0.28999000D+01,0.00000000D+00
     .,0.22292560D+03,0.221D+03,0.350D+02,0.28999000D+01,0.00000000D+00
     .,0.19302240D+03,0.221D+03,0.360D+02,0.28999000D+01,0.00000000D+00
     .,0.10561444D+04,0.221D+03,0.370D+02,0.28999000D+01,0.00000000D+00
     .,0.92214300D+03,0.221D+03,0.380D+02,0.28999000D+01,0.00000000D+00
     .,0.80504650D+03,0.221D+03,0.390D+02,0.28999000D+01,0.00000000D+00
     .,0.72178370D+03,0.221D+03,0.400D+02,0.28999000D+01,0.00000000D+00
     .,0.65695460D+03,0.221D+03,0.410D+02,0.28999000D+01,0.00000000D+00
     .,0.50523460D+03,0.221D+03,0.420D+02,0.28999000D+01,0.00000000D+00
     .,0.56455600D+03,0.221D+03,0.430D+02,0.28999000D+01,0.00000000D+00
     .,0.42826290D+03,0.221D+03,0.440D+02,0.28999000D+01,0.00000000D+00
     .,0.46853580D+03,0.221D+03,0.450D+02,0.28999000D+01,0.00000000D+00
     .,0.43394840D+03,0.221D+03,0.460D+02,0.28999000D+01,0.00000000D+00
     .,0.36150570D+03,0.221D+03,0.470D+02,0.28999000D+01,0.00000000D+00
     .,0.38172980D+03,0.221D+03,0.480D+02,0.28999000D+01,0.00000000D+00
     .,0.48100660D+03,0.221D+03,0.490D+02,0.28999000D+01,0.00000000D+00
     .,0.44306050D+03,0.221D+03,0.500D+02,0.28999000D+01,0.00000000D+00
     .,0.39301150D+03,0.221D+03,0.510D+02,0.28999000D+01,0.00000000D+00
     .,0.36347770D+03,0.221D+03,0.520D+02,0.28999000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  92901:  93000)=(/
     . 0.32743400D+03,0.221D+03,0.530D+02,0.28999000D+01,0.00000000D+00
     .,0.29327410D+03,0.221D+03,0.540D+02,0.28999000D+01,0.00000000D+00
     .,0.12859957D+04,0.221D+03,0.550D+02,0.28999000D+01,0.00000000D+00
     .,0.11762602D+04,0.221D+03,0.560D+02,0.28999000D+01,0.00000000D+00
     .,0.10300975D+04,0.221D+03,0.570D+02,0.28999000D+01,0.00000000D+00
     .,0.46446000D+03,0.221D+03,0.580D+02,0.28999000D+01,0.27991000D+01
     .,0.10408154D+04,0.221D+03,0.590D+02,0.28999000D+01,0.00000000D+00
     .,0.99899710D+03,0.221D+03,0.600D+02,0.28999000D+01,0.00000000D+00
     .,0.97382280D+03,0.221D+03,0.610D+02,0.28999000D+01,0.00000000D+00
     .,0.95069090D+03,0.221D+03,0.620D+02,0.28999000D+01,0.00000000D+00
     .,0.93017500D+03,0.221D+03,0.630D+02,0.28999000D+01,0.00000000D+00
     .,0.72811220D+03,0.221D+03,0.640D+02,0.28999000D+01,0.00000000D+00
     .,0.82368220D+03,0.221D+03,0.650D+02,0.28999000D+01,0.00000000D+00
     .,0.79385410D+03,0.221D+03,0.660D+02,0.28999000D+01,0.00000000D+00
     .,0.83837100D+03,0.221D+03,0.670D+02,0.28999000D+01,0.00000000D+00
     .,0.82054230D+03,0.221D+03,0.680D+02,0.28999000D+01,0.00000000D+00
     .,0.80442380D+03,0.221D+03,0.690D+02,0.28999000D+01,0.00000000D+00
     .,0.79518560D+03,0.221D+03,0.700D+02,0.28999000D+01,0.00000000D+00
     .,0.66789240D+03,0.221D+03,0.710D+02,0.28999000D+01,0.00000000D+00
     .,0.65462000D+03,0.221D+03,0.720D+02,0.28999000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  93001:  93100)=(/
     . 0.59577000D+03,0.221D+03,0.730D+02,0.28999000D+01,0.00000000D+00
     .,0.50153070D+03,0.221D+03,0.740D+02,0.28999000D+01,0.00000000D+00
     .,0.50981600D+03,0.221D+03,0.750D+02,0.28999000D+01,0.00000000D+00
     .,0.46083870D+03,0.221D+03,0.760D+02,0.28999000D+01,0.00000000D+00
     .,0.42109420D+03,0.221D+03,0.770D+02,0.28999000D+01,0.00000000D+00
     .,0.34866710D+03,0.221D+03,0.780D+02,0.28999000D+01,0.00000000D+00
     .,0.32533860D+03,0.221D+03,0.790D+02,0.28999000D+01,0.00000000D+00
     .,0.33453100D+03,0.221D+03,0.800D+02,0.28999000D+01,0.00000000D+00
     .,0.49268870D+03,0.221D+03,0.810D+02,0.28999000D+01,0.00000000D+00
     .,0.48044970D+03,0.221D+03,0.820D+02,0.28999000D+01,0.00000000D+00
     .,0.43974760D+03,0.221D+03,0.830D+02,0.28999000D+01,0.00000000D+00
     .,0.41833640D+03,0.221D+03,0.840D+02,0.28999000D+01,0.00000000D+00
     .,0.38479250D+03,0.221D+03,0.850D+02,0.28999000D+01,0.00000000D+00
     .,0.35151420D+03,0.221D+03,0.860D+02,0.28999000D+01,0.00000000D+00
     .,0.12112384D+04,0.221D+03,0.870D+02,0.28999000D+01,0.00000000D+00
     .,0.11609837D+04,0.221D+03,0.880D+02,0.28999000D+01,0.00000000D+00
     .,0.10231422D+04,0.221D+03,0.890D+02,0.28999000D+01,0.00000000D+00
     .,0.91552140D+03,0.221D+03,0.900D+02,0.28999000D+01,0.00000000D+00
     .,0.91036450D+03,0.221D+03,0.910D+02,0.28999000D+01,0.00000000D+00
     .,0.88134280D+03,0.221D+03,0.920D+02,0.28999000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  93101:  93200)=(/
     . 0.90964690D+03,0.221D+03,0.930D+02,0.28999000D+01,0.00000000D+00
     .,0.88054330D+03,0.221D+03,0.940D+02,0.28999000D+01,0.00000000D+00
     .,0.48492900D+02,0.221D+03,0.101D+03,0.28999000D+01,0.00000000D+00
     .,0.15957150D+03,0.221D+03,0.103D+03,0.28999000D+01,0.98650000D+00
     .,0.20306780D+03,0.221D+03,0.104D+03,0.28999000D+01,0.98080000D+00
     .,0.15370500D+03,0.221D+03,0.105D+03,0.28999000D+01,0.97060000D+00
     .,0.11497100D+03,0.221D+03,0.106D+03,0.28999000D+01,0.98680000D+00
     .,0.79258600D+02,0.221D+03,0.107D+03,0.28999000D+01,0.99440000D+00
     .,0.57280500D+02,0.221D+03,0.108D+03,0.28999000D+01,0.99250000D+00
     .,0.38989900D+02,0.221D+03,0.109D+03,0.28999000D+01,0.99820000D+00
     .,0.23346740D+03,0.221D+03,0.111D+03,0.28999000D+01,0.96840000D+00
     .,0.36145020D+03,0.221D+03,0.112D+03,0.28999000D+01,0.96280000D+00
     .,0.36466680D+03,0.221D+03,0.113D+03,0.28999000D+01,0.96480000D+00
     .,0.29100370D+03,0.221D+03,0.114D+03,0.28999000D+01,0.95070000D+00
     .,0.23687400D+03,0.221D+03,0.115D+03,0.28999000D+01,0.99470000D+00
     .,0.19933220D+03,0.221D+03,0.116D+03,0.28999000D+01,0.99480000D+00
     .,0.16205420D+03,0.221D+03,0.117D+03,0.28999000D+01,0.99720000D+00
     .,0.32000430D+03,0.221D+03,0.119D+03,0.28999000D+01,0.97670000D+00
     .,0.61816760D+03,0.221D+03,0.120D+03,0.28999000D+01,0.98310000D+00
     .,0.31880040D+03,0.221D+03,0.121D+03,0.28999000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters(  93201:  93300)=(/
     . 0.30759130D+03,0.221D+03,0.122D+03,0.28999000D+01,0.18299000D+01
     .,0.30144200D+03,0.221D+03,0.123D+03,0.28999000D+01,0.19138000D+01
     .,0.29881900D+03,0.221D+03,0.124D+03,0.28999000D+01,0.18269000D+01
     .,0.27417030D+03,0.221D+03,0.125D+03,0.28999000D+01,0.16406000D+01
     .,0.25341680D+03,0.221D+03,0.126D+03,0.28999000D+01,0.16483000D+01
     .,0.24168330D+03,0.221D+03,0.127D+03,0.28999000D+01,0.17149000D+01
     .,0.23632960D+03,0.221D+03,0.128D+03,0.28999000D+01,0.17937000D+01
     .,0.23403740D+03,0.221D+03,0.129D+03,0.28999000D+01,0.95760000D+00
     .,0.21866030D+03,0.221D+03,0.130D+03,0.28999000D+01,0.19419000D+01
     .,0.36091960D+03,0.221D+03,0.131D+03,0.28999000D+01,0.96010000D+00
     .,0.31533670D+03,0.221D+03,0.132D+03,0.28999000D+01,0.94340000D+00
     .,0.28133310D+03,0.221D+03,0.133D+03,0.28999000D+01,0.98890000D+00
     .,0.25597460D+03,0.221D+03,0.134D+03,0.28999000D+01,0.99010000D+00
     .,0.22452090D+03,0.221D+03,0.135D+03,0.28999000D+01,0.99740000D+00
     .,0.38121510D+03,0.221D+03,0.137D+03,0.28999000D+01,0.97380000D+00
     .,0.75216410D+03,0.221D+03,0.138D+03,0.28999000D+01,0.98010000D+00
     .,0.57086180D+03,0.221D+03,0.139D+03,0.28999000D+01,0.19153000D+01
     .,0.42153880D+03,0.221D+03,0.140D+03,0.28999000D+01,0.19355000D+01
     .,0.42572990D+03,0.221D+03,0.141D+03,0.28999000D+01,0.19545000D+01
     .,0.39634700D+03,0.221D+03,0.142D+03,0.28999000D+01,0.19420000D+01
     ./)
      grimme_c6_parameters(  93301:  93400)=(/
     . 0.44614920D+03,0.221D+03,0.143D+03,0.28999000D+01,0.16682000D+01
     .,0.34429480D+03,0.221D+03,0.144D+03,0.28999000D+01,0.18584000D+01
     .,0.32185830D+03,0.221D+03,0.145D+03,0.28999000D+01,0.19003000D+01
     .,0.29856920D+03,0.221D+03,0.146D+03,0.28999000D+01,0.18630000D+01
     .,0.28894080D+03,0.221D+03,0.147D+03,0.28999000D+01,0.96790000D+00
     .,0.28528140D+03,0.221D+03,0.148D+03,0.28999000D+01,0.19539000D+01
     .,0.45781840D+03,0.221D+03,0.149D+03,0.28999000D+01,0.96330000D+00
     .,0.41239390D+03,0.221D+03,0.150D+03,0.28999000D+01,0.95140000D+00
     .,0.38490810D+03,0.221D+03,0.151D+03,0.28999000D+01,0.97490000D+00
     .,0.36314460D+03,0.221D+03,0.152D+03,0.28999000D+01,0.98110000D+00
     .,0.33053650D+03,0.221D+03,0.153D+03,0.28999000D+01,0.99680000D+00
     .,0.44947740D+03,0.221D+03,0.155D+03,0.28999000D+01,0.99090000D+00
     .,0.97596650D+03,0.221D+03,0.156D+03,0.28999000D+01,0.97970000D+00
     .,0.72280680D+03,0.221D+03,0.157D+03,0.28999000D+01,0.19373000D+01
     .,0.45030760D+03,0.221D+03,0.159D+03,0.28999000D+01,0.29425000D+01
     .,0.44096740D+03,0.221D+03,0.160D+03,0.28999000D+01,0.29455000D+01
     .,0.42686830D+03,0.221D+03,0.161D+03,0.28999000D+01,0.29413000D+01
     .,0.42925270D+03,0.221D+03,0.162D+03,0.28999000D+01,0.29300000D+01
     .,0.41458930D+03,0.221D+03,0.163D+03,0.28999000D+01,0.18286000D+01
     .,0.43214410D+03,0.221D+03,0.164D+03,0.28999000D+01,0.28732000D+01
     ./)
      grimme_c6_parameters(  93401:  93500)=(/
     . 0.40560400D+03,0.221D+03,0.165D+03,0.28999000D+01,0.29086000D+01
     .,0.41317950D+03,0.221D+03,0.166D+03,0.28999000D+01,0.28965000D+01
     .,0.38477440D+03,0.221D+03,0.167D+03,0.28999000D+01,0.29242000D+01
     .,0.37372510D+03,0.221D+03,0.168D+03,0.28999000D+01,0.29282000D+01
     .,0.37141000D+03,0.221D+03,0.169D+03,0.28999000D+01,0.29246000D+01
     .,0.39092160D+03,0.221D+03,0.170D+03,0.28999000D+01,0.28482000D+01
     .,0.35888950D+03,0.221D+03,0.171D+03,0.28999000D+01,0.29219000D+01
     .,0.48998500D+03,0.221D+03,0.172D+03,0.28999000D+01,0.19254000D+01
     .,0.45345540D+03,0.221D+03,0.173D+03,0.28999000D+01,0.19459000D+01
     .,0.41248260D+03,0.221D+03,0.174D+03,0.28999000D+01,0.19292000D+01
     .,0.41838190D+03,0.221D+03,0.175D+03,0.28999000D+01,0.18104000D+01
     .,0.36375220D+03,0.221D+03,0.176D+03,0.28999000D+01,0.18858000D+01
     .,0.34171650D+03,0.221D+03,0.177D+03,0.28999000D+01,0.18648000D+01
     .,0.32608130D+03,0.221D+03,0.178D+03,0.28999000D+01,0.19188000D+01
     .,0.31164840D+03,0.221D+03,0.179D+03,0.28999000D+01,0.98460000D+00
     .,0.30046490D+03,0.221D+03,0.180D+03,0.28999000D+01,0.19896000D+01
     .,0.49070860D+03,0.221D+03,0.181D+03,0.28999000D+01,0.92670000D+00
     .,0.44539670D+03,0.221D+03,0.182D+03,0.28999000D+01,0.93830000D+00
     .,0.43091620D+03,0.221D+03,0.183D+03,0.28999000D+01,0.98200000D+00
     .,0.41829040D+03,0.221D+03,0.184D+03,0.28999000D+01,0.98150000D+00
     ./)
      grimme_c6_parameters(  93501:  93600)=(/
     . 0.38946080D+03,0.221D+03,0.185D+03,0.28999000D+01,0.99540000D+00
     .,0.50612520D+03,0.221D+03,0.187D+03,0.28999000D+01,0.97050000D+00
     .,0.96871930D+03,0.221D+03,0.188D+03,0.28999000D+01,0.96620000D+00
     .,0.53300150D+03,0.221D+03,0.189D+03,0.28999000D+01,0.29070000D+01
     .,0.61730540D+03,0.221D+03,0.190D+03,0.28999000D+01,0.28844000D+01
     .,0.55082530D+03,0.221D+03,0.191D+03,0.28999000D+01,0.28738000D+01
     .,0.48540710D+03,0.221D+03,0.192D+03,0.28999000D+01,0.28878000D+01
     .,0.46674110D+03,0.221D+03,0.193D+03,0.28999000D+01,0.29095000D+01
     .,0.56587940D+03,0.221D+03,0.194D+03,0.28999000D+01,0.19209000D+01
     .,0.13129800D+03,0.221D+03,0.204D+03,0.28999000D+01,0.19697000D+01
     .,0.12867160D+03,0.221D+03,0.205D+03,0.28999000D+01,0.19441000D+01
     .,0.93360300D+02,0.221D+03,0.206D+03,0.28999000D+01,0.19985000D+01
     .,0.74329700D+02,0.221D+03,0.207D+03,0.28999000D+01,0.20143000D+01
     .,0.50392000D+02,0.221D+03,0.208D+03,0.28999000D+01,0.19887000D+01
     .,0.23400680D+03,0.221D+03,0.212D+03,0.28999000D+01,0.19496000D+01
     .,0.28286280D+03,0.221D+03,0.213D+03,0.28999000D+01,0.19311000D+01
     .,0.27035480D+03,0.221D+03,0.214D+03,0.28999000D+01,0.19435000D+01
     .,0.23372820D+03,0.221D+03,0.215D+03,0.28999000D+01,0.20102000D+01
     .,0.19526710D+03,0.221D+03,0.216D+03,0.28999000D+01,0.19903000D+01
     .,0.32764580D+03,0.221D+03,0.220D+03,0.28999000D+01,0.19349000D+01
     ./)
      grimme_c6_parameters(  93601:  93700)=(/
     . 0.31398460D+03,0.221D+03,0.221D+03,0.28999000D+01,0.28999000D+01
     .,0.30259300D+02,0.222D+03,0.100D+01,0.38675000D+01,0.91180000D+00
     .,0.19720500D+02,0.222D+03,0.200D+01,0.38675000D+01,0.00000000D+00
     .,0.48620980D+03,0.222D+03,0.300D+01,0.38675000D+01,0.00000000D+00
     .,0.27793710D+03,0.222D+03,0.400D+01,0.38675000D+01,0.00000000D+00
     .,0.18540740D+03,0.222D+03,0.500D+01,0.38675000D+01,0.00000000D+00
     .,0.12418490D+03,0.222D+03,0.600D+01,0.38675000D+01,0.00000000D+00
     .,0.86210900D+02,0.222D+03,0.700D+01,0.38675000D+01,0.00000000D+00
     .,0.64903700D+02,0.222D+03,0.800D+01,0.38675000D+01,0.00000000D+00
     .,0.48913100D+02,0.222D+03,0.900D+01,0.38675000D+01,0.00000000D+00
     .,0.37455400D+02,0.222D+03,0.100D+02,0.38675000D+01,0.00000000D+00
     .,0.58090670D+03,0.222D+03,0.110D+02,0.38675000D+01,0.00000000D+00
     .,0.44375570D+03,0.222D+03,0.120D+02,0.38675000D+01,0.00000000D+00
     .,0.40733310D+03,0.222D+03,0.130D+02,0.38675000D+01,0.00000000D+00
     .,0.31895500D+03,0.222D+03,0.140D+02,0.38675000D+01,0.00000000D+00
     .,0.24716030D+03,0.222D+03,0.150D+02,0.38675000D+01,0.00000000D+00
     .,0.20416200D+03,0.222D+03,0.160D+02,0.38675000D+01,0.00000000D+00
     .,0.16596320D+03,0.222D+03,0.170D+02,0.38675000D+01,0.00000000D+00
     .,0.13515860D+03,0.222D+03,0.180D+02,0.38675000D+01,0.00000000D+00
     .,0.95162680D+03,0.222D+03,0.190D+02,0.38675000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  93701:  93800)=(/
     . 0.78176790D+03,0.222D+03,0.200D+02,0.38675000D+01,0.00000000D+00
     .,0.64493880D+03,0.222D+03,0.210D+02,0.38675000D+01,0.00000000D+00
     .,0.62162280D+03,0.222D+03,0.220D+02,0.38675000D+01,0.00000000D+00
     .,0.56863160D+03,0.222D+03,0.230D+02,0.38675000D+01,0.00000000D+00
     .,0.44737630D+03,0.222D+03,0.240D+02,0.38675000D+01,0.00000000D+00
     .,0.48878880D+03,0.222D+03,0.250D+02,0.38675000D+01,0.00000000D+00
     .,0.38306060D+03,0.222D+03,0.260D+02,0.38675000D+01,0.00000000D+00
     .,0.40558090D+03,0.222D+03,0.270D+02,0.38675000D+01,0.00000000D+00
     .,0.41831130D+03,0.222D+03,0.280D+02,0.38675000D+01,0.00000000D+00
     .,0.32021980D+03,0.222D+03,0.290D+02,0.38675000D+01,0.00000000D+00
     .,0.32800010D+03,0.222D+03,0.300D+02,0.38675000D+01,0.00000000D+00
     .,0.38913250D+03,0.222D+03,0.310D+02,0.38675000D+01,0.00000000D+00
     .,0.34156270D+03,0.222D+03,0.320D+02,0.38675000D+01,0.00000000D+00
     .,0.28985600D+03,0.222D+03,0.330D+02,0.38675000D+01,0.00000000D+00
     .,0.25914890D+03,0.222D+03,0.340D+02,0.38675000D+01,0.00000000D+00
     .,0.22588180D+03,0.222D+03,0.350D+02,0.38675000D+01,0.00000000D+00
     .,0.19566660D+03,0.222D+03,0.360D+02,0.38675000D+01,0.00000000D+00
     .,0.10654841D+04,0.222D+03,0.370D+02,0.38675000D+01,0.00000000D+00
     .,0.93121720D+03,0.222D+03,0.380D+02,0.38675000D+01,0.00000000D+00
     .,0.81333020D+03,0.222D+03,0.390D+02,0.38675000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  93801:  93900)=(/
     . 0.72942430D+03,0.222D+03,0.400D+02,0.38675000D+01,0.00000000D+00
     .,0.66404520D+03,0.222D+03,0.410D+02,0.38675000D+01,0.00000000D+00
     .,0.51089670D+03,0.222D+03,0.420D+02,0.38675000D+01,0.00000000D+00
     .,0.57079220D+03,0.222D+03,0.430D+02,0.38675000D+01,0.00000000D+00
     .,0.43319140D+03,0.222D+03,0.440D+02,0.38675000D+01,0.00000000D+00
     .,0.47389730D+03,0.222D+03,0.450D+02,0.38675000D+01,0.00000000D+00
     .,0.43897520D+03,0.222D+03,0.460D+02,0.38675000D+01,0.00000000D+00
     .,0.36571240D+03,0.222D+03,0.470D+02,0.38675000D+01,0.00000000D+00
     .,0.38622410D+03,0.222D+03,0.480D+02,0.38675000D+01,0.00000000D+00
     .,0.48644970D+03,0.222D+03,0.490D+02,0.38675000D+01,0.00000000D+00
     .,0.44827700D+03,0.222D+03,0.500D+02,0.38675000D+01,0.00000000D+00
     .,0.39783330D+03,0.222D+03,0.510D+02,0.38675000D+01,0.00000000D+00
     .,0.36805570D+03,0.222D+03,0.520D+02,0.38675000D+01,0.00000000D+00
     .,0.33168000D+03,0.222D+03,0.530D+02,0.38675000D+01,0.00000000D+00
     .,0.29718710D+03,0.222D+03,0.540D+02,0.38675000D+01,0.00000000D+00
     .,0.12973700D+04,0.222D+03,0.550D+02,0.38675000D+01,0.00000000D+00
     .,0.11876789D+04,0.222D+03,0.560D+02,0.38675000D+01,0.00000000D+00
     .,0.10405570D+04,0.222D+03,0.570D+02,0.38675000D+01,0.00000000D+00
     .,0.47013410D+03,0.222D+03,0.580D+02,0.38675000D+01,0.27991000D+01
     .,0.10511001D+04,0.222D+03,0.590D+02,0.38675000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  93901:  94000)=(/
     . 0.10089483D+04,0.222D+03,0.600D+02,0.38675000D+01,0.00000000D+00
     .,0.98354270D+03,0.222D+03,0.610D+02,0.38675000D+01,0.00000000D+00
     .,0.96019540D+03,0.222D+03,0.620D+02,0.38675000D+01,0.00000000D+00
     .,0.93948900D+03,0.222D+03,0.630D+02,0.38675000D+01,0.00000000D+00
     .,0.73579720D+03,0.222D+03,0.640D+02,0.38675000D+01,0.00000000D+00
     .,0.83177260D+03,0.222D+03,0.650D+02,0.38675000D+01,0.00000000D+00
     .,0.80171120D+03,0.222D+03,0.660D+02,0.38675000D+01,0.00000000D+00
     .,0.84685680D+03,0.222D+03,0.670D+02,0.38675000D+01,0.00000000D+00
     .,0.82885550D+03,0.222D+03,0.680D+02,0.38675000D+01,0.00000000D+00
     .,0.81258600D+03,0.222D+03,0.690D+02,0.38675000D+01,0.00000000D+00
     .,0.80323470D+03,0.222D+03,0.700D+02,0.38675000D+01,0.00000000D+00
     .,0.67488900D+03,0.222D+03,0.710D+02,0.38675000D+01,0.00000000D+00
     .,0.66176650D+03,0.222D+03,0.720D+02,0.38675000D+01,0.00000000D+00
     .,0.60245920D+03,0.222D+03,0.730D+02,0.38675000D+01,0.00000000D+00
     .,0.50731550D+03,0.222D+03,0.740D+02,0.38675000D+01,0.00000000D+00
     .,0.51574640D+03,0.222D+03,0.750D+02,0.38675000D+01,0.00000000D+00
     .,0.46633110D+03,0.222D+03,0.760D+02,0.38675000D+01,0.00000000D+00
     .,0.42621440D+03,0.222D+03,0.770D+02,0.38675000D+01,0.00000000D+00
     .,0.35302080D+03,0.222D+03,0.780D+02,0.38675000D+01,0.00000000D+00
     .,0.32944450D+03,0.222D+03,0.790D+02,0.38675000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  94001:  94100)=(/
     . 0.33877410D+03,0.222D+03,0.800D+02,0.38675000D+01,0.00000000D+00
     .,0.49837090D+03,0.222D+03,0.810D+02,0.38675000D+01,0.00000000D+00
     .,0.48615110D+03,0.222D+03,0.820D+02,0.38675000D+01,0.00000000D+00
     .,0.44515370D+03,0.222D+03,0.830D+02,0.38675000D+01,0.00000000D+00
     .,0.42359010D+03,0.222D+03,0.840D+02,0.38675000D+01,0.00000000D+00
     .,0.38975590D+03,0.222D+03,0.850D+02,0.38675000D+01,0.00000000D+00
     .,0.35616530D+03,0.222D+03,0.860D+02,0.38675000D+01,0.00000000D+00
     .,0.12224279D+04,0.222D+03,0.870D+02,0.38675000D+01,0.00000000D+00
     .,0.11725376D+04,0.222D+03,0.880D+02,0.38675000D+01,0.00000000D+00
     .,0.10337520D+04,0.222D+03,0.890D+02,0.38675000D+01,0.00000000D+00
     .,0.92548980D+03,0.222D+03,0.900D+02,0.38675000D+01,0.00000000D+00
     .,0.92008400D+03,0.222D+03,0.910D+02,0.38675000D+01,0.00000000D+00
     .,0.89076990D+03,0.222D+03,0.920D+02,0.38675000D+01,0.00000000D+00
     .,0.91911090D+03,0.222D+03,0.930D+02,0.38675000D+01,0.00000000D+00
     .,0.88975190D+03,0.222D+03,0.940D+02,0.38675000D+01,0.00000000D+00
     .,0.49098300D+02,0.222D+03,0.101D+03,0.38675000D+01,0.00000000D+00
     .,0.16130130D+03,0.222D+03,0.103D+03,0.38675000D+01,0.98650000D+00
     .,0.20531340D+03,0.222D+03,0.104D+03,0.38675000D+01,0.98080000D+00
     .,0.15556610D+03,0.222D+03,0.105D+03,0.38675000D+01,0.97060000D+00
     .,0.11644710D+03,0.222D+03,0.106D+03,0.38675000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  94101:  94200)=(/
     . 0.80346400D+02,0.222D+03,0.107D+03,0.38675000D+01,0.99440000D+00
     .,0.58112700D+02,0.222D+03,0.108D+03,0.38675000D+01,0.99250000D+00
     .,0.39601500D+02,0.222D+03,0.109D+03,0.38675000D+01,0.99820000D+00
     .,0.23597180D+03,0.222D+03,0.111D+03,0.38675000D+01,0.96840000D+00
     .,0.36527360D+03,0.222D+03,0.112D+03,0.38675000D+01,0.96280000D+00
     .,0.36870140D+03,0.222D+03,0.113D+03,0.38675000D+01,0.96480000D+00
     .,0.29444790D+03,0.222D+03,0.114D+03,0.38675000D+01,0.95070000D+00
     .,0.23982940D+03,0.222D+03,0.115D+03,0.38675000D+01,0.99470000D+00
     .,0.20191810D+03,0.222D+03,0.116D+03,0.38675000D+01,0.99480000D+00
     .,0.16424590D+03,0.222D+03,0.117D+03,0.38675000D+01,0.99720000D+00
     .,0.32361900D+03,0.222D+03,0.119D+03,0.38675000D+01,0.97670000D+00
     .,0.62430360D+03,0.222D+03,0.120D+03,0.38675000D+01,0.98310000D+00
     .,0.32257050D+03,0.222D+03,0.121D+03,0.38675000D+01,0.18627000D+01
     .,0.31124080D+03,0.222D+03,0.122D+03,0.38675000D+01,0.18299000D+01
     .,0.30502010D+03,0.222D+03,0.123D+03,0.38675000D+01,0.19138000D+01
     .,0.30234740D+03,0.222D+03,0.124D+03,0.38675000D+01,0.18269000D+01
     .,0.27750050D+03,0.222D+03,0.125D+03,0.38675000D+01,0.16406000D+01
     .,0.25652910D+03,0.222D+03,0.126D+03,0.38675000D+01,0.16483000D+01
     .,0.24465710D+03,0.222D+03,0.127D+03,0.38675000D+01,0.17149000D+01
     .,0.23923230D+03,0.222D+03,0.128D+03,0.38675000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters(  94201:  94300)=(/
     . 0.23685320D+03,0.222D+03,0.129D+03,0.38675000D+01,0.95760000D+00
     .,0.22139430D+03,0.222D+03,0.130D+03,0.38675000D+01,0.19419000D+01
     .,0.36502390D+03,0.222D+03,0.131D+03,0.38675000D+01,0.96010000D+00
     .,0.31910990D+03,0.222D+03,0.132D+03,0.38675000D+01,0.94340000D+00
     .,0.28483450D+03,0.222D+03,0.133D+03,0.38675000D+01,0.98890000D+00
     .,0.25925390D+03,0.222D+03,0.134D+03,0.38675000D+01,0.99010000D+00
     .,0.22749370D+03,0.222D+03,0.135D+03,0.38675000D+01,0.99740000D+00
     .,0.38558300D+03,0.222D+03,0.137D+03,0.38675000D+01,0.97380000D+00
     .,0.75959780D+03,0.222D+03,0.138D+03,0.38675000D+01,0.98010000D+00
     .,0.57702860D+03,0.222D+03,0.139D+03,0.38675000D+01,0.19153000D+01
     .,0.42651570D+03,0.222D+03,0.140D+03,0.38675000D+01,0.19355000D+01
     .,0.43076130D+03,0.222D+03,0.141D+03,0.38675000D+01,0.19545000D+01
     .,0.40109190D+03,0.222D+03,0.142D+03,0.38675000D+01,0.19420000D+01
     .,0.45128660D+03,0.222D+03,0.143D+03,0.38675000D+01,0.16682000D+01
     .,0.34854900D+03,0.222D+03,0.144D+03,0.38675000D+01,0.18584000D+01
     .,0.32585820D+03,0.222D+03,0.145D+03,0.38675000D+01,0.19003000D+01
     .,0.30231120D+03,0.222D+03,0.146D+03,0.38675000D+01,0.18630000D+01
     .,0.29255140D+03,0.222D+03,0.147D+03,0.38675000D+01,0.96790000D+00
     .,0.28891110D+03,0.222D+03,0.148D+03,0.38675000D+01,0.19539000D+01
     .,0.46307770D+03,0.222D+03,0.149D+03,0.38675000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters(  94301:  94400)=(/
     . 0.41733250D+03,0.222D+03,0.150D+03,0.38675000D+01,0.95140000D+00
     .,0.38965780D+03,0.222D+03,0.151D+03,0.38675000D+01,0.97490000D+00
     .,0.36772520D+03,0.222D+03,0.152D+03,0.38675000D+01,0.98110000D+00
     .,0.33481970D+03,0.222D+03,0.153D+03,0.38675000D+01,0.99680000D+00
     .,0.45477990D+03,0.222D+03,0.155D+03,0.38675000D+01,0.99090000D+00
     .,0.98542930D+03,0.222D+03,0.156D+03,0.38675000D+01,0.97970000D+00
     .,0.73055840D+03,0.222D+03,0.157D+03,0.38675000D+01,0.19373000D+01
     .,0.45582340D+03,0.222D+03,0.159D+03,0.38675000D+01,0.29425000D+01
     .,0.44637170D+03,0.222D+03,0.160D+03,0.38675000D+01,0.29455000D+01
     .,0.43211200D+03,0.222D+03,0.161D+03,0.38675000D+01,0.29413000D+01
     .,0.43449190D+03,0.222D+03,0.162D+03,0.38675000D+01,0.29300000D+01
     .,0.41956220D+03,0.222D+03,0.163D+03,0.38675000D+01,0.18286000D+01
     .,0.43740200D+03,0.222D+03,0.164D+03,0.38675000D+01,0.28732000D+01
     .,0.41057030D+03,0.222D+03,0.165D+03,0.38675000D+01,0.29086000D+01
     .,0.41818290D+03,0.222D+03,0.166D+03,0.38675000D+01,0.28965000D+01
     .,0.38950840D+03,0.222D+03,0.167D+03,0.38675000D+01,0.29242000D+01
     .,0.37833210D+03,0.222D+03,0.168D+03,0.38675000D+01,0.29282000D+01
     .,0.37597960D+03,0.222D+03,0.169D+03,0.38675000D+01,0.29246000D+01
     .,0.39567790D+03,0.222D+03,0.170D+03,0.38675000D+01,0.28482000D+01
     .,0.36331600D+03,0.222D+03,0.171D+03,0.38675000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters(  94401:  94500)=(/
     . 0.49559850D+03,0.222D+03,0.172D+03,0.38675000D+01,0.19254000D+01
     .,0.45879570D+03,0.222D+03,0.173D+03,0.38675000D+01,0.19459000D+01
     .,0.41747930D+03,0.222D+03,0.174D+03,0.38675000D+01,0.19292000D+01
     .,0.42334010D+03,0.222D+03,0.175D+03,0.38675000D+01,0.18104000D+01
     .,0.36833170D+03,0.222D+03,0.176D+03,0.38675000D+01,0.18858000D+01
     .,0.34606910D+03,0.222D+03,0.177D+03,0.38675000D+01,0.18648000D+01
     .,0.33026610D+03,0.222D+03,0.178D+03,0.38675000D+01,0.19188000D+01
     .,0.31565750D+03,0.222D+03,0.179D+03,0.38675000D+01,0.98460000D+00
     .,0.30440290D+03,0.222D+03,0.180D+03,0.38675000D+01,0.19896000D+01
     .,0.49642620D+03,0.222D+03,0.181D+03,0.38675000D+01,0.92670000D+00
     .,0.45079950D+03,0.222D+03,0.182D+03,0.38675000D+01,0.93830000D+00
     .,0.43625560D+03,0.222D+03,0.183D+03,0.38675000D+01,0.98200000D+00
     .,0.42355850D+03,0.222D+03,0.184D+03,0.38675000D+01,0.98150000D+00
     .,0.39448330D+03,0.222D+03,0.185D+03,0.38675000D+01,0.99540000D+00
     .,0.51210760D+03,0.222D+03,0.187D+03,0.38675000D+01,0.97050000D+00
     .,0.97841480D+03,0.222D+03,0.188D+03,0.38675000D+01,0.96620000D+00
     .,0.53951560D+03,0.222D+03,0.189D+03,0.38675000D+01,0.29070000D+01
     .,0.62459130D+03,0.222D+03,0.190D+03,0.38675000D+01,0.28844000D+01
     .,0.55742270D+03,0.222D+03,0.191D+03,0.38675000D+01,0.28738000D+01
     .,0.49140260D+03,0.222D+03,0.192D+03,0.38675000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters(  94501:  94600)=(/
     . 0.47254630D+03,0.222D+03,0.193D+03,0.38675000D+01,0.29095000D+01
     .,0.57240170D+03,0.222D+03,0.194D+03,0.38675000D+01,0.19209000D+01
     .,0.13288810D+03,0.222D+03,0.204D+03,0.38675000D+01,0.19697000D+01
     .,0.13026620D+03,0.222D+03,0.205D+03,0.38675000D+01,0.19441000D+01
     .,0.94601300D+02,0.222D+03,0.206D+03,0.38675000D+01,0.19985000D+01
     .,0.75360900D+02,0.222D+03,0.207D+03,0.38675000D+01,0.20143000D+01
     .,0.51141000D+02,0.222D+03,0.208D+03,0.38675000D+01,0.19887000D+01
     .,0.23672460D+03,0.222D+03,0.212D+03,0.38675000D+01,0.19496000D+01
     .,0.28613170D+03,0.222D+03,0.213D+03,0.38675000D+01,0.19311000D+01
     .,0.27358870D+03,0.222D+03,0.214D+03,0.38675000D+01,0.19435000D+01
     .,0.23663740D+03,0.222D+03,0.215D+03,0.38675000D+01,0.20102000D+01
     .,0.19780370D+03,0.222D+03,0.216D+03,0.38675000D+01,0.19903000D+01
     .,0.33148510D+03,0.222D+03,0.220D+03,0.38675000D+01,0.19349000D+01
     .,0.31775890D+03,0.222D+03,0.221D+03,0.38675000D+01,0.28999000D+01
     .,0.32158900D+03,0.222D+03,0.222D+03,0.38675000D+01,0.38675000D+01
     .,0.27688000D+02,0.223D+03,0.100D+01,0.29110000D+01,0.91180000D+00
     .,0.18112700D+02,0.223D+03,0.200D+01,0.29110000D+01,0.00000000D+00
     .,0.44829230D+03,0.223D+03,0.300D+01,0.29110000D+01,0.00000000D+00
     .,0.25437670D+03,0.223D+03,0.400D+01,0.29110000D+01,0.00000000D+00
     .,0.16952210D+03,0.223D+03,0.500D+01,0.29110000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  94601:  94700)=(/
     . 0.11361290D+03,0.223D+03,0.600D+01,0.29110000D+01,0.00000000D+00
     .,0.78976100D+02,0.223D+03,0.700D+01,0.29110000D+01,0.00000000D+00
     .,0.59544500D+02,0.223D+03,0.800D+01,0.29110000D+01,0.00000000D+00
     .,0.44949300D+02,0.223D+03,0.900D+01,0.29110000D+01,0.00000000D+00
     .,0.34478900D+02,0.223D+03,0.100D+02,0.29110000D+01,0.00000000D+00
     .,0.53544830D+03,0.223D+03,0.110D+02,0.29110000D+01,0.00000000D+00
     .,0.40656420D+03,0.223D+03,0.120D+02,0.29110000D+01,0.00000000D+00
     .,0.37280190D+03,0.223D+03,0.130D+02,0.29110000D+01,0.00000000D+00
     .,0.29163180D+03,0.223D+03,0.140D+02,0.29110000D+01,0.00000000D+00
     .,0.22598490D+03,0.223D+03,0.150D+02,0.29110000D+01,0.00000000D+00
     .,0.18676650D+03,0.223D+03,0.160D+02,0.29110000D+01,0.00000000D+00
     .,0.15194160D+03,0.223D+03,0.170D+02,0.29110000D+01,0.00000000D+00
     .,0.12386350D+03,0.223D+03,0.180D+02,0.29110000D+01,0.00000000D+00
     .,0.87974450D+03,0.223D+03,0.190D+02,0.29110000D+01,0.00000000D+00
     .,0.71816300D+03,0.223D+03,0.200D+02,0.29110000D+01,0.00000000D+00
     .,0.59186950D+03,0.223D+03,0.210D+02,0.29110000D+01,0.00000000D+00
     .,0.57022820D+03,0.223D+03,0.220D+02,0.29110000D+01,0.00000000D+00
     .,0.52146020D+03,0.223D+03,0.230D+02,0.29110000D+01,0.00000000D+00
     .,0.41056610D+03,0.223D+03,0.240D+02,0.29110000D+01,0.00000000D+00
     .,0.44806980D+03,0.223D+03,0.250D+02,0.29110000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  94701:  94800)=(/
     . 0.35139390D+03,0.223D+03,0.260D+02,0.29110000D+01,0.00000000D+00
     .,0.37151490D+03,0.223D+03,0.270D+02,0.29110000D+01,0.00000000D+00
     .,0.38325570D+03,0.223D+03,0.280D+02,0.29110000D+01,0.00000000D+00
     .,0.29368160D+03,0.223D+03,0.290D+02,0.29110000D+01,0.00000000D+00
     .,0.30031300D+03,0.223D+03,0.300D+02,0.29110000D+01,0.00000000D+00
     .,0.35624690D+03,0.223D+03,0.310D+02,0.29110000D+01,0.00000000D+00
     .,0.31241300D+03,0.223D+03,0.320D+02,0.29110000D+01,0.00000000D+00
     .,0.26507780D+03,0.223D+03,0.330D+02,0.29110000D+01,0.00000000D+00
     .,0.23705770D+03,0.223D+03,0.340D+02,0.29110000D+01,0.00000000D+00
     .,0.20672770D+03,0.223D+03,0.350D+02,0.29110000D+01,0.00000000D+00
     .,0.17919650D+03,0.223D+03,0.360D+02,0.29110000D+01,0.00000000D+00
     .,0.98495040D+03,0.223D+03,0.370D+02,0.29110000D+01,0.00000000D+00
     .,0.85590050D+03,0.223D+03,0.380D+02,0.29110000D+01,0.00000000D+00
     .,0.74643350D+03,0.223D+03,0.390D+02,0.29110000D+01,0.00000000D+00
     .,0.66896670D+03,0.223D+03,0.400D+02,0.29110000D+01,0.00000000D+00
     .,0.60884420D+03,0.223D+03,0.410D+02,0.29110000D+01,0.00000000D+00
     .,0.46840590D+03,0.223D+03,0.420D+02,0.29110000D+01,0.00000000D+00
     .,0.52332230D+03,0.223D+03,0.430D+02,0.29110000D+01,0.00000000D+00
     .,0.39715580D+03,0.223D+03,0.440D+02,0.29110000D+01,0.00000000D+00
     .,0.43421760D+03,0.223D+03,0.450D+02,0.29110000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  94801:  94900)=(/
     . 0.40217500D+03,0.223D+03,0.460D+02,0.29110000D+01,0.00000000D+00
     .,0.33544360D+03,0.223D+03,0.470D+02,0.29110000D+01,0.00000000D+00
     .,0.35382270D+03,0.223D+03,0.480D+02,0.29110000D+01,0.00000000D+00
     .,0.44577660D+03,0.223D+03,0.490D+02,0.29110000D+01,0.00000000D+00
     .,0.41035180D+03,0.223D+03,0.500D+02,0.29110000D+01,0.00000000D+00
     .,0.36401890D+03,0.223D+03,0.510D+02,0.29110000D+01,0.00000000D+00
     .,0.33677190D+03,0.223D+03,0.520D+02,0.29110000D+01,0.00000000D+00
     .,0.30354590D+03,0.223D+03,0.530D+02,0.29110000D+01,0.00000000D+00
     .,0.27207950D+03,0.223D+03,0.540D+02,0.29110000D+01,0.00000000D+00
     .,0.11997581D+04,0.223D+03,0.550D+02,0.29110000D+01,0.00000000D+00
     .,0.10926689D+04,0.223D+03,0.560D+02,0.29110000D+01,0.00000000D+00
     .,0.95571690D+03,0.223D+03,0.570D+02,0.29110000D+01,0.00000000D+00
     .,0.43033410D+03,0.223D+03,0.580D+02,0.29110000D+01,0.27991000D+01
     .,0.96666190D+03,0.223D+03,0.590D+02,0.29110000D+01,0.00000000D+00
     .,0.92752540D+03,0.223D+03,0.600D+02,0.29110000D+01,0.00000000D+00
     .,0.90407530D+03,0.223D+03,0.610D+02,0.29110000D+01,0.00000000D+00
     .,0.88253130D+03,0.223D+03,0.620D+02,0.29110000D+01,0.00000000D+00
     .,0.86342100D+03,0.223D+03,0.630D+02,0.29110000D+01,0.00000000D+00
     .,0.67551500D+03,0.223D+03,0.640D+02,0.29110000D+01,0.00000000D+00
     .,0.76607760D+03,0.223D+03,0.650D+02,0.29110000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  94901:  95000)=(/
     . 0.73824890D+03,0.223D+03,0.660D+02,0.29110000D+01,0.00000000D+00
     .,0.77789910D+03,0.223D+03,0.670D+02,0.29110000D+01,0.00000000D+00
     .,0.76130400D+03,0.223D+03,0.680D+02,0.29110000D+01,0.00000000D+00
     .,0.74629430D+03,0.223D+03,0.690D+02,0.29110000D+01,0.00000000D+00
     .,0.73772690D+03,0.223D+03,0.700D+02,0.29110000D+01,0.00000000D+00
     .,0.61945150D+03,0.223D+03,0.710D+02,0.29110000D+01,0.00000000D+00
     .,0.60644790D+03,0.223D+03,0.720D+02,0.29110000D+01,0.00000000D+00
     .,0.55185300D+03,0.223D+03,0.730D+02,0.29110000D+01,0.00000000D+00
     .,0.46484330D+03,0.223D+03,0.740D+02,0.29110000D+01,0.00000000D+00
     .,0.47240710D+03,0.223D+03,0.750D+02,0.29110000D+01,0.00000000D+00
     .,0.42706310D+03,0.223D+03,0.760D+02,0.29110000D+01,0.00000000D+00
     .,0.39030550D+03,0.223D+03,0.770D+02,0.29110000D+01,0.00000000D+00
     .,0.32344940D+03,0.223D+03,0.780D+02,0.29110000D+01,0.00000000D+00
     .,0.30191160D+03,0.223D+03,0.790D+02,0.29110000D+01,0.00000000D+00
     .,0.31033530D+03,0.223D+03,0.800D+02,0.29110000D+01,0.00000000D+00
     .,0.45700230D+03,0.223D+03,0.810D+02,0.29110000D+01,0.00000000D+00
     .,0.44528620D+03,0.223D+03,0.820D+02,0.29110000D+01,0.00000000D+00
     .,0.40750360D+03,0.223D+03,0.830D+02,0.29110000D+01,0.00000000D+00
     .,0.38771530D+03,0.223D+03,0.840D+02,0.29110000D+01,0.00000000D+00
     .,0.35676420D+03,0.223D+03,0.850D+02,0.29110000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  95001:  95100)=(/
     . 0.32609510D+03,0.223D+03,0.860D+02,0.29110000D+01,0.00000000D+00
     .,0.11286750D+04,0.223D+03,0.870D+02,0.29110000D+01,0.00000000D+00
     .,0.10779350D+04,0.223D+03,0.880D+02,0.29110000D+01,0.00000000D+00
     .,0.94892310D+03,0.223D+03,0.890D+02,0.29110000D+01,0.00000000D+00
     .,0.84862350D+03,0.223D+03,0.900D+02,0.29110000D+01,0.00000000D+00
     .,0.84446350D+03,0.223D+03,0.910D+02,0.29110000D+01,0.00000000D+00
     .,0.81754620D+03,0.223D+03,0.920D+02,0.29110000D+01,0.00000000D+00
     .,0.84421690D+03,0.223D+03,0.930D+02,0.29110000D+01,0.00000000D+00
     .,0.81709710D+03,0.223D+03,0.940D+02,0.29110000D+01,0.00000000D+00
     .,0.44884200D+02,0.223D+03,0.101D+03,0.29110000D+01,0.00000000D+00
     .,0.14764100D+03,0.223D+03,0.103D+03,0.29110000D+01,0.98650000D+00
     .,0.18795310D+03,0.223D+03,0.104D+03,0.29110000D+01,0.98080000D+00
     .,0.14227280D+03,0.223D+03,0.105D+03,0.29110000D+01,0.97060000D+00
     .,0.10657110D+03,0.223D+03,0.106D+03,0.29110000D+01,0.98680000D+00
     .,0.73627500D+02,0.223D+03,0.107D+03,0.29110000D+01,0.99440000D+00
     .,0.53340000D+02,0.223D+03,0.108D+03,0.29110000D+01,0.99250000D+00
     .,0.36451300D+02,0.223D+03,0.109D+03,0.29110000D+01,0.99820000D+00
     .,0.21618670D+03,0.223D+03,0.111D+03,0.29110000D+01,0.96840000D+00
     .,0.33467830D+03,0.223D+03,0.112D+03,0.29110000D+01,0.96280000D+00
     .,0.33741280D+03,0.223D+03,0.113D+03,0.29110000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters(  95101:  95200)=(/
     . 0.26924130D+03,0.223D+03,0.114D+03,0.29110000D+01,0.95070000D+00
     .,0.21930330D+03,0.223D+03,0.115D+03,0.29110000D+01,0.99470000D+00
     .,0.18472410D+03,0.223D+03,0.116D+03,0.29110000D+01,0.99480000D+00
     .,0.15037570D+03,0.223D+03,0.117D+03,0.29110000D+01,0.99720000D+00
     .,0.29674310D+03,0.223D+03,0.119D+03,0.29110000D+01,0.97670000D+00
     .,0.57423510D+03,0.223D+03,0.120D+03,0.29110000D+01,0.98310000D+00
     .,0.29523740D+03,0.223D+03,0.121D+03,0.29110000D+01,0.18627000D+01
     .,0.28494970D+03,0.223D+03,0.122D+03,0.29110000D+01,0.18299000D+01
     .,0.27927550D+03,0.223D+03,0.123D+03,0.29110000D+01,0.19138000D+01
     .,0.27688190D+03,0.223D+03,0.124D+03,0.29110000D+01,0.18269000D+01
     .,0.25393700D+03,0.223D+03,0.125D+03,0.29110000D+01,0.16406000D+01
     .,0.23476650D+03,0.223D+03,0.126D+03,0.29110000D+01,0.16483000D+01
     .,0.22394370D+03,0.223D+03,0.127D+03,0.29110000D+01,0.17149000D+01
     .,0.21899430D+03,0.223D+03,0.128D+03,0.29110000D+01,0.17937000D+01
     .,0.21692030D+03,0.223D+03,0.129D+03,0.29110000D+01,0.95760000D+00
     .,0.20259800D+03,0.223D+03,0.130D+03,0.29110000D+01,0.19419000D+01
     .,0.33410780D+03,0.223D+03,0.131D+03,0.29110000D+01,0.96010000D+00
     .,0.29187130D+03,0.223D+03,0.132D+03,0.29110000D+01,0.94340000D+00
     .,0.26049700D+03,0.223D+03,0.133D+03,0.29110000D+01,0.98890000D+00
     .,0.23715920D+03,0.223D+03,0.134D+03,0.29110000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters(  95201:  95300)=(/
     . 0.20820220D+03,0.223D+03,0.135D+03,0.29110000D+01,0.99740000D+00
     .,0.35359290D+03,0.223D+03,0.137D+03,0.29110000D+01,0.97380000D+00
     .,0.69913020D+03,0.223D+03,0.138D+03,0.29110000D+01,0.98010000D+00
     .,0.52968240D+03,0.223D+03,0.139D+03,0.29110000D+01,0.19153000D+01
     .,0.39060560D+03,0.223D+03,0.140D+03,0.29110000D+01,0.19355000D+01
     .,0.39448540D+03,0.223D+03,0.141D+03,0.29110000D+01,0.19545000D+01
     .,0.36737500D+03,0.223D+03,0.142D+03,0.29110000D+01,0.19420000D+01
     .,0.41382300D+03,0.223D+03,0.143D+03,0.29110000D+01,0.16682000D+01
     .,0.31915840D+03,0.223D+03,0.144D+03,0.29110000D+01,0.18584000D+01
     .,0.29845770D+03,0.223D+03,0.145D+03,0.29110000D+01,0.19003000D+01
     .,0.27694720D+03,0.223D+03,0.146D+03,0.29110000D+01,0.18630000D+01
     .,0.26803530D+03,0.223D+03,0.147D+03,0.29110000D+01,0.96790000D+00
     .,0.26453140D+03,0.223D+03,0.148D+03,0.29110000D+01,0.19539000D+01
     .,0.42422720D+03,0.223D+03,0.149D+03,0.29110000D+01,0.96330000D+00
     .,0.38198180D+03,0.223D+03,0.150D+03,0.29110000D+01,0.95140000D+00
     .,0.35653490D+03,0.223D+03,0.151D+03,0.29110000D+01,0.97490000D+00
     .,0.33646710D+03,0.223D+03,0.152D+03,0.29110000D+01,0.98110000D+00
     .,0.30641230D+03,0.223D+03,0.153D+03,0.29110000D+01,0.99680000D+00
     .,0.41667550D+03,0.223D+03,0.155D+03,0.29110000D+01,0.99090000D+00
     .,0.90813400D+03,0.223D+03,0.156D+03,0.29110000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters(  95301:  95400)=(/
     . 0.67092080D+03,0.223D+03,0.157D+03,0.29110000D+01,0.19373000D+01
     .,0.41723950D+03,0.223D+03,0.159D+03,0.29110000D+01,0.29425000D+01
     .,0.40858800D+03,0.223D+03,0.160D+03,0.29110000D+01,0.29455000D+01
     .,0.39554120D+03,0.223D+03,0.161D+03,0.29110000D+01,0.29413000D+01
     .,0.39776470D+03,0.223D+03,0.162D+03,0.29110000D+01,0.29300000D+01
     .,0.38425760D+03,0.223D+03,0.163D+03,0.29110000D+01,0.18286000D+01
     .,0.40037930D+03,0.223D+03,0.164D+03,0.29110000D+01,0.28732000D+01
     .,0.37581950D+03,0.223D+03,0.165D+03,0.29110000D+01,0.29086000D+01
     .,0.38288660D+03,0.223D+03,0.166D+03,0.29110000D+01,0.28965000D+01
     .,0.35650840D+03,0.223D+03,0.167D+03,0.29110000D+01,0.29242000D+01
     .,0.34627180D+03,0.223D+03,0.168D+03,0.29110000D+01,0.29282000D+01
     .,0.34411550D+03,0.223D+03,0.169D+03,0.29110000D+01,0.29246000D+01
     .,0.36209870D+03,0.223D+03,0.170D+03,0.29110000D+01,0.28482000D+01
     .,0.33249970D+03,0.223D+03,0.171D+03,0.29110000D+01,0.29219000D+01
     .,0.45419310D+03,0.223D+03,0.172D+03,0.29110000D+01,0.19254000D+01
     .,0.42031920D+03,0.223D+03,0.173D+03,0.29110000D+01,0.19459000D+01
     .,0.38236280D+03,0.223D+03,0.174D+03,0.29110000D+01,0.19292000D+01
     .,0.38788720D+03,0.223D+03,0.175D+03,0.29110000D+01,0.18104000D+01
     .,0.33726140D+03,0.223D+03,0.176D+03,0.29110000D+01,0.18858000D+01
     .,0.31693610D+03,0.223D+03,0.177D+03,0.29110000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters(  95401:  95500)=(/
     . 0.30251590D+03,0.223D+03,0.178D+03,0.29110000D+01,0.19188000D+01
     .,0.28922160D+03,0.223D+03,0.179D+03,0.29110000D+01,0.98460000D+00
     .,0.27881840D+03,0.223D+03,0.180D+03,0.29110000D+01,0.19896000D+01
     .,0.45500920D+03,0.223D+03,0.181D+03,0.29110000D+01,0.92670000D+00
     .,0.41279290D+03,0.223D+03,0.182D+03,0.29110000D+01,0.93830000D+00
     .,0.39932210D+03,0.223D+03,0.183D+03,0.29110000D+01,0.98200000D+00
     .,0.38766700D+03,0.223D+03,0.184D+03,0.29110000D+01,0.98150000D+00
     .,0.36107620D+03,0.223D+03,0.185D+03,0.29110000D+01,0.99540000D+00
     .,0.46915130D+03,0.223D+03,0.187D+03,0.29110000D+01,0.97050000D+00
     .,0.90055920D+03,0.223D+03,0.188D+03,0.29110000D+01,0.96620000D+00
     .,0.49379900D+03,0.223D+03,0.189D+03,0.29110000D+01,0.29070000D+01
     .,0.57234950D+03,0.223D+03,0.190D+03,0.29110000D+01,0.28844000D+01
     .,0.51099770D+03,0.223D+03,0.191D+03,0.29110000D+01,0.28738000D+01
     .,0.45000790D+03,0.223D+03,0.192D+03,0.29110000D+01,0.28878000D+01
     .,0.43270840D+03,0.223D+03,0.193D+03,0.29110000D+01,0.29095000D+01
     .,0.52512640D+03,0.223D+03,0.194D+03,0.29110000D+01,0.19209000D+01
     .,0.12146010D+03,0.223D+03,0.204D+03,0.29110000D+01,0.19697000D+01
     .,0.11917710D+03,0.223D+03,0.205D+03,0.29110000D+01,0.19441000D+01
     .,0.86606000D+02,0.223D+03,0.206D+03,0.29110000D+01,0.19985000D+01
     .,0.69080900D+02,0.223D+03,0.207D+03,0.29110000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters(  95501:  95600)=(/
     . 0.46987500D+02,0.223D+03,0.208D+03,0.29110000D+01,0.19887000D+01
     .,0.21643950D+03,0.223D+03,0.212D+03,0.29110000D+01,0.19496000D+01
     .,0.26172830D+03,0.223D+03,0.213D+03,0.29110000D+01,0.19311000D+01
     .,0.25015910D+03,0.223D+03,0.214D+03,0.29110000D+01,0.19435000D+01
     .,0.21641010D+03,0.223D+03,0.215D+03,0.29110000D+01,0.20102000D+01
     .,0.18097100D+03,0.223D+03,0.216D+03,0.29110000D+01,0.19903000D+01
     .,0.30339700D+03,0.223D+03,0.220D+03,0.29110000D+01,0.19349000D+01
     .,0.29073090D+03,0.223D+03,0.221D+03,0.29110000D+01,0.28999000D+01
     .,0.29424170D+03,0.223D+03,0.222D+03,0.29110000D+01,0.38675000D+01
     .,0.26933490D+03,0.223D+03,0.223D+03,0.29110000D+01,0.29110000D+01
     .,0.21313400D+02,0.224D+03,0.100D+01,0.10619100D+02,0.91180000D+00
     .,0.14405100D+02,0.224D+03,0.200D+01,0.10619100D+02,0.00000000D+00
     .,0.31428070D+03,0.224D+03,0.300D+01,0.10619100D+02,0.00000000D+00
     .,0.18490790D+03,0.224D+03,0.400D+01,0.10619100D+02,0.00000000D+00
     .,0.12637360D+03,0.224D+03,0.500D+01,0.10619100D+02,0.00000000D+00
     .,0.86546400D+02,0.224D+03,0.600D+01,0.10619100D+02,0.00000000D+00
     .,0.61247100D+02,0.224D+03,0.700D+01,0.10619100D+02,0.00000000D+00
     .,0.46813800D+02,0.224D+03,0.800D+01,0.10619100D+02,0.00000000D+00
     .,0.35781100D+02,0.224D+03,0.900D+01,0.10619100D+02,0.00000000D+00
     .,0.27737200D+02,0.224D+03,0.100D+02,0.10619100D+02,0.00000000D+00
     ./)
      grimme_c6_parameters(  95601:  95700)=(/
     . 0.37649060D+03,0.224D+03,0.110D+02,0.10619100D+02,0.00000000D+00
     .,0.29367770D+03,0.224D+03,0.120D+02,0.10619100D+02,0.00000000D+00
     .,0.27250150D+03,0.224D+03,0.130D+02,0.10619100D+02,0.00000000D+00
     .,0.21680010D+03,0.224D+03,0.140D+02,0.10619100D+02,0.00000000D+00
     .,0.17067670D+03,0.224D+03,0.150D+02,0.10619100D+02,0.00000000D+00
     .,0.14267950D+03,0.224D+03,0.160D+02,0.10619100D+02,0.00000000D+00
     .,0.11742580D+03,0.224D+03,0.170D+02,0.10619100D+02,0.00000000D+00
     .,0.96759300D+02,0.224D+03,0.180D+02,0.10619100D+02,0.00000000D+00
     .,0.61705660D+03,0.224D+03,0.190D+02,0.10619100D+02,0.00000000D+00
     .,0.51377680D+03,0.224D+03,0.200D+02,0.10619100D+02,0.00000000D+00
     .,0.42547450D+03,0.224D+03,0.210D+02,0.10619100D+02,0.00000000D+00
     .,0.41213870D+03,0.224D+03,0.220D+02,0.10619100D+02,0.00000000D+00
     .,0.37806600D+03,0.224D+03,0.230D+02,0.10619100D+02,0.00000000D+00
     .,0.29848940D+03,0.224D+03,0.240D+02,0.10619100D+02,0.00000000D+00
     .,0.32635580D+03,0.224D+03,0.250D+02,0.10619100D+02,0.00000000D+00
     .,0.25682780D+03,0.224D+03,0.260D+02,0.10619100D+02,0.00000000D+00
     .,0.27263010D+03,0.224D+03,0.270D+02,0.10619100D+02,0.00000000D+00
     .,0.28029770D+03,0.224D+03,0.280D+02,0.10619100D+02,0.00000000D+00
     .,0.21550230D+03,0.224D+03,0.290D+02,0.10619100D+02,0.00000000D+00
     .,0.22196560D+03,0.224D+03,0.300D+02,0.10619100D+02,0.00000000D+00
     ./)
      grimme_c6_parameters(  95701:  95800)=(/
     . 0.26215300D+03,0.224D+03,0.310D+02,0.10619100D+02,0.00000000D+00
     .,0.23279920D+03,0.224D+03,0.320D+02,0.10619100D+02,0.00000000D+00
     .,0.20004860D+03,0.224D+03,0.330D+02,0.10619100D+02,0.00000000D+00
     .,0.18047050D+03,0.224D+03,0.340D+02,0.10619100D+02,0.00000000D+00
     .,0.15887040D+03,0.224D+03,0.350D+02,0.10619100D+02,0.00000000D+00
     .,0.13897880D+03,0.224D+03,0.360D+02,0.10619100D+02,0.00000000D+00
     .,0.69273590D+03,0.224D+03,0.370D+02,0.10619100D+02,0.00000000D+00
     .,0.61235490D+03,0.224D+03,0.380D+02,0.10619100D+02,0.00000000D+00
     .,0.53890290D+03,0.224D+03,0.390D+02,0.10619100D+02,0.00000000D+00
     .,0.48594470D+03,0.224D+03,0.400D+02,0.10619100D+02,0.00000000D+00
     .,0.44423280D+03,0.224D+03,0.410D+02,0.10619100D+02,0.00000000D+00
     .,0.34481050D+03,0.224D+03,0.420D+02,0.10619100D+02,0.00000000D+00
     .,0.38391860D+03,0.224D+03,0.430D+02,0.10619100D+02,0.00000000D+00
     .,0.29422580D+03,0.224D+03,0.440D+02,0.10619100D+02,0.00000000D+00
     .,0.32113840D+03,0.224D+03,0.450D+02,0.10619100D+02,0.00000000D+00
     .,0.29830140D+03,0.224D+03,0.460D+02,0.10619100D+02,0.00000000D+00
     .,0.24916130D+03,0.224D+03,0.470D+02,0.10619100D+02,0.00000000D+00
     .,0.26345110D+03,0.224D+03,0.480D+02,0.10619100D+02,0.00000000D+00
     .,0.32878360D+03,0.224D+03,0.490D+02,0.10619100D+02,0.00000000D+00
     .,0.30551080D+03,0.224D+03,0.500D+02,0.10619100D+02,0.00000000D+00
     ./)
      grimme_c6_parameters(  95801:  95900)=(/
     . 0.27385520D+03,0.224D+03,0.510D+02,0.10619100D+02,0.00000000D+00
     .,0.25510770D+03,0.224D+03,0.520D+02,0.10619100D+02,0.00000000D+00
     .,0.23174840D+03,0.224D+03,0.530D+02,0.10619100D+02,0.00000000D+00
     .,0.20936220D+03,0.224D+03,0.540D+02,0.10619100D+02,0.00000000D+00
     .,0.84446350D+03,0.224D+03,0.550D+02,0.10619100D+02,0.00000000D+00
     .,0.78008380D+03,0.224D+03,0.560D+02,0.10619100D+02,0.00000000D+00
     .,0.68834330D+03,0.224D+03,0.570D+02,0.10619100D+02,0.00000000D+00
     .,0.32346600D+03,0.224D+03,0.580D+02,0.10619100D+02,0.27991000D+01
     .,0.69246670D+03,0.224D+03,0.590D+02,0.10619100D+02,0.00000000D+00
     .,0.66535710D+03,0.224D+03,0.600D+02,0.10619100D+02,0.00000000D+00
     .,0.64877270D+03,0.224D+03,0.610D+02,0.10619100D+02,0.00000000D+00
     .,0.63350050D+03,0.224D+03,0.620D+02,0.10619100D+02,0.00000000D+00
     .,0.61995990D+03,0.224D+03,0.630D+02,0.10619100D+02,0.00000000D+00
     .,0.49059980D+03,0.224D+03,0.640D+02,0.10619100D+02,0.00000000D+00
     .,0.54884660D+03,0.224D+03,0.650D+02,0.10619100D+02,0.00000000D+00
     .,0.52980690D+03,0.224D+03,0.660D+02,0.10619100D+02,0.00000000D+00
     .,0.55970160D+03,0.224D+03,0.670D+02,0.10619100D+02,0.00000000D+00
     .,0.54785030D+03,0.224D+03,0.680D+02,0.10619100D+02,0.00000000D+00
     .,0.53720110D+03,0.224D+03,0.690D+02,0.10619100D+02,0.00000000D+00
     .,0.53075810D+03,0.224D+03,0.700D+02,0.10619100D+02,0.00000000D+00
     ./)
      grimme_c6_parameters(  95901:  96000)=(/
     . 0.44908170D+03,0.224D+03,0.710D+02,0.10619100D+02,0.00000000D+00
     .,0.44357620D+03,0.224D+03,0.720D+02,0.10619100D+02,0.00000000D+00
     .,0.40628410D+03,0.224D+03,0.730D+02,0.10619100D+02,0.00000000D+00
     .,0.34453870D+03,0.224D+03,0.740D+02,0.10619100D+02,0.00000000D+00
     .,0.35083400D+03,0.224D+03,0.750D+02,0.10619100D+02,0.00000000D+00
     .,0.31905950D+03,0.224D+03,0.760D+02,0.10619100D+02,0.00000000D+00
     .,0.29307050D+03,0.224D+03,0.770D+02,0.10619100D+02,0.00000000D+00
     .,0.24455970D+03,0.224D+03,0.780D+02,0.10619100D+02,0.00000000D+00
     .,0.22890260D+03,0.224D+03,0.790D+02,0.10619100D+02,0.00000000D+00
     .,0.23555590D+03,0.224D+03,0.800D+02,0.10619100D+02,0.00000000D+00
     .,0.33874020D+03,0.224D+03,0.810D+02,0.10619100D+02,0.00000000D+00
     .,0.33222990D+03,0.224D+03,0.820D+02,0.10619100D+02,0.00000000D+00
     .,0.30674920D+03,0.224D+03,0.830D+02,0.10619100D+02,0.00000000D+00
     .,0.29347990D+03,0.224D+03,0.840D+02,0.10619100D+02,0.00000000D+00
     .,0.27198150D+03,0.224D+03,0.850D+02,0.10619100D+02,0.00000000D+00
     .,0.25033250D+03,0.224D+03,0.860D+02,0.10619100D+02,0.00000000D+00
     .,0.80027390D+03,0.224D+03,0.870D+02,0.10619100D+02,0.00000000D+00
     .,0.77336630D+03,0.224D+03,0.880D+02,0.10619100D+02,0.00000000D+00
     .,0.68635790D+03,0.224D+03,0.890D+02,0.10619100D+02,0.00000000D+00
     .,0.62032700D+03,0.224D+03,0.900D+02,0.10619100D+02,0.00000000D+00
     ./)
      grimme_c6_parameters(  96001:  96100)=(/
     . 0.61475560D+03,0.224D+03,0.910D+02,0.10619100D+02,0.00000000D+00
     .,0.59538630D+03,0.224D+03,0.920D+02,0.10619100D+02,0.00000000D+00
     .,0.61108390D+03,0.224D+03,0.930D+02,0.10619100D+02,0.00000000D+00
     .,0.59208300D+03,0.224D+03,0.940D+02,0.10619100D+02,0.00000000D+00
     .,0.33942700D+02,0.224D+03,0.101D+03,0.10619100D+02,0.00000000D+00
     .,0.10775270D+03,0.224D+03,0.103D+03,0.10619100D+02,0.98650000D+00
     .,0.13789190D+03,0.224D+03,0.104D+03,0.10619100D+02,0.98080000D+00
     .,0.10672440D+03,0.224D+03,0.105D+03,0.10619100D+02,0.97060000D+00
     .,0.81233500D+02,0.224D+03,0.106D+03,0.10619100D+02,0.98680000D+00
     .,0.57176600D+02,0.224D+03,0.107D+03,0.10619100D+02,0.99440000D+00
     .,0.42104600D+02,0.224D+03,0.108D+03,0.10619100D+02,0.99250000D+00
     .,0.29392300D+02,0.224D+03,0.109D+03,0.10619100D+02,0.99820000D+00
     .,0.15738300D+03,0.224D+03,0.111D+03,0.10619100D+02,0.96840000D+00
     .,0.24300490D+03,0.224D+03,0.112D+03,0.10619100D+02,0.96280000D+00
     .,0.24743720D+03,0.224D+03,0.113D+03,0.10619100D+02,0.96480000D+00
     .,0.20073440D+03,0.224D+03,0.114D+03,0.10619100D+02,0.95070000D+00
     .,0.16576280D+03,0.224D+03,0.115D+03,0.10619100D+02,0.99470000D+00
     .,0.14110920D+03,0.224D+03,0.116D+03,0.10619100D+02,0.99480000D+00
     .,0.11621000D+03,0.224D+03,0.117D+03,0.10619100D+02,0.99720000D+00
     .,0.21890440D+03,0.224D+03,0.119D+03,0.10619100D+02,0.97670000D+00
     ./)
      grimme_c6_parameters(  96101:  96200)=(/
     . 0.41206100D+03,0.224D+03,0.120D+03,0.10619100D+02,0.98310000D+00
     .,0.22010130D+03,0.224D+03,0.121D+03,0.10619100D+02,0.18627000D+01
     .,0.21264500D+03,0.224D+03,0.122D+03,0.10619100D+02,0.18299000D+01
     .,0.20840940D+03,0.224D+03,0.123D+03,0.10619100D+02,0.19138000D+01
     .,0.20634260D+03,0.224D+03,0.124D+03,0.10619100D+02,0.18269000D+01
     .,0.19055280D+03,0.224D+03,0.125D+03,0.10619100D+02,0.16406000D+01
     .,0.17666070D+03,0.224D+03,0.126D+03,0.10619100D+02,0.16483000D+01
     .,0.16859690D+03,0.224D+03,0.127D+03,0.10619100D+02,0.17149000D+01
     .,0.16478470D+03,0.224D+03,0.128D+03,0.10619100D+02,0.17937000D+01
     .,0.16235450D+03,0.224D+03,0.129D+03,0.10619100D+02,0.95760000D+00
     .,0.15312950D+03,0.224D+03,0.130D+03,0.10619100D+02,0.19419000D+01
     .,0.24667960D+03,0.224D+03,0.131D+03,0.10619100D+02,0.96010000D+00
     .,0.21822070D+03,0.224D+03,0.132D+03,0.10619100D+02,0.94340000D+00
     .,0.19676310D+03,0.224D+03,0.133D+03,0.10619100D+02,0.98890000D+00
     .,0.18053650D+03,0.224D+03,0.134D+03,0.10619100D+02,0.99010000D+00
     .,0.15993620D+03,0.224D+03,0.135D+03,0.10619100D+02,0.99740000D+00
     .,0.26178690D+03,0.224D+03,0.137D+03,0.10619100D+02,0.97380000D+00
     .,0.50151140D+03,0.224D+03,0.138D+03,0.10619100D+02,0.98010000D+00
     .,0.38709820D+03,0.224D+03,0.139D+03,0.10619100D+02,0.19153000D+01
     .,0.29122970D+03,0.224D+03,0.140D+03,0.10619100D+02,0.19355000D+01
     ./)
      grimme_c6_parameters(  96201:  96300)=(/
     . 0.29411860D+03,0.224D+03,0.141D+03,0.10619100D+02,0.19545000D+01
     .,0.27484220D+03,0.224D+03,0.142D+03,0.10619100D+02,0.19420000D+01
     .,0.30675850D+03,0.224D+03,0.143D+03,0.10619100D+02,0.16682000D+01
     .,0.24066050D+03,0.224D+03,0.144D+03,0.10619100D+02,0.18584000D+01
     .,0.22538880D+03,0.224D+03,0.145D+03,0.10619100D+02,0.19003000D+01
     .,0.20959760D+03,0.224D+03,0.146D+03,0.10619100D+02,0.18630000D+01
     .,0.20266840D+03,0.224D+03,0.147D+03,0.10619100D+02,0.96790000D+00
     .,0.20093810D+03,0.224D+03,0.148D+03,0.10619100D+02,0.19539000D+01
     .,0.31400260D+03,0.224D+03,0.149D+03,0.10619100D+02,0.96330000D+00
     .,0.28561070D+03,0.224D+03,0.150D+03,0.10619100D+02,0.95140000D+00
     .,0.26862910D+03,0.224D+03,0.151D+03,0.10619100D+02,0.97490000D+00
     .,0.25497950D+03,0.224D+03,0.152D+03,0.10619100D+02,0.98110000D+00
     .,0.23389400D+03,0.224D+03,0.153D+03,0.10619100D+02,0.99680000D+00
     .,0.31070160D+03,0.224D+03,0.155D+03,0.10619100D+02,0.99090000D+00
     .,0.64956240D+03,0.224D+03,0.156D+03,0.10619100D+02,0.97970000D+00
     .,0.48969530D+03,0.224D+03,0.157D+03,0.10619100D+02,0.19373000D+01
     .,0.31384690D+03,0.224D+03,0.159D+03,0.10619100D+02,0.29425000D+01
     .,0.30738260D+03,0.224D+03,0.160D+03,0.10619100D+02,0.29455000D+01
     .,0.29775220D+03,0.224D+03,0.161D+03,0.10619100D+02,0.29413000D+01
     .,0.29895830D+03,0.224D+03,0.162D+03,0.10619100D+02,0.29300000D+01
     ./)
      grimme_c6_parameters(  96301:  96400)=(/
     . 0.28752360D+03,0.224D+03,0.163D+03,0.10619100D+02,0.18286000D+01
     .,0.30066880D+03,0.224D+03,0.164D+03,0.10619100D+02,0.28732000D+01
     .,0.28267060D+03,0.224D+03,0.165D+03,0.10619100D+02,0.29086000D+01
     .,0.28721540D+03,0.224D+03,0.166D+03,0.10619100D+02,0.28965000D+01
     .,0.26848670D+03,0.224D+03,0.167D+03,0.10619100D+02,0.29242000D+01
     .,0.26090960D+03,0.224D+03,0.168D+03,0.10619100D+02,0.29282000D+01
     .,0.25915780D+03,0.224D+03,0.169D+03,0.10619100D+02,0.29246000D+01
     .,0.27191140D+03,0.224D+03,0.170D+03,0.10619100D+02,0.28482000D+01
     .,0.25057300D+03,0.224D+03,0.171D+03,0.10619100D+02,0.29219000D+01
     .,0.33624450D+03,0.224D+03,0.172D+03,0.10619100D+02,0.19254000D+01
     .,0.31321870D+03,0.224D+03,0.173D+03,0.10619100D+02,0.19459000D+01
     .,0.28691560D+03,0.224D+03,0.174D+03,0.10619100D+02,0.19292000D+01
     .,0.28946620D+03,0.224D+03,0.175D+03,0.10619100D+02,0.18104000D+01
     .,0.25557530D+03,0.224D+03,0.176D+03,0.10619100D+02,0.18858000D+01
     .,0.24090600D+03,0.224D+03,0.177D+03,0.10619100D+02,0.18648000D+01
     .,0.23039700D+03,0.224D+03,0.178D+03,0.10619100D+02,0.19188000D+01
     .,0.22040320D+03,0.224D+03,0.179D+03,0.10619100D+02,0.98460000D+00
     .,0.21352200D+03,0.224D+03,0.180D+03,0.10619100D+02,0.19896000D+01
     .,0.33805130D+03,0.224D+03,0.181D+03,0.10619100D+02,0.92670000D+00
     .,0.30969410D+03,0.224D+03,0.182D+03,0.10619100D+02,0.93830000D+00
     ./)
      grimme_c6_parameters(  96401:  96500)=(/
     . 0.30120530D+03,0.224D+03,0.183D+03,0.10619100D+02,0.98200000D+00
     .,0.29366450D+03,0.224D+03,0.184D+03,0.10619100D+02,0.98150000D+00
     .,0.27525520D+03,0.224D+03,0.185D+03,0.10619100D+02,0.99540000D+00
     .,0.34998930D+03,0.224D+03,0.187D+03,0.10619100D+02,0.97050000D+00
     .,0.64793370D+03,0.224D+03,0.188D+03,0.10619100D+02,0.96620000D+00
     .,0.37121200D+03,0.224D+03,0.189D+03,0.10619100D+02,0.29070000D+01
     .,0.42672840D+03,0.224D+03,0.190D+03,0.10619100D+02,0.28844000D+01
     .,0.38254780D+03,0.224D+03,0.191D+03,0.10619100D+02,0.28738000D+01
     .,0.33923950D+03,0.224D+03,0.192D+03,0.10619100D+02,0.28878000D+01
     .,0.32676380D+03,0.224D+03,0.193D+03,0.10619100D+02,0.29095000D+01
     .,0.38936500D+03,0.224D+03,0.194D+03,0.10619100D+02,0.19209000D+01
     .,0.91098500D+02,0.224D+03,0.204D+03,0.10619100D+02,0.19697000D+01
     .,0.89961000D+02,0.224D+03,0.205D+03,0.10619100D+02,0.19441000D+01
     .,0.66613100D+02,0.224D+03,0.206D+03,0.10619100D+02,0.19985000D+01
     .,0.53772600D+02,0.224D+03,0.207D+03,0.10619100D+02,0.20143000D+01
     .,0.37302400D+02,0.224D+03,0.208D+03,0.10619100D+02,0.19887000D+01
     .,0.16055540D+03,0.224D+03,0.212D+03,0.10619100D+02,0.19496000D+01
     .,0.19398150D+03,0.224D+03,0.213D+03,0.10619100D+02,0.19311000D+01
     .,0.18700360D+03,0.224D+03,0.214D+03,0.10619100D+02,0.19435000D+01
     .,0.16347330D+03,0.224D+03,0.215D+03,0.10619100D+02,0.20102000D+01
     ./)
      grimme_c6_parameters(  96501:  96600)=(/
     . 0.13829440D+03,0.224D+03,0.216D+03,0.10619100D+02,0.19903000D+01
     .,0.22568810D+03,0.224D+03,0.220D+03,0.10619100D+02,0.19349000D+01
     .,0.21764940D+03,0.224D+03,0.221D+03,0.10619100D+02,0.28999000D+01
     .,0.22041700D+03,0.224D+03,0.222D+03,0.10619100D+02,0.38675000D+01
     .,0.20186410D+03,0.224D+03,0.223D+03,0.10619100D+02,0.29110000D+01
     .,0.15334350D+03,0.224D+03,0.224D+03,0.10619100D+02,0.10619100D+02
     .,0.18469400D+02,0.225D+03,0.100D+01,0.98849000D+01,0.91180000D+00
     .,0.12698500D+02,0.225D+03,0.200D+01,0.98849000D+01,0.00000000D+00
     .,0.25656890D+03,0.225D+03,0.300D+01,0.98849000D+01,0.00000000D+00
     .,0.15476870D+03,0.225D+03,0.400D+01,0.98849000D+01,0.00000000D+00
     .,0.10748660D+03,0.225D+03,0.500D+01,0.98849000D+01,0.00000000D+00
     .,0.74551100D+02,0.225D+03,0.600D+01,0.98849000D+01,0.00000000D+00
     .,0.53282800D+02,0.225D+03,0.700D+01,0.98849000D+01,0.00000000D+00
     .,0.41023700D+02,0.225D+03,0.800D+01,0.98849000D+01,0.00000000D+00
     .,0.31558200D+02,0.225D+03,0.900D+01,0.98849000D+01,0.00000000D+00
     .,0.24595700D+02,0.225D+03,0.100D+02,0.98849000D+01,0.00000000D+00
     .,0.30795570D+03,0.225D+03,0.110D+02,0.98849000D+01,0.00000000D+00
     .,0.24475170D+03,0.225D+03,0.120D+02,0.98849000D+01,0.00000000D+00
     .,0.22891250D+03,0.225D+03,0.130D+02,0.98849000D+01,0.00000000D+00
     .,0.18409450D+03,0.225D+03,0.140D+02,0.98849000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  96601:  96700)=(/
     . 0.14631750D+03,0.225D+03,0.150D+02,0.98849000D+01,0.00000000D+00
     .,0.12311700D+03,0.225D+03,0.160D+02,0.98849000D+01,0.00000000D+00
     .,0.10197460D+03,0.225D+03,0.170D+02,0.98849000D+01,0.00000000D+00
     .,0.84510700D+02,0.225D+03,0.180D+02,0.98849000D+01,0.00000000D+00
     .,0.50386210D+03,0.225D+03,0.190D+02,0.98849000D+01,0.00000000D+00
     .,0.42523820D+03,0.225D+03,0.200D+02,0.98849000D+01,0.00000000D+00
     .,0.35332830D+03,0.225D+03,0.210D+02,0.98849000D+01,0.00000000D+00
     .,0.34349160D+03,0.225D+03,0.220D+02,0.98849000D+01,0.00000000D+00
     .,0.31574920D+03,0.225D+03,0.230D+02,0.98849000D+01,0.00000000D+00
     .,0.24968190D+03,0.225D+03,0.240D+02,0.98849000D+01,0.00000000D+00
     .,0.27339370D+03,0.225D+03,0.250D+02,0.98849000D+01,0.00000000D+00
     .,0.21557380D+03,0.225D+03,0.260D+02,0.98849000D+01,0.00000000D+00
     .,0.22950770D+03,0.225D+03,0.270D+02,0.98849000D+01,0.00000000D+00
     .,0.23544990D+03,0.225D+03,0.280D+02,0.98849000D+01,0.00000000D+00
     .,0.18134820D+03,0.225D+03,0.290D+02,0.98849000D+01,0.00000000D+00
     .,0.18772140D+03,0.225D+03,0.300D+02,0.98849000D+01,0.00000000D+00
     .,0.22112170D+03,0.225D+03,0.310D+02,0.98849000D+01,0.00000000D+00
     .,0.19793940D+03,0.225D+03,0.320D+02,0.98849000D+01,0.00000000D+00
     .,0.17140770D+03,0.225D+03,0.330D+02,0.98849000D+01,0.00000000D+00
     .,0.15541540D+03,0.225D+03,0.340D+02,0.98849000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  96701:  96800)=(/
     . 0.13754060D+03,0.225D+03,0.350D+02,0.98849000D+01,0.00000000D+00
     .,0.12092190D+03,0.225D+03,0.360D+02,0.98849000D+01,0.00000000D+00
     .,0.56671690D+03,0.225D+03,0.370D+02,0.98849000D+01,0.00000000D+00
     .,0.50680360D+03,0.225D+03,0.380D+02,0.98849000D+01,0.00000000D+00
     .,0.44877680D+03,0.225D+03,0.390D+02,0.98849000D+01,0.00000000D+00
     .,0.40632670D+03,0.225D+03,0.400D+02,0.98849000D+01,0.00000000D+00
     .,0.37252150D+03,0.225D+03,0.410D+02,0.98849000D+01,0.00000000D+00
     .,0.29074940D+03,0.225D+03,0.420D+02,0.98849000D+01,0.00000000D+00
     .,0.32305520D+03,0.225D+03,0.430D+02,0.98849000D+01,0.00000000D+00
     .,0.24907370D+03,0.225D+03,0.440D+02,0.98849000D+01,0.00000000D+00
     .,0.27161880D+03,0.225D+03,0.450D+02,0.98849000D+01,0.00000000D+00
     .,0.25275950D+03,0.225D+03,0.460D+02,0.98849000D+01,0.00000000D+00
     .,0.21123900D+03,0.225D+03,0.470D+02,0.98849000D+01,0.00000000D+00
     .,0.22376440D+03,0.225D+03,0.480D+02,0.98849000D+01,0.00000000D+00
     .,0.27763500D+03,0.225D+03,0.490D+02,0.98849000D+01,0.00000000D+00
     .,0.25955840D+03,0.225D+03,0.500D+02,0.98849000D+01,0.00000000D+00
     .,0.23417500D+03,0.225D+03,0.510D+02,0.98849000D+01,0.00000000D+00
     .,0.21904270D+03,0.225D+03,0.520D+02,0.98849000D+01,0.00000000D+00
     .,0.19989240D+03,0.225D+03,0.530D+02,0.98849000D+01,0.00000000D+00
     .,0.18138370D+03,0.225D+03,0.540D+02,0.98849000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  96801:  96900)=(/
     . 0.69130860D+03,0.225D+03,0.550D+02,0.98849000D+01,0.00000000D+00
     .,0.64466000D+03,0.225D+03,0.560D+02,0.98849000D+01,0.00000000D+00
     .,0.57226670D+03,0.225D+03,0.570D+02,0.98849000D+01,0.00000000D+00
     .,0.27639550D+03,0.225D+03,0.580D+02,0.98849000D+01,0.27991000D+01
     .,0.57357140D+03,0.225D+03,0.590D+02,0.98849000D+01,0.00000000D+00
     .,0.55161300D+03,0.225D+03,0.600D+02,0.98849000D+01,0.00000000D+00
     .,0.53799770D+03,0.225D+03,0.610D+02,0.98849000D+01,0.00000000D+00
     .,0.52544060D+03,0.225D+03,0.620D+02,0.98849000D+01,0.00000000D+00
     .,0.51431120D+03,0.225D+03,0.630D+02,0.98849000D+01,0.00000000D+00
     .,0.41008630D+03,0.225D+03,0.640D+02,0.98849000D+01,0.00000000D+00
     .,0.45463510D+03,0.225D+03,0.650D+02,0.98849000D+01,0.00000000D+00
     .,0.43940520D+03,0.225D+03,0.660D+02,0.98849000D+01,0.00000000D+00
     .,0.46497300D+03,0.225D+03,0.670D+02,0.98849000D+01,0.00000000D+00
     .,0.45518120D+03,0.225D+03,0.680D+02,0.98849000D+01,0.00000000D+00
     .,0.44642190D+03,0.225D+03,0.690D+02,0.98849000D+01,0.00000000D+00
     .,0.44091820D+03,0.225D+03,0.700D+02,0.98849000D+01,0.00000000D+00
     .,0.37499750D+03,0.225D+03,0.710D+02,0.98849000D+01,0.00000000D+00
     .,0.37259650D+03,0.225D+03,0.720D+02,0.98849000D+01,0.00000000D+00
     .,0.34269950D+03,0.225D+03,0.730D+02,0.98849000D+01,0.00000000D+00
     .,0.29180770D+03,0.225D+03,0.740D+02,0.98849000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  96901:  97000)=(/
     . 0.29752890D+03,0.225D+03,0.750D+02,0.98849000D+01,0.00000000D+00
     .,0.27157970D+03,0.225D+03,0.760D+02,0.98849000D+01,0.00000000D+00
     .,0.25022110D+03,0.225D+03,0.770D+02,0.98849000D+01,0.00000000D+00
     .,0.20963300D+03,0.225D+03,0.780D+02,0.98849000D+01,0.00000000D+00
     .,0.19652040D+03,0.225D+03,0.790D+02,0.98849000D+01,0.00000000D+00
     .,0.20240200D+03,0.225D+03,0.800D+02,0.98849000D+01,0.00000000D+00
     .,0.28686700D+03,0.225D+03,0.810D+02,0.98849000D+01,0.00000000D+00
     .,0.28256650D+03,0.225D+03,0.820D+02,0.98849000D+01,0.00000000D+00
     .,0.26234870D+03,0.225D+03,0.830D+02,0.98849000D+01,0.00000000D+00
     .,0.25184810D+03,0.225D+03,0.840D+02,0.98849000D+01,0.00000000D+00
     .,0.23438100D+03,0.225D+03,0.850D+02,0.98849000D+01,0.00000000D+00
     .,0.21658230D+03,0.225D+03,0.860D+02,0.98849000D+01,0.00000000D+00
     .,0.65835450D+03,0.225D+03,0.870D+02,0.98849000D+01,0.00000000D+00
     .,0.64123120D+03,0.225D+03,0.880D+02,0.98849000D+01,0.00000000D+00
     .,0.57224570D+03,0.225D+03,0.890D+02,0.98849000D+01,0.00000000D+00
     .,0.52079400D+03,0.225D+03,0.900D+02,0.98849000D+01,0.00000000D+00
     .,0.51467310D+03,0.225D+03,0.910D+02,0.98849000D+01,0.00000000D+00
     .,0.49856630D+03,0.225D+03,0.920D+02,0.98849000D+01,0.00000000D+00
     .,0.50962770D+03,0.225D+03,0.930D+02,0.98849000D+01,0.00000000D+00
     .,0.49413580D+03,0.225D+03,0.940D+02,0.98849000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  97001:  97100)=(/
     . 0.29120800D+02,0.225D+03,0.101D+03,0.98849000D+01,0.00000000D+00
     .,0.90423100D+02,0.225D+03,0.103D+03,0.98849000D+01,0.98650000D+00
     .,0.11610320D+03,0.225D+03,0.104D+03,0.98849000D+01,0.98080000D+00
     .,0.91109100D+02,0.225D+03,0.105D+03,0.98849000D+01,0.97060000D+00
     .,0.69988300D+02,0.225D+03,0.106D+03,0.98849000D+01,0.98680000D+00
     .,0.49769800D+02,0.225D+03,0.107D+03,0.98849000D+01,0.99440000D+00
     .,0.36969200D+02,0.225D+03,0.108D+03,0.98849000D+01,0.99250000D+00
     .,0.26092600D+02,0.225D+03,0.109D+03,0.98849000D+01,0.99820000D+00
     .,0.13182570D+03,0.225D+03,0.111D+03,0.98849000D+01,0.96840000D+00
     .,0.20321730D+03,0.225D+03,0.112D+03,0.98849000D+01,0.96280000D+00
     .,0.20829020D+03,0.225D+03,0.113D+03,0.98849000D+01,0.96480000D+00
     .,0.17075150D+03,0.225D+03,0.114D+03,0.98849000D+01,0.95070000D+00
     .,0.14216740D+03,0.225D+03,0.115D+03,0.98849000D+01,0.99470000D+00
     .,0.12175410D+03,0.225D+03,0.116D+03,0.98849000D+01,0.99480000D+00
     .,0.10091430D+03,0.225D+03,0.117D+03,0.98849000D+01,0.99720000D+00
     .,0.18481700D+03,0.225D+03,0.119D+03,0.98849000D+01,0.97670000D+00
     .,0.34176740D+03,0.225D+03,0.120D+03,0.98849000D+01,0.98310000D+00
     .,0.18713640D+03,0.225D+03,0.121D+03,0.98849000D+01,0.18627000D+01
     .,0.18091050D+03,0.225D+03,0.122D+03,0.98849000D+01,0.18299000D+01
     .,0.17729930D+03,0.225D+03,0.123D+03,0.98849000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters(  97101:  97200)=(/
     . 0.17538670D+03,0.225D+03,0.124D+03,0.98849000D+01,0.18269000D+01
     .,0.16268440D+03,0.225D+03,0.125D+03,0.98849000D+01,0.16406000D+01
     .,0.15107680D+03,0.225D+03,0.126D+03,0.98849000D+01,0.16483000D+01
     .,0.14421590D+03,0.225D+03,0.127D+03,0.98849000D+01,0.17149000D+01
     .,0.14090800D+03,0.225D+03,0.128D+03,0.98849000D+01,0.17937000D+01
     .,0.13835720D+03,0.225D+03,0.129D+03,0.98849000D+01,0.95760000D+00
     .,0.13131000D+03,0.225D+03,0.130D+03,0.98849000D+01,0.19419000D+01
     .,0.20851100D+03,0.225D+03,0.131D+03,0.98849000D+01,0.96010000D+00
     .,0.18592460D+03,0.225D+03,0.132D+03,0.98849000D+01,0.94340000D+00
     .,0.16867800D+03,0.225D+03,0.133D+03,0.98849000D+01,0.98890000D+00
     .,0.15546520D+03,0.225D+03,0.134D+03,0.98849000D+01,0.99010000D+00
     .,0.13842960D+03,0.225D+03,0.135D+03,0.98849000D+01,0.99740000D+00
     .,0.22151020D+03,0.225D+03,0.137D+03,0.98849000D+01,0.97380000D+00
     .,0.41583400D+03,0.225D+03,0.138D+03,0.98849000D+01,0.98010000D+00
     .,0.32497510D+03,0.225D+03,0.139D+03,0.98849000D+01,0.19153000D+01
     .,0.24759810D+03,0.225D+03,0.140D+03,0.98849000D+01,0.19355000D+01
     .,0.25002660D+03,0.225D+03,0.141D+03,0.98849000D+01,0.19545000D+01
     .,0.23413150D+03,0.225D+03,0.142D+03,0.98849000D+01,0.19420000D+01
     .,0.25980510D+03,0.225D+03,0.143D+03,0.98849000D+01,0.16682000D+01
     .,0.20600200D+03,0.225D+03,0.144D+03,0.98849000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters(  97201:  97300)=(/
     . 0.19308940D+03,0.225D+03,0.145D+03,0.98849000D+01,0.19003000D+01
     .,0.17978240D+03,0.225D+03,0.146D+03,0.98849000D+01,0.18630000D+01
     .,0.17373810D+03,0.225D+03,0.147D+03,0.98849000D+01,0.96790000D+00
     .,0.17276980D+03,0.225D+03,0.148D+03,0.98849000D+01,0.19539000D+01
     .,0.26575750D+03,0.225D+03,0.149D+03,0.98849000D+01,0.96330000D+00
     .,0.24329840D+03,0.225D+03,0.150D+03,0.98849000D+01,0.95140000D+00
     .,0.22991580D+03,0.225D+03,0.151D+03,0.98849000D+01,0.97490000D+00
     .,0.21898580D+03,0.225D+03,0.152D+03,0.98849000D+01,0.98110000D+00
     .,0.20172290D+03,0.225D+03,0.153D+03,0.98849000D+01,0.99680000D+00
     .,0.26411800D+03,0.225D+03,0.155D+03,0.98849000D+01,0.99090000D+00
     .,0.53758040D+03,0.225D+03,0.156D+03,0.98849000D+01,0.97970000D+00
     .,0.41076200D+03,0.225D+03,0.157D+03,0.98849000D+01,0.19373000D+01
     .,0.26829020D+03,0.225D+03,0.159D+03,0.98849000D+01,0.29425000D+01
     .,0.26278540D+03,0.225D+03,0.160D+03,0.98849000D+01,0.29455000D+01
     .,0.25464690D+03,0.225D+03,0.161D+03,0.98849000D+01,0.29413000D+01
     .,0.25543700D+03,0.225D+03,0.162D+03,0.98849000D+01,0.29300000D+01
     .,0.24496120D+03,0.225D+03,0.163D+03,0.98849000D+01,0.18286000D+01
     .,0.25677460D+03,0.225D+03,0.164D+03,0.98849000D+01,0.28732000D+01
     .,0.24162910D+03,0.225D+03,0.165D+03,0.98849000D+01,0.29086000D+01
     .,0.24510920D+03,0.225D+03,0.166D+03,0.98849000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters(  97301:  97400)=(/
     . 0.22968660D+03,0.225D+03,0.167D+03,0.98849000D+01,0.29242000D+01
     .,0.22327460D+03,0.225D+03,0.168D+03,0.98849000D+01,0.29282000D+01
     .,0.22171170D+03,0.225D+03,0.169D+03,0.98849000D+01,0.29246000D+01
     .,0.23223100D+03,0.225D+03,0.170D+03,0.98849000D+01,0.28482000D+01
     .,0.21445700D+03,0.225D+03,0.171D+03,0.98849000D+01,0.29219000D+01
     .,0.28461080D+03,0.225D+03,0.172D+03,0.98849000D+01,0.19254000D+01
     .,0.26619500D+03,0.225D+03,0.173D+03,0.98849000D+01,0.19459000D+01
     .,0.24486880D+03,0.225D+03,0.174D+03,0.98849000D+01,0.19292000D+01
     .,0.24620160D+03,0.225D+03,0.175D+03,0.98849000D+01,0.18104000D+01
     .,0.21942180D+03,0.225D+03,0.176D+03,0.98849000D+01,0.18858000D+01
     .,0.20718460D+03,0.225D+03,0.177D+03,0.98849000D+01,0.18648000D+01
     .,0.19836510D+03,0.225D+03,0.178D+03,0.98849000D+01,0.19188000D+01
     .,0.18980990D+03,0.225D+03,0.179D+03,0.98849000D+01,0.98460000D+00
     .,0.18444130D+03,0.225D+03,0.180D+03,0.98849000D+01,0.19896000D+01
     .,0.28672590D+03,0.225D+03,0.181D+03,0.98849000D+01,0.92670000D+00
     .,0.26430990D+03,0.225D+03,0.182D+03,0.98849000D+01,0.93830000D+00
     .,0.25793290D+03,0.225D+03,0.183D+03,0.98849000D+01,0.98200000D+00
     .,0.25212510D+03,0.225D+03,0.184D+03,0.98849000D+01,0.98150000D+00
     .,0.23719910D+03,0.225D+03,0.185D+03,0.98849000D+01,0.99540000D+00
     .,0.29760870D+03,0.225D+03,0.187D+03,0.98849000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters(  97401:  97500)=(/
     . 0.53830700D+03,0.225D+03,0.188D+03,0.98849000D+01,0.96620000D+00
     .,0.31722510D+03,0.225D+03,0.189D+03,0.98849000D+01,0.29070000D+01
     .,0.36280170D+03,0.225D+03,0.190D+03,0.98849000D+01,0.28844000D+01
     .,0.32606070D+03,0.225D+03,0.191D+03,0.98849000D+01,0.28738000D+01
     .,0.29035010D+03,0.225D+03,0.192D+03,0.98849000D+01,0.28878000D+01
     .,0.27996200D+03,0.225D+03,0.193D+03,0.98849000D+01,0.29095000D+01
     .,0.32981320D+03,0.225D+03,0.194D+03,0.98849000D+01,0.19209000D+01
     .,0.77782300D+02,0.225D+03,0.204D+03,0.98849000D+01,0.19697000D+01
     .,0.77081200D+02,0.225D+03,0.205D+03,0.98849000D+01,0.19441000D+01
     .,0.57689300D+02,0.225D+03,0.206D+03,0.98849000D+01,0.19985000D+01
     .,0.46868100D+02,0.225D+03,0.207D+03,0.98849000D+01,0.20143000D+01
     .,0.32849500D+02,0.225D+03,0.208D+03,0.98849000D+01,0.19887000D+01
     .,0.13616190D+03,0.225D+03,0.212D+03,0.98849000D+01,0.19496000D+01
     .,0.16440450D+03,0.225D+03,0.213D+03,0.98849000D+01,0.19311000D+01
     .,0.15932860D+03,0.225D+03,0.214D+03,0.98849000D+01,0.19435000D+01
     .,0.14014430D+03,0.225D+03,0.215D+03,0.98849000D+01,0.20102000D+01
     .,0.11934860D+03,0.225D+03,0.216D+03,0.98849000D+01,0.19903000D+01
     .,0.19163220D+03,0.225D+03,0.220D+03,0.98849000D+01,0.19349000D+01
     .,0.18555440D+03,0.225D+03,0.221D+03,0.98849000D+01,0.28999000D+01
     .,0.18798380D+03,0.225D+03,0.222D+03,0.98849000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters(  97501:  97600)=(/
     . 0.17219800D+03,0.225D+03,0.223D+03,0.98849000D+01,0.29110000D+01
     .,0.13182880D+03,0.225D+03,0.224D+03,0.98849000D+01,0.10619100D+02
     .,0.11384630D+03,0.225D+03,0.225D+03,0.98849000D+01,0.98849000D+01
     .,0.18097700D+02,0.226D+03,0.100D+01,0.91376000D+01,0.91180000D+00
     .,0.12427700D+02,0.226D+03,0.200D+01,0.91376000D+01,0.00000000D+00
     .,0.25324320D+03,0.226D+03,0.300D+01,0.91376000D+01,0.00000000D+00
     .,0.15229860D+03,0.226D+03,0.400D+01,0.91376000D+01,0.00000000D+00
     .,0.10555810D+03,0.226D+03,0.500D+01,0.91376000D+01,0.00000000D+00
     .,0.73107900D+02,0.226D+03,0.600D+01,0.91376000D+01,0.00000000D+00
     .,0.52202800D+02,0.226D+03,0.700D+01,0.91376000D+01,0.00000000D+00
     .,0.40170900D+02,0.226D+03,0.800D+01,0.91376000D+01,0.00000000D+00
     .,0.30892500D+02,0.226D+03,0.900D+01,0.91376000D+01,0.00000000D+00
     .,0.24074100D+02,0.226D+03,0.100D+02,0.91376000D+01,0.00000000D+00
     .,0.30391240D+03,0.226D+03,0.110D+02,0.91376000D+01,0.00000000D+00
     .,0.24099620D+03,0.226D+03,0.120D+02,0.91376000D+01,0.00000000D+00
     .,0.22516630D+03,0.226D+03,0.130D+02,0.91376000D+01,0.00000000D+00
     .,0.18083460D+03,0.226D+03,0.140D+02,0.91376000D+01,0.00000000D+00
     .,0.14355850D+03,0.226D+03,0.150D+02,0.91376000D+01,0.00000000D+00
     .,0.12070600D+03,0.226D+03,0.160D+02,0.91376000D+01,0.00000000D+00
     .,0.99911900D+02,0.226D+03,0.170D+02,0.91376000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  97601:  97700)=(/
     . 0.82759100D+02,0.226D+03,0.180D+02,0.91376000D+01,0.00000000D+00
     .,0.49731050D+03,0.226D+03,0.190D+02,0.91376000D+01,0.00000000D+00
     .,0.41906350D+03,0.226D+03,0.200D+02,0.91376000D+01,0.00000000D+00
     .,0.34806420D+03,0.226D+03,0.210D+02,0.91376000D+01,0.00000000D+00
     .,0.33822830D+03,0.226D+03,0.220D+02,0.91376000D+01,0.00000000D+00
     .,0.31083750D+03,0.226D+03,0.230D+02,0.91376000D+01,0.00000000D+00
     .,0.24576290D+03,0.226D+03,0.240D+02,0.91376000D+01,0.00000000D+00
     .,0.26904940D+03,0.226D+03,0.250D+02,0.91376000D+01,0.00000000D+00
     .,0.21211090D+03,0.226D+03,0.260D+02,0.91376000D+01,0.00000000D+00
     .,0.22573460D+03,0.226D+03,0.270D+02,0.91376000D+01,0.00000000D+00
     .,0.23164220D+03,0.226D+03,0.280D+02,0.91376000D+01,0.00000000D+00
     .,0.17839240D+03,0.226D+03,0.290D+02,0.91376000D+01,0.00000000D+00
     .,0.18454030D+03,0.226D+03,0.300D+02,0.91376000D+01,0.00000000D+00
     .,0.21740400D+03,0.226D+03,0.310D+02,0.91376000D+01,0.00000000D+00
     .,0.19441570D+03,0.226D+03,0.320D+02,0.91376000D+01,0.00000000D+00
     .,0.16819670D+03,0.226D+03,0.330D+02,0.91376000D+01,0.00000000D+00
     .,0.15241280D+03,0.226D+03,0.340D+02,0.91376000D+01,0.00000000D+00
     .,0.13480510D+03,0.226D+03,0.350D+02,0.91376000D+01,0.00000000D+00
     .,0.11845780D+03,0.226D+03,0.360D+02,0.91376000D+01,0.00000000D+00
     .,0.55921770D+03,0.226D+03,0.370D+02,0.91376000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  97701:  97800)=(/
     . 0.49943750D+03,0.226D+03,0.380D+02,0.91376000D+01,0.00000000D+00
     .,0.44192580D+03,0.226D+03,0.390D+02,0.91376000D+01,0.00000000D+00
     .,0.39992950D+03,0.226D+03,0.400D+02,0.91376000D+01,0.00000000D+00
     .,0.36653290D+03,0.226D+03,0.410D+02,0.91376000D+01,0.00000000D+00
     .,0.28589770D+03,0.226D+03,0.420D+02,0.91376000D+01,0.00000000D+00
     .,0.31774320D+03,0.226D+03,0.430D+02,0.91376000D+01,0.00000000D+00
     .,0.24481840D+03,0.226D+03,0.440D+02,0.91376000D+01,0.00000000D+00
     .,0.26700480D+03,0.226D+03,0.450D+02,0.91376000D+01,0.00000000D+00
     .,0.24842030D+03,0.226D+03,0.460D+02,0.91376000D+01,0.00000000D+00
     .,0.20761810D+03,0.226D+03,0.470D+02,0.91376000D+01,0.00000000D+00
     .,0.21987500D+03,0.226D+03,0.480D+02,0.91376000D+01,0.00000000D+00
     .,0.27297690D+03,0.226D+03,0.490D+02,0.91376000D+01,0.00000000D+00
     .,0.25501000D+03,0.226D+03,0.500D+02,0.91376000D+01,0.00000000D+00
     .,0.22988770D+03,0.226D+03,0.510D+02,0.91376000D+01,0.00000000D+00
     .,0.21492360D+03,0.226D+03,0.520D+02,0.91376000D+01,0.00000000D+00
     .,0.19602880D+03,0.226D+03,0.530D+02,0.91376000D+01,0.00000000D+00
     .,0.17779050D+03,0.226D+03,0.540D+02,0.91376000D+01,0.00000000D+00
     .,0.68205790D+03,0.226D+03,0.550D+02,0.91376000D+01,0.00000000D+00
     .,0.63538110D+03,0.226D+03,0.560D+02,0.91376000D+01,0.00000000D+00
     .,0.56362450D+03,0.226D+03,0.570D+02,0.91376000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  97801:  97900)=(/
     . 0.27135450D+03,0.226D+03,0.580D+02,0.91376000D+01,0.27991000D+01
     .,0.56520430D+03,0.226D+03,0.590D+02,0.91376000D+01,0.00000000D+00
     .,0.54351170D+03,0.226D+03,0.600D+02,0.91376000D+01,0.00000000D+00
     .,0.53008260D+03,0.226D+03,0.610D+02,0.91376000D+01,0.00000000D+00
     .,0.51769890D+03,0.226D+03,0.620D+02,0.91376000D+01,0.00000000D+00
     .,0.50672260D+03,0.226D+03,0.630D+02,0.91376000D+01,0.00000000D+00
     .,0.40367390D+03,0.226D+03,0.640D+02,0.91376000D+01,0.00000000D+00
     .,0.44799700D+03,0.226D+03,0.650D+02,0.91376000D+01,0.00000000D+00
     .,0.43292450D+03,0.226D+03,0.660D+02,0.91376000D+01,0.00000000D+00
     .,0.45804090D+03,0.226D+03,0.670D+02,0.91376000D+01,0.00000000D+00
     .,0.44838960D+03,0.226D+03,0.680D+02,0.91376000D+01,0.00000000D+00
     .,0.43975060D+03,0.226D+03,0.690D+02,0.91376000D+01,0.00000000D+00
     .,0.43434720D+03,0.226D+03,0.700D+02,0.91376000D+01,0.00000000D+00
     .,0.36918400D+03,0.226D+03,0.710D+02,0.91376000D+01,0.00000000D+00
     .,0.36653030D+03,0.226D+03,0.720D+02,0.91376000D+01,0.00000000D+00
     .,0.33695440D+03,0.226D+03,0.730D+02,0.91376000D+01,0.00000000D+00
     .,0.28678360D+03,0.226D+03,0.740D+02,0.91376000D+01,0.00000000D+00
     .,0.29236350D+03,0.226D+03,0.750D+02,0.91376000D+01,0.00000000D+00
     .,0.26675590D+03,0.226D+03,0.760D+02,0.91376000D+01,0.00000000D+00
     .,0.24569670D+03,0.226D+03,0.770D+02,0.91376000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  97901:  98000)=(/
     . 0.20576580D+03,0.226D+03,0.780D+02,0.91376000D+01,0.00000000D+00
     .,0.19287140D+03,0.226D+03,0.790D+02,0.91376000D+01,0.00000000D+00
     .,0.19862370D+03,0.226D+03,0.800D+02,0.91376000D+01,0.00000000D+00
     .,0.28196900D+03,0.226D+03,0.810D+02,0.91376000D+01,0.00000000D+00
     .,0.27759650D+03,0.226D+03,0.820D+02,0.91376000D+01,0.00000000D+00
     .,0.25755980D+03,0.226D+03,0.830D+02,0.91376000D+01,0.00000000D+00
     .,0.24714790D+03,0.226D+03,0.840D+02,0.91376000D+01,0.00000000D+00
     .,0.22989230D+03,0.226D+03,0.850D+02,0.91376000D+01,0.00000000D+00
     .,0.21233880D+03,0.226D+03,0.860D+02,0.91376000D+01,0.00000000D+00
     .,0.64916640D+03,0.226D+03,0.870D+02,0.91376000D+01,0.00000000D+00
     .,0.63174380D+03,0.226D+03,0.880D+02,0.91376000D+01,0.00000000D+00
     .,0.56344000D+03,0.226D+03,0.890D+02,0.91376000D+01,0.00000000D+00
     .,0.51237500D+03,0.226D+03,0.900D+02,0.91376000D+01,0.00000000D+00
     .,0.50653490D+03,0.226D+03,0.910D+02,0.91376000D+01,0.00000000D+00
     .,0.49067580D+03,0.226D+03,0.920D+02,0.91376000D+01,0.00000000D+00
     .,0.50182620D+03,0.226D+03,0.930D+02,0.91376000D+01,0.00000000D+00
     .,0.48653240D+03,0.226D+03,0.940D+02,0.91376000D+01,0.00000000D+00
     .,0.28566500D+02,0.226D+03,0.101D+03,0.91376000D+01,0.00000000D+00
     .,0.88953800D+02,0.226D+03,0.103D+03,0.91376000D+01,0.98650000D+00
     .,0.11416130D+03,0.226D+03,0.104D+03,0.91376000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters(  98001:  98100)=(/
     . 0.89435400D+02,0.226D+03,0.105D+03,0.91376000D+01,0.97060000D+00
     .,0.68629300D+02,0.226D+03,0.106D+03,0.91376000D+01,0.98680000D+00
     .,0.48755800D+02,0.226D+03,0.107D+03,0.91376000D+01,0.99440000D+00
     .,0.36191900D+02,0.226D+03,0.108D+03,0.91376000D+01,0.99250000D+00
     .,0.25531400D+02,0.226D+03,0.109D+03,0.91376000D+01,0.99820000D+00
     .,0.12973320D+03,0.226D+03,0.111D+03,0.91376000D+01,0.96840000D+00
     .,0.20000410D+03,0.226D+03,0.112D+03,0.91376000D+01,0.96280000D+00
     .,0.20482820D+03,0.226D+03,0.113D+03,0.91376000D+01,0.96480000D+00
     .,0.16769170D+03,0.226D+03,0.114D+03,0.91376000D+01,0.95070000D+00
     .,0.13948020D+03,0.226D+03,0.115D+03,0.91376000D+01,0.99470000D+00
     .,0.11937190D+03,0.226D+03,0.116D+03,0.91376000D+01,0.99480000D+00
     .,0.98874700D+02,0.226D+03,0.117D+03,0.91376000D+01,0.99720000D+00
     .,0.18170400D+03,0.226D+03,0.119D+03,0.91376000D+01,0.97670000D+00
     .,0.33670380D+03,0.226D+03,0.120D+03,0.91376000D+01,0.98310000D+00
     .,0.18382570D+03,0.226D+03,0.121D+03,0.91376000D+01,0.18627000D+01
     .,0.17770070D+03,0.226D+03,0.122D+03,0.91376000D+01,0.18299000D+01
     .,0.17415940D+03,0.226D+03,0.123D+03,0.91376000D+01,0.19138000D+01
     .,0.17230360D+03,0.226D+03,0.124D+03,0.91376000D+01,0.18269000D+01
     .,0.15974020D+03,0.226D+03,0.125D+03,0.91376000D+01,0.16406000D+01
     .,0.14831710D+03,0.226D+03,0.126D+03,0.91376000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters(  98101:  98200)=(/
     . 0.14158150D+03,0.226D+03,0.127D+03,0.91376000D+01,0.17149000D+01
     .,0.13834240D+03,0.226D+03,0.128D+03,0.91376000D+01,0.17937000D+01
     .,0.13590190D+03,0.226D+03,0.129D+03,0.91376000D+01,0.95760000D+00
     .,0.12887600D+03,0.226D+03,0.130D+03,0.91376000D+01,0.19419000D+01
     .,0.20495230D+03,0.226D+03,0.131D+03,0.91376000D+01,0.96010000D+00
     .,0.18256910D+03,0.226D+03,0.132D+03,0.91376000D+01,0.94340000D+00
     .,0.16550840D+03,0.226D+03,0.133D+03,0.91376000D+01,0.98890000D+00
     .,0.15246290D+03,0.226D+03,0.134D+03,0.91376000D+01,0.99010000D+00
     .,0.13568060D+03,0.226D+03,0.135D+03,0.91376000D+01,0.99740000D+00
     .,0.21771950D+03,0.226D+03,0.137D+03,0.91376000D+01,0.97380000D+00
     .,0.40967730D+03,0.226D+03,0.138D+03,0.91376000D+01,0.98010000D+00
     .,0.31968600D+03,0.226D+03,0.139D+03,0.91376000D+01,0.19153000D+01
     .,0.24320860D+03,0.226D+03,0.140D+03,0.91376000D+01,0.19355000D+01
     .,0.24560370D+03,0.226D+03,0.141D+03,0.91376000D+01,0.19545000D+01
     .,0.22993990D+03,0.226D+03,0.142D+03,0.91376000D+01,0.19420000D+01
     .,0.25533300D+03,0.226D+03,0.143D+03,0.91376000D+01,0.16682000D+01
     .,0.20221300D+03,0.226D+03,0.144D+03,0.91376000D+01,0.18584000D+01
     .,0.18952850D+03,0.226D+03,0.145D+03,0.91376000D+01,0.19003000D+01
     .,0.17645130D+03,0.226D+03,0.146D+03,0.91376000D+01,0.18630000D+01
     .,0.17054030D+03,0.226D+03,0.147D+03,0.91376000D+01,0.96790000D+00
     ./)
      grimme_c6_parameters(  98201:  98300)=(/
     . 0.16952460D+03,0.226D+03,0.148D+03,0.91376000D+01,0.19539000D+01
     .,0.26122680D+03,0.226D+03,0.149D+03,0.91376000D+01,0.96330000D+00
     .,0.23895870D+03,0.226D+03,0.150D+03,0.91376000D+01,0.95140000D+00
     .,0.22568120D+03,0.226D+03,0.151D+03,0.91376000D+01,0.97490000D+00
     .,0.21486070D+03,0.226D+03,0.152D+03,0.91376000D+01,0.98110000D+00
     .,0.19782510D+03,0.226D+03,0.153D+03,0.91376000D+01,0.99680000D+00
     .,0.25941930D+03,0.226D+03,0.155D+03,0.91376000D+01,0.99090000D+00
     .,0.52971550D+03,0.226D+03,0.156D+03,0.91376000D+01,0.97970000D+00
     .,0.40410260D+03,0.226D+03,0.157D+03,0.91376000D+01,0.19373000D+01
     .,0.26338510D+03,0.226D+03,0.159D+03,0.91376000D+01,0.29425000D+01
     .,0.25797950D+03,0.226D+03,0.160D+03,0.91376000D+01,0.29455000D+01
     .,0.24997990D+03,0.226D+03,0.161D+03,0.91376000D+01,0.29413000D+01
     .,0.25078300D+03,0.226D+03,0.162D+03,0.91376000D+01,0.29300000D+01
     .,0.24059220D+03,0.226D+03,0.163D+03,0.91376000D+01,0.18286000D+01
     .,0.25210750D+03,0.226D+03,0.164D+03,0.91376000D+01,0.28732000D+01
     .,0.23721640D+03,0.226D+03,0.165D+03,0.91376000D+01,0.29086000D+01
     .,0.24067880D+03,0.226D+03,0.166D+03,0.91376000D+01,0.28965000D+01
     .,0.22546970D+03,0.226D+03,0.167D+03,0.91376000D+01,0.29242000D+01
     .,0.21916750D+03,0.226D+03,0.168D+03,0.91376000D+01,0.29282000D+01
     .,0.21764010D+03,0.226D+03,0.169D+03,0.91376000D+01,0.29246000D+01
     ./)
      grimme_c6_parameters(  98301:  98400)=(/
     . 0.22800720D+03,0.226D+03,0.170D+03,0.91376000D+01,0.28482000D+01
     .,0.21050650D+03,0.226D+03,0.171D+03,0.91376000D+01,0.29219000D+01
     .,0.27971240D+03,0.226D+03,0.172D+03,0.91376000D+01,0.19254000D+01
     .,0.26149250D+03,0.226D+03,0.173D+03,0.91376000D+01,0.19459000D+01
     .,0.24043090D+03,0.226D+03,0.174D+03,0.91376000D+01,0.19292000D+01
     .,0.24184390D+03,0.226D+03,0.175D+03,0.91376000D+01,0.18104000D+01
     .,0.21530790D+03,0.226D+03,0.176D+03,0.91376000D+01,0.18858000D+01
     .,0.20326950D+03,0.226D+03,0.177D+03,0.91376000D+01,0.18648000D+01
     .,0.19460130D+03,0.226D+03,0.178D+03,0.91376000D+01,0.19188000D+01
     .,0.18621520D+03,0.226D+03,0.179D+03,0.91376000D+01,0.98460000D+00
     .,0.18088400D+03,0.226D+03,0.180D+03,0.91376000D+01,0.19896000D+01
     .,0.28177560D+03,0.226D+03,0.181D+03,0.91376000D+01,0.92670000D+00
     .,0.25955420D+03,0.226D+03,0.182D+03,0.91376000D+01,0.93830000D+00
     .,0.25318480D+03,0.226D+03,0.183D+03,0.91376000D+01,0.98200000D+00
     .,0.24740350D+03,0.226D+03,0.184D+03,0.91376000D+01,0.98150000D+00
     .,0.23265410D+03,0.226D+03,0.185D+03,0.91376000D+01,0.99540000D+00
     .,0.29230010D+03,0.226D+03,0.187D+03,0.91376000D+01,0.97050000D+00
     .,0.53018710D+03,0.226D+03,0.188D+03,0.91376000D+01,0.96620000D+00
     .,0.31143140D+03,0.226D+03,0.189D+03,0.91376000D+01,0.29070000D+01
     .,0.35639700D+03,0.226D+03,0.190D+03,0.91376000D+01,0.28844000D+01
     ./)
      grimme_c6_parameters(  98401:  98500)=(/
     . 0.32021770D+03,0.226D+03,0.191D+03,0.91376000D+01,0.28738000D+01
     .,0.28502300D+03,0.226D+03,0.192D+03,0.91376000D+01,0.28878000D+01
     .,0.27479730D+03,0.226D+03,0.193D+03,0.91376000D+01,0.29095000D+01
     .,0.32416540D+03,0.226D+03,0.194D+03,0.91376000D+01,0.19209000D+01
     .,0.76349400D+02,0.226D+03,0.204D+03,0.91376000D+01,0.19697000D+01
     .,0.75632700D+02,0.226D+03,0.205D+03,0.91376000D+01,0.19441000D+01
     .,0.56542900D+02,0.226D+03,0.206D+03,0.91376000D+01,0.19985000D+01
     .,0.45914000D+02,0.226D+03,0.207D+03,0.91376000D+01,0.20143000D+01
     .,0.32158400D+02,0.226D+03,0.208D+03,0.91376000D+01,0.19887000D+01
     .,0.13378530D+03,0.226D+03,0.212D+03,0.91376000D+01,0.19496000D+01
     .,0.16153570D+03,0.226D+03,0.213D+03,0.91376000D+01,0.19311000D+01
     .,0.15644370D+03,0.226D+03,0.214D+03,0.91376000D+01,0.19435000D+01
     .,0.13750430D+03,0.226D+03,0.215D+03,0.91376000D+01,0.20102000D+01
     .,0.11701210D+03,0.226D+03,0.216D+03,0.91376000D+01,0.19903000D+01
     .,0.18826960D+03,0.226D+03,0.220D+03,0.91376000D+01,0.19349000D+01
     .,0.18220620D+03,0.226D+03,0.221D+03,0.91376000D+01,0.28999000D+01
     .,0.18458560D+03,0.226D+03,0.222D+03,0.91376000D+01,0.38675000D+01
     .,0.16909000D+03,0.226D+03,0.223D+03,0.91376000D+01,0.29110000D+01
     .,0.12934440D+03,0.226D+03,0.224D+03,0.91376000D+01,0.10619100D+02
     .,0.11164910D+03,0.226D+03,0.225D+03,0.91376000D+01,0.98849000D+01
     ./)
      grimme_c6_parameters(  98501:  98600)=(/
     . 0.10950410D+03,0.226D+03,0.226D+03,0.91376000D+01,0.91376000D+01
     .,0.20774100D+02,0.227D+03,0.100D+01,0.29263000D+01,0.91180000D+00
     .,0.13880400D+02,0.227D+03,0.200D+01,0.29263000D+01,0.00000000D+00
     .,0.31984480D+03,0.227D+03,0.300D+01,0.29263000D+01,0.00000000D+00
     .,0.18489380D+03,0.227D+03,0.400D+01,0.29263000D+01,0.00000000D+00
     .,0.12490870D+03,0.227D+03,0.500D+01,0.29263000D+01,0.00000000D+00
     .,0.84755200D+02,0.227D+03,0.600D+01,0.29263000D+01,0.00000000D+00
     .,0.59562800D+02,0.227D+03,0.700D+01,0.29263000D+01,0.00000000D+00
     .,0.45306600D+02,0.227D+03,0.800D+01,0.29263000D+01,0.00000000D+00
     .,0.34493500D+02,0.227D+03,0.900D+01,0.29263000D+01,0.00000000D+00
     .,0.26662700D+02,0.227D+03,0.100D+02,0.29263000D+01,0.00000000D+00
     .,0.38268210D+03,0.227D+03,0.110D+02,0.29263000D+01,0.00000000D+00
     .,0.29460910D+03,0.227D+03,0.120D+02,0.29263000D+01,0.00000000D+00
     .,0.27182260D+03,0.227D+03,0.130D+02,0.29263000D+01,0.00000000D+00
     .,0.21457260D+03,0.227D+03,0.140D+02,0.29263000D+01,0.00000000D+00
     .,0.16773560D+03,0.227D+03,0.150D+02,0.29263000D+01,0.00000000D+00
     .,0.13954300D+03,0.227D+03,0.160D+02,0.29263000D+01,0.00000000D+00
     .,0.11430910D+03,0.227D+03,0.170D+02,0.29263000D+01,0.00000000D+00
     .,0.93808400D+02,0.227D+03,0.180D+02,0.29263000D+01,0.00000000D+00
     .,0.62812380D+03,0.227D+03,0.190D+02,0.29263000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  98601:  98700)=(/
     . 0.51787690D+03,0.227D+03,0.200D+02,0.29263000D+01,0.00000000D+00
     .,0.42788660D+03,0.227D+03,0.210D+02,0.29263000D+01,0.00000000D+00
     .,0.41344790D+03,0.227D+03,0.220D+02,0.29263000D+01,0.00000000D+00
     .,0.37873270D+03,0.227D+03,0.230D+02,0.29263000D+01,0.00000000D+00
     .,0.29871690D+03,0.227D+03,0.240D+02,0.29263000D+01,0.00000000D+00
     .,0.32626030D+03,0.227D+03,0.250D+02,0.29263000D+01,0.00000000D+00
     .,0.25642380D+03,0.227D+03,0.260D+02,0.29263000D+01,0.00000000D+00
     .,0.27162880D+03,0.227D+03,0.270D+02,0.29263000D+01,0.00000000D+00
     .,0.27970520D+03,0.227D+03,0.280D+02,0.29263000D+01,0.00000000D+00
     .,0.21480930D+03,0.227D+03,0.290D+02,0.29263000D+01,0.00000000D+00
     .,0.22045250D+03,0.227D+03,0.300D+02,0.29263000D+01,0.00000000D+00
     .,0.26075480D+03,0.227D+03,0.310D+02,0.29263000D+01,0.00000000D+00
     .,0.23021330D+03,0.227D+03,0.320D+02,0.29263000D+01,0.00000000D+00
     .,0.19670460D+03,0.227D+03,0.330D+02,0.29263000D+01,0.00000000D+00
     .,0.17678440D+03,0.227D+03,0.340D+02,0.29263000D+01,0.00000000D+00
     .,0.15501690D+03,0.227D+03,0.350D+02,0.29263000D+01,0.00000000D+00
     .,0.13511470D+03,0.227D+03,0.360D+02,0.29263000D+01,0.00000000D+00
     .,0.70427300D+03,0.227D+03,0.370D+02,0.29263000D+01,0.00000000D+00
     .,0.61724930D+03,0.227D+03,0.380D+02,0.29263000D+01,0.00000000D+00
     .,0.54087060D+03,0.227D+03,0.390D+02,0.29263000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  98701:  98800)=(/
     . 0.48633250D+03,0.227D+03,0.400D+02,0.29263000D+01,0.00000000D+00
     .,0.44370070D+03,0.227D+03,0.410D+02,0.29263000D+01,0.00000000D+00
     .,0.34307100D+03,0.227D+03,0.420D+02,0.29263000D+01,0.00000000D+00
     .,0.38256460D+03,0.227D+03,0.430D+02,0.29263000D+01,0.00000000D+00
     .,0.29196350D+03,0.227D+03,0.440D+02,0.29263000D+01,0.00000000D+00
     .,0.31887320D+03,0.227D+03,0.450D+02,0.29263000D+01,0.00000000D+00
     .,0.29583660D+03,0.227D+03,0.460D+02,0.29263000D+01,0.00000000D+00
     .,0.24704870D+03,0.227D+03,0.470D+02,0.29263000D+01,0.00000000D+00
     .,0.26087010D+03,0.227D+03,0.480D+02,0.29263000D+01,0.00000000D+00
     .,0.32688520D+03,0.227D+03,0.490D+02,0.29263000D+01,0.00000000D+00
     .,0.30241310D+03,0.227D+03,0.500D+02,0.29263000D+01,0.00000000D+00
     .,0.26980100D+03,0.227D+03,0.510D+02,0.29263000D+01,0.00000000D+00
     .,0.25056260D+03,0.227D+03,0.520D+02,0.29263000D+01,0.00000000D+00
     .,0.22685100D+03,0.227D+03,0.530D+02,0.29263000D+01,0.00000000D+00
     .,0.20426630D+03,0.227D+03,0.540D+02,0.29263000D+01,0.00000000D+00
     .,0.85816140D+03,0.227D+03,0.550D+02,0.29263000D+01,0.00000000D+00
     .,0.78713930D+03,0.227D+03,0.560D+02,0.29263000D+01,0.00000000D+00
     .,0.69163680D+03,0.227D+03,0.570D+02,0.29263000D+01,0.00000000D+00
     .,0.31880260D+03,0.227D+03,0.580D+02,0.29263000D+01,0.27991000D+01
     .,0.69775630D+03,0.227D+03,0.590D+02,0.29263000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  98801:  98900)=(/
     . 0.66998350D+03,0.227D+03,0.600D+02,0.29263000D+01,0.00000000D+00
     .,0.65317050D+03,0.227D+03,0.610D+02,0.29263000D+01,0.00000000D+00
     .,0.63770390D+03,0.227D+03,0.620D+02,0.29263000D+01,0.00000000D+00
     .,0.62398650D+03,0.227D+03,0.630D+02,0.29263000D+01,0.00000000D+00
     .,0.49120470D+03,0.227D+03,0.640D+02,0.29263000D+01,0.00000000D+00
     .,0.55314370D+03,0.227D+03,0.650D+02,0.29263000D+01,0.00000000D+00
     .,0.53353430D+03,0.227D+03,0.660D+02,0.29263000D+01,0.00000000D+00
     .,0.56278640D+03,0.227D+03,0.670D+02,0.29263000D+01,0.00000000D+00
     .,0.55082490D+03,0.227D+03,0.680D+02,0.29263000D+01,0.00000000D+00
     .,0.54004150D+03,0.227D+03,0.690D+02,0.29263000D+01,0.00000000D+00
     .,0.53369230D+03,0.227D+03,0.700D+02,0.29263000D+01,0.00000000D+00
     .,0.44999220D+03,0.227D+03,0.710D+02,0.29263000D+01,0.00000000D+00
     .,0.44251450D+03,0.227D+03,0.720D+02,0.29263000D+01,0.00000000D+00
     .,0.40411740D+03,0.227D+03,0.730D+02,0.29263000D+01,0.00000000D+00
     .,0.34172070D+03,0.227D+03,0.740D+02,0.29263000D+01,0.00000000D+00
     .,0.34765120D+03,0.227D+03,0.750D+02,0.29263000D+01,0.00000000D+00
     .,0.31534640D+03,0.227D+03,0.760D+02,0.29263000D+01,0.00000000D+00
     .,0.28904310D+03,0.227D+03,0.770D+02,0.29263000D+01,0.00000000D+00
     .,0.24054490D+03,0.227D+03,0.780D+02,0.29263000D+01,0.00000000D+00
     .,0.22491750D+03,0.227D+03,0.790D+02,0.29263000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  98901:  99000)=(/
     . 0.23132500D+03,0.227D+03,0.800D+02,0.29263000D+01,0.00000000D+00
     .,0.33611600D+03,0.227D+03,0.810D+02,0.29263000D+01,0.00000000D+00
     .,0.32863270D+03,0.227D+03,0.820D+02,0.29263000D+01,0.00000000D+00
     .,0.30220800D+03,0.227D+03,0.830D+02,0.29263000D+01,0.00000000D+00
     .,0.28841500D+03,0.227D+03,0.840D+02,0.29263000D+01,0.00000000D+00
     .,0.26645950D+03,0.227D+03,0.850D+02,0.29263000D+01,0.00000000D+00
     .,0.24453080D+03,0.227D+03,0.860D+02,0.29263000D+01,0.00000000D+00
     .,0.81034850D+03,0.227D+03,0.870D+02,0.29263000D+01,0.00000000D+00
     .,0.77851930D+03,0.227D+03,0.880D+02,0.29263000D+01,0.00000000D+00
     .,0.68835160D+03,0.227D+03,0.890D+02,0.29263000D+01,0.00000000D+00
     .,0.61915580D+03,0.227D+03,0.900D+02,0.29263000D+01,0.00000000D+00
     .,0.61484900D+03,0.227D+03,0.910D+02,0.29263000D+01,0.00000000D+00
     .,0.59539070D+03,0.227D+03,0.920D+02,0.29263000D+01,0.00000000D+00
     .,0.61287940D+03,0.227D+03,0.930D+02,0.29263000D+01,0.00000000D+00
     .,0.59353010D+03,0.227D+03,0.940D+02,0.29263000D+01,0.00000000D+00
     .,0.33330700D+02,0.227D+03,0.101D+03,0.29263000D+01,0.00000000D+00
     .,0.10755820D+03,0.227D+03,0.103D+03,0.29263000D+01,0.98650000D+00
     .,0.13729980D+03,0.227D+03,0.104D+03,0.29263000D+01,0.98080000D+00
     .,0.10520190D+03,0.227D+03,0.105D+03,0.29263000D+01,0.97060000D+00
     .,0.79527300D+02,0.227D+03,0.106D+03,0.29263000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters(  99001:  99100)=(/
     . 0.55568500D+02,0.227D+03,0.107D+03,0.29263000D+01,0.99440000D+00
     .,0.40679900D+02,0.227D+03,0.108D+03,0.29263000D+01,0.99250000D+00
     .,0.28212200D+02,0.227D+03,0.109D+03,0.29263000D+01,0.99820000D+00
     .,0.15735780D+03,0.227D+03,0.111D+03,0.29263000D+01,0.96840000D+00
     .,0.24318090D+03,0.227D+03,0.112D+03,0.29263000D+01,0.96280000D+00
     .,0.24645390D+03,0.227D+03,0.113D+03,0.29263000D+01,0.96480000D+00
     .,0.19841740D+03,0.227D+03,0.114D+03,0.29263000D+01,0.95070000D+00
     .,0.16285410D+03,0.227D+03,0.115D+03,0.29263000D+01,0.99470000D+00
     .,0.13801590D+03,0.227D+03,0.116D+03,0.29263000D+01,0.99480000D+00
     .,0.11313180D+03,0.227D+03,0.117D+03,0.29263000D+01,0.99720000D+00
     .,0.21759670D+03,0.227D+03,0.119D+03,0.29263000D+01,0.97670000D+00
     .,0.41483380D+03,0.227D+03,0.120D+03,0.29263000D+01,0.98310000D+00
     .,0.21769090D+03,0.227D+03,0.121D+03,0.29263000D+01,0.18627000D+01
     .,0.21024640D+03,0.227D+03,0.122D+03,0.29263000D+01,0.18299000D+01
     .,0.20607570D+03,0.227D+03,0.123D+03,0.29263000D+01,0.19138000D+01
     .,0.20417500D+03,0.227D+03,0.124D+03,0.29263000D+01,0.18269000D+01
     .,0.18795640D+03,0.227D+03,0.125D+03,0.29263000D+01,0.16406000D+01
     .,0.17405360D+03,0.227D+03,0.126D+03,0.29263000D+01,0.16483000D+01
     .,0.16609110D+03,0.227D+03,0.127D+03,0.29263000D+01,0.17149000D+01
     .,0.16238310D+03,0.227D+03,0.128D+03,0.29263000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters(  99101:  99200)=(/
     . 0.16040150D+03,0.227D+03,0.129D+03,0.29263000D+01,0.95760000D+00
     .,0.15059460D+03,0.227D+03,0.130D+03,0.29263000D+01,0.19419000D+01
     .,0.24499140D+03,0.227D+03,0.131D+03,0.29263000D+01,0.96010000D+00
     .,0.21547520D+03,0.227D+03,0.132D+03,0.29263000D+01,0.94340000D+00
     .,0.19340210D+03,0.227D+03,0.133D+03,0.29263000D+01,0.98890000D+00
     .,0.17685580D+03,0.227D+03,0.134D+03,0.29263000D+01,0.99010000D+00
     .,0.15608590D+03,0.227D+03,0.135D+03,0.29263000D+01,0.99740000D+00
     .,0.25980390D+03,0.227D+03,0.137D+03,0.29263000D+01,0.97380000D+00
     .,0.50499050D+03,0.227D+03,0.138D+03,0.29263000D+01,0.98010000D+00
     .,0.38637760D+03,0.227D+03,0.139D+03,0.29263000D+01,0.19153000D+01
     .,0.28802430D+03,0.227D+03,0.140D+03,0.29263000D+01,0.19355000D+01
     .,0.29089880D+03,0.227D+03,0.141D+03,0.29263000D+01,0.19545000D+01
     .,0.27145590D+03,0.227D+03,0.142D+03,0.29263000D+01,0.19420000D+01
     .,0.30427490D+03,0.227D+03,0.143D+03,0.29263000D+01,0.16682000D+01
     .,0.23690460D+03,0.227D+03,0.144D+03,0.29263000D+01,0.18584000D+01
     .,0.22176150D+03,0.227D+03,0.145D+03,0.29263000D+01,0.19003000D+01
     .,0.20606490D+03,0.227D+03,0.146D+03,0.29263000D+01,0.18630000D+01
     .,0.19936290D+03,0.227D+03,0.147D+03,0.29263000D+01,0.96790000D+00
     .,0.19723130D+03,0.227D+03,0.148D+03,0.29263000D+01,0.19539000D+01
     .,0.31168130D+03,0.227D+03,0.149D+03,0.29263000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters(  99201:  99300)=(/
     . 0.28217500D+03,0.227D+03,0.150D+03,0.29263000D+01,0.95140000D+00
     .,0.26447480D+03,0.227D+03,0.151D+03,0.29263000D+01,0.97490000D+00
     .,0.25038960D+03,0.227D+03,0.152D+03,0.29263000D+01,0.98110000D+00
     .,0.22896540D+03,0.227D+03,0.153D+03,0.29263000D+01,0.99680000D+00
     .,0.30722970D+03,0.227D+03,0.155D+03,0.29263000D+01,0.99090000D+00
     .,0.65499420D+03,0.227D+03,0.156D+03,0.29263000D+01,0.97970000D+00
     .,0.48905800D+03,0.227D+03,0.157D+03,0.29263000D+01,0.19373000D+01
     .,0.30922990D+03,0.227D+03,0.159D+03,0.29263000D+01,0.29425000D+01
     .,0.30284470D+03,0.227D+03,0.160D+03,0.29263000D+01,0.29455000D+01
     .,0.29328050D+03,0.227D+03,0.161D+03,0.29263000D+01,0.29413000D+01
     .,0.29467450D+03,0.227D+03,0.162D+03,0.29263000D+01,0.29300000D+01
     .,0.28401110D+03,0.227D+03,0.163D+03,0.29263000D+01,0.18286000D+01
     .,0.29645530D+03,0.227D+03,0.164D+03,0.29263000D+01,0.28732000D+01
     .,0.27853190D+03,0.227D+03,0.165D+03,0.29263000D+01,0.29086000D+01
     .,0.28335200D+03,0.227D+03,0.166D+03,0.29263000D+01,0.28965000D+01
     .,0.26440130D+03,0.227D+03,0.167D+03,0.29263000D+01,0.29242000D+01
     .,0.25688240D+03,0.227D+03,0.168D+03,0.29263000D+01,0.29282000D+01
     .,0.25521000D+03,0.227D+03,0.169D+03,0.29263000D+01,0.29246000D+01
     .,0.26809220D+03,0.227D+03,0.170D+03,0.29263000D+01,0.28482000D+01
     .,0.24667760D+03,0.227D+03,0.171D+03,0.29263000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters(  99301:  99400)=(/
     . 0.33363020D+03,0.227D+03,0.172D+03,0.29263000D+01,0.19254000D+01
     .,0.30987820D+03,0.227D+03,0.173D+03,0.29263000D+01,0.19459000D+01
     .,0.28300050D+03,0.227D+03,0.174D+03,0.29263000D+01,0.19292000D+01
     .,0.28624380D+03,0.227D+03,0.175D+03,0.29263000D+01,0.18104000D+01
     .,0.25103410D+03,0.227D+03,0.176D+03,0.29263000D+01,0.18858000D+01
     .,0.23634850D+03,0.227D+03,0.177D+03,0.29263000D+01,0.18648000D+01
     .,0.22587990D+03,0.227D+03,0.178D+03,0.29263000D+01,0.19188000D+01
     .,0.21607200D+03,0.227D+03,0.179D+03,0.29263000D+01,0.98460000D+00
     .,0.20886990D+03,0.227D+03,0.180D+03,0.29263000D+01,0.19896000D+01
     .,0.33505330D+03,0.227D+03,0.181D+03,0.29263000D+01,0.92670000D+00
     .,0.30558290D+03,0.227D+03,0.182D+03,0.29263000D+01,0.93830000D+00
     .,0.29647100D+03,0.227D+03,0.183D+03,0.29263000D+01,0.98200000D+00
     .,0.28849230D+03,0.227D+03,0.184D+03,0.29263000D+01,0.98150000D+00
     .,0.26966300D+03,0.227D+03,0.185D+03,0.29263000D+01,0.99540000D+00
     .,0.34599510D+03,0.227D+03,0.187D+03,0.29263000D+01,0.97050000D+00
     .,0.65149430D+03,0.227D+03,0.188D+03,0.29263000D+01,0.96620000D+00
     .,0.36582470D+03,0.227D+03,0.189D+03,0.29263000D+01,0.29070000D+01
     .,0.42216210D+03,0.227D+03,0.190D+03,0.29263000D+01,0.28844000D+01
     .,0.37782790D+03,0.227D+03,0.191D+03,0.29263000D+01,0.28738000D+01
     .,0.33401640D+03,0.227D+03,0.192D+03,0.29263000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters(  99401:  99500)=(/
     . 0.32150040D+03,0.227D+03,0.193D+03,0.29263000D+01,0.29095000D+01
     .,0.38630110D+03,0.227D+03,0.194D+03,0.29263000D+01,0.19209000D+01
     .,0.89789100D+02,0.227D+03,0.204D+03,0.29263000D+01,0.19697000D+01
     .,0.88440500D+02,0.227D+03,0.205D+03,0.29263000D+01,0.19441000D+01
     .,0.64985600D+02,0.227D+03,0.206D+03,0.29263000D+01,0.19985000D+01
     .,0.52232200D+02,0.227D+03,0.207D+03,0.29263000D+01,0.20143000D+01
     .,0.35989200D+02,0.227D+03,0.208D+03,0.29263000D+01,0.19887000D+01
     .,0.15909800D+03,0.227D+03,0.212D+03,0.29263000D+01,0.19496000D+01
     .,0.19227550D+03,0.227D+03,0.213D+03,0.29263000D+01,0.19311000D+01
     .,0.18462850D+03,0.227D+03,0.214D+03,0.29263000D+01,0.19435000D+01
     .,0.16065780D+03,0.227D+03,0.215D+03,0.29263000D+01,0.20102000D+01
     .,0.13524560D+03,0.227D+03,0.216D+03,0.29263000D+01,0.19903000D+01
     .,0.22342730D+03,0.227D+03,0.220D+03,0.29263000D+01,0.19349000D+01
     .,0.21483990D+03,0.227D+03,0.221D+03,0.29263000D+01,0.28999000D+01
     .,0.21751780D+03,0.227D+03,0.222D+03,0.29263000D+01,0.38675000D+01
     .,0.19920380D+03,0.227D+03,0.223D+03,0.29263000D+01,0.29110000D+01
     .,0.15048630D+03,0.227D+03,0.224D+03,0.29263000D+01,0.10619100D+02
     .,0.12896280D+03,0.227D+03,0.225D+03,0.29263000D+01,0.98849000D+01
     .,0.12658850D+03,0.227D+03,0.226D+03,0.29263000D+01,0.91376000D+01
     .,0.14806570D+03,0.227D+03,0.227D+03,0.29263000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters(  99501:  99600)=(/
     . 0.19464800D+02,0.228D+03,0.100D+01,0.65458000D+01,0.91180000D+00
     .,0.13097900D+02,0.228D+03,0.200D+01,0.65458000D+01,0.00000000D+00
     .,0.29104880D+03,0.228D+03,0.300D+01,0.65458000D+01,0.00000000D+00
     .,0.17059360D+03,0.228D+03,0.400D+01,0.65458000D+01,0.00000000D+00
     .,0.11609230D+03,0.228D+03,0.500D+01,0.65458000D+01,0.00000000D+00
     .,0.79205600D+02,0.228D+03,0.600D+01,0.65458000D+01,0.00000000D+00
     .,0.55895400D+02,0.228D+03,0.700D+01,0.65458000D+01,0.00000000D+00
     .,0.42646200D+02,0.228D+03,0.800D+01,0.65458000D+01,0.00000000D+00
     .,0.32555300D+02,0.228D+03,0.900D+01,0.65458000D+01,0.00000000D+00
     .,0.25221000D+02,0.228D+03,0.100D+02,0.65458000D+01,0.00000000D+00
     .,0.34857980D+03,0.228D+03,0.110D+02,0.65458000D+01,0.00000000D+00
     .,0.27122230D+03,0.228D+03,0.120D+02,0.65458000D+01,0.00000000D+00
     .,0.25118770D+03,0.228D+03,0.130D+02,0.65458000D+01,0.00000000D+00
     .,0.19928550D+03,0.228D+03,0.140D+02,0.65458000D+01,0.00000000D+00
     .,0.15644320D+03,0.228D+03,0.150D+02,0.65458000D+01,0.00000000D+00
     .,0.13051020D+03,0.228D+03,0.160D+02,0.65458000D+01,0.00000000D+00
     .,0.10719760D+03,0.228D+03,0.170D+02,0.65458000D+01,0.00000000D+00
     .,0.88182900D+02,0.228D+03,0.180D+02,0.65458000D+01,0.00000000D+00
     .,0.57086590D+03,0.228D+03,0.190D+02,0.65458000D+01,0.00000000D+00
     .,0.47482250D+03,0.228D+03,0.200D+02,0.65458000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  99601:  99700)=(/
     . 0.39304870D+03,0.228D+03,0.210D+02,0.65458000D+01,0.00000000D+00
     .,0.38043770D+03,0.228D+03,0.220D+02,0.65458000D+01,0.00000000D+00
     .,0.34885100D+03,0.228D+03,0.230D+02,0.65458000D+01,0.00000000D+00
     .,0.27525510D+03,0.228D+03,0.240D+02,0.65458000D+01,0.00000000D+00
     .,0.30096400D+03,0.228D+03,0.250D+02,0.65458000D+01,0.00000000D+00
     .,0.23668420D+03,0.228D+03,0.260D+02,0.65458000D+01,0.00000000D+00
     .,0.25118370D+03,0.228D+03,0.270D+02,0.65458000D+01,0.00000000D+00
     .,0.25838880D+03,0.228D+03,0.280D+02,0.65458000D+01,0.00000000D+00
     .,0.19852020D+03,0.228D+03,0.290D+02,0.65458000D+01,0.00000000D+00
     .,0.20431190D+03,0.228D+03,0.300D+02,0.65458000D+01,0.00000000D+00
     .,0.24136360D+03,0.228D+03,0.310D+02,0.65458000D+01,0.00000000D+00
     .,0.21391340D+03,0.228D+03,0.320D+02,0.65458000D+01,0.00000000D+00
     .,0.18341100D+03,0.228D+03,0.330D+02,0.65458000D+01,0.00000000D+00
     .,0.16519610D+03,0.228D+03,0.340D+02,0.65458000D+01,0.00000000D+00
     .,0.14518280D+03,0.228D+03,0.350D+02,0.65458000D+01,0.00000000D+00
     .,0.12680940D+03,0.228D+03,0.360D+02,0.65458000D+01,0.00000000D+00
     .,0.64057820D+03,0.228D+03,0.370D+02,0.65458000D+01,0.00000000D+00
     .,0.56577900D+03,0.228D+03,0.380D+02,0.65458000D+01,0.00000000D+00
     .,0.49739960D+03,0.228D+03,0.390D+02,0.65458000D+01,0.00000000D+00
     .,0.44816000D+03,0.228D+03,0.400D+02,0.65458000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  99701:  99800)=(/
     . 0.40942870D+03,0.228D+03,0.410D+02,0.65458000D+01,0.00000000D+00
     .,0.31734720D+03,0.228D+03,0.420D+02,0.65458000D+01,0.00000000D+00
     .,0.35355460D+03,0.228D+03,0.430D+02,0.65458000D+01,0.00000000D+00
     .,0.27055020D+03,0.228D+03,0.440D+02,0.65458000D+01,0.00000000D+00
     .,0.29544510D+03,0.228D+03,0.450D+02,0.65458000D+01,0.00000000D+00
     .,0.27433660D+03,0.228D+03,0.460D+02,0.65458000D+01,0.00000000D+00
     .,0.22905370D+03,0.228D+03,0.470D+02,0.65458000D+01,0.00000000D+00
     .,0.24218240D+03,0.228D+03,0.480D+02,0.65458000D+01,0.00000000D+00
     .,0.30263410D+03,0.228D+03,0.490D+02,0.65458000D+01,0.00000000D+00
     .,0.28084550D+03,0.228D+03,0.500D+02,0.65458000D+01,0.00000000D+00
     .,0.25131640D+03,0.228D+03,0.510D+02,0.65458000D+01,0.00000000D+00
     .,0.23382360D+03,0.228D+03,0.520D+02,0.65458000D+01,0.00000000D+00
     .,0.21211680D+03,0.228D+03,0.530D+02,0.65458000D+01,0.00000000D+00
     .,0.19136210D+03,0.228D+03,0.540D+02,0.65458000D+01,0.00000000D+00
     .,0.78055200D+03,0.228D+03,0.550D+02,0.65458000D+01,0.00000000D+00
     .,0.72070440D+03,0.228D+03,0.560D+02,0.65458000D+01,0.00000000D+00
     .,0.63535610D+03,0.228D+03,0.570D+02,0.65458000D+01,0.00000000D+00
     .,0.29682360D+03,0.228D+03,0.580D+02,0.65458000D+01,0.27991000D+01
     .,0.63962140D+03,0.228D+03,0.590D+02,0.65458000D+01,0.00000000D+00
     .,0.61452410D+03,0.228D+03,0.600D+02,0.65458000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  99801:  99900)=(/
     . 0.59919690D+03,0.228D+03,0.610D+02,0.65458000D+01,0.00000000D+00
     .,0.58508560D+03,0.228D+03,0.620D+02,0.65458000D+01,0.00000000D+00
     .,0.57257280D+03,0.228D+03,0.630D+02,0.65458000D+01,0.00000000D+00
     .,0.45239680D+03,0.228D+03,0.640D+02,0.65458000D+01,0.00000000D+00
     .,0.50669850D+03,0.228D+03,0.650D+02,0.65458000D+01,0.00000000D+00
     .,0.48901870D+03,0.228D+03,0.660D+02,0.65458000D+01,0.00000000D+00
     .,0.51684540D+03,0.228D+03,0.670D+02,0.65458000D+01,0.00000000D+00
     .,0.50590420D+03,0.228D+03,0.680D+02,0.65458000D+01,0.00000000D+00
     .,0.49606180D+03,0.228D+03,0.690D+02,0.65458000D+01,0.00000000D+00
     .,0.49015300D+03,0.228D+03,0.700D+02,0.65458000D+01,0.00000000D+00
     .,0.41429680D+03,0.228D+03,0.710D+02,0.65458000D+01,0.00000000D+00
     .,0.40871690D+03,0.228D+03,0.720D+02,0.65458000D+01,0.00000000D+00
     .,0.37400200D+03,0.228D+03,0.730D+02,0.65458000D+01,0.00000000D+00
     .,0.31678470D+03,0.228D+03,0.740D+02,0.65458000D+01,0.00000000D+00
     .,0.32251470D+03,0.228D+03,0.750D+02,0.65458000D+01,0.00000000D+00
     .,0.29305060D+03,0.228D+03,0.760D+02,0.65458000D+01,0.00000000D+00
     .,0.26898340D+03,0.228D+03,0.770D+02,0.65458000D+01,0.00000000D+00
     .,0.22421600D+03,0.228D+03,0.780D+02,0.65458000D+01,0.00000000D+00
     .,0.20978810D+03,0.228D+03,0.790D+02,0.65458000D+01,0.00000000D+00
     .,0.21587920D+03,0.228D+03,0.800D+02,0.65458000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters(  99901: 100000)=(/
     . 0.31149490D+03,0.228D+03,0.810D+02,0.65458000D+01,0.00000000D+00
     .,0.30528260D+03,0.228D+03,0.820D+02,0.65458000D+01,0.00000000D+00
     .,0.28148900D+03,0.228D+03,0.830D+02,0.65458000D+01,0.00000000D+00
     .,0.26905740D+03,0.228D+03,0.840D+02,0.65458000D+01,0.00000000D+00
     .,0.24904140D+03,0.228D+03,0.850D+02,0.65458000D+01,0.00000000D+00
     .,0.22894100D+03,0.228D+03,0.860D+02,0.65458000D+01,0.00000000D+00
     .,0.73916470D+03,0.228D+03,0.870D+02,0.65458000D+01,0.00000000D+00
     .,0.71405300D+03,0.228D+03,0.880D+02,0.65458000D+01,0.00000000D+00
     .,0.63328860D+03,0.228D+03,0.890D+02,0.65458000D+01,0.00000000D+00
     .,0.57161590D+03,0.228D+03,0.900D+02,0.65458000D+01,0.00000000D+00
     .,0.56672940D+03,0.228D+03,0.910D+02,0.65458000D+01,0.00000000D+00
     .,0.54885680D+03,0.228D+03,0.920D+02,0.65458000D+01,0.00000000D+00
     .,0.56381700D+03,0.228D+03,0.930D+02,0.65458000D+01,0.00000000D+00
     .,0.54623160D+03,0.228D+03,0.940D+02,0.65458000D+01,0.00000000D+00
     .,0.31098100D+02,0.228D+03,0.101D+03,0.65458000D+01,0.00000000D+00
     .,0.99345400D+02,0.228D+03,0.103D+03,0.65458000D+01,0.98650000D+00
     .,0.12698120D+03,0.228D+03,0.104D+03,0.65458000D+01,0.98080000D+00
     .,0.97926800D+02,0.228D+03,0.105D+03,0.65458000D+01,0.97060000D+00
     .,0.74314900D+02,0.228D+03,0.106D+03,0.65458000D+01,0.98680000D+00
     .,0.52153200D+02,0.228D+03,0.107D+03,0.65458000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters( 100001: 100100)=(/
     . 0.38319400D+02,0.228D+03,0.108D+03,0.65458000D+01,0.99250000D+00
     .,0.26700000D+02,0.228D+03,0.109D+03,0.65458000D+01,0.99820000D+00
     .,0.14518540D+03,0.228D+03,0.111D+03,0.65458000D+01,0.96840000D+00
     .,0.22418120D+03,0.228D+03,0.112D+03,0.65458000D+01,0.96280000D+00
     .,0.22795650D+03,0.228D+03,0.113D+03,0.65458000D+01,0.96480000D+00
     .,0.18441750D+03,0.228D+03,0.114D+03,0.65458000D+01,0.95070000D+00
     .,0.15191520D+03,0.228D+03,0.115D+03,0.65458000D+01,0.99470000D+00
     .,0.12907630D+03,0.228D+03,0.116D+03,0.65458000D+01,0.99480000D+00
     .,0.10609050D+03,0.228D+03,0.117D+03,0.65458000D+01,0.99720000D+00
     .,0.20137990D+03,0.228D+03,0.119D+03,0.65458000D+01,0.97670000D+00
     .,0.38042010D+03,0.228D+03,0.120D+03,0.65458000D+01,0.98310000D+00
     .,0.20223920D+03,0.228D+03,0.121D+03,0.65458000D+01,0.18627000D+01
     .,0.19535160D+03,0.228D+03,0.122D+03,0.65458000D+01,0.18299000D+01
     .,0.19147150D+03,0.228D+03,0.123D+03,0.65458000D+01,0.19138000D+01
     .,0.18962030D+03,0.228D+03,0.124D+03,0.65458000D+01,0.18269000D+01
     .,0.17495290D+03,0.228D+03,0.125D+03,0.65458000D+01,0.16406000D+01
     .,0.16212930D+03,0.228D+03,0.126D+03,0.65458000D+01,0.16483000D+01
     .,0.15471980D+03,0.228D+03,0.127D+03,0.65458000D+01,0.17149000D+01
     .,0.15124090D+03,0.228D+03,0.128D+03,0.65458000D+01,0.17937000D+01
     .,0.14914790D+03,0.228D+03,0.129D+03,0.65458000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters( 100101: 100200)=(/
     . 0.14045520D+03,0.228D+03,0.130D+03,0.65458000D+01,0.19419000D+01
     .,0.22700010D+03,0.228D+03,0.131D+03,0.65458000D+01,0.96010000D+00
     .,0.20040030D+03,0.228D+03,0.132D+03,0.65458000D+01,0.94340000D+00
     .,0.18036950D+03,0.228D+03,0.133D+03,0.65458000D+01,0.98890000D+00
     .,0.16525840D+03,0.228D+03,0.134D+03,0.65458000D+01,0.99010000D+00
     .,0.14616810D+03,0.228D+03,0.135D+03,0.65458000D+01,0.99740000D+00
     .,0.24066290D+03,0.228D+03,0.137D+03,0.65458000D+01,0.97380000D+00
     .,0.46289020D+03,0.228D+03,0.138D+03,0.65458000D+01,0.98010000D+00
     .,0.35647370D+03,0.228D+03,0.139D+03,0.65458000D+01,0.19153000D+01
     .,0.26749730D+03,0.228D+03,0.140D+03,0.65458000D+01,0.19355000D+01
     .,0.27016880D+03,0.228D+03,0.141D+03,0.65458000D+01,0.19545000D+01
     .,0.25232810D+03,0.228D+03,0.142D+03,0.65458000D+01,0.19420000D+01
     .,0.28197070D+03,0.228D+03,0.143D+03,0.65458000D+01,0.16682000D+01
     .,0.22072030D+03,0.228D+03,0.144D+03,0.65458000D+01,0.18584000D+01
     .,0.20667290D+03,0.228D+03,0.145D+03,0.65458000D+01,0.19003000D+01
     .,0.19214160D+03,0.228D+03,0.146D+03,0.65458000D+01,0.18630000D+01
     .,0.18584300D+03,0.228D+03,0.147D+03,0.65458000D+01,0.96790000D+00
     .,0.18414330D+03,0.228D+03,0.148D+03,0.65458000D+01,0.19539000D+01
     .,0.28888240D+03,0.228D+03,0.149D+03,0.65458000D+01,0.96330000D+00
     .,0.26236960D+03,0.228D+03,0.150D+03,0.65458000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters( 100201: 100300)=(/
     . 0.24645550D+03,0.228D+03,0.151D+03,0.65458000D+01,0.97490000D+00
     .,0.23368760D+03,0.228D+03,0.152D+03,0.65458000D+01,0.98110000D+00
     .,0.21408530D+03,0.228D+03,0.153D+03,0.65458000D+01,0.99680000D+00
     .,0.28525530D+03,0.228D+03,0.155D+03,0.65458000D+01,0.99090000D+00
     .,0.59951160D+03,0.228D+03,0.156D+03,0.65458000D+01,0.97970000D+00
     .,0.45093480D+03,0.228D+03,0.157D+03,0.65458000D+01,0.19373000D+01
     .,0.28796490D+03,0.228D+03,0.159D+03,0.65458000D+01,0.29425000D+01
     .,0.28202970D+03,0.228D+03,0.160D+03,0.65458000D+01,0.29455000D+01
     .,0.27316700D+03,0.228D+03,0.161D+03,0.65458000D+01,0.29413000D+01
     .,0.27433460D+03,0.228D+03,0.162D+03,0.65458000D+01,0.29300000D+01
     .,0.26403730D+03,0.228D+03,0.163D+03,0.65458000D+01,0.18286000D+01
     .,0.27594550D+03,0.228D+03,0.164D+03,0.65458000D+01,0.28732000D+01
     .,0.25937430D+03,0.228D+03,0.165D+03,0.65458000D+01,0.29086000D+01
     .,0.26363770D+03,0.228D+03,0.166D+03,0.65458000D+01,0.28965000D+01
     .,0.24631030D+03,0.228D+03,0.167D+03,0.65458000D+01,0.29242000D+01
     .,0.23934130D+03,0.228D+03,0.168D+03,0.65458000D+01,0.29282000D+01
     .,0.23775270D+03,0.228D+03,0.169D+03,0.65458000D+01,0.29246000D+01
     .,0.24957470D+03,0.228D+03,0.170D+03,0.65458000D+01,0.28482000D+01
     .,0.22985230D+03,0.228D+03,0.171D+03,0.65458000D+01,0.29219000D+01
     .,0.30915100D+03,0.228D+03,0.172D+03,0.65458000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters( 100301: 100400)=(/
     . 0.28770370D+03,0.228D+03,0.173D+03,0.65458000D+01,0.19459000D+01
     .,0.26327960D+03,0.228D+03,0.174D+03,0.65458000D+01,0.19292000D+01
     .,0.26585220D+03,0.228D+03,0.175D+03,0.65458000D+01,0.18104000D+01
     .,0.23419810D+03,0.228D+03,0.176D+03,0.65458000D+01,0.18858000D+01
     .,0.22066120D+03,0.228D+03,0.177D+03,0.65458000D+01,0.18648000D+01
     .,0.21098510D+03,0.228D+03,0.178D+03,0.65458000D+01,0.19188000D+01
     .,0.20183220D+03,0.228D+03,0.179D+03,0.65458000D+01,0.98460000D+00
     .,0.19539650D+03,0.228D+03,0.180D+03,0.65458000D+01,0.19896000D+01
     .,0.31077960D+03,0.228D+03,0.181D+03,0.65458000D+01,0.92670000D+00
     .,0.28433510D+03,0.228D+03,0.182D+03,0.65458000D+01,0.93830000D+00
     .,0.27630910D+03,0.228D+03,0.183D+03,0.65458000D+01,0.98200000D+00
     .,0.26918960D+03,0.228D+03,0.184D+03,0.65458000D+01,0.98150000D+00
     .,0.25203630D+03,0.228D+03,0.185D+03,0.65458000D+01,0.99540000D+00
     .,0.32130350D+03,0.228D+03,0.187D+03,0.65458000D+01,0.97050000D+00
     .,0.59764750D+03,0.228D+03,0.188D+03,0.65458000D+01,0.96620000D+00
     .,0.34062710D+03,0.228D+03,0.189D+03,0.65458000D+01,0.29070000D+01
     .,0.39198180D+03,0.228D+03,0.190D+03,0.65458000D+01,0.28844000D+01
     .,0.35114350D+03,0.228D+03,0.191D+03,0.65458000D+01,0.28738000D+01
     .,0.31117290D+03,0.228D+03,0.192D+03,0.65458000D+01,0.28878000D+01
     .,0.29966590D+03,0.228D+03,0.193D+03,0.65458000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters( 100401: 100500)=(/
     . 0.35795210D+03,0.228D+03,0.194D+03,0.65458000D+01,0.19209000D+01
     .,0.83603000D+02,0.228D+03,0.204D+03,0.65458000D+01,0.19697000D+01
     .,0.82447400D+02,0.228D+03,0.205D+03,0.65458000D+01,0.19441000D+01
     .,0.60867800D+02,0.228D+03,0.206D+03,0.65458000D+01,0.19985000D+01
     .,0.49051100D+02,0.228D+03,0.207D+03,0.65458000D+01,0.20143000D+01
     .,0.33942700D+02,0.228D+03,0.208D+03,0.65458000D+01,0.19887000D+01
     .,0.14769120D+03,0.228D+03,0.212D+03,0.65458000D+01,0.19496000D+01
     .,0.17839840D+03,0.228D+03,0.213D+03,0.65458000D+01,0.19311000D+01
     .,0.17172690D+03,0.228D+03,0.214D+03,0.65458000D+01,0.19435000D+01
     .,0.14983280D+03,0.228D+03,0.215D+03,0.65458000D+01,0.20102000D+01
     .,0.12649470D+03,0.228D+03,0.216D+03,0.65458000D+01,0.19903000D+01
     .,0.20744400D+03,0.228D+03,0.220D+03,0.65458000D+01,0.19349000D+01
     .,0.19985020D+03,0.228D+03,0.221D+03,0.65458000D+01,0.28999000D+01
     .,0.20237460D+03,0.228D+03,0.222D+03,0.65458000D+01,0.38675000D+01
     .,0.18532650D+03,0.228D+03,0.223D+03,0.65458000D+01,0.29110000D+01
     .,0.14047480D+03,0.228D+03,0.224D+03,0.65458000D+01,0.10619100D+02
     .,0.12062490D+03,0.228D+03,0.225D+03,0.65458000D+01,0.98849000D+01
     .,0.11838000D+03,0.228D+03,0.226D+03,0.65458000D+01,0.91376000D+01
     .,0.13802230D+03,0.228D+03,0.227D+03,0.65458000D+01,0.29263000D+01
     .,0.12878200D+03,0.228D+03,0.228D+03,0.65458000D+01,0.65458000D+01
     ./)
      grimme_c6_parameters( 100501: 100600)=(/
     . 0.26956200D+02,0.231D+03,0.100D+01,0.19315000D+01,0.91180000D+00
     .,0.17439200D+02,0.231D+03,0.200D+01,0.19315000D+01,0.00000000D+00
     .,0.44148880D+03,0.231D+03,0.300D+01,0.19315000D+01,0.00000000D+00
     .,0.25018890D+03,0.231D+03,0.400D+01,0.19315000D+01,0.00000000D+00
     .,0.16615250D+03,0.231D+03,0.500D+01,0.19315000D+01,0.00000000D+00
     .,0.11083840D+03,0.231D+03,0.600D+01,0.19315000D+01,0.00000000D+00
     .,0.76664100D+02,0.231D+03,0.700D+01,0.19315000D+01,0.00000000D+00
     .,0.57542500D+02,0.231D+03,0.800D+01,0.19315000D+01,0.00000000D+00
     .,0.43238500D+02,0.231D+03,0.900D+01,0.19315000D+01,0.00000000D+00
     .,0.33022800D+02,0.231D+03,0.100D+02,0.19315000D+01,0.00000000D+00
     .,0.52706710D+03,0.231D+03,0.110D+02,0.19315000D+01,0.00000000D+00
     .,0.39992630D+03,0.231D+03,0.120D+02,0.19315000D+01,0.00000000D+00
     .,0.36633710D+03,0.231D+03,0.130D+02,0.19315000D+01,0.00000000D+00
     .,0.28597610D+03,0.231D+03,0.140D+02,0.19315000D+01,0.00000000D+00
     .,0.22097630D+03,0.231D+03,0.150D+02,0.19315000D+01,0.00000000D+00
     .,0.18213800D+03,0.231D+03,0.160D+02,0.19315000D+01,0.00000000D+00
     .,0.14771690D+03,0.231D+03,0.170D+02,0.19315000D+01,0.00000000D+00
     .,0.12002340D+03,0.231D+03,0.180D+02,0.19315000D+01,0.00000000D+00
     .,0.86510660D+03,0.231D+03,0.190D+02,0.19315000D+01,0.00000000D+00
     .,0.70620410D+03,0.231D+03,0.200D+02,0.19315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 100601: 100700)=(/
     . 0.58191500D+03,0.231D+03,0.210D+02,0.19315000D+01,0.00000000D+00
     .,0.56029450D+03,0.231D+03,0.220D+02,0.19315000D+01,0.00000000D+00
     .,0.51220750D+03,0.231D+03,0.230D+02,0.19315000D+01,0.00000000D+00
     .,0.40283090D+03,0.231D+03,0.240D+02,0.19315000D+01,0.00000000D+00
     .,0.43988290D+03,0.231D+03,0.250D+02,0.19315000D+01,0.00000000D+00
     .,0.34453520D+03,0.231D+03,0.260D+02,0.19315000D+01,0.00000000D+00
     .,0.36443400D+03,0.231D+03,0.270D+02,0.19315000D+01,0.00000000D+00
     .,0.37611120D+03,0.231D+03,0.280D+02,0.19315000D+01,0.00000000D+00
     .,0.28776680D+03,0.231D+03,0.290D+02,0.19315000D+01,0.00000000D+00
     .,0.29431290D+03,0.231D+03,0.300D+02,0.19315000D+01,0.00000000D+00
     .,0.34953890D+03,0.231D+03,0.310D+02,0.19315000D+01,0.00000000D+00
     .,0.30609340D+03,0.231D+03,0.320D+02,0.19315000D+01,0.00000000D+00
     .,0.25916500D+03,0.231D+03,0.330D+02,0.19315000D+01,0.00000000D+00
     .,0.23133530D+03,0.231D+03,0.340D+02,0.19315000D+01,0.00000000D+00
     .,0.20127060D+03,0.231D+03,0.350D+02,0.19315000D+01,0.00000000D+00
     .,0.17402300D+03,0.231D+03,0.360D+02,0.19315000D+01,0.00000000D+00
     .,0.96816820D+03,0.231D+03,0.370D+02,0.19315000D+01,0.00000000D+00
     .,0.84136100D+03,0.231D+03,0.380D+02,0.19315000D+01,0.00000000D+00
     .,0.73335550D+03,0.231D+03,0.390D+02,0.19315000D+01,0.00000000D+00
     .,0.65685920D+03,0.231D+03,0.400D+02,0.19315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 100701: 100800)=(/
     . 0.59747450D+03,0.231D+03,0.410D+02,0.19315000D+01,0.00000000D+00
     .,0.45889060D+03,0.231D+03,0.420D+02,0.19315000D+01,0.00000000D+00
     .,0.51304100D+03,0.231D+03,0.430D+02,0.19315000D+01,0.00000000D+00
     .,0.38860430D+03,0.231D+03,0.440D+02,0.19315000D+01,0.00000000D+00
     .,0.42520690D+03,0.231D+03,0.450D+02,0.19315000D+01,0.00000000D+00
     .,0.39363700D+03,0.231D+03,0.460D+02,0.19315000D+01,0.00000000D+00
     .,0.32788520D+03,0.231D+03,0.470D+02,0.19315000D+01,0.00000000D+00
     .,0.34605680D+03,0.231D+03,0.480D+02,0.19315000D+01,0.00000000D+00
     .,0.43674070D+03,0.231D+03,0.490D+02,0.19315000D+01,0.00000000D+00
     .,0.40172510D+03,0.231D+03,0.500D+02,0.19315000D+01,0.00000000D+00
     .,0.35584740D+03,0.231D+03,0.510D+02,0.19315000D+01,0.00000000D+00
     .,0.32880760D+03,0.231D+03,0.520D+02,0.19315000D+01,0.00000000D+00
     .,0.29588170D+03,0.231D+03,0.530D+02,0.19315000D+01,0.00000000D+00
     .,0.26471260D+03,0.231D+03,0.540D+02,0.19315000D+01,0.00000000D+00
     .,0.11792492D+04,0.231D+03,0.550D+02,0.19315000D+01,0.00000000D+00
     .,0.10739458D+04,0.231D+03,0.560D+02,0.19315000D+01,0.00000000D+00
     .,0.93892860D+03,0.231D+03,0.570D+02,0.19315000D+01,0.00000000D+00
     .,0.42057330D+03,0.231D+03,0.580D+02,0.19315000D+01,0.27991000D+01
     .,0.94969780D+03,0.231D+03,0.590D+02,0.19315000D+01,0.00000000D+00
     .,0.91118510D+03,0.231D+03,0.600D+02,0.19315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 100801: 100900)=(/
     . 0.88814170D+03,0.231D+03,0.610D+02,0.19315000D+01,0.00000000D+00
     .,0.86697870D+03,0.231D+03,0.620D+02,0.19315000D+01,0.00000000D+00
     .,0.84820840D+03,0.231D+03,0.630D+02,0.19315000D+01,0.00000000D+00
     .,0.66277010D+03,0.231D+03,0.640D+02,0.19315000D+01,0.00000000D+00
     .,0.75204060D+03,0.231D+03,0.650D+02,0.19315000D+01,0.00000000D+00
     .,0.72468160D+03,0.231D+03,0.660D+02,0.19315000D+01,0.00000000D+00
     .,0.76414750D+03,0.231D+03,0.670D+02,0.19315000D+01,0.00000000D+00
     .,0.74786110D+03,0.231D+03,0.680D+02,0.19315000D+01,0.00000000D+00
     .,0.73312340D+03,0.231D+03,0.690D+02,0.19315000D+01,0.00000000D+00
     .,0.72475960D+03,0.231D+03,0.700D+02,0.19315000D+01,0.00000000D+00
     .,0.60808820D+03,0.231D+03,0.710D+02,0.19315000D+01,0.00000000D+00
     .,0.59509760D+03,0.231D+03,0.720D+02,0.19315000D+01,0.00000000D+00
     .,0.54106220D+03,0.231D+03,0.730D+02,0.19315000D+01,0.00000000D+00
     .,0.45507210D+03,0.231D+03,0.740D+02,0.19315000D+01,0.00000000D+00
     .,0.46243470D+03,0.231D+03,0.750D+02,0.19315000D+01,0.00000000D+00
     .,0.41762900D+03,0.231D+03,0.760D+02,0.19315000D+01,0.00000000D+00
     .,0.38132090D+03,0.231D+03,0.770D+02,0.19315000D+01,0.00000000D+00
     .,0.31540110D+03,0.231D+03,0.780D+02,0.19315000D+01,0.00000000D+00
     .,0.29416770D+03,0.231D+03,0.790D+02,0.19315000D+01,0.00000000D+00
     .,0.30243400D+03,0.231D+03,0.800D+02,0.19315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 100901: 101000)=(/
     . 0.44706730D+03,0.231D+03,0.810D+02,0.19315000D+01,0.00000000D+00
     .,0.43547920D+03,0.231D+03,0.820D+02,0.19315000D+01,0.00000000D+00
     .,0.39809290D+03,0.231D+03,0.830D+02,0.19315000D+01,0.00000000D+00
     .,0.37843240D+03,0.231D+03,0.840D+02,0.19315000D+01,0.00000000D+00
     .,0.34775130D+03,0.231D+03,0.850D+02,0.19315000D+01,0.00000000D+00
     .,0.31736560D+03,0.231D+03,0.860D+02,0.19315000D+01,0.00000000D+00
     .,0.11088359D+04,0.231D+03,0.870D+02,0.19315000D+01,0.00000000D+00
     .,0.10590662D+04,0.231D+03,0.880D+02,0.19315000D+01,0.00000000D+00
     .,0.93187680D+03,0.231D+03,0.890D+02,0.19315000D+01,0.00000000D+00
     .,0.83242240D+03,0.231D+03,0.900D+02,0.19315000D+01,0.00000000D+00
     .,0.82834850D+03,0.231D+03,0.910D+02,0.19315000D+01,0.00000000D+00
     .,0.80186390D+03,0.231D+03,0.920D+02,0.19315000D+01,0.00000000D+00
     .,0.82836820D+03,0.231D+03,0.930D+02,0.19315000D+01,0.00000000D+00
     .,0.80170370D+03,0.231D+03,0.940D+02,0.19315000D+01,0.00000000D+00
     .,0.43888100D+02,0.231D+03,0.101D+03,0.19315000D+01,0.00000000D+00
     .,0.14510430D+03,0.231D+03,0.103D+03,0.19315000D+01,0.98650000D+00
     .,0.18457440D+03,0.231D+03,0.104D+03,0.19315000D+01,0.98080000D+00
     .,0.13925460D+03,0.231D+03,0.105D+03,0.19315000D+01,0.97060000D+00
     .,0.10391800D+03,0.231D+03,0.106D+03,0.19315000D+01,0.98680000D+00
     .,0.71423400D+02,0.231D+03,0.107D+03,0.19315000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters( 101001: 101100)=(/
     . 0.51470500D+02,0.231D+03,0.108D+03,0.19315000D+01,0.99250000D+00
     .,0.34900800D+02,0.231D+03,0.109D+03,0.19315000D+01,0.99820000D+00
     .,0.21236180D+03,0.231D+03,0.111D+03,0.19315000D+01,0.96840000D+00
     .,0.32896970D+03,0.231D+03,0.112D+03,0.19315000D+01,0.96280000D+00
     .,0.33140550D+03,0.231D+03,0.113D+03,0.19315000D+01,0.96480000D+00
     .,0.26387400D+03,0.231D+03,0.114D+03,0.19315000D+01,0.95070000D+00
     .,0.21439030D+03,0.231D+03,0.115D+03,0.19315000D+01,0.99470000D+00
     .,0.18013610D+03,0.231D+03,0.116D+03,0.19315000D+01,0.99480000D+00
     .,0.14618730D+03,0.231D+03,0.117D+03,0.19315000D+01,0.99720000D+00
     .,0.29057390D+03,0.231D+03,0.119D+03,0.19315000D+01,0.97670000D+00
     .,0.56411470D+03,0.231D+03,0.120D+03,0.19315000D+01,0.98310000D+00
     .,0.28899240D+03,0.231D+03,0.121D+03,0.19315000D+01,0.18627000D+01
     .,0.27882930D+03,0.231D+03,0.122D+03,0.19315000D+01,0.18299000D+01
     .,0.27324400D+03,0.231D+03,0.123D+03,0.19315000D+01,0.19138000D+01
     .,0.27091680D+03,0.231D+03,0.124D+03,0.19315000D+01,0.18269000D+01
     .,0.24831530D+03,0.231D+03,0.125D+03,0.19315000D+01,0.16406000D+01
     .,0.22943180D+03,0.231D+03,0.126D+03,0.19315000D+01,0.16483000D+01
     .,0.21879640D+03,0.231D+03,0.127D+03,0.19315000D+01,0.17149000D+01
     .,0.21396210D+03,0.231D+03,0.128D+03,0.19315000D+01,0.17937000D+01
     .,0.21202750D+03,0.231D+03,0.129D+03,0.19315000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters( 101101: 101200)=(/
     . 0.19784590D+03,0.231D+03,0.130D+03,0.19315000D+01,0.19419000D+01
     .,0.32767720D+03,0.231D+03,0.131D+03,0.19315000D+01,0.96010000D+00
     .,0.28580490D+03,0.231D+03,0.132D+03,0.19315000D+01,0.94340000D+00
     .,0.25463590D+03,0.231D+03,0.133D+03,0.19315000D+01,0.98890000D+00
     .,0.23143120D+03,0.231D+03,0.134D+03,0.19315000D+01,0.99010000D+00
     .,0.20272250D+03,0.231D+03,0.135D+03,0.19315000D+01,0.99740000D+00
     .,0.34599210D+03,0.231D+03,0.137D+03,0.19315000D+01,0.97380000D+00
     .,0.68659850D+03,0.231D+03,0.138D+03,0.19315000D+01,0.98010000D+00
     .,0.51944370D+03,0.231D+03,0.139D+03,0.19315000D+01,0.19153000D+01
     .,0.38219520D+03,0.231D+03,0.140D+03,0.19315000D+01,0.19355000D+01
     .,0.38593850D+03,0.231D+03,0.141D+03,0.19315000D+01,0.19545000D+01
     .,0.35915800D+03,0.231D+03,0.142D+03,0.19315000D+01,0.19420000D+01
     .,0.40491750D+03,0.231D+03,0.143D+03,0.19315000D+01,0.16682000D+01
     .,0.31159910D+03,0.231D+03,0.144D+03,0.19315000D+01,0.18584000D+01
     .,0.29122610D+03,0.231D+03,0.145D+03,0.19315000D+01,0.19003000D+01
     .,0.27005910D+03,0.231D+03,0.146D+03,0.19315000D+01,0.18630000D+01
     .,0.26136540D+03,0.231D+03,0.147D+03,0.19315000D+01,0.96790000D+00
     .,0.25790070D+03,0.231D+03,0.148D+03,0.19315000D+01,0.19539000D+01
     .,0.41546410D+03,0.231D+03,0.149D+03,0.19315000D+01,0.96330000D+00
     .,0.37370470D+03,0.231D+03,0.150D+03,0.19315000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters( 101201: 101300)=(/
     . 0.34844250D+03,0.231D+03,0.151D+03,0.19315000D+01,0.97490000D+00
     .,0.32849050D+03,0.231D+03,0.152D+03,0.19315000D+01,0.98110000D+00
     .,0.29869480D+03,0.231D+03,0.153D+03,0.19315000D+01,0.99680000D+00
     .,0.40757240D+03,0.231D+03,0.155D+03,0.19315000D+01,0.99090000D+00
     .,0.89181060D+03,0.231D+03,0.156D+03,0.19315000D+01,0.97970000D+00
     .,0.65796510D+03,0.231D+03,0.157D+03,0.19315000D+01,0.19373000D+01
     .,0.40771430D+03,0.231D+03,0.159D+03,0.19315000D+01,0.29425000D+01
     .,0.39924480D+03,0.231D+03,0.160D+03,0.19315000D+01,0.29455000D+01
     .,0.38644530D+03,0.231D+03,0.161D+03,0.19315000D+01,0.29413000D+01
     .,0.38870550D+03,0.231D+03,0.162D+03,0.19315000D+01,0.29300000D+01
     .,0.37562490D+03,0.231D+03,0.163D+03,0.19315000D+01,0.18286000D+01
     .,0.39136320D+03,0.231D+03,0.164D+03,0.19315000D+01,0.28732000D+01
     .,0.36723070D+03,0.231D+03,0.165D+03,0.19315000D+01,0.29086000D+01
     .,0.37425920D+03,0.231D+03,0.166D+03,0.19315000D+01,0.28965000D+01
     .,0.34830790D+03,0.231D+03,0.167D+03,0.19315000D+01,0.29242000D+01
     .,0.33828140D+03,0.231D+03,0.168D+03,0.19315000D+01,0.29282000D+01
     .,0.33621030D+03,0.231D+03,0.169D+03,0.19315000D+01,0.29246000D+01
     .,0.35402460D+03,0.231D+03,0.170D+03,0.19315000D+01,0.28482000D+01
     .,0.32484810D+03,0.231D+03,0.171D+03,0.19315000D+01,0.29219000D+01
     .,0.44480230D+03,0.231D+03,0.172D+03,0.19315000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters( 101301: 101400)=(/
     . 0.41120500D+03,0.231D+03,0.173D+03,0.19315000D+01,0.19459000D+01
     .,0.37363290D+03,0.231D+03,0.174D+03,0.19315000D+01,0.19292000D+01
     .,0.37928200D+03,0.231D+03,0.175D+03,0.19315000D+01,0.18104000D+01
     .,0.32899190D+03,0.231D+03,0.176D+03,0.19315000D+01,0.18858000D+01
     .,0.30890630D+03,0.231D+03,0.177D+03,0.19315000D+01,0.18648000D+01
     .,0.29467460D+03,0.231D+03,0.178D+03,0.19315000D+01,0.19188000D+01
     .,0.28159150D+03,0.231D+03,0.179D+03,0.19315000D+01,0.98460000D+00
     .,0.27130180D+03,0.231D+03,0.180D+03,0.19315000D+01,0.19896000D+01
     .,0.44509120D+03,0.231D+03,0.181D+03,0.19315000D+01,0.92670000D+00
     .,0.40339300D+03,0.231D+03,0.182D+03,0.19315000D+01,0.93830000D+00
     .,0.38999300D+03,0.231D+03,0.183D+03,0.19315000D+01,0.98200000D+00
     .,0.37835750D+03,0.231D+03,0.184D+03,0.19315000D+01,0.98150000D+00
     .,0.35197820D+03,0.231D+03,0.185D+03,0.19315000D+01,0.99540000D+00
     .,0.45891490D+03,0.231D+03,0.187D+03,0.19315000D+01,0.97050000D+00
     .,0.88404110D+03,0.231D+03,0.188D+03,0.19315000D+01,0.96620000D+00
     .,0.48263570D+03,0.231D+03,0.189D+03,0.19315000D+01,0.29070000D+01
     .,0.55982510D+03,0.231D+03,0.190D+03,0.19315000D+01,0.28844000D+01
     .,0.49934950D+03,0.231D+03,0.191D+03,0.19315000D+01,0.28738000D+01
     .,0.43935480D+03,0.231D+03,0.192D+03,0.19315000D+01,0.28878000D+01
     .,0.42233120D+03,0.231D+03,0.193D+03,0.19315000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters( 101401: 101500)=(/
     . 0.51359610D+03,0.231D+03,0.194D+03,0.19315000D+01,0.19209000D+01
     .,0.11896190D+03,0.231D+03,0.204D+03,0.19315000D+01,0.19697000D+01
     .,0.11648300D+03,0.231D+03,0.205D+03,0.19315000D+01,0.19441000D+01
     .,0.84269100D+02,0.231D+03,0.206D+03,0.19315000D+01,0.19985000D+01
     .,0.66955000D+02,0.231D+03,0.207D+03,0.19315000D+01,0.20143000D+01
     .,0.45233600D+02,0.231D+03,0.208D+03,0.19315000D+01,0.19887000D+01
     .,0.21230440D+03,0.231D+03,0.212D+03,0.19315000D+01,0.19496000D+01
     .,0.25671210D+03,0.231D+03,0.213D+03,0.19315000D+01,0.19311000D+01
     .,0.24505850D+03,0.231D+03,0.214D+03,0.19315000D+01,0.19435000D+01
     .,0.21155710D+03,0.231D+03,0.215D+03,0.19315000D+01,0.20102000D+01
     .,0.17644990D+03,0.231D+03,0.216D+03,0.19315000D+01,0.19903000D+01
     .,0.29710840D+03,0.231D+03,0.220D+03,0.19315000D+01,0.19349000D+01
     .,0.28448700D+03,0.231D+03,0.221D+03,0.19315000D+01,0.28999000D+01
     .,0.28787970D+03,0.231D+03,0.222D+03,0.19315000D+01,0.38675000D+01
     .,0.26338000D+03,0.231D+03,0.223D+03,0.19315000D+01,0.29110000D+01
     .,0.19677040D+03,0.231D+03,0.224D+03,0.19315000D+01,0.10619100D+02
     .,0.16756290D+03,0.231D+03,0.225D+03,0.19315000D+01,0.98849000D+01
     .,0.16455530D+03,0.231D+03,0.226D+03,0.19315000D+01,0.91376000D+01
     .,0.19438680D+03,0.231D+03,0.227D+03,0.19315000D+01,0.29263000D+01
     .,0.18072890D+03,0.231D+03,0.228D+03,0.19315000D+01,0.65458000D+01
     ./)
      grimme_c6_parameters( 101501: 101600)=(/
     . 0.25787270D+03,0.231D+03,0.231D+03,0.19315000D+01,0.19315000D+01
     .,0.28635900D+02,0.232D+03,0.100D+01,0.19447000D+01,0.91180000D+00
     .,0.18618600D+02,0.232D+03,0.200D+01,0.19447000D+01,0.00000000D+00
     .,0.45411250D+03,0.232D+03,0.300D+01,0.19447000D+01,0.00000000D+00
     .,0.26160340D+03,0.232D+03,0.400D+01,0.19447000D+01,0.00000000D+00
     .,0.17509380D+03,0.232D+03,0.500D+01,0.19447000D+01,0.00000000D+00
     .,0.11741980D+03,0.232D+03,0.600D+01,0.19447000D+01,0.00000000D+00
     .,0.81501900D+02,0.232D+03,0.700D+01,0.19447000D+01,0.00000000D+00
     .,0.61309900D+02,0.232D+03,0.800D+01,0.19447000D+01,0.00000000D+00
     .,0.46146800D+02,0.232D+03,0.900D+01,0.19447000D+01,0.00000000D+00
     .,0.35284200D+02,0.232D+03,0.100D+02,0.19447000D+01,0.00000000D+00
     .,0.54266570D+03,0.232D+03,0.110D+02,0.19447000D+01,0.00000000D+00
     .,0.41703070D+03,0.232D+03,0.120D+02,0.19447000D+01,0.00000000D+00
     .,0.38363050D+03,0.232D+03,0.130D+02,0.19447000D+01,0.00000000D+00
     .,0.30113800D+03,0.232D+03,0.140D+02,0.19447000D+01,0.00000000D+00
     .,0.23370440D+03,0.232D+03,0.150D+02,0.19447000D+01,0.00000000D+00
     .,0.19313150D+03,0.232D+03,0.160D+02,0.19447000D+01,0.00000000D+00
     .,0.15700310D+03,0.232D+03,0.170D+02,0.19447000D+01,0.00000000D+00
     .,0.12781130D+03,0.232D+03,0.180D+02,0.19447000D+01,0.00000000D+00
     .,0.88770750D+03,0.232D+03,0.190D+02,0.19447000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 101601: 101700)=(/
     . 0.73264330D+03,0.232D+03,0.200D+02,0.19447000D+01,0.00000000D+00
     .,0.60503430D+03,0.232D+03,0.210D+02,0.19447000D+01,0.00000000D+00
     .,0.58362370D+03,0.232D+03,0.220D+02,0.19447000D+01,0.00000000D+00
     .,0.53412560D+03,0.232D+03,0.230D+02,0.19447000D+01,0.00000000D+00
     .,0.42006420D+03,0.232D+03,0.240D+02,0.19447000D+01,0.00000000D+00
     .,0.45943140D+03,0.232D+03,0.250D+02,0.19447000D+01,0.00000000D+00
     .,0.35991720D+03,0.232D+03,0.260D+02,0.19447000D+01,0.00000000D+00
     .,0.38165880D+03,0.232D+03,0.270D+02,0.19447000D+01,0.00000000D+00
     .,0.39345300D+03,0.232D+03,0.280D+02,0.19447000D+01,0.00000000D+00
     .,0.30098740D+03,0.232D+03,0.290D+02,0.19447000D+01,0.00000000D+00
     .,0.30895170D+03,0.232D+03,0.300D+02,0.19447000D+01,0.00000000D+00
     .,0.36657420D+03,0.232D+03,0.310D+02,0.19447000D+01,0.00000000D+00
     .,0.32239740D+03,0.232D+03,0.320D+02,0.19447000D+01,0.00000000D+00
     .,0.27396550D+03,0.232D+03,0.330D+02,0.19447000D+01,0.00000000D+00
     .,0.24506900D+03,0.232D+03,0.340D+02,0.19447000D+01,0.00000000D+00
     .,0.21366510D+03,0.232D+03,0.350D+02,0.19447000D+01,0.00000000D+00
     .,0.18507510D+03,0.232D+03,0.360D+02,0.19447000D+01,0.00000000D+00
     .,0.99420460D+03,0.232D+03,0.370D+02,0.19447000D+01,0.00000000D+00
     .,0.87244650D+03,0.232D+03,0.380D+02,0.19447000D+01,0.00000000D+00
     .,0.76334100D+03,0.232D+03,0.390D+02,0.19447000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 101701: 101800)=(/
     . 0.68527160D+03,0.232D+03,0.400D+02,0.19447000D+01,0.00000000D+00
     .,0.62420610D+03,0.232D+03,0.410D+02,0.19447000D+01,0.00000000D+00
     .,0.48055520D+03,0.232D+03,0.420D+02,0.19447000D+01,0.00000000D+00
     .,0.53677950D+03,0.232D+03,0.430D+02,0.19447000D+01,0.00000000D+00
     .,0.40763390D+03,0.232D+03,0.440D+02,0.19447000D+01,0.00000000D+00
     .,0.44608760D+03,0.232D+03,0.450D+02,0.19447000D+01,0.00000000D+00
     .,0.41332440D+03,0.232D+03,0.460D+02,0.19447000D+01,0.00000000D+00
     .,0.34400650D+03,0.232D+03,0.470D+02,0.19447000D+01,0.00000000D+00
     .,0.36375360D+03,0.232D+03,0.480D+02,0.19447000D+01,0.00000000D+00
     .,0.45781190D+03,0.232D+03,0.490D+02,0.19447000D+01,0.00000000D+00
     .,0.42263220D+03,0.232D+03,0.500D+02,0.19447000D+01,0.00000000D+00
     .,0.37560470D+03,0.232D+03,0.510D+02,0.19447000D+01,0.00000000D+00
     .,0.34772860D+03,0.232D+03,0.520D+02,0.19447000D+01,0.00000000D+00
     .,0.31352800D+03,0.232D+03,0.530D+02,0.19447000D+01,0.00000000D+00
     .,0.28100460D+03,0.232D+03,0.540D+02,0.19447000D+01,0.00000000D+00
     .,0.12108497D+04,0.232D+03,0.550D+02,0.19447000D+01,0.00000000D+00
     .,0.11120376D+04,0.232D+03,0.560D+02,0.19447000D+01,0.00000000D+00
     .,0.97600660D+03,0.232D+03,0.570D+02,0.19447000D+01,0.00000000D+00
     .,0.44363880D+03,0.232D+03,0.580D+02,0.19447000D+01,0.27991000D+01
     .,0.98453560D+03,0.232D+03,0.590D+02,0.19447000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 101801: 101900)=(/
     . 0.94530650D+03,0.232D+03,0.600D+02,0.19447000D+01,0.00000000D+00
     .,0.92157530D+03,0.232D+03,0.610D+02,0.19447000D+01,0.00000000D+00
     .,0.89976220D+03,0.232D+03,0.620D+02,0.19447000D+01,0.00000000D+00
     .,0.88042150D+03,0.232D+03,0.630D+02,0.19447000D+01,0.00000000D+00
     .,0.69068230D+03,0.232D+03,0.640D+02,0.19447000D+01,0.00000000D+00
     .,0.77859640D+03,0.232D+03,0.650D+02,0.19447000D+01,0.00000000D+00
     .,0.75073230D+03,0.232D+03,0.660D+02,0.19447000D+01,0.00000000D+00
     .,0.79395920D+03,0.232D+03,0.670D+02,0.19447000D+01,0.00000000D+00
     .,0.77712650D+03,0.232D+03,0.680D+02,0.19447000D+01,0.00000000D+00
     .,0.76193210D+03,0.232D+03,0.690D+02,0.19447000D+01,0.00000000D+00
     .,0.75311720D+03,0.232D+03,0.700D+02,0.19447000D+01,0.00000000D+00
     .,0.63353080D+03,0.232D+03,0.710D+02,0.19447000D+01,0.00000000D+00
     .,0.62243820D+03,0.232D+03,0.720D+02,0.19447000D+01,0.00000000D+00
     .,0.56714200D+03,0.232D+03,0.730D+02,0.19447000D+01,0.00000000D+00
     .,0.47771970D+03,0.232D+03,0.740D+02,0.19447000D+01,0.00000000D+00
     .,0.48586480D+03,0.232D+03,0.750D+02,0.19447000D+01,0.00000000D+00
     .,0.43956860D+03,0.232D+03,0.760D+02,0.19447000D+01,0.00000000D+00
     .,0.40191180D+03,0.232D+03,0.770D+02,0.19447000D+01,0.00000000D+00
     .,0.33286630D+03,0.232D+03,0.780D+02,0.19447000D+01,0.00000000D+00
     .,0.31061480D+03,0.232D+03,0.790D+02,0.19447000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 101901: 102000)=(/
     . 0.31958080D+03,0.232D+03,0.800D+02,0.19447000D+01,0.00000000D+00
     .,0.46894260D+03,0.232D+03,0.810D+02,0.19447000D+01,0.00000000D+00
     .,0.45811250D+03,0.232D+03,0.820D+02,0.19447000D+01,0.00000000D+00
     .,0.42004290D+03,0.232D+03,0.830D+02,0.19447000D+01,0.00000000D+00
     .,0.39996790D+03,0.232D+03,0.840D+02,0.19447000D+01,0.00000000D+00
     .,0.36825120D+03,0.232D+03,0.850D+02,0.19447000D+01,0.00000000D+00
     .,0.33664170D+03,0.232D+03,0.860D+02,0.19447000D+01,0.00000000D+00
     .,0.11423947D+04,0.232D+03,0.870D+02,0.19447000D+01,0.00000000D+00
     .,0.10988136D+04,0.232D+03,0.880D+02,0.19447000D+01,0.00000000D+00
     .,0.97025760D+03,0.232D+03,0.890D+02,0.19447000D+01,0.00000000D+00
     .,0.87002090D+03,0.232D+03,0.900D+02,0.19447000D+01,0.00000000D+00
     .,0.86401750D+03,0.232D+03,0.910D+02,0.19447000D+01,0.00000000D+00
     .,0.83647440D+03,0.232D+03,0.920D+02,0.19447000D+01,0.00000000D+00
     .,0.86205870D+03,0.232D+03,0.930D+02,0.19447000D+01,0.00000000D+00
     .,0.83468930D+03,0.232D+03,0.940D+02,0.19447000D+01,0.00000000D+00
     .,0.46440900D+02,0.232D+03,0.101D+03,0.19447000D+01,0.00000000D+00
     .,0.15187590D+03,0.232D+03,0.103D+03,0.19447000D+01,0.98650000D+00
     .,0.19344570D+03,0.232D+03,0.104D+03,0.19447000D+01,0.98080000D+00
     .,0.14696060D+03,0.232D+03,0.105D+03,0.19447000D+01,0.97060000D+00
     .,0.11006510D+03,0.232D+03,0.106D+03,0.19447000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters( 102001: 102100)=(/
     . 0.75928700D+02,0.232D+03,0.107D+03,0.19447000D+01,0.99440000D+00
     .,0.54869300D+02,0.232D+03,0.108D+03,0.19447000D+01,0.99250000D+00
     .,0.37320200D+02,0.232D+03,0.109D+03,0.19447000D+01,0.99820000D+00
     .,0.22190310D+03,0.232D+03,0.111D+03,0.19447000D+01,0.96840000D+00
     .,0.34351060D+03,0.232D+03,0.112D+03,0.19447000D+01,0.96280000D+00
     .,0.34738790D+03,0.232D+03,0.113D+03,0.19447000D+01,0.96480000D+00
     .,0.27806710D+03,0.232D+03,0.114D+03,0.19447000D+01,0.95070000D+00
     .,0.22676600D+03,0.232D+03,0.115D+03,0.19447000D+01,0.99470000D+00
     .,0.19099270D+03,0.232D+03,0.116D+03,0.19447000D+01,0.99480000D+00
     .,0.15536720D+03,0.232D+03,0.117D+03,0.19447000D+01,0.99720000D+00
     .,0.30442220D+03,0.232D+03,0.119D+03,0.19447000D+01,0.97670000D+00
     .,0.58505150D+03,0.232D+03,0.120D+03,0.19447000D+01,0.98310000D+00
     .,0.30419020D+03,0.232D+03,0.121D+03,0.19447000D+01,0.18627000D+01
     .,0.29348990D+03,0.232D+03,0.122D+03,0.19447000D+01,0.18299000D+01
     .,0.28758510D+03,0.232D+03,0.123D+03,0.19447000D+01,0.19138000D+01
     .,0.28497290D+03,0.232D+03,0.124D+03,0.19447000D+01,0.18269000D+01
     .,0.26188660D+03,0.232D+03,0.125D+03,0.19447000D+01,0.16406000D+01
     .,0.24213490D+03,0.232D+03,0.126D+03,0.19447000D+01,0.16483000D+01
     .,0.23089560D+03,0.232D+03,0.127D+03,0.19447000D+01,0.17149000D+01
     .,0.22574350D+03,0.232D+03,0.128D+03,0.19447000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters( 102101: 102200)=(/
     . 0.22325740D+03,0.232D+03,0.129D+03,0.19447000D+01,0.95760000D+00
     .,0.20907070D+03,0.232D+03,0.130D+03,0.19447000D+01,0.19419000D+01
     .,0.34402320D+03,0.232D+03,0.131D+03,0.19447000D+01,0.96010000D+00
     .,0.30131020D+03,0.232D+03,0.132D+03,0.19447000D+01,0.94340000D+00
     .,0.26923080D+03,0.232D+03,0.133D+03,0.19447000D+01,0.98890000D+00
     .,0.24516040D+03,0.232D+03,0.134D+03,0.19447000D+01,0.99010000D+00
     .,0.21518160D+03,0.232D+03,0.135D+03,0.19447000D+01,0.99740000D+00
     .,0.36280200D+03,0.232D+03,0.137D+03,0.19447000D+01,0.97380000D+00
     .,0.71158620D+03,0.232D+03,0.138D+03,0.19447000D+01,0.98010000D+00
     .,0.54236550D+03,0.232D+03,0.139D+03,0.19447000D+01,0.19153000D+01
     .,0.40208770D+03,0.232D+03,0.140D+03,0.19447000D+01,0.19355000D+01
     .,0.40601940D+03,0.232D+03,0.141D+03,0.19447000D+01,0.19545000D+01
     .,0.37812310D+03,0.232D+03,0.142D+03,0.19447000D+01,0.19420000D+01
     .,0.42477910D+03,0.232D+03,0.143D+03,0.19447000D+01,0.16682000D+01
     .,0.32883410D+03,0.232D+03,0.144D+03,0.19447000D+01,0.18584000D+01
     .,0.30737400D+03,0.232D+03,0.145D+03,0.19447000D+01,0.19003000D+01
     .,0.28513600D+03,0.232D+03,0.146D+03,0.19447000D+01,0.18630000D+01
     .,0.27584840D+03,0.232D+03,0.147D+03,0.19447000D+01,0.96790000D+00
     .,0.27272280D+03,0.232D+03,0.148D+03,0.19447000D+01,0.19539000D+01
     .,0.43605730D+03,0.232D+03,0.149D+03,0.19447000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters( 102201: 102300)=(/
     . 0.39365950D+03,0.232D+03,0.150D+03,0.19447000D+01,0.95140000D+00
     .,0.36794630D+03,0.232D+03,0.151D+03,0.19447000D+01,0.97490000D+00
     .,0.34743580D+03,0.232D+03,0.152D+03,0.19447000D+01,0.98110000D+00
     .,0.31650110D+03,0.232D+03,0.153D+03,0.19447000D+01,0.99680000D+00
     .,0.42861700D+03,0.232D+03,0.155D+03,0.19447000D+01,0.99090000D+00
     .,0.92250460D+03,0.232D+03,0.156D+03,0.19447000D+01,0.97970000D+00
     .,0.68647720D+03,0.232D+03,0.157D+03,0.19447000D+01,0.19373000D+01
     .,0.43015130D+03,0.232D+03,0.159D+03,0.19447000D+01,0.29425000D+01
     .,0.42122950D+03,0.232D+03,0.160D+03,0.19447000D+01,0.29455000D+01
     .,0.40778710D+03,0.232D+03,0.161D+03,0.19447000D+01,0.29413000D+01
     .,0.40995360D+03,0.232D+03,0.162D+03,0.19447000D+01,0.29300000D+01
     .,0.39549150D+03,0.232D+03,0.163D+03,0.19447000D+01,0.18286000D+01
     .,0.41271440D+03,0.232D+03,0.164D+03,0.19447000D+01,0.28732000D+01
     .,0.38742350D+03,0.232D+03,0.165D+03,0.19447000D+01,0.29086000D+01
     .,0.39445350D+03,0.232D+03,0.166D+03,0.19447000D+01,0.28965000D+01
     .,0.36762060D+03,0.232D+03,0.167D+03,0.19447000D+01,0.29242000D+01
     .,0.35709490D+03,0.232D+03,0.168D+03,0.19447000D+01,0.29282000D+01
     .,0.35486500D+03,0.232D+03,0.169D+03,0.19447000D+01,0.29246000D+01
     .,0.37342540D+03,0.232D+03,0.170D+03,0.19447000D+01,0.28482000D+01
     .,0.34296160D+03,0.232D+03,0.171D+03,0.19447000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters( 102301: 102400)=(/
     . 0.46674760D+03,0.232D+03,0.172D+03,0.19447000D+01,0.19254000D+01
     .,0.43239170D+03,0.232D+03,0.173D+03,0.19447000D+01,0.19459000D+01
     .,0.39371210D+03,0.232D+03,0.174D+03,0.19447000D+01,0.19292000D+01
     .,0.39890670D+03,0.232D+03,0.175D+03,0.19447000D+01,0.18104000D+01
     .,0.34767760D+03,0.232D+03,0.176D+03,0.19447000D+01,0.18858000D+01
     .,0.32665250D+03,0.232D+03,0.177D+03,0.19447000D+01,0.18648000D+01
     .,0.31170830D+03,0.232D+03,0.178D+03,0.19447000D+01,0.19188000D+01
     .,0.29781700D+03,0.232D+03,0.179D+03,0.19447000D+01,0.98460000D+00
     .,0.28742670D+03,0.232D+03,0.180D+03,0.19447000D+01,0.19896000D+01
     .,0.46737550D+03,0.232D+03,0.181D+03,0.19447000D+01,0.92670000D+00
     .,0.42511580D+03,0.232D+03,0.182D+03,0.19447000D+01,0.93830000D+00
     .,0.41176820D+03,0.232D+03,0.183D+03,0.19447000D+01,0.98200000D+00
     .,0.39999560D+03,0.232D+03,0.184D+03,0.19447000D+01,0.98150000D+00
     .,0.37274130D+03,0.232D+03,0.185D+03,0.19447000D+01,0.99540000D+00
     .,0.48272480D+03,0.232D+03,0.187D+03,0.19447000D+01,0.97050000D+00
     .,0.91693150D+03,0.232D+03,0.188D+03,0.19447000D+01,0.96620000D+00
     .,0.50916980D+03,0.232D+03,0.189D+03,0.19447000D+01,0.29070000D+01
     .,0.58862060D+03,0.232D+03,0.190D+03,0.19447000D+01,0.28844000D+01
     .,0.52540620D+03,0.232D+03,0.191D+03,0.19447000D+01,0.28738000D+01
     .,0.46359030D+03,0.232D+03,0.192D+03,0.19447000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters( 102401: 102500)=(/
     . 0.44586270D+03,0.232D+03,0.193D+03,0.19447000D+01,0.29095000D+01
     .,0.53855800D+03,0.232D+03,0.194D+03,0.19447000D+01,0.19209000D+01
     .,0.12562090D+03,0.232D+03,0.204D+03,0.19447000D+01,0.19697000D+01
     .,0.12309690D+03,0.232D+03,0.205D+03,0.19447000D+01,0.19441000D+01
     .,0.89444800D+02,0.232D+03,0.206D+03,0.19447000D+01,0.19985000D+01
     .,0.71201700D+02,0.232D+03,0.207D+03,0.19447000D+01,0.20143000D+01
     .,0.48247600D+02,0.232D+03,0.208D+03,0.19447000D+01,0.19887000D+01
     .,0.22342490D+03,0.232D+03,0.212D+03,0.19447000D+01,0.19496000D+01
     .,0.26999430D+03,0.232D+03,0.213D+03,0.19447000D+01,0.19311000D+01
     .,0.25843380D+03,0.232D+03,0.214D+03,0.19447000D+01,0.19435000D+01
     .,0.22370080D+03,0.232D+03,0.215D+03,0.19447000D+01,0.20102000D+01
     .,0.18709060D+03,0.232D+03,0.216D+03,0.19447000D+01,0.19903000D+01
     .,0.31254240D+03,0.232D+03,0.220D+03,0.19447000D+01,0.19349000D+01
     .,0.29990140D+03,0.232D+03,0.221D+03,0.19447000D+01,0.28999000D+01
     .,0.30352280D+03,0.232D+03,0.222D+03,0.19447000D+01,0.38675000D+01
     .,0.27760900D+03,0.232D+03,0.223D+03,0.19447000D+01,0.29110000D+01
     .,0.20803810D+03,0.232D+03,0.224D+03,0.19447000D+01,0.10619100D+02
     .,0.17749730D+03,0.232D+03,0.225D+03,0.19447000D+01,0.98849000D+01
     .,0.17426540D+03,0.232D+03,0.226D+03,0.19447000D+01,0.91376000D+01
     .,0.20521220D+03,0.232D+03,0.227D+03,0.19447000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters( 102501: 102600)=(/
     . 0.19097590D+03,0.232D+03,0.228D+03,0.19447000D+01,0.65458000D+01
     .,0.27172720D+03,0.232D+03,0.231D+03,0.19447000D+01,0.19315000D+01
     .,0.28665450D+03,0.232D+03,0.232D+03,0.19447000D+01,0.19447000D+01
     .,0.26704200D+02,0.233D+03,0.100D+01,0.19793000D+01,0.91180000D+00
     .,0.17705100D+02,0.233D+03,0.200D+01,0.19793000D+01,0.00000000D+00
     .,0.39243650D+03,0.233D+03,0.300D+01,0.19793000D+01,0.00000000D+00
     .,0.23351510D+03,0.233D+03,0.400D+01,0.19793000D+01,0.00000000D+00
     .,0.15949690D+03,0.233D+03,0.500D+01,0.19793000D+01,0.00000000D+00
     .,0.10864070D+03,0.233D+03,0.600D+01,0.19793000D+01,0.00000000D+00
     .,0.76299200D+02,0.233D+03,0.700D+01,0.19793000D+01,0.00000000D+00
     .,0.57878400D+02,0.233D+03,0.800D+01,0.19793000D+01,0.00000000D+00
     .,0.43876200D+02,0.233D+03,0.900D+01,0.19793000D+01,0.00000000D+00
     .,0.33739100D+02,0.233D+03,0.100D+02,0.19793000D+01,0.00000000D+00
     .,0.46995960D+03,0.233D+03,0.110D+02,0.19793000D+01,0.00000000D+00
     .,0.37006380D+03,0.233D+03,0.120D+02,0.19793000D+01,0.00000000D+00
     .,0.34393430D+03,0.233D+03,0.130D+02,0.19793000D+01,0.00000000D+00
     .,0.27373340D+03,0.233D+03,0.140D+02,0.19793000D+01,0.00000000D+00
     .,0.21501030D+03,0.233D+03,0.150D+02,0.19793000D+01,0.00000000D+00
     .,0.17911600D+03,0.233D+03,0.160D+02,0.19793000D+01,0.00000000D+00
     .,0.14674050D+03,0.233D+03,0.170D+02,0.19793000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 102601: 102700)=(/
     . 0.12026980D+03,0.233D+03,0.180D+02,0.19793000D+01,0.00000000D+00
     .,0.76653110D+03,0.233D+03,0.190D+02,0.19793000D+01,0.00000000D+00
     .,0.64403510D+03,0.233D+03,0.200D+02,0.19793000D+01,0.00000000D+00
     .,0.53415750D+03,0.233D+03,0.210D+02,0.19793000D+01,0.00000000D+00
     .,0.51756110D+03,0.233D+03,0.220D+02,0.19793000D+01,0.00000000D+00
     .,0.47488980D+03,0.233D+03,0.230D+02,0.19793000D+01,0.00000000D+00
     .,0.37400380D+03,0.233D+03,0.240D+02,0.19793000D+01,0.00000000D+00
     .,0.41001990D+03,0.233D+03,0.250D+02,0.19793000D+01,0.00000000D+00
     .,0.32180920D+03,0.233D+03,0.260D+02,0.19793000D+01,0.00000000D+00
     .,0.34272150D+03,0.233D+03,0.270D+02,0.19793000D+01,0.00000000D+00
     .,0.35234030D+03,0.233D+03,0.280D+02,0.19793000D+01,0.00000000D+00
     .,0.26993300D+03,0.233D+03,0.290D+02,0.19793000D+01,0.00000000D+00
     .,0.27903750D+03,0.233D+03,0.300D+02,0.19793000D+01,0.00000000D+00
     .,0.33018810D+03,0.233D+03,0.310D+02,0.19793000D+01,0.00000000D+00
     .,0.29343220D+03,0.233D+03,0.320D+02,0.19793000D+01,0.00000000D+00
     .,0.25181550D+03,0.233D+03,0.330D+02,0.19793000D+01,0.00000000D+00
     .,0.22668450D+03,0.233D+03,0.340D+02,0.19793000D+01,0.00000000D+00
     .,0.19893080D+03,0.233D+03,0.350D+02,0.19793000D+01,0.00000000D+00
     .,0.17335820D+03,0.233D+03,0.360D+02,0.19793000D+01,0.00000000D+00
     .,0.86036720D+03,0.233D+03,0.370D+02,0.19793000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 102701: 102800)=(/
     . 0.76674210D+03,0.233D+03,0.380D+02,0.19793000D+01,0.00000000D+00
     .,0.67620360D+03,0.233D+03,0.390D+02,0.19793000D+01,0.00000000D+00
     .,0.61017610D+03,0.233D+03,0.400D+02,0.19793000D+01,0.00000000D+00
     .,0.55778500D+03,0.233D+03,0.410D+02,0.19793000D+01,0.00000000D+00
     .,0.43224960D+03,0.233D+03,0.420D+02,0.19793000D+01,0.00000000D+00
     .,0.48162290D+03,0.233D+03,0.430D+02,0.19793000D+01,0.00000000D+00
     .,0.36836950D+03,0.233D+03,0.440D+02,0.19793000D+01,0.00000000D+00
     .,0.40280170D+03,0.233D+03,0.450D+02,0.19793000D+01,0.00000000D+00
     .,0.37403530D+03,0.233D+03,0.460D+02,0.19793000D+01,0.00000000D+00
     .,0.31127990D+03,0.233D+03,0.470D+02,0.19793000D+01,0.00000000D+00
     .,0.33010750D+03,0.233D+03,0.480D+02,0.19793000D+01,0.00000000D+00
     .,0.41255410D+03,0.233D+03,0.490D+02,0.19793000D+01,0.00000000D+00
     .,0.38394660D+03,0.233D+03,0.500D+02,0.19793000D+01,0.00000000D+00
     .,0.34410360D+03,0.233D+03,0.510D+02,0.19793000D+01,0.00000000D+00
     .,0.32025290D+03,0.233D+03,0.520D+02,0.19793000D+01,0.00000000D+00
     .,0.29042110D+03,0.233D+03,0.530D+02,0.19793000D+01,0.00000000D+00
     .,0.26173610D+03,0.233D+03,0.540D+02,0.19793000D+01,0.00000000D+00
     .,0.10488144D+04,0.233D+03,0.550D+02,0.19793000D+01,0.00000000D+00
     .,0.97532420D+03,0.233D+03,0.560D+02,0.19793000D+01,0.00000000D+00
     .,0.86267800D+03,0.233D+03,0.570D+02,0.19793000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 102801: 102900)=(/
     . 0.40598460D+03,0.233D+03,0.580D+02,0.19793000D+01,0.27991000D+01
     .,0.86579390D+03,0.233D+03,0.590D+02,0.19793000D+01,0.00000000D+00
     .,0.83226700D+03,0.233D+03,0.600D+02,0.19793000D+01,0.00000000D+00
     .,0.81163560D+03,0.233D+03,0.610D+02,0.19793000D+01,0.00000000D+00
     .,0.79263850D+03,0.233D+03,0.620D+02,0.19793000D+01,0.00000000D+00
     .,0.77580510D+03,0.233D+03,0.630D+02,0.19793000D+01,0.00000000D+00
     .,0.61436540D+03,0.233D+03,0.640D+02,0.19793000D+01,0.00000000D+00
     .,0.68438050D+03,0.233D+03,0.650D+02,0.19793000D+01,0.00000000D+00
     .,0.66094210D+03,0.233D+03,0.660D+02,0.19793000D+01,0.00000000D+00
     .,0.70089270D+03,0.233D+03,0.670D+02,0.19793000D+01,0.00000000D+00
     .,0.68614780D+03,0.233D+03,0.680D+02,0.19793000D+01,0.00000000D+00
     .,0.67291500D+03,0.233D+03,0.690D+02,0.19793000D+01,0.00000000D+00
     .,0.66485520D+03,0.233D+03,0.700D+02,0.19793000D+01,0.00000000D+00
     .,0.56289600D+03,0.233D+03,0.710D+02,0.19793000D+01,0.00000000D+00
     .,0.55747290D+03,0.233D+03,0.720D+02,0.19793000D+01,0.00000000D+00
     .,0.51061380D+03,0.233D+03,0.730D+02,0.19793000D+01,0.00000000D+00
     .,0.43217460D+03,0.233D+03,0.740D+02,0.19793000D+01,0.00000000D+00
     .,0.44031270D+03,0.233D+03,0.750D+02,0.19793000D+01,0.00000000D+00
     .,0.40018070D+03,0.233D+03,0.760D+02,0.19793000D+01,0.00000000D+00
     .,0.36727240D+03,0.233D+03,0.770D+02,0.19793000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 102901: 103000)=(/
     . 0.30555600D+03,0.233D+03,0.780D+02,0.19793000D+01,0.00000000D+00
     .,0.28562940D+03,0.233D+03,0.790D+02,0.19793000D+01,0.00000000D+00
     .,0.29425470D+03,0.233D+03,0.800D+02,0.19793000D+01,0.00000000D+00
     .,0.42390230D+03,0.233D+03,0.810D+02,0.19793000D+01,0.00000000D+00
     .,0.41654960D+03,0.233D+03,0.820D+02,0.19793000D+01,0.00000000D+00
     .,0.38473230D+03,0.233D+03,0.830D+02,0.19793000D+01,0.00000000D+00
     .,0.36796170D+03,0.233D+03,0.840D+02,0.19793000D+01,0.00000000D+00
     .,0.34061170D+03,0.233D+03,0.850D+02,0.19793000D+01,0.00000000D+00
     .,0.31293820D+03,0.233D+03,0.860D+02,0.19793000D+01,0.00000000D+00
     .,0.99568830D+03,0.233D+03,0.870D+02,0.19793000D+01,0.00000000D+00
     .,0.96779800D+03,0.233D+03,0.880D+02,0.19793000D+01,0.00000000D+00
     .,0.86060590D+03,0.233D+03,0.890D+02,0.19793000D+01,0.00000000D+00
     .,0.77842680D+03,0.233D+03,0.900D+02,0.19793000D+01,0.00000000D+00
     .,0.77007950D+03,0.233D+03,0.910D+02,0.19793000D+01,0.00000000D+00
     .,0.74569540D+03,0.233D+03,0.920D+02,0.19793000D+01,0.00000000D+00
     .,0.76439730D+03,0.233D+03,0.930D+02,0.19793000D+01,0.00000000D+00
     .,0.74080980D+03,0.233D+03,0.940D+02,0.19793000D+01,0.00000000D+00
     .,0.42778900D+02,0.233D+03,0.101D+03,0.19793000D+01,0.00000000D+00
     .,0.13598320D+03,0.233D+03,0.103D+03,0.19793000D+01,0.98650000D+00
     .,0.17394150D+03,0.233D+03,0.104D+03,0.19793000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters( 103001: 103100)=(/
     . 0.13447040D+03,0.233D+03,0.105D+03,0.19793000D+01,0.97060000D+00
     .,0.10184690D+03,0.233D+03,0.106D+03,0.19793000D+01,0.98680000D+00
     .,0.71123800D+02,0.233D+03,0.107D+03,0.19793000D+01,0.99440000D+00
     .,0.51919900D+02,0.233D+03,0.108D+03,0.19793000D+01,0.99250000D+00
     .,0.35758200D+02,0.233D+03,0.109D+03,0.19793000D+01,0.99820000D+00
     .,0.19806920D+03,0.233D+03,0.111D+03,0.19793000D+01,0.96840000D+00
     .,0.30612750D+03,0.233D+03,0.112D+03,0.19793000D+01,0.96280000D+00
     .,0.31225010D+03,0.233D+03,0.113D+03,0.19793000D+01,0.96480000D+00
     .,0.25331120D+03,0.233D+03,0.114D+03,0.19793000D+01,0.95070000D+00
     .,0.20873090D+03,0.233D+03,0.115D+03,0.19793000D+01,0.99470000D+00
     .,0.17710850D+03,0.233D+03,0.116D+03,0.19793000D+01,0.99480000D+00
     .,0.14519610D+03,0.233D+03,0.117D+03,0.19793000D+01,0.99720000D+00
     .,0.27423250D+03,0.233D+03,0.119D+03,0.19793000D+01,0.97670000D+00
     .,0.51543230D+03,0.233D+03,0.120D+03,0.19793000D+01,0.98310000D+00
     .,0.27666340D+03,0.233D+03,0.121D+03,0.19793000D+01,0.18627000D+01
     .,0.26710550D+03,0.233D+03,0.122D+03,0.19793000D+01,0.18299000D+01
     .,0.26168720D+03,0.233D+03,0.123D+03,0.19793000D+01,0.19138000D+01
     .,0.25898560D+03,0.233D+03,0.124D+03,0.19793000D+01,0.18269000D+01
     .,0.23941200D+03,0.233D+03,0.125D+03,0.19793000D+01,0.16406000D+01
     .,0.22180340D+03,0.233D+03,0.126D+03,0.19793000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters( 103101: 103200)=(/
     . 0.21154220D+03,0.233D+03,0.127D+03,0.19793000D+01,0.17149000D+01
     .,0.20671720D+03,0.233D+03,0.128D+03,0.19793000D+01,0.17937000D+01
     .,0.20348070D+03,0.233D+03,0.129D+03,0.19793000D+01,0.95760000D+00
     .,0.19216860D+03,0.233D+03,0.130D+03,0.19793000D+01,0.19419000D+01
     .,0.31071100D+03,0.233D+03,0.131D+03,0.19793000D+01,0.96010000D+00
     .,0.27494970D+03,0.233D+03,0.132D+03,0.19793000D+01,0.94340000D+00
     .,0.24761740D+03,0.233D+03,0.133D+03,0.19793000D+01,0.98890000D+00
     .,0.22675190D+03,0.233D+03,0.134D+03,0.19793000D+01,0.99010000D+00
     .,0.20027860D+03,0.233D+03,0.135D+03,0.19793000D+01,0.99740000D+00
     .,0.32770320D+03,0.233D+03,0.137D+03,0.19793000D+01,0.97380000D+00
     .,0.62656050D+03,0.233D+03,0.138D+03,0.19793000D+01,0.98010000D+00
     .,0.48524610D+03,0.233D+03,0.139D+03,0.19793000D+01,0.19153000D+01
     .,0.36563120D+03,0.233D+03,0.140D+03,0.19793000D+01,0.19355000D+01
     .,0.36911250D+03,0.233D+03,0.141D+03,0.19793000D+01,0.19545000D+01
     .,0.34461330D+03,0.233D+03,0.142D+03,0.19793000D+01,0.19420000D+01
     .,0.38416440D+03,0.233D+03,0.143D+03,0.19793000D+01,0.16682000D+01
     .,0.30149240D+03,0.233D+03,0.144D+03,0.19793000D+01,0.18584000D+01
     .,0.28204640D+03,0.233D+03,0.145D+03,0.19793000D+01,0.19003000D+01
     .,0.26198970D+03,0.233D+03,0.146D+03,0.19793000D+01,0.18630000D+01
     .,0.25321800D+03,0.233D+03,0.147D+03,0.19793000D+01,0.96790000D+00
     ./)
      grimme_c6_parameters( 103201: 103300)=(/
     . 0.25140820D+03,0.233D+03,0.148D+03,0.19793000D+01,0.19539000D+01
     .,0.39410730D+03,0.233D+03,0.149D+03,0.19793000D+01,0.96330000D+00
     .,0.35883980D+03,0.233D+03,0.150D+03,0.19793000D+01,0.95140000D+00
     .,0.33748280D+03,0.233D+03,0.151D+03,0.19793000D+01,0.97490000D+00
     .,0.32008780D+03,0.233D+03,0.152D+03,0.19793000D+01,0.98110000D+00
     .,0.29314450D+03,0.233D+03,0.153D+03,0.19793000D+01,0.99680000D+00
     .,0.38968370D+03,0.233D+03,0.155D+03,0.19793000D+01,0.99090000D+00
     .,0.81023570D+03,0.233D+03,0.156D+03,0.19793000D+01,0.97970000D+00
     .,0.61351580D+03,0.233D+03,0.157D+03,0.19793000D+01,0.19373000D+01
     .,0.39384480D+03,0.233D+03,0.159D+03,0.19793000D+01,0.29425000D+01
     .,0.38570960D+03,0.233D+03,0.160D+03,0.19793000D+01,0.29455000D+01
     .,0.37356920D+03,0.233D+03,0.161D+03,0.19793000D+01,0.29413000D+01
     .,0.37509470D+03,0.233D+03,0.162D+03,0.19793000D+01,0.29300000D+01
     .,0.36042550D+03,0.233D+03,0.163D+03,0.19793000D+01,0.18286000D+01
     .,0.37742120D+03,0.233D+03,0.164D+03,0.19793000D+01,0.28732000D+01
     .,0.35468510D+03,0.233D+03,0.165D+03,0.19793000D+01,0.29086000D+01
     .,0.36034200D+03,0.233D+03,0.166D+03,0.19793000D+01,0.28965000D+01
     .,0.33690980D+03,0.233D+03,0.167D+03,0.19793000D+01,0.29242000D+01
     .,0.32739560D+03,0.233D+03,0.168D+03,0.19793000D+01,0.29282000D+01
     .,0.32523710D+03,0.233D+03,0.169D+03,0.19793000D+01,0.29246000D+01
     ./)
      grimme_c6_parameters( 103301: 103400)=(/
     . 0.34156110D+03,0.233D+03,0.170D+03,0.19793000D+01,0.28482000D+01
     .,0.31451130D+03,0.233D+03,0.171D+03,0.19793000D+01,0.29219000D+01
     .,0.42201500D+03,0.233D+03,0.172D+03,0.19793000D+01,0.19254000D+01
     .,0.39293770D+03,0.233D+03,0.173D+03,0.19793000D+01,0.19459000D+01
     .,0.35967380D+03,0.233D+03,0.174D+03,0.19793000D+01,0.19292000D+01
     .,0.36277430D+03,0.233D+03,0.175D+03,0.19793000D+01,0.18104000D+01
     .,0.31999870D+03,0.233D+03,0.176D+03,0.19793000D+01,0.18858000D+01
     .,0.30124260D+03,0.233D+03,0.177D+03,0.19793000D+01,0.18648000D+01
     .,0.28780780D+03,0.233D+03,0.178D+03,0.19793000D+01,0.19188000D+01
     .,0.27498950D+03,0.233D+03,0.179D+03,0.19793000D+01,0.98460000D+00
     .,0.26648330D+03,0.233D+03,0.180D+03,0.19793000D+01,0.19896000D+01
     .,0.42338910D+03,0.233D+03,0.181D+03,0.19793000D+01,0.92670000D+00
     .,0.38827410D+03,0.233D+03,0.182D+03,0.19793000D+01,0.93830000D+00
     .,0.37778300D+03,0.233D+03,0.183D+03,0.19793000D+01,0.98200000D+00
     .,0.36822760D+03,0.233D+03,0.184D+03,0.19793000D+01,0.98150000D+00
     .,0.34477670D+03,0.233D+03,0.185D+03,0.19793000D+01,0.99540000D+00
     .,0.43908390D+03,0.233D+03,0.187D+03,0.19793000D+01,0.97050000D+00
     .,0.80936840D+03,0.233D+03,0.188D+03,0.19793000D+01,0.96620000D+00
     .,0.46604700D+03,0.233D+03,0.189D+03,0.19793000D+01,0.29070000D+01
     .,0.53507930D+03,0.233D+03,0.190D+03,0.19793000D+01,0.28844000D+01
     ./)
      grimme_c6_parameters( 103401: 103500)=(/
     . 0.47904230D+03,0.233D+03,0.191D+03,0.19793000D+01,0.28738000D+01
     .,0.42495090D+03,0.233D+03,0.192D+03,0.19793000D+01,0.28878000D+01
     .,0.40922440D+03,0.233D+03,0.193D+03,0.19793000D+01,0.29095000D+01
     .,0.48694030D+03,0.233D+03,0.194D+03,0.19793000D+01,0.19209000D+01
     .,0.11501370D+03,0.233D+03,0.204D+03,0.19793000D+01,0.19697000D+01
     .,0.11314120D+03,0.233D+03,0.205D+03,0.19793000D+01,0.19441000D+01
     .,0.83286500D+02,0.233D+03,0.206D+03,0.19793000D+01,0.19985000D+01
     .,0.66781800D+02,0.233D+03,0.207D+03,0.19793000D+01,0.20143000D+01
     .,0.45789900D+02,0.233D+03,0.208D+03,0.19793000D+01,0.19887000D+01
     .,0.20272440D+03,0.233D+03,0.212D+03,0.19793000D+01,0.19496000D+01
     .,0.24478960D+03,0.233D+03,0.213D+03,0.19793000D+01,0.19311000D+01
     .,0.23590120D+03,0.233D+03,0.214D+03,0.19793000D+01,0.19435000D+01
     .,0.20577840D+03,0.233D+03,0.215D+03,0.19793000D+01,0.20102000D+01
     .,0.17352340D+03,0.233D+03,0.216D+03,0.19793000D+01,0.19903000D+01
     .,0.28380130D+03,0.233D+03,0.220D+03,0.19793000D+01,0.19349000D+01
     .,0.27376840D+03,0.233D+03,0.221D+03,0.19793000D+01,0.28999000D+01
     .,0.27719390D+03,0.233D+03,0.222D+03,0.19793000D+01,0.38675000D+01
     .,0.25351690D+03,0.233D+03,0.223D+03,0.19793000D+01,0.29110000D+01
     .,0.19175980D+03,0.233D+03,0.224D+03,0.19793000D+01,0.10619100D+02
     .,0.16452480D+03,0.233D+03,0.225D+03,0.19793000D+01,0.98849000D+01
     ./)
      grimme_c6_parameters( 103501: 103600)=(/
     . 0.16141780D+03,0.233D+03,0.226D+03,0.19793000D+01,0.91376000D+01
     .,0.18837020D+03,0.233D+03,0.227D+03,0.19793000D+01,0.29263000D+01
     .,0.17573990D+03,0.233D+03,0.228D+03,0.19793000D+01,0.65458000D+01
     .,0.24774210D+03,0.233D+03,0.231D+03,0.19793000D+01,0.19315000D+01
     .,0.26203540D+03,0.233D+03,0.232D+03,0.19793000D+01,0.19447000D+01
     .,0.24124940D+03,0.233D+03,0.233D+03,0.19793000D+01,0.19793000D+01
     .,0.25126800D+02,0.234D+03,0.100D+01,0.19812000D+01,0.91180000D+00
     .,0.16915700D+02,0.234D+03,0.200D+01,0.19812000D+01,0.00000000D+00
     .,0.35181040D+03,0.234D+03,0.300D+01,0.19812000D+01,0.00000000D+00
     .,0.21331490D+03,0.234D+03,0.400D+01,0.19812000D+01,0.00000000D+00
     .,0.14765020D+03,0.234D+03,0.500D+01,0.19812000D+01,0.00000000D+00
     .,0.10167860D+03,0.234D+03,0.600D+01,0.19812000D+01,0.00000000D+00
     .,0.72032800D+02,0.234D+03,0.700D+01,0.19812000D+01,0.00000000D+00
     .,0.54994300D+02,0.234D+03,0.800D+01,0.19812000D+01,0.00000000D+00
     .,0.41926000D+02,0.234D+03,0.900D+01,0.19812000D+01,0.00000000D+00
     .,0.32389200D+02,0.234D+03,0.100D+02,0.19812000D+01,0.00000000D+00
     .,0.42191950D+03,0.234D+03,0.110D+02,0.19812000D+01,0.00000000D+00
     .,0.33688690D+03,0.234D+03,0.120D+02,0.19812000D+01,0.00000000D+00
     .,0.31511470D+03,0.234D+03,0.130D+02,0.19812000D+01,0.00000000D+00
     .,0.25302890D+03,0.234D+03,0.140D+02,0.19812000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 103601: 103700)=(/
     . 0.20037470D+03,0.234D+03,0.150D+02,0.19812000D+01,0.00000000D+00
     .,0.16788680D+03,0.234D+03,0.160D+02,0.19812000D+01,0.00000000D+00
     .,0.13832530D+03,0.234D+03,0.170D+02,0.19812000D+01,0.00000000D+00
     .,0.11395770D+03,0.234D+03,0.180D+02,0.19812000D+01,0.00000000D+00
     .,0.68773700D+03,0.234D+03,0.190D+02,0.19812000D+01,0.00000000D+00
     .,0.58340090D+03,0.234D+03,0.200D+02,0.19812000D+01,0.00000000D+00
     .,0.48505940D+03,0.234D+03,0.210D+02,0.19812000D+01,0.00000000D+00
     .,0.47134280D+03,0.234D+03,0.220D+02,0.19812000D+01,0.00000000D+00
     .,0.43318300D+03,0.234D+03,0.230D+02,0.19812000D+01,0.00000000D+00
     .,0.34166370D+03,0.234D+03,0.240D+02,0.19812000D+01,0.00000000D+00
     .,0.37490260D+03,0.234D+03,0.250D+02,0.19812000D+01,0.00000000D+00
     .,0.29477780D+03,0.234D+03,0.260D+02,0.19812000D+01,0.00000000D+00
     .,0.31457060D+03,0.234D+03,0.270D+02,0.19812000D+01,0.00000000D+00
     .,0.32282380D+03,0.234D+03,0.280D+02,0.19812000D+01,0.00000000D+00
     .,0.24774600D+03,0.234D+03,0.290D+02,0.19812000D+01,0.00000000D+00
     .,0.25705830D+03,0.234D+03,0.300D+02,0.19812000D+01,0.00000000D+00
     .,0.30357640D+03,0.234D+03,0.310D+02,0.19812000D+01,0.00000000D+00
     .,0.27154740D+03,0.234D+03,0.320D+02,0.19812000D+01,0.00000000D+00
     .,0.23456310D+03,0.234D+03,0.330D+02,0.19812000D+01,0.00000000D+00
     .,0.21209150D+03,0.234D+03,0.340D+02,0.19812000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 103701: 103800)=(/
     . 0.18699940D+03,0.234D+03,0.350D+02,0.19812000D+01,0.00000000D+00
     .,0.16369060D+03,0.234D+03,0.360D+02,0.19812000D+01,0.00000000D+00
     .,0.77312550D+03,0.234D+03,0.370D+02,0.19812000D+01,0.00000000D+00
     .,0.69465560D+03,0.234D+03,0.380D+02,0.19812000D+01,0.00000000D+00
     .,0.61553170D+03,0.234D+03,0.390D+02,0.19812000D+01,0.00000000D+00
     .,0.55720710D+03,0.234D+03,0.400D+02,0.19812000D+01,0.00000000D+00
     .,0.51054640D+03,0.234D+03,0.410D+02,0.19812000D+01,0.00000000D+00
     .,0.39746440D+03,0.234D+03,0.420D+02,0.19812000D+01,0.00000000D+00
     .,0.44207860D+03,0.234D+03,0.430D+02,0.19812000D+01,0.00000000D+00
     .,0.33981570D+03,0.234D+03,0.440D+02,0.19812000D+01,0.00000000D+00
     .,0.37122770D+03,0.234D+03,0.450D+02,0.19812000D+01,0.00000000D+00
     .,0.34521240D+03,0.234D+03,0.460D+02,0.19812000D+01,0.00000000D+00
     .,0.28750250D+03,0.234D+03,0.470D+02,0.19812000D+01,0.00000000D+00
     .,0.30524540D+03,0.234D+03,0.480D+02,0.19812000D+01,0.00000000D+00
     .,0.37968440D+03,0.234D+03,0.490D+02,0.19812000D+01,0.00000000D+00
     .,0.35506520D+03,0.234D+03,0.500D+02,0.19812000D+01,0.00000000D+00
     .,0.31993540D+03,0.234D+03,0.510D+02,0.19812000D+01,0.00000000D+00
     .,0.29881560D+03,0.234D+03,0.520D+02,0.19812000D+01,0.00000000D+00
     .,0.27205830D+03,0.234D+03,0.530D+02,0.19812000D+01,0.00000000D+00
     .,0.24614950D+03,0.234D+03,0.540D+02,0.19812000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 103801: 103900)=(/
     . 0.94314870D+03,0.234D+03,0.550D+02,0.19812000D+01,0.00000000D+00
     .,0.88280690D+03,0.234D+03,0.560D+02,0.19812000D+01,0.00000000D+00
     .,0.78440000D+03,0.234D+03,0.570D+02,0.19812000D+01,0.00000000D+00
     .,0.37731490D+03,0.234D+03,0.580D+02,0.19812000D+01,0.27991000D+01
     .,0.78497740D+03,0.234D+03,0.590D+02,0.19812000D+01,0.00000000D+00
     .,0.75507130D+03,0.234D+03,0.600D+02,0.19812000D+01,0.00000000D+00
     .,0.73648110D+03,0.234D+03,0.610D+02,0.19812000D+01,0.00000000D+00
     .,0.71934360D+03,0.234D+03,0.620D+02,0.19812000D+01,0.00000000D+00
     .,0.70416270D+03,0.234D+03,0.630D+02,0.19812000D+01,0.00000000D+00
     .,0.56098910D+03,0.234D+03,0.640D+02,0.19812000D+01,0.00000000D+00
     .,0.62074640D+03,0.234D+03,0.650D+02,0.19812000D+01,0.00000000D+00
     .,0.60005550D+03,0.234D+03,0.660D+02,0.19812000D+01,0.00000000D+00
     .,0.63681140D+03,0.234D+03,0.670D+02,0.19812000D+01,0.00000000D+00
     .,0.62345960D+03,0.234D+03,0.680D+02,0.19812000D+01,0.00000000D+00
     .,0.61152130D+03,0.234D+03,0.690D+02,0.19812000D+01,0.00000000D+00
     .,0.60402840D+03,0.234D+03,0.700D+02,0.19812000D+01,0.00000000D+00
     .,0.51348430D+03,0.234D+03,0.710D+02,0.19812000D+01,0.00000000D+00
     .,0.51090340D+03,0.234D+03,0.720D+02,0.19812000D+01,0.00000000D+00
     .,0.46953520D+03,0.234D+03,0.730D+02,0.19812000D+01,0.00000000D+00
     .,0.39880630D+03,0.234D+03,0.740D+02,0.19812000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 103901: 104000)=(/
     . 0.40670940D+03,0.234D+03,0.750D+02,0.19812000D+01,0.00000000D+00
     .,0.37075460D+03,0.234D+03,0.760D+02,0.19812000D+01,0.00000000D+00
     .,0.34112450D+03,0.234D+03,0.770D+02,0.19812000D+01,0.00000000D+00
     .,0.28477860D+03,0.234D+03,0.780D+02,0.19812000D+01,0.00000000D+00
     .,0.26655850D+03,0.234D+03,0.790D+02,0.19812000D+01,0.00000000D+00
     .,0.27475930D+03,0.234D+03,0.800D+02,0.19812000D+01,0.00000000D+00
     .,0.39114380D+03,0.234D+03,0.810D+02,0.19812000D+01,0.00000000D+00
     .,0.38562000D+03,0.234D+03,0.820D+02,0.19812000D+01,0.00000000D+00
     .,0.35778450D+03,0.234D+03,0.830D+02,0.19812000D+01,0.00000000D+00
     .,0.34316660D+03,0.234D+03,0.840D+02,0.19812000D+01,0.00000000D+00
     .,0.31880970D+03,0.234D+03,0.850D+02,0.19812000D+01,0.00000000D+00
     .,0.29392920D+03,0.234D+03,0.860D+02,0.19812000D+01,0.00000000D+00
     .,0.89872340D+03,0.234D+03,0.870D+02,0.19812000D+01,0.00000000D+00
     .,0.87826560D+03,0.234D+03,0.880D+02,0.19812000D+01,0.00000000D+00
     .,0.78418190D+03,0.234D+03,0.890D+02,0.19812000D+01,0.00000000D+00
     .,0.71316020D+03,0.234D+03,0.900D+02,0.19812000D+01,0.00000000D+00
     .,0.70403150D+03,0.234D+03,0.910D+02,0.19812000D+01,0.00000000D+00
     .,0.68185240D+03,0.234D+03,0.920D+02,0.19812000D+01,0.00000000D+00
     .,0.69668950D+03,0.234D+03,0.930D+02,0.19812000D+01,0.00000000D+00
     .,0.67555290D+03,0.234D+03,0.940D+02,0.19812000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 104001: 104100)=(/
     . 0.39896700D+02,0.234D+03,0.101D+03,0.19812000D+01,0.00000000D+00
     .,0.12448680D+03,0.234D+03,0.103D+03,0.19812000D+01,0.98650000D+00
     .,0.15970990D+03,0.234D+03,0.104D+03,0.19812000D+01,0.98080000D+00
     .,0.12488450D+03,0.234D+03,0.105D+03,0.19812000D+01,0.97060000D+00
     .,0.95355300D+02,0.234D+03,0.106D+03,0.19812000D+01,0.98680000D+00
     .,0.67193600D+02,0.234D+03,0.107D+03,0.19812000D+01,0.99440000D+00
     .,0.49429100D+02,0.234D+03,0.108D+03,0.19812000D+01,0.99250000D+00
     .,0.34372900D+02,0.234D+03,0.109D+03,0.19812000D+01,0.99820000D+00
     .,0.18104870D+03,0.234D+03,0.111D+03,0.19812000D+01,0.96840000D+00
     .,0.27950350D+03,0.234D+03,0.112D+03,0.19812000D+01,0.96280000D+00
     .,0.28658090D+03,0.234D+03,0.113D+03,0.19812000D+01,0.96480000D+00
     .,0.23450660D+03,0.234D+03,0.114D+03,0.19812000D+01,0.95070000D+00
     .,0.19460170D+03,0.234D+03,0.115D+03,0.19812000D+01,0.99470000D+00
     .,0.16599750D+03,0.234D+03,0.116D+03,0.19812000D+01,0.99480000D+00
     .,0.13686440D+03,0.234D+03,0.117D+03,0.19812000D+01,0.99720000D+00
     .,0.25244980D+03,0.234D+03,0.119D+03,0.19812000D+01,0.97670000D+00
     .,0.46788320D+03,0.234D+03,0.120D+03,0.19812000D+01,0.98310000D+00
     .,0.25604740D+03,0.234D+03,0.121D+03,0.19812000D+01,0.18627000D+01
     .,0.24734020D+03,0.234D+03,0.122D+03,0.19812000D+01,0.18299000D+01
     .,0.24231110D+03,0.234D+03,0.123D+03,0.19812000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters( 104101: 104200)=(/
     . 0.23963570D+03,0.234D+03,0.124D+03,0.19812000D+01,0.18269000D+01
     .,0.22229610D+03,0.234D+03,0.125D+03,0.19812000D+01,0.16406000D+01
     .,0.20623670D+03,0.234D+03,0.126D+03,0.19812000D+01,0.16483000D+01
     .,0.19674030D+03,0.234D+03,0.127D+03,0.19812000D+01,0.17149000D+01
     .,0.19219700D+03,0.234D+03,0.128D+03,0.19812000D+01,0.17937000D+01
     .,0.18865600D+03,0.234D+03,0.129D+03,0.19812000D+01,0.95760000D+00
     .,0.17907470D+03,0.234D+03,0.130D+03,0.19812000D+01,0.19419000D+01
     .,0.28616240D+03,0.234D+03,0.131D+03,0.19812000D+01,0.96010000D+00
     .,0.25488570D+03,0.234D+03,0.132D+03,0.19812000D+01,0.94340000D+00
     .,0.23075580D+03,0.234D+03,0.133D+03,0.19812000D+01,0.98890000D+00
     .,0.21214750D+03,0.234D+03,0.134D+03,0.19812000D+01,0.99010000D+00
     .,0.18822630D+03,0.234D+03,0.135D+03,0.19812000D+01,0.99740000D+00
     .,0.30225300D+03,0.234D+03,0.137D+03,0.19812000D+01,0.97380000D+00
     .,0.56874160D+03,0.234D+03,0.138D+03,0.19812000D+01,0.98010000D+00
     .,0.44473220D+03,0.234D+03,0.139D+03,0.19812000D+01,0.19153000D+01
     .,0.33846100D+03,0.234D+03,0.140D+03,0.19812000D+01,0.19355000D+01
     .,0.34164920D+03,0.234D+03,0.141D+03,0.19812000D+01,0.19545000D+01
     .,0.31953400D+03,0.234D+03,0.142D+03,0.19812000D+01,0.19420000D+01
     .,0.35457680D+03,0.234D+03,0.143D+03,0.19812000D+01,0.16682000D+01
     .,0.28063740D+03,0.234D+03,0.144D+03,0.19812000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters( 104201: 104300)=(/
     . 0.26272550D+03,0.234D+03,0.145D+03,0.19812000D+01,0.19003000D+01
     .,0.24429540D+03,0.234D+03,0.146D+03,0.19812000D+01,0.18630000D+01
     .,0.23598710D+03,0.234D+03,0.147D+03,0.19812000D+01,0.96790000D+00
     .,0.23484700D+03,0.234D+03,0.148D+03,0.19812000D+01,0.19539000D+01
     .,0.36336970D+03,0.234D+03,0.149D+03,0.19812000D+01,0.96330000D+00
     .,0.33258250D+03,0.234D+03,0.150D+03,0.19812000D+01,0.95140000D+00
     .,0.31402340D+03,0.234D+03,0.151D+03,0.19812000D+01,0.97490000D+00
     .,0.29872470D+03,0.234D+03,0.152D+03,0.19812000D+01,0.98110000D+00
     .,0.27458620D+03,0.234D+03,0.153D+03,0.19812000D+01,0.99680000D+00
     .,0.36080530D+03,0.234D+03,0.155D+03,0.19812000D+01,0.99090000D+00
     .,0.73458650D+03,0.234D+03,0.156D+03,0.19812000D+01,0.97970000D+00
     .,0.56200060D+03,0.234D+03,0.157D+03,0.19812000D+01,0.19373000D+01
     .,0.36616290D+03,0.234D+03,0.159D+03,0.19812000D+01,0.29425000D+01
     .,0.35862210D+03,0.234D+03,0.160D+03,0.19812000D+01,0.29455000D+01
     .,0.34744280D+03,0.234D+03,0.161D+03,0.19812000D+01,0.29413000D+01
     .,0.34859290D+03,0.234D+03,0.162D+03,0.19812000D+01,0.29300000D+01
     .,0.33417340D+03,0.234D+03,0.163D+03,0.19812000D+01,0.18286000D+01
     .,0.35060320D+03,0.234D+03,0.164D+03,0.19812000D+01,0.28732000D+01
     .,0.32973370D+03,0.234D+03,0.165D+03,0.19812000D+01,0.29086000D+01
     .,0.33455220D+03,0.234D+03,0.166D+03,0.19812000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters( 104301: 104400)=(/
     . 0.31341130D+03,0.234D+03,0.167D+03,0.19812000D+01,0.29242000D+01
     .,0.30463840D+03,0.234D+03,0.168D+03,0.19812000D+01,0.29282000D+01
     .,0.30255580D+03,0.234D+03,0.169D+03,0.19812000D+01,0.29246000D+01
     .,0.31727860D+03,0.234D+03,0.170D+03,0.19812000D+01,0.28482000D+01
     .,0.29267680D+03,0.234D+03,0.171D+03,0.19812000D+01,0.29219000D+01
     .,0.38927450D+03,0.234D+03,0.172D+03,0.19812000D+01,0.19254000D+01
     .,0.36365250D+03,0.234D+03,0.173D+03,0.19812000D+01,0.19459000D+01
     .,0.33401770D+03,0.234D+03,0.174D+03,0.19812000D+01,0.19292000D+01
     .,0.33595050D+03,0.234D+03,0.175D+03,0.19812000D+01,0.18104000D+01
     .,0.29862210D+03,0.234D+03,0.176D+03,0.19812000D+01,0.18858000D+01
     .,0.28153260D+03,0.234D+03,0.177D+03,0.19812000D+01,0.18648000D+01
     .,0.26922650D+03,0.234D+03,0.178D+03,0.19812000D+01,0.19188000D+01
     .,0.25729480D+03,0.234D+03,0.179D+03,0.19812000D+01,0.98460000D+00
     .,0.24994700D+03,0.234D+03,0.180D+03,0.19812000D+01,0.19896000D+01
     .,0.39112750D+03,0.234D+03,0.181D+03,0.19812000D+01,0.92670000D+00
     .,0.36046170D+03,0.234D+03,0.182D+03,0.19812000D+01,0.93830000D+00
     .,0.35169120D+03,0.234D+03,0.183D+03,0.19812000D+01,0.98200000D+00
     .,0.34355060D+03,0.234D+03,0.184D+03,0.19812000D+01,0.98150000D+00
     .,0.32270510D+03,0.234D+03,0.185D+03,0.19812000D+01,0.99540000D+00
     .,0.40664340D+03,0.234D+03,0.187D+03,0.19812000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters( 104401: 104500)=(/
     . 0.73595700D+03,0.234D+03,0.188D+03,0.19812000D+01,0.96620000D+00
     .,0.43316650D+03,0.234D+03,0.189D+03,0.19812000D+01,0.29070000D+01
     .,0.49533320D+03,0.234D+03,0.190D+03,0.19812000D+01,0.28844000D+01
     .,0.44442440D+03,0.234D+03,0.191D+03,0.19812000D+01,0.28738000D+01
     .,0.39550150D+03,0.234D+03,0.192D+03,0.19812000D+01,0.28878000D+01
     .,0.38118140D+03,0.234D+03,0.193D+03,0.19812000D+01,0.29095000D+01
     .,0.44946340D+03,0.234D+03,0.194D+03,0.19812000D+01,0.19209000D+01
     .,0.10680860D+03,0.234D+03,0.204D+03,0.19812000D+01,0.19697000D+01
     .,0.10541670D+03,0.234D+03,0.205D+03,0.19812000D+01,0.19441000D+01
     .,0.78317700D+02,0.234D+03,0.206D+03,0.19812000D+01,0.19985000D+01
     .,0.63154900D+02,0.234D+03,0.207D+03,0.19812000D+01,0.20143000D+01
     .,0.43702200D+02,0.234D+03,0.208D+03,0.19812000D+01,0.19887000D+01
     .,0.18715040D+03,0.234D+03,0.212D+03,0.19812000D+01,0.19496000D+01
     .,0.22592450D+03,0.234D+03,0.213D+03,0.19812000D+01,0.19311000D+01
     .,0.21868530D+03,0.234D+03,0.214D+03,0.19812000D+01,0.19435000D+01
     .,0.19178480D+03,0.234D+03,0.215D+03,0.19812000D+01,0.20102000D+01
     .,0.16266590D+03,0.234D+03,0.216D+03,0.19812000D+01,0.19903000D+01
     .,0.26236130D+03,0.234D+03,0.220D+03,0.19812000D+01,0.19349000D+01
     .,0.25392720D+03,0.234D+03,0.221D+03,0.19812000D+01,0.28999000D+01
     .,0.25718410D+03,0.234D+03,0.222D+03,0.19812000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters( 104501: 104600)=(/
     . 0.23527290D+03,0.234D+03,0.223D+03,0.19812000D+01,0.29110000D+01
     .,0.17915590D+03,0.234D+03,0.224D+03,0.19812000D+01,0.10619100D+02
     .,0.15430230D+03,0.234D+03,0.225D+03,0.19812000D+01,0.98849000D+01
     .,0.15132020D+03,0.234D+03,0.226D+03,0.19812000D+01,0.91376000D+01
     .,0.17548260D+03,0.234D+03,0.227D+03,0.19812000D+01,0.29263000D+01
     .,0.16398640D+03,0.234D+03,0.228D+03,0.19812000D+01,0.65458000D+01
     .,0.22956900D+03,0.234D+03,0.231D+03,0.19812000D+01,0.19315000D+01
     .,0.24320020D+03,0.234D+03,0.232D+03,0.19812000D+01,0.19447000D+01
     .,0.22498180D+03,0.234D+03,0.233D+03,0.19812000D+01,0.19793000D+01
     .,0.21052310D+03,0.234D+03,0.234D+03,0.19812000D+01,0.19812000D+01
     .,0.36860600D+02,0.238D+03,0.100D+01,0.19143000D+01,0.91180000D+00
     .,0.23840100D+02,0.238D+03,0.200D+01,0.19143000D+01,0.00000000D+00
     .,0.62823990D+03,0.238D+03,0.300D+01,0.19143000D+01,0.00000000D+00
     .,0.34816900D+03,0.238D+03,0.400D+01,0.19143000D+01,0.00000000D+00
     .,0.22895120D+03,0.238D+03,0.500D+01,0.19143000D+01,0.00000000D+00
     .,0.15197450D+03,0.238D+03,0.600D+01,0.19143000D+01,0.00000000D+00
     .,0.10490040D+03,0.238D+03,0.700D+01,0.19143000D+01,0.00000000D+00
     .,0.78693300D+02,0.238D+03,0.800D+01,0.19143000D+01,0.00000000D+00
     .,0.59141500D+02,0.238D+03,0.900D+01,0.19143000D+01,0.00000000D+00
     .,0.45194100D+02,0.238D+03,0.100D+02,0.19143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 104601: 104700)=(/
     . 0.74930050D+03,0.238D+03,0.110D+02,0.19143000D+01,0.00000000D+00
     .,0.55878190D+03,0.238D+03,0.120D+02,0.19143000D+01,0.00000000D+00
     .,0.50880610D+03,0.238D+03,0.130D+02,0.19143000D+01,0.00000000D+00
     .,0.39434550D+03,0.238D+03,0.140D+02,0.19143000D+01,0.00000000D+00
     .,0.30325210D+03,0.238D+03,0.150D+02,0.19143000D+01,0.00000000D+00
     .,0.24942670D+03,0.238D+03,0.160D+02,0.19143000D+01,0.00000000D+00
     .,0.20199970D+03,0.238D+03,0.170D+02,0.19143000D+01,0.00000000D+00
     .,0.16402750D+03,0.238D+03,0.180D+02,0.19143000D+01,0.00000000D+00
     .,0.12349320D+04,0.238D+03,0.190D+02,0.19143000D+01,0.00000000D+00
     .,0.99446760D+03,0.238D+03,0.200D+02,0.19143000D+01,0.00000000D+00
     .,0.81692750D+03,0.238D+03,0.210D+02,0.19143000D+01,0.00000000D+00
     .,0.78468860D+03,0.238D+03,0.220D+02,0.19143000D+01,0.00000000D+00
     .,0.71627780D+03,0.238D+03,0.230D+02,0.19143000D+01,0.00000000D+00
     .,0.56371140D+03,0.238D+03,0.240D+02,0.19143000D+01,0.00000000D+00
     .,0.61384180D+03,0.238D+03,0.250D+02,0.19143000D+01,0.00000000D+00
     .,0.48104470D+03,0.238D+03,0.260D+02,0.19143000D+01,0.00000000D+00
     .,0.50672720D+03,0.238D+03,0.270D+02,0.19143000D+01,0.00000000D+00
     .,0.52370020D+03,0.238D+03,0.280D+02,0.19143000D+01,0.00000000D+00
     .,0.40117140D+03,0.238D+03,0.290D+02,0.19143000D+01,0.00000000D+00
     .,0.40794990D+03,0.238D+03,0.300D+02,0.19143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 104701: 104800)=(/
     . 0.48488130D+03,0.238D+03,0.310D+02,0.19143000D+01,0.00000000D+00
     .,0.42218130D+03,0.238D+03,0.320D+02,0.19143000D+01,0.00000000D+00
     .,0.35593940D+03,0.238D+03,0.330D+02,0.19143000D+01,0.00000000D+00
     .,0.31709380D+03,0.238D+03,0.340D+02,0.19143000D+01,0.00000000D+00
     .,0.27544760D+03,0.238D+03,0.350D+02,0.19143000D+01,0.00000000D+00
     .,0.23792190D+03,0.238D+03,0.360D+02,0.19143000D+01,0.00000000D+00
     .,0.13808411D+04,0.238D+03,0.370D+02,0.19143000D+01,0.00000000D+00
     .,0.11858018D+04,0.238D+03,0.380D+02,0.19143000D+01,0.00000000D+00
     .,0.10282536D+04,0.238D+03,0.390D+02,0.19143000D+01,0.00000000D+00
     .,0.91823780D+03,0.238D+03,0.400D+02,0.19143000D+01,0.00000000D+00
     .,0.83371350D+03,0.238D+03,0.410D+02,0.19143000D+01,0.00000000D+00
     .,0.63877680D+03,0.238D+03,0.420D+02,0.19143000D+01,0.00000000D+00
     .,0.71471880D+03,0.238D+03,0.430D+02,0.19143000D+01,0.00000000D+00
     .,0.53996390D+03,0.238D+03,0.440D+02,0.19143000D+01,0.00000000D+00
     .,0.59037440D+03,0.238D+03,0.450D+02,0.19143000D+01,0.00000000D+00
     .,0.54597680D+03,0.238D+03,0.460D+02,0.19143000D+01,0.00000000D+00
     .,0.45572670D+03,0.238D+03,0.470D+02,0.19143000D+01,0.00000000D+00
     .,0.47937970D+03,0.238D+03,0.480D+02,0.19143000D+01,0.00000000D+00
     .,0.60681450D+03,0.238D+03,0.490D+02,0.19143000D+01,0.00000000D+00
     .,0.55532330D+03,0.238D+03,0.500D+02,0.19143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 104801: 104900)=(/
     . 0.48982280D+03,0.238D+03,0.510D+02,0.19143000D+01,0.00000000D+00
     .,0.45162950D+03,0.238D+03,0.520D+02,0.19143000D+01,0.00000000D+00
     .,0.40561580D+03,0.238D+03,0.530D+02,0.19143000D+01,0.00000000D+00
     .,0.36235560D+03,0.238D+03,0.540D+02,0.19143000D+01,0.00000000D+00
     .,0.16813249D+04,0.238D+03,0.550D+02,0.19143000D+01,0.00000000D+00
     .,0.15165369D+04,0.238D+03,0.560D+02,0.19143000D+01,0.00000000D+00
     .,0.13190312D+04,0.238D+03,0.570D+02,0.19143000D+01,0.00000000D+00
     .,0.57973570D+03,0.238D+03,0.580D+02,0.19143000D+01,0.27991000D+01
     .,0.13389789D+04,0.238D+03,0.590D+02,0.19143000D+01,0.00000000D+00
     .,0.12836521D+04,0.238D+03,0.600D+02,0.19143000D+01,0.00000000D+00
     .,0.12508766D+04,0.238D+03,0.610D+02,0.19143000D+01,0.00000000D+00
     .,0.12208006D+04,0.238D+03,0.620D+02,0.19143000D+01,0.00000000D+00
     .,0.11941104D+04,0.238D+03,0.630D+02,0.19143000D+01,0.00000000D+00
     .,0.92828660D+03,0.238D+03,0.640D+02,0.19143000D+01,0.00000000D+00
     .,0.10621534D+04,0.238D+03,0.650D+02,0.19143000D+01,0.00000000D+00
     .,0.10223708D+04,0.238D+03,0.660D+02,0.19143000D+01,0.00000000D+00
     .,0.10743220D+04,0.238D+03,0.670D+02,0.19143000D+01,0.00000000D+00
     .,0.10512437D+04,0.238D+03,0.680D+02,0.19143000D+01,0.00000000D+00
     .,0.10302928D+04,0.238D+03,0.690D+02,0.19143000D+01,0.00000000D+00
     .,0.10187310D+04,0.238D+03,0.700D+02,0.19143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 104901: 105000)=(/
     . 0.85160220D+03,0.238D+03,0.710D+02,0.19143000D+01,0.00000000D+00
     .,0.82898030D+03,0.238D+03,0.720D+02,0.19143000D+01,0.00000000D+00
     .,0.75166620D+03,0.238D+03,0.730D+02,0.19143000D+01,0.00000000D+00
     .,0.63136390D+03,0.238D+03,0.740D+02,0.19143000D+01,0.00000000D+00
     .,0.64074450D+03,0.238D+03,0.750D+02,0.19143000D+01,0.00000000D+00
     .,0.57745940D+03,0.238D+03,0.760D+02,0.19143000D+01,0.00000000D+00
     .,0.52643720D+03,0.238D+03,0.770D+02,0.19143000D+01,0.00000000D+00
     .,0.43510780D+03,0.238D+03,0.780D+02,0.19143000D+01,0.00000000D+00
     .,0.40568950D+03,0.238D+03,0.790D+02,0.19143000D+01,0.00000000D+00
     .,0.41649740D+03,0.238D+03,0.800D+02,0.19143000D+01,0.00000000D+00
     .,0.62114960D+03,0.238D+03,0.810D+02,0.19143000D+01,0.00000000D+00
     .,0.60248990D+03,0.238D+03,0.820D+02,0.19143000D+01,0.00000000D+00
     .,0.54855160D+03,0.238D+03,0.830D+02,0.19143000D+01,0.00000000D+00
     .,0.52038560D+03,0.238D+03,0.840D+02,0.19143000D+01,0.00000000D+00
     .,0.47718560D+03,0.238D+03,0.850D+02,0.19143000D+01,0.00000000D+00
     .,0.43481090D+03,0.238D+03,0.860D+02,0.19143000D+01,0.00000000D+00
     .,0.15749942D+04,0.238D+03,0.870D+02,0.19143000D+01,0.00000000D+00
     .,0.14917535D+04,0.238D+03,0.880D+02,0.19143000D+01,0.00000000D+00
     .,0.13062558D+04,0.238D+03,0.890D+02,0.19143000D+01,0.00000000D+00
     .,0.11610723D+04,0.238D+03,0.900D+02,0.19143000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 105001: 105100)=(/
     . 0.11587996D+04,0.238D+03,0.910D+02,0.19143000D+01,0.00000000D+00
     .,0.11217009D+04,0.238D+03,0.920D+02,0.19143000D+01,0.00000000D+00
     .,0.11626290D+04,0.238D+03,0.930D+02,0.19143000D+01,0.00000000D+00
     .,0.11245057D+04,0.238D+03,0.940D+02,0.19143000D+01,0.00000000D+00
     .,0.60189200D+02,0.238D+03,0.101D+03,0.19143000D+01,0.00000000D+00
     .,0.20169000D+03,0.238D+03,0.103D+03,0.19143000D+01,0.98650000D+00
     .,0.25612950D+03,0.238D+03,0.104D+03,0.19143000D+01,0.98080000D+00
     .,0.19164290D+03,0.238D+03,0.105D+03,0.19143000D+01,0.97060000D+00
     .,0.14261130D+03,0.238D+03,0.106D+03,0.19143000D+01,0.98680000D+00
     .,0.97808500D+02,0.238D+03,0.107D+03,0.19143000D+01,0.99440000D+00
     .,0.70428500D+02,0.238D+03,0.108D+03,0.19143000D+01,0.99250000D+00
     .,0.47741100D+02,0.238D+03,0.109D+03,0.19143000D+01,0.99820000D+00
     .,0.29600050D+03,0.238D+03,0.111D+03,0.19143000D+01,0.96840000D+00
     .,0.45880010D+03,0.238D+03,0.112D+03,0.19143000D+01,0.96280000D+00
     .,0.45973700D+03,0.238D+03,0.113D+03,0.19143000D+01,0.96480000D+00
     .,0.36358720D+03,0.238D+03,0.114D+03,0.19143000D+01,0.95070000D+00
     .,0.29421340D+03,0.238D+03,0.115D+03,0.19143000D+01,0.99470000D+00
     .,0.24672930D+03,0.238D+03,0.116D+03,0.19143000D+01,0.99480000D+00
     .,0.19993530D+03,0.238D+03,0.117D+03,0.19143000D+01,0.99720000D+00
     .,0.40435370D+03,0.238D+03,0.119D+03,0.19143000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters( 105101: 105200)=(/
     . 0.79454790D+03,0.238D+03,0.120D+03,0.19143000D+01,0.98310000D+00
     .,0.39932770D+03,0.238D+03,0.121D+03,0.19143000D+01,0.18627000D+01
     .,0.38527560D+03,0.238D+03,0.122D+03,0.19143000D+01,0.18299000D+01
     .,0.37765080D+03,0.238D+03,0.123D+03,0.19143000D+01,0.19138000D+01
     .,0.37474370D+03,0.238D+03,0.124D+03,0.19143000D+01,0.18269000D+01
     .,0.34218210D+03,0.238D+03,0.125D+03,0.19143000D+01,0.16406000D+01
     .,0.31593550D+03,0.238D+03,0.126D+03,0.19143000D+01,0.16483000D+01
     .,0.30136140D+03,0.238D+03,0.127D+03,0.19143000D+01,0.17149000D+01
     .,0.29480040D+03,0.238D+03,0.128D+03,0.19143000D+01,0.17937000D+01
     .,0.29297830D+03,0.238D+03,0.129D+03,0.19143000D+01,0.95760000D+00
     .,0.27198180D+03,0.238D+03,0.130D+03,0.19143000D+01,0.19419000D+01
     .,0.45391820D+03,0.238D+03,0.131D+03,0.19143000D+01,0.96010000D+00
     .,0.39376600D+03,0.238D+03,0.132D+03,0.19143000D+01,0.94340000D+00
     .,0.34965980D+03,0.238D+03,0.133D+03,0.19143000D+01,0.98890000D+00
     .,0.31724980D+03,0.238D+03,0.134D+03,0.19143000D+01,0.99010000D+00
     .,0.27746890D+03,0.238D+03,0.135D+03,0.19143000D+01,0.99740000D+00
     .,0.48106050D+03,0.238D+03,0.137D+03,0.19143000D+01,0.97380000D+00
     .,0.96807870D+03,0.238D+03,0.138D+03,0.19143000D+01,0.98010000D+00
     .,0.72518090D+03,0.238D+03,0.139D+03,0.19143000D+01,0.19153000D+01
     .,0.52865740D+03,0.238D+03,0.140D+03,0.19143000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters( 105201: 105300)=(/
     . 0.53402030D+03,0.238D+03,0.141D+03,0.19143000D+01,0.19545000D+01
     .,0.49651280D+03,0.238D+03,0.142D+03,0.19143000D+01,0.19420000D+01
     .,0.56243130D+03,0.238D+03,0.143D+03,0.19143000D+01,0.16682000D+01
     .,0.42953830D+03,0.238D+03,0.144D+03,0.19143000D+01,0.18584000D+01
     .,0.40150480D+03,0.238D+03,0.145D+03,0.19143000D+01,0.19003000D+01
     .,0.37226120D+03,0.238D+03,0.146D+03,0.19143000D+01,0.18630000D+01
     .,0.36048910D+03,0.238D+03,0.147D+03,0.19143000D+01,0.96790000D+00
     .,0.35460960D+03,0.238D+03,0.148D+03,0.19143000D+01,0.19539000D+01
     .,0.57628960D+03,0.238D+03,0.149D+03,0.19143000D+01,0.96330000D+00
     .,0.51576060D+03,0.238D+03,0.150D+03,0.19143000D+01,0.95140000D+00
     .,0.47938630D+03,0.238D+03,0.151D+03,0.19143000D+01,0.97490000D+00
     .,0.45112580D+03,0.238D+03,0.152D+03,0.19143000D+01,0.98110000D+00
     .,0.40947120D+03,0.238D+03,0.153D+03,0.19143000D+01,0.99680000D+00
     .,0.56434540D+03,0.238D+03,0.155D+03,0.19143000D+01,0.99090000D+00
     .,0.12601619D+04,0.238D+03,0.156D+03,0.19143000D+01,0.97970000D+00
     .,0.91944900D+03,0.238D+03,0.157D+03,0.19143000D+01,0.19373000D+01
     .,0.56190760D+03,0.238D+03,0.159D+03,0.19143000D+01,0.29425000D+01
     .,0.55022410D+03,0.238D+03,0.160D+03,0.19143000D+01,0.29455000D+01
     .,0.53249960D+03,0.238D+03,0.161D+03,0.19143000D+01,0.29413000D+01
     .,0.53594970D+03,0.238D+03,0.162D+03,0.19143000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters( 105301: 105400)=(/
     . 0.51922710D+03,0.238D+03,0.163D+03,0.19143000D+01,0.18286000D+01
     .,0.53962270D+03,0.238D+03,0.164D+03,0.19143000D+01,0.28732000D+01
     .,0.50614540D+03,0.238D+03,0.165D+03,0.19143000D+01,0.29086000D+01
     .,0.51646990D+03,0.238D+03,0.166D+03,0.19143000D+01,0.28965000D+01
     .,0.47978110D+03,0.238D+03,0.167D+03,0.19143000D+01,0.29242000D+01
     .,0.46587230D+03,0.238D+03,0.168D+03,0.19143000D+01,0.29282000D+01
     .,0.46307400D+03,0.238D+03,0.169D+03,0.19143000D+01,0.29246000D+01
     .,0.48786280D+03,0.238D+03,0.170D+03,0.19143000D+01,0.28482000D+01
     .,0.44725110D+03,0.238D+03,0.171D+03,0.19143000D+01,0.29219000D+01
     .,0.61717070D+03,0.238D+03,0.172D+03,0.19143000D+01,0.19254000D+01
     .,0.56919750D+03,0.238D+03,0.173D+03,0.19143000D+01,0.19459000D+01
     .,0.51595990D+03,0.238D+03,0.174D+03,0.19143000D+01,0.19292000D+01
     .,0.52505030D+03,0.238D+03,0.175D+03,0.19143000D+01,0.18104000D+01
     .,0.45276340D+03,0.238D+03,0.176D+03,0.19143000D+01,0.18858000D+01
     .,0.42495970D+03,0.238D+03,0.177D+03,0.19143000D+01,0.18648000D+01
     .,0.40531970D+03,0.238D+03,0.178D+03,0.19143000D+01,0.19188000D+01
     .,0.38754040D+03,0.238D+03,0.179D+03,0.19143000D+01,0.98460000D+00
     .,0.37247490D+03,0.238D+03,0.180D+03,0.19143000D+01,0.19896000D+01
     .,0.61741750D+03,0.238D+03,0.181D+03,0.19143000D+01,0.92670000D+00
     .,0.55680680D+03,0.238D+03,0.182D+03,0.19143000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters( 105401: 105500)=(/
     . 0.53692140D+03,0.238D+03,0.183D+03,0.19143000D+01,0.98200000D+00
     .,0.52008520D+03,0.238D+03,0.184D+03,0.19143000D+01,0.98150000D+00
     .,0.48293520D+03,0.238D+03,0.185D+03,0.19143000D+01,0.99540000D+00
     .,0.63518450D+03,0.238D+03,0.187D+03,0.19143000D+01,0.97050000D+00
     .,0.12452372D+04,0.238D+03,0.188D+03,0.19143000D+01,0.96620000D+00
     .,0.66511670D+03,0.238D+03,0.189D+03,0.19143000D+01,0.29070000D+01
     .,0.77484830D+03,0.238D+03,0.190D+03,0.19143000D+01,0.28844000D+01
     .,0.69052460D+03,0.238D+03,0.191D+03,0.19143000D+01,0.28738000D+01
     .,0.60568150D+03,0.238D+03,0.192D+03,0.19143000D+01,0.28878000D+01
     .,0.58187050D+03,0.238D+03,0.193D+03,0.19143000D+01,0.29095000D+01
     .,0.71381570D+03,0.238D+03,0.194D+03,0.19143000D+01,0.19209000D+01
     .,0.16346210D+03,0.238D+03,0.204D+03,0.19143000D+01,0.19697000D+01
     .,0.16010980D+03,0.238D+03,0.205D+03,0.19143000D+01,0.19441000D+01
     .,0.11541070D+03,0.238D+03,0.206D+03,0.19143000D+01,0.19985000D+01
     .,0.91672500D+02,0.238D+03,0.207D+03,0.19143000D+01,0.20143000D+01
     .,0.61915900D+02,0.238D+03,0.208D+03,0.19143000D+01,0.19887000D+01
     .,0.29291740D+03,0.238D+03,0.212D+03,0.19143000D+01,0.19496000D+01
     .,0.35455260D+03,0.238D+03,0.213D+03,0.19143000D+01,0.19311000D+01
     .,0.33737570D+03,0.238D+03,0.214D+03,0.19143000D+01,0.19435000D+01
     .,0.29047610D+03,0.238D+03,0.215D+03,0.19143000D+01,0.20102000D+01
     ./)
      grimme_c6_parameters( 105501: 105600)=(/
     . 0.24169490D+03,0.238D+03,0.216D+03,0.19143000D+01,0.19903000D+01
     .,0.41078570D+03,0.238D+03,0.220D+03,0.19143000D+01,0.19349000D+01
     .,0.39219670D+03,0.238D+03,0.221D+03,0.19143000D+01,0.28999000D+01
     .,0.39682160D+03,0.238D+03,0.222D+03,0.19143000D+01,0.38675000D+01
     .,0.36331250D+03,0.238D+03,0.223D+03,0.19143000D+01,0.29110000D+01
     .,0.27075430D+03,0.238D+03,0.224D+03,0.19143000D+01,0.10619100D+02
     .,0.23012310D+03,0.238D+03,0.225D+03,0.19143000D+01,0.98849000D+01
     .,0.22605370D+03,0.238D+03,0.226D+03,0.19143000D+01,0.91376000D+01
     .,0.26782340D+03,0.238D+03,0.227D+03,0.19143000D+01,0.29263000D+01
     .,0.24873790D+03,0.238D+03,0.228D+03,0.19143000D+01,0.65458000D+01
     .,0.35556210D+03,0.238D+03,0.231D+03,0.19143000D+01,0.19315000D+01
     .,0.37409750D+03,0.238D+03,0.232D+03,0.19143000D+01,0.19447000D+01
     .,0.34006880D+03,0.238D+03,0.233D+03,0.19143000D+01,0.19793000D+01
     .,0.31469330D+03,0.238D+03,0.234D+03,0.19143000D+01,0.19812000D+01
     .,0.49174480D+03,0.238D+03,0.238D+03,0.19143000D+01,0.19143000D+01
     .,0.36054300D+02,0.239D+03,0.100D+01,0.28903000D+01,0.91180000D+00
     .,0.23646200D+02,0.239D+03,0.200D+01,0.28903000D+01,0.00000000D+00
     .,0.56732020D+03,0.239D+03,0.300D+01,0.28903000D+01,0.00000000D+00
     .,0.32691860D+03,0.239D+03,0.400D+01,0.28903000D+01,0.00000000D+00
     .,0.21933470D+03,0.239D+03,0.500D+01,0.28903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 105601: 105700)=(/
     . 0.14760490D+03,0.239D+03,0.600D+01,0.28903000D+01,0.00000000D+00
     .,0.10284790D+03,0.239D+03,0.700D+01,0.28903000D+01,0.00000000D+00
     .,0.77633500D+02,0.239D+03,0.800D+01,0.28903000D+01,0.00000000D+00
     .,0.58635900D+02,0.239D+03,0.900D+01,0.28903000D+01,0.00000000D+00
     .,0.44975300D+02,0.239D+03,0.100D+02,0.28903000D+01,0.00000000D+00
     .,0.67817260D+03,0.239D+03,0.110D+02,0.28903000D+01,0.00000000D+00
     .,0.52114300D+03,0.239D+03,0.120D+02,0.28903000D+01,0.00000000D+00
     .,0.47968840D+03,0.239D+03,0.130D+02,0.28903000D+01,0.00000000D+00
     .,0.37706390D+03,0.239D+03,0.140D+02,0.28903000D+01,0.00000000D+00
     .,0.29323240D+03,0.239D+03,0.150D+02,0.28903000D+01,0.00000000D+00
     .,0.24282560D+03,0.239D+03,0.160D+02,0.28903000D+01,0.00000000D+00
     .,0.19787960D+03,0.239D+03,0.170D+02,0.28903000D+01,0.00000000D+00
     .,0.16150560D+03,0.239D+03,0.180D+02,0.28903000D+01,0.00000000D+00
     .,0.11105426D+04,0.239D+03,0.190D+02,0.28903000D+01,0.00000000D+00
     .,0.91608550D+03,0.239D+03,0.200D+02,0.28903000D+01,0.00000000D+00
     .,0.75654430D+03,0.239D+03,0.210D+02,0.28903000D+01,0.00000000D+00
     .,0.73005840D+03,0.239D+03,0.220D+02,0.28903000D+01,0.00000000D+00
     .,0.66827290D+03,0.239D+03,0.230D+02,0.28903000D+01,0.00000000D+00
     .,0.52603240D+03,0.239D+03,0.240D+02,0.28903000D+01,0.00000000D+00
     .,0.57500600D+03,0.239D+03,0.250D+02,0.28903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 105701: 105800)=(/
     . 0.45091200D+03,0.239D+03,0.260D+02,0.28903000D+01,0.00000000D+00
     .,0.47789770D+03,0.239D+03,0.270D+02,0.28903000D+01,0.00000000D+00
     .,0.49251980D+03,0.239D+03,0.280D+02,0.28903000D+01,0.00000000D+00
     .,0.37723750D+03,0.239D+03,0.290D+02,0.28903000D+01,0.00000000D+00
     .,0.38708210D+03,0.239D+03,0.300D+02,0.28903000D+01,0.00000000D+00
     .,0.45890330D+03,0.239D+03,0.310D+02,0.28903000D+01,0.00000000D+00
     .,0.40396460D+03,0.239D+03,0.320D+02,0.28903000D+01,0.00000000D+00
     .,0.34379750D+03,0.239D+03,0.330D+02,0.28903000D+01,0.00000000D+00
     .,0.30797330D+03,0.239D+03,0.340D+02,0.28903000D+01,0.00000000D+00
     .,0.26898800D+03,0.239D+03,0.350D+02,0.28903000D+01,0.00000000D+00
     .,0.23345810D+03,0.239D+03,0.360D+02,0.28903000D+01,0.00000000D+00
     .,0.12441578D+04,0.239D+03,0.370D+02,0.28903000D+01,0.00000000D+00
     .,0.10912408D+04,0.239D+03,0.380D+02,0.28903000D+01,0.00000000D+00
     .,0.95501530D+03,0.239D+03,0.390D+02,0.28903000D+01,0.00000000D+00
     .,0.85765270D+03,0.239D+03,0.400D+02,0.28903000D+01,0.00000000D+00
     .,0.78153770D+03,0.239D+03,0.410D+02,0.28903000D+01,0.00000000D+00
     .,0.60242530D+03,0.239D+03,0.420D+02,0.28903000D+01,0.00000000D+00
     .,0.67255530D+03,0.239D+03,0.430D+02,0.28903000D+01,0.00000000D+00
     .,0.51147220D+03,0.239D+03,0.440D+02,0.28903000D+01,0.00000000D+00
     .,0.55934530D+03,0.239D+03,0.450D+02,0.28903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 105801: 105900)=(/
     . 0.51843740D+03,0.239D+03,0.460D+02,0.28903000D+01,0.00000000D+00
     .,0.43197050D+03,0.239D+03,0.470D+02,0.28903000D+01,0.00000000D+00
     .,0.45648750D+03,0.239D+03,0.480D+02,0.28903000D+01,0.00000000D+00
     .,0.57380210D+03,0.239D+03,0.490D+02,0.28903000D+01,0.00000000D+00
     .,0.52991860D+03,0.239D+03,0.500D+02,0.28903000D+01,0.00000000D+00
     .,0.47140640D+03,0.239D+03,0.510D+02,0.28903000D+01,0.00000000D+00
     .,0.43680220D+03,0.239D+03,0.520D+02,0.28903000D+01,0.00000000D+00
     .,0.39431850D+03,0.239D+03,0.530D+02,0.28903000D+01,0.00000000D+00
     .,0.35391780D+03,0.239D+03,0.540D+02,0.28903000D+01,0.00000000D+00
     .,0.15153755D+04,0.239D+03,0.550D+02,0.28903000D+01,0.00000000D+00
     .,0.13911764D+04,0.239D+03,0.560D+02,0.28903000D+01,0.00000000D+00
     .,0.12212152D+04,0.239D+03,0.570D+02,0.28903000D+01,0.00000000D+00
     .,0.55696970D+03,0.239D+03,0.580D+02,0.28903000D+01,0.27991000D+01
     .,0.12319890D+04,0.239D+03,0.590D+02,0.28903000D+01,0.00000000D+00
     .,0.11829141D+04,0.239D+03,0.600D+02,0.28903000D+01,0.00000000D+00
     .,0.11532166D+04,0.239D+03,0.610D+02,0.28903000D+01,0.00000000D+00
     .,0.11259127D+04,0.239D+03,0.620D+02,0.28903000D+01,0.00000000D+00
     .,0.11017008D+04,0.239D+03,0.630D+02,0.28903000D+01,0.00000000D+00
     .,0.86500110D+03,0.239D+03,0.640D+02,0.28903000D+01,0.00000000D+00
     .,0.97497080D+03,0.239D+03,0.650D+02,0.28903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 105901: 106000)=(/
     . 0.94011780D+03,0.239D+03,0.660D+02,0.28903000D+01,0.00000000D+00
     .,0.99351430D+03,0.239D+03,0.670D+02,0.28903000D+01,0.00000000D+00
     .,0.97243020D+03,0.239D+03,0.680D+02,0.28903000D+01,0.00000000D+00
     .,0.95340360D+03,0.239D+03,0.690D+02,0.28903000D+01,0.00000000D+00
     .,0.94232490D+03,0.239D+03,0.700D+02,0.28903000D+01,0.00000000D+00
     .,0.79310590D+03,0.239D+03,0.710D+02,0.28903000D+01,0.00000000D+00
     .,0.77930040D+03,0.239D+03,0.720D+02,0.28903000D+01,0.00000000D+00
     .,0.71047900D+03,0.239D+03,0.730D+02,0.28903000D+01,0.00000000D+00
     .,0.59913420D+03,0.239D+03,0.740D+02,0.28903000D+01,0.00000000D+00
     .,0.60936150D+03,0.239D+03,0.750D+02,0.28903000D+01,0.00000000D+00
     .,0.55168900D+03,0.239D+03,0.760D+02,0.28903000D+01,0.00000000D+00
     .,0.50477160D+03,0.239D+03,0.770D+02,0.28903000D+01,0.00000000D+00
     .,0.41866960D+03,0.239D+03,0.780D+02,0.28903000D+01,0.00000000D+00
     .,0.39091310D+03,0.239D+03,0.790D+02,0.28903000D+01,0.00000000D+00
     .,0.40209420D+03,0.239D+03,0.800D+02,0.28903000D+01,0.00000000D+00
     .,0.58845790D+03,0.239D+03,0.810D+02,0.28903000D+01,0.00000000D+00
     .,0.57489740D+03,0.239D+03,0.820D+02,0.28903000D+01,0.00000000D+00
     .,0.52748310D+03,0.239D+03,0.830D+02,0.28903000D+01,0.00000000D+00
     .,0.50256880D+03,0.239D+03,0.840D+02,0.28903000D+01,0.00000000D+00
     .,0.46316440D+03,0.239D+03,0.850D+02,0.28903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 106001: 106100)=(/
     . 0.42389390D+03,0.239D+03,0.860D+02,0.28903000D+01,0.00000000D+00
     .,0.14300247D+04,0.239D+03,0.870D+02,0.28903000D+01,0.00000000D+00
     .,0.13749340D+04,0.239D+03,0.880D+02,0.28903000D+01,0.00000000D+00
     .,0.12142860D+04,0.239D+03,0.890D+02,0.28903000D+01,0.00000000D+00
     .,0.10895911D+04,0.239D+03,0.900D+02,0.28903000D+01,0.00000000D+00
     .,0.10821909D+04,0.239D+03,0.910D+02,0.28903000D+01,0.00000000D+00
     .,0.10477793D+04,0.239D+03,0.920D+02,0.28903000D+01,0.00000000D+00
     .,0.10795998D+04,0.239D+03,0.930D+02,0.28903000D+01,0.00000000D+00
     .,0.10453553D+04,0.239D+03,0.940D+02,0.28903000D+01,0.00000000D+00
     .,0.58275500D+02,0.239D+03,0.101D+03,0.28903000D+01,0.00000000D+00
     .,0.18988940D+03,0.239D+03,0.103D+03,0.28903000D+01,0.98650000D+00
     .,0.24200800D+03,0.239D+03,0.104D+03,0.28903000D+01,0.98080000D+00
     .,0.18428470D+03,0.239D+03,0.105D+03,0.28903000D+01,0.97060000D+00
     .,0.13843530D+03,0.239D+03,0.106D+03,0.28903000D+01,0.98680000D+00
     .,0.95889700D+02,0.239D+03,0.107D+03,0.28903000D+01,0.99440000D+00
     .,0.69580600D+02,0.239D+03,0.108D+03,0.28903000D+01,0.99250000D+00
     .,0.47591400D+02,0.239D+03,0.109D+03,0.28903000D+01,0.99820000D+00
     .,0.27757010D+03,0.239D+03,0.111D+03,0.28903000D+01,0.96840000D+00
     .,0.42950590D+03,0.239D+03,0.112D+03,0.28903000D+01,0.96280000D+00
     .,0.43451020D+03,0.239D+03,0.113D+03,0.28903000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters( 106101: 106200)=(/
     . 0.34831620D+03,0.239D+03,0.114D+03,0.28903000D+01,0.95070000D+00
     .,0.28458190D+03,0.239D+03,0.115D+03,0.28903000D+01,0.99470000D+00
     .,0.24014930D+03,0.239D+03,0.116D+03,0.28903000D+01,0.99480000D+00
     .,0.19582670D+03,0.239D+03,0.117D+03,0.28903000D+01,0.99720000D+00
     .,0.38177780D+03,0.239D+03,0.119D+03,0.28903000D+01,0.97670000D+00
     .,0.73212430D+03,0.239D+03,0.120D+03,0.28903000D+01,0.98310000D+00
     .,0.38147190D+03,0.239D+03,0.121D+03,0.28903000D+01,0.18627000D+01
     .,0.36814810D+03,0.239D+03,0.122D+03,0.28903000D+01,0.18299000D+01
     .,0.36077080D+03,0.239D+03,0.123D+03,0.28903000D+01,0.19138000D+01
     .,0.35748370D+03,0.239D+03,0.124D+03,0.28903000D+01,0.18269000D+01
     .,0.32862230D+03,0.239D+03,0.125D+03,0.28903000D+01,0.16406000D+01
     .,0.30396440D+03,0.239D+03,0.126D+03,0.28903000D+01,0.16483000D+01
     .,0.28991370D+03,0.239D+03,0.127D+03,0.28903000D+01,0.17149000D+01
     .,0.28344240D+03,0.239D+03,0.128D+03,0.28903000D+01,0.17937000D+01
     .,0.28025690D+03,0.239D+03,0.129D+03,0.28903000D+01,0.95760000D+00
     .,0.26257350D+03,0.239D+03,0.130D+03,0.28903000D+01,0.19419000D+01
     .,0.43079250D+03,0.239D+03,0.131D+03,0.28903000D+01,0.96010000D+00
     .,0.37769300D+03,0.239D+03,0.132D+03,0.28903000D+01,0.94340000D+00
     .,0.33790570D+03,0.239D+03,0.133D+03,0.28903000D+01,0.98890000D+00
     .,0.30809200D+03,0.239D+03,0.134D+03,0.28903000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters( 106201: 106300)=(/
     . 0.27088100D+03,0.239D+03,0.135D+03,0.28903000D+01,0.99740000D+00
     .,0.45524600D+03,0.239D+03,0.137D+03,0.28903000D+01,0.97380000D+00
     .,0.89074400D+03,0.239D+03,0.138D+03,0.28903000D+01,0.98010000D+00
     .,0.67945910D+03,0.239D+03,0.139D+03,0.28903000D+01,0.19153000D+01
     .,0.50443250D+03,0.239D+03,0.140D+03,0.28903000D+01,0.19355000D+01
     .,0.50941810D+03,0.239D+03,0.141D+03,0.28903000D+01,0.19545000D+01
     .,0.47468070D+03,0.239D+03,0.142D+03,0.28903000D+01,0.19420000D+01
     .,0.53297190D+03,0.239D+03,0.143D+03,0.28903000D+01,0.16682000D+01
     .,0.41319030D+03,0.239D+03,0.144D+03,0.28903000D+01,0.18584000D+01
     .,0.38639150D+03,0.239D+03,0.145D+03,0.28903000D+01,0.19003000D+01
     .,0.35861330D+03,0.239D+03,0.146D+03,0.28903000D+01,0.18630000D+01
     .,0.34693600D+03,0.239D+03,0.147D+03,0.28903000D+01,0.96790000D+00
     .,0.34299870D+03,0.239D+03,0.148D+03,0.28903000D+01,0.19539000D+01
     .,0.54666900D+03,0.239D+03,0.149D+03,0.28903000D+01,0.96330000D+00
     .,0.49381290D+03,0.239D+03,0.150D+03,0.28903000D+01,0.95140000D+00
     .,0.46187660D+03,0.239D+03,0.151D+03,0.28903000D+01,0.97490000D+00
     .,0.43645200D+03,0.239D+03,0.152D+03,0.28903000D+01,0.98110000D+00
     .,0.39803820D+03,0.239D+03,0.153D+03,0.28903000D+01,0.99680000D+00
     .,0.53790930D+03,0.239D+03,0.155D+03,0.28903000D+01,0.99090000D+00
     .,0.11549423D+04,0.239D+03,0.156D+03,0.28903000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters( 106301: 106400)=(/
     . 0.86004650D+03,0.239D+03,0.157D+03,0.28903000D+01,0.19373000D+01
     .,0.54009920D+03,0.239D+03,0.159D+03,0.28903000D+01,0.29425000D+01
     .,0.52891450D+03,0.239D+03,0.160D+03,0.28903000D+01,0.29455000D+01
     .,0.51208670D+03,0.239D+03,0.161D+03,0.28903000D+01,0.29413000D+01
     .,0.51473080D+03,0.239D+03,0.162D+03,0.28903000D+01,0.29300000D+01
     .,0.49650390D+03,0.239D+03,0.163D+03,0.28903000D+01,0.18286000D+01
     .,0.51809120D+03,0.239D+03,0.164D+03,0.28903000D+01,0.28732000D+01
     .,0.48646500D+03,0.239D+03,0.165D+03,0.28903000D+01,0.29086000D+01
     .,0.49519130D+03,0.239D+03,0.166D+03,0.28903000D+01,0.28965000D+01
     .,0.46164810D+03,0.239D+03,0.167D+03,0.28903000D+01,0.29242000D+01
     .,0.44845310D+03,0.239D+03,0.168D+03,0.28903000D+01,0.29282000D+01
     .,0.44561860D+03,0.239D+03,0.169D+03,0.28903000D+01,0.29246000D+01
     .,0.46867840D+03,0.239D+03,0.170D+03,0.28903000D+01,0.28482000D+01
     .,0.43067940D+03,0.239D+03,0.171D+03,0.28903000D+01,0.29219000D+01
     .,0.58521160D+03,0.239D+03,0.172D+03,0.28903000D+01,0.19254000D+01
     .,0.54252680D+03,0.239D+03,0.173D+03,0.28903000D+01,0.19459000D+01
     .,0.49440990D+03,0.239D+03,0.174D+03,0.28903000D+01,0.19292000D+01
     .,0.50071270D+03,0.239D+03,0.175D+03,0.28903000D+01,0.18104000D+01
     .,0.43713590D+03,0.239D+03,0.176D+03,0.28903000D+01,0.18858000D+01
     .,0.41096170D+03,0.239D+03,0.177D+03,0.28903000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters( 106401: 106500)=(/
     . 0.39233860D+03,0.239D+03,0.178D+03,0.28903000D+01,0.19188000D+01
     .,0.37499560D+03,0.239D+03,0.179D+03,0.28903000D+01,0.98460000D+00
     .,0.36203330D+03,0.239D+03,0.180D+03,0.28903000D+01,0.19896000D+01
     .,0.58648270D+03,0.239D+03,0.181D+03,0.28903000D+01,0.92670000D+00
     .,0.53375820D+03,0.239D+03,0.182D+03,0.28903000D+01,0.93830000D+00
     .,0.51718370D+03,0.239D+03,0.183D+03,0.28903000D+01,0.98200000D+00
     .,0.50262410D+03,0.239D+03,0.184D+03,0.28903000D+01,0.98150000D+00
     .,0.46878500D+03,0.239D+03,0.185D+03,0.28903000D+01,0.99540000D+00
     .,0.60578760D+03,0.239D+03,0.187D+03,0.28903000D+01,0.97050000D+00
     .,0.11481563D+04,0.239D+03,0.188D+03,0.28903000D+01,0.96620000D+00
     .,0.63919770D+03,0.239D+03,0.189D+03,0.28903000D+01,0.29070000D+01
     .,0.73861040D+03,0.239D+03,0.190D+03,0.28903000D+01,0.28844000D+01
     .,0.65977710D+03,0.239D+03,0.191D+03,0.28903000D+01,0.28738000D+01
     .,0.58247220D+03,0.239D+03,0.192D+03,0.28903000D+01,0.28878000D+01
     .,0.56032370D+03,0.239D+03,0.193D+03,0.28903000D+01,0.29095000D+01
     .,0.67595320D+03,0.239D+03,0.194D+03,0.28903000D+01,0.19209000D+01
     .,0.15742770D+03,0.239D+03,0.204D+03,0.28903000D+01,0.19697000D+01
     .,0.15452800D+03,0.239D+03,0.205D+03,0.28903000D+01,0.19441000D+01
     .,0.11266800D+03,0.239D+03,0.206D+03,0.28903000D+01,0.19985000D+01
     .,0.89962600D+02,0.239D+03,0.207D+03,0.28903000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters( 106501: 106600)=(/
     . 0.61279600D+02,0.239D+03,0.208D+03,0.28903000D+01,0.19887000D+01
     .,0.27968340D+03,0.239D+03,0.212D+03,0.28903000D+01,0.19496000D+01
     .,0.33801530D+03,0.239D+03,0.213D+03,0.28903000D+01,0.19311000D+01
     .,0.32383050D+03,0.239D+03,0.214D+03,0.28903000D+01,0.19435000D+01
     .,0.28074710D+03,0.239D+03,0.215D+03,0.28903000D+01,0.20102000D+01
     .,0.23527170D+03,0.239D+03,0.216D+03,0.28903000D+01,0.19903000D+01
     .,0.39183600D+03,0.239D+03,0.220D+03,0.28903000D+01,0.19349000D+01
     .,0.37616230D+03,0.239D+03,0.221D+03,0.28903000D+01,0.28999000D+01
     .,0.38074190D+03,0.239D+03,0.222D+03,0.28903000D+01,0.38675000D+01
     .,0.34837280D+03,0.239D+03,0.223D+03,0.28903000D+01,0.29110000D+01
     .,0.26170420D+03,0.239D+03,0.224D+03,0.28903000D+01,0.10619100D+02
     .,0.22356370D+03,0.239D+03,0.225D+03,0.28903000D+01,0.98849000D+01
     .,0.21947140D+03,0.239D+03,0.226D+03,0.28903000D+01,0.91376000D+01
     .,0.25791900D+03,0.239D+03,0.227D+03,0.28903000D+01,0.29263000D+01
     .,0.24013260D+03,0.239D+03,0.228D+03,0.28903000D+01,0.65458000D+01
     .,0.34065350D+03,0.239D+03,0.231D+03,0.28903000D+01,0.19315000D+01
     .,0.35942740D+03,0.239D+03,0.232D+03,0.28903000D+01,0.19447000D+01
     .,0.32894310D+03,0.239D+03,0.233D+03,0.28903000D+01,0.19793000D+01
     .,0.30565080D+03,0.239D+03,0.234D+03,0.28903000D+01,0.19812000D+01
     .,0.46926390D+03,0.239D+03,0.238D+03,0.28903000D+01,0.19143000D+01
     ./)
      grimme_c6_parameters( 106601: 106700)=(/
     . 0.45108450D+03,0.239D+03,0.239D+03,0.28903000D+01,0.28903000D+01
     .,0.36540500D+02,0.240D+03,0.100D+01,0.39106000D+01,0.91180000D+00
     .,0.24088300D+02,0.240D+03,0.200D+01,0.39106000D+01,0.00000000D+00
     .,0.56215830D+03,0.240D+03,0.300D+01,0.39106000D+01,0.00000000D+00
     .,0.32721920D+03,0.240D+03,0.400D+01,0.39106000D+01,0.00000000D+00
     .,0.22083610D+03,0.240D+03,0.500D+01,0.39106000D+01,0.00000000D+00
     .,0.14926580D+03,0.240D+03,0.600D+01,0.39106000D+01,0.00000000D+00
     .,0.10433800D+03,0.240D+03,0.700D+01,0.39106000D+01,0.00000000D+00
     .,0.78933900D+02,0.240D+03,0.800D+01,0.39106000D+01,0.00000000D+00
     .,0.59729900D+02,0.240D+03,0.900D+01,0.39106000D+01,0.00000000D+00
     .,0.45882400D+02,0.240D+03,0.100D+02,0.39106000D+01,0.00000000D+00
     .,0.67243030D+03,0.240D+03,0.110D+02,0.39106000D+01,0.00000000D+00
     .,0.52068680D+03,0.240D+03,0.120D+02,0.39106000D+01,0.00000000D+00
     .,0.48073130D+03,0.240D+03,0.130D+02,0.39106000D+01,0.00000000D+00
     .,0.37942120D+03,0.240D+03,0.140D+02,0.39106000D+01,0.00000000D+00
     .,0.29608060D+03,0.240D+03,0.150D+02,0.39106000D+01,0.00000000D+00
     .,0.24572860D+03,0.240D+03,0.160D+02,0.39106000D+01,0.00000000D+00
     .,0.20066650D+03,0.240D+03,0.170D+02,0.39106000D+01,0.00000000D+00
     .,0.16407610D+03,0.240D+03,0.180D+02,0.39106000D+01,0.00000000D+00
     .,0.10998393D+04,0.240D+03,0.190D+02,0.39106000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 106701: 106800)=(/
     . 0.91252050D+03,0.240D+03,0.200D+02,0.39106000D+01,0.00000000D+00
     .,0.75461820D+03,0.240D+03,0.210D+02,0.39106000D+01,0.00000000D+00
     .,0.72916220D+03,0.240D+03,0.220D+02,0.39106000D+01,0.00000000D+00
     .,0.66796950D+03,0.240D+03,0.230D+02,0.39106000D+01,0.00000000D+00
     .,0.52595350D+03,0.240D+03,0.240D+02,0.39106000D+01,0.00000000D+00
     .,0.57539200D+03,0.240D+03,0.250D+02,0.39106000D+01,0.00000000D+00
     .,0.45141300D+03,0.240D+03,0.260D+02,0.39106000D+01,0.00000000D+00
     .,0.47910890D+03,0.240D+03,0.270D+02,0.39106000D+01,0.00000000D+00
     .,0.49336920D+03,0.240D+03,0.280D+02,0.39106000D+01,0.00000000D+00
     .,0.37799640D+03,0.240D+03,0.290D+02,0.39106000D+01,0.00000000D+00
     .,0.38872950D+03,0.240D+03,0.300D+02,0.39106000D+01,0.00000000D+00
     .,0.46049590D+03,0.240D+03,0.310D+02,0.39106000D+01,0.00000000D+00
     .,0.40661960D+03,0.240D+03,0.320D+02,0.39106000D+01,0.00000000D+00
     .,0.34703710D+03,0.240D+03,0.330D+02,0.39106000D+01,0.00000000D+00
     .,0.31142450D+03,0.240D+03,0.340D+02,0.39106000D+01,0.00000000D+00
     .,0.27249100D+03,0.240D+03,0.350D+02,0.39106000D+01,0.00000000D+00
     .,0.23688550D+03,0.240D+03,0.360D+02,0.39106000D+01,0.00000000D+00
     .,0.12329252D+04,0.240D+03,0.370D+02,0.39106000D+01,0.00000000D+00
     .,0.10868394D+04,0.240D+03,0.380D+02,0.39106000D+01,0.00000000D+00
     .,0.95348210D+03,0.240D+03,0.390D+02,0.39106000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 106801: 106900)=(/
     . 0.85760110D+03,0.240D+03,0.400D+02,0.39106000D+01,0.00000000D+00
     .,0.78230880D+03,0.240D+03,0.410D+02,0.39106000D+01,0.00000000D+00
     .,0.60414750D+03,0.240D+03,0.420D+02,0.39106000D+01,0.00000000D+00
     .,0.67400680D+03,0.240D+03,0.430D+02,0.39106000D+01,0.00000000D+00
     .,0.51361970D+03,0.240D+03,0.440D+02,0.39106000D+01,0.00000000D+00
     .,0.56161690D+03,0.240D+03,0.450D+02,0.39106000D+01,0.00000000D+00
     .,0.52087810D+03,0.240D+03,0.460D+02,0.39106000D+01,0.00000000D+00
     .,0.43392780D+03,0.240D+03,0.470D+02,0.39106000D+01,0.00000000D+00
     .,0.45901640D+03,0.240D+03,0.480D+02,0.39106000D+01,0.00000000D+00
     .,0.57580200D+03,0.240D+03,0.490D+02,0.39106000D+01,0.00000000D+00
     .,0.53307320D+03,0.240D+03,0.500D+02,0.39106000D+01,0.00000000D+00
     .,0.47538210D+03,0.240D+03,0.510D+02,0.39106000D+01,0.00000000D+00
     .,0.44115130D+03,0.240D+03,0.520D+02,0.39106000D+01,0.00000000D+00
     .,0.39888950D+03,0.240D+03,0.530D+02,0.39106000D+01,0.00000000D+00
     .,0.35856750D+03,0.240D+03,0.540D+02,0.39106000D+01,0.00000000D+00
     .,0.15020119D+04,0.240D+03,0.550D+02,0.39106000D+01,0.00000000D+00
     .,0.13846011D+04,0.240D+03,0.560D+02,0.39106000D+01,0.00000000D+00
     .,0.12183604D+04,0.240D+03,0.570D+02,0.39106000D+01,0.00000000D+00
     .,0.56144680D+03,0.240D+03,0.580D+02,0.39106000D+01,0.27991000D+01
     .,0.12271618D+04,0.240D+03,0.590D+02,0.39106000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 106901: 107000)=(/
     . 0.11787222D+04,0.240D+03,0.600D+02,0.39106000D+01,0.00000000D+00
     .,0.11492501D+04,0.240D+03,0.610D+02,0.39106000D+01,0.00000000D+00
     .,0.11221393D+04,0.240D+03,0.620D+02,0.39106000D+01,0.00000000D+00
     .,0.10981031D+04,0.240D+03,0.630D+02,0.39106000D+01,0.00000000D+00
     .,0.86458960D+03,0.240D+03,0.640D+02,0.39106000D+01,0.00000000D+00
     .,0.97085510D+03,0.240D+03,0.650D+02,0.39106000D+01,0.00000000D+00
     .,0.93659920D+03,0.240D+03,0.660D+02,0.39106000D+01,0.00000000D+00
     .,0.99084400D+03,0.240D+03,0.670D+02,0.39106000D+01,0.00000000D+00
     .,0.96987250D+03,0.240D+03,0.680D+02,0.39106000D+01,0.00000000D+00
     .,0.95097990D+03,0.240D+03,0.690D+02,0.39106000D+01,0.00000000D+00
     .,0.93981690D+03,0.240D+03,0.700D+02,0.39106000D+01,0.00000000D+00
     .,0.79250890D+03,0.240D+03,0.710D+02,0.39106000D+01,0.00000000D+00
     .,0.78062700D+03,0.240D+03,0.720D+02,0.39106000D+01,0.00000000D+00
     .,0.71279020D+03,0.240D+03,0.730D+02,0.39106000D+01,0.00000000D+00
     .,0.60188010D+03,0.240D+03,0.740D+02,0.39106000D+01,0.00000000D+00
     .,0.61249070D+03,0.240D+03,0.750D+02,0.39106000D+01,0.00000000D+00
     .,0.55526090D+03,0.240D+03,0.760D+02,0.39106000D+01,0.00000000D+00
     .,0.50858990D+03,0.240D+03,0.770D+02,0.39106000D+01,0.00000000D+00
     .,0.42235350D+03,0.240D+03,0.780D+02,0.39106000D+01,0.00000000D+00
     .,0.39454210D+03,0.240D+03,0.790D+02,0.39106000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 107001: 107100)=(/
     . 0.40600450D+03,0.240D+03,0.800D+02,0.39106000D+01,0.00000000D+00
     .,0.59097830D+03,0.240D+03,0.810D+02,0.39106000D+01,0.00000000D+00
     .,0.57841880D+03,0.240D+03,0.820D+02,0.39106000D+01,0.00000000D+00
     .,0.53186650D+03,0.240D+03,0.830D+02,0.39106000D+01,0.00000000D+00
     .,0.50739330D+03,0.240D+03,0.840D+02,0.39106000D+01,0.00000000D+00
     .,0.46832900D+03,0.240D+03,0.850D+02,0.39106000D+01,0.00000000D+00
     .,0.42922150D+03,0.240D+03,0.860D+02,0.39106000D+01,0.00000000D+00
     .,0.14201434D+04,0.240D+03,0.870D+02,0.39106000D+01,0.00000000D+00
     .,0.13701849D+04,0.240D+03,0.880D+02,0.39106000D+01,0.00000000D+00
     .,0.12127510D+04,0.240D+03,0.890D+02,0.39106000D+01,0.00000000D+00
     .,0.10910589D+04,0.240D+03,0.900D+02,0.39106000D+01,0.00000000D+00
     .,0.10823309D+04,0.240D+03,0.910D+02,0.39106000D+01,0.00000000D+00
     .,0.10479820D+04,0.240D+03,0.920D+02,0.39106000D+01,0.00000000D+00
     .,0.10780658D+04,0.240D+03,0.930D+02,0.39106000D+01,0.00000000D+00
     .,0.10441684D+04,0.240D+03,0.940D+02,0.39106000D+01,0.00000000D+00
     .,0.58862500D+02,0.240D+03,0.101D+03,0.39106000D+01,0.00000000D+00
     .,0.19022830D+03,0.240D+03,0.103D+03,0.39106000D+01,0.98650000D+00
     .,0.24272640D+03,0.240D+03,0.104D+03,0.39106000D+01,0.98080000D+00
     .,0.18577620D+03,0.240D+03,0.105D+03,0.39106000D+01,0.97060000D+00
     .,0.13998770D+03,0.240D+03,0.106D+03,0.39106000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters( 107101: 107200)=(/
     . 0.97288100D+02,0.240D+03,0.107D+03,0.39106000D+01,0.99440000D+00
     .,0.70786500D+02,0.240D+03,0.108D+03,0.39106000D+01,0.99250000D+00
     .,0.48576900D+02,0.240D+03,0.109D+03,0.39106000D+01,0.99820000D+00
     .,0.27779360D+03,0.240D+03,0.111D+03,0.39106000D+01,0.96840000D+00
     .,0.42964620D+03,0.240D+03,0.112D+03,0.39106000D+01,0.96280000D+00
     .,0.43578140D+03,0.240D+03,0.113D+03,0.39106000D+01,0.96480000D+00
     .,0.35070760D+03,0.240D+03,0.114D+03,0.39106000D+01,0.95070000D+00
     .,0.28738300D+03,0.240D+03,0.115D+03,0.39106000D+01,0.99470000D+00
     .,0.24300890D+03,0.240D+03,0.116D+03,0.39106000D+01,0.99480000D+00
     .,0.19857750D+03,0.240D+03,0.117D+03,0.39106000D+01,0.99720000D+00
     .,0.38302240D+03,0.240D+03,0.119D+03,0.39106000D+01,0.97670000D+00
     .,0.72962110D+03,0.240D+03,0.120D+03,0.39106000D+01,0.98310000D+00
     .,0.38386450D+03,0.240D+03,0.121D+03,0.39106000D+01,0.18627000D+01
     .,0.37051580D+03,0.240D+03,0.122D+03,0.39106000D+01,0.18299000D+01
     .,0.36307110D+03,0.240D+03,0.123D+03,0.39106000D+01,0.19138000D+01
     .,0.35962670D+03,0.240D+03,0.124D+03,0.39106000D+01,0.18269000D+01
     .,0.33118730D+03,0.240D+03,0.125D+03,0.39106000D+01,0.16406000D+01
     .,0.30651240D+03,0.240D+03,0.126D+03,0.39106000D+01,0.16483000D+01
     .,0.29235140D+03,0.240D+03,0.127D+03,0.39106000D+01,0.17149000D+01
     .,0.28578230D+03,0.240D+03,0.128D+03,0.39106000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters( 107201: 107300)=(/
     . 0.28217240D+03,0.240D+03,0.129D+03,0.39106000D+01,0.95760000D+00
     .,0.26504020D+03,0.240D+03,0.130D+03,0.39106000D+01,0.19419000D+01
     .,0.43263090D+03,0.240D+03,0.131D+03,0.39106000D+01,0.96010000D+00
     .,0.38045750D+03,0.240D+03,0.132D+03,0.39106000D+01,0.94340000D+00
     .,0.34114820D+03,0.240D+03,0.133D+03,0.39106000D+01,0.98890000D+00
     .,0.31153680D+03,0.240D+03,0.134D+03,0.39106000D+01,0.99010000D+00
     .,0.27438370D+03,0.240D+03,0.135D+03,0.39106000D+01,0.99740000D+00
     .,0.45707170D+03,0.240D+03,0.137D+03,0.39106000D+01,0.97380000D+00
     .,0.88748100D+03,0.240D+03,0.138D+03,0.39106000D+01,0.98010000D+00
     .,0.68026830D+03,0.240D+03,0.139D+03,0.39106000D+01,0.19153000D+01
     .,0.50752160D+03,0.240D+03,0.140D+03,0.39106000D+01,0.19355000D+01
     .,0.51249950D+03,0.240D+03,0.141D+03,0.39106000D+01,0.19545000D+01
     .,0.47788700D+03,0.240D+03,0.142D+03,0.39106000D+01,0.19420000D+01
     .,0.53531530D+03,0.240D+03,0.143D+03,0.39106000D+01,0.16682000D+01
     .,0.41671520D+03,0.240D+03,0.144D+03,0.39106000D+01,0.18584000D+01
     .,0.38976730D+03,0.240D+03,0.145D+03,0.39106000D+01,0.19003000D+01
     .,0.36187710D+03,0.240D+03,0.146D+03,0.39106000D+01,0.18630000D+01
     .,0.34999750D+03,0.240D+03,0.147D+03,0.39106000D+01,0.96790000D+00
     .,0.34647920D+03,0.240D+03,0.148D+03,0.39106000D+01,0.19539000D+01
     .,0.54905720D+03,0.240D+03,0.149D+03,0.39106000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters( 107301: 107400)=(/
     . 0.49724240D+03,0.240D+03,0.150D+03,0.39106000D+01,0.95140000D+00
     .,0.46592890D+03,0.240D+03,0.151D+03,0.39106000D+01,0.97490000D+00
     .,0.44083920D+03,0.240D+03,0.152D+03,0.39106000D+01,0.98110000D+00
     .,0.40264130D+03,0.240D+03,0.153D+03,0.39106000D+01,0.99680000D+00
     .,0.54112590D+03,0.240D+03,0.155D+03,0.39106000D+01,0.99090000D+00
     .,0.11497163D+04,0.240D+03,0.156D+03,0.39106000D+01,0.97970000D+00
     .,0.86075030D+03,0.240D+03,0.157D+03,0.39106000D+01,0.19373000D+01
     .,0.54452030D+03,0.240D+03,0.159D+03,0.39106000D+01,0.29425000D+01
     .,0.53325740D+03,0.240D+03,0.160D+03,0.39106000D+01,0.29455000D+01
     .,0.51635730D+03,0.240D+03,0.161D+03,0.39106000D+01,0.29413000D+01
     .,0.51883450D+03,0.240D+03,0.162D+03,0.39106000D+01,0.29300000D+01
     .,0.49986370D+03,0.240D+03,0.163D+03,0.39106000D+01,0.18286000D+01
     .,0.52215120D+03,0.240D+03,0.164D+03,0.39106000D+01,0.28732000D+01
     .,0.49043320D+03,0.240D+03,0.165D+03,0.39106000D+01,0.29086000D+01
     .,0.49890510D+03,0.240D+03,0.166D+03,0.39106000D+01,0.28965000D+01
     .,0.46555960D+03,0.240D+03,0.167D+03,0.39106000D+01,0.29242000D+01
     .,0.45230680D+03,0.240D+03,0.168D+03,0.39106000D+01,0.29282000D+01
     .,0.44940350D+03,0.240D+03,0.169D+03,0.39106000D+01,0.29246000D+01
     .,0.47239670D+03,0.240D+03,0.170D+03,0.39106000D+01,0.28482000D+01
     .,0.43441480D+03,0.240D+03,0.171D+03,0.39106000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters( 107401: 107500)=(/
     . 0.58778890D+03,0.240D+03,0.172D+03,0.39106000D+01,0.19254000D+01
     .,0.54572750D+03,0.240D+03,0.173D+03,0.39106000D+01,0.19459000D+01
     .,0.49809170D+03,0.240D+03,0.174D+03,0.39106000D+01,0.19292000D+01
     .,0.50376490D+03,0.240D+03,0.175D+03,0.39106000D+01,0.18104000D+01
     .,0.44135260D+03,0.240D+03,0.176D+03,0.39106000D+01,0.18858000D+01
     .,0.41515170D+03,0.240D+03,0.177D+03,0.39106000D+01,0.18648000D+01
     .,0.39646860D+03,0.240D+03,0.178D+03,0.39106000D+01,0.19188000D+01
     .,0.37893340D+03,0.240D+03,0.179D+03,0.39106000D+01,0.98460000D+00
     .,0.36628550D+03,0.240D+03,0.180D+03,0.39106000D+01,0.19896000D+01
     .,0.58938990D+03,0.240D+03,0.181D+03,0.39106000D+01,0.92670000D+00
     .,0.53773400D+03,0.240D+03,0.182D+03,0.39106000D+01,0.93830000D+00
     .,0.52173760D+03,0.240D+03,0.183D+03,0.39106000D+01,0.98200000D+00
     .,0.50754760D+03,0.240D+03,0.184D+03,0.39106000D+01,0.98150000D+00
     .,0.47401940D+03,0.240D+03,0.185D+03,0.39106000D+01,0.99540000D+00
     .,0.60950110D+03,0.240D+03,0.187D+03,0.39106000D+01,0.97050000D+00
     .,0.11447357D+04,0.240D+03,0.188D+03,0.39106000D+01,0.96620000D+00
     .,0.64438060D+03,0.240D+03,0.189D+03,0.39106000D+01,0.29070000D+01
     .,0.74302780D+03,0.240D+03,0.190D+03,0.39106000D+01,0.28844000D+01
     .,0.66426180D+03,0.240D+03,0.191D+03,0.39106000D+01,0.28738000D+01
     .,0.58740530D+03,0.240D+03,0.192D+03,0.39106000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters( 107501: 107600)=(/
     . 0.56528300D+03,0.240D+03,0.193D+03,0.39106000D+01,0.29095000D+01
     .,0.67885160D+03,0.240D+03,0.194D+03,0.39106000D+01,0.19209000D+01
     .,0.15874420D+03,0.240D+03,0.204D+03,0.39106000D+01,0.19697000D+01
     .,0.15597060D+03,0.240D+03,0.205D+03,0.39106000D+01,0.19441000D+01
     .,0.11413350D+03,0.240D+03,0.206D+03,0.39106000D+01,0.19985000D+01
     .,0.91307200D+02,0.240D+03,0.207D+03,0.39106000D+01,0.20143000D+01
     .,0.62389300D+02,0.240D+03,0.208D+03,0.39106000D+01,0.19887000D+01
     .,0.28129500D+03,0.240D+03,0.212D+03,0.39106000D+01,0.19496000D+01
     .,0.33986220D+03,0.240D+03,0.213D+03,0.39106000D+01,0.19311000D+01
     .,0.32624310D+03,0.240D+03,0.214D+03,0.39106000D+01,0.19435000D+01
     .,0.28345370D+03,0.240D+03,0.215D+03,0.39106000D+01,0.20102000D+01
     .,0.23808430D+03,0.240D+03,0.216D+03,0.39106000D+01,0.19903000D+01
     .,0.39411100D+03,0.240D+03,0.220D+03,0.39106000D+01,0.19349000D+01
     .,0.37893950D+03,0.240D+03,0.221D+03,0.39106000D+01,0.28999000D+01
     .,0.38359990D+03,0.240D+03,0.222D+03,0.39106000D+01,0.38675000D+01
     .,0.35096590D+03,0.240D+03,0.223D+03,0.39106000D+01,0.29110000D+01
     .,0.26433470D+03,0.240D+03,0.224D+03,0.39106000D+01,0.10619100D+02
     .,0.22616840D+03,0.240D+03,0.225D+03,0.39106000D+01,0.98849000D+01
     .,0.22198580D+03,0.240D+03,0.226D+03,0.39106000D+01,0.91376000D+01
     .,0.26021080D+03,0.240D+03,0.227D+03,0.39106000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters( 107601: 107700)=(/
     . 0.24244220D+03,0.240D+03,0.228D+03,0.39106000D+01,0.65458000D+01
     .,0.34305200D+03,0.240D+03,0.231D+03,0.39106000D+01,0.19315000D+01
     .,0.36224070D+03,0.240D+03,0.232D+03,0.39106000D+01,0.19447000D+01
     .,0.33219680D+03,0.240D+03,0.233D+03,0.39106000D+01,0.19793000D+01
     .,0.30908380D+03,0.240D+03,0.234D+03,0.39106000D+01,0.19812000D+01
     .,0.47210810D+03,0.240D+03,0.238D+03,0.39106000D+01,0.19143000D+01
     .,0.45473560D+03,0.240D+03,0.239D+03,0.39106000D+01,0.28903000D+01
     .,0.45868960D+03,0.240D+03,0.240D+03,0.39106000D+01,0.39106000D+01
     .,0.35315200D+02,0.241D+03,0.100D+01,0.29225000D+01,0.91180000D+00
     .,0.23359200D+02,0.241D+03,0.200D+01,0.29225000D+01,0.00000000D+00
     .,0.54961140D+03,0.241D+03,0.300D+01,0.29225000D+01,0.00000000D+00
     .,0.31671620D+03,0.241D+03,0.400D+01,0.29225000D+01,0.00000000D+00
     .,0.21337350D+03,0.241D+03,0.500D+01,0.29225000D+01,0.00000000D+00
     .,0.14425580D+03,0.241D+03,0.600D+01,0.29225000D+01,0.00000000D+00
     .,0.10094600D+03,0.241D+03,0.700D+01,0.29225000D+01,0.00000000D+00
     .,0.76465800D+02,0.241D+03,0.800D+01,0.29225000D+01,0.00000000D+00
     .,0.57946700D+02,0.241D+03,0.900D+01,0.29225000D+01,0.00000000D+00
     .,0.44577600D+02,0.241D+03,0.100D+02,0.29225000D+01,0.00000000D+00
     .,0.65711510D+03,0.241D+03,0.110D+02,0.29225000D+01,0.00000000D+00
     .,0.50467530D+03,0.241D+03,0.120D+02,0.29225000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 107701: 107800)=(/
     . 0.46522590D+03,0.241D+03,0.130D+02,0.29225000D+01,0.00000000D+00
     .,0.36661690D+03,0.241D+03,0.140D+02,0.29225000D+01,0.00000000D+00
     .,0.28599260D+03,0.241D+03,0.150D+02,0.29225000D+01,0.00000000D+00
     .,0.23744480D+03,0.241D+03,0.160D+02,0.29225000D+01,0.00000000D+00
     .,0.19403010D+03,0.241D+03,0.170D+02,0.29225000D+01,0.00000000D+00
     .,0.15879150D+03,0.241D+03,0.180D+02,0.29225000D+01,0.00000000D+00
     .,0.10788336D+04,0.241D+03,0.190D+02,0.29225000D+01,0.00000000D+00
     .,0.88761670D+03,0.241D+03,0.200D+02,0.29225000D+01,0.00000000D+00
     .,0.73301140D+03,0.241D+03,0.210D+02,0.29225000D+01,0.00000000D+00
     .,0.70781110D+03,0.241D+03,0.220D+02,0.29225000D+01,0.00000000D+00
     .,0.64811200D+03,0.241D+03,0.230D+02,0.29225000D+01,0.00000000D+00
     .,0.51073850D+03,0.241D+03,0.240D+02,0.29225000D+01,0.00000000D+00
     .,0.55795140D+03,0.241D+03,0.250D+02,0.29225000D+01,0.00000000D+00
     .,0.43806030D+03,0.241D+03,0.260D+02,0.29225000D+01,0.00000000D+00
     .,0.46406680D+03,0.241D+03,0.270D+02,0.29225000D+01,0.00000000D+00
     .,0.47803720D+03,0.241D+03,0.280D+02,0.29225000D+01,0.00000000D+00
     .,0.36666480D+03,0.241D+03,0.290D+02,0.29225000D+01,0.00000000D+00
     .,0.37623990D+03,0.241D+03,0.300D+02,0.29225000D+01,0.00000000D+00
     .,0.44572790D+03,0.241D+03,0.310D+02,0.29225000D+01,0.00000000D+00
     .,0.39303660D+03,0.241D+03,0.320D+02,0.29225000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 107801: 107900)=(/
     . 0.33529210D+03,0.241D+03,0.330D+02,0.29225000D+01,0.00000000D+00
     .,0.30092580D+03,0.241D+03,0.340D+02,0.29225000D+01,0.00000000D+00
     .,0.26340340D+03,0.241D+03,0.350D+02,0.29225000D+01,0.00000000D+00
     .,0.22911910D+03,0.241D+03,0.360D+02,0.29225000D+01,0.00000000D+00
     .,0.12092081D+04,0.241D+03,0.370D+02,0.29225000D+01,0.00000000D+00
     .,0.10578748D+04,0.241D+03,0.380D+02,0.29225000D+01,0.00000000D+00
     .,0.92614390D+03,0.241D+03,0.390D+02,0.29225000D+01,0.00000000D+00
     .,0.83217430D+03,0.241D+03,0.400D+02,0.29225000D+01,0.00000000D+00
     .,0.75877890D+03,0.241D+03,0.410D+02,0.29225000D+01,0.00000000D+00
     .,0.58581260D+03,0.241D+03,0.420D+02,0.29225000D+01,0.00000000D+00
     .,0.65360280D+03,0.241D+03,0.430D+02,0.29225000D+01,0.00000000D+00
     .,0.49792860D+03,0.241D+03,0.440D+02,0.29225000D+01,0.00000000D+00
     .,0.54408210D+03,0.241D+03,0.450D+02,0.29225000D+01,0.00000000D+00
     .,0.50450370D+03,0.241D+03,0.460D+02,0.29225000D+01,0.00000000D+00
     .,0.42085520D+03,0.241D+03,0.470D+02,0.29225000D+01,0.00000000D+00
     .,0.44449320D+03,0.241D+03,0.480D+02,0.29225000D+01,0.00000000D+00
     .,0.55793400D+03,0.241D+03,0.490D+02,0.29225000D+01,0.00000000D+00
     .,0.51573740D+03,0.241D+03,0.500D+02,0.29225000D+01,0.00000000D+00
     .,0.45957500D+03,0.241D+03,0.510D+02,0.29225000D+01,0.00000000D+00
     .,0.42642020D+03,0.241D+03,0.520D+02,0.29225000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 107901: 108000)=(/
     . 0.38559230D+03,0.241D+03,0.530D+02,0.29225000D+01,0.00000000D+00
     .,0.34670630D+03,0.241D+03,0.540D+02,0.29225000D+01,0.00000000D+00
     .,0.14737970D+04,0.241D+03,0.550D+02,0.29225000D+01,0.00000000D+00
     .,0.13493970D+04,0.241D+03,0.560D+02,0.29225000D+01,0.00000000D+00
     .,0.11846610D+04,0.241D+03,0.570D+02,0.29225000D+01,0.00000000D+00
     .,0.54305060D+03,0.241D+03,0.580D+02,0.29225000D+01,0.27991000D+01
     .,0.11952654D+04,0.241D+03,0.590D+02,0.29225000D+01,0.00000000D+00
     .,0.11474757D+04,0.241D+03,0.600D+02,0.29225000D+01,0.00000000D+00
     .,0.11186278D+04,0.241D+03,0.610D+02,0.29225000D+01,0.00000000D+00
     .,0.10921025D+04,0.241D+03,0.620D+02,0.29225000D+01,0.00000000D+00
     .,0.10685805D+04,0.241D+03,0.630D+02,0.29225000D+01,0.00000000D+00
     .,0.84000980D+03,0.241D+03,0.640D+02,0.29225000D+01,0.00000000D+00
     .,0.94732140D+03,0.241D+03,0.650D+02,0.29225000D+01,0.00000000D+00
     .,0.91363480D+03,0.241D+03,0.660D+02,0.29225000D+01,0.00000000D+00
     .,0.96355250D+03,0.241D+03,0.670D+02,0.29225000D+01,0.00000000D+00
     .,0.94306260D+03,0.241D+03,0.680D+02,0.29225000D+01,0.00000000D+00
     .,0.92458410D+03,0.241D+03,0.690D+02,0.29225000D+01,0.00000000D+00
     .,0.91377400D+03,0.241D+03,0.700D+02,0.29225000D+01,0.00000000D+00
     .,0.76978010D+03,0.241D+03,0.710D+02,0.29225000D+01,0.00000000D+00
     .,0.75663130D+03,0.241D+03,0.720D+02,0.29225000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 108001: 108100)=(/
     . 0.69039390D+03,0.241D+03,0.730D+02,0.29225000D+01,0.00000000D+00
     .,0.58308880D+03,0.241D+03,0.740D+02,0.29225000D+01,0.00000000D+00
     .,0.59308720D+03,0.241D+03,0.750D+02,0.29225000D+01,0.00000000D+00
     .,0.53746300D+03,0.241D+03,0.760D+02,0.29225000D+01,0.00000000D+00
     .,0.49219170D+03,0.241D+03,0.770D+02,0.29225000D+01,0.00000000D+00
     .,0.40891560D+03,0.241D+03,0.780D+02,0.29225000D+01,0.00000000D+00
     .,0.38205000D+03,0.241D+03,0.790D+02,0.29225000D+01,0.00000000D+00
     .,0.39294050D+03,0.241D+03,0.800D+02,0.29225000D+01,0.00000000D+00
     .,0.57302740D+03,0.241D+03,0.810D+02,0.29225000D+01,0.00000000D+00
     .,0.55997550D+03,0.241D+03,0.820D+02,0.29225000D+01,0.00000000D+00
     .,0.51444520D+03,0.241D+03,0.830D+02,0.29225000D+01,0.00000000D+00
     .,0.49063940D+03,0.241D+03,0.840D+02,0.29225000D+01,0.00000000D+00
     .,0.45281960D+03,0.241D+03,0.850D+02,0.29225000D+01,0.00000000D+00
     .,0.41506050D+03,0.241D+03,0.860D+02,0.29225000D+01,0.00000000D+00
     .,0.13904637D+04,0.241D+03,0.870D+02,0.29225000D+01,0.00000000D+00
     .,0.13339556D+04,0.241D+03,0.880D+02,0.29225000D+01,0.00000000D+00
     .,0.11782143D+04,0.241D+03,0.890D+02,0.29225000D+01,0.00000000D+00
     .,0.10582704D+04,0.241D+03,0.900D+02,0.29225000D+01,0.00000000D+00
     .,0.10511231D+04,0.241D+03,0.910D+02,0.29225000D+01,0.00000000D+00
     .,0.10177328D+04,0.241D+03,0.920D+02,0.29225000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 108101: 108200)=(/
     . 0.10481038D+04,0.241D+03,0.930D+02,0.29225000D+01,0.00000000D+00
     .,0.10148828D+04,0.241D+03,0.940D+02,0.29225000D+01,0.00000000D+00
     .,0.56846600D+02,0.241D+03,0.101D+03,0.29225000D+01,0.00000000D+00
     .,0.18412220D+03,0.241D+03,0.103D+03,0.29225000D+01,0.98650000D+00
     .,0.23495680D+03,0.241D+03,0.104D+03,0.29225000D+01,0.98080000D+00
     .,0.17952910D+03,0.241D+03,0.105D+03,0.29225000D+01,0.97060000D+00
     .,0.13534930D+03,0.241D+03,0.106D+03,0.29225000D+01,0.98680000D+00
     .,0.94163100D+02,0.241D+03,0.107D+03,0.29225000D+01,0.99440000D+00
     .,0.68608700D+02,0.241D+03,0.108D+03,0.29225000D+01,0.99250000D+00
     .,0.47194100D+02,0.241D+03,0.109D+03,0.29225000D+01,0.99820000D+00
     .,0.26917780D+03,0.241D+03,0.111D+03,0.29225000D+01,0.96840000D+00
     .,0.41641830D+03,0.241D+03,0.112D+03,0.29225000D+01,0.96280000D+00
     .,0.42164610D+03,0.241D+03,0.113D+03,0.29225000D+01,0.96480000D+00
     .,0.33887850D+03,0.241D+03,0.114D+03,0.29225000D+01,0.95070000D+00
     .,0.27761880D+03,0.241D+03,0.115D+03,0.29225000D+01,0.99470000D+00
     .,0.23483210D+03,0.241D+03,0.116D+03,0.29225000D+01,0.99480000D+00
     .,0.19201920D+03,0.241D+03,0.117D+03,0.29225000D+01,0.99720000D+00
     .,0.37144330D+03,0.241D+03,0.119D+03,0.29225000D+01,0.97670000D+00
     .,0.71075730D+03,0.241D+03,0.120D+03,0.29225000D+01,0.98310000D+00
     .,0.37132440D+03,0.241D+03,0.121D+03,0.29225000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters( 108201: 108300)=(/
     . 0.35852320D+03,0.241D+03,0.122D+03,0.29225000D+01,0.18299000D+01
     .,0.35134710D+03,0.241D+03,0.123D+03,0.29225000D+01,0.19138000D+01
     .,0.34810210D+03,0.241D+03,0.124D+03,0.29225000D+01,0.18269000D+01
     .,0.32022560D+03,0.241D+03,0.125D+03,0.29225000D+01,0.16406000D+01
     .,0.29637490D+03,0.241D+03,0.126D+03,0.29225000D+01,0.16483000D+01
     .,0.28273960D+03,0.241D+03,0.127D+03,0.29225000D+01,0.17149000D+01
     .,0.27641130D+03,0.241D+03,0.128D+03,0.29225000D+01,0.17937000D+01
     .,0.27310650D+03,0.241D+03,0.129D+03,0.29225000D+01,0.95760000D+00
     .,0.25621710D+03,0.241D+03,0.130D+03,0.29225000D+01,0.19419000D+01
     .,0.41862090D+03,0.241D+03,0.131D+03,0.29225000D+01,0.96010000D+00
     .,0.36771370D+03,0.241D+03,0.132D+03,0.29225000D+01,0.94340000D+00
     .,0.32961390D+03,0.241D+03,0.133D+03,0.29225000D+01,0.98890000D+00
     .,0.30104260D+03,0.241D+03,0.134D+03,0.29225000D+01,0.99010000D+00
     .,0.26523400D+03,0.241D+03,0.135D+03,0.29225000D+01,0.99740000D+00
     .,0.44326820D+03,0.241D+03,0.137D+03,0.29225000D+01,0.97380000D+00
     .,0.86524620D+03,0.241D+03,0.138D+03,0.29225000D+01,0.98010000D+00
     .,0.66073770D+03,0.241D+03,0.139D+03,0.29225000D+01,0.19153000D+01
     .,0.49130810D+03,0.241D+03,0.140D+03,0.29225000D+01,0.19355000D+01
     .,0.49611270D+03,0.241D+03,0.141D+03,0.29225000D+01,0.19545000D+01
     .,0.46265460D+03,0.241D+03,0.142D+03,0.29225000D+01,0.19420000D+01
     ./)
      grimme_c6_parameters( 108301: 108400)=(/
     . 0.51908450D+03,0.241D+03,0.143D+03,0.29225000D+01,0.16682000D+01
     .,0.40320320D+03,0.241D+03,0.144D+03,0.29225000D+01,0.18584000D+01
     .,0.37722490D+03,0.241D+03,0.145D+03,0.29225000D+01,0.19003000D+01
     .,0.35029100D+03,0.241D+03,0.146D+03,0.29225000D+01,0.18630000D+01
     .,0.33883350D+03,0.241D+03,0.147D+03,0.29225000D+01,0.96790000D+00
     .,0.33513120D+03,0.241D+03,0.148D+03,0.29225000D+01,0.19539000D+01
     .,0.53177200D+03,0.241D+03,0.149D+03,0.29225000D+01,0.96330000D+00
     .,0.48095640D+03,0.241D+03,0.150D+03,0.29225000D+01,0.95140000D+00
     .,0.45041590D+03,0.241D+03,0.151D+03,0.29225000D+01,0.97490000D+00
     .,0.42611180D+03,0.241D+03,0.152D+03,0.29225000D+01,0.98110000D+00
     .,0.38921120D+03,0.241D+03,0.153D+03,0.29225000D+01,0.99680000D+00
     .,0.52415620D+03,0.241D+03,0.155D+03,0.29225000D+01,0.99090000D+00
     .,0.11227672D+04,0.241D+03,0.156D+03,0.29225000D+01,0.97970000D+00
     .,0.83655040D+03,0.241D+03,0.157D+03,0.29225000D+01,0.19373000D+01
     .,0.52667590D+03,0.241D+03,0.159D+03,0.29225000D+01,0.29425000D+01
     .,0.51577970D+03,0.241D+03,0.160D+03,0.29225000D+01,0.29455000D+01
     .,0.49943430D+03,0.241D+03,0.161D+03,0.29225000D+01,0.29413000D+01
     .,0.50191700D+03,0.241D+03,0.162D+03,0.29225000D+01,0.29300000D+01
     .,0.48385420D+03,0.241D+03,0.163D+03,0.29225000D+01,0.18286000D+01
     .,0.50506200D+03,0.241D+03,0.164D+03,0.29225000D+01,0.28732000D+01
     ./)
      grimme_c6_parameters( 108401: 108500)=(/
     . 0.47436130D+03,0.241D+03,0.165D+03,0.29225000D+01,0.29086000D+01
     .,0.48273800D+03,0.241D+03,0.166D+03,0.29225000D+01,0.28965000D+01
     .,0.45024130D+03,0.241D+03,0.167D+03,0.29225000D+01,0.29242000D+01
     .,0.43740790D+03,0.241D+03,0.168D+03,0.29225000D+01,0.29282000D+01
     .,0.43460070D+03,0.241D+03,0.169D+03,0.29225000D+01,0.29246000D+01
     .,0.45679920D+03,0.241D+03,0.170D+03,0.29225000D+01,0.28482000D+01
     .,0.42006140D+03,0.241D+03,0.171D+03,0.29225000D+01,0.29219000D+01
     .,0.56959350D+03,0.241D+03,0.172D+03,0.29225000D+01,0.19254000D+01
     .,0.52852650D+03,0.241D+03,0.173D+03,0.29225000D+01,0.19459000D+01
     .,0.48214800D+03,0.241D+03,0.174D+03,0.29225000D+01,0.19292000D+01
     .,0.48793610D+03,0.241D+03,0.175D+03,0.29225000D+01,0.18104000D+01
     .,0.42697730D+03,0.241D+03,0.176D+03,0.29225000D+01,0.18858000D+01
     .,0.40168310D+03,0.241D+03,0.177D+03,0.29225000D+01,0.18648000D+01
     .,0.38365960D+03,0.241D+03,0.178D+03,0.29225000D+01,0.19188000D+01
     .,0.36680700D+03,0.241D+03,0.179D+03,0.29225000D+01,0.98460000D+00
     .,0.35437800D+03,0.241D+03,0.180D+03,0.29225000D+01,0.19896000D+01
     .,0.57113440D+03,0.241D+03,0.181D+03,0.29225000D+01,0.92670000D+00
     .,0.52034420D+03,0.241D+03,0.182D+03,0.29225000D+01,0.93830000D+00
     .,0.50456970D+03,0.241D+03,0.183D+03,0.29225000D+01,0.98200000D+00
     .,0.49075210D+03,0.241D+03,0.184D+03,0.29225000D+01,0.98150000D+00
     ./)
      grimme_c6_parameters( 108501: 108600)=(/
     . 0.45830100D+03,0.241D+03,0.185D+03,0.29225000D+01,0.99540000D+00
     .,0.59030800D+03,0.241D+03,0.187D+03,0.29225000D+01,0.97050000D+00
     .,0.11160377D+04,0.241D+03,0.188D+03,0.29225000D+01,0.96620000D+00
     .,0.62320270D+03,0.241D+03,0.189D+03,0.29225000D+01,0.29070000D+01
     .,0.71978040D+03,0.241D+03,0.190D+03,0.29225000D+01,0.28844000D+01
     .,0.64370980D+03,0.241D+03,0.191D+03,0.29225000D+01,0.28738000D+01
     .,0.56841140D+03,0.241D+03,0.192D+03,0.29225000D+01,0.28878000D+01
     .,0.54692870D+03,0.241D+03,0.193D+03,0.29225000D+01,0.29095000D+01
     .,0.65859550D+03,0.241D+03,0.194D+03,0.29225000D+01,0.19209000D+01
     .,0.15329480D+03,0.241D+03,0.204D+03,0.29225000D+01,0.19697000D+01
     .,0.15076980D+03,0.241D+03,0.205D+03,0.29225000D+01,0.19441000D+01
     .,0.11036390D+03,0.241D+03,0.206D+03,0.29225000D+01,0.19985000D+01
     .,0.88394400D+02,0.241D+03,0.207D+03,0.29225000D+01,0.20143000D+01
     .,0.60521700D+02,0.241D+03,0.208D+03,0.29225000D+01,0.19887000D+01
     .,0.27178760D+03,0.241D+03,0.212D+03,0.29225000D+01,0.19496000D+01
     .,0.32857270D+03,0.241D+03,0.213D+03,0.29225000D+01,0.19311000D+01
     .,0.31520730D+03,0.241D+03,0.214D+03,0.29225000D+01,0.19435000D+01
     .,0.27386490D+03,0.241D+03,0.215D+03,0.29225000D+01,0.20102000D+01
     .,0.23008710D+03,0.241D+03,0.216D+03,0.29225000D+01,0.19903000D+01
     .,0.38125920D+03,0.241D+03,0.220D+03,0.29225000D+01,0.19349000D+01
     ./)
      grimme_c6_parameters( 108601: 108700)=(/
     . 0.36637160D+03,0.241D+03,0.221D+03,0.29225000D+01,0.28999000D+01
     .,0.37088000D+03,0.241D+03,0.222D+03,0.29225000D+01,0.38675000D+01
     .,0.33949100D+03,0.241D+03,0.223D+03,0.29225000D+01,0.29110000D+01
     .,0.25576580D+03,0.241D+03,0.224D+03,0.29225000D+01,0.10619100D+02
     .,0.21884580D+03,0.241D+03,0.225D+03,0.29225000D+01,0.98849000D+01
     .,0.21480530D+03,0.241D+03,0.226D+03,0.29225000D+01,0.91376000D+01
     .,0.25178560D+03,0.241D+03,0.227D+03,0.29225000D+01,0.29263000D+01
     .,0.23455580D+03,0.241D+03,0.228D+03,0.29225000D+01,0.65458000D+01
     .,0.33167180D+03,0.241D+03,0.231D+03,0.29225000D+01,0.19315000D+01
     .,0.35008010D+03,0.241D+03,0.232D+03,0.29225000D+01,0.19447000D+01
     .,0.32096670D+03,0.241D+03,0.233D+03,0.29225000D+01,0.19793000D+01
     .,0.29868080D+03,0.241D+03,0.234D+03,0.29225000D+01,0.19812000D+01
     .,0.45688220D+03,0.241D+03,0.238D+03,0.29225000D+01,0.19143000D+01
     .,0.43965480D+03,0.241D+03,0.239D+03,0.29225000D+01,0.28903000D+01
     .,0.44341820D+03,0.241D+03,0.240D+03,0.29225000D+01,0.39106000D+01
     .,0.42889620D+03,0.241D+03,0.241D+03,0.29225000D+01,0.29225000D+01
     .,0.31668100D+02,0.242D+03,0.100D+01,0.11055600D+02,0.91180000D+00
     .,0.21351600D+02,0.242D+03,0.200D+01,0.11055600D+02,0.00000000D+00
     .,0.46157510D+03,0.242D+03,0.300D+01,0.11055600D+02,0.00000000D+00
     .,0.27354460D+03,0.242D+03,0.400D+01,0.11055600D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 108701: 108800)=(/
     . 0.18746660D+03,0.242D+03,0.500D+01,0.11055600D+02,0.00000000D+00
     .,0.12849780D+03,0.242D+03,0.600D+01,0.11055600D+02,0.00000000D+00
     .,0.90904300D+02,0.242D+03,0.700D+01,0.11055600D+02,0.00000000D+00
     .,0.69418100D+02,0.242D+03,0.800D+01,0.11055600D+02,0.00000000D+00
     .,0.52984500D+02,0.242D+03,0.900D+01,0.11055600D+02,0.00000000D+00
     .,0.41003500D+02,0.242D+03,0.100D+02,0.11055600D+02,0.00000000D+00
     .,0.55303570D+03,0.242D+03,0.110D+02,0.11055600D+02,0.00000000D+00
     .,0.43382780D+03,0.242D+03,0.120D+02,0.11055600D+02,0.00000000D+00
     .,0.40329140D+03,0.242D+03,0.130D+02,0.11055600D+02,0.00000000D+00
     .,0.32151630D+03,0.242D+03,0.140D+02,0.11055600D+02,0.00000000D+00
     .,0.25341230D+03,0.242D+03,0.150D+02,0.11055600D+02,0.00000000D+00
     .,0.21190690D+03,0.242D+03,0.160D+02,0.11055600D+02,0.00000000D+00
     .,0.17439200D+03,0.242D+03,0.170D+02,0.11055600D+02,0.00000000D+00
     .,0.14363890D+03,0.242D+03,0.180D+02,0.11055600D+02,0.00000000D+00
     .,0.90508480D+03,0.242D+03,0.190D+02,0.11055600D+02,0.00000000D+00
     .,0.75708580D+03,0.242D+03,0.200D+02,0.11055600D+02,0.00000000D+00
     .,0.62755600D+03,0.242D+03,0.210D+02,0.11055600D+02,0.00000000D+00
     .,0.60830000D+03,0.242D+03,0.220D+02,0.11055600D+02,0.00000000D+00
     .,0.55823240D+03,0.242D+03,0.230D+02,0.11055600D+02,0.00000000D+00
     .,0.44055160D+03,0.242D+03,0.240D+02,0.11055600D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 108801: 108900)=(/
     . 0.48213620D+03,0.242D+03,0.250D+02,0.11055600D+02,0.00000000D+00
     .,0.37926880D+03,0.242D+03,0.260D+02,0.11055600D+02,0.00000000D+00
     .,0.40314840D+03,0.242D+03,0.270D+02,0.11055600D+02,0.00000000D+00
     .,0.41431560D+03,0.242D+03,0.280D+02,0.11055600D+02,0.00000000D+00
     .,0.31832390D+03,0.242D+03,0.290D+02,0.11055600D+02,0.00000000D+00
     .,0.32847070D+03,0.242D+03,0.300D+02,0.11055600D+02,0.00000000D+00
     .,0.38804460D+03,0.242D+03,0.310D+02,0.11055600D+02,0.00000000D+00
     .,0.34515780D+03,0.242D+03,0.320D+02,0.11055600D+02,0.00000000D+00
     .,0.29691650D+03,0.242D+03,0.330D+02,0.11055600D+02,0.00000000D+00
     .,0.26796230D+03,0.242D+03,0.340D+02,0.11055600D+02,0.00000000D+00
     .,0.23592640D+03,0.242D+03,0.350D+02,0.11055600D+02,0.00000000D+00
     .,0.20636370D+03,0.242D+03,0.360D+02,0.11055600D+02,0.00000000D+00
     .,0.10163718D+04,0.242D+03,0.370D+02,0.11055600D+02,0.00000000D+00
     .,0.90210970D+03,0.242D+03,0.380D+02,0.11055600D+02,0.00000000D+00
     .,0.79517640D+03,0.242D+03,0.390D+02,0.11055600D+02,0.00000000D+00
     .,0.71766320D+03,0.242D+03,0.400D+02,0.11055600D+02,0.00000000D+00
     .,0.65637740D+03,0.242D+03,0.410D+02,0.11055600D+02,0.00000000D+00
     .,0.50974240D+03,0.242D+03,0.420D+02,0.11055600D+02,0.00000000D+00
     .,0.56744410D+03,0.242D+03,0.430D+02,0.11055600D+02,0.00000000D+00
     .,0.43508880D+03,0.242D+03,0.440D+02,0.11055600D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 108901: 109000)=(/
     . 0.47502730D+03,0.242D+03,0.450D+02,0.11055600D+02,0.00000000D+00
     .,0.44133190D+03,0.242D+03,0.460D+02,0.11055600D+02,0.00000000D+00
     .,0.36828980D+03,0.242D+03,0.470D+02,0.11055600D+02,0.00000000D+00
     .,0.38983000D+03,0.242D+03,0.480D+02,0.11055600D+02,0.00000000D+00
     .,0.48621160D+03,0.242D+03,0.490D+02,0.11055600D+02,0.00000000D+00
     .,0.45246160D+03,0.242D+03,0.500D+02,0.11055600D+02,0.00000000D+00
     .,0.40603120D+03,0.242D+03,0.510D+02,0.11055600D+02,0.00000000D+00
     .,0.37843120D+03,0.242D+03,0.520D+02,0.11055600D+02,0.00000000D+00
     .,0.34390960D+03,0.242D+03,0.530D+02,0.11055600D+02,0.00000000D+00
     .,0.31074420D+03,0.242D+03,0.540D+02,0.11055600D+02,0.00000000D+00
     .,0.12391934D+04,0.242D+03,0.550D+02,0.11055600D+02,0.00000000D+00
     .,0.11485106D+04,0.242D+03,0.560D+02,0.11055600D+02,0.00000000D+00
     .,0.10151154D+04,0.242D+03,0.570D+02,0.11055600D+02,0.00000000D+00
     .,0.47942470D+03,0.242D+03,0.580D+02,0.11055600D+02,0.27991000D+01
     .,0.10198084D+04,0.242D+03,0.590D+02,0.11055600D+02,0.00000000D+00
     .,0.98014620D+03,0.242D+03,0.600D+02,0.11055600D+02,0.00000000D+00
     .,0.95578910D+03,0.242D+03,0.610D+02,0.11055600D+02,0.00000000D+00
     .,0.93335430D+03,0.242D+03,0.620D+02,0.11055600D+02,0.00000000D+00
     .,0.91346790D+03,0.242D+03,0.630D+02,0.11055600D+02,0.00000000D+00
     .,0.72393420D+03,0.242D+03,0.640D+02,0.11055600D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 109001: 109100)=(/
     . 0.80773280D+03,0.242D+03,0.650D+02,0.11055600D+02,0.00000000D+00
     .,0.77996820D+03,0.242D+03,0.660D+02,0.11055600D+02,0.00000000D+00
     .,0.82502430D+03,0.242D+03,0.670D+02,0.11055600D+02,0.00000000D+00
     .,0.80759920D+03,0.242D+03,0.680D+02,0.11055600D+02,0.00000000D+00
     .,0.79196020D+03,0.242D+03,0.690D+02,0.11055600D+02,0.00000000D+00
     .,0.78241790D+03,0.242D+03,0.700D+02,0.11055600D+02,0.00000000D+00
     .,0.66269770D+03,0.242D+03,0.710D+02,0.11055600D+02,0.00000000D+00
     .,0.65575410D+03,0.242D+03,0.720D+02,0.11055600D+02,0.00000000D+00
     .,0.60105960D+03,0.242D+03,0.730D+02,0.11055600D+02,0.00000000D+00
     .,0.50981570D+03,0.242D+03,0.740D+02,0.11055600D+02,0.00000000D+00
     .,0.51931350D+03,0.242D+03,0.750D+02,0.11055600D+02,0.00000000D+00
     .,0.47249570D+03,0.242D+03,0.760D+02,0.11055600D+02,0.00000000D+00
     .,0.43413160D+03,0.242D+03,0.770D+02,0.11055600D+02,0.00000000D+00
     .,0.36221680D+03,0.242D+03,0.780D+02,0.11055600D+02,0.00000000D+00
     .,0.33898810D+03,0.242D+03,0.790D+02,0.11055600D+02,0.00000000D+00
     .,0.34897520D+03,0.242D+03,0.800D+02,0.11055600D+02,0.00000000D+00
     .,0.50083330D+03,0.242D+03,0.810D+02,0.11055600D+02,0.00000000D+00
     .,0.49181440D+03,0.242D+03,0.820D+02,0.11055600D+02,0.00000000D+00
     .,0.45457810D+03,0.242D+03,0.830D+02,0.11055600D+02,0.00000000D+00
     .,0.43514050D+03,0.242D+03,0.840D+02,0.11055600D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 109101: 109200)=(/
     . 0.40344890D+03,0.242D+03,0.850D+02,0.11055600D+02,0.00000000D+00
     .,0.37142770D+03,0.242D+03,0.860D+02,0.11055600D+02,0.00000000D+00
     .,0.11758873D+04,0.242D+03,0.870D+02,0.11055600D+02,0.00000000D+00
     .,0.11395556D+04,0.242D+03,0.880D+02,0.11055600D+02,0.00000000D+00
     .,0.10127341D+04,0.242D+03,0.890D+02,0.11055600D+02,0.00000000D+00
     .,0.91652630D+03,0.242D+03,0.900D+02,0.11055600D+02,0.00000000D+00
     .,0.90743040D+03,0.242D+03,0.910D+02,0.11055600D+02,0.00000000D+00
     .,0.87883040D+03,0.242D+03,0.920D+02,0.11055600D+02,0.00000000D+00
     .,0.90104700D+03,0.242D+03,0.930D+02,0.11055600D+02,0.00000000D+00
     .,0.87318690D+03,0.242D+03,0.940D+02,0.11055600D+02,0.00000000D+00
     .,0.50417300D+02,0.242D+03,0.101D+03,0.11055600D+02,0.00000000D+00
     .,0.15944040D+03,0.242D+03,0.103D+03,0.11055600D+02,0.98650000D+00
     .,0.20415190D+03,0.242D+03,0.104D+03,0.11055600D+02,0.98080000D+00
     .,0.15835630D+03,0.242D+03,0.105D+03,0.11055600D+02,0.97060000D+00
     .,0.12059460D+03,0.242D+03,0.106D+03,0.11055600D+02,0.98680000D+00
     .,0.84858200D+02,0.242D+03,0.107D+03,0.11055600D+02,0.99440000D+00
     .,0.62432400D+02,0.242D+03,0.108D+03,0.11055600D+02,0.99250000D+00
     .,0.43476000D+02,0.242D+03,0.109D+03,0.11055600D+02,0.99820000D+00
     .,0.23259320D+03,0.242D+03,0.111D+03,0.11055600D+02,0.96840000D+00
     .,0.35918880D+03,0.242D+03,0.112D+03,0.11055600D+02,0.96280000D+00
     ./)
      grimme_c6_parameters( 109201: 109300)=(/
     . 0.36631710D+03,0.242D+03,0.113D+03,0.11055600D+02,0.96480000D+00
     .,0.29774360D+03,0.242D+03,0.114D+03,0.11055600D+02,0.95070000D+00
     .,0.24610860D+03,0.242D+03,0.115D+03,0.11055600D+02,0.99470000D+00
     .,0.20955990D+03,0.242D+03,0.116D+03,0.11055600D+02,0.99480000D+00
     .,0.17257580D+03,0.242D+03,0.117D+03,0.11055600D+02,0.99720000D+00
     .,0.32363810D+03,0.242D+03,0.119D+03,0.11055600D+02,0.97670000D+00
     .,0.60709190D+03,0.242D+03,0.120D+03,0.11055600D+02,0.98310000D+00
     .,0.32607870D+03,0.242D+03,0.121D+03,0.11055600D+02,0.18627000D+01
     .,0.31499830D+03,0.242D+03,0.122D+03,0.11055600D+02,0.18299000D+01
     .,0.30868010D+03,0.242D+03,0.123D+03,0.11055600D+02,0.19138000D+01
     .,0.30552730D+03,0.242D+03,0.124D+03,0.11055600D+02,0.18269000D+01
     .,0.28243340D+03,0.242D+03,0.125D+03,0.11055600D+02,0.16406000D+01
     .,0.26186300D+03,0.242D+03,0.126D+03,0.11055600D+02,0.16483000D+01
     .,0.24986950D+03,0.242D+03,0.127D+03,0.11055600D+02,0.17149000D+01
     .,0.24418470D+03,0.242D+03,0.128D+03,0.11055600D+02,0.17937000D+01
     .,0.24036730D+03,0.242D+03,0.129D+03,0.11055600D+02,0.95760000D+00
     .,0.22704050D+03,0.242D+03,0.130D+03,0.11055600D+02,0.19419000D+01
     .,0.36528020D+03,0.242D+03,0.131D+03,0.11055600D+02,0.96010000D+00
     .,0.32362930D+03,0.242D+03,0.132D+03,0.11055600D+02,0.94340000D+00
     .,0.29204750D+03,0.242D+03,0.133D+03,0.11055600D+02,0.98890000D+00
     ./)
      grimme_c6_parameters( 109301: 109400)=(/
     . 0.26805260D+03,0.242D+03,0.134D+03,0.11055600D+02,0.99010000D+00
     .,0.23750190D+03,0.242D+03,0.135D+03,0.11055600D+02,0.99740000D+00
     .,0.38712360D+03,0.242D+03,0.137D+03,0.11055600D+02,0.97380000D+00
     .,0.73864010D+03,0.242D+03,0.138D+03,0.11055600D+02,0.98010000D+00
     .,0.57185300D+03,0.242D+03,0.139D+03,0.11055600D+02,0.19153000D+01
     .,0.43135120D+03,0.242D+03,0.140D+03,0.11055600D+02,0.19355000D+01
     .,0.43556920D+03,0.242D+03,0.141D+03,0.11055600D+02,0.19545000D+01
     .,0.40706590D+03,0.242D+03,0.142D+03,0.11055600D+02,0.19420000D+01
     .,0.45371970D+03,0.242D+03,0.143D+03,0.11055600D+02,0.16682000D+01
     .,0.35663380D+03,0.242D+03,0.144D+03,0.11055600D+02,0.18584000D+01
     .,0.33393870D+03,0.242D+03,0.145D+03,0.11055600D+02,0.19003000D+01
     .,0.31050050D+03,0.242D+03,0.146D+03,0.11055600D+02,0.18630000D+01
     .,0.30014930D+03,0.242D+03,0.147D+03,0.11055600D+02,0.96790000D+00
     .,0.29784780D+03,0.242D+03,0.148D+03,0.11055600D+02,0.19539000D+01
     .,0.46456790D+03,0.242D+03,0.149D+03,0.11055600D+02,0.96330000D+00
     .,0.42315700D+03,0.242D+03,0.150D+03,0.11055600D+02,0.95140000D+00
     .,0.39833180D+03,0.242D+03,0.151D+03,0.11055600D+02,0.97490000D+00
     .,0.37825790D+03,0.242D+03,0.152D+03,0.11055600D+02,0.98110000D+00
     .,0.34710000D+03,0.242D+03,0.153D+03,0.11055600D+02,0.99680000D+00
     .,0.46012630D+03,0.242D+03,0.155D+03,0.11055600D+02,0.99090000D+00
     ./)
      grimme_c6_parameters( 109401: 109500)=(/
     . 0.95602290D+03,0.242D+03,0.156D+03,0.11055600D+02,0.97970000D+00
     .,0.72324370D+03,0.242D+03,0.157D+03,0.11055600D+02,0.19373000D+01
     .,0.46518180D+03,0.242D+03,0.159D+03,0.11055600D+02,0.29425000D+01
     .,0.45559950D+03,0.242D+03,0.160D+03,0.11055600D+02,0.29455000D+01
     .,0.44133640D+03,0.242D+03,0.161D+03,0.11055600D+02,0.29413000D+01
     .,0.44305470D+03,0.242D+03,0.162D+03,0.11055600D+02,0.29300000D+01
     .,0.42578150D+03,0.242D+03,0.163D+03,0.11055600D+02,0.18286000D+01
     .,0.44561250D+03,0.242D+03,0.164D+03,0.11055600D+02,0.28732000D+01
     .,0.41895420D+03,0.242D+03,0.165D+03,0.11055600D+02,0.29086000D+01
     .,0.42555500D+03,0.242D+03,0.166D+03,0.11055600D+02,0.28965000D+01
     .,0.39799830D+03,0.242D+03,0.167D+03,0.11055600D+02,0.29242000D+01
     .,0.38678540D+03,0.242D+03,0.168D+03,0.11055600D+02,0.29282000D+01
     .,0.38418230D+03,0.242D+03,0.169D+03,0.11055600D+02,0.29246000D+01
     .,0.40306860D+03,0.242D+03,0.170D+03,0.11055600D+02,0.28482000D+01
     .,0.37150160D+03,0.242D+03,0.171D+03,0.11055600D+02,0.29219000D+01
     .,0.49758720D+03,0.242D+03,0.172D+03,0.11055600D+02,0.19254000D+01
     .,0.46378430D+03,0.242D+03,0.173D+03,0.11055600D+02,0.19459000D+01
     .,0.42506300D+03,0.242D+03,0.174D+03,0.11055600D+02,0.19292000D+01
     .,0.42853830D+03,0.242D+03,0.175D+03,0.11055600D+02,0.18104000D+01
     .,0.37888850D+03,0.242D+03,0.176D+03,0.11055600D+02,0.18858000D+01
     ./)
      grimme_c6_parameters( 109501: 109600)=(/
     . 0.35711560D+03,0.242D+03,0.177D+03,0.11055600D+02,0.18648000D+01
     .,0.34149670D+03,0.242D+03,0.178D+03,0.11055600D+02,0.19188000D+01
     .,0.32657380D+03,0.242D+03,0.179D+03,0.11055600D+02,0.98460000D+00
     .,0.31656330D+03,0.242D+03,0.180D+03,0.11055600D+02,0.19896000D+01
     .,0.50005880D+03,0.242D+03,0.181D+03,0.11055600D+02,0.92670000D+00
     .,0.45872390D+03,0.242D+03,0.182D+03,0.11055600D+02,0.93830000D+00
     .,0.44646550D+03,0.242D+03,0.183D+03,0.11055600D+02,0.98200000D+00
     .,0.43546460D+03,0.242D+03,0.184D+03,0.11055600D+02,0.98150000D+00
     .,0.40832830D+03,0.242D+03,0.185D+03,0.11055600D+02,0.99540000D+00
     .,0.51837750D+03,0.242D+03,0.187D+03,0.11055600D+02,0.97050000D+00
     .,0.95463010D+03,0.242D+03,0.188D+03,0.11055600D+02,0.96620000D+00
     .,0.55025080D+03,0.242D+03,0.189D+03,0.11055600D+02,0.29070000D+01
     .,0.63174190D+03,0.242D+03,0.190D+03,0.11055600D+02,0.28844000D+01
     .,0.56637730D+03,0.242D+03,0.191D+03,0.11055600D+02,0.28738000D+01
     .,0.50265170D+03,0.242D+03,0.192D+03,0.11055600D+02,0.28878000D+01
     .,0.48421620D+03,0.242D+03,0.193D+03,0.11055600D+02,0.29095000D+01
     .,0.57561980D+03,0.242D+03,0.194D+03,0.11055600D+02,0.19209000D+01
     .,0.13524280D+03,0.242D+03,0.204D+03,0.11055600D+02,0.19697000D+01
     .,0.13350900D+03,0.242D+03,0.205D+03,0.11055600D+02,0.19441000D+01
     .,0.98890300D+02,0.242D+03,0.206D+03,0.11055600D+02,0.19985000D+01
     ./)
      grimme_c6_parameters( 109601: 109700)=(/
     . 0.79767200D+02,0.242D+03,0.207D+03,0.11055600D+02,0.20143000D+01
     .,0.55248400D+02,0.242D+03,0.208D+03,0.11055600D+02,0.19887000D+01
     .,0.23801690D+03,0.242D+03,0.212D+03,0.11055600D+02,0.19496000D+01
     .,0.28752250D+03,0.242D+03,0.213D+03,0.11055600D+02,0.19311000D+01
     .,0.27743120D+03,0.242D+03,0.214D+03,0.11055600D+02,0.19435000D+01
     .,0.24266760D+03,0.242D+03,0.215D+03,0.11055600D+02,0.20102000D+01
     .,0.20536950D+03,0.242D+03,0.216D+03,0.11055600D+02,0.19903000D+01
     .,0.33432060D+03,0.242D+03,0.220D+03,0.11055600D+02,0.19349000D+01
     .,0.32266550D+03,0.242D+03,0.221D+03,0.11055600D+02,0.28999000D+01
     .,0.32676700D+03,0.242D+03,0.222D+03,0.11055600D+02,0.38675000D+01
     .,0.29914950D+03,0.242D+03,0.223D+03,0.11055600D+02,0.29110000D+01
     .,0.22729470D+03,0.242D+03,0.224D+03,0.11055600D+02,0.10619100D+02
     .,0.19544560D+03,0.242D+03,0.225D+03,0.11055600D+02,0.98849000D+01
     .,0.19173330D+03,0.242D+03,0.226D+03,0.11055600D+02,0.91376000D+01
     .,0.22295460D+03,0.242D+03,0.227D+03,0.11055600D+02,0.29263000D+01
     .,0.20815700D+03,0.242D+03,0.228D+03,0.11055600D+02,0.65458000D+01
     .,0.29172410D+03,0.242D+03,0.231D+03,0.11055600D+02,0.19315000D+01
     .,0.30857810D+03,0.242D+03,0.232D+03,0.11055600D+02,0.19447000D+01
     .,0.28464110D+03,0.242D+03,0.233D+03,0.11055600D+02,0.19793000D+01
     .,0.26599860D+03,0.242D+03,0.234D+03,0.11055600D+02,0.19812000D+01
     ./)
      grimme_c6_parameters( 109701: 109800)=(/
     . 0.40105410D+03,0.242D+03,0.238D+03,0.11055600D+02,0.19143000D+01
     .,0.38807180D+03,0.242D+03,0.239D+03,0.11055600D+02,0.28903000D+01
     .,0.39206550D+03,0.242D+03,0.240D+03,0.11055600D+02,0.39106000D+01
     .,0.37920750D+03,0.242D+03,0.241D+03,0.11055600D+02,0.29225000D+01
     .,0.33710750D+03,0.242D+03,0.242D+03,0.11055600D+02,0.11055600D+02
     .,0.28262700D+02,0.243D+03,0.100D+01,0.95402000D+01,0.91180000D+00
     .,0.19355600D+02,0.243D+03,0.200D+01,0.95402000D+01,0.00000000D+00
     .,0.39142550D+03,0.243D+03,0.300D+01,0.95402000D+01,0.00000000D+00
     .,0.23684570D+03,0.243D+03,0.400D+01,0.95402000D+01,0.00000000D+00
     .,0.16457770D+03,0.243D+03,0.500D+01,0.95402000D+01,0.00000000D+00
     .,0.11407740D+03,0.243D+03,0.600D+01,0.95402000D+01,0.00000000D+00
     .,0.81421700D+02,0.243D+03,0.700D+01,0.95402000D+01,0.00000000D+00
     .,0.62588600D+02,0.243D+03,0.800D+01,0.95402000D+01,0.00000000D+00
     .,0.48054000D+02,0.243D+03,0.900D+01,0.95402000D+01,0.00000000D+00
     .,0.37372300D+02,0.243D+03,0.100D+02,0.95402000D+01,0.00000000D+00
     .,0.46976960D+03,0.243D+03,0.110D+02,0.95402000D+01,0.00000000D+00
     .,0.37426910D+03,0.243D+03,0.120D+02,0.95402000D+01,0.00000000D+00
     .,0.35028040D+03,0.243D+03,0.130D+02,0.95402000D+01,0.00000000D+00
     .,0.28184800D+03,0.243D+03,0.140D+02,0.95402000D+01,0.00000000D+00
     .,0.22400340D+03,0.243D+03,0.150D+02,0.95402000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 109801: 109900)=(/
     . 0.18840440D+03,0.243D+03,0.160D+02,0.95402000D+01,0.00000000D+00
     .,0.15594050D+03,0.243D+03,0.170D+02,0.95402000D+01,0.00000000D+00
     .,0.12911050D+03,0.243D+03,0.180D+02,0.95402000D+01,0.00000000D+00
     .,0.76793390D+03,0.243D+03,0.190D+02,0.95402000D+01,0.00000000D+00
     .,0.64950000D+03,0.243D+03,0.200D+02,0.95402000D+01,0.00000000D+00
     .,0.53986620D+03,0.243D+03,0.210D+02,0.95402000D+01,0.00000000D+00
     .,0.52491730D+03,0.243D+03,0.220D+02,0.95402000D+01,0.00000000D+00
     .,0.48256220D+03,0.243D+03,0.230D+02,0.95402000D+01,0.00000000D+00
     .,0.38140060D+03,0.243D+03,0.240D+02,0.95402000D+01,0.00000000D+00
     .,0.41786140D+03,0.243D+03,0.250D+02,0.95402000D+01,0.00000000D+00
     .,0.32931160D+03,0.243D+03,0.260D+02,0.95402000D+01,0.00000000D+00
     .,0.35085640D+03,0.243D+03,0.270D+02,0.95402000D+01,0.00000000D+00
     .,0.35990170D+03,0.243D+03,0.280D+02,0.95402000D+01,0.00000000D+00
     .,0.27699700D+03,0.243D+03,0.290D+02,0.95402000D+01,0.00000000D+00
     .,0.28699270D+03,0.243D+03,0.300D+02,0.95402000D+01,0.00000000D+00
     .,0.33826270D+03,0.243D+03,0.310D+02,0.95402000D+01,0.00000000D+00
     .,0.30293890D+03,0.243D+03,0.320D+02,0.95402000D+01,0.00000000D+00
     .,0.26234800D+03,0.243D+03,0.330D+02,0.95402000D+01,0.00000000D+00
     .,0.23782350D+03,0.243D+03,0.340D+02,0.95402000D+01,0.00000000D+00
     .,0.21038120D+03,0.243D+03,0.350D+02,0.95402000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 109901: 110000)=(/
     . 0.18484770D+03,0.243D+03,0.360D+02,0.95402000D+01,0.00000000D+00
     .,0.86376550D+03,0.243D+03,0.370D+02,0.95402000D+01,0.00000000D+00
     .,0.77394630D+03,0.243D+03,0.380D+02,0.95402000D+01,0.00000000D+00
     .,0.68574890D+03,0.243D+03,0.390D+02,0.95402000D+01,0.00000000D+00
     .,0.62104380D+03,0.243D+03,0.400D+02,0.95402000D+01,0.00000000D+00
     .,0.56941590D+03,0.243D+03,0.410D+02,0.95402000D+01,0.00000000D+00
     .,0.44434710D+03,0.243D+03,0.420D+02,0.95402000D+01,0.00000000D+00
     .,0.49374300D+03,0.243D+03,0.430D+02,0.95402000D+01,0.00000000D+00
     .,0.38057300D+03,0.243D+03,0.440D+02,0.95402000D+01,0.00000000D+00
     .,0.41514630D+03,0.243D+03,0.450D+02,0.95402000D+01,0.00000000D+00
     .,0.38629860D+03,0.243D+03,0.460D+02,0.95402000D+01,0.00000000D+00
     .,0.32258210D+03,0.243D+03,0.470D+02,0.95402000D+01,0.00000000D+00
     .,0.34192370D+03,0.243D+03,0.480D+02,0.95402000D+01,0.00000000D+00
     .,0.42431450D+03,0.243D+03,0.490D+02,0.95402000D+01,0.00000000D+00
     .,0.39689200D+03,0.243D+03,0.500D+02,0.95402000D+01,0.00000000D+00
     .,0.35815190D+03,0.243D+03,0.510D+02,0.95402000D+01,0.00000000D+00
     .,0.33500590D+03,0.243D+03,0.520D+02,0.95402000D+01,0.00000000D+00
     .,0.30566670D+03,0.243D+03,0.530D+02,0.95402000D+01,0.00000000D+00
     .,0.27727710D+03,0.243D+03,0.540D+02,0.95402000D+01,0.00000000D+00
     .,0.10537818D+04,0.243D+03,0.550D+02,0.95402000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 110001: 110100)=(/
     . 0.98418610D+03,0.243D+03,0.560D+02,0.95402000D+01,0.00000000D+00
     .,0.87424490D+03,0.243D+03,0.570D+02,0.95402000D+01,0.00000000D+00
     .,0.42266280D+03,0.243D+03,0.580D+02,0.95402000D+01,0.27991000D+01
     .,0.87559270D+03,0.243D+03,0.590D+02,0.95402000D+01,0.00000000D+00
     .,0.84216510D+03,0.243D+03,0.600D+02,0.95402000D+01,0.00000000D+00
     .,0.82140430D+03,0.243D+03,0.610D+02,0.95402000D+01,0.00000000D+00
     .,0.80225710D+03,0.243D+03,0.620D+02,0.95402000D+01,0.00000000D+00
     .,0.78528980D+03,0.243D+03,0.630D+02,0.95402000D+01,0.00000000D+00
     .,0.62638240D+03,0.243D+03,0.640D+02,0.95402000D+01,0.00000000D+00
     .,0.69366130D+03,0.243D+03,0.650D+02,0.95402000D+01,0.00000000D+00
     .,0.67051140D+03,0.243D+03,0.660D+02,0.95402000D+01,0.00000000D+00
     .,0.71007710D+03,0.243D+03,0.670D+02,0.95402000D+01,0.00000000D+00
     .,0.69514360D+03,0.243D+03,0.680D+02,0.95402000D+01,0.00000000D+00
     .,0.68179200D+03,0.243D+03,0.690D+02,0.95402000D+01,0.00000000D+00
     .,0.67337970D+03,0.243D+03,0.700D+02,0.95402000D+01,0.00000000D+00
     .,0.57285580D+03,0.243D+03,0.710D+02,0.95402000D+01,0.00000000D+00
     .,0.56966440D+03,0.243D+03,0.720D+02,0.95402000D+01,0.00000000D+00
     .,0.52402130D+03,0.243D+03,0.730D+02,0.95402000D+01,0.00000000D+00
     .,0.44608380D+03,0.243D+03,0.740D+02,0.95402000D+01,0.00000000D+00
     .,0.45488600D+03,0.243D+03,0.750D+02,0.95402000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 110101: 110200)=(/
     . 0.41519500D+03,0.243D+03,0.760D+02,0.95402000D+01,0.00000000D+00
     .,0.38249740D+03,0.243D+03,0.770D+02,0.95402000D+01,0.00000000D+00
     .,0.32027240D+03,0.243D+03,0.780D+02,0.95402000D+01,0.00000000D+00
     .,0.30015390D+03,0.243D+03,0.790D+02,0.95402000D+01,0.00000000D+00
     .,0.30919500D+03,0.243D+03,0.800D+02,0.95402000D+01,0.00000000D+00
     .,0.43822480D+03,0.243D+03,0.810D+02,0.95402000D+01,0.00000000D+00
     .,0.43187000D+03,0.243D+03,0.820D+02,0.95402000D+01,0.00000000D+00
     .,0.40107000D+03,0.243D+03,0.830D+02,0.95402000D+01,0.00000000D+00
     .,0.38504170D+03,0.243D+03,0.840D+02,0.95402000D+01,0.00000000D+00
     .,0.35831060D+03,0.243D+03,0.850D+02,0.95402000D+01,0.00000000D+00
     .,0.33103010D+03,0.243D+03,0.860D+02,0.95402000D+01,0.00000000D+00
     .,0.10040757D+04,0.243D+03,0.870D+02,0.95402000D+01,0.00000000D+00
     .,0.97925300D+03,0.243D+03,0.880D+02,0.95402000D+01,0.00000000D+00
     .,0.87428430D+03,0.243D+03,0.890D+02,0.95402000D+01,0.00000000D+00
     .,0.79590040D+03,0.243D+03,0.900D+02,0.95402000D+01,0.00000000D+00
     .,0.78618960D+03,0.243D+03,0.910D+02,0.95402000D+01,0.00000000D+00
     .,0.76155790D+03,0.243D+03,0.920D+02,0.95402000D+01,0.00000000D+00
     .,0.77812490D+03,0.243D+03,0.930D+02,0.95402000D+01,0.00000000D+00
     .,0.75451690D+03,0.243D+03,0.940D+02,0.95402000D+01,0.00000000D+00
     .,0.44596300D+02,0.243D+03,0.101D+03,0.95402000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 110201: 110300)=(/
     . 0.13836130D+03,0.243D+03,0.103D+03,0.95402000D+01,0.98650000D+00
     .,0.17768370D+03,0.243D+03,0.104D+03,0.95402000D+01,0.98080000D+00
     .,0.13947630D+03,0.243D+03,0.105D+03,0.95402000D+01,0.97060000D+00
     .,0.10709060D+03,0.243D+03,0.106D+03,0.95402000D+01,0.98680000D+00
     .,0.76053200D+02,0.243D+03,0.107D+03,0.95402000D+01,0.99440000D+00
     .,0.56396200D+02,0.243D+03,0.108D+03,0.95402000D+01,0.99250000D+00
     .,0.39666800D+02,0.243D+03,0.109D+03,0.95402000D+01,0.99820000D+00
     .,0.20154030D+03,0.243D+03,0.111D+03,0.95402000D+01,0.96840000D+00
     .,0.31080830D+03,0.243D+03,0.112D+03,0.95402000D+01,0.96280000D+00
     .,0.31873880D+03,0.243D+03,0.113D+03,0.95402000D+01,0.96480000D+00
     .,0.26141050D+03,0.243D+03,0.114D+03,0.95402000D+01,0.95070000D+00
     .,0.21763470D+03,0.243D+03,0.115D+03,0.95402000D+01,0.99470000D+00
     .,0.18630930D+03,0.243D+03,0.116D+03,0.95402000D+01,0.99480000D+00
     .,0.15431180D+03,0.243D+03,0.117D+03,0.95402000D+01,0.99720000D+00
     .,0.28243840D+03,0.243D+03,0.119D+03,0.95402000D+01,0.97670000D+00
     .,0.52184580D+03,0.243D+03,0.120D+03,0.95402000D+01,0.98310000D+00
     .,0.28622410D+03,0.243D+03,0.121D+03,0.95402000D+01,0.18627000D+01
     .,0.27665670D+03,0.243D+03,0.122D+03,0.95402000D+01,0.18299000D+01
     .,0.27110010D+03,0.243D+03,0.123D+03,0.95402000D+01,0.19138000D+01
     .,0.26813250D+03,0.243D+03,0.124D+03,0.95402000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters( 110301: 110400)=(/
     . 0.24878950D+03,0.243D+03,0.125D+03,0.95402000D+01,0.16406000D+01
     .,0.23100810D+03,0.243D+03,0.126D+03,0.95402000D+01,0.16483000D+01
     .,0.22048020D+03,0.243D+03,0.127D+03,0.95402000D+01,0.17149000D+01
     .,0.21540300D+03,0.243D+03,0.128D+03,0.95402000D+01,0.17937000D+01
     .,0.21142380D+03,0.243D+03,0.129D+03,0.95402000D+01,0.95760000D+00
     .,0.20075620D+03,0.243D+03,0.130D+03,0.95402000D+01,0.19419000D+01
     .,0.31899680D+03,0.243D+03,0.131D+03,0.95402000D+01,0.96010000D+00
     .,0.28455050D+03,0.243D+03,0.132D+03,0.95402000D+01,0.94340000D+00
     .,0.25816170D+03,0.243D+03,0.133D+03,0.95402000D+01,0.98890000D+00
     .,0.23789530D+03,0.243D+03,0.134D+03,0.95402000D+01,0.99010000D+00
     .,0.21174100D+03,0.243D+03,0.135D+03,0.95402000D+01,0.99740000D+00
     .,0.33850140D+03,0.243D+03,0.137D+03,0.95402000D+01,0.97380000D+00
     .,0.63481680D+03,0.243D+03,0.138D+03,0.95402000D+01,0.98010000D+00
     .,0.49663990D+03,0.243D+03,0.139D+03,0.95402000D+01,0.19153000D+01
     .,0.37865110D+03,0.243D+03,0.140D+03,0.95402000D+01,0.19355000D+01
     .,0.38232250D+03,0.243D+03,0.141D+03,0.95402000D+01,0.19545000D+01
     .,0.35796340D+03,0.243D+03,0.142D+03,0.95402000D+01,0.19420000D+01
     .,0.39703670D+03,0.243D+03,0.143D+03,0.95402000D+01,0.16682000D+01
     .,0.31491710D+03,0.243D+03,0.144D+03,0.95402000D+01,0.18584000D+01
     .,0.29510120D+03,0.243D+03,0.145D+03,0.95402000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters( 110401: 110500)=(/
     . 0.27469180D+03,0.243D+03,0.146D+03,0.95402000D+01,0.18630000D+01
     .,0.26540330D+03,0.243D+03,0.147D+03,0.95402000D+01,0.96790000D+00
     .,0.26402010D+03,0.243D+03,0.148D+03,0.95402000D+01,0.19539000D+01
     .,0.40621170D+03,0.243D+03,0.149D+03,0.95402000D+01,0.96330000D+00
     .,0.37204100D+03,0.243D+03,0.150D+03,0.95402000D+01,0.95140000D+00
     .,0.35163900D+03,0.243D+03,0.151D+03,0.95402000D+01,0.97490000D+00
     .,0.33492300D+03,0.243D+03,0.152D+03,0.95402000D+01,0.98110000D+00
     .,0.30847430D+03,0.243D+03,0.153D+03,0.95402000D+01,0.99680000D+00
     .,0.40390770D+03,0.243D+03,0.155D+03,0.95402000D+01,0.99090000D+00
     .,0.82041740D+03,0.243D+03,0.156D+03,0.95402000D+01,0.97970000D+00
     .,0.62770030D+03,0.243D+03,0.157D+03,0.95402000D+01,0.19373000D+01
     .,0.41025930D+03,0.243D+03,0.159D+03,0.95402000D+01,0.29425000D+01
     .,0.40183710D+03,0.243D+03,0.160D+03,0.95402000D+01,0.29455000D+01
     .,0.38938420D+03,0.243D+03,0.161D+03,0.95402000D+01,0.29413000D+01
     .,0.39058410D+03,0.243D+03,0.162D+03,0.95402000D+01,0.29300000D+01
     .,0.37444730D+03,0.243D+03,0.163D+03,0.95402000D+01,0.18286000D+01
     .,0.39266670D+03,0.243D+03,0.164D+03,0.95402000D+01,0.28732000D+01
     .,0.36947670D+03,0.243D+03,0.165D+03,0.95402000D+01,0.29086000D+01
     .,0.37477260D+03,0.243D+03,0.166D+03,0.95402000D+01,0.28965000D+01
     .,0.35123330D+03,0.243D+03,0.167D+03,0.95402000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters( 110501: 110600)=(/
     . 0.34142990D+03,0.243D+03,0.168D+03,0.95402000D+01,0.29282000D+01
     .,0.33904640D+03,0.243D+03,0.169D+03,0.95402000D+01,0.29246000D+01
     .,0.35518230D+03,0.243D+03,0.170D+03,0.95402000D+01,0.28482000D+01
     .,0.32797090D+03,0.243D+03,0.171D+03,0.95402000D+01,0.29219000D+01
     .,0.43515580D+03,0.243D+03,0.172D+03,0.95402000D+01,0.19254000D+01
     .,0.40701010D+03,0.243D+03,0.173D+03,0.95402000D+01,0.19459000D+01
     .,0.37438790D+03,0.243D+03,0.174D+03,0.95402000D+01,0.19292000D+01
     .,0.37634630D+03,0.243D+03,0.175D+03,0.95402000D+01,0.18104000D+01
     .,0.33543720D+03,0.243D+03,0.176D+03,0.95402000D+01,0.18858000D+01
     .,0.31664800D+03,0.243D+03,0.177D+03,0.95402000D+01,0.18648000D+01
     .,0.30309840D+03,0.243D+03,0.178D+03,0.95402000D+01,0.19188000D+01
     .,0.28993290D+03,0.243D+03,0.179D+03,0.95402000D+01,0.98460000D+00
     .,0.28176770D+03,0.243D+03,0.180D+03,0.95402000D+01,0.19896000D+01
     .,0.43810480D+03,0.243D+03,0.181D+03,0.95402000D+01,0.92670000D+00
     .,0.40400650D+03,0.243D+03,0.182D+03,0.95402000D+01,0.93830000D+00
     .,0.39433950D+03,0.243D+03,0.183D+03,0.95402000D+01,0.98200000D+00
     .,0.38548280D+03,0.243D+03,0.184D+03,0.95402000D+01,0.98150000D+00
     .,0.36263740D+03,0.243D+03,0.185D+03,0.95402000D+01,0.99540000D+00
     .,0.45515750D+03,0.243D+03,0.187D+03,0.95402000D+01,0.97050000D+00
     .,0.82187390D+03,0.243D+03,0.188D+03,0.95402000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters( 110601: 110700)=(/
     . 0.48513840D+03,0.243D+03,0.189D+03,0.95402000D+01,0.29070000D+01
     .,0.55458830D+03,0.243D+03,0.190D+03,0.95402000D+01,0.28844000D+01
     .,0.49832020D+03,0.243D+03,0.191D+03,0.95402000D+01,0.28738000D+01
     .,0.44380410D+03,0.243D+03,0.192D+03,0.95402000D+01,0.28878000D+01
     .,0.42790900D+03,0.243D+03,0.193D+03,0.95402000D+01,0.29095000D+01
     .,0.50378650D+03,0.243D+03,0.194D+03,0.95402000D+01,0.19209000D+01
     .,0.11912060D+03,0.243D+03,0.204D+03,0.95402000D+01,0.19697000D+01
     .,0.11797580D+03,0.243D+03,0.205D+03,0.95402000D+01,0.19441000D+01
     .,0.88215800D+02,0.243D+03,0.206D+03,0.95402000D+01,0.19985000D+01
     .,0.71572300D+02,0.243D+03,0.207D+03,0.95402000D+01,0.20143000D+01
     .,0.50040600D+02,0.243D+03,0.208D+03,0.95402000D+01,0.19887000D+01
     .,0.20841310D+03,0.243D+03,0.212D+03,0.95402000D+01,0.19496000D+01
     .,0.25164210D+03,0.243D+03,0.213D+03,0.95402000D+01,0.19311000D+01
     .,0.24391880D+03,0.243D+03,0.214D+03,0.95402000D+01,0.19435000D+01
     .,0.21451760D+03,0.243D+03,0.215D+03,0.95402000D+01,0.20102000D+01
     .,0.18261700D+03,0.243D+03,0.216D+03,0.95402000D+01,0.19903000D+01
     .,0.29311980D+03,0.243D+03,0.220D+03,0.95402000D+01,0.19349000D+01
     .,0.28387840D+03,0.243D+03,0.221D+03,0.95402000D+01,0.28999000D+01
     .,0.28758070D+03,0.243D+03,0.222D+03,0.95402000D+01,0.38675000D+01
     .,0.26334090D+03,0.243D+03,0.223D+03,0.95402000D+01,0.29110000D+01
     ./)
      grimme_c6_parameters( 110701: 110800)=(/
     . 0.20147070D+03,0.243D+03,0.224D+03,0.95402000D+01,0.10619100D+02
     .,0.17392920D+03,0.243D+03,0.225D+03,0.95402000D+01,0.98849000D+01
     .,0.17055570D+03,0.243D+03,0.226D+03,0.95402000D+01,0.91376000D+01
     .,0.19706800D+03,0.243D+03,0.227D+03,0.95402000D+01,0.29263000D+01
     .,0.18430860D+03,0.243D+03,0.228D+03,0.95402000D+01,0.65458000D+01
     .,0.25639330D+03,0.243D+03,0.231D+03,0.95402000D+01,0.19315000D+01
     .,0.27164740D+03,0.243D+03,0.232D+03,0.95402000D+01,0.19447000D+01
     .,0.25179730D+03,0.243D+03,0.233D+03,0.95402000D+01,0.19793000D+01
     .,0.23610840D+03,0.243D+03,0.234D+03,0.95402000D+01,0.19812000D+01
     .,0.35195640D+03,0.243D+03,0.238D+03,0.95402000D+01,0.19143000D+01
     .,0.34203460D+03,0.243D+03,0.239D+03,0.95402000D+01,0.28903000D+01
     .,0.34602660D+03,0.243D+03,0.240D+03,0.95402000D+01,0.39106000D+01
     .,0.33471740D+03,0.243D+03,0.241D+03,0.95402000D+01,0.29225000D+01
     .,0.29885080D+03,0.243D+03,0.242D+03,0.95402000D+01,0.11055600D+02
     .,0.26586540D+03,0.243D+03,0.243D+03,0.95402000D+01,0.95402000D+01
     .,0.26814200D+02,0.244D+03,0.100D+01,0.88895000D+01,0.91180000D+00
     .,0.18486400D+02,0.244D+03,0.200D+01,0.88895000D+01,0.00000000D+00
     .,0.36441020D+03,0.244D+03,0.300D+01,0.88895000D+01,0.00000000D+00
     .,0.22214890D+03,0.244D+03,0.400D+01,0.88895000D+01,0.00000000D+00
     .,0.15516280D+03,0.244D+03,0.500D+01,0.88895000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 110801: 110900)=(/
     . 0.10802000D+03,0.244D+03,0.600D+01,0.88895000D+01,0.00000000D+00
     .,0.77377200D+02,0.244D+03,0.700D+01,0.88895000D+01,0.00000000D+00
     .,0.59646000D+02,0.244D+03,0.800D+01,0.88895000D+01,0.00000000D+00
     .,0.45913300D+02,0.244D+03,0.900D+01,0.88895000D+01,0.00000000D+00
     .,0.35788400D+02,0.244D+03,0.100D+02,0.88895000D+01,0.00000000D+00
     .,0.43764910D+03,0.244D+03,0.110D+02,0.88895000D+01,0.00000000D+00
     .,0.35061410D+03,0.244D+03,0.120D+02,0.88895000D+01,0.00000000D+00
     .,0.32894340D+03,0.244D+03,0.130D+02,0.88895000D+01,0.00000000D+00
     .,0.26558080D+03,0.244D+03,0.140D+02,0.88895000D+01,0.00000000D+00
     .,0.21173900D+03,0.244D+03,0.150D+02,0.88895000D+01,0.00000000D+00
     .,0.17849350D+03,0.244D+03,0.160D+02,0.88895000D+01,0.00000000D+00
     .,0.14807630D+03,0.244D+03,0.170D+02,0.88895000D+01,0.00000000D+00
     .,0.12286250D+03,0.244D+03,0.180D+02,0.88895000D+01,0.00000000D+00
     .,0.71523760D+03,0.244D+03,0.190D+02,0.88895000D+01,0.00000000D+00
     .,0.60729210D+03,0.244D+03,0.200D+02,0.88895000D+01,0.00000000D+00
     .,0.50528540D+03,0.244D+03,0.210D+02,0.88895000D+01,0.00000000D+00
     .,0.49186430D+03,0.244D+03,0.220D+02,0.88895000D+01,0.00000000D+00
     .,0.45247550D+03,0.244D+03,0.230D+02,0.88895000D+01,0.00000000D+00
     .,0.35786670D+03,0.244D+03,0.240D+02,0.88895000D+01,0.00000000D+00
     .,0.39219220D+03,0.244D+03,0.250D+02,0.88895000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 110901: 111000)=(/
     . 0.30933800D+03,0.244D+03,0.260D+02,0.88895000D+01,0.00000000D+00
     .,0.32981210D+03,0.244D+03,0.270D+02,0.88895000D+01,0.00000000D+00
     .,0.33808050D+03,0.244D+03,0.280D+02,0.88895000D+01,0.00000000D+00
     .,0.26041990D+03,0.244D+03,0.290D+02,0.88895000D+01,0.00000000D+00
     .,0.27017940D+03,0.244D+03,0.300D+02,0.88895000D+01,0.00000000D+00
     .,0.31812240D+03,0.244D+03,0.310D+02,0.88895000D+01,0.00000000D+00
     .,0.28561020D+03,0.244D+03,0.320D+02,0.88895000D+01,0.00000000D+00
     .,0.24796070D+03,0.244D+03,0.330D+02,0.88895000D+01,0.00000000D+00
     .,0.22516700D+03,0.244D+03,0.340D+02,0.88895000D+01,0.00000000D+00
     .,0.19955490D+03,0.244D+03,0.350D+02,0.88895000D+01,0.00000000D+00
     .,0.17565240D+03,0.244D+03,0.360D+02,0.88895000D+01,0.00000000D+00
     .,0.80500650D+03,0.244D+03,0.370D+02,0.88895000D+01,0.00000000D+00
     .,0.72369110D+03,0.244D+03,0.380D+02,0.88895000D+01,0.00000000D+00
     .,0.64242790D+03,0.244D+03,0.390D+02,0.88895000D+01,0.00000000D+00
     .,0.58255440D+03,0.244D+03,0.400D+02,0.88895000D+01,0.00000000D+00
     .,0.53462660D+03,0.244D+03,0.410D+02,0.88895000D+01,0.00000000D+00
     .,0.41798890D+03,0.244D+03,0.420D+02,0.88895000D+01,0.00000000D+00
     .,0.46412390D+03,0.244D+03,0.430D+02,0.88895000D+01,0.00000000D+00
     .,0.35848400D+03,0.244D+03,0.440D+02,0.88895000D+01,0.00000000D+00
     .,0.39089370D+03,0.244D+03,0.450D+02,0.88895000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 111001: 111100)=(/
     . 0.36395130D+03,0.244D+03,0.460D+02,0.88895000D+01,0.00000000D+00
     .,0.30405500D+03,0.244D+03,0.470D+02,0.88895000D+01,0.00000000D+00
     .,0.32240840D+03,0.244D+03,0.480D+02,0.88895000D+01,0.00000000D+00
     .,0.39931090D+03,0.244D+03,0.490D+02,0.88895000D+01,0.00000000D+00
     .,0.37418700D+03,0.244D+03,0.500D+02,0.88895000D+01,0.00000000D+00
     .,0.33835410D+03,0.244D+03,0.510D+02,0.88895000D+01,0.00000000D+00
     .,0.31691230D+03,0.244D+03,0.520D+02,0.88895000D+01,0.00000000D+00
     .,0.28960010D+03,0.244D+03,0.530D+02,0.88895000D+01,0.00000000D+00
     .,0.26310510D+03,0.244D+03,0.540D+02,0.88895000D+01,0.00000000D+00
     .,0.98230160D+03,0.244D+03,0.550D+02,0.88895000D+01,0.00000000D+00
     .,0.91991100D+03,0.244D+03,0.560D+02,0.88895000D+01,0.00000000D+00
     .,0.81862810D+03,0.244D+03,0.570D+02,0.88895000D+01,0.00000000D+00
     .,0.39923510D+03,0.244D+03,0.580D+02,0.88895000D+01,0.27991000D+01
     .,0.81904250D+03,0.244D+03,0.590D+02,0.88895000D+01,0.00000000D+00
     .,0.78798460D+03,0.244D+03,0.600D+02,0.88895000D+01,0.00000000D+00
     .,0.76861590D+03,0.244D+03,0.610D+02,0.88895000D+01,0.00000000D+00
     .,0.75074320D+03,0.244D+03,0.620D+02,0.88895000D+01,0.00000000D+00
     .,0.73490660D+03,0.244D+03,0.630D+02,0.88895000D+01,0.00000000D+00
     .,0.58761560D+03,0.244D+03,0.640D+02,0.88895000D+01,0.00000000D+00
     .,0.64899040D+03,0.244D+03,0.650D+02,0.88895000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 111101: 111200)=(/
     . 0.62756590D+03,0.244D+03,0.660D+02,0.88895000D+01,0.00000000D+00
     .,0.66479550D+03,0.244D+03,0.670D+02,0.88895000D+01,0.00000000D+00
     .,0.65083380D+03,0.244D+03,0.680D+02,0.88895000D+01,0.00000000D+00
     .,0.63836820D+03,0.244D+03,0.690D+02,0.88895000D+01,0.00000000D+00
     .,0.63042130D+03,0.244D+03,0.700D+02,0.88895000D+01,0.00000000D+00
     .,0.53719250D+03,0.244D+03,0.710D+02,0.88895000D+01,0.00000000D+00
     .,0.53511600D+03,0.244D+03,0.720D+02,0.88895000D+01,0.00000000D+00
     .,0.49290160D+03,0.244D+03,0.730D+02,0.88895000D+01,0.00000000D+00
     .,0.42019700D+03,0.244D+03,0.740D+02,0.88895000D+01,0.00000000D+00
     .,0.42865240D+03,0.244D+03,0.750D+02,0.88895000D+01,0.00000000D+00
     .,0.39172610D+03,0.244D+03,0.760D+02,0.88895000D+01,0.00000000D+00
     .,0.36124810D+03,0.244D+03,0.770D+02,0.88895000D+01,0.00000000D+00
     .,0.30292430D+03,0.244D+03,0.780D+02,0.88895000D+01,0.00000000D+00
     .,0.28406330D+03,0.244D+03,0.790D+02,0.88895000D+01,0.00000000D+00
     .,0.29267440D+03,0.244D+03,0.800D+02,0.88895000D+01,0.00000000D+00
     .,0.41285870D+03,0.244D+03,0.810D+02,0.88895000D+01,0.00000000D+00
     .,0.40737440D+03,0.244D+03,0.820D+02,0.88895000D+01,0.00000000D+00
     .,0.37897400D+03,0.244D+03,0.830D+02,0.88895000D+01,0.00000000D+00
     .,0.36421970D+03,0.244D+03,0.840D+02,0.88895000D+01,0.00000000D+00
     .,0.33940270D+03,0.244D+03,0.850D+02,0.88895000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 111201: 111300)=(/
     . 0.31398490D+03,0.244D+03,0.860D+02,0.88895000D+01,0.00000000D+00
     .,0.93738470D+03,0.244D+03,0.870D+02,0.88895000D+01,0.00000000D+00
     .,0.91624010D+03,0.244D+03,0.880D+02,0.88895000D+01,0.00000000D+00
     .,0.81940930D+03,0.244D+03,0.890D+02,0.88895000D+01,0.00000000D+00
     .,0.74758980D+03,0.244D+03,0.900D+02,0.88895000D+01,0.00000000D+00
     .,0.73789240D+03,0.244D+03,0.910D+02,0.88895000D+01,0.00000000D+00
     .,0.71483440D+03,0.244D+03,0.920D+02,0.88895000D+01,0.00000000D+00
     .,0.72948730D+03,0.244D+03,0.930D+02,0.88895000D+01,0.00000000D+00
     .,0.70750950D+03,0.244D+03,0.940D+02,0.88895000D+01,0.00000000D+00
     .,0.42162700D+02,0.244D+03,0.101D+03,0.88895000D+01,0.00000000D+00
     .,0.12989070D+03,0.244D+03,0.103D+03,0.88895000D+01,0.98650000D+00
     .,0.16698720D+03,0.244D+03,0.104D+03,0.88895000D+01,0.98080000D+00
     .,0.13166500D+03,0.244D+03,0.105D+03,0.88895000D+01,0.97060000D+00
     .,0.10141840D+03,0.244D+03,0.106D+03,0.88895000D+01,0.98680000D+00
     .,0.72295000D+02,0.244D+03,0.107D+03,0.88895000D+01,0.99440000D+00
     .,0.53786300D+02,0.244D+03,0.108D+03,0.88895000D+01,0.99250000D+00
     .,0.37996100D+02,0.244D+03,0.109D+03,0.88895000D+01,0.99820000D+00
     .,0.18913000D+03,0.244D+03,0.111D+03,0.88895000D+01,0.96840000D+00
     .,0.29149160D+03,0.244D+03,0.112D+03,0.88895000D+01,0.96280000D+00
     .,0.29952560D+03,0.244D+03,0.113D+03,0.88895000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters( 111301: 111400)=(/
     . 0.24646800D+03,0.244D+03,0.114D+03,0.88895000D+01,0.95070000D+00
     .,0.20575330D+03,0.244D+03,0.115D+03,0.88895000D+01,0.99470000D+00
     .,0.17650780D+03,0.244D+03,0.116D+03,0.88895000D+01,0.99480000D+00
     .,0.14652980D+03,0.244D+03,0.117D+03,0.88895000D+01,0.99720000D+00
     .,0.26580330D+03,0.244D+03,0.119D+03,0.88895000D+01,0.97670000D+00
     .,0.48833520D+03,0.244D+03,0.120D+03,0.88895000D+01,0.98310000D+00
     .,0.26990590D+03,0.244D+03,0.121D+03,0.88895000D+01,0.18627000D+01
     .,0.26094910D+03,0.244D+03,0.122D+03,0.88895000D+01,0.18299000D+01
     .,0.25571250D+03,0.244D+03,0.123D+03,0.88895000D+01,0.19138000D+01
     .,0.25285150D+03,0.244D+03,0.124D+03,0.88895000D+01,0.18269000D+01
     .,0.23492290D+03,0.244D+03,0.125D+03,0.88895000D+01,0.16406000D+01
     .,0.21825880D+03,0.244D+03,0.126D+03,0.88895000D+01,0.16483000D+01
     .,0.20833810D+03,0.244D+03,0.127D+03,0.88895000D+01,0.17149000D+01
     .,0.20352280D+03,0.244D+03,0.128D+03,0.88895000D+01,0.17937000D+01
     .,0.19956410D+03,0.244D+03,0.129D+03,0.88895000D+01,0.95760000D+00
     .,0.18984580D+03,0.244D+03,0.130D+03,0.88895000D+01,0.19419000D+01
     .,0.30020530D+03,0.244D+03,0.131D+03,0.88895000D+01,0.96010000D+00
     .,0.26845380D+03,0.244D+03,0.132D+03,0.88895000D+01,0.94340000D+00
     .,0.24404670D+03,0.244D+03,0.133D+03,0.88895000D+01,0.98890000D+00
     .,0.22523300D+03,0.244D+03,0.134D+03,0.88895000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters( 111401: 111500)=(/
     . 0.20082890D+03,0.244D+03,0.135D+03,0.88895000D+01,0.99740000D+00
     .,0.31880410D+03,0.244D+03,0.137D+03,0.88895000D+01,0.97380000D+00
     .,0.59403870D+03,0.244D+03,0.138D+03,0.88895000D+01,0.98010000D+00
     .,0.46651060D+03,0.244D+03,0.139D+03,0.88895000D+01,0.19153000D+01
     .,0.35708190D+03,0.244D+03,0.140D+03,0.88895000D+01,0.19355000D+01
     .,0.36054300D+03,0.244D+03,0.141D+03,0.88895000D+01,0.19545000D+01
     .,0.33781860D+03,0.244D+03,0.142D+03,0.88895000D+01,0.19420000D+01
     .,0.37403450D+03,0.244D+03,0.143D+03,0.88895000D+01,0.16682000D+01
     .,0.29766760D+03,0.244D+03,0.144D+03,0.88895000D+01,0.18584000D+01
     .,0.27903330D+03,0.244D+03,0.145D+03,0.88895000D+01,0.19003000D+01
     .,0.25985840D+03,0.244D+03,0.146D+03,0.88895000D+01,0.18630000D+01
     .,0.25103670D+03,0.244D+03,0.147D+03,0.88895000D+01,0.96790000D+00
     .,0.24993600D+03,0.244D+03,0.148D+03,0.88895000D+01,0.19539000D+01
     .,0.38254570D+03,0.244D+03,0.149D+03,0.88895000D+01,0.96330000D+00
     .,0.35105910D+03,0.244D+03,0.150D+03,0.88895000D+01,0.95140000D+00
     .,0.33229950D+03,0.244D+03,0.151D+03,0.88895000D+01,0.97490000D+00
     .,0.31685780D+03,0.244D+03,0.152D+03,0.88895000D+01,0.98110000D+00
     .,0.29224830D+03,0.244D+03,0.153D+03,0.88895000D+01,0.99680000D+00
     .,0.38090100D+03,0.244D+03,0.155D+03,0.88895000D+01,0.99090000D+00
     .,0.76731680D+03,0.244D+03,0.156D+03,0.88895000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters( 111501: 111600)=(/
     . 0.58947680D+03,0.244D+03,0.157D+03,0.88895000D+01,0.19373000D+01
     .,0.38757590D+03,0.244D+03,0.159D+03,0.88895000D+01,0.29425000D+01
     .,0.37963090D+03,0.244D+03,0.160D+03,0.88895000D+01,0.29455000D+01
     .,0.36791330D+03,0.244D+03,0.161D+03,0.88895000D+01,0.29413000D+01
     .,0.36893680D+03,0.244D+03,0.162D+03,0.88895000D+01,0.29300000D+01
     .,0.35339960D+03,0.244D+03,0.163D+03,0.88895000D+01,0.18286000D+01
     .,0.37083500D+03,0.244D+03,0.164D+03,0.88895000D+01,0.28732000D+01
     .,0.34904790D+03,0.244D+03,0.165D+03,0.88895000D+01,0.29086000D+01
     .,0.35387000D+03,0.244D+03,0.166D+03,0.88895000D+01,0.28965000D+01
     .,0.33189420D+03,0.244D+03,0.167D+03,0.88895000D+01,0.29242000D+01
     .,0.32266300D+03,0.244D+03,0.168D+03,0.88895000D+01,0.29282000D+01
     .,0.32037880D+03,0.244D+03,0.169D+03,0.88895000D+01,0.29246000D+01
     .,0.33542660D+03,0.244D+03,0.170D+03,0.88895000D+01,0.28482000D+01
     .,0.30995020D+03,0.244D+03,0.171D+03,0.88895000D+01,0.29219000D+01
     .,0.40980230D+03,0.244D+03,0.172D+03,0.88895000D+01,0.19254000D+01
     .,0.38380190D+03,0.244D+03,0.173D+03,0.88895000D+01,0.19459000D+01
     .,0.35352930D+03,0.244D+03,0.174D+03,0.88895000D+01,0.19292000D+01
     .,0.35500360D+03,0.244D+03,0.175D+03,0.88895000D+01,0.18104000D+01
     .,0.31737010D+03,0.244D+03,0.176D+03,0.88895000D+01,0.18858000D+01
     .,0.29978350D+03,0.244D+03,0.177D+03,0.88895000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters( 111601: 111700)=(/
     . 0.28707700D+03,0.244D+03,0.178D+03,0.88895000D+01,0.19188000D+01
     .,0.27465620D+03,0.244D+03,0.179D+03,0.88895000D+01,0.98460000D+00
     .,0.26716680D+03,0.244D+03,0.180D+03,0.88895000D+01,0.19896000D+01
     .,0.41292460D+03,0.244D+03,0.181D+03,0.88895000D+01,0.92670000D+00
     .,0.38150770D+03,0.244D+03,0.182D+03,0.88895000D+01,0.93830000D+00
     .,0.37276100D+03,0.244D+03,0.183D+03,0.88895000D+01,0.98200000D+00
     .,0.36468730D+03,0.244D+03,0.184D+03,0.88895000D+01,0.98150000D+00
     .,0.34349450D+03,0.244D+03,0.185D+03,0.88895000D+01,0.99540000D+00
     .,0.42926480D+03,0.244D+03,0.187D+03,0.88895000D+01,0.97050000D+00
     .,0.76957810D+03,0.244D+03,0.188D+03,0.88895000D+01,0.96620000D+00
     .,0.45825190D+03,0.244D+03,0.189D+03,0.88895000D+01,0.29070000D+01
     .,0.52305080D+03,0.244D+03,0.190D+03,0.88895000D+01,0.28844000D+01
     .,0.47040220D+03,0.244D+03,0.191D+03,0.88895000D+01,0.28738000D+01
     .,0.41948400D+03,0.244D+03,0.192D+03,0.88895000D+01,0.28878000D+01
     .,0.40459980D+03,0.244D+03,0.193D+03,0.88895000D+01,0.29095000D+01
     .,0.47467630D+03,0.244D+03,0.194D+03,0.88895000D+01,0.19209000D+01
     .,0.11243910D+03,0.244D+03,0.204D+03,0.88895000D+01,0.19697000D+01
     .,0.11151080D+03,0.244D+03,0.205D+03,0.88895000D+01,0.19441000D+01
     .,0.83694600D+02,0.244D+03,0.206D+03,0.88895000D+01,0.19985000D+01
     .,0.68072000D+02,0.244D+03,0.207D+03,0.88895000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters( 111701: 111800)=(/
     . 0.47784700D+02,0.244D+03,0.208D+03,0.88895000D+01,0.19887000D+01
     .,0.19631020D+03,0.244D+03,0.212D+03,0.88895000D+01,0.19496000D+01
     .,0.23698540D+03,0.244D+03,0.213D+03,0.88895000D+01,0.19311000D+01
     .,0.23009880D+03,0.244D+03,0.214D+03,0.88895000D+01,0.19435000D+01
     .,0.20278480D+03,0.244D+03,0.215D+03,0.88895000D+01,0.20102000D+01
     .,0.17302410D+03,0.244D+03,0.216D+03,0.88895000D+01,0.19903000D+01
     .,0.27628420D+03,0.244D+03,0.220D+03,0.88895000D+01,0.19349000D+01
     .,0.26790880D+03,0.244D+03,0.221D+03,0.88895000D+01,0.28999000D+01
     .,0.27143870D+03,0.244D+03,0.222D+03,0.88895000D+01,0.38675000D+01
     .,0.24860210D+03,0.244D+03,0.223D+03,0.88895000D+01,0.29110000D+01
     .,0.19071700D+03,0.244D+03,0.224D+03,0.88895000D+01,0.10619100D+02
     .,0.16490150D+03,0.244D+03,0.225D+03,0.88895000D+01,0.98849000D+01
     .,0.16168180D+03,0.244D+03,0.226D+03,0.88895000D+01,0.91376000D+01
     .,0.18635590D+03,0.244D+03,0.227D+03,0.88895000D+01,0.29263000D+01
     .,0.17440700D+03,0.244D+03,0.228D+03,0.88895000D+01,0.65458000D+01
     .,0.24186460D+03,0.244D+03,0.231D+03,0.88895000D+01,0.19315000D+01
     .,0.25639940D+03,0.244D+03,0.232D+03,0.88895000D+01,0.19447000D+01
     .,0.23809660D+03,0.244D+03,0.233D+03,0.88895000D+01,0.19793000D+01
     .,0.22355550D+03,0.244D+03,0.234D+03,0.88895000D+01,0.19812000D+01
     .,0.33186870D+03,0.244D+03,0.238D+03,0.88895000D+01,0.19143000D+01
     ./)
      grimme_c6_parameters( 111801: 111900)=(/
     . 0.32301240D+03,0.244D+03,0.239D+03,0.88895000D+01,0.28903000D+01
     .,0.32694770D+03,0.244D+03,0.240D+03,0.88895000D+01,0.39106000D+01
     .,0.31629900D+03,0.244D+03,0.241D+03,0.88895000D+01,0.29225000D+01
     .,0.28288320D+03,0.244D+03,0.242D+03,0.88895000D+01,0.11055600D+02
     .,0.25200750D+03,0.244D+03,0.243D+03,0.88895000D+01,0.95402000D+01
     .,0.23900710D+03,0.244D+03,0.244D+03,0.88895000D+01,0.88895000D+01
     .,0.26980300D+02,0.245D+03,0.100D+01,0.29696000D+01,0.91180000D+00
     .,0.18402600D+02,0.245D+03,0.200D+01,0.29696000D+01,0.00000000D+00
     .,0.39027660D+03,0.245D+03,0.300D+01,0.29696000D+01,0.00000000D+00
     .,0.23089960D+03,0.245D+03,0.400D+01,0.29696000D+01,0.00000000D+00
     .,0.15871240D+03,0.245D+03,0.500D+01,0.29696000D+01,0.00000000D+00
     .,0.10928410D+03,0.245D+03,0.600D+01,0.29696000D+01,0.00000000D+00
     .,0.77707400D+02,0.245D+03,0.700D+01,0.29696000D+01,0.00000000D+00
     .,0.59619400D+02,0.245D+03,0.800D+01,0.29696000D+01,0.00000000D+00
     .,0.45728900D+02,0.245D+03,0.900D+01,0.29696000D+01,0.00000000D+00
     .,0.35556300D+02,0.245D+03,0.100D+02,0.29696000D+01,0.00000000D+00
     .,0.46780860D+03,0.245D+03,0.110D+02,0.29696000D+01,0.00000000D+00
     .,0.36632450D+03,0.245D+03,0.120D+02,0.29696000D+01,0.00000000D+00
     .,0.34074550D+03,0.245D+03,0.130D+02,0.29696000D+01,0.00000000D+00
     .,0.27209130D+03,0.245D+03,0.140D+02,0.29696000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 111901: 112000)=(/
     . 0.21501450D+03,0.245D+03,0.150D+02,0.29696000D+01,0.00000000D+00
     .,0.18027000D+03,0.245D+03,0.160D+02,0.29696000D+01,0.00000000D+00
     .,0.14881480D+03,0.245D+03,0.170D+02,0.29696000D+01,0.00000000D+00
     .,0.12298220D+03,0.245D+03,0.180D+02,0.29696000D+01,0.00000000D+00
     .,0.76742050D+03,0.245D+03,0.190D+02,0.29696000D+01,0.00000000D+00
     .,0.64014310D+03,0.245D+03,0.200D+02,0.29696000D+01,0.00000000D+00
     .,0.53051110D+03,0.245D+03,0.210D+02,0.29696000D+01,0.00000000D+00
     .,0.51447440D+03,0.245D+03,0.220D+02,0.29696000D+01,0.00000000D+00
     .,0.47224010D+03,0.245D+03,0.230D+02,0.29696000D+01,0.00000000D+00
     .,0.37322320D+03,0.245D+03,0.240D+02,0.29696000D+01,0.00000000D+00
     .,0.40804110D+03,0.245D+03,0.250D+02,0.29696000D+01,0.00000000D+00
     .,0.32148500D+03,0.245D+03,0.260D+02,0.29696000D+01,0.00000000D+00
     .,0.34137600D+03,0.245D+03,0.270D+02,0.29696000D+01,0.00000000D+00
     .,0.35071710D+03,0.245D+03,0.280D+02,0.29696000D+01,0.00000000D+00
     .,0.26998860D+03,0.245D+03,0.290D+02,0.29696000D+01,0.00000000D+00
     .,0.27836200D+03,0.245D+03,0.300D+02,0.29696000D+01,0.00000000D+00
     .,0.32839780D+03,0.245D+03,0.310D+02,0.29696000D+01,0.00000000D+00
     .,0.29239200D+03,0.245D+03,0.320D+02,0.29696000D+01,0.00000000D+00
     .,0.25200000D+03,0.245D+03,0.330D+02,0.29696000D+01,0.00000000D+00
     .,0.22783110D+03,0.245D+03,0.340D+02,0.29696000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 112001: 112100)=(/
     . 0.20104720D+03,0.245D+03,0.350D+02,0.29696000D+01,0.00000000D+00
     .,0.17630020D+03,0.245D+03,0.360D+02,0.29696000D+01,0.00000000D+00
     .,0.86212220D+03,0.245D+03,0.370D+02,0.29696000D+01,0.00000000D+00
     .,0.76317560D+03,0.245D+03,0.380D+02,0.29696000D+01,0.00000000D+00
     .,0.67268360D+03,0.245D+03,0.390D+02,0.29696000D+01,0.00000000D+00
     .,0.60730800D+03,0.245D+03,0.400D+02,0.29696000D+01,0.00000000D+00
     .,0.55572040D+03,0.245D+03,0.410D+02,0.29696000D+01,0.00000000D+00
     .,0.43227820D+03,0.245D+03,0.420D+02,0.29696000D+01,0.00000000D+00
     .,0.48090810D+03,0.245D+03,0.430D+02,0.29696000D+01,0.00000000D+00
     .,0.36943280D+03,0.245D+03,0.440D+02,0.29696000D+01,0.00000000D+00
     .,0.40294980D+03,0.245D+03,0.450D+02,0.29696000D+01,0.00000000D+00
     .,0.37453940D+03,0.245D+03,0.460D+02,0.29696000D+01,0.00000000D+00
     .,0.31311430D+03,0.245D+03,0.470D+02,0.29696000D+01,0.00000000D+00
     .,0.33108150D+03,0.245D+03,0.480D+02,0.29696000D+01,0.00000000D+00
     .,0.41228890D+03,0.245D+03,0.490D+02,0.29696000D+01,0.00000000D+00
     .,0.38378510D+03,0.245D+03,0.500D+02,0.29696000D+01,0.00000000D+00
     .,0.34480820D+03,0.245D+03,0.510D+02,0.29696000D+01,0.00000000D+00
     .,0.32172250D+03,0.245D+03,0.520D+02,0.29696000D+01,0.00000000D+00
     .,0.29282270D+03,0.245D+03,0.530D+02,0.29696000D+01,0.00000000D+00
     .,0.26506110D+03,0.245D+03,0.540D+02,0.29696000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 112101: 112200)=(/
     . 0.10513610D+04,0.245D+03,0.550D+02,0.29696000D+01,0.00000000D+00
     .,0.97214520D+03,0.245D+03,0.560D+02,0.29696000D+01,0.00000000D+00
     .,0.85902210D+03,0.245D+03,0.570D+02,0.29696000D+01,0.00000000D+00
     .,0.40725580D+03,0.245D+03,0.580D+02,0.29696000D+01,0.27991000D+01
     .,0.86353440D+03,0.245D+03,0.590D+02,0.29696000D+01,0.00000000D+00
     .,0.82985260D+03,0.245D+03,0.600D+02,0.29696000D+01,0.00000000D+00
     .,0.80920320D+03,0.245D+03,0.610D+02,0.29696000D+01,0.00000000D+00
     .,0.79017910D+03,0.245D+03,0.620D+02,0.29696000D+01,0.00000000D+00
     .,0.77331220D+03,0.245D+03,0.630D+02,0.29696000D+01,0.00000000D+00
     .,0.61339590D+03,0.245D+03,0.640D+02,0.29696000D+01,0.00000000D+00
     .,0.68497150D+03,0.245D+03,0.650D+02,0.29696000D+01,0.00000000D+00
     .,0.66143730D+03,0.245D+03,0.660D+02,0.29696000D+01,0.00000000D+00
     .,0.69834480D+03,0.245D+03,0.670D+02,0.29696000D+01,0.00000000D+00
     .,0.68356120D+03,0.245D+03,0.680D+02,0.29696000D+01,0.00000000D+00
     .,0.67029400D+03,0.245D+03,0.690D+02,0.29696000D+01,0.00000000D+00
     .,0.66217850D+03,0.245D+03,0.700D+02,0.29696000D+01,0.00000000D+00
     .,0.56118900D+03,0.245D+03,0.710D+02,0.29696000D+01,0.00000000D+00
     .,0.55510630D+03,0.245D+03,0.720D+02,0.29696000D+01,0.00000000D+00
     .,0.50914750D+03,0.245D+03,0.730D+02,0.29696000D+01,0.00000000D+00
     .,0.43253910D+03,0.245D+03,0.740D+02,0.29696000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 112201: 112300)=(/
     . 0.44058660D+03,0.245D+03,0.750D+02,0.29696000D+01,0.00000000D+00
     .,0.40122800D+03,0.245D+03,0.760D+02,0.29696000D+01,0.00000000D+00
     .,0.36898490D+03,0.245D+03,0.770D+02,0.29696000D+01,0.00000000D+00
     .,0.30849150D+03,0.245D+03,0.780D+02,0.29696000D+01,0.00000000D+00
     .,0.28895780D+03,0.245D+03,0.790D+02,0.29696000D+01,0.00000000D+00
     .,0.29737620D+03,0.245D+03,0.800D+02,0.29696000D+01,0.00000000D+00
     .,0.42541930D+03,0.245D+03,0.810D+02,0.29696000D+01,0.00000000D+00
     .,0.41768300D+03,0.245D+03,0.820D+02,0.29696000D+01,0.00000000D+00
     .,0.38636610D+03,0.245D+03,0.830D+02,0.29696000D+01,0.00000000D+00
     .,0.37011470D+03,0.245D+03,0.840D+02,0.29696000D+01,0.00000000D+00
     .,0.34358050D+03,0.245D+03,0.850D+02,0.29696000D+01,0.00000000D+00
     .,0.31677380D+03,0.245D+03,0.860D+02,0.29696000D+01,0.00000000D+00
     .,0.99738560D+03,0.245D+03,0.870D+02,0.29696000D+01,0.00000000D+00
     .,0.96461400D+03,0.245D+03,0.880D+02,0.29696000D+01,0.00000000D+00
     .,0.85721330D+03,0.245D+03,0.890D+02,0.29696000D+01,0.00000000D+00
     .,0.77636620D+03,0.245D+03,0.900D+02,0.29696000D+01,0.00000000D+00
     .,0.76896120D+03,0.245D+03,0.910D+02,0.29696000D+01,0.00000000D+00
     .,0.74479890D+03,0.245D+03,0.920D+02,0.29696000D+01,0.00000000D+00
     .,0.76357260D+03,0.245D+03,0.930D+02,0.29696000D+01,0.00000000D+00
     .,0.73996210D+03,0.245D+03,0.940D+02,0.29696000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 112301: 112400)=(/
     . 0.42771400D+02,0.245D+03,0.101D+03,0.29696000D+01,0.00000000D+00
     .,0.13469310D+03,0.245D+03,0.103D+03,0.29696000D+01,0.98650000D+00
     .,0.17260210D+03,0.245D+03,0.104D+03,0.29696000D+01,0.98080000D+00
     .,0.13425050D+03,0.245D+03,0.105D+03,0.29696000D+01,0.97060000D+00
     .,0.10261550D+03,0.245D+03,0.106D+03,0.29696000D+01,0.98680000D+00
     .,0.72586300D+02,0.245D+03,0.107D+03,0.29696000D+01,0.99440000D+00
     .,0.53693400D+02,0.245D+03,0.108D+03,0.29696000D+01,0.99250000D+00
     .,0.37696700D+02,0.245D+03,0.109D+03,0.29696000D+01,0.99820000D+00
     .,0.19669260D+03,0.245D+03,0.111D+03,0.29696000D+01,0.96840000D+00
     .,0.30353120D+03,0.245D+03,0.112D+03,0.29696000D+01,0.96280000D+00
     .,0.30963670D+03,0.245D+03,0.113D+03,0.29696000D+01,0.96480000D+00
     .,0.25211010D+03,0.245D+03,0.114D+03,0.29696000D+01,0.95070000D+00
     .,0.20887230D+03,0.245D+03,0.115D+03,0.29696000D+01,0.99470000D+00
     .,0.17828770D+03,0.245D+03,0.116D+03,0.29696000D+01,0.99480000D+00
     .,0.14727550D+03,0.245D+03,0.117D+03,0.29696000D+01,0.99720000D+00
     .,0.27459280D+03,0.245D+03,0.119D+03,0.29696000D+01,0.97670000D+00
     .,0.51413850D+03,0.245D+03,0.120D+03,0.29696000D+01,0.98310000D+00
     .,0.27656690D+03,0.245D+03,0.121D+03,0.29696000D+01,0.18627000D+01
     .,0.26729850D+03,0.245D+03,0.122D+03,0.29696000D+01,0.18299000D+01
     .,0.26198070D+03,0.245D+03,0.123D+03,0.29696000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters( 112401: 112500)=(/
     . 0.25931910D+03,0.245D+03,0.124D+03,0.29696000D+01,0.18269000D+01
     .,0.23979050D+03,0.245D+03,0.125D+03,0.29696000D+01,0.16406000D+01
     .,0.22246400D+03,0.245D+03,0.126D+03,0.29696000D+01,0.16483000D+01
     .,0.21235000D+03,0.245D+03,0.127D+03,0.29696000D+01,0.17149000D+01
     .,0.20752820D+03,0.245D+03,0.128D+03,0.29696000D+01,0.17937000D+01
     .,0.20425110D+03,0.245D+03,0.129D+03,0.29696000D+01,0.95760000D+00
     .,0.19302210D+03,0.245D+03,0.130D+03,0.29696000D+01,0.19419000D+01
     .,0.30923520D+03,0.245D+03,0.131D+03,0.29696000D+01,0.96010000D+00
     .,0.27429900D+03,0.245D+03,0.132D+03,0.29696000D+01,0.94340000D+00
     .,0.24791670D+03,0.245D+03,0.133D+03,0.29696000D+01,0.98890000D+00
     .,0.22791320D+03,0.245D+03,0.134D+03,0.29696000D+01,0.99010000D+00
     .,0.20237580D+03,0.245D+03,0.135D+03,0.29696000D+01,0.99740000D+00
     .,0.32868890D+03,0.245D+03,0.137D+03,0.29696000D+01,0.97380000D+00
     .,0.62589490D+03,0.245D+03,0.138D+03,0.29696000D+01,0.98010000D+00
     .,0.48472570D+03,0.245D+03,0.139D+03,0.29696000D+01,0.19153000D+01
     .,0.36605390D+03,0.245D+03,0.140D+03,0.29696000D+01,0.19355000D+01
     .,0.36967440D+03,0.245D+03,0.141D+03,0.29696000D+01,0.19545000D+01
     .,0.34576000D+03,0.245D+03,0.142D+03,0.29696000D+01,0.19420000D+01
     .,0.38525950D+03,0.245D+03,0.143D+03,0.29696000D+01,0.16682000D+01
     .,0.30329340D+03,0.245D+03,0.144D+03,0.29696000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters( 112501: 112600)=(/
     . 0.28418210D+03,0.245D+03,0.145D+03,0.29696000D+01,0.19003000D+01
     .,0.26443210D+03,0.245D+03,0.146D+03,0.29696000D+01,0.18630000D+01
     .,0.25564790D+03,0.245D+03,0.147D+03,0.29696000D+01,0.96790000D+00
     .,0.25366630D+03,0.245D+03,0.148D+03,0.29696000D+01,0.19539000D+01
     .,0.39403700D+03,0.245D+03,0.149D+03,0.29696000D+01,0.96330000D+00
     .,0.35913800D+03,0.245D+03,0.150D+03,0.29696000D+01,0.95140000D+00
     .,0.33834720D+03,0.245D+03,0.151D+03,0.29696000D+01,0.97490000D+00
     .,0.32158990D+03,0.245D+03,0.152D+03,0.29696000D+01,0.98110000D+00
     .,0.29551790D+03,0.245D+03,0.153D+03,0.29696000D+01,0.99680000D+00
     .,0.39060480D+03,0.245D+03,0.155D+03,0.29696000D+01,0.99090000D+00
     .,0.81058950D+03,0.245D+03,0.156D+03,0.29696000D+01,0.97970000D+00
     .,0.61313650D+03,0.245D+03,0.157D+03,0.29696000D+01,0.19373000D+01
     .,0.39521610D+03,0.245D+03,0.159D+03,0.29696000D+01,0.29425000D+01
     .,0.38709050D+03,0.245D+03,0.160D+03,0.29696000D+01,0.29455000D+01
     .,0.37502280D+03,0.245D+03,0.161D+03,0.29696000D+01,0.29413000D+01
     .,0.37642310D+03,0.245D+03,0.162D+03,0.29696000D+01,0.29300000D+01
     .,0.36171140D+03,0.245D+03,0.163D+03,0.29696000D+01,0.18286000D+01
     .,0.37848060D+03,0.245D+03,0.164D+03,0.29696000D+01,0.28732000D+01
     .,0.35595940D+03,0.245D+03,0.165D+03,0.29696000D+01,0.29086000D+01
     .,0.36149530D+03,0.245D+03,0.166D+03,0.29696000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters( 112601: 112700)=(/
     . 0.33818990D+03,0.245D+03,0.167D+03,0.29696000D+01,0.29242000D+01
     .,0.32868340D+03,0.245D+03,0.168D+03,0.29696000D+01,0.29282000D+01
     .,0.32643780D+03,0.245D+03,0.169D+03,0.29696000D+01,0.29246000D+01
     .,0.34224650D+03,0.245D+03,0.170D+03,0.29696000D+01,0.28482000D+01
     .,0.31566390D+03,0.245D+03,0.171D+03,0.29696000D+01,0.29219000D+01
     .,0.42204710D+03,0.245D+03,0.172D+03,0.29696000D+01,0.19254000D+01
     .,0.39370480D+03,0.245D+03,0.173D+03,0.29696000D+01,0.19459000D+01
     .,0.36119710D+03,0.245D+03,0.174D+03,0.29696000D+01,0.19292000D+01
     .,0.36399550D+03,0.245D+03,0.175D+03,0.29696000D+01,0.18104000D+01
     .,0.32246250D+03,0.245D+03,0.176D+03,0.29696000D+01,0.18858000D+01
     .,0.30419920D+03,0.245D+03,0.177D+03,0.29696000D+01,0.18648000D+01
     .,0.29108740D+03,0.245D+03,0.178D+03,0.29696000D+01,0.19188000D+01
     .,0.27853890D+03,0.245D+03,0.179D+03,0.29696000D+01,0.98460000D+00
     .,0.27011300D+03,0.245D+03,0.180D+03,0.29696000D+01,0.19896000D+01
     .,0.42470380D+03,0.245D+03,0.181D+03,0.29696000D+01,0.92670000D+00
     .,0.38982000D+03,0.245D+03,0.182D+03,0.29696000D+01,0.93830000D+00
     .,0.37955200D+03,0.245D+03,0.183D+03,0.29696000D+01,0.98200000D+00
     .,0.37040460D+03,0.245D+03,0.184D+03,0.29696000D+01,0.98150000D+00
     .,0.34770470D+03,0.245D+03,0.185D+03,0.29696000D+01,0.99540000D+00
     .,0.44002170D+03,0.245D+03,0.187D+03,0.29696000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters( 112701: 112800)=(/
     . 0.80924300D+03,0.245D+03,0.188D+03,0.29696000D+01,0.96620000D+00
     .,0.46736610D+03,0.245D+03,0.189D+03,0.29696000D+01,0.29070000D+01
     .,0.53649470D+03,0.245D+03,0.190D+03,0.29696000D+01,0.28844000D+01
     .,0.48151730D+03,0.245D+03,0.191D+03,0.29696000D+01,0.28738000D+01
     .,0.42750540D+03,0.245D+03,0.192D+03,0.29696000D+01,0.28878000D+01
     .,0.41194110D+03,0.245D+03,0.193D+03,0.29696000D+01,0.29095000D+01
     .,0.48914000D+03,0.245D+03,0.194D+03,0.29696000D+01,0.19209000D+01
     .,0.11455870D+03,0.245D+03,0.204D+03,0.29696000D+01,0.19697000D+01
     .,0.11335080D+03,0.245D+03,0.205D+03,0.29696000D+01,0.19441000D+01
     .,0.84329800D+02,0.245D+03,0.206D+03,0.29696000D+01,0.19985000D+01
     .,0.68302900D+02,0.245D+03,0.207D+03,0.29696000D+01,0.20143000D+01
     .,0.47642200D+02,0.245D+03,0.208D+03,0.29696000D+01,0.19887000D+01
     .,0.20139880D+03,0.245D+03,0.212D+03,0.29696000D+01,0.19496000D+01
     .,0.24332100D+03,0.245D+03,0.213D+03,0.29696000D+01,0.19311000D+01
     .,0.23501080D+03,0.245D+03,0.214D+03,0.29696000D+01,0.19435000D+01
     .,0.20596780D+03,0.245D+03,0.215D+03,0.29696000D+01,0.20102000D+01
     .,0.17475170D+03,0.245D+03,0.216D+03,0.29696000D+01,0.19903000D+01
     .,0.28343990D+03,0.245D+03,0.220D+03,0.29696000D+01,0.19349000D+01
     .,0.27371790D+03,0.245D+03,0.221D+03,0.29696000D+01,0.28999000D+01
     .,0.27724060D+03,0.245D+03,0.222D+03,0.29696000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters( 112801: 112900)=(/
     . 0.25398530D+03,0.245D+03,0.223D+03,0.29696000D+01,0.29110000D+01
     .,0.19359700D+03,0.245D+03,0.224D+03,0.29696000D+01,0.10619100D+02
     .,0.16675330D+03,0.245D+03,0.225D+03,0.29696000D+01,0.98849000D+01
     .,0.16358130D+03,0.245D+03,0.226D+03,0.29696000D+01,0.91376000D+01
     .,0.18973800D+03,0.245D+03,0.227D+03,0.29696000D+01,0.29263000D+01
     .,0.17725080D+03,0.245D+03,0.228D+03,0.29696000D+01,0.65458000D+01
     .,0.24732620D+03,0.245D+03,0.231D+03,0.29696000D+01,0.19315000D+01
     .,0.26164130D+03,0.245D+03,0.232D+03,0.29696000D+01,0.19447000D+01
     .,0.24169560D+03,0.245D+03,0.233D+03,0.29696000D+01,0.19793000D+01
     .,0.22618930D+03,0.245D+03,0.234D+03,0.29696000D+01,0.19812000D+01
     .,0.34023920D+03,0.245D+03,0.238D+03,0.29696000D+01,0.19143000D+01
     .,0.32940570D+03,0.245D+03,0.239D+03,0.29696000D+01,0.28903000D+01
     .,0.33291030D+03,0.245D+03,0.240D+03,0.29696000D+01,0.39106000D+01
     .,0.32221010D+03,0.245D+03,0.241D+03,0.29696000D+01,0.29225000D+01
     .,0.28693400D+03,0.245D+03,0.242D+03,0.29696000D+01,0.11055600D+02
     .,0.25477490D+03,0.245D+03,0.243D+03,0.29696000D+01,0.95402000D+01
     .,0.24134970D+03,0.245D+03,0.244D+03,0.29696000D+01,0.88895000D+01
     .,0.24465860D+03,0.245D+03,0.245D+03,0.29696000D+01,0.29696000D+01
     .,0.28063100D+02,0.246D+03,0.100D+01,0.57095000D+01,0.91180000D+00
     .,0.19020800D+02,0.246D+03,0.200D+01,0.57095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 112901: 113000)=(/
     . 0.41221710D+03,0.246D+03,0.300D+01,0.57095000D+01,0.00000000D+00
     .,0.24288250D+03,0.246D+03,0.400D+01,0.57095000D+01,0.00000000D+00
     .,0.16615330D+03,0.246D+03,0.500D+01,0.57095000D+01,0.00000000D+00
     .,0.11391260D+03,0.246D+03,0.600D+01,0.57095000D+01,0.00000000D+00
     .,0.80711800D+02,0.246D+03,0.700D+01,0.57095000D+01,0.00000000D+00
     .,0.61761900D+02,0.246D+03,0.800D+01,0.57095000D+01,0.00000000D+00
     .,0.47264500D+02,0.246D+03,0.900D+01,0.57095000D+01,0.00000000D+00
     .,0.36683700D+02,0.246D+03,0.100D+02,0.57095000D+01,0.00000000D+00
     .,0.49392410D+03,0.246D+03,0.110D+02,0.57095000D+01,0.00000000D+00
     .,0.38571180D+03,0.246D+03,0.120D+02,0.57095000D+01,0.00000000D+00
     .,0.35802870D+03,0.246D+03,0.130D+02,0.57095000D+01,0.00000000D+00
     .,0.28501380D+03,0.246D+03,0.140D+02,0.57095000D+01,0.00000000D+00
     .,0.22452110D+03,0.246D+03,0.150D+02,0.57095000D+01,0.00000000D+00
     .,0.18780070D+03,0.246D+03,0.160D+02,0.57095000D+01,0.00000000D+00
     .,0.15466930D+03,0.246D+03,0.170D+02,0.57095000D+01,0.00000000D+00
     .,0.12754830D+03,0.246D+03,0.180D+02,0.57095000D+01,0.00000000D+00
     .,0.80942550D+03,0.246D+03,0.190D+02,0.57095000D+01,0.00000000D+00
     .,0.67457400D+03,0.246D+03,0.200D+02,0.57095000D+01,0.00000000D+00
     .,0.55875930D+03,0.246D+03,0.210D+02,0.57095000D+01,0.00000000D+00
     .,0.54137410D+03,0.246D+03,0.220D+02,0.57095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 113001: 113100)=(/
     . 0.49669050D+03,0.246D+03,0.230D+02,0.57095000D+01,0.00000000D+00
     .,0.39222970D+03,0.246D+03,0.240D+02,0.57095000D+01,0.00000000D+00
     .,0.42885090D+03,0.246D+03,0.250D+02,0.57095000D+01,0.00000000D+00
     .,0.33757700D+03,0.246D+03,0.260D+02,0.57095000D+01,0.00000000D+00
     .,0.35837430D+03,0.246D+03,0.270D+02,0.57095000D+01,0.00000000D+00
     .,0.36840320D+03,0.246D+03,0.280D+02,0.57095000D+01,0.00000000D+00
     .,0.28332920D+03,0.246D+03,0.290D+02,0.57095000D+01,0.00000000D+00
     .,0.29187250D+03,0.246D+03,0.300D+02,0.57095000D+01,0.00000000D+00
     .,0.34456860D+03,0.246D+03,0.310D+02,0.57095000D+01,0.00000000D+00
     .,0.30611920D+03,0.246D+03,0.320D+02,0.57095000D+01,0.00000000D+00
     .,0.26318210D+03,0.246D+03,0.330D+02,0.57095000D+01,0.00000000D+00
     .,0.23751920D+03,0.246D+03,0.340D+02,0.57095000D+01,0.00000000D+00
     .,0.20919710D+03,0.246D+03,0.350D+02,0.57095000D+01,0.00000000D+00
     .,0.18310950D+03,0.246D+03,0.360D+02,0.57095000D+01,0.00000000D+00
     .,0.90881520D+03,0.246D+03,0.370D+02,0.57095000D+01,0.00000000D+00
     .,0.80400360D+03,0.246D+03,0.380D+02,0.57095000D+01,0.00000000D+00
     .,0.70783430D+03,0.246D+03,0.390D+02,0.57095000D+01,0.00000000D+00
     .,0.63844630D+03,0.246D+03,0.400D+02,0.57095000D+01,0.00000000D+00
     .,0.58376530D+03,0.246D+03,0.410D+02,0.57095000D+01,0.00000000D+00
     .,0.45332840D+03,0.246D+03,0.420D+02,0.57095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 113101: 113200)=(/
     . 0.50466070D+03,0.246D+03,0.430D+02,0.57095000D+01,0.00000000D+00
     .,0.38697280D+03,0.246D+03,0.440D+02,0.57095000D+01,0.00000000D+00
     .,0.42232030D+03,0.246D+03,0.450D+02,0.57095000D+01,0.00000000D+00
     .,0.39235480D+03,0.246D+03,0.460D+02,0.57095000D+01,0.00000000D+00
     .,0.32780150D+03,0.246D+03,0.470D+02,0.57095000D+01,0.00000000D+00
     .,0.34660550D+03,0.246D+03,0.480D+02,0.57095000D+01,0.00000000D+00
     .,0.43231830D+03,0.246D+03,0.490D+02,0.57095000D+01,0.00000000D+00
     .,0.40184330D+03,0.246D+03,0.500D+02,0.57095000D+01,0.00000000D+00
     .,0.36034200D+03,0.246D+03,0.510D+02,0.57095000D+01,0.00000000D+00
     .,0.33576050D+03,0.246D+03,0.520D+02,0.57095000D+01,0.00000000D+00
     .,0.30512160D+03,0.246D+03,0.530D+02,0.57095000D+01,0.00000000D+00
     .,0.27575770D+03,0.246D+03,0.540D+02,0.57095000D+01,0.00000000D+00
     .,0.11077988D+04,0.246D+03,0.550D+02,0.57095000D+01,0.00000000D+00
     .,0.10240901D+04,0.246D+03,0.560D+02,0.57095000D+01,0.00000000D+00
     .,0.90399280D+03,0.246D+03,0.570D+02,0.57095000D+01,0.00000000D+00
     .,0.42561430D+03,0.246D+03,0.580D+02,0.57095000D+01,0.27991000D+01
     .,0.90929190D+03,0.246D+03,0.590D+02,0.57095000D+01,0.00000000D+00
     .,0.87375470D+03,0.246D+03,0.600D+02,0.57095000D+01,0.00000000D+00
     .,0.85199520D+03,0.246D+03,0.610D+02,0.57095000D+01,0.00000000D+00
     .,0.83195410D+03,0.246D+03,0.620D+02,0.57095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 113201: 113300)=(/
     . 0.81418450D+03,0.246D+03,0.630D+02,0.57095000D+01,0.00000000D+00
     .,0.64463620D+03,0.246D+03,0.640D+02,0.57095000D+01,0.00000000D+00
     .,0.72073150D+03,0.246D+03,0.650D+02,0.57095000D+01,0.00000000D+00
     .,0.69578030D+03,0.246D+03,0.660D+02,0.57095000D+01,0.00000000D+00
     .,0.73512820D+03,0.246D+03,0.670D+02,0.57095000D+01,0.00000000D+00
     .,0.71956930D+03,0.246D+03,0.680D+02,0.57095000D+01,0.00000000D+00
     .,0.70559090D+03,0.246D+03,0.690D+02,0.57095000D+01,0.00000000D+00
     .,0.69711310D+03,0.246D+03,0.700D+02,0.57095000D+01,0.00000000D+00
     .,0.59004660D+03,0.246D+03,0.710D+02,0.57095000D+01,0.00000000D+00
     .,0.58295090D+03,0.246D+03,0.720D+02,0.57095000D+01,0.00000000D+00
     .,0.53409830D+03,0.246D+03,0.730D+02,0.57095000D+01,0.00000000D+00
     .,0.45309060D+03,0.246D+03,0.740D+02,0.57095000D+01,0.00000000D+00
     .,0.46141030D+03,0.246D+03,0.750D+02,0.57095000D+01,0.00000000D+00
     .,0.41975000D+03,0.246D+03,0.760D+02,0.57095000D+01,0.00000000D+00
     .,0.38566670D+03,0.246D+03,0.770D+02,0.57095000D+01,0.00000000D+00
     .,0.32198390D+03,0.246D+03,0.780D+02,0.57095000D+01,0.00000000D+00
     .,0.30143730D+03,0.246D+03,0.790D+02,0.57095000D+01,0.00000000D+00
     .,0.31019540D+03,0.246D+03,0.800D+02,0.57095000D+01,0.00000000D+00
     .,0.44555610D+03,0.246D+03,0.810D+02,0.57095000D+01,0.00000000D+00
     .,0.43708990D+03,0.246D+03,0.820D+02,0.57095000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 113301: 113400)=(/
     . 0.40369830D+03,0.246D+03,0.830D+02,0.57095000D+01,0.00000000D+00
     .,0.38631140D+03,0.246D+03,0.840D+02,0.57095000D+01,0.00000000D+00
     .,0.35811890D+03,0.246D+03,0.850D+02,0.57095000D+01,0.00000000D+00
     .,0.32972180D+03,0.246D+03,0.860D+02,0.57095000D+01,0.00000000D+00
     .,0.10501750D+04,0.246D+03,0.870D+02,0.57095000D+01,0.00000000D+00
     .,0.10154760D+04,0.246D+03,0.880D+02,0.57095000D+01,0.00000000D+00
     .,0.90160180D+03,0.246D+03,0.890D+02,0.57095000D+01,0.00000000D+00
     .,0.81526350D+03,0.246D+03,0.900D+02,0.57095000D+01,0.00000000D+00
     .,0.80784930D+03,0.246D+03,0.910D+02,0.57095000D+01,0.00000000D+00
     .,0.78242750D+03,0.246D+03,0.920D+02,0.57095000D+01,0.00000000D+00
     .,0.80290250D+03,0.246D+03,0.930D+02,0.57095000D+01,0.00000000D+00
     .,0.77797910D+03,0.246D+03,0.940D+02,0.57095000D+01,0.00000000D+00
     .,0.44649800D+02,0.246D+03,0.101D+03,0.57095000D+01,0.00000000D+00
     .,0.14156390D+03,0.246D+03,0.103D+03,0.57095000D+01,0.98650000D+00
     .,0.18118110D+03,0.246D+03,0.104D+03,0.57095000D+01,0.98080000D+00
     .,0.14035990D+03,0.246D+03,0.105D+03,0.57095000D+01,0.97060000D+00
     .,0.10693200D+03,0.246D+03,0.106D+03,0.57095000D+01,0.98680000D+00
     .,0.75363600D+02,0.246D+03,0.107D+03,0.57095000D+01,0.99440000D+00
     .,0.55574400D+02,0.246D+03,0.108D+03,0.57095000D+01,0.99250000D+00
     .,0.38869700D+02,0.246D+03,0.109D+03,0.57095000D+01,0.99820000D+00
     ./)
      grimme_c6_parameters( 113401: 113500)=(/
     . 0.20679400D+03,0.246D+03,0.111D+03,0.57095000D+01,0.96840000D+00
     .,0.31921760D+03,0.246D+03,0.112D+03,0.57095000D+01,0.96280000D+00
     .,0.32513700D+03,0.246D+03,0.113D+03,0.57095000D+01,0.96480000D+00
     .,0.26392340D+03,0.246D+03,0.114D+03,0.57095000D+01,0.95070000D+00
     .,0.21806750D+03,0.246D+03,0.115D+03,0.57095000D+01,0.99470000D+00
     .,0.18573680D+03,0.246D+03,0.116D+03,0.57095000D+01,0.99480000D+00
     .,0.15307080D+03,0.246D+03,0.117D+03,0.57095000D+01,0.99720000D+00
     .,0.28782600D+03,0.246D+03,0.119D+03,0.57095000D+01,0.97670000D+00
     .,0.54107730D+03,0.246D+03,0.120D+03,0.57095000D+01,0.98310000D+00
     .,0.28949650D+03,0.246D+03,0.121D+03,0.57095000D+01,0.18627000D+01
     .,0.27971050D+03,0.246D+03,0.122D+03,0.57095000D+01,0.18299000D+01
     .,0.27414900D+03,0.246D+03,0.123D+03,0.57095000D+01,0.19138000D+01
     .,0.27142500D+03,0.246D+03,0.124D+03,0.57095000D+01,0.18269000D+01
     .,0.25071870D+03,0.246D+03,0.125D+03,0.57095000D+01,0.16406000D+01
     .,0.23247500D+03,0.246D+03,0.126D+03,0.57095000D+01,0.16483000D+01
     .,0.22187670D+03,0.246D+03,0.127D+03,0.57095000D+01,0.17149000D+01
     .,0.21686020D+03,0.246D+03,0.128D+03,0.57095000D+01,0.17937000D+01
     .,0.21363790D+03,0.246D+03,0.129D+03,0.57095000D+01,0.95760000D+00
     .,0.20155080D+03,0.246D+03,0.130D+03,0.57095000D+01,0.19419000D+01
     .,0.32427260D+03,0.246D+03,0.131D+03,0.57095000D+01,0.96010000D+00
     ./)
      grimme_c6_parameters( 113501: 113600)=(/
     . 0.28698700D+03,0.246D+03,0.132D+03,0.57095000D+01,0.94340000D+00
     .,0.25886990D+03,0.246D+03,0.133D+03,0.57095000D+01,0.98890000D+00
     .,0.23760650D+03,0.246D+03,0.134D+03,0.57095000D+01,0.99010000D+00
     .,0.21059700D+03,0.246D+03,0.135D+03,0.57095000D+01,0.99740000D+00
     .,0.34426700D+03,0.246D+03,0.137D+03,0.57095000D+01,0.97380000D+00
     .,0.65851960D+03,0.246D+03,0.138D+03,0.57095000D+01,0.98010000D+00
     .,0.50868390D+03,0.246D+03,0.139D+03,0.57095000D+01,0.19153000D+01
     .,0.38304250D+03,0.246D+03,0.140D+03,0.57095000D+01,0.19355000D+01
     .,0.38685740D+03,0.246D+03,0.141D+03,0.57095000D+01,0.19545000D+01
     .,0.36157810D+03,0.246D+03,0.142D+03,0.57095000D+01,0.19420000D+01
     .,0.40341880D+03,0.246D+03,0.143D+03,0.57095000D+01,0.16682000D+01
     .,0.31674990D+03,0.246D+03,0.144D+03,0.57095000D+01,0.18584000D+01
     .,0.29669340D+03,0.246D+03,0.145D+03,0.57095000D+01,0.19003000D+01
     .,0.27595750D+03,0.246D+03,0.146D+03,0.57095000D+01,0.18630000D+01
     .,0.26684590D+03,0.246D+03,0.147D+03,0.57095000D+01,0.96790000D+00
     .,0.26459410D+03,0.246D+03,0.148D+03,0.57095000D+01,0.19539000D+01
     .,0.41294080D+03,0.246D+03,0.149D+03,0.57095000D+01,0.96330000D+00
     .,0.37573450D+03,0.246D+03,0.150D+03,0.57095000D+01,0.95140000D+00
     .,0.35348570D+03,0.246D+03,0.151D+03,0.57095000D+01,0.97490000D+00
     .,0.33559490D+03,0.246D+03,0.152D+03,0.57095000D+01,0.98110000D+00
     ./)
      grimme_c6_parameters( 113601: 113700)=(/
     . 0.30794100D+03,0.246D+03,0.153D+03,0.57095000D+01,0.99680000D+00
     .,0.40861880D+03,0.246D+03,0.155D+03,0.57095000D+01,0.99090000D+00
     .,0.85276800D+03,0.246D+03,0.156D+03,0.57095000D+01,0.97970000D+00
     .,0.64344430D+03,0.246D+03,0.157D+03,0.57095000D+01,0.19373000D+01
     .,0.41297590D+03,0.246D+03,0.159D+03,0.57095000D+01,0.29425000D+01
     .,0.40447640D+03,0.246D+03,0.160D+03,0.57095000D+01,0.29455000D+01
     .,0.39181900D+03,0.246D+03,0.161D+03,0.57095000D+01,0.29413000D+01
     .,0.39338030D+03,0.246D+03,0.162D+03,0.57095000D+01,0.29300000D+01
     .,0.37830190D+03,0.246D+03,0.163D+03,0.57095000D+01,0.18286000D+01
     .,0.39560900D+03,0.246D+03,0.164D+03,0.57095000D+01,0.28732000D+01
     .,0.37196670D+03,0.246D+03,0.165D+03,0.57095000D+01,0.29086000D+01
     .,0.37790420D+03,0.246D+03,0.166D+03,0.57095000D+01,0.28965000D+01
     .,0.35332080D+03,0.246D+03,0.167D+03,0.57095000D+01,0.29242000D+01
     .,0.34335820D+03,0.246D+03,0.168D+03,0.57095000D+01,0.29282000D+01
     .,0.34104430D+03,0.246D+03,0.169D+03,0.57095000D+01,0.29246000D+01
     .,0.35776850D+03,0.246D+03,0.170D+03,0.57095000D+01,0.28482000D+01
     .,0.32975260D+03,0.246D+03,0.171D+03,0.57095000D+01,0.29219000D+01
     .,0.44211340D+03,0.246D+03,0.172D+03,0.57095000D+01,0.19254000D+01
     .,0.41196690D+03,0.246D+03,0.173D+03,0.57095000D+01,0.19459000D+01
     .,0.37750500D+03,0.246D+03,0.174D+03,0.57095000D+01,0.19292000D+01
     ./)
      grimme_c6_parameters( 113701: 113800)=(/
     . 0.38078680D+03,0.246D+03,0.175D+03,0.57095000D+01,0.18104000D+01
     .,0.33644710D+03,0.246D+03,0.176D+03,0.57095000D+01,0.18858000D+01
     .,0.31720710D+03,0.246D+03,0.177D+03,0.57095000D+01,0.18648000D+01
     .,0.30342150D+03,0.246D+03,0.178D+03,0.57095000D+01,0.19188000D+01
     .,0.29030040D+03,0.246D+03,0.179D+03,0.57095000D+01,0.98460000D+00
     .,0.28128840D+03,0.246D+03,0.180D+03,0.57095000D+01,0.19896000D+01
     .,0.44468180D+03,0.246D+03,0.181D+03,0.57095000D+01,0.92670000D+00
     .,0.40753420D+03,0.246D+03,0.182D+03,0.57095000D+01,0.93830000D+00
     .,0.39643040D+03,0.246D+03,0.183D+03,0.57095000D+01,0.98200000D+00
     .,0.38655960D+03,0.246D+03,0.184D+03,0.57095000D+01,0.98150000D+00
     .,0.36242110D+03,0.246D+03,0.185D+03,0.57095000D+01,0.99540000D+00
     .,0.46028590D+03,0.246D+03,0.187D+03,0.57095000D+01,0.97050000D+00
     .,0.85084330D+03,0.246D+03,0.188D+03,0.57095000D+01,0.96620000D+00
     .,0.48843100D+03,0.246D+03,0.189D+03,0.57095000D+01,0.29070000D+01
     .,0.56129360D+03,0.246D+03,0.190D+03,0.57095000D+01,0.28844000D+01
     .,0.50330170D+03,0.246D+03,0.191D+03,0.57095000D+01,0.28738000D+01
     .,0.44649080D+03,0.246D+03,0.192D+03,0.57095000D+01,0.28878000D+01
     .,0.43011690D+03,0.246D+03,0.193D+03,0.57095000D+01,0.29095000D+01
     .,0.51213360D+03,0.246D+03,0.194D+03,0.57095000D+01,0.19209000D+01
     .,0.11979600D+03,0.246D+03,0.204D+03,0.57095000D+01,0.19697000D+01
     ./)
      grimme_c6_parameters( 113801: 113900)=(/
     . 0.11834870D+03,0.246D+03,0.205D+03,0.57095000D+01,0.19441000D+01
     .,0.87732000D+02,0.246D+03,0.206D+03,0.57095000D+01,0.19985000D+01
     .,0.70890900D+02,0.246D+03,0.207D+03,0.57095000D+01,0.20143000D+01
     .,0.49262900D+02,0.246D+03,0.208D+03,0.57095000D+01,0.19887000D+01
     .,0.21108310D+03,0.246D+03,0.212D+03,0.57095000D+01,0.19496000D+01
     .,0.25499480D+03,0.246D+03,0.213D+03,0.57095000D+01,0.19311000D+01
     .,0.24589890D+03,0.246D+03,0.214D+03,0.57095000D+01,0.19435000D+01
     .,0.21505640D+03,0.246D+03,0.215D+03,0.57095000D+01,0.20102000D+01
     .,0.18203880D+03,0.246D+03,0.216D+03,0.57095000D+01,0.19903000D+01
     .,0.29681460D+03,0.246D+03,0.220D+03,0.57095000D+01,0.19349000D+01
     .,0.28630250D+03,0.246D+03,0.221D+03,0.57095000D+01,0.28999000D+01
     .,0.28995300D+03,0.246D+03,0.222D+03,0.57095000D+01,0.38675000D+01
     .,0.26557670D+03,0.246D+03,0.223D+03,0.57095000D+01,0.29110000D+01
     .,0.20190070D+03,0.246D+03,0.224D+03,0.57095000D+01,0.10619100D+02
     .,0.17364950D+03,0.246D+03,0.225D+03,0.57095000D+01,0.98849000D+01
     .,0.17037740D+03,0.246D+03,0.226D+03,0.57095000D+01,0.91376000D+01
     .,0.19810080D+03,0.246D+03,0.227D+03,0.57095000D+01,0.29263000D+01
     .,0.18495540D+03,0.246D+03,0.228D+03,0.57095000D+01,0.65458000D+01
     .,0.25878790D+03,0.246D+03,0.231D+03,0.57095000D+01,0.19315000D+01
     .,0.27362340D+03,0.246D+03,0.232D+03,0.57095000D+01,0.19447000D+01
     ./)
      grimme_c6_parameters( 113901: 114000)=(/
     . 0.25230300D+03,0.246D+03,0.233D+03,0.57095000D+01,0.19793000D+01
     .,0.23579430D+03,0.246D+03,0.234D+03,0.57095000D+01,0.19812000D+01
     .,0.35611480D+03,0.246D+03,0.238D+03,0.57095000D+01,0.19143000D+01
     .,0.34430530D+03,0.246D+03,0.239D+03,0.57095000D+01,0.28903000D+01
     .,0.34779920D+03,0.246D+03,0.240D+03,0.57095000D+01,0.39106000D+01
     .,0.33655350D+03,0.246D+03,0.241D+03,0.57095000D+01,0.29225000D+01
     .,0.29922510D+03,0.246D+03,0.242D+03,0.57095000D+01,0.11055600D+02
     .,0.26533520D+03,0.246D+03,0.243D+03,0.57095000D+01,0.95402000D+01
     .,0.25122310D+03,0.246D+03,0.244D+03,0.57095000D+01,0.88895000D+01
     .,0.25497130D+03,0.246D+03,0.245D+03,0.57095000D+01,0.29696000D+01
     .,0.26587460D+03,0.246D+03,0.246D+03,0.57095000D+01,0.57095000D+01
     .,0.34893100D+02,0.249D+03,0.100D+01,0.19378000D+01,0.91180000D+00
     .,0.22907600D+02,0.249D+03,0.200D+01,0.19378000D+01,0.00000000D+00
     .,0.56526540D+03,0.249D+03,0.300D+01,0.19378000D+01,0.00000000D+00
     .,0.32028070D+03,0.249D+03,0.400D+01,0.19378000D+01,0.00000000D+00
     .,0.21344840D+03,0.249D+03,0.500D+01,0.19378000D+01,0.00000000D+00
     .,0.14316020D+03,0.249D+03,0.600D+01,0.19378000D+01,0.00000000D+00
     .,0.99643500D+02,0.249D+03,0.700D+01,0.19378000D+01,0.00000000D+00
     .,0.75235100D+02,0.249D+03,0.800D+01,0.19378000D+01,0.00000000D+00
     .,0.56892200D+02,0.249D+03,0.900D+01,0.19378000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 114001: 114100)=(/
     . 0.43721500D+02,0.249D+03,0.100D+02,0.19378000D+01,0.00000000D+00
     .,0.67522680D+03,0.249D+03,0.110D+02,0.19378000D+01,0.00000000D+00
     .,0.51209020D+03,0.249D+03,0.120D+02,0.19378000D+01,0.00000000D+00
     .,0.46945400D+03,0.249D+03,0.130D+02,0.19378000D+01,0.00000000D+00
     .,0.36720280D+03,0.249D+03,0.140D+02,0.19378000D+01,0.00000000D+00
     .,0.28461460D+03,0.249D+03,0.150D+02,0.19378000D+01,0.00000000D+00
     .,0.23533010D+03,0.249D+03,0.160D+02,0.19378000D+01,0.00000000D+00
     .,0.19158160D+03,0.249D+03,0.170D+02,0.19378000D+01,0.00000000D+00
     .,0.15631790D+03,0.249D+03,0.180D+02,0.19378000D+01,0.00000000D+00
     .,0.11101907D+04,0.249D+03,0.190D+02,0.19378000D+01,0.00000000D+00
     .,0.90511860D+03,0.249D+03,0.200D+02,0.19378000D+01,0.00000000D+00
     .,0.74582820D+03,0.249D+03,0.210D+02,0.19378000D+01,0.00000000D+00
     .,0.71855370D+03,0.249D+03,0.220D+02,0.19378000D+01,0.00000000D+00
     .,0.65710020D+03,0.249D+03,0.230D+02,0.19378000D+01,0.00000000D+00
     .,0.51754970D+03,0.249D+03,0.240D+02,0.19378000D+01,0.00000000D+00
     .,0.56463620D+03,0.249D+03,0.250D+02,0.19378000D+01,0.00000000D+00
     .,0.44298550D+03,0.249D+03,0.260D+02,0.19378000D+01,0.00000000D+00
     .,0.46815800D+03,0.249D+03,0.270D+02,0.19378000D+01,0.00000000D+00
     .,0.48295770D+03,0.249D+03,0.280D+02,0.19378000D+01,0.00000000D+00
     .,0.37028130D+03,0.249D+03,0.290D+02,0.19378000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 114101: 114200)=(/
     . 0.37846340D+03,0.249D+03,0.300D+02,0.19378000D+01,0.00000000D+00
     .,0.44874480D+03,0.249D+03,0.310D+02,0.19378000D+01,0.00000000D+00
     .,0.39348230D+03,0.249D+03,0.320D+02,0.19378000D+01,0.00000000D+00
     .,0.33391140D+03,0.249D+03,0.330D+02,0.19378000D+01,0.00000000D+00
     .,0.29869330D+03,0.249D+03,0.340D+02,0.19378000D+01,0.00000000D+00
     .,0.26059250D+03,0.249D+03,0.350D+02,0.19378000D+01,0.00000000D+00
     .,0.22602150D+03,0.249D+03,0.360D+02,0.19378000D+01,0.00000000D+00
     .,0.12430036D+04,0.249D+03,0.370D+02,0.19378000D+01,0.00000000D+00
     .,0.10788447D+04,0.249D+03,0.380D+02,0.19378000D+01,0.00000000D+00
     .,0.94063630D+03,0.249D+03,0.390D+02,0.19378000D+01,0.00000000D+00
     .,0.84295940D+03,0.249D+03,0.400D+02,0.19378000D+01,0.00000000D+00
     .,0.76722430D+03,0.249D+03,0.410D+02,0.19378000D+01,0.00000000D+00
     .,0.59040500D+03,0.249D+03,0.420D+02,0.19378000D+01,0.00000000D+00
     .,0.65957470D+03,0.249D+03,0.430D+02,0.19378000D+01,0.00000000D+00
     .,0.50072770D+03,0.249D+03,0.440D+02,0.19378000D+01,0.00000000D+00
     .,0.54733000D+03,0.249D+03,0.450D+02,0.19378000D+01,0.00000000D+00
     .,0.50698660D+03,0.249D+03,0.460D+02,0.19378000D+01,0.00000000D+00
     .,0.42310210D+03,0.249D+03,0.470D+02,0.19378000D+01,0.00000000D+00
     .,0.44611840D+03,0.249D+03,0.480D+02,0.19378000D+01,0.00000000D+00
     .,0.56190060D+03,0.249D+03,0.490D+02,0.19378000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 114201: 114300)=(/
     . 0.51714790D+03,0.249D+03,0.500D+02,0.19378000D+01,0.00000000D+00
     .,0.45876760D+03,0.249D+03,0.510D+02,0.19378000D+01,0.00000000D+00
     .,0.42447180D+03,0.249D+03,0.520D+02,0.19378000D+01,0.00000000D+00
     .,0.38268090D+03,0.249D+03,0.530D+02,0.19378000D+01,0.00000000D+00
     .,0.34312810D+03,0.249D+03,0.540D+02,0.19378000D+01,0.00000000D+00
     .,0.15141166D+04,0.249D+03,0.550D+02,0.19378000D+01,0.00000000D+00
     .,0.13775185D+04,0.249D+03,0.560D+02,0.19378000D+01,0.00000000D+00
     .,0.12045072D+04,0.249D+03,0.570D+02,0.19378000D+01,0.00000000D+00
     .,0.54238350D+03,0.249D+03,0.580D+02,0.19378000D+01,0.27991000D+01
     .,0.12188063D+04,0.249D+03,0.590D+02,0.19378000D+01,0.00000000D+00
     .,0.11693656D+04,0.249D+03,0.600D+02,0.19378000D+01,0.00000000D+00
     .,0.11397842D+04,0.249D+03,0.610D+02,0.19378000D+01,0.00000000D+00
     .,0.11126065D+04,0.249D+03,0.620D+02,0.19378000D+01,0.00000000D+00
     .,0.10884965D+04,0.249D+03,0.630D+02,0.19378000D+01,0.00000000D+00
     .,0.85158160D+03,0.249D+03,0.640D+02,0.19378000D+01,0.00000000D+00
     .,0.96631820D+03,0.249D+03,0.650D+02,0.19378000D+01,0.00000000D+00
     .,0.93121350D+03,0.249D+03,0.660D+02,0.19378000D+01,0.00000000D+00
     .,0.98060600D+03,0.249D+03,0.670D+02,0.19378000D+01,0.00000000D+00
     .,0.95967190D+03,0.249D+03,0.680D+02,0.19378000D+01,0.00000000D+00
     .,0.94073330D+03,0.249D+03,0.690D+02,0.19378000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 114301: 114400)=(/
     . 0.92993260D+03,0.249D+03,0.700D+02,0.19378000D+01,0.00000000D+00
     .,0.78085310D+03,0.249D+03,0.710D+02,0.19378000D+01,0.00000000D+00
     .,0.76411810D+03,0.249D+03,0.720D+02,0.19378000D+01,0.00000000D+00
     .,0.69534460D+03,0.249D+03,0.730D+02,0.19378000D+01,0.00000000D+00
     .,0.58588080D+03,0.249D+03,0.740D+02,0.19378000D+01,0.00000000D+00
     .,0.59538900D+03,0.249D+03,0.750D+02,0.19378000D+01,0.00000000D+00
     .,0.53831140D+03,0.249D+03,0.760D+02,0.19378000D+01,0.00000000D+00
     .,0.49206190D+03,0.249D+03,0.770D+02,0.19378000D+01,0.00000000D+00
     .,0.40798400D+03,0.249D+03,0.780D+02,0.19378000D+01,0.00000000D+00
     .,0.38091340D+03,0.249D+03,0.790D+02,0.19378000D+01,0.00000000D+00
     .,0.39149310D+03,0.249D+03,0.800D+02,0.19378000D+01,0.00000000D+00
     .,0.57627840D+03,0.249D+03,0.810D+02,0.19378000D+01,0.00000000D+00
     .,0.56137620D+03,0.249D+03,0.820D+02,0.19378000D+01,0.00000000D+00
     .,0.51373240D+03,0.249D+03,0.830D+02,0.19378000D+01,0.00000000D+00
     .,0.48880570D+03,0.249D+03,0.840D+02,0.19378000D+01,0.00000000D+00
     .,0.44985640D+03,0.249D+03,0.850D+02,0.19378000D+01,0.00000000D+00
     .,0.41128990D+03,0.249D+03,0.860D+02,0.19378000D+01,0.00000000D+00
     .,0.14239693D+04,0.249D+03,0.870D+02,0.19378000D+01,0.00000000D+00
     .,0.13587684D+04,0.249D+03,0.880D+02,0.19378000D+01,0.00000000D+00
     .,0.11959642D+04,0.249D+03,0.890D+02,0.19378000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 114401: 114500)=(/
     . 0.10695257D+04,0.249D+03,0.900D+02,0.19378000D+01,0.00000000D+00
     .,0.10645406D+04,0.249D+03,0.910D+02,0.19378000D+01,0.00000000D+00
     .,0.10306377D+04,0.249D+03,0.920D+02,0.19378000D+01,0.00000000D+00
     .,0.10644434D+04,0.249D+03,0.930D+02,0.19378000D+01,0.00000000D+00
     .,0.10302277D+04,0.249D+03,0.940D+02,0.19378000D+01,0.00000000D+00
     .,0.56518900D+02,0.249D+03,0.101D+03,0.19378000D+01,0.00000000D+00
     .,0.18591700D+03,0.249D+03,0.103D+03,0.19378000D+01,0.98650000D+00
     .,0.23667710D+03,0.249D+03,0.104D+03,0.19378000D+01,0.98080000D+00
     .,0.17917550D+03,0.249D+03,0.105D+03,0.19378000D+01,0.97060000D+00
     .,0.13430140D+03,0.249D+03,0.106D+03,0.19378000D+01,0.98680000D+00
     .,0.92908600D+02,0.249D+03,0.107D+03,0.19378000D+01,0.99440000D+00
     .,0.67419300D+02,0.249D+03,0.108D+03,0.19378000D+01,0.99250000D+00
     .,0.46208200D+02,0.249D+03,0.109D+03,0.19378000D+01,0.99820000D+00
     .,0.27237350D+03,0.249D+03,0.111D+03,0.19378000D+01,0.96840000D+00
     .,0.42155730D+03,0.249D+03,0.112D+03,0.19378000D+01,0.96280000D+00
     .,0.42489670D+03,0.249D+03,0.113D+03,0.19378000D+01,0.96480000D+00
     .,0.33903150D+03,0.249D+03,0.114D+03,0.19378000D+01,0.95070000D+00
     .,0.27621540D+03,0.249D+03,0.115D+03,0.19378000D+01,0.99470000D+00
     .,0.23276490D+03,0.249D+03,0.116D+03,0.19378000D+01,0.99480000D+00
     .,0.18961390D+03,0.249D+03,0.117D+03,0.19378000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters( 114501: 114600)=(/
     . 0.37405850D+03,0.249D+03,0.119D+03,0.19378000D+01,0.97670000D+00
     .,0.72398140D+03,0.249D+03,0.120D+03,0.19378000D+01,0.98310000D+00
     .,0.37201170D+03,0.249D+03,0.121D+03,0.19378000D+01,0.18627000D+01
     .,0.35910570D+03,0.249D+03,0.122D+03,0.19378000D+01,0.18299000D+01
     .,0.35198070D+03,0.249D+03,0.123D+03,0.19378000D+01,0.19138000D+01
     .,0.34899300D+03,0.249D+03,0.124D+03,0.19378000D+01,0.18269000D+01
     .,0.32004310D+03,0.249D+03,0.125D+03,0.19378000D+01,0.16406000D+01
     .,0.29592090D+03,0.249D+03,0.126D+03,0.19378000D+01,0.16483000D+01
     .,0.28231300D+03,0.249D+03,0.127D+03,0.19378000D+01,0.17149000D+01
     .,0.27608710D+03,0.249D+03,0.128D+03,0.19378000D+01,0.17937000D+01
     .,0.27351670D+03,0.249D+03,0.129D+03,0.19378000D+01,0.95760000D+00
     .,0.25541010D+03,0.249D+03,0.130D+03,0.19378000D+01,0.19419000D+01
     .,0.42085570D+03,0.249D+03,0.131D+03,0.19378000D+01,0.96010000D+00
     .,0.36762820D+03,0.249D+03,0.132D+03,0.19378000D+01,0.94340000D+00
     .,0.32815180D+03,0.249D+03,0.133D+03,0.19378000D+01,0.98890000D+00
     .,0.29882440D+03,0.249D+03,0.134D+03,0.19378000D+01,0.99010000D+00
     .,0.26244940D+03,0.249D+03,0.135D+03,0.19378000D+01,0.99740000D+00
     .,0.44576050D+03,0.249D+03,0.137D+03,0.19378000D+01,0.97380000D+00
     .,0.88157390D+03,0.249D+03,0.138D+03,0.19378000D+01,0.98010000D+00
     .,0.66764710D+03,0.249D+03,0.139D+03,0.19378000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters( 114601: 114700)=(/
     . 0.49222910D+03,0.249D+03,0.140D+03,0.19378000D+01,0.19355000D+01
     .,0.49713820D+03,0.249D+03,0.141D+03,0.19378000D+01,0.19545000D+01
     .,0.46306700D+03,0.249D+03,0.142D+03,0.19378000D+01,0.19420000D+01
     .,0.52169780D+03,0.249D+03,0.143D+03,0.19378000D+01,0.16682000D+01
     .,0.40238250D+03,0.249D+03,0.144D+03,0.19378000D+01,0.18584000D+01
     .,0.37636250D+03,0.249D+03,0.145D+03,0.19378000D+01,0.19003000D+01
     .,0.34931490D+03,0.249D+03,0.146D+03,0.19378000D+01,0.18630000D+01
     .,0.33811650D+03,0.249D+03,0.147D+03,0.19378000D+01,0.96790000D+00
     .,0.33364080D+03,0.249D+03,0.148D+03,0.19378000D+01,0.19539000D+01
     .,0.53472480D+03,0.249D+03,0.149D+03,0.19378000D+01,0.96330000D+00
     .,0.48141850D+03,0.249D+03,0.150D+03,0.19378000D+01,0.95140000D+00
     .,0.44934480D+03,0.249D+03,0.151D+03,0.19378000D+01,0.97490000D+00
     .,0.42408620D+03,0.249D+03,0.152D+03,0.19378000D+01,0.98110000D+00
     .,0.38628580D+03,0.249D+03,0.153D+03,0.19378000D+01,0.99680000D+00
     .,0.52507760D+03,0.249D+03,0.155D+03,0.19378000D+01,0.99090000D+00
     .,0.11453931D+04,0.249D+03,0.156D+03,0.19378000D+01,0.97970000D+00
     .,0.84571730D+03,0.249D+03,0.157D+03,0.19378000D+01,0.19373000D+01
     .,0.52589560D+03,0.249D+03,0.159D+03,0.19378000D+01,0.29425000D+01
     .,0.51499740D+03,0.249D+03,0.160D+03,0.19378000D+01,0.29455000D+01
     .,0.49856690D+03,0.249D+03,0.161D+03,0.19378000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters( 114701: 114800)=(/
     . 0.50136870D+03,0.249D+03,0.162D+03,0.19378000D+01,0.29300000D+01
     .,0.48441020D+03,0.249D+03,0.163D+03,0.19378000D+01,0.18286000D+01
     .,0.50462370D+03,0.249D+03,0.164D+03,0.19378000D+01,0.28732000D+01
     .,0.47370770D+03,0.249D+03,0.165D+03,0.19378000D+01,0.29086000D+01
     .,0.48262190D+03,0.249D+03,0.166D+03,0.19378000D+01,0.28965000D+01
     .,0.44936380D+03,0.249D+03,0.167D+03,0.19378000D+01,0.29242000D+01
     .,0.43646450D+03,0.249D+03,0.168D+03,0.19378000D+01,0.29282000D+01
     .,0.43373820D+03,0.249D+03,0.169D+03,0.19378000D+01,0.29246000D+01
     .,0.45634090D+03,0.249D+03,0.170D+03,0.19378000D+01,0.28482000D+01
     .,0.41908700D+03,0.249D+03,0.171D+03,0.19378000D+01,0.29219000D+01
     .,0.57239970D+03,0.249D+03,0.172D+03,0.19378000D+01,0.19254000D+01
     .,0.52974800D+03,0.249D+03,0.173D+03,0.19378000D+01,0.19459000D+01
     .,0.48197450D+03,0.249D+03,0.174D+03,0.19378000D+01,0.19292000D+01
     .,0.48896420D+03,0.249D+03,0.175D+03,0.19378000D+01,0.18104000D+01
     .,0.42523900D+03,0.249D+03,0.176D+03,0.19378000D+01,0.18858000D+01
     .,0.39970400D+03,0.249D+03,0.177D+03,0.19378000D+01,0.18648000D+01
     .,0.38159490D+03,0.249D+03,0.178D+03,0.19378000D+01,0.19188000D+01
     .,0.36491310D+03,0.249D+03,0.179D+03,0.19378000D+01,0.98460000D+00
     .,0.35178910D+03,0.249D+03,0.180D+03,0.19378000D+01,0.19896000D+01
     .,0.57370310D+03,0.249D+03,0.181D+03,0.19378000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters( 114801: 114900)=(/
     . 0.52042840D+03,0.249D+03,0.182D+03,0.19378000D+01,0.93830000D+00
     .,0.50341800D+03,0.249D+03,0.183D+03,0.19378000D+01,0.98200000D+00
     .,0.48873500D+03,0.249D+03,0.184D+03,0.19378000D+01,0.98150000D+00
     .,0.45527610D+03,0.249D+03,0.185D+03,0.19378000D+01,0.99540000D+00
     .,0.59117920D+03,0.249D+03,0.187D+03,0.19378000D+01,0.97050000D+00
     .,0.11355611D+04,0.249D+03,0.188D+03,0.19378000D+01,0.96620000D+00
     .,0.62234260D+03,0.249D+03,0.189D+03,0.19378000D+01,0.29070000D+01
     .,0.72148760D+03,0.249D+03,0.190D+03,0.19378000D+01,0.28844000D+01
     .,0.64433230D+03,0.249D+03,0.191D+03,0.19378000D+01,0.28738000D+01
     .,0.56739040D+03,0.249D+03,0.192D+03,0.19378000D+01,0.28878000D+01
     .,0.54560930D+03,0.249D+03,0.193D+03,0.19378000D+01,0.29095000D+01
     .,0.66224690D+03,0.249D+03,0.194D+03,0.19378000D+01,0.19209000D+01
     .,0.15292390D+03,0.249D+03,0.204D+03,0.19378000D+01,0.19697000D+01
     .,0.15012670D+03,0.249D+03,0.205D+03,0.19378000D+01,0.19441000D+01
     .,0.10920000D+03,0.249D+03,0.206D+03,0.19378000D+01,0.19985000D+01
     .,0.87207600D+02,0.249D+03,0.207D+03,0.19378000D+01,0.20143000D+01
     .,0.59451100D+02,0.249D+03,0.208D+03,0.19378000D+01,0.19887000D+01
     .,0.27256770D+03,0.249D+03,0.212D+03,0.19378000D+01,0.19496000D+01
     .,0.32959200D+03,0.249D+03,0.213D+03,0.19378000D+01,0.19311000D+01
     .,0.31501770D+03,0.249D+03,0.214D+03,0.19378000D+01,0.19435000D+01
     ./)
      grimme_c6_parameters( 114901: 115000)=(/
     . 0.27258640D+03,0.249D+03,0.215D+03,0.19378000D+01,0.20102000D+01
     .,0.22804730D+03,0.249D+03,0.216D+03,0.19378000D+01,0.19903000D+01
     .,0.38227200D+03,0.249D+03,0.220D+03,0.19378000D+01,0.19349000D+01
     .,0.36630170D+03,0.249D+03,0.221D+03,0.19378000D+01,0.28999000D+01
     .,0.37073900D+03,0.249D+03,0.222D+03,0.19378000D+01,0.38675000D+01
     .,0.33943990D+03,0.249D+03,0.223D+03,0.19378000D+01,0.29110000D+01
     .,0.25457810D+03,0.249D+03,0.224D+03,0.19378000D+01,0.10619100D+02
     .,0.21724670D+03,0.249D+03,0.225D+03,0.19378000D+01,0.98849000D+01
     .,0.21333730D+03,0.249D+03,0.226D+03,0.19378000D+01,0.91376000D+01
     .,0.25122060D+03,0.249D+03,0.227D+03,0.19378000D+01,0.29263000D+01
     .,0.23374770D+03,0.249D+03,0.228D+03,0.19378000D+01,0.65458000D+01
     .,0.33179130D+03,0.249D+03,0.231D+03,0.19378000D+01,0.19315000D+01
     .,0.34968000D+03,0.249D+03,0.232D+03,0.19378000D+01,0.19447000D+01
     .,0.31937190D+03,0.249D+03,0.233D+03,0.19378000D+01,0.19793000D+01
     .,0.29645520D+03,0.249D+03,0.234D+03,0.19378000D+01,0.19812000D+01
     .,0.45781020D+03,0.249D+03,0.238D+03,0.19378000D+01,0.19143000D+01
     .,0.43894830D+03,0.249D+03,0.239D+03,0.19378000D+01,0.28903000D+01
     .,0.44222600D+03,0.249D+03,0.240D+03,0.19378000D+01,0.39106000D+01
     .,0.42786320D+03,0.249D+03,0.241D+03,0.19378000D+01,0.29225000D+01
     .,0.37713750D+03,0.249D+03,0.242D+03,0.19378000D+01,0.11055600D+02
     ./)
      grimme_c6_parameters( 115001: 115100)=(/
     . 0.33210880D+03,0.249D+03,0.243D+03,0.19378000D+01,0.95402000D+01
     .,0.31358880D+03,0.249D+03,0.244D+03,0.19378000D+01,0.88895000D+01
     .,0.32040110D+03,0.249D+03,0.245D+03,0.19378000D+01,0.29696000D+01
     .,0.33498740D+03,0.249D+03,0.246D+03,0.19378000D+01,0.57095000D+01
     .,0.42791400D+03,0.249D+03,0.249D+03,0.19378000D+01,0.19378000D+01
     .,0.37912200D+02,0.250D+03,0.100D+01,0.19505000D+01,0.91180000D+00
     .,0.24783300D+02,0.250D+03,0.200D+01,0.19505000D+01,0.00000000D+00
     .,0.61156120D+03,0.250D+03,0.300D+01,0.19505000D+01,0.00000000D+00
     .,0.34839490D+03,0.250D+03,0.400D+01,0.19505000D+01,0.00000000D+00
     .,0.23225130D+03,0.250D+03,0.500D+01,0.19505000D+01,0.00000000D+00
     .,0.15560830D+03,0.250D+03,0.600D+01,0.19505000D+01,0.00000000D+00
     .,0.10812990D+03,0.250D+03,0.700D+01,0.19505000D+01,0.00000000D+00
     .,0.81505800D+02,0.250D+03,0.800D+01,0.19505000D+01,0.00000000D+00
     .,0.61521400D+02,0.250D+03,0.900D+01,0.19505000D+01,0.00000000D+00
     .,0.47194200D+02,0.250D+03,0.100D+02,0.19505000D+01,0.00000000D+00
     .,0.73065870D+03,0.250D+03,0.110D+02,0.19505000D+01,0.00000000D+00
     .,0.55662410D+03,0.250D+03,0.120D+02,0.19505000D+01,0.00000000D+00
     .,0.51060870D+03,0.250D+03,0.130D+02,0.19505000D+01,0.00000000D+00
     .,0.39957740D+03,0.250D+03,0.140D+02,0.19505000D+01,0.00000000D+00
     .,0.30959920D+03,0.250D+03,0.150D+02,0.19505000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 115101: 115200)=(/
     . 0.25580130D+03,0.250D+03,0.160D+02,0.19505000D+01,0.00000000D+00
     .,0.20804020D+03,0.250D+03,0.170D+02,0.19505000D+01,0.00000000D+00
     .,0.16954570D+03,0.250D+03,0.180D+02,0.19505000D+01,0.00000000D+00
     .,0.11982993D+04,0.250D+03,0.190D+02,0.19505000D+01,0.00000000D+00
     .,0.98182060D+03,0.250D+03,0.200D+02,0.19505000D+01,0.00000000D+00
     .,0.80962470D+03,0.250D+03,0.210D+02,0.19505000D+01,0.00000000D+00
     .,0.78020170D+03,0.250D+03,0.220D+02,0.19505000D+01,0.00000000D+00
     .,0.71360600D+03,0.250D+03,0.230D+02,0.19505000D+01,0.00000000D+00
     .,0.56166940D+03,0.250D+03,0.240D+02,0.19505000D+01,0.00000000D+00
     .,0.61332300D+03,0.250D+03,0.250D+02,0.19505000D+01,0.00000000D+00
     .,0.48085880D+03,0.250D+03,0.260D+02,0.19505000D+01,0.00000000D+00
     .,0.50875980D+03,0.250D+03,0.270D+02,0.19505000D+01,0.00000000D+00
     .,0.52479280D+03,0.250D+03,0.280D+02,0.19505000D+01,0.00000000D+00
     .,0.40197520D+03,0.250D+03,0.290D+02,0.19505000D+01,0.00000000D+00
     .,0.41137780D+03,0.250D+03,0.300D+02,0.19505000D+01,0.00000000D+00
     .,0.48787860D+03,0.250D+03,0.310D+02,0.19505000D+01,0.00000000D+00
     .,0.42801030D+03,0.250D+03,0.320D+02,0.19505000D+01,0.00000000D+00
     .,0.36315760D+03,0.250D+03,0.330D+02,0.19505000D+01,0.00000000D+00
     .,0.32471350D+03,0.250D+03,0.340D+02,0.19505000D+01,0.00000000D+00
     .,0.28310510D+03,0.250D+03,0.350D+02,0.19505000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 115201: 115300)=(/
     . 0.24534090D+03,0.250D+03,0.360D+02,0.19505000D+01,0.00000000D+00
     .,0.13416152D+04,0.250D+03,0.370D+02,0.19505000D+01,0.00000000D+00
     .,0.11697495D+04,0.250D+03,0.380D+02,0.19505000D+01,0.00000000D+00
     .,0.10209627D+04,0.250D+03,0.390D+02,0.19505000D+01,0.00000000D+00
     .,0.91534550D+03,0.250D+03,0.400D+02,0.19505000D+01,0.00000000D+00
     .,0.83320500D+03,0.250D+03,0.410D+02,0.19505000D+01,0.00000000D+00
     .,0.64106430D+03,0.250D+03,0.420D+02,0.19505000D+01,0.00000000D+00
     .,0.71622390D+03,0.250D+03,0.430D+02,0.19505000D+01,0.00000000D+00
     .,0.54361040D+03,0.250D+03,0.440D+02,0.19505000D+01,0.00000000D+00
     .,0.59452770D+03,0.250D+03,0.450D+02,0.19505000D+01,0.00000000D+00
     .,0.55071590D+03,0.250D+03,0.460D+02,0.19505000D+01,0.00000000D+00
     .,0.45912190D+03,0.250D+03,0.470D+02,0.19505000D+01,0.00000000D+00
     .,0.48457590D+03,0.250D+03,0.480D+02,0.19505000D+01,0.00000000D+00
     .,0.61033820D+03,0.250D+03,0.490D+02,0.19505000D+01,0.00000000D+00
     .,0.56212760D+03,0.250D+03,0.500D+02,0.19505000D+01,0.00000000D+00
     .,0.49873950D+03,0.250D+03,0.510D+02,0.19505000D+01,0.00000000D+00
     .,0.46138680D+03,0.250D+03,0.520D+02,0.19505000D+01,0.00000000D+00
     .,0.41581730D+03,0.250D+03,0.530D+02,0.19505000D+01,0.00000000D+00
     .,0.37264800D+03,0.250D+03,0.540D+02,0.19505000D+01,0.00000000D+00
     .,0.16336348D+04,0.250D+03,0.550D+02,0.19505000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 115301: 115400)=(/
     . 0.14924625D+04,0.250D+03,0.560D+02,0.19505000D+01,0.00000000D+00
     .,0.13065898D+04,0.250D+03,0.570D+02,0.19505000D+01,0.00000000D+00
     .,0.58945280D+03,0.250D+03,0.580D+02,0.19505000D+01,0.27991000D+01
     .,0.13207683D+04,0.250D+03,0.590D+02,0.19505000D+01,0.00000000D+00
     .,0.12676087D+04,0.250D+03,0.600D+02,0.19505000D+01,0.00000000D+00
     .,0.12356389D+04,0.250D+03,0.610D+02,0.19505000D+01,0.00000000D+00
     .,0.12062616D+04,0.250D+03,0.620D+02,0.19505000D+01,0.00000000D+00
     .,0.11802039D+04,0.250D+03,0.630D+02,0.19505000D+01,0.00000000D+00
     .,0.92388260D+03,0.250D+03,0.640D+02,0.19505000D+01,0.00000000D+00
     .,0.10458286D+04,0.250D+03,0.650D+02,0.19505000D+01,0.00000000D+00
     .,0.10079093D+04,0.250D+03,0.660D+02,0.19505000D+01,0.00000000D+00
     .,0.10636161D+04,0.250D+03,0.670D+02,0.19505000D+01,0.00000000D+00
     .,0.10409736D+04,0.250D+03,0.680D+02,0.19505000D+01,0.00000000D+00
     .,0.10204995D+04,0.250D+03,0.690D+02,0.19505000D+01,0.00000000D+00
     .,0.10087709D+04,0.250D+03,0.700D+02,0.19505000D+01,0.00000000D+00
     .,0.84732020D+03,0.250D+03,0.710D+02,0.19505000D+01,0.00000000D+00
     .,0.83014100D+03,0.250D+03,0.720D+02,0.19505000D+01,0.00000000D+00
     .,0.75559170D+03,0.250D+03,0.730D+02,0.19505000D+01,0.00000000D+00
     .,0.63637500D+03,0.250D+03,0.740D+02,0.19505000D+01,0.00000000D+00
     .,0.64685600D+03,0.250D+03,0.750D+02,0.19505000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 115401: 115500)=(/
     . 0.58485060D+03,0.250D+03,0.760D+02,0.19505000D+01,0.00000000D+00
     .,0.53455500D+03,0.250D+03,0.770D+02,0.19505000D+01,0.00000000D+00
     .,0.44293230D+03,0.250D+03,0.780D+02,0.19505000D+01,0.00000000D+00
     .,0.41343530D+03,0.250D+03,0.790D+02,0.19505000D+01,0.00000000D+00
     .,0.42506050D+03,0.250D+03,0.800D+02,0.19505000D+01,0.00000000D+00
     .,0.62552300D+03,0.250D+03,0.810D+02,0.19505000D+01,0.00000000D+00
     .,0.60984910D+03,0.250D+03,0.820D+02,0.19505000D+01,0.00000000D+00
     .,0.55825050D+03,0.250D+03,0.830D+02,0.19505000D+01,0.00000000D+00
     .,0.53115730D+03,0.250D+03,0.840D+02,0.19505000D+01,0.00000000D+00
     .,0.48873370D+03,0.250D+03,0.850D+02,0.19505000D+01,0.00000000D+00
     .,0.44666830D+03,0.250D+03,0.860D+02,0.19505000D+01,0.00000000D+00
     .,0.15382573D+04,0.250D+03,0.870D+02,0.19505000D+01,0.00000000D+00
     .,0.14729117D+04,0.250D+03,0.880D+02,0.19505000D+01,0.00000000D+00
     .,0.12978097D+04,0.250D+03,0.890D+02,0.19505000D+01,0.00000000D+00
     .,0.11613917D+04,0.250D+03,0.900D+02,0.19505000D+01,0.00000000D+00
     .,0.11551516D+04,0.250D+03,0.910D+02,0.19505000D+01,0.00000000D+00
     .,0.11183627D+04,0.250D+03,0.920D+02,0.19505000D+01,0.00000000D+00
     .,0.11544374D+04,0.250D+03,0.930D+02,0.19505000D+01,0.00000000D+00
     .,0.11174761D+04,0.250D+03,0.940D+02,0.19505000D+01,0.00000000D+00
     .,0.61486800D+02,0.250D+03,0.101D+03,0.19505000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 115501: 115600)=(/
     . 0.20220530D+03,0.250D+03,0.103D+03,0.19505000D+01,0.98650000D+00
     .,0.25735510D+03,0.250D+03,0.104D+03,0.19505000D+01,0.98080000D+00
     .,0.19488950D+03,0.250D+03,0.105D+03,0.19505000D+01,0.97060000D+00
     .,0.14592740D+03,0.250D+03,0.106D+03,0.19505000D+01,0.98680000D+00
     .,0.10078260D+03,0.250D+03,0.107D+03,0.19505000D+01,0.99440000D+00
     .,0.72992300D+02,0.250D+03,0.108D+03,0.19505000D+01,0.99250000D+00
     .,0.49877800D+02,0.250D+03,0.109D+03,0.19505000D+01,0.99820000D+00
     .,0.29601550D+03,0.250D+03,0.111D+03,0.19505000D+01,0.96840000D+00
     .,0.45814250D+03,0.250D+03,0.112D+03,0.19505000D+01,0.96280000D+00
     .,0.46215210D+03,0.250D+03,0.113D+03,0.19505000D+01,0.96480000D+00
     .,0.36887960D+03,0.250D+03,0.114D+03,0.19505000D+01,0.95070000D+00
     .,0.30043180D+03,0.250D+03,0.115D+03,0.19505000D+01,0.99470000D+00
     .,0.25300030D+03,0.250D+03,0.116D+03,0.19505000D+01,0.99480000D+00
     .,0.20589540D+03,0.250D+03,0.117D+03,0.19505000D+01,0.99720000D+00
     .,0.40608450D+03,0.250D+03,0.119D+03,0.19505000D+01,0.97670000D+00
     .,0.78442190D+03,0.250D+03,0.120D+03,0.19505000D+01,0.98310000D+00
     .,0.40440960D+03,0.250D+03,0.121D+03,0.19505000D+01,0.18627000D+01
     .,0.39026550D+03,0.250D+03,0.122D+03,0.19505000D+01,0.18299000D+01
     .,0.38249970D+03,0.250D+03,0.123D+03,0.19505000D+01,0.19138000D+01
     .,0.37920210D+03,0.250D+03,0.124D+03,0.19505000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters( 115601: 115700)=(/
     . 0.34791510D+03,0.250D+03,0.125D+03,0.19505000D+01,0.16406000D+01
     .,0.32164840D+03,0.250D+03,0.126D+03,0.19505000D+01,0.16483000D+01
     .,0.30680410D+03,0.250D+03,0.127D+03,0.19505000D+01,0.17149000D+01
     .,0.30002320D+03,0.250D+03,0.128D+03,0.19505000D+01,0.17937000D+01
     .,0.29714060D+03,0.250D+03,0.129D+03,0.19505000D+01,0.95760000D+00
     .,0.27760830D+03,0.250D+03,0.130D+03,0.19505000D+01,0.19419000D+01
     .,0.45760310D+03,0.250D+03,0.131D+03,0.19505000D+01,0.96010000D+00
     .,0.39986460D+03,0.250D+03,0.132D+03,0.19505000D+01,0.94340000D+00
     .,0.35687340D+03,0.250D+03,0.133D+03,0.19505000D+01,0.98890000D+00
     .,0.32485020D+03,0.250D+03,0.134D+03,0.19505000D+01,0.99010000D+00
     .,0.28512610D+03,0.250D+03,0.135D+03,0.19505000D+01,0.99740000D+00
     .,0.48384610D+03,0.250D+03,0.137D+03,0.19505000D+01,0.97380000D+00
     .,0.95464460D+03,0.250D+03,0.138D+03,0.19505000D+01,0.98010000D+00
     .,0.72429340D+03,0.250D+03,0.139D+03,0.19505000D+01,0.19153000D+01
     .,0.53482740D+03,0.250D+03,0.140D+03,0.19505000D+01,0.19355000D+01
     .,0.54017920D+03,0.250D+03,0.141D+03,0.19505000D+01,0.19545000D+01
     .,0.50302360D+03,0.250D+03,0.142D+03,0.19505000D+01,0.19420000D+01
     .,0.56629020D+03,0.250D+03,0.143D+03,0.19505000D+01,0.16682000D+01
     .,0.43711840D+03,0.250D+03,0.144D+03,0.19505000D+01,0.18584000D+01
     .,0.40874340D+03,0.250D+03,0.145D+03,0.19505000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters( 115701: 115800)=(/
     . 0.37927910D+03,0.250D+03,0.146D+03,0.19505000D+01,0.18630000D+01
     .,0.36709070D+03,0.250D+03,0.147D+03,0.19505000D+01,0.96790000D+00
     .,0.36239660D+03,0.250D+03,0.148D+03,0.19505000D+01,0.19539000D+01
     .,0.58092600D+03,0.250D+03,0.149D+03,0.19505000D+01,0.96330000D+00
     .,0.52329100D+03,0.250D+03,0.150D+03,0.19505000D+01,0.95140000D+00
     .,0.48848390D+03,0.250D+03,0.151D+03,0.19505000D+01,0.97490000D+00
     .,0.46096710D+03,0.250D+03,0.152D+03,0.19505000D+01,0.98110000D+00
     .,0.41974500D+03,0.250D+03,0.153D+03,0.19505000D+01,0.99680000D+00
     .,0.57029930D+03,0.250D+03,0.155D+03,0.19505000D+01,0.99090000D+00
     .,0.12390351D+04,0.250D+03,0.156D+03,0.19505000D+01,0.97970000D+00
     .,0.91712310D+03,0.250D+03,0.157D+03,0.19505000D+01,0.19373000D+01
     .,0.57151660D+03,0.250D+03,0.159D+03,0.19505000D+01,0.29425000D+01
     .,0.55966960D+03,0.250D+03,0.160D+03,0.19505000D+01,0.29455000D+01
     .,0.54179760D+03,0.250D+03,0.161D+03,0.19505000D+01,0.29413000D+01
     .,0.54480780D+03,0.250D+03,0.162D+03,0.19505000D+01,0.29300000D+01
     .,0.52623920D+03,0.250D+03,0.163D+03,0.19505000D+01,0.18286000D+01
     .,0.54841680D+03,0.250D+03,0.164D+03,0.19505000D+01,0.28732000D+01
     .,0.51479430D+03,0.250D+03,0.165D+03,0.19505000D+01,0.29086000D+01
     .,0.52439740D+03,0.250D+03,0.166D+03,0.19505000D+01,0.28965000D+01
     .,0.48836000D+03,0.250D+03,0.167D+03,0.19505000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters( 115801: 115900)=(/
     . 0.47434360D+03,0.250D+03,0.168D+03,0.19505000D+01,0.29282000D+01
     .,0.47138980D+03,0.250D+03,0.169D+03,0.19505000D+01,0.29246000D+01
     .,0.49604540D+03,0.250D+03,0.170D+03,0.19505000D+01,0.28482000D+01
     .,0.45549010D+03,0.250D+03,0.171D+03,0.19505000D+01,0.29219000D+01
     .,0.62165690D+03,0.250D+03,0.172D+03,0.19505000D+01,0.19254000D+01
     .,0.57541630D+03,0.250D+03,0.173D+03,0.19505000D+01,0.19459000D+01
     .,0.52355470D+03,0.250D+03,0.174D+03,0.19505000D+01,0.19292000D+01
     .,0.53103290D+03,0.250D+03,0.175D+03,0.19505000D+01,0.18104000D+01
     .,0.46190580D+03,0.250D+03,0.176D+03,0.19505000D+01,0.18858000D+01
     .,0.43406330D+03,0.250D+03,0.177D+03,0.19505000D+01,0.18648000D+01
     .,0.41431110D+03,0.250D+03,0.178D+03,0.19505000D+01,0.19188000D+01
     .,0.39608640D+03,0.250D+03,0.179D+03,0.19505000D+01,0.98460000D+00
     .,0.38190670D+03,0.250D+03,0.180D+03,0.19505000D+01,0.19896000D+01
     .,0.62293810D+03,0.250D+03,0.181D+03,0.19505000D+01,0.92670000D+00
     .,0.56542470D+03,0.250D+03,0.182D+03,0.19505000D+01,0.93830000D+00
     .,0.54706010D+03,0.250D+03,0.183D+03,0.19505000D+01,0.98200000D+00
     .,0.53109590D+03,0.250D+03,0.184D+03,0.19505000D+01,0.98150000D+00
     .,0.49464220D+03,0.250D+03,0.185D+03,0.19505000D+01,0.99540000D+00
     .,0.64214730D+03,0.250D+03,0.187D+03,0.19505000D+01,0.97050000D+00
     .,0.12295628D+04,0.250D+03,0.188D+03,0.19505000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters( 115901: 116000)=(/
     . 0.67640190D+03,0.250D+03,0.189D+03,0.19505000D+01,0.29070000D+01
     .,0.78351290D+03,0.250D+03,0.190D+03,0.19505000D+01,0.28844000D+01
     .,0.69937990D+03,0.250D+03,0.191D+03,0.19505000D+01,0.28738000D+01
     .,0.61633520D+03,0.250D+03,0.192D+03,0.19505000D+01,0.28878000D+01
     .,0.59268480D+03,0.250D+03,0.193D+03,0.19505000D+01,0.29095000D+01
     .,0.71854240D+03,0.250D+03,0.194D+03,0.19505000D+01,0.19209000D+01
     .,0.16642480D+03,0.250D+03,0.204D+03,0.19505000D+01,0.19697000D+01
     .,0.16321840D+03,0.250D+03,0.205D+03,0.19505000D+01,0.19441000D+01
     .,0.11859420D+03,0.250D+03,0.206D+03,0.19505000D+01,0.19985000D+01
     .,0.94569600D+02,0.250D+03,0.207D+03,0.19505000D+01,0.20143000D+01
     .,0.64302200D+02,0.250D+03,0.208D+03,0.19505000D+01,0.19887000D+01
     .,0.29661470D+03,0.250D+03,0.212D+03,0.19505000D+01,0.19496000D+01
     .,0.35855000D+03,0.250D+03,0.213D+03,0.19505000D+01,0.19311000D+01
     .,0.34274070D+03,0.250D+03,0.214D+03,0.19505000D+01,0.19435000D+01
     .,0.29645720D+03,0.250D+03,0.215D+03,0.19505000D+01,0.20102000D+01
     .,0.24785630D+03,0.250D+03,0.216D+03,0.19505000D+01,0.19903000D+01
     .,0.41557270D+03,0.250D+03,0.220D+03,0.19505000D+01,0.19349000D+01
     .,0.39827950D+03,0.250D+03,0.221D+03,0.19505000D+01,0.28999000D+01
     .,0.40309190D+03,0.250D+03,0.222D+03,0.19505000D+01,0.38675000D+01
     .,0.36892090D+03,0.250D+03,0.223D+03,0.19505000D+01,0.29110000D+01
     ./)
      grimme_c6_parameters( 116001: 116100)=(/
     . 0.27646740D+03,0.250D+03,0.224D+03,0.19505000D+01,0.10619100D+02
     .,0.23583660D+03,0.250D+03,0.225D+03,0.19505000D+01,0.98849000D+01
     .,0.23159140D+03,0.250D+03,0.226D+03,0.19505000D+01,0.91376000D+01
     .,0.27286680D+03,0.250D+03,0.227D+03,0.19505000D+01,0.29263000D+01
     .,0.25387790D+03,0.250D+03,0.228D+03,0.19505000D+01,0.65458000D+01
     .,0.36080170D+03,0.250D+03,0.231D+03,0.19505000D+01,0.19315000D+01
     .,0.38032910D+03,0.250D+03,0.232D+03,0.19505000D+01,0.19447000D+01
     .,0.34730490D+03,0.250D+03,0.233D+03,0.19505000D+01,0.19793000D+01
     .,0.32226350D+03,0.250D+03,0.234D+03,0.19505000D+01,0.19812000D+01
     .,0.49753160D+03,0.250D+03,0.238D+03,0.19505000D+01,0.19143000D+01
     .,0.47720360D+03,0.250D+03,0.239D+03,0.19505000D+01,0.28903000D+01
     .,0.48076680D+03,0.250D+03,0.240D+03,0.19505000D+01,0.39106000D+01
     .,0.46495560D+03,0.250D+03,0.241D+03,0.19505000D+01,0.29225000D+01
     .,0.40969630D+03,0.250D+03,0.242D+03,0.19505000D+01,0.11055600D+02
     .,0.36063780D+03,0.250D+03,0.243D+03,0.19505000D+01,0.95402000D+01
     .,0.34045080D+03,0.250D+03,0.244D+03,0.19505000D+01,0.88895000D+01
     .,0.34781660D+03,0.250D+03,0.245D+03,0.19505000D+01,0.29696000D+01
     .,0.36373910D+03,0.250D+03,0.246D+03,0.19505000D+01,0.57095000D+01
     .,0.46496770D+03,0.250D+03,0.249D+03,0.19505000D+01,0.19378000D+01
     .,0.50541480D+03,0.250D+03,0.250D+03,0.19505000D+01,0.19505000D+01
     ./)
      grimme_c6_parameters( 116101: 116200)=(/
     . 0.36227700D+02,0.251D+03,0.100D+01,0.19523000D+01,0.91180000D+00
     .,0.24014100D+02,0.251D+03,0.200D+01,0.19523000D+01,0.00000000D+00
     .,0.54685470D+03,0.251D+03,0.300D+01,0.19523000D+01,0.00000000D+00
     .,0.32111700D+03,0.251D+03,0.400D+01,0.19523000D+01,0.00000000D+00
     .,0.21779050D+03,0.251D+03,0.500D+01,0.19523000D+01,0.00000000D+00
     .,0.14775190D+03,0.251D+03,0.600D+01,0.19523000D+01,0.00000000D+00
     .,0.10359080D+03,0.251D+03,0.700D+01,0.19523000D+01,0.00000000D+00
     .,0.78560000D+02,0.251D+03,0.800D+01,0.19523000D+01,0.00000000D+00
     .,0.59593700D+02,0.251D+03,0.900D+01,0.19523000D+01,0.00000000D+00
     .,0.45889400D+02,0.251D+03,0.100D+02,0.19523000D+01,0.00000000D+00
     .,0.65457160D+03,0.251D+03,0.110D+02,0.19523000D+01,0.00000000D+00
     .,0.51028240D+03,0.251D+03,0.120D+02,0.19523000D+01,0.00000000D+00
     .,0.47233520D+03,0.251D+03,0.130D+02,0.19523000D+01,0.00000000D+00
     .,0.37405660D+03,0.251D+03,0.140D+02,0.19523000D+01,0.00000000D+00
     .,0.29271450D+03,0.251D+03,0.150D+02,0.19523000D+01,0.00000000D+00
     .,0.24337850D+03,0.251D+03,0.160D+02,0.19523000D+01,0.00000000D+00
     .,0.19910820D+03,0.251D+03,0.170D+02,0.19523000D+01,0.00000000D+00
     .,0.16307830D+03,0.251D+03,0.180D+02,0.19523000D+01,0.00000000D+00
     .,0.10694211D+04,0.251D+03,0.190D+02,0.19523000D+01,0.00000000D+00
     .,0.89182320D+03,0.251D+03,0.200D+02,0.19523000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 116201: 116300)=(/
     . 0.73841210D+03,0.251D+03,0.210D+02,0.19523000D+01,0.00000000D+00
     .,0.71434970D+03,0.251D+03,0.220D+02,0.19523000D+01,0.00000000D+00
     .,0.65487180D+03,0.251D+03,0.230D+02,0.19523000D+01,0.00000000D+00
     .,0.51581520D+03,0.251D+03,0.240D+02,0.19523000D+01,0.00000000D+00
     .,0.56471100D+03,0.251D+03,0.250D+02,0.19523000D+01,0.00000000D+00
     .,0.44324120D+03,0.251D+03,0.260D+02,0.19523000D+01,0.00000000D+00
     .,0.47101860D+03,0.251D+03,0.270D+02,0.19523000D+01,0.00000000D+00
     .,0.48471110D+03,0.251D+03,0.280D+02,0.19523000D+01,0.00000000D+00
     .,0.37150280D+03,0.251D+03,0.290D+02,0.19523000D+01,0.00000000D+00
     .,0.38278190D+03,0.251D+03,0.300D+02,0.19523000D+01,0.00000000D+00
     .,0.45296620D+03,0.251D+03,0.310D+02,0.19523000D+01,0.00000000D+00
     .,0.40100980D+03,0.251D+03,0.320D+02,0.19523000D+01,0.00000000D+00
     .,0.34304870D+03,0.251D+03,0.330D+02,0.19523000D+01,0.00000000D+00
     .,0.30828460D+03,0.251D+03,0.340D+02,0.19523000D+01,0.00000000D+00
     .,0.27015060D+03,0.251D+03,0.350D+02,0.19523000D+01,0.00000000D+00
     .,0.23518820D+03,0.251D+03,0.360D+02,0.19523000D+01,0.00000000D+00
     .,0.11994646D+04,0.251D+03,0.370D+02,0.19523000D+01,0.00000000D+00
     .,0.10619947D+04,0.251D+03,0.380D+02,0.19523000D+01,0.00000000D+00
     .,0.93369560D+03,0.251D+03,0.390D+02,0.19523000D+01,0.00000000D+00
     .,0.84095330D+03,0.251D+03,0.400D+02,0.19523000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 116301: 116400)=(/
     . 0.76784150D+03,0.251D+03,0.410D+02,0.19523000D+01,0.00000000D+00
     .,0.59396240D+03,0.251D+03,0.420D+02,0.19523000D+01,0.00000000D+00
     .,0.66226990D+03,0.251D+03,0.430D+02,0.19523000D+01,0.00000000D+00
     .,0.50560890D+03,0.251D+03,0.440D+02,0.19523000D+01,0.00000000D+00
     .,0.55281280D+03,0.251D+03,0.450D+02,0.19523000D+01,0.00000000D+00
     .,0.51303450D+03,0.251D+03,0.460D+02,0.19523000D+01,0.00000000D+00
     .,0.42738710D+03,0.251D+03,0.470D+02,0.19523000D+01,0.00000000D+00
     .,0.45249980D+03,0.251D+03,0.480D+02,0.19523000D+01,0.00000000D+00
     .,0.56656420D+03,0.251D+03,0.490D+02,0.19523000D+01,0.00000000D+00
     .,0.52563100D+03,0.251D+03,0.500D+02,0.19523000D+01,0.00000000D+00
     .,0.46972550D+03,0.251D+03,0.510D+02,0.19523000D+01,0.00000000D+00
     .,0.43644300D+03,0.251D+03,0.520D+02,0.19523000D+01,0.00000000D+00
     .,0.39516260D+03,0.251D+03,0.530D+02,0.19523000D+01,0.00000000D+00
     .,0.35567420D+03,0.251D+03,0.540D+02,0.19523000D+01,0.00000000D+00
     .,0.14614083D+04,0.251D+03,0.550D+02,0.19523000D+01,0.00000000D+00
     .,0.13520527D+04,0.251D+03,0.560D+02,0.19523000D+01,0.00000000D+00
     .,0.11922239D+04,0.251D+03,0.570D+02,0.19523000D+01,0.00000000D+00
     .,0.55449760D+03,0.251D+03,0.580D+02,0.19523000D+01,0.27991000D+01
     .,0.11993914D+04,0.251D+03,0.590D+02,0.19523000D+01,0.00000000D+00
     .,0.11524260D+04,0.251D+03,0.600D+02,0.19523000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 116401: 116500)=(/
     . 0.11237195D+04,0.251D+03,0.610D+02,0.19523000D+01,0.00000000D+00
     .,0.10972997D+04,0.251D+03,0.620D+02,0.19523000D+01,0.00000000D+00
     .,0.10738792D+04,0.251D+03,0.630D+02,0.19523000D+01,0.00000000D+00
     .,0.84761650D+03,0.251D+03,0.640D+02,0.19523000D+01,0.00000000D+00
     .,0.94867820D+03,0.251D+03,0.650D+02,0.19523000D+01,0.00000000D+00
     .,0.91560320D+03,0.251D+03,0.660D+02,0.19523000D+01,0.00000000D+00
     .,0.96949560D+03,0.251D+03,0.670D+02,0.19523000D+01,0.00000000D+00
     .,0.94902750D+03,0.251D+03,0.680D+02,0.19523000D+01,0.00000000D+00
     .,0.93061310D+03,0.251D+03,0.690D+02,0.19523000D+01,0.00000000D+00
     .,0.91959590D+03,0.251D+03,0.700D+02,0.19523000D+01,0.00000000D+00
     .,0.77679900D+03,0.251D+03,0.710D+02,0.19523000D+01,0.00000000D+00
     .,0.76667010D+03,0.251D+03,0.720D+02,0.19523000D+01,0.00000000D+00
     .,0.70099760D+03,0.251D+03,0.730D+02,0.19523000D+01,0.00000000D+00
     .,0.59261750D+03,0.251D+03,0.740D+02,0.19523000D+01,0.00000000D+00
     .,0.60337400D+03,0.251D+03,0.750D+02,0.19523000D+01,0.00000000D+00
     .,0.54765300D+03,0.251D+03,0.760D+02,0.19523000D+01,0.00000000D+00
     .,0.50212300D+03,0.251D+03,0.770D+02,0.19523000D+01,0.00000000D+00
     .,0.41748050D+03,0.251D+03,0.780D+02,0.19523000D+01,0.00000000D+00
     .,0.39019750D+03,0.251D+03,0.790D+02,0.19523000D+01,0.00000000D+00
     .,0.40170990D+03,0.251D+03,0.800D+02,0.19523000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 116501: 116600)=(/
     . 0.58191410D+03,0.251D+03,0.810D+02,0.19523000D+01,0.00000000D+00
     .,0.57046250D+03,0.251D+03,0.820D+02,0.19523000D+01,0.00000000D+00
     .,0.52553390D+03,0.251D+03,0.830D+02,0.19523000D+01,0.00000000D+00
     .,0.50188930D+03,0.251D+03,0.840D+02,0.19523000D+01,0.00000000D+00
     .,0.46384860D+03,0.251D+03,0.850D+02,0.19523000D+01,0.00000000D+00
     .,0.42562050D+03,0.251D+03,0.860D+02,0.19523000D+01,0.00000000D+00
     .,0.13840410D+04,0.251D+03,0.870D+02,0.19523000D+01,0.00000000D+00
     .,0.13394353D+04,0.251D+03,0.880D+02,0.19523000D+01,0.00000000D+00
     .,0.11880075D+04,0.251D+03,0.890D+02,0.19523000D+01,0.00000000D+00
     .,0.10713664D+04,0.251D+03,0.900D+02,0.19523000D+01,0.00000000D+00
     .,0.10616930D+04,0.251D+03,0.910D+02,0.19523000D+01,0.00000000D+00
     .,0.10280688D+04,0.251D+03,0.920D+02,0.19523000D+01,0.00000000D+00
     .,0.10561396D+04,0.251D+03,0.930D+02,0.19523000D+01,0.00000000D+00
     .,0.10232018D+04,0.251D+03,0.940D+02,0.19523000D+01,0.00000000D+00
     .,0.58196200D+02,0.251D+03,0.101D+03,0.19523000D+01,0.00000000D+00
     .,0.18683530D+03,0.251D+03,0.103D+03,0.19523000D+01,0.98650000D+00
     .,0.23860370D+03,0.251D+03,0.104D+03,0.19523000D+01,0.98080000D+00
     .,0.18340000D+03,0.251D+03,0.105D+03,0.19523000D+01,0.97060000D+00
     .,0.13853490D+03,0.251D+03,0.106D+03,0.19523000D+01,0.98680000D+00
     .,0.96572400D+02,0.251D+03,0.107D+03,0.19523000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters( 116601: 116700)=(/
     . 0.70463400D+02,0.251D+03,0.108D+03,0.19523000D+01,0.99250000D+00
     .,0.48576600D+02,0.251D+03,0.109D+03,0.19523000D+01,0.99820000D+00
     .,0.27268930D+03,0.251D+03,0.111D+03,0.19523000D+01,0.96840000D+00
     .,0.42146260D+03,0.251D+03,0.112D+03,0.19523000D+01,0.96280000D+00
     .,0.42844370D+03,0.251D+03,0.113D+03,0.19523000D+01,0.96480000D+00
     .,0.34592360D+03,0.251D+03,0.114D+03,0.19523000D+01,0.95070000D+00
     .,0.28414620D+03,0.251D+03,0.115D+03,0.19523000D+01,0.99470000D+00
     .,0.24067810D+03,0.251D+03,0.116D+03,0.19523000D+01,0.99480000D+00
     .,0.19703300D+03,0.251D+03,0.117D+03,0.19523000D+01,0.99720000D+00
     .,0.37667550D+03,0.251D+03,0.119D+03,0.19523000D+01,0.97670000D+00
     .,0.71337770D+03,0.251D+03,0.120D+03,0.19523000D+01,0.98310000D+00
     .,0.37851240D+03,0.251D+03,0.121D+03,0.19523000D+01,0.18627000D+01
     .,0.36542570D+03,0.251D+03,0.122D+03,0.19523000D+01,0.18299000D+01
     .,0.35808830D+03,0.251D+03,0.123D+03,0.19523000D+01,0.19138000D+01
     .,0.35459770D+03,0.251D+03,0.124D+03,0.19523000D+01,0.18269000D+01
     .,0.32708070D+03,0.251D+03,0.125D+03,0.19523000D+01,0.16406000D+01
     .,0.30288030D+03,0.251D+03,0.126D+03,0.19523000D+01,0.16483000D+01
     .,0.28891150D+03,0.251D+03,0.127D+03,0.19523000D+01,0.17149000D+01
     .,0.28239730D+03,0.251D+03,0.128D+03,0.19523000D+01,0.17937000D+01
     .,0.27851920D+03,0.251D+03,0.129D+03,0.19523000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters( 116701: 116800)=(/
     . 0.26216840D+03,0.251D+03,0.130D+03,0.19523000D+01,0.19419000D+01
     .,0.42584750D+03,0.251D+03,0.131D+03,0.19523000D+01,0.96010000D+00
     .,0.37544380D+03,0.251D+03,0.132D+03,0.19523000D+01,0.94340000D+00
     .,0.33727630D+03,0.251D+03,0.133D+03,0.19523000D+01,0.98890000D+00
     .,0.30839060D+03,0.251D+03,0.134D+03,0.19523000D+01,0.99010000D+00
     .,0.27200760D+03,0.251D+03,0.135D+03,0.19523000D+01,0.99740000D+00
     .,0.44976690D+03,0.251D+03,0.137D+03,0.19523000D+01,0.97380000D+00
     .,0.86748280D+03,0.251D+03,0.138D+03,0.19523000D+01,0.98010000D+00
     .,0.66777030D+03,0.251D+03,0.139D+03,0.19523000D+01,0.19153000D+01
     .,0.50031680D+03,0.251D+03,0.140D+03,0.19523000D+01,0.19355000D+01
     .,0.50520350D+03,0.251D+03,0.141D+03,0.19523000D+01,0.19545000D+01
     .,0.47139900D+03,0.251D+03,0.142D+03,0.19523000D+01,0.19420000D+01
     .,0.52700000D+03,0.251D+03,0.143D+03,0.19523000D+01,0.16682000D+01
     .,0.41174300D+03,0.251D+03,0.144D+03,0.19523000D+01,0.18584000D+01
     .,0.38521960D+03,0.251D+03,0.145D+03,0.19523000D+01,0.19003000D+01
     .,0.35780550D+03,0.251D+03,0.146D+03,0.19523000D+01,0.18630000D+01
     .,0.34602160D+03,0.251D+03,0.147D+03,0.19523000D+01,0.96790000D+00
     .,0.34293620D+03,0.251D+03,0.148D+03,0.19523000D+01,0.19539000D+01
     .,0.54066240D+03,0.251D+03,0.149D+03,0.19523000D+01,0.96330000D+00
     .,0.49072030D+03,0.251D+03,0.150D+03,0.19523000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters( 116801: 116900)=(/
     . 0.46051500D+03,0.251D+03,0.151D+03,0.19523000D+01,0.97490000D+00
     .,0.43616550D+03,0.251D+03,0.152D+03,0.19523000D+01,0.98110000D+00
     .,0.39886600D+03,0.251D+03,0.153D+03,0.19523000D+01,0.99680000D+00
     .,0.53323930D+03,0.251D+03,0.155D+03,0.19523000D+01,0.99090000D+00
     .,0.11229068D+04,0.251D+03,0.156D+03,0.19523000D+01,0.97970000D+00
     .,0.84459250D+03,0.251D+03,0.157D+03,0.19523000D+01,0.19373000D+01
     .,0.53785080D+03,0.251D+03,0.159D+03,0.19523000D+01,0.29425000D+01
     .,0.52673890D+03,0.251D+03,0.160D+03,0.19523000D+01,0.29455000D+01
     .,0.51010490D+03,0.251D+03,0.161D+03,0.19523000D+01,0.29413000D+01
     .,0.51239170D+03,0.251D+03,0.162D+03,0.19523000D+01,0.29300000D+01
     .,0.49317410D+03,0.251D+03,0.163D+03,0.19523000D+01,0.18286000D+01
     .,0.51559660D+03,0.251D+03,0.164D+03,0.19523000D+01,0.28732000D+01
     .,0.48442780D+03,0.251D+03,0.165D+03,0.19523000D+01,0.29086000D+01
     .,0.49251520D+03,0.251D+03,0.166D+03,0.19523000D+01,0.28965000D+01
     .,0.45997740D+03,0.251D+03,0.167D+03,0.19523000D+01,0.29242000D+01
     .,0.44693120D+03,0.251D+03,0.168D+03,0.19523000D+01,0.29282000D+01
     .,0.44402250D+03,0.251D+03,0.169D+03,0.19523000D+01,0.29246000D+01
     .,0.46651200D+03,0.251D+03,0.170D+03,0.19523000D+01,0.28482000D+01
     .,0.42927350D+03,0.251D+03,0.171D+03,0.19523000D+01,0.29219000D+01
     .,0.57861310D+03,0.251D+03,0.172D+03,0.19523000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters( 116901: 117000)=(/
     . 0.53790480D+03,0.251D+03,0.173D+03,0.19523000D+01,0.19459000D+01
     .,0.49161910D+03,0.251D+03,0.174D+03,0.19523000D+01,0.19292000D+01
     .,0.49667380D+03,0.251D+03,0.175D+03,0.19523000D+01,0.18104000D+01
     .,0.43648690D+03,0.251D+03,0.176D+03,0.19523000D+01,0.18858000D+01
     .,0.41080070D+03,0.251D+03,0.177D+03,0.19523000D+01,0.18648000D+01
     .,0.39246080D+03,0.251D+03,0.178D+03,0.19523000D+01,0.19188000D+01
     .,0.37514240D+03,0.251D+03,0.179D+03,0.19523000D+01,0.98460000D+00
     .,0.36302260D+03,0.251D+03,0.180D+03,0.19523000D+01,0.19896000D+01
     .,0.58068260D+03,0.251D+03,0.181D+03,0.19523000D+01,0.92670000D+00
     .,0.53094590D+03,0.251D+03,0.182D+03,0.19523000D+01,0.93830000D+00
     .,0.51573940D+03,0.251D+03,0.183D+03,0.19523000D+01,0.98200000D+00
     .,0.50211810D+03,0.251D+03,0.184D+03,0.19523000D+01,0.98150000D+00
     .,0.46948140D+03,0.251D+03,0.185D+03,0.19523000D+01,0.99540000D+00
     .,0.60069020D+03,0.251D+03,0.187D+03,0.19523000D+01,0.97050000D+00
     .,0.11195215D+04,0.251D+03,0.188D+03,0.19523000D+01,0.96620000D+00
     .,0.63642920D+03,0.251D+03,0.189D+03,0.19523000D+01,0.29070000D+01
     .,0.73257850D+03,0.251D+03,0.190D+03,0.19523000D+01,0.28844000D+01
     .,0.65541880D+03,0.251D+03,0.191D+03,0.19523000D+01,0.28738000D+01
     .,0.58044230D+03,0.251D+03,0.192D+03,0.19523000D+01,0.28878000D+01
     .,0.55878270D+03,0.251D+03,0.193D+03,0.19523000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters( 117001: 117100)=(/
     . 0.66842250D+03,0.251D+03,0.194D+03,0.19523000D+01,0.19209000D+01
     .,0.15675410D+03,0.251D+03,0.204D+03,0.19523000D+01,0.19697000D+01
     .,0.15413350D+03,0.251D+03,0.205D+03,0.19523000D+01,0.19441000D+01
     .,0.11315480D+03,0.251D+03,0.206D+03,0.19523000D+01,0.19985000D+01
     .,0.90704300D+02,0.251D+03,0.207D+03,0.19523000D+01,0.20143000D+01
     .,0.62195400D+02,0.251D+03,0.208D+03,0.19523000D+01,0.19887000D+01
     .,0.27727810D+03,0.251D+03,0.212D+03,0.19523000D+01,0.19496000D+01
     .,0.33486500D+03,0.251D+03,0.213D+03,0.19523000D+01,0.19311000D+01
     .,0.32195190D+03,0.251D+03,0.214D+03,0.19523000D+01,0.19435000D+01
     .,0.28021780D+03,0.251D+03,0.215D+03,0.19523000D+01,0.20102000D+01
     .,0.23581280D+03,0.251D+03,0.216D+03,0.19523000D+01,0.19903000D+01
     .,0.38844680D+03,0.251D+03,0.220D+03,0.19523000D+01,0.19349000D+01
     .,0.37399630D+03,0.251D+03,0.221D+03,0.19523000D+01,0.28999000D+01
     .,0.37864590D+03,0.251D+03,0.222D+03,0.19523000D+01,0.38675000D+01
     .,0.34645320D+03,0.251D+03,0.223D+03,0.19523000D+01,0.29110000D+01
     .,0.26154130D+03,0.251D+03,0.224D+03,0.19523000D+01,0.10619100D+02
     .,0.22411260D+03,0.251D+03,0.225D+03,0.19523000D+01,0.98849000D+01
     .,0.21995380D+03,0.251D+03,0.226D+03,0.19523000D+01,0.91376000D+01
     .,0.25727540D+03,0.251D+03,0.227D+03,0.19523000D+01,0.29263000D+01
     .,0.23987350D+03,0.251D+03,0.228D+03,0.19523000D+01,0.65458000D+01
     ./)
      grimme_c6_parameters( 117101: 117200)=(/
     . 0.33847720D+03,0.251D+03,0.231D+03,0.19523000D+01,0.19315000D+01
     .,0.35762210D+03,0.251D+03,0.232D+03,0.19523000D+01,0.19447000D+01
     .,0.32850830D+03,0.251D+03,0.233D+03,0.19523000D+01,0.19793000D+01
     .,0.30597730D+03,0.251D+03,0.234D+03,0.19523000D+01,0.19812000D+01
     .,0.46536830D+03,0.251D+03,0.238D+03,0.19523000D+01,0.19143000D+01
     .,0.44902050D+03,0.251D+03,0.239D+03,0.19523000D+01,0.28903000D+01
     .,0.45315700D+03,0.251D+03,0.240D+03,0.19523000D+01,0.39106000D+01
     .,0.43804100D+03,0.251D+03,0.241D+03,0.19523000D+01,0.29225000D+01
     .,0.38788180D+03,0.251D+03,0.242D+03,0.19523000D+01,0.11055600D+02
     .,0.34276350D+03,0.251D+03,0.243D+03,0.19523000D+01,0.95402000D+01
     .,0.32403570D+03,0.251D+03,0.244D+03,0.19523000D+01,0.88895000D+01
     .,0.32956900D+03,0.251D+03,0.245D+03,0.19523000D+01,0.29696000D+01
     .,0.34418570D+03,0.251D+03,0.246D+03,0.19523000D+01,0.57095000D+01
     .,0.43665200D+03,0.251D+03,0.249D+03,0.19523000D+01,0.19378000D+01
     .,0.47467200D+03,0.251D+03,0.250D+03,0.19523000D+01,0.19505000D+01
     .,0.44805730D+03,0.251D+03,0.251D+03,0.19523000D+01,0.19523000D+01
     .,0.35246100D+02,0.252D+03,0.100D+01,0.19639000D+01,0.91180000D+00
     .,0.23585100D+02,0.252D+03,0.200D+01,0.19639000D+01,0.00000000D+00
     .,0.51271640D+03,0.252D+03,0.300D+01,0.19639000D+01,0.00000000D+00
     .,0.30576290D+03,0.252D+03,0.400D+01,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 117201: 117300)=(/
     . 0.20945590D+03,0.252D+03,0.500D+01,0.19639000D+01,0.00000000D+00
     .,0.14319470D+03,0.252D+03,0.600D+01,0.19639000D+01,0.00000000D+00
     .,0.10097450D+03,0.252D+03,0.700D+01,0.19639000D+01,0.00000000D+00
     .,0.76886300D+02,0.252D+03,0.800D+01,0.19639000D+01,0.00000000D+00
     .,0.58522300D+02,0.252D+03,0.900D+01,0.19639000D+01,0.00000000D+00
     .,0.45183600D+02,0.252D+03,0.100D+02,0.19639000D+01,0.00000000D+00
     .,0.61435230D+03,0.252D+03,0.110D+02,0.19639000D+01,0.00000000D+00
     .,0.48450380D+03,0.252D+03,0.120D+02,0.19639000D+01,0.00000000D+00
     .,0.45072670D+03,0.252D+03,0.130D+02,0.19639000D+01,0.00000000D+00
     .,0.35936400D+03,0.252D+03,0.140D+02,0.19639000D+01,0.00000000D+00
     .,0.28289020D+03,0.252D+03,0.150D+02,0.19639000D+01,0.00000000D+00
     .,0.23614560D+03,0.252D+03,0.160D+02,0.19639000D+01,0.00000000D+00
     .,0.19392690D+03,0.252D+03,0.170D+02,0.19639000D+01,0.00000000D+00
     .,0.15936080D+03,0.252D+03,0.180D+02,0.19639000D+01,0.00000000D+00
     .,0.10025559D+04,0.252D+03,0.190D+02,0.19639000D+01,0.00000000D+00
     .,0.84305400D+03,0.252D+03,0.200D+02,0.19639000D+01,0.00000000D+00
     .,0.69945860D+03,0.252D+03,0.210D+02,0.19639000D+01,0.00000000D+00
     .,0.67814850D+03,0.252D+03,0.220D+02,0.19639000D+01,0.00000000D+00
     .,0.62246350D+03,0.252D+03,0.230D+02,0.19639000D+01,0.00000000D+00
     .,0.49067860D+03,0.252D+03,0.240D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 117301: 117400)=(/
     . 0.53774700D+03,0.252D+03,0.250D+02,0.19639000D+01,0.00000000D+00
     .,0.42250680D+03,0.252D+03,0.260D+02,0.19639000D+01,0.00000000D+00
     .,0.44986640D+03,0.252D+03,0.270D+02,0.19639000D+01,0.00000000D+00
     .,0.46232080D+03,0.252D+03,0.280D+02,0.19639000D+01,0.00000000D+00
     .,0.35464230D+03,0.252D+03,0.290D+02,0.19639000D+01,0.00000000D+00
     .,0.36661620D+03,0.252D+03,0.300D+02,0.19639000D+01,0.00000000D+00
     .,0.43326650D+03,0.252D+03,0.310D+02,0.19639000D+01,0.00000000D+00
     .,0.38551090D+03,0.252D+03,0.320D+02,0.19639000D+01,0.00000000D+00
     .,0.33138440D+03,0.252D+03,0.330D+02,0.19639000D+01,0.00000000D+00
     .,0.29873310D+03,0.252D+03,0.340D+02,0.19639000D+01,0.00000000D+00
     .,0.26262260D+03,0.252D+03,0.350D+02,0.19639000D+01,0.00000000D+00
     .,0.22931350D+03,0.252D+03,0.360D+02,0.19639000D+01,0.00000000D+00
     .,0.11257134D+04,0.252D+03,0.370D+02,0.19639000D+01,0.00000000D+00
     .,0.10038665D+04,0.252D+03,0.380D+02,0.19639000D+01,0.00000000D+00
     .,0.88595760D+03,0.252D+03,0.390D+02,0.19639000D+01,0.00000000D+00
     .,0.79994710D+03,0.252D+03,0.400D+02,0.19639000D+01,0.00000000D+00
     .,0.73167410D+03,0.252D+03,0.410D+02,0.19639000D+01,0.00000000D+00
     .,0.56783410D+03,0.252D+03,0.420D+02,0.19639000D+01,0.00000000D+00
     .,0.63235020D+03,0.252D+03,0.430D+02,0.19639000D+01,0.00000000D+00
     .,0.48447400D+03,0.252D+03,0.440D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 117401: 117500)=(/
     . 0.52945790D+03,0.252D+03,0.450D+02,0.19639000D+01,0.00000000D+00
     .,0.49188120D+03,0.252D+03,0.460D+02,0.19639000D+01,0.00000000D+00
     .,0.40979950D+03,0.252D+03,0.470D+02,0.19639000D+01,0.00000000D+00
     .,0.43443580D+03,0.252D+03,0.480D+02,0.19639000D+01,0.00000000D+00
     .,0.54208910D+03,0.252D+03,0.490D+02,0.19639000D+01,0.00000000D+00
     .,0.50487630D+03,0.252D+03,0.500D+02,0.19639000D+01,0.00000000D+00
     .,0.45302540D+03,0.252D+03,0.510D+02,0.19639000D+01,0.00000000D+00
     .,0.42201870D+03,0.252D+03,0.520D+02,0.19639000D+01,0.00000000D+00
     .,0.38318370D+03,0.252D+03,0.530D+02,0.19639000D+01,0.00000000D+00
     .,0.34582830D+03,0.252D+03,0.540D+02,0.19639000D+01,0.00000000D+00
     .,0.13722422D+04,0.252D+03,0.550D+02,0.19639000D+01,0.00000000D+00
     .,0.12768973D+04,0.252D+03,0.560D+02,0.19639000D+01,0.00000000D+00
     .,0.11301276D+04,0.252D+03,0.570D+02,0.19639000D+01,0.00000000D+00
     .,0.53452440D+03,0.252D+03,0.580D+02,0.19639000D+01,0.27991000D+01
     .,0.11341681D+04,0.252D+03,0.590D+02,0.19639000D+01,0.00000000D+00
     .,0.10903536D+04,0.252D+03,0.600D+02,0.19639000D+01,0.00000000D+00
     .,0.10633516D+04,0.252D+03,0.610D+02,0.19639000D+01,0.00000000D+00
     .,0.10384792D+04,0.252D+03,0.620D+02,0.19639000D+01,0.00000000D+00
     .,0.10164371D+04,0.252D+03,0.630D+02,0.19639000D+01,0.00000000D+00
     .,0.80596520D+03,0.252D+03,0.640D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 117501: 117600)=(/
     . 0.89702580D+03,0.252D+03,0.650D+02,0.19639000D+01,0.00000000D+00
     .,0.86641260D+03,0.252D+03,0.660D+02,0.19639000D+01,0.00000000D+00
     .,0.91841900D+03,0.252D+03,0.670D+02,0.19639000D+01,0.00000000D+00
     .,0.89909510D+03,0.252D+03,0.680D+02,0.19639000D+01,0.00000000D+00
     .,0.88176000D+03,0.252D+03,0.690D+02,0.19639000D+01,0.00000000D+00
     .,0.87114240D+03,0.252D+03,0.700D+02,0.19639000D+01,0.00000000D+00
     .,0.73817630D+03,0.252D+03,0.710D+02,0.19639000D+01,0.00000000D+00
     .,0.73134130D+03,0.252D+03,0.720D+02,0.19639000D+01,0.00000000D+00
     .,0.67040070D+03,0.252D+03,0.730D+02,0.19639000D+01,0.00000000D+00
     .,0.56812010D+03,0.252D+03,0.740D+02,0.19639000D+01,0.00000000D+00
     .,0.57890380D+03,0.252D+03,0.750D+02,0.19639000D+01,0.00000000D+00
     .,0.52661010D+03,0.252D+03,0.760D+02,0.19639000D+01,0.00000000D+00
     .,0.48371080D+03,0.252D+03,0.770D+02,0.19639000D+01,0.00000000D+00
     .,0.40307740D+03,0.252D+03,0.780D+02,0.19639000D+01,0.00000000D+00
     .,0.37705920D+03,0.252D+03,0.790D+02,0.19639000D+01,0.00000000D+00
     .,0.38840990D+03,0.252D+03,0.800D+02,0.19639000D+01,0.00000000D+00
     .,0.55767540D+03,0.252D+03,0.810D+02,0.19639000D+01,0.00000000D+00
     .,0.54820960D+03,0.252D+03,0.820D+02,0.19639000D+01,0.00000000D+00
     .,0.50681290D+03,0.252D+03,0.830D+02,0.19639000D+01,0.00000000D+00
     .,0.48504920D+03,0.252D+03,0.840D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 117601: 117700)=(/
     . 0.44946500D+03,0.252D+03,0.850D+02,0.19639000D+01,0.00000000D+00
     .,0.41343530D+03,0.252D+03,0.860D+02,0.19639000D+01,0.00000000D+00
     .,0.13034917D+04,0.252D+03,0.870D+02,0.19639000D+01,0.00000000D+00
     .,0.12675667D+04,0.252D+03,0.880D+02,0.19639000D+01,0.00000000D+00
     .,0.11280206D+04,0.252D+03,0.890D+02,0.19639000D+01,0.00000000D+00
     .,0.10215531D+04,0.252D+03,0.900D+02,0.19639000D+01,0.00000000D+00
     .,0.10104948D+04,0.252D+03,0.910D+02,0.19639000D+01,0.00000000D+00
     .,0.97859690D+03,0.252D+03,0.920D+02,0.19639000D+01,0.00000000D+00
     .,0.10027172D+04,0.252D+03,0.930D+02,0.19639000D+01,0.00000000D+00
     .,0.97186890D+03,0.252D+03,0.940D+02,0.19639000D+01,0.00000000D+00
     .,0.56276900D+02,0.252D+03,0.101D+03,0.19639000D+01,0.00000000D+00
     .,0.17817450D+03,0.252D+03,0.103D+03,0.19639000D+01,0.98650000D+00
     .,0.22803400D+03,0.252D+03,0.104D+03,0.19639000D+01,0.98080000D+00
     .,0.17677650D+03,0.252D+03,0.105D+03,0.19639000D+01,0.97060000D+00
     .,0.13427420D+03,0.252D+03,0.106D+03,0.19639000D+01,0.98680000D+00
     .,0.94162200D+02,0.252D+03,0.107D+03,0.19639000D+01,0.99440000D+00
     .,0.69039900D+02,0.252D+03,0.108D+03,0.19639000D+01,0.99250000D+00
     .,0.47877100D+02,0.252D+03,0.109D+03,0.19639000D+01,0.99820000D+00
     .,0.25966980D+03,0.252D+03,0.111D+03,0.19639000D+01,0.96840000D+00
     .,0.40103040D+03,0.252D+03,0.112D+03,0.19639000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters( 117701: 117800)=(/
     . 0.40936850D+03,0.252D+03,0.113D+03,0.19639000D+01,0.96480000D+00
     .,0.33269600D+03,0.252D+03,0.114D+03,0.19639000D+01,0.95070000D+00
     .,0.27467950D+03,0.252D+03,0.115D+03,0.19639000D+01,0.99470000D+00
     .,0.23351090D+03,0.252D+03,0.116D+03,0.19639000D+01,0.99480000D+00
     .,0.19189600D+03,0.252D+03,0.117D+03,0.19639000D+01,0.99720000D+00
     .,0.36037990D+03,0.252D+03,0.119D+03,0.19639000D+01,0.97670000D+00
     .,0.67520960D+03,0.252D+03,0.120D+03,0.19639000D+01,0.98310000D+00
     .,0.36377550D+03,0.252D+03,0.121D+03,0.19639000D+01,0.18627000D+01
     .,0.35131790D+03,0.252D+03,0.122D+03,0.19639000D+01,0.18299000D+01
     .,0.34423720D+03,0.252D+03,0.123D+03,0.19639000D+01,0.19138000D+01
     .,0.34067740D+03,0.252D+03,0.124D+03,0.19639000D+01,0.18269000D+01
     .,0.31512290D+03,0.252D+03,0.125D+03,0.19639000D+01,0.16406000D+01
     .,0.29209790D+03,0.252D+03,0.126D+03,0.19639000D+01,0.16483000D+01
     .,0.27865290D+03,0.252D+03,0.127D+03,0.19639000D+01,0.17149000D+01
     .,0.27230380D+03,0.252D+03,0.128D+03,0.19639000D+01,0.17937000D+01
     .,0.26795690D+03,0.252D+03,0.129D+03,0.19639000D+01,0.95760000D+00
     .,0.25325200D+03,0.252D+03,0.130D+03,0.19639000D+01,0.19419000D+01
     .,0.40786260D+03,0.252D+03,0.131D+03,0.19639000D+01,0.96010000D+00
     .,0.36139310D+03,0.252D+03,0.132D+03,0.19639000D+01,0.94340000D+00
     .,0.32590920D+03,0.252D+03,0.133D+03,0.19639000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters( 117801: 117900)=(/
     . 0.29882550D+03,0.252D+03,0.134D+03,0.19639000D+01,0.99010000D+00
     .,0.26438680D+03,0.252D+03,0.135D+03,0.19639000D+01,0.99740000D+00
     .,0.43088900D+03,0.252D+03,0.137D+03,0.19639000D+01,0.97380000D+00
     .,0.82090550D+03,0.252D+03,0.138D+03,0.19639000D+01,0.98010000D+00
     .,0.63678340D+03,0.252D+03,0.139D+03,0.19639000D+01,0.19153000D+01
     .,0.48083080D+03,0.252D+03,0.140D+03,0.19639000D+01,0.19355000D+01
     .,0.48546850D+03,0.252D+03,0.141D+03,0.19639000D+01,0.19545000D+01
     .,0.45354170D+03,0.252D+03,0.142D+03,0.19639000D+01,0.19420000D+01
     .,0.50518300D+03,0.252D+03,0.143D+03,0.19639000D+01,0.16682000D+01
     .,0.39728740D+03,0.252D+03,0.144D+03,0.19639000D+01,0.18584000D+01
     .,0.37184930D+03,0.252D+03,0.145D+03,0.19639000D+01,0.19003000D+01
     .,0.34561400D+03,0.252D+03,0.146D+03,0.19639000D+01,0.18630000D+01
     .,0.33407750D+03,0.252D+03,0.147D+03,0.19639000D+01,0.96790000D+00
     .,0.33175670D+03,0.252D+03,0.148D+03,0.19639000D+01,0.19539000D+01
     .,0.51804080D+03,0.252D+03,0.149D+03,0.19639000D+01,0.96330000D+00
     .,0.47212430D+03,0.252D+03,0.150D+03,0.19639000D+01,0.95140000D+00
     .,0.44439750D+03,0.252D+03,0.151D+03,0.19639000D+01,0.97490000D+00
     .,0.42181780D+03,0.252D+03,0.152D+03,0.19639000D+01,0.98110000D+00
     .,0.38675500D+03,0.252D+03,0.153D+03,0.19639000D+01,0.99680000D+00
     .,0.51246920D+03,0.252D+03,0.155D+03,0.19639000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters( 117901: 118000)=(/
     . 0.10614185D+04,0.252D+03,0.156D+03,0.19639000D+01,0.97970000D+00
     .,0.80501180D+03,0.252D+03,0.157D+03,0.19639000D+01,0.19373000D+01
     .,0.51860750D+03,0.252D+03,0.159D+03,0.19639000D+01,0.29425000D+01
     .,0.50791390D+03,0.252D+03,0.160D+03,0.19639000D+01,0.29455000D+01
     .,0.49198270D+03,0.252D+03,0.161D+03,0.19639000D+01,0.29413000D+01
     .,0.49389760D+03,0.252D+03,0.162D+03,0.19639000D+01,0.29300000D+01
     .,0.47446600D+03,0.252D+03,0.163D+03,0.19639000D+01,0.18286000D+01
     .,0.49685260D+03,0.252D+03,0.164D+03,0.19639000D+01,0.28732000D+01
     .,0.46706730D+03,0.252D+03,0.165D+03,0.19639000D+01,0.29086000D+01
     .,0.47437630D+03,0.252D+03,0.166D+03,0.19639000D+01,0.28965000D+01
     .,0.44371620D+03,0.252D+03,0.167D+03,0.19639000D+01,0.29242000D+01
     .,0.43121480D+03,0.252D+03,0.168D+03,0.19639000D+01,0.29282000D+01
     .,0.42833450D+03,0.252D+03,0.169D+03,0.19639000D+01,0.29246000D+01
     .,0.44958170D+03,0.252D+03,0.170D+03,0.19639000D+01,0.28482000D+01
     .,0.41422170D+03,0.252D+03,0.171D+03,0.19639000D+01,0.29219000D+01
     .,0.55455640D+03,0.252D+03,0.172D+03,0.19639000D+01,0.19254000D+01
     .,0.51681140D+03,0.252D+03,0.173D+03,0.19639000D+01,0.19459000D+01
     .,0.47354520D+03,0.252D+03,0.174D+03,0.19639000D+01,0.19292000D+01
     .,0.47737190D+03,0.252D+03,0.175D+03,0.19639000D+01,0.18104000D+01
     .,0.42195370D+03,0.252D+03,0.176D+03,0.19639000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters( 118001: 118100)=(/
     . 0.39750830D+03,0.252D+03,0.177D+03,0.19639000D+01,0.18648000D+01
     .,0.37998620D+03,0.252D+03,0.178D+03,0.19639000D+01,0.19188000D+01
     .,0.36322860D+03,0.252D+03,0.179D+03,0.19639000D+01,0.98460000D+00
     .,0.35217630D+03,0.252D+03,0.180D+03,0.19639000D+01,0.19896000D+01
     .,0.55705210D+03,0.252D+03,0.181D+03,0.19639000D+01,0.92670000D+00
     .,0.51133530D+03,0.252D+03,0.182D+03,0.19639000D+01,0.93830000D+00
     .,0.49776870D+03,0.252D+03,0.183D+03,0.19639000D+01,0.98200000D+00
     .,0.48542330D+03,0.252D+03,0.184D+03,0.19639000D+01,0.98150000D+00
     .,0.45493030D+03,0.252D+03,0.185D+03,0.19639000D+01,0.99540000D+00
     .,0.57742140D+03,0.252D+03,0.187D+03,0.19639000D+01,0.97050000D+00
     .,0.10607432D+04,0.252D+03,0.188D+03,0.19639000D+01,0.96620000D+00
     .,0.61356050D+03,0.252D+03,0.189D+03,0.19639000D+01,0.29070000D+01
     .,0.70396650D+03,0.252D+03,0.190D+03,0.19639000D+01,0.28844000D+01
     .,0.63075620D+03,0.252D+03,0.191D+03,0.19639000D+01,0.28738000D+01
     .,0.56000710D+03,0.252D+03,0.192D+03,0.19639000D+01,0.28878000D+01
     .,0.53943990D+03,0.252D+03,0.193D+03,0.19639000D+01,0.29095000D+01
     .,0.64068280D+03,0.252D+03,0.194D+03,0.19639000D+01,0.19209000D+01
     .,0.15112750D+03,0.252D+03,0.204D+03,0.19639000D+01,0.19697000D+01
     .,0.14889980D+03,0.252D+03,0.205D+03,0.19639000D+01,0.19441000D+01
     .,0.11000870D+03,0.252D+03,0.206D+03,0.19639000D+01,0.19985000D+01
     ./)
      grimme_c6_parameters( 118101: 118200)=(/
     . 0.88495300D+02,0.252D+03,0.207D+03,0.19639000D+01,0.20143000D+01
     .,0.61025800D+02,0.252D+03,0.208D+03,0.19639000D+01,0.19887000D+01
     .,0.26613770D+03,0.252D+03,0.212D+03,0.19639000D+01,0.19496000D+01
     .,0.32131290D+03,0.252D+03,0.213D+03,0.19639000D+01,0.19311000D+01
     .,0.30994780D+03,0.252D+03,0.214D+03,0.19639000D+01,0.19435000D+01
     .,0.27080050D+03,0.252D+03,0.215D+03,0.19639000D+01,0.20102000D+01
     .,0.22881280D+03,0.252D+03,0.216D+03,0.19639000D+01,0.19903000D+01
     .,0.37302450D+03,0.252D+03,0.220D+03,0.19639000D+01,0.19349000D+01
     .,0.36007160D+03,0.252D+03,0.221D+03,0.19639000D+01,0.28999000D+01
     .,0.36462620D+03,0.252D+03,0.222D+03,0.19639000D+01,0.38675000D+01
     .,0.33363080D+03,0.252D+03,0.223D+03,0.19639000D+01,0.29110000D+01
     .,0.25301950D+03,0.252D+03,0.224D+03,0.19639000D+01,0.10619100D+02
     .,0.21739930D+03,0.252D+03,0.225D+03,0.19639000D+01,0.98849000D+01
     .,0.21329230D+03,0.252D+03,0.226D+03,0.19639000D+01,0.91376000D+01
     .,0.24838210D+03,0.252D+03,0.227D+03,0.19639000D+01,0.29263000D+01
     .,0.23186030D+03,0.252D+03,0.228D+03,0.19639000D+01,0.65458000D+01
     .,0.32567860D+03,0.252D+03,0.231D+03,0.19639000D+01,0.19315000D+01
     .,0.34453460D+03,0.252D+03,0.232D+03,0.19639000D+01,0.19447000D+01
     .,0.31759860D+03,0.252D+03,0.233D+03,0.19639000D+01,0.19793000D+01
     .,0.29651530D+03,0.252D+03,0.234D+03,0.19639000D+01,0.19812000D+01
     ./)
      grimme_c6_parameters( 118201: 118300)=(/
     . 0.44715550D+03,0.252D+03,0.238D+03,0.19639000D+01,0.19143000D+01
     .,0.43284780D+03,0.252D+03,0.239D+03,0.19639000D+01,0.28903000D+01
     .,0.43727120D+03,0.252D+03,0.240D+03,0.19639000D+01,0.39106000D+01
     .,0.42265520D+03,0.252D+03,0.241D+03,0.19639000D+01,0.29225000D+01
     .,0.37537250D+03,0.252D+03,0.242D+03,0.19639000D+01,0.11055600D+02
     .,0.33249710D+03,0.252D+03,0.243D+03,0.19639000D+01,0.95402000D+01
     .,0.31460820D+03,0.252D+03,0.244D+03,0.19639000D+01,0.88895000D+01
     .,0.31917350D+03,0.252D+03,0.245D+03,0.19639000D+01,0.29696000D+01
     .,0.33302450D+03,0.252D+03,0.246D+03,0.19639000D+01,0.57095000D+01
     .,0.42051550D+03,0.252D+03,0.249D+03,0.19639000D+01,0.19378000D+01
     .,0.45707930D+03,0.252D+03,0.250D+03,0.19639000D+01,0.19505000D+01
     .,0.43269410D+03,0.252D+03,0.251D+03,0.19639000D+01,0.19523000D+01
     .,0.41857890D+03,0.252D+03,0.252D+03,0.19639000D+01,0.19639000D+01
     .,0.44832100D+02,0.256D+03,0.100D+01,0.18467000D+01,0.91180000D+00
     .,0.29186400D+02,0.256D+03,0.200D+01,0.18467000D+01,0.00000000D+00
     .,0.75032270D+03,0.256D+03,0.300D+01,0.18467000D+01,0.00000000D+00
     .,0.41786520D+03,0.256D+03,0.400D+01,0.18467000D+01,0.00000000D+00
     .,0.27634300D+03,0.256D+03,0.500D+01,0.18467000D+01,0.00000000D+00
     .,0.18434620D+03,0.256D+03,0.600D+01,0.18467000D+01,0.00000000D+00
     .,0.12774190D+03,0.256D+03,0.700D+01,0.18467000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 118301: 118400)=(/
     . 0.96095000D+02,0.256D+03,0.800D+01,0.18467000D+01,0.00000000D+00
     .,0.72385200D+02,0.256D+03,0.900D+01,0.18467000D+01,0.00000000D+00
     .,0.55409200D+02,0.256D+03,0.100D+02,0.18467000D+01,0.00000000D+00
     .,0.89516260D+03,0.256D+03,0.110D+02,0.18467000D+01,0.00000000D+00
     .,0.66976420D+03,0.256D+03,0.120D+02,0.18467000D+01,0.00000000D+00
     .,0.61142610D+03,0.256D+03,0.130D+02,0.18467000D+01,0.00000000D+00
     .,0.47565060D+03,0.256D+03,0.140D+02,0.18467000D+01,0.00000000D+00
     .,0.36714490D+03,0.256D+03,0.150D+02,0.18467000D+01,0.00000000D+00
     .,0.30279080D+03,0.256D+03,0.160D+02,0.18467000D+01,0.00000000D+00
     .,0.24586350D+03,0.256D+03,0.170D+02,0.18467000D+01,0.00000000D+00
     .,0.20010940D+03,0.256D+03,0.180D+02,0.18467000D+01,0.00000000D+00
     .,0.14768694D+04,0.256D+03,0.190D+02,0.18467000D+01,0.00000000D+00
     .,0.11905306D+04,0.256D+03,0.200D+02,0.18467000D+01,0.00000000D+00
     .,0.97858840D+03,0.256D+03,0.210D+02,0.18467000D+01,0.00000000D+00
     .,0.94093240D+03,0.256D+03,0.220D+02,0.18467000D+01,0.00000000D+00
     .,0.85937300D+03,0.256D+03,0.230D+02,0.18467000D+01,0.00000000D+00
     .,0.67681130D+03,0.256D+03,0.240D+02,0.18467000D+01,0.00000000D+00
     .,0.73708980D+03,0.256D+03,0.250D+02,0.18467000D+01,0.00000000D+00
     .,0.57808990D+03,0.256D+03,0.260D+02,0.18467000D+01,0.00000000D+00
     .,0.60928650D+03,0.256D+03,0.270D+02,0.18467000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 118401: 118500)=(/
     . 0.62924930D+03,0.256D+03,0.280D+02,0.18467000D+01,0.00000000D+00
     .,0.48241490D+03,0.256D+03,0.290D+02,0.18467000D+01,0.00000000D+00
     .,0.49120730D+03,0.256D+03,0.300D+02,0.18467000D+01,0.00000000D+00
     .,0.58352030D+03,0.256D+03,0.310D+02,0.18467000D+01,0.00000000D+00
     .,0.50945200D+03,0.256D+03,0.320D+02,0.18467000D+01,0.00000000D+00
     .,0.43080210D+03,0.256D+03,0.330D+02,0.18467000D+01,0.00000000D+00
     .,0.38458730D+03,0.256D+03,0.340D+02,0.18467000D+01,0.00000000D+00
     .,0.33481150D+03,0.256D+03,0.350D+02,0.18467000D+01,0.00000000D+00
     .,0.28979810D+03,0.256D+03,0.360D+02,0.18467000D+01,0.00000000D+00
     .,0.16522832D+04,0.256D+03,0.370D+02,0.18467000D+01,0.00000000D+00
     .,0.14199417D+04,0.256D+03,0.380D+02,0.18467000D+01,0.00000000D+00
     .,0.12330006D+04,0.256D+03,0.390D+02,0.18467000D+01,0.00000000D+00
     .,0.11022638D+04,0.256D+03,0.400D+02,0.18467000D+01,0.00000000D+00
     .,0.10016660D+04,0.256D+03,0.410D+02,0.18467000D+01,0.00000000D+00
     .,0.76883820D+03,0.256D+03,0.420D+02,0.18467000D+01,0.00000000D+00
     .,0.85963920D+03,0.256D+03,0.430D+02,0.18467000D+01,0.00000000D+00
     .,0.65071280D+03,0.256D+03,0.440D+02,0.18467000D+01,0.00000000D+00
     .,0.71108920D+03,0.256D+03,0.450D+02,0.18467000D+01,0.00000000D+00
     .,0.65796470D+03,0.256D+03,0.460D+02,0.18467000D+01,0.00000000D+00
     .,0.54942990D+03,0.256D+03,0.470D+02,0.18467000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 118501: 118600)=(/
     . 0.57810960D+03,0.256D+03,0.480D+02,0.18467000D+01,0.00000000D+00
     .,0.73051140D+03,0.256D+03,0.490D+02,0.18467000D+01,0.00000000D+00
     .,0.66979600D+03,0.256D+03,0.500D+02,0.18467000D+01,0.00000000D+00
     .,0.59220770D+03,0.256D+03,0.510D+02,0.18467000D+01,0.00000000D+00
     .,0.54693930D+03,0.256D+03,0.520D+02,0.18467000D+01,0.00000000D+00
     .,0.49213770D+03,0.256D+03,0.530D+02,0.18467000D+01,0.00000000D+00
     .,0.44046680D+03,0.256D+03,0.540D+02,0.18467000D+01,0.00000000D+00
     .,0.20130282D+04,0.256D+03,0.550D+02,0.18467000D+01,0.00000000D+00
     .,0.18160675D+04,0.256D+03,0.560D+02,0.18467000D+01,0.00000000D+00
     .,0.15814671D+04,0.256D+03,0.570D+02,0.18467000D+01,0.00000000D+00
     .,0.70080410D+03,0.256D+03,0.580D+02,0.18467000D+01,0.27991000D+01
     .,0.16040906D+04,0.256D+03,0.590D+02,0.18467000D+01,0.00000000D+00
     .,0.15379273D+04,0.256D+03,0.600D+02,0.18467000D+01,0.00000000D+00
     .,0.14986941D+04,0.256D+03,0.610D+02,0.18467000D+01,0.00000000D+00
     .,0.14626834D+04,0.256D+03,0.620D+02,0.18467000D+01,0.00000000D+00
     .,0.14307306D+04,0.256D+03,0.630D+02,0.18467000D+01,0.00000000D+00
     .,0.11145114D+04,0.256D+03,0.640D+02,0.18467000D+01,0.00000000D+00
     .,0.12733916D+04,0.256D+03,0.650D+02,0.18467000D+01,0.00000000D+00
     .,0.12261232D+04,0.256D+03,0.660D+02,0.18467000D+01,0.00000000D+00
     .,0.12874672D+04,0.256D+03,0.670D+02,0.18467000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 118601: 118700)=(/
     . 0.12598096D+04,0.256D+03,0.680D+02,0.18467000D+01,0.00000000D+00
     .,0.12347344D+04,0.256D+03,0.690D+02,0.18467000D+01,0.00000000D+00
     .,0.12207557D+04,0.256D+03,0.700D+02,0.18467000D+01,0.00000000D+00
     .,0.10219725D+04,0.256D+03,0.710D+02,0.18467000D+01,0.00000000D+00
     .,0.99637850D+03,0.256D+03,0.720D+02,0.18467000D+01,0.00000000D+00
     .,0.90460210D+03,0.256D+03,0.730D+02,0.18467000D+01,0.00000000D+00
     .,0.76098160D+03,0.256D+03,0.740D+02,0.18467000D+01,0.00000000D+00
     .,0.77254200D+03,0.256D+03,0.750D+02,0.18467000D+01,0.00000000D+00
     .,0.69708220D+03,0.256D+03,0.760D+02,0.18467000D+01,0.00000000D+00
     .,0.63615080D+03,0.256D+03,0.770D+02,0.18467000D+01,0.00000000D+00
     .,0.52655380D+03,0.256D+03,0.780D+02,0.18467000D+01,0.00000000D+00
     .,0.49121220D+03,0.256D+03,0.790D+02,0.18467000D+01,0.00000000D+00
     .,0.50441110D+03,0.256D+03,0.800D+02,0.18467000D+01,0.00000000D+00
     .,0.74864790D+03,0.256D+03,0.810D+02,0.18467000D+01,0.00000000D+00
     .,0.72700690D+03,0.256D+03,0.820D+02,0.18467000D+01,0.00000000D+00
     .,0.66322010D+03,0.256D+03,0.830D+02,0.18467000D+01,0.00000000D+00
     .,0.63000140D+03,0.256D+03,0.840D+02,0.18467000D+01,0.00000000D+00
     .,0.57868480D+03,0.256D+03,0.850D+02,0.18467000D+01,0.00000000D+00
     .,0.52816950D+03,0.256D+03,0.860D+02,0.18467000D+01,0.00000000D+00
     .,0.18871061D+04,0.256D+03,0.870D+02,0.18467000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 118701: 118800)=(/
     . 0.17877406D+04,0.256D+03,0.880D+02,0.18467000D+01,0.00000000D+00
     .,0.15670784D+04,0.256D+03,0.890D+02,0.18467000D+01,0.00000000D+00
     .,0.13954519D+04,0.256D+03,0.900D+02,0.18467000D+01,0.00000000D+00
     .,0.13918292D+04,0.256D+03,0.910D+02,0.18467000D+01,0.00000000D+00
     .,0.13473076D+04,0.256D+03,0.920D+02,0.18467000D+01,0.00000000D+00
     .,0.13948404D+04,0.256D+03,0.930D+02,0.18467000D+01,0.00000000D+00
     .,0.13493008D+04,0.256D+03,0.940D+02,0.18467000D+01,0.00000000D+00
     .,0.72901300D+02,0.256D+03,0.101D+03,0.18467000D+01,0.00000000D+00
     .,0.24228720D+03,0.256D+03,0.103D+03,0.18467000D+01,0.98650000D+00
     .,0.30814100D+03,0.256D+03,0.104D+03,0.18467000D+01,0.98080000D+00
     .,0.23165430D+03,0.256D+03,0.105D+03,0.18467000D+01,0.97060000D+00
     .,0.17302490D+03,0.256D+03,0.106D+03,0.18467000D+01,0.98680000D+00
     .,0.11914340D+03,0.256D+03,0.107D+03,0.18467000D+01,0.99440000D+00
     .,0.86077300D+02,0.256D+03,0.108D+03,0.18467000D+01,0.99250000D+00
     .,0.58583600D+02,0.256D+03,0.109D+03,0.18467000D+01,0.99820000D+00
     .,0.35534390D+03,0.256D+03,0.111D+03,0.18467000D+01,0.96840000D+00
     .,0.55067610D+03,0.256D+03,0.112D+03,0.18467000D+01,0.96280000D+00
     .,0.55286340D+03,0.256D+03,0.113D+03,0.18467000D+01,0.96480000D+00
     .,0.43885970D+03,0.256D+03,0.114D+03,0.18467000D+01,0.95070000D+00
     .,0.35626970D+03,0.256D+03,0.115D+03,0.18467000D+01,0.99470000D+00
     ./)
      grimme_c6_parameters( 118801: 118900)=(/
     . 0.29950590D+03,0.256D+03,0.116D+03,0.18467000D+01,0.99480000D+00
     .,0.24334210D+03,0.256D+03,0.117D+03,0.18467000D+01,0.99720000D+00
     .,0.48693460D+03,0.256D+03,0.119D+03,0.18467000D+01,0.97670000D+00
     .,0.95257710D+03,0.256D+03,0.120D+03,0.18467000D+01,0.98310000D+00
     .,0.48182380D+03,0.256D+03,0.121D+03,0.18467000D+01,0.18627000D+01
     .,0.46502110D+03,0.256D+03,0.122D+03,0.18467000D+01,0.18299000D+01
     .,0.45578960D+03,0.256D+03,0.123D+03,0.18467000D+01,0.19138000D+01
     .,0.45213520D+03,0.256D+03,0.124D+03,0.18467000D+01,0.18269000D+01
     .,0.41343280D+03,0.256D+03,0.125D+03,0.18467000D+01,0.16406000D+01
     .,0.38195910D+03,0.256D+03,0.126D+03,0.18467000D+01,0.16483000D+01
     .,0.36437600D+03,0.256D+03,0.127D+03,0.18467000D+01,0.17149000D+01
     .,0.35638920D+03,0.256D+03,0.128D+03,0.18467000D+01,0.17937000D+01
     .,0.35372270D+03,0.256D+03,0.129D+03,0.18467000D+01,0.95760000D+00
     .,0.32913430D+03,0.256D+03,0.130D+03,0.18467000D+01,0.19419000D+01
     .,0.54664020D+03,0.256D+03,0.131D+03,0.18467000D+01,0.96010000D+00
     .,0.47553820D+03,0.256D+03,0.132D+03,0.18467000D+01,0.94340000D+00
     .,0.42329180D+03,0.256D+03,0.133D+03,0.18467000D+01,0.98890000D+00
     .,0.38476970D+03,0.256D+03,0.134D+03,0.18467000D+01,0.99010000D+00
     .,0.33723270D+03,0.256D+03,0.135D+03,0.18467000D+01,0.99740000D+00
     .,0.57979800D+03,0.256D+03,0.137D+03,0.18467000D+01,0.97380000D+00
     ./)
      grimme_c6_parameters( 118901: 119000)=(/
     . 0.11609040D+04,0.256D+03,0.138D+03,0.18467000D+01,0.98010000D+00
     .,0.87228820D+03,0.256D+03,0.139D+03,0.18467000D+01,0.19153000D+01
     .,0.63807920D+03,0.256D+03,0.140D+03,0.18467000D+01,0.19355000D+01
     .,0.64445150D+03,0.256D+03,0.141D+03,0.18467000D+01,0.19545000D+01
     .,0.59966140D+03,0.256D+03,0.142D+03,0.18467000D+01,0.19420000D+01
     .,0.67812320D+03,0.256D+03,0.143D+03,0.18467000D+01,0.16682000D+01
     .,0.51957380D+03,0.256D+03,0.144D+03,0.18467000D+01,0.18584000D+01
     .,0.48580720D+03,0.256D+03,0.145D+03,0.18467000D+01,0.19003000D+01
     .,0.45060820D+03,0.256D+03,0.146D+03,0.18467000D+01,0.18630000D+01
     .,0.43621390D+03,0.256D+03,0.147D+03,0.18467000D+01,0.96790000D+00
     .,0.42955510D+03,0.256D+03,0.148D+03,0.18467000D+01,0.19539000D+01
     .,0.69425600D+03,0.256D+03,0.149D+03,0.18467000D+01,0.96330000D+00
     .,0.62268260D+03,0.256D+03,0.150D+03,0.18467000D+01,0.95140000D+00
     .,0.57980000D+03,0.256D+03,0.151D+03,0.18467000D+01,0.97490000D+00
     .,0.54638720D+03,0.256D+03,0.152D+03,0.18467000D+01,0.98110000D+00
     .,0.49679900D+03,0.256D+03,0.153D+03,0.18467000D+01,0.99680000D+00
     .,0.68134670D+03,0.256D+03,0.155D+03,0.18467000D+01,0.99090000D+00
     .,0.15113430D+04,0.256D+03,0.156D+03,0.18467000D+01,0.97970000D+00
     .,0.11059643D+04,0.256D+03,0.157D+03,0.18467000D+01,0.19373000D+01
     .,0.67935610D+03,0.256D+03,0.159D+03,0.18467000D+01,0.29425000D+01
     ./)
      grimme_c6_parameters( 119001: 119100)=(/
     . 0.66524220D+03,0.256D+03,0.160D+03,0.18467000D+01,0.29455000D+01
     .,0.64390080D+03,0.256D+03,0.161D+03,0.18467000D+01,0.29413000D+01
     .,0.64787420D+03,0.256D+03,0.162D+03,0.18467000D+01,0.29300000D+01
     .,0.62696840D+03,0.256D+03,0.163D+03,0.18467000D+01,0.18286000D+01
     .,0.65218100D+03,0.256D+03,0.164D+03,0.18467000D+01,0.28732000D+01
     .,0.61190030D+03,0.256D+03,0.165D+03,0.18467000D+01,0.29086000D+01
     .,0.62406450D+03,0.256D+03,0.166D+03,0.18467000D+01,0.28965000D+01
     .,0.58019150D+03,0.256D+03,0.167D+03,0.18467000D+01,0.29242000D+01
     .,0.56343460D+03,0.256D+03,0.168D+03,0.18467000D+01,0.29282000D+01
     .,0.55999100D+03,0.256D+03,0.169D+03,0.18467000D+01,0.29246000D+01
     .,0.58959320D+03,0.256D+03,0.170D+03,0.18467000D+01,0.28482000D+01
     .,0.54094020D+03,0.256D+03,0.171D+03,0.18467000D+01,0.29219000D+01
     .,0.74394190D+03,0.256D+03,0.172D+03,0.18467000D+01,0.19254000D+01
     .,0.68699120D+03,0.256D+03,0.173D+03,0.18467000D+01,0.19459000D+01
     .,0.62358700D+03,0.256D+03,0.174D+03,0.18467000D+01,0.19292000D+01
     .,0.63381630D+03,0.256D+03,0.175D+03,0.18467000D+01,0.18104000D+01
     .,0.54831610D+03,0.256D+03,0.176D+03,0.18467000D+01,0.18858000D+01
     .,0.51495440D+03,0.256D+03,0.177D+03,0.18467000D+01,0.18648000D+01
     .,0.49133470D+03,0.256D+03,0.178D+03,0.18467000D+01,0.19188000D+01
     .,0.46979990D+03,0.256D+03,0.179D+03,0.18467000D+01,0.98460000D+00
     ./)
      grimme_c6_parameters( 119101: 119200)=(/
     . 0.45204520D+03,0.256D+03,0.180D+03,0.18467000D+01,0.19896000D+01
     .,0.74445260D+03,0.256D+03,0.181D+03,0.18467000D+01,0.92670000D+00
     .,0.67269630D+03,0.256D+03,0.182D+03,0.18467000D+01,0.93830000D+00
     .,0.64947180D+03,0.256D+03,0.183D+03,0.18467000D+01,0.98200000D+00
     .,0.62976130D+03,0.256D+03,0.184D+03,0.18467000D+01,0.98150000D+00
     .,0.58566430D+03,0.256D+03,0.185D+03,0.18467000D+01,0.99540000D+00
     .,0.76695690D+03,0.256D+03,0.187D+03,0.18467000D+01,0.97050000D+00
     .,0.14944404D+04,0.256D+03,0.188D+03,0.18467000D+01,0.96620000D+00
     .,0.80404920D+03,0.256D+03,0.189D+03,0.18467000D+01,0.29070000D+01
     .,0.93536030D+03,0.256D+03,0.190D+03,0.18467000D+01,0.28844000D+01
     .,0.83446090D+03,0.256D+03,0.191D+03,0.18467000D+01,0.28738000D+01
     .,0.73260640D+03,0.256D+03,0.192D+03,0.18467000D+01,0.28878000D+01
     .,0.70402570D+03,0.256D+03,0.193D+03,0.18467000D+01,0.29095000D+01
     .,0.86065850D+03,0.256D+03,0.194D+03,0.18467000D+01,0.19209000D+01
     .,0.19758390D+03,0.256D+03,0.204D+03,0.18467000D+01,0.19697000D+01
     .,0.19383810D+03,0.256D+03,0.205D+03,0.18467000D+01,0.19441000D+01
     .,0.14029040D+03,0.256D+03,0.206D+03,0.18467000D+01,0.19985000D+01
     .,0.11170570D+03,0.256D+03,0.207D+03,0.18467000D+01,0.20143000D+01
     .,0.75741700D+02,0.256D+03,0.208D+03,0.18467000D+01,0.19887000D+01
     .,0.35305310D+03,0.256D+03,0.212D+03,0.18467000D+01,0.19496000D+01
     ./)
      grimme_c6_parameters( 119201: 119300)=(/
     . 0.42739490D+03,0.256D+03,0.213D+03,0.18467000D+01,0.19311000D+01
     .,0.40746200D+03,0.256D+03,0.214D+03,0.18467000D+01,0.19435000D+01
     .,0.35168440D+03,0.256D+03,0.215D+03,0.18467000D+01,0.20102000D+01
     .,0.29341430D+03,0.256D+03,0.216D+03,0.18467000D+01,0.19903000D+01
     .,0.49541720D+03,0.256D+03,0.220D+03,0.18467000D+01,0.19349000D+01
     .,0.47369840D+03,0.256D+03,0.221D+03,0.18467000D+01,0.28999000D+01
     .,0.47934490D+03,0.256D+03,0.222D+03,0.18467000D+01,0.38675000D+01
     .,0.43891900D+03,0.256D+03,0.223D+03,0.18467000D+01,0.29110000D+01
     .,0.32804360D+03,0.256D+03,0.224D+03,0.18467000D+01,0.10619100D+02
     .,0.27929530D+03,0.256D+03,0.225D+03,0.18467000D+01,0.98849000D+01
     .,0.27428730D+03,0.256D+03,0.226D+03,0.18467000D+01,0.91376000D+01
     .,0.32404980D+03,0.256D+03,0.227D+03,0.18467000D+01,0.29263000D+01
     .,0.30116290D+03,0.256D+03,0.228D+03,0.18467000D+01,0.65458000D+01
     .,0.42932210D+03,0.256D+03,0.231D+03,0.18467000D+01,0.19315000D+01
     .,0.45201960D+03,0.256D+03,0.232D+03,0.18467000D+01,0.19447000D+01
     .,0.41181840D+03,0.256D+03,0.233D+03,0.18467000D+01,0.19793000D+01
     .,0.38169420D+03,0.256D+03,0.234D+03,0.18467000D+01,0.19812000D+01
     .,0.59335720D+03,0.256D+03,0.238D+03,0.18467000D+01,0.19143000D+01
     .,0.56724450D+03,0.256D+03,0.239D+03,0.18467000D+01,0.28903000D+01
     .,0.57102950D+03,0.256D+03,0.240D+03,0.18467000D+01,0.39106000D+01
     ./)
      grimme_c6_parameters( 119301: 119400)=(/
     . 0.55267180D+03,0.256D+03,0.241D+03,0.18467000D+01,0.29225000D+01
     .,0.48602980D+03,0.256D+03,0.242D+03,0.18467000D+01,0.11055600D+02
     .,0.42718180D+03,0.256D+03,0.243D+03,0.18467000D+01,0.95402000D+01
     .,0.40302800D+03,0.256D+03,0.244D+03,0.18467000D+01,0.88895000D+01
     .,0.41253210D+03,0.256D+03,0.245D+03,0.18467000D+01,0.29696000D+01
     .,0.43149070D+03,0.256D+03,0.246D+03,0.18467000D+01,0.57095000D+01
     .,0.55308270D+03,0.256D+03,0.249D+03,0.18467000D+01,0.19378000D+01
     .,0.60097790D+03,0.256D+03,0.250D+03,0.18467000D+01,0.19505000D+01
     .,0.56310510D+03,0.256D+03,0.251D+03,0.18467000D+01,0.19523000D+01
     .,0.54167760D+03,0.256D+03,0.252D+03,0.18467000D+01,0.19639000D+01
     .,0.71654750D+03,0.256D+03,0.256D+03,0.18467000D+01,0.18467000D+01
     .,0.46820200D+02,0.257D+03,0.100D+01,0.29175000D+01,0.91180000D+00
     .,0.30588600D+02,0.257D+03,0.200D+01,0.29175000D+01,0.00000000D+00
     .,0.74890520D+03,0.257D+03,0.300D+01,0.29175000D+01,0.00000000D+00
     .,0.42804980D+03,0.257D+03,0.400D+01,0.29175000D+01,0.00000000D+00
     .,0.28602900D+03,0.257D+03,0.500D+01,0.29175000D+01,0.00000000D+00
     .,0.19193550D+03,0.257D+03,0.600D+01,0.29175000D+01,0.00000000D+00
     .,0.13344100D+03,0.257D+03,0.700D+01,0.29175000D+01,0.00000000D+00
     .,0.10055750D+03,0.257D+03,0.800D+01,0.29175000D+01,0.00000000D+00
     .,0.75829800D+02,0.257D+03,0.900D+01,0.29175000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 119401: 119500)=(/
     . 0.58079500D+02,0.257D+03,0.100D+02,0.29175000D+01,0.00000000D+00
     .,0.89474480D+03,0.257D+03,0.110D+02,0.29175000D+01,0.00000000D+00
     .,0.68323710D+03,0.257D+03,0.120D+02,0.29175000D+01,0.00000000D+00
     .,0.62753480D+03,0.257D+03,0.130D+02,0.29175000D+01,0.00000000D+00
     .,0.49189290D+03,0.257D+03,0.140D+02,0.29175000D+01,0.00000000D+00
     .,0.38167570D+03,0.257D+03,0.150D+02,0.29175000D+01,0.00000000D+00
     .,0.31561930D+03,0.257D+03,0.160D+02,0.29175000D+01,0.00000000D+00
     .,0.25684550D+03,0.257D+03,0.170D+02,0.29175000D+01,0.00000000D+00
     .,0.20937070D+03,0.257D+03,0.180D+02,0.29175000D+01,0.00000000D+00
     .,0.14672405D+04,0.257D+03,0.190D+02,0.29175000D+01,0.00000000D+00
     .,0.12041091D+04,0.257D+03,0.200D+02,0.29175000D+01,0.00000000D+00
     .,0.99328050D+03,0.257D+03,0.210D+02,0.29175000D+01,0.00000000D+00
     .,0.95757000D+03,0.257D+03,0.220D+02,0.29175000D+01,0.00000000D+00
     .,0.87600500D+03,0.257D+03,0.230D+02,0.29175000D+01,0.00000000D+00
     .,0.68947940D+03,0.257D+03,0.240D+02,0.29175000D+01,0.00000000D+00
     .,0.75309320D+03,0.257D+03,0.250D+02,0.29175000D+01,0.00000000D+00
     .,0.59043900D+03,0.257D+03,0.260D+02,0.29175000D+01,0.00000000D+00
     .,0.62501030D+03,0.257D+03,0.270D+02,0.29175000D+01,0.00000000D+00
     .,0.64450280D+03,0.257D+03,0.280D+02,0.29175000D+01,0.00000000D+00
     .,0.49360530D+03,0.257D+03,0.290D+02,0.29175000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 119501: 119600)=(/
     . 0.50558370D+03,0.257D+03,0.300D+02,0.29175000D+01,0.00000000D+00
     .,0.59983010D+03,0.257D+03,0.310D+02,0.29175000D+01,0.00000000D+00
     .,0.52686600D+03,0.257D+03,0.320D+02,0.29175000D+01,0.00000000D+00
     .,0.44755460D+03,0.257D+03,0.330D+02,0.29175000D+01,0.00000000D+00
     .,0.40047040D+03,0.257D+03,0.340D+02,0.29175000D+01,0.00000000D+00
     .,0.34937100D+03,0.257D+03,0.350D+02,0.29175000D+01,0.00000000D+00
     .,0.30289600D+03,0.257D+03,0.360D+02,0.29175000D+01,0.00000000D+00
     .,0.16430879D+04,0.257D+03,0.370D+02,0.29175000D+01,0.00000000D+00
     .,0.14346583D+04,0.257D+03,0.380D+02,0.29175000D+01,0.00000000D+00
     .,0.12531317D+04,0.257D+03,0.390D+02,0.29175000D+01,0.00000000D+00
     .,0.11240457D+04,0.257D+03,0.400D+02,0.29175000D+01,0.00000000D+00
     .,0.10235000D+04,0.257D+03,0.410D+02,0.29175000D+01,0.00000000D+00
     .,0.78790450D+03,0.257D+03,0.420D+02,0.29175000D+01,0.00000000D+00
     .,0.88003140D+03,0.257D+03,0.430D+02,0.29175000D+01,0.00000000D+00
     .,0.66828590D+03,0.257D+03,0.440D+02,0.29175000D+01,0.00000000D+00
     .,0.73081350D+03,0.257D+03,0.450D+02,0.29175000D+01,0.00000000D+00
     .,0.67702710D+03,0.257D+03,0.460D+02,0.29175000D+01,0.00000000D+00
     .,0.56424900D+03,0.257D+03,0.470D+02,0.29175000D+01,0.00000000D+00
     .,0.59573220D+03,0.257D+03,0.480D+02,0.29175000D+01,0.00000000D+00
     .,0.74999110D+03,0.257D+03,0.490D+02,0.29175000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 119601: 119700)=(/
     . 0.69136370D+03,0.257D+03,0.500D+02,0.29175000D+01,0.00000000D+00
     .,0.61397930D+03,0.257D+03,0.510D+02,0.29175000D+01,0.00000000D+00
     .,0.56835230D+03,0.257D+03,0.520D+02,0.29175000D+01,0.00000000D+00
     .,0.51253890D+03,0.257D+03,0.530D+02,0.29175000D+01,0.00000000D+00
     .,0.45957350D+03,0.257D+03,0.540D+02,0.29175000D+01,0.00000000D+00
     .,0.20012557D+04,0.257D+03,0.550D+02,0.29175000D+01,0.00000000D+00
     .,0.18302684D+04,0.257D+03,0.560D+02,0.29175000D+01,0.00000000D+00
     .,0.16035452D+04,0.257D+03,0.570D+02,0.29175000D+01,0.00000000D+00
     .,0.72568940D+03,0.257D+03,0.580D+02,0.29175000D+01,0.27991000D+01
     .,0.16196684D+04,0.257D+03,0.590D+02,0.29175000D+01,0.00000000D+00
     .,0.15546376D+04,0.257D+03,0.600D+02,0.29175000D+01,0.00000000D+00
     .,0.15154611D+04,0.257D+03,0.610D+02,0.29175000D+01,0.00000000D+00
     .,0.14794584D+04,0.257D+03,0.620D+02,0.29175000D+01,0.00000000D+00
     .,0.14475288D+04,0.257D+03,0.630D+02,0.29175000D+01,0.00000000D+00
     .,0.11341326D+04,0.257D+03,0.640D+02,0.29175000D+01,0.00000000D+00
     .,0.12823779D+04,0.257D+03,0.650D+02,0.29175000D+01,0.00000000D+00
     .,0.12360668D+04,0.257D+03,0.660D+02,0.29175000D+01,0.00000000D+00
     .,0.13047191D+04,0.257D+03,0.670D+02,0.29175000D+01,0.00000000D+00
     .,0.12769567D+04,0.257D+03,0.680D+02,0.29175000D+01,0.00000000D+00
     .,0.12518739D+04,0.257D+03,0.690D+02,0.29175000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 119701: 119800)=(/
     . 0.12374305D+04,0.257D+03,0.700D+02,0.29175000D+01,0.00000000D+00
     .,0.10399691D+04,0.257D+03,0.710D+02,0.29175000D+01,0.00000000D+00
     .,0.10199809D+04,0.257D+03,0.720D+02,0.29175000D+01,0.00000000D+00
     .,0.92884540D+03,0.257D+03,0.730D+02,0.29175000D+01,0.00000000D+00
     .,0.78260680D+03,0.257D+03,0.740D+02,0.29175000D+01,0.00000000D+00
     .,0.79560020D+03,0.257D+03,0.750D+02,0.29175000D+01,0.00000000D+00
     .,0.71959790D+03,0.257D+03,0.760D+02,0.29175000D+01,0.00000000D+00
     .,0.65787990D+03,0.257D+03,0.770D+02,0.29175000D+01,0.00000000D+00
     .,0.54519970D+03,0.257D+03,0.780D+02,0.29175000D+01,0.00000000D+00
     .,0.50886690D+03,0.257D+03,0.790D+02,0.29175000D+01,0.00000000D+00
     .,0.52322550D+03,0.257D+03,0.800D+02,0.29175000D+01,0.00000000D+00
     .,0.76879970D+03,0.257D+03,0.810D+02,0.29175000D+01,0.00000000D+00
     .,0.74998940D+03,0.257D+03,0.820D+02,0.29175000D+01,0.00000000D+00
     .,0.68706370D+03,0.257D+03,0.830D+02,0.29175000D+01,0.00000000D+00
     .,0.65405030D+03,0.257D+03,0.840D+02,0.29175000D+01,0.00000000D+00
     .,0.60215770D+03,0.257D+03,0.850D+02,0.29175000D+01,0.00000000D+00
     .,0.55060100D+03,0.257D+03,0.860D+02,0.29175000D+01,0.00000000D+00
     .,0.18855867D+04,0.257D+03,0.870D+02,0.29175000D+01,0.00000000D+00
     .,0.18071153D+04,0.257D+03,0.880D+02,0.29175000D+01,0.00000000D+00
     .,0.15930087D+04,0.257D+03,0.890D+02,0.29175000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 119801: 119900)=(/
     . 0.14265400D+04,0.257D+03,0.900D+02,0.29175000D+01,0.00000000D+00
     .,0.14182359D+04,0.257D+03,0.910D+02,0.29175000D+01,0.00000000D+00
     .,0.13730549D+04,0.257D+03,0.920D+02,0.29175000D+01,0.00000000D+00
     .,0.14164457D+04,0.257D+03,0.930D+02,0.29175000D+01,0.00000000D+00
     .,0.13711890D+04,0.257D+03,0.940D+02,0.29175000D+01,0.00000000D+00
     .,0.75839400D+02,0.257D+03,0.101D+03,0.29175000D+01,0.00000000D+00
     .,0.24848670D+03,0.257D+03,0.103D+03,0.29175000D+01,0.98650000D+00
     .,0.31648150D+03,0.257D+03,0.104D+03,0.29175000D+01,0.98080000D+00
     .,0.24013610D+03,0.257D+03,0.105D+03,0.29175000D+01,0.97060000D+00
     .,0.18003260D+03,0.257D+03,0.106D+03,0.29175000D+01,0.98680000D+00
     .,0.12441240D+03,0.257D+03,0.107D+03,0.29175000D+01,0.99440000D+00
     .,0.90093200D+02,0.257D+03,0.108D+03,0.29175000D+01,0.99250000D+00
     .,0.61449900D+02,0.257D+03,0.109D+03,0.29175000D+01,0.99820000D+00
     .,0.36346120D+03,0.257D+03,0.111D+03,0.29175000D+01,0.96840000D+00
     .,0.56268080D+03,0.257D+03,0.112D+03,0.29175000D+01,0.96280000D+00
     .,0.56814570D+03,0.257D+03,0.113D+03,0.29175000D+01,0.96480000D+00
     .,0.45421760D+03,0.257D+03,0.114D+03,0.29175000D+01,0.95070000D+00
     .,0.37038990D+03,0.257D+03,0.115D+03,0.29175000D+01,0.99470000D+00
     .,0.31215000D+03,0.257D+03,0.116D+03,0.29175000D+01,0.99480000D+00
     .,0.25418510D+03,0.257D+03,0.117D+03,0.29175000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters( 119901: 120000)=(/
     . 0.49920670D+03,0.257D+03,0.119D+03,0.29175000D+01,0.97670000D+00
     .,0.96226620D+03,0.257D+03,0.120D+03,0.29175000D+01,0.98310000D+00
     .,0.49762570D+03,0.257D+03,0.121D+03,0.29175000D+01,0.18627000D+01
     .,0.48020280D+03,0.257D+03,0.122D+03,0.29175000D+01,0.18299000D+01
     .,0.47059030D+03,0.257D+03,0.123D+03,0.29175000D+01,0.19138000D+01
     .,0.46642410D+03,0.257D+03,0.124D+03,0.29175000D+01,0.18269000D+01
     .,0.42818050D+03,0.257D+03,0.125D+03,0.29175000D+01,0.16406000D+01
     .,0.39589450D+03,0.257D+03,0.126D+03,0.29175000D+01,0.16483000D+01
     .,0.37758950D+03,0.257D+03,0.127D+03,0.29175000D+01,0.17149000D+01
     .,0.36919520D+03,0.257D+03,0.128D+03,0.29175000D+01,0.17937000D+01
     .,0.36539900D+03,0.257D+03,0.129D+03,0.29175000D+01,0.95760000D+00
     .,0.34173160D+03,0.257D+03,0.130D+03,0.29175000D+01,0.19419000D+01
     .,0.56276860D+03,0.257D+03,0.131D+03,0.29175000D+01,0.96010000D+00
     .,0.49236040D+03,0.257D+03,0.132D+03,0.29175000D+01,0.94340000D+00
     .,0.43983840D+03,0.257D+03,0.133D+03,0.29175000D+01,0.98890000D+00
     .,0.40063200D+03,0.257D+03,0.134D+03,0.29175000D+01,0.99010000D+00
     .,0.35185020D+03,0.257D+03,0.135D+03,0.29175000D+01,0.99740000D+00
     .,0.59499260D+03,0.257D+03,0.137D+03,0.29175000D+01,0.97380000D+00
     .,0.11711205D+04,0.257D+03,0.138D+03,0.29175000D+01,0.98010000D+00
     .,0.88995010D+03,0.257D+03,0.139D+03,0.29175000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters( 120001: 120100)=(/
     . 0.65820980D+03,0.257D+03,0.140D+03,0.29175000D+01,0.19355000D+01
     .,0.66473460D+03,0.257D+03,0.141D+03,0.29175000D+01,0.19545000D+01
     .,0.61909740D+03,0.257D+03,0.142D+03,0.29175000D+01,0.19420000D+01
     .,0.69637520D+03,0.257D+03,0.143D+03,0.29175000D+01,0.16682000D+01
     .,0.53817200D+03,0.257D+03,0.144D+03,0.29175000D+01,0.18584000D+01
     .,0.50319100D+03,0.257D+03,0.145D+03,0.29175000D+01,0.19003000D+01
     .,0.46688550D+03,0.257D+03,0.146D+03,0.29175000D+01,0.18630000D+01
     .,0.45174170D+03,0.257D+03,0.147D+03,0.29175000D+01,0.96790000D+00
     .,0.44617650D+03,0.257D+03,0.148D+03,0.29175000D+01,0.19539000D+01
     .,0.71406170D+03,0.257D+03,0.149D+03,0.29175000D+01,0.96330000D+00
     .,0.64381770D+03,0.257D+03,0.150D+03,0.29175000D+01,0.95140000D+00
     .,0.60143340D+03,0.257D+03,0.151D+03,0.29175000D+01,0.97490000D+00
     .,0.56786370D+03,0.257D+03,0.152D+03,0.29175000D+01,0.98110000D+00
     .,0.51738510D+03,0.257D+03,0.153D+03,0.29175000D+01,0.99680000D+00
     .,0.70211480D+03,0.257D+03,0.155D+03,0.29175000D+01,0.99090000D+00
     .,0.15197933D+04,0.257D+03,0.156D+03,0.29175000D+01,0.97970000D+00
     .,0.11269136D+04,0.257D+03,0.157D+03,0.29175000D+01,0.19373000D+01
     .,0.70363390D+03,0.257D+03,0.159D+03,0.29175000D+01,0.29425000D+01
     .,0.68904640D+03,0.257D+03,0.160D+03,0.29175000D+01,0.29455000D+01
     .,0.66706290D+03,0.257D+03,0.161D+03,0.29175000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters( 120101: 120200)=(/
     . 0.67068630D+03,0.257D+03,0.162D+03,0.29175000D+01,0.29300000D+01
     .,0.64747300D+03,0.257D+03,0.163D+03,0.29175000D+01,0.18286000D+01
     .,0.67511960D+03,0.257D+03,0.164D+03,0.29175000D+01,0.28732000D+01
     .,0.63375280D+03,0.257D+03,0.165D+03,0.29175000D+01,0.29086000D+01
     .,0.64544130D+03,0.257D+03,0.166D+03,0.29175000D+01,0.28965000D+01
     .,0.60128460D+03,0.257D+03,0.167D+03,0.29175000D+01,0.29242000D+01
     .,0.58404680D+03,0.257D+03,0.168D+03,0.29175000D+01,0.29282000D+01
     .,0.58039470D+03,0.257D+03,0.169D+03,0.29175000D+01,0.29246000D+01
     .,0.61065540D+03,0.257D+03,0.170D+03,0.29175000D+01,0.28482000D+01
     .,0.56086530D+03,0.257D+03,0.171D+03,0.29175000D+01,0.29219000D+01
     .,0.76459540D+03,0.257D+03,0.172D+03,0.29175000D+01,0.19254000D+01
     .,0.70805680D+03,0.257D+03,0.173D+03,0.29175000D+01,0.19459000D+01
     .,0.64452930D+03,0.257D+03,0.174D+03,0.29175000D+01,0.19292000D+01
     .,0.65336840D+03,0.257D+03,0.175D+03,0.29175000D+01,0.18104000D+01
     .,0.56893970D+03,0.257D+03,0.176D+03,0.29175000D+01,0.18858000D+01
     .,0.53465980D+03,0.257D+03,0.177D+03,0.29175000D+01,0.18648000D+01
     .,0.51029930D+03,0.257D+03,0.178D+03,0.29175000D+01,0.19188000D+01
     .,0.48773540D+03,0.257D+03,0.179D+03,0.29175000D+01,0.98460000D+00
     .,0.47044860D+03,0.257D+03,0.180D+03,0.29175000D+01,0.19896000D+01
     .,0.76580950D+03,0.257D+03,0.181D+03,0.29175000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters( 120201: 120300)=(/
     . 0.69566310D+03,0.257D+03,0.182D+03,0.29175000D+01,0.93830000D+00
     .,0.67341930D+03,0.257D+03,0.183D+03,0.29175000D+01,0.98200000D+00
     .,0.65403890D+03,0.257D+03,0.184D+03,0.29175000D+01,0.98150000D+00
     .,0.60946360D+03,0.257D+03,0.185D+03,0.29175000D+01,0.99540000D+00
     .,0.79062920D+03,0.257D+03,0.187D+03,0.29175000D+01,0.97050000D+00
     .,0.15089609D+04,0.257D+03,0.188D+03,0.29175000D+01,0.96620000D+00
     .,0.83278590D+03,0.257D+03,0.189D+03,0.29175000D+01,0.29070000D+01
     .,0.96389140D+03,0.257D+03,0.190D+03,0.29175000D+01,0.28844000D+01
     .,0.86055570D+03,0.257D+03,0.191D+03,0.29175000D+01,0.28738000D+01
     .,0.75868030D+03,0.257D+03,0.192D+03,0.29175000D+01,0.28878000D+01
     .,0.72961370D+03,0.257D+03,0.193D+03,0.29175000D+01,0.29095000D+01
     .,0.88320780D+03,0.257D+03,0.194D+03,0.29175000D+01,0.19209000D+01
     .,0.20508500D+03,0.257D+03,0.204D+03,0.29175000D+01,0.19697000D+01
     .,0.20120830D+03,0.257D+03,0.205D+03,0.29175000D+01,0.19441000D+01
     .,0.14633300D+03,0.257D+03,0.206D+03,0.29175000D+01,0.19985000D+01
     .,0.11668030D+03,0.257D+03,0.207D+03,0.29175000D+01,0.20143000D+01
     .,0.79287700D+02,0.257D+03,0.208D+03,0.29175000D+01,0.19887000D+01
     .,0.36491620D+03,0.257D+03,0.212D+03,0.29175000D+01,0.19496000D+01
     .,0.44120040D+03,0.257D+03,0.213D+03,0.29175000D+01,0.19311000D+01
     .,0.42212020D+03,0.257D+03,0.214D+03,0.29175000D+01,0.19435000D+01
     ./)
      grimme_c6_parameters( 120301: 120400)=(/
     . 0.36544980D+03,0.257D+03,0.215D+03,0.29175000D+01,0.20102000D+01
     .,0.30579960D+03,0.257D+03,0.216D+03,0.29175000D+01,0.19903000D+01
     .,0.51130630D+03,0.257D+03,0.220D+03,0.29175000D+01,0.19349000D+01
     .,0.49031810D+03,0.257D+03,0.221D+03,0.29175000D+01,0.28999000D+01
     .,0.49624460D+03,0.257D+03,0.222D+03,0.29175000D+01,0.38675000D+01
     .,0.45408320D+03,0.257D+03,0.223D+03,0.29175000D+01,0.29110000D+01
     .,0.34051320D+03,0.257D+03,0.224D+03,0.29175000D+01,0.10619100D+02
     .,0.29056100D+03,0.257D+03,0.225D+03,0.29175000D+01,0.98849000D+01
     .,0.28526770D+03,0.257D+03,0.226D+03,0.29175000D+01,0.91376000D+01
     .,0.33581530D+03,0.257D+03,0.227D+03,0.29175000D+01,0.29263000D+01
     .,0.31248780D+03,0.257D+03,0.228D+03,0.29175000D+01,0.65458000D+01
     .,0.44415730D+03,0.257D+03,0.231D+03,0.29175000D+01,0.19315000D+01
     .,0.46838860D+03,0.257D+03,0.232D+03,0.29175000D+01,0.19447000D+01
     .,0.42809060D+03,0.257D+03,0.233D+03,0.29175000D+01,0.19793000D+01
     .,0.39744450D+03,0.257D+03,0.234D+03,0.29175000D+01,0.19812000D+01
     .,0.61229940D+03,0.257D+03,0.238D+03,0.29175000D+01,0.19143000D+01
     .,0.58772220D+03,0.257D+03,0.239D+03,0.29175000D+01,0.28903000D+01
     .,0.59223960D+03,0.257D+03,0.240D+03,0.29175000D+01,0.39106000D+01
     .,0.57268150D+03,0.257D+03,0.241D+03,0.29175000D+01,0.29225000D+01
     .,0.50489560D+03,0.257D+03,0.242D+03,0.29175000D+01,0.11055600D+02
     ./)
      grimme_c6_parameters( 120401: 120500)=(/
     . 0.44457570D+03,0.257D+03,0.243D+03,0.29175000D+01,0.95402000D+01
     .,0.41969160D+03,0.257D+03,0.244D+03,0.29175000D+01,0.88895000D+01
     .,0.42842590D+03,0.257D+03,0.245D+03,0.29175000D+01,0.29696000D+01
     .,0.44792670D+03,0.257D+03,0.246D+03,0.29175000D+01,0.57095000D+01
     .,0.57208230D+03,0.257D+03,0.249D+03,0.29175000D+01,0.19378000D+01
     .,0.62193900D+03,0.257D+03,0.250D+03,0.29175000D+01,0.19505000D+01
     .,0.58452180D+03,0.257D+03,0.251D+03,0.29175000D+01,0.19523000D+01
     .,0.56311340D+03,0.257D+03,0.252D+03,0.29175000D+01,0.19639000D+01
     .,0.73991600D+03,0.257D+03,0.256D+03,0.29175000D+01,0.18467000D+01
     .,0.76602020D+03,0.257D+03,0.257D+03,0.29175000D+01,0.29175000D+01
     .,0.35219500D+02,0.272D+03,0.100D+01,0.38840000D+01,0.91180000D+00
     .,0.23410600D+02,0.272D+03,0.200D+01,0.38840000D+01,0.00000000D+00
     .,0.52531240D+03,0.272D+03,0.300D+01,0.38840000D+01,0.00000000D+00
     .,0.30984670D+03,0.272D+03,0.400D+01,0.38840000D+01,0.00000000D+00
     .,0.21084170D+03,0.272D+03,0.500D+01,0.38840000D+01,0.00000000D+00
     .,0.14342000D+03,0.272D+03,0.600D+01,0.38840000D+01,0.00000000D+00
     .,0.10074190D+03,0.272D+03,0.700D+01,0.38840000D+01,0.00000000D+00
     .,0.76484200D+02,0.272D+03,0.800D+01,0.38840000D+01,0.00000000D+00
     .,0.58056700D+02,0.272D+03,0.900D+01,0.38840000D+01,0.00000000D+00
     .,0.44712000D+02,0.272D+03,0.100D+02,0.38840000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 120501: 120600)=(/
     . 0.62893080D+03,0.272D+03,0.110D+02,0.38840000D+01,0.00000000D+00
     .,0.49188460D+03,0.272D+03,0.120D+02,0.38840000D+01,0.00000000D+00
     .,0.45602900D+03,0.272D+03,0.130D+02,0.38840000D+01,0.00000000D+00
     .,0.36194550D+03,0.272D+03,0.140D+02,0.38840000D+01,0.00000000D+00
     .,0.28382390D+03,0.272D+03,0.150D+02,0.38840000D+01,0.00000000D+00
     .,0.23632710D+03,0.272D+03,0.160D+02,0.38840000D+01,0.00000000D+00
     .,0.19360200D+03,0.272D+03,0.170D+02,0.38840000D+01,0.00000000D+00
     .,0.15874630D+03,0.272D+03,0.180D+02,0.38840000D+01,0.00000000D+00
     .,0.10274537D+04,0.272D+03,0.190D+02,0.38840000D+01,0.00000000D+00
     .,0.85873510D+03,0.272D+03,0.200D+02,0.38840000D+01,0.00000000D+00
     .,0.71140130D+03,0.272D+03,0.210D+02,0.38840000D+01,0.00000000D+00
     .,0.68866520D+03,0.272D+03,0.220D+02,0.38840000D+01,0.00000000D+00
     .,0.63154370D+03,0.272D+03,0.230D+02,0.38840000D+01,0.00000000D+00
     .,0.49757540D+03,0.272D+03,0.240D+02,0.38840000D+01,0.00000000D+00
     .,0.54486260D+03,0.272D+03,0.250D+02,0.38840000D+01,0.00000000D+00
     .,0.42780560D+03,0.272D+03,0.260D+02,0.38840000D+01,0.00000000D+00
     .,0.45484270D+03,0.272D+03,0.270D+02,0.38840000D+01,0.00000000D+00
     .,0.46785600D+03,0.272D+03,0.280D+02,0.38840000D+01,0.00000000D+00
     .,0.35868500D+03,0.272D+03,0.290D+02,0.38840000D+01,0.00000000D+00
     .,0.36992010D+03,0.272D+03,0.300D+02,0.38840000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 120601: 120700)=(/
     . 0.43768410D+03,0.272D+03,0.310D+02,0.38840000D+01,0.00000000D+00
     .,0.38810850D+03,0.272D+03,0.320D+02,0.38840000D+01,0.00000000D+00
     .,0.33255870D+03,0.272D+03,0.330D+02,0.38840000D+01,0.00000000D+00
     .,0.29919670D+03,0.272D+03,0.340D+02,0.38840000D+01,0.00000000D+00
     .,0.26248890D+03,0.272D+03,0.350D+02,0.38840000D+01,0.00000000D+00
     .,0.22875780D+03,0.272D+03,0.360D+02,0.38840000D+01,0.00000000D+00
     .,0.11528150D+04,0.272D+03,0.370D+02,0.38840000D+01,0.00000000D+00
     .,0.10226698D+04,0.272D+03,0.380D+02,0.38840000D+01,0.00000000D+00
     .,0.90010840D+03,0.272D+03,0.390D+02,0.38840000D+01,0.00000000D+00
     .,0.81130330D+03,0.272D+03,0.400D+02,0.38840000D+01,0.00000000D+00
     .,0.74116010D+03,0.272D+03,0.410D+02,0.38840000D+01,0.00000000D+00
     .,0.57392370D+03,0.272D+03,0.420D+02,0.38840000D+01,0.00000000D+00
     .,0.63963880D+03,0.272D+03,0.430D+02,0.38840000D+01,0.00000000D+00
     .,0.48887360D+03,0.272D+03,0.440D+02,0.38840000D+01,0.00000000D+00
     .,0.53438470D+03,0.272D+03,0.450D+02,0.38840000D+01,0.00000000D+00
     .,0.49607390D+03,0.272D+03,0.460D+02,0.38840000D+01,0.00000000D+00
     .,0.41327390D+03,0.272D+03,0.470D+02,0.38840000D+01,0.00000000D+00
     .,0.43768030D+03,0.272D+03,0.480D+02,0.38840000D+01,0.00000000D+00
     .,0.54743800D+03,0.272D+03,0.490D+02,0.38840000D+01,0.00000000D+00
     .,0.50847990D+03,0.272D+03,0.500D+02,0.38840000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 120701: 120800)=(/
     . 0.45499670D+03,0.272D+03,0.510D+02,0.38840000D+01,0.00000000D+00
     .,0.42313470D+03,0.272D+03,0.520D+02,0.38840000D+01,0.00000000D+00
     .,0.38349110D+03,0.272D+03,0.530D+02,0.38840000D+01,0.00000000D+00
     .,0.34549990D+03,0.272D+03,0.540D+02,0.38840000D+01,0.00000000D+00
     .,0.14048971D+04,0.272D+03,0.550D+02,0.38840000D+01,0.00000000D+00
     .,0.13017488D+04,0.272D+03,0.560D+02,0.38840000D+01,0.00000000D+00
     .,0.11490950D+04,0.272D+03,0.570D+02,0.38840000D+01,0.00000000D+00
     .,0.53712000D+03,0.272D+03,0.580D+02,0.38840000D+01,0.27991000D+01
     .,0.11550423D+04,0.272D+03,0.590D+02,0.38840000D+01,0.00000000D+00
     .,0.11099829D+04,0.272D+03,0.600D+02,0.38840000D+01,0.00000000D+00
     .,0.10823751D+04,0.272D+03,0.610D+02,0.38840000D+01,0.00000000D+00
     .,0.10569604D+04,0.272D+03,0.620D+02,0.38840000D+01,0.00000000D+00
     .,0.10344333D+04,0.272D+03,0.630D+02,0.38840000D+01,0.00000000D+00
     .,0.81761230D+03,0.272D+03,0.640D+02,0.38840000D+01,0.00000000D+00
     .,0.91364540D+03,0.272D+03,0.650D+02,0.38840000D+01,0.00000000D+00
     .,0.88198390D+03,0.272D+03,0.660D+02,0.38840000D+01,0.00000000D+00
     .,0.93409640D+03,0.272D+03,0.670D+02,0.38840000D+01,0.00000000D+00
     .,0.91438960D+03,0.272D+03,0.680D+02,0.38840000D+01,0.00000000D+00
     .,0.89667750D+03,0.272D+03,0.690D+02,0.38840000D+01,0.00000000D+00
     .,0.88600250D+03,0.272D+03,0.700D+02,0.38840000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 120801: 120900)=(/
     . 0.74911050D+03,0.272D+03,0.710D+02,0.38840000D+01,0.00000000D+00
     .,0.74025210D+03,0.272D+03,0.720D+02,0.38840000D+01,0.00000000D+00
     .,0.67737500D+03,0.272D+03,0.730D+02,0.38840000D+01,0.00000000D+00
     .,0.57310850D+03,0.272D+03,0.740D+02,0.38840000D+01,0.00000000D+00
     .,0.58363200D+03,0.272D+03,0.750D+02,0.38840000D+01,0.00000000D+00
     .,0.53009450D+03,0.272D+03,0.760D+02,0.38840000D+01,0.00000000D+00
     .,0.48629160D+03,0.272D+03,0.770D+02,0.38840000D+01,0.00000000D+00
     .,0.40460200D+03,0.272D+03,0.780D+02,0.38840000D+01,0.00000000D+00
     .,0.37824260D+03,0.272D+03,0.790D+02,0.38840000D+01,0.00000000D+00
     .,0.38943520D+03,0.272D+03,0.800D+02,0.38840000D+01,0.00000000D+00
     .,0.56259750D+03,0.272D+03,0.810D+02,0.38840000D+01,0.00000000D+00
     .,0.55195500D+03,0.272D+03,0.820D+02,0.38840000D+01,0.00000000D+00
     .,0.50903810D+03,0.272D+03,0.830D+02,0.38840000D+01,0.00000000D+00
     .,0.48647930D+03,0.272D+03,0.840D+02,0.38840000D+01,0.00000000D+00
     .,0.45000480D+03,0.272D+03,0.850D+02,0.38840000D+01,0.00000000D+00
     .,0.41326650D+03,0.272D+03,0.860D+02,0.38840000D+01,0.00000000D+00
     .,0.13317058D+04,0.272D+03,0.870D+02,0.38840000D+01,0.00000000D+00
     .,0.12904127D+04,0.272D+03,0.880D+02,0.38840000D+01,0.00000000D+00
     .,0.11454809D+04,0.272D+03,0.890D+02,0.38840000D+01,0.00000000D+00
     .,0.10342317D+04,0.272D+03,0.900D+02,0.38840000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 120901: 121000)=(/
     . 0.10243603D+04,0.272D+03,0.910D+02,0.38840000D+01,0.00000000D+00
     .,0.99194790D+03,0.272D+03,0.920D+02,0.38840000D+01,0.00000000D+00
     .,0.10182141D+04,0.272D+03,0.930D+02,0.38840000D+01,0.00000000D+00
     .,0.98657360D+03,0.272D+03,0.940D+02,0.38840000D+01,0.00000000D+00
     .,0.56451300D+02,0.272D+03,0.101D+03,0.38840000D+01,0.00000000D+00
     .,0.18035670D+03,0.272D+03,0.103D+03,0.38840000D+01,0.98650000D+00
     .,0.23052060D+03,0.272D+03,0.104D+03,0.38840000D+01,0.98080000D+00
     .,0.17769180D+03,0.272D+03,0.105D+03,0.38840000D+01,0.97060000D+00
     .,0.13451000D+03,0.272D+03,0.106D+03,0.38840000D+01,0.98680000D+00
     .,0.93956900D+02,0.272D+03,0.107D+03,0.38840000D+01,0.99440000D+00
     .,0.68655500D+02,0.272D+03,0.108D+03,0.38840000D+01,0.99250000D+00
     .,0.47370200D+02,0.272D+03,0.109D+03,0.38840000D+01,0.99820000D+00
     .,0.26307010D+03,0.272D+03,0.111D+03,0.38840000D+01,0.96840000D+00
     .,0.40658200D+03,0.272D+03,0.112D+03,0.38840000D+01,0.96280000D+00
     .,0.41382490D+03,0.272D+03,0.113D+03,0.38840000D+01,0.96480000D+00
     .,0.33484900D+03,0.272D+03,0.114D+03,0.38840000D+01,0.95070000D+00
     .,0.27554270D+03,0.272D+03,0.115D+03,0.38840000D+01,0.99470000D+00
     .,0.23369990D+03,0.272D+03,0.116D+03,0.38840000D+01,0.99480000D+00
     .,0.19157960D+03,0.272D+03,0.117D+03,0.38840000D+01,0.99720000D+00
     .,0.36408150D+03,0.272D+03,0.119D+03,0.38840000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters( 121001: 121100)=(/
     . 0.68723560D+03,0.272D+03,0.120D+03,0.38840000D+01,0.98310000D+00
     .,0.36630740D+03,0.272D+03,0.121D+03,0.38840000D+01,0.18627000D+01
     .,0.35366860D+03,0.272D+03,0.122D+03,0.38840000D+01,0.18299000D+01
     .,0.34654410D+03,0.272D+03,0.123D+03,0.38840000D+01,0.19138000D+01
     .,0.34308700D+03,0.272D+03,0.124D+03,0.38840000D+01,0.18269000D+01
     .,0.31671570D+03,0.272D+03,0.125D+03,0.38840000D+01,0.16406000D+01
     .,0.29336460D+03,0.272D+03,0.126D+03,0.38840000D+01,0.16483000D+01
     .,0.27983390D+03,0.272D+03,0.127D+03,0.38840000D+01,0.17149000D+01
     .,0.27349300D+03,0.272D+03,0.128D+03,0.38840000D+01,0.17937000D+01
     .,0.26953150D+03,0.272D+03,0.129D+03,0.38840000D+01,0.95760000D+00
     .,0.25402930D+03,0.272D+03,0.130D+03,0.38840000D+01,0.19419000D+01
     .,0.41165060D+03,0.272D+03,0.131D+03,0.38840000D+01,0.96010000D+00
     .,0.36351880D+03,0.272D+03,0.132D+03,0.38840000D+01,0.94340000D+00
     .,0.32699810D+03,0.272D+03,0.133D+03,0.38840000D+01,0.98890000D+00
     .,0.29929580D+03,0.272D+03,0.134D+03,0.38840000D+01,0.99010000D+00
     .,0.26427820D+03,0.272D+03,0.135D+03,0.38840000D+01,0.99740000D+00
     .,0.43494430D+03,0.272D+03,0.137D+03,0.38840000D+01,0.97380000D+00
     .,0.83572700D+03,0.272D+03,0.138D+03,0.38840000D+01,0.98010000D+00
     .,0.64479280D+03,0.272D+03,0.139D+03,0.38840000D+01,0.19153000D+01
     .,0.48425820D+03,0.272D+03,0.140D+03,0.38840000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters( 121101: 121200)=(/
     . 0.48896320D+03,0.272D+03,0.141D+03,0.38840000D+01,0.19545000D+01
     .,0.45641490D+03,0.272D+03,0.142D+03,0.38840000D+01,0.19420000D+01
     .,0.50966540D+03,0.272D+03,0.143D+03,0.38840000D+01,0.16682000D+01
     .,0.39898040D+03,0.272D+03,0.144D+03,0.38840000D+01,0.18584000D+01
     .,0.37331410D+03,0.272D+03,0.145D+03,0.38840000D+01,0.19003000D+01
     .,0.34680080D+03,0.272D+03,0.146D+03,0.38840000D+01,0.18630000D+01
     .,0.33529990D+03,0.272D+03,0.147D+03,0.38840000D+01,0.96790000D+00
     .,0.33249420D+03,0.272D+03,0.148D+03,0.38840000D+01,0.19539000D+01
     .,0.52263660D+03,0.272D+03,0.149D+03,0.38840000D+01,0.96330000D+00
     .,0.47495740D+03,0.272D+03,0.150D+03,0.38840000D+01,0.95140000D+00
     .,0.44616040D+03,0.272D+03,0.151D+03,0.38840000D+01,0.97490000D+00
     .,0.42289020D+03,0.272D+03,0.152D+03,0.38840000D+01,0.98110000D+00
     .,0.38708050D+03,0.272D+03,0.153D+03,0.38840000D+01,0.99680000D+00
     .,0.51625270D+03,0.272D+03,0.155D+03,0.38840000D+01,0.99090000D+00
     .,0.10815338D+04,0.272D+03,0.156D+03,0.38840000D+01,0.97970000D+00
     .,0.81548330D+03,0.272D+03,0.157D+03,0.38840000D+01,0.19373000D+01
     .,0.52103820D+03,0.272D+03,0.159D+03,0.38840000D+01,0.29425000D+01
     .,0.51028040D+03,0.272D+03,0.160D+03,0.38840000D+01,0.29455000D+01
     .,0.49420110D+03,0.272D+03,0.161D+03,0.38840000D+01,0.29413000D+01
     .,0.49632490D+03,0.272D+03,0.162D+03,0.38840000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters( 121201: 121300)=(/
     . 0.47741750D+03,0.272D+03,0.163D+03,0.38840000D+01,0.18286000D+01
     .,0.49938720D+03,0.272D+03,0.164D+03,0.38840000D+01,0.28732000D+01
     .,0.46926950D+03,0.272D+03,0.165D+03,0.38840000D+01,0.29086000D+01
     .,0.47695560D+03,0.272D+03,0.166D+03,0.38840000D+01,0.28965000D+01
     .,0.44565950D+03,0.272D+03,0.167D+03,0.38840000D+01,0.29242000D+01
     .,0.43304490D+03,0.272D+03,0.168D+03,0.38840000D+01,0.29282000D+01
     .,0.43020330D+03,0.272D+03,0.169D+03,0.38840000D+01,0.29246000D+01
     .,0.45184050D+03,0.272D+03,0.170D+03,0.38840000D+01,0.28482000D+01
     .,0.41595250D+03,0.272D+03,0.171D+03,0.38840000D+01,0.29219000D+01
     .,0.55954550D+03,0.272D+03,0.172D+03,0.38840000D+01,0.19254000D+01
     .,0.52058420D+03,0.272D+03,0.173D+03,0.38840000D+01,0.19459000D+01
     .,0.47617010D+03,0.272D+03,0.174D+03,0.38840000D+01,0.19292000D+01
     .,0.48071520D+03,0.272D+03,0.175D+03,0.38840000D+01,0.18104000D+01
     .,0.42322750D+03,0.272D+03,0.176D+03,0.38840000D+01,0.18858000D+01
     .,0.39843450D+03,0.272D+03,0.177D+03,0.38840000D+01,0.18648000D+01
     .,0.38070180D+03,0.272D+03,0.178D+03,0.38840000D+01,0.19188000D+01
     .,0.36388290D+03,0.272D+03,0.179D+03,0.38840000D+01,0.98460000D+00
     .,0.35232230D+03,0.272D+03,0.180D+03,0.38840000D+01,0.19896000D+01
     .,0.56157040D+03,0.272D+03,0.181D+03,0.38840000D+01,0.92670000D+00
     .,0.51406470D+03,0.272D+03,0.182D+03,0.38840000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters( 121301: 121400)=(/
     . 0.49968080D+03,0.272D+03,0.183D+03,0.38840000D+01,0.98200000D+00
     .,0.48675350D+03,0.272D+03,0.184D+03,0.38840000D+01,0.98150000D+00
     .,0.45547580D+03,0.272D+03,0.185D+03,0.38840000D+01,0.99540000D+00
     .,0.58159320D+03,0.272D+03,0.187D+03,0.38840000D+01,0.97050000D+00
     .,0.10790444D+04,0.272D+03,0.188D+03,0.38840000D+01,0.96620000D+00
     .,0.61650660D+03,0.272D+03,0.189D+03,0.38840000D+01,0.29070000D+01
     .,0.70890840D+03,0.272D+03,0.190D+03,0.38840000D+01,0.28844000D+01
     .,0.63454270D+03,0.272D+03,0.191D+03,0.38840000D+01,0.28738000D+01
     .,0.56236500D+03,0.272D+03,0.192D+03,0.38840000D+01,0.28878000D+01
     .,0.54147420D+03,0.272D+03,0.193D+03,0.38840000D+01,0.29095000D+01
     .,0.64630030D+03,0.272D+03,0.194D+03,0.38840000D+01,0.19209000D+01
     .,0.15187100D+03,0.272D+03,0.204D+03,0.38840000D+01,0.19697000D+01
     .,0.14945570D+03,0.272D+03,0.205D+03,0.38840000D+01,0.19441000D+01
     .,0.10995340D+03,0.272D+03,0.206D+03,0.38840000D+01,0.19985000D+01
     .,0.88233300D+02,0.272D+03,0.207D+03,0.38840000D+01,0.20143000D+01
     .,0.60592700D+02,0.272D+03,0.208D+03,0.38840000D+01,0.19887000D+01
     .,0.26815940D+03,0.272D+03,0.212D+03,0.38840000D+01,0.19496000D+01
     .,0.32387400D+03,0.272D+03,0.213D+03,0.38840000D+01,0.19311000D+01
     .,0.31174680D+03,0.272D+03,0.214D+03,0.38840000D+01,0.19435000D+01
     .,0.27170710D+03,0.272D+03,0.215D+03,0.38840000D+01,0.20102000D+01
     ./)
      grimme_c6_parameters( 121401: 121500)=(/
     . 0.22898300D+03,0.272D+03,0.216D+03,0.38840000D+01,0.19903000D+01
     .,0.37583520D+03,0.272D+03,0.220D+03,0.38840000D+01,0.19349000D+01
     .,0.36214280D+03,0.272D+03,0.221D+03,0.38840000D+01,0.28999000D+01
     .,0.36666280D+03,0.272D+03,0.222D+03,0.38840000D+01,0.38675000D+01
     .,0.33547490D+03,0.272D+03,0.223D+03,0.38840000D+01,0.29110000D+01
     .,0.25363880D+03,0.272D+03,0.224D+03,0.38840000D+01,0.10619100D+02
     .,0.21751740D+03,0.272D+03,0.225D+03,0.38840000D+01,0.98849000D+01
     .,0.21343980D+03,0.272D+03,0.226D+03,0.38840000D+01,0.91376000D+01
     .,0.24927270D+03,0.272D+03,0.227D+03,0.38840000D+01,0.29263000D+01
     .,0.23249050D+03,0.272D+03,0.228D+03,0.38840000D+01,0.65458000D+01
     .,0.32767280D+03,0.272D+03,0.231D+03,0.38840000D+01,0.19315000D+01
     .,0.34636060D+03,0.272D+03,0.232D+03,0.38840000D+01,0.19447000D+01
     .,0.31855200D+03,0.272D+03,0.233D+03,0.38840000D+01,0.19793000D+01
     .,0.29696280D+03,0.272D+03,0.234D+03,0.38840000D+01,0.19812000D+01
     .,0.45040960D+03,0.272D+03,0.238D+03,0.38840000D+01,0.19143000D+01
     .,0.43502220D+03,0.272D+03,0.239D+03,0.38840000D+01,0.28903000D+01
     .,0.43916880D+03,0.272D+03,0.240D+03,0.38840000D+01,0.39106000D+01
     .,0.42451400D+03,0.272D+03,0.241D+03,0.38840000D+01,0.29225000D+01
     .,0.37628530D+03,0.272D+03,0.242D+03,0.38840000D+01,0.11055600D+02
     .,0.33276620D+03,0.272D+03,0.243D+03,0.38840000D+01,0.95402000D+01
     ./)
      grimme_c6_parameters( 121501: 121600)=(/
     . 0.31465980D+03,0.272D+03,0.244D+03,0.38840000D+01,0.88895000D+01
     .,0.31973310D+03,0.272D+03,0.245D+03,0.38840000D+01,0.29696000D+01
     .,0.33378790D+03,0.272D+03,0.246D+03,0.38840000D+01,0.57095000D+01
     .,0.42275520D+03,0.272D+03,0.249D+03,0.38840000D+01,0.19378000D+01
     .,0.45955200D+03,0.272D+03,0.250D+03,0.38840000D+01,0.19505000D+01
     .,0.43419590D+03,0.272D+03,0.251D+03,0.38840000D+01,0.19523000D+01
     .,0.41956530D+03,0.272D+03,0.252D+03,0.38840000D+01,0.19639000D+01
     .,0.54526090D+03,0.272D+03,0.256D+03,0.38840000D+01,0.18467000D+01
     .,0.56623920D+03,0.272D+03,0.257D+03,0.38840000D+01,0.29175000D+01
     .,0.42097660D+03,0.272D+03,0.272D+03,0.38840000D+01,0.38840000D+01
     .,0.36595100D+02,0.273D+03,0.100D+01,0.28988000D+01,0.91180000D+00
     .,0.24281400D+02,0.273D+03,0.200D+01,0.28988000D+01,0.00000000D+00
     .,0.56610590D+03,0.273D+03,0.300D+01,0.28988000D+01,0.00000000D+00
     .,0.32644690D+03,0.273D+03,0.400D+01,0.28988000D+01,0.00000000D+00
     .,0.22041970D+03,0.273D+03,0.500D+01,0.28988000D+01,0.00000000D+00
     .,0.14932900D+03,0.273D+03,0.600D+01,0.28988000D+01,0.00000000D+00
     .,0.10467690D+03,0.273D+03,0.700D+01,0.28988000D+01,0.00000000D+00
     .,0.79396800D+02,0.273D+03,0.800D+01,0.28988000D+01,0.00000000D+00
     .,0.60239300D+02,0.273D+03,0.900D+01,0.28988000D+01,0.00000000D+00
     .,0.46387800D+02,0.273D+03,0.100D+02,0.28988000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 121601: 121700)=(/
     . 0.67687130D+03,0.273D+03,0.110D+02,0.28988000D+01,0.00000000D+00
     .,0.51998460D+03,0.273D+03,0.120D+02,0.28988000D+01,0.00000000D+00
     .,0.47979410D+03,0.273D+03,0.130D+02,0.28988000D+01,0.00000000D+00
     .,0.37862690D+03,0.273D+03,0.140D+02,0.28988000D+01,0.00000000D+00
     .,0.29580530D+03,0.273D+03,0.150D+02,0.28988000D+01,0.00000000D+00
     .,0.24586750D+03,0.273D+03,0.160D+02,0.28988000D+01,0.00000000D+00
     .,0.20113960D+03,0.273D+03,0.170D+02,0.28988000D+01,0.00000000D+00
     .,0.16478050D+03,0.273D+03,0.180D+02,0.28988000D+01,0.00000000D+00
     .,0.11126264D+04,0.273D+03,0.190D+02,0.28988000D+01,0.00000000D+00
     .,0.91447030D+03,0.273D+03,0.200D+02,0.28988000D+01,0.00000000D+00
     .,0.75525190D+03,0.273D+03,0.210D+02,0.28988000D+01,0.00000000D+00
     .,0.72956490D+03,0.273D+03,0.220D+02,0.28988000D+01,0.00000000D+00
     .,0.66815990D+03,0.273D+03,0.230D+02,0.28988000D+01,0.00000000D+00
     .,0.52676740D+03,0.273D+03,0.240D+02,0.28988000D+01,0.00000000D+00
     .,0.57538750D+03,0.273D+03,0.250D+02,0.28988000D+01,0.00000000D+00
     .,0.45195440D+03,0.273D+03,0.260D+02,0.28988000D+01,0.00000000D+00
     .,0.47878370D+03,0.273D+03,0.270D+02,0.28988000D+01,0.00000000D+00
     .,0.49306650D+03,0.273D+03,0.280D+02,0.28988000D+01,0.00000000D+00
     .,0.37838780D+03,0.273D+03,0.290D+02,0.28988000D+01,0.00000000D+00
     .,0.38837940D+03,0.273D+03,0.300D+02,0.28988000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 121701: 121800)=(/
     . 0.45998760D+03,0.273D+03,0.310D+02,0.28988000D+01,0.00000000D+00
     .,0.40600970D+03,0.273D+03,0.320D+02,0.28988000D+01,0.00000000D+00
     .,0.34676900D+03,0.273D+03,0.330D+02,0.28988000D+01,0.00000000D+00
     .,0.31149230D+03,0.273D+03,0.340D+02,0.28988000D+01,0.00000000D+00
     .,0.27290380D+03,0.273D+03,0.350D+02,0.28988000D+01,0.00000000D+00
     .,0.23759510D+03,0.273D+03,0.360D+02,0.28988000D+01,0.00000000D+00
     .,0.12473944D+04,0.273D+03,0.370D+02,0.28988000D+01,0.00000000D+00
     .,0.10901054D+04,0.273D+03,0.380D+02,0.28988000D+01,0.00000000D+00
     .,0.95467960D+03,0.273D+03,0.390D+02,0.28988000D+01,0.00000000D+00
     .,0.85810820D+03,0.273D+03,0.400D+02,0.28988000D+01,0.00000000D+00
     .,0.78268490D+03,0.273D+03,0.410D+02,0.28988000D+01,0.00000000D+00
     .,0.60471660D+03,0.273D+03,0.420D+02,0.28988000D+01,0.00000000D+00
     .,0.67451160D+03,0.273D+03,0.430D+02,0.28988000D+01,0.00000000D+00
     .,0.51426690D+03,0.273D+03,0.440D+02,0.28988000D+01,0.00000000D+00
     .,0.56175990D+03,0.273D+03,0.450D+02,0.28988000D+01,0.00000000D+00
     .,0.52100450D+03,0.273D+03,0.460D+02,0.28988000D+01,0.00000000D+00
     .,0.43478170D+03,0.273D+03,0.470D+02,0.28988000D+01,0.00000000D+00
     .,0.45916630D+03,0.273D+03,0.480D+02,0.28988000D+01,0.00000000D+00
     .,0.57597200D+03,0.273D+03,0.490D+02,0.28988000D+01,0.00000000D+00
     .,0.53273890D+03,0.273D+03,0.500D+02,0.28988000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 121801: 121900)=(/
     . 0.47516010D+03,0.273D+03,0.510D+02,0.28988000D+01,0.00000000D+00
     .,0.44117360D+03,0.273D+03,0.520D+02,0.28988000D+01,0.00000000D+00
     .,0.39923870D+03,0.273D+03,0.530D+02,0.28988000D+01,0.00000000D+00
     .,0.35925420D+03,0.273D+03,0.540D+02,0.28988000D+01,0.00000000D+00
     .,0.15209786D+04,0.273D+03,0.550D+02,0.28988000D+01,0.00000000D+00
     .,0.13908237D+04,0.273D+03,0.560D+02,0.28988000D+01,0.00000000D+00
     .,0.12212713D+04,0.273D+03,0.570D+02,0.28988000D+01,0.00000000D+00
     .,0.56144200D+03,0.273D+03,0.580D+02,0.28988000D+01,0.27991000D+01
     .,0.12321348D+04,0.273D+03,0.590D+02,0.28988000D+01,0.00000000D+00
     .,0.11827756D+04,0.273D+03,0.600D+02,0.28988000D+01,0.00000000D+00
     .,0.11530265D+04,0.273D+03,0.610D+02,0.28988000D+01,0.00000000D+00
     .,0.11256719D+04,0.273D+03,0.620D+02,0.28988000D+01,0.00000000D+00
     .,0.11014151D+04,0.273D+03,0.630D+02,0.28988000D+01,0.00000000D+00
     .,0.86643530D+03,0.273D+03,0.640D+02,0.28988000D+01,0.00000000D+00
     .,0.97722080D+03,0.273D+03,0.650D+02,0.28988000D+01,0.00000000D+00
     .,0.94263090D+03,0.273D+03,0.660D+02,0.28988000D+01,0.00000000D+00
     .,0.99314900D+03,0.273D+03,0.670D+02,0.28988000D+01,0.00000000D+00
     .,0.97201510D+03,0.273D+03,0.680D+02,0.28988000D+01,0.00000000D+00
     .,0.95296410D+03,0.273D+03,0.690D+02,0.28988000D+01,0.00000000D+00
     .,0.94178690D+03,0.273D+03,0.700D+02,0.28988000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 121901: 122000)=(/
     . 0.79383690D+03,0.273D+03,0.710D+02,0.28988000D+01,0.00000000D+00
     .,0.78053540D+03,0.273D+03,0.720D+02,0.28988000D+01,0.00000000D+00
     .,0.71253240D+03,0.273D+03,0.730D+02,0.28988000D+01,0.00000000D+00
     .,0.60220240D+03,0.273D+03,0.740D+02,0.28988000D+01,0.00000000D+00
     .,0.61258210D+03,0.273D+03,0.750D+02,0.28988000D+01,0.00000000D+00
     .,0.55538920D+03,0.273D+03,0.760D+02,0.28988000D+01,0.00000000D+00
     .,0.50882230D+03,0.273D+03,0.770D+02,0.28988000D+01,0.00000000D+00
     .,0.42301850D+03,0.273D+03,0.780D+02,0.28988000D+01,0.00000000D+00
     .,0.39532750D+03,0.273D+03,0.790D+02,0.28988000D+01,0.00000000D+00
     .,0.40661330D+03,0.273D+03,0.800D+02,0.28988000D+01,0.00000000D+00
     .,0.59190940D+03,0.273D+03,0.810D+02,0.28988000D+01,0.00000000D+00
     .,0.57859300D+03,0.273D+03,0.820D+02,0.28988000D+01,0.00000000D+00
     .,0.53193140D+03,0.273D+03,0.830D+02,0.28988000D+01,0.00000000D+00
     .,0.50757870D+03,0.273D+03,0.840D+02,0.28988000D+01,0.00000000D+00
     .,0.46877360D+03,0.273D+03,0.850D+02,0.28988000D+01,0.00000000D+00
     .,0.42997720D+03,0.273D+03,0.860D+02,0.28988000D+01,0.00000000D+00
     .,0.14348337D+04,0.273D+03,0.870D+02,0.28988000D+01,0.00000000D+00
     .,0.13751465D+04,0.273D+03,0.880D+02,0.28988000D+01,0.00000000D+00
     .,0.12148259D+04,0.273D+03,0.890D+02,0.28988000D+01,0.00000000D+00
     .,0.10917991D+04,0.273D+03,0.900D+02,0.28988000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 122001: 122100)=(/
     . 0.10843209D+04,0.273D+03,0.910D+02,0.28988000D+01,0.00000000D+00
     .,0.10498792D+04,0.273D+03,0.920D+02,0.28988000D+01,0.00000000D+00
     .,0.10808128D+04,0.273D+03,0.930D+02,0.28988000D+01,0.00000000D+00
     .,0.10465858D+04,0.273D+03,0.940D+02,0.28988000D+01,0.00000000D+00
     .,0.58803800D+02,0.273D+03,0.101D+03,0.28988000D+01,0.00000000D+00
     .,0.18986110D+03,0.273D+03,0.103D+03,0.28988000D+01,0.98650000D+00
     .,0.24244290D+03,0.273D+03,0.104D+03,0.28988000D+01,0.98080000D+00
     .,0.18557490D+03,0.273D+03,0.105D+03,0.28988000D+01,0.97060000D+00
     .,0.14012490D+03,0.273D+03,0.106D+03,0.28988000D+01,0.98680000D+00
     .,0.97656800D+02,0.273D+03,0.107D+03,0.28988000D+01,0.99440000D+00
     .,0.71264400D+02,0.273D+03,0.108D+03,0.28988000D+01,0.99250000D+00
     .,0.49121900D+02,0.273D+03,0.109D+03,0.28988000D+01,0.99820000D+00
     .,0.27753610D+03,0.273D+03,0.111D+03,0.28988000D+01,0.96840000D+00
     .,0.42932400D+03,0.273D+03,0.112D+03,0.28988000D+01,0.96280000D+00
     .,0.43497780D+03,0.273D+03,0.113D+03,0.28988000D+01,0.96480000D+00
     .,0.35008490D+03,0.273D+03,0.114D+03,0.28988000D+01,0.95070000D+00
     .,0.28716960D+03,0.273D+03,0.115D+03,0.28988000D+01,0.99470000D+00
     .,0.24316080D+03,0.273D+03,0.116D+03,0.28988000D+01,0.99480000D+00
     .,0.19905370D+03,0.273D+03,0.117D+03,0.28988000D+01,0.99720000D+00
     .,0.38351900D+03,0.273D+03,0.119D+03,0.28988000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters( 122101: 122200)=(/
     . 0.73299270D+03,0.273D+03,0.120D+03,0.28988000D+01,0.98310000D+00
     .,0.38359320D+03,0.273D+03,0.121D+03,0.28988000D+01,0.18627000D+01
     .,0.37045440D+03,0.273D+03,0.122D+03,0.28988000D+01,0.18299000D+01
     .,0.36303280D+03,0.273D+03,0.123D+03,0.28988000D+01,0.19138000D+01
     .,0.35964520D+03,0.273D+03,0.124D+03,0.28988000D+01,0.18269000D+01
     .,0.33100010D+03,0.273D+03,0.125D+03,0.28988000D+01,0.16406000D+01
     .,0.30643150D+03,0.273D+03,0.126D+03,0.28988000D+01,0.16483000D+01
     .,0.29235680D+03,0.273D+03,0.127D+03,0.28988000D+01,0.17149000D+01
     .,0.28579970D+03,0.273D+03,0.128D+03,0.28988000D+01,0.17937000D+01
     .,0.28225140D+03,0.273D+03,0.129D+03,0.28988000D+01,0.95760000D+00
     .,0.26501660D+03,0.273D+03,0.130D+03,0.28988000D+01,0.19419000D+01
     .,0.43212490D+03,0.273D+03,0.131D+03,0.28988000D+01,0.96010000D+00
     .,0.37997370D+03,0.273D+03,0.132D+03,0.28988000D+01,0.94340000D+00
     .,0.34092760D+03,0.273D+03,0.133D+03,0.28988000D+01,0.98890000D+00
     .,0.31161210D+03,0.273D+03,0.134D+03,0.28988000D+01,0.99010000D+00
     .,0.27478910D+03,0.273D+03,0.135D+03,0.28988000D+01,0.99740000D+00
     .,0.45784580D+03,0.273D+03,0.137D+03,0.28988000D+01,0.97380000D+00
     .,0.89253360D+03,0.273D+03,0.138D+03,0.28988000D+01,0.98010000D+00
     .,0.68212820D+03,0.273D+03,0.139D+03,0.28988000D+01,0.19153000D+01
     .,0.50766120D+03,0.273D+03,0.140D+03,0.28988000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters( 122201: 122300)=(/
     . 0.51256950D+03,0.273D+03,0.141D+03,0.28988000D+01,0.19545000D+01
     .,0.47819280D+03,0.273D+03,0.142D+03,0.28988000D+01,0.19420000D+01
     .,0.53626360D+03,0.273D+03,0.143D+03,0.28988000D+01,0.16682000D+01
     .,0.41699040D+03,0.273D+03,0.144D+03,0.28988000D+01,0.18584000D+01
     .,0.39019030D+03,0.273D+03,0.145D+03,0.28988000D+01,0.19003000D+01
     .,0.36240560D+03,0.273D+03,0.146D+03,0.28988000D+01,0.18630000D+01
     .,0.35051370D+03,0.273D+03,0.147D+03,0.28988000D+01,0.96790000D+00
     .,0.34680430D+03,0.273D+03,0.148D+03,0.28988000D+01,0.19539000D+01
     .,0.54909790D+03,0.273D+03,0.149D+03,0.28988000D+01,0.96330000D+00
     .,0.49700410D+03,0.273D+03,0.150D+03,0.28988000D+01,0.95140000D+00
     .,0.46575860D+03,0.273D+03,0.151D+03,0.28988000D+01,0.97490000D+00
     .,0.44087250D+03,0.273D+03,0.152D+03,0.28988000D+01,0.98110000D+00
     .,0.40297870D+03,0.273D+03,0.153D+03,0.28988000D+01,0.99680000D+00
     .,0.54168560D+03,0.273D+03,0.155D+03,0.28988000D+01,0.99090000D+00
     .,0.11586256D+04,0.273D+03,0.156D+03,0.28988000D+01,0.97970000D+00
     .,0.86372770D+03,0.273D+03,0.157D+03,0.28988000D+01,0.19373000D+01
     .,0.54454800D+03,0.273D+03,0.159D+03,0.28988000D+01,0.29425000D+01
     .,0.53328550D+03,0.273D+03,0.160D+03,0.28988000D+01,0.29455000D+01
     .,0.51641630D+03,0.273D+03,0.161D+03,0.28988000D+01,0.29413000D+01
     .,0.51893410D+03,0.273D+03,0.162D+03,0.28988000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters( 122301: 122400)=(/
     . 0.50005910D+03,0.273D+03,0.163D+03,0.28988000D+01,0.18286000D+01
     .,0.52212860D+03,0.273D+03,0.164D+03,0.28988000D+01,0.28732000D+01
     .,0.49044870D+03,0.273D+03,0.165D+03,0.28988000D+01,0.29086000D+01
     .,0.49903390D+03,0.273D+03,0.166D+03,0.28988000D+01,0.28965000D+01
     .,0.46555820D+03,0.273D+03,0.167D+03,0.28988000D+01,0.29242000D+01
     .,0.45230800D+03,0.273D+03,0.168D+03,0.28988000D+01,0.29282000D+01
     .,0.44938570D+03,0.273D+03,0.169D+03,0.28988000D+01,0.29246000D+01
     .,0.47221050D+03,0.273D+03,0.170D+03,0.28988000D+01,0.28482000D+01
     .,0.43437410D+03,0.273D+03,0.171D+03,0.28988000D+01,0.29219000D+01
     .,0.58833640D+03,0.273D+03,0.172D+03,0.28988000D+01,0.19254000D+01
     .,0.54616030D+03,0.273D+03,0.173D+03,0.28988000D+01,0.19459000D+01
     .,0.49848100D+03,0.273D+03,0.174D+03,0.28988000D+01,0.19292000D+01
     .,0.50425710D+03,0.273D+03,0.175D+03,0.28988000D+01,0.18104000D+01
     .,0.44178790D+03,0.273D+03,0.176D+03,0.28988000D+01,0.18858000D+01
     .,0.41572770D+03,0.273D+03,0.177D+03,0.28988000D+01,0.18648000D+01
     .,0.39714540D+03,0.273D+03,0.178D+03,0.28988000D+01,0.19188000D+01
     .,0.37972750D+03,0.273D+03,0.179D+03,0.28988000D+01,0.98460000D+00
     .,0.36701200D+03,0.273D+03,0.180D+03,0.28988000D+01,0.19896000D+01
     .,0.59000540D+03,0.273D+03,0.181D+03,0.28988000D+01,0.92670000D+00
     .,0.53789130D+03,0.273D+03,0.182D+03,0.28988000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters( 122401: 122500)=(/
     . 0.52181620D+03,0.273D+03,0.183D+03,0.28988000D+01,0.98200000D+00
     .,0.50773170D+03,0.273D+03,0.184D+03,0.28988000D+01,0.98150000D+00
     .,0.47444690D+03,0.273D+03,0.185D+03,0.28988000D+01,0.99540000D+00
     .,0.61006800D+03,0.273D+03,0.187D+03,0.28988000D+01,0.97050000D+00
     .,0.11516502D+04,0.273D+03,0.188D+03,0.28988000D+01,0.96620000D+00
     .,0.64431070D+03,0.273D+03,0.189D+03,0.28988000D+01,0.29070000D+01
     .,0.74392250D+03,0.273D+03,0.190D+03,0.28988000D+01,0.28844000D+01
     .,0.66568850D+03,0.273D+03,0.191D+03,0.28988000D+01,0.28738000D+01
     .,0.58786120D+03,0.273D+03,0.192D+03,0.28988000D+01,0.28878000D+01
     .,0.56570590D+03,0.273D+03,0.193D+03,0.28988000D+01,0.29095000D+01
     .,0.68049130D+03,0.273D+03,0.194D+03,0.28988000D+01,0.19209000D+01
     .,0.15844380D+03,0.273D+03,0.204D+03,0.28988000D+01,0.19697000D+01
     .,0.15595490D+03,0.273D+03,0.205D+03,0.28988000D+01,0.19441000D+01
     .,0.11435140D+03,0.273D+03,0.206D+03,0.28988000D+01,0.19985000D+01
     .,0.91693500D+02,0.273D+03,0.207D+03,0.28988000D+01,0.20143000D+01
     .,0.62899100D+02,0.273D+03,0.208D+03,0.28988000D+01,0.19887000D+01
     .,0.28061570D+03,0.273D+03,0.212D+03,0.28988000D+01,0.19496000D+01
     .,0.33928390D+03,0.273D+03,0.213D+03,0.28988000D+01,0.19311000D+01
     .,0.32570670D+03,0.273D+03,0.214D+03,0.28988000D+01,0.19435000D+01
     .,0.28327190D+03,0.273D+03,0.215D+03,0.28988000D+01,0.20102000D+01
     ./)
      grimme_c6_parameters( 122501: 122600)=(/
     . 0.23825580D+03,0.273D+03,0.216D+03,0.28988000D+01,0.19903000D+01
     .,0.39378620D+03,0.273D+03,0.220D+03,0.28988000D+01,0.19349000D+01
     .,0.37862350D+03,0.273D+03,0.221D+03,0.28988000D+01,0.28999000D+01
     .,0.38330360D+03,0.273D+03,0.222D+03,0.28988000D+01,0.38675000D+01
     .,0.35090960D+03,0.273D+03,0.223D+03,0.28988000D+01,0.29110000D+01
     .,0.26469190D+03,0.273D+03,0.224D+03,0.28988000D+01,0.10619100D+02
     .,0.22664920D+03,0.273D+03,0.225D+03,0.28988000D+01,0.98849000D+01
     .,0.22244630D+03,0.273D+03,0.226D+03,0.28988000D+01,0.91376000D+01
     .,0.26044220D+03,0.273D+03,0.227D+03,0.28988000D+01,0.29263000D+01
     .,0.24268500D+03,0.273D+03,0.228D+03,0.28988000D+01,0.65458000D+01
     .,0.34272530D+03,0.273D+03,0.231D+03,0.28988000D+01,0.19315000D+01
     .,0.36182680D+03,0.273D+03,0.232D+03,0.28988000D+01,0.19447000D+01
     .,0.33202940D+03,0.273D+03,0.233D+03,0.28988000D+01,0.19793000D+01
     .,0.30917670D+03,0.273D+03,0.234D+03,0.28988000D+01,0.19812000D+01
     .,0.47200610D+03,0.273D+03,0.238D+03,0.28988000D+01,0.19143000D+01
     .,0.45450240D+03,0.273D+03,0.239D+03,0.28988000D+01,0.28903000D+01
     .,0.45850240D+03,0.273D+03,0.240D+03,0.28988000D+01,0.39106000D+01
     .,0.44354250D+03,0.273D+03,0.241D+03,0.28988000D+01,0.29225000D+01
     .,0.39244480D+03,0.273D+03,0.242D+03,0.28988000D+01,0.11055600D+02
     .,0.34662740D+03,0.273D+03,0.243D+03,0.28988000D+01,0.95402000D+01
     ./)
      grimme_c6_parameters( 122601: 122700)=(/
     . 0.32763810D+03,0.273D+03,0.244D+03,0.28988000D+01,0.88895000D+01
     .,0.33357090D+03,0.273D+03,0.245D+03,0.28988000D+01,0.29696000D+01
     .,0.34831840D+03,0.273D+03,0.246D+03,0.28988000D+01,0.57095000D+01
     .,0.44228570D+03,0.273D+03,0.249D+03,0.28988000D+01,0.19378000D+01
     .,0.48056320D+03,0.273D+03,0.250D+03,0.28988000D+01,0.19505000D+01
     .,0.45304590D+03,0.273D+03,0.251D+03,0.28988000D+01,0.19523000D+01
     .,0.43732780D+03,0.273D+03,0.252D+03,0.28988000D+01,0.19639000D+01
     .,0.57116140D+03,0.273D+03,0.256D+03,0.28988000D+01,0.18467000D+01
     .,0.59193970D+03,0.273D+03,0.257D+03,0.28988000D+01,0.29175000D+01
     .,0.43911410D+03,0.273D+03,0.272D+03,0.28988000D+01,0.38840000D+01
     .,0.45876770D+03,0.273D+03,0.273D+03,0.28988000D+01,0.28988000D+01
     .,0.34435200D+02,0.274D+03,0.100D+01,0.10915300D+02,0.91180000D+00
     .,0.23230100D+02,0.274D+03,0.200D+01,0.10915300D+02,0.00000000D+00
     .,0.49948070D+03,0.274D+03,0.300D+01,0.10915300D+02,0.00000000D+00
     .,0.29673610D+03,0.274D+03,0.400D+01,0.10915300D+02,0.00000000D+00
     .,0.20361200D+03,0.274D+03,0.500D+01,0.10915300D+02,0.00000000D+00
     .,0.13967130D+03,0.274D+03,0.600D+01,0.10915300D+02,0.00000000D+00
     .,0.98854100D+02,0.274D+03,0.700D+01,0.10915300D+02,0.00000000D+00
     .,0.75508800D+02,0.274D+03,0.800D+01,0.10915300D+02,0.00000000D+00
     .,0.57643800D+02,0.274D+03,0.900D+01,0.10915300D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 122701: 122800)=(/
     . 0.44614500D+02,0.274D+03,0.100D+02,0.10915300D+02,0.00000000D+00
     .,0.59853480D+03,0.274D+03,0.110D+02,0.10915300D+02,0.00000000D+00
     .,0.47040460D+03,0.274D+03,0.120D+02,0.10915300D+02,0.00000000D+00
     .,0.43759830D+03,0.274D+03,0.130D+02,0.10915300D+02,0.00000000D+00
     .,0.34916910D+03,0.274D+03,0.140D+02,0.10915300D+02,0.00000000D+00
     .,0.27538760D+03,0.274D+03,0.150D+02,0.10915300D+02,0.00000000D+00
     .,0.23036660D+03,0.274D+03,0.160D+02,0.10915300D+02,0.00000000D+00
     .,0.18964180D+03,0.274D+03,0.170D+02,0.10915300D+02,0.00000000D+00
     .,0.15623470D+03,0.274D+03,0.180D+02,0.10915300D+02,0.00000000D+00
     .,0.97919910D+03,0.274D+03,0.190D+02,0.10915300D+02,0.00000000D+00
     .,0.82027660D+03,0.274D+03,0.200D+02,0.10915300D+02,0.00000000D+00
     .,0.68015970D+03,0.274D+03,0.210D+02,0.10915300D+02,0.00000000D+00
     .,0.65948500D+03,0.274D+03,0.220D+02,0.10915300D+02,0.00000000D+00
     .,0.60531050D+03,0.274D+03,0.230D+02,0.10915300D+02,0.00000000D+00
     .,0.47771160D+03,0.274D+03,0.240D+02,0.10915300D+02,0.00000000D+00
     .,0.52292780D+03,0.274D+03,0.250D+02,0.10915300D+02,0.00000000D+00
     .,0.41137250D+03,0.274D+03,0.260D+02,0.10915300D+02,0.00000000D+00
     .,0.43743830D+03,0.274D+03,0.270D+02,0.10915300D+02,0.00000000D+00
     .,0.44947760D+03,0.274D+03,0.280D+02,0.10915300D+02,0.00000000D+00
     .,0.34533400D+03,0.274D+03,0.290D+02,0.10915300D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 122801: 122900)=(/
     . 0.35654050D+03,0.274D+03,0.300D+02,0.10915300D+02,0.00000000D+00
     .,0.42115000D+03,0.274D+03,0.310D+02,0.10915300D+02,0.00000000D+00
     .,0.37485400D+03,0.274D+03,0.320D+02,0.10915300D+02,0.00000000D+00
     .,0.32264010D+03,0.274D+03,0.330D+02,0.10915300D+02,0.00000000D+00
     .,0.29126630D+03,0.274D+03,0.340D+02,0.10915300D+02,0.00000000D+00
     .,0.25651700D+03,0.274D+03,0.350D+02,0.10915300D+02,0.00000000D+00
     .,0.22442600D+03,0.274D+03,0.360D+02,0.10915300D+02,0.00000000D+00
     .,0.10997481D+04,0.274D+03,0.370D+02,0.10915300D+02,0.00000000D+00
     .,0.97735030D+03,0.274D+03,0.380D+02,0.10915300D+02,0.00000000D+00
     .,0.86199720D+03,0.274D+03,0.390D+02,0.10915300D+02,0.00000000D+00
     .,0.77824330D+03,0.274D+03,0.400D+02,0.10915300D+02,0.00000000D+00
     .,0.71194490D+03,0.274D+03,0.410D+02,0.10915300D+02,0.00000000D+00
     .,0.55309640D+03,0.274D+03,0.420D+02,0.10915300D+02,0.00000000D+00
     .,0.61562580D+03,0.274D+03,0.430D+02,0.10915300D+02,0.00000000D+00
     .,0.47221430D+03,0.274D+03,0.440D+02,0.10915300D+02,0.00000000D+00
     .,0.51556800D+03,0.274D+03,0.450D+02,0.10915300D+02,0.00000000D+00
     .,0.47905900D+03,0.274D+03,0.460D+02,0.10915300D+02,0.00000000D+00
     .,0.39972620D+03,0.274D+03,0.470D+02,0.10915300D+02,0.00000000D+00
     .,0.42322300D+03,0.274D+03,0.480D+02,0.10915300D+02,0.00000000D+00
     .,0.52765140D+03,0.274D+03,0.490D+02,0.10915300D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 122901: 123000)=(/
     . 0.49129650D+03,0.274D+03,0.500D+02,0.10915300D+02,0.00000000D+00
     .,0.44110510D+03,0.274D+03,0.510D+02,0.10915300D+02,0.00000000D+00
     .,0.41123900D+03,0.274D+03,0.520D+02,0.10915300D+02,0.00000000D+00
     .,0.37383140D+03,0.274D+03,0.530D+02,0.10915300D+02,0.00000000D+00
     .,0.33786400D+03,0.274D+03,0.540D+02,0.10915300D+02,0.00000000D+00
     .,0.13409193D+04,0.274D+03,0.550D+02,0.10915300D+02,0.00000000D+00
     .,0.12440756D+04,0.274D+03,0.560D+02,0.10915300D+02,0.00000000D+00
     .,0.11002138D+04,0.274D+03,0.570D+02,0.10915300D+02,0.00000000D+00
     .,0.52077890D+03,0.274D+03,0.580D+02,0.10915300D+02,0.27991000D+01
     .,0.11048675D+04,0.274D+03,0.590D+02,0.10915300D+02,0.00000000D+00
     .,0.10619928D+04,0.274D+03,0.600D+02,0.10915300D+02,0.00000000D+00
     .,0.10356282D+04,0.274D+03,0.610D+02,0.10915300D+02,0.00000000D+00
     .,0.10113417D+04,0.274D+03,0.620D+02,0.10915300D+02,0.00000000D+00
     .,0.98981510D+03,0.274D+03,0.630D+02,0.10915300D+02,0.00000000D+00
     .,0.78493070D+03,0.274D+03,0.640D+02,0.10915300D+02,0.00000000D+00
     .,0.87500190D+03,0.274D+03,0.650D+02,0.10915300D+02,0.00000000D+00
     .,0.84502380D+03,0.274D+03,0.660D+02,0.10915300D+02,0.00000000D+00
     .,0.89410530D+03,0.274D+03,0.670D+02,0.10915300D+02,0.00000000D+00
     .,0.87523480D+03,0.274D+03,0.680D+02,0.10915300D+02,0.00000000D+00
     .,0.85830520D+03,0.274D+03,0.690D+02,0.10915300D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 123001: 123100)=(/
     . 0.84794180D+03,0.274D+03,0.700D+02,0.10915300D+02,0.00000000D+00
     .,0.71850660D+03,0.274D+03,0.710D+02,0.10915300D+02,0.00000000D+00
     .,0.71139240D+03,0.274D+03,0.720D+02,0.10915300D+02,0.00000000D+00
     .,0.65227240D+03,0.274D+03,0.730D+02,0.10915300D+02,0.00000000D+00
     .,0.55338510D+03,0.274D+03,0.740D+02,0.10915300D+02,0.00000000D+00
     .,0.56376710D+03,0.274D+03,0.750D+02,0.10915300D+02,0.00000000D+00
     .,0.51307710D+03,0.274D+03,0.760D+02,0.10915300D+02,0.00000000D+00
     .,0.47151500D+03,0.274D+03,0.770D+02,0.10915300D+02,0.00000000D+00
     .,0.39347970D+03,0.274D+03,0.780D+02,0.10915300D+02,0.00000000D+00
     .,0.36827210D+03,0.274D+03,0.790D+02,0.10915300D+02,0.00000000D+00
     .,0.37916720D+03,0.274D+03,0.800D+02,0.10915300D+02,0.00000000D+00
     .,0.54357710D+03,0.274D+03,0.810D+02,0.10915300D+02,0.00000000D+00
     .,0.53401680D+03,0.274D+03,0.820D+02,0.10915300D+02,0.00000000D+00
     .,0.49381190D+03,0.274D+03,0.830D+02,0.10915300D+02,0.00000000D+00
     .,0.47281700D+03,0.274D+03,0.840D+02,0.10915300D+02,0.00000000D+00
     .,0.43850630D+03,0.274D+03,0.850D+02,0.10915300D+02,0.00000000D+00
     .,0.40379910D+03,0.274D+03,0.860D+02,0.10915300D+02,0.00000000D+00
     .,0.12730029D+04,0.274D+03,0.870D+02,0.10915300D+02,0.00000000D+00
     .,0.12347444D+04,0.274D+03,0.880D+02,0.10915300D+02,0.00000000D+00
     .,0.10979052D+04,0.274D+03,0.890D+02,0.10915300D+02,0.00000000D+00
     ./)
      grimme_c6_parameters( 123101: 123200)=(/
     . 0.99418690D+03,0.274D+03,0.900D+02,0.10915300D+02,0.00000000D+00
     .,0.98402510D+03,0.274D+03,0.910D+02,0.10915300D+02,0.00000000D+00
     .,0.95302030D+03,0.274D+03,0.920D+02,0.10915300D+02,0.00000000D+00
     .,0.97674380D+03,0.274D+03,0.930D+02,0.10915300D+02,0.00000000D+00
     .,0.94660700D+03,0.274D+03,0.940D+02,0.10915300D+02,0.00000000D+00
     .,0.54793400D+02,0.274D+03,0.101D+03,0.10915300D+02,0.00000000D+00
     .,0.17298830D+03,0.274D+03,0.103D+03,0.10915300D+02,0.98650000D+00
     .,0.22155260D+03,0.274D+03,0.104D+03,0.10915300D+02,0.98080000D+00
     .,0.17203160D+03,0.274D+03,0.105D+03,0.10915300D+02,0.97060000D+00
     .,0.13107440D+03,0.274D+03,0.106D+03,0.10915300D+02,0.98680000D+00
     .,0.92276100D+02,0.274D+03,0.107D+03,0.10915300D+02,0.99440000D+00
     .,0.67911900D+02,0.274D+03,0.108D+03,0.10915300D+02,0.99250000D+00
     .,0.47308600D+02,0.274D+03,0.109D+03,0.10915300D+02,0.99820000D+00
     .,0.25228990D+03,0.274D+03,0.111D+03,0.10915300D+02,0.96840000D+00
     .,0.38957210D+03,0.274D+03,0.112D+03,0.10915300D+02,0.96280000D+00
     .,0.39754110D+03,0.274D+03,0.113D+03,0.10915300D+02,0.96480000D+00
     .,0.32338900D+03,0.274D+03,0.114D+03,0.10915300D+02,0.95070000D+00
     .,0.26745480D+03,0.274D+03,0.115D+03,0.10915300D+02,0.99470000D+00
     .,0.22781180D+03,0.274D+03,0.116D+03,0.10915300D+02,0.99480000D+00
     .,0.18766470D+03,0.274D+03,0.117D+03,0.10915300D+02,0.99720000D+00
     ./)
      grimme_c6_parameters( 123201: 123300)=(/
     . 0.35118760D+03,0.274D+03,0.119D+03,0.10915300D+02,0.97670000D+00
     .,0.65780950D+03,0.274D+03,0.120D+03,0.10915300D+02,0.98310000D+00
     .,0.35408760D+03,0.274D+03,0.121D+03,0.10915300D+02,0.18627000D+01
     .,0.34206260D+03,0.274D+03,0.122D+03,0.10915300D+02,0.18299000D+01
     .,0.33519530D+03,0.274D+03,0.123D+03,0.10915300D+02,0.19138000D+01
     .,0.33174290D+03,0.274D+03,0.124D+03,0.10915300D+02,0.18269000D+01
     .,0.30679020D+03,0.274D+03,0.125D+03,0.10915300D+02,0.16406000D+01
     .,0.28447550D+03,0.274D+03,0.126D+03,0.10915300D+02,0.16483000D+01
     .,0.27144430D+03,0.274D+03,0.127D+03,0.10915300D+02,0.17149000D+01
     .,0.26525960D+03,0.274D+03,0.128D+03,0.10915300D+02,0.17937000D+01
     .,0.26103120D+03,0.274D+03,0.129D+03,0.10915300D+02,0.95760000D+00
     .,0.24669600D+03,0.274D+03,0.130D+03,0.10915300D+02,0.19419000D+01
     .,0.39651060D+03,0.274D+03,0.131D+03,0.10915300D+02,0.96010000D+00
     .,0.35152430D+03,0.274D+03,0.132D+03,0.10915300D+02,0.94340000D+00
     .,0.31735850D+03,0.274D+03,0.133D+03,0.10915300D+02,0.98890000D+00
     .,0.29136250D+03,0.274D+03,0.134D+03,0.10915300D+02,0.99010000D+00
     .,0.25822570D+03,0.274D+03,0.135D+03,0.10915300D+02,0.99740000D+00
     .,0.42013560D+03,0.274D+03,0.137D+03,0.10915300D+02,0.97380000D+00
     .,0.80028360D+03,0.274D+03,0.138D+03,0.10915300D+02,0.98010000D+00
     .,0.62027440D+03,0.274D+03,0.139D+03,0.10915300D+02,0.19153000D+01
     ./)
      grimme_c6_parameters( 123301: 123400)=(/
     . 0.46837410D+03,0.274D+03,0.140D+03,0.10915300D+02,0.19355000D+01
     .,0.47294180D+03,0.274D+03,0.141D+03,0.10915300D+02,0.19545000D+01
     .,0.44204910D+03,0.274D+03,0.142D+03,0.10915300D+02,0.19420000D+01
     .,0.49245940D+03,0.274D+03,0.143D+03,0.10915300D+02,0.16682000D+01
     .,0.38741710D+03,0.274D+03,0.144D+03,0.10915300D+02,0.18584000D+01
     .,0.36276960D+03,0.274D+03,0.145D+03,0.10915300D+02,0.19003000D+01
     .,0.33732470D+03,0.274D+03,0.146D+03,0.10915300D+02,0.18630000D+01
     .,0.32605860D+03,0.274D+03,0.147D+03,0.10915300D+02,0.96790000D+00
     .,0.32365690D+03,0.274D+03,0.148D+03,0.10915300D+02,0.19539000D+01
     .,0.50425970D+03,0.274D+03,0.149D+03,0.10915300D+02,0.96330000D+00
     .,0.45956860D+03,0.274D+03,0.150D+03,0.10915300D+02,0.95140000D+00
     .,0.43276910D+03,0.274D+03,0.151D+03,0.10915300D+02,0.97490000D+00
     .,0.41105850D+03,0.274D+03,0.152D+03,0.10915300D+02,0.98110000D+00
     .,0.37729830D+03,0.274D+03,0.153D+03,0.10915300D+02,0.99680000D+00
     .,0.49958850D+03,0.274D+03,0.155D+03,0.10915300D+02,0.99090000D+00
     .,0.10355821D+04,0.274D+03,0.156D+03,0.10915300D+02,0.97970000D+00
     .,0.78441150D+03,0.274D+03,0.157D+03,0.10915300D+02,0.19373000D+01
     .,0.50532050D+03,0.274D+03,0.159D+03,0.10915300D+02,0.29425000D+01
     .,0.49491310D+03,0.274D+03,0.160D+03,0.10915300D+02,0.29455000D+01
     .,0.47943010D+03,0.274D+03,0.161D+03,0.10915300D+02,0.29413000D+01
     ./)
      grimme_c6_parameters( 123401: 123500)=(/
     . 0.48126120D+03,0.274D+03,0.162D+03,0.10915300D+02,0.29300000D+01
     .,0.46237370D+03,0.274D+03,0.163D+03,0.10915300D+02,0.18286000D+01
     .,0.48403110D+03,0.274D+03,0.164D+03,0.10915300D+02,0.28732000D+01
     .,0.45510020D+03,0.274D+03,0.165D+03,0.10915300D+02,0.29086000D+01
     .,0.46220710D+03,0.274D+03,0.166D+03,0.10915300D+02,0.28965000D+01
     .,0.43236450D+03,0.274D+03,0.167D+03,0.10915300D+02,0.29242000D+01
     .,0.42019360D+03,0.274D+03,0.168D+03,0.10915300D+02,0.29282000D+01
     .,0.41735840D+03,0.274D+03,0.169D+03,0.10915300D+02,0.29246000D+01
     .,0.43783510D+03,0.274D+03,0.170D+03,0.10915300D+02,0.28482000D+01
     .,0.40359860D+03,0.274D+03,0.171D+03,0.10915300D+02,0.29219000D+01
     .,0.54010000D+03,0.274D+03,0.172D+03,0.10915300D+02,0.19254000D+01
     .,0.50356000D+03,0.274D+03,0.173D+03,0.10915300D+02,0.19459000D+01
     .,0.46165670D+03,0.274D+03,0.174D+03,0.10915300D+02,0.19292000D+01
     .,0.46529970D+03,0.274D+03,0.175D+03,0.10915300D+02,0.18104000D+01
     .,0.41168040D+03,0.274D+03,0.176D+03,0.10915300D+02,0.18858000D+01
     .,0.38805470D+03,0.274D+03,0.177D+03,0.10915300D+02,0.18648000D+01
     .,0.37109900D+03,0.274D+03,0.178D+03,0.10915300D+02,0.19188000D+01
     .,0.35487160D+03,0.274D+03,0.179D+03,0.10915300D+02,0.98460000D+00
     .,0.34408260D+03,0.274D+03,0.180D+03,0.10915300D+02,0.19896000D+01
     .,0.54282280D+03,0.274D+03,0.181D+03,0.10915300D+02,0.92670000D+00
     ./)
      grimme_c6_parameters( 123501: 123600)=(/
     . 0.49822260D+03,0.274D+03,0.182D+03,0.10915300D+02,0.93830000D+00
     .,0.48504830D+03,0.274D+03,0.183D+03,0.10915300D+02,0.98200000D+00
     .,0.47318900D+03,0.274D+03,0.184D+03,0.10915300D+02,0.98150000D+00
     .,0.44381290D+03,0.274D+03,0.185D+03,0.10915300D+02,0.99540000D+00
     .,0.56285700D+03,0.274D+03,0.187D+03,0.10915300D+02,0.97050000D+00
     .,0.10344519D+04,0.274D+03,0.188D+03,0.10915300D+02,0.96620000D+00
     .,0.59772660D+03,0.274D+03,0.189D+03,0.10915300D+02,0.29070000D+01
     .,0.68593330D+03,0.274D+03,0.190D+03,0.10915300D+02,0.28844000D+01
     .,0.61504850D+03,0.274D+03,0.191D+03,0.10915300D+02,0.28738000D+01
     .,0.54603460D+03,0.274D+03,0.192D+03,0.10915300D+02,0.28878000D+01
     .,0.52604590D+03,0.274D+03,0.193D+03,0.10915300D+02,0.29095000D+01
     .,0.62473940D+03,0.274D+03,0.194D+03,0.10915300D+02,0.19209000D+01
     .,0.14693770D+03,0.274D+03,0.204D+03,0.10915300D+02,0.19697000D+01
     .,0.14506890D+03,0.274D+03,0.205D+03,0.10915300D+02,0.19441000D+01
     .,0.10751640D+03,0.274D+03,0.206D+03,0.10915300D+02,0.19985000D+01
     .,0.86744300D+02,0.274D+03,0.207D+03,0.10915300D+02,0.20143000D+01
     .,0.60101300D+02,0.274D+03,0.208D+03,0.10915300D+02,0.19887000D+01
     .,0.25846390D+03,0.274D+03,0.212D+03,0.10915300D+02,0.19496000D+01
     .,0.31219790D+03,0.274D+03,0.213D+03,0.10915300D+02,0.19311000D+01
     .,0.30136080D+03,0.274D+03,0.214D+03,0.10915300D+02,0.19435000D+01
     ./)
      grimme_c6_parameters( 123601: 123700)=(/
     . 0.26370240D+03,0.274D+03,0.215D+03,0.10915300D+02,0.20102000D+01
     .,0.22325700D+03,0.274D+03,0.216D+03,0.10915300D+02,0.19903000D+01
     .,0.36300510D+03,0.274D+03,0.220D+03,0.10915300D+02,0.19349000D+01
     .,0.35046740D+03,0.274D+03,0.221D+03,0.10915300D+02,0.28999000D+01
     .,0.35493010D+03,0.274D+03,0.222D+03,0.10915300D+02,0.38675000D+01
     .,0.32491900D+03,0.274D+03,0.223D+03,0.10915300D+02,0.29110000D+01
     .,0.24698040D+03,0.274D+03,0.224D+03,0.10915300D+02,0.10619100D+02
     .,0.21243170D+03,0.274D+03,0.225D+03,0.10915300D+02,0.98849000D+01
     .,0.20838910D+03,0.274D+03,0.226D+03,0.10915300D+02,0.91376000D+01
     .,0.24221550D+03,0.274D+03,0.227D+03,0.10915300D+02,0.29263000D+01
     .,0.22617060D+03,0.274D+03,0.228D+03,0.10915300D+02,0.65458000D+01
     .,0.31684610D+03,0.274D+03,0.231D+03,0.10915300D+02,0.19315000D+01
     .,0.33520830D+03,0.274D+03,0.232D+03,0.10915300D+02,0.19447000D+01
     .,0.30932650D+03,0.274D+03,0.233D+03,0.10915300D+02,0.19793000D+01
     .,0.28913180D+03,0.274D+03,0.234D+03,0.10915300D+02,0.19812000D+01
     .,0.43547330D+03,0.274D+03,0.238D+03,0.10915300D+02,0.19143000D+01
     .,0.42156130D+03,0.274D+03,0.239D+03,0.10915300D+02,0.28903000D+01
     .,0.42595070D+03,0.274D+03,0.240D+03,0.10915300D+02,0.39106000D+01
     .,0.41195670D+03,0.274D+03,0.241D+03,0.10915300D+02,0.29225000D+01
     .,0.36633030D+03,0.274D+03,0.242D+03,0.10915300D+02,0.11055600D+02
     ./)
      grimme_c6_parameters( 123701: 123800)=(/
     . 0.32483190D+03,0.274D+03,0.243D+03,0.10915300D+02,0.95402000D+01
     .,0.30750010D+03,0.274D+03,0.244D+03,0.10915300D+02,0.88895000D+01
     .,0.31180890D+03,0.274D+03,0.245D+03,0.10915300D+02,0.29696000D+01
     .,0.32514160D+03,0.274D+03,0.246D+03,0.10915300D+02,0.57095000D+01
     .,0.40961940D+03,0.274D+03,0.249D+03,0.10915300D+02,0.19378000D+01
     .,0.44499610D+03,0.274D+03,0.250D+03,0.10915300D+02,0.19505000D+01
     .,0.42145120D+03,0.274D+03,0.251D+03,0.10915300D+02,0.19523000D+01
     .,0.40793570D+03,0.274D+03,0.252D+03,0.10915300D+02,0.19639000D+01
     .,0.52780130D+03,0.274D+03,0.256D+03,0.10915300D+02,0.18467000D+01
     .,0.54842160D+03,0.274D+03,0.257D+03,0.10915300D+02,0.29175000D+01
     .,0.40887060D+03,0.274D+03,0.272D+03,0.10915300D+02,0.38840000D+01
     .,0.42635470D+03,0.274D+03,0.273D+03,0.10915300D+02,0.28988000D+01
     .,0.39809730D+03,0.274D+03,0.274D+03,0.10915300D+02,0.10915300D+02
     .,0.31592800D+02,0.275D+03,0.100D+01,0.98054000D+01,0.91180000D+00
     .,0.21621000D+02,0.275D+03,0.200D+01,0.98054000D+01,0.00000000D+00
     .,0.43757960D+03,0.275D+03,0.300D+01,0.98054000D+01,0.00000000D+00
     .,0.26483780D+03,0.275D+03,0.400D+01,0.98054000D+01,0.00000000D+00
     .,0.18401940D+03,0.275D+03,0.500D+01,0.98054000D+01,0.00000000D+00
     .,0.12752710D+03,0.275D+03,0.600D+01,0.98054000D+01,0.00000000D+00
     .,0.90995800D+02,0.275D+03,0.700D+01,0.98054000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 123801: 123900)=(/
     . 0.69928900D+02,0.275D+03,0.800D+01,0.98054000D+01,0.00000000D+00
     .,0.53673800D+02,0.275D+03,0.900D+01,0.98054000D+01,0.00000000D+00
     .,0.41731000D+02,0.275D+03,0.100D+02,0.98054000D+01,0.00000000D+00
     .,0.52514830D+03,0.275D+03,0.110D+02,0.98054000D+01,0.00000000D+00
     .,0.41847680D+03,0.275D+03,0.120D+02,0.98054000D+01,0.00000000D+00
     .,0.39167000D+03,0.275D+03,0.130D+02,0.98054000D+01,0.00000000D+00
     .,0.31514880D+03,0.275D+03,0.140D+02,0.98054000D+01,0.00000000D+00
     .,0.25044750D+03,0.275D+03,0.150D+02,0.98054000D+01,0.00000000D+00
     .,0.21061910D+03,0.275D+03,0.160D+02,0.98054000D+01,0.00000000D+00
     .,0.17429820D+03,0.275D+03,0.170D+02,0.98054000D+01,0.00000000D+00
     .,0.14428140D+03,0.275D+03,0.180D+02,0.98054000D+01,0.00000000D+00
     .,0.85835650D+03,0.275D+03,0.190D+02,0.98054000D+01,0.00000000D+00
     .,0.72611640D+03,0.275D+03,0.200D+02,0.98054000D+01,0.00000000D+00
     .,0.60356880D+03,0.275D+03,0.210D+02,0.98054000D+01,0.00000000D+00
     .,0.58685490D+03,0.275D+03,0.220D+02,0.98054000D+01,0.00000000D+00
     .,0.53950230D+03,0.275D+03,0.230D+02,0.98054000D+01,0.00000000D+00
     .,0.42636910D+03,0.275D+03,0.240D+02,0.98054000D+01,0.00000000D+00
     .,0.46716530D+03,0.275D+03,0.250D+02,0.98054000D+01,0.00000000D+00
     .,0.36813400D+03,0.275D+03,0.260D+02,0.98054000D+01,0.00000000D+00
     .,0.39225490D+03,0.275D+03,0.270D+02,0.98054000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 123901: 124000)=(/
     . 0.40236920D+03,0.275D+03,0.280D+02,0.98054000D+01,0.00000000D+00
     .,0.30964490D+03,0.275D+03,0.290D+02,0.98054000D+01,0.00000000D+00
     .,0.32085180D+03,0.275D+03,0.300D+02,0.98054000D+01,0.00000000D+00
     .,0.37820130D+03,0.275D+03,0.310D+02,0.98054000D+01,0.00000000D+00
     .,0.33870950D+03,0.275D+03,0.320D+02,0.98054000D+01,0.00000000D+00
     .,0.29330960D+03,0.275D+03,0.330D+02,0.98054000D+01,0.00000000D+00
     .,0.26587000D+03,0.275D+03,0.340D+02,0.98054000D+01,0.00000000D+00
     .,0.23516470D+03,0.275D+03,0.350D+02,0.98054000D+01,0.00000000D+00
     .,0.20659450D+03,0.275D+03,0.360D+02,0.98054000D+01,0.00000000D+00
     .,0.96546080D+03,0.275D+03,0.370D+02,0.98054000D+01,0.00000000D+00
     .,0.86521550D+03,0.275D+03,0.380D+02,0.98054000D+01,0.00000000D+00
     .,0.76664930D+03,0.275D+03,0.390D+02,0.98054000D+01,0.00000000D+00
     .,0.69431570D+03,0.275D+03,0.400D+02,0.98054000D+01,0.00000000D+00
     .,0.63659010D+03,0.275D+03,0.410D+02,0.98054000D+01,0.00000000D+00
     .,0.49673190D+03,0.275D+03,0.420D+02,0.98054000D+01,0.00000000D+00
     .,0.55196750D+03,0.275D+03,0.430D+02,0.98054000D+01,0.00000000D+00
     .,0.42541540D+03,0.275D+03,0.440D+02,0.98054000D+01,0.00000000D+00
     .,0.46408940D+03,0.275D+03,0.450D+02,0.98054000D+01,0.00000000D+00
     .,0.43183300D+03,0.275D+03,0.460D+02,0.98054000D+01,0.00000000D+00
     .,0.36056290D+03,0.275D+03,0.470D+02,0.98054000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 124001: 124100)=(/
     . 0.38221490D+03,0.275D+03,0.480D+02,0.98054000D+01,0.00000000D+00
     .,0.47434870D+03,0.275D+03,0.490D+02,0.98054000D+01,0.00000000D+00
     .,0.44370850D+03,0.275D+03,0.500D+02,0.98054000D+01,0.00000000D+00
     .,0.40039260D+03,0.275D+03,0.510D+02,0.98054000D+01,0.00000000D+00
     .,0.37450420D+03,0.275D+03,0.520D+02,0.98054000D+01,0.00000000D+00
     .,0.34168440D+03,0.275D+03,0.530D+02,0.98054000D+01,0.00000000D+00
     .,0.30992280D+03,0.275D+03,0.540D+02,0.98054000D+01,0.00000000D+00
     .,0.11778622D+04,0.275D+03,0.550D+02,0.98054000D+01,0.00000000D+00
     .,0.11002149D+04,0.275D+03,0.560D+02,0.98054000D+01,0.00000000D+00
     .,0.97735910D+03,0.275D+03,0.570D+02,0.98054000D+01,0.00000000D+00
     .,0.47249460D+03,0.275D+03,0.580D+02,0.98054000D+01,0.27991000D+01
     .,0.97880490D+03,0.275D+03,0.590D+02,0.98054000D+01,0.00000000D+00
     .,0.94144390D+03,0.275D+03,0.600D+02,0.98054000D+01,0.00000000D+00
     .,0.91823780D+03,0.275D+03,0.610D+02,0.98054000D+01,0.00000000D+00
     .,0.89683560D+03,0.275D+03,0.620D+02,0.98054000D+01,0.00000000D+00
     .,0.87787040D+03,0.275D+03,0.630D+02,0.98054000D+01,0.00000000D+00
     .,0.70022530D+03,0.275D+03,0.640D+02,0.98054000D+01,0.00000000D+00
     .,0.77537110D+03,0.275D+03,0.650D+02,0.98054000D+01,0.00000000D+00
     .,0.74950170D+03,0.275D+03,0.660D+02,0.98054000D+01,0.00000000D+00
     .,0.79380070D+03,0.275D+03,0.670D+02,0.98054000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 124101: 124200)=(/
     . 0.77710890D+03,0.275D+03,0.680D+02,0.98054000D+01,0.00000000D+00
     .,0.76218580D+03,0.275D+03,0.690D+02,0.98054000D+01,0.00000000D+00
     .,0.75278270D+03,0.275D+03,0.700D+02,0.98054000D+01,0.00000000D+00
     .,0.64040610D+03,0.275D+03,0.710D+02,0.98054000D+01,0.00000000D+00
     .,0.63688250D+03,0.275D+03,0.720D+02,0.98054000D+01,0.00000000D+00
     .,0.58584610D+03,0.275D+03,0.730D+02,0.98054000D+01,0.00000000D+00
     .,0.49867750D+03,0.275D+03,0.740D+02,0.98054000D+01,0.00000000D+00
     .,0.50852330D+03,0.275D+03,0.750D+02,0.98054000D+01,0.00000000D+00
     .,0.46413690D+03,0.275D+03,0.760D+02,0.98054000D+01,0.00000000D+00
     .,0.42756890D+03,0.275D+03,0.770D+02,0.98054000D+01,0.00000000D+00
     .,0.35797140D+03,0.275D+03,0.780D+02,0.98054000D+01,0.00000000D+00
     .,0.33546850D+03,0.275D+03,0.790D+02,0.98054000D+01,0.00000000D+00
     .,0.34558560D+03,0.275D+03,0.800D+02,0.98054000D+01,0.00000000D+00
     .,0.48985300D+03,0.275D+03,0.810D+02,0.98054000D+01,0.00000000D+00
     .,0.48277210D+03,0.275D+03,0.820D+02,0.98054000D+01,0.00000000D+00
     .,0.44834220D+03,0.275D+03,0.830D+02,0.98054000D+01,0.00000000D+00
     .,0.43041860D+03,0.275D+03,0.840D+02,0.98054000D+01,0.00000000D+00
     .,0.40052020D+03,0.275D+03,0.850D+02,0.98054000D+01,0.00000000D+00
     .,0.37000240D+03,0.275D+03,0.860D+02,0.98054000D+01,0.00000000D+00
     .,0.11223371D+04,0.275D+03,0.870D+02,0.98054000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 124201: 124300)=(/
     . 0.10947171D+04,0.275D+03,0.880D+02,0.98054000D+01,0.00000000D+00
     .,0.97740400D+03,0.275D+03,0.890D+02,0.98054000D+01,0.00000000D+00
     .,0.88977500D+03,0.275D+03,0.900D+02,0.98054000D+01,0.00000000D+00
     .,0.87887760D+03,0.275D+03,0.910D+02,0.98054000D+01,0.00000000D+00
     .,0.85133500D+03,0.275D+03,0.920D+02,0.98054000D+01,0.00000000D+00
     .,0.86982820D+03,0.275D+03,0.930D+02,0.98054000D+01,0.00000000D+00
     .,0.84344130D+03,0.275D+03,0.940D+02,0.98054000D+01,0.00000000D+00
     .,0.49861600D+02,0.275D+03,0.101D+03,0.98054000D+01,0.00000000D+00
     .,0.15470980D+03,0.275D+03,0.103D+03,0.98054000D+01,0.98650000D+00
     .,0.19867640D+03,0.275D+03,0.104D+03,0.98054000D+01,0.98080000D+00
     .,0.15594320D+03,0.275D+03,0.105D+03,0.98054000D+01,0.97060000D+00
     .,0.11971100D+03,0.275D+03,0.106D+03,0.98054000D+01,0.98680000D+00
     .,0.84990600D+02,0.275D+03,0.107D+03,0.98054000D+01,0.99440000D+00
     .,0.63003200D+02,0.275D+03,0.108D+03,0.98054000D+01,0.99250000D+00
     .,0.44293300D+02,0.275D+03,0.109D+03,0.98054000D+01,0.99820000D+00
     .,0.22533300D+03,0.275D+03,0.111D+03,0.98054000D+01,0.96840000D+00
     .,0.34751630D+03,0.275D+03,0.112D+03,0.98054000D+01,0.96280000D+00
     .,0.35639850D+03,0.275D+03,0.113D+03,0.98054000D+01,0.96480000D+00
     .,0.29229100D+03,0.275D+03,0.114D+03,0.98054000D+01,0.95070000D+00
     .,0.24332340D+03,0.275D+03,0.115D+03,0.98054000D+01,0.99470000D+00
     ./)
      grimme_c6_parameters( 124301: 124400)=(/
     . 0.20827540D+03,0.275D+03,0.116D+03,0.98054000D+01,0.99480000D+00
     .,0.17247660D+03,0.275D+03,0.117D+03,0.98054000D+01,0.99720000D+00
     .,0.31572770D+03,0.275D+03,0.119D+03,0.98054000D+01,0.97670000D+00
     .,0.58337200D+03,0.275D+03,0.120D+03,0.98054000D+01,0.98310000D+00
     .,0.31998810D+03,0.275D+03,0.121D+03,0.98054000D+01,0.18627000D+01
     .,0.30928520D+03,0.275D+03,0.122D+03,0.98054000D+01,0.18299000D+01
     .,0.30306940D+03,0.275D+03,0.123D+03,0.98054000D+01,0.19138000D+01
     .,0.29974820D+03,0.275D+03,0.124D+03,0.98054000D+01,0.18269000D+01
     .,0.27813060D+03,0.275D+03,0.125D+03,0.98054000D+01,0.16406000D+01
     .,0.25824560D+03,0.275D+03,0.126D+03,0.98054000D+01,0.16483000D+01
     .,0.24647110D+03,0.275D+03,0.127D+03,0.98054000D+01,0.17149000D+01
     .,0.24079380D+03,0.275D+03,0.128D+03,0.98054000D+01,0.17937000D+01
     .,0.23633890D+03,0.275D+03,0.129D+03,0.98054000D+01,0.95760000D+00
     .,0.22442270D+03,0.275D+03,0.130D+03,0.98054000D+01,0.19419000D+01
     .,0.35665940D+03,0.275D+03,0.131D+03,0.98054000D+01,0.96010000D+00
     .,0.31814490D+03,0.275D+03,0.132D+03,0.98054000D+01,0.94340000D+00
     .,0.28862680D+03,0.275D+03,0.133D+03,0.98054000D+01,0.98890000D+00
     .,0.26594970D+03,0.275D+03,0.134D+03,0.98054000D+01,0.99010000D+00
     .,0.23668530D+03,0.275D+03,0.135D+03,0.98054000D+01,0.99740000D+00
     .,0.37838750D+03,0.275D+03,0.137D+03,0.98054000D+01,0.97380000D+00
     ./)
      grimme_c6_parameters( 124401: 124500)=(/
     . 0.70963970D+03,0.275D+03,0.138D+03,0.98054000D+01,0.98010000D+00
     .,0.55520870D+03,0.275D+03,0.139D+03,0.98054000D+01,0.19153000D+01
     .,0.42330460D+03,0.275D+03,0.140D+03,0.98054000D+01,0.19355000D+01
     .,0.42740240D+03,0.275D+03,0.141D+03,0.98054000D+01,0.19545000D+01
     .,0.40015670D+03,0.275D+03,0.142D+03,0.98054000D+01,0.19420000D+01
     .,0.44382790D+03,0.275D+03,0.143D+03,0.98054000D+01,0.16682000D+01
     .,0.35202000D+03,0.275D+03,0.144D+03,0.98054000D+01,0.18584000D+01
     .,0.32985620D+03,0.275D+03,0.145D+03,0.98054000D+01,0.19003000D+01
     .,0.30703010D+03,0.275D+03,0.146D+03,0.98054000D+01,0.18630000D+01
     .,0.29664300D+03,0.275D+03,0.147D+03,0.98054000D+01,0.96790000D+00
     .,0.29510960D+03,0.275D+03,0.148D+03,0.98054000D+01,0.19539000D+01
     .,0.45411220D+03,0.275D+03,0.149D+03,0.98054000D+01,0.96330000D+00
     .,0.41592040D+03,0.275D+03,0.150D+03,0.98054000D+01,0.95140000D+00
     .,0.39310920D+03,0.275D+03,0.151D+03,0.98054000D+01,0.97490000D+00
     .,0.37441140D+03,0.275D+03,0.152D+03,0.98054000D+01,0.98110000D+00
     .,0.34482440D+03,0.275D+03,0.153D+03,0.98054000D+01,0.99680000D+00
     .,0.45152920D+03,0.275D+03,0.155D+03,0.98054000D+01,0.99090000D+00
     .,0.91708910D+03,0.275D+03,0.156D+03,0.98054000D+01,0.97970000D+00
     .,0.70171880D+03,0.275D+03,0.157D+03,0.98054000D+01,0.19373000D+01
     .,0.45862530D+03,0.275D+03,0.159D+03,0.98054000D+01,0.29425000D+01
     ./)
      grimme_c6_parameters( 124501: 124600)=(/
     . 0.44920880D+03,0.275D+03,0.160D+03,0.98054000D+01,0.29455000D+01
     .,0.43528510D+03,0.275D+03,0.161D+03,0.98054000D+01,0.29413000D+01
     .,0.43662810D+03,0.275D+03,0.162D+03,0.98054000D+01,0.29300000D+01
     .,0.41857700D+03,0.275D+03,0.163D+03,0.98054000D+01,0.18286000D+01
     .,0.43896330D+03,0.275D+03,0.164D+03,0.98054000D+01,0.28732000D+01
     .,0.41303190D+03,0.275D+03,0.165D+03,0.98054000D+01,0.29086000D+01
     .,0.41895270D+03,0.275D+03,0.166D+03,0.98054000D+01,0.28965000D+01
     .,0.39263770D+03,0.275D+03,0.167D+03,0.98054000D+01,0.29242000D+01
     .,0.38167800D+03,0.275D+03,0.168D+03,0.98054000D+01,0.29282000D+01
     .,0.37901540D+03,0.275D+03,0.169D+03,0.98054000D+01,0.29246000D+01
     .,0.39706740D+03,0.275D+03,0.170D+03,0.98054000D+01,0.28482000D+01
     .,0.36663560D+03,0.275D+03,0.171D+03,0.98054000D+01,0.29219000D+01
     .,0.48647620D+03,0.275D+03,0.172D+03,0.98054000D+01,0.19254000D+01
     .,0.45499830D+03,0.275D+03,0.173D+03,0.98054000D+01,0.19459000D+01
     .,0.41851340D+03,0.275D+03,0.174D+03,0.98054000D+01,0.19292000D+01
     .,0.42070230D+03,0.275D+03,0.175D+03,0.98054000D+01,0.18104000D+01
     .,0.37494930D+03,0.275D+03,0.176D+03,0.98054000D+01,0.18858000D+01
     .,0.35392940D+03,0.275D+03,0.177D+03,0.98054000D+01,0.18648000D+01
     .,0.33877130D+03,0.275D+03,0.178D+03,0.98054000D+01,0.19188000D+01
     .,0.32404200D+03,0.275D+03,0.179D+03,0.98054000D+01,0.98460000D+00
     ./)
      grimme_c6_parameters( 124601: 124700)=(/
     . 0.31491790D+03,0.275D+03,0.180D+03,0.98054000D+01,0.19896000D+01
     .,0.48972910D+03,0.275D+03,0.181D+03,0.98054000D+01,0.92670000D+00
     .,0.45162020D+03,0.275D+03,0.182D+03,0.98054000D+01,0.93830000D+00
     .,0.44081790D+03,0.275D+03,0.183D+03,0.98054000D+01,0.98200000D+00
     .,0.43091310D+03,0.275D+03,0.184D+03,0.98054000D+01,0.98150000D+00
     .,0.40535970D+03,0.275D+03,0.185D+03,0.98054000D+01,0.99540000D+00
     .,0.50882630D+03,0.275D+03,0.187D+03,0.98054000D+01,0.97050000D+00
     .,0.91874100D+03,0.275D+03,0.188D+03,0.98054000D+01,0.96620000D+00
     .,0.54234140D+03,0.275D+03,0.189D+03,0.98054000D+01,0.29070000D+01
     .,0.61996910D+03,0.275D+03,0.190D+03,0.98054000D+01,0.28844000D+01
     .,0.55704040D+03,0.275D+03,0.191D+03,0.98054000D+01,0.28738000D+01
     .,0.49609310D+03,0.275D+03,0.192D+03,0.98054000D+01,0.28878000D+01
     .,0.47831910D+03,0.275D+03,0.193D+03,0.98054000D+01,0.29095000D+01
     .,0.56313100D+03,0.275D+03,0.194D+03,0.98054000D+01,0.19209000D+01
     .,0.13319340D+03,0.275D+03,0.204D+03,0.98054000D+01,0.19697000D+01
     .,0.13189570D+03,0.275D+03,0.205D+03,0.98054000D+01,0.19441000D+01
     .,0.98601900D+02,0.275D+03,0.206D+03,0.98054000D+01,0.19985000D+01
     .,0.79979000D+02,0.275D+03,0.207D+03,0.98054000D+01,0.20143000D+01
     .,0.55894600D+02,0.275D+03,0.208D+03,0.98054000D+01,0.19887000D+01
     .,0.23303610D+03,0.275D+03,0.212D+03,0.98054000D+01,0.19496000D+01
     ./)
      grimme_c6_parameters( 124701: 124800)=(/
     . 0.28137080D+03,0.275D+03,0.213D+03,0.98054000D+01,0.19311000D+01
     .,0.27272890D+03,0.275D+03,0.214D+03,0.98054000D+01,0.19435000D+01
     .,0.23983560D+03,0.275D+03,0.215D+03,0.98054000D+01,0.20102000D+01
     .,0.20414550D+03,0.275D+03,0.216D+03,0.98054000D+01,0.19903000D+01
     .,0.32770190D+03,0.275D+03,0.220D+03,0.98054000D+01,0.19349000D+01
     .,0.31737170D+03,0.275D+03,0.221D+03,0.98054000D+01,0.28999000D+01
     .,0.32150860D+03,0.275D+03,0.222D+03,0.98054000D+01,0.38675000D+01
     .,0.29439580D+03,0.275D+03,0.223D+03,0.98054000D+01,0.29110000D+01
     .,0.22519270D+03,0.275D+03,0.224D+03,0.98054000D+01,0.10619100D+02
     .,0.19439360D+03,0.275D+03,0.225D+03,0.98054000D+01,0.98849000D+01
     .,0.19062290D+03,0.275D+03,0.226D+03,0.98054000D+01,0.91376000D+01
     .,0.22028000D+03,0.275D+03,0.227D+03,0.98054000D+01,0.29263000D+01
     .,0.20601270D+03,0.275D+03,0.228D+03,0.98054000D+01,0.65458000D+01
     .,0.28665620D+03,0.275D+03,0.231D+03,0.98054000D+01,0.19315000D+01
     .,0.30371450D+03,0.275D+03,0.232D+03,0.98054000D+01,0.19447000D+01
     .,0.28150840D+03,0.275D+03,0.233D+03,0.98054000D+01,0.19793000D+01
     .,0.26395060D+03,0.275D+03,0.234D+03,0.98054000D+01,0.19812000D+01
     .,0.39346440D+03,0.275D+03,0.238D+03,0.98054000D+01,0.19143000D+01
     .,0.38237800D+03,0.275D+03,0.239D+03,0.98054000D+01,0.28903000D+01
     .,0.38683830D+03,0.275D+03,0.240D+03,0.98054000D+01,0.39106000D+01
     ./)
      grimme_c6_parameters( 124801: 124900)=(/
     . 0.37417790D+03,0.275D+03,0.241D+03,0.98054000D+01,0.29225000D+01
     .,0.33405520D+03,0.275D+03,0.242D+03,0.98054000D+01,0.11055600D+02
     .,0.29716160D+03,0.275D+03,0.243D+03,0.98054000D+01,0.95402000D+01
     .,0.28166080D+03,0.275D+03,0.244D+03,0.98054000D+01,0.88895000D+01
     .,0.28475480D+03,0.275D+03,0.245D+03,0.98054000D+01,0.29696000D+01
     .,0.29656750D+03,0.275D+03,0.246D+03,0.98054000D+01,0.57095000D+01
     .,0.37125760D+03,0.275D+03,0.249D+03,0.98054000D+01,0.19378000D+01
     .,0.40316950D+03,0.275D+03,0.250D+03,0.98054000D+01,0.19505000D+01
     .,0.38318380D+03,0.275D+03,0.251D+03,0.98054000D+01,0.19523000D+01
     .,0.37169830D+03,0.275D+03,0.252D+03,0.98054000D+01,0.19639000D+01
     .,0.47755530D+03,0.275D+03,0.256D+03,0.98054000D+01,0.18467000D+01
     .,0.49702050D+03,0.275D+03,0.257D+03,0.98054000D+01,0.29175000D+01
     .,0.37200450D+03,0.275D+03,0.272D+03,0.98054000D+01,0.38840000D+01
     .,0.38748710D+03,0.275D+03,0.273D+03,0.98054000D+01,0.28988000D+01
     .,0.36309850D+03,0.275D+03,0.274D+03,0.98054000D+01,0.10915300D+02
     .,0.33214480D+03,0.275D+03,0.275D+03,0.98054000D+01,0.98054000D+01
     .,0.29959700D+02,0.276D+03,0.100D+01,0.91527000D+01,0.91180000D+00
     .,0.20732100D+02,0.276D+03,0.200D+01,0.91527000D+01,0.00000000D+00
     .,0.39946230D+03,0.276D+03,0.300D+01,0.91527000D+01,0.00000000D+00
     .,0.24560490D+03,0.276D+03,0.400D+01,0.91527000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 124901: 125000)=(/
     . 0.17242600D+03,0.276D+03,0.500D+01,0.91527000D+01,0.00000000D+00
     .,0.12047520D+03,0.276D+03,0.600D+01,0.91527000D+01,0.00000000D+00
     .,0.86515000D+02,0.276D+03,0.700D+01,0.91527000D+01,0.00000000D+00
     .,0.66798300D+02,0.276D+03,0.800D+01,0.91527000D+01,0.00000000D+00
     .,0.51483900D+02,0.276D+03,0.900D+01,0.91527000D+01,0.00000000D+00
     .,0.40166600D+02,0.276D+03,0.100D+02,0.91527000D+01,0.00000000D+00
     .,0.48002060D+03,0.276D+03,0.110D+02,0.91527000D+01,0.00000000D+00
     .,0.38703270D+03,0.276D+03,0.120D+02,0.91527000D+01,0.00000000D+00
     .,0.36408530D+03,0.276D+03,0.130D+02,0.91527000D+01,0.00000000D+00
     .,0.29497480D+03,0.276D+03,0.140D+02,0.91527000D+01,0.00000000D+00
     .,0.23585440D+03,0.276D+03,0.150D+02,0.91527000D+01,0.00000000D+00
     .,0.19918590D+03,0.276D+03,0.160D+02,0.91527000D+01,0.00000000D+00
     .,0.16551840D+03,0.276D+03,0.170D+02,0.91527000D+01,0.00000000D+00
     .,0.13752330D+03,0.276D+03,0.180D+02,0.91527000D+01,0.00000000D+00
     .,0.78398180D+03,0.276D+03,0.190D+02,0.91527000D+01,0.00000000D+00
     .,0.66874580D+03,0.276D+03,0.200D+02,0.91527000D+01,0.00000000D+00
     .,0.55703780D+03,0.276D+03,0.210D+02,0.91527000D+01,0.00000000D+00
     .,0.54287970D+03,0.276D+03,0.220D+02,0.91527000D+01,0.00000000D+00
     .,0.49973800D+03,0.276D+03,0.230D+02,0.91527000D+01,0.00000000D+00
     .,0.39539650D+03,0.276D+03,0.240D+02,0.91527000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 125001: 125100)=(/
     . 0.43357460D+03,0.276D+03,0.250D+02,0.91527000D+01,0.00000000D+00
     .,0.34214260D+03,0.276D+03,0.260D+02,0.91527000D+01,0.00000000D+00
     .,0.36517850D+03,0.276D+03,0.270D+02,0.91527000D+01,0.00000000D+00
     .,0.37407150D+03,0.276D+03,0.280D+02,0.91527000D+01,0.00000000D+00
     .,0.28825030D+03,0.276D+03,0.290D+02,0.91527000D+01,0.00000000D+00
     .,0.29957880D+03,0.276D+03,0.300D+02,0.91527000D+01,0.00000000D+00
     .,0.35252400D+03,0.276D+03,0.310D+02,0.91527000D+01,0.00000000D+00
     .,0.31731180D+03,0.276D+03,0.320D+02,0.91527000D+01,0.00000000D+00
     .,0.27613370D+03,0.276D+03,0.330D+02,0.91527000D+01,0.00000000D+00
     .,0.25111640D+03,0.276D+03,0.340D+02,0.91527000D+01,0.00000000D+00
     .,0.22287460D+03,0.276D+03,0.350D+02,0.91527000D+01,0.00000000D+00
     .,0.19643010D+03,0.276D+03,0.360D+02,0.91527000D+01,0.00000000D+00
     .,0.88292900D+03,0.276D+03,0.370D+02,0.91527000D+01,0.00000000D+00
     .,0.79689500D+03,0.276D+03,0.380D+02,0.91527000D+01,0.00000000D+00
     .,0.70887790D+03,0.276D+03,0.390D+02,0.91527000D+01,0.00000000D+00
     .,0.64366450D+03,0.276D+03,0.400D+02,0.91527000D+01,0.00000000D+00
     .,0.59124780D+03,0.276D+03,0.410D+02,0.91527000D+01,0.00000000D+00
     .,0.46302150D+03,0.276D+03,0.420D+02,0.91527000D+01,0.00000000D+00
     .,0.51380610D+03,0.276D+03,0.430D+02,0.91527000D+01,0.00000000D+00
     .,0.39755570D+03,0.276D+03,0.440D+02,0.91527000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 125101: 125200)=(/
     . 0.43340920D+03,0.276D+03,0.450D+02,0.91527000D+01,0.00000000D+00
     .,0.40374870D+03,0.276D+03,0.460D+02,0.91527000D+01,0.00000000D+00
     .,0.33729140D+03,0.276D+03,0.470D+02,0.91527000D+01,0.00000000D+00
     .,0.35790130D+03,0.276D+03,0.480D+02,0.91527000D+01,0.00000000D+00
     .,0.44252210D+03,0.276D+03,0.490D+02,0.91527000D+01,0.00000000D+00
     .,0.41550540D+03,0.276D+03,0.500D+02,0.91527000D+01,0.00000000D+00
     .,0.37647850D+03,0.276D+03,0.510D+02,0.91527000D+01,0.00000000D+00
     .,0.35306060D+03,0.276D+03,0.520D+02,0.91527000D+01,0.00000000D+00
     .,0.32305850D+03,0.276D+03,0.530D+02,0.91527000D+01,0.00000000D+00
     .,0.29386160D+03,0.276D+03,0.540D+02,0.91527000D+01,0.00000000D+00
     .,0.10777158D+04,0.276D+03,0.550D+02,0.91527000D+01,0.00000000D+00
     .,0.10124643D+04,0.276D+03,0.560D+02,0.91527000D+01,0.00000000D+00
     .,0.90281190D+03,0.276D+03,0.570D+02,0.91527000D+01,0.00000000D+00
     .,0.44410240D+03,0.276D+03,0.580D+02,0.91527000D+01,0.27991000D+01
     .,0.90205950D+03,0.276D+03,0.590D+02,0.91527000D+01,0.00000000D+00
     .,0.86810970D+03,0.276D+03,0.600D+02,0.91527000D+01,0.00000000D+00
     .,0.84683980D+03,0.276D+03,0.610D+02,0.91527000D+01,0.00000000D+00
     .,0.82720360D+03,0.276D+03,0.620D+02,0.91527000D+01,0.00000000D+00
     .,0.80980750D+03,0.276D+03,0.630D+02,0.91527000D+01,0.00000000D+00
     .,0.64909210D+03,0.276D+03,0.640D+02,0.91527000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 125201: 125300)=(/
     . 0.71473580D+03,0.276D+03,0.650D+02,0.91527000D+01,0.00000000D+00
     .,0.69143160D+03,0.276D+03,0.660D+02,0.91527000D+01,0.00000000D+00
     .,0.73288920D+03,0.276D+03,0.670D+02,0.91527000D+01,0.00000000D+00
     .,0.71752640D+03,0.276D+03,0.680D+02,0.91527000D+01,0.00000000D+00
     .,0.70383170D+03,0.276D+03,0.690D+02,0.91527000D+01,0.00000000D+00
     .,0.69499350D+03,0.276D+03,0.700D+02,0.91527000D+01,0.00000000D+00
     .,0.59320990D+03,0.276D+03,0.710D+02,0.91527000D+01,0.00000000D+00
     .,0.59212750D+03,0.276D+03,0.720D+02,0.91527000D+01,0.00000000D+00
     .,0.54613100D+03,0.276D+03,0.730D+02,0.91527000D+01,0.00000000D+00
     .,0.46612960D+03,0.276D+03,0.740D+02,0.91527000D+01,0.00000000D+00
     .,0.47570880D+03,0.276D+03,0.750D+02,0.91527000D+01,0.00000000D+00
     .,0.43520440D+03,0.276D+03,0.760D+02,0.91527000D+01,0.00000000D+00
     .,0.40169710D+03,0.276D+03,0.770D+02,0.91527000D+01,0.00000000D+00
     .,0.33718850D+03,0.276D+03,0.780D+02,0.91527000D+01,0.00000000D+00
     .,0.31631490D+03,0.276D+03,0.790D+02,0.91527000D+01,0.00000000D+00
     .,0.32600310D+03,0.276D+03,0.800D+02,0.91527000D+01,0.00000000D+00
     .,0.45788770D+03,0.276D+03,0.810D+02,0.91527000D+01,0.00000000D+00
     .,0.45244550D+03,0.276D+03,0.820D+02,0.91527000D+01,0.00000000D+00
     .,0.42163980D+03,0.276D+03,0.830D+02,0.91527000D+01,0.00000000D+00
     .,0.40564640D+03,0.276D+03,0.840D+02,0.91527000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 125301: 125400)=(/
     . 0.37847640D+03,0.276D+03,0.850D+02,0.91527000D+01,0.00000000D+00
     .,0.35052560D+03,0.276D+03,0.860D+02,0.91527000D+01,0.00000000D+00
     .,0.10301431D+04,0.276D+03,0.870D+02,0.91527000D+01,0.00000000D+00
     .,0.10095485D+04,0.276D+03,0.880D+02,0.91527000D+01,0.00000000D+00
     .,0.90447790D+03,0.276D+03,0.890D+02,0.91527000D+01,0.00000000D+00
     .,0.82702680D+03,0.276D+03,0.900D+02,0.91527000D+01,0.00000000D+00
     .,0.81550490D+03,0.276D+03,0.910D+02,0.91527000D+01,0.00000000D+00
     .,0.79006160D+03,0.276D+03,0.920D+02,0.91527000D+01,0.00000000D+00
     .,0.80513870D+03,0.276D+03,0.930D+02,0.91527000D+01,0.00000000D+00
     .,0.78106340D+03,0.276D+03,0.940D+02,0.91527000D+01,0.00000000D+00
     .,0.46979300D+02,0.276D+03,0.101D+03,0.91527000D+01,0.00000000D+00
     .,0.14371930D+03,0.276D+03,0.103D+03,0.91527000D+01,0.98650000D+00
     .,0.18497380D+03,0.276D+03,0.104D+03,0.91527000D+01,0.98080000D+00
     .,0.14647120D+03,0.276D+03,0.105D+03,0.91527000D+01,0.97060000D+00
     .,0.11311480D+03,0.276D+03,0.106D+03,0.91527000D+01,0.98680000D+00
     .,0.80841400D+02,0.276D+03,0.107D+03,0.91527000D+01,0.99440000D+00
     .,0.60262600D+02,0.276D+03,0.108D+03,0.91527000D+01,0.99250000D+00
     .,0.42663600D+02,0.276D+03,0.109D+03,0.91527000D+01,0.99820000D+00
     .,0.20909190D+03,0.276D+03,0.111D+03,0.91527000D+01,0.96840000D+00
     .,0.32213980D+03,0.276D+03,0.112D+03,0.91527000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters( 125401: 125500)=(/
     . 0.33174520D+03,0.276D+03,0.113D+03,0.91527000D+01,0.96480000D+00
     .,0.27389260D+03,0.276D+03,0.114D+03,0.91527000D+01,0.95070000D+00
     .,0.22921310D+03,0.276D+03,0.115D+03,0.91527000D+01,0.99470000D+00
     .,0.19696310D+03,0.276D+03,0.116D+03,0.91527000D+01,0.99480000D+00
     .,0.16378500D+03,0.276D+03,0.117D+03,0.91527000D+01,0.99720000D+00
     .,0.29455150D+03,0.276D+03,0.119D+03,0.91527000D+01,0.97670000D+00
     .,0.53811810D+03,0.276D+03,0.120D+03,0.91527000D+01,0.98310000D+00
     .,0.29979870D+03,0.276D+03,0.121D+03,0.91527000D+01,0.18627000D+01
     .,0.28989590D+03,0.276D+03,0.122D+03,0.91527000D+01,0.18299000D+01
     .,0.28406410D+03,0.276D+03,0.123D+03,0.91527000D+01,0.19138000D+01
     .,0.28079860D+03,0.276D+03,0.124D+03,0.91527000D+01,0.18269000D+01
     .,0.26125710D+03,0.276D+03,0.125D+03,0.91527000D+01,0.16406000D+01
     .,0.24283990D+03,0.276D+03,0.126D+03,0.91527000D+01,0.16483000D+01
     .,0.23180890D+03,0.276D+03,0.127D+03,0.91527000D+01,0.17149000D+01
     .,0.22642260D+03,0.276D+03,0.128D+03,0.91527000D+01,0.17937000D+01
     .,0.22176420D+03,0.276D+03,0.129D+03,0.91527000D+01,0.95760000D+00
     .,0.21139390D+03,0.276D+03,0.130D+03,0.91527000D+01,0.19419000D+01
     .,0.33289310D+03,0.276D+03,0.131D+03,0.91527000D+01,0.96010000D+00
     .,0.29843870D+03,0.276D+03,0.132D+03,0.91527000D+01,0.94340000D+00
     .,0.27181450D+03,0.276D+03,0.133D+03,0.91527000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters( 125501: 125600)=(/
     . 0.25118530D+03,0.276D+03,0.134D+03,0.91527000D+01,0.99010000D+00
     .,0.22428140D+03,0.276D+03,0.135D+03,0.91527000D+01,0.99740000D+00
     .,0.35352250D+03,0.276D+03,0.137D+03,0.91527000D+01,0.97380000D+00
     .,0.65452330D+03,0.276D+03,0.138D+03,0.91527000D+01,0.98010000D+00
     .,0.51611830D+03,0.276D+03,0.139D+03,0.91527000D+01,0.19153000D+01
     .,0.39662190D+03,0.276D+03,0.140D+03,0.91527000D+01,0.19355000D+01
     .,0.40043580D+03,0.276D+03,0.141D+03,0.91527000D+01,0.19545000D+01
     .,0.37541960D+03,0.276D+03,0.142D+03,0.91527000D+01,0.19420000D+01
     .,0.41489900D+03,0.276D+03,0.143D+03,0.91527000D+01,0.16682000D+01
     .,0.33125900D+03,0.276D+03,0.144D+03,0.91527000D+01,0.18584000D+01
     .,0.31057580D+03,0.276D+03,0.145D+03,0.91527000D+01,0.19003000D+01
     .,0.28931700D+03,0.276D+03,0.146D+03,0.91527000D+01,0.18630000D+01
     .,0.27942790D+03,0.276D+03,0.147D+03,0.91527000D+01,0.96790000D+00
     .,0.27848020D+03,0.276D+03,0.148D+03,0.91527000D+01,0.19539000D+01
     .,0.42425050D+03,0.276D+03,0.149D+03,0.91527000D+01,0.96330000D+00
     .,0.39014410D+03,0.276D+03,0.150D+03,0.91527000D+01,0.95140000D+00
     .,0.36984470D+03,0.276D+03,0.151D+03,0.91527000D+01,0.97490000D+00
     .,0.35302740D+03,0.276D+03,0.152D+03,0.91527000D+01,0.98110000D+00
     .,0.32600590D+03,0.276D+03,0.153D+03,0.91527000D+01,0.99680000D+00
     .,0.42307320D+03,0.276D+03,0.155D+03,0.91527000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters( 125601: 125700)=(/
     . 0.84493410D+03,0.276D+03,0.156D+03,0.91527000D+01,0.97970000D+00
     .,0.65199750D+03,0.276D+03,0.157D+03,0.91527000D+01,0.19373000D+01
     .,0.43118430D+03,0.276D+03,0.159D+03,0.91527000D+01,0.29425000D+01
     .,0.42235310D+03,0.276D+03,0.160D+03,0.91527000D+01,0.29455000D+01
     .,0.40935960D+03,0.276D+03,0.161D+03,0.91527000D+01,0.29413000D+01
     .,0.41038090D+03,0.276D+03,0.162D+03,0.91527000D+01,0.29300000D+01
     .,0.39271700D+03,0.276D+03,0.163D+03,0.91527000D+01,0.18286000D+01
     .,0.41244200D+03,0.276D+03,0.164D+03,0.91527000D+01,0.28732000D+01
     .,0.38830810D+03,0.276D+03,0.165D+03,0.91527000D+01,0.29086000D+01
     .,0.39347340D+03,0.276D+03,0.166D+03,0.91527000D+01,0.28965000D+01
     .,0.36931690D+03,0.276D+03,0.167D+03,0.91527000D+01,0.29242000D+01
     .,0.35907870D+03,0.276D+03,0.168D+03,0.91527000D+01,0.29282000D+01
     .,0.35650780D+03,0.276D+03,0.169D+03,0.91527000D+01,0.29246000D+01
     .,0.37307840D+03,0.276D+03,0.170D+03,0.91527000D+01,0.28482000D+01
     .,0.34495150D+03,0.276D+03,0.171D+03,0.91527000D+01,0.29219000D+01
     .,0.45455470D+03,0.276D+03,0.172D+03,0.91527000D+01,0.19254000D+01
     .,0.42623560D+03,0.276D+03,0.173D+03,0.91527000D+01,0.19459000D+01
     .,0.39310340D+03,0.276D+03,0.174D+03,0.91527000D+01,0.19292000D+01
     .,0.39431360D+03,0.276D+03,0.175D+03,0.91527000D+01,0.18104000D+01
     .,0.35350380D+03,0.276D+03,0.176D+03,0.91527000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters( 125701: 125800)=(/
     . 0.33405950D+03,0.276D+03,0.177D+03,0.91527000D+01,0.18648000D+01
     .,0.31998180D+03,0.276D+03,0.178D+03,0.91527000D+01,0.19188000D+01
     .,0.30613090D+03,0.276D+03,0.179D+03,0.91527000D+01,0.98460000D+00
     .,0.29806110D+03,0.276D+03,0.180D+03,0.91527000D+01,0.19896000D+01
     .,0.45819840D+03,0.276D+03,0.181D+03,0.91527000D+01,0.92670000D+00
     .,0.42417020D+03,0.276D+03,0.182D+03,0.91527000D+01,0.93830000D+00
     .,0.41489180D+03,0.276D+03,0.183D+03,0.91527000D+01,0.98200000D+00
     .,0.40623070D+03,0.276D+03,0.184D+03,0.91527000D+01,0.98150000D+00
     .,0.38304430D+03,0.276D+03,0.185D+03,0.91527000D+01,0.99540000D+00
     .,0.47684810D+03,0.276D+03,0.187D+03,0.91527000D+01,0.97050000D+00
     .,0.84851510D+03,0.276D+03,0.188D+03,0.91527000D+01,0.96620000D+00
     .,0.50977850D+03,0.276D+03,0.189D+03,0.91527000D+01,0.29070000D+01
     .,0.58092120D+03,0.276D+03,0.190D+03,0.91527000D+01,0.28844000D+01
     .,0.52282120D+03,0.276D+03,0.191D+03,0.91527000D+01,0.28738000D+01
     .,0.46679740D+03,0.276D+03,0.192D+03,0.91527000D+01,0.28878000D+01
     .,0.45036480D+03,0.276D+03,0.193D+03,0.91527000D+01,0.29095000D+01
     .,0.52648950D+03,0.276D+03,0.194D+03,0.91527000D+01,0.19209000D+01
     .,0.12510340D+03,0.276D+03,0.204D+03,0.91527000D+01,0.19697000D+01
     .,0.12418210D+03,0.276D+03,0.205D+03,0.91527000D+01,0.19441000D+01
     .,0.93473800D+02,0.276D+03,0.206D+03,0.91527000D+01,0.19985000D+01
     ./)
      grimme_c6_parameters( 125801: 125900)=(/
     . 0.76136500D+02,0.276D+03,0.207D+03,0.91527000D+01,0.20143000D+01
     .,0.53564100D+02,0.276D+03,0.208D+03,0.91527000D+01,0.19887000D+01
     .,0.21793200D+03,0.276D+03,0.212D+03,0.91527000D+01,0.19496000D+01
     .,0.26304720D+03,0.276D+03,0.213D+03,0.91527000D+01,0.19311000D+01
     .,0.25582610D+03,0.276D+03,0.214D+03,0.91527000D+01,0.19435000D+01
     .,0.22587090D+03,0.276D+03,0.215D+03,0.91527000D+01,0.20102000D+01
     .,0.19308290D+03,0.276D+03,0.216D+03,0.91527000D+01,0.19903000D+01
     .,0.30676340D+03,0.276D+03,0.220D+03,0.91527000D+01,0.19349000D+01
     .,0.29784850D+03,0.276D+03,0.221D+03,0.91527000D+01,0.28999000D+01
     .,0.30180320D+03,0.276D+03,0.222D+03,0.91527000D+01,0.38675000D+01
     .,0.27640530D+03,0.276D+03,0.223D+03,0.91527000D+01,0.29110000D+01
     .,0.21249880D+03,0.276D+03,0.224D+03,0.91527000D+01,0.10619100D+02
     .,0.18396380D+03,0.276D+03,0.225D+03,0.91527000D+01,0.98849000D+01
     .,0.18034190D+03,0.276D+03,0.226D+03,0.91527000D+01,0.91376000D+01
     .,0.20743670D+03,0.276D+03,0.227D+03,0.91527000D+01,0.29263000D+01
     .,0.19424620D+03,0.276D+03,0.228D+03,0.91527000D+01,0.65458000D+01
     .,0.26882090D+03,0.276D+03,0.231D+03,0.91527000D+01,0.19315000D+01
     .,0.28515730D+03,0.276D+03,0.232D+03,0.91527000D+01,0.19447000D+01
     .,0.26525130D+03,0.276D+03,0.233D+03,0.91527000D+01,0.19793000D+01
     .,0.24932490D+03,0.276D+03,0.234D+03,0.91527000D+01,0.19812000D+01
     ./)
      grimme_c6_parameters( 125901: 126000)=(/
     . 0.36858100D+03,0.276D+03,0.238D+03,0.91527000D+01,0.19143000D+01
     .,0.35932890D+03,0.276D+03,0.239D+03,0.91527000D+01,0.28903000D+01
     .,0.36388390D+03,0.276D+03,0.240D+03,0.91527000D+01,0.39106000D+01
     .,0.35200850D+03,0.276D+03,0.241D+03,0.91527000D+01,0.29225000D+01
     .,0.31525780D+03,0.276D+03,0.242D+03,0.91527000D+01,0.11055600D+02
     .,0.28115270D+03,0.276D+03,0.243D+03,0.91527000D+01,0.95402000D+01
     .,0.26675220D+03,0.276D+03,0.244D+03,0.91527000D+01,0.88895000D+01
     .,0.26904190D+03,0.276D+03,0.245D+03,0.91527000D+01,0.29696000D+01
     .,0.27993090D+03,0.276D+03,0.246D+03,0.91527000D+01,0.57095000D+01
     .,0.34865850D+03,0.276D+03,0.249D+03,0.91527000D+01,0.19378000D+01
     .,0.37851600D+03,0.276D+03,0.250D+03,0.91527000D+01,0.19505000D+01
     .,0.36077560D+03,0.276D+03,0.251D+03,0.91527000D+01,0.19523000D+01
     .,0.35056820D+03,0.276D+03,0.252D+03,0.91527000D+01,0.19639000D+01
     .,0.44786270D+03,0.276D+03,0.256D+03,0.91527000D+01,0.18467000D+01
     .,0.46673680D+03,0.276D+03,0.257D+03,0.91527000D+01,0.29175000D+01
     .,0.35044320D+03,0.276D+03,0.272D+03,0.91527000D+01,0.38840000D+01
     .,0.36470460D+03,0.276D+03,0.273D+03,0.91527000D+01,0.28988000D+01
     .,0.34272390D+03,0.276D+03,0.274D+03,0.91527000D+01,0.10915300D+02
     .,0.31423420D+03,0.276D+03,0.275D+03,0.91527000D+01,0.98054000D+01
     .,0.29783380D+03,0.276D+03,0.276D+03,0.91527000D+01,0.91527000D+01
     ./)
      grimme_c6_parameters( 126001: 126100)=(/
     . 0.30229400D+02,0.277D+03,0.100D+01,0.29424000D+01,0.91180000D+00
     .,0.20760800D+02,0.277D+03,0.200D+01,0.29424000D+01,0.00000000D+00
     .,0.42636380D+03,0.277D+03,0.300D+01,0.29424000D+01,0.00000000D+00
     .,0.25474750D+03,0.277D+03,0.400D+01,0.29424000D+01,0.00000000D+00
     .,0.17635010D+03,0.277D+03,0.500D+01,0.29424000D+01,0.00000000D+00
     .,0.12210880D+03,0.277D+03,0.600D+01,0.29424000D+01,0.00000000D+00
     .,0.87190700D+02,0.277D+03,0.700D+01,0.29424000D+01,0.00000000D+00
     .,0.67091300D+02,0.277D+03,0.800D+01,0.29424000D+01,0.00000000D+00
     .,0.51585000D+02,0.277D+03,0.900D+01,0.29424000D+01,0.00000000D+00
     .,0.40184600D+02,0.277D+03,0.100D+02,0.29424000D+01,0.00000000D+00
     .,0.51143160D+03,0.277D+03,0.110D+02,0.29424000D+01,0.00000000D+00
     .,0.40339630D+03,0.277D+03,0.120D+02,0.29424000D+01,0.00000000D+00
     .,0.37653390D+03,0.277D+03,0.130D+02,0.29424000D+01,0.00000000D+00
     .,0.30209560D+03,0.277D+03,0.140D+02,0.29424000D+01,0.00000000D+00
     .,0.23974340D+03,0.277D+03,0.150D+02,0.29424000D+01,0.00000000D+00
     .,0.20158550D+03,0.277D+03,0.160D+02,0.29424000D+01,0.00000000D+00
     .,0.16687220D+03,0.277D+03,0.170D+02,0.29424000D+01,0.00000000D+00
     .,0.13823710D+03,0.277D+03,0.180D+02,0.29424000D+01,0.00000000D+00
     .,0.83884470D+03,0.277D+03,0.190D+02,0.29424000D+01,0.00000000D+00
     .,0.70306100D+03,0.277D+03,0.200D+02,0.29424000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 126101: 126200)=(/
     . 0.58340320D+03,0.277D+03,0.210D+02,0.29424000D+01,0.00000000D+00
     .,0.56663000D+03,0.277D+03,0.220D+02,0.29424000D+01,0.00000000D+00
     .,0.52055850D+03,0.277D+03,0.230D+02,0.29424000D+01,0.00000000D+00
     .,0.41171570D+03,0.277D+03,0.240D+02,0.29424000D+01,0.00000000D+00
     .,0.45035590D+03,0.277D+03,0.250D+02,0.29424000D+01,0.00000000D+00
     .,0.35513960D+03,0.277D+03,0.260D+02,0.29424000D+01,0.00000000D+00
     .,0.37753770D+03,0.277D+03,0.270D+02,0.29424000D+01,0.00000000D+00
     .,0.38750230D+03,0.277D+03,0.280D+02,0.29424000D+01,0.00000000D+00
     .,0.29855250D+03,0.277D+03,0.290D+02,0.29424000D+01,0.00000000D+00
     .,0.30844330D+03,0.277D+03,0.300D+02,0.29424000D+01,0.00000000D+00
     .,0.36354100D+03,0.277D+03,0.310D+02,0.29424000D+01,0.00000000D+00
     .,0.32481010D+03,0.277D+03,0.320D+02,0.29424000D+01,0.00000000D+00
     .,0.28090060D+03,0.277D+03,0.330D+02,0.29424000D+01,0.00000000D+00
     .,0.25453380D+03,0.277D+03,0.340D+02,0.29424000D+01,0.00000000D+00
     .,0.22513410D+03,0.277D+03,0.350D+02,0.29424000D+01,0.00000000D+00
     .,0.19784740D+03,0.277D+03,0.360D+02,0.29424000D+01,0.00000000D+00
     .,0.94312750D+03,0.277D+03,0.370D+02,0.29424000D+01,0.00000000D+00
     .,0.83825760D+03,0.277D+03,0.380D+02,0.29424000D+01,0.00000000D+00
     .,0.74070150D+03,0.277D+03,0.390D+02,0.29424000D+01,0.00000000D+00
     .,0.66984280D+03,0.277D+03,0.400D+02,0.29424000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 126201: 126300)=(/
     . 0.61369150D+03,0.277D+03,0.410D+02,0.29424000D+01,0.00000000D+00
     .,0.47850440D+03,0.277D+03,0.420D+02,0.29424000D+01,0.00000000D+00
     .,0.53185130D+03,0.277D+03,0.430D+02,0.29424000D+01,0.00000000D+00
     .,0.40961050D+03,0.277D+03,0.440D+02,0.29424000D+01,0.00000000D+00
     .,0.44656770D+03,0.277D+03,0.450D+02,0.29424000D+01,0.00000000D+00
     .,0.41538870D+03,0.277D+03,0.460D+02,0.29424000D+01,0.00000000D+00
     .,0.34736190D+03,0.277D+03,0.470D+02,0.29424000D+01,0.00000000D+00
     .,0.36754320D+03,0.277D+03,0.480D+02,0.29424000D+01,0.00000000D+00
     .,0.45659440D+03,0.277D+03,0.490D+02,0.29424000D+01,0.00000000D+00
     .,0.42612630D+03,0.277D+03,0.500D+02,0.29424000D+01,0.00000000D+00
     .,0.38393930D+03,0.277D+03,0.510D+02,0.29424000D+01,0.00000000D+00
     .,0.35889370D+03,0.277D+03,0.520D+02,0.29424000D+01,0.00000000D+00
     .,0.32731610D+03,0.277D+03,0.530D+02,0.29424000D+01,0.00000000D+00
     .,0.29686250D+03,0.277D+03,0.540D+02,0.29424000D+01,0.00000000D+00
     .,0.11506653D+04,0.277D+03,0.550D+02,0.29424000D+01,0.00000000D+00
     .,0.10673048D+04,0.277D+03,0.560D+02,0.29424000D+01,0.00000000D+00
     .,0.94534330D+03,0.277D+03,0.570D+02,0.29424000D+01,0.00000000D+00
     .,0.45335410D+03,0.277D+03,0.580D+02,0.29424000D+01,0.27991000D+01
     .,0.94886600D+03,0.277D+03,0.590D+02,0.29424000D+01,0.00000000D+00
     .,0.91214940D+03,0.277D+03,0.600D+02,0.29424000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 126301: 126400)=(/
     . 0.88952970D+03,0.277D+03,0.610D+02,0.29424000D+01,0.00000000D+00
     .,0.86867840D+03,0.277D+03,0.620D+02,0.29424000D+01,0.00000000D+00
     .,0.85019490D+03,0.277D+03,0.630D+02,0.29424000D+01,0.00000000D+00
     .,0.67650560D+03,0.277D+03,0.640D+02,0.29424000D+01,0.00000000D+00
     .,0.75286050D+03,0.277D+03,0.650D+02,0.29424000D+01,0.00000000D+00
     .,0.72736460D+03,0.277D+03,0.660D+02,0.29424000D+01,0.00000000D+00
     .,0.76817290D+03,0.277D+03,0.670D+02,0.29424000D+01,0.00000000D+00
     .,0.75193870D+03,0.277D+03,0.680D+02,0.29424000D+01,0.00000000D+00
     .,0.73739820D+03,0.277D+03,0.690D+02,0.29424000D+01,0.00000000D+00
     .,0.72836400D+03,0.277D+03,0.700D+02,0.29424000D+01,0.00000000D+00
     .,0.61861380D+03,0.277D+03,0.710D+02,0.29424000D+01,0.00000000D+00
     .,0.61342840D+03,0.277D+03,0.720D+02,0.29424000D+01,0.00000000D+00
     .,0.56363530D+03,0.277D+03,0.730D+02,0.29424000D+01,0.00000000D+00
     .,0.47969460D+03,0.277D+03,0.740D+02,0.29424000D+01,0.00000000D+00
     .,0.48887240D+03,0.277D+03,0.750D+02,0.29424000D+01,0.00000000D+00
     .,0.44589270D+03,0.277D+03,0.760D+02,0.29424000D+01,0.00000000D+00
     .,0.41058900D+03,0.277D+03,0.770D+02,0.29424000D+01,0.00000000D+00
     .,0.34385250D+03,0.277D+03,0.780D+02,0.29424000D+01,0.00000000D+00
     .,0.32228400D+03,0.277D+03,0.790D+02,0.29424000D+01,0.00000000D+00
     .,0.33178240D+03,0.277D+03,0.800D+02,0.29424000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 126401: 126500)=(/
     . 0.47174830D+03,0.277D+03,0.810D+02,0.29424000D+01,0.00000000D+00
     .,0.46398210D+03,0.277D+03,0.820D+02,0.29424000D+01,0.00000000D+00
     .,0.43022560D+03,0.277D+03,0.830D+02,0.29424000D+01,0.00000000D+00
     .,0.41274680D+03,0.277D+03,0.840D+02,0.29424000D+01,0.00000000D+00
     .,0.38386920D+03,0.277D+03,0.850D+02,0.29424000D+01,0.00000000D+00
     .,0.35453980D+03,0.277D+03,0.860D+02,0.29424000D+01,0.00000000D+00
     .,0.10936353D+04,0.277D+03,0.870D+02,0.29424000D+01,0.00000000D+00
     .,0.10604655D+04,0.277D+03,0.880D+02,0.29424000D+01,0.00000000D+00
     .,0.94439170D+03,0.277D+03,0.890D+02,0.29424000D+01,0.00000000D+00
     .,0.85775700D+03,0.277D+03,0.900D+02,0.29424000D+01,0.00000000D+00
     .,0.84861880D+03,0.277D+03,0.910D+02,0.29424000D+01,0.00000000D+00
     .,0.82201600D+03,0.277D+03,0.920D+02,0.29424000D+01,0.00000000D+00
     .,0.84127950D+03,0.277D+03,0.930D+02,0.29424000D+01,0.00000000D+00
     .,0.81549360D+03,0.277D+03,0.940D+02,0.29424000D+01,0.00000000D+00
     .,0.47710700D+02,0.277D+03,0.101D+03,0.29424000D+01,0.00000000D+00
     .,0.14877410D+03,0.277D+03,0.103D+03,0.29424000D+01,0.98650000D+00
     .,0.19095480D+03,0.277D+03,0.104D+03,0.29424000D+01,0.98080000D+00
     .,0.14941700D+03,0.277D+03,0.105D+03,0.29424000D+01,0.97060000D+00
     .,0.11467490D+03,0.277D+03,0.106D+03,0.29424000D+01,0.98680000D+00
     .,0.81468600D+02,0.277D+03,0.107D+03,0.29424000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters( 126501: 126600)=(/
     . 0.60474900D+02,0.277D+03,0.108D+03,0.29424000D+01,0.99250000D+00
     .,0.42633000D+02,0.277D+03,0.109D+03,0.29424000D+01,0.99820000D+00
     .,0.21706070D+03,0.277D+03,0.111D+03,0.29424000D+01,0.96840000D+00
     .,0.33478560D+03,0.277D+03,0.112D+03,0.29424000D+01,0.96280000D+00
     .,0.34247320D+03,0.277D+03,0.113D+03,0.29424000D+01,0.96480000D+00
     .,0.28013350D+03,0.277D+03,0.114D+03,0.29424000D+01,0.95070000D+00
     .,0.23294100D+03,0.277D+03,0.115D+03,0.29424000D+01,0.99470000D+00
     .,0.19936180D+03,0.277D+03,0.116D+03,0.29424000D+01,0.99480000D+00
     .,0.16514130D+03,0.277D+03,0.117D+03,0.29424000D+01,0.99720000D+00
     .,0.30413400D+03,0.277D+03,0.119D+03,0.29424000D+01,0.97670000D+00
     .,0.56534700D+03,0.277D+03,0.120D+03,0.29424000D+01,0.98310000D+00
     .,0.30720500D+03,0.277D+03,0.121D+03,0.29424000D+01,0.18627000D+01
     .,0.29699590D+03,0.277D+03,0.122D+03,0.29424000D+01,0.18299000D+01
     .,0.29107410D+03,0.277D+03,0.123D+03,0.29424000D+01,0.19138000D+01
     .,0.28800240D+03,0.277D+03,0.124D+03,0.29424000D+01,0.18269000D+01
     .,0.26680930D+03,0.277D+03,0.125D+03,0.29424000D+01,0.16406000D+01
     .,0.24770870D+03,0.277D+03,0.126D+03,0.29424000D+01,0.16483000D+01
     .,0.23646980D+03,0.277D+03,0.127D+03,0.29424000D+01,0.17149000D+01
     .,0.23106240D+03,0.277D+03,0.128D+03,0.29424000D+01,0.17937000D+01
     .,0.22706590D+03,0.277D+03,0.129D+03,0.29424000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters( 126601: 126700)=(/
     . 0.21517070D+03,0.277D+03,0.130D+03,0.29424000D+01,0.19419000D+01
     .,0.34264070D+03,0.277D+03,0.131D+03,0.29424000D+01,0.96010000D+00
     .,0.30498940D+03,0.277D+03,0.132D+03,0.29424000D+01,0.94340000D+00
     .,0.27641200D+03,0.277D+03,0.133D+03,0.29424000D+01,0.98890000D+00
     .,0.25462020D+03,0.277D+03,0.134D+03,0.29424000D+01,0.99010000D+00
     .,0.22659700D+03,0.277D+03,0.135D+03,0.29424000D+01,0.99740000D+00
     .,0.36441220D+03,0.277D+03,0.137D+03,0.29424000D+01,0.97380000D+00
     .,0.68823470D+03,0.277D+03,0.138D+03,0.29424000D+01,0.98010000D+00
     .,0.53570340D+03,0.277D+03,0.139D+03,0.29424000D+01,0.19153000D+01
     .,0.40665130D+03,0.277D+03,0.140D+03,0.29424000D+01,0.19355000D+01
     .,0.41063670D+03,0.277D+03,0.141D+03,0.29424000D+01,0.19545000D+01
     .,0.38441940D+03,0.277D+03,0.142D+03,0.29424000D+01,0.19420000D+01
     .,0.42730450D+03,0.277D+03,0.143D+03,0.29424000D+01,0.16682000D+01
     .,0.33787470D+03,0.277D+03,0.144D+03,0.29424000D+01,0.18584000D+01
     .,0.31668990D+03,0.277D+03,0.145D+03,0.29424000D+01,0.19003000D+01
     .,0.29482600D+03,0.277D+03,0.146D+03,0.29424000D+01,0.18630000D+01
     .,0.28494240D+03,0.277D+03,0.147D+03,0.29424000D+01,0.96790000D+00
     .,0.28309650D+03,0.277D+03,0.148D+03,0.29424000D+01,0.19539000D+01
     .,0.43680210D+03,0.277D+03,0.149D+03,0.29424000D+01,0.96330000D+00
     .,0.39922460D+03,0.277D+03,0.150D+03,0.29424000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters( 126701: 126800)=(/
     . 0.37689830D+03,0.277D+03,0.151D+03,0.29424000D+01,0.97490000D+00
     .,0.35878610D+03,0.277D+03,0.152D+03,0.29424000D+01,0.98110000D+00
     .,0.33031590D+03,0.277D+03,0.153D+03,0.29424000D+01,0.99680000D+00
     .,0.43396820D+03,0.277D+03,0.155D+03,0.29424000D+01,0.99090000D+00
     .,0.89082740D+03,0.277D+03,0.156D+03,0.29424000D+01,0.97970000D+00
     .,0.67744550D+03,0.277D+03,0.157D+03,0.29424000D+01,0.19373000D+01
     .,0.44003130D+03,0.277D+03,0.159D+03,0.29424000D+01,0.29425000D+01
     .,0.43099700D+03,0.277D+03,0.160D+03,0.29424000D+01,0.29455000D+01
     .,0.41762690D+03,0.277D+03,0.161D+03,0.29424000D+01,0.29413000D+01
     .,0.41901960D+03,0.277D+03,0.162D+03,0.29424000D+01,0.29300000D+01
     .,0.40212590D+03,0.277D+03,0.163D+03,0.29424000D+01,0.18286000D+01
     .,0.42122030D+03,0.277D+03,0.164D+03,0.29424000D+01,0.28732000D+01
     .,0.39630640D+03,0.277D+03,0.165D+03,0.29424000D+01,0.29086000D+01
     .,0.40219400D+03,0.277D+03,0.166D+03,0.29424000D+01,0.28965000D+01
     .,0.37665190D+03,0.277D+03,0.167D+03,0.29424000D+01,0.29242000D+01
     .,0.36611320D+03,0.277D+03,0.168D+03,0.29424000D+01,0.29282000D+01
     .,0.36356690D+03,0.277D+03,0.169D+03,0.29424000D+01,0.29246000D+01
     .,0.38089510D+03,0.277D+03,0.170D+03,0.29424000D+01,0.28482000D+01
     .,0.35163250D+03,0.277D+03,0.171D+03,0.29424000D+01,0.29219000D+01
     .,0.46799190D+03,0.277D+03,0.172D+03,0.29424000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters( 126801: 126900)=(/
     . 0.43730900D+03,0.277D+03,0.173D+03,0.29424000D+01,0.19459000D+01
     .,0.40191040D+03,0.277D+03,0.174D+03,0.29424000D+01,0.19292000D+01
     .,0.40442320D+03,0.277D+03,0.175D+03,0.29424000D+01,0.18104000D+01
     .,0.35970450D+03,0.277D+03,0.176D+03,0.29424000D+01,0.18858000D+01
     .,0.33957300D+03,0.277D+03,0.177D+03,0.29424000D+01,0.18648000D+01
     .,0.32507870D+03,0.277D+03,0.178D+03,0.29424000D+01,0.19188000D+01
     .,0.31108440D+03,0.277D+03,0.179D+03,0.29424000D+01,0.98460000D+00
     .,0.30206450D+03,0.277D+03,0.180D+03,0.29424000D+01,0.19896000D+01
     .,0.47125110D+03,0.277D+03,0.181D+03,0.29424000D+01,0.92670000D+00
     .,0.43367490D+03,0.277D+03,0.182D+03,0.29424000D+01,0.93830000D+00
     .,0.42287330D+03,0.277D+03,0.183D+03,0.29424000D+01,0.98200000D+00
     .,0.41315870D+03,0.277D+03,0.184D+03,0.29424000D+01,0.98150000D+00
     .,0.38847900D+03,0.277D+03,0.185D+03,0.29424000D+01,0.99540000D+00
     .,0.48893950D+03,0.277D+03,0.187D+03,0.29424000D+01,0.97050000D+00
     .,0.89067630D+03,0.277D+03,0.188D+03,0.29424000D+01,0.96620000D+00
     .,0.52029480D+03,0.277D+03,0.189D+03,0.29424000D+01,0.29070000D+01
     .,0.59599730D+03,0.277D+03,0.190D+03,0.29424000D+01,0.28844000D+01
     .,0.53552370D+03,0.277D+03,0.191D+03,0.29424000D+01,0.28738000D+01
     .,0.47621600D+03,0.277D+03,0.192D+03,0.29424000D+01,0.28878000D+01
     .,0.45907020D+03,0.277D+03,0.193D+03,0.29424000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters( 126901: 127000)=(/
     . 0.54251670D+03,0.277D+03,0.194D+03,0.29424000D+01,0.19209000D+01
     .,0.12750670D+03,0.277D+03,0.204D+03,0.29424000D+01,0.19697000D+01
     .,0.12636580D+03,0.277D+03,0.205D+03,0.29424000D+01,0.19441000D+01
     .,0.94442200D+02,0.277D+03,0.206D+03,0.29424000D+01,0.19985000D+01
     .,0.76693600D+02,0.277D+03,0.207D+03,0.29424000D+01,0.20143000D+01
     .,0.53713500D+02,0.277D+03,0.208D+03,0.29424000D+01,0.19887000D+01
     .,0.22345060D+03,0.277D+03,0.212D+03,0.29424000D+01,0.19496000D+01
     .,0.26992960D+03,0.277D+03,0.213D+03,0.29424000D+01,0.19311000D+01
     .,0.26131790D+03,0.277D+03,0.214D+03,0.29424000D+01,0.19435000D+01
     .,0.22965740D+03,0.277D+03,0.215D+03,0.29424000D+01,0.20102000D+01
     .,0.19542290D+03,0.277D+03,0.216D+03,0.29424000D+01,0.19903000D+01
     .,0.31465860D+03,0.277D+03,0.220D+03,0.29424000D+01,0.19349000D+01
     .,0.30440560D+03,0.277D+03,0.221D+03,0.29424000D+01,0.28999000D+01
     .,0.30837100D+03,0.277D+03,0.222D+03,0.29424000D+01,0.38675000D+01
     .,0.28252780D+03,0.277D+03,0.223D+03,0.29424000D+01,0.29110000D+01
     .,0.21607310D+03,0.277D+03,0.224D+03,0.29424000D+01,0.10619100D+02
     .,0.18647130D+03,0.277D+03,0.225D+03,0.29424000D+01,0.98849000D+01
     .,0.18288010D+03,0.277D+03,0.226D+03,0.29424000D+01,0.91376000D+01
     .,0.21145410D+03,0.277D+03,0.227D+03,0.29424000D+01,0.29263000D+01
     .,0.19770250D+03,0.277D+03,0.228D+03,0.29424000D+01,0.65458000D+01
     ./)
      grimme_c6_parameters( 127001: 127100)=(/
     . 0.27493230D+03,0.277D+03,0.231D+03,0.29424000D+01,0.19315000D+01
     .,0.29109370D+03,0.277D+03,0.232D+03,0.29424000D+01,0.19447000D+01
     .,0.26957470D+03,0.277D+03,0.233D+03,0.29424000D+01,0.19793000D+01
     .,0.25271240D+03,0.277D+03,0.234D+03,0.29424000D+01,0.19812000D+01
     .,0.37790170D+03,0.277D+03,0.238D+03,0.29424000D+01,0.19143000D+01
     .,0.36667450D+03,0.277D+03,0.239D+03,0.29424000D+01,0.28903000D+01
     .,0.37083430D+03,0.277D+03,0.240D+03,0.29424000D+01,0.39106000D+01
     .,0.35892720D+03,0.277D+03,0.241D+03,0.29424000D+01,0.29225000D+01
     .,0.32031090D+03,0.277D+03,0.242D+03,0.29424000D+01,0.11055600D+02
     .,0.28489430D+03,0.277D+03,0.243D+03,0.29424000D+01,0.95402000D+01
     .,0.27005380D+03,0.277D+03,0.244D+03,0.29424000D+01,0.88895000D+01
     .,0.27328420D+03,0.277D+03,0.245D+03,0.29424000D+01,0.29696000D+01
     .,0.28460940D+03,0.277D+03,0.246D+03,0.29424000D+01,0.57095000D+01
     .,0.35643230D+03,0.277D+03,0.249D+03,0.29424000D+01,0.19378000D+01
     .,0.38687350D+03,0.277D+03,0.250D+03,0.29424000D+01,0.19505000D+01
     .,0.36731080D+03,0.277D+03,0.251D+03,0.29424000D+01,0.19523000D+01
     .,0.35616120D+03,0.277D+03,0.252D+03,0.29424000D+01,0.19639000D+01
     .,0.45858100D+03,0.277D+03,0.256D+03,0.29424000D+01,0.18467000D+01
     .,0.47669270D+03,0.277D+03,0.257D+03,0.29424000D+01,0.29175000D+01
     .,0.35651190D+03,0.277D+03,0.272D+03,0.29424000D+01,0.38840000D+01
     ./)
      grimme_c6_parameters( 127101: 127200)=(/
     . 0.37170810D+03,0.277D+03,0.273D+03,0.29424000D+01,0.28988000D+01
     .,0.34812240D+03,0.277D+03,0.274D+03,0.29424000D+01,0.10915300D+02
     .,0.31841110D+03,0.277D+03,0.275D+03,0.29424000D+01,0.98054000D+01
     .,0.30121160D+03,0.277D+03,0.276D+03,0.29424000D+01,0.91527000D+01
     .,0.30552580D+03,0.277D+03,0.277D+03,0.29424000D+01,0.29424000D+01
     .,0.31736800D+02,0.278D+03,0.100D+01,0.66669000D+01,0.91180000D+00
     .,0.21706400D+02,0.278D+03,0.200D+01,0.66669000D+01,0.00000000D+00
     .,0.44817370D+03,0.278D+03,0.300D+01,0.66669000D+01,0.00000000D+00
     .,0.26864910D+03,0.278D+03,0.400D+01,0.66669000D+01,0.00000000D+00
     .,0.18571950D+03,0.278D+03,0.500D+01,0.66669000D+01,0.00000000D+00
     .,0.12832810D+03,0.278D+03,0.600D+01,0.66669000D+01,0.00000000D+00
     .,0.91444100D+02,0.278D+03,0.700D+01,0.66669000D+01,0.00000000D+00
     .,0.70247200D+02,0.278D+03,0.800D+01,0.66669000D+01,0.00000000D+00
     .,0.53929300D+02,0.278D+03,0.900D+01,0.66669000D+01,0.00000000D+00
     .,0.41957400D+02,0.278D+03,0.100D+02,0.66669000D+01,0.00000000D+00
     .,0.53764280D+03,0.278D+03,0.110D+02,0.66669000D+01,0.00000000D+00
     .,0.42531660D+03,0.278D+03,0.120D+02,0.66669000D+01,0.00000000D+00
     .,0.39691230D+03,0.278D+03,0.130D+02,0.66669000D+01,0.00000000D+00
     .,0.31822850D+03,0.278D+03,0.140D+02,0.66669000D+01,0.00000000D+00
     .,0.25221940D+03,0.278D+03,0.150D+02,0.66669000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 127201: 127300)=(/
     . 0.21181210D+03,0.278D+03,0.160D+02,0.66669000D+01,0.00000000D+00
     .,0.17510170D+03,0.278D+03,0.170D+02,0.66669000D+01,0.00000000D+00
     .,0.14486250D+03,0.278D+03,0.180D+02,0.66669000D+01,0.00000000D+00
     .,0.87976340D+03,0.278D+03,0.190D+02,0.66669000D+01,0.00000000D+00
     .,0.74019810D+03,0.278D+03,0.200D+02,0.66669000D+01,0.00000000D+00
     .,0.61451280D+03,0.278D+03,0.210D+02,0.66669000D+01,0.00000000D+00
     .,0.59680090D+03,0.278D+03,0.220D+02,0.66669000D+01,0.00000000D+00
     .,0.54828530D+03,0.278D+03,0.230D+02,0.66669000D+01,0.00000000D+00
     .,0.43331070D+03,0.278D+03,0.240D+02,0.66669000D+01,0.00000000D+00
     .,0.47433180D+03,0.278D+03,0.250D+02,0.66669000D+01,0.00000000D+00
     .,0.37375740D+03,0.278D+03,0.260D+02,0.66669000D+01,0.00000000D+00
     .,0.39765430D+03,0.278D+03,0.270D+02,0.66669000D+01,0.00000000D+00
     .,0.40819710D+03,0.278D+03,0.280D+02,0.66669000D+01,0.00000000D+00
     .,0.31418780D+03,0.278D+03,0.290D+02,0.66669000D+01,0.00000000D+00
     .,0.32482660D+03,0.278D+03,0.300D+02,0.66669000D+01,0.00000000D+00
     .,0.38293500D+03,0.278D+03,0.310D+02,0.66669000D+01,0.00000000D+00
     .,0.34202100D+03,0.278D+03,0.320D+02,0.66669000D+01,0.00000000D+00
     .,0.29551180D+03,0.278D+03,0.330D+02,0.66669000D+01,0.00000000D+00
     .,0.26753780D+03,0.278D+03,0.340D+02,0.66669000D+01,0.00000000D+00
     .,0.23639130D+03,0.278D+03,0.350D+02,0.66669000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 127301: 127400)=(/
     . 0.20751570D+03,0.278D+03,0.360D+02,0.66669000D+01,0.00000000D+00
     .,0.98897460D+03,0.278D+03,0.370D+02,0.66669000D+01,0.00000000D+00
     .,0.88212520D+03,0.278D+03,0.380D+02,0.66669000D+01,0.00000000D+00
     .,0.77987150D+03,0.278D+03,0.390D+02,0.66669000D+01,0.00000000D+00
     .,0.70532520D+03,0.278D+03,0.400D+02,0.66669000D+01,0.00000000D+00
     .,0.64612000D+03,0.278D+03,0.410D+02,0.66669000D+01,0.00000000D+00
     .,0.50347710D+03,0.278D+03,0.420D+02,0.66669000D+01,0.00000000D+00
     .,0.55975880D+03,0.278D+03,0.430D+02,0.66669000D+01,0.00000000D+00
     .,0.43081480D+03,0.278D+03,0.440D+02,0.66669000D+01,0.00000000D+00
     .,0.46996810D+03,0.278D+03,0.450D+02,0.66669000D+01,0.00000000D+00
     .,0.43711170D+03,0.278D+03,0.460D+02,0.66669000D+01,0.00000000D+00
     .,0.36518920D+03,0.278D+03,0.470D+02,0.66669000D+01,0.00000000D+00
     .,0.38669930D+03,0.278D+03,0.480D+02,0.66669000D+01,0.00000000D+00
     .,0.48058480D+03,0.278D+03,0.490D+02,0.66669000D+01,0.00000000D+00
     .,0.44855300D+03,0.278D+03,0.500D+02,0.66669000D+01,0.00000000D+00
     .,0.40393700D+03,0.278D+03,0.510D+02,0.66669000D+01,0.00000000D+00
     .,0.37737610D+03,0.278D+03,0.520D+02,0.66669000D+01,0.00000000D+00
     .,0.34391650D+03,0.278D+03,0.530D+02,0.66669000D+01,0.00000000D+00
     .,0.31165760D+03,0.278D+03,0.540D+02,0.66669000D+01,0.00000000D+00
     .,0.12060907D+04,0.278D+03,0.550D+02,0.66669000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 127401: 127500)=(/
     . 0.11224006D+04,0.278D+03,0.560D+02,0.66669000D+01,0.00000000D+00
     .,0.99484110D+03,0.278D+03,0.570D+02,0.66669000D+01,0.00000000D+00
     .,0.47685250D+03,0.278D+03,0.580D+02,0.66669000D+01,0.27991000D+01
     .,0.99799760D+03,0.278D+03,0.590D+02,0.66669000D+01,0.00000000D+00
     .,0.95958830D+03,0.278D+03,0.600D+02,0.66669000D+01,0.00000000D+00
     .,0.93585100D+03,0.278D+03,0.610D+02,0.66669000D+01,0.00000000D+00
     .,0.91396730D+03,0.278D+03,0.620D+02,0.66669000D+01,0.00000000D+00
     .,0.89457000D+03,0.278D+03,0.630D+02,0.66669000D+01,0.00000000D+00
     .,0.71180730D+03,0.278D+03,0.640D+02,0.66669000D+01,0.00000000D+00
     .,0.79087860D+03,0.278D+03,0.650D+02,0.66669000D+01,0.00000000D+00
     .,0.76413790D+03,0.278D+03,0.660D+02,0.66669000D+01,0.00000000D+00
     .,0.80848440D+03,0.278D+03,0.670D+02,0.66669000D+01,0.00000000D+00
     .,0.79144150D+03,0.278D+03,0.680D+02,0.66669000D+01,0.00000000D+00
     .,0.77617700D+03,0.278D+03,0.690D+02,0.66669000D+01,0.00000000D+00
     .,0.76668210D+03,0.278D+03,0.700D+02,0.66669000D+01,0.00000000D+00
     .,0.65113390D+03,0.278D+03,0.710D+02,0.66669000D+01,0.00000000D+00
     .,0.64597680D+03,0.278D+03,0.720D+02,0.66669000D+01,0.00000000D+00
     .,0.59345200D+03,0.278D+03,0.730D+02,0.66669000D+01,0.00000000D+00
     .,0.50469500D+03,0.278D+03,0.740D+02,0.66669000D+01,0.00000000D+00
     .,0.51441860D+03,0.278D+03,0.750D+02,0.66669000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 127501: 127600)=(/
     . 0.46906170D+03,0.278D+03,0.760D+02,0.66669000D+01,0.00000000D+00
     .,0.43179110D+03,0.278D+03,0.770D+02,0.66669000D+01,0.00000000D+00
     .,0.36131080D+03,0.278D+03,0.780D+02,0.66669000D+01,0.00000000D+00
     .,0.33854780D+03,0.278D+03,0.790D+02,0.66669000D+01,0.00000000D+00
     .,0.34860350D+03,0.278D+03,0.800D+02,0.66669000D+01,0.00000000D+00
     .,0.49610630D+03,0.278D+03,0.810D+02,0.66669000D+01,0.00000000D+00
     .,0.48812730D+03,0.278D+03,0.820D+02,0.66669000D+01,0.00000000D+00
     .,0.45249450D+03,0.278D+03,0.830D+02,0.66669000D+01,0.00000000D+00
     .,0.43395750D+03,0.278D+03,0.840D+02,0.66669000D+01,0.00000000D+00
     .,0.40335980D+03,0.278D+03,0.850D+02,0.66669000D+01,0.00000000D+00
     .,0.37228610D+03,0.278D+03,0.860D+02,0.66669000D+01,0.00000000D+00
     .,0.11471809D+04,0.278D+03,0.870D+02,0.66669000D+01,0.00000000D+00
     .,0.11154572D+04,0.278D+03,0.880D+02,0.66669000D+01,0.00000000D+00
     .,0.99404090D+03,0.278D+03,0.890D+02,0.66669000D+01,0.00000000D+00
     .,0.90293930D+03,0.278D+03,0.900D+02,0.66669000D+01,0.00000000D+00
     .,0.89295040D+03,0.278D+03,0.910D+02,0.66669000D+01,0.00000000D+00
     .,0.86495490D+03,0.278D+03,0.920D+02,0.66669000D+01,0.00000000D+00
     .,0.88511780D+03,0.278D+03,0.930D+02,0.66669000D+01,0.00000000D+00
     .,0.85805490D+03,0.278D+03,0.940D+02,0.66669000D+01,0.00000000D+00
     .,0.50189900D+02,0.278D+03,0.101D+03,0.66669000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 127601: 127700)=(/
     . 0.15683270D+03,0.278D+03,0.103D+03,0.66669000D+01,0.98650000D+00
     .,0.20116870D+03,0.278D+03,0.104D+03,0.66669000D+01,0.98080000D+00
     .,0.15724660D+03,0.278D+03,0.105D+03,0.66669000D+01,0.97060000D+00
     .,0.12047330D+03,0.278D+03,0.106D+03,0.66669000D+01,0.98680000D+00
     .,0.85411300D+02,0.278D+03,0.107D+03,0.66669000D+01,0.99440000D+00
     .,0.63280300D+02,0.278D+03,0.108D+03,0.66669000D+01,0.99250000D+00
     .,0.44500400D+02,0.278D+03,0.109D+03,0.66669000D+01,0.99820000D+00
     .,0.22873580D+03,0.278D+03,0.111D+03,0.66669000D+01,0.96840000D+00
     .,0.35278900D+03,0.278D+03,0.112D+03,0.66669000D+01,0.96280000D+00
     .,0.36093540D+03,0.278D+03,0.113D+03,0.66669000D+01,0.96480000D+00
     .,0.29500710D+03,0.278D+03,0.114D+03,0.66669000D+01,0.95070000D+00
     .,0.24503090D+03,0.278D+03,0.115D+03,0.66669000D+01,0.99470000D+00
     .,0.20947030D+03,0.278D+03,0.116D+03,0.66669000D+01,0.99480000D+00
     .,0.17328290D+03,0.278D+03,0.117D+03,0.66669000D+01,0.99720000D+00
     .,0.31991700D+03,0.278D+03,0.119D+03,0.66669000D+01,0.97670000D+00
     .,0.59442400D+03,0.278D+03,0.120D+03,0.66669000D+01,0.98310000D+00
     .,0.32334130D+03,0.278D+03,0.121D+03,0.66669000D+01,0.18627000D+01
     .,0.31251320D+03,0.278D+03,0.122D+03,0.66669000D+01,0.18299000D+01
     .,0.30627330D+03,0.278D+03,0.123D+03,0.66669000D+01,0.19138000D+01
     .,0.30303740D+03,0.278D+03,0.124D+03,0.66669000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters( 127701: 127800)=(/
     . 0.28075180D+03,0.278D+03,0.125D+03,0.66669000D+01,0.16406000D+01
     .,0.26058650D+03,0.278D+03,0.126D+03,0.66669000D+01,0.16483000D+01
     .,0.24872640D+03,0.278D+03,0.127D+03,0.66669000D+01,0.17149000D+01
     .,0.24304070D+03,0.278D+03,0.128D+03,0.66669000D+01,0.17937000D+01
     .,0.23886500D+03,0.278D+03,0.129D+03,0.66669000D+01,0.95760000D+00
     .,0.22630430D+03,0.278D+03,0.130D+03,0.66669000D+01,0.19419000D+01
     .,0.36087970D+03,0.278D+03,0.131D+03,0.66669000D+01,0.96010000D+00
     .,0.32106640D+03,0.278D+03,0.132D+03,0.66669000D+01,0.94340000D+00
     .,0.29076020D+03,0.278D+03,0.133D+03,0.66669000D+01,0.98890000D+00
     .,0.26762610D+03,0.278D+03,0.134D+03,0.66669000D+01,0.99010000D+00
     .,0.23793600D+03,0.278D+03,0.135D+03,0.66669000D+01,0.99740000D+00
     .,0.38318340D+03,0.278D+03,0.137D+03,0.66669000D+01,0.97380000D+00
     .,0.72324770D+03,0.278D+03,0.138D+03,0.66669000D+01,0.98010000D+00
     .,0.56337460D+03,0.278D+03,0.139D+03,0.66669000D+01,0.19153000D+01
     .,0.42778570D+03,0.278D+03,0.140D+03,0.66669000D+01,0.19355000D+01
     .,0.43199420D+03,0.278D+03,0.141D+03,0.66669000D+01,0.19545000D+01
     .,0.40427790D+03,0.278D+03,0.142D+03,0.66669000D+01,0.19420000D+01
     .,0.44929790D+03,0.278D+03,0.143D+03,0.66669000D+01,0.16682000D+01
     .,0.35522280D+03,0.278D+03,0.144D+03,0.66669000D+01,0.18584000D+01
     .,0.33286530D+03,0.278D+03,0.145D+03,0.66669000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters( 127801: 127900)=(/
     . 0.30980620D+03,0.278D+03,0.146D+03,0.66669000D+01,0.18630000D+01
     .,0.29943630D+03,0.278D+03,0.147D+03,0.66669000D+01,0.96790000D+00
     .,0.29752810D+03,0.278D+03,0.148D+03,0.66669000D+01,0.19539000D+01
     .,0.45973620D+03,0.278D+03,0.149D+03,0.66669000D+01,0.96330000D+00
     .,0.42013030D+03,0.278D+03,0.150D+03,0.66669000D+01,0.95140000D+00
     .,0.39648380D+03,0.278D+03,0.151D+03,0.66669000D+01,0.97490000D+00
     .,0.37725130D+03,0.278D+03,0.152D+03,0.66669000D+01,0.98110000D+00
     .,0.34707680D+03,0.278D+03,0.153D+03,0.66669000D+01,0.99680000D+00
     .,0.45631660D+03,0.278D+03,0.155D+03,0.66669000D+01,0.99090000D+00
     .,0.93534640D+03,0.278D+03,0.156D+03,0.66669000D+01,0.97970000D+00
     .,0.71222580D+03,0.278D+03,0.157D+03,0.66669000D+01,0.19373000D+01
     .,0.46281270D+03,0.278D+03,0.159D+03,0.66669000D+01,0.29425000D+01
     .,0.45330770D+03,0.278D+03,0.160D+03,0.66669000D+01,0.29455000D+01
     .,0.43922170D+03,0.278D+03,0.161D+03,0.66669000D+01,0.29413000D+01
     .,0.44070090D+03,0.278D+03,0.162D+03,0.66669000D+01,0.29300000D+01
     .,0.42296520D+03,0.278D+03,0.163D+03,0.66669000D+01,0.18286000D+01
     .,0.44307970D+03,0.278D+03,0.164D+03,0.66669000D+01,0.28732000D+01
     .,0.41683270D+03,0.278D+03,0.165D+03,0.66669000D+01,0.29086000D+01
     .,0.42302650D+03,0.278D+03,0.166D+03,0.66669000D+01,0.28965000D+01
     .,0.39614680D+03,0.278D+03,0.167D+03,0.66669000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters( 127901: 128000)=(/
     . 0.38505430D+03,0.278D+03,0.168D+03,0.66669000D+01,0.29282000D+01
     .,0.38239220D+03,0.278D+03,0.169D+03,0.66669000D+01,0.29246000D+01
     .,0.40073810D+03,0.278D+03,0.170D+03,0.66669000D+01,0.28482000D+01
     .,0.36983970D+03,0.278D+03,0.171D+03,0.66669000D+01,0.29219000D+01
     .,0.49231890D+03,0.278D+03,0.172D+03,0.66669000D+01,0.19254000D+01
     .,0.45993990D+03,0.278D+03,0.173D+03,0.66669000D+01,0.19459000D+01
     .,0.42259020D+03,0.278D+03,0.174D+03,0.66669000D+01,0.19292000D+01
     .,0.42529100D+03,0.278D+03,0.175D+03,0.66669000D+01,0.18104000D+01
     .,0.37803640D+03,0.278D+03,0.176D+03,0.66669000D+01,0.18858000D+01
     .,0.35676720D+03,0.278D+03,0.177D+03,0.66669000D+01,0.18648000D+01
     .,0.34146440D+03,0.278D+03,0.178D+03,0.66669000D+01,0.19188000D+01
     .,0.32670140D+03,0.278D+03,0.179D+03,0.66669000D+01,0.98460000D+00
     .,0.31719220D+03,0.278D+03,0.180D+03,0.66669000D+01,0.19896000D+01
     .,0.49566950D+03,0.278D+03,0.181D+03,0.66669000D+01,0.92670000D+00
     .,0.45614500D+03,0.278D+03,0.182D+03,0.66669000D+01,0.93830000D+00
     .,0.44471840D+03,0.278D+03,0.183D+03,0.66669000D+01,0.98200000D+00
     .,0.43437700D+03,0.278D+03,0.184D+03,0.66669000D+01,0.98150000D+00
     .,0.40821270D+03,0.278D+03,0.185D+03,0.66669000D+01,0.99540000D+00
     .,0.51413610D+03,0.278D+03,0.187D+03,0.66669000D+01,0.97050000D+00
     .,0.93570360D+03,0.278D+03,0.188D+03,0.66669000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters( 128001: 128100)=(/
     . 0.54728610D+03,0.278D+03,0.189D+03,0.66669000D+01,0.29070000D+01
     .,0.62674370D+03,0.278D+03,0.190D+03,0.66669000D+01,0.28844000D+01
     .,0.56283810D+03,0.278D+03,0.191D+03,0.66669000D+01,0.28738000D+01
     .,0.50066010D+03,0.278D+03,0.192D+03,0.66669000D+01,0.28878000D+01
     .,0.48260870D+03,0.278D+03,0.193D+03,0.66669000D+01,0.29095000D+01
     .,0.57030020D+03,0.278D+03,0.194D+03,0.66669000D+01,0.19209000D+01
     .,0.13424720D+03,0.278D+03,0.204D+03,0.66669000D+01,0.19697000D+01
     .,0.13288680D+03,0.278D+03,0.205D+03,0.66669000D+01,0.19441000D+01
     .,0.99142600D+02,0.278D+03,0.206D+03,0.66669000D+01,0.19985000D+01
     .,0.80387800D+02,0.278D+03,0.207D+03,0.66669000D+01,0.20143000D+01
     .,0.56164700D+02,0.278D+03,0.208D+03,0.66669000D+01,0.19887000D+01
     .,0.23546090D+03,0.278D+03,0.212D+03,0.66669000D+01,0.19496000D+01
     .,0.28433280D+03,0.278D+03,0.213D+03,0.66669000D+01,0.19311000D+01
     .,0.27514210D+03,0.278D+03,0.214D+03,0.66669000D+01,0.19435000D+01
     .,0.24157090D+03,0.278D+03,0.215D+03,0.66669000D+01,0.20102000D+01
     .,0.20531920D+03,0.278D+03,0.216D+03,0.66669000D+01,0.19903000D+01
     .,0.33124320D+03,0.278D+03,0.220D+03,0.66669000D+01,0.19349000D+01
     .,0.32036790D+03,0.278D+03,0.221D+03,0.66669000D+01,0.28999000D+01
     .,0.32452330D+03,0.278D+03,0.222D+03,0.66669000D+01,0.38675000D+01
     .,0.29723410D+03,0.278D+03,0.223D+03,0.66669000D+01,0.29110000D+01
     ./)
      grimme_c6_parameters( 128101: 128200)=(/
     . 0.22702370D+03,0.278D+03,0.224D+03,0.66669000D+01,0.10619100D+02
     .,0.19579190D+03,0.278D+03,0.225D+03,0.66669000D+01,0.98849000D+01
     .,0.19203650D+03,0.278D+03,0.226D+03,0.66669000D+01,0.91376000D+01
     .,0.22228680D+03,0.278D+03,0.227D+03,0.66669000D+01,0.29263000D+01
     .,0.20779350D+03,0.278D+03,0.228D+03,0.66669000D+01,0.65458000D+01
     .,0.28939310D+03,0.278D+03,0.231D+03,0.66669000D+01,0.19315000D+01
     .,0.30638780D+03,0.278D+03,0.232D+03,0.66669000D+01,0.19447000D+01
     .,0.28353080D+03,0.278D+03,0.233D+03,0.66669000D+01,0.19793000D+01
     .,0.26560990D+03,0.278D+03,0.234D+03,0.66669000D+01,0.19812000D+01
     .,0.39765110D+03,0.278D+03,0.238D+03,0.66669000D+01,0.19143000D+01
     .,0.38577200D+03,0.278D+03,0.239D+03,0.66669000D+01,0.28903000D+01
     .,0.39008630D+03,0.278D+03,0.240D+03,0.66669000D+01,0.39106000D+01
     .,0.37742800D+03,0.278D+03,0.241D+03,0.66669000D+01,0.29225000D+01
     .,0.33658580D+03,0.278D+03,0.242D+03,0.66669000D+01,0.11055600D+02
     .,0.29917850D+03,0.278D+03,0.243D+03,0.66669000D+01,0.95402000D+01
     .,0.28351650D+03,0.278D+03,0.244D+03,0.66669000D+01,0.88895000D+01
     .,0.28700770D+03,0.278D+03,0.245D+03,0.66669000D+01,0.29696000D+01
     .,0.29901090D+03,0.278D+03,0.246D+03,0.66669000D+01,0.57095000D+01
     .,0.37493950D+03,0.278D+03,0.249D+03,0.66669000D+01,0.19378000D+01
     .,0.40708260D+03,0.278D+03,0.250D+03,0.66669000D+01,0.19505000D+01
     ./)
      grimme_c6_parameters( 128201: 128300)=(/
     . 0.38634370D+03,0.278D+03,0.251D+03,0.66669000D+01,0.19523000D+01
     .,0.37446930D+03,0.278D+03,0.252D+03,0.66669000D+01,0.19639000D+01
     .,0.48236480D+03,0.278D+03,0.256D+03,0.66669000D+01,0.18467000D+01
     .,0.50153880D+03,0.278D+03,0.257D+03,0.66669000D+01,0.29175000D+01
     .,0.37491100D+03,0.278D+03,0.272D+03,0.66669000D+01,0.38840000D+01
     .,0.39079260D+03,0.278D+03,0.273D+03,0.66669000D+01,0.28988000D+01
     .,0.36580820D+03,0.278D+03,0.274D+03,0.66669000D+01,0.10915300D+02
     .,0.33438680D+03,0.278D+03,0.275D+03,0.66669000D+01,0.98054000D+01
     .,0.31617560D+03,0.278D+03,0.276D+03,0.66669000D+01,0.91527000D+01
     .,0.32076260D+03,0.278D+03,0.277D+03,0.66669000D+01,0.29424000D+01
     .,0.33687270D+03,0.278D+03,0.278D+03,0.66669000D+01,0.66669000D+01
     .,0.37640700D+02,0.281D+03,0.100D+01,0.19302000D+01,0.91180000D+00
     .,0.25087500D+02,0.281D+03,0.200D+01,0.19302000D+01,0.00000000D+00
     .,0.58487960D+03,0.281D+03,0.300D+01,0.19302000D+01,0.00000000D+00
     .,0.33672920D+03,0.281D+03,0.400D+01,0.19302000D+01,0.00000000D+00
     .,0.22693930D+03,0.281D+03,0.500D+01,0.19302000D+01,0.00000000D+00
     .,0.15370200D+03,0.281D+03,0.600D+01,0.19302000D+01,0.00000000D+00
     .,0.10786020D+03,0.281D+03,0.700D+01,0.19302000D+01,0.00000000D+00
     .,0.81954700D+02,0.281D+03,0.800D+01,0.19302000D+01,0.00000000D+00
     .,0.62331700D+02,0.281D+03,0.900D+01,0.19302000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 128301: 128400)=(/
     . 0.48136800D+02,0.281D+03,0.100D+02,0.19302000D+01,0.00000000D+00
     .,0.69957010D+03,0.281D+03,0.110D+02,0.19302000D+01,0.00000000D+00
     .,0.53690060D+03,0.281D+03,0.120D+02,0.19302000D+01,0.00000000D+00
     .,0.49477230D+03,0.281D+03,0.130D+02,0.19302000D+01,0.00000000D+00
     .,0.38992290D+03,0.281D+03,0.140D+02,0.19302000D+01,0.00000000D+00
     .,0.30437830D+03,0.281D+03,0.150D+02,0.19302000D+01,0.00000000D+00
     .,0.25298030D+03,0.281D+03,0.160D+02,0.19302000D+01,0.00000000D+00
     .,0.20704280D+03,0.281D+03,0.170D+02,0.19302000D+01,0.00000000D+00
     .,0.16977090D+03,0.281D+03,0.180D+02,0.19302000D+01,0.00000000D+00
     .,0.11488307D+04,0.281D+03,0.190D+02,0.19302000D+01,0.00000000D+00
     .,0.94494750D+03,0.281D+03,0.200D+02,0.19302000D+01,0.00000000D+00
     .,0.78031190D+03,0.281D+03,0.210D+02,0.19302000D+01,0.00000000D+00
     .,0.75356620D+03,0.281D+03,0.220D+02,0.19302000D+01,0.00000000D+00
     .,0.69006660D+03,0.281D+03,0.230D+02,0.19302000D+01,0.00000000D+00
     .,0.54417950D+03,0.281D+03,0.240D+02,0.19302000D+01,0.00000000D+00
     .,0.59417250D+03,0.281D+03,0.250D+02,0.19302000D+01,0.00000000D+00
     .,0.46687620D+03,0.281D+03,0.260D+02,0.19302000D+01,0.00000000D+00
     .,0.49428940D+03,0.281D+03,0.270D+02,0.19302000D+01,0.00000000D+00
     .,0.50915080D+03,0.281D+03,0.280D+02,0.19302000D+01,0.00000000D+00
     .,0.39094350D+03,0.281D+03,0.290D+02,0.19302000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 128401: 128500)=(/
     . 0.40086460D+03,0.281D+03,0.300D+02,0.19302000D+01,0.00000000D+00
     .,0.47436550D+03,0.281D+03,0.310D+02,0.19302000D+01,0.00000000D+00
     .,0.41828000D+03,0.281D+03,0.320D+02,0.19302000D+01,0.00000000D+00
     .,0.35698080D+03,0.281D+03,0.330D+02,0.19302000D+01,0.00000000D+00
     .,0.32059210D+03,0.281D+03,0.340D+02,0.19302000D+01,0.00000000D+00
     .,0.28090020D+03,0.281D+03,0.350D+02,0.19302000D+01,0.00000000D+00
     .,0.24465900D+03,0.281D+03,0.360D+02,0.19302000D+01,0.00000000D+00
     .,0.12877826D+04,0.281D+03,0.370D+02,0.19302000D+01,0.00000000D+00
     .,0.11263391D+04,0.281D+03,0.380D+02,0.19302000D+01,0.00000000D+00
     .,0.98598710D+03,0.281D+03,0.390D+02,0.19302000D+01,0.00000000D+00
     .,0.88600180D+03,0.281D+03,0.400D+02,0.19302000D+01,0.00000000D+00
     .,0.80798210D+03,0.281D+03,0.410D+02,0.19302000D+01,0.00000000D+00
     .,0.62423380D+03,0.281D+03,0.420D+02,0.19302000D+01,0.00000000D+00
     .,0.69629870D+03,0.281D+03,0.430D+02,0.19302000D+01,0.00000000D+00
     .,0.53092790D+03,0.281D+03,0.440D+02,0.19302000D+01,0.00000000D+00
     .,0.57990290D+03,0.281D+03,0.450D+02,0.19302000D+01,0.00000000D+00
     .,0.53785540D+03,0.281D+03,0.460D+02,0.19302000D+01,0.00000000D+00
     .,0.44915460D+03,0.281D+03,0.470D+02,0.19302000D+01,0.00000000D+00
     .,0.47410150D+03,0.281D+03,0.480D+02,0.19302000D+01,0.00000000D+00
     .,0.59460280D+03,0.281D+03,0.490D+02,0.19302000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 128501: 128600)=(/
     . 0.54954150D+03,0.281D+03,0.500D+02,0.19302000D+01,0.00000000D+00
     .,0.48978390D+03,0.281D+03,0.510D+02,0.19302000D+01,0.00000000D+00
     .,0.45457430D+03,0.281D+03,0.520D+02,0.19302000D+01,0.00000000D+00
     .,0.41127480D+03,0.281D+03,0.530D+02,0.19302000D+01,0.00000000D+00
     .,0.37008590D+03,0.281D+03,0.540D+02,0.19302000D+01,0.00000000D+00
     .,0.15690757D+04,0.281D+03,0.550D+02,0.19302000D+01,0.00000000D+00
     .,0.14367682D+04,0.281D+03,0.560D+02,0.19302000D+01,0.00000000D+00
     .,0.12612174D+04,0.281D+03,0.570D+02,0.19302000D+01,0.00000000D+00
     .,0.57883370D+03,0.281D+03,0.580D+02,0.19302000D+01,0.27991000D+01
     .,0.12731210D+04,0.281D+03,0.590D+02,0.19302000D+01,0.00000000D+00
     .,0.12222593D+04,0.281D+03,0.600D+02,0.19302000D+01,0.00000000D+00
     .,0.11915365D+04,0.281D+03,0.610D+02,0.19302000D+01,0.00000000D+00
     .,0.11632807D+04,0.281D+03,0.620D+02,0.19302000D+01,0.00000000D+00
     .,0.11382189D+04,0.281D+03,0.630D+02,0.19302000D+01,0.00000000D+00
     .,0.89497400D+03,0.281D+03,0.640D+02,0.19302000D+01,0.00000000D+00
     .,0.10093816D+04,0.281D+03,0.650D+02,0.19302000D+01,0.00000000D+00
     .,0.97340780D+03,0.281D+03,0.660D+02,0.19302000D+01,0.00000000D+00
     .,0.10263420D+04,0.281D+03,0.670D+02,0.19302000D+01,0.00000000D+00
     .,0.10045056D+04,0.281D+03,0.680D+02,0.19302000D+01,0.00000000D+00
     .,0.98480680D+03,0.281D+03,0.690D+02,0.19302000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 128601: 128700)=(/
     . 0.97327760D+03,0.281D+03,0.700D+02,0.19302000D+01,0.00000000D+00
     .,0.81998780D+03,0.281D+03,0.710D+02,0.19302000D+01,0.00000000D+00
     .,0.80559300D+03,0.281D+03,0.720D+02,0.19302000D+01,0.00000000D+00
     .,0.73521850D+03,0.281D+03,0.730D+02,0.19302000D+01,0.00000000D+00
     .,0.62134250D+03,0.281D+03,0.740D+02,0.19302000D+01,0.00000000D+00
     .,0.63198300D+03,0.281D+03,0.750D+02,0.19302000D+01,0.00000000D+00
     .,0.57293310D+03,0.281D+03,0.760D+02,0.19302000D+01,0.00000000D+00
     .,0.52489900D+03,0.281D+03,0.770D+02,0.19302000D+01,0.00000000D+00
     .,0.43657950D+03,0.281D+03,0.780D+02,0.19302000D+01,0.00000000D+00
     .,0.40812070D+03,0.281D+03,0.790D+02,0.19302000D+01,0.00000000D+00
     .,0.41966530D+03,0.281D+03,0.800D+02,0.19302000D+01,0.00000000D+00
     .,0.61117330D+03,0.281D+03,0.810D+02,0.19302000D+01,0.00000000D+00
     .,0.59712280D+03,0.281D+03,0.820D+02,0.19302000D+01,0.00000000D+00
     .,0.54862180D+03,0.281D+03,0.830D+02,0.19302000D+01,0.00000000D+00
     .,0.52330660D+03,0.281D+03,0.840D+02,0.19302000D+01,0.00000000D+00
     .,0.48315870D+03,0.281D+03,0.850D+02,0.19302000D+01,0.00000000D+00
     .,0.44313040D+03,0.281D+03,0.860D+02,0.19302000D+01,0.00000000D+00
     .,0.14804889D+04,0.281D+03,0.870D+02,0.19302000D+01,0.00000000D+00
     .,0.14202956D+04,0.281D+03,0.880D+02,0.19302000D+01,0.00000000D+00
     .,0.12546279D+04,0.281D+03,0.890D+02,0.19302000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 128701: 128800)=(/
     . 0.11272570D+04,0.281D+03,0.900D+02,0.19302000D+01,0.00000000D+00
     .,0.11199568D+04,0.281D+03,0.910D+02,0.19302000D+01,0.00000000D+00
     .,0.10844785D+04,0.281D+03,0.920D+02,0.19302000D+01,0.00000000D+00
     .,0.11170554D+04,0.281D+03,0.930D+02,0.19302000D+01,0.00000000D+00
     .,0.10816612D+04,0.281D+03,0.940D+02,0.19302000D+01,0.00000000D+00
     .,0.60479200D+02,0.281D+03,0.101D+03,0.19302000D+01,0.00000000D+00
     .,0.19581130D+03,0.281D+03,0.103D+03,0.19302000D+01,0.98650000D+00
     .,0.24984400D+03,0.281D+03,0.104D+03,0.19302000D+01,0.98080000D+00
     .,0.19103520D+03,0.281D+03,0.105D+03,0.19302000D+01,0.97060000D+00
     .,0.14423770D+03,0.281D+03,0.106D+03,0.19302000D+01,0.98680000D+00
     .,0.10063880D+03,0.281D+03,0.107D+03,0.19302000D+01,0.99440000D+00
     .,0.73584100D+02,0.281D+03,0.108D+03,0.19302000D+01,0.99250000D+00
     .,0.50930700D+02,0.281D+03,0.109D+03,0.19302000D+01,0.99820000D+00
     .,0.28655560D+03,0.281D+03,0.111D+03,0.19302000D+01,0.96840000D+00
     .,0.44298480D+03,0.281D+03,0.112D+03,0.19302000D+01,0.96280000D+00
     .,0.44845700D+03,0.281D+03,0.113D+03,0.19302000D+01,0.96480000D+00
     .,0.36047340D+03,0.281D+03,0.114D+03,0.19302000D+01,0.95070000D+00
     .,0.29550270D+03,0.281D+03,0.115D+03,0.19302000D+01,0.99470000D+00
     .,0.25021530D+03,0.281D+03,0.116D+03,0.19302000D+01,0.99480000D+00
     .,0.20491230D+03,0.281D+03,0.117D+03,0.19302000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters( 128801: 128900)=(/
     . 0.39586240D+03,0.281D+03,0.119D+03,0.19302000D+01,0.97670000D+00
     .,0.75678810D+03,0.281D+03,0.120D+03,0.19302000D+01,0.98310000D+00
     .,0.39555800D+03,0.281D+03,0.121D+03,0.19302000D+01,0.18627000D+01
     .,0.38199770D+03,0.281D+03,0.122D+03,0.19302000D+01,0.18299000D+01
     .,0.37441990D+03,0.281D+03,0.123D+03,0.19302000D+01,0.19138000D+01
     .,0.37101600D+03,0.281D+03,0.124D+03,0.19302000D+01,0.18269000D+01
     .,0.34129280D+03,0.281D+03,0.125D+03,0.19302000D+01,0.16406000D+01
     .,0.31596540D+03,0.281D+03,0.126D+03,0.19302000D+01,0.16483000D+01
     .,0.30149960D+03,0.281D+03,0.127D+03,0.19302000D+01,0.17149000D+01
     .,0.29478150D+03,0.281D+03,0.128D+03,0.19302000D+01,0.17937000D+01
     .,0.29134120D+03,0.281D+03,0.129D+03,0.19302000D+01,0.95760000D+00
     .,0.27325060D+03,0.281D+03,0.130D+03,0.19302000D+01,0.19419000D+01
     .,0.44554260D+03,0.281D+03,0.131D+03,0.19302000D+01,0.96010000D+00
     .,0.39138140D+03,0.281D+03,0.132D+03,0.19302000D+01,0.94340000D+00
     .,0.35096110D+03,0.281D+03,0.133D+03,0.19302000D+01,0.98890000D+00
     .,0.32072380D+03,0.281D+03,0.134D+03,0.19302000D+01,0.99010000D+00
     .,0.28284750D+03,0.281D+03,0.135D+03,0.19302000D+01,0.99740000D+00
     .,0.47250610D+03,0.281D+03,0.137D+03,0.19302000D+01,0.97380000D+00
     .,0.92136230D+03,0.281D+03,0.138D+03,0.19302000D+01,0.98010000D+00
     .,0.70355580D+03,0.281D+03,0.139D+03,0.19302000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters( 128901: 129000)=(/
     . 0.52340250D+03,0.281D+03,0.140D+03,0.19302000D+01,0.19355000D+01
     .,0.52863200D+03,0.281D+03,0.141D+03,0.19302000D+01,0.19545000D+01
     .,0.49314640D+03,0.281D+03,0.142D+03,0.19302000D+01,0.19420000D+01
     .,0.55329240D+03,0.281D+03,0.143D+03,0.19302000D+01,0.16682000D+01
     .,0.43004960D+03,0.281D+03,0.144D+03,0.19302000D+01,0.18584000D+01
     .,0.40251430D+03,0.281D+03,0.145D+03,0.19302000D+01,0.19003000D+01
     .,0.37395490D+03,0.281D+03,0.146D+03,0.19302000D+01,0.18630000D+01
     .,0.36182100D+03,0.281D+03,0.147D+03,0.19302000D+01,0.96790000D+00
     .,0.35776620D+03,0.281D+03,0.148D+03,0.19302000D+01,0.19539000D+01
     .,0.56674250D+03,0.281D+03,0.149D+03,0.19302000D+01,0.96330000D+00
     .,0.51255600D+03,0.281D+03,0.150D+03,0.19302000D+01,0.95140000D+00
     .,0.48004840D+03,0.281D+03,0.151D+03,0.19302000D+01,0.97490000D+00
     .,0.45424350D+03,0.281D+03,0.152D+03,0.19302000D+01,0.98110000D+00
     .,0.41511430D+03,0.281D+03,0.153D+03,0.19302000D+01,0.99680000D+00
     .,0.55834700D+03,0.281D+03,0.155D+03,0.19302000D+01,0.99090000D+00
     .,0.11954806D+04,0.281D+03,0.156D+03,0.19302000D+01,0.97970000D+00
     .,0.89067110D+03,0.281D+03,0.157D+03,0.19302000D+01,0.19373000D+01
     .,0.56141900D+03,0.281D+03,0.159D+03,0.19302000D+01,0.29425000D+01
     .,0.54982120D+03,0.281D+03,0.160D+03,0.19302000D+01,0.29455000D+01
     .,0.53242950D+03,0.281D+03,0.161D+03,0.19302000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters( 129001: 129100)=(/
     . 0.53504270D+03,0.281D+03,0.162D+03,0.19302000D+01,0.29300000D+01
     .,0.51592290D+03,0.281D+03,0.163D+03,0.19302000D+01,0.18286000D+01
     .,0.53831350D+03,0.281D+03,0.164D+03,0.19302000D+01,0.28732000D+01
     .,0.50569480D+03,0.281D+03,0.165D+03,0.19302000D+01,0.29086000D+01
     .,0.51458640D+03,0.281D+03,0.166D+03,0.19302000D+01,0.28965000D+01
     .,0.47998260D+03,0.281D+03,0.167D+03,0.19302000D+01,0.29242000D+01
     .,0.46631110D+03,0.281D+03,0.168D+03,0.19302000D+01,0.29282000D+01
     .,0.46329610D+03,0.281D+03,0.169D+03,0.19302000D+01,0.29246000D+01
     .,0.48680100D+03,0.281D+03,0.170D+03,0.19302000D+01,0.28482000D+01
     .,0.44777810D+03,0.281D+03,0.171D+03,0.19302000D+01,0.29219000D+01
     .,0.60670050D+03,0.281D+03,0.172D+03,0.19302000D+01,0.19254000D+01
     .,0.56315480D+03,0.281D+03,0.173D+03,0.19302000D+01,0.19459000D+01
     .,0.51397290D+03,0.281D+03,0.174D+03,0.19302000D+01,0.19292000D+01
     .,0.52014190D+03,0.281D+03,0.175D+03,0.19302000D+01,0.18104000D+01
     .,0.45549230D+03,0.281D+03,0.176D+03,0.19302000D+01,0.18858000D+01
     .,0.42873640D+03,0.281D+03,0.177D+03,0.19302000D+01,0.18648000D+01
     .,0.40967910D+03,0.281D+03,0.178D+03,0.19302000D+01,0.19188000D+01
     .,0.39187930D+03,0.281D+03,0.179D+03,0.19302000D+01,0.98460000D+00
     .,0.37862560D+03,0.281D+03,0.180D+03,0.19302000D+01,0.19896000D+01
     .,0.60907890D+03,0.281D+03,0.181D+03,0.19302000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters( 129101: 129200)=(/
     . 0.55494180D+03,0.281D+03,0.182D+03,0.19302000D+01,0.93830000D+00
     .,0.53810030D+03,0.281D+03,0.183D+03,0.19302000D+01,0.98200000D+00
     .,0.52340750D+03,0.281D+03,0.184D+03,0.19302000D+01,0.98150000D+00
     .,0.48896760D+03,0.281D+03,0.185D+03,0.19302000D+01,0.99540000D+00
     .,0.62876220D+03,0.281D+03,0.187D+03,0.19302000D+01,0.97050000D+00
     .,0.11883406D+04,0.281D+03,0.188D+03,0.19302000D+01,0.96620000D+00
     .,0.66419980D+03,0.281D+03,0.189D+03,0.19302000D+01,0.29070000D+01
     .,0.76713680D+03,0.281D+03,0.190D+03,0.19302000D+01,0.28844000D+01
     .,0.68633050D+03,0.281D+03,0.191D+03,0.19302000D+01,0.28738000D+01
     .,0.60632050D+03,0.281D+03,0.192D+03,0.19302000D+01,0.28878000D+01
     .,0.58350520D+03,0.281D+03,0.193D+03,0.19302000D+01,0.29095000D+01
     .,0.70242340D+03,0.281D+03,0.194D+03,0.19302000D+01,0.19209000D+01
     .,0.16303250D+03,0.281D+03,0.204D+03,0.19302000D+01,0.19697000D+01
     .,0.16051470D+03,0.281D+03,0.205D+03,0.19302000D+01,0.19441000D+01
     .,0.11775890D+03,0.281D+03,0.206D+03,0.19302000D+01,0.19985000D+01
     .,0.94561900D+02,0.281D+03,0.207D+03,0.19302000D+01,0.20143000D+01
     .,0.65054900D+02,0.281D+03,0.208D+03,0.19302000D+01,0.19887000D+01
     .,0.28915800D+03,0.281D+03,0.212D+03,0.19302000D+01,0.19496000D+01
     .,0.34950920D+03,0.281D+03,0.213D+03,0.19302000D+01,0.19311000D+01
     .,0.33534010D+03,0.281D+03,0.214D+03,0.19302000D+01,0.19435000D+01
     ./)
      grimme_c6_parameters( 129201: 129300)=(/
     . 0.29153890D+03,0.281D+03,0.215D+03,0.19302000D+01,0.20102000D+01
     .,0.24518670D+03,0.281D+03,0.216D+03,0.19302000D+01,0.19903000D+01
     .,0.40606400D+03,0.281D+03,0.220D+03,0.19302000D+01,0.19349000D+01
     .,0.39020820D+03,0.281D+03,0.221D+03,0.19302000D+01,0.28999000D+01
     .,0.39504660D+03,0.281D+03,0.222D+03,0.19302000D+01,0.38675000D+01
     .,0.36178060D+03,0.281D+03,0.223D+03,0.19302000D+01,0.29110000D+01
     .,0.27298940D+03,0.281D+03,0.224D+03,0.19302000D+01,0.10619100D+02
     .,0.23378110D+03,0.281D+03,0.225D+03,0.19302000D+01,0.98849000D+01
     .,0.22948940D+03,0.281D+03,0.226D+03,0.19302000D+01,0.91376000D+01
     .,0.26871310D+03,0.281D+03,0.227D+03,0.19302000D+01,0.29263000D+01
     .,0.25040430D+03,0.281D+03,0.228D+03,0.19302000D+01,0.65458000D+01
     .,0.35311120D+03,0.281D+03,0.231D+03,0.19302000D+01,0.19315000D+01
     .,0.37266030D+03,0.281D+03,0.232D+03,0.19302000D+01,0.19447000D+01
     .,0.34178700D+03,0.281D+03,0.233D+03,0.19302000D+01,0.19793000D+01
     .,0.31822560D+03,0.281D+03,0.234D+03,0.19302000D+01,0.19812000D+01
     .,0.48670590D+03,0.281D+03,0.238D+03,0.19302000D+01,0.19143000D+01
     .,0.46832670D+03,0.281D+03,0.239D+03,0.19302000D+01,0.28903000D+01
     .,0.47237120D+03,0.281D+03,0.240D+03,0.19302000D+01,0.39106000D+01
     .,0.45708930D+03,0.281D+03,0.241D+03,0.19302000D+01,0.29225000D+01
     .,0.40445180D+03,0.281D+03,0.242D+03,0.19302000D+01,0.11055600D+02
     ./)
      grimme_c6_parameters( 129301: 129400)=(/
     . 0.35727900D+03,0.281D+03,0.243D+03,0.19302000D+01,0.95402000D+01
     .,0.33777820D+03,0.281D+03,0.244D+03,0.19302000D+01,0.88895000D+01
     .,0.34411230D+03,0.281D+03,0.245D+03,0.19302000D+01,0.29696000D+01
     .,0.35934930D+03,0.281D+03,0.246D+03,0.19302000D+01,0.57095000D+01
     .,0.45622010D+03,0.281D+03,0.249D+03,0.19302000D+01,0.19378000D+01
     .,0.49554180D+03,0.281D+03,0.250D+03,0.19302000D+01,0.19505000D+01
     .,0.46689650D+03,0.281D+03,0.251D+03,0.19302000D+01,0.19523000D+01
     .,0.45057090D+03,0.281D+03,0.252D+03,0.19302000D+01,0.19639000D+01
     .,0.58874480D+03,0.281D+03,0.256D+03,0.19302000D+01,0.18467000D+01
     .,0.60988230D+03,0.281D+03,0.257D+03,0.19302000D+01,0.29175000D+01
     .,0.45235490D+03,0.281D+03,0.272D+03,0.19302000D+01,0.38840000D+01
     .,0.47275440D+03,0.281D+03,0.273D+03,0.19302000D+01,0.28988000D+01
     .,0.43936980D+03,0.281D+03,0.274D+03,0.19302000D+01,0.10915300D+02
     .,0.39936360D+03,0.281D+03,0.275D+03,0.19302000D+01,0.98054000D+01
     .,0.37591510D+03,0.281D+03,0.276D+03,0.19302000D+01,0.91527000D+01
     .,0.38338850D+03,0.281D+03,0.277D+03,0.19302000D+01,0.29424000D+01
     .,0.40305640D+03,0.281D+03,0.278D+03,0.19302000D+01,0.66669000D+01
     .,0.48774180D+03,0.281D+03,0.281D+03,0.19302000D+01,0.19302000D+01
     .,0.39792200D+02,0.282D+03,0.100D+01,0.19356000D+01,0.91180000D+00
     .,0.26446700D+02,0.282D+03,0.200D+01,0.19356000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 129401: 129500)=(/
     . 0.61488410D+03,0.282D+03,0.300D+01,0.19356000D+01,0.00000000D+00
     .,0.35582050D+03,0.282D+03,0.400D+01,0.19356000D+01,0.00000000D+00
     .,0.24002620D+03,0.282D+03,0.500D+01,0.19356000D+01,0.00000000D+00
     .,0.16250360D+03,0.282D+03,0.600D+01,0.19356000D+01,0.00000000D+00
     .,0.11392620D+03,0.282D+03,0.700D+01,0.19356000D+01,0.00000000D+00
     .,0.86471200D+02,0.282D+03,0.800D+01,0.19356000D+01,0.00000000D+00
     .,0.65688800D+02,0.282D+03,0.900D+01,0.19356000D+01,0.00000000D+00
     .,0.50670700D+02,0.282D+03,0.100D+02,0.19356000D+01,0.00000000D+00
     .,0.73557820D+03,0.282D+03,0.110D+02,0.19356000D+01,0.00000000D+00
     .,0.56688720D+03,0.282D+03,0.120D+02,0.19356000D+01,0.00000000D+00
     .,0.52287510D+03,0.282D+03,0.130D+02,0.19356000D+01,0.00000000D+00
     .,0.41241080D+03,0.282D+03,0.140D+02,0.19356000D+01,0.00000000D+00
     .,0.32196130D+03,0.282D+03,0.150D+02,0.19356000D+01,0.00000000D+00
     .,0.26749610D+03,0.282D+03,0.160D+02,0.19356000D+01,0.00000000D+00
     .,0.21879400D+03,0.282D+03,0.170D+02,0.19356000D+01,0.00000000D+00
     .,0.17927010D+03,0.282D+03,0.180D+02,0.19356000D+01,0.00000000D+00
     .,0.12058672D+04,0.282D+03,0.190D+02,0.19356000D+01,0.00000000D+00
     .,0.99578930D+03,0.282D+03,0.200D+02,0.19356000D+01,0.00000000D+00
     .,0.82287620D+03,0.282D+03,0.210D+02,0.19356000D+01,0.00000000D+00
     .,0.79494560D+03,0.282D+03,0.220D+02,0.19356000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 129501: 129600)=(/
     . 0.72813060D+03,0.282D+03,0.230D+02,0.19356000D+01,0.00000000D+00
     .,0.57390570D+03,0.282D+03,0.240D+02,0.19356000D+01,0.00000000D+00
     .,0.62713920D+03,0.282D+03,0.250D+02,0.19356000D+01,0.00000000D+00
     .,0.49253590D+03,0.282D+03,0.260D+02,0.19356000D+01,0.00000000D+00
     .,0.52201020D+03,0.282D+03,0.270D+02,0.19356000D+01,0.00000000D+00
     .,0.53761470D+03,0.282D+03,0.280D+02,0.19356000D+01,0.00000000D+00
     .,0.41250160D+03,0.282D+03,0.290D+02,0.19356000D+01,0.00000000D+00
     .,0.42350910D+03,0.282D+03,0.300D+02,0.19356000D+01,0.00000000D+00
     .,0.50121030D+03,0.282D+03,0.310D+02,0.19356000D+01,0.00000000D+00
     .,0.44228050D+03,0.282D+03,0.320D+02,0.19356000D+01,0.00000000D+00
     .,0.37753680D+03,0.282D+03,0.330D+02,0.19356000D+01,0.00000000D+00
     .,0.33899500D+03,0.282D+03,0.340D+02,0.19356000D+01,0.00000000D+00
     .,0.29691970D+03,0.282D+03,0.350D+02,0.19356000D+01,0.00000000D+00
     .,0.25848000D+03,0.282D+03,0.360D+02,0.19356000D+01,0.00000000D+00
     .,0.13518089D+04,0.282D+03,0.370D+02,0.19356000D+01,0.00000000D+00
     .,0.11865298D+04,0.282D+03,0.380D+02,0.19356000D+01,0.00000000D+00
     .,0.10397874D+04,0.282D+03,0.390D+02,0.19356000D+01,0.00000000D+00
     .,0.93482320D+03,0.282D+03,0.400D+02,0.19356000D+01,0.00000000D+00
     .,0.85268980D+03,0.282D+03,0.410D+02,0.19356000D+01,0.00000000D+00
     .,0.65880460D+03,0.282D+03,0.420D+02,0.19356000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 129601: 129700)=(/
     . 0.73487030D+03,0.282D+03,0.430D+02,0.19356000D+01,0.00000000D+00
     .,0.56035040D+03,0.282D+03,0.440D+02,0.19356000D+01,0.00000000D+00
     .,0.61229710D+03,0.282D+03,0.450D+02,0.19356000D+01,0.00000000D+00
     .,0.56795070D+03,0.282D+03,0.460D+02,0.19356000D+01,0.00000000D+00
     .,0.47388930D+03,0.282D+03,0.470D+02,0.19356000D+01,0.00000000D+00
     .,0.50066290D+03,0.282D+03,0.480D+02,0.19356000D+01,0.00000000D+00
     .,0.62779210D+03,0.282D+03,0.490D+02,0.19356000D+01,0.00000000D+00
     .,0.58070530D+03,0.282D+03,0.500D+02,0.19356000D+01,0.00000000D+00
     .,0.51776630D+03,0.282D+03,0.510D+02,0.19356000D+01,0.00000000D+00
     .,0.48056780D+03,0.282D+03,0.520D+02,0.19356000D+01,0.00000000D+00
     .,0.43474640D+03,0.282D+03,0.530D+02,0.19356000D+01,0.00000000D+00
     .,0.39110730D+03,0.282D+03,0.540D+02,0.19356000D+01,0.00000000D+00
     .,0.16469053D+04,0.282D+03,0.550D+02,0.19356000D+01,0.00000000D+00
     .,0.15126316D+04,0.282D+03,0.560D+02,0.19356000D+01,0.00000000D+00
     .,0.13293437D+04,0.282D+03,0.570D+02,0.19356000D+01,0.00000000D+00
     .,0.61169810D+03,0.282D+03,0.580D+02,0.19356000D+01,0.27991000D+01
     .,0.13407087D+04,0.282D+03,0.590D+02,0.19356000D+01,0.00000000D+00
     .,0.12874426D+04,0.282D+03,0.600D+02,0.19356000D+01,0.00000000D+00
     .,0.12551651D+04,0.282D+03,0.610D+02,0.19356000D+01,0.00000000D+00
     .,0.12254747D+04,0.282D+03,0.620D+02,0.19356000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 129701: 129800)=(/
     . 0.11991443D+04,0.282D+03,0.630D+02,0.19356000D+01,0.00000000D+00
     .,0.94362380D+03,0.282D+03,0.640D+02,0.19356000D+01,0.00000000D+00
     .,0.10620589D+04,0.282D+03,0.650D+02,0.19356000D+01,0.00000000D+00
     .,0.10244069D+04,0.282D+03,0.660D+02,0.19356000D+01,0.00000000D+00
     .,0.10816382D+04,0.282D+03,0.670D+02,0.19356000D+01,0.00000000D+00
     .,0.10586802D+04,0.282D+03,0.680D+02,0.19356000D+01,0.00000000D+00
     .,0.10379814D+04,0.282D+03,0.690D+02,0.19356000D+01,0.00000000D+00
     .,0.10258078D+04,0.282D+03,0.700D+02,0.19356000D+01,0.00000000D+00
     .,0.86471680D+03,0.282D+03,0.710D+02,0.19356000D+01,0.00000000D+00
     .,0.85048450D+03,0.282D+03,0.720D+02,0.19356000D+01,0.00000000D+00
     .,0.77645220D+03,0.282D+03,0.730D+02,0.19356000D+01,0.00000000D+00
     .,0.65606950D+03,0.282D+03,0.740D+02,0.19356000D+01,0.00000000D+00
     .,0.66747630D+03,0.282D+03,0.750D+02,0.19356000D+01,0.00000000D+00
     .,0.60520260D+03,0.282D+03,0.760D+02,0.19356000D+01,0.00000000D+00
     .,0.55449180D+03,0.282D+03,0.770D+02,0.19356000D+01,0.00000000D+00
     .,0.46101730D+03,0.282D+03,0.780D+02,0.19356000D+01,0.00000000D+00
     .,0.43090160D+03,0.282D+03,0.790D+02,0.19356000D+01,0.00000000D+00
     .,0.44323910D+03,0.282D+03,0.800D+02,0.19356000D+01,0.00000000D+00
     .,0.64499260D+03,0.282D+03,0.810D+02,0.19356000D+01,0.00000000D+00
     .,0.63069680D+03,0.282D+03,0.820D+02,0.19356000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 129801: 129900)=(/
     . 0.57974990D+03,0.282D+03,0.830D+02,0.19356000D+01,0.00000000D+00
     .,0.55307510D+03,0.282D+03,0.840D+02,0.19356000D+01,0.00000000D+00
     .,0.51064800D+03,0.282D+03,0.850D+02,0.19356000D+01,0.00000000D+00
     .,0.46827350D+03,0.282D+03,0.860D+02,0.19356000D+01,0.00000000D+00
     .,0.15554213D+04,0.282D+03,0.870D+02,0.19356000D+01,0.00000000D+00
     .,0.14960560D+04,0.282D+03,0.880D+02,0.19356000D+01,0.00000000D+00
     .,0.13229452D+04,0.282D+03,0.890D+02,0.19356000D+01,0.00000000D+00
     .,0.11895930D+04,0.282D+03,0.900D+02,0.19356000D+01,0.00000000D+00
     .,0.11810895D+04,0.282D+03,0.910D+02,0.19356000D+01,0.00000000D+00
     .,0.11436704D+04,0.282D+03,0.920D+02,0.19356000D+01,0.00000000D+00
     .,0.11773166D+04,0.282D+03,0.930D+02,0.19356000D+01,0.00000000D+00
     .,0.11401626D+04,0.282D+03,0.940D+02,0.19356000D+01,0.00000000D+00
     .,0.63979600D+02,0.282D+03,0.101D+03,0.19356000D+01,0.00000000D+00
     .,0.20691270D+03,0.282D+03,0.103D+03,0.19356000D+01,0.98650000D+00
     .,0.26400830D+03,0.282D+03,0.104D+03,0.19356000D+01,0.98080000D+00
     .,0.20201910D+03,0.282D+03,0.105D+03,0.19356000D+01,0.97060000D+00
     .,0.15244950D+03,0.282D+03,0.106D+03,0.19356000D+01,0.98680000D+00
     .,0.10626350D+03,0.282D+03,0.107D+03,0.19356000D+01,0.99440000D+00
     .,0.77602400D+02,0.282D+03,0.108D+03,0.19356000D+01,0.99250000D+00
     .,0.53610900D+02,0.282D+03,0.109D+03,0.19356000D+01,0.99820000D+00
     ./)
      grimme_c6_parameters( 129901: 130000)=(/
     . 0.30258820D+03,0.282D+03,0.111D+03,0.19356000D+01,0.96840000D+00
     .,0.46775760D+03,0.282D+03,0.112D+03,0.19356000D+01,0.96280000D+00
     .,0.47397540D+03,0.282D+03,0.113D+03,0.19356000D+01,0.96480000D+00
     .,0.38125380D+03,0.282D+03,0.114D+03,0.19356000D+01,0.95070000D+00
     .,0.31255060D+03,0.282D+03,0.115D+03,0.19356000D+01,0.99470000D+00
     .,0.26456000D+03,0.282D+03,0.116D+03,0.19356000D+01,0.99480000D+00
     .,0.21653480D+03,0.282D+03,0.117D+03,0.19356000D+01,0.99720000D+00
     .,0.41774830D+03,0.282D+03,0.119D+03,0.19356000D+01,0.97670000D+00
     .,0.79700090D+03,0.282D+03,0.120D+03,0.19356000D+01,0.98310000D+00
     .,0.41801280D+03,0.282D+03,0.121D+03,0.19356000D+01,0.18627000D+01
     .,0.40362390D+03,0.282D+03,0.122D+03,0.19356000D+01,0.18299000D+01
     .,0.39559060D+03,0.282D+03,0.123D+03,0.19356000D+01,0.19138000D+01
     .,0.39193640D+03,0.282D+03,0.124D+03,0.19356000D+01,0.18269000D+01
     .,0.36075390D+03,0.282D+03,0.125D+03,0.19356000D+01,0.16406000D+01
     .,0.33396980D+03,0.282D+03,0.126D+03,0.19356000D+01,0.16483000D+01
     .,0.31863900D+03,0.282D+03,0.127D+03,0.19356000D+01,0.17149000D+01
     .,0.31152110D+03,0.282D+03,0.128D+03,0.19356000D+01,0.17937000D+01
     .,0.30775700D+03,0.282D+03,0.129D+03,0.19356000D+01,0.95760000D+00
     .,0.28885340D+03,0.282D+03,0.130D+03,0.19356000D+01,0.19419000D+01
     .,0.47083440D+03,0.282D+03,0.131D+03,0.19356000D+01,0.96010000D+00
     ./)
      grimme_c6_parameters( 130001: 130100)=(/
     . 0.41385520D+03,0.282D+03,0.132D+03,0.19356000D+01,0.94340000D+00
     .,0.37116030D+03,0.282D+03,0.133D+03,0.19356000D+01,0.98890000D+00
     .,0.33912820D+03,0.282D+03,0.134D+03,0.19356000D+01,0.99010000D+00
     .,0.29897830D+03,0.282D+03,0.135D+03,0.19356000D+01,0.99740000D+00
     .,0.49860580D+03,0.282D+03,0.137D+03,0.19356000D+01,0.97380000D+00
     .,0.96992320D+03,0.282D+03,0.138D+03,0.19356000D+01,0.98010000D+00
     .,0.74205020D+03,0.282D+03,0.139D+03,0.19356000D+01,0.19153000D+01
     .,0.55289600D+03,0.282D+03,0.140D+03,0.19356000D+01,0.19355000D+01
     .,0.55839300D+03,0.282D+03,0.141D+03,0.19356000D+01,0.19545000D+01
     .,0.52087780D+03,0.282D+03,0.142D+03,0.19356000D+01,0.19420000D+01
     .,0.58393470D+03,0.282D+03,0.143D+03,0.19356000D+01,0.16682000D+01
     .,0.45433520D+03,0.282D+03,0.144D+03,0.19356000D+01,0.18584000D+01
     .,0.42516750D+03,0.282D+03,0.145D+03,0.19356000D+01,0.19003000D+01
     .,0.39494400D+03,0.282D+03,0.146D+03,0.19356000D+01,0.18630000D+01
     .,0.38209250D+03,0.282D+03,0.147D+03,0.19356000D+01,0.96790000D+00
     .,0.37801500D+03,0.282D+03,0.148D+03,0.19356000D+01,0.19539000D+01
     .,0.59852070D+03,0.282D+03,0.149D+03,0.19356000D+01,0.96330000D+00
     .,0.54168720D+03,0.282D+03,0.150D+03,0.19356000D+01,0.95140000D+00
     .,0.50748490D+03,0.282D+03,0.151D+03,0.19356000D+01,0.97490000D+00
     .,0.48022270D+03,0.282D+03,0.152D+03,0.19356000D+01,0.98110000D+00
     ./)
      grimme_c6_parameters( 130101: 130200)=(/
     . 0.43881240D+03,0.282D+03,0.153D+03,0.19356000D+01,0.99680000D+00
     .,0.58960800D+03,0.282D+03,0.155D+03,0.19356000D+01,0.99090000D+00
     .,0.12575693D+04,0.282D+03,0.156D+03,0.19356000D+01,0.97970000D+00
     .,0.93914200D+03,0.282D+03,0.157D+03,0.19356000D+01,0.19373000D+01
     .,0.59329090D+03,0.282D+03,0.159D+03,0.19356000D+01,0.29425000D+01
     .,0.58103250D+03,0.282D+03,0.160D+03,0.19356000D+01,0.29455000D+01
     .,0.56264920D+03,0.282D+03,0.161D+03,0.19356000D+01,0.29413000D+01
     .,0.56536800D+03,0.282D+03,0.162D+03,0.19356000D+01,0.29300000D+01
     .,0.54495840D+03,0.282D+03,0.163D+03,0.19356000D+01,0.18286000D+01
     .,0.56886990D+03,0.282D+03,0.164D+03,0.19356000D+01,0.28732000D+01
     .,0.53439680D+03,0.282D+03,0.165D+03,0.19356000D+01,0.29086000D+01
     .,0.54369520D+03,0.282D+03,0.166D+03,0.19356000D+01,0.28965000D+01
     .,0.50726200D+03,0.282D+03,0.167D+03,0.19356000D+01,0.29242000D+01
     .,0.49282300D+03,0.282D+03,0.168D+03,0.19356000D+01,0.29282000D+01
     .,0.48963950D+03,0.282D+03,0.169D+03,0.19356000D+01,0.29246000D+01
     .,0.51452780D+03,0.282D+03,0.170D+03,0.19356000D+01,0.28482000D+01
     .,0.47326870D+03,0.282D+03,0.171D+03,0.19356000D+01,0.29219000D+01
     .,0.64058910D+03,0.282D+03,0.172D+03,0.19356000D+01,0.19254000D+01
     .,0.59475240D+03,0.282D+03,0.173D+03,0.19356000D+01,0.19459000D+01
     .,0.54291370D+03,0.282D+03,0.174D+03,0.19356000D+01,0.19292000D+01
     ./)
      grimme_c6_parameters( 130201: 130300)=(/
     . 0.54925780D+03,0.282D+03,0.175D+03,0.19356000D+01,0.18104000D+01
     .,0.48124530D+03,0.282D+03,0.176D+03,0.19356000D+01,0.18858000D+01
     .,0.45291160D+03,0.282D+03,0.177D+03,0.19356000D+01,0.18648000D+01
     .,0.43272460D+03,0.282D+03,0.178D+03,0.19356000D+01,0.19188000D+01
     .,0.41382910D+03,0.282D+03,0.179D+03,0.19356000D+01,0.98460000D+00
     .,0.39995160D+03,0.282D+03,0.180D+03,0.19356000D+01,0.19896000D+01
     .,0.64299800D+03,0.282D+03,0.181D+03,0.19356000D+01,0.92670000D+00
     .,0.58628560D+03,0.282D+03,0.182D+03,0.19356000D+01,0.93830000D+00
     .,0.56868040D+03,0.282D+03,0.183D+03,0.19356000D+01,0.98200000D+00
     .,0.55320800D+03,0.282D+03,0.184D+03,0.19356000D+01,0.98150000D+00
     .,0.51680550D+03,0.282D+03,0.185D+03,0.19356000D+01,0.99540000D+00
     .,0.66402220D+03,0.282D+03,0.187D+03,0.19356000D+01,0.97050000D+00
     .,0.12510172D+04,0.282D+03,0.188D+03,0.19356000D+01,0.96620000D+00
     .,0.70195930D+03,0.282D+03,0.189D+03,0.19356000D+01,0.29070000D+01
     .,0.81010680D+03,0.282D+03,0.190D+03,0.19356000D+01,0.28844000D+01
     .,0.72464740D+03,0.282D+03,0.191D+03,0.19356000D+01,0.28738000D+01
     .,0.64054440D+03,0.282D+03,0.192D+03,0.19356000D+01,0.28878000D+01
     .,0.61646960D+03,0.282D+03,0.193D+03,0.19356000D+01,0.29095000D+01
     .,0.74111760D+03,0.282D+03,0.194D+03,0.19356000D+01,0.19209000D+01
     .,0.17249040D+03,0.282D+03,0.204D+03,0.19356000D+01,0.19697000D+01
     ./)
      grimme_c6_parameters( 130301: 130400)=(/
     . 0.16970770D+03,0.282D+03,0.205D+03,0.19356000D+01,0.19441000D+01
     .,0.12443980D+03,0.282D+03,0.206D+03,0.19356000D+01,0.19985000D+01
     .,0.99829400D+02,0.282D+03,0.207D+03,0.19356000D+01,0.20143000D+01
     .,0.68563200D+02,0.282D+03,0.208D+03,0.19356000D+01,0.19887000D+01
     .,0.30583900D+03,0.282D+03,0.212D+03,0.19356000D+01,0.19496000D+01
     .,0.36956280D+03,0.282D+03,0.213D+03,0.19356000D+01,0.19311000D+01
     .,0.35468400D+03,0.282D+03,0.214D+03,0.19356000D+01,0.19435000D+01
     .,0.30832680D+03,0.282D+03,0.215D+03,0.19356000D+01,0.20102000D+01
     .,0.25923020D+03,0.282D+03,0.216D+03,0.19356000D+01,0.19903000D+01
     .,0.42911330D+03,0.282D+03,0.220D+03,0.19356000D+01,0.19349000D+01
     .,0.41249460D+03,0.282D+03,0.221D+03,0.19356000D+01,0.28999000D+01
     .,0.41760390D+03,0.282D+03,0.222D+03,0.19356000D+01,0.38675000D+01
     .,0.38232410D+03,0.282D+03,0.223D+03,0.19356000D+01,0.29110000D+01
     .,0.28838020D+03,0.282D+03,0.224D+03,0.19356000D+01,0.10619100D+02
     .,0.24693330D+03,0.282D+03,0.225D+03,0.19356000D+01,0.98849000D+01
     .,0.24239630D+03,0.282D+03,0.226D+03,0.19356000D+01,0.91376000D+01
     .,0.28387680D+03,0.282D+03,0.227D+03,0.19356000D+01,0.29263000D+01
     .,0.26454680D+03,0.282D+03,0.228D+03,0.19356000D+01,0.65458000D+01
     .,0.37331260D+03,0.282D+03,0.231D+03,0.19356000D+01,0.19315000D+01
     .,0.39406900D+03,0.282D+03,0.232D+03,0.19356000D+01,0.19447000D+01
     ./)
      grimme_c6_parameters( 130401: 130500)=(/
     . 0.36145320D+03,0.282D+03,0.233D+03,0.19356000D+01,0.19793000D+01
     .,0.33647870D+03,0.282D+03,0.234D+03,0.19356000D+01,0.19812000D+01
     .,0.51420470D+03,0.282D+03,0.238D+03,0.19356000D+01,0.19143000D+01
     .,0.49505130D+03,0.282D+03,0.239D+03,0.19356000D+01,0.28903000D+01
     .,0.49936110D+03,0.282D+03,0.240D+03,0.19356000D+01,0.39106000D+01
     .,0.48303860D+03,0.282D+03,0.241D+03,0.19356000D+01,0.29225000D+01
     .,0.42736900D+03,0.282D+03,0.242D+03,0.19356000D+01,0.11055600D+02
     .,0.37746330D+03,0.282D+03,0.243D+03,0.19356000D+01,0.95402000D+01
     .,0.35681920D+03,0.282D+03,0.244D+03,0.19356000D+01,0.88895000D+01
     .,0.36342680D+03,0.282D+03,0.245D+03,0.19356000D+01,0.29696000D+01
     .,0.37957410D+03,0.282D+03,0.246D+03,0.19356000D+01,0.57095000D+01
     .,0.48204630D+03,0.282D+03,0.249D+03,0.19356000D+01,0.19378000D+01
     .,0.52374110D+03,0.282D+03,0.250D+03,0.19356000D+01,0.19505000D+01
     .,0.49359530D+03,0.282D+03,0.251D+03,0.19356000D+01,0.19523000D+01
     .,0.47634340D+03,0.282D+03,0.252D+03,0.19356000D+01,0.19639000D+01
     .,0.62197270D+03,0.282D+03,0.256D+03,0.19356000D+01,0.18467000D+01
     .,0.64464210D+03,0.282D+03,0.257D+03,0.19356000D+01,0.29175000D+01
     .,0.47820960D+03,0.282D+03,0.272D+03,0.19356000D+01,0.38840000D+01
     .,0.49956010D+03,0.282D+03,0.273D+03,0.19356000D+01,0.28988000D+01
     .,0.46428480D+03,0.282D+03,0.274D+03,0.19356000D+01,0.10915300D+02
     ./)
      grimme_c6_parameters( 130501: 130600)=(/
     . 0.42194200D+03,0.282D+03,0.275D+03,0.19356000D+01,0.98054000D+01
     .,0.39711980D+03,0.282D+03,0.276D+03,0.19356000D+01,0.91527000D+01
     .,0.40488970D+03,0.282D+03,0.277D+03,0.19356000D+01,0.29424000D+01
     .,0.42575640D+03,0.282D+03,0.278D+03,0.19356000D+01,0.66669000D+01
     .,0.51525750D+03,0.282D+03,0.281D+03,0.19356000D+01,0.19302000D+01
     .,0.54445630D+03,0.282D+03,0.282D+03,0.19356000D+01,0.19356000D+01
     .,0.40764900D+02,0.283D+03,0.100D+01,0.19655000D+01,0.91180000D+00
     .,0.27174600D+02,0.283D+03,0.200D+01,0.19655000D+01,0.00000000D+00
     .,0.61318280D+03,0.283D+03,0.300D+01,0.19655000D+01,0.00000000D+00
     .,0.35984820D+03,0.283D+03,0.400D+01,0.19655000D+01,0.00000000D+00
     .,0.24435680D+03,0.283D+03,0.500D+01,0.19655000D+01,0.00000000D+00
     .,0.16611890D+03,0.283D+03,0.600D+01,0.19655000D+01,0.00000000D+00
     .,0.11675030D+03,0.283D+03,0.700D+01,0.19655000D+01,0.00000000D+00
     .,0.88739700D+02,0.283D+03,0.800D+01,0.19655000D+01,0.00000000D+00
     .,0.67475000D+02,0.283D+03,0.900D+01,0.19655000D+01,0.00000000D+00
     .,0.52075900D+02,0.283D+03,0.100D+02,0.19655000D+01,0.00000000D+00
     .,0.73412320D+03,0.283D+03,0.110D+02,0.19655000D+01,0.00000000D+00
     .,0.57193110D+03,0.283D+03,0.120D+02,0.19655000D+01,0.00000000D+00
     .,0.52949770D+03,0.283D+03,0.130D+02,0.19655000D+01,0.00000000D+00
     .,0.41959890D+03,0.283D+03,0.140D+02,0.19655000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 130601: 130700)=(/
     . 0.32872910D+03,0.283D+03,0.150D+02,0.19655000D+01,0.00000000D+00
     .,0.27365740D+03,0.283D+03,0.160D+02,0.19655000D+01,0.00000000D+00
     .,0.22421020D+03,0.283D+03,0.170D+02,0.19655000D+01,0.00000000D+00
     .,0.18393680D+03,0.283D+03,0.180D+02,0.19655000D+01,0.00000000D+00
     .,0.12004050D+04,0.283D+03,0.190D+02,0.19655000D+01,0.00000000D+00
     .,0.10001815D+04,0.283D+03,0.200D+02,0.19655000D+01,0.00000000D+00
     .,0.82806580D+03,0.283D+03,0.210D+02,0.19655000D+01,0.00000000D+00
     .,0.80123380D+03,0.283D+03,0.220D+02,0.19655000D+01,0.00000000D+00
     .,0.73459090D+03,0.283D+03,0.230D+02,0.19655000D+01,0.00000000D+00
     .,0.57897210D+03,0.283D+03,0.240D+02,0.19655000D+01,0.00000000D+00
     .,0.63356300D+03,0.283D+03,0.250D+02,0.19655000D+01,0.00000000D+00
     .,0.49763260D+03,0.283D+03,0.260D+02,0.19655000D+01,0.00000000D+00
     .,0.52856480D+03,0.283D+03,0.270D+02,0.19655000D+01,0.00000000D+00
     .,0.54385410D+03,0.283D+03,0.280D+02,0.19655000D+01,0.00000000D+00
     .,0.41719990D+03,0.283D+03,0.290D+02,0.19655000D+01,0.00000000D+00
     .,0.42968510D+03,0.283D+03,0.300D+02,0.19655000D+01,0.00000000D+00
     .,0.50815670D+03,0.283D+03,0.310D+02,0.19655000D+01,0.00000000D+00
     .,0.45004640D+03,0.283D+03,0.320D+02,0.19655000D+01,0.00000000D+00
     .,0.38531250D+03,0.283D+03,0.330D+02,0.19655000D+01,0.00000000D+00
     .,0.34654960D+03,0.283D+03,0.340D+02,0.19655000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 130701: 130800)=(/
     . 0.30400640D+03,0.283D+03,0.350D+02,0.19655000D+01,0.00000000D+00
     .,0.26498470D+03,0.283D+03,0.360D+02,0.19655000D+01,0.00000000D+00
     .,0.13466051D+04,0.283D+03,0.370D+02,0.19655000D+01,0.00000000D+00
     .,0.11912973D+04,0.283D+03,0.380D+02,0.19655000D+01,0.00000000D+00
     .,0.10473694D+04,0.283D+03,0.390D+02,0.19655000D+01,0.00000000D+00
     .,0.94346900D+03,0.283D+03,0.400D+02,0.19655000D+01,0.00000000D+00
     .,0.86162430D+03,0.283D+03,0.410D+02,0.19655000D+01,0.00000000D+00
     .,0.66699900D+03,0.283D+03,0.420D+02,0.19655000D+01,0.00000000D+00
     .,0.74348240D+03,0.283D+03,0.430D+02,0.19655000D+01,0.00000000D+00
     .,0.56809890D+03,0.283D+03,0.440D+02,0.19655000D+01,0.00000000D+00
     .,0.62085810D+03,0.283D+03,0.450D+02,0.19655000D+01,0.00000000D+00
     .,0.57630050D+03,0.283D+03,0.460D+02,0.19655000D+01,0.00000000D+00
     .,0.48048740D+03,0.283D+03,0.470D+02,0.19655000D+01,0.00000000D+00
     .,0.50846720D+03,0.283D+03,0.480D+02,0.19655000D+01,0.00000000D+00
     .,0.63617130D+03,0.283D+03,0.490D+02,0.19655000D+01,0.00000000D+00
     .,0.59026500D+03,0.283D+03,0.500D+02,0.19655000D+01,0.00000000D+00
     .,0.52774110D+03,0.283D+03,0.510D+02,0.19655000D+01,0.00000000D+00
     .,0.49058420D+03,0.283D+03,0.520D+02,0.19655000D+01,0.00000000D+00
     .,0.44449370D+03,0.283D+03,0.530D+02,0.19655000D+01,0.00000000D+00
     .,0.40041400D+03,0.283D+03,0.540D+02,0.19655000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 130801: 130900)=(/
     . 0.16407171D+04,0.283D+03,0.550D+02,0.19655000D+01,0.00000000D+00
     .,0.15169526D+04,0.283D+03,0.560D+02,0.19655000D+01,0.00000000D+00
     .,0.13375362D+04,0.283D+03,0.570D+02,0.19655000D+01,0.00000000D+00
     .,0.62310240D+03,0.283D+03,0.580D+02,0.19655000D+01,0.27991000D+01
     .,0.13458984D+04,0.283D+03,0.590D+02,0.19655000D+01,0.00000000D+00
     .,0.12931656D+04,0.283D+03,0.600D+02,0.19655000D+01,0.00000000D+00
     .,0.12609414D+04,0.283D+03,0.610D+02,0.19655000D+01,0.00000000D+00
     .,0.12312801D+04,0.283D+03,0.620D+02,0.19655000D+01,0.00000000D+00
     .,0.12049833D+04,0.283D+03,0.630D+02,0.19655000D+01,0.00000000D+00
     .,0.95146290D+03,0.283D+03,0.640D+02,0.19655000D+01,0.00000000D+00
     .,0.10651460D+04,0.283D+03,0.650D+02,0.19655000D+01,0.00000000D+00
     .,0.10280001D+04,0.283D+03,0.660D+02,0.19655000D+01,0.00000000D+00
     .,0.10878112D+04,0.283D+03,0.670D+02,0.19655000D+01,0.00000000D+00
     .,0.10648244D+04,0.283D+03,0.680D+02,0.19655000D+01,0.00000000D+00
     .,0.10441447D+04,0.283D+03,0.690D+02,0.19655000D+01,0.00000000D+00
     .,0.10317560D+04,0.283D+03,0.700D+02,0.19655000D+01,0.00000000D+00
     .,0.87174390D+03,0.283D+03,0.710D+02,0.19655000D+01,0.00000000D+00
     .,0.86024520D+03,0.283D+03,0.720D+02,0.19655000D+01,0.00000000D+00
     .,0.78678670D+03,0.283D+03,0.730D+02,0.19655000D+01,0.00000000D+00
     .,0.66560880D+03,0.283D+03,0.740D+02,0.19655000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 130901: 131000)=(/
     . 0.67767670D+03,0.283D+03,0.750D+02,0.19655000D+01,0.00000000D+00
     .,0.61534220D+03,0.283D+03,0.760D+02,0.19655000D+01,0.00000000D+00
     .,0.56441430D+03,0.283D+03,0.770D+02,0.19655000D+01,0.00000000D+00
     .,0.46971680D+03,0.283D+03,0.780D+02,0.19655000D+01,0.00000000D+00
     .,0.43919500D+03,0.283D+03,0.790D+02,0.19655000D+01,0.00000000D+00
     .,0.45207010D+03,0.283D+03,0.800D+02,0.19655000D+01,0.00000000D+00
     .,0.65391820D+03,0.283D+03,0.810D+02,0.19655000D+01,0.00000000D+00
     .,0.64098700D+03,0.283D+03,0.820D+02,0.19655000D+01,0.00000000D+00
     .,0.59069190D+03,0.283D+03,0.830D+02,0.19655000D+01,0.00000000D+00
     .,0.56428990D+03,0.283D+03,0.840D+02,0.19655000D+01,0.00000000D+00
     .,0.52180500D+03,0.283D+03,0.850D+02,0.19655000D+01,0.00000000D+00
     .,0.47912360D+03,0.283D+03,0.860D+02,0.19655000D+01,0.00000000D+00
     .,0.15538386D+04,0.283D+03,0.870D+02,0.19655000D+01,0.00000000D+00
     .,0.15028627D+04,0.283D+03,0.880D+02,0.19655000D+01,0.00000000D+00
     .,0.13329466D+04,0.283D+03,0.890D+02,0.19655000D+01,0.00000000D+00
     .,0.12024650D+04,0.283D+03,0.900D+02,0.19655000D+01,0.00000000D+00
     .,0.11918172D+04,0.283D+03,0.910D+02,0.19655000D+01,0.00000000D+00
     .,0.11541338D+04,0.283D+03,0.920D+02,0.19655000D+01,0.00000000D+00
     .,0.11856295D+04,0.283D+03,0.930D+02,0.19655000D+01,0.00000000D+00
     .,0.11486554D+04,0.283D+03,0.940D+02,0.19655000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 131001: 131100)=(/
     . 0.65353600D+02,0.283D+03,0.101D+03,0.19655000D+01,0.00000000D+00
     .,0.20943720D+03,0.283D+03,0.103D+03,0.19655000D+01,0.98650000D+00
     .,0.26754910D+03,0.283D+03,0.104D+03,0.19655000D+01,0.98080000D+00
     .,0.20589850D+03,0.283D+03,0.105D+03,0.19655000D+01,0.97060000D+00
     .,0.15580320D+03,0.283D+03,0.106D+03,0.19655000D+01,0.98680000D+00
     .,0.10888470D+03,0.283D+03,0.107D+03,0.19655000D+01,0.99440000D+00
     .,0.79657600D+02,0.283D+03,0.108D+03,0.19655000D+01,0.99250000D+00
     .,0.55128300D+02,0.283D+03,0.109D+03,0.19655000D+01,0.99820000D+00
     .,0.30582180D+03,0.283D+03,0.111D+03,0.19655000D+01,0.96840000D+00
     .,0.47251580D+03,0.283D+03,0.112D+03,0.19655000D+01,0.96280000D+00
     .,0.48037720D+03,0.283D+03,0.113D+03,0.19655000D+01,0.96480000D+00
     .,0.38813130D+03,0.283D+03,0.114D+03,0.19655000D+01,0.95070000D+00
     .,0.31914590D+03,0.283D+03,0.115D+03,0.19655000D+01,0.99470000D+00
     .,0.27063230D+03,0.283D+03,0.116D+03,0.19655000D+01,0.99480000D+00
     .,0.22188150D+03,0.283D+03,0.117D+03,0.19655000D+01,0.99720000D+00
     .,0.42309090D+03,0.283D+03,0.119D+03,0.19655000D+01,0.97670000D+00
     .,0.80050250D+03,0.283D+03,0.120D+03,0.19655000D+01,0.98310000D+00
     .,0.42505990D+03,0.283D+03,0.121D+03,0.19655000D+01,0.18627000D+01
     .,0.41044180D+03,0.283D+03,0.122D+03,0.19655000D+01,0.18299000D+01
     .,0.40223240D+03,0.283D+03,0.123D+03,0.19655000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters( 131101: 131200)=(/
     . 0.39832240D+03,0.283D+03,0.124D+03,0.19655000D+01,0.18269000D+01
     .,0.36744750D+03,0.283D+03,0.125D+03,0.19655000D+01,0.16406000D+01
     .,0.34035150D+03,0.283D+03,0.126D+03,0.19655000D+01,0.16483000D+01
     .,0.32470530D+03,0.283D+03,0.127D+03,0.19655000D+01,0.17149000D+01
     .,0.31739060D+03,0.283D+03,0.128D+03,0.19655000D+01,0.17937000D+01
     .,0.31302130D+03,0.283D+03,0.129D+03,0.19655000D+01,0.95760000D+00
     .,0.29468800D+03,0.283D+03,0.130D+03,0.19655000D+01,0.19419000D+01
     .,0.47779970D+03,0.283D+03,0.131D+03,0.19655000D+01,0.96010000D+00
     .,0.42144820D+03,0.283D+03,0.132D+03,0.19655000D+01,0.94340000D+00
     .,0.37886260D+03,0.283D+03,0.133D+03,0.19655000D+01,0.98890000D+00
     .,0.34667280D+03,0.283D+03,0.134D+03,0.19655000D+01,0.99010000D+00
     .,0.30608650D+03,0.283D+03,0.135D+03,0.19655000D+01,0.99740000D+00
     .,0.50534960D+03,0.283D+03,0.137D+03,0.19655000D+01,0.97380000D+00
     .,0.97364740D+03,0.283D+03,0.138D+03,0.19655000D+01,0.98010000D+00
     .,0.74962580D+03,0.283D+03,0.139D+03,0.19655000D+01,0.19153000D+01
     .,0.56197920D+03,0.283D+03,0.140D+03,0.19655000D+01,0.19355000D+01
     .,0.56751500D+03,0.283D+03,0.141D+03,0.19655000D+01,0.19545000D+01
     .,0.52972340D+03,0.283D+03,0.142D+03,0.19655000D+01,0.19420000D+01
     .,0.59210620D+03,0.283D+03,0.143D+03,0.19655000D+01,0.16682000D+01
     .,0.46293930D+03,0.283D+03,0.144D+03,0.19655000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters( 131201: 131300)=(/
     . 0.43325010D+03,0.283D+03,0.145D+03,0.19655000D+01,0.19003000D+01
     .,0.40255460D+03,0.283D+03,0.146D+03,0.19655000D+01,0.18630000D+01
     .,0.38932060D+03,0.283D+03,0.147D+03,0.19655000D+01,0.96790000D+00
     .,0.38581270D+03,0.283D+03,0.148D+03,0.19655000D+01,0.19539000D+01
     .,0.60715180D+03,0.283D+03,0.149D+03,0.19655000D+01,0.96330000D+00
     .,0.55119600D+03,0.283D+03,0.150D+03,0.19655000D+01,0.95140000D+00
     .,0.51744360D+03,0.283D+03,0.151D+03,0.19655000D+01,0.97490000D+00
     .,0.49028150D+03,0.283D+03,0.152D+03,0.19655000D+01,0.98110000D+00
     .,0.44864430D+03,0.283D+03,0.153D+03,0.19655000D+01,0.99680000D+00
     .,0.59907190D+03,0.283D+03,0.155D+03,0.19655000D+01,0.99090000D+00
     .,0.12605537D+04,0.283D+03,0.156D+03,0.19655000D+01,0.97970000D+00
     .,0.94816680D+03,0.283D+03,0.157D+03,0.19655000D+01,0.19373000D+01
     .,0.60443760D+03,0.283D+03,0.159D+03,0.19655000D+01,0.29425000D+01
     .,0.59196230D+03,0.283D+03,0.160D+03,0.19655000D+01,0.29455000D+01
     .,0.57330320D+03,0.283D+03,0.161D+03,0.19655000D+01,0.29413000D+01
     .,0.57583010D+03,0.283D+03,0.162D+03,0.19655000D+01,0.29300000D+01
     .,0.55423280D+03,0.283D+03,0.163D+03,0.19655000D+01,0.18286000D+01
     .,0.57935270D+03,0.283D+03,0.164D+03,0.19655000D+01,0.28732000D+01
     .,0.54441580D+03,0.283D+03,0.165D+03,0.19655000D+01,0.29086000D+01
     .,0.55345320D+03,0.283D+03,0.166D+03,0.19655000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters( 131301: 131400)=(/
     . 0.51696070D+03,0.283D+03,0.167D+03,0.19655000D+01,0.29242000D+01
     .,0.50231200D+03,0.283D+03,0.168D+03,0.19655000D+01,0.29282000D+01
     .,0.49901960D+03,0.283D+03,0.169D+03,0.19655000D+01,0.29246000D+01
     .,0.52412520D+03,0.283D+03,0.170D+03,0.19655000D+01,0.28482000D+01
     .,0.48244240D+03,0.283D+03,0.171D+03,0.19655000D+01,0.29219000D+01
     .,0.64975910D+03,0.283D+03,0.172D+03,0.19655000D+01,0.19254000D+01
     .,0.60428050D+03,0.283D+03,0.173D+03,0.19655000D+01,0.19459000D+01
     .,0.55254180D+03,0.283D+03,0.174D+03,0.19655000D+01,0.19292000D+01
     .,0.55811920D+03,0.283D+03,0.175D+03,0.19655000D+01,0.18104000D+01
     .,0.49092230D+03,0.283D+03,0.176D+03,0.19655000D+01,0.18858000D+01
     .,0.46222330D+03,0.283D+03,0.177D+03,0.19655000D+01,0.18648000D+01
     .,0.44172420D+03,0.283D+03,0.178D+03,0.19655000D+01,0.19188000D+01
     .,0.42235490D+03,0.283D+03,0.179D+03,0.19655000D+01,0.98460000D+00
     .,0.40877310D+03,0.283D+03,0.180D+03,0.19655000D+01,0.19896000D+01
     .,0.65249230D+03,0.283D+03,0.181D+03,0.19655000D+01,0.92670000D+00
     .,0.59673810D+03,0.283D+03,0.182D+03,0.19655000D+01,0.93830000D+00
     .,0.57973290D+03,0.283D+03,0.183D+03,0.19655000D+01,0.98200000D+00
     .,0.56455350D+03,0.283D+03,0.184D+03,0.19655000D+01,0.98150000D+00
     .,0.52811830D+03,0.283D+03,0.185D+03,0.19655000D+01,0.99540000D+00
     .,0.67482210D+03,0.283D+03,0.187D+03,0.19655000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters( 131401: 131500)=(/
     . 0.12567278D+04,0.283D+03,0.188D+03,0.19655000D+01,0.96620000D+00
     .,0.71513070D+03,0.283D+03,0.189D+03,0.19655000D+01,0.29070000D+01
     .,0.82307590D+03,0.283D+03,0.190D+03,0.19655000D+01,0.28844000D+01
     .,0.73672690D+03,0.283D+03,0.191D+03,0.19655000D+01,0.28738000D+01
     .,0.65261520D+03,0.283D+03,0.192D+03,0.19655000D+01,0.28878000D+01
     .,0.62834540D+03,0.283D+03,0.193D+03,0.19655000D+01,0.29095000D+01
     .,0.75123490D+03,0.283D+03,0.194D+03,0.19655000D+01,0.19209000D+01
     .,0.17590820D+03,0.283D+03,0.204D+03,0.19655000D+01,0.19697000D+01
     .,0.17315440D+03,0.283D+03,0.205D+03,0.19655000D+01,0.19441000D+01
     .,0.12738320D+03,0.283D+03,0.206D+03,0.19655000D+01,0.19985000D+01
     .,0.10231260D+03,0.283D+03,0.207D+03,0.19655000D+01,0.20143000D+01
     .,0.70396100D+02,0.283D+03,0.208D+03,0.19655000D+01,0.19887000D+01
     .,0.31101430D+03,0.283D+03,0.212D+03,0.19655000D+01,0.19496000D+01
     .,0.37562900D+03,0.283D+03,0.213D+03,0.19655000D+01,0.19311000D+01
     .,0.36130250D+03,0.283D+03,0.214D+03,0.19655000D+01,0.19435000D+01
     .,0.31474790D+03,0.283D+03,0.215D+03,0.19655000D+01,0.20102000D+01
     .,0.26518320D+03,0.283D+03,0.216D+03,0.19655000D+01,0.19903000D+01
     .,0.43613820D+03,0.283D+03,0.220D+03,0.19655000D+01,0.19349000D+01
     .,0.42000450D+03,0.283D+03,0.221D+03,0.19655000D+01,0.28999000D+01
     .,0.42525490D+03,0.283D+03,0.222D+03,0.19655000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters( 131501: 131600)=(/
     . 0.38922030D+03,0.283D+03,0.223D+03,0.19655000D+01,0.29110000D+01
     .,0.29426590D+03,0.283D+03,0.224D+03,0.19655000D+01,0.10619100D+02
     .,0.25234820D+03,0.283D+03,0.225D+03,0.19655000D+01,0.98849000D+01
     .,0.24765980D+03,0.283D+03,0.226D+03,0.19655000D+01,0.91376000D+01
     .,0.28933940D+03,0.283D+03,0.227D+03,0.19655000D+01,0.29263000D+01
     .,0.26984110D+03,0.283D+03,0.228D+03,0.19655000D+01,0.65458000D+01
     .,0.38000030D+03,0.283D+03,0.231D+03,0.19655000D+01,0.19315000D+01
     .,0.40150980D+03,0.283D+03,0.232D+03,0.19655000D+01,0.19447000D+01
     .,0.36905850D+03,0.283D+03,0.233D+03,0.19655000D+01,0.19793000D+01
     .,0.34397610D+03,0.283D+03,0.234D+03,0.19655000D+01,0.19812000D+01
     .,0.52267140D+03,0.283D+03,0.238D+03,0.19655000D+01,0.19143000D+01
     .,0.50441040D+03,0.283D+03,0.239D+03,0.19655000D+01,0.28903000D+01
     .,0.50913000D+03,0.283D+03,0.240D+03,0.19655000D+01,0.39106000D+01
     .,0.49230130D+03,0.283D+03,0.241D+03,0.19655000D+01,0.29225000D+01
     .,0.43628420D+03,0.283D+03,0.242D+03,0.19655000D+01,0.11055600D+02
     .,0.38581740D+03,0.283D+03,0.243D+03,0.19655000D+01,0.95402000D+01
     .,0.36486800D+03,0.283D+03,0.244D+03,0.19655000D+01,0.88895000D+01
     .,0.37099700D+03,0.283D+03,0.245D+03,0.19655000D+01,0.29696000D+01
     .,0.38733000D+03,0.283D+03,0.246D+03,0.19655000D+01,0.57095000D+01
     .,0.49068810D+03,0.283D+03,0.249D+03,0.19655000D+01,0.19378000D+01
     ./)
      grimme_c6_parameters( 131601: 131700)=(/
     . 0.53323730D+03,0.283D+03,0.250D+03,0.19655000D+01,0.19505000D+01
     .,0.50351030D+03,0.283D+03,0.251D+03,0.19655000D+01,0.19523000D+01
     .,0.48640400D+03,0.283D+03,0.252D+03,0.19655000D+01,0.19639000D+01
     .,0.63257940D+03,0.283D+03,0.256D+03,0.19655000D+01,0.18467000D+01
     .,0.65653900D+03,0.283D+03,0.257D+03,0.19655000D+01,0.29175000D+01
     .,0.48797410D+03,0.283D+03,0.272D+03,0.19655000D+01,0.38840000D+01
     .,0.50923540D+03,0.283D+03,0.273D+03,0.19655000D+01,0.28988000D+01
     .,0.47403980D+03,0.283D+03,0.274D+03,0.19655000D+01,0.10915300D+02
     .,0.43128970D+03,0.283D+03,0.275D+03,0.19655000D+01,0.98054000D+01
     .,0.40628510D+03,0.283D+03,0.276D+03,0.19655000D+01,0.91527000D+01
     .,0.41359970D+03,0.283D+03,0.277D+03,0.19655000D+01,0.29424000D+01
     .,0.43491300D+03,0.283D+03,0.278D+03,0.19655000D+01,0.66669000D+01
     .,0.52503950D+03,0.283D+03,0.281D+03,0.19655000D+01,0.19302000D+01
     .,0.55492310D+03,0.283D+03,0.282D+03,0.19655000D+01,0.19356000D+01
     .,0.56604970D+03,0.283D+03,0.283D+03,0.19655000D+01,0.19655000D+01
     .,0.40683500D+02,0.284D+03,0.100D+01,0.19639000D+01,0.91180000D+00
     .,0.27269000D+02,0.284D+03,0.200D+01,0.19639000D+01,0.00000000D+00
     .,0.59704830D+03,0.284D+03,0.300D+01,0.19639000D+01,0.00000000D+00
     .,0.35412790D+03,0.284D+03,0.400D+01,0.19639000D+01,0.00000000D+00
     .,0.24207220D+03,0.284D+03,0.500D+01,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 131701: 131800)=(/
     . 0.16537510D+03,0.284D+03,0.600D+01,0.19639000D+01,0.00000000D+00
     .,0.11663660D+03,0.284D+03,0.700D+01,0.19639000D+01,0.00000000D+00
     .,0.88864100D+02,0.284D+03,0.800D+01,0.19639000D+01,0.00000000D+00
     .,0.67699200D+02,0.284D+03,0.900D+01,0.19639000D+01,0.00000000D+00
     .,0.52323700D+02,0.284D+03,0.100D+02,0.19639000D+01,0.00000000D+00
     .,0.71529180D+03,0.284D+03,0.110D+02,0.19639000D+01,0.00000000D+00
     .,0.56173090D+03,0.284D+03,0.120D+02,0.19639000D+01,0.00000000D+00
     .,0.52182740D+03,0.284D+03,0.130D+02,0.19639000D+01,0.00000000D+00
     .,0.41539360D+03,0.284D+03,0.140D+02,0.19639000D+01,0.00000000D+00
     .,0.32669480D+03,0.284D+03,0.150D+02,0.19639000D+01,0.00000000D+00
     .,0.27264470D+03,0.284D+03,0.160D+02,0.19639000D+01,0.00000000D+00
     .,0.22390350D+03,0.284D+03,0.170D+02,0.19639000D+01,0.00000000D+00
     .,0.18404790D+03,0.284D+03,0.180D+02,0.19639000D+01,0.00000000D+00
     .,0.11685636D+04,0.284D+03,0.190D+02,0.19639000D+01,0.00000000D+00
     .,0.97928960D+03,0.284D+03,0.200D+02,0.19639000D+01,0.00000000D+00
     .,0.81191130D+03,0.284D+03,0.210D+02,0.19639000D+01,0.00000000D+00
     .,0.78675610D+03,0.284D+03,0.220D+02,0.19639000D+01,0.00000000D+00
     .,0.72192550D+03,0.284D+03,0.230D+02,0.19639000D+01,0.00000000D+00
     .,0.56923970D+03,0.284D+03,0.240D+02,0.19639000D+01,0.00000000D+00
     .,0.62340350D+03,0.284D+03,0.250D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 131801: 131900)=(/
     . 0.48993540D+03,0.284D+03,0.260D+02,0.19639000D+01,0.00000000D+00
     .,0.52113280D+03,0.284D+03,0.270D+02,0.19639000D+01,0.00000000D+00
     .,0.53572570D+03,0.284D+03,0.280D+02,0.19639000D+01,0.00000000D+00
     .,0.41114170D+03,0.284D+03,0.290D+02,0.19639000D+01,0.00000000D+00
     .,0.42443520D+03,0.284D+03,0.300D+02,0.19639000D+01,0.00000000D+00
     .,0.50154410D+03,0.284D+03,0.310D+02,0.19639000D+01,0.00000000D+00
     .,0.44570000D+03,0.284D+03,0.320D+02,0.19639000D+01,0.00000000D+00
     .,0.38280030D+03,0.284D+03,0.330D+02,0.19639000D+01,0.00000000D+00
     .,0.34497610D+03,0.284D+03,0.340D+02,0.19639000D+01,0.00000000D+00
     .,0.30323440D+03,0.284D+03,0.350D+02,0.19639000D+01,0.00000000D+00
     .,0.26479090D+03,0.284D+03,0.360D+02,0.19639000D+01,0.00000000D+00
     .,0.13118379D+04,0.284D+03,0.370D+02,0.19639000D+01,0.00000000D+00
     .,0.11663270D+04,0.284D+03,0.380D+02,0.19639000D+01,0.00000000D+00
     .,0.10280879D+04,0.284D+03,0.390D+02,0.19639000D+01,0.00000000D+00
     .,0.92765740D+03,0.284D+03,0.400D+02,0.19639000D+01,0.00000000D+00
     .,0.84816650D+03,0.284D+03,0.410D+02,0.19639000D+01,0.00000000D+00
     .,0.65796520D+03,0.284D+03,0.420D+02,0.19639000D+01,0.00000000D+00
     .,0.73282990D+03,0.284D+03,0.430D+02,0.19639000D+01,0.00000000D+00
     .,0.56123130D+03,0.284D+03,0.440D+02,0.19639000D+01,0.00000000D+00
     .,0.61320640D+03,0.284D+03,0.450D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 131901: 132000)=(/
     . 0.56959290D+03,0.284D+03,0.460D+02,0.19639000D+01,0.00000000D+00
     .,0.47485530D+03,0.284D+03,0.470D+02,0.19639000D+01,0.00000000D+00
     .,0.50299460D+03,0.284D+03,0.480D+02,0.19639000D+01,0.00000000D+00
     .,0.62793100D+03,0.284D+03,0.490D+02,0.19639000D+01,0.00000000D+00
     .,0.58416010D+03,0.284D+03,0.500D+02,0.19639000D+01,0.00000000D+00
     .,0.52370500D+03,0.284D+03,0.510D+02,0.19639000D+01,0.00000000D+00
     .,0.48765620D+03,0.284D+03,0.520D+02,0.19639000D+01,0.00000000D+00
     .,0.44264170D+03,0.284D+03,0.530D+02,0.19639000D+01,0.00000000D+00
     .,0.39942590D+03,0.284D+03,0.540D+02,0.19639000D+01,0.00000000D+00
     .,0.15989091D+04,0.284D+03,0.550D+02,0.19639000D+01,0.00000000D+00
     .,0.14842030D+04,0.284D+03,0.560D+02,0.19639000D+01,0.00000000D+00
     .,0.13119805D+04,0.284D+03,0.570D+02,0.19639000D+01,0.00000000D+00
     .,0.61810270D+03,0.284D+03,0.580D+02,0.19639000D+01,0.27991000D+01
     .,0.13179599D+04,0.284D+03,0.590D+02,0.19639000D+01,0.00000000D+00
     .,0.12667956D+04,0.284D+03,0.600D+02,0.19639000D+01,0.00000000D+00
     .,0.12353557D+04,0.284D+03,0.610D+02,0.19639000D+01,0.00000000D+00
     .,0.12064001D+04,0.284D+03,0.620D+02,0.19639000D+01,0.00000000D+00
     .,0.11807346D+04,0.284D+03,0.630D+02,0.19639000D+01,0.00000000D+00
     .,0.93518300D+03,0.284D+03,0.640D+02,0.19639000D+01,0.00000000D+00
     .,0.10429069D+04,0.284D+03,0.650D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 132001: 132100)=(/
     . 0.10070657D+04,0.284D+03,0.660D+02,0.19639000D+01,0.00000000D+00
     .,0.10665471D+04,0.284D+03,0.670D+02,0.19639000D+01,0.00000000D+00
     .,0.10440654D+04,0.284D+03,0.680D+02,0.19639000D+01,0.00000000D+00
     .,0.10238793D+04,0.284D+03,0.690D+02,0.19639000D+01,0.00000000D+00
     .,0.10115941D+04,0.284D+03,0.700D+02,0.19639000D+01,0.00000000D+00
     .,0.85651120D+03,0.284D+03,0.710D+02,0.19639000D+01,0.00000000D+00
     .,0.84744200D+03,0.284D+03,0.720D+02,0.19639000D+01,0.00000000D+00
     .,0.77639170D+03,0.284D+03,0.730D+02,0.19639000D+01,0.00000000D+00
     .,0.65782210D+03,0.284D+03,0.740D+02,0.19639000D+01,0.00000000D+00
     .,0.67012730D+03,0.284D+03,0.750D+02,0.19639000D+01,0.00000000D+00
     .,0.60937170D+03,0.284D+03,0.760D+02,0.19639000D+01,0.00000000D+00
     .,0.55959870D+03,0.284D+03,0.770D+02,0.19639000D+01,0.00000000D+00
     .,0.46635070D+03,0.284D+03,0.780D+02,0.19639000D+01,0.00000000D+00
     .,0.43627520D+03,0.284D+03,0.790D+02,0.19639000D+01,0.00000000D+00
     .,0.44926040D+03,0.284D+03,0.800D+02,0.19639000D+01,0.00000000D+00
     .,0.64607450D+03,0.284D+03,0.810D+02,0.19639000D+01,0.00000000D+00
     .,0.63450740D+03,0.284D+03,0.820D+02,0.19639000D+01,0.00000000D+00
     .,0.58610180D+03,0.284D+03,0.830D+02,0.19639000D+01,0.00000000D+00
     .,0.56069830D+03,0.284D+03,0.840D+02,0.19639000D+01,0.00000000D+00
     .,0.51936900D+03,0.284D+03,0.850D+02,0.19639000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 132101: 132200)=(/
     . 0.47763150D+03,0.284D+03,0.860D+02,0.19639000D+01,0.00000000D+00
     .,0.15173140D+04,0.284D+03,0.870D+02,0.19639000D+01,0.00000000D+00
     .,0.14724510D+04,0.284D+03,0.880D+02,0.19639000D+01,0.00000000D+00
     .,0.13089597D+04,0.284D+03,0.890D+02,0.19639000D+01,0.00000000D+00
     .,0.11841644D+04,0.284D+03,0.900D+02,0.19639000D+01,0.00000000D+00
     .,0.11721895D+04,0.284D+03,0.910D+02,0.19639000D+01,0.00000000D+00
     .,0.11351989D+04,0.284D+03,0.920D+02,0.19639000D+01,0.00000000D+00
     .,0.11641193D+04,0.284D+03,0.930D+02,0.19639000D+01,0.00000000D+00
     .,0.11281520D+04,0.284D+03,0.940D+02,0.19639000D+01,0.00000000D+00
     .,0.64976000D+02,0.284D+03,0.101D+03,0.19639000D+01,0.00000000D+00
     .,0.20631430D+03,0.284D+03,0.103D+03,0.19639000D+01,0.98650000D+00
     .,0.26393510D+03,0.284D+03,0.104D+03,0.19639000D+01,0.98080000D+00
     .,0.20426390D+03,0.284D+03,0.105D+03,0.19639000D+01,0.97060000D+00
     .,0.15510600D+03,0.284D+03,0.106D+03,0.19639000D+01,0.98680000D+00
     .,0.10879270D+03,0.284D+03,0.107D+03,0.19639000D+01,0.99440000D+00
     .,0.79818800D+02,0.284D+03,0.108D+03,0.19639000D+01,0.99250000D+00
     .,0.55426400D+02,0.284D+03,0.109D+03,0.19639000D+01,0.99820000D+00
     .,0.30093900D+03,0.284D+03,0.111D+03,0.19639000D+01,0.96840000D+00
     .,0.46475070D+03,0.284D+03,0.112D+03,0.19639000D+01,0.96280000D+00
     .,0.47382140D+03,0.284D+03,0.113D+03,0.19639000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters( 132201: 132300)=(/
     . 0.38451100D+03,0.284D+03,0.114D+03,0.19639000D+01,0.95070000D+00
     .,0.31721920D+03,0.284D+03,0.115D+03,0.19639000D+01,0.99470000D+00
     .,0.26961720D+03,0.284D+03,0.116D+03,0.19639000D+01,0.99480000D+00
     .,0.22156890D+03,0.284D+03,0.117D+03,0.19639000D+01,0.99720000D+00
     .,0.41756030D+03,0.284D+03,0.119D+03,0.19639000D+01,0.97670000D+00
     .,0.78439170D+03,0.284D+03,0.120D+03,0.19639000D+01,0.98310000D+00
     .,0.42082330D+03,0.284D+03,0.121D+03,0.19639000D+01,0.18627000D+01
     .,0.40643450D+03,0.284D+03,0.122D+03,0.19639000D+01,0.18299000D+01
     .,0.39827910D+03,0.284D+03,0.123D+03,0.19639000D+01,0.19138000D+01
     .,0.39424420D+03,0.284D+03,0.124D+03,0.19639000D+01,0.18269000D+01
     .,0.36438140D+03,0.284D+03,0.125D+03,0.19639000D+01,0.16406000D+01
     .,0.33772700D+03,0.284D+03,0.126D+03,0.19639000D+01,0.16483000D+01
     .,0.32221420D+03,0.284D+03,0.127D+03,0.19639000D+01,0.17149000D+01
     .,0.31490220D+03,0.284D+03,0.128D+03,0.19639000D+01,0.17937000D+01
     .,0.31008700D+03,0.284D+03,0.129D+03,0.19639000D+01,0.95760000D+00
     .,0.29273330D+03,0.284D+03,0.130D+03,0.19639000D+01,0.19419000D+01
     .,0.47199570D+03,0.284D+03,0.131D+03,0.19639000D+01,0.96010000D+00
     .,0.41772680D+03,0.284D+03,0.132D+03,0.19639000D+01,0.94340000D+00
     .,0.37646650D+03,0.284D+03,0.133D+03,0.19639000D+01,0.98890000D+00
     .,0.34508980D+03,0.284D+03,0.134D+03,0.19639000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters( 132301: 132400)=(/
     . 0.30527830D+03,0.284D+03,0.135D+03,0.19639000D+01,0.99740000D+00
     .,0.49917560D+03,0.284D+03,0.137D+03,0.19639000D+01,0.97380000D+00
     .,0.95388690D+03,0.284D+03,0.138D+03,0.19639000D+01,0.98010000D+00
     .,0.73824840D+03,0.284D+03,0.139D+03,0.19639000D+01,0.19153000D+01
     .,0.55634680D+03,0.284D+03,0.140D+03,0.19639000D+01,0.19355000D+01
     .,0.56177040D+03,0.284D+03,0.141D+03,0.19639000D+01,0.19545000D+01
     .,0.52477420D+03,0.284D+03,0.142D+03,0.19639000D+01,0.19420000D+01
     .,0.58512270D+03,0.284D+03,0.143D+03,0.19639000D+01,0.16682000D+01
     .,0.45947870D+03,0.284D+03,0.144D+03,0.19639000D+01,0.18584000D+01
     .,0.43011170D+03,0.284D+03,0.145D+03,0.19639000D+01,0.19003000D+01
     .,0.39979630D+03,0.284D+03,0.146D+03,0.19639000D+01,0.18630000D+01
     .,0.38652800D+03,0.284D+03,0.147D+03,0.19639000D+01,0.96790000D+00
     .,0.38357630D+03,0.284D+03,0.148D+03,0.19639000D+01,0.19539000D+01
     .,0.59985960D+03,0.284D+03,0.149D+03,0.19639000D+01,0.96330000D+00
     .,0.54609180D+03,0.284D+03,0.150D+03,0.19639000D+01,0.95140000D+00
     .,0.51367970D+03,0.284D+03,0.151D+03,0.19639000D+01,0.97490000D+00
     .,0.48740710D+03,0.284D+03,0.152D+03,0.19639000D+01,0.98110000D+00
     .,0.44676180D+03,0.284D+03,0.153D+03,0.19639000D+01,0.99680000D+00
     .,0.59303760D+03,0.284D+03,0.155D+03,0.19639000D+01,0.99090000D+00
     .,0.12339967D+04,0.284D+03,0.156D+03,0.19639000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters( 132401: 132500)=(/
     . 0.93345900D+03,0.284D+03,0.157D+03,0.19639000D+01,0.19373000D+01
     .,0.59968400D+03,0.284D+03,0.159D+03,0.19639000D+01,0.29425000D+01
     .,0.58732120D+03,0.284D+03,0.160D+03,0.19639000D+01,0.29455000D+01
     .,0.56888850D+03,0.284D+03,0.161D+03,0.19639000D+01,0.29413000D+01
     .,0.57117360D+03,0.284D+03,0.162D+03,0.19639000D+01,0.29300000D+01
     .,0.54902970D+03,0.284D+03,0.163D+03,0.19639000D+01,0.18286000D+01
     .,0.57457480D+03,0.284D+03,0.164D+03,0.19639000D+01,0.28732000D+01
     .,0.54011010D+03,0.284D+03,0.165D+03,0.19639000D+01,0.29086000D+01
     .,0.54869770D+03,0.284D+03,0.166D+03,0.19639000D+01,0.28965000D+01
     .,0.51304540D+03,0.284D+03,0.167D+03,0.19639000D+01,0.29242000D+01
     .,0.49857190D+03,0.284D+03,0.168D+03,0.19639000D+01,0.29282000D+01
     .,0.49524940D+03,0.284D+03,0.169D+03,0.19639000D+01,0.29246000D+01
     .,0.51984050D+03,0.284D+03,0.170D+03,0.19639000D+01,0.28482000D+01
     .,0.47888930D+03,0.284D+03,0.171D+03,0.19639000D+01,0.29219000D+01
     .,0.64207210D+03,0.284D+03,0.172D+03,0.19639000D+01,0.19254000D+01
     .,0.59809800D+03,0.284D+03,0.173D+03,0.19639000D+01,0.19459000D+01
     .,0.54779890D+03,0.284D+03,0.174D+03,0.19639000D+01,0.19292000D+01
     .,0.55252070D+03,0.284D+03,0.175D+03,0.19639000D+01,0.18104000D+01
     .,0.48785140D+03,0.284D+03,0.176D+03,0.19639000D+01,0.18858000D+01
     .,0.45960480D+03,0.284D+03,0.177D+03,0.19639000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters( 132501: 132600)=(/
     . 0.43937670D+03,0.284D+03,0.178D+03,0.19639000D+01,0.19188000D+01
     .,0.42009830D+03,0.284D+03,0.179D+03,0.19639000D+01,0.98460000D+00
     .,0.40712160D+03,0.284D+03,0.180D+03,0.19639000D+01,0.19896000D+01
     .,0.64511470D+03,0.284D+03,0.181D+03,0.19639000D+01,0.92670000D+00
     .,0.59155410D+03,0.284D+03,0.182D+03,0.19639000D+01,0.93830000D+00
     .,0.57553810D+03,0.284D+03,0.183D+03,0.19639000D+01,0.98200000D+00
     .,0.56108050D+03,0.284D+03,0.184D+03,0.19639000D+01,0.98150000D+00
     .,0.52566240D+03,0.284D+03,0.185D+03,0.19639000D+01,0.99540000D+00
     .,0.66813180D+03,0.284D+03,0.187D+03,0.19639000D+01,0.97050000D+00
     .,0.12322448D+04,0.284D+03,0.188D+03,0.19639000D+01,0.96620000D+00
     .,0.70944400D+03,0.284D+03,0.189D+03,0.19639000D+01,0.29070000D+01
     .,0.81473780D+03,0.284D+03,0.190D+03,0.19639000D+01,0.28844000D+01
     .,0.72995170D+03,0.284D+03,0.191D+03,0.19639000D+01,0.28738000D+01
     .,0.64769500D+03,0.284D+03,0.192D+03,0.19639000D+01,0.28878000D+01
     .,0.62385580D+03,0.284D+03,0.193D+03,0.19639000D+01,0.29095000D+01
     .,0.74228920D+03,0.284D+03,0.194D+03,0.19639000D+01,0.19209000D+01
     .,0.17455350D+03,0.284D+03,0.204D+03,0.19639000D+01,0.19697000D+01
     .,0.17202380D+03,0.284D+03,0.205D+03,0.19639000D+01,0.19441000D+01
     .,0.12705660D+03,0.284D+03,0.206D+03,0.19639000D+01,0.19985000D+01
     .,0.10226240D+03,0.284D+03,0.207D+03,0.19639000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters( 132601: 132700)=(/
     . 0.70592600D+02,0.284D+03,0.208D+03,0.19639000D+01,0.19887000D+01
     .,0.30770750D+03,0.284D+03,0.212D+03,0.19639000D+01,0.19496000D+01
     .,0.37155110D+03,0.284D+03,0.213D+03,0.19639000D+01,0.19311000D+01
     .,0.35816390D+03,0.284D+03,0.214D+03,0.19639000D+01,0.19435000D+01
     .,0.31278040D+03,0.284D+03,0.215D+03,0.19639000D+01,0.20102000D+01
     .,0.26420220D+03,0.284D+03,0.216D+03,0.19639000D+01,0.19903000D+01
     .,0.43156730D+03,0.284D+03,0.220D+03,0.19639000D+01,0.19349000D+01
     .,0.41632140D+03,0.284D+03,0.221D+03,0.19639000D+01,0.28999000D+01
     .,0.42158300D+03,0.284D+03,0.222D+03,0.19639000D+01,0.38675000D+01
     .,0.38584400D+03,0.284D+03,0.223D+03,0.19639000D+01,0.29110000D+01
     .,0.29255420D+03,0.284D+03,0.224D+03,0.19639000D+01,0.10619100D+02
     .,0.25131440D+03,0.284D+03,0.225D+03,0.19639000D+01,0.98849000D+01
     .,0.24658940D+03,0.284D+03,0.226D+03,0.19639000D+01,0.91376000D+01
     .,0.28727800D+03,0.284D+03,0.227D+03,0.19639000D+01,0.29263000D+01
     .,0.26812740D+03,0.284D+03,0.228D+03,0.19639000D+01,0.65458000D+01
     .,0.37653350D+03,0.284D+03,0.231D+03,0.19639000D+01,0.19315000D+01
     .,0.39818770D+03,0.284D+03,0.232D+03,0.19639000D+01,0.19447000D+01
     .,0.36684470D+03,0.284D+03,0.233D+03,0.19639000D+01,0.19793000D+01
     .,0.34242490D+03,0.284D+03,0.234D+03,0.19639000D+01,0.19812000D+01
     .,0.51736980D+03,0.284D+03,0.238D+03,0.19639000D+01,0.19143000D+01
     ./)
      grimme_c6_parameters( 132701: 132800)=(/
     . 0.50039000D+03,0.284D+03,0.239D+03,0.19639000D+01,0.28903000D+01
     .,0.50540540D+03,0.284D+03,0.240D+03,0.19639000D+01,0.39106000D+01
     .,0.48864930D+03,0.284D+03,0.241D+03,0.19639000D+01,0.29225000D+01
     .,0.43386770D+03,0.284D+03,0.242D+03,0.19639000D+01,0.11055600D+02
     .,0.38425630D+03,0.284D+03,0.243D+03,0.19639000D+01,0.95402000D+01
     .,0.36358980D+03,0.284D+03,0.244D+03,0.19639000D+01,0.88895000D+01
     .,0.36907770D+03,0.284D+03,0.245D+03,0.19639000D+01,0.29696000D+01
     .,0.38510740D+03,0.284D+03,0.246D+03,0.19639000D+01,0.57095000D+01
     .,0.48643230D+03,0.284D+03,0.249D+03,0.19639000D+01,0.19378000D+01
     .,0.52860140D+03,0.284D+03,0.250D+03,0.19639000D+01,0.19505000D+01
     .,0.50008910D+03,0.284D+03,0.251D+03,0.19639000D+01,0.19523000D+01
     .,0.48364170D+03,0.284D+03,0.252D+03,0.19639000D+01,0.19639000D+01
     .,0.62662040D+03,0.284D+03,0.256D+03,0.19639000D+01,0.18467000D+01
     .,0.65103510D+03,0.284D+03,0.257D+03,0.19639000D+01,0.29175000D+01
     .,0.48484790D+03,0.284D+03,0.272D+03,0.19639000D+01,0.38840000D+01
     .,0.50560090D+03,0.284D+03,0.273D+03,0.19639000D+01,0.28988000D+01
     .,0.47147570D+03,0.284D+03,0.274D+03,0.19639000D+01,0.10915300D+02
     .,0.42954230D+03,0.284D+03,0.275D+03,0.19639000D+01,0.98054000D+01
     .,0.40508190D+03,0.284D+03,0.276D+03,0.19639000D+01,0.91527000D+01
     .,0.41178430D+03,0.284D+03,0.277D+03,0.19639000D+01,0.29424000D+01
     ./)
      grimme_c6_parameters( 132801: 132900)=(/
     . 0.43290980D+03,0.284D+03,0.278D+03,0.19639000D+01,0.66669000D+01
     .,0.52115810D+03,0.284D+03,0.281D+03,0.19639000D+01,0.19302000D+01
     .,0.55085190D+03,0.284D+03,0.282D+03,0.19639000D+01,0.19356000D+01
     .,0.56229090D+03,0.284D+03,0.283D+03,0.19639000D+01,0.19655000D+01
     .,0.55897120D+03,0.284D+03,0.284D+03,0.19639000D+01,0.19639000D+01
     .,0.49435900D+02,0.288D+03,0.100D+01,0.18075000D+01,0.91180000D+00
     .,0.32220500D+02,0.288D+03,0.200D+01,0.18075000D+01,0.00000000D+00
     .,0.82215000D+03,0.288D+03,0.300D+01,0.18075000D+01,0.00000000D+00
     .,0.45899560D+03,0.288D+03,0.400D+01,0.18075000D+01,0.00000000D+00
     .,0.30409170D+03,0.288D+03,0.500D+01,0.18075000D+01,0.00000000D+00
     .,0.20312550D+03,0.288D+03,0.600D+01,0.18075000D+01,0.00000000D+00
     .,0.14087730D+03,0.288D+03,0.700D+01,0.18075000D+01,0.00000000D+00
     .,0.10603060D+03,0.288D+03,0.800D+01,0.18075000D+01,0.00000000D+00
     .,0.79895700D+02,0.288D+03,0.900D+01,0.18075000D+01,0.00000000D+00
     .,0.61167600D+02,0.288D+03,0.100D+02,0.18075000D+01,0.00000000D+00
     .,0.98096360D+03,0.288D+03,0.110D+02,0.18075000D+01,0.00000000D+00
     .,0.73528720D+03,0.288D+03,0.120D+02,0.18075000D+01,0.00000000D+00
     .,0.67185720D+03,0.288D+03,0.130D+02,0.18075000D+01,0.00000000D+00
     .,0.52330930D+03,0.288D+03,0.140D+02,0.18075000D+01,0.00000000D+00
     .,0.40436880D+03,0.288D+03,0.150D+02,0.18075000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 132901: 133000)=(/
     . 0.33371710D+03,0.288D+03,0.160D+02,0.18075000D+01,0.00000000D+00
     .,0.27114080D+03,0.288D+03,0.170D+02,0.18075000D+01,0.00000000D+00
     .,0.22078740D+03,0.288D+03,0.180D+02,0.18075000D+01,0.00000000D+00
     .,0.16183210D+04,0.288D+03,0.190D+02,0.18075000D+01,0.00000000D+00
     .,0.13060236D+04,0.288D+03,0.200D+02,0.18075000D+01,0.00000000D+00
     .,0.10738645D+04,0.288D+03,0.210D+02,0.18075000D+01,0.00000000D+00
     .,0.10329143D+04,0.288D+03,0.220D+02,0.18075000D+01,0.00000000D+00
     .,0.94357380D+03,0.288D+03,0.230D+02,0.18075000D+01,0.00000000D+00
     .,0.74319420D+03,0.288D+03,0.240D+02,0.18075000D+01,0.00000000D+00
     .,0.80955010D+03,0.288D+03,0.250D+02,0.18075000D+01,0.00000000D+00
     .,0.63499500D+03,0.288D+03,0.260D+02,0.18075000D+01,0.00000000D+00
     .,0.66951560D+03,0.288D+03,0.270D+02,0.18075000D+01,0.00000000D+00
     .,0.69128830D+03,0.288D+03,0.280D+02,0.18075000D+01,0.00000000D+00
     .,0.53001490D+03,0.288D+03,0.290D+02,0.18075000D+01,0.00000000D+00
     .,0.54001980D+03,0.288D+03,0.300D+02,0.18075000D+01,0.00000000D+00
     .,0.64142920D+03,0.288D+03,0.310D+02,0.18075000D+01,0.00000000D+00
     .,0.56053310D+03,0.288D+03,0.320D+02,0.18075000D+01,0.00000000D+00
     .,0.47441890D+03,0.288D+03,0.330D+02,0.18075000D+01,0.00000000D+00
     .,0.42376020D+03,0.288D+03,0.340D+02,0.18075000D+01,0.00000000D+00
     .,0.36911450D+03,0.288D+03,0.350D+02,0.18075000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 133001: 133100)=(/
     . 0.31963860D+03,0.288D+03,0.360D+02,0.18075000D+01,0.00000000D+00
     .,0.18108441D+04,0.288D+03,0.370D+02,0.18075000D+01,0.00000000D+00
     .,0.15576903D+04,0.288D+03,0.380D+02,0.18075000D+01,0.00000000D+00
     .,0.13534487D+04,0.288D+03,0.390D+02,0.18075000D+01,0.00000000D+00
     .,0.12104384D+04,0.288D+03,0.400D+02,0.18075000D+01,0.00000000D+00
     .,0.11002859D+04,0.288D+03,0.410D+02,0.18075000D+01,0.00000000D+00
     .,0.84497140D+03,0.288D+03,0.420D+02,0.18075000D+01,0.00000000D+00
     .,0.94457550D+03,0.288D+03,0.430D+02,0.18075000D+01,0.00000000D+00
     .,0.71540020D+03,0.288D+03,0.440D+02,0.18075000D+01,0.00000000D+00
     .,0.78173110D+03,0.288D+03,0.450D+02,0.18075000D+01,0.00000000D+00
     .,0.72344940D+03,0.288D+03,0.460D+02,0.18075000D+01,0.00000000D+00
     .,0.60407200D+03,0.288D+03,0.470D+02,0.18075000D+01,0.00000000D+00
     .,0.63577580D+03,0.288D+03,0.480D+02,0.18075000D+01,0.00000000D+00
     .,0.80295170D+03,0.288D+03,0.490D+02,0.18075000D+01,0.00000000D+00
     .,0.73674350D+03,0.288D+03,0.500D+02,0.18075000D+01,0.00000000D+00
     .,0.65189600D+03,0.288D+03,0.510D+02,0.18075000D+01,0.00000000D+00
     .,0.60235480D+03,0.288D+03,0.520D+02,0.18075000D+01,0.00000000D+00
     .,0.54227570D+03,0.288D+03,0.530D+02,0.18075000D+01,0.00000000D+00
     .,0.48556750D+03,0.288D+03,0.540D+02,0.18075000D+01,0.00000000D+00
     .,0.22065294D+04,0.288D+03,0.550D+02,0.18075000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 133101: 133200)=(/
     . 0.19920198D+04,0.288D+03,0.560D+02,0.18075000D+01,0.00000000D+00
     .,0.17357045D+04,0.288D+03,0.570D+02,0.18075000D+01,0.00000000D+00
     .,0.77135460D+03,0.288D+03,0.580D+02,0.18075000D+01,0.27991000D+01
     .,0.17597955D+04,0.288D+03,0.590D+02,0.18075000D+01,0.00000000D+00
     .,0.16873282D+04,0.288D+03,0.600D+02,0.18075000D+01,0.00000000D+00
     .,0.16443172D+04,0.288D+03,0.610D+02,0.18075000D+01,0.00000000D+00
     .,0.16048351D+04,0.288D+03,0.620D+02,0.18075000D+01,0.00000000D+00
     .,0.15698044D+04,0.288D+03,0.630D+02,0.18075000D+01,0.00000000D+00
     .,0.12237547D+04,0.288D+03,0.640D+02,0.18075000D+01,0.00000000D+00
     .,0.13970237D+04,0.288D+03,0.650D+02,0.18075000D+01,0.00000000D+00
     .,0.13453523D+04,0.288D+03,0.660D+02,0.18075000D+01,0.00000000D+00
     .,0.14127942D+04,0.288D+03,0.670D+02,0.18075000D+01,0.00000000D+00
     .,0.13824590D+04,0.288D+03,0.680D+02,0.18075000D+01,0.00000000D+00
     .,0.13549696D+04,0.288D+03,0.690D+02,0.18075000D+01,0.00000000D+00
     .,0.13395852D+04,0.288D+03,0.700D+02,0.18075000D+01,0.00000000D+00
     .,0.11220389D+04,0.288D+03,0.710D+02,0.18075000D+01,0.00000000D+00
     .,0.10946876D+04,0.288D+03,0.720D+02,0.18075000D+01,0.00000000D+00
     .,0.99428480D+03,0.288D+03,0.730D+02,0.18075000D+01,0.00000000D+00
     .,0.83675230D+03,0.288D+03,0.740D+02,0.18075000D+01,0.00000000D+00
     .,0.84958700D+03,0.288D+03,0.750D+02,0.18075000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 133201: 133300)=(/
     . 0.76688670D+03,0.288D+03,0.760D+02,0.18075000D+01,0.00000000D+00
     .,0.70006410D+03,0.288D+03,0.770D+02,0.18075000D+01,0.00000000D+00
     .,0.57964280D+03,0.288D+03,0.780D+02,0.18075000D+01,0.00000000D+00
     .,0.54079780D+03,0.288D+03,0.790D+02,0.18075000D+01,0.00000000D+00
     .,0.55540190D+03,0.288D+03,0.800D+02,0.18075000D+01,0.00000000D+00
     .,0.82307860D+03,0.288D+03,0.810D+02,0.18075000D+01,0.00000000D+00
     .,0.79969300D+03,0.288D+03,0.820D+02,0.18075000D+01,0.00000000D+00
     .,0.73000700D+03,0.288D+03,0.830D+02,0.18075000D+01,0.00000000D+00
     .,0.69372340D+03,0.288D+03,0.840D+02,0.18075000D+01,0.00000000D+00
     .,0.63752300D+03,0.288D+03,0.850D+02,0.18075000D+01,0.00000000D+00
     .,0.58212360D+03,0.288D+03,0.860D+02,0.18075000D+01,0.00000000D+00
     .,0.20693475D+04,0.288D+03,0.870D+02,0.18075000D+01,0.00000000D+00
     .,0.19615822D+04,0.288D+03,0.880D+02,0.18075000D+01,0.00000000D+00
     .,0.17203415D+04,0.288D+03,0.890D+02,0.18075000D+01,0.00000000D+00
     .,0.15329737D+04,0.288D+03,0.900D+02,0.18075000D+01,0.00000000D+00
     .,0.15284967D+04,0.288D+03,0.910D+02,0.18075000D+01,0.00000000D+00
     .,0.14796138D+04,0.288D+03,0.920D+02,0.18075000D+01,0.00000000D+00
     .,0.15311137D+04,0.288D+03,0.930D+02,0.18075000D+01,0.00000000D+00
     .,0.14812261D+04,0.288D+03,0.940D+02,0.18075000D+01,0.00000000D+00
     .,0.80304800D+02,0.288D+03,0.101D+03,0.18075000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 133301: 133400)=(/
     . 0.26620380D+03,0.288D+03,0.103D+03,0.18075000D+01,0.98650000D+00
     .,0.33870130D+03,0.288D+03,0.104D+03,0.18075000D+01,0.98080000D+00
     .,0.25501410D+03,0.288D+03,0.105D+03,0.18075000D+01,0.97060000D+00
     .,0.19065070D+03,0.288D+03,0.106D+03,0.18075000D+01,0.98680000D+00
     .,0.13139800D+03,0.288D+03,0.107D+03,0.18075000D+01,0.99440000D+00
     .,0.94990900D+02,0.288D+03,0.108D+03,0.18075000D+01,0.99250000D+00
     .,0.64689400D+02,0.288D+03,0.109D+03,0.18075000D+01,0.99820000D+00
     .,0.39028390D+03,0.288D+03,0.111D+03,0.18075000D+01,0.96840000D+00
     .,0.60479080D+03,0.288D+03,0.112D+03,0.18075000D+01,0.96280000D+00
     .,0.60764500D+03,0.288D+03,0.113D+03,0.18075000D+01,0.96480000D+00
     .,0.48292640D+03,0.288D+03,0.114D+03,0.18075000D+01,0.95070000D+00
     .,0.39240610D+03,0.288D+03,0.115D+03,0.18075000D+01,0.99470000D+00
     .,0.33009010D+03,0.288D+03,0.116D+03,0.18075000D+01,0.99480000D+00
     .,0.26835530D+03,0.288D+03,0.117D+03,0.18075000D+01,0.99720000D+00
     .,0.53522110D+03,0.288D+03,0.119D+03,0.18075000D+01,0.97670000D+00
     .,0.10452655D+04,0.288D+03,0.120D+03,0.18075000D+01,0.98310000D+00
     .,0.53005110D+03,0.288D+03,0.121D+03,0.18075000D+01,0.18627000D+01
     .,0.51159590D+03,0.288D+03,0.122D+03,0.18075000D+01,0.18299000D+01
     .,0.50142290D+03,0.288D+03,0.123D+03,0.18075000D+01,0.19138000D+01
     .,0.49734050D+03,0.288D+03,0.124D+03,0.18075000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters( 133401: 133500)=(/
     . 0.45500680D+03,0.288D+03,0.125D+03,0.18075000D+01,0.16406000D+01
     .,0.42043750D+03,0.288D+03,0.126D+03,0.18075000D+01,0.16483000D+01
     .,0.40108240D+03,0.288D+03,0.127D+03,0.18075000D+01,0.17149000D+01
     .,0.39226860D+03,0.288D+03,0.128D+03,0.18075000D+01,0.17937000D+01
     .,0.38915420D+03,0.288D+03,0.129D+03,0.18075000D+01,0.95760000D+00
     .,0.36239480D+03,0.288D+03,0.130D+03,0.18075000D+01,0.19419000D+01
     .,0.60102950D+03,0.288D+03,0.131D+03,0.18075000D+01,0.96010000D+00
     .,0.52334040D+03,0.288D+03,0.132D+03,0.18075000D+01,0.94340000D+00
     .,0.46617350D+03,0.288D+03,0.133D+03,0.18075000D+01,0.98890000D+00
     .,0.42395730D+03,0.288D+03,0.134D+03,0.18075000D+01,0.99010000D+00
     .,0.37177260D+03,0.288D+03,0.135D+03,0.18075000D+01,0.99740000D+00
     .,0.63744040D+03,0.288D+03,0.137D+03,0.18075000D+01,0.97380000D+00
     .,0.12738440D+04,0.288D+03,0.138D+03,0.18075000D+01,0.98010000D+00
     .,0.95836130D+03,0.288D+03,0.139D+03,0.18075000D+01,0.19153000D+01
     .,0.70195430D+03,0.288D+03,0.140D+03,0.18075000D+01,0.19355000D+01
     .,0.70892730D+03,0.288D+03,0.141D+03,0.18075000D+01,0.19545000D+01
     .,0.65979250D+03,0.288D+03,0.142D+03,0.18075000D+01,0.19420000D+01
     .,0.74563430D+03,0.288D+03,0.143D+03,0.18075000D+01,0.16682000D+01
     .,0.57194600D+03,0.288D+03,0.144D+03,0.18075000D+01,0.18584000D+01
     .,0.53479690D+03,0.288D+03,0.145D+03,0.18075000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters( 133501: 133600)=(/
     . 0.49608770D+03,0.288D+03,0.146D+03,0.18075000D+01,0.18630000D+01
     .,0.48018350D+03,0.288D+03,0.147D+03,0.18075000D+01,0.96790000D+00
     .,0.47304820D+03,0.288D+03,0.148D+03,0.18075000D+01,0.19539000D+01
     .,0.76329290D+03,0.288D+03,0.149D+03,0.18075000D+01,0.96330000D+00
     .,0.68512580D+03,0.288D+03,0.150D+03,0.18075000D+01,0.95140000D+00
     .,0.63830590D+03,0.288D+03,0.151D+03,0.18075000D+01,0.97490000D+00
     .,0.60176620D+03,0.288D+03,0.152D+03,0.18075000D+01,0.98110000D+00
     .,0.54740910D+03,0.288D+03,0.153D+03,0.18075000D+01,0.99680000D+00
     .,0.74957040D+03,0.288D+03,0.155D+03,0.18075000D+01,0.99090000D+00
     .,0.16581771D+04,0.288D+03,0.156D+03,0.18075000D+01,0.97970000D+00
     .,0.12150291D+04,0.288D+03,0.157D+03,0.18075000D+01,0.19373000D+01
     .,0.74777800D+03,0.288D+03,0.159D+03,0.18075000D+01,0.29425000D+01
     .,0.73224530D+03,0.288D+03,0.160D+03,0.18075000D+01,0.29455000D+01
     .,0.70878020D+03,0.288D+03,0.161D+03,0.18075000D+01,0.29413000D+01
     .,0.71308040D+03,0.288D+03,0.162D+03,0.18075000D+01,0.29300000D+01
     .,0.68979990D+03,0.288D+03,0.163D+03,0.18075000D+01,0.18286000D+01
     .,0.71779230D+03,0.288D+03,0.164D+03,0.18075000D+01,0.28732000D+01
     .,0.67351320D+03,0.288D+03,0.165D+03,0.18075000D+01,0.29086000D+01
     .,0.68677710D+03,0.288D+03,0.166D+03,0.18075000D+01,0.28965000D+01
     .,0.63867240D+03,0.288D+03,0.167D+03,0.18075000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters( 133601: 133700)=(/
     . 0.62024820D+03,0.288D+03,0.168D+03,0.18075000D+01,0.29282000D+01
     .,0.61643990D+03,0.288D+03,0.169D+03,0.18075000D+01,0.29246000D+01
     .,0.64892260D+03,0.288D+03,0.170D+03,0.18075000D+01,0.28482000D+01
     .,0.59550270D+03,0.288D+03,0.171D+03,0.18075000D+01,0.29219000D+01
     .,0.81802970D+03,0.288D+03,0.172D+03,0.18075000D+01,0.19254000D+01
     .,0.75571890D+03,0.288D+03,0.173D+03,0.18075000D+01,0.19459000D+01
     .,0.68626340D+03,0.288D+03,0.174D+03,0.18075000D+01,0.19292000D+01
     .,0.69723760D+03,0.288D+03,0.175D+03,0.18075000D+01,0.18104000D+01
     .,0.60379550D+03,0.288D+03,0.176D+03,0.18075000D+01,0.18858000D+01
     .,0.56713440D+03,0.288D+03,0.177D+03,0.18075000D+01,0.18648000D+01
     .,0.54115970D+03,0.288D+03,0.178D+03,0.18075000D+01,0.19188000D+01
     .,0.51741800D+03,0.288D+03,0.179D+03,0.18075000D+01,0.98460000D+00
     .,0.49805080D+03,0.288D+03,0.180D+03,0.18075000D+01,0.19896000D+01
     .,0.81861890D+03,0.288D+03,0.181D+03,0.18075000D+01,0.92670000D+00
     .,0.74024200D+03,0.288D+03,0.182D+03,0.18075000D+01,0.93830000D+00
     .,0.71498450D+03,0.288D+03,0.183D+03,0.18075000D+01,0.98200000D+00
     .,0.69350480D+03,0.288D+03,0.184D+03,0.18075000D+01,0.98150000D+00
     .,0.64521980D+03,0.288D+03,0.185D+03,0.18075000D+01,0.99540000D+00
     .,0.84379470D+03,0.288D+03,0.187D+03,0.18075000D+01,0.97050000D+00
     .,0.16402094D+04,0.288D+03,0.188D+03,0.18075000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters( 133701: 133800)=(/
     . 0.88501740D+03,0.288D+03,0.189D+03,0.18075000D+01,0.29070000D+01
     .,0.10289540D+04,0.288D+03,0.190D+03,0.18075000D+01,0.28844000D+01
     .,0.91819730D+03,0.288D+03,0.191D+03,0.18075000D+01,0.28738000D+01
     .,0.80643310D+03,0.288D+03,0.192D+03,0.18075000D+01,0.28878000D+01
     .,0.77504710D+03,0.288D+03,0.193D+03,0.18075000D+01,0.29095000D+01
     .,0.94627710D+03,0.288D+03,0.194D+03,0.18075000D+01,0.19209000D+01
     .,0.21752840D+03,0.288D+03,0.204D+03,0.18075000D+01,0.19697000D+01
     .,0.21346830D+03,0.288D+03,0.205D+03,0.18075000D+01,0.19441000D+01
     .,0.15465610D+03,0.288D+03,0.206D+03,0.18075000D+01,0.19985000D+01
     .,0.12319970D+03,0.288D+03,0.207D+03,0.18075000D+01,0.20143000D+01
     .,0.83591200D+02,0.288D+03,0.208D+03,0.18075000D+01,0.19887000D+01
     .,0.38834390D+03,0.288D+03,0.212D+03,0.18075000D+01,0.19496000D+01
     .,0.47010710D+03,0.288D+03,0.213D+03,0.18075000D+01,0.19311000D+01
     .,0.44845450D+03,0.288D+03,0.214D+03,0.18075000D+01,0.19435000D+01
     .,0.38732870D+03,0.288D+03,0.215D+03,0.18075000D+01,0.20102000D+01
     .,0.32337880D+03,0.288D+03,0.216D+03,0.18075000D+01,0.19903000D+01
     .,0.54493370D+03,0.288D+03,0.220D+03,0.18075000D+01,0.19349000D+01
     .,0.52129830D+03,0.288D+03,0.221D+03,0.18075000D+01,0.28999000D+01
     .,0.52752920D+03,0.288D+03,0.222D+03,0.18075000D+01,0.38675000D+01
     .,0.48302220D+03,0.288D+03,0.223D+03,0.18075000D+01,0.29110000D+01
     ./)
      grimme_c6_parameters( 133801: 133900)=(/
     . 0.36126840D+03,0.288D+03,0.224D+03,0.18075000D+01,0.10619100D+02
     .,0.30772170D+03,0.288D+03,0.225D+03,0.18075000D+01,0.98849000D+01
     .,0.30218010D+03,0.288D+03,0.226D+03,0.18075000D+01,0.91376000D+01
     .,0.35673210D+03,0.288D+03,0.227D+03,0.18075000D+01,0.29263000D+01
     .,0.33160290D+03,0.288D+03,0.228D+03,0.18075000D+01,0.65458000D+01
     .,0.47243170D+03,0.288D+03,0.231D+03,0.18075000D+01,0.19315000D+01
     .,0.49753330D+03,0.288D+03,0.232D+03,0.18075000D+01,0.19447000D+01
     .,0.45357900D+03,0.288D+03,0.233D+03,0.18075000D+01,0.19793000D+01
     .,0.42057420D+03,0.288D+03,0.234D+03,0.18075000D+01,0.19812000D+01
     .,0.65272580D+03,0.288D+03,0.238D+03,0.18075000D+01,0.19143000D+01
     .,0.62438560D+03,0.288D+03,0.239D+03,0.18075000D+01,0.28903000D+01
     .,0.62866890D+03,0.288D+03,0.240D+03,0.18075000D+01,0.39106000D+01
     .,0.60842970D+03,0.288D+03,0.241D+03,0.18075000D+01,0.29225000D+01
     .,0.53532960D+03,0.288D+03,0.242D+03,0.18075000D+01,0.11055600D+02
     .,0.47069610D+03,0.288D+03,0.243D+03,0.18075000D+01,0.95402000D+01
     .,0.44413890D+03,0.288D+03,0.244D+03,0.18075000D+01,0.88895000D+01
     .,0.45438240D+03,0.288D+03,0.245D+03,0.18075000D+01,0.29696000D+01
     .,0.47518820D+03,0.288D+03,0.246D+03,0.18075000D+01,0.57095000D+01
     .,0.60862900D+03,0.288D+03,0.249D+03,0.18075000D+01,0.19378000D+01
     .,0.66134830D+03,0.288D+03,0.250D+03,0.18075000D+01,0.19505000D+01
     ./)
      grimme_c6_parameters( 133901: 134000)=(/
     . 0.62001070D+03,0.288D+03,0.251D+03,0.18075000D+01,0.19523000D+01
     .,0.59661110D+03,0.288D+03,0.252D+03,0.18075000D+01,0.19639000D+01
     .,0.78841700D+03,0.288D+03,0.256D+03,0.18075000D+01,0.18467000D+01
     .,0.81437400D+03,0.288D+03,0.257D+03,0.18075000D+01,0.29175000D+01
     .,0.60044820D+03,0.288D+03,0.272D+03,0.18075000D+01,0.38840000D+01
     .,0.62883490D+03,0.288D+03,0.273D+03,0.18075000D+01,0.28988000D+01
     .,0.58136160D+03,0.288D+03,0.274D+03,0.18075000D+01,0.10915300D+02
     .,0.52620370D+03,0.288D+03,0.275D+03,0.18075000D+01,0.98054000D+01
     .,0.49362900D+03,0.288D+03,0.276D+03,0.18075000D+01,0.91527000D+01
     .,0.50521810D+03,0.288D+03,0.277D+03,0.18075000D+01,0.29424000D+01
     .,0.53138910D+03,0.288D+03,0.278D+03,0.18075000D+01,0.66669000D+01
     .,0.64808000D+03,0.288D+03,0.281D+03,0.18075000D+01,0.19302000D+01
     .,0.68468130D+03,0.288D+03,0.282D+03,0.18075000D+01,0.19356000D+01
     .,0.69650710D+03,0.288D+03,0.283D+03,0.18075000D+01,0.19655000D+01
     .,0.69009760D+03,0.288D+03,0.284D+03,0.18075000D+01,0.19639000D+01
     .,0.86755840D+03,0.288D+03,0.288D+03,0.18075000D+01,0.18075000D+01
     .,0.97472000D+01,0.305D+03,0.100D+01,0.29128000D+01,0.91180000D+00
     .,0.66434000D+01,0.305D+03,0.200D+01,0.29128000D+01,0.00000000D+00
     .,0.12998750D+03,0.305D+03,0.300D+01,0.29128000D+01,0.00000000D+00
     .,0.80427600D+02,0.305D+03,0.400D+01,0.29128000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 134001: 134100)=(/
     . 0.56411600D+02,0.305D+03,0.500D+01,0.29128000D+01,0.00000000D+00
     .,0.39244900D+02,0.305D+03,0.600D+01,0.29128000D+01,0.00000000D+00
     .,0.28012900D+02,0.305D+03,0.700D+01,0.29128000D+01,0.00000000D+00
     .,0.21498900D+02,0.305D+03,0.800D+01,0.29128000D+01,0.00000000D+00
     .,0.16460700D+02,0.305D+03,0.900D+01,0.29128000D+01,0.00000000D+00
     .,0.12757700D+02,0.305D+03,0.100D+02,0.29128000D+01,0.00000000D+00
     .,0.15611380D+03,0.305D+03,0.110D+02,0.29128000D+01,0.00000000D+00
     .,0.12654250D+03,0.305D+03,0.120D+02,0.29128000D+01,0.00000000D+00
     .,0.11915450D+03,0.305D+03,0.130D+02,0.29128000D+01,0.00000000D+00
     .,0.96531300D+02,0.305D+03,0.140D+02,0.29128000D+01,0.00000000D+00
     .,0.77042900D+02,0.305D+03,0.150D+02,0.29128000D+01,0.00000000D+00
     .,0.64891800D+02,0.305D+03,0.160D+02,0.29128000D+01,0.00000000D+00
     .,0.53734300D+02,0.305D+03,0.170D+02,0.29128000D+01,0.00000000D+00
     .,0.44461300D+02,0.305D+03,0.180D+02,0.29128000D+01,0.00000000D+00
     .,0.25422370D+03,0.305D+03,0.190D+02,0.29128000D+01,0.00000000D+00
     .,0.21794570D+03,0.305D+03,0.200D+02,0.29128000D+01,0.00000000D+00
     .,0.18168340D+03,0.305D+03,0.210D+02,0.29128000D+01,0.00000000D+00
     .,0.17706600D+03,0.305D+03,0.220D+02,0.29128000D+01,0.00000000D+00
     .,0.16299900D+03,0.305D+03,0.230D+02,0.29128000D+01,0.00000000D+00
     .,0.12872330D+03,0.305D+03,0.240D+02,0.29128000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 134101: 134200)=(/
     . 0.14140710D+03,0.305D+03,0.250D+02,0.29128000D+01,0.00000000D+00
     .,0.11135690D+03,0.305D+03,0.260D+02,0.29128000D+01,0.00000000D+00
     .,0.11910910D+03,0.305D+03,0.270D+02,0.29128000D+01,0.00000000D+00
     .,0.12201440D+03,0.305D+03,0.280D+02,0.29128000D+01,0.00000000D+00
     .,0.93766000D+02,0.305D+03,0.290D+02,0.29128000D+01,0.00000000D+00
     .,0.97684500D+02,0.305D+03,0.300D+02,0.29128000D+01,0.00000000D+00
     .,0.11517060D+03,0.305D+03,0.310D+02,0.29128000D+01,0.00000000D+00
     .,0.10369470D+03,0.305D+03,0.320D+02,0.29128000D+01,0.00000000D+00
     .,0.90137300D+02,0.305D+03,0.330D+02,0.29128000D+01,0.00000000D+00
     .,0.81838100D+02,0.305D+03,0.340D+02,0.29128000D+01,0.00000000D+00
     .,0.72461300D+02,0.305D+03,0.350D+02,0.29128000D+01,0.00000000D+00
     .,0.63676800D+02,0.305D+03,0.360D+02,0.29128000D+01,0.00000000D+00
     .,0.28624860D+03,0.305D+03,0.370D+02,0.29128000D+01,0.00000000D+00
     .,0.25952790D+03,0.305D+03,0.380D+02,0.29128000D+01,0.00000000D+00
     .,0.23111730D+03,0.305D+03,0.390D+02,0.29128000D+01,0.00000000D+00
     .,0.20990660D+03,0.305D+03,0.400D+02,0.29128000D+01,0.00000000D+00
     .,0.19277650D+03,0.305D+03,0.410D+02,0.29128000D+01,0.00000000D+00
     .,0.15074470D+03,0.305D+03,0.420D+02,0.29128000D+01,0.00000000D+00
     .,0.16737830D+03,0.305D+03,0.430D+02,0.29128000D+01,0.00000000D+00
     .,0.12927260D+03,0.305D+03,0.440D+02,0.29128000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 134201: 134300)=(/
     . 0.14111090D+03,0.305D+03,0.450D+02,0.29128000D+01,0.00000000D+00
     .,0.13140190D+03,0.305D+03,0.460D+02,0.29128000D+01,0.00000000D+00
     .,0.10947410D+03,0.305D+03,0.470D+02,0.29128000D+01,0.00000000D+00
     .,0.11639220D+03,0.305D+03,0.480D+02,0.29128000D+01,0.00000000D+00
     .,0.14412590D+03,0.305D+03,0.490D+02,0.29128000D+01,0.00000000D+00
     .,0.13544390D+03,0.305D+03,0.500D+02,0.29128000D+01,0.00000000D+00
     .,0.12268730D+03,0.305D+03,0.510D+02,0.29128000D+01,0.00000000D+00
     .,0.11497520D+03,0.305D+03,0.520D+02,0.29128000D+01,0.00000000D+00
     .,0.10506600D+03,0.305D+03,0.530D+02,0.29128000D+01,0.00000000D+00
     .,0.95397300D+02,0.305D+03,0.540D+02,0.29128000D+01,0.00000000D+00
     .,0.34948600D+03,0.305D+03,0.550D+02,0.29128000D+01,0.00000000D+00
     .,0.32947840D+03,0.305D+03,0.560D+02,0.29128000D+01,0.00000000D+00
     .,0.29416920D+03,0.305D+03,0.570D+02,0.29128000D+01,0.00000000D+00
     .,0.14462380D+03,0.305D+03,0.580D+02,0.29128000D+01,0.27991000D+01
     .,0.29344860D+03,0.305D+03,0.590D+02,0.29128000D+01,0.00000000D+00
     .,0.28246410D+03,0.305D+03,0.600D+02,0.29128000D+01,0.00000000D+00
     .,0.27556100D+03,0.305D+03,0.610D+02,0.29128000D+01,0.00000000D+00
     .,0.26918990D+03,0.305D+03,0.620D+02,0.29128000D+01,0.00000000D+00
     .,0.26354840D+03,0.305D+03,0.630D+02,0.29128000D+01,0.00000000D+00
     .,0.21125650D+03,0.305D+03,0.640D+02,0.29128000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 134301: 134400)=(/
     . 0.23210280D+03,0.305D+03,0.650D+02,0.29128000D+01,0.00000000D+00
     .,0.22459400D+03,0.305D+03,0.660D+02,0.29128000D+01,0.00000000D+00
     .,0.23859840D+03,0.305D+03,0.670D+02,0.29128000D+01,0.00000000D+00
     .,0.23361550D+03,0.305D+03,0.680D+02,0.29128000D+01,0.00000000D+00
     .,0.22917770D+03,0.305D+03,0.690D+02,0.29128000D+01,0.00000000D+00
     .,0.22630560D+03,0.305D+03,0.700D+02,0.29128000D+01,0.00000000D+00
     .,0.19318890D+03,0.305D+03,0.710D+02,0.29128000D+01,0.00000000D+00
     .,0.19317020D+03,0.305D+03,0.720D+02,0.29128000D+01,0.00000000D+00
     .,0.17812490D+03,0.305D+03,0.730D+02,0.29128000D+01,0.00000000D+00
     .,0.15179460D+03,0.305D+03,0.740D+02,0.29128000D+01,0.00000000D+00
     .,0.15495640D+03,0.305D+03,0.750D+02,0.29128000D+01,0.00000000D+00
     .,0.14166610D+03,0.305D+03,0.760D+02,0.29128000D+01,0.00000000D+00
     .,0.13065360D+03,0.305D+03,0.770D+02,0.29128000D+01,0.00000000D+00
     .,0.10940400D+03,0.305D+03,0.780D+02,0.29128000D+01,0.00000000D+00
     .,0.10252010D+03,0.305D+03,0.790D+02,0.29128000D+01,0.00000000D+00
     .,0.10573840D+03,0.305D+03,0.800D+02,0.29128000D+01,0.00000000D+00
     .,0.14882270D+03,0.305D+03,0.810D+02,0.29128000D+01,0.00000000D+00
     .,0.14721780D+03,0.305D+03,0.820D+02,0.29128000D+01,0.00000000D+00
     .,0.13720280D+03,0.305D+03,0.830D+02,0.29128000D+01,0.00000000D+00
     .,0.13195960D+03,0.305D+03,0.840D+02,0.29128000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 134401: 134500)=(/
     . 0.12301010D+03,0.305D+03,0.850D+02,0.29128000D+01,0.00000000D+00
     .,0.11377160D+03,0.305D+03,0.860D+02,0.29128000D+01,0.00000000D+00
     .,0.33435640D+03,0.305D+03,0.870D+02,0.29128000D+01,0.00000000D+00
     .,0.32867970D+03,0.305D+03,0.880D+02,0.29128000D+01,0.00000000D+00
     .,0.29472000D+03,0.305D+03,0.890D+02,0.29128000D+01,0.00000000D+00
     .,0.26950210D+03,0.305D+03,0.900D+02,0.29128000D+01,0.00000000D+00
     .,0.26545030D+03,0.305D+03,0.910D+02,0.29128000D+01,0.00000000D+00
     .,0.25712540D+03,0.305D+03,0.920D+02,0.29128000D+01,0.00000000D+00
     .,0.26182830D+03,0.305D+03,0.930D+02,0.29128000D+01,0.00000000D+00
     .,0.25402630D+03,0.305D+03,0.940D+02,0.29128000D+01,0.00000000D+00
     .,0.15353100D+02,0.305D+03,0.101D+03,0.29128000D+01,0.00000000D+00
     .,0.47033800D+02,0.305D+03,0.103D+03,0.29128000D+01,0.98650000D+00
     .,0.60523400D+02,0.305D+03,0.104D+03,0.29128000D+01,0.98080000D+00
     .,0.47858000D+02,0.305D+03,0.105D+03,0.29128000D+01,0.97060000D+00
     .,0.36816600D+02,0.305D+03,0.106D+03,0.29128000D+01,0.98680000D+00
     .,0.26148100D+02,0.305D+03,0.107D+03,0.29128000D+01,0.99440000D+00
     .,0.19357100D+02,0.305D+03,0.108D+03,0.29128000D+01,0.99250000D+00
     .,0.13558100D+02,0.305D+03,0.109D+03,0.29128000D+01,0.99820000D+00
     .,0.68275500D+02,0.305D+03,0.111D+03,0.29128000D+01,0.96840000D+00
     .,0.10530540D+03,0.305D+03,0.112D+03,0.29128000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters( 134501: 134600)=(/
     . 0.10855170D+03,0.305D+03,0.113D+03,0.29128000D+01,0.96480000D+00
     .,0.89594800D+02,0.305D+03,0.114D+03,0.29128000D+01,0.95070000D+00
     .,0.74849700D+02,0.305D+03,0.115D+03,0.29128000D+01,0.99470000D+00
     .,0.64157300D+02,0.305D+03,0.116D+03,0.29128000D+01,0.99480000D+00
     .,0.53163800D+02,0.305D+03,0.117D+03,0.29128000D+01,0.99720000D+00
     .,0.95849700D+02,0.305D+03,0.119D+03,0.29128000D+01,0.97670000D+00
     .,0.17514340D+03,0.305D+03,0.120D+03,0.29128000D+01,0.98310000D+00
     .,0.97755000D+02,0.305D+03,0.121D+03,0.29128000D+01,0.18627000D+01
     .,0.94475800D+02,0.305D+03,0.122D+03,0.29128000D+01,0.18299000D+01
     .,0.92545100D+02,0.305D+03,0.123D+03,0.29128000D+01,0.19138000D+01
     .,0.91452800D+02,0.305D+03,0.124D+03,0.29128000D+01,0.18269000D+01
     .,0.85131200D+02,0.305D+03,0.125D+03,0.29128000D+01,0.16406000D+01
     .,0.79083200D+02,0.305D+03,0.126D+03,0.29128000D+01,0.16483000D+01
     .,0.75452500D+02,0.305D+03,0.127D+03,0.29128000D+01,0.17149000D+01
     .,0.73686500D+02,0.305D+03,0.128D+03,0.29128000D+01,0.17937000D+01
     .,0.72121600D+02,0.305D+03,0.129D+03,0.29128000D+01,0.95760000D+00
     .,0.68807700D+02,0.305D+03,0.130D+03,0.29128000D+01,0.19419000D+01
     .,0.10875080D+03,0.305D+03,0.131D+03,0.29128000D+01,0.96010000D+00
     .,0.97495300D+02,0.305D+03,0.132D+03,0.29128000D+01,0.94340000D+00
     .,0.88710800D+02,0.305D+03,0.133D+03,0.29128000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters( 134601: 134700)=(/
     . 0.81856400D+02,0.305D+03,0.134D+03,0.29128000D+01,0.99010000D+00
     .,0.72922100D+02,0.305D+03,0.135D+03,0.29128000D+01,0.99740000D+00
     .,0.11497210D+03,0.305D+03,0.137D+03,0.29128000D+01,0.97380000D+00
     .,0.21287590D+03,0.305D+03,0.138D+03,0.29128000D+01,0.98010000D+00
     .,0.16813540D+03,0.305D+03,0.139D+03,0.29128000D+01,0.19153000D+01
     .,0.12924090D+03,0.305D+03,0.140D+03,0.29128000D+01,0.19355000D+01
     .,0.13043790D+03,0.305D+03,0.141D+03,0.29128000D+01,0.19545000D+01
     .,0.12219410D+03,0.305D+03,0.142D+03,0.29128000D+01,0.19420000D+01
     .,0.13497050D+03,0.305D+03,0.143D+03,0.29128000D+01,0.16682000D+01
     .,0.10771280D+03,0.305D+03,0.144D+03,0.29128000D+01,0.18584000D+01
     .,0.10089580D+03,0.305D+03,0.145D+03,0.29128000D+01,0.19003000D+01
     .,0.93899700D+02,0.305D+03,0.146D+03,0.29128000D+01,0.18630000D+01
     .,0.90650800D+02,0.305D+03,0.147D+03,0.29128000D+01,0.96790000D+00
     .,0.90427700D+02,0.305D+03,0.148D+03,0.29128000D+01,0.19539000D+01
     .,0.13818550D+03,0.305D+03,0.149D+03,0.29128000D+01,0.96330000D+00
     .,0.12714090D+03,0.305D+03,0.150D+03,0.29128000D+01,0.95140000D+00
     .,0.12050990D+03,0.305D+03,0.151D+03,0.29128000D+01,0.97490000D+00
     .,0.11496400D+03,0.305D+03,0.152D+03,0.29128000D+01,0.98110000D+00
     .,0.10603500D+03,0.305D+03,0.153D+03,0.29128000D+01,0.99680000D+00
     .,0.13780050D+03,0.305D+03,0.155D+03,0.29128000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters( 134701: 134800)=(/
     . 0.27459140D+03,0.305D+03,0.156D+03,0.29128000D+01,0.97970000D+00
     .,0.21235690D+03,0.305D+03,0.157D+03,0.29128000D+01,0.19373000D+01
     .,0.14039590D+03,0.305D+03,0.159D+03,0.29128000D+01,0.29425000D+01
     .,0.13751220D+03,0.305D+03,0.160D+03,0.29128000D+01,0.29455000D+01
     .,0.13326430D+03,0.305D+03,0.161D+03,0.29128000D+01,0.29413000D+01
     .,0.13360610D+03,0.305D+03,0.162D+03,0.29128000D+01,0.29300000D+01
     .,0.12777250D+03,0.305D+03,0.163D+03,0.29128000D+01,0.18286000D+01
     .,0.13432640D+03,0.305D+03,0.164D+03,0.29128000D+01,0.28732000D+01
     .,0.12641840D+03,0.305D+03,0.165D+03,0.29128000D+01,0.29086000D+01
     .,0.12810090D+03,0.305D+03,0.166D+03,0.29128000D+01,0.28965000D+01
     .,0.12023750D+03,0.305D+03,0.167D+03,0.29128000D+01,0.29242000D+01
     .,0.11690070D+03,0.305D+03,0.168D+03,0.29128000D+01,0.29282000D+01
     .,0.11607540D+03,0.305D+03,0.169D+03,0.29128000D+01,0.29246000D+01
     .,0.12156170D+03,0.305D+03,0.170D+03,0.29128000D+01,0.28482000D+01
     .,0.11232440D+03,0.305D+03,0.171D+03,0.29128000D+01,0.29219000D+01
     .,0.14812250D+03,0.305D+03,0.172D+03,0.29128000D+01,0.19254000D+01
     .,0.13881710D+03,0.305D+03,0.173D+03,0.29128000D+01,0.19459000D+01
     .,0.12792520D+03,0.305D+03,0.174D+03,0.29128000D+01,0.19292000D+01
     .,0.12830620D+03,0.305D+03,0.175D+03,0.29128000D+01,0.18104000D+01
     .,0.11489450D+03,0.305D+03,0.176D+03,0.29128000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters( 134801: 134900)=(/
     . 0.10845800D+03,0.305D+03,0.177D+03,0.29128000D+01,0.18648000D+01
     .,0.10379770D+03,0.305D+03,0.178D+03,0.29128000D+01,0.19188000D+01
     .,0.99205000D+02,0.305D+03,0.179D+03,0.29128000D+01,0.98460000D+00
     .,0.96600200D+02,0.305D+03,0.180D+03,0.29128000D+01,0.19896000D+01
     .,0.14899930D+03,0.305D+03,0.181D+03,0.29128000D+01,0.92670000D+00
     .,0.13799420D+03,0.305D+03,0.182D+03,0.29128000D+01,0.93830000D+00
     .,0.13500470D+03,0.305D+03,0.183D+03,0.29128000D+01,0.98200000D+00
     .,0.13215970D+03,0.305D+03,0.184D+03,0.29128000D+01,0.98150000D+00
     .,0.12451480D+03,0.305D+03,0.185D+03,0.29128000D+01,0.99540000D+00
     .,0.15534870D+03,0.305D+03,0.187D+03,0.29128000D+01,0.97050000D+00
     .,0.27595780D+03,0.305D+03,0.188D+03,0.29128000D+01,0.96620000D+00
     .,0.16604890D+03,0.305D+03,0.189D+03,0.29128000D+01,0.29070000D+01
     .,0.18911370D+03,0.305D+03,0.190D+03,0.29128000D+01,0.28844000D+01
     .,0.17001950D+03,0.305D+03,0.191D+03,0.29128000D+01,0.28738000D+01
     .,0.15177090D+03,0.305D+03,0.192D+03,0.29128000D+01,0.28878000D+01
     .,0.14638890D+03,0.305D+03,0.193D+03,0.29128000D+01,0.29095000D+01
     .,0.17106450D+03,0.305D+03,0.194D+03,0.29128000D+01,0.19209000D+01
     .,0.40935800D+02,0.305D+03,0.204D+03,0.29128000D+01,0.19697000D+01
     .,0.40519200D+02,0.305D+03,0.205D+03,0.29128000D+01,0.19441000D+01
     .,0.30353600D+02,0.305D+03,0.206D+03,0.29128000D+01,0.19985000D+01
     ./)
      grimme_c6_parameters( 134901: 135000)=(/
     . 0.24591900D+02,0.305D+03,0.207D+03,0.29128000D+01,0.20143000D+01
     .,0.17142400D+02,0.305D+03,0.208D+03,0.29128000D+01,0.19887000D+01
     .,0.71302300D+02,0.305D+03,0.212D+03,0.29128000D+01,0.19496000D+01
     .,0.86053200D+02,0.305D+03,0.213D+03,0.29128000D+01,0.19311000D+01
     .,0.83658600D+02,0.305D+03,0.214D+03,0.29128000D+01,0.19435000D+01
     .,0.73739700D+02,0.305D+03,0.215D+03,0.29128000D+01,0.20102000D+01
     .,0.62878300D+02,0.305D+03,0.216D+03,0.29128000D+01,0.19903000D+01
     .,0.10006100D+03,0.305D+03,0.220D+03,0.29128000D+01,0.19349000D+01
     .,0.97163200D+02,0.305D+03,0.221D+03,0.29128000D+01,0.28999000D+01
     .,0.98436300D+02,0.305D+03,0.222D+03,0.29128000D+01,0.38675000D+01
     .,0.90057400D+02,0.305D+03,0.223D+03,0.29128000D+01,0.29110000D+01
     .,0.68995800D+02,0.305D+03,0.224D+03,0.29128000D+01,0.10619100D+02
     .,0.59631300D+02,0.305D+03,0.225D+03,0.29128000D+01,0.98849000D+01
     .,0.58451500D+02,0.305D+03,0.226D+03,0.29128000D+01,0.91376000D+01
     .,0.67393200D+02,0.305D+03,0.227D+03,0.29128000D+01,0.29263000D+01
     .,0.63074000D+02,0.305D+03,0.228D+03,0.29128000D+01,0.65458000D+01
     .,0.87768800D+02,0.305D+03,0.231D+03,0.29128000D+01,0.19315000D+01
     .,0.93130100D+02,0.305D+03,0.232D+03,0.29128000D+01,0.19447000D+01
     .,0.86548600D+02,0.305D+03,0.233D+03,0.29128000D+01,0.19793000D+01
     .,0.81240000D+02,0.305D+03,0.234D+03,0.29128000D+01,0.19812000D+01
     ./)
      grimme_c6_parameters( 135001: 135100)=(/
     . 0.12013000D+03,0.305D+03,0.238D+03,0.29128000D+01,0.19143000D+01
     .,0.11715700D+03,0.305D+03,0.239D+03,0.29128000D+01,0.28903000D+01
     .,0.11862430D+03,0.305D+03,0.240D+03,0.29128000D+01,0.39106000D+01
     .,0.11463280D+03,0.305D+03,0.241D+03,0.29128000D+01,0.29225000D+01
     .,0.10248830D+03,0.305D+03,0.242D+03,0.29128000D+01,0.11055600D+02
     .,0.91251800D+02,0.305D+03,0.243D+03,0.29128000D+01,0.95402000D+01
     .,0.86498600D+02,0.305D+03,0.244D+03,0.29128000D+01,0.88895000D+01
     .,0.87237600D+02,0.305D+03,0.245D+03,0.29128000D+01,0.29696000D+01
     .,0.90828400D+02,0.305D+03,0.246D+03,0.29128000D+01,0.57095000D+01
     .,0.11348260D+03,0.305D+03,0.249D+03,0.29128000D+01,0.19378000D+01
     .,0.12333400D+03,0.305D+03,0.250D+03,0.29128000D+01,0.19505000D+01
     .,0.11753380D+03,0.305D+03,0.251D+03,0.29128000D+01,0.19523000D+01
     .,0.11415530D+03,0.305D+03,0.252D+03,0.29128000D+01,0.19639000D+01
     .,0.14593300D+03,0.305D+03,0.256D+03,0.29128000D+01,0.18467000D+01
     .,0.15222500D+03,0.305D+03,0.257D+03,0.29128000D+01,0.29175000D+01
     .,0.11417940D+03,0.305D+03,0.272D+03,0.29128000D+01,0.38840000D+01
     .,0.11873150D+03,0.305D+03,0.273D+03,0.29128000D+01,0.28988000D+01
     .,0.11142620D+03,0.305D+03,0.274D+03,0.29128000D+01,0.10915300D+02
     .,0.10200810D+03,0.305D+03,0.275D+03,0.29128000D+01,0.98054000D+01
     .,0.96570600D+02,0.305D+03,0.276D+03,0.29128000D+01,0.91527000D+01
     ./)
      grimme_c6_parameters( 135101: 135200)=(/
     . 0.97623800D+02,0.305D+03,0.277D+03,0.29128000D+01,0.29424000D+01
     .,0.10254510D+03,0.305D+03,0.278D+03,0.29128000D+01,0.66669000D+01
     .,0.12215410D+03,0.305D+03,0.281D+03,0.29128000D+01,0.19302000D+01
     .,0.12915240D+03,0.305D+03,0.282D+03,0.29128000D+01,0.19356000D+01
     .,0.13219470D+03,0.305D+03,0.283D+03,0.29128000D+01,0.19655000D+01
     .,0.13178890D+03,0.305D+03,0.284D+03,0.29128000D+01,0.19639000D+01
     .,0.16086740D+03,0.305D+03,0.288D+03,0.29128000D+01,0.18075000D+01
     .,0.31443600D+02,0.305D+03,0.305D+03,0.29128000D+01,0.29128000D+01
     .,0.88210000D+01,0.306D+03,0.100D+01,0.29987000D+01,0.91180000D+00
     .,0.61196000D+01,0.306D+03,0.200D+01,0.29987000D+01,0.00000000D+00
     .,0.11594980D+03,0.306D+03,0.300D+01,0.29987000D+01,0.00000000D+00
     .,0.71681800D+02,0.306D+03,0.400D+01,0.29987000D+01,0.00000000D+00
     .,0.50530300D+02,0.306D+03,0.500D+01,0.29987000D+01,0.00000000D+00
     .,0.35412900D+02,0.306D+03,0.600D+01,0.29987000D+01,0.00000000D+00
     .,0.25479900D+02,0.306D+03,0.700D+01,0.29987000D+01,0.00000000D+00
     .,0.19694300D+02,0.306D+03,0.800D+01,0.29987000D+01,0.00000000D+00
     .,0.15188300D+02,0.306D+03,0.900D+01,0.29987000D+01,0.00000000D+00
     .,0.11851300D+02,0.306D+03,0.100D+02,0.29987000D+01,0.00000000D+00
     .,0.13937530D+03,0.306D+03,0.110D+02,0.29987000D+01,0.00000000D+00
     .,0.11282100D+03,0.306D+03,0.120D+02,0.29987000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 135201: 135300)=(/
     . 0.10635080D+03,0.306D+03,0.130D+02,0.29987000D+01,0.00000000D+00
     .,0.86399900D+02,0.306D+03,0.140D+02,0.29987000D+01,0.00000000D+00
     .,0.69251500D+02,0.306D+03,0.150D+02,0.29987000D+01,0.00000000D+00
     .,0.58577600D+02,0.306D+03,0.160D+02,0.29987000D+01,0.00000000D+00
     .,0.48744800D+02,0.306D+03,0.170D+02,0.29987000D+01,0.00000000D+00
     .,0.40544100D+02,0.306D+03,0.180D+02,0.29987000D+01,0.00000000D+00
     .,0.22766000D+03,0.306D+03,0.190D+02,0.29987000D+01,0.00000000D+00
     .,0.19467190D+03,0.306D+03,0.200D+02,0.29987000D+01,0.00000000D+00
     .,0.16226090D+03,0.306D+03,0.210D+02,0.29987000D+01,0.00000000D+00
     .,0.15827050D+03,0.306D+03,0.220D+02,0.29987000D+01,0.00000000D+00
     .,0.14575800D+03,0.306D+03,0.230D+02,0.29987000D+01,0.00000000D+00
     .,0.11536970D+03,0.306D+03,0.240D+02,0.29987000D+01,0.00000000D+00
     .,0.12654160D+03,0.306D+03,0.250D+02,0.29987000D+01,0.00000000D+00
     .,0.99901700D+02,0.306D+03,0.260D+02,0.29987000D+01,0.00000000D+00
     .,0.10669170D+03,0.306D+03,0.270D+02,0.29987000D+01,0.00000000D+00
     .,0.10923050D+03,0.306D+03,0.280D+02,0.29987000D+01,0.00000000D+00
     .,0.84202800D+02,0.306D+03,0.290D+02,0.29987000D+01,0.00000000D+00
     .,0.87612400D+02,0.306D+03,0.300D+02,0.29987000D+01,0.00000000D+00
     .,0.10307380D+03,0.306D+03,0.310D+02,0.29987000D+01,0.00000000D+00
     .,0.92962100D+02,0.306D+03,0.320D+02,0.29987000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 135301: 135400)=(/
     . 0.81056300D+02,0.306D+03,0.330D+02,0.29987000D+01,0.00000000D+00
     .,0.73806400D+02,0.306D+03,0.340D+02,0.29987000D+01,0.00000000D+00
     .,0.65586800D+02,0.306D+03,0.350D+02,0.29987000D+01,0.00000000D+00
     .,0.57866500D+02,0.306D+03,0.360D+02,0.29987000D+01,0.00000000D+00
     .,0.25651980D+03,0.306D+03,0.370D+02,0.29987000D+01,0.00000000D+00
     .,0.23200320D+03,0.306D+03,0.380D+02,0.29987000D+01,0.00000000D+00
     .,0.20665890D+03,0.306D+03,0.390D+02,0.29987000D+01,0.00000000D+00
     .,0.18782030D+03,0.306D+03,0.400D+02,0.29987000D+01,0.00000000D+00
     .,0.17263950D+03,0.306D+03,0.410D+02,0.29987000D+01,0.00000000D+00
     .,0.13537160D+03,0.306D+03,0.420D+02,0.29987000D+01,0.00000000D+00
     .,0.15013980D+03,0.306D+03,0.430D+02,0.29987000D+01,0.00000000D+00
     .,0.11632470D+03,0.306D+03,0.440D+02,0.29987000D+01,0.00000000D+00
     .,0.12677780D+03,0.306D+03,0.450D+02,0.29987000D+01,0.00000000D+00
     .,0.11814270D+03,0.306D+03,0.460D+02,0.29987000D+01,0.00000000D+00
     .,0.98703200D+02,0.306D+03,0.470D+02,0.29987000D+01,0.00000000D+00
     .,0.10476920D+03,0.306D+03,0.480D+02,0.29987000D+01,0.00000000D+00
     .,0.12938530D+03,0.306D+03,0.490D+02,0.29987000D+01,0.00000000D+00
     .,0.12165980D+03,0.306D+03,0.500D+02,0.29987000D+01,0.00000000D+00
     .,0.11040890D+03,0.306D+03,0.510D+02,0.29987000D+01,0.00000000D+00
     .,0.10365030D+03,0.306D+03,0.520D+02,0.29987000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 135401: 135500)=(/
     . 0.94948900D+02,0.306D+03,0.530D+02,0.29987000D+01,0.00000000D+00
     .,0.86458100D+02,0.306D+03,0.540D+02,0.29987000D+01,0.00000000D+00
     .,0.31323470D+03,0.306D+03,0.550D+02,0.29987000D+01,0.00000000D+00
     .,0.29471680D+03,0.306D+03,0.560D+02,0.29987000D+01,0.00000000D+00
     .,0.26313810D+03,0.306D+03,0.570D+02,0.29987000D+01,0.00000000D+00
     .,0.13023410D+03,0.306D+03,0.580D+02,0.29987000D+01,0.27991000D+01
     .,0.26266440D+03,0.306D+03,0.590D+02,0.29987000D+01,0.00000000D+00
     .,0.25281970D+03,0.306D+03,0.600D+02,0.29987000D+01,0.00000000D+00
     .,0.24663480D+03,0.306D+03,0.610D+02,0.29987000D+01,0.00000000D+00
     .,0.24092330D+03,0.306D+03,0.620D+02,0.29987000D+01,0.00000000D+00
     .,0.23586410D+03,0.306D+03,0.630D+02,0.29987000D+01,0.00000000D+00
     .,0.18938240D+03,0.306D+03,0.640D+02,0.29987000D+01,0.00000000D+00
     .,0.20816040D+03,0.306D+03,0.650D+02,0.29987000D+01,0.00000000D+00
     .,0.20142940D+03,0.306D+03,0.660D+02,0.29987000D+01,0.00000000D+00
     .,0.21351460D+03,0.306D+03,0.670D+02,0.29987000D+01,0.00000000D+00
     .,0.20904160D+03,0.306D+03,0.680D+02,0.29987000D+01,0.00000000D+00
     .,0.20505940D+03,0.306D+03,0.690D+02,0.29987000D+01,0.00000000D+00
     .,0.20246690D+03,0.306D+03,0.700D+02,0.29987000D+01,0.00000000D+00
     .,0.17301760D+03,0.306D+03,0.710D+02,0.29987000D+01,0.00000000D+00
     .,0.17295930D+03,0.306D+03,0.720D+02,0.29987000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 135501: 135600)=(/
     . 0.15967690D+03,0.306D+03,0.730D+02,0.29987000D+01,0.00000000D+00
     .,0.13642100D+03,0.306D+03,0.740D+02,0.29987000D+01,0.00000000D+00
     .,0.13925850D+03,0.306D+03,0.750D+02,0.29987000D+01,0.00000000D+00
     .,0.12750310D+03,0.306D+03,0.760D+02,0.29987000D+01,0.00000000D+00
     .,0.11776180D+03,0.306D+03,0.770D+02,0.29987000D+01,0.00000000D+00
     .,0.98928700D+02,0.306D+03,0.780D+02,0.29987000D+01,0.00000000D+00
     .,0.92827200D+02,0.306D+03,0.790D+02,0.29987000D+01,0.00000000D+00
     .,0.95685300D+02,0.306D+03,0.800D+02,0.29987000D+01,0.00000000D+00
     .,0.13397180D+03,0.306D+03,0.810D+02,0.29987000D+01,0.00000000D+00
     .,0.13250170D+03,0.306D+03,0.820D+02,0.29987000D+01,0.00000000D+00
     .,0.12364240D+03,0.306D+03,0.830D+02,0.29987000D+01,0.00000000D+00
     .,0.11905310D+03,0.306D+03,0.840D+02,0.29987000D+01,0.00000000D+00
     .,0.11119300D+03,0.306D+03,0.850D+02,0.29987000D+01,0.00000000D+00
     .,0.10307880D+03,0.306D+03,0.860D+02,0.29987000D+01,0.00000000D+00
     .,0.29972370D+03,0.306D+03,0.870D+02,0.29987000D+01,0.00000000D+00
     .,0.29409590D+03,0.306D+03,0.880D+02,0.29987000D+01,0.00000000D+00
     .,0.26375700D+03,0.306D+03,0.890D+02,0.29987000D+01,0.00000000D+00
     .,0.24153050D+03,0.306D+03,0.900D+02,0.29987000D+01,0.00000000D+00
     .,0.23801510D+03,0.306D+03,0.910D+02,0.29987000D+01,0.00000000D+00
     .,0.23059460D+03,0.306D+03,0.920D+02,0.29987000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 135601: 135700)=(/
     . 0.23475660D+03,0.306D+03,0.930D+02,0.29987000D+01,0.00000000D+00
     .,0.22776830D+03,0.306D+03,0.940D+02,0.29987000D+01,0.00000000D+00
     .,0.13799200D+02,0.306D+03,0.101D+03,0.29987000D+01,0.00000000D+00
     .,0.41971300D+02,0.306D+03,0.103D+03,0.29987000D+01,0.98650000D+00
     .,0.54077000D+02,0.306D+03,0.104D+03,0.29987000D+01,0.98080000D+00
     .,0.42964600D+02,0.306D+03,0.105D+03,0.29987000D+01,0.97060000D+00
     .,0.33254000D+02,0.306D+03,0.106D+03,0.29987000D+01,0.98680000D+00
     .,0.23813600D+02,0.306D+03,0.107D+03,0.29987000D+01,0.99440000D+00
     .,0.17775000D+02,0.306D+03,0.108D+03,0.29987000D+01,0.99250000D+00
     .,0.12597000D+02,0.306D+03,0.109D+03,0.29987000D+01,0.99820000D+00
     .,0.61017400D+02,0.306D+03,0.111D+03,0.29987000D+01,0.96840000D+00
     .,0.93997800D+02,0.306D+03,0.112D+03,0.29987000D+01,0.96280000D+00
     .,0.96956000D+02,0.306D+03,0.113D+03,0.29987000D+01,0.96480000D+00
     .,0.80261800D+02,0.306D+03,0.114D+03,0.29987000D+01,0.95070000D+00
     .,0.67308800D+02,0.306D+03,0.115D+03,0.29987000D+01,0.99470000D+00
     .,0.57922100D+02,0.306D+03,0.116D+03,0.29987000D+01,0.99480000D+00
     .,0.48232800D+02,0.306D+03,0.117D+03,0.29987000D+01,0.99720000D+00
     .,0.86148100D+02,0.306D+03,0.119D+03,0.29987000D+01,0.97670000D+00
     .,0.15677020D+03,0.306D+03,0.120D+03,0.29987000D+01,0.98310000D+00
     .,0.87815300D+02,0.306D+03,0.121D+03,0.29987000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters( 135701: 135800)=(/
     . 0.84925300D+02,0.306D+03,0.122D+03,0.29987000D+01,0.18299000D+01
     .,0.83211100D+02,0.306D+03,0.123D+03,0.29987000D+01,0.19138000D+01
     .,0.82233100D+02,0.306D+03,0.124D+03,0.29987000D+01,0.18269000D+01
     .,0.76584600D+02,0.306D+03,0.125D+03,0.29987000D+01,0.16406000D+01
     .,0.71211000D+02,0.306D+03,0.126D+03,0.29987000D+01,0.16483000D+01
     .,0.67977400D+02,0.306D+03,0.127D+03,0.29987000D+01,0.17149000D+01
     .,0.66389700D+02,0.306D+03,0.128D+03,0.29987000D+01,0.17937000D+01
     .,0.64964100D+02,0.306D+03,0.129D+03,0.29987000D+01,0.95760000D+00
     .,0.62022800D+02,0.306D+03,0.130D+03,0.29987000D+01,0.19419000D+01
     .,0.97383800D+02,0.306D+03,0.131D+03,0.29987000D+01,0.96010000D+00
     .,0.87478100D+02,0.306D+03,0.132D+03,0.29987000D+01,0.94340000D+00
     .,0.79798600D+02,0.306D+03,0.133D+03,0.29987000D+01,0.98890000D+00
     .,0.73825700D+02,0.306D+03,0.134D+03,0.29987000D+01,0.99010000D+00
     .,0.65996700D+02,0.306D+03,0.135D+03,0.29987000D+01,0.99740000D+00
     .,0.10345590D+03,0.306D+03,0.137D+03,0.29987000D+01,0.97380000D+00
     .,0.19069760D+03,0.306D+03,0.138D+03,0.29987000D+01,0.98010000D+00
     .,0.15078940D+03,0.306D+03,0.139D+03,0.29987000D+01,0.19153000D+01
     .,0.11619730D+03,0.306D+03,0.140D+03,0.29987000D+01,0.19355000D+01
     .,0.11730510D+03,0.306D+03,0.141D+03,0.29987000D+01,0.19545000D+01
     .,0.11002550D+03,0.306D+03,0.142D+03,0.29987000D+01,0.19420000D+01
     ./)
      grimme_c6_parameters( 135801: 135900)=(/
     . 0.12143810D+03,0.306D+03,0.143D+03,0.29987000D+01,0.16682000D+01
     .,0.97174400D+02,0.306D+03,0.144D+03,0.29987000D+01,0.18584000D+01
     .,0.91117100D+02,0.306D+03,0.145D+03,0.29987000D+01,0.19003000D+01
     .,0.84895400D+02,0.306D+03,0.146D+03,0.29987000D+01,0.18630000D+01
     .,0.81971500D+02,0.306D+03,0.147D+03,0.29987000D+01,0.96790000D+00
     .,0.81750000D+02,0.306D+03,0.148D+03,0.29987000D+01,0.19539000D+01
     .,0.12410850D+03,0.306D+03,0.149D+03,0.29987000D+01,0.96330000D+00
     .,0.11430720D+03,0.306D+03,0.150D+03,0.29987000D+01,0.95140000D+00
     .,0.10848830D+03,0.306D+03,0.151D+03,0.29987000D+01,0.97490000D+00
     .,0.10364770D+03,0.306D+03,0.152D+03,0.29987000D+01,0.98110000D+00
     .,0.95813900D+02,0.306D+03,0.153D+03,0.29987000D+01,0.99680000D+00
     .,0.12398030D+03,0.306D+03,0.155D+03,0.29987000D+01,0.99090000D+00
     .,0.24612560D+03,0.306D+03,0.156D+03,0.29987000D+01,0.97970000D+00
     .,0.19047850D+03,0.306D+03,0.157D+03,0.29987000D+01,0.19373000D+01
     .,0.12645720D+03,0.306D+03,0.159D+03,0.29987000D+01,0.29425000D+01
     .,0.12386820D+03,0.306D+03,0.160D+03,0.29987000D+01,0.29455000D+01
     .,0.12006680D+03,0.306D+03,0.161D+03,0.29987000D+01,0.29413000D+01
     .,0.12034080D+03,0.306D+03,0.162D+03,0.29987000D+01,0.29300000D+01
     .,0.11507330D+03,0.306D+03,0.163D+03,0.29987000D+01,0.18286000D+01
     .,0.12093240D+03,0.306D+03,0.164D+03,0.29987000D+01,0.28732000D+01
     ./)
      grimme_c6_parameters( 135901: 136000)=(/
     . 0.11387540D+03,0.306D+03,0.165D+03,0.29987000D+01,0.29086000D+01
     .,0.11534910D+03,0.306D+03,0.166D+03,0.29987000D+01,0.28965000D+01
     .,0.10832620D+03,0.306D+03,0.167D+03,0.29987000D+01,0.29242000D+01
     .,0.10533020D+03,0.306D+03,0.168D+03,0.29987000D+01,0.29282000D+01
     .,0.10456940D+03,0.306D+03,0.169D+03,0.29987000D+01,0.29246000D+01
     .,0.10938790D+03,0.306D+03,0.170D+03,0.29987000D+01,0.28482000D+01
     .,0.10119050D+03,0.306D+03,0.171D+03,0.29987000D+01,0.29219000D+01
     .,0.13303630D+03,0.306D+03,0.172D+03,0.29987000D+01,0.19254000D+01
     .,0.12486130D+03,0.306D+03,0.173D+03,0.29987000D+01,0.19459000D+01
     .,0.11526060D+03,0.306D+03,0.174D+03,0.29987000D+01,0.19292000D+01
     .,0.11551780D+03,0.306D+03,0.175D+03,0.29987000D+01,0.18104000D+01
     .,0.10377670D+03,0.306D+03,0.176D+03,0.29987000D+01,0.18858000D+01
     .,0.98098700D+02,0.306D+03,0.177D+03,0.29987000D+01,0.18648000D+01
     .,0.93979300D+02,0.306D+03,0.178D+03,0.29987000D+01,0.19188000D+01
     .,0.89905200D+02,0.306D+03,0.179D+03,0.29987000D+01,0.98460000D+00
     .,0.87593000D+02,0.306D+03,0.180D+03,0.29987000D+01,0.19896000D+01
     .,0.13410840D+03,0.306D+03,0.181D+03,0.29987000D+01,0.92670000D+00
     .,0.12432080D+03,0.306D+03,0.182D+03,0.29987000D+01,0.93830000D+00
     .,0.12170140D+03,0.306D+03,0.183D+03,0.29987000D+01,0.98200000D+00
     .,0.11924010D+03,0.306D+03,0.184D+03,0.29987000D+01,0.98150000D+00
     ./)
      grimme_c6_parameters( 136001: 136100)=(/
     . 0.11253730D+03,0.306D+03,0.185D+03,0.29987000D+01,0.99540000D+00
     .,0.13975100D+03,0.306D+03,0.187D+03,0.29987000D+01,0.97050000D+00
     .,0.24737300D+03,0.306D+03,0.188D+03,0.29987000D+01,0.96620000D+00
     .,0.14949980D+03,0.306D+03,0.189D+03,0.29987000D+01,0.29070000D+01
     .,0.17017100D+03,0.306D+03,0.190D+03,0.29987000D+01,0.28844000D+01
     .,0.15324030D+03,0.306D+03,0.191D+03,0.29987000D+01,0.28738000D+01
     .,0.13692210D+03,0.306D+03,0.192D+03,0.29987000D+01,0.28878000D+01
     .,0.13212700D+03,0.306D+03,0.193D+03,0.29987000D+01,0.29095000D+01
     .,0.15407130D+03,0.306D+03,0.194D+03,0.29987000D+01,0.19209000D+01
     .,0.36697700D+02,0.306D+03,0.204D+03,0.29987000D+01,0.19697000D+01
     .,0.36460400D+02,0.306D+03,0.205D+03,0.29987000D+01,0.19441000D+01
     .,0.27506300D+02,0.306D+03,0.206D+03,0.29987000D+01,0.19985000D+01
     .,0.22427900D+02,0.306D+03,0.207D+03,0.29987000D+01,0.20143000D+01
     .,0.15800900D+02,0.306D+03,0.208D+03,0.29987000D+01,0.19887000D+01
     .,0.63794400D+02,0.306D+03,0.212D+03,0.29987000D+01,0.19496000D+01
     .,0.77008700D+02,0.306D+03,0.213D+03,0.29987000D+01,0.19311000D+01
     .,0.74996700D+02,0.306D+03,0.214D+03,0.29987000D+01,0.19435000D+01
     .,0.66319400D+02,0.306D+03,0.215D+03,0.29987000D+01,0.20102000D+01
     .,0.56782600D+02,0.306D+03,0.216D+03,0.29987000D+01,0.19903000D+01
     .,0.89828500D+02,0.306D+03,0.220D+03,0.29987000D+01,0.19349000D+01
     ./)
      grimme_c6_parameters( 136101: 136200)=(/
     . 0.87304800D+02,0.306D+03,0.221D+03,0.29987000D+01,0.28999000D+01
     .,0.88470300D+02,0.306D+03,0.222D+03,0.29987000D+01,0.38675000D+01
     .,0.81022900D+02,0.306D+03,0.223D+03,0.29987000D+01,0.29110000D+01
     .,0.62396300D+02,0.306D+03,0.224D+03,0.29987000D+01,0.10619100D+02
     .,0.54067600D+02,0.306D+03,0.225D+03,0.29987000D+01,0.98849000D+01
     .,0.52992800D+02,0.306D+03,0.226D+03,0.29987000D+01,0.91376000D+01
     .,0.60851300D+02,0.306D+03,0.227D+03,0.29987000D+01,0.29263000D+01
     .,0.57004600D+02,0.306D+03,0.228D+03,0.29987000D+01,0.65458000D+01
     .,0.78781200D+02,0.306D+03,0.231D+03,0.29987000D+01,0.19315000D+01
     .,0.83613100D+02,0.306D+03,0.232D+03,0.29987000D+01,0.19447000D+01
     .,0.77887400D+02,0.306D+03,0.233D+03,0.29987000D+01,0.19793000D+01
     .,0.73281400D+02,0.306D+03,0.234D+03,0.29987000D+01,0.19812000D+01
     .,0.10796880D+03,0.306D+03,0.238D+03,0.29987000D+01,0.19143000D+01
     .,0.10538580D+03,0.306D+03,0.239D+03,0.29987000D+01,0.28903000D+01
     .,0.10676290D+03,0.306D+03,0.240D+03,0.29987000D+01,0.39106000D+01
     .,0.10327750D+03,0.306D+03,0.241D+03,0.29987000D+01,0.29225000D+01
     .,0.92598300D+02,0.306D+03,0.242D+03,0.29987000D+01,0.11055600D+02
     .,0.82649600D+02,0.306D+03,0.243D+03,0.29987000D+01,0.95402000D+01
     .,0.78436800D+02,0.306D+03,0.244D+03,0.29987000D+01,0.88895000D+01
     .,0.79027900D+02,0.306D+03,0.245D+03,0.29987000D+01,0.29696000D+01
     ./)
      grimme_c6_parameters( 136201: 136300)=(/
     . 0.82193000D+02,0.306D+03,0.246D+03,0.29987000D+01,0.57095000D+01
     .,0.10218770D+03,0.306D+03,0.249D+03,0.29987000D+01,0.19378000D+01
     .,0.11093720D+03,0.306D+03,0.250D+03,0.29987000D+01,0.19505000D+01
     .,0.10585840D+03,0.306D+03,0.251D+03,0.29987000D+01,0.19523000D+01
     .,0.10293730D+03,0.306D+03,0.252D+03,0.29987000D+01,0.19639000D+01
     .,0.13126760D+03,0.306D+03,0.256D+03,0.29987000D+01,0.18467000D+01
     .,0.13686860D+03,0.306D+03,0.257D+03,0.29987000D+01,0.29175000D+01
     .,0.10287240D+03,0.306D+03,0.272D+03,0.29987000D+01,0.38840000D+01
     .,0.10702160D+03,0.306D+03,0.273D+03,0.29987000D+01,0.28988000D+01
     .,0.10067270D+03,0.306D+03,0.274D+03,0.29987000D+01,0.10915300D+02
     .,0.92374800D+02,0.306D+03,0.275D+03,0.29987000D+01,0.98054000D+01
     .,0.87606400D+02,0.306D+03,0.276D+03,0.29987000D+01,0.91527000D+01
     .,0.88522700D+02,0.306D+03,0.277D+03,0.29987000D+01,0.29424000D+01
     .,0.92901000D+02,0.306D+03,0.278D+03,0.29987000D+01,0.66669000D+01
     .,0.11026110D+03,0.306D+03,0.281D+03,0.29987000D+01,0.19302000D+01
     .,0.11648110D+03,0.306D+03,0.282D+03,0.29987000D+01,0.19356000D+01
     .,0.11921790D+03,0.306D+03,0.283D+03,0.29987000D+01,0.19655000D+01
     .,0.11892080D+03,0.306D+03,0.284D+03,0.29987000D+01,0.19639000D+01
     .,0.14470670D+03,0.306D+03,0.288D+03,0.29987000D+01,0.18075000D+01
     .,0.28412100D+02,0.306D+03,0.305D+03,0.29987000D+01,0.29128000D+01
     ./)
      grimme_c6_parameters( 136301: 136400)=(/
     . 0.25780900D+02,0.306D+03,0.306D+03,0.29987000D+01,0.29987000D+01
     .,0.67746000D+01,0.307D+03,0.100D+01,0.29903000D+01,0.91180000D+00
     .,0.48836000D+01,0.307D+03,0.200D+01,0.29903000D+01,0.00000000D+00
     .,0.81977000D+02,0.307D+03,0.300D+01,0.29903000D+01,0.00000000D+00
     .,0.52023700D+02,0.307D+03,0.400D+01,0.29903000D+01,0.00000000D+00
     .,0.37568500D+02,0.307D+03,0.500D+01,0.29903000D+01,0.00000000D+00
     .,0.26935100D+02,0.307D+03,0.600D+01,0.29903000D+01,0.00000000D+00
     .,0.19770700D+02,0.307D+03,0.700D+01,0.29903000D+01,0.00000000D+00
     .,0.15524900D+02,0.307D+03,0.800D+01,0.29903000D+01,0.00000000D+00
     .,0.12151100D+02,0.307D+03,0.900D+01,0.29903000D+01,0.00000000D+00
     .,0.96050000D+01,0.307D+03,0.100D+02,0.29903000D+01,0.00000000D+00
     .,0.98880600D+02,0.307D+03,0.110D+02,0.29903000D+01,0.00000000D+00
     .,0.81535200D+02,0.307D+03,0.120D+02,0.29903000D+01,0.00000000D+00
     .,0.77652000D+02,0.307D+03,0.130D+02,0.29903000D+01,0.00000000D+00
     .,0.64057600D+02,0.307D+03,0.140D+02,0.29903000D+01,0.00000000D+00
     .,0.52150900D+02,0.307D+03,0.150D+02,0.29903000D+01,0.00000000D+00
     .,0.44652900D+02,0.307D+03,0.160D+02,0.29903000D+01,0.00000000D+00
     .,0.37629500D+02,0.307D+03,0.170D+02,0.29903000D+01,0.00000000D+00
     .,0.31680400D+02,0.307D+03,0.180D+02,0.29903000D+01,0.00000000D+00
     .,0.16201600D+03,0.307D+03,0.190D+02,0.29903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 136401: 136500)=(/
     . 0.14002730D+03,0.307D+03,0.200D+02,0.29903000D+01,0.00000000D+00
     .,0.11711120D+03,0.307D+03,0.210D+02,0.29903000D+01,0.00000000D+00
     .,0.11482560D+03,0.307D+03,0.220D+02,0.29903000D+01,0.00000000D+00
     .,0.10604890D+03,0.307D+03,0.230D+02,0.29903000D+01,0.00000000D+00
     .,0.84363100D+02,0.307D+03,0.240D+02,0.29903000D+01,0.00000000D+00
     .,0.92463600D+02,0.307D+03,0.250D+02,0.29903000D+01,0.00000000D+00
     .,0.73418500D+02,0.307D+03,0.260D+02,0.29903000D+01,0.00000000D+00
     .,0.78469600D+02,0.307D+03,0.270D+02,0.29903000D+01,0.00000000D+00
     .,0.80085300D+02,0.307D+03,0.280D+02,0.29903000D+01,0.00000000D+00
     .,0.62129900D+02,0.307D+03,0.290D+02,0.29903000D+01,0.00000000D+00
     .,0.64863300D+02,0.307D+03,0.300D+02,0.29903000D+01,0.00000000D+00
     .,0.75880000D+02,0.307D+03,0.310D+02,0.29903000D+01,0.00000000D+00
     .,0.69171000D+02,0.307D+03,0.320D+02,0.29903000D+01,0.00000000D+00
     .,0.61042500D+02,0.307D+03,0.330D+02,0.29903000D+01,0.00000000D+00
     .,0.56081200D+02,0.307D+03,0.340D+02,0.29903000D+01,0.00000000D+00
     .,0.50334400D+02,0.307D+03,0.350D+02,0.29903000D+01,0.00000000D+00
     .,0.44854600D+02,0.307D+03,0.360D+02,0.29903000D+01,0.00000000D+00
     .,0.18314860D+03,0.307D+03,0.370D+02,0.29903000D+01,0.00000000D+00
     .,0.16708650D+03,0.307D+03,0.380D+02,0.29903000D+01,0.00000000D+00
     .,0.14989060D+03,0.307D+03,0.390D+02,0.29903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 136501: 136600)=(/
     . 0.13695780D+03,0.307D+03,0.400D+02,0.29903000D+01,0.00000000D+00
     .,0.12643070D+03,0.307D+03,0.410D+02,0.29903000D+01,0.00000000D+00
     .,0.10010800D+03,0.307D+03,0.420D+02,0.29903000D+01,0.00000000D+00
     .,0.11061190D+03,0.307D+03,0.430D+02,0.29903000D+01,0.00000000D+00
     .,0.86616300D+02,0.307D+03,0.440D+02,0.29903000D+01,0.00000000D+00
     .,0.94100700D+02,0.307D+03,0.450D+02,0.29903000D+01,0.00000000D+00
     .,0.87943000D+02,0.307D+03,0.460D+02,0.29903000D+01,0.00000000D+00
     .,0.73805700D+02,0.307D+03,0.470D+02,0.29903000D+01,0.00000000D+00
     .,0.78301600D+02,0.307D+03,0.480D+02,0.29903000D+01,0.00000000D+00
     .,0.95772700D+02,0.307D+03,0.490D+02,0.29903000D+01,0.00000000D+00
     .,0.90687600D+02,0.307D+03,0.500D+02,0.29903000D+01,0.00000000D+00
     .,0.83057700D+02,0.307D+03,0.510D+02,0.29903000D+01,0.00000000D+00
     .,0.78481900D+02,0.307D+03,0.520D+02,0.29903000D+01,0.00000000D+00
     .,0.72453100D+02,0.307D+03,0.530D+02,0.29903000D+01,0.00000000D+00
     .,0.66508100D+02,0.307D+03,0.540D+02,0.29903000D+01,0.00000000D+00
     .,0.22390760D+03,0.307D+03,0.550D+02,0.29903000D+01,0.00000000D+00
     .,0.21212970D+03,0.307D+03,0.560D+02,0.29903000D+01,0.00000000D+00
     .,0.19063700D+03,0.307D+03,0.570D+02,0.29903000D+01,0.00000000D+00
     .,0.97988200D+02,0.307D+03,0.580D+02,0.29903000D+01,0.27991000D+01
     .,0.18970840D+03,0.307D+03,0.590D+02,0.29903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 136601: 136700)=(/
     . 0.18275600D+03,0.307D+03,0.600D+02,0.29903000D+01,0.00000000D+00
     .,0.17832410D+03,0.307D+03,0.610D+02,0.29903000D+01,0.00000000D+00
     .,0.17422140D+03,0.307D+03,0.620D+02,0.29903000D+01,0.00000000D+00
     .,0.17058700D+03,0.307D+03,0.630D+02,0.29903000D+01,0.00000000D+00
     .,0.13842980D+03,0.307D+03,0.640D+02,0.29903000D+01,0.00000000D+00
     .,0.15082040D+03,0.307D+03,0.650D+02,0.29903000D+01,0.00000000D+00
     .,0.14614450D+03,0.307D+03,0.660D+02,0.29903000D+01,0.00000000D+00
     .,0.15462870D+03,0.307D+03,0.670D+02,0.29903000D+01,0.00000000D+00
     .,0.15139240D+03,0.307D+03,0.680D+02,0.29903000D+01,0.00000000D+00
     .,0.14852730D+03,0.307D+03,0.690D+02,0.29903000D+01,0.00000000D+00
     .,0.14657090D+03,0.307D+03,0.700D+02,0.29903000D+01,0.00000000D+00
     .,0.12614450D+03,0.307D+03,0.710D+02,0.29903000D+01,0.00000000D+00
     .,0.12685210D+03,0.307D+03,0.720D+02,0.29903000D+01,0.00000000D+00
     .,0.11782080D+03,0.307D+03,0.730D+02,0.29903000D+01,0.00000000D+00
     .,0.10145610D+03,0.307D+03,0.740D+02,0.29903000D+01,0.00000000D+00
     .,0.10369670D+03,0.307D+03,0.750D+02,0.29903000D+01,0.00000000D+00
     .,0.95491900D+02,0.307D+03,0.760D+02,0.29903000D+01,0.00000000D+00
     .,0.88641300D+02,0.307D+03,0.770D+02,0.29903000D+01,0.00000000D+00
     .,0.75088300D+02,0.307D+03,0.780D+02,0.29903000D+01,0.00000000D+00
     .,0.70691000D+02,0.307D+03,0.790D+02,0.29903000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 136701: 136800)=(/
     . 0.72867700D+02,0.307D+03,0.800D+02,0.29903000D+01,0.00000000D+00
     .,0.99854500D+02,0.307D+03,0.810D+02,0.29903000D+01,0.00000000D+00
     .,0.99155700D+02,0.307D+03,0.820D+02,0.29903000D+01,0.00000000D+00
     .,0.93202900D+02,0.307D+03,0.830D+02,0.29903000D+01,0.00000000D+00
     .,0.90185300D+02,0.307D+03,0.840D+02,0.29903000D+01,0.00000000D+00
     .,0.84799100D+02,0.307D+03,0.850D+02,0.29903000D+01,0.00000000D+00
     .,0.79155500D+02,0.307D+03,0.860D+02,0.29903000D+01,0.00000000D+00
     .,0.21546340D+03,0.307D+03,0.870D+02,0.29903000D+01,0.00000000D+00
     .,0.21255240D+03,0.307D+03,0.880D+02,0.29903000D+01,0.00000000D+00
     .,0.19179540D+03,0.307D+03,0.890D+02,0.29903000D+01,0.00000000D+00
     .,0.17728870D+03,0.307D+03,0.900D+02,0.29903000D+01,0.00000000D+00
     .,0.17432070D+03,0.307D+03,0.910D+02,0.29903000D+01,0.00000000D+00
     .,0.16896800D+03,0.307D+03,0.920D+02,0.29903000D+01,0.00000000D+00
     .,0.17120630D+03,0.307D+03,0.930D+02,0.29903000D+01,0.00000000D+00
     .,0.16624200D+03,0.307D+03,0.940D+02,0.29903000D+01,0.00000000D+00
     .,0.10398700D+02,0.307D+03,0.101D+03,0.29903000D+01,0.00000000D+00
     .,0.30602200D+02,0.307D+03,0.103D+03,0.29903000D+01,0.98650000D+00
     .,0.39647800D+02,0.307D+03,0.104D+03,0.29903000D+01,0.98080000D+00
     .,0.32164400D+02,0.307D+03,0.105D+03,0.29903000D+01,0.97060000D+00
     .,0.25331800D+02,0.307D+03,0.106D+03,0.29903000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters( 136801: 136900)=(/
     . 0.18518000D+02,0.307D+03,0.107D+03,0.29903000D+01,0.99440000D+00
     .,0.14079300D+02,0.307D+03,0.108D+03,0.29903000D+01,0.99250000D+00
     .,0.10221400D+02,0.307D+03,0.109D+03,0.29903000D+01,0.99820000D+00
     .,0.44492400D+02,0.307D+03,0.111D+03,0.29903000D+01,0.96840000D+00
     .,0.68314100D+02,0.307D+03,0.112D+03,0.29903000D+01,0.96280000D+00
     .,0.71023100D+02,0.307D+03,0.113D+03,0.29903000D+01,0.96480000D+00
     .,0.59688700D+02,0.307D+03,0.114D+03,0.29903000D+01,0.95070000D+00
     .,0.50739800D+02,0.307D+03,0.115D+03,0.29903000D+01,0.99470000D+00
     .,0.44158100D+02,0.307D+03,0.116D+03,0.29903000D+01,0.99480000D+00
     .,0.37238100D+02,0.307D+03,0.117D+03,0.29903000D+01,0.99720000D+00
     .,0.63868600D+02,0.307D+03,0.119D+03,0.29903000D+01,0.97670000D+00
     .,0.11341610D+03,0.307D+03,0.120D+03,0.29903000D+01,0.98310000D+00
     .,0.65520300D+02,0.307D+03,0.121D+03,0.29903000D+01,0.18627000D+01
     .,0.63464500D+02,0.307D+03,0.122D+03,0.29903000D+01,0.18299000D+01
     .,0.62202000D+02,0.307D+03,0.123D+03,0.29903000D+01,0.19138000D+01
     .,0.61420200D+02,0.307D+03,0.124D+03,0.29903000D+01,0.18269000D+01
     .,0.57491500D+02,0.307D+03,0.125D+03,0.29903000D+01,0.16406000D+01
     .,0.53617100D+02,0.307D+03,0.126D+03,0.29903000D+01,0.16483000D+01
     .,0.51231800D+02,0.307D+03,0.127D+03,0.29903000D+01,0.17149000D+01
     .,0.50021800D+02,0.307D+03,0.128D+03,0.29903000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters( 136901: 137000)=(/
     . 0.48763000D+02,0.307D+03,0.129D+03,0.29903000D+01,0.95760000D+00
     .,0.46891100D+02,0.307D+03,0.130D+03,0.29903000D+01,0.19419000D+01
     .,0.71907900D+02,0.307D+03,0.131D+03,0.29903000D+01,0.96010000D+00
     .,0.65304100D+02,0.307D+03,0.132D+03,0.29903000D+01,0.94340000D+00
     .,0.60151900D+02,0.307D+03,0.133D+03,0.29903000D+01,0.98890000D+00
     .,0.56096200D+02,0.307D+03,0.134D+03,0.29903000D+01,0.99010000D+00
     .,0.50629800D+02,0.307D+03,0.135D+03,0.29903000D+01,0.99740000D+00
     .,0.77004000D+02,0.307D+03,0.137D+03,0.29903000D+01,0.97380000D+00
     .,0.13809270D+03,0.307D+03,0.138D+03,0.29903000D+01,0.98010000D+00
     .,0.11082380D+03,0.307D+03,0.139D+03,0.29903000D+01,0.19153000D+01
     .,0.86803500D+02,0.307D+03,0.140D+03,0.29903000D+01,0.19355000D+01
     .,0.87650400D+02,0.307D+03,0.141D+03,0.29903000D+01,0.19545000D+01
     .,0.82525100D+02,0.307D+03,0.142D+03,0.29903000D+01,0.19420000D+01
     .,0.90466000D+02,0.307D+03,0.143D+03,0.29903000D+01,0.16682000D+01
     .,0.73425900D+02,0.307D+03,0.144D+03,0.29903000D+01,0.18584000D+01
     .,0.69000500D+02,0.307D+03,0.145D+03,0.29903000D+01,0.19003000D+01
     .,0.64465100D+02,0.307D+03,0.146D+03,0.29903000D+01,0.18630000D+01
     .,0.62220900D+02,0.307D+03,0.147D+03,0.29903000D+01,0.96790000D+00
     .,0.62213100D+02,0.307D+03,0.148D+03,0.29903000D+01,0.19539000D+01
     .,0.92140300D+02,0.307D+03,0.149D+03,0.29903000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters( 137001: 137100)=(/
     . 0.85547900D+02,0.307D+03,0.150D+03,0.29903000D+01,0.95140000D+00
     .,0.81727900D+02,0.307D+03,0.151D+03,0.29903000D+01,0.97490000D+00
     .,0.78506700D+02,0.307D+03,0.152D+03,0.29903000D+01,0.98110000D+00
     .,0.73095400D+02,0.307D+03,0.153D+03,0.29903000D+01,0.99680000D+00
     .,0.92705000D+02,0.307D+03,0.155D+03,0.29903000D+01,0.99090000D+00
     .,0.17805360D+03,0.307D+03,0.156D+03,0.29903000D+01,0.97970000D+00
     .,0.13991280D+03,0.307D+03,0.157D+03,0.29903000D+01,0.19373000D+01
     .,0.95217800D+02,0.307D+03,0.159D+03,0.29903000D+01,0.29425000D+01
     .,0.93284100D+02,0.307D+03,0.160D+03,0.29903000D+01,0.29455000D+01
     .,0.90480700D+02,0.307D+03,0.161D+03,0.29903000D+01,0.29413000D+01
     .,0.90568200D+02,0.307D+03,0.162D+03,0.29903000D+01,0.29300000D+01
     .,0.86338600D+02,0.307D+03,0.163D+03,0.29903000D+01,0.18286000D+01
     .,0.90910000D+02,0.307D+03,0.164D+03,0.29903000D+01,0.28732000D+01
     .,0.85747500D+02,0.307D+03,0.165D+03,0.29903000D+01,0.29086000D+01
     .,0.86674000D+02,0.307D+03,0.166D+03,0.29903000D+01,0.28965000D+01
     .,0.81652000D+02,0.307D+03,0.167D+03,0.29903000D+01,0.29242000D+01
     .,0.79429100D+02,0.307D+03,0.168D+03,0.29903000D+01,0.29282000D+01
     .,0.78815000D+02,0.307D+03,0.169D+03,0.29903000D+01,0.29246000D+01
     .,0.82180600D+02,0.307D+03,0.170D+03,0.29903000D+01,0.28482000D+01
     .,0.76300400D+02,0.307D+03,0.171D+03,0.29903000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters( 137101: 137200)=(/
     . 0.98802500D+02,0.307D+03,0.172D+03,0.29903000D+01,0.19254000D+01
     .,0.93300800D+02,0.307D+03,0.173D+03,0.29903000D+01,0.19459000D+01
     .,0.86690900D+02,0.307D+03,0.174D+03,0.29903000D+01,0.19292000D+01
     .,0.86498300D+02,0.307D+03,0.175D+03,0.29903000D+01,0.18104000D+01
     .,0.78773500D+02,0.307D+03,0.176D+03,0.29903000D+01,0.18858000D+01
     .,0.74726900D+02,0.307D+03,0.177D+03,0.29903000D+01,0.18648000D+01
     .,0.71762400D+02,0.307D+03,0.178D+03,0.29903000D+01,0.19188000D+01
     .,0.68753800D+02,0.307D+03,0.179D+03,0.29903000D+01,0.98460000D+00
     .,0.67229300D+02,0.307D+03,0.180D+03,0.29903000D+01,0.19896000D+01
     .,0.10008700D+03,0.307D+03,0.181D+03,0.29903000D+01,0.92670000D+00
     .,0.93482100D+02,0.307D+03,0.182D+03,0.29903000D+01,0.93830000D+00
     .,0.91896500D+02,0.307D+03,0.183D+03,0.29903000D+01,0.98200000D+00
     .,0.90376000D+02,0.307D+03,0.184D+03,0.29903000D+01,0.98150000D+00
     .,0.85807500D+02,0.307D+03,0.185D+03,0.29903000D+01,0.99540000D+00
     .,0.10451280D+03,0.307D+03,0.187D+03,0.29903000D+01,0.97050000D+00
     .,0.17971610D+03,0.307D+03,0.188D+03,0.29903000D+01,0.96620000D+00
     .,0.11246690D+03,0.307D+03,0.189D+03,0.29903000D+01,0.29070000D+01
     .,0.12728190D+03,0.307D+03,0.190D+03,0.29903000D+01,0.28844000D+01
     .,0.11517510D+03,0.307D+03,0.191D+03,0.29903000D+01,0.28738000D+01
     .,0.10344890D+03,0.307D+03,0.192D+03,0.29903000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters( 137201: 137300)=(/
     . 0.99987800D+02,0.307D+03,0.193D+03,0.29903000D+01,0.29095000D+01
     .,0.11495380D+03,0.307D+03,0.194D+03,0.29903000D+01,0.19209000D+01
     .,0.27422500D+02,0.307D+03,0.204D+03,0.29903000D+01,0.19697000D+01
     .,0.27484200D+02,0.307D+03,0.205D+03,0.29903000D+01,0.19441000D+01
     .,0.21148800D+02,0.307D+03,0.206D+03,0.29903000D+01,0.19985000D+01
     .,0.17492800D+02,0.307D+03,0.207D+03,0.29903000D+01,0.20143000D+01
     .,0.12607700D+02,0.307D+03,0.208D+03,0.29903000D+01,0.19887000D+01
     .,0.47205900D+02,0.307D+03,0.212D+03,0.29903000D+01,0.19496000D+01
     .,0.56971300D+02,0.307D+03,0.213D+03,0.29903000D+01,0.19311000D+01
     .,0.55919700D+02,0.307D+03,0.214D+03,0.29903000D+01,0.19435000D+01
     .,0.49981800D+02,0.307D+03,0.215D+03,0.29903000D+01,0.20102000D+01
     .,0.43313000D+02,0.307D+03,0.216D+03,0.29903000D+01,0.19903000D+01
     .,0.66870600D+02,0.307D+03,0.220D+03,0.29903000D+01,0.19349000D+01
     .,0.65341500D+02,0.307D+03,0.221D+03,0.29903000D+01,0.28999000D+01
     .,0.66260700D+02,0.307D+03,0.222D+03,0.29903000D+01,0.38675000D+01
     .,0.60783400D+02,0.307D+03,0.223D+03,0.29903000D+01,0.29110000D+01
     .,0.47503300D+02,0.307D+03,0.224D+03,0.29903000D+01,0.10619100D+02
     .,0.41486200D+02,0.307D+03,0.225D+03,0.29903000D+01,0.98849000D+01
     .,0.40637600D+02,0.307D+03,0.226D+03,0.29903000D+01,0.91376000D+01
     .,0.46084100D+02,0.307D+03,0.227D+03,0.29903000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters( 137301: 137400)=(/
     . 0.43309600D+02,0.307D+03,0.228D+03,0.29903000D+01,0.65458000D+01
     .,0.58812600D+02,0.307D+03,0.231D+03,0.29903000D+01,0.19315000D+01
     .,0.62560900D+02,0.307D+03,0.232D+03,0.29903000D+01,0.19447000D+01
     .,0.58794500D+02,0.307D+03,0.233D+03,0.29903000D+01,0.19793000D+01
     .,0.55703700D+02,0.307D+03,0.234D+03,0.29903000D+01,0.19812000D+01
     .,0.80586800D+02,0.307D+03,0.238D+03,0.29903000D+01,0.19143000D+01
     .,0.79155000D+02,0.307D+03,0.239D+03,0.29903000D+01,0.28903000D+01
     .,0.80375800D+02,0.307D+03,0.240D+03,0.29903000D+01,0.39106000D+01
     .,0.77868100D+02,0.307D+03,0.241D+03,0.29903000D+01,0.29225000D+01
     .,0.70424400D+02,0.307D+03,0.242D+03,0.29903000D+01,0.11055600D+02
     .,0.63308100D+02,0.307D+03,0.243D+03,0.29903000D+01,0.95402000D+01
     .,0.60264100D+02,0.307D+03,0.244D+03,0.29903000D+01,0.88895000D+01
     .,0.60414900D+02,0.307D+03,0.245D+03,0.29903000D+01,0.29696000D+01
     .,0.62653200D+02,0.307D+03,0.246D+03,0.29903000D+01,0.57095000D+01
     .,0.76779800D+02,0.307D+03,0.249D+03,0.29903000D+01,0.19378000D+01
     .,0.83196800D+02,0.307D+03,0.250D+03,0.29903000D+01,0.19505000D+01
     .,0.79891200D+02,0.307D+03,0.251D+03,0.29903000D+01,0.19523000D+01
     .,0.78022400D+02,0.307D+03,0.252D+03,0.29903000D+01,0.19639000D+01
     .,0.98267000D+02,0.307D+03,0.256D+03,0.29903000D+01,0.18467000D+01
     .,0.10262510D+03,0.307D+03,0.257D+03,0.29903000D+01,0.29175000D+01
     ./)
      grimme_c6_parameters( 137401: 137500)=(/
     . 0.77737900D+02,0.307D+03,0.272D+03,0.29903000D+01,0.38840000D+01
     .,0.80805200D+02,0.307D+03,0.273D+03,0.29903000D+01,0.28988000D+01
     .,0.76585200D+02,0.307D+03,0.274D+03,0.29903000D+01,0.10915300D+02
     .,0.70735300D+02,0.307D+03,0.275D+03,0.29903000D+01,0.98054000D+01
     .,0.67427200D+02,0.307D+03,0.276D+03,0.29903000D+01,0.91527000D+01
     .,0.67888500D+02,0.307D+03,0.277D+03,0.29903000D+01,0.29424000D+01
     .,0.71112000D+02,0.307D+03,0.278D+03,0.29903000D+01,0.66669000D+01
     .,0.83409500D+02,0.307D+03,0.281D+03,0.29903000D+01,0.19302000D+01
     .,0.88005200D+02,0.307D+03,0.282D+03,0.29903000D+01,0.19356000D+01
     .,0.90199000D+02,0.307D+03,0.283D+03,0.29903000D+01,0.19655000D+01
     .,0.90200500D+02,0.307D+03,0.284D+03,0.29903000D+01,0.19639000D+01
     .,0.10838490D+03,0.307D+03,0.288D+03,0.29903000D+01,0.18075000D+01
     .,0.21720500D+02,0.307D+03,0.305D+03,0.29903000D+01,0.29128000D+01
     .,0.19866900D+02,0.307D+03,0.306D+03,0.29903000D+01,0.29987000D+01
     .,0.15581700D+02,0.307D+03,0.307D+03,0.29903000D+01,0.29903000D+01
     .,0.21058400D+02,0.313D+03,0.100D+01,0.29146000D+01,0.91180000D+00
     .,0.13698200D+02,0.313D+03,0.200D+01,0.29146000D+01,0.00000000D+00
     .,0.32279250D+03,0.313D+03,0.300D+01,0.29146000D+01,0.00000000D+00
     .,0.18966050D+03,0.313D+03,0.400D+01,0.29146000D+01,0.00000000D+00
     .,0.12796450D+03,0.313D+03,0.500D+01,0.29146000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 137501: 137600)=(/
     . 0.86160500D+02,0.313D+03,0.600D+01,0.29146000D+01,0.00000000D+00
     .,0.59907400D+02,0.313D+03,0.700D+01,0.29146000D+01,0.00000000D+00
     .,0.45087600D+02,0.313D+03,0.800D+01,0.29146000D+01,0.00000000D+00
     .,0.33933400D+02,0.313D+03,0.900D+01,0.29146000D+01,0.00000000D+00
     .,0.25933500D+02,0.313D+03,0.100D+02,0.29146000D+01,0.00000000D+00
     .,0.38609800D+03,0.313D+03,0.110D+02,0.29146000D+01,0.00000000D+00
     .,0.30133070D+03,0.313D+03,0.120D+02,0.29146000D+01,0.00000000D+00
     .,0.27856390D+03,0.313D+03,0.130D+02,0.29146000D+01,0.00000000D+00
     .,0.21994790D+03,0.313D+03,0.140D+02,0.29146000D+01,0.00000000D+00
     .,0.17135570D+03,0.313D+03,0.150D+02,0.29146000D+01,0.00000000D+00
     .,0.14185170D+03,0.313D+03,0.160D+02,0.29146000D+01,0.00000000D+00
     .,0.11545520D+03,0.313D+03,0.170D+02,0.29146000D+01,0.00000000D+00
     .,0.94042800D+02,0.313D+03,0.180D+02,0.29146000D+01,0.00000000D+00
     .,0.62895370D+03,0.313D+03,0.190D+02,0.29146000D+01,0.00000000D+00
     .,0.52583670D+03,0.313D+03,0.200D+02,0.29146000D+01,0.00000000D+00
     .,0.43542050D+03,0.313D+03,0.210D+02,0.29146000D+01,0.00000000D+00
     .,0.42087110D+03,0.313D+03,0.220D+02,0.29146000D+01,0.00000000D+00
     .,0.38566110D+03,0.313D+03,0.230D+02,0.29146000D+01,0.00000000D+00
     .,0.30312660D+03,0.313D+03,0.240D+02,0.29146000D+01,0.00000000D+00
     .,0.33231560D+03,0.313D+03,0.250D+02,0.29146000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 137601: 137700)=(/
     . 0.26022290D+03,0.313D+03,0.260D+02,0.29146000D+01,0.00000000D+00
     .,0.27689480D+03,0.313D+03,0.270D+02,0.29146000D+01,0.00000000D+00
     .,0.28511740D+03,0.313D+03,0.280D+02,0.29146000D+01,0.00000000D+00
     .,0.21789580D+03,0.313D+03,0.290D+02,0.29146000D+01,0.00000000D+00
     .,0.22471970D+03,0.313D+03,0.300D+02,0.29146000D+01,0.00000000D+00
     .,0.26645340D+03,0.313D+03,0.310D+02,0.29146000D+01,0.00000000D+00
     .,0.23543820D+03,0.313D+03,0.320D+02,0.29146000D+01,0.00000000D+00
     .,0.20075140D+03,0.313D+03,0.330D+02,0.29146000D+01,0.00000000D+00
     .,0.17986350D+03,0.313D+03,0.340D+02,0.29146000D+01,0.00000000D+00
     .,0.15701910D+03,0.313D+03,0.350D+02,0.29146000D+01,0.00000000D+00
     .,0.13612380D+03,0.313D+03,0.360D+02,0.29146000D+01,0.00000000D+00
     .,0.70496090D+03,0.313D+03,0.370D+02,0.29146000D+01,0.00000000D+00
     .,0.62569960D+03,0.313D+03,0.380D+02,0.29146000D+01,0.00000000D+00
     .,0.54992420D+03,0.313D+03,0.390D+02,0.29146000D+01,0.00000000D+00
     .,0.49495070D+03,0.313D+03,0.400D+02,0.29146000D+01,0.00000000D+00
     .,0.45153080D+03,0.313D+03,0.410D+02,0.29146000D+01,0.00000000D+00
     .,0.34833970D+03,0.313D+03,0.420D+02,0.29146000D+01,0.00000000D+00
     .,0.38882260D+03,0.313D+03,0.430D+02,0.29146000D+01,0.00000000D+00
     .,0.29592560D+03,0.313D+03,0.440D+02,0.29146000D+01,0.00000000D+00
     .,0.32404080D+03,0.313D+03,0.450D+02,0.29146000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 137701: 137800)=(/
     . 0.30049770D+03,0.313D+03,0.460D+02,0.29146000D+01,0.00000000D+00
     .,0.24967590D+03,0.313D+03,0.470D+02,0.29146000D+01,0.00000000D+00
     .,0.26472910D+03,0.313D+03,0.480D+02,0.29146000D+01,0.00000000D+00
     .,0.33234100D+03,0.313D+03,0.490D+02,0.29146000D+01,0.00000000D+00
     .,0.30808400D+03,0.313D+03,0.500D+02,0.29146000D+01,0.00000000D+00
     .,0.27473330D+03,0.313D+03,0.510D+02,0.29146000D+01,0.00000000D+00
     .,0.25478050D+03,0.313D+03,0.520D+02,0.29146000D+01,0.00000000D+00
     .,0.23007980D+03,0.313D+03,0.530D+02,0.29146000D+01,0.00000000D+00
     .,0.20645810D+03,0.313D+03,0.540D+02,0.29146000D+01,0.00000000D+00
     .,0.85867990D+03,0.313D+03,0.550D+02,0.29146000D+01,0.00000000D+00
     .,0.79610660D+03,0.313D+03,0.560D+02,0.29146000D+01,0.00000000D+00
     .,0.70193980D+03,0.313D+03,0.570D+02,0.29146000D+01,0.00000000D+00
     .,0.32415330D+03,0.313D+03,0.580D+02,0.29146000D+01,0.27991000D+01
     .,0.70578730D+03,0.313D+03,0.590D+02,0.29146000D+01,0.00000000D+00
     .,0.67819310D+03,0.313D+03,0.600D+02,0.29146000D+01,0.00000000D+00
     .,0.66131780D+03,0.313D+03,0.610D+02,0.29146000D+01,0.00000000D+00
     .,0.64579390D+03,0.313D+03,0.620D+02,0.29146000D+01,0.00000000D+00
     .,0.63203590D+03,0.313D+03,0.630D+02,0.29146000D+01,0.00000000D+00
     .,0.49802070D+03,0.313D+03,0.640D+02,0.29146000D+01,0.00000000D+00
     .,0.55718410D+03,0.313D+03,0.650D+02,0.29146000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 137801: 137900)=(/
     . 0.53772660D+03,0.313D+03,0.660D+02,0.29146000D+01,0.00000000D+00
     .,0.57065080D+03,0.313D+03,0.670D+02,0.29146000D+01,0.00000000D+00
     .,0.55863790D+03,0.313D+03,0.680D+02,0.29146000D+01,0.00000000D+00
     .,0.54782520D+03,0.313D+03,0.690D+02,0.29146000D+01,0.00000000D+00
     .,0.54139780D+03,0.313D+03,0.700D+02,0.29146000D+01,0.00000000D+00
     .,0.45683250D+03,0.313D+03,0.710D+02,0.29146000D+01,0.00000000D+00
     .,0.45089790D+03,0.313D+03,0.720D+02,0.29146000D+01,0.00000000D+00
     .,0.41177370D+03,0.313D+03,0.730D+02,0.29146000D+01,0.00000000D+00
     .,0.34723090D+03,0.313D+03,0.740D+02,0.29146000D+01,0.00000000D+00
     .,0.35352640D+03,0.313D+03,0.750D+02,0.29146000D+01,0.00000000D+00
     .,0.32038750D+03,0.313D+03,0.760D+02,0.29146000D+01,0.00000000D+00
     .,0.29331160D+03,0.313D+03,0.770D+02,0.29146000D+01,0.00000000D+00
     .,0.24307640D+03,0.313D+03,0.780D+02,0.29146000D+01,0.00000000D+00
     .,0.22688500D+03,0.313D+03,0.790D+02,0.29146000D+01,0.00000000D+00
     .,0.23369270D+03,0.313D+03,0.800D+02,0.29146000D+01,0.00000000D+00
     .,0.34043160D+03,0.313D+03,0.810D+02,0.29146000D+01,0.00000000D+00
     .,0.33373140D+03,0.313D+03,0.820D+02,0.29146000D+01,0.00000000D+00
     .,0.30698840D+03,0.313D+03,0.830D+02,0.29146000D+01,0.00000000D+00
     .,0.29279590D+03,0.313D+03,0.840D+02,0.29146000D+01,0.00000000D+00
     .,0.27003130D+03,0.313D+03,0.850D+02,0.29146000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 137901: 138000)=(/
     . 0.24716150D+03,0.313D+03,0.860D+02,0.29146000D+01,0.00000000D+00
     .,0.81311660D+03,0.313D+03,0.870D+02,0.29146000D+01,0.00000000D+00
     .,0.78841980D+03,0.313D+03,0.880D+02,0.29146000D+01,0.00000000D+00
     .,0.69912600D+03,0.313D+03,0.890D+02,0.29146000D+01,0.00000000D+00
     .,0.62955760D+03,0.313D+03,0.900D+02,0.29146000D+01,0.00000000D+00
     .,0.62364620D+03,0.313D+03,0.910D+02,0.29146000D+01,0.00000000D+00
     .,0.60379750D+03,0.313D+03,0.920D+02,0.29146000D+01,0.00000000D+00
     .,0.62051110D+03,0.313D+03,0.930D+02,0.29146000D+01,0.00000000D+00
     .,0.60113500D+03,0.313D+03,0.940D+02,0.29146000D+01,0.00000000D+00
     .,0.34070000D+02,0.313D+03,0.101D+03,0.29146000D+01,0.00000000D+00
     .,0.11021360D+03,0.313D+03,0.103D+03,0.29146000D+01,0.98650000D+00
     .,0.14056320D+03,0.313D+03,0.104D+03,0.29146000D+01,0.98080000D+00
     .,0.10751580D+03,0.313D+03,0.105D+03,0.29146000D+01,0.97060000D+00
     .,0.80711100D+02,0.313D+03,0.106D+03,0.29146000D+01,0.98680000D+00
     .,0.55779300D+02,0.313D+03,0.107D+03,0.29146000D+01,0.99440000D+00
     .,0.40337400D+02,0.313D+03,0.108D+03,0.29146000D+01,0.99250000D+00
     .,0.27443600D+02,0.313D+03,0.109D+03,0.29146000D+01,0.99820000D+00
     .,0.16065940D+03,0.313D+03,0.111D+03,0.29146000D+01,0.96840000D+00
     .,0.24856920D+03,0.313D+03,0.112D+03,0.29146000D+01,0.96280000D+00
     .,0.25249530D+03,0.313D+03,0.113D+03,0.29146000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters( 138001: 138100)=(/
     . 0.20322260D+03,0.313D+03,0.114D+03,0.29146000D+01,0.95070000D+00
     .,0.16626980D+03,0.313D+03,0.115D+03,0.29146000D+01,0.99470000D+00
     .,0.14026180D+03,0.313D+03,0.116D+03,0.29146000D+01,0.99480000D+00
     .,0.11424050D+03,0.313D+03,0.117D+03,0.29146000D+01,0.99720000D+00
     .,0.22072640D+03,0.313D+03,0.119D+03,0.29146000D+01,0.97670000D+00
     .,0.41971290D+03,0.313D+03,0.120D+03,0.29146000D+01,0.98310000D+00
     .,0.22183390D+03,0.313D+03,0.121D+03,0.29146000D+01,0.18627000D+01
     .,0.21401930D+03,0.313D+03,0.122D+03,0.29146000D+01,0.18299000D+01
     .,0.20967420D+03,0.313D+03,0.123D+03,0.29146000D+01,0.19138000D+01
     .,0.20762990D+03,0.313D+03,0.124D+03,0.29146000D+01,0.18269000D+01
     .,0.19138970D+03,0.313D+03,0.125D+03,0.29146000D+01,0.16406000D+01
     .,0.17705420D+03,0.313D+03,0.126D+03,0.29146000D+01,0.16483000D+01
     .,0.16880270D+03,0.313D+03,0.127D+03,0.29146000D+01,0.17149000D+01
     .,0.16499240D+03,0.313D+03,0.128D+03,0.29146000D+01,0.17937000D+01
     .,0.16280210D+03,0.313D+03,0.129D+03,0.29146000D+01,0.95760000D+00
     .,0.15307760D+03,0.313D+03,0.130D+03,0.29146000D+01,0.19419000D+01
     .,0.25034940D+03,0.313D+03,0.131D+03,0.29146000D+01,0.96010000D+00
     .,0.22023170D+03,0.313D+03,0.132D+03,0.29146000D+01,0.94340000D+00
     .,0.19730880D+03,0.313D+03,0.133D+03,0.29146000D+01,0.98890000D+00
     .,0.17991980D+03,0.313D+03,0.134D+03,0.29146000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters( 138101: 138200)=(/
     . 0.15811820D+03,0.313D+03,0.135D+03,0.29146000D+01,0.99740000D+00
     .,0.26324390D+03,0.313D+03,0.137D+03,0.29146000D+01,0.97380000D+00
     .,0.50999270D+03,0.313D+03,0.138D+03,0.29146000D+01,0.98010000D+00
     .,0.39206600D+03,0.313D+03,0.139D+03,0.29146000D+01,0.19153000D+01
     .,0.29297650D+03,0.313D+03,0.140D+03,0.29146000D+01,0.19355000D+01
     .,0.29577860D+03,0.313D+03,0.141D+03,0.29146000D+01,0.19545000D+01
     .,0.27564350D+03,0.313D+03,0.142D+03,0.29146000D+01,0.19420000D+01
     .,0.30843590D+03,0.313D+03,0.143D+03,0.29146000D+01,0.16682000D+01
     .,0.24026870D+03,0.313D+03,0.144D+03,0.29146000D+01,0.18584000D+01
     .,0.22456570D+03,0.313D+03,0.145D+03,0.29146000D+01,0.19003000D+01
     .,0.20834700D+03,0.313D+03,0.146D+03,0.29146000D+01,0.18630000D+01
     .,0.20146610D+03,0.313D+03,0.147D+03,0.29146000D+01,0.96790000D+00
     .,0.19966700D+03,0.313D+03,0.148D+03,0.29146000D+01,0.19539000D+01
     .,0.31698520D+03,0.313D+03,0.149D+03,0.29146000D+01,0.96330000D+00
     .,0.28733370D+03,0.313D+03,0.150D+03,0.29146000D+01,0.95140000D+00
     .,0.26924000D+03,0.313D+03,0.151D+03,0.29146000D+01,0.97490000D+00
     .,0.25459630D+03,0.313D+03,0.152D+03,0.29146000D+01,0.98110000D+00
     .,0.23226170D+03,0.313D+03,0.153D+03,0.29146000D+01,0.99680000D+00
     .,0.31205400D+03,0.313D+03,0.155D+03,0.29146000D+01,0.99090000D+00
     .,0.65974760D+03,0.313D+03,0.156D+03,0.29146000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters( 138201: 138300)=(/
     . 0.49580770D+03,0.313D+03,0.157D+03,0.29146000D+01,0.19373000D+01
     .,0.31434490D+03,0.313D+03,0.159D+03,0.29146000D+01,0.29425000D+01
     .,0.30783100D+03,0.313D+03,0.160D+03,0.29146000D+01,0.29455000D+01
     .,0.29804520D+03,0.313D+03,0.161D+03,0.29146000D+01,0.29413000D+01
     .,0.29947280D+03,0.313D+03,0.162D+03,0.29146000D+01,0.29300000D+01
     .,0.28833130D+03,0.313D+03,0.163D+03,0.29146000D+01,0.18286000D+01
     .,0.30148740D+03,0.313D+03,0.164D+03,0.29146000D+01,0.28732000D+01
     .,0.28310610D+03,0.313D+03,0.165D+03,0.29146000D+01,0.29086000D+01
     .,0.28795020D+03,0.313D+03,0.166D+03,0.29146000D+01,0.28965000D+01
     .,0.26876200D+03,0.313D+03,0.167D+03,0.29146000D+01,0.29242000D+01
     .,0.26111000D+03,0.313D+03,0.168D+03,0.29146000D+01,0.29282000D+01
     .,0.25945460D+03,0.313D+03,0.169D+03,0.29146000D+01,0.29246000D+01
     .,0.27290680D+03,0.313D+03,0.170D+03,0.29146000D+01,0.28482000D+01
     .,0.25082830D+03,0.313D+03,0.171D+03,0.29146000D+01,0.29219000D+01
     .,0.33919420D+03,0.313D+03,0.172D+03,0.29146000D+01,0.19254000D+01
     .,0.31485670D+03,0.313D+03,0.173D+03,0.29146000D+01,0.19459000D+01
     .,0.28725880D+03,0.313D+03,0.174D+03,0.29146000D+01,0.19292000D+01
     .,0.29046490D+03,0.313D+03,0.175D+03,0.29146000D+01,0.18104000D+01
     .,0.25437210D+03,0.313D+03,0.176D+03,0.29146000D+01,0.18858000D+01
     .,0.23906730D+03,0.313D+03,0.177D+03,0.29146000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters( 138301: 138400)=(/
     . 0.22815940D+03,0.313D+03,0.178D+03,0.29146000D+01,0.19188000D+01
     .,0.21789610D+03,0.313D+03,0.179D+03,0.29146000D+01,0.98460000D+00
     .,0.21069250D+03,0.313D+03,0.180D+03,0.29146000D+01,0.19896000D+01
     .,0.33974310D+03,0.313D+03,0.181D+03,0.29146000D+01,0.92670000D+00
     .,0.31027180D+03,0.313D+03,0.182D+03,0.29146000D+01,0.93830000D+00
     .,0.30114890D+03,0.313D+03,0.183D+03,0.29146000D+01,0.98200000D+00
     .,0.29290320D+03,0.313D+03,0.184D+03,0.29146000D+01,0.98150000D+00
     .,0.27334560D+03,0.313D+03,0.185D+03,0.29146000D+01,0.99540000D+00
     .,0.35155860D+03,0.313D+03,0.187D+03,0.29146000D+01,0.97050000D+00
     .,0.65770110D+03,0.313D+03,0.188D+03,0.29146000D+01,0.96620000D+00
     .,0.37210800D+03,0.313D+03,0.189D+03,0.29146000D+01,0.29070000D+01
     .,0.42861200D+03,0.313D+03,0.190D+03,0.29146000D+01,0.28844000D+01
     .,0.38281860D+03,0.313D+03,0.191D+03,0.29146000D+01,0.28738000D+01
     .,0.33870230D+03,0.313D+03,0.192D+03,0.29146000D+01,0.28878000D+01
     .,0.32590880D+03,0.313D+03,0.193D+03,0.29146000D+01,0.29095000D+01
     .,0.39082830D+03,0.313D+03,0.194D+03,0.29146000D+01,0.19209000D+01
     .,0.92012600D+02,0.313D+03,0.204D+03,0.29146000D+01,0.19697000D+01
     .,0.90144000D+02,0.313D+03,0.205D+03,0.29146000D+01,0.19441000D+01
     .,0.65696800D+02,0.313D+03,0.206D+03,0.29146000D+01,0.19985000D+01
     .,0.52313600D+02,0.313D+03,0.207D+03,0.29146000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters( 138401: 138500)=(/
     . 0.35460200D+02,0.313D+03,0.208D+03,0.29146000D+01,0.19887000D+01
     .,0.16311000D+03,0.313D+03,0.212D+03,0.29146000D+01,0.19496000D+01
     .,0.19694110D+03,0.313D+03,0.213D+03,0.29146000D+01,0.19311000D+01
     .,0.18900340D+03,0.313D+03,0.214D+03,0.29146000D+01,0.19435000D+01
     .,0.16395650D+03,0.313D+03,0.215D+03,0.29146000D+01,0.20102000D+01
     .,0.13739070D+03,0.313D+03,0.216D+03,0.29146000D+01,0.19903000D+01
     .,0.22781080D+03,0.313D+03,0.220D+03,0.29146000D+01,0.19349000D+01
     .,0.21910140D+03,0.313D+03,0.221D+03,0.29146000D+01,0.28999000D+01
     .,0.22177080D+03,0.313D+03,0.222D+03,0.29146000D+01,0.38675000D+01
     .,0.20271680D+03,0.313D+03,0.223D+03,0.29146000D+01,0.29110000D+01
     .,0.15223080D+03,0.313D+03,0.224D+03,0.29146000D+01,0.10619100D+02
     .,0.13008090D+03,0.313D+03,0.225D+03,0.29146000D+01,0.98849000D+01
     .,0.12768330D+03,0.313D+03,0.226D+03,0.29146000D+01,0.91376000D+01
     .,0.14999510D+03,0.313D+03,0.227D+03,0.29146000D+01,0.29263000D+01
     .,0.13971080D+03,0.313D+03,0.228D+03,0.29146000D+01,0.65458000D+01
     .,0.19848130D+03,0.313D+03,0.231D+03,0.29146000D+01,0.19315000D+01
     .,0.20964300D+03,0.313D+03,0.232D+03,0.29146000D+01,0.19447000D+01
     .,0.19209160D+03,0.313D+03,0.233D+03,0.29146000D+01,0.19793000D+01
     .,0.17848350D+03,0.313D+03,0.234D+03,0.29146000D+01,0.19812000D+01
     .,0.27262520D+03,0.313D+03,0.238D+03,0.29146000D+01,0.19143000D+01
     ./)
      grimme_c6_parameters( 138501: 138600)=(/
     . 0.26276340D+03,0.313D+03,0.239D+03,0.29146000D+01,0.28903000D+01
     .,0.26502430D+03,0.313D+03,0.240D+03,0.29146000D+01,0.39106000D+01
     .,0.25593200D+03,0.313D+03,0.241D+03,0.29146000D+01,0.29225000D+01
     .,0.22596360D+03,0.313D+03,0.242D+03,0.29146000D+01,0.11055600D+02
     .,0.19915880D+03,0.313D+03,0.243D+03,0.29146000D+01,0.95402000D+01
     .,0.18804460D+03,0.313D+03,0.244D+03,0.29146000D+01,0.88895000D+01
     .,0.19149380D+03,0.313D+03,0.245D+03,0.29146000D+01,0.29696000D+01
     .,0.20021140D+03,0.313D+03,0.246D+03,0.29146000D+01,0.57095000D+01
     .,0.25528030D+03,0.313D+03,0.249D+03,0.29146000D+01,0.19378000D+01
     .,0.27779270D+03,0.313D+03,0.250D+03,0.29146000D+01,0.19505000D+01
     .,0.26182240D+03,0.313D+03,0.251D+03,0.29146000D+01,0.19523000D+01
     .,0.25251890D+03,0.313D+03,0.252D+03,0.29146000D+01,0.19639000D+01
     .,0.32959150D+03,0.313D+03,0.256D+03,0.29146000D+01,0.18467000D+01
     .,0.34222420D+03,0.313D+03,0.257D+03,0.29146000D+01,0.29175000D+01
     .,0.25364330D+03,0.313D+03,0.272D+03,0.29146000D+01,0.38840000D+01
     .,0.26456000D+03,0.313D+03,0.273D+03,0.29146000D+01,0.28988000D+01
     .,0.24551490D+03,0.313D+03,0.274D+03,0.29146000D+01,0.10915300D+02
     .,0.22268310D+03,0.313D+03,0.275D+03,0.29146000D+01,0.98054000D+01
     .,0.20925910D+03,0.313D+03,0.276D+03,0.29146000D+01,0.91527000D+01
     .,0.21319310D+03,0.313D+03,0.277D+03,0.29146000D+01,0.29424000D+01
     ./)
      grimme_c6_parameters( 138601: 138700)=(/
     . 0.22444800D+03,0.313D+03,0.278D+03,0.29146000D+01,0.66669000D+01
     .,0.27230380D+03,0.313D+03,0.281D+03,0.29146000D+01,0.19302000D+01
     .,0.28809540D+03,0.313D+03,0.282D+03,0.29146000D+01,0.19356000D+01
     .,0.29386510D+03,0.313D+03,0.283D+03,0.29146000D+01,0.19655000D+01
     .,0.29167140D+03,0.313D+03,0.284D+03,0.29146000D+01,0.19639000D+01
     .,0.36287330D+03,0.313D+03,0.288D+03,0.29146000D+01,0.18075000D+01
     .,0.68433000D+02,0.313D+03,0.305D+03,0.29146000D+01,0.29128000D+01
     .,0.61382900D+02,0.313D+03,0.306D+03,0.29146000D+01,0.29987000D+01
     .,0.45939900D+02,0.313D+03,0.307D+03,0.29146000D+01,0.29903000D+01
     .,0.15359450D+03,0.313D+03,0.313D+03,0.29146000D+01,0.29146000D+01
     .,0.24983300D+02,0.314D+03,0.100D+01,0.29407000D+01,0.91180000D+00
     .,0.16110400D+02,0.314D+03,0.200D+01,0.29407000D+01,0.00000000D+00
     .,0.40808020D+03,0.314D+03,0.300D+01,0.29407000D+01,0.00000000D+00
     .,0.23182510D+03,0.314D+03,0.400D+01,0.29407000D+01,0.00000000D+00
     .,0.15403880D+03,0.314D+03,0.500D+01,0.29407000D+01,0.00000000D+00
     .,0.10272020D+03,0.314D+03,0.600D+01,0.29407000D+01,0.00000000D+00
     .,0.70976100D+02,0.314D+03,0.700D+01,0.29407000D+01,0.00000000D+00
     .,0.53206100D+02,0.314D+03,0.800D+01,0.29407000D+01,0.00000000D+00
     .,0.39917200D+02,0.314D+03,0.900D+01,0.29407000D+01,0.00000000D+00
     .,0.30433800D+02,0.314D+03,0.100D+02,0.29407000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 138701: 138800)=(/
     . 0.48717610D+03,0.314D+03,0.110D+02,0.29407000D+01,0.00000000D+00
     .,0.37037780D+03,0.314D+03,0.120D+02,0.29407000D+01,0.00000000D+00
     .,0.33945020D+03,0.314D+03,0.130D+02,0.29407000D+01,0.00000000D+00
     .,0.26511890D+03,0.314D+03,0.140D+02,0.29407000D+01,0.00000000D+00
     .,0.20487700D+03,0.314D+03,0.150D+02,0.29407000D+01,0.00000000D+00
     .,0.16882250D+03,0.314D+03,0.160D+02,0.29407000D+01,0.00000000D+00
     .,0.13684600D+03,0.314D+03,0.170D+02,0.29407000D+01,0.00000000D+00
     .,0.11110440D+03,0.314D+03,0.180D+02,0.29407000D+01,0.00000000D+00
     .,0.79883900D+03,0.314D+03,0.190D+02,0.29407000D+01,0.00000000D+00
     .,0.65341740D+03,0.314D+03,0.200D+02,0.29407000D+01,0.00000000D+00
     .,0.53857540D+03,0.314D+03,0.210D+02,0.29407000D+01,0.00000000D+00
     .,0.51863330D+03,0.314D+03,0.220D+02,0.29407000D+01,0.00000000D+00
     .,0.47415850D+03,0.314D+03,0.230D+02,0.29407000D+01,0.00000000D+00
     .,0.37278380D+03,0.314D+03,0.240D+02,0.29407000D+01,0.00000000D+00
     .,0.40724250D+03,0.314D+03,0.250D+02,0.29407000D+01,0.00000000D+00
     .,0.31885890D+03,0.314D+03,0.260D+02,0.29407000D+01,0.00000000D+00
     .,0.33746240D+03,0.314D+03,0.270D+02,0.29407000D+01,0.00000000D+00
     .,0.34824770D+03,0.314D+03,0.280D+02,0.29407000D+01,0.00000000D+00
     .,0.26631200D+03,0.314D+03,0.290D+02,0.29407000D+01,0.00000000D+00
     .,0.27256060D+03,0.314D+03,0.300D+02,0.29407000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 138801: 138900)=(/
     . 0.32381790D+03,0.314D+03,0.310D+02,0.29407000D+01,0.00000000D+00
     .,0.28369090D+03,0.314D+03,0.320D+02,0.29407000D+01,0.00000000D+00
     .,0.24023030D+03,0.314D+03,0.330D+02,0.29407000D+01,0.00000000D+00
     .,0.21441210D+03,0.314D+03,0.340D+02,0.29407000D+01,0.00000000D+00
     .,0.18649270D+03,0.314D+03,0.350D+02,0.29407000D+01,0.00000000D+00
     .,0.16117030D+03,0.314D+03,0.360D+02,0.29407000D+01,0.00000000D+00
     .,0.89400720D+03,0.314D+03,0.370D+02,0.29407000D+01,0.00000000D+00
     .,0.77835390D+03,0.314D+03,0.380D+02,0.29407000D+01,0.00000000D+00
     .,0.67875770D+03,0.314D+03,0.390D+02,0.29407000D+01,0.00000000D+00
     .,0.60808480D+03,0.314D+03,0.400D+02,0.29407000D+01,0.00000000D+00
     .,0.55314470D+03,0.314D+03,0.410D+02,0.29407000D+01,0.00000000D+00
     .,0.42480720D+03,0.314D+03,0.420D+02,0.29407000D+01,0.00000000D+00
     .,0.47494180D+03,0.314D+03,0.430D+02,0.29407000D+01,0.00000000D+00
     .,0.35969290D+03,0.314D+03,0.440D+02,0.29407000D+01,0.00000000D+00
     .,0.39366130D+03,0.314D+03,0.450D+02,0.29407000D+01,0.00000000D+00
     .,0.36442410D+03,0.314D+03,0.460D+02,0.29407000D+01,0.00000000D+00
     .,0.30337520D+03,0.314D+03,0.470D+02,0.29407000D+01,0.00000000D+00
     .,0.32034290D+03,0.314D+03,0.480D+02,0.29407000D+01,0.00000000D+00
     .,0.40432940D+03,0.314D+03,0.490D+02,0.29407000D+01,0.00000000D+00
     .,0.37207850D+03,0.314D+03,0.500D+02,0.29407000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 138901: 139000)=(/
     . 0.32966250D+03,0.314D+03,0.510D+02,0.29407000D+01,0.00000000D+00
     .,0.30462850D+03,0.314D+03,0.520D+02,0.29407000D+01,0.00000000D+00
     .,0.27410450D+03,0.314D+03,0.530D+02,0.29407000D+01,0.00000000D+00
     .,0.24517980D+03,0.314D+03,0.540D+02,0.29407000D+01,0.00000000D+00
     .,0.10888566D+04,0.314D+03,0.550D+02,0.29407000D+01,0.00000000D+00
     .,0.99327630D+03,0.314D+03,0.560D+02,0.29407000D+01,0.00000000D+00
     .,0.86886070D+03,0.314D+03,0.570D+02,0.29407000D+01,0.00000000D+00
     .,0.38956690D+03,0.314D+03,0.580D+02,0.29407000D+01,0.27991000D+01
     .,0.87832220D+03,0.314D+03,0.590D+02,0.29407000D+01,0.00000000D+00
     .,0.84282680D+03,0.314D+03,0.600D+02,0.29407000D+01,0.00000000D+00
     .,0.82153240D+03,0.314D+03,0.610D+02,0.29407000D+01,0.00000000D+00
     .,0.80197510D+03,0.314D+03,0.620D+02,0.29407000D+01,0.00000000D+00
     .,0.78463100D+03,0.314D+03,0.630D+02,0.29407000D+01,0.00000000D+00
     .,0.61326270D+03,0.314D+03,0.640D+02,0.29407000D+01,0.00000000D+00
     .,0.69516170D+03,0.314D+03,0.650D+02,0.29407000D+01,0.00000000D+00
     .,0.66987120D+03,0.314D+03,0.660D+02,0.29407000D+01,0.00000000D+00
     .,0.70696300D+03,0.314D+03,0.670D+02,0.29407000D+01,0.00000000D+00
     .,0.69190950D+03,0.314D+03,0.680D+02,0.29407000D+01,0.00000000D+00
     .,0.67829270D+03,0.314D+03,0.690D+02,0.29407000D+01,0.00000000D+00
     .,0.67054790D+03,0.314D+03,0.700D+02,0.29407000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 139001: 139100)=(/
     . 0.56267060D+03,0.314D+03,0.710D+02,0.29407000D+01,0.00000000D+00
     .,0.55104570D+03,0.314D+03,0.720D+02,0.29407000D+01,0.00000000D+00
     .,0.50107280D+03,0.314D+03,0.730D+02,0.29407000D+01,0.00000000D+00
     .,0.42136670D+03,0.314D+03,0.740D+02,0.29407000D+01,0.00000000D+00
     .,0.42822450D+03,0.314D+03,0.750D+02,0.29407000D+01,0.00000000D+00
     .,0.38673130D+03,0.314D+03,0.760D+02,0.29407000D+01,0.00000000D+00
     .,0.35308580D+03,0.314D+03,0.770D+02,0.29407000D+01,0.00000000D+00
     .,0.29192880D+03,0.314D+03,0.780D+02,0.29407000D+01,0.00000000D+00
     .,0.27221920D+03,0.314D+03,0.790D+02,0.29407000D+01,0.00000000D+00
     .,0.27992390D+03,0.314D+03,0.800D+02,0.29407000D+01,0.00000000D+00
     .,0.41374950D+03,0.314D+03,0.810D+02,0.29407000D+01,0.00000000D+00
     .,0.40319540D+03,0.314D+03,0.820D+02,0.29407000D+01,0.00000000D+00
     .,0.36867120D+03,0.314D+03,0.830D+02,0.29407000D+01,0.00000000D+00
     .,0.35049670D+03,0.314D+03,0.840D+02,0.29407000D+01,0.00000000D+00
     .,0.32207940D+03,0.314D+03,0.850D+02,0.29407000D+01,0.00000000D+00
     .,0.29390180D+03,0.314D+03,0.860D+02,0.29407000D+01,0.00000000D+00
     .,0.10244219D+04,0.314D+03,0.870D+02,0.29407000D+01,0.00000000D+00
     .,0.97976180D+03,0.314D+03,0.880D+02,0.29407000D+01,0.00000000D+00
     .,0.86241890D+03,0.314D+03,0.890D+02,0.29407000D+01,0.00000000D+00
     .,0.77060950D+03,0.314D+03,0.900D+02,0.29407000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 139101: 139200)=(/
     . 0.76655200D+03,0.314D+03,0.910D+02,0.29407000D+01,0.00000000D+00
     .,0.74202530D+03,0.314D+03,0.920D+02,0.29407000D+01,0.00000000D+00
     .,0.76630100D+03,0.314D+03,0.930D+02,0.29407000D+01,0.00000000D+00
     .,0.74167020D+03,0.314D+03,0.940D+02,0.29407000D+01,0.00000000D+00
     .,0.40697200D+02,0.314D+03,0.101D+03,0.29407000D+01,0.00000000D+00
     .,0.13444900D+03,0.314D+03,0.103D+03,0.29407000D+01,0.98650000D+00
     .,0.17103980D+03,0.314D+03,0.104D+03,0.29407000D+01,0.98080000D+00
     .,0.12908980D+03,0.314D+03,0.105D+03,0.29407000D+01,0.97060000D+00
     .,0.96287200D+02,0.314D+03,0.106D+03,0.29407000D+01,0.98680000D+00
     .,0.66105200D+02,0.314D+03,0.107D+03,0.29407000D+01,0.99440000D+00
     .,0.47566400D+02,0.314D+03,0.108D+03,0.29407000D+01,0.99250000D+00
     .,0.32173000D+02,0.314D+03,0.109D+03,0.29407000D+01,0.99820000D+00
     .,0.19665260D+03,0.314D+03,0.111D+03,0.29407000D+01,0.96840000D+00
     .,0.30467970D+03,0.314D+03,0.112D+03,0.29407000D+01,0.96280000D+00
     .,0.30710150D+03,0.314D+03,0.113D+03,0.29407000D+01,0.96480000D+00
     .,0.24462880D+03,0.314D+03,0.114D+03,0.29407000D+01,0.95070000D+00
     .,0.19876160D+03,0.314D+03,0.115D+03,0.29407000D+01,0.99470000D+00
     .,0.16695970D+03,0.314D+03,0.116D+03,0.29407000D+01,0.99480000D+00
     .,0.13542340D+03,0.314D+03,0.117D+03,0.29407000D+01,0.99720000D+00
     .,0.26897780D+03,0.314D+03,0.119D+03,0.29407000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters( 139201: 139300)=(/
     . 0.52175350D+03,0.314D+03,0.120D+03,0.29407000D+01,0.98310000D+00
     .,0.26771200D+03,0.314D+03,0.121D+03,0.29407000D+01,0.18627000D+01
     .,0.25825540D+03,0.314D+03,0.122D+03,0.29407000D+01,0.18299000D+01
     .,0.25306610D+03,0.314D+03,0.123D+03,0.29407000D+01,0.19138000D+01
     .,0.25088270D+03,0.314D+03,0.124D+03,0.29407000D+01,0.18269000D+01
     .,0.23001820D+03,0.314D+03,0.125D+03,0.29407000D+01,0.16406000D+01
     .,0.21251260D+03,0.314D+03,0.126D+03,0.29407000D+01,0.16483000D+01
     .,0.20263880D+03,0.314D+03,0.127D+03,0.29407000D+01,0.17149000D+01
     .,0.19815060D+03,0.314D+03,0.128D+03,0.29407000D+01,0.17937000D+01
     .,0.19629960D+03,0.314D+03,0.129D+03,0.29407000D+01,0.95760000D+00
     .,0.18325560D+03,0.314D+03,0.130D+03,0.29407000D+01,0.19419000D+01
     .,0.30359070D+03,0.314D+03,0.131D+03,0.29407000D+01,0.96010000D+00
     .,0.26489450D+03,0.314D+03,0.132D+03,0.29407000D+01,0.94340000D+00
     .,0.23602870D+03,0.314D+03,0.133D+03,0.29407000D+01,0.98890000D+00
     .,0.21449810D+03,0.314D+03,0.134D+03,0.29407000D+01,0.99010000D+00
     .,0.18783780D+03,0.314D+03,0.135D+03,0.29407000D+01,0.99740000D+00
     .,0.32026650D+03,0.314D+03,0.137D+03,0.29407000D+01,0.97380000D+00
     .,0.63491250D+03,0.314D+03,0.138D+03,0.29407000D+01,0.98010000D+00
     .,0.48074960D+03,0.314D+03,0.139D+03,0.29407000D+01,0.19153000D+01
     .,0.35400180D+03,0.314D+03,0.140D+03,0.29407000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters( 139301: 139400)=(/
     . 0.35746120D+03,0.314D+03,0.141D+03,0.29407000D+01,0.19545000D+01
     .,0.33259800D+03,0.314D+03,0.142D+03,0.29407000D+01,0.19420000D+01
     .,0.37482840D+03,0.314D+03,0.143D+03,0.29407000D+01,0.16682000D+01
     .,0.28854060D+03,0.314D+03,0.144D+03,0.29407000D+01,0.18584000D+01
     .,0.26962410D+03,0.314D+03,0.145D+03,0.29407000D+01,0.19003000D+01
     .,0.24998080D+03,0.314D+03,0.146D+03,0.29407000D+01,0.18630000D+01
     .,0.24189890D+03,0.314D+03,0.147D+03,0.29407000D+01,0.96790000D+00
     .,0.23876910D+03,0.314D+03,0.148D+03,0.29407000D+01,0.19539000D+01
     .,0.38467520D+03,0.314D+03,0.149D+03,0.29407000D+01,0.96330000D+00
     .,0.34614310D+03,0.314D+03,0.150D+03,0.29407000D+01,0.95140000D+00
     .,0.32280720D+03,0.314D+03,0.151D+03,0.29407000D+01,0.97490000D+00
     .,0.30433880D+03,0.314D+03,0.152D+03,0.29407000D+01,0.98110000D+00
     .,0.27671610D+03,0.314D+03,0.153D+03,0.29407000D+01,0.99680000D+00
     .,0.37749200D+03,0.314D+03,0.155D+03,0.29407000D+01,0.99090000D+00
     .,0.82435520D+03,0.314D+03,0.156D+03,0.29407000D+01,0.97970000D+00
     .,0.60887560D+03,0.314D+03,0.157D+03,0.29407000D+01,0.19373000D+01
     .,0.37764800D+03,0.314D+03,0.159D+03,0.29407000D+01,0.29425000D+01
     .,0.36979850D+03,0.314D+03,0.160D+03,0.29407000D+01,0.29455000D+01
     .,0.35793640D+03,0.314D+03,0.161D+03,0.29407000D+01,0.29413000D+01
     .,0.36001510D+03,0.314D+03,0.162D+03,0.29407000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters( 139401: 139500)=(/
     . 0.34780870D+03,0.314D+03,0.163D+03,0.29407000D+01,0.18286000D+01
     .,0.36250210D+03,0.314D+03,0.164D+03,0.29407000D+01,0.28732000D+01
     .,0.34013210D+03,0.314D+03,0.165D+03,0.29407000D+01,0.29086000D+01
     .,0.34661200D+03,0.314D+03,0.166D+03,0.29407000D+01,0.28965000D+01
     .,0.32261560D+03,0.314D+03,0.167D+03,0.29407000D+01,0.29242000D+01
     .,0.31332960D+03,0.314D+03,0.168D+03,0.29407000D+01,0.29282000D+01
     .,0.31141380D+03,0.314D+03,0.169D+03,0.29407000D+01,0.29246000D+01
     .,0.32794410D+03,0.314D+03,0.170D+03,0.29407000D+01,0.28482000D+01
     .,0.30090150D+03,0.314D+03,0.171D+03,0.29407000D+01,0.29219000D+01
     .,0.41188700D+03,0.314D+03,0.172D+03,0.29407000D+01,0.19254000D+01
     .,0.38080640D+03,0.314D+03,0.173D+03,0.29407000D+01,0.19459000D+01
     .,0.34601610D+03,0.314D+03,0.174D+03,0.29407000D+01,0.19292000D+01
     .,0.35118480D+03,0.314D+03,0.175D+03,0.29407000D+01,0.18104000D+01
     .,0.30465320D+03,0.314D+03,0.176D+03,0.29407000D+01,0.18858000D+01
     .,0.28600240D+03,0.314D+03,0.177D+03,0.29407000D+01,0.18648000D+01
     .,0.27277910D+03,0.314D+03,0.178D+03,0.29407000D+01,0.19188000D+01
     .,0.26060470D+03,0.314D+03,0.179D+03,0.29407000D+01,0.98460000D+00
     .,0.25111540D+03,0.314D+03,0.180D+03,0.29407000D+01,0.19896000D+01
     .,0.41199350D+03,0.314D+03,0.181D+03,0.29407000D+01,0.92670000D+00
     .,0.37352430D+03,0.314D+03,0.182D+03,0.29407000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters( 139501: 139600)=(/
     . 0.36118830D+03,0.314D+03,0.183D+03,0.29407000D+01,0.98200000D+00
     .,0.35044170D+03,0.314D+03,0.184D+03,0.29407000D+01,0.98150000D+00
     .,0.32600770D+03,0.314D+03,0.185D+03,0.29407000D+01,0.99540000D+00
     .,0.42507230D+03,0.314D+03,0.187D+03,0.29407000D+01,0.97050000D+00
     .,0.81753510D+03,0.314D+03,0.188D+03,0.29407000D+01,0.96620000D+00
     .,0.44707850D+03,0.314D+03,0.189D+03,0.29407000D+01,0.29070000D+01
     .,0.51836450D+03,0.314D+03,0.190D+03,0.29407000D+01,0.28844000D+01
     .,0.46224170D+03,0.314D+03,0.191D+03,0.29407000D+01,0.28738000D+01
     .,0.40682820D+03,0.314D+03,0.192D+03,0.29407000D+01,0.28878000D+01
     .,0.39105750D+03,0.314D+03,0.193D+03,0.29407000D+01,0.29095000D+01
     .,0.47525970D+03,0.314D+03,0.194D+03,0.29407000D+01,0.19209000D+01
     .,0.11031340D+03,0.314D+03,0.204D+03,0.29407000D+01,0.19697000D+01
     .,0.10796470D+03,0.314D+03,0.205D+03,0.29407000D+01,0.19441000D+01
     .,0.78057400D+02,0.314D+03,0.206D+03,0.29407000D+01,0.19985000D+01
     .,0.61953000D+02,0.314D+03,0.207D+03,0.29407000D+01,0.20143000D+01
     .,0.41768700D+02,0.314D+03,0.208D+03,0.29407000D+01,0.19887000D+01
     .,0.19678410D+03,0.314D+03,0.212D+03,0.29407000D+01,0.19496000D+01
     .,0.23794340D+03,0.314D+03,0.213D+03,0.29407000D+01,0.19311000D+01
     .,0.22718820D+03,0.314D+03,0.214D+03,0.29407000D+01,0.19435000D+01
     .,0.19611960D+03,0.314D+03,0.215D+03,0.29407000D+01,0.20102000D+01
     ./)
      grimme_c6_parameters( 139601: 139700)=(/
     . 0.16353520D+03,0.314D+03,0.216D+03,0.29407000D+01,0.19903000D+01
     .,0.27522420D+03,0.314D+03,0.220D+03,0.29407000D+01,0.19349000D+01
     .,0.26358530D+03,0.314D+03,0.221D+03,0.29407000D+01,0.28999000D+01
     .,0.26672430D+03,0.314D+03,0.222D+03,0.29407000D+01,0.38675000D+01
     .,0.24396540D+03,0.314D+03,0.223D+03,0.29407000D+01,0.29110000D+01
     .,0.18218540D+03,0.314D+03,0.224D+03,0.29407000D+01,0.10619100D+02
     .,0.15510950D+03,0.314D+03,0.225D+03,0.29407000D+01,0.98849000D+01
     .,0.15231640D+03,0.314D+03,0.226D+03,0.29407000D+01,0.91376000D+01
     .,0.17996900D+03,0.314D+03,0.227D+03,0.29407000D+01,0.29263000D+01
     .,0.16731730D+03,0.314D+03,0.228D+03,0.29407000D+01,0.65458000D+01
     .,0.23896240D+03,0.314D+03,0.231D+03,0.29407000D+01,0.19315000D+01
     .,0.25184820D+03,0.314D+03,0.232D+03,0.29407000D+01,0.19447000D+01
     .,0.22963620D+03,0.314D+03,0.233D+03,0.29407000D+01,0.19793000D+01
     .,0.21276790D+03,0.314D+03,0.234D+03,0.29407000D+01,0.19812000D+01
     .,0.32933860D+03,0.314D+03,0.238D+03,0.29407000D+01,0.19143000D+01
     .,0.31562100D+03,0.314D+03,0.239D+03,0.29407000D+01,0.28903000D+01
     .,0.31785670D+03,0.314D+03,0.240D+03,0.29407000D+01,0.39106000D+01
     .,0.30723810D+03,0.314D+03,0.241D+03,0.29407000D+01,0.29225000D+01
     .,0.27018990D+03,0.314D+03,0.242D+03,0.29407000D+01,0.11055600D+02
     .,0.23741460D+03,0.314D+03,0.243D+03,0.29407000D+01,0.95402000D+01
     ./)
      grimme_c6_parameters( 139701: 139800)=(/
     . 0.22392390D+03,0.314D+03,0.244D+03,0.29407000D+01,0.88895000D+01
     .,0.22893290D+03,0.314D+03,0.245D+03,0.29407000D+01,0.29696000D+01
     .,0.23956050D+03,0.314D+03,0.246D+03,0.29407000D+01,0.57095000D+01
     .,0.30725150D+03,0.314D+03,0.249D+03,0.29407000D+01,0.19378000D+01
     .,0.33420220D+03,0.314D+03,0.250D+03,0.29407000D+01,0.19505000D+01
     .,0.31357940D+03,0.314D+03,0.251D+03,0.29407000D+01,0.19523000D+01
     .,0.30173570D+03,0.314D+03,0.252D+03,0.29407000D+01,0.19639000D+01
     .,0.39768030D+03,0.314D+03,0.256D+03,0.29407000D+01,0.18467000D+01
     .,0.41154360D+03,0.314D+03,0.257D+03,0.29407000D+01,0.29175000D+01
     .,0.30359840D+03,0.314D+03,0.272D+03,0.29407000D+01,0.38840000D+01
     .,0.31746390D+03,0.314D+03,0.273D+03,0.29407000D+01,0.28988000D+01
     .,0.29346710D+03,0.314D+03,0.274D+03,0.29407000D+01,0.10915300D+02
     .,0.26545010D+03,0.314D+03,0.275D+03,0.29407000D+01,0.98054000D+01
     .,0.24889430D+03,0.314D+03,0.276D+03,0.29407000D+01,0.91527000D+01
     .,0.25448410D+03,0.314D+03,0.277D+03,0.29407000D+01,0.29424000D+01
     .,0.26790110D+03,0.314D+03,0.278D+03,0.29407000D+01,0.66669000D+01
     .,0.32692180D+03,0.314D+03,0.281D+03,0.29407000D+01,0.19302000D+01
     .,0.34569090D+03,0.314D+03,0.282D+03,0.29407000D+01,0.19356000D+01
     .,0.35194960D+03,0.314D+03,0.283D+03,0.29407000D+01,0.19655000D+01
     .,0.34876390D+03,0.314D+03,0.284D+03,0.29407000D+01,0.19639000D+01
     ./)
      grimme_c6_parameters( 139801: 139900)=(/
     . 0.43764130D+03,0.314D+03,0.288D+03,0.29407000D+01,0.18075000D+01
     .,0.81347800D+02,0.314D+03,0.305D+03,0.29407000D+01,0.29128000D+01
     .,0.72953000D+02,0.314D+03,0.306D+03,0.29407000D+01,0.29987000D+01
     .,0.54385700D+02,0.314D+03,0.307D+03,0.29407000D+01,0.29903000D+01
     .,0.18402910D+03,0.314D+03,0.313D+03,0.29407000D+01,0.29146000D+01
     .,0.22150460D+03,0.314D+03,0.314D+03,0.29407000D+01,0.29407000D+01
     .,0.21250700D+02,0.315D+03,0.100D+01,0.29859000D+01,0.91180000D+00
     .,0.14157700D+02,0.315D+03,0.200D+01,0.29859000D+01,0.00000000D+00
     .,0.30477070D+03,0.315D+03,0.300D+01,0.29859000D+01,0.00000000D+00
     .,0.18330560D+03,0.315D+03,0.400D+01,0.29859000D+01,0.00000000D+00
     .,0.12601940D+03,0.315D+03,0.500D+01,0.29859000D+01,0.00000000D+00
     .,0.86242700D+02,0.315D+03,0.600D+01,0.29859000D+01,0.00000000D+00
     .,0.60766300D+02,0.315D+03,0.700D+01,0.29859000D+01,0.00000000D+00
     .,0.46192700D+02,0.315D+03,0.800D+01,0.29859000D+01,0.00000000D+00
     .,0.35073300D+02,0.315D+03,0.900D+01,0.29859000D+01,0.00000000D+00
     .,0.26999000D+02,0.315D+03,0.100D+02,0.29859000D+01,0.00000000D+00
     .,0.36521100D+03,0.315D+03,0.110D+02,0.29859000D+01,0.00000000D+00
     .,0.28990900D+03,0.315D+03,0.120D+02,0.29859000D+01,0.00000000D+00
     .,0.27035350D+03,0.315D+03,0.130D+02,0.29859000D+01,0.00000000D+00
     .,0.21613030D+03,0.315D+03,0.140D+02,0.29859000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 139901: 140000)=(/
     . 0.17040450D+03,0.315D+03,0.150D+02,0.29859000D+01,0.00000000D+00
     .,0.14229820D+03,0.315D+03,0.160D+02,0.29859000D+01,0.00000000D+00
     .,0.11683550D+03,0.315D+03,0.170D+02,0.29859000D+01,0.00000000D+00
     .,0.95933600D+02,0.315D+03,0.180D+02,0.29859000D+01,0.00000000D+00
     .,0.59510330D+03,0.315D+03,0.190D+02,0.29859000D+01,0.00000000D+00
     .,0.50296540D+03,0.315D+03,0.200D+02,0.29859000D+01,0.00000000D+00
     .,0.41774000D+03,0.315D+03,0.210D+02,0.29859000D+01,0.00000000D+00
     .,0.40534620D+03,0.315D+03,0.220D+02,0.29859000D+01,0.00000000D+00
     .,0.37223260D+03,0.315D+03,0.230D+02,0.29859000D+01,0.00000000D+00
     .,0.29326800D+03,0.315D+03,0.240D+02,0.29859000D+01,0.00000000D+00
     .,0.32176790D+03,0.315D+03,0.250D+02,0.29859000D+01,0.00000000D+00
     .,0.25267400D+03,0.315D+03,0.260D+02,0.29859000D+01,0.00000000D+00
     .,0.26948070D+03,0.315D+03,0.270D+02,0.29859000D+01,0.00000000D+00
     .,0.27679850D+03,0.315D+03,0.280D+02,0.29859000D+01,0.00000000D+00
     .,0.21213400D+03,0.315D+03,0.290D+02,0.29859000D+01,0.00000000D+00
     .,0.21980160D+03,0.315D+03,0.300D+02,0.29859000D+01,0.00000000D+00
     .,0.25991840D+03,0.315D+03,0.310D+02,0.29859000D+01,0.00000000D+00
     .,0.23175640D+03,0.315D+03,0.320D+02,0.29859000D+01,0.00000000D+00
     .,0.19950090D+03,0.315D+03,0.330D+02,0.29859000D+01,0.00000000D+00
     .,0.17993740D+03,0.315D+03,0.340D+02,0.29859000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 140001: 140100)=(/
     . 0.15821040D+03,0.315D+03,0.350D+02,0.29859000D+01,0.00000000D+00
     .,0.13810760D+03,0.315D+03,0.360D+02,0.29859000D+01,0.00000000D+00
     .,0.66844010D+03,0.315D+03,0.370D+02,0.29859000D+01,0.00000000D+00
     .,0.59874980D+03,0.315D+03,0.380D+02,0.29859000D+01,0.00000000D+00
     .,0.52942130D+03,0.315D+03,0.390D+02,0.29859000D+01,0.00000000D+00
     .,0.47851960D+03,0.315D+03,0.400D+02,0.29859000D+01,0.00000000D+00
     .,0.43792800D+03,0.315D+03,0.410D+02,0.29859000D+01,0.00000000D+00
     .,0.34005920D+03,0.315D+03,0.420D+02,0.29859000D+01,0.00000000D+00
     .,0.37860580D+03,0.315D+03,0.430D+02,0.29859000D+01,0.00000000D+00
     .,0.29020770D+03,0.315D+03,0.440D+02,0.29859000D+01,0.00000000D+00
     .,0.31726290D+03,0.315D+03,0.450D+02,0.29859000D+01,0.00000000D+00
     .,0.29479860D+03,0.315D+03,0.460D+02,0.29859000D+01,0.00000000D+00
     .,0.24529960D+03,0.315D+03,0.470D+02,0.29859000D+01,0.00000000D+00
     .,0.26038920D+03,0.315D+03,0.480D+02,0.29859000D+01,0.00000000D+00
     .,0.32473460D+03,0.315D+03,0.490D+02,0.29859000D+01,0.00000000D+00
     .,0.30300330D+03,0.315D+03,0.500D+02,0.29859000D+01,0.00000000D+00
     .,0.27228130D+03,0.315D+03,0.510D+02,0.29859000D+01,0.00000000D+00
     .,0.25382690D+03,0.315D+03,0.520D+02,0.29859000D+01,0.00000000D+00
     .,0.23058600D+03,0.315D+03,0.530D+02,0.29859000D+01,0.00000000D+00
     .,0.20815070D+03,0.315D+03,0.540D+02,0.29859000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 140101: 140200)=(/
     . 0.81515180D+03,0.315D+03,0.550D+02,0.29859000D+01,0.00000000D+00
     .,0.76114330D+03,0.315D+03,0.560D+02,0.29859000D+01,0.00000000D+00
     .,0.67494890D+03,0.315D+03,0.570D+02,0.29859000D+01,0.00000000D+00
     .,0.32113780D+03,0.315D+03,0.580D+02,0.29859000D+01,0.27991000D+01
     .,0.67620310D+03,0.315D+03,0.590D+02,0.29859000D+01,0.00000000D+00
     .,0.65026390D+03,0.315D+03,0.600D+02,0.29859000D+01,0.00000000D+00
     .,0.63420890D+03,0.315D+03,0.610D+02,0.29859000D+01,0.00000000D+00
     .,0.61941760D+03,0.315D+03,0.620D+02,0.29859000D+01,0.00000000D+00
     .,0.60631410D+03,0.315D+03,0.630D+02,0.29859000D+01,0.00000000D+00
     .,0.48160310D+03,0.315D+03,0.640D+02,0.29859000D+01,0.00000000D+00
     .,0.53441950D+03,0.315D+03,0.650D+02,0.29859000D+01,0.00000000D+00
     .,0.51638640D+03,0.315D+03,0.660D+02,0.29859000D+01,0.00000000D+00
     .,0.54808770D+03,0.315D+03,0.670D+02,0.29859000D+01,0.00000000D+00
     .,0.53658580D+03,0.315D+03,0.680D+02,0.29859000D+01,0.00000000D+00
     .,0.52628420D+03,0.315D+03,0.690D+02,0.29859000D+01,0.00000000D+00
     .,0.51991030D+03,0.315D+03,0.700D+02,0.29859000D+01,0.00000000D+00
     .,0.44109130D+03,0.315D+03,0.710D+02,0.29859000D+01,0.00000000D+00
     .,0.43800800D+03,0.315D+03,0.720D+02,0.29859000D+01,0.00000000D+00
     .,0.40185550D+03,0.315D+03,0.730D+02,0.29859000D+01,0.00000000D+00
     .,0.34062380D+03,0.315D+03,0.740D+02,0.29859000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 140201: 140300)=(/
     . 0.34722720D+03,0.315D+03,0.750D+02,0.29859000D+01,0.00000000D+00
     .,0.31601980D+03,0.315D+03,0.760D+02,0.29859000D+01,0.00000000D+00
     .,0.29035810D+03,0.315D+03,0.770D+02,0.29859000D+01,0.00000000D+00
     .,0.24187400D+03,0.315D+03,0.780D+02,0.29859000D+01,0.00000000D+00
     .,0.22620530D+03,0.315D+03,0.790D+02,0.29859000D+01,0.00000000D+00
     .,0.23313640D+03,0.315D+03,0.800D+02,0.29859000D+01,0.00000000D+00
     .,0.33397090D+03,0.315D+03,0.810D+02,0.29859000D+01,0.00000000D+00
     .,0.32879450D+03,0.315D+03,0.820D+02,0.29859000D+01,0.00000000D+00
     .,0.30437900D+03,0.315D+03,0.830D+02,0.29859000D+01,0.00000000D+00
     .,0.29151300D+03,0.315D+03,0.840D+02,0.29859000D+01,0.00000000D+00
     .,0.27029090D+03,0.315D+03,0.850D+02,0.29859000D+01,0.00000000D+00
     .,0.24870320D+03,0.315D+03,0.860D+02,0.29859000D+01,0.00000000D+00
     .,0.77546700D+03,0.315D+03,0.870D+02,0.29859000D+01,0.00000000D+00
     .,0.75632330D+03,0.315D+03,0.880D+02,0.29859000D+01,0.00000000D+00
     .,0.67406280D+03,0.315D+03,0.890D+02,0.29859000D+01,0.00000000D+00
     .,0.61138240D+03,0.315D+03,0.900D+02,0.29859000D+01,0.00000000D+00
     .,0.60405420D+03,0.315D+03,0.910D+02,0.29859000D+01,0.00000000D+00
     .,0.58496010D+03,0.315D+03,0.920D+02,0.29859000D+01,0.00000000D+00
     .,0.59856780D+03,0.315D+03,0.930D+02,0.29859000D+01,0.00000000D+00
     .,0.58026720D+03,0.315D+03,0.940D+02,0.29859000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 140301: 140400)=(/
     . 0.33919300D+02,0.315D+03,0.101D+03,0.29859000D+01,0.00000000D+00
     .,0.10684660D+03,0.315D+03,0.103D+03,0.29859000D+01,0.98650000D+00
     .,0.13686740D+03,0.315D+03,0.104D+03,0.29859000D+01,0.98080000D+00
     .,0.10639230D+03,0.315D+03,0.105D+03,0.29859000D+01,0.97060000D+00
     .,0.80849600D+02,0.315D+03,0.106D+03,0.29859000D+01,0.98680000D+00
     .,0.56650800D+02,0.315D+03,0.107D+03,0.29859000D+01,0.99440000D+00
     .,0.41460000D+02,0.315D+03,0.108D+03,0.29859000D+01,0.99250000D+00
     .,0.28636200D+02,0.315D+03,0.109D+03,0.29859000D+01,0.99820000D+00
     .,0.15544950D+03,0.315D+03,0.111D+03,0.29859000D+01,0.96840000D+00
     .,0.24015820D+03,0.315D+03,0.112D+03,0.29859000D+01,0.96280000D+00
     .,0.24565290D+03,0.315D+03,0.113D+03,0.29859000D+01,0.96480000D+00
     .,0.20014220D+03,0.315D+03,0.114D+03,0.29859000D+01,0.95070000D+00
     .,0.16545180D+03,0.315D+03,0.115D+03,0.29859000D+01,0.99470000D+00
     .,0.14069580D+03,0.315D+03,0.116D+03,0.29859000D+01,0.99480000D+00
     .,0.11560060D+03,0.315D+03,0.117D+03,0.29859000D+01,0.99720000D+00
     .,0.21584670D+03,0.315D+03,0.119D+03,0.29859000D+01,0.97670000D+00
     .,0.40282860D+03,0.315D+03,0.120D+03,0.29859000D+01,0.98310000D+00
     .,0.21843190D+03,0.315D+03,0.121D+03,0.29859000D+01,0.18627000D+01
     .,0.21092280D+03,0.315D+03,0.122D+03,0.29859000D+01,0.18299000D+01
     .,0.20662740D+03,0.315D+03,0.123D+03,0.29859000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters( 140401: 140500)=(/
     . 0.20440810D+03,0.315D+03,0.124D+03,0.29859000D+01,0.18269000D+01
     .,0.18931020D+03,0.315D+03,0.125D+03,0.29859000D+01,0.16406000D+01
     .,0.17549190D+03,0.315D+03,0.126D+03,0.29859000D+01,0.16483000D+01
     .,0.16737650D+03,0.315D+03,0.127D+03,0.29859000D+01,0.17149000D+01
     .,0.16353010D+03,0.315D+03,0.128D+03,0.29859000D+01,0.17937000D+01
     .,0.16072250D+03,0.315D+03,0.129D+03,0.29859000D+01,0.95760000D+00
     .,0.15220000D+03,0.315D+03,0.130D+03,0.29859000D+01,0.19419000D+01
     .,0.24479640D+03,0.315D+03,0.131D+03,0.29859000D+01,0.96010000D+00
     .,0.21733500D+03,0.315D+03,0.132D+03,0.29859000D+01,0.94340000D+00
     .,0.19621220D+03,0.315D+03,0.133D+03,0.29859000D+01,0.98890000D+00
     .,0.17998620D+03,0.315D+03,0.134D+03,0.29859000D+01,0.99010000D+00
     .,0.15926660D+03,0.315D+03,0.135D+03,0.29859000D+01,0.99740000D+00
     .,0.25815200D+03,0.315D+03,0.137D+03,0.29859000D+01,0.97380000D+00
     .,0.48959430D+03,0.315D+03,0.138D+03,0.29859000D+01,0.98010000D+00
     .,0.38114140D+03,0.315D+03,0.139D+03,0.29859000D+01,0.19153000D+01
     .,0.28866370D+03,0.315D+03,0.140D+03,0.29859000D+01,0.19355000D+01
     .,0.29138130D+03,0.315D+03,0.141D+03,0.29859000D+01,0.19545000D+01
     .,0.27224210D+03,0.315D+03,0.142D+03,0.29859000D+01,0.19420000D+01
     .,0.30274930D+03,0.315D+03,0.143D+03,0.29859000D+01,0.16682000D+01
     .,0.23860140D+03,0.315D+03,0.144D+03,0.29859000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters( 140501: 140600)=(/
     . 0.22325490D+03,0.315D+03,0.145D+03,0.29859000D+01,0.19003000D+01
     .,0.20745050D+03,0.315D+03,0.146D+03,0.29859000D+01,0.18630000D+01
     .,0.20043480D+03,0.315D+03,0.147D+03,0.29859000D+01,0.96790000D+00
     .,0.19927140D+03,0.315D+03,0.148D+03,0.29859000D+01,0.19539000D+01
     .,0.31050480D+03,0.315D+03,0.149D+03,0.29859000D+01,0.96330000D+00
     .,0.28348980D+03,0.315D+03,0.150D+03,0.29859000D+01,0.95140000D+00
     .,0.26714010D+03,0.315D+03,0.151D+03,0.29859000D+01,0.97490000D+00
     .,0.25372280D+03,0.315D+03,0.152D+03,0.29859000D+01,0.98110000D+00
     .,0.23274260D+03,0.315D+03,0.153D+03,0.29859000D+01,0.99680000D+00
     .,0.30765740D+03,0.315D+03,0.155D+03,0.29859000D+01,0.99090000D+00
     .,0.63261590D+03,0.315D+03,0.156D+03,0.29859000D+01,0.97970000D+00
     .,0.48173950D+03,0.315D+03,0.157D+03,0.29859000D+01,0.19373000D+01
     .,0.31158240D+03,0.315D+03,0.159D+03,0.29859000D+01,0.29425000D+01
     .,0.30515280D+03,0.315D+03,0.160D+03,0.29859000D+01,0.29455000D+01
     .,0.29558710D+03,0.315D+03,0.161D+03,0.29859000D+01,0.29413000D+01
     .,0.29668160D+03,0.315D+03,0.162D+03,0.29859000D+01,0.29300000D+01
     .,0.28470850D+03,0.315D+03,0.163D+03,0.29859000D+01,0.18286000D+01
     .,0.29847730D+03,0.315D+03,0.164D+03,0.29859000D+01,0.28732000D+01
     .,0.28058560D+03,0.315D+03,0.165D+03,0.29859000D+01,0.29086000D+01
     .,0.28487000D+03,0.315D+03,0.166D+03,0.29859000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters( 140601: 140700)=(/
     . 0.26661130D+03,0.315D+03,0.167D+03,0.29859000D+01,0.29242000D+01
     .,0.25911400D+03,0.315D+03,0.168D+03,0.29859000D+01,0.29282000D+01
     .,0.25737860D+03,0.315D+03,0.169D+03,0.29859000D+01,0.29246000D+01
     .,0.27013590D+03,0.315D+03,0.170D+03,0.29859000D+01,0.28482000D+01
     .,0.24893750D+03,0.315D+03,0.171D+03,0.29859000D+01,0.29219000D+01
     .,0.33258120D+03,0.315D+03,0.172D+03,0.29859000D+01,0.19254000D+01
     .,0.31015250D+03,0.315D+03,0.173D+03,0.29859000D+01,0.19459000D+01
     .,0.28435150D+03,0.315D+03,0.174D+03,0.29859000D+01,0.19292000D+01
     .,0.28639060D+03,0.315D+03,0.175D+03,0.29859000D+01,0.18104000D+01
     .,0.25354990D+03,0.315D+03,0.176D+03,0.29859000D+01,0.18858000D+01
     .,0.23881810D+03,0.315D+03,0.177D+03,0.29859000D+01,0.18648000D+01
     .,0.22823770D+03,0.315D+03,0.178D+03,0.29859000D+01,0.19188000D+01
     .,0.21805720D+03,0.315D+03,0.179D+03,0.29859000D+01,0.98460000D+00
     .,0.21157770D+03,0.315D+03,0.180D+03,0.29859000D+01,0.19896000D+01
     .,0.33379720D+03,0.315D+03,0.181D+03,0.29859000D+01,0.92670000D+00
     .,0.30690290D+03,0.315D+03,0.182D+03,0.29859000D+01,0.93830000D+00
     .,0.29903800D+03,0.315D+03,0.183D+03,0.29859000D+01,0.98200000D+00
     .,0.29178570D+03,0.315D+03,0.184D+03,0.29859000D+01,0.98150000D+00
     .,0.27360270D+03,0.315D+03,0.185D+03,0.29859000D+01,0.99540000D+00
     .,0.34671520D+03,0.315D+03,0.187D+03,0.29859000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters( 140701: 140800)=(/
     . 0.63297580D+03,0.315D+03,0.188D+03,0.29859000D+01,0.96620000D+00
     .,0.36867540D+03,0.315D+03,0.189D+03,0.29859000D+01,0.29070000D+01
     .,0.42237050D+03,0.315D+03,0.190D+03,0.29859000D+01,0.28844000D+01
     .,0.37847190D+03,0.315D+03,0.191D+03,0.29859000D+01,0.28738000D+01
     .,0.33627890D+03,0.315D+03,0.192D+03,0.29859000D+01,0.28878000D+01
     .,0.32395480D+03,0.315D+03,0.193D+03,0.29859000D+01,0.29095000D+01
     .,0.38367070D+03,0.315D+03,0.194D+03,0.29859000D+01,0.19209000D+01
     .,0.91020600D+02,0.315D+03,0.204D+03,0.29859000D+01,0.19697000D+01
     .,0.89639100D+02,0.315D+03,0.205D+03,0.29859000D+01,0.19441000D+01
     .,0.66234300D+02,0.315D+03,0.206D+03,0.29859000D+01,0.19985000D+01
     .,0.53207600D+02,0.315D+03,0.207D+03,0.29859000D+01,0.20143000D+01
     .,0.36587500D+02,0.315D+03,0.208D+03,0.29859000D+01,0.19887000D+01
     .,0.15995620D+03,0.315D+03,0.212D+03,0.29859000D+01,0.19496000D+01
     .,0.19311320D+03,0.315D+03,0.213D+03,0.29859000D+01,0.19311000D+01
     .,0.18650310D+03,0.315D+03,0.214D+03,0.29859000D+01,0.19435000D+01
     .,0.16307640D+03,0.315D+03,0.215D+03,0.29859000D+01,0.20102000D+01
     .,0.13785400D+03,0.315D+03,0.216D+03,0.29859000D+01,0.19903000D+01
     .,0.22395660D+03,0.315D+03,0.220D+03,0.29859000D+01,0.19349000D+01
     .,0.21640380D+03,0.315D+03,0.221D+03,0.29859000D+01,0.28999000D+01
     .,0.21913910D+03,0.315D+03,0.222D+03,0.29859000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters( 140801: 140900)=(/
     . 0.20040530D+03,0.315D+03,0.223D+03,0.29859000D+01,0.29110000D+01
     .,0.15200100D+03,0.315D+03,0.224D+03,0.29859000D+01,0.10619100D+02
     .,0.13062480D+03,0.315D+03,0.225D+03,0.29859000D+01,0.98849000D+01
     .,0.12812710D+03,0.315D+03,0.226D+03,0.29859000D+01,0.91376000D+01
     .,0.14911580D+03,0.315D+03,0.227D+03,0.29859000D+01,0.29263000D+01
     .,0.13922010D+03,0.315D+03,0.228D+03,0.29859000D+01,0.65458000D+01
     .,0.19576670D+03,0.315D+03,0.231D+03,0.29859000D+01,0.19315000D+01
     .,0.20723900D+03,0.315D+03,0.232D+03,0.29859000D+01,0.19447000D+01
     .,0.19122650D+03,0.315D+03,0.233D+03,0.29859000D+01,0.19793000D+01
     .,0.17859070D+03,0.315D+03,0.234D+03,0.29859000D+01,0.19812000D+01
     .,0.26845260D+03,0.315D+03,0.238D+03,0.29859000D+01,0.19143000D+01
     .,0.26022540D+03,0.315D+03,0.239D+03,0.29859000D+01,0.28903000D+01
     .,0.26296750D+03,0.315D+03,0.240D+03,0.29859000D+01,0.39106000D+01
     .,0.25404600D+03,0.315D+03,0.241D+03,0.29859000D+01,0.29225000D+01
     .,0.22570300D+03,0.315D+03,0.242D+03,0.29859000D+01,0.11055600D+02
     .,0.19994180D+03,0.315D+03,0.243D+03,0.29859000D+01,0.95402000D+01
     .,0.18915600D+03,0.315D+03,0.244D+03,0.29859000D+01,0.88895000D+01
     .,0.19169620D+03,0.315D+03,0.245D+03,0.29859000D+01,0.29696000D+01
     .,0.19999790D+03,0.315D+03,0.246D+03,0.29859000D+01,0.57095000D+01
     .,0.25244560D+03,0.315D+03,0.249D+03,0.29859000D+01,0.19378000D+01
     ./)
      grimme_c6_parameters( 140901: 141000)=(/
     . 0.27452930D+03,0.315D+03,0.250D+03,0.29859000D+01,0.19505000D+01
     .,0.26015780D+03,0.315D+03,0.251D+03,0.29859000D+01,0.19523000D+01
     .,0.25179490D+03,0.315D+03,0.252D+03,0.29859000D+01,0.19639000D+01
     .,0.32533280D+03,0.315D+03,0.256D+03,0.29859000D+01,0.18467000D+01
     .,0.33853620D+03,0.315D+03,0.257D+03,0.29859000D+01,0.29175000D+01
     .,0.25238610D+03,0.315D+03,0.272D+03,0.29859000D+01,0.38840000D+01
     .,0.26287220D+03,0.315D+03,0.273D+03,0.29859000D+01,0.28988000D+01
     .,0.24530820D+03,0.315D+03,0.274D+03,0.29859000D+01,0.10915300D+02
     .,0.22353440D+03,0.315D+03,0.275D+03,0.29859000D+01,0.98054000D+01
     .,0.21084220D+03,0.315D+03,0.276D+03,0.29859000D+01,0.91527000D+01
     .,0.21397300D+03,0.315D+03,0.277D+03,0.29859000D+01,0.29424000D+01
     .,0.22500270D+03,0.315D+03,0.278D+03,0.29859000D+01,0.66669000D+01
     .,0.27049420D+03,0.315D+03,0.281D+03,0.29859000D+01,0.19302000D+01
     .,0.28607870D+03,0.315D+03,0.282D+03,0.29859000D+01,0.19356000D+01
     .,0.29230220D+03,0.315D+03,0.283D+03,0.29859000D+01,0.19655000D+01
     .,0.29076120D+03,0.315D+03,0.284D+03,0.29859000D+01,0.19639000D+01
     .,0.35840590D+03,0.315D+03,0.288D+03,0.29859000D+01,0.18075000D+01
     .,0.68800700D+02,0.315D+03,0.305D+03,0.29859000D+01,0.29128000D+01
     .,0.61943300D+02,0.315D+03,0.306D+03,0.29859000D+01,0.29987000D+01
     .,0.46863500D+02,0.315D+03,0.307D+03,0.29859000D+01,0.29903000D+01
     ./)
      grimme_c6_parameters( 141001: 141100)=(/
     . 0.15204520D+03,0.315D+03,0.313D+03,0.29859000D+01,0.29146000D+01
     .,0.18148400D+03,0.315D+03,0.314D+03,0.29859000D+01,0.29407000D+01
     .,0.15168860D+03,0.315D+03,0.315D+03,0.29859000D+01,0.29859000D+01
     .,0.18750000D+02,0.327D+03,0.100D+01,0.77785000D+01,0.91180000D+00
     .,0.12752300D+02,0.327D+03,0.200D+01,0.77785000D+01,0.00000000D+00
     .,0.27075980D+03,0.327D+03,0.300D+01,0.77785000D+01,0.00000000D+00
     .,0.16088700D+03,0.327D+03,0.400D+01,0.77785000D+01,0.00000000D+00
     .,0.11053650D+03,0.327D+03,0.500D+01,0.77785000D+01,0.00000000D+00
     .,0.76007200D+02,0.327D+03,0.600D+01,0.77785000D+01,0.00000000D+00
     .,0.53969500D+02,0.327D+03,0.700D+01,0.77785000D+01,0.00000000D+00
     .,0.41362300D+02,0.327D+03,0.800D+01,0.77785000D+01,0.00000000D+00
     .,0.31698500D+02,0.327D+03,0.900D+01,0.77785000D+01,0.00000000D+00
     .,0.24634300D+02,0.327D+03,0.100D+02,0.77785000D+01,0.00000000D+00
     .,0.32462410D+03,0.327D+03,0.110D+02,0.77785000D+01,0.00000000D+00
     .,0.25515610D+03,0.327D+03,0.120D+02,0.77785000D+01,0.00000000D+00
     .,0.23739610D+03,0.327D+03,0.130D+02,0.77785000D+01,0.00000000D+00
     .,0.18954880D+03,0.327D+03,0.140D+02,0.77785000D+01,0.00000000D+00
     .,0.14967090D+03,0.327D+03,0.150D+02,0.77785000D+01,0.00000000D+00
     .,0.12537250D+03,0.327D+03,0.160D+02,0.77785000D+01,0.00000000D+00
     .,0.10339310D+03,0.327D+03,0.170D+02,0.77785000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 141101: 141200)=(/
     . 0.85361600D+02,0.327D+03,0.180D+02,0.77785000D+01,0.00000000D+00
     .,0.53130440D+03,0.327D+03,0.190D+02,0.77785000D+01,0.00000000D+00
     .,0.44506810D+03,0.327D+03,0.200D+02,0.77785000D+01,0.00000000D+00
     .,0.36908350D+03,0.327D+03,0.210D+02,0.77785000D+01,0.00000000D+00
     .,0.35797830D+03,0.327D+03,0.220D+02,0.77785000D+01,0.00000000D+00
     .,0.32864070D+03,0.327D+03,0.230D+02,0.77785000D+01,0.00000000D+00
     .,0.25957220D+03,0.327D+03,0.240D+02,0.77785000D+01,0.00000000D+00
     .,0.28401670D+03,0.327D+03,0.250D+02,0.77785000D+01,0.00000000D+00
     .,0.22363540D+03,0.327D+03,0.260D+02,0.77785000D+01,0.00000000D+00
     .,0.23769940D+03,0.327D+03,0.270D+02,0.77785000D+01,0.00000000D+00
     .,0.24420530D+03,0.327D+03,0.280D+02,0.77785000D+01,0.00000000D+00
     .,0.18784400D+03,0.327D+03,0.290D+02,0.77785000D+01,0.00000000D+00
     .,0.19385700D+03,0.327D+03,0.300D+02,0.77785000D+01,0.00000000D+00
     .,0.22867850D+03,0.327D+03,0.310D+02,0.77785000D+01,0.00000000D+00
     .,0.20362780D+03,0.327D+03,0.320D+02,0.77785000D+01,0.00000000D+00
     .,0.17541210D+03,0.327D+03,0.330D+02,0.77785000D+01,0.00000000D+00
     .,0.15849070D+03,0.327D+03,0.340D+02,0.77785000D+01,0.00000000D+00
     .,0.13975410D+03,0.327D+03,0.350D+02,0.77785000D+01,0.00000000D+00
     .,0.12245360D+03,0.327D+03,0.360D+02,0.77785000D+01,0.00000000D+00
     .,0.59683060D+03,0.327D+03,0.370D+02,0.77785000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 141201: 141300)=(/
     . 0.53035890D+03,0.327D+03,0.380D+02,0.77785000D+01,0.00000000D+00
     .,0.46786120D+03,0.327D+03,0.390D+02,0.77785000D+01,0.00000000D+00
     .,0.42252080D+03,0.327D+03,0.400D+02,0.77785000D+01,0.00000000D+00
     .,0.38664910D+03,0.327D+03,0.410D+02,0.77785000D+01,0.00000000D+00
     .,0.30067530D+03,0.327D+03,0.420D+02,0.77785000D+01,0.00000000D+00
     .,0.33455830D+03,0.327D+03,0.430D+02,0.77785000D+01,0.00000000D+00
     .,0.25692950D+03,0.327D+03,0.440D+02,0.77785000D+01,0.00000000D+00
     .,0.28039530D+03,0.327D+03,0.450D+02,0.77785000D+01,0.00000000D+00
     .,0.26063370D+03,0.327D+03,0.460D+02,0.77785000D+01,0.00000000D+00
     .,0.21771120D+03,0.327D+03,0.470D+02,0.77785000D+01,0.00000000D+00
     .,0.23040100D+03,0.327D+03,0.480D+02,0.77785000D+01,0.00000000D+00
     .,0.28692990D+03,0.327D+03,0.490D+02,0.77785000D+01,0.00000000D+00
     .,0.26720820D+03,0.327D+03,0.500D+02,0.77785000D+01,0.00000000D+00
     .,0.24003960D+03,0.327D+03,0.510D+02,0.77785000D+01,0.00000000D+00
     .,0.22389640D+03,0.327D+03,0.520D+02,0.77785000D+01,0.00000000D+00
     .,0.20368550D+03,0.327D+03,0.530D+02,0.77785000D+01,0.00000000D+00
     .,0.18426650D+03,0.327D+03,0.540D+02,0.77785000D+01,0.00000000D+00
     .,0.72757110D+03,0.327D+03,0.550D+02,0.77785000D+01,0.00000000D+00
     .,0.67509330D+03,0.327D+03,0.560D+02,0.77785000D+01,0.00000000D+00
     .,0.59711540D+03,0.327D+03,0.570D+02,0.77785000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 141301: 141400)=(/
     . 0.28341080D+03,0.327D+03,0.580D+02,0.77785000D+01,0.27991000D+01
     .,0.59987830D+03,0.327D+03,0.590D+02,0.77785000D+01,0.00000000D+00
     .,0.57662050D+03,0.327D+03,0.600D+02,0.77785000D+01,0.00000000D+00
     .,0.56231220D+03,0.327D+03,0.610D+02,0.77785000D+01,0.00000000D+00
     .,0.54912780D+03,0.327D+03,0.620D+02,0.77785000D+01,0.00000000D+00
     .,0.53743950D+03,0.327D+03,0.630D+02,0.77785000D+01,0.00000000D+00
     .,0.42647230D+03,0.327D+03,0.640D+02,0.77785000D+01,0.00000000D+00
     .,0.47530650D+03,0.327D+03,0.650D+02,0.77785000D+01,0.00000000D+00
     .,0.45903360D+03,0.327D+03,0.660D+02,0.77785000D+01,0.00000000D+00
     .,0.48549610D+03,0.327D+03,0.670D+02,0.77785000D+01,0.00000000D+00
     .,0.47524580D+03,0.327D+03,0.680D+02,0.77785000D+01,0.00000000D+00
     .,0.46604870D+03,0.327D+03,0.690D+02,0.77785000D+01,0.00000000D+00
     .,0.46040630D+03,0.327D+03,0.700D+02,0.77785000D+01,0.00000000D+00
     .,0.39029370D+03,0.327D+03,0.710D+02,0.77785000D+01,0.00000000D+00
     .,0.38633500D+03,0.327D+03,0.720D+02,0.77785000D+01,0.00000000D+00
     .,0.35438040D+03,0.327D+03,0.730D+02,0.77785000D+01,0.00000000D+00
     .,0.30091280D+03,0.327D+03,0.740D+02,0.77785000D+01,0.00000000D+00
     .,0.30657700D+03,0.327D+03,0.750D+02,0.77785000D+01,0.00000000D+00
     .,0.27917480D+03,0.327D+03,0.760D+02,0.77785000D+01,0.00000000D+00
     .,0.25671260D+03,0.327D+03,0.770D+02,0.77785000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 141401: 141500)=(/
     . 0.21450850D+03,0.327D+03,0.780D+02,0.77785000D+01,0.00000000D+00
     .,0.20089400D+03,0.327D+03,0.790D+02,0.77785000D+01,0.00000000D+00
     .,0.20681470D+03,0.327D+03,0.800D+02,0.77785000D+01,0.00000000D+00
     .,0.29586670D+03,0.327D+03,0.810D+02,0.77785000D+01,0.00000000D+00
     .,0.29066840D+03,0.327D+03,0.820D+02,0.77785000D+01,0.00000000D+00
     .,0.26889430D+03,0.327D+03,0.830D+02,0.77785000D+01,0.00000000D+00
     .,0.25754500D+03,0.327D+03,0.840D+02,0.77785000D+01,0.00000000D+00
     .,0.23900100D+03,0.327D+03,0.850D+02,0.77785000D+01,0.00000000D+00
     .,0.22025450D+03,0.327D+03,0.860D+02,0.77785000D+01,0.00000000D+00
     .,0.69085290D+03,0.327D+03,0.870D+02,0.77785000D+01,0.00000000D+00
     .,0.67010980D+03,0.327D+03,0.880D+02,0.77785000D+01,0.00000000D+00
     .,0.59610010D+03,0.327D+03,0.890D+02,0.77785000D+01,0.00000000D+00
     .,0.54016650D+03,0.327D+03,0.900D+02,0.77785000D+01,0.00000000D+00
     .,0.53472260D+03,0.327D+03,0.910D+02,0.77785000D+01,0.00000000D+00
     .,0.51792390D+03,0.327D+03,0.920D+02,0.77785000D+01,0.00000000D+00
     .,0.53080430D+03,0.327D+03,0.930D+02,0.77785000D+01,0.00000000D+00
     .,0.51445080D+03,0.327D+03,0.940D+02,0.77785000D+01,0.00000000D+00
     .,0.29768000D+02,0.327D+03,0.101D+03,0.77785000D+01,0.00000000D+00
     .,0.93835600D+02,0.327D+03,0.103D+03,0.77785000D+01,0.98650000D+00
     .,0.12018800D+03,0.327D+03,0.104D+03,0.77785000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters( 141501: 141600)=(/
     . 0.93454100D+02,0.327D+03,0.105D+03,0.77785000D+01,0.97060000D+00
     .,0.71331800D+02,0.327D+03,0.106D+03,0.77785000D+01,0.98680000D+00
     .,0.50381400D+02,0.327D+03,0.107D+03,0.77785000D+01,0.99440000D+00
     .,0.37217800D+02,0.327D+03,0.108D+03,0.77785000D+01,0.99250000D+00
     .,0.26103100D+02,0.327D+03,0.109D+03,0.77785000D+01,0.99820000D+00
     .,0.13698410D+03,0.327D+03,0.111D+03,0.77785000D+01,0.96840000D+00
     .,0.21133880D+03,0.327D+03,0.112D+03,0.77785000D+01,0.96280000D+00
     .,0.21570660D+03,0.327D+03,0.113D+03,0.77785000D+01,0.96480000D+00
     .,0.17559630D+03,0.327D+03,0.114D+03,0.77785000D+01,0.95070000D+00
     .,0.14538010D+03,0.327D+03,0.115D+03,0.77785000D+01,0.99470000D+00
     .,0.12399050D+03,0.327D+03,0.116D+03,0.77785000D+01,0.99480000D+00
     .,0.10232230D+03,0.327D+03,0.117D+03,0.77785000D+01,0.99720000D+00
     .,0.19095210D+03,0.327D+03,0.119D+03,0.77785000D+01,0.97670000D+00
     .,0.35707210D+03,0.327D+03,0.120D+03,0.77785000D+01,0.98310000D+00
     .,0.19252210D+03,0.327D+03,0.121D+03,0.77785000D+01,0.18627000D+01
     .,0.18603690D+03,0.327D+03,0.122D+03,0.77785000D+01,0.18299000D+01
     .,0.18233530D+03,0.327D+03,0.123D+03,0.77785000D+01,0.19138000D+01
     .,0.18047740D+03,0.327D+03,0.124D+03,0.77785000D+01,0.18269000D+01
     .,0.16694170D+03,0.327D+03,0.125D+03,0.77785000D+01,0.16406000D+01
     .,0.15486080D+03,0.327D+03,0.126D+03,0.77785000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters( 141601: 141700)=(/
     . 0.14780570D+03,0.327D+03,0.127D+03,0.77785000D+01,0.17149000D+01
     .,0.14445180D+03,0.327D+03,0.128D+03,0.77785000D+01,0.17937000D+01
     .,0.14216340D+03,0.327D+03,0.129D+03,0.77785000D+01,0.95760000D+00
     .,0.13437060D+03,0.327D+03,0.130D+03,0.77785000D+01,0.19419000D+01
     .,0.21533740D+03,0.327D+03,0.131D+03,0.77785000D+01,0.96010000D+00
     .,0.19100140D+03,0.327D+03,0.132D+03,0.77785000D+01,0.94340000D+00
     .,0.17255780D+03,0.327D+03,0.133D+03,0.77785000D+01,0.98890000D+00
     .,0.15854630D+03,0.327D+03,0.134D+03,0.77785000D+01,0.99010000D+00
     .,0.14068120D+03,0.327D+03,0.135D+03,0.77785000D+01,0.99740000D+00
     .,0.22851060D+03,0.327D+03,0.137D+03,0.77785000D+01,0.97380000D+00
     .,0.43445030D+03,0.327D+03,0.138D+03,0.77785000D+01,0.98010000D+00
     .,0.33691730D+03,0.327D+03,0.139D+03,0.77785000D+01,0.19153000D+01
     .,0.25466980D+03,0.327D+03,0.140D+03,0.77785000D+01,0.19355000D+01
     .,0.25719610D+03,0.327D+03,0.141D+03,0.77785000D+01,0.19545000D+01
     .,0.24051390D+03,0.327D+03,0.142D+03,0.77785000D+01,0.19420000D+01
     .,0.26786660D+03,0.327D+03,0.143D+03,0.77785000D+01,0.16682000D+01
     .,0.21097970D+03,0.327D+03,0.144D+03,0.77785000D+01,0.18584000D+01
     .,0.19765180D+03,0.327D+03,0.145D+03,0.77785000D+01,0.19003000D+01
     .,0.18389000D+03,0.327D+03,0.146D+03,0.77785000D+01,0.18630000D+01
     .,0.17779340D+03,0.327D+03,0.147D+03,0.77785000D+01,0.96790000D+00
     ./)
      grimme_c6_parameters( 141701: 141800)=(/
     . 0.17646970D+03,0.327D+03,0.148D+03,0.77785000D+01,0.19539000D+01
     .,0.27425370D+03,0.327D+03,0.149D+03,0.77785000D+01,0.96330000D+00
     .,0.25002640D+03,0.327D+03,0.150D+03,0.77785000D+01,0.95140000D+00
     .,0.23552760D+03,0.327D+03,0.151D+03,0.77785000D+01,0.97490000D+00
     .,0.22379990D+03,0.327D+03,0.152D+03,0.77785000D+01,0.98110000D+00
     .,0.20556330D+03,0.327D+03,0.153D+03,0.77785000D+01,0.99680000D+00
     .,0.27160040D+03,0.327D+03,0.155D+03,0.77785000D+01,0.99090000D+00
     .,0.56214810D+03,0.327D+03,0.156D+03,0.77785000D+01,0.97970000D+00
     .,0.42601980D+03,0.327D+03,0.157D+03,0.77785000D+01,0.19373000D+01
     .,0.27502300D+03,0.327D+03,0.159D+03,0.77785000D+01,0.29425000D+01
     .,0.26936720D+03,0.327D+03,0.160D+03,0.77785000D+01,0.29455000D+01
     .,0.26096100D+03,0.327D+03,0.161D+03,0.77785000D+01,0.29413000D+01
     .,0.26192990D+03,0.327D+03,0.162D+03,0.77785000D+01,0.29300000D+01
     .,0.25167010D+03,0.327D+03,0.163D+03,0.77785000D+01,0.18286000D+01
     .,0.26338860D+03,0.327D+03,0.164D+03,0.77785000D+01,0.28732000D+01
     .,0.24770800D+03,0.327D+03,0.165D+03,0.77785000D+01,0.29086000D+01
     .,0.25153730D+03,0.327D+03,0.166D+03,0.77785000D+01,0.28965000D+01
     .,0.23534260D+03,0.327D+03,0.167D+03,0.77785000D+01,0.29242000D+01
     .,0.22872630D+03,0.327D+03,0.168D+03,0.77785000D+01,0.29282000D+01
     .,0.22716850D+03,0.327D+03,0.169D+03,0.77785000D+01,0.29246000D+01
     ./)
      grimme_c6_parameters( 141801: 141900)=(/
     . 0.23821710D+03,0.327D+03,0.170D+03,0.77785000D+01,0.28482000D+01
     .,0.21967420D+03,0.327D+03,0.171D+03,0.77785000D+01,0.29219000D+01
     .,0.29356720D+03,0.327D+03,0.172D+03,0.77785000D+01,0.19254000D+01
     .,0.27385420D+03,0.327D+03,0.173D+03,0.77785000D+01,0.19459000D+01
     .,0.25123200D+03,0.327D+03,0.174D+03,0.77785000D+01,0.19292000D+01
     .,0.25317100D+03,0.327D+03,0.175D+03,0.77785000D+01,0.18104000D+01
     .,0.22427020D+03,0.327D+03,0.176D+03,0.77785000D+01,0.18858000D+01
     .,0.21152860D+03,0.327D+03,0.177D+03,0.77785000D+01,0.18648000D+01
     .,0.20238660D+03,0.327D+03,0.178D+03,0.77785000D+01,0.19188000D+01
     .,0.19363610D+03,0.327D+03,0.179D+03,0.77785000D+01,0.98460000D+00
     .,0.18779620D+03,0.327D+03,0.180D+03,0.77785000D+01,0.19896000D+01
     .,0.29544290D+03,0.327D+03,0.181D+03,0.77785000D+01,0.92670000D+00
     .,0.27127660D+03,0.327D+03,0.182D+03,0.77785000D+01,0.93830000D+00
     .,0.26414600D+03,0.327D+03,0.183D+03,0.77785000D+01,0.98200000D+00
     .,0.25774500D+03,0.327D+03,0.184D+03,0.77785000D+01,0.98150000D+00
     .,0.24187370D+03,0.327D+03,0.185D+03,0.77785000D+01,0.99540000D+00
     .,0.30597750D+03,0.327D+03,0.187D+03,0.77785000D+01,0.97050000D+00
     .,0.56160150D+03,0.327D+03,0.188D+03,0.77785000D+01,0.96620000D+00
     .,0.32525320D+03,0.327D+03,0.189D+03,0.77785000D+01,0.29070000D+01
     .,0.37317930D+03,0.327D+03,0.190D+03,0.77785000D+01,0.28844000D+01
     ./)
      grimme_c6_parameters( 141901: 142000)=(/
     . 0.33481340D+03,0.327D+03,0.191D+03,0.77785000D+01,0.28738000D+01
     .,0.29740820D+03,0.327D+03,0.192D+03,0.77785000D+01,0.28878000D+01
     .,0.28658400D+03,0.327D+03,0.193D+03,0.77785000D+01,0.29095000D+01
     .,0.34006000D+03,0.327D+03,0.194D+03,0.77785000D+01,0.19209000D+01
     .,0.79784500D+02,0.327D+03,0.204D+03,0.77785000D+01,0.19697000D+01
     .,0.78862400D+02,0.327D+03,0.205D+03,0.77785000D+01,0.19441000D+01
     .,0.58605700D+02,0.327D+03,0.206D+03,0.77785000D+01,0.19985000D+01
     .,0.47416800D+02,0.327D+03,0.207D+03,0.77785000D+01,0.20143000D+01
     .,0.33021500D+02,0.327D+03,0.208D+03,0.77785000D+01,0.19887000D+01
     .,0.14035180D+03,0.327D+03,0.212D+03,0.77785000D+01,0.19496000D+01
     .,0.16949030D+03,0.327D+03,0.213D+03,0.77785000D+01,0.19311000D+01
     .,0.16367210D+03,0.327D+03,0.214D+03,0.77785000D+01,0.19435000D+01
     .,0.14335180D+03,0.327D+03,0.215D+03,0.77785000D+01,0.20102000D+01
     .,0.12152560D+03,0.327D+03,0.216D+03,0.77785000D+01,0.19903000D+01
     .,0.19732010D+03,0.327D+03,0.220D+03,0.77785000D+01,0.19349000D+01
     .,0.19055180D+03,0.327D+03,0.221D+03,0.77785000D+01,0.28999000D+01
     .,0.19300120D+03,0.327D+03,0.222D+03,0.77785000D+01,0.38675000D+01
     .,0.17676920D+03,0.327D+03,0.223D+03,0.77785000D+01,0.29110000D+01
     .,0.13462870D+03,0.327D+03,0.224D+03,0.77785000D+01,0.10619100D+02
     .,0.11592230D+03,0.327D+03,0.225D+03,0.77785000D+01,0.98849000D+01
     ./)
      grimme_c6_parameters( 142001: 142100)=(/
     . 0.11372870D+03,0.327D+03,0.226D+03,0.77785000D+01,0.91376000D+01
     .,0.13200850D+03,0.327D+03,0.227D+03,0.77785000D+01,0.29263000D+01
     .,0.12331710D+03,0.327D+03,0.228D+03,0.77785000D+01,0.65458000D+01
     .,0.17220040D+03,0.327D+03,0.231D+03,0.77785000D+01,0.19315000D+01
     .,0.18217310D+03,0.327D+03,0.232D+03,0.77785000D+01,0.19447000D+01
     .,0.16821430D+03,0.327D+03,0.233D+03,0.77785000D+01,0.19793000D+01
     .,0.15734260D+03,0.327D+03,0.234D+03,0.77785000D+01,0.19812000D+01
     .,0.23676080D+03,0.327D+03,0.238D+03,0.77785000D+01,0.19143000D+01
     .,0.22925270D+03,0.327D+03,0.239D+03,0.77785000D+01,0.28903000D+01
     .,0.23167830D+03,0.327D+03,0.240D+03,0.77785000D+01,0.39106000D+01
     .,0.22415900D+03,0.327D+03,0.241D+03,0.77785000D+01,0.29225000D+01
     .,0.19953250D+03,0.327D+03,0.242D+03,0.77785000D+01,0.11055600D+02
     .,0.17710190D+03,0.327D+03,0.243D+03,0.77785000D+01,0.95402000D+01
     .,0.16774480D+03,0.327D+03,0.244D+03,0.77785000D+01,0.88895000D+01
     .,0.17007730D+03,0.327D+03,0.245D+03,0.77785000D+01,0.29696000D+01
     .,0.17730100D+03,0.327D+03,0.246D+03,0.77785000D+01,0.57095000D+01
     .,0.22299250D+03,0.327D+03,0.249D+03,0.77785000D+01,0.19378000D+01
     .,0.24213510D+03,0.327D+03,0.250D+03,0.77785000D+01,0.19505000D+01
     .,0.22940100D+03,0.327D+03,0.251D+03,0.77785000D+01,0.19523000D+01
     .,0.22211080D+03,0.327D+03,0.252D+03,0.77785000D+01,0.19639000D+01
     ./)
      grimme_c6_parameters( 142101: 142200)=(/
     . 0.28697840D+03,0.327D+03,0.256D+03,0.77785000D+01,0.18467000D+01
     .,0.29814430D+03,0.327D+03,0.257D+03,0.77785000D+01,0.29175000D+01
     .,0.22247740D+03,0.327D+03,0.272D+03,0.77785000D+01,0.38840000D+01
     .,0.23203320D+03,0.327D+03,0.273D+03,0.77785000D+01,0.28988000D+01
     .,0.21683460D+03,0.327D+03,0.274D+03,0.77785000D+01,0.10915300D+02
     .,0.19794790D+03,0.327D+03,0.275D+03,0.77785000D+01,0.98054000D+01
     .,0.18697210D+03,0.327D+03,0.276D+03,0.77785000D+01,0.91527000D+01
     .,0.18993130D+03,0.327D+03,0.277D+03,0.77785000D+01,0.29424000D+01
     .,0.19953230D+03,0.327D+03,0.278D+03,0.77785000D+01,0.66669000D+01
     .,0.23939990D+03,0.327D+03,0.281D+03,0.77785000D+01,0.19302000D+01
     .,0.25289420D+03,0.327D+03,0.282D+03,0.77785000D+01,0.19356000D+01
     .,0.25818280D+03,0.327D+03,0.283D+03,0.77785000D+01,0.19655000D+01
     .,0.25681660D+03,0.327D+03,0.284D+03,0.77785000D+01,0.19639000D+01
     .,0.31607620D+03,0.327D+03,0.288D+03,0.77785000D+01,0.18075000D+01
     .,0.60653700D+02,0.327D+03,0.305D+03,0.77785000D+01,0.29128000D+01
     .,0.54906600D+02,0.327D+03,0.306D+03,0.77785000D+01,0.29987000D+01
     .,0.41919300D+02,0.327D+03,0.307D+03,0.77785000D+01,0.29903000D+01
     .,0.13338200D+03,0.327D+03,0.313D+03,0.77785000D+01,0.29146000D+01
     .,0.15940630D+03,0.327D+03,0.314D+03,0.77785000D+01,0.29407000D+01
     .,0.13339560D+03,0.327D+03,0.315D+03,0.77785000D+01,0.29859000D+01
     ./)
      grimme_c6_parameters( 142201: 142300)=(/
     . 0.11828630D+03,0.327D+03,0.327D+03,0.77785000D+01,0.77785000D+01
     .,0.20185300D+02,0.328D+03,0.100D+01,0.62918000D+01,0.91180000D+00
     .,0.13430500D+02,0.328D+03,0.200D+01,0.62918000D+01,0.00000000D+00
     .,0.32065850D+03,0.328D+03,0.300D+01,0.62918000D+01,0.00000000D+00
     .,0.18269550D+03,0.328D+03,0.400D+01,0.62918000D+01,0.00000000D+00
     .,0.12239150D+03,0.328D+03,0.500D+01,0.62918000D+01,0.00000000D+00
     .,0.82593000D+02,0.328D+03,0.600D+01,0.62918000D+01,0.00000000D+00
     .,0.57846900D+02,0.328D+03,0.700D+01,0.62918000D+01,0.00000000D+00
     .,0.43916100D+02,0.328D+03,0.800D+01,0.62918000D+01,0.00000000D+00
     .,0.33392400D+02,0.328D+03,0.900D+01,0.62918000D+01,0.00000000D+00
     .,0.25794000D+02,0.328D+03,0.100D+02,0.62918000D+01,0.00000000D+00
     .,0.38337730D+03,0.328D+03,0.110D+02,0.62918000D+01,0.00000000D+00
     .,0.29192630D+03,0.328D+03,0.120D+02,0.62918000D+01,0.00000000D+00
     .,0.26812070D+03,0.328D+03,0.130D+02,0.62918000D+01,0.00000000D+00
     .,0.21041880D+03,0.328D+03,0.140D+02,0.62918000D+01,0.00000000D+00
     .,0.16372990D+03,0.328D+03,0.150D+02,0.62918000D+01,0.00000000D+00
     .,0.13584700D+03,0.328D+03,0.160D+02,0.62918000D+01,0.00000000D+00
     .,0.11102480D+03,0.328D+03,0.170D+02,0.62918000D+01,0.00000000D+00
     .,0.90955300D+02,0.328D+03,0.180D+02,0.62918000D+01,0.00000000D+00
     .,0.63014120D+03,0.328D+03,0.190D+02,0.62918000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 142301: 142400)=(/
     . 0.51554150D+03,0.328D+03,0.200D+02,0.62918000D+01,0.00000000D+00
     .,0.42512770D+03,0.328D+03,0.210D+02,0.62918000D+01,0.00000000D+00
     .,0.41001290D+03,0.328D+03,0.220D+02,0.62918000D+01,0.00000000D+00
     .,0.37517450D+03,0.328D+03,0.230D+02,0.62918000D+01,0.00000000D+00
     .,0.29585990D+03,0.328D+03,0.240D+02,0.62918000D+01,0.00000000D+00
     .,0.32268450D+03,0.328D+03,0.250D+02,0.62918000D+01,0.00000000D+00
     .,0.25353650D+03,0.328D+03,0.260D+02,0.62918000D+01,0.00000000D+00
     .,0.26794820D+03,0.328D+03,0.270D+02,0.62918000D+01,0.00000000D+00
     .,0.27623270D+03,0.328D+03,0.280D+02,0.62918000D+01,0.00000000D+00
     .,0.21214340D+03,0.328D+03,0.290D+02,0.62918000D+01,0.00000000D+00
     .,0.21694470D+03,0.328D+03,0.300D+02,0.62918000D+01,0.00000000D+00
     .,0.25679600D+03,0.328D+03,0.310D+02,0.62918000D+01,0.00000000D+00
     .,0.22570800D+03,0.328D+03,0.320D+02,0.62918000D+01,0.00000000D+00
     .,0.19211030D+03,0.328D+03,0.330D+02,0.62918000D+01,0.00000000D+00
     .,0.17227180D+03,0.328D+03,0.340D+02,0.62918000D+01,0.00000000D+00
     .,0.15074260D+03,0.328D+03,0.350D+02,0.62918000D+01,0.00000000D+00
     .,0.13116000D+03,0.328D+03,0.360D+02,0.62918000D+01,0.00000000D+00
     .,0.70593280D+03,0.328D+03,0.370D+02,0.62918000D+01,0.00000000D+00
     .,0.61461390D+03,0.328D+03,0.380D+02,0.62918000D+01,0.00000000D+00
     .,0.53667450D+03,0.328D+03,0.390D+02,0.62918000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 142401: 142500)=(/
     . 0.48150000D+03,0.328D+03,0.400D+02,0.62918000D+01,0.00000000D+00
     .,0.43865020D+03,0.328D+03,0.410D+02,0.62918000D+01,0.00000000D+00
     .,0.33835350D+03,0.328D+03,0.420D+02,0.62918000D+01,0.00000000D+00
     .,0.37763020D+03,0.328D+03,0.430D+02,0.62918000D+01,0.00000000D+00
     .,0.28746140D+03,0.328D+03,0.440D+02,0.62918000D+01,0.00000000D+00
     .,0.31395770D+03,0.328D+03,0.450D+02,0.62918000D+01,0.00000000D+00
     .,0.29103090D+03,0.328D+03,0.460D+02,0.62918000D+01,0.00000000D+00
     .,0.24320090D+03,0.328D+03,0.470D+02,0.62918000D+01,0.00000000D+00
     .,0.25636430D+03,0.328D+03,0.480D+02,0.62918000D+01,0.00000000D+00
     .,0.32207710D+03,0.328D+03,0.490D+02,0.62918000D+01,0.00000000D+00
     .,0.29688720D+03,0.328D+03,0.500D+02,0.62918000D+01,0.00000000D+00
     .,0.26394960D+03,0.328D+03,0.510D+02,0.62918000D+01,0.00000000D+00
     .,0.24463100D+03,0.328D+03,0.520D+02,0.62918000D+01,0.00000000D+00
     .,0.22102500D+03,0.328D+03,0.530D+02,0.62918000D+01,0.00000000D+00
     .,0.19865840D+03,0.328D+03,0.540D+02,0.62918000D+01,0.00000000D+00
     .,0.85972520D+03,0.328D+03,0.550D+02,0.62918000D+01,0.00000000D+00
     .,0.78452520D+03,0.328D+03,0.560D+02,0.62918000D+01,0.00000000D+00
     .,0.68699020D+03,0.328D+03,0.570D+02,0.62918000D+01,0.00000000D+00
     .,0.31211020D+03,0.328D+03,0.580D+02,0.62918000D+01,0.27991000D+01
     .,0.69469690D+03,0.328D+03,0.590D+02,0.62918000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 142501: 142600)=(/
     . 0.66673430D+03,0.328D+03,0.600D+02,0.62918000D+01,0.00000000D+00
     .,0.64990940D+03,0.328D+03,0.610D+02,0.62918000D+01,0.00000000D+00
     .,0.63444150D+03,0.328D+03,0.620D+02,0.62918000D+01,0.00000000D+00
     .,0.62071840D+03,0.328D+03,0.630D+02,0.62918000D+01,0.00000000D+00
     .,0.48671800D+03,0.328D+03,0.640D+02,0.62918000D+01,0.00000000D+00
     .,0.55092420D+03,0.328D+03,0.650D+02,0.62918000D+01,0.00000000D+00
     .,0.53097990D+03,0.328D+03,0.660D+02,0.62918000D+01,0.00000000D+00
     .,0.55938190D+03,0.328D+03,0.670D+02,0.62918000D+01,0.00000000D+00
     .,0.54744560D+03,0.328D+03,0.680D+02,0.62918000D+01,0.00000000D+00
     .,0.53665810D+03,0.328D+03,0.690D+02,0.62918000D+01,0.00000000D+00
     .,0.53043510D+03,0.328D+03,0.700D+02,0.62918000D+01,0.00000000D+00
     .,0.44599990D+03,0.328D+03,0.710D+02,0.62918000D+01,0.00000000D+00
     .,0.43700330D+03,0.328D+03,0.720D+02,0.62918000D+01,0.00000000D+00
     .,0.39822740D+03,0.328D+03,0.730D+02,0.62918000D+01,0.00000000D+00
     .,0.33618450D+03,0.328D+03,0.740D+02,0.62918000D+01,0.00000000D+00
     .,0.34173640D+03,0.328D+03,0.750D+02,0.62918000D+01,0.00000000D+00
     .,0.30943260D+03,0.328D+03,0.760D+02,0.62918000D+01,0.00000000D+00
     .,0.28322570D+03,0.328D+03,0.770D+02,0.62918000D+01,0.00000000D+00
     .,0.23539680D+03,0.328D+03,0.780D+02,0.62918000D+01,0.00000000D+00
     .,0.21999670D+03,0.328D+03,0.790D+02,0.62918000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 142601: 142700)=(/
     . 0.22609290D+03,0.328D+03,0.800D+02,0.62918000D+01,0.00000000D+00
     .,0.33090130D+03,0.328D+03,0.810D+02,0.62918000D+01,0.00000000D+00
     .,0.32264990D+03,0.328D+03,0.820D+02,0.62918000D+01,0.00000000D+00
     .,0.29578510D+03,0.328D+03,0.830D+02,0.62918000D+01,0.00000000D+00
     .,0.28178430D+03,0.328D+03,0.840D+02,0.62918000D+01,0.00000000D+00
     .,0.25980700D+03,0.328D+03,0.850D+02,0.62918000D+01,0.00000000D+00
     .,0.23801290D+03,0.328D+03,0.860D+02,0.62918000D+01,0.00000000D+00
     .,0.80981600D+03,0.328D+03,0.870D+02,0.62918000D+01,0.00000000D+00
     .,0.77454730D+03,0.328D+03,0.880D+02,0.62918000D+01,0.00000000D+00
     .,0.68271560D+03,0.328D+03,0.890D+02,0.62918000D+01,0.00000000D+00
     .,0.61185740D+03,0.328D+03,0.900D+02,0.62918000D+01,0.00000000D+00
     .,0.60871940D+03,0.328D+03,0.910D+02,0.62918000D+01,0.00000000D+00
     .,0.58942580D+03,0.328D+03,0.920D+02,0.62918000D+01,0.00000000D+00
     .,0.60818860D+03,0.328D+03,0.930D+02,0.62918000D+01,0.00000000D+00
     .,0.58874820D+03,0.328D+03,0.940D+02,0.62918000D+01,0.00000000D+00
     .,0.32514900D+02,0.328D+03,0.101D+03,0.62918000D+01,0.00000000D+00
     .,0.10615450D+03,0.328D+03,0.103D+03,0.62918000D+01,0.98650000D+00
     .,0.13527020D+03,0.328D+03,0.104D+03,0.62918000D+01,0.98080000D+00
     .,0.10292200D+03,0.328D+03,0.105D+03,0.62918000D+01,0.97060000D+00
     .,0.77512400D+02,0.328D+03,0.106D+03,0.62918000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters( 142701: 142800)=(/
     . 0.53969000D+02,0.328D+03,0.107D+03,0.62918000D+01,0.99440000D+00
     .,0.39412500D+02,0.328D+03,0.108D+03,0.62918000D+01,0.99250000D+00
     .,0.27270500D+02,0.328D+03,0.109D+03,0.62918000D+01,0.99820000D+00
     .,0.15557860D+03,0.328D+03,0.111D+03,0.62918000D+01,0.96840000D+00
     .,0.24053020D+03,0.328D+03,0.112D+03,0.62918000D+01,0.96280000D+00
     .,0.24284190D+03,0.328D+03,0.113D+03,0.62918000D+01,0.96480000D+00
     .,0.19441840D+03,0.328D+03,0.114D+03,0.62918000D+01,0.95070000D+00
     .,0.15894530D+03,0.328D+03,0.115D+03,0.62918000D+01,0.99470000D+00
     .,0.13437370D+03,0.328D+03,0.116D+03,0.62918000D+01,0.99480000D+00
     .,0.10989000D+03,0.328D+03,0.117D+03,0.62918000D+01,0.99720000D+00
     .,0.21449610D+03,0.328D+03,0.119D+03,0.62918000D+01,0.97670000D+00
     .,0.41261420D+03,0.328D+03,0.120D+03,0.62918000D+01,0.98310000D+00
     .,0.21361290D+03,0.328D+03,0.121D+03,0.62918000D+01,0.18627000D+01
     .,0.20626510D+03,0.328D+03,0.122D+03,0.62918000D+01,0.18299000D+01
     .,0.20220500D+03,0.328D+03,0.123D+03,0.62918000D+01,0.19138000D+01
     .,0.20045980D+03,0.328D+03,0.124D+03,0.62918000D+01,0.18269000D+01
     .,0.18404780D+03,0.328D+03,0.125D+03,0.62918000D+01,0.16406000D+01
     .,0.17031170D+03,0.328D+03,0.126D+03,0.62918000D+01,0.16483000D+01
     .,0.16252860D+03,0.328D+03,0.127D+03,0.62918000D+01,0.17149000D+01
     .,0.15894050D+03,0.328D+03,0.128D+03,0.62918000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters( 142801: 142900)=(/
     . 0.15733960D+03,0.328D+03,0.129D+03,0.62918000D+01,0.95760000D+00
     .,0.14715970D+03,0.328D+03,0.130D+03,0.62918000D+01,0.19419000D+01
     .,0.24100160D+03,0.328D+03,0.131D+03,0.62918000D+01,0.96010000D+00
     .,0.21104400D+03,0.328D+03,0.132D+03,0.62918000D+01,0.94340000D+00
     .,0.18884500D+03,0.328D+03,0.133D+03,0.62918000D+01,0.98890000D+00
     .,0.17234930D+03,0.328D+03,0.134D+03,0.62918000D+01,0.99010000D+00
     .,0.15180060D+03,0.328D+03,0.135D+03,0.62918000D+01,0.99740000D+00
     .,0.25585120D+03,0.328D+03,0.137D+03,0.62918000D+01,0.97380000D+00
     .,0.50246340D+03,0.328D+03,0.138D+03,0.62918000D+01,0.98010000D+00
     .,0.38179030D+03,0.328D+03,0.139D+03,0.62918000D+01,0.19153000D+01
     .,0.28270210D+03,0.328D+03,0.140D+03,0.62918000D+01,0.19355000D+01
     .,0.28559450D+03,0.328D+03,0.141D+03,0.62918000D+01,0.19545000D+01
     .,0.26625680D+03,0.328D+03,0.142D+03,0.62918000D+01,0.19420000D+01
     .,0.29944610D+03,0.328D+03,0.143D+03,0.62918000D+01,0.16682000D+01
     .,0.23182850D+03,0.328D+03,0.144D+03,0.62918000D+01,0.18584000D+01
     .,0.21698060D+03,0.328D+03,0.145D+03,0.62918000D+01,0.19003000D+01
     .,0.20155360D+03,0.328D+03,0.146D+03,0.62918000D+01,0.18630000D+01
     .,0.19509170D+03,0.328D+03,0.147D+03,0.62918000D+01,0.96790000D+00
     .,0.19260990D+03,0.328D+03,0.148D+03,0.62918000D+01,0.19539000D+01
     .,0.30671200D+03,0.328D+03,0.149D+03,0.62918000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters( 142901: 143000)=(/
     . 0.27663930D+03,0.328D+03,0.150D+03,0.62918000D+01,0.95140000D+00
     .,0.25861940D+03,0.328D+03,0.151D+03,0.62918000D+01,0.97490000D+00
     .,0.24442920D+03,0.328D+03,0.152D+03,0.62918000D+01,0.98110000D+00
     .,0.22308960D+03,0.328D+03,0.153D+03,0.62918000D+01,0.99680000D+00
     .,0.30164000D+03,0.328D+03,0.155D+03,0.62918000D+01,0.99090000D+00
     .,0.65239960D+03,0.328D+03,0.156D+03,0.62918000D+01,0.97970000D+00
     .,0.48348120D+03,0.328D+03,0.157D+03,0.62918000D+01,0.19373000D+01
     .,0.30268200D+03,0.328D+03,0.159D+03,0.62918000D+01,0.29425000D+01
     .,0.29642470D+03,0.328D+03,0.160D+03,0.62918000D+01,0.29455000D+01
     .,0.28701630D+03,0.328D+03,0.161D+03,0.62918000D+01,0.29413000D+01
     .,0.28852060D+03,0.328D+03,0.162D+03,0.62918000D+01,0.29300000D+01
     .,0.27859570D+03,0.328D+03,0.163D+03,0.62918000D+01,0.18286000D+01
     .,0.29030390D+03,0.328D+03,0.164D+03,0.62918000D+01,0.28732000D+01
     .,0.27264920D+03,0.328D+03,0.165D+03,0.62918000D+01,0.29086000D+01
     .,0.27761700D+03,0.328D+03,0.166D+03,0.62918000D+01,0.28965000D+01
     .,0.25869870D+03,0.328D+03,0.167D+03,0.62918000D+01,0.29242000D+01
     .,0.25129970D+03,0.328D+03,0.168D+03,0.62918000D+01,0.29282000D+01
     .,0.24969380D+03,0.328D+03,0.169D+03,0.62918000D+01,0.29246000D+01
     .,0.26246920D+03,0.328D+03,0.170D+03,0.62918000D+01,0.28482000D+01
     .,0.24127880D+03,0.328D+03,0.171D+03,0.62918000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters( 143001: 143100)=(/
     . 0.32823180D+03,0.328D+03,0.172D+03,0.62918000D+01,0.19254000D+01
     .,0.30426470D+03,0.328D+03,0.173D+03,0.62918000D+01,0.19459000D+01
     .,0.27731590D+03,0.328D+03,0.174D+03,0.62918000D+01,0.19292000D+01
     .,0.28103260D+03,0.328D+03,0.175D+03,0.62918000D+01,0.18104000D+01
     .,0.24528440D+03,0.328D+03,0.176D+03,0.62918000D+01,0.18858000D+01
     .,0.23080460D+03,0.328D+03,0.177D+03,0.62918000D+01,0.18648000D+01
     .,0.22051410D+03,0.328D+03,0.178D+03,0.62918000D+01,0.19188000D+01
     .,0.21098620D+03,0.328D+03,0.179D+03,0.62918000D+01,0.98460000D+00
     .,0.20359070D+03,0.328D+03,0.180D+03,0.62918000D+01,0.19896000D+01
     .,0.32952070D+03,0.328D+03,0.181D+03,0.62918000D+01,0.92670000D+00
     .,0.29946420D+03,0.328D+03,0.182D+03,0.62918000D+01,0.93830000D+00
     .,0.28996580D+03,0.328D+03,0.183D+03,0.62918000D+01,0.98200000D+00
     .,0.28177690D+03,0.328D+03,0.184D+03,0.62918000D+01,0.98150000D+00
     .,0.26291680D+03,0.328D+03,0.185D+03,0.62918000D+01,0.99540000D+00
     .,0.33961520D+03,0.328D+03,0.187D+03,0.62918000D+01,0.97050000D+00
     .,0.64757740D+03,0.328D+03,0.188D+03,0.62918000D+01,0.96620000D+00
     .,0.35809400D+03,0.328D+03,0.189D+03,0.62918000D+01,0.29070000D+01
     .,0.41447150D+03,0.328D+03,0.190D+03,0.62918000D+01,0.28844000D+01
     .,0.37053510D+03,0.328D+03,0.191D+03,0.62918000D+01,0.28738000D+01
     .,0.32689030D+03,0.328D+03,0.192D+03,0.62918000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters( 143101: 143200)=(/
     . 0.31449130D+03,0.328D+03,0.193D+03,0.62918000D+01,0.29095000D+01
     .,0.38028110D+03,0.328D+03,0.194D+03,0.62918000D+01,0.19209000D+01
     .,0.87785200D+02,0.328D+03,0.204D+03,0.62918000D+01,0.19697000D+01
     .,0.86389500D+02,0.328D+03,0.205D+03,0.62918000D+01,0.19441000D+01
     .,0.63209200D+02,0.328D+03,0.206D+03,0.62918000D+01,0.19985000D+01
     .,0.50719800D+02,0.328D+03,0.207D+03,0.62918000D+01,0.20143000D+01
     .,0.34859600D+02,0.328D+03,0.208D+03,0.62918000D+01,0.19887000D+01
     .,0.15613270D+03,0.328D+03,0.212D+03,0.62918000D+01,0.19496000D+01
     .,0.18876990D+03,0.328D+03,0.213D+03,0.62918000D+01,0.19311000D+01
     .,0.18076730D+03,0.328D+03,0.214D+03,0.62918000D+01,0.19435000D+01
     .,0.15685490D+03,0.328D+03,0.215D+03,0.62918000D+01,0.20102000D+01
     .,0.13167410D+03,0.328D+03,0.216D+03,0.62918000D+01,0.19903000D+01
     .,0.21936790D+03,0.328D+03,0.220D+03,0.62918000D+01,0.19349000D+01
     .,0.21045590D+03,0.328D+03,0.221D+03,0.62918000D+01,0.28999000D+01
     .,0.21305010D+03,0.328D+03,0.222D+03,0.62918000D+01,0.38675000D+01
     .,0.19516290D+03,0.328D+03,0.223D+03,0.62918000D+01,0.29110000D+01
     .,0.14698850D+03,0.328D+03,0.224D+03,0.62918000D+01,0.10619100D+02
     .,0.12572050D+03,0.328D+03,0.225D+03,0.62918000D+01,0.98849000D+01
     .,0.12344170D+03,0.328D+03,0.226D+03,0.62918000D+01,0.91376000D+01
     .,0.14484240D+03,0.328D+03,0.227D+03,0.62918000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters( 143201: 143300)=(/
     . 0.13489330D+03,0.328D+03,0.228D+03,0.62918000D+01,0.65458000D+01
     .,0.19047990D+03,0.328D+03,0.231D+03,0.62918000D+01,0.19315000D+01
     .,0.20085740D+03,0.328D+03,0.232D+03,0.62918000D+01,0.19447000D+01
     .,0.18386230D+03,0.328D+03,0.233D+03,0.62918000D+01,0.19793000D+01
     .,0.17100310D+03,0.328D+03,0.234D+03,0.62918000D+01,0.19812000D+01
     .,0.26289820D+03,0.328D+03,0.238D+03,0.62918000D+01,0.19143000D+01
     .,0.25242450D+03,0.328D+03,0.239D+03,0.62918000D+01,0.28903000D+01
     .,0.25445670D+03,0.328D+03,0.240D+03,0.62918000D+01,0.39106000D+01
     .,0.24630770D+03,0.328D+03,0.241D+03,0.62918000D+01,0.29225000D+01
     .,0.21764570D+03,0.328D+03,0.242D+03,0.62918000D+01,0.11055600D+02
     .,0.19205910D+03,0.328D+03,0.243D+03,0.62918000D+01,0.95402000D+01
     .,0.18151960D+03,0.328D+03,0.244D+03,0.62918000D+01,0.88895000D+01
     .,0.18521540D+03,0.328D+03,0.245D+03,0.62918000D+01,0.29696000D+01
     .,0.19349000D+03,0.328D+03,0.246D+03,0.62918000D+01,0.57095000D+01
     .,0.24615700D+03,0.328D+03,0.249D+03,0.62918000D+01,0.19378000D+01
     .,0.26732250D+03,0.328D+03,0.250D+03,0.62918000D+01,0.19505000D+01
     .,0.25143010D+03,0.328D+03,0.251D+03,0.62918000D+01,0.19523000D+01
     .,0.24241490D+03,0.328D+03,0.252D+03,0.62918000D+01,0.19639000D+01
     .,0.31782550D+03,0.328D+03,0.256D+03,0.62918000D+01,0.18467000D+01
     .,0.32883880D+03,0.328D+03,0.257D+03,0.62918000D+01,0.29175000D+01
     ./)
      grimme_c6_parameters( 143301: 143400)=(/
     . 0.24349370D+03,0.328D+03,0.272D+03,0.62918000D+01,0.38840000D+01
     .,0.25469760D+03,0.328D+03,0.273D+03,0.62918000D+01,0.28988000D+01
     .,0.23640400D+03,0.328D+03,0.274D+03,0.62918000D+01,0.10915300D+02
     .,0.21467590D+03,0.328D+03,0.275D+03,0.62918000D+01,0.98054000D+01
     .,0.20191630D+03,0.328D+03,0.276D+03,0.62918000D+01,0.91527000D+01
     .,0.20622720D+03,0.328D+03,0.277D+03,0.62918000D+01,0.29424000D+01
     .,0.21681400D+03,0.328D+03,0.278D+03,0.62918000D+01,0.66669000D+01
     .,0.26294210D+03,0.328D+03,0.281D+03,0.62918000D+01,0.19302000D+01
     .,0.27771100D+03,0.328D+03,0.282D+03,0.62918000D+01,0.19356000D+01
     .,0.28277180D+03,0.328D+03,0.283D+03,0.62918000D+01,0.19655000D+01
     .,0.28049880D+03,0.328D+03,0.284D+03,0.62918000D+01,0.19639000D+01
     .,0.34977880D+03,0.328D+03,0.288D+03,0.62918000D+01,0.18075000D+01
     .,0.65561800D+02,0.328D+03,0.305D+03,0.62918000D+01,0.29128000D+01
     .,0.59198000D+02,0.328D+03,0.306D+03,0.62918000D+01,0.29987000D+01
     .,0.44744200D+02,0.328D+03,0.307D+03,0.62918000D+01,0.29903000D+01
     .,0.14661210D+03,0.328D+03,0.313D+03,0.62918000D+01,0.29146000D+01
     .,0.17631430D+03,0.328D+03,0.314D+03,0.62918000D+01,0.29407000D+01
     .,0.14541330D+03,0.328D+03,0.315D+03,0.62918000D+01,0.29859000D+01
     .,0.12886410D+03,0.328D+03,0.327D+03,0.62918000D+01,0.77785000D+01
     .,0.14187630D+03,0.328D+03,0.328D+03,0.62918000D+01,0.62918000D+01
     ./)
      grimme_c6_parameters( 143401: 143500)=(/
     . 0.22539000D+02,0.331D+03,0.100D+01,0.29233000D+01,0.91180000D+00
     .,0.14929600D+02,0.331D+03,0.200D+01,0.29233000D+01,0.00000000D+00
     .,0.33234640D+03,0.331D+03,0.300D+01,0.29233000D+01,0.00000000D+00
     .,0.19774540D+03,0.331D+03,0.400D+01,0.29233000D+01,0.00000000D+00
     .,0.13488560D+03,0.331D+03,0.500D+01,0.29233000D+01,0.00000000D+00
     .,0.91766100D+02,0.331D+03,0.600D+01,0.29233000D+01,0.00000000D+00
     .,0.64397700D+02,0.331D+03,0.700D+01,0.29233000D+01,0.00000000D+00
     .,0.48831000D+02,0.331D+03,0.800D+01,0.29233000D+01,0.00000000D+00
     .,0.37012900D+02,0.331D+03,0.900D+01,0.29233000D+01,0.00000000D+00
     .,0.28465400D+02,0.331D+03,0.100D+02,0.29233000D+01,0.00000000D+00
     .,0.39801800D+03,0.331D+03,0.110D+02,0.29233000D+01,0.00000000D+00
     .,0.31346580D+03,0.331D+03,0.120D+02,0.29233000D+01,0.00000000D+00
     .,0.29117040D+03,0.331D+03,0.130D+02,0.29233000D+01,0.00000000D+00
     .,0.23154320D+03,0.331D+03,0.140D+02,0.29233000D+01,0.00000000D+00
     .,0.18169810D+03,0.331D+03,0.150D+02,0.29233000D+01,0.00000000D+00
     .,0.15126110D+03,0.331D+03,0.160D+02,0.29233000D+01,0.00000000D+00
     .,0.12384420D+03,0.331D+03,0.170D+02,0.29233000D+01,0.00000000D+00
     .,0.10145720D+03,0.331D+03,0.180D+02,0.29233000D+01,0.00000000D+00
     .,0.64868790D+03,0.331D+03,0.190D+02,0.29233000D+01,0.00000000D+00
     .,0.54545480D+03,0.331D+03,0.200D+02,0.29233000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 143501: 143600)=(/
     . 0.45241480D+03,0.331D+03,0.210D+02,0.29233000D+01,0.00000000D+00
     .,0.43828120D+03,0.331D+03,0.220D+02,0.29233000D+01,0.00000000D+00
     .,0.40212020D+03,0.331D+03,0.230D+02,0.29233000D+01,0.00000000D+00
     .,0.31661340D+03,0.331D+03,0.240D+02,0.29233000D+01,0.00000000D+00
     .,0.34715450D+03,0.331D+03,0.250D+02,0.29233000D+01,0.00000000D+00
     .,0.27239980D+03,0.331D+03,0.260D+02,0.29233000D+01,0.00000000D+00
     .,0.29012680D+03,0.331D+03,0.270D+02,0.29233000D+01,0.00000000D+00
     .,0.29831410D+03,0.331D+03,0.280D+02,0.29233000D+01,0.00000000D+00
     .,0.22848110D+03,0.331D+03,0.290D+02,0.29233000D+01,0.00000000D+00
     .,0.23616610D+03,0.331D+03,0.300D+02,0.29233000D+01,0.00000000D+00
     .,0.27943460D+03,0.331D+03,0.310D+02,0.29233000D+01,0.00000000D+00
     .,0.24818660D+03,0.331D+03,0.320D+02,0.29233000D+01,0.00000000D+00
     .,0.21282990D+03,0.331D+03,0.330D+02,0.29233000D+01,0.00000000D+00
     .,0.19148490D+03,0.331D+03,0.340D+02,0.29233000D+01,0.00000000D+00
     .,0.16795000D+03,0.331D+03,0.350D+02,0.29233000D+01,0.00000000D+00
     .,0.14629100D+03,0.331D+03,0.360D+02,0.29233000D+01,0.00000000D+00
     .,0.72799780D+03,0.331D+03,0.370D+02,0.29233000D+01,0.00000000D+00
     .,0.64926400D+03,0.331D+03,0.380D+02,0.29233000D+01,0.00000000D+00
     .,0.57254520D+03,0.331D+03,0.390D+02,0.29233000D+01,0.00000000D+00
     .,0.51656560D+03,0.331D+03,0.400D+02,0.29233000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 143601: 143700)=(/
     . 0.47214060D+03,0.331D+03,0.410D+02,0.29233000D+01,0.00000000D+00
     .,0.36573900D+03,0.331D+03,0.420D+02,0.29233000D+01,0.00000000D+00
     .,0.40759020D+03,0.331D+03,0.430D+02,0.29233000D+01,0.00000000D+00
     .,0.31162540D+03,0.331D+03,0.440D+02,0.29233000D+01,0.00000000D+00
     .,0.34083280D+03,0.331D+03,0.450D+02,0.29233000D+01,0.00000000D+00
     .,0.31647210D+03,0.331D+03,0.460D+02,0.29233000D+01,0.00000000D+00
     .,0.26332580D+03,0.331D+03,0.470D+02,0.29233000D+01,0.00000000D+00
     .,0.27928860D+03,0.331D+03,0.480D+02,0.29233000D+01,0.00000000D+00
     .,0.34913300D+03,0.331D+03,0.490D+02,0.29233000D+01,0.00000000D+00
     .,0.32482290D+03,0.331D+03,0.500D+02,0.29233000D+01,0.00000000D+00
     .,0.29096000D+03,0.331D+03,0.510D+02,0.29233000D+01,0.00000000D+00
     .,0.27067740D+03,0.331D+03,0.520D+02,0.29233000D+01,0.00000000D+00
     .,0.24534690D+03,0.331D+03,0.530D+02,0.29233000D+01,0.00000000D+00
     .,0.22101200D+03,0.331D+03,0.540D+02,0.29233000D+01,0.00000000D+00
     .,0.88720920D+03,0.331D+03,0.550D+02,0.29233000D+01,0.00000000D+00
     .,0.82570960D+03,0.331D+03,0.560D+02,0.29233000D+01,0.00000000D+00
     .,0.73032590D+03,0.331D+03,0.570D+02,0.29233000D+01,0.00000000D+00
     .,0.34326010D+03,0.331D+03,0.580D+02,0.29233000D+01,0.27991000D+01
     .,0.73303460D+03,0.331D+03,0.590D+02,0.29233000D+01,0.00000000D+00
     .,0.70467870D+03,0.331D+03,0.600D+02,0.29233000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 143701: 143800)=(/
     . 0.68722230D+03,0.331D+03,0.610D+02,0.29233000D+01,0.00000000D+00
     .,0.67114820D+03,0.331D+03,0.620D+02,0.29233000D+01,0.00000000D+00
     .,0.65690430D+03,0.331D+03,0.630D+02,0.29233000D+01,0.00000000D+00
     .,0.52004840D+03,0.331D+03,0.640D+02,0.29233000D+01,0.00000000D+00
     .,0.57921270D+03,0.331D+03,0.650D+02,0.29233000D+01,0.00000000D+00
     .,0.55935900D+03,0.331D+03,0.660D+02,0.29233000D+01,0.00000000D+00
     .,0.59350440D+03,0.331D+03,0.670D+02,0.29233000D+01,0.00000000D+00
     .,0.58102860D+03,0.331D+03,0.680D+02,0.29233000D+01,0.00000000D+00
     .,0.56982860D+03,0.331D+03,0.690D+02,0.29233000D+01,0.00000000D+00
     .,0.56301640D+03,0.331D+03,0.700D+02,0.29233000D+01,0.00000000D+00
     .,0.47657670D+03,0.331D+03,0.710D+02,0.29233000D+01,0.00000000D+00
     .,0.47186840D+03,0.331D+03,0.720D+02,0.29233000D+01,0.00000000D+00
     .,0.43210850D+03,0.331D+03,0.730D+02,0.29233000D+01,0.00000000D+00
     .,0.36558740D+03,0.331D+03,0.740D+02,0.29233000D+01,0.00000000D+00
     .,0.37247260D+03,0.331D+03,0.750D+02,0.29233000D+01,0.00000000D+00
     .,0.33845240D+03,0.331D+03,0.760D+02,0.29233000D+01,0.00000000D+00
     .,0.31056410D+03,0.331D+03,0.770D+02,0.29233000D+01,0.00000000D+00
     .,0.25829950D+03,0.331D+03,0.780D+02,0.29233000D+01,0.00000000D+00
     .,0.24143850D+03,0.331D+03,0.790D+02,0.29233000D+01,0.00000000D+00
     .,0.24873340D+03,0.331D+03,0.800D+02,0.29233000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 143801: 143900)=(/
     . 0.35861390D+03,0.331D+03,0.810D+02,0.29233000D+01,0.00000000D+00
     .,0.35236140D+03,0.331D+03,0.820D+02,0.29233000D+01,0.00000000D+00
     .,0.32532280D+03,0.331D+03,0.830D+02,0.29233000D+01,0.00000000D+00
     .,0.31104340D+03,0.331D+03,0.840D+02,0.29233000D+01,0.00000000D+00
     .,0.28780550D+03,0.331D+03,0.850D+02,0.29233000D+01,0.00000000D+00
     .,0.26431470D+03,0.331D+03,0.860D+02,0.29233000D+01,0.00000000D+00
     .,0.84229970D+03,0.331D+03,0.870D+02,0.29233000D+01,0.00000000D+00
     .,0.81926690D+03,0.331D+03,0.880D+02,0.29233000D+01,0.00000000D+00
     .,0.72858620D+03,0.331D+03,0.890D+02,0.29233000D+01,0.00000000D+00
     .,0.65887100D+03,0.331D+03,0.900D+02,0.29233000D+01,0.00000000D+00
     .,0.65182590D+03,0.331D+03,0.910D+02,0.29233000D+01,0.00000000D+00
     .,0.63119280D+03,0.331D+03,0.920D+02,0.29233000D+01,0.00000000D+00
     .,0.64715530D+03,0.331D+03,0.930D+02,0.29233000D+01,0.00000000D+00
     .,0.62718910D+03,0.331D+03,0.940D+02,0.29233000D+01,0.00000000D+00
     .,0.36144700D+02,0.331D+03,0.101D+03,0.29233000D+01,0.00000000D+00
     .,0.11512840D+03,0.331D+03,0.103D+03,0.29233000D+01,0.98650000D+00
     .,0.14719230D+03,0.331D+03,0.104D+03,0.29233000D+01,0.98080000D+00
     .,0.11367480D+03,0.331D+03,0.105D+03,0.29233000D+01,0.97060000D+00
     .,0.86017200D+02,0.331D+03,0.106D+03,0.29233000D+01,0.98680000D+00
     .,0.60022900D+02,0.331D+03,0.107D+03,0.29233000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters( 143901: 144000)=(/
     . 0.43796200D+02,0.331D+03,0.108D+03,0.29233000D+01,0.99250000D+00
     .,0.30155700D+02,0.331D+03,0.109D+03,0.29233000D+01,0.99820000D+00
     .,0.16772780D+03,0.331D+03,0.111D+03,0.29233000D+01,0.96840000D+00
     .,0.25920610D+03,0.331D+03,0.112D+03,0.29233000D+01,0.96280000D+00
     .,0.26429930D+03,0.331D+03,0.113D+03,0.29233000D+01,0.96480000D+00
     .,0.21422700D+03,0.331D+03,0.114D+03,0.29233000D+01,0.95070000D+00
     .,0.17638160D+03,0.331D+03,0.115D+03,0.29233000D+01,0.99470000D+00
     .,0.14956740D+03,0.331D+03,0.116D+03,0.29233000D+01,0.99480000D+00
     .,0.12254290D+03,0.331D+03,0.117D+03,0.29233000D+01,0.99720000D+00
     .,0.23199890D+03,0.331D+03,0.119D+03,0.29233000D+01,0.97670000D+00
     .,0.43628440D+03,0.331D+03,0.120D+03,0.29233000D+01,0.98310000D+00
     .,0.23401650D+03,0.331D+03,0.121D+03,0.29233000D+01,0.18627000D+01
     .,0.22591360D+03,0.331D+03,0.122D+03,0.29233000D+01,0.18299000D+01
     .,0.22133820D+03,0.331D+03,0.123D+03,0.29233000D+01,0.19138000D+01
     .,0.21907040D+03,0.331D+03,0.124D+03,0.29233000D+01,0.18269000D+01
     .,0.20247400D+03,0.331D+03,0.125D+03,0.29233000D+01,0.16406000D+01
     .,0.18755800D+03,0.331D+03,0.126D+03,0.29233000D+01,0.16483000D+01
     .,0.17887740D+03,0.331D+03,0.127D+03,0.29233000D+01,0.17149000D+01
     .,0.17480580D+03,0.331D+03,0.128D+03,0.29233000D+01,0.17937000D+01
     .,0.17212150D+03,0.331D+03,0.129D+03,0.29233000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters( 144001: 144100)=(/
     . 0.16247350D+03,0.331D+03,0.130D+03,0.29233000D+01,0.19419000D+01
     .,0.26291340D+03,0.331D+03,0.131D+03,0.29233000D+01,0.96010000D+00
     .,0.23250850D+03,0.331D+03,0.132D+03,0.29233000D+01,0.94340000D+00
     .,0.20926950D+03,0.331D+03,0.133D+03,0.29233000D+01,0.98890000D+00
     .,0.19154240D+03,0.331D+03,0.134D+03,0.29233000D+01,0.99010000D+00
     .,0.16909250D+03,0.331D+03,0.135D+03,0.29233000D+01,0.99740000D+00
     .,0.27717010D+03,0.331D+03,0.137D+03,0.29233000D+01,0.97380000D+00
     .,0.53024480D+03,0.331D+03,0.138D+03,0.29233000D+01,0.98010000D+00
     .,0.41052730D+03,0.331D+03,0.139D+03,0.29233000D+01,0.19153000D+01
     .,0.30919640D+03,0.331D+03,0.140D+03,0.29233000D+01,0.19355000D+01
     .,0.31215680D+03,0.331D+03,0.141D+03,0.29233000D+01,0.19545000D+01
     .,0.29139440D+03,0.331D+03,0.142D+03,0.29233000D+01,0.19420000D+01
     .,0.32490950D+03,0.331D+03,0.143D+03,0.29233000D+01,0.16682000D+01
     .,0.25488120D+03,0.331D+03,0.144D+03,0.29233000D+01,0.18584000D+01
     .,0.23843110D+03,0.331D+03,0.145D+03,0.29233000D+01,0.19003000D+01
     .,0.22146490D+03,0.331D+03,0.146D+03,0.29233000D+01,0.18630000D+01
     .,0.21407940D+03,0.331D+03,0.147D+03,0.29233000D+01,0.96790000D+00
     .,0.21251480D+03,0.331D+03,0.148D+03,0.29233000D+01,0.19539000D+01
     .,0.33348150D+03,0.331D+03,0.149D+03,0.29233000D+01,0.96330000D+00
     .,0.30351790D+03,0.331D+03,0.150D+03,0.29233000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters( 144101: 144200)=(/
     . 0.28533630D+03,0.331D+03,0.151D+03,0.29233000D+01,0.97490000D+00
     .,0.27052970D+03,0.331D+03,0.152D+03,0.29233000D+01,0.98110000D+00
     .,0.24764850D+03,0.331D+03,0.153D+03,0.29233000D+01,0.99680000D+00
     .,0.32944100D+03,0.331D+03,0.155D+03,0.29233000D+01,0.99090000D+00
     .,0.68550020D+03,0.331D+03,0.156D+03,0.29233000D+01,0.97970000D+00
     .,0.51898320D+03,0.331D+03,0.157D+03,0.29233000D+01,0.19373000D+01
     .,0.33298690D+03,0.331D+03,0.159D+03,0.29233000D+01,0.29425000D+01
     .,0.32610980D+03,0.331D+03,0.160D+03,0.29233000D+01,0.29455000D+01
     .,0.31583740D+03,0.331D+03,0.161D+03,0.29233000D+01,0.29413000D+01
     .,0.31714450D+03,0.331D+03,0.162D+03,0.29233000D+01,0.29300000D+01
     .,0.30481740D+03,0.331D+03,0.163D+03,0.29233000D+01,0.18286000D+01
     .,0.31912880D+03,0.331D+03,0.164D+03,0.29233000D+01,0.28732000D+01
     .,0.29989300D+03,0.331D+03,0.165D+03,0.29233000D+01,0.29086000D+01
     .,0.30469800D+03,0.331D+03,0.166D+03,0.29233000D+01,0.28965000D+01
     .,0.28484920D+03,0.331D+03,0.167D+03,0.29233000D+01,0.29242000D+01
     .,0.27680030D+03,0.331D+03,0.168D+03,0.29233000D+01,0.29282000D+01
     .,0.27498180D+03,0.331D+03,0.169D+03,0.29233000D+01,0.29246000D+01
     .,0.28882640D+03,0.331D+03,0.170D+03,0.29233000D+01,0.28482000D+01
     .,0.26590550D+03,0.331D+03,0.171D+03,0.29233000D+01,0.29219000D+01
     .,0.35695090D+03,0.331D+03,0.172D+03,0.29233000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters( 144201: 144300)=(/
     . 0.33227960D+03,0.331D+03,0.173D+03,0.29233000D+01,0.19459000D+01
     .,0.30407910D+03,0.331D+03,0.174D+03,0.29233000D+01,0.19292000D+01
     .,0.30677590D+03,0.331D+03,0.175D+03,0.29233000D+01,0.18104000D+01
     .,0.27045010D+03,0.331D+03,0.176D+03,0.29233000D+01,0.18858000D+01
     .,0.25457310D+03,0.331D+03,0.177D+03,0.29233000D+01,0.18648000D+01
     .,0.24321020D+03,0.331D+03,0.178D+03,0.29233000D+01,0.19188000D+01
     .,0.23238620D+03,0.331D+03,0.179D+03,0.29233000D+01,0.98460000D+00
     .,0.22515610D+03,0.331D+03,0.180D+03,0.29233000D+01,0.19896000D+01
     .,0.35816930D+03,0.331D+03,0.181D+03,0.29233000D+01,0.92670000D+00
     .,0.32836650D+03,0.331D+03,0.182D+03,0.29233000D+01,0.93830000D+00
     .,0.31941280D+03,0.331D+03,0.183D+03,0.29233000D+01,0.98200000D+00
     .,0.31125260D+03,0.331D+03,0.184D+03,0.29233000D+01,0.98150000D+00
     .,0.29132130D+03,0.331D+03,0.185D+03,0.29233000D+01,0.99540000D+00
     .,0.37119590D+03,0.331D+03,0.187D+03,0.29233000D+01,0.97050000D+00
     .,0.68477170D+03,0.331D+03,0.188D+03,0.29233000D+01,0.96620000D+00
     .,0.39403910D+03,0.331D+03,0.189D+03,0.29233000D+01,0.29070000D+01
     .,0.45247860D+03,0.331D+03,0.190D+03,0.29233000D+01,0.28844000D+01
     .,0.40499240D+03,0.331D+03,0.191D+03,0.29233000D+01,0.28738000D+01
     .,0.35926250D+03,0.331D+03,0.192D+03,0.29233000D+01,0.28878000D+01
     .,0.34595630D+03,0.331D+03,0.193D+03,0.29233000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters( 144301: 144400)=(/
     . 0.41186560D+03,0.331D+03,0.194D+03,0.29233000D+01,0.19209000D+01
     .,0.97234600D+02,0.331D+03,0.204D+03,0.29233000D+01,0.19697000D+01
     .,0.95603900D+02,0.331D+03,0.205D+03,0.29233000D+01,0.19441000D+01
     .,0.70318400D+02,0.331D+03,0.206D+03,0.29233000D+01,0.19985000D+01
     .,0.56361200D+02,0.331D+03,0.207D+03,0.29233000D+01,0.20143000D+01
     .,0.38626300D+02,0.331D+03,0.208D+03,0.29233000D+01,0.19887000D+01
     .,0.17153850D+03,0.331D+03,0.212D+03,0.29233000D+01,0.19496000D+01
     .,0.20708710D+03,0.331D+03,0.213D+03,0.29233000D+01,0.19311000D+01
     .,0.19947600D+03,0.331D+03,0.214D+03,0.29233000D+01,0.19435000D+01
     .,0.17389310D+03,0.331D+03,0.215D+03,0.29233000D+01,0.20102000D+01
     .,0.14653820D+03,0.331D+03,0.216D+03,0.29233000D+01,0.19903000D+01
     .,0.24008000D+03,0.331D+03,0.220D+03,0.29233000D+01,0.19349000D+01
     .,0.23151840D+03,0.331D+03,0.221D+03,0.29233000D+01,0.28999000D+01
     .,0.23440930D+03,0.331D+03,0.222D+03,0.29233000D+01,0.38675000D+01
     .,0.21438080D+03,0.331D+03,0.223D+03,0.29233000D+01,0.29110000D+01
     .,0.16205470D+03,0.331D+03,0.224D+03,0.29233000D+01,0.10619100D+02
     .,0.13899280D+03,0.331D+03,0.225D+03,0.29233000D+01,0.98849000D+01
     .,0.13638180D+03,0.331D+03,0.226D+03,0.29233000D+01,0.91376000D+01
     .,0.15925840D+03,0.331D+03,0.227D+03,0.29233000D+01,0.29263000D+01
     .,0.14856420D+03,0.331D+03,0.228D+03,0.29233000D+01,0.65458000D+01
     ./)
      grimme_c6_parameters( 144401: 144500)=(/
     . 0.20951300D+03,0.331D+03,0.231D+03,0.29233000D+01,0.19315000D+01
     .,0.22156120D+03,0.331D+03,0.232D+03,0.29233000D+01,0.19447000D+01
     .,0.20387080D+03,0.331D+03,0.233D+03,0.29233000D+01,0.19793000D+01
     .,0.19004420D+03,0.331D+03,0.234D+03,0.29233000D+01,0.19812000D+01
     .,0.28761670D+03,0.331D+03,0.238D+03,0.29233000D+01,0.19143000D+01
     .,0.27811250D+03,0.331D+03,0.239D+03,0.29233000D+01,0.28903000D+01
     .,0.28082410D+03,0.331D+03,0.240D+03,0.29233000D+01,0.39106000D+01
     .,0.27131370D+03,0.331D+03,0.241D+03,0.29233000D+01,0.29225000D+01
     .,0.24051090D+03,0.331D+03,0.242D+03,0.29233000D+01,0.11055600D+02
     .,0.21269370D+03,0.331D+03,0.243D+03,0.29233000D+01,0.95402000D+01
     .,0.20110400D+03,0.331D+03,0.244D+03,0.29233000D+01,0.88895000D+01
     .,0.20422770D+03,0.331D+03,0.245D+03,0.29233000D+01,0.29696000D+01
     .,0.21323450D+03,0.331D+03,0.246D+03,0.29233000D+01,0.57095000D+01
     .,0.27009880D+03,0.331D+03,0.249D+03,0.29233000D+01,0.19378000D+01
     .,0.29372900D+03,0.331D+03,0.250D+03,0.29233000D+01,0.19505000D+01
     .,0.27771860D+03,0.331D+03,0.251D+03,0.29233000D+01,0.19523000D+01
     .,0.26841360D+03,0.331D+03,0.252D+03,0.29233000D+01,0.19639000D+01
     .,0.34819780D+03,0.331D+03,0.256D+03,0.29233000D+01,0.18467000D+01
     .,0.36193370D+03,0.331D+03,0.257D+03,0.29233000D+01,0.29175000D+01
     .,0.26924010D+03,0.331D+03,0.272D+03,0.29233000D+01,0.38840000D+01
     ./)
      grimme_c6_parameters( 144501: 144600)=(/
     . 0.28063840D+03,0.331D+03,0.273D+03,0.29233000D+01,0.28988000D+01
     .,0.26136250D+03,0.331D+03,0.274D+03,0.29233000D+01,0.10915300D+02
     .,0.23778890D+03,0.331D+03,0.275D+03,0.29233000D+01,0.98054000D+01
     .,0.22400480D+03,0.331D+03,0.276D+03,0.29233000D+01,0.91527000D+01
     .,0.22773200D+03,0.331D+03,0.277D+03,0.29233000D+01,0.29424000D+01
     .,0.23955770D+03,0.331D+03,0.278D+03,0.29233000D+01,0.66669000D+01
     .,0.28897680D+03,0.331D+03,0.281D+03,0.29233000D+01,0.19302000D+01
     .,0.30561160D+03,0.331D+03,0.282D+03,0.29233000D+01,0.19356000D+01
     .,0.31199930D+03,0.331D+03,0.283D+03,0.29233000D+01,0.19655000D+01
     .,0.31006550D+03,0.331D+03,0.284D+03,0.29233000D+01,0.19639000D+01
     .,0.38347400D+03,0.331D+03,0.288D+03,0.29233000D+01,0.18075000D+01
     .,0.73075400D+02,0.331D+03,0.305D+03,0.29233000D+01,0.29128000D+01
     .,0.65758400D+02,0.331D+03,0.306D+03,0.29233000D+01,0.29987000D+01
     .,0.49615900D+02,0.331D+03,0.307D+03,0.29233000D+01,0.29903000D+01
     .,0.16240650D+03,0.331D+03,0.313D+03,0.29233000D+01,0.29146000D+01
     .,0.19417780D+03,0.331D+03,0.314D+03,0.29233000D+01,0.29407000D+01
     .,0.16155910D+03,0.331D+03,0.315D+03,0.29233000D+01,0.29859000D+01
     .,0.14216340D+03,0.331D+03,0.327D+03,0.29233000D+01,0.77785000D+01
     .,0.15548130D+03,0.331D+03,0.328D+03,0.29233000D+01,0.62918000D+01
     .,0.17231530D+03,0.331D+03,0.331D+03,0.29233000D+01,0.29233000D+01
     ./)
      grimme_c6_parameters( 144601: 144700)=(/
     . 0.25925500D+02,0.332D+03,0.100D+01,0.29186000D+01,0.91180000D+00
     .,0.17061400D+02,0.332D+03,0.200D+01,0.29186000D+01,0.00000000D+00
     .,0.39241090D+03,0.332D+03,0.300D+01,0.29186000D+01,0.00000000D+00
     .,0.23062870D+03,0.332D+03,0.400D+01,0.29186000D+01,0.00000000D+00
     .,0.15627830D+03,0.332D+03,0.500D+01,0.29186000D+01,0.00000000D+00
     .,0.10580040D+03,0.332D+03,0.600D+01,0.29186000D+01,0.00000000D+00
     .,0.73967500D+02,0.332D+03,0.700D+01,0.29186000D+01,0.00000000D+00
     .,0.55931400D+02,0.332D+03,0.800D+01,0.29186000D+01,0.00000000D+00
     .,0.42287900D+02,0.332D+03,0.900D+01,0.29186000D+01,0.00000000D+00
     .,0.32451500D+02,0.332D+03,0.100D+02,0.29186000D+01,0.00000000D+00
     .,0.46954960D+03,0.332D+03,0.110D+02,0.29186000D+01,0.00000000D+00
     .,0.36633190D+03,0.332D+03,0.120D+02,0.29186000D+01,0.00000000D+00
     .,0.33910340D+03,0.332D+03,0.130D+02,0.29186000D+01,0.00000000D+00
     .,0.26843700D+03,0.332D+03,0.140D+02,0.29186000D+01,0.00000000D+00
     .,0.20985610D+03,0.332D+03,0.150D+02,0.29186000D+01,0.00000000D+00
     .,0.17427160D+03,0.332D+03,0.160D+02,0.29186000D+01,0.00000000D+00
     .,0.14234130D+03,0.332D+03,0.170D+02,0.29186000D+01,0.00000000D+00
     .,0.11635890D+03,0.332D+03,0.180D+02,0.29186000D+01,0.00000000D+00
     .,0.76657140D+03,0.332D+03,0.190D+02,0.29186000D+01,0.00000000D+00
     .,0.63980000D+03,0.332D+03,0.200D+02,0.29186000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 144701: 144800)=(/
     . 0.52977990D+03,0.332D+03,0.210D+02,0.29186000D+01,0.00000000D+00
     .,0.51242740D+03,0.332D+03,0.220D+02,0.29186000D+01,0.00000000D+00
     .,0.46971220D+03,0.332D+03,0.230D+02,0.29186000D+01,0.00000000D+00
     .,0.36970490D+03,0.332D+03,0.240D+02,0.29186000D+01,0.00000000D+00
     .,0.40496220D+03,0.332D+03,0.250D+02,0.29186000D+01,0.00000000D+00
     .,0.31759430D+03,0.332D+03,0.260D+02,0.29186000D+01,0.00000000D+00
     .,0.33769310D+03,0.332D+03,0.270D+02,0.29186000D+01,0.00000000D+00
     .,0.34754450D+03,0.332D+03,0.280D+02,0.29186000D+01,0.00000000D+00
     .,0.26609200D+03,0.332D+03,0.290D+02,0.29186000D+01,0.00000000D+00
     .,0.27433390D+03,0.332D+03,0.300D+02,0.29186000D+01,0.00000000D+00
     .,0.32494560D+03,0.332D+03,0.310D+02,0.29186000D+01,0.00000000D+00
     .,0.28761030D+03,0.332D+03,0.320D+02,0.29186000D+01,0.00000000D+00
     .,0.24587190D+03,0.332D+03,0.330D+02,0.29186000D+01,0.00000000D+00
     .,0.22078460D+03,0.332D+03,0.340D+02,0.29186000D+01,0.00000000D+00
     .,0.19325910D+03,0.332D+03,0.350D+02,0.29186000D+01,0.00000000D+00
     .,0.16801940D+03,0.332D+03,0.360D+02,0.29186000D+01,0.00000000D+00
     .,0.85965830D+03,0.332D+03,0.370D+02,0.29186000D+01,0.00000000D+00
     .,0.76173640D+03,0.332D+03,0.380D+02,0.29186000D+01,0.00000000D+00
     .,0.66974730D+03,0.332D+03,0.390D+02,0.29186000D+01,0.00000000D+00
     .,0.60315190D+03,0.332D+03,0.400D+02,0.29186000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 144801: 144900)=(/
     . 0.55060110D+03,0.332D+03,0.410D+02,0.29186000D+01,0.00000000D+00
     .,0.42558490D+03,0.332D+03,0.420D+02,0.29186000D+01,0.00000000D+00
     .,0.47466380D+03,0.332D+03,0.430D+02,0.29186000D+01,0.00000000D+00
     .,0.36203660D+03,0.332D+03,0.440D+02,0.29186000D+01,0.00000000D+00
     .,0.39601830D+03,0.332D+03,0.450D+02,0.29186000D+01,0.00000000D+00
     .,0.36742870D+03,0.332D+03,0.460D+02,0.29186000D+01,0.00000000D+00
     .,0.30577550D+03,0.332D+03,0.470D+02,0.29186000D+01,0.00000000D+00
     .,0.32392920D+03,0.332D+03,0.480D+02,0.29186000D+01,0.00000000D+00
     .,0.40593030D+03,0.332D+03,0.490D+02,0.29186000D+01,0.00000000D+00
     .,0.37661080D+03,0.332D+03,0.500D+02,0.29186000D+01,0.00000000D+00
     .,0.33642890D+03,0.332D+03,0.510D+02,0.29186000D+01,0.00000000D+00
     .,0.31246310D+03,0.332D+03,0.520D+02,0.29186000D+01,0.00000000D+00
     .,0.28271950D+03,0.332D+03,0.530D+02,0.29186000D+01,0.00000000D+00
     .,0.25424580D+03,0.332D+03,0.540D+02,0.29186000D+01,0.00000000D+00
     .,0.10475077D+04,0.332D+03,0.550D+02,0.29186000D+01,0.00000000D+00
     .,0.96965590D+03,0.332D+03,0.560D+02,0.29186000D+01,0.00000000D+00
     .,0.85512980D+03,0.332D+03,0.570D+02,0.29186000D+01,0.00000000D+00
     .,0.39708240D+03,0.332D+03,0.580D+02,0.29186000D+01,0.27991000D+01
     .,0.85990430D+03,0.332D+03,0.590D+02,0.29186000D+01,0.00000000D+00
     .,0.82624710D+03,0.332D+03,0.600D+02,0.29186000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 144901: 145000)=(/
     . 0.80566910D+03,0.332D+03,0.610D+02,0.29186000D+01,0.00000000D+00
     .,0.78673400D+03,0.332D+03,0.620D+02,0.29186000D+01,0.00000000D+00
     .,0.76995120D+03,0.332D+03,0.630D+02,0.29186000D+01,0.00000000D+00
     .,0.60750730D+03,0.332D+03,0.640D+02,0.29186000D+01,0.00000000D+00
     .,0.67977520D+03,0.332D+03,0.650D+02,0.29186000D+01,0.00000000D+00
     .,0.65608890D+03,0.332D+03,0.660D+02,0.29186000D+01,0.00000000D+00
     .,0.69513050D+03,0.332D+03,0.670D+02,0.29186000D+01,0.00000000D+00
     .,0.68046640D+03,0.332D+03,0.680D+02,0.29186000D+01,0.00000000D+00
     .,0.66727580D+03,0.332D+03,0.690D+02,0.29186000D+01,0.00000000D+00
     .,0.65939100D+03,0.332D+03,0.700D+02,0.29186000D+01,0.00000000D+00
     .,0.55687690D+03,0.332D+03,0.710D+02,0.29186000D+01,0.00000000D+00
     .,0.54981880D+03,0.332D+03,0.720D+02,0.29186000D+01,0.00000000D+00
     .,0.50258340D+03,0.332D+03,0.730D+02,0.29186000D+01,0.00000000D+00
     .,0.42456930D+03,0.332D+03,0.740D+02,0.29186000D+01,0.00000000D+00
     .,0.43228120D+03,0.332D+03,0.750D+02,0.29186000D+01,0.00000000D+00
     .,0.39218940D+03,0.332D+03,0.760D+02,0.29186000D+01,0.00000000D+00
     .,0.35941840D+03,0.332D+03,0.770D+02,0.29186000D+01,0.00000000D+00
     .,0.29849470D+03,0.332D+03,0.780D+02,0.29186000D+01,0.00000000D+00
     .,0.27884190D+03,0.332D+03,0.790D+02,0.29186000D+01,0.00000000D+00
     .,0.28712700D+03,0.332D+03,0.800D+02,0.29186000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 145001: 145100)=(/
     . 0.41657100D+03,0.332D+03,0.810D+02,0.29186000D+01,0.00000000D+00
     .,0.40843950D+03,0.332D+03,0.820D+02,0.29186000D+01,0.00000000D+00
     .,0.37618150D+03,0.332D+03,0.830D+02,0.29186000D+01,0.00000000D+00
     .,0.35916750D+03,0.332D+03,0.840D+02,0.29186000D+01,0.00000000D+00
     .,0.33177440D+03,0.332D+03,0.850D+02,0.29186000D+01,0.00000000D+00
     .,0.30422370D+03,0.332D+03,0.860D+02,0.29186000D+01,0.00000000D+00
     .,0.99208740D+03,0.332D+03,0.870D+02,0.29186000D+01,0.00000000D+00
     .,0.96060620D+03,0.332D+03,0.880D+02,0.29186000D+01,0.00000000D+00
     .,0.85194620D+03,0.332D+03,0.890D+02,0.29186000D+01,0.00000000D+00
     .,0.76802670D+03,0.332D+03,0.900D+02,0.29186000D+01,0.00000000D+00
     .,0.76090240D+03,0.332D+03,0.910D+02,0.29186000D+01,0.00000000D+00
     .,0.73674860D+03,0.332D+03,0.920D+02,0.29186000D+01,0.00000000D+00
     .,0.75679710D+03,0.332D+03,0.930D+02,0.29186000D+01,0.00000000D+00
     .,0.73318910D+03,0.332D+03,0.940D+02,0.29186000D+01,0.00000000D+00
     .,0.41732300D+02,0.332D+03,0.101D+03,0.29186000D+01,0.00000000D+00
     .,0.13414080D+03,0.332D+03,0.103D+03,0.29186000D+01,0.98650000D+00
     .,0.17128910D+03,0.332D+03,0.104D+03,0.29186000D+01,0.98080000D+00
     .,0.13152340D+03,0.332D+03,0.105D+03,0.29186000D+01,0.97060000D+00
     .,0.99176300D+02,0.332D+03,0.106D+03,0.29186000D+01,0.98680000D+00
     .,0.68932300D+02,0.332D+03,0.107D+03,0.29186000D+01,0.99440000D+00
     ./)
      grimme_c6_parameters( 145101: 145200)=(/
     . 0.50126900D+02,0.332D+03,0.108D+03,0.29186000D+01,0.99250000D+00
     .,0.34364200D+02,0.332D+03,0.109D+03,0.29186000D+01,0.99820000D+00
     .,0.19562310D+03,0.332D+03,0.111D+03,0.29186000D+01,0.96840000D+00
     .,0.30252130D+03,0.332D+03,0.112D+03,0.29186000D+01,0.96280000D+00
     .,0.30755040D+03,0.332D+03,0.113D+03,0.29186000D+01,0.96480000D+00
     .,0.24819650D+03,0.332D+03,0.114D+03,0.29186000D+01,0.95070000D+00
     .,0.20368650D+03,0.332D+03,0.115D+03,0.29186000D+01,0.99470000D+00
     .,0.17232720D+03,0.332D+03,0.116D+03,0.29186000D+01,0.99480000D+00
     .,0.14084920D+03,0.332D+03,0.117D+03,0.29186000D+01,0.99720000D+00
     .,0.26984030D+03,0.332D+03,0.119D+03,0.29186000D+01,0.97670000D+00
     .,0.51153740D+03,0.332D+03,0.120D+03,0.29186000D+01,0.98310000D+00
     .,0.27124750D+03,0.332D+03,0.121D+03,0.29186000D+01,0.18627000D+01
     .,0.26180740D+03,0.332D+03,0.122D+03,0.29186000D+01,0.18299000D+01
     .,0.25651490D+03,0.332D+03,0.123D+03,0.29186000D+01,0.19138000D+01
     .,0.25399050D+03,0.332D+03,0.124D+03,0.29186000D+01,0.18269000D+01
     .,0.23426800D+03,0.332D+03,0.125D+03,0.29186000D+01,0.16406000D+01
     .,0.21686750D+03,0.332D+03,0.126D+03,0.29186000D+01,0.16483000D+01
     .,0.20682100D+03,0.332D+03,0.127D+03,0.29186000D+01,0.17149000D+01
     .,0.20214420D+03,0.332D+03,0.128D+03,0.29186000D+01,0.17937000D+01
     .,0.19934300D+03,0.332D+03,0.129D+03,0.29186000D+01,0.95760000D+00
     ./)
      grimme_c6_parameters( 145201: 145300)=(/
     . 0.18764810D+03,0.332D+03,0.130D+03,0.29186000D+01,0.19419000D+01
     .,0.30545790D+03,0.332D+03,0.131D+03,0.29186000D+01,0.96010000D+00
     .,0.26922150D+03,0.332D+03,0.132D+03,0.29186000D+01,0.94340000D+00
     .,0.24171350D+03,0.332D+03,0.133D+03,0.29186000D+01,0.98890000D+00
     .,0.22085650D+03,0.332D+03,0.134D+03,0.29186000D+01,0.99010000D+00
     .,0.19459280D+03,0.332D+03,0.135D+03,0.29186000D+01,0.99740000D+00
     .,0.32210960D+03,0.332D+03,0.137D+03,0.29186000D+01,0.97380000D+00
     .,0.62192630D+03,0.332D+03,0.138D+03,0.29186000D+01,0.98010000D+00
     .,0.47871320D+03,0.332D+03,0.139D+03,0.29186000D+01,0.19153000D+01
     .,0.35847720D+03,0.332D+03,0.140D+03,0.29186000D+01,0.19355000D+01
     .,0.36192950D+03,0.332D+03,0.141D+03,0.29186000D+01,0.19545000D+01
     .,0.33757750D+03,0.332D+03,0.142D+03,0.29186000D+01,0.19420000D+01
     .,0.37742760D+03,0.332D+03,0.143D+03,0.29186000D+01,0.16682000D+01
     .,0.29466340D+03,0.332D+03,0.144D+03,0.29186000D+01,0.18584000D+01
     .,0.27557070D+03,0.332D+03,0.145D+03,0.29186000D+01,0.19003000D+01
     .,0.25584410D+03,0.332D+03,0.146D+03,0.29186000D+01,0.18630000D+01
     .,0.24737280D+03,0.332D+03,0.147D+03,0.29186000D+01,0.96790000D+00
     .,0.24521190D+03,0.332D+03,0.148D+03,0.29186000D+01,0.19539000D+01
     .,0.38734040D+03,0.332D+03,0.149D+03,0.29186000D+01,0.96330000D+00
     .,0.35152010D+03,0.332D+03,0.150D+03,0.29186000D+01,0.95140000D+00
     ./)
      grimme_c6_parameters( 145301: 145400)=(/
     . 0.32980470D+03,0.332D+03,0.151D+03,0.29186000D+01,0.97490000D+00
     .,0.31226190D+03,0.332D+03,0.152D+03,0.29186000D+01,0.98110000D+00
     .,0.28538200D+03,0.332D+03,0.153D+03,0.29186000D+01,0.99680000D+00
     .,0.38205620D+03,0.332D+03,0.155D+03,0.29186000D+01,0.99090000D+00
     .,0.80495990D+03,0.332D+03,0.156D+03,0.29186000D+01,0.97970000D+00
     .,0.60548420D+03,0.332D+03,0.157D+03,0.29186000D+01,0.19373000D+01
     .,0.38513200D+03,0.332D+03,0.159D+03,0.29186000D+01,0.29425000D+01
     .,0.37716470D+03,0.332D+03,0.160D+03,0.29186000D+01,0.29455000D+01
     .,0.36522950D+03,0.332D+03,0.161D+03,0.29186000D+01,0.29413000D+01
     .,0.36689290D+03,0.332D+03,0.162D+03,0.29186000D+01,0.29300000D+01
     .,0.35308810D+03,0.332D+03,0.163D+03,0.29186000D+01,0.18286000D+01
     .,0.36924660D+03,0.332D+03,0.164D+03,0.29186000D+01,0.28732000D+01
     .,0.34685640D+03,0.332D+03,0.165D+03,0.29186000D+01,0.29086000D+01
     .,0.35267810D+03,0.332D+03,0.166D+03,0.29186000D+01,0.28965000D+01
     .,0.32934030D+03,0.332D+03,0.167D+03,0.29186000D+01,0.29242000D+01
     .,0.31999040D+03,0.332D+03,0.168D+03,0.29186000D+01,0.29282000D+01
     .,0.31792410D+03,0.332D+03,0.169D+03,0.29186000D+01,0.29246000D+01
     .,0.33414390D+03,0.332D+03,0.170D+03,0.29186000D+01,0.28482000D+01
     .,0.30737050D+03,0.332D+03,0.171D+03,0.29186000D+01,0.29219000D+01
     .,0.41466360D+03,0.332D+03,0.172D+03,0.29186000D+01,0.19254000D+01
     ./)
      grimme_c6_parameters( 145401: 145500)=(/
     . 0.38533830D+03,0.332D+03,0.173D+03,0.29186000D+01,0.19459000D+01
     .,0.35200450D+03,0.332D+03,0.174D+03,0.29186000D+01,0.19292000D+01
     .,0.35566060D+03,0.332D+03,0.175D+03,0.29186000D+01,0.18104000D+01
     .,0.31228140D+03,0.332D+03,0.176D+03,0.29186000D+01,0.18858000D+01
     .,0.29375400D+03,0.332D+03,0.177D+03,0.29186000D+01,0.18648000D+01
     .,0.28052440D+03,0.332D+03,0.178D+03,0.29186000D+01,0.19188000D+01
     .,0.26802920D+03,0.332D+03,0.179D+03,0.29186000D+01,0.98460000D+00
     .,0.25933470D+03,0.332D+03,0.180D+03,0.29186000D+01,0.19896000D+01
     .,0.41573130D+03,0.332D+03,0.181D+03,0.29186000D+01,0.92670000D+00
     .,0.38005970D+03,0.332D+03,0.182D+03,0.29186000D+01,0.93830000D+00
     .,0.36914810D+03,0.332D+03,0.183D+03,0.29186000D+01,0.98200000D+00
     .,0.35933580D+03,0.332D+03,0.184D+03,0.29186000D+01,0.98150000D+00
     .,0.33582630D+03,0.332D+03,0.185D+03,0.29186000D+01,0.99540000D+00
     .,0.43041160D+03,0.332D+03,0.187D+03,0.29186000D+01,0.97050000D+00
     .,0.80257380D+03,0.332D+03,0.188D+03,0.29186000D+01,0.96620000D+00
     .,0.45579310D+03,0.332D+03,0.189D+03,0.29186000D+01,0.29070000D+01
     .,0.52467090D+03,0.332D+03,0.190D+03,0.29186000D+01,0.28844000D+01
     .,0.46916950D+03,0.332D+03,0.191D+03,0.29186000D+01,0.28738000D+01
     .,0.41536370D+03,0.332D+03,0.192D+03,0.29186000D+01,0.28878000D+01
     .,0.39979830D+03,0.332D+03,0.193D+03,0.29186000D+01,0.29095000D+01
     ./)
      grimme_c6_parameters( 145501: 145600)=(/
     . 0.47845560D+03,0.332D+03,0.194D+03,0.29186000D+01,0.19209000D+01
     .,0.11247080D+03,0.332D+03,0.204D+03,0.29186000D+01,0.19697000D+01
     .,0.11046530D+03,0.332D+03,0.205D+03,0.29186000D+01,0.19441000D+01
     .,0.80908400D+02,0.332D+03,0.206D+03,0.29186000D+01,0.19985000D+01
     .,0.64694600D+02,0.332D+03,0.207D+03,0.29186000D+01,0.20143000D+01
     .,0.44161100D+02,0.332D+03,0.208D+03,0.29186000D+01,0.19887000D+01
     .,0.19895420D+03,0.332D+03,0.212D+03,0.29186000D+01,0.19496000D+01
     .,0.24029350D+03,0.332D+03,0.213D+03,0.29186000D+01,0.19311000D+01
     .,0.23095630D+03,0.332D+03,0.214D+03,0.29186000D+01,0.19435000D+01
     .,0.20085430D+03,0.332D+03,0.215D+03,0.29186000D+01,0.20102000D+01
     .,0.16882630D+03,0.332D+03,0.216D+03,0.29186000D+01,0.19903000D+01
     .,0.27842050D+03,0.332D+03,0.220D+03,0.29186000D+01,0.19349000D+01
     .,0.26802690D+03,0.332D+03,0.221D+03,0.29186000D+01,0.28999000D+01
     .,0.27133540D+03,0.332D+03,0.222D+03,0.29186000D+01,0.38675000D+01
     .,0.24816060D+03,0.332D+03,0.223D+03,0.29186000D+01,0.29110000D+01
     .,0.18702850D+03,0.332D+03,0.224D+03,0.29186000D+01,0.10619100D+02
     .,0.16012070D+03,0.332D+03,0.225D+03,0.29186000D+01,0.98849000D+01
     .,0.15714100D+03,0.332D+03,0.226D+03,0.29186000D+01,0.91376000D+01
     .,0.18402720D+03,0.332D+03,0.227D+03,0.29186000D+01,0.29263000D+01
     .,0.17152460D+03,0.332D+03,0.228D+03,0.29186000D+01,0.65458000D+01
     ./)
      grimme_c6_parameters( 145601: 145700)=(/
     . 0.24266150D+03,0.332D+03,0.231D+03,0.29186000D+01,0.19315000D+01
     .,0.25640090D+03,0.332D+03,0.232D+03,0.29186000D+01,0.19447000D+01
     .,0.23540190D+03,0.332D+03,0.233D+03,0.29186000D+01,0.19793000D+01
     .,0.21911610D+03,0.332D+03,0.234D+03,0.29186000D+01,0.19812000D+01
     .,0.33346480D+03,0.332D+03,0.238D+03,0.29186000D+01,0.19143000D+01
     .,0.32171900D+03,0.332D+03,0.239D+03,0.29186000D+01,0.28903000D+01
     .,0.32464310D+03,0.332D+03,0.240D+03,0.29186000D+01,0.39106000D+01
     .,0.31369090D+03,0.332D+03,0.241D+03,0.29186000D+01,0.29225000D+01
     .,0.27753210D+03,0.332D+03,0.242D+03,0.29186000D+01,0.11055600D+02
     .,0.24504710D+03,0.332D+03,0.243D+03,0.29186000D+01,0.95402000D+01
     .,0.23155270D+03,0.332D+03,0.244D+03,0.29186000D+01,0.88895000D+01
     .,0.23553230D+03,0.332D+03,0.245D+03,0.29186000D+01,0.29696000D+01
     .,0.24604900D+03,0.332D+03,0.246D+03,0.29186000D+01,0.57095000D+01
     .,0.31261830D+03,0.332D+03,0.249D+03,0.29186000D+01,0.19378000D+01
     .,0.33998590D+03,0.332D+03,0.250D+03,0.29186000D+01,0.19505000D+01
     .,0.32084600D+03,0.332D+03,0.251D+03,0.29186000D+01,0.19523000D+01
     .,0.30976360D+03,0.332D+03,0.252D+03,0.29186000D+01,0.19639000D+01
     .,0.40345600D+03,0.332D+03,0.256D+03,0.29186000D+01,0.18467000D+01
     .,0.41889570D+03,0.332D+03,0.257D+03,0.29186000D+01,0.29175000D+01
     .,0.31096060D+03,0.332D+03,0.272D+03,0.29186000D+01,0.38840000D+01
     ./)
      grimme_c6_parameters( 145701: 145800)=(/
     . 0.32438890D+03,0.332D+03,0.273D+03,0.29186000D+01,0.28988000D+01
     .,0.30155580D+03,0.332D+03,0.274D+03,0.29186000D+01,0.10915300D+02
     .,0.27396610D+03,0.332D+03,0.275D+03,0.29186000D+01,0.98054000D+01
     .,0.25778980D+03,0.332D+03,0.276D+03,0.29186000D+01,0.91527000D+01
     .,0.26244250D+03,0.332D+03,0.277D+03,0.29186000D+01,0.29424000D+01
     .,0.27611510D+03,0.332D+03,0.278D+03,0.29186000D+01,0.66669000D+01
     .,0.33401410D+03,0.332D+03,0.281D+03,0.29186000D+01,0.19302000D+01
     .,0.35322530D+03,0.332D+03,0.282D+03,0.29186000D+01,0.19356000D+01
     .,0.36036290D+03,0.332D+03,0.283D+03,0.29186000D+01,0.19655000D+01
     .,0.35787940D+03,0.332D+03,0.284D+03,0.29186000D+01,0.19639000D+01
     .,0.44425160D+03,0.332D+03,0.288D+03,0.29186000D+01,0.18075000D+01
     .,0.84139800D+02,0.332D+03,0.305D+03,0.29186000D+01,0.29128000D+01
     .,0.75651400D+02,0.332D+03,0.306D+03,0.29186000D+01,0.29987000D+01
     .,0.56913400D+02,0.332D+03,0.307D+03,0.29186000D+01,0.29903000D+01
     .,0.18779330D+03,0.332D+03,0.313D+03,0.29186000D+01,0.29146000D+01
     .,0.22491460D+03,0.332D+03,0.314D+03,0.29186000D+01,0.29407000D+01
     .,0.18642580D+03,0.332D+03,0.315D+03,0.29186000D+01,0.29859000D+01
     .,0.16395940D+03,0.332D+03,0.327D+03,0.29186000D+01,0.77785000D+01
     .,0.17981780D+03,0.332D+03,0.328D+03,0.29186000D+01,0.62918000D+01
     .,0.19898010D+03,0.332D+03,0.331D+03,0.29186000D+01,0.29233000D+01
     ./)
      grimme_c6_parameters( 145801: 145900)=(/
     . 0.22994980D+03,0.332D+03,0.332D+03,0.29186000D+01,0.29186000D+01
     .,0.25814400D+02,0.333D+03,0.100D+01,0.29709000D+01,0.91180000D+00
     .,0.17190000D+02,0.333D+03,0.200D+01,0.29709000D+01,0.00000000D+00
     .,0.37309010D+03,0.333D+03,0.300D+01,0.29709000D+01,0.00000000D+00
     .,0.22360990D+03,0.333D+03,0.400D+01,0.29709000D+01,0.00000000D+00
     .,0.15340550D+03,0.333D+03,0.500D+01,0.29709000D+01,0.00000000D+00
     .,0.10484620D+03,0.333D+03,0.600D+01,0.29709000D+01,0.00000000D+00
     .,0.73824600D+02,0.333D+03,0.700D+01,0.29709000D+01,0.00000000D+00
     .,0.56105700D+02,0.333D+03,0.800D+01,0.29709000D+01,0.00000000D+00
     .,0.42601300D+02,0.333D+03,0.900D+01,0.29709000D+01,0.00000000D+00
     .,0.32802100D+02,0.333D+03,0.100D+02,0.29709000D+01,0.00000000D+00
     .,0.44701790D+03,0.333D+03,0.110D+02,0.29709000D+01,0.00000000D+00
     .,0.35391780D+03,0.333D+03,0.120D+02,0.29709000D+01,0.00000000D+00
     .,0.32966240D+03,0.333D+03,0.130D+02,0.29709000D+01,0.00000000D+00
     .,0.26315950D+03,0.333D+03,0.140D+02,0.29709000D+01,0.00000000D+00
     .,0.20724190D+03,0.333D+03,0.150D+02,0.29709000D+01,0.00000000D+00
     .,0.17294560D+03,0.333D+03,0.160D+02,0.29709000D+01,0.00000000D+00
     .,0.14192450D+03,0.333D+03,0.170D+02,0.29709000D+01,0.00000000D+00
     .,0.11649640D+03,0.333D+03,0.180D+02,0.29709000D+01,0.00000000D+00
     .,0.72861950D+03,0.333D+03,0.190D+02,0.29709000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 145901: 146000)=(/
     . 0.61467050D+03,0.333D+03,0.200D+02,0.29709000D+01,0.00000000D+00
     .,0.51029120D+03,0.333D+03,0.210D+02,0.29709000D+01,0.00000000D+00
     .,0.49492760D+03,0.333D+03,0.220D+02,0.29709000D+01,0.00000000D+00
     .,0.45438220D+03,0.333D+03,0.230D+02,0.29709000D+01,0.00000000D+00
     .,0.35797570D+03,0.333D+03,0.240D+02,0.29709000D+01,0.00000000D+00
     .,0.39264080D+03,0.333D+03,0.250D+02,0.29709000D+01,0.00000000D+00
     .,0.30830750D+03,0.333D+03,0.260D+02,0.29709000D+01,0.00000000D+00
     .,0.32864030D+03,0.333D+03,0.270D+02,0.29709000D+01,0.00000000D+00
     .,0.33766070D+03,0.333D+03,0.280D+02,0.29709000D+01,0.00000000D+00
     .,0.25878300D+03,0.333D+03,0.290D+02,0.29709000D+01,0.00000000D+00
     .,0.26791080D+03,0.333D+03,0.300D+02,0.29709000D+01,0.00000000D+00
     .,0.31682010D+03,0.333D+03,0.310D+02,0.29709000D+01,0.00000000D+00
     .,0.28218280D+03,0.333D+03,0.320D+02,0.29709000D+01,0.00000000D+00
     .,0.24267360D+03,0.333D+03,0.330D+02,0.29709000D+01,0.00000000D+00
     .,0.21875310D+03,0.333D+03,0.340D+02,0.29709000D+01,0.00000000D+00
     .,0.19224210D+03,0.333D+03,0.350D+02,0.29709000D+01,0.00000000D+00
     .,0.16775050D+03,0.333D+03,0.360D+02,0.29709000D+01,0.00000000D+00
     .,0.81822470D+03,0.333D+03,0.370D+02,0.29709000D+01,0.00000000D+00
     .,0.73174620D+03,0.333D+03,0.380D+02,0.29709000D+01,0.00000000D+00
     .,0.64647740D+03,0.333D+03,0.390D+02,0.29709000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 146001: 146100)=(/
     . 0.58401600D+03,0.333D+03,0.400D+02,0.29709000D+01,0.00000000D+00
     .,0.53429150D+03,0.333D+03,0.410D+02,0.29709000D+01,0.00000000D+00
     .,0.41465090D+03,0.333D+03,0.420D+02,0.29709000D+01,0.00000000D+00
     .,0.46175770D+03,0.333D+03,0.430D+02,0.29709000D+01,0.00000000D+00
     .,0.35373830D+03,0.333D+03,0.440D+02,0.29709000D+01,0.00000000D+00
     .,0.38672900D+03,0.333D+03,0.450D+02,0.29709000D+01,0.00000000D+00
     .,0.35928420D+03,0.333D+03,0.460D+02,0.29709000D+01,0.00000000D+00
     .,0.29901370D+03,0.333D+03,0.470D+02,0.29709000D+01,0.00000000D+00
     .,0.31728800D+03,0.333D+03,0.480D+02,0.29709000D+01,0.00000000D+00
     .,0.39591570D+03,0.333D+03,0.490D+02,0.29709000D+01,0.00000000D+00
     .,0.36910130D+03,0.333D+03,0.500D+02,0.29709000D+01,0.00000000D+00
     .,0.33139460D+03,0.333D+03,0.510D+02,0.29709000D+01,0.00000000D+00
     .,0.30877390D+03,0.333D+03,0.520D+02,0.29709000D+01,0.00000000D+00
     .,0.28035770D+03,0.333D+03,0.530D+02,0.29709000D+01,0.00000000D+00
     .,0.25296780D+03,0.333D+03,0.540D+02,0.29709000D+01,0.00000000D+00
     .,0.99762710D+03,0.333D+03,0.550D+02,0.29709000D+01,0.00000000D+00
     .,0.93038380D+03,0.333D+03,0.560D+02,0.29709000D+01,0.00000000D+00
     .,0.82434880D+03,0.333D+03,0.570D+02,0.29709000D+01,0.00000000D+00
     .,0.39090330D+03,0.333D+03,0.580D+02,0.29709000D+01,0.27991000D+01
     .,0.82640440D+03,0.333D+03,0.590D+02,0.29709000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 146101: 146200)=(/
     . 0.79461360D+03,0.333D+03,0.600D+02,0.29709000D+01,0.00000000D+00
     .,0.77497180D+03,0.333D+03,0.610D+02,0.29709000D+01,0.00000000D+00
     .,0.75687850D+03,0.333D+03,0.620D+02,0.29709000D+01,0.00000000D+00
     .,0.74084790D+03,0.333D+03,0.630D+02,0.29709000D+01,0.00000000D+00
     .,0.58791190D+03,0.333D+03,0.640D+02,0.29709000D+01,0.00000000D+00
     .,0.65318150D+03,0.333D+03,0.650D+02,0.29709000D+01,0.00000000D+00
     .,0.63103160D+03,0.333D+03,0.660D+02,0.29709000D+01,0.00000000D+00
     .,0.66958290D+03,0.333D+03,0.670D+02,0.29709000D+01,0.00000000D+00
     .,0.65552070D+03,0.333D+03,0.680D+02,0.29709000D+01,0.00000000D+00
     .,0.64291690D+03,0.333D+03,0.690D+02,0.29709000D+01,0.00000000D+00
     .,0.63515750D+03,0.333D+03,0.700D+02,0.29709000D+01,0.00000000D+00
     .,0.53851890D+03,0.333D+03,0.710D+02,0.29709000D+01,0.00000000D+00
     .,0.53425460D+03,0.333D+03,0.720D+02,0.29709000D+01,0.00000000D+00
     .,0.48990920D+03,0.333D+03,0.730D+02,0.29709000D+01,0.00000000D+00
     .,0.41509390D+03,0.333D+03,0.740D+02,0.29709000D+01,0.00000000D+00
     .,0.42306850D+03,0.333D+03,0.750D+02,0.29709000D+01,0.00000000D+00
     .,0.38489200D+03,0.333D+03,0.760D+02,0.29709000D+01,0.00000000D+00
     .,0.35353050D+03,0.333D+03,0.770D+02,0.29709000D+01,0.00000000D+00
     .,0.29442160D+03,0.333D+03,0.780D+02,0.29709000D+01,0.00000000D+00
     .,0.27532990D+03,0.333D+03,0.790D+02,0.29709000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 146201: 146300)=(/
     . 0.28371810D+03,0.333D+03,0.800D+02,0.29709000D+01,0.00000000D+00
     .,0.40709580D+03,0.333D+03,0.810D+02,0.29709000D+01,0.00000000D+00
     .,0.40053490D+03,0.333D+03,0.820D+02,0.29709000D+01,0.00000000D+00
     .,0.37051780D+03,0.333D+03,0.830D+02,0.29709000D+01,0.00000000D+00
     .,0.35469940D+03,0.333D+03,0.840D+02,0.29709000D+01,0.00000000D+00
     .,0.32871350D+03,0.333D+03,0.850D+02,0.29709000D+01,0.00000000D+00
     .,0.30233200D+03,0.333D+03,0.860D+02,0.29709000D+01,0.00000000D+00
     .,0.94844440D+03,0.333D+03,0.870D+02,0.29709000D+01,0.00000000D+00
     .,0.92407530D+03,0.333D+03,0.880D+02,0.29709000D+01,0.00000000D+00
     .,0.82301470D+03,0.333D+03,0.890D+02,0.29709000D+01,0.00000000D+00
     .,0.74585710D+03,0.333D+03,0.900D+02,0.29709000D+01,0.00000000D+00
     .,0.73724570D+03,0.333D+03,0.910D+02,0.29709000D+01,0.00000000D+00
     .,0.71393940D+03,0.333D+03,0.920D+02,0.29709000D+01,0.00000000D+00
     .,0.73098970D+03,0.333D+03,0.930D+02,0.29709000D+01,0.00000000D+00
     .,0.70857740D+03,0.333D+03,0.940D+02,0.29709000D+01,0.00000000D+00
     .,0.41243400D+02,0.333D+03,0.101D+03,0.29709000D+01,0.00000000D+00
     .,0.13030340D+03,0.333D+03,0.103D+03,0.29709000D+01,0.98650000D+00
     .,0.16682950D+03,0.333D+03,0.104D+03,0.29709000D+01,0.98080000D+00
     .,0.12946150D+03,0.333D+03,0.105D+03,0.29709000D+01,0.97060000D+00
     .,0.98293000D+02,0.333D+03,0.106D+03,0.29709000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters( 146301: 146400)=(/
     . 0.68826400D+02,0.333D+03,0.107D+03,0.29709000D+01,0.99440000D+00
     .,0.50355500D+02,0.333D+03,0.108D+03,0.29709000D+01,0.99250000D+00
     .,0.34778500D+02,0.333D+03,0.109D+03,0.29709000D+01,0.99820000D+00
     .,0.18967700D+03,0.333D+03,0.111D+03,0.29709000D+01,0.96840000D+00
     .,0.29304400D+03,0.333D+03,0.112D+03,0.29709000D+01,0.96280000D+00
     .,0.29946280D+03,0.333D+03,0.113D+03,0.29709000D+01,0.96480000D+00
     .,0.24364100D+03,0.333D+03,0.114D+03,0.29709000D+01,0.95070000D+00
     .,0.20121190D+03,0.333D+03,0.115D+03,0.29709000D+01,0.99470000D+00
     .,0.17100300D+03,0.333D+03,0.116D+03,0.29709000D+01,0.99480000D+00
     .,0.14042820D+03,0.333D+03,0.117D+03,0.29709000D+01,0.99720000D+00
     .,0.26315470D+03,0.333D+03,0.119D+03,0.29709000D+01,0.97670000D+00
     .,0.49217040D+03,0.333D+03,0.120D+03,0.29709000D+01,0.98310000D+00
     .,0.26602940D+03,0.333D+03,0.121D+03,0.29709000D+01,0.18627000D+01
     .,0.25687630D+03,0.333D+03,0.122D+03,0.29709000D+01,0.18299000D+01
     .,0.25165870D+03,0.333D+03,0.123D+03,0.29709000D+01,0.19138000D+01
     .,0.24899550D+03,0.333D+03,0.124D+03,0.29709000D+01,0.18269000D+01
     .,0.23046590D+03,0.333D+03,0.125D+03,0.29709000D+01,0.16406000D+01
     .,0.21360980D+03,0.333D+03,0.126D+03,0.29709000D+01,0.16483000D+01
     .,0.20373690D+03,0.333D+03,0.127D+03,0.29709000D+01,0.17149000D+01
     .,0.19906950D+03,0.333D+03,0.128D+03,0.29709000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters( 146401: 146500)=(/
     . 0.19575950D+03,0.333D+03,0.129D+03,0.29709000D+01,0.95760000D+00
     .,0.18520600D+03,0.333D+03,0.130D+03,0.29709000D+01,0.19419000D+01
     .,0.29830600D+03,0.333D+03,0.131D+03,0.29709000D+01,0.96010000D+00
     .,0.26455660D+03,0.333D+03,0.132D+03,0.29709000D+01,0.94340000D+00
     .,0.23866010D+03,0.333D+03,0.133D+03,0.29709000D+01,0.98890000D+00
     .,0.21881490D+03,0.333D+03,0.134D+03,0.29709000D+01,0.99010000D+00
     .,0.19353150D+03,0.333D+03,0.135D+03,0.29709000D+01,0.99740000D+00
     .,0.31465180D+03,0.333D+03,0.137D+03,0.29709000D+01,0.97380000D+00
     .,0.59821020D+03,0.333D+03,0.138D+03,0.29709000D+01,0.98010000D+00
     .,0.46492540D+03,0.333D+03,0.139D+03,0.29709000D+01,0.19153000D+01
     .,0.35156410D+03,0.333D+03,0.140D+03,0.29709000D+01,0.19355000D+01
     .,0.35489700D+03,0.333D+03,0.141D+03,0.29709000D+01,0.19545000D+01
     .,0.33152300D+03,0.333D+03,0.142D+03,0.29709000D+01,0.19420000D+01
     .,0.36896070D+03,0.333D+03,0.143D+03,0.29709000D+01,0.16682000D+01
     .,0.29041810D+03,0.333D+03,0.144D+03,0.29709000D+01,0.18584000D+01
     .,0.27173870D+03,0.333D+03,0.145D+03,0.29709000D+01,0.19003000D+01
     .,0.25249180D+03,0.333D+03,0.146D+03,0.29709000D+01,0.18630000D+01
     .,0.24399260D+03,0.333D+03,0.147D+03,0.29709000D+01,0.96790000D+00
     .,0.24246050D+03,0.333D+03,0.148D+03,0.29709000D+01,0.19539000D+01
     .,0.37845390D+03,0.333D+03,0.149D+03,0.29709000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters( 146501: 146600)=(/
     . 0.34521760D+03,0.333D+03,0.150D+03,0.29709000D+01,0.95140000D+00
     .,0.32509990D+03,0.333D+03,0.151D+03,0.29709000D+01,0.97490000D+00
     .,0.30863590D+03,0.333D+03,0.152D+03,0.29709000D+01,0.98110000D+00
     .,0.28298000D+03,0.333D+03,0.153D+03,0.29709000D+01,0.99680000D+00
     .,0.37467690D+03,0.333D+03,0.155D+03,0.29709000D+01,0.99090000D+00
     .,0.77312930D+03,0.333D+03,0.156D+03,0.29709000D+01,0.97970000D+00
     .,0.58768050D+03,0.333D+03,0.157D+03,0.29709000D+01,0.19373000D+01
     .,0.37925720D+03,0.333D+03,0.159D+03,0.29709000D+01,0.29425000D+01
     .,0.37143070D+03,0.333D+03,0.160D+03,0.29709000D+01,0.29455000D+01
     .,0.35977520D+03,0.333D+03,0.161D+03,0.29709000D+01,0.29413000D+01
     .,0.36114910D+03,0.333D+03,0.162D+03,0.29709000D+01,0.29300000D+01
     .,0.34673650D+03,0.333D+03,0.163D+03,0.29709000D+01,0.18286000D+01
     .,0.36334580D+03,0.333D+03,0.164D+03,0.29709000D+01,0.28732000D+01
     .,0.34154120D+03,0.333D+03,0.165D+03,0.29709000D+01,0.29086000D+01
     .,0.34682760D+03,0.333D+03,0.166D+03,0.29709000D+01,0.28965000D+01
     .,0.32449690D+03,0.333D+03,0.167D+03,0.29709000D+01,0.29242000D+01
     .,0.31536050D+03,0.333D+03,0.168D+03,0.29709000D+01,0.29282000D+01
     .,0.31325730D+03,0.333D+03,0.169D+03,0.29709000D+01,0.29246000D+01
     .,0.32883440D+03,0.333D+03,0.170D+03,0.29709000D+01,0.28482000D+01
     .,0.30296350D+03,0.333D+03,0.171D+03,0.29709000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters( 146601: 146700)=(/
     . 0.40527710D+03,0.333D+03,0.172D+03,0.29709000D+01,0.19254000D+01
     .,0.37777130D+03,0.333D+03,0.173D+03,0.29709000D+01,0.19459000D+01
     .,0.34618800D+03,0.333D+03,0.174D+03,0.29709000D+01,0.19292000D+01
     .,0.34883500D+03,0.333D+03,0.175D+03,0.29709000D+01,0.18104000D+01
     .,0.30849820D+03,0.333D+03,0.176D+03,0.29709000D+01,0.18858000D+01
     .,0.29054470D+03,0.333D+03,0.177D+03,0.29709000D+01,0.18648000D+01
     .,0.27766310D+03,0.333D+03,0.178D+03,0.29709000D+01,0.19188000D+01
     .,0.26530450D+03,0.333D+03,0.179D+03,0.29709000D+01,0.98460000D+00
     .,0.25731840D+03,0.333D+03,0.180D+03,0.29709000D+01,0.19896000D+01
     .,0.40678760D+03,0.333D+03,0.181D+03,0.29709000D+01,0.92670000D+00
     .,0.37370420D+03,0.333D+03,0.182D+03,0.29709000D+01,0.93830000D+00
     .,0.36395410D+03,0.333D+03,0.183D+03,0.29709000D+01,0.98200000D+00
     .,0.35500400D+03,0.333D+03,0.184D+03,0.29709000D+01,0.98150000D+00
     .,0.33273420D+03,0.333D+03,0.185D+03,0.29709000D+01,0.99540000D+00
     .,0.42221560D+03,0.333D+03,0.187D+03,0.29709000D+01,0.97050000D+00
     .,0.77316810D+03,0.333D+03,0.188D+03,0.29709000D+01,0.96620000D+00
     .,0.44875130D+03,0.333D+03,0.189D+03,0.29709000D+01,0.29070000D+01
     .,0.51446500D+03,0.333D+03,0.190D+03,0.29709000D+01,0.28844000D+01
     .,0.46088700D+03,0.333D+03,0.191D+03,0.29709000D+01,0.28738000D+01
     .,0.40932390D+03,0.333D+03,0.192D+03,0.29709000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters( 146701: 146800)=(/
     . 0.39428590D+03,0.333D+03,0.193D+03,0.29709000D+01,0.29095000D+01
     .,0.46765480D+03,0.333D+03,0.194D+03,0.29709000D+01,0.19209000D+01
     .,0.11074050D+03,0.333D+03,0.204D+03,0.29709000D+01,0.19697000D+01
     .,0.10903310D+03,0.333D+03,0.205D+03,0.29709000D+01,0.19441000D+01
     .,0.80490200D+02,0.333D+03,0.206D+03,0.29709000D+01,0.19985000D+01
     .,0.64644600D+02,0.333D+03,0.207D+03,0.29709000D+01,0.20143000D+01
     .,0.44441700D+02,0.333D+03,0.208D+03,0.29709000D+01,0.19887000D+01
     .,0.19481980D+03,0.333D+03,0.212D+03,0.29709000D+01,0.19496000D+01
     .,0.23520410D+03,0.333D+03,0.213D+03,0.29709000D+01,0.19311000D+01
     .,0.22699490D+03,0.333D+03,0.214D+03,0.29709000D+01,0.19435000D+01
     .,0.19834020D+03,0.333D+03,0.215D+03,0.29709000D+01,0.20102000D+01
     .,0.16754910D+03,0.333D+03,0.216D+03,0.29709000D+01,0.19903000D+01
     .,0.27279590D+03,0.333D+03,0.220D+03,0.29709000D+01,0.19349000D+01
     .,0.26344960D+03,0.333D+03,0.221D+03,0.29709000D+01,0.28999000D+01
     .,0.26677170D+03,0.333D+03,0.222D+03,0.29709000D+01,0.38675000D+01
     .,0.24398790D+03,0.333D+03,0.223D+03,0.29709000D+01,0.29110000D+01
     .,0.18493070D+03,0.333D+03,0.224D+03,0.29709000D+01,0.10619100D+02
     .,0.15885780D+03,0.333D+03,0.225D+03,0.29709000D+01,0.98849000D+01
     .,0.15583590D+03,0.333D+03,0.226D+03,0.29709000D+01,0.91376000D+01
     .,0.18150050D+03,0.333D+03,0.227D+03,0.29709000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters( 146801: 146900)=(/
     . 0.16942270D+03,0.333D+03,0.228D+03,0.29709000D+01,0.65458000D+01
     .,0.23833640D+03,0.333D+03,0.231D+03,0.29709000D+01,0.19315000D+01
     .,0.25222610D+03,0.333D+03,0.232D+03,0.29709000D+01,0.19447000D+01
     .,0.23257440D+03,0.333D+03,0.233D+03,0.29709000D+01,0.19793000D+01
     .,0.21711610D+03,0.333D+03,0.234D+03,0.29709000D+01,0.19812000D+01
     .,0.32696240D+03,0.333D+03,0.238D+03,0.29709000D+01,0.19143000D+01
     .,0.31671890D+03,0.333D+03,0.239D+03,0.29709000D+01,0.28903000D+01
     .,0.31999160D+03,0.333D+03,0.240D+03,0.29709000D+01,0.39106000D+01
     .,0.30916430D+03,0.333D+03,0.241D+03,0.29709000D+01,0.29225000D+01
     .,0.27453760D+03,0.333D+03,0.242D+03,0.29709000D+01,0.11055600D+02
     .,0.24311650D+03,0.333D+03,0.243D+03,0.29709000D+01,0.95402000D+01
     .,0.22998060D+03,0.333D+03,0.244D+03,0.29709000D+01,0.88895000D+01
     .,0.23320160D+03,0.333D+03,0.245D+03,0.29709000D+01,0.29696000D+01
     .,0.24333990D+03,0.333D+03,0.246D+03,0.29709000D+01,0.57095000D+01
     .,0.30738320D+03,0.333D+03,0.249D+03,0.29709000D+01,0.19378000D+01
     .,0.33424830D+03,0.333D+03,0.250D+03,0.29709000D+01,0.19505000D+01
     .,0.31655690D+03,0.333D+03,0.251D+03,0.29709000D+01,0.19523000D+01
     .,0.30627350D+03,0.333D+03,0.252D+03,0.29709000D+01,0.19639000D+01
     .,0.39613570D+03,0.333D+03,0.256D+03,0.29709000D+01,0.18467000D+01
     .,0.41206100D+03,0.333D+03,0.257D+03,0.29709000D+01,0.29175000D+01
     ./)
      grimme_c6_parameters( 146901: 147000)=(/
     . 0.30703930D+03,0.333D+03,0.272D+03,0.29709000D+01,0.38840000D+01
     .,0.31988160D+03,0.333D+03,0.273D+03,0.29709000D+01,0.28988000D+01
     .,0.29837090D+03,0.333D+03,0.274D+03,0.29709000D+01,0.10915300D+02
     .,0.27179960D+03,0.333D+03,0.275D+03,0.29709000D+01,0.98054000D+01
     .,0.25630050D+03,0.333D+03,0.276D+03,0.29709000D+01,0.91527000D+01
     .,0.26023930D+03,0.333D+03,0.277D+03,0.29709000D+01,0.29424000D+01
     .,0.27366690D+03,0.333D+03,0.278D+03,0.29709000D+01,0.66669000D+01
     .,0.32926130D+03,0.333D+03,0.281D+03,0.29709000D+01,0.19302000D+01
     .,0.34820710D+03,0.333D+03,0.282D+03,0.29709000D+01,0.19356000D+01
     .,0.35568970D+03,0.333D+03,0.283D+03,0.29709000D+01,0.19655000D+01
     .,0.35372780D+03,0.333D+03,0.284D+03,0.29709000D+01,0.19639000D+01
     .,0.43636490D+03,0.333D+03,0.288D+03,0.29709000D+01,0.18075000D+01
     .,0.83603600D+02,0.333D+03,0.305D+03,0.29709000D+01,0.29128000D+01
     .,0.75280800D+02,0.333D+03,0.306D+03,0.29709000D+01,0.29987000D+01
     .,0.56939800D+02,0.333D+03,0.307D+03,0.29709000D+01,0.29903000D+01
     .,0.18498860D+03,0.333D+03,0.313D+03,0.29709000D+01,0.29146000D+01
     .,0.22091650D+03,0.333D+03,0.314D+03,0.29709000D+01,0.29407000D+01
     .,0.18443640D+03,0.333D+03,0.315D+03,0.29709000D+01,0.29859000D+01
     .,0.16228780D+03,0.333D+03,0.327D+03,0.29709000D+01,0.77785000D+01
     .,0.17705570D+03,0.333D+03,0.328D+03,0.29709000D+01,0.62918000D+01
     ./)
      grimme_c6_parameters( 147001: 147100)=(/
     . 0.19651790D+03,0.333D+03,0.331D+03,0.29709000D+01,0.29233000D+01
     .,0.22680190D+03,0.333D+03,0.332D+03,0.29709000D+01,0.29186000D+01
     .,0.22428510D+03,0.333D+03,0.333D+03,0.29709000D+01,0.29709000D+01
     .,0.30319300D+02,0.349D+03,0.100D+01,0.29353000D+01,0.91180000D+00
     .,0.20340200D+02,0.349D+03,0.200D+01,0.29353000D+01,0.00000000D+00
     .,0.44469780D+03,0.349D+03,0.300D+01,0.29353000D+01,0.00000000D+00
     .,0.26404390D+03,0.349D+03,0.400D+01,0.29353000D+01,0.00000000D+00
     .,0.18045680D+03,0.349D+03,0.500D+01,0.29353000D+01,0.00000000D+00
     .,0.12327050D+03,0.349D+03,0.600D+01,0.29353000D+01,0.00000000D+00
     .,0.86956900D+02,0.349D+03,0.700D+01,0.29353000D+01,0.00000000D+00
     .,0.66274100D+02,0.349D+03,0.800D+01,0.29353000D+01,0.00000000D+00
     .,0.50515600D+02,0.349D+03,0.900D+01,0.29353000D+01,0.00000000D+00
     .,0.39067400D+02,0.349D+03,0.100D+02,0.29353000D+01,0.00000000D+00
     .,0.53285380D+03,0.349D+03,0.110D+02,0.29353000D+01,0.00000000D+00
     .,0.41885670D+03,0.349D+03,0.120D+02,0.29353000D+01,0.00000000D+00
     .,0.38906980D+03,0.349D+03,0.130D+02,0.29353000D+01,0.00000000D+00
     .,0.30967790D+03,0.349D+03,0.140D+02,0.29353000D+01,0.00000000D+00
     .,0.24351060D+03,0.349D+03,0.150D+02,0.29353000D+01,0.00000000D+00
     .,0.20320970D+03,0.349D+03,0.160D+02,0.29353000D+01,0.00000000D+00
     .,0.16688670D+03,0.349D+03,0.170D+02,0.29353000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 147101: 147200)=(/
     . 0.13720100D+03,0.349D+03,0.180D+02,0.29353000D+01,0.00000000D+00
     .,0.86995980D+03,0.349D+03,0.190D+02,0.29353000D+01,0.00000000D+00
     .,0.72995940D+03,0.349D+03,0.200D+02,0.29353000D+01,0.00000000D+00
     .,0.60530470D+03,0.349D+03,0.210D+02,0.29353000D+01,0.00000000D+00
     .,0.58657520D+03,0.349D+03,0.220D+02,0.29353000D+01,0.00000000D+00
     .,0.53826720D+03,0.349D+03,0.230D+02,0.29353000D+01,0.00000000D+00
     .,0.42440160D+03,0.349D+03,0.240D+02,0.29353000D+01,0.00000000D+00
     .,0.46484110D+03,0.349D+03,0.250D+02,0.29353000D+01,0.00000000D+00
     .,0.36531290D+03,0.349D+03,0.260D+02,0.29353000D+01,0.00000000D+00
     .,0.38862700D+03,0.349D+03,0.270D+02,0.29353000D+01,0.00000000D+00
     .,0.39951060D+03,0.349D+03,0.280D+02,0.29353000D+01,0.00000000D+00
     .,0.30659770D+03,0.349D+03,0.290D+02,0.29353000D+01,0.00000000D+00
     .,0.31653820D+03,0.349D+03,0.300D+02,0.29353000D+01,0.00000000D+00
     .,0.37394790D+03,0.349D+03,0.310D+02,0.29353000D+01,0.00000000D+00
     .,0.33229320D+03,0.349D+03,0.320D+02,0.29353000D+01,0.00000000D+00
     .,0.28535990D+03,0.349D+03,0.330D+02,0.29353000D+01,0.00000000D+00
     .,0.25714220D+03,0.349D+03,0.340D+02,0.29353000D+01,0.00000000D+00
     .,0.22602240D+03,0.349D+03,0.350D+02,0.29353000D+01,0.00000000D+00
     .,0.19737620D+03,0.349D+03,0.360D+02,0.29353000D+01,0.00000000D+00
     .,0.97661940D+03,0.349D+03,0.370D+02,0.29353000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 147201: 147300)=(/
     . 0.86927450D+03,0.349D+03,0.380D+02,0.29353000D+01,0.00000000D+00
     .,0.76640590D+03,0.349D+03,0.390D+02,0.29353000D+01,0.00000000D+00
     .,0.69159970D+03,0.349D+03,0.400D+02,0.29353000D+01,0.00000000D+00
     .,0.63235800D+03,0.349D+03,0.410D+02,0.29353000D+01,0.00000000D+00
     .,0.49057200D+03,0.349D+03,0.420D+02,0.29353000D+01,0.00000000D+00
     .,0.54639300D+03,0.349D+03,0.430D+02,0.29353000D+01,0.00000000D+00
     .,0.41848510D+03,0.349D+03,0.440D+02,0.29353000D+01,0.00000000D+00
     .,0.45727800D+03,0.349D+03,0.450D+02,0.29353000D+01,0.00000000D+00
     .,0.42477830D+03,0.349D+03,0.460D+02,0.29353000D+01,0.00000000D+00
     .,0.35412210D+03,0.349D+03,0.470D+02,0.29353000D+01,0.00000000D+00
     .,0.37514860D+03,0.349D+03,0.480D+02,0.29353000D+01,0.00000000D+00
     .,0.46825210D+03,0.349D+03,0.490D+02,0.29353000D+01,0.00000000D+00
     .,0.43562520D+03,0.349D+03,0.500D+02,0.29353000D+01,0.00000000D+00
     .,0.39051070D+03,0.349D+03,0.510D+02,0.29353000D+01,0.00000000D+00
     .,0.36359740D+03,0.349D+03,0.520D+02,0.29353000D+01,0.00000000D+00
     .,0.33001060D+03,0.349D+03,0.530D+02,0.29353000D+01,0.00000000D+00
     .,0.29777960D+03,0.349D+03,0.540D+02,0.29353000D+01,0.00000000D+00
     .,0.11900927D+04,0.349D+03,0.550D+02,0.29353000D+01,0.00000000D+00
     .,0.11059339D+04,0.349D+03,0.560D+02,0.29353000D+01,0.00000000D+00
     .,0.97785820D+03,0.349D+03,0.570D+02,0.29353000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 147301: 147400)=(/
     . 0.46088570D+03,0.349D+03,0.580D+02,0.29353000D+01,0.27991000D+01
     .,0.98223880D+03,0.349D+03,0.590D+02,0.29353000D+01,0.00000000D+00
     .,0.94418200D+03,0.349D+03,0.600D+02,0.29353000D+01,0.00000000D+00
     .,0.92077280D+03,0.349D+03,0.610D+02,0.29353000D+01,0.00000000D+00
     .,0.89921070D+03,0.349D+03,0.620D+02,0.29353000D+01,0.00000000D+00
     .,0.88009790D+03,0.349D+03,0.630D+02,0.29353000D+01,0.00000000D+00
     .,0.69717420D+03,0.349D+03,0.640D+02,0.29353000D+01,0.00000000D+00
     .,0.77703650D+03,0.349D+03,0.650D+02,0.29353000D+01,0.00000000D+00
     .,0.75035490D+03,0.349D+03,0.660D+02,0.29353000D+01,0.00000000D+00
     .,0.79506940D+03,0.349D+03,0.670D+02,0.29353000D+01,0.00000000D+00
     .,0.77832350D+03,0.349D+03,0.680D+02,0.29353000D+01,0.00000000D+00
     .,0.76328690D+03,0.349D+03,0.690D+02,0.29353000D+01,0.00000000D+00
     .,0.75412760D+03,0.349D+03,0.700D+02,0.29353000D+01,0.00000000D+00
     .,0.63857600D+03,0.349D+03,0.710D+02,0.29353000D+01,0.00000000D+00
     .,0.63185040D+03,0.349D+03,0.720D+02,0.29353000D+01,0.00000000D+00
     .,0.57890360D+03,0.349D+03,0.730D+02,0.29353000D+01,0.00000000D+00
     .,0.49047740D+03,0.349D+03,0.740D+02,0.29353000D+01,0.00000000D+00
     .,0.49968040D+03,0.349D+03,0.750D+02,0.29353000D+01,0.00000000D+00
     .,0.45440140D+03,0.349D+03,0.760D+02,0.29353000D+01,0.00000000D+00
     .,0.41730580D+03,0.349D+03,0.770D+02,0.29353000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 147401: 147500)=(/
     . 0.34779410D+03,0.349D+03,0.780D+02,0.29353000D+01,0.00000000D+00
     .,0.32538710D+03,0.349D+03,0.790D+02,0.29353000D+01,0.00000000D+00
     .,0.33507650D+03,0.349D+03,0.800D+02,0.29353000D+01,0.00000000D+00
     .,0.48176440D+03,0.349D+03,0.810D+02,0.29353000D+01,0.00000000D+00
     .,0.47318850D+03,0.349D+03,0.820D+02,0.29353000D+01,0.00000000D+00
     .,0.43707980D+03,0.349D+03,0.830D+02,0.29353000D+01,0.00000000D+00
     .,0.41810900D+03,0.349D+03,0.840D+02,0.29353000D+01,0.00000000D+00
     .,0.38726470D+03,0.349D+03,0.850D+02,0.29353000D+01,0.00000000D+00
     .,0.35612660D+03,0.349D+03,0.860D+02,0.29353000D+01,0.00000000D+00
     .,0.11296762D+04,0.349D+03,0.870D+02,0.29353000D+01,0.00000000D+00
     .,0.10972829D+04,0.349D+03,0.880D+02,0.29353000D+01,0.00000000D+00
     .,0.97575910D+03,0.349D+03,0.890D+02,0.29353000D+01,0.00000000D+00
     .,0.88288780D+03,0.349D+03,0.900D+02,0.29353000D+01,0.00000000D+00
     .,0.87388960D+03,0.349D+03,0.910D+02,0.29353000D+01,0.00000000D+00
     .,0.84633640D+03,0.349D+03,0.920D+02,0.29353000D+01,0.00000000D+00
     .,0.86787930D+03,0.349D+03,0.930D+02,0.29353000D+01,0.00000000D+00
     .,0.84109640D+03,0.349D+03,0.940D+02,0.29353000D+01,0.00000000D+00
     .,0.48427000D+02,0.349D+03,0.101D+03,0.29353000D+01,0.00000000D+00
     .,0.15382640D+03,0.349D+03,0.103D+03,0.29353000D+01,0.98650000D+00
     .,0.19674540D+03,0.349D+03,0.104D+03,0.29353000D+01,0.98080000D+00
     ./)
      grimme_c6_parameters( 147501: 147600)=(/
     . 0.15226150D+03,0.349D+03,0.105D+03,0.29353000D+01,0.97060000D+00
     .,0.11561300D+03,0.349D+03,0.106D+03,0.29353000D+01,0.98680000D+00
     .,0.81111000D+02,0.349D+03,0.107D+03,0.29353000D+01,0.99440000D+00
     .,0.59534400D+02,0.349D+03,0.108D+03,0.29353000D+01,0.99250000D+00
     .,0.41374600D+02,0.349D+03,0.109D+03,0.29353000D+01,0.99820000D+00
     .,0.22440970D+03,0.349D+03,0.111D+03,0.29353000D+01,0.96840000D+00
     .,0.34649400D+03,0.349D+03,0.112D+03,0.29353000D+01,0.96280000D+00
     .,0.35326540D+03,0.349D+03,0.113D+03,0.29353000D+01,0.96480000D+00
     .,0.28664120D+03,0.349D+03,0.114D+03,0.29353000D+01,0.95070000D+00
     .,0.23644610D+03,0.349D+03,0.115D+03,0.29353000D+01,0.99470000D+00
     .,0.20095580D+03,0.349D+03,0.116D+03,0.29353000D+01,0.99480000D+00
     .,0.16514950D+03,0.349D+03,0.117D+03,0.29353000D+01,0.99720000D+00
     .,0.31131870D+03,0.349D+03,0.119D+03,0.29353000D+01,0.97670000D+00
     .,0.58448340D+03,0.349D+03,0.120D+03,0.29353000D+01,0.98310000D+00
     .,0.31379200D+03,0.349D+03,0.121D+03,0.29353000D+01,0.18627000D+01
     .,0.30305660D+03,0.349D+03,0.122D+03,0.29353000D+01,0.18299000D+01
     .,0.29698540D+03,0.349D+03,0.123D+03,0.29353000D+01,0.19138000D+01
     .,0.29398400D+03,0.349D+03,0.124D+03,0.29353000D+01,0.18269000D+01
     .,0.27172730D+03,0.349D+03,0.125D+03,0.29353000D+01,0.16406000D+01
     .,0.25185120D+03,0.349D+03,0.126D+03,0.29353000D+01,0.16483000D+01
     ./)
      grimme_c6_parameters( 147601: 147700)=(/
     . 0.24028600D+03,0.349D+03,0.127D+03,0.29353000D+01,0.17149000D+01
     .,0.23483900D+03,0.349D+03,0.128D+03,0.29353000D+01,0.17937000D+01
     .,0.23127000D+03,0.349D+03,0.129D+03,0.29353000D+01,0.95760000D+00
     .,0.21830270D+03,0.349D+03,0.130D+03,0.29353000D+01,0.19419000D+01
     .,0.35191540D+03,0.349D+03,0.131D+03,0.29353000D+01,0.96010000D+00
     .,0.31142600D+03,0.349D+03,0.132D+03,0.29353000D+01,0.94340000D+00
     .,0.28063500D+03,0.349D+03,0.133D+03,0.29353000D+01,0.98890000D+00
     .,0.25722750D+03,0.349D+03,0.134D+03,0.29353000D+01,0.99010000D+00
     .,0.22754720D+03,0.349D+03,0.135D+03,0.29353000D+01,0.99740000D+00
     .,0.37215270D+03,0.349D+03,0.137D+03,0.29353000D+01,0.97380000D+00
     .,0.71067900D+03,0.349D+03,0.138D+03,0.29353000D+01,0.98010000D+00
     .,0.55021640D+03,0.349D+03,0.139D+03,0.29353000D+01,0.19153000D+01
     .,0.41478140D+03,0.349D+03,0.140D+03,0.29353000D+01,0.19355000D+01
     .,0.41884820D+03,0.349D+03,0.141D+03,0.29353000D+01,0.19545000D+01
     .,0.39127220D+03,0.349D+03,0.142D+03,0.29353000D+01,0.19420000D+01
     .,0.43621610D+03,0.349D+03,0.143D+03,0.29353000D+01,0.16682000D+01
     .,0.34263080D+03,0.349D+03,0.144D+03,0.29353000D+01,0.18584000D+01
     .,0.32074540D+03,0.349D+03,0.145D+03,0.29353000D+01,0.19003000D+01
     .,0.29815620D+03,0.349D+03,0.146D+03,0.29353000D+01,0.18630000D+01
     .,0.28828650D+03,0.349D+03,0.147D+03,0.29353000D+01,0.96790000D+00
     ./)
      grimme_c6_parameters( 147701: 147800)=(/
     . 0.28607710D+03,0.349D+03,0.148D+03,0.29353000D+01,0.19539000D+01
     .,0.44732690D+03,0.349D+03,0.149D+03,0.29353000D+01,0.96330000D+00
     .,0.40722750D+03,0.349D+03,0.150D+03,0.29353000D+01,0.95140000D+00
     .,0.38302800D+03,0.349D+03,0.151D+03,0.29353000D+01,0.97490000D+00
     .,0.36340770D+03,0.349D+03,0.152D+03,0.29353000D+01,0.98110000D+00
     .,0.33308010D+03,0.349D+03,0.153D+03,0.29353000D+01,0.99680000D+00
     .,0.44205370D+03,0.349D+03,0.155D+03,0.29353000D+01,0.99090000D+00
     .,0.91909280D+03,0.349D+03,0.156D+03,0.29353000D+01,0.97970000D+00
     .,0.69561840D+03,0.349D+03,0.157D+03,0.29353000D+01,0.19373000D+01
     .,0.44715510D+03,0.349D+03,0.159D+03,0.29353000D+01,0.29425000D+01
     .,0.43794100D+03,0.349D+03,0.160D+03,0.29353000D+01,0.29455000D+01
     .,0.42419840D+03,0.349D+03,0.161D+03,0.29353000D+01,0.29413000D+01
     .,0.42589770D+03,0.349D+03,0.162D+03,0.29353000D+01,0.29300000D+01
     .,0.40941900D+03,0.349D+03,0.163D+03,0.29353000D+01,0.18286000D+01
     .,0.42843500D+03,0.349D+03,0.164D+03,0.29353000D+01,0.28732000D+01
     .,0.40274990D+03,0.349D+03,0.165D+03,0.29353000D+01,0.29086000D+01
     .,0.40914080D+03,0.349D+03,0.166D+03,0.29353000D+01,0.28965000D+01
     .,0.38256860D+03,0.349D+03,0.167D+03,0.29353000D+01,0.29242000D+01
     .,0.37177680D+03,0.349D+03,0.168D+03,0.29353000D+01,0.29282000D+01
     .,0.36929910D+03,0.349D+03,0.169D+03,0.29353000D+01,0.29246000D+01
     ./)
      grimme_c6_parameters( 147801: 147900)=(/
     . 0.38763420D+03,0.349D+03,0.170D+03,0.29353000D+01,0.28482000D+01
     .,0.35709720D+03,0.349D+03,0.171D+03,0.29353000D+01,0.29219000D+01
     .,0.47865480D+03,0.349D+03,0.172D+03,0.29353000D+01,0.19254000D+01
     .,0.44589750D+03,0.349D+03,0.173D+03,0.29353000D+01,0.19459000D+01
     .,0.40842780D+03,0.349D+03,0.174D+03,0.29353000D+01,0.19292000D+01
     .,0.41195430D+03,0.349D+03,0.175D+03,0.29353000D+01,0.18104000D+01
     .,0.36377170D+03,0.349D+03,0.176D+03,0.29353000D+01,0.18858000D+01
     .,0.34272900D+03,0.349D+03,0.177D+03,0.29353000D+01,0.18648000D+01
     .,0.32766460D+03,0.349D+03,0.178D+03,0.29353000D+01,0.19188000D+01
     .,0.31331210D+03,0.349D+03,0.179D+03,0.29353000D+01,0.98460000D+00
     .,0.30363280D+03,0.349D+03,0.180D+03,0.29353000D+01,0.19896000D+01
     .,0.48106690D+03,0.349D+03,0.181D+03,0.29353000D+01,0.92670000D+00
     .,0.44115490D+03,0.349D+03,0.182D+03,0.29353000D+01,0.93830000D+00
     .,0.42919400D+03,0.349D+03,0.183D+03,0.29353000D+01,0.98200000D+00
     .,0.41838610D+03,0.349D+03,0.184D+03,0.29353000D+01,0.98150000D+00
     .,0.39195070D+03,0.349D+03,0.185D+03,0.29353000D+01,0.99540000D+00
     .,0.49802340D+03,0.349D+03,0.187D+03,0.29353000D+01,0.97050000D+00
     .,0.91797160D+03,0.349D+03,0.188D+03,0.29353000D+01,0.96620000D+00
     .,0.52898700D+03,0.349D+03,0.189D+03,0.29353000D+01,0.29070000D+01
     .,0.60741450D+03,0.349D+03,0.190D+03,0.29353000D+01,0.28844000D+01
     ./)
      grimme_c6_parameters( 147901: 148000)=(/
     . 0.54418980D+03,0.349D+03,0.191D+03,0.29353000D+01,0.28738000D+01
     .,0.48298360D+03,0.349D+03,0.192D+03,0.29353000D+01,0.28878000D+01
     .,0.46522570D+03,0.349D+03,0.193D+03,0.29353000D+01,0.29095000D+01
     .,0.55343860D+03,0.349D+03,0.194D+03,0.29353000D+01,0.19209000D+01
     .,0.13011390D+03,0.349D+03,0.204D+03,0.29353000D+01,0.19697000D+01
     .,0.12821910D+03,0.349D+03,0.205D+03,0.29353000D+01,0.19441000D+01
     .,0.94715300D+02,0.349D+03,0.206D+03,0.29353000D+01,0.19985000D+01
     .,0.76253000D+02,0.349D+03,0.207D+03,0.29353000D+01,0.20143000D+01
     .,0.52669000D+02,0.349D+03,0.208D+03,0.29353000D+01,0.19887000D+01
     .,0.22944250D+03,0.349D+03,0.212D+03,0.29353000D+01,0.19496000D+01
     .,0.27699400D+03,0.349D+03,0.213D+03,0.29353000D+01,0.19311000D+01
     .,0.26699740D+03,0.349D+03,0.214D+03,0.29353000D+01,0.19435000D+01
     .,0.23314220D+03,0.349D+03,0.215D+03,0.29353000D+01,0.20102000D+01
     .,0.19692250D+03,0.349D+03,0.216D+03,0.29353000D+01,0.19903000D+01
     .,0.32180650D+03,0.349D+03,0.220D+03,0.29353000D+01,0.19349000D+01
     .,0.31041930D+03,0.349D+03,0.221D+03,0.29353000D+01,0.28999000D+01
     .,0.31434380D+03,0.349D+03,0.222D+03,0.29353000D+01,0.38675000D+01
     .,0.28770260D+03,0.349D+03,0.223D+03,0.29353000D+01,0.29110000D+01
     .,0.21815660D+03,0.349D+03,0.224D+03,0.29353000D+01,0.10619100D+02
     .,0.18741200D+03,0.349D+03,0.225D+03,0.29353000D+01,0.98849000D+01
     ./)
      grimme_c6_parameters( 148001: 148100)=(/
     . 0.18389760D+03,0.349D+03,0.226D+03,0.29353000D+01,0.91376000D+01
     .,0.21424530D+03,0.349D+03,0.227D+03,0.29353000D+01,0.29263000D+01
     .,0.19997120D+03,0.349D+03,0.228D+03,0.29353000D+01,0.65458000D+01
     .,0.28072610D+03,0.349D+03,0.231D+03,0.29353000D+01,0.19315000D+01
     .,0.29685620D+03,0.349D+03,0.232D+03,0.29353000D+01,0.19447000D+01
     .,0.27345920D+03,0.349D+03,0.233D+03,0.29353000D+01,0.19793000D+01
     .,0.25524180D+03,0.349D+03,0.234D+03,0.29353000D+01,0.19812000D+01
     .,0.38575940D+03,0.349D+03,0.238D+03,0.29353000D+01,0.19143000D+01
     .,0.37308750D+03,0.349D+03,0.239D+03,0.29353000D+01,0.28903000D+01
     .,0.37681730D+03,0.349D+03,0.240D+03,0.29353000D+01,0.39106000D+01
     .,0.36432260D+03,0.349D+03,0.241D+03,0.29353000D+01,0.29225000D+01
     .,0.32348820D+03,0.349D+03,0.242D+03,0.29353000D+01,0.11055600D+02
     .,0.28650850D+03,0.349D+03,0.243D+03,0.29353000D+01,0.95402000D+01
     .,0.27111330D+03,0.349D+03,0.244D+03,0.29353000D+01,0.88895000D+01
     .,0.27523510D+03,0.349D+03,0.245D+03,0.29353000D+01,0.29696000D+01
     .,0.28720260D+03,0.349D+03,0.246D+03,0.29353000D+01,0.57095000D+01
     .,0.36275140D+03,0.349D+03,0.249D+03,0.29353000D+01,0.19378000D+01
     .,0.39418070D+03,0.349D+03,0.250D+03,0.29353000D+01,0.19505000D+01
     .,0.37288760D+03,0.349D+03,0.251D+03,0.29353000D+01,0.19523000D+01
     .,0.36059670D+03,0.349D+03,0.252D+03,0.29353000D+01,0.19639000D+01
     ./)
      grimme_c6_parameters( 148101: 148200)=(/
     . 0.46716080D+03,0.349D+03,0.256D+03,0.29353000D+01,0.18467000D+01
     .,0.48537390D+03,0.349D+03,0.257D+03,0.29353000D+01,0.29175000D+01
     .,0.36148780D+03,0.349D+03,0.272D+03,0.29353000D+01,0.38840000D+01
     .,0.37694960D+03,0.349D+03,0.273D+03,0.29353000D+01,0.28988000D+01
     .,0.35152420D+03,0.349D+03,0.274D+03,0.29353000D+01,0.10915300D+02
     .,0.32026850D+03,0.349D+03,0.275D+03,0.29353000D+01,0.98054000D+01
     .,0.30203680D+03,0.349D+03,0.276D+03,0.29353000D+01,0.91527000D+01
     .,0.30706620D+03,0.349D+03,0.277D+03,0.29353000D+01,0.29424000D+01
     .,0.32283420D+03,0.349D+03,0.278D+03,0.29353000D+01,0.66669000D+01
     .,0.38866590D+03,0.349D+03,0.281D+03,0.29353000D+01,0.19302000D+01
     .,0.41079890D+03,0.349D+03,0.282D+03,0.29353000D+01,0.19356000D+01
     .,0.41930730D+03,0.349D+03,0.283D+03,0.29353000D+01,0.19655000D+01
     .,0.41680560D+03,0.349D+03,0.284D+03,0.29353000D+01,0.19639000D+01
     .,0.51446020D+03,0.349D+03,0.288D+03,0.29353000D+01,0.18075000D+01
     .,0.98223500D+02,0.349D+03,0.305D+03,0.29353000D+01,0.29128000D+01
     .,0.88657200D+02,0.349D+03,0.306D+03,0.29353000D+01,0.29987000D+01
     .,0.67270400D+02,0.349D+03,0.307D+03,0.29353000D+01,0.29903000D+01
     .,0.21743180D+03,0.349D+03,0.313D+03,0.29353000D+01,0.29146000D+01
     .,0.25998580D+03,0.349D+03,0.314D+03,0.29353000D+01,0.29407000D+01
     .,0.21672230D+03,0.349D+03,0.315D+03,0.29353000D+01,0.29859000D+01
     ./)
      grimme_c6_parameters( 148201: 148300)=(/
     . 0.19153170D+03,0.349D+03,0.327D+03,0.29353000D+01,0.77785000D+01
     .,0.20921040D+03,0.349D+03,0.328D+03,0.29353000D+01,0.62918000D+01
     .,0.23116180D+03,0.349D+03,0.331D+03,0.29353000D+01,0.29233000D+01
     .,0.26679440D+03,0.349D+03,0.332D+03,0.29353000D+01,0.29186000D+01
     .,0.26367810D+03,0.349D+03,0.333D+03,0.29353000D+01,0.29709000D+01
     .,0.31083150D+03,0.349D+03,0.349D+03,0.29353000D+01,0.29353000D+01
     .,0.34550300D+02,0.350D+03,0.100D+01,0.29259000D+01,0.91180000D+00
     .,0.22887500D+02,0.350D+03,0.200D+01,0.29259000D+01,0.00000000D+00
     .,0.52718510D+03,0.350D+03,0.300D+01,0.29259000D+01,0.00000000D+00
     .,0.30788140D+03,0.350D+03,0.400D+01,0.29259000D+01,0.00000000D+00
     .,0.20823790D+03,0.350D+03,0.500D+01,0.29259000D+01,0.00000000D+00
     .,0.14104070D+03,0.350D+03,0.600D+01,0.29259000D+01,0.00000000D+00
     .,0.98802500D+02,0.350D+03,0.700D+01,0.29259000D+01,0.00000000D+00
     .,0.74902900D+02,0.350D+03,0.800D+01,0.29259000D+01,0.00000000D+00
     .,0.56815100D+02,0.350D+03,0.900D+01,0.29259000D+01,0.00000000D+00
     .,0.43755600D+02,0.350D+03,0.100D+02,0.29259000D+01,0.00000000D+00
     .,0.63086870D+03,0.350D+03,0.110D+02,0.29259000D+01,0.00000000D+00
     .,0.48975320D+03,0.350D+03,0.120D+02,0.29259000D+01,0.00000000D+00
     .,0.45261920D+03,0.350D+03,0.130D+02,0.29259000D+01,0.00000000D+00
     .,0.35774280D+03,0.350D+03,0.140D+02,0.29259000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 148301: 148400)=(/
     . 0.27953920D+03,0.350D+03,0.150D+02,0.29259000D+01,0.00000000D+00
     .,0.23224340D+03,0.350D+03,0.160D+02,0.29259000D+01,0.00000000D+00
     .,0.18988240D+03,0.350D+03,0.170D+02,0.29259000D+01,0.00000000D+00
     .,0.15546270D+03,0.350D+03,0.180D+02,0.29259000D+01,0.00000000D+00
     .,0.10315350D+04,0.350D+03,0.190D+02,0.29259000D+01,0.00000000D+00
     .,0.85745370D+03,0.350D+03,0.200D+02,0.29259000D+01,0.00000000D+00
     .,0.70944180D+03,0.350D+03,0.210D+02,0.29259000D+01,0.00000000D+00
     .,0.68588510D+03,0.350D+03,0.220D+02,0.29259000D+01,0.00000000D+00
     .,0.62854190D+03,0.350D+03,0.230D+02,0.29259000D+01,0.00000000D+00
     .,0.49509360D+03,0.350D+03,0.240D+02,0.29259000D+01,0.00000000D+00
     .,0.54171840D+03,0.350D+03,0.250D+02,0.29259000D+01,0.00000000D+00
     .,0.42519040D+03,0.350D+03,0.260D+02,0.29259000D+01,0.00000000D+00
     .,0.45143600D+03,0.350D+03,0.270D+02,0.29259000D+01,0.00000000D+00
     .,0.46473810D+03,0.350D+03,0.280D+02,0.29259000D+01,0.00000000D+00
     .,0.35624130D+03,0.350D+03,0.290D+02,0.29259000D+01,0.00000000D+00
     .,0.36657850D+03,0.350D+03,0.300D+02,0.29259000D+01,0.00000000D+00
     .,0.43386350D+03,0.350D+03,0.310D+02,0.29259000D+01,0.00000000D+00
     .,0.38351890D+03,0.350D+03,0.320D+02,0.29259000D+01,0.00000000D+00
     .,0.32767900D+03,0.350D+03,0.330D+02,0.29259000D+01,0.00000000D+00
     .,0.29427420D+03,0.350D+03,0.340D+02,0.29259000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 148401: 148500)=(/
     . 0.25771960D+03,0.350D+03,0.350D+02,0.29259000D+01,0.00000000D+00
     .,0.22426550D+03,0.350D+03,0.360D+02,0.29259000D+01,0.00000000D+00
     .,0.11566447D+04,0.350D+03,0.370D+02,0.29259000D+01,0.00000000D+00
     .,0.10211992D+04,0.350D+03,0.380D+02,0.29259000D+01,0.00000000D+00
     .,0.89668220D+03,0.350D+03,0.390D+02,0.29259000D+01,0.00000000D+00
     .,0.80699680D+03,0.350D+03,0.400D+02,0.29259000D+01,0.00000000D+00
     .,0.73648020D+03,0.350D+03,0.410D+02,0.29259000D+01,0.00000000D+00
     .,0.56927660D+03,0.350D+03,0.420D+02,0.29259000D+01,0.00000000D+00
     .,0.63492090D+03,0.350D+03,0.430D+02,0.29259000D+01,0.00000000D+00
     .,0.48434860D+03,0.350D+03,0.440D+02,0.29259000D+01,0.00000000D+00
     .,0.52953710D+03,0.350D+03,0.450D+02,0.29259000D+01,0.00000000D+00
     .,0.49130410D+03,0.350D+03,0.460D+02,0.29259000D+01,0.00000000D+00
     .,0.40943180D+03,0.350D+03,0.470D+02,0.29259000D+01,0.00000000D+00
     .,0.43319920D+03,0.350D+03,0.480D+02,0.29259000D+01,0.00000000D+00
     .,0.54284130D+03,0.350D+03,0.490D+02,0.29259000D+01,0.00000000D+00
     .,0.50298910D+03,0.350D+03,0.500D+02,0.29259000D+01,0.00000000D+00
     .,0.44897690D+03,0.350D+03,0.510D+02,0.29259000D+01,0.00000000D+00
     .,0.41689450D+03,0.350D+03,0.520D+02,0.29259000D+01,0.00000000D+00
     .,0.37722550D+03,0.350D+03,0.530D+02,0.29259000D+01,0.00000000D+00
     .,0.33935050D+03,0.350D+03,0.540D+02,0.29259000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 148501: 148600)=(/
     . 0.14090375D+04,0.350D+03,0.550D+02,0.29259000D+01,0.00000000D+00
     .,0.13006349D+04,0.350D+03,0.560D+02,0.29259000D+01,0.00000000D+00
     .,0.11454236D+04,0.350D+03,0.570D+02,0.29259000D+01,0.00000000D+00
     .,0.53013690D+03,0.350D+03,0.580D+02,0.29259000D+01,0.27991000D+01
     .,0.11533721D+04,0.350D+03,0.590D+02,0.29259000D+01,0.00000000D+00
     .,0.11079903D+04,0.350D+03,0.600D+02,0.29259000D+01,0.00000000D+00
     .,0.10803308D+04,0.350D+03,0.610D+02,0.29259000D+01,0.00000000D+00
     .,0.10548803D+04,0.350D+03,0.620D+02,0.29259000D+01,0.00000000D+00
     .,0.10323159D+04,0.350D+03,0.630D+02,0.29259000D+01,0.00000000D+00
     .,0.81371020D+03,0.350D+03,0.640D+02,0.29259000D+01,0.00000000D+00
     .,0.91255420D+03,0.350D+03,0.650D+02,0.29259000D+01,0.00000000D+00
     .,0.88050980D+03,0.350D+03,0.660D+02,0.29259000D+01,0.00000000D+00
     .,0.93168500D+03,0.350D+03,0.670D+02,0.29259000D+01,0.00000000D+00
     .,0.91198360D+03,0.350D+03,0.680D+02,0.29259000D+01,0.00000000D+00
     .,0.89424260D+03,0.350D+03,0.690D+02,0.29259000D+01,0.00000000D+00
     .,0.88370520D+03,0.350D+03,0.700D+02,0.29259000D+01,0.00000000D+00
     .,0.74578300D+03,0.350D+03,0.710D+02,0.29259000D+01,0.00000000D+00
     .,0.73506570D+03,0.350D+03,0.720D+02,0.29259000D+01,0.00000000D+00
     .,0.67161750D+03,0.350D+03,0.730D+02,0.29259000D+01,0.00000000D+00
     .,0.56750780D+03,0.350D+03,0.740D+02,0.29259000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 148601: 148700)=(/
     . 0.57764320D+03,0.350D+03,0.750D+02,0.29259000D+01,0.00000000D+00
     .,0.52400420D+03,0.350D+03,0.760D+02,0.29259000D+01,0.00000000D+00
     .,0.48023510D+03,0.350D+03,0.770D+02,0.29259000D+01,0.00000000D+00
     .,0.39915430D+03,0.350D+03,0.780D+02,0.29259000D+01,0.00000000D+00
     .,0.37302900D+03,0.350D+03,0.790D+02,0.29259000D+01,0.00000000D+00
     .,0.38392690D+03,0.350D+03,0.800D+02,0.29259000D+01,0.00000000D+00
     .,0.55745160D+03,0.350D+03,0.810D+02,0.29259000D+01,0.00000000D+00
     .,0.54594690D+03,0.350D+03,0.820D+02,0.29259000D+01,0.00000000D+00
     .,0.50242860D+03,0.350D+03,0.830D+02,0.29259000D+01,0.00000000D+00
     .,0.47954670D+03,0.350D+03,0.840D+02,0.29259000D+01,0.00000000D+00
     .,0.44291920D+03,0.350D+03,0.850D+02,0.29259000D+01,0.00000000D+00
     .,0.40620580D+03,0.350D+03,0.860D+02,0.29259000D+01,0.00000000D+00
     .,0.13331000D+04,0.350D+03,0.870D+02,0.29259000D+01,0.00000000D+00
     .,0.12876457D+04,0.350D+03,0.880D+02,0.29259000D+01,0.00000000D+00
     .,0.11407848D+04,0.350D+03,0.890D+02,0.29259000D+01,0.00000000D+00
     .,0.10274883D+04,0.350D+03,0.900D+02,0.29259000D+01,0.00000000D+00
     .,0.10189158D+04,0.350D+03,0.910D+02,0.29259000D+01,0.00000000D+00
     .,0.98663370D+03,0.350D+03,0.920D+02,0.29259000D+01,0.00000000D+00
     .,0.10144405D+04,0.350D+03,0.930D+02,0.29259000D+01,0.00000000D+00
     .,0.98265960D+03,0.350D+03,0.940D+02,0.29259000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 148701: 148800)=(/
     . 0.55564300D+02,0.350D+03,0.101D+03,0.29259000D+01,0.00000000D+00
     .,0.17907060D+03,0.350D+03,0.103D+03,0.29259000D+01,0.98650000D+00
     .,0.22855840D+03,0.350D+03,0.104D+03,0.29259000D+01,0.98080000D+00
     .,0.17527450D+03,0.350D+03,0.105D+03,0.29259000D+01,0.97060000D+00
     .,0.13225620D+03,0.350D+03,0.106D+03,0.29259000D+01,0.98680000D+00
     .,0.92115400D+02,0.350D+03,0.107D+03,0.29259000D+01,0.99440000D+00
     .,0.67181100D+02,0.350D+03,0.108D+03,0.29259000D+01,0.99250000D+00
     .,0.46303000D+02,0.350D+03,0.109D+03,0.29259000D+01,0.99820000D+00
     .,0.26154000D+03,0.350D+03,0.111D+03,0.29259000D+01,0.96840000D+00
     .,0.40427630D+03,0.350D+03,0.112D+03,0.29259000D+01,0.96280000D+00
     .,0.41041760D+03,0.350D+03,0.113D+03,0.29259000D+01,0.96480000D+00
     .,0.33075310D+03,0.350D+03,0.114D+03,0.29259000D+01,0.95070000D+00
     .,0.27134880D+03,0.350D+03,0.115D+03,0.29259000D+01,0.99470000D+00
     .,0.22967560D+03,0.350D+03,0.116D+03,0.29259000D+01,0.99480000D+00
     .,0.18790960D+03,0.350D+03,0.117D+03,0.29259000D+01,0.99720000D+00
     .,0.36096750D+03,0.350D+03,0.119D+03,0.29259000D+01,0.97670000D+00
     .,0.68580030D+03,0.350D+03,0.120D+03,0.29259000D+01,0.98310000D+00
     .,0.36213940D+03,0.350D+03,0.121D+03,0.29259000D+01,0.18627000D+01
     .,0.34961060D+03,0.350D+03,0.122D+03,0.29259000D+01,0.18299000D+01
     .,0.34261200D+03,0.350D+03,0.123D+03,0.29259000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters( 148801: 148900)=(/
     . 0.33934490D+03,0.350D+03,0.124D+03,0.29259000D+01,0.18269000D+01
     .,0.31272950D+03,0.350D+03,0.125D+03,0.29259000D+01,0.16406000D+01
     .,0.28953010D+03,0.350D+03,0.126D+03,0.29259000D+01,0.16483000D+01
     .,0.27618840D+03,0.350D+03,0.127D+03,0.29259000D+01,0.17149000D+01
     .,0.26998570D+03,0.350D+03,0.128D+03,0.29259000D+01,0.17937000D+01
     .,0.26647580D+03,0.350D+03,0.129D+03,0.29259000D+01,0.95760000D+00
     .,0.25050770D+03,0.350D+03,0.130D+03,0.29259000D+01,0.19419000D+01
     .,0.40773530D+03,0.350D+03,0.131D+03,0.29259000D+01,0.96010000D+00
     .,0.35895200D+03,0.350D+03,0.132D+03,0.29259000D+01,0.94340000D+00
     .,0.32214500D+03,0.350D+03,0.133D+03,0.29259000D+01,0.98890000D+00
     .,0.29438040D+03,0.350D+03,0.134D+03,0.29259000D+01,0.99010000D+00
     .,0.25950110D+03,0.350D+03,0.135D+03,0.29259000D+01,0.99740000D+00
     .,0.43088110D+03,0.350D+03,0.137D+03,0.29259000D+01,0.97380000D+00
     .,0.83409790D+03,0.350D+03,0.138D+03,0.29259000D+01,0.98010000D+00
     .,0.64047400D+03,0.350D+03,0.139D+03,0.29259000D+01,0.19153000D+01
     .,0.47873550D+03,0.350D+03,0.140D+03,0.29259000D+01,0.19355000D+01
     .,0.48344780D+03,0.350D+03,0.141D+03,0.29259000D+01,0.19545000D+01
     .,0.45098400D+03,0.350D+03,0.142D+03,0.29259000D+01,0.19420000D+01
     .,0.50476500D+03,0.350D+03,0.143D+03,0.29259000D+01,0.16682000D+01
     .,0.39362700D+03,0.350D+03,0.144D+03,0.29259000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters( 148901: 149000)=(/
     . 0.36827100D+03,0.350D+03,0.145D+03,0.29259000D+01,0.19003000D+01
     .,0.34204040D+03,0.350D+03,0.146D+03,0.29259000D+01,0.18630000D+01
     .,0.33083540D+03,0.350D+03,0.147D+03,0.29259000D+01,0.96790000D+00
     .,0.32765190D+03,0.350D+03,0.148D+03,0.29259000D+01,0.19539000D+01
     .,0.51780290D+03,0.350D+03,0.149D+03,0.29259000D+01,0.96330000D+00
     .,0.46937510D+03,0.350D+03,0.150D+03,0.29259000D+01,0.95140000D+00
     .,0.44010850D+03,0.350D+03,0.151D+03,0.29259000D+01,0.97490000D+00
     .,0.41661070D+03,0.350D+03,0.152D+03,0.29259000D+01,0.98110000D+00
     .,0.38076150D+03,0.350D+03,0.153D+03,0.29259000D+01,0.99680000D+00
     .,0.51028570D+03,0.350D+03,0.155D+03,0.29259000D+01,0.99090000D+00
     .,0.10802049D+04,0.350D+03,0.156D+03,0.29259000D+01,0.97970000D+00
     .,0.81022120D+03,0.350D+03,0.157D+03,0.29259000D+01,0.19373000D+01
     .,0.51419410D+03,0.350D+03,0.159D+03,0.29259000D+01,0.29425000D+01
     .,0.50356860D+03,0.350D+03,0.160D+03,0.29259000D+01,0.29455000D+01
     .,0.48764360D+03,0.350D+03,0.161D+03,0.29259000D+01,0.29413000D+01
     .,0.48991040D+03,0.350D+03,0.162D+03,0.29259000D+01,0.29300000D+01
     .,0.47183730D+03,0.350D+03,0.163D+03,0.29259000D+01,0.18286000D+01
     .,0.49298820D+03,0.350D+03,0.164D+03,0.29259000D+01,0.28732000D+01
     .,0.46313550D+03,0.350D+03,0.165D+03,0.29259000D+01,0.29086000D+01
     .,0.47101170D+03,0.350D+03,0.166D+03,0.29259000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters( 149001: 149100)=(/
     . 0.43969410D+03,0.350D+03,0.167D+03,0.29259000D+01,0.29242000D+01
     .,0.42720060D+03,0.350D+03,0.168D+03,0.29259000D+01,0.29282000D+01
     .,0.42443580D+03,0.350D+03,0.169D+03,0.29259000D+01,0.29246000D+01
     .,0.44601630D+03,0.350D+03,0.170D+03,0.29259000D+01,0.28482000D+01
     .,0.41029850D+03,0.350D+03,0.171D+03,0.29259000D+01,0.29219000D+01
     .,0.55410220D+03,0.350D+03,0.172D+03,0.29259000D+01,0.19254000D+01
     .,0.51478350D+03,0.350D+03,0.173D+03,0.29259000D+01,0.19459000D+01
     .,0.47018380D+03,0.350D+03,0.174D+03,0.29259000D+01,0.19292000D+01
     .,0.47532640D+03,0.350D+03,0.175D+03,0.29259000D+01,0.18104000D+01
     .,0.41708260D+03,0.350D+03,0.176D+03,0.29259000D+01,0.18858000D+01
     .,0.39248360D+03,0.350D+03,0.177D+03,0.29259000D+01,0.18648000D+01
     .,0.37493960D+03,0.350D+03,0.178D+03,0.29259000D+01,0.19188000D+01
     .,0.35843860D+03,0.350D+03,0.179D+03,0.29259000D+01,0.98460000D+00
     .,0.34665580D+03,0.350D+03,0.180D+03,0.29259000D+01,0.19896000D+01
     .,0.55606680D+03,0.350D+03,0.181D+03,0.29259000D+01,0.92670000D+00
     .,0.50782080D+03,0.350D+03,0.182D+03,0.29259000D+01,0.93830000D+00
     .,0.49295080D+03,0.350D+03,0.183D+03,0.29259000D+01,0.98200000D+00
     .,0.47971720D+03,0.350D+03,0.184D+03,0.29259000D+01,0.98150000D+00
     .,0.44828660D+03,0.350D+03,0.185D+03,0.29259000D+01,0.99540000D+00
     .,0.57477940D+03,0.350D+03,0.187D+03,0.29259000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters( 149101: 149200)=(/
     . 0.10760744D+04,0.350D+03,0.188D+03,0.29259000D+01,0.96620000D+00
     .,0.60843480D+03,0.350D+03,0.189D+03,0.29259000D+01,0.29070000D+01
     .,0.70109350D+03,0.350D+03,0.190D+03,0.29259000D+01,0.28844000D+01
     .,0.62707340D+03,0.350D+03,0.191D+03,0.29259000D+01,0.28738000D+01
     .,0.55492490D+03,0.350D+03,0.192D+03,0.29259000D+01,0.28878000D+01
     .,0.53413870D+03,0.350D+03,0.193D+03,0.29259000D+01,0.29095000D+01
     .,0.64033600D+03,0.350D+03,0.194D+03,0.29259000D+01,0.19209000D+01
     .,0.14976800D+03,0.350D+03,0.204D+03,0.29259000D+01,0.19697000D+01
     .,0.14723850D+03,0.350D+03,0.205D+03,0.29259000D+01,0.19441000D+01
     .,0.10796360D+03,0.350D+03,0.206D+03,0.29259000D+01,0.19985000D+01
     .,0.86517400D+02,0.350D+03,0.207D+03,0.29259000D+01,0.20143000D+01
     .,0.59302900D+02,0.350D+03,0.208D+03,0.29259000D+01,0.19887000D+01
     .,0.26525750D+03,0.350D+03,0.212D+03,0.29259000D+01,0.19496000D+01
     .,0.32039240D+03,0.350D+03,0.213D+03,0.29259000D+01,0.19311000D+01
     .,0.30775700D+03,0.350D+03,0.214D+03,0.29259000D+01,0.19435000D+01
     .,0.26762990D+03,0.350D+03,0.215D+03,0.29259000D+01,0.20102000D+01
     .,0.22503380D+03,0.350D+03,0.216D+03,0.29259000D+01,0.19903000D+01
     .,0.37171230D+03,0.350D+03,0.220D+03,0.29259000D+01,0.19349000D+01
     .,0.35761290D+03,0.350D+03,0.221D+03,0.29259000D+01,0.28999000D+01
     .,0.36204400D+03,0.350D+03,0.222D+03,0.29259000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters( 149201: 149300)=(/
     . 0.33130930D+03,0.350D+03,0.223D+03,0.29259000D+01,0.29110000D+01
     .,0.24989390D+03,0.350D+03,0.224D+03,0.29259000D+01,0.10619100D+02
     .,0.21401180D+03,0.350D+03,0.225D+03,0.29259000D+01,0.98849000D+01
     .,0.21006230D+03,0.350D+03,0.226D+03,0.29259000D+01,0.91376000D+01
     .,0.24593880D+03,0.350D+03,0.227D+03,0.29259000D+01,0.29263000D+01
     .,0.22923870D+03,0.350D+03,0.228D+03,0.29259000D+01,0.65458000D+01
     .,0.32367220D+03,0.350D+03,0.231D+03,0.29259000D+01,0.19315000D+01
     .,0.34184070D+03,0.350D+03,0.232D+03,0.29259000D+01,0.19447000D+01
     .,0.31373420D+03,0.350D+03,0.233D+03,0.29259000D+01,0.19793000D+01
     .,0.29207370D+03,0.350D+03,0.234D+03,0.29259000D+01,0.19812000D+01
     .,0.44529880D+03,0.350D+03,0.238D+03,0.29259000D+01,0.19143000D+01
     .,0.42922790D+03,0.350D+03,0.239D+03,0.29259000D+01,0.28903000D+01
     .,0.43306580D+03,0.350D+03,0.240D+03,0.29259000D+01,0.39106000D+01
     .,0.41869180D+03,0.350D+03,0.241D+03,0.29259000D+01,0.29225000D+01
     .,0.37051430D+03,0.350D+03,0.242D+03,0.29259000D+01,0.11055600D+02
     .,0.32726370D+03,0.350D+03,0.243D+03,0.29259000D+01,0.95402000D+01
     .,0.30934100D+03,0.350D+03,0.244D+03,0.29259000D+01,0.88895000D+01
     .,0.31485220D+03,0.350D+03,0.245D+03,0.29259000D+01,0.29696000D+01
     .,0.32886980D+03,0.350D+03,0.246D+03,0.29259000D+01,0.57095000D+01
     .,0.41760930D+03,0.350D+03,0.249D+03,0.29259000D+01,0.19378000D+01
     ./)
      grimme_c6_parameters( 149301: 149400)=(/
     . 0.45391950D+03,0.350D+03,0.250D+03,0.29259000D+01,0.19505000D+01
     .,0.42812220D+03,0.350D+03,0.251D+03,0.29259000D+01,0.19523000D+01
     .,0.41326530D+03,0.350D+03,0.252D+03,0.29259000D+01,0.19639000D+01
     .,0.53867350D+03,0.350D+03,0.256D+03,0.29259000D+01,0.18467000D+01
     .,0.55884130D+03,0.350D+03,0.257D+03,0.29259000D+01,0.29175000D+01
     .,0.41480660D+03,0.350D+03,0.272D+03,0.29259000D+01,0.38840000D+01
     .,0.43299810D+03,0.350D+03,0.273D+03,0.29259000D+01,0.28988000D+01
     .,0.40255440D+03,0.350D+03,0.274D+03,0.29259000D+01,0.10915300D+02
     .,0.36584940D+03,0.350D+03,0.275D+03,0.29259000D+01,0.98054000D+01
     .,0.34433760D+03,0.350D+03,0.276D+03,0.29259000D+01,0.91527000D+01
     .,0.35080960D+03,0.350D+03,0.277D+03,0.29259000D+01,0.29424000D+01
     .,0.36898910D+03,0.350D+03,0.278D+03,0.29259000D+01,0.66669000D+01
     .,0.44636650D+03,0.350D+03,0.281D+03,0.29259000D+01,0.19302000D+01
     .,0.47183450D+03,0.350D+03,0.282D+03,0.29259000D+01,0.19356000D+01
     .,0.48114100D+03,0.350D+03,0.283D+03,0.29259000D+01,0.19655000D+01
     .,0.47772640D+03,0.350D+03,0.284D+03,0.29259000D+01,0.19639000D+01
     .,0.59304720D+03,0.350D+03,0.288D+03,0.29259000D+01,0.18075000D+01
     .,0.11213310D+03,0.350D+03,0.305D+03,0.29259000D+01,0.29128000D+01
     .,0.10101310D+03,0.350D+03,0.306D+03,0.29259000D+01,0.29987000D+01
     .,0.76210000D+02,0.350D+03,0.307D+03,0.29259000D+01,0.29903000D+01
     ./)
      grimme_c6_parameters( 149401: 149500)=(/
     . 0.25014210D+03,0.350D+03,0.313D+03,0.29259000D+01,0.29146000D+01
     .,0.29982180D+03,0.350D+03,0.314D+03,0.29259000D+01,0.29407000D+01
     .,0.24837820D+03,0.350D+03,0.315D+03,0.29259000D+01,0.29859000D+01
     .,0.21915410D+03,0.350D+03,0.327D+03,0.29259000D+01,0.77785000D+01
     .,0.24046050D+03,0.350D+03,0.328D+03,0.29259000D+01,0.62918000D+01
     .,0.26525500D+03,0.350D+03,0.331D+03,0.29259000D+01,0.29233000D+01
     .,0.30652410D+03,0.350D+03,0.332D+03,0.29259000D+01,0.29186000D+01
     .,0.30226660D+03,0.350D+03,0.333D+03,0.29259000D+01,0.29709000D+01
     .,0.35623590D+03,0.350D+03,0.349D+03,0.29259000D+01,0.29353000D+01
     .,0.40914530D+03,0.350D+03,0.350D+03,0.29259000D+01,0.29259000D+01
     .,0.35093900D+02,0.351D+03,0.100D+01,0.29315000D+01,0.91180000D+00
     .,0.23379200D+02,0.351D+03,0.200D+01,0.29315000D+01,0.00000000D+00
     .,0.51864270D+03,0.351D+03,0.300D+01,0.29315000D+01,0.00000000D+00
     .,0.30744210D+03,0.351D+03,0.400D+01,0.29315000D+01,0.00000000D+00
     .,0.20967450D+03,0.351D+03,0.500D+01,0.29315000D+01,0.00000000D+00
     .,0.14283480D+03,0.351D+03,0.600D+01,0.29315000D+01,0.00000000D+00
     .,0.10045000D+03,0.351D+03,0.700D+01,0.29315000D+01,0.00000000D+00
     .,0.76342400D+02,0.351D+03,0.800D+01,0.29315000D+01,0.00000000D+00
     .,0.58017600D+02,0.351D+03,0.900D+01,0.29315000D+01,0.00000000D+00
     .,0.44740800D+02,0.351D+03,0.100D+02,0.29315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 149501: 149600)=(/
     . 0.62119430D+03,0.351D+03,0.110D+02,0.29315000D+01,0.00000000D+00
     .,0.48774180D+03,0.351D+03,0.120D+02,0.29315000D+01,0.00000000D+00
     .,0.45276050D+03,0.351D+03,0.130D+02,0.29315000D+01,0.00000000D+00
     .,0.35991590D+03,0.351D+03,0.140D+02,0.29315000D+01,0.00000000D+00
     .,0.28255640D+03,0.351D+03,0.150D+02,0.29315000D+01,0.00000000D+00
     .,0.23542680D+03,0.351D+03,0.160D+02,0.29315000D+01,0.00000000D+00
     .,0.19298930D+03,0.351D+03,0.170D+02,0.29315000D+01,0.00000000D+00
     .,0.15834200D+03,0.351D+03,0.180D+02,0.29315000D+01,0.00000000D+00
     .,0.10138323D+04,0.351D+03,0.190D+02,0.29315000D+01,0.00000000D+00
     .,0.85006180D+03,0.351D+03,0.200D+02,0.29315000D+01,0.00000000D+00
     .,0.70472450D+03,0.351D+03,0.210D+02,0.29315000D+01,0.00000000D+00
     .,0.68261700D+03,0.351D+03,0.220D+02,0.29315000D+01,0.00000000D+00
     .,0.62623920D+03,0.351D+03,0.230D+02,0.29315000D+01,0.00000000D+00
     .,0.49343100D+03,0.351D+03,0.240D+02,0.29315000D+01,0.00000000D+00
     .,0.54059460D+03,0.351D+03,0.250D+02,0.29315000D+01,0.00000000D+00
     .,0.42451240D+03,0.351D+03,0.260D+02,0.29315000D+01,0.00000000D+00
     .,0.45168930D+03,0.351D+03,0.270D+02,0.29315000D+01,0.00000000D+00
     .,0.46446650D+03,0.351D+03,0.280D+02,0.29315000D+01,0.00000000D+00
     .,0.35610950D+03,0.351D+03,0.290D+02,0.29315000D+01,0.00000000D+00
     .,0.36766370D+03,0.351D+03,0.300D+02,0.29315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 149601: 149700)=(/
     . 0.43474170D+03,0.351D+03,0.310D+02,0.29315000D+01,0.00000000D+00
     .,0.38597850D+03,0.351D+03,0.320D+02,0.29315000D+01,0.00000000D+00
     .,0.33106180D+03,0.351D+03,0.330D+02,0.29315000D+01,0.00000000D+00
     .,0.29800720D+03,0.351D+03,0.340D+02,0.29315000D+01,0.00000000D+00
     .,0.26158890D+03,0.351D+03,0.350D+02,0.29315000D+01,0.00000000D+00
     .,0.22809040D+03,0.351D+03,0.360D+02,0.29315000D+01,0.00000000D+00
     .,0.11378099D+04,0.351D+03,0.370D+02,0.29315000D+01,0.00000000D+00
     .,0.10121518D+04,0.351D+03,0.380D+02,0.29315000D+01,0.00000000D+00
     .,0.89191400D+03,0.351D+03,0.390D+02,0.29315000D+01,0.00000000D+00
     .,0.80449370D+03,0.351D+03,0.400D+02,0.29315000D+01,0.00000000D+00
     .,0.73528120D+03,0.351D+03,0.410D+02,0.29315000D+01,0.00000000D+00
     .,0.56979780D+03,0.351D+03,0.420D+02,0.29315000D+01,0.00000000D+00
     .,0.63489910D+03,0.351D+03,0.430D+02,0.29315000D+01,0.00000000D+00
     .,0.48565920D+03,0.351D+03,0.440D+02,0.29315000D+01,0.00000000D+00
     .,0.53091130D+03,0.351D+03,0.450D+02,0.29315000D+01,0.00000000D+00
     .,0.49300840D+03,0.351D+03,0.460D+02,0.29315000D+01,0.00000000D+00
     .,0.41066850D+03,0.351D+03,0.470D+02,0.29315000D+01,0.00000000D+00
     .,0.43517770D+03,0.351D+03,0.480D+02,0.29315000D+01,0.00000000D+00
     .,0.54381980D+03,0.351D+03,0.490D+02,0.29315000D+01,0.00000000D+00
     .,0.50566970D+03,0.351D+03,0.500D+02,0.29315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 149701: 149800)=(/
     . 0.45291870D+03,0.351D+03,0.510D+02,0.29315000D+01,0.00000000D+00
     .,0.42141870D+03,0.351D+03,0.520D+02,0.29315000D+01,0.00000000D+00
     .,0.38213760D+03,0.351D+03,0.530D+02,0.29315000D+01,0.00000000D+00
     .,0.34444580D+03,0.351D+03,0.540D+02,0.29315000D+01,0.00000000D+00
     .,0.13865806D+04,0.351D+03,0.550D+02,0.29315000D+01,0.00000000D+00
     .,0.12877738D+04,0.351D+03,0.560D+02,0.29315000D+01,0.00000000D+00
     .,0.11381053D+04,0.351D+03,0.570D+02,0.29315000D+01,0.00000000D+00
     .,0.53448010D+03,0.351D+03,0.580D+02,0.29315000D+01,0.27991000D+01
     .,0.11432636D+04,0.351D+03,0.590D+02,0.29315000D+01,0.00000000D+00
     .,0.10988818D+04,0.351D+03,0.600D+02,0.29315000D+01,0.00000000D+00
     .,0.10716137D+04,0.351D+03,0.610D+02,0.29315000D+01,0.00000000D+00
     .,0.10465046D+04,0.351D+03,0.620D+02,0.29315000D+01,0.00000000D+00
     .,0.10242500D+04,0.351D+03,0.630D+02,0.29315000D+01,0.00000000D+00
     .,0.81059520D+03,0.351D+03,0.640D+02,0.29315000D+01,0.00000000D+00
     .,0.90407560D+03,0.351D+03,0.650D+02,0.29315000D+01,0.00000000D+00
     .,0.87295200D+03,0.351D+03,0.660D+02,0.29315000D+01,0.00000000D+00
     .,0.92519070D+03,0.351D+03,0.670D+02,0.29315000D+01,0.00000000D+00
     .,0.90570520D+03,0.351D+03,0.680D+02,0.29315000D+01,0.00000000D+00
     .,0.88820360D+03,0.351D+03,0.690D+02,0.29315000D+01,0.00000000D+00
     .,0.87758750D+03,0.351D+03,0.700D+02,0.29315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 149801: 149900)=(/
     . 0.74266050D+03,0.351D+03,0.710D+02,0.29315000D+01,0.00000000D+00
     .,0.73464070D+03,0.351D+03,0.720D+02,0.29315000D+01,0.00000000D+00
     .,0.67268970D+03,0.351D+03,0.730D+02,0.29315000D+01,0.00000000D+00
     .,0.56941570D+03,0.351D+03,0.740D+02,0.29315000D+01,0.00000000D+00
     .,0.58004130D+03,0.351D+03,0.750D+02,0.29315000D+01,0.00000000D+00
     .,0.52713410D+03,0.351D+03,0.760D+02,0.29315000D+01,0.00000000D+00
     .,0.48380280D+03,0.351D+03,0.770D+02,0.29315000D+01,0.00000000D+00
     .,0.40272830D+03,0.351D+03,0.780D+02,0.29315000D+01,0.00000000D+00
     .,0.37658500D+03,0.351D+03,0.790D+02,0.29315000D+01,0.00000000D+00
     .,0.38784150D+03,0.351D+03,0.800D+02,0.29315000D+01,0.00000000D+00
     .,0.55900180D+03,0.351D+03,0.810D+02,0.29315000D+01,0.00000000D+00
     .,0.54891370D+03,0.351D+03,0.820D+02,0.29315000D+01,0.00000000D+00
     .,0.50669310D+03,0.351D+03,0.830D+02,0.29315000D+01,0.00000000D+00
     .,0.48446800D+03,0.351D+03,0.840D+02,0.29315000D+01,0.00000000D+00
     .,0.44838730D+03,0.351D+03,0.850D+02,0.29315000D+01,0.00000000D+00
     .,0.41197350D+03,0.351D+03,0.860D+02,0.29315000D+01,0.00000000D+00
     .,0.13155898D+04,0.351D+03,0.870D+02,0.29315000D+01,0.00000000D+00
     .,0.12773025D+04,0.351D+03,0.880D+02,0.29315000D+01,0.00000000D+00
     .,0.11352332D+04,0.351D+03,0.890D+02,0.29315000D+01,0.00000000D+00
     .,0.10262943D+04,0.351D+03,0.900D+02,0.29315000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 149901: 150000)=(/
     . 0.10158964D+04,0.351D+03,0.910D+02,0.29315000D+01,0.00000000D+00
     .,0.98378580D+03,0.351D+03,0.920D+02,0.29315000D+01,0.00000000D+00
     .,0.10091230D+04,0.351D+03,0.930D+02,0.29315000D+01,0.00000000D+00
     .,0.97791270D+03,0.351D+03,0.940D+02,0.29315000D+01,0.00000000D+00
     .,0.56194600D+02,0.351D+03,0.101D+03,0.29315000D+01,0.00000000D+00
     .,0.17902740D+03,0.351D+03,0.103D+03,0.29315000D+01,0.98650000D+00
     .,0.22888940D+03,0.351D+03,0.104D+03,0.29315000D+01,0.98080000D+00
     .,0.17677430D+03,0.351D+03,0.105D+03,0.29315000D+01,0.97060000D+00
     .,0.13392400D+03,0.351D+03,0.106D+03,0.29315000D+01,0.98680000D+00
     .,0.93656200D+02,0.351D+03,0.107D+03,0.29315000D+01,0.99440000D+00
     .,0.68514100D+02,0.351D+03,0.108D+03,0.29315000D+01,0.99250000D+00
     .,0.47383500D+02,0.351D+03,0.109D+03,0.29315000D+01,0.99820000D+00
     .,0.26106680D+03,0.351D+03,0.111D+03,0.29315000D+01,0.96840000D+00
     .,0.40330920D+03,0.351D+03,0.112D+03,0.29315000D+01,0.96280000D+00
     .,0.41097880D+03,0.351D+03,0.113D+03,0.29315000D+01,0.96480000D+00
     .,0.33303840D+03,0.351D+03,0.114D+03,0.29315000D+01,0.95070000D+00
     .,0.27432020D+03,0.351D+03,0.115D+03,0.29315000D+01,0.99470000D+00
     .,0.23280570D+03,0.351D+03,0.116D+03,0.29315000D+01,0.99480000D+00
     .,0.19097240D+03,0.351D+03,0.117D+03,0.29315000D+01,0.99720000D+00
     .,0.36149280D+03,0.351D+03,0.119D+03,0.29315000D+01,0.97670000D+00
     ./)
      grimme_c6_parameters( 150001: 150100)=(/
     . 0.68031840D+03,0.351D+03,0.120D+03,0.29315000D+01,0.98310000D+00
     .,0.36424560D+03,0.351D+03,0.121D+03,0.29315000D+01,0.18627000D+01
     .,0.35170890D+03,0.351D+03,0.122D+03,0.29315000D+01,0.18299000D+01
     .,0.34463160D+03,0.351D+03,0.123D+03,0.29315000D+01,0.19138000D+01
     .,0.34115480D+03,0.351D+03,0.124D+03,0.29315000D+01,0.18269000D+01
     .,0.31519770D+03,0.351D+03,0.125D+03,0.29315000D+01,0.16406000D+01
     .,0.29203450D+03,0.351D+03,0.126D+03,0.29315000D+01,0.16483000D+01
     .,0.27857600D+03,0.351D+03,0.127D+03,0.29315000D+01,0.17149000D+01
     .,0.27225780D+03,0.351D+03,0.128D+03,0.29315000D+01,0.17937000D+01
     .,0.26817480D+03,0.351D+03,0.129D+03,0.29315000D+01,0.95760000D+00
     .,0.25301490D+03,0.351D+03,0.130D+03,0.29315000D+01,0.19419000D+01
     .,0.40901750D+03,0.351D+03,0.131D+03,0.29315000D+01,0.96010000D+00
     .,0.36162180D+03,0.351D+03,0.132D+03,0.29315000D+01,0.94340000D+00
     .,0.32554390D+03,0.351D+03,0.133D+03,0.29315000D+01,0.98890000D+00
     .,0.29810330D+03,0.351D+03,0.134D+03,0.29315000D+01,0.99010000D+00
     .,0.26336490D+03,0.351D+03,0.135D+03,0.29315000D+01,0.99740000D+00
     .,0.43194800D+03,0.351D+03,0.137D+03,0.29315000D+01,0.97380000D+00
     .,0.82711060D+03,0.351D+03,0.138D+03,0.29315000D+01,0.98010000D+00
     .,0.63960320D+03,0.351D+03,0.139D+03,0.29315000D+01,0.19153000D+01
     .,0.48140710D+03,0.351D+03,0.140D+03,0.29315000D+01,0.19355000D+01
     ./)
      grimme_c6_parameters( 150101: 150200)=(/
     . 0.48607860D+03,0.351D+03,0.141D+03,0.29315000D+01,0.19545000D+01
     .,0.45385780D+03,0.351D+03,0.142D+03,0.29315000D+01,0.19420000D+01
     .,0.50629760D+03,0.351D+03,0.143D+03,0.29315000D+01,0.16682000D+01
     .,0.39707420D+03,0.351D+03,0.144D+03,0.29315000D+01,0.18584000D+01
     .,0.37157400D+03,0.351D+03,0.145D+03,0.29315000D+01,0.19003000D+01
     .,0.34525330D+03,0.351D+03,0.146D+03,0.29315000D+01,0.18630000D+01
     .,0.33380120D+03,0.351D+03,0.147D+03,0.29315000D+01,0.96790000D+00
     .,0.33121190D+03,0.351D+03,0.148D+03,0.29315000D+01,0.19539000D+01
     .,0.51938200D+03,0.351D+03,0.149D+03,0.29315000D+01,0.96330000D+00
     .,0.47251890D+03,0.351D+03,0.150D+03,0.29315000D+01,0.95140000D+00
     .,0.44417700D+03,0.351D+03,0.151D+03,0.29315000D+01,0.97490000D+00
     .,0.42118710D+03,0.351D+03,0.152D+03,0.29315000D+01,0.98110000D+00
     .,0.38570840D+03,0.351D+03,0.153D+03,0.29315000D+01,0.99680000D+00
     .,0.51302910D+03,0.351D+03,0.155D+03,0.29315000D+01,0.99090000D+00
     .,0.10697955D+04,0.351D+03,0.156D+03,0.29315000D+01,0.97970000D+00
     .,0.80869310D+03,0.351D+03,0.157D+03,0.29315000D+01,0.19373000D+01
     .,0.51850620D+03,0.351D+03,0.159D+03,0.29315000D+01,0.29425000D+01
     .,0.50780630D+03,0.351D+03,0.160D+03,0.29315000D+01,0.29455000D+01
     .,0.49182970D+03,0.351D+03,0.161D+03,0.29315000D+01,0.29413000D+01
     .,0.49386870D+03,0.351D+03,0.162D+03,0.29315000D+01,0.29300000D+01
     ./)
      grimme_c6_parameters( 150201: 150300)=(/
     . 0.47482940D+03,0.351D+03,0.163D+03,0.29315000D+01,0.18286000D+01
     .,0.49689070D+03,0.351D+03,0.164D+03,0.29315000D+01,0.28732000D+01
     .,0.46699360D+03,0.351D+03,0.165D+03,0.29315000D+01,0.29086000D+01
     .,0.47450580D+03,0.351D+03,0.166D+03,0.29315000D+01,0.28965000D+01
     .,0.44355070D+03,0.351D+03,0.167D+03,0.29315000D+01,0.29242000D+01
     .,0.43101790D+03,0.351D+03,0.168D+03,0.29315000D+01,0.29282000D+01
     .,0.42817260D+03,0.351D+03,0.169D+03,0.29315000D+01,0.29246000D+01
     .,0.44962020D+03,0.351D+03,0.170D+03,0.29315000D+01,0.28482000D+01
     .,0.41401670D+03,0.351D+03,0.171D+03,0.29315000D+01,0.29219000D+01
     .,0.55586120D+03,0.351D+03,0.172D+03,0.29315000D+01,0.19254000D+01
     .,0.51747490D+03,0.351D+03,0.173D+03,0.29315000D+01,0.19459000D+01
     .,0.47362850D+03,0.351D+03,0.174D+03,0.29315000D+01,0.19292000D+01
     .,0.47790620D+03,0.351D+03,0.175D+03,0.29315000D+01,0.18104000D+01
     .,0.42136930D+03,0.351D+03,0.176D+03,0.29315000D+01,0.18858000D+01
     .,0.39678090D+03,0.351D+03,0.177D+03,0.29315000D+01,0.18648000D+01
     .,0.37918850D+03,0.351D+03,0.178D+03,0.29315000D+01,0.19188000D+01
     .,0.36245620D+03,0.351D+03,0.179D+03,0.29315000D+01,0.98460000D+00
     .,0.35113700D+03,0.351D+03,0.180D+03,0.29315000D+01,0.19896000D+01
     .,0.55815810D+03,0.351D+03,0.181D+03,0.29315000D+01,0.92670000D+00
     .,0.51151250D+03,0.351D+03,0.182D+03,0.29315000D+01,0.93830000D+00
     ./)
      grimme_c6_parameters( 150301: 150400)=(/
     . 0.49747420D+03,0.351D+03,0.183D+03,0.29315000D+01,0.98200000D+00
     .,0.48477400D+03,0.351D+03,0.184D+03,0.29315000D+01,0.98150000D+00
     .,0.45383680D+03,0.351D+03,0.185D+03,0.29315000D+01,0.99540000D+00
     .,0.57800010D+03,0.351D+03,0.187D+03,0.29315000D+01,0.97050000D+00
     .,0.10681281D+04,0.351D+03,0.188D+03,0.29315000D+01,0.96620000D+00
     .,0.61348930D+03,0.351D+03,0.189D+03,0.29315000D+01,0.29070000D+01
     .,0.70481290D+03,0.351D+03,0.190D+03,0.29315000D+01,0.28844000D+01
     .,0.63107130D+03,0.351D+03,0.191D+03,0.29315000D+01,0.28738000D+01
     .,0.55973100D+03,0.351D+03,0.192D+03,0.29315000D+01,0.28878000D+01
     .,0.53903440D+03,0.351D+03,0.193D+03,0.29315000D+01,0.29095000D+01
     .,0.64211740D+03,0.351D+03,0.194D+03,0.29315000D+01,0.19209000D+01
     .,0.15112150D+03,0.351D+03,0.204D+03,0.29315000D+01,0.19697000D+01
     .,0.14873950D+03,0.351D+03,0.205D+03,0.29315000D+01,0.19441000D+01
     .,0.10957100D+03,0.351D+03,0.206D+03,0.29315000D+01,0.19985000D+01
     .,0.87995800D+02,0.351D+03,0.207D+03,0.29315000D+01,0.20143000D+01
     .,0.60520900D+02,0.351D+03,0.208D+03,0.29315000D+01,0.19887000D+01
     .,0.26667450D+03,0.351D+03,0.212D+03,0.29315000D+01,0.19496000D+01
     .,0.32197480D+03,0.351D+03,0.213D+03,0.29315000D+01,0.19311000D+01
     .,0.31012840D+03,0.351D+03,0.214D+03,0.29315000D+01,0.19435000D+01
     .,0.27048000D+03,0.351D+03,0.215D+03,0.29315000D+01,0.20102000D+01
     ./)
      grimme_c6_parameters( 150401: 150500)=(/
     . 0.22811080D+03,0.351D+03,0.216D+03,0.29315000D+01,0.19903000D+01
     .,0.37364230D+03,0.351D+03,0.220D+03,0.29315000D+01,0.19349000D+01
     .,0.36026270D+03,0.351D+03,0.221D+03,0.29315000D+01,0.28999000D+01
     .,0.36478380D+03,0.351D+03,0.222D+03,0.29315000D+01,0.38675000D+01
     .,0.33375970D+03,0.351D+03,0.223D+03,0.29315000D+01,0.29110000D+01
     .,0.25258170D+03,0.351D+03,0.224D+03,0.29315000D+01,0.10619100D+02
     .,0.21675670D+03,0.351D+03,0.225D+03,0.29315000D+01,0.98849000D+01
     .,0.21269690D+03,0.351D+03,0.226D+03,0.29315000D+01,0.91376000D+01
     .,0.24819240D+03,0.351D+03,0.227D+03,0.29315000D+01,0.29263000D+01
     .,0.23156140D+03,0.351D+03,0.228D+03,0.29315000D+01,0.65458000D+01
     .,0.32593780D+03,0.351D+03,0.231D+03,0.29315000D+01,0.19315000D+01
     .,0.34461890D+03,0.351D+03,0.232D+03,0.29315000D+01,0.19447000D+01
     .,0.31716790D+03,0.351D+03,0.233D+03,0.29315000D+01,0.19793000D+01
     .,0.29578510D+03,0.351D+03,0.234D+03,0.29315000D+01,0.19812000D+01
     .,0.44775000D+03,0.351D+03,0.238D+03,0.29315000D+01,0.19143000D+01
     .,0.43282190D+03,0.351D+03,0.239D+03,0.29315000D+01,0.28903000D+01
     .,0.43705000D+03,0.351D+03,0.240D+03,0.29315000D+01,0.39106000D+01
     .,0.42243200D+03,0.351D+03,0.241D+03,0.29315000D+01,0.29225000D+01
     .,0.37466630D+03,0.351D+03,0.242D+03,0.29315000D+01,0.11055600D+02
     .,0.33151190D+03,0.351D+03,0.243D+03,0.29315000D+01,0.95402000D+01
     ./)
      grimme_c6_parameters( 150501: 150600)=(/
     . 0.31355000D+03,0.351D+03,0.244D+03,0.29315000D+01,0.88895000D+01
     .,0.31846020D+03,0.351D+03,0.245D+03,0.29315000D+01,0.29696000D+01
     .,0.33242910D+03,0.351D+03,0.246D+03,0.29315000D+01,0.57095000D+01
     .,0.42067140D+03,0.351D+03,0.249D+03,0.29315000D+01,0.19378000D+01
     .,0.45728600D+03,0.351D+03,0.250D+03,0.29315000D+01,0.19505000D+01
     .,0.43233570D+03,0.351D+03,0.251D+03,0.29315000D+01,0.19523000D+01
     .,0.41789910D+03,0.351D+03,0.252D+03,0.29315000D+01,0.19639000D+01
     .,0.54209840D+03,0.351D+03,0.256D+03,0.29315000D+01,0.18467000D+01
     .,0.56322280D+03,0.351D+03,0.257D+03,0.29315000D+01,0.29175000D+01
     .,0.41908730D+03,0.351D+03,0.272D+03,0.29315000D+01,0.38840000D+01
     .,0.43700180D+03,0.351D+03,0.273D+03,0.29315000D+01,0.28988000D+01
     .,0.40713540D+03,0.351D+03,0.274D+03,0.29315000D+01,0.10915300D+02
     .,0.37060120D+03,0.351D+03,0.275D+03,0.29315000D+01,0.98054000D+01
     .,0.34925650D+03,0.351D+03,0.276D+03,0.29315000D+01,0.91527000D+01
     .,0.35516130D+03,0.351D+03,0.277D+03,0.29315000D+01,0.29424000D+01
     .,0.37350160D+03,0.351D+03,0.278D+03,0.29315000D+01,0.66669000D+01
     .,0.45030970D+03,0.351D+03,0.281D+03,0.29315000D+01,0.19302000D+01
     .,0.47607850D+03,0.351D+03,0.282D+03,0.29315000D+01,0.19356000D+01
     .,0.48592250D+03,0.351D+03,0.283D+03,0.29315000D+01,0.19655000D+01
     .,0.48291440D+03,0.351D+03,0.284D+03,0.29315000D+01,0.19639000D+01
     ./)
      grimme_c6_parameters( 150601: 150700)=(/
     . 0.59698270D+03,0.351D+03,0.288D+03,0.29315000D+01,0.18075000D+01
     .,0.11375420D+03,0.351D+03,0.305D+03,0.29315000D+01,0.29128000D+01
     .,0.10251480D+03,0.351D+03,0.306D+03,0.29315000D+01,0.29987000D+01
     .,0.77544000D+02,0.351D+03,0.307D+03,0.29315000D+01,0.29903000D+01
     .,0.25247130D+03,0.351D+03,0.313D+03,0.29315000D+01,0.29146000D+01
     .,0.30196690D+03,0.351D+03,0.314D+03,0.29315000D+01,0.29407000D+01
     .,0.25132430D+03,0.351D+03,0.315D+03,0.29315000D+01,0.29859000D+01
     .,0.22165120D+03,0.351D+03,0.327D+03,0.29315000D+01,0.77785000D+01
     .,0.24237210D+03,0.351D+03,0.328D+03,0.29315000D+01,0.62918000D+01
     .,0.26809680D+03,0.351D+03,0.331D+03,0.29315000D+01,0.29233000D+01
     .,0.30954100D+03,0.351D+03,0.332D+03,0.29315000D+01,0.29186000D+01
     .,0.30575380D+03,0.351D+03,0.333D+03,0.29315000D+01,0.29709000D+01
     .,0.36007570D+03,0.351D+03,0.349D+03,0.29315000D+01,0.29353000D+01
     .,0.41300240D+03,0.351D+03,0.350D+03,0.29315000D+01,0.29259000D+01
     .,0.41737900D+03,0.351D+03,0.351D+03,0.29315000D+01,0.29315000D+01
     .,0.34044000D+02,0.381D+03,0.100D+01,0.29420000D+01,0.91180000D+00
     .,0.23069600D+02,0.381D+03,0.200D+01,0.29420000D+01,0.00000000D+00
     .,0.48987970D+03,0.381D+03,0.300D+01,0.29420000D+01,0.00000000D+00
     .,0.29240300D+03,0.381D+03,0.400D+01,0.29420000D+01,0.00000000D+00
     .,0.20096210D+03,0.381D+03,0.500D+01,0.29420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 150701: 150800)=(/
     . 0.13805320D+03,0.381D+03,0.600D+01,0.29420000D+01,0.00000000D+00
     .,0.97883500D+02,0.381D+03,0.700D+01,0.29420000D+01,0.00000000D+00
     .,0.74909600D+02,0.381D+03,0.800D+01,0.29420000D+01,0.00000000D+00
     .,0.57318900D+02,0.381D+03,0.900D+01,0.29420000D+01,0.00000000D+00
     .,0.44478100D+02,0.381D+03,0.100D+02,0.29420000D+01,0.00000000D+00
     .,0.58737390D+03,0.381D+03,0.110D+02,0.29420000D+01,0.00000000D+00
     .,0.46339590D+03,0.381D+03,0.120D+02,0.29420000D+01,0.00000000D+00
     .,0.43142990D+03,0.381D+03,0.130D+02,0.29420000D+01,0.00000000D+00
     .,0.34462380D+03,0.381D+03,0.140D+02,0.29420000D+01,0.00000000D+00
     .,0.27203200D+03,0.381D+03,0.150D+02,0.29420000D+01,0.00000000D+00
     .,0.22771370D+03,0.381D+03,0.160D+02,0.29420000D+01,0.00000000D+00
     .,0.18762390D+03,0.381D+03,0.170D+02,0.29420000D+01,0.00000000D+00
     .,0.15474190D+03,0.381D+03,0.180D+02,0.29420000D+01,0.00000000D+00
     .,0.95974420D+03,0.381D+03,0.190D+02,0.29420000D+01,0.00000000D+00
     .,0.80685000D+03,0.381D+03,0.200D+02,0.29420000D+01,0.00000000D+00
     .,0.66951760D+03,0.381D+03,0.210D+02,0.29420000D+01,0.00000000D+00
     .,0.64952300D+03,0.381D+03,0.220D+02,0.29420000D+01,0.00000000D+00
     .,0.59639240D+03,0.381D+03,0.230D+02,0.29420000D+01,0.00000000D+00
     .,0.47075810D+03,0.381D+03,0.240D+02,0.29420000D+01,0.00000000D+00
     .,0.51551420D+03,0.381D+03,0.250D+02,0.29420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 150801: 150900)=(/
     . 0.40565730D+03,0.381D+03,0.260D+02,0.29420000D+01,0.00000000D+00
     .,0.43161180D+03,0.381D+03,0.270D+02,0.29420000D+01,0.00000000D+00
     .,0.44337980D+03,0.381D+03,0.280D+02,0.29420000D+01,0.00000000D+00
     .,0.34075230D+03,0.381D+03,0.290D+02,0.29420000D+01,0.00000000D+00
     .,0.35207290D+03,0.381D+03,0.300D+02,0.29420000D+01,0.00000000D+00
     .,0.41543610D+03,0.381D+03,0.310D+02,0.29420000D+01,0.00000000D+00
     .,0.37009550D+03,0.381D+03,0.320D+02,0.29420000D+01,0.00000000D+00
     .,0.31876960D+03,0.381D+03,0.330D+02,0.29420000D+01,0.00000000D+00
     .,0.28790150D+03,0.381D+03,0.340D+02,0.29420000D+01,0.00000000D+00
     .,0.25371080D+03,0.381D+03,0.350D+02,0.29420000D+01,0.00000000D+00
     .,0.22213540D+03,0.381D+03,0.360D+02,0.29420000D+01,0.00000000D+00
     .,0.10781354D+04,0.381D+03,0.370D+02,0.29420000D+01,0.00000000D+00
     .,0.96112990D+03,0.381D+03,0.380D+02,0.29420000D+01,0.00000000D+00
     .,0.84864220D+03,0.381D+03,0.390D+02,0.29420000D+01,0.00000000D+00
     .,0.76669670D+03,0.381D+03,0.400D+02,0.29420000D+01,0.00000000D+00
     .,0.70169050D+03,0.381D+03,0.410D+02,0.29420000D+01,0.00000000D+00
     .,0.54556530D+03,0.381D+03,0.420D+02,0.29420000D+01,0.00000000D+00
     .,0.60711050D+03,0.381D+03,0.430D+02,0.29420000D+01,0.00000000D+00
     .,0.46612980D+03,0.381D+03,0.440D+02,0.29420000D+01,0.00000000D+00
     .,0.50894760D+03,0.381D+03,0.450D+02,0.29420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 150901: 151000)=(/
     . 0.47308430D+03,0.381D+03,0.460D+02,0.29420000D+01,0.00000000D+00
     .,0.39480510D+03,0.381D+03,0.470D+02,0.29420000D+01,0.00000000D+00
     .,0.41818980D+03,0.381D+03,0.480D+02,0.29420000D+01,0.00000000D+00
     .,0.52081600D+03,0.381D+03,0.490D+02,0.29420000D+01,0.00000000D+00
     .,0.48532990D+03,0.381D+03,0.500D+02,0.29420000D+01,0.00000000D+00
     .,0.43604710D+03,0.381D+03,0.510D+02,0.29420000D+01,0.00000000D+00
     .,0.40666470D+03,0.381D+03,0.520D+02,0.29420000D+01,0.00000000D+00
     .,0.36983570D+03,0.381D+03,0.530D+02,0.29420000D+01,0.00000000D+00
     .,0.33441780D+03,0.381D+03,0.540D+02,0.29420000D+01,0.00000000D+00
     .,0.13141925D+04,0.381D+03,0.550D+02,0.29420000D+01,0.00000000D+00
     .,0.12227209D+04,0.381D+03,0.560D+02,0.29420000D+01,0.00000000D+00
     .,0.10825707D+04,0.381D+03,0.570D+02,0.29420000D+01,0.00000000D+00
     .,0.51466410D+03,0.381D+03,0.580D+02,0.29420000D+01,0.27991000D+01
     .,0.10866848D+04,0.381D+03,0.590D+02,0.29420000D+01,0.00000000D+00
     .,0.10447574D+04,0.381D+03,0.600D+02,0.29420000D+01,0.00000000D+00
     .,0.10188963D+04,0.381D+03,0.610D+02,0.29420000D+01,0.00000000D+00
     .,0.99506410D+03,0.381D+03,0.620D+02,0.29420000D+01,0.00000000D+00
     .,0.97393920D+03,0.381D+03,0.630D+02,0.29420000D+01,0.00000000D+00
     .,0.77328240D+03,0.381D+03,0.640D+02,0.29420000D+01,0.00000000D+00
     .,0.86029910D+03,0.381D+03,0.650D+02,0.29420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 151001: 151100)=(/
     . 0.83099980D+03,0.381D+03,0.660D+02,0.29420000D+01,0.00000000D+00
     .,0.88007510D+03,0.381D+03,0.670D+02,0.29420000D+01,0.00000000D+00
     .,0.86153880D+03,0.381D+03,0.680D+02,0.29420000D+01,0.00000000D+00
     .,0.84491510D+03,0.381D+03,0.690D+02,0.29420000D+01,0.00000000D+00
     .,0.83467880D+03,0.381D+03,0.700D+02,0.29420000D+01,0.00000000D+00
     .,0.70786620D+03,0.381D+03,0.710D+02,0.29420000D+01,0.00000000D+00
     .,0.70135370D+03,0.381D+03,0.720D+02,0.29420000D+01,0.00000000D+00
     .,0.64346570D+03,0.381D+03,0.730D+02,0.29420000D+01,0.00000000D+00
     .,0.54618300D+03,0.381D+03,0.740D+02,0.29420000D+01,0.00000000D+00
     .,0.55658840D+03,0.381D+03,0.750D+02,0.29420000D+01,0.00000000D+00
     .,0.50684330D+03,0.381D+03,0.760D+02,0.29420000D+01,0.00000000D+00
     .,0.46602790D+03,0.381D+03,0.770D+02,0.29420000D+01,0.00000000D+00
     .,0.38918560D+03,0.381D+03,0.780D+02,0.29420000D+01,0.00000000D+00
     .,0.36440110D+03,0.381D+03,0.790D+02,0.29420000D+01,0.00000000D+00
     .,0.37525010D+03,0.381D+03,0.800D+02,0.29420000D+01,0.00000000D+00
     .,0.53671560D+03,0.381D+03,0.810D+02,0.29420000D+01,0.00000000D+00
     .,0.52765960D+03,0.381D+03,0.820D+02,0.29420000D+01,0.00000000D+00
     .,0.48826870D+03,0.381D+03,0.830D+02,0.29420000D+01,0.00000000D+00
     .,0.46765830D+03,0.381D+03,0.840D+02,0.29420000D+01,0.00000000D+00
     .,0.43390630D+03,0.381D+03,0.850D+02,0.29420000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 151101: 151200)=(/
     . 0.39973560D+03,0.381D+03,0.860D+02,0.29420000D+01,0.00000000D+00
     .,0.12488786D+04,0.381D+03,0.870D+02,0.29420000D+01,0.00000000D+00
     .,0.12142011D+04,0.381D+03,0.880D+02,0.29420000D+01,0.00000000D+00
     .,0.10810636D+04,0.381D+03,0.890D+02,0.29420000D+01,0.00000000D+00
     .,0.98016620D+03,0.381D+03,0.900D+02,0.29420000D+01,0.00000000D+00
     .,0.96970180D+03,0.381D+03,0.910D+02,0.29420000D+01,0.00000000D+00
     .,0.93922300D+03,0.381D+03,0.920D+02,0.29420000D+01,0.00000000D+00
     .,0.96210980D+03,0.381D+03,0.930D+02,0.29420000D+01,0.00000000D+00
     .,0.93257400D+03,0.381D+03,0.940D+02,0.29420000D+01,0.00000000D+00
     .,0.54112100D+02,0.381D+03,0.101D+03,0.29420000D+01,0.00000000D+00
     .,0.17052180D+03,0.381D+03,0.103D+03,0.29420000D+01,0.98650000D+00
     .,0.21838760D+03,0.381D+03,0.104D+03,0.29420000D+01,0.98080000D+00
     .,0.16984800D+03,0.381D+03,0.105D+03,0.29420000D+01,0.97060000D+00
     .,0.12953340D+03,0.381D+03,0.106D+03,0.29420000D+01,0.98680000D+00
     .,0.91360600D+02,0.381D+03,0.107D+03,0.29420000D+01,0.99440000D+00
     .,0.67384900D+02,0.381D+03,0.108D+03,0.29420000D+01,0.99250000D+00
     .,0.47131600D+02,0.381D+03,0.109D+03,0.29420000D+01,0.99820000D+00
     .,0.24874970D+03,0.381D+03,0.111D+03,0.29420000D+01,0.96840000D+00
     .,0.38382790D+03,0.381D+03,0.112D+03,0.29420000D+01,0.96280000D+00
     .,0.39201850D+03,0.381D+03,0.113D+03,0.29420000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters( 151201: 151300)=(/
     . 0.31922290D+03,0.381D+03,0.114D+03,0.29420000D+01,0.95070000D+00
     .,0.26420730D+03,0.381D+03,0.115D+03,0.29420000D+01,0.99470000D+00
     .,0.22519300D+03,0.381D+03,0.116D+03,0.29420000D+01,0.99480000D+00
     .,0.18567430D+03,0.381D+03,0.117D+03,0.29420000D+01,0.99720000D+00
     .,0.34642790D+03,0.381D+03,0.119D+03,0.29420000D+01,0.97670000D+00
     .,0.64689750D+03,0.381D+03,0.120D+03,0.29420000D+01,0.98310000D+00
     .,0.34969760D+03,0.381D+03,0.121D+03,0.29420000D+01,0.18627000D+01
     .,0.33785900D+03,0.381D+03,0.122D+03,0.29420000D+01,0.18299000D+01
     .,0.33110740D+03,0.381D+03,0.123D+03,0.29420000D+01,0.19138000D+01
     .,0.32768960D+03,0.381D+03,0.124D+03,0.29420000D+01,0.18269000D+01
     .,0.30324930D+03,0.381D+03,0.125D+03,0.29420000D+01,0.16406000D+01
     .,0.28126900D+03,0.381D+03,0.126D+03,0.29420000D+01,0.16483000D+01
     .,0.26841200D+03,0.381D+03,0.127D+03,0.29420000D+01,0.17149000D+01
     .,0.26230550D+03,0.381D+03,0.128D+03,0.29420000D+01,0.17937000D+01
     .,0.25806750D+03,0.381D+03,0.129D+03,0.29420000D+01,0.95760000D+00
     .,0.24404160D+03,0.381D+03,0.130D+03,0.29420000D+01,0.19419000D+01
     .,0.39123290D+03,0.381D+03,0.131D+03,0.29420000D+01,0.96010000D+00
     .,0.34713060D+03,0.381D+03,0.132D+03,0.29420000D+01,0.94340000D+00
     .,0.31356550D+03,0.381D+03,0.133D+03,0.29420000D+01,0.98890000D+00
     .,0.28799690D+03,0.381D+03,0.134D+03,0.29420000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters( 151301: 151400)=(/
     . 0.25539640D+03,0.381D+03,0.135D+03,0.29420000D+01,0.99740000D+00
     .,0.41451570D+03,0.381D+03,0.137D+03,0.29420000D+01,0.97380000D+00
     .,0.78676620D+03,0.381D+03,0.138D+03,0.29420000D+01,0.98010000D+00
     .,0.61108840D+03,0.381D+03,0.139D+03,0.29420000D+01,0.19153000D+01
     .,0.46240460D+03,0.381D+03,0.140D+03,0.29420000D+01,0.19355000D+01
     .,0.46695430D+03,0.381D+03,0.141D+03,0.29420000D+01,0.19545000D+01
     .,0.43660630D+03,0.381D+03,0.142D+03,0.29420000D+01,0.19420000D+01
     .,0.48596370D+03,0.381D+03,0.143D+03,0.29420000D+01,0.16682000D+01
     .,0.38300380D+03,0.381D+03,0.144D+03,0.29420000D+01,0.18584000D+01
     .,0.35872510D+03,0.381D+03,0.145D+03,0.29420000D+01,0.19003000D+01
     .,0.33367710D+03,0.381D+03,0.146D+03,0.29420000D+01,0.18630000D+01
     .,0.32258500D+03,0.381D+03,0.147D+03,0.29420000D+01,0.96790000D+00
     .,0.32032730D+03,0.381D+03,0.148D+03,0.29420000D+01,0.19539000D+01
     .,0.49788730D+03,0.381D+03,0.149D+03,0.29420000D+01,0.96330000D+00
     .,0.45413030D+03,0.381D+03,0.150D+03,0.29420000D+01,0.95140000D+00
     .,0.42784290D+03,0.381D+03,0.151D+03,0.29420000D+01,0.97490000D+00
     .,0.40648930D+03,0.381D+03,0.152D+03,0.29420000D+01,0.98110000D+00
     .,0.37325390D+03,0.381D+03,0.153D+03,0.29420000D+01,0.99680000D+00
     .,0.49296130D+03,0.381D+03,0.155D+03,0.29420000D+01,0.99090000D+00
     .,0.10173501D+04,0.381D+03,0.156D+03,0.29420000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters( 151401: 151500)=(/
     . 0.77250690D+03,0.381D+03,0.157D+03,0.29420000D+01,0.19373000D+01
     .,0.49942220D+03,0.381D+03,0.159D+03,0.29420000D+01,0.29425000D+01
     .,0.48915000D+03,0.381D+03,0.160D+03,0.29420000D+01,0.29455000D+01
     .,0.47387610D+03,0.381D+03,0.161D+03,0.29420000D+01,0.29413000D+01
     .,0.47562120D+03,0.381D+03,0.162D+03,0.29420000D+01,0.29300000D+01
     .,0.45685930D+03,0.381D+03,0.163D+03,0.29420000D+01,0.18286000D+01
     .,0.47832350D+03,0.381D+03,0.164D+03,0.29420000D+01,0.28732000D+01
     .,0.44982470D+03,0.381D+03,0.165D+03,0.29420000D+01,0.29086000D+01
     .,0.45672830D+03,0.381D+03,0.166D+03,0.29420000D+01,0.28965000D+01
     .,0.42739350D+03,0.381D+03,0.167D+03,0.29420000D+01,0.29242000D+01
     .,0.41538260D+03,0.381D+03,0.168D+03,0.29420000D+01,0.29282000D+01
     .,0.41256270D+03,0.381D+03,0.169D+03,0.29420000D+01,0.29246000D+01
     .,0.43270380D+03,0.381D+03,0.170D+03,0.29420000D+01,0.28482000D+01
     .,0.39897500D+03,0.381D+03,0.171D+03,0.29420000D+01,0.29219000D+01
     .,0.53287050D+03,0.381D+03,0.172D+03,0.29420000D+01,0.19254000D+01
     .,0.49712170D+03,0.381D+03,0.173D+03,0.29420000D+01,0.19459000D+01
     .,0.45606110D+03,0.381D+03,0.174D+03,0.29420000D+01,0.19292000D+01
     .,0.45949090D+03,0.381D+03,0.175D+03,0.29420000D+01,0.18104000D+01
     .,0.40710880D+03,0.381D+03,0.176D+03,0.29420000D+01,0.18858000D+01
     .,0.38388990D+03,0.381D+03,0.177D+03,0.29420000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters( 151501: 151600)=(/
     . 0.36723030D+03,0.381D+03,0.178D+03,0.29420000D+01,0.19188000D+01
     .,0.35126140D+03,0.381D+03,0.179D+03,0.29420000D+01,0.98460000D+00
     .,0.34073060D+03,0.381D+03,0.180D+03,0.29420000D+01,0.19896000D+01
     .,0.53610400D+03,0.381D+03,0.181D+03,0.29420000D+01,0.92670000D+00
     .,0.49251500D+03,0.381D+03,0.182D+03,0.29420000D+01,0.93830000D+00
     .,0.47966590D+03,0.381D+03,0.183D+03,0.29420000D+01,0.98200000D+00
     .,0.46803600D+03,0.381D+03,0.184D+03,0.29420000D+01,0.98150000D+00
     .,0.43913860D+03,0.381D+03,0.185D+03,0.29420000D+01,0.99540000D+00
     .,0.55539950D+03,0.381D+03,0.187D+03,0.29420000D+01,0.97050000D+00
     .,0.10170070D+04,0.381D+03,0.188D+03,0.29420000D+01,0.96620000D+00
     .,0.59069510D+03,0.381D+03,0.189D+03,0.29420000D+01,0.29070000D+01
     .,0.67732330D+03,0.381D+03,0.190D+03,0.29420000D+01,0.28844000D+01
     .,0.60753220D+03,0.381D+03,0.191D+03,0.29420000D+01,0.28738000D+01
     .,0.53986600D+03,0.381D+03,0.192D+03,0.29420000D+01,0.28878000D+01
     .,0.52021880D+03,0.381D+03,0.193D+03,0.29420000D+01,0.29095000D+01
     .,0.61673560D+03,0.381D+03,0.194D+03,0.29420000D+01,0.19209000D+01
     .,0.14507840D+03,0.381D+03,0.204D+03,0.29420000D+01,0.19697000D+01
     .,0.14327430D+03,0.381D+03,0.205D+03,0.29420000D+01,0.19441000D+01
     .,0.10636560D+03,0.381D+03,0.206D+03,0.29420000D+01,0.19985000D+01
     .,0.85946800D+02,0.381D+03,0.207D+03,0.29420000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters( 151601: 151700)=(/
     . 0.59722700D+02,0.381D+03,0.208D+03,0.29420000D+01,0.19887000D+01
     .,0.25519400D+03,0.381D+03,0.212D+03,0.29420000D+01,0.19496000D+01
     .,0.30808810D+03,0.381D+03,0.213D+03,0.29420000D+01,0.19311000D+01
     .,0.29753400D+03,0.381D+03,0.214D+03,0.29420000D+01,0.19435000D+01
     .,0.26049720D+03,0.381D+03,0.215D+03,0.29420000D+01,0.20102000D+01
     .,0.22070250D+03,0.381D+03,0.216D+03,0.29420000D+01,0.19903000D+01
     .,0.35843680D+03,0.381D+03,0.220D+03,0.29420000D+01,0.19349000D+01
     .,0.34620560D+03,0.381D+03,0.221D+03,0.29420000D+01,0.28999000D+01
     .,0.35064040D+03,0.381D+03,0.222D+03,0.29420000D+01,0.38675000D+01
     .,0.32104220D+03,0.381D+03,0.223D+03,0.29420000D+01,0.29110000D+01
     .,0.24431950D+03,0.381D+03,0.224D+03,0.29420000D+01,0.10619100D+02
     .,0.21030300D+03,0.381D+03,0.225D+03,0.29420000D+01,0.98849000D+01
     .,0.20632120D+03,0.381D+03,0.226D+03,0.29420000D+01,0.91376000D+01
     .,0.23960260D+03,0.381D+03,0.227D+03,0.29420000D+01,0.29263000D+01
     .,0.22381460D+03,0.381D+03,0.228D+03,0.29420000D+01,0.65458000D+01
     .,0.31290410D+03,0.381D+03,0.231D+03,0.29420000D+01,0.19315000D+01
     .,0.33107290D+03,0.381D+03,0.232D+03,0.29420000D+01,0.19447000D+01
     .,0.30565610D+03,0.381D+03,0.233D+03,0.29420000D+01,0.19793000D+01
     .,0.28580050D+03,0.381D+03,0.234D+03,0.29420000D+01,0.19812000D+01
     .,0.42995510D+03,0.381D+03,0.238D+03,0.29420000D+01,0.19143000D+01
     ./)
      grimme_c6_parameters( 151701: 151800)=(/
     . 0.41647270D+03,0.381D+03,0.239D+03,0.29420000D+01,0.28903000D+01
     .,0.42087950D+03,0.381D+03,0.240D+03,0.29420000D+01,0.39106000D+01
     .,0.40706770D+03,0.381D+03,0.241D+03,0.29420000D+01,0.29225000D+01
     .,0.36222600D+03,0.381D+03,0.242D+03,0.29420000D+01,0.11055600D+02
     .,0.32139710D+03,0.381D+03,0.243D+03,0.29420000D+01,0.95402000D+01
     .,0.30435760D+03,0.381D+03,0.244D+03,0.29420000D+01,0.88895000D+01
     .,0.30856230D+03,0.381D+03,0.245D+03,0.29420000D+01,0.29696000D+01
     .,0.32173420D+03,0.381D+03,0.246D+03,0.29420000D+01,0.57095000D+01
     .,0.40490970D+03,0.381D+03,0.249D+03,0.29420000D+01,0.19378000D+01
     .,0.43980180D+03,0.381D+03,0.250D+03,0.29420000D+01,0.19505000D+01
     .,0.41670500D+03,0.381D+03,0.251D+03,0.29420000D+01,0.19523000D+01
     .,0.40341630D+03,0.381D+03,0.252D+03,0.29420000D+01,0.19639000D+01
     .,0.52107880D+03,0.381D+03,0.256D+03,0.29420000D+01,0.18467000D+01
     .,0.54160900D+03,0.381D+03,0.257D+03,0.29420000D+01,0.29175000D+01
     .,0.40413150D+03,0.381D+03,0.272D+03,0.29420000D+01,0.38840000D+01
     .,0.42132440D+03,0.381D+03,0.273D+03,0.29420000D+01,0.28988000D+01
     .,0.39364640D+03,0.381D+03,0.274D+03,0.29420000D+01,0.10915300D+02
     .,0.35924180D+03,0.381D+03,0.275D+03,0.29420000D+01,0.98054000D+01
     .,0.33923690D+03,0.381D+03,0.276D+03,0.29420000D+01,0.91527000D+01
     .,0.34453850D+03,0.381D+03,0.277D+03,0.29420000D+01,0.29424000D+01
     ./)
      grimme_c6_parameters( 151801: 151900)=(/
     . 0.36204930D+03,0.381D+03,0.278D+03,0.29420000D+01,0.66669000D+01
     .,0.43455430D+03,0.381D+03,0.281D+03,0.29420000D+01,0.19302000D+01
     .,0.45916510D+03,0.381D+03,0.282D+03,0.29420000D+01,0.19356000D+01
     .,0.46885050D+03,0.381D+03,0.283D+03,0.29420000D+01,0.19655000D+01
     .,0.46635820D+03,0.381D+03,0.284D+03,0.29420000D+01,0.19639000D+01
     .,0.57392320D+03,0.381D+03,0.288D+03,0.29420000D+01,0.18075000D+01
     .,0.11015230D+03,0.381D+03,0.305D+03,0.29420000D+01,0.29128000D+01
     .,0.99617500D+02,0.381D+03,0.306D+03,0.29420000D+01,0.29987000D+01
     .,0.75930400D+02,0.381D+03,0.307D+03,0.29420000D+01,0.29903000D+01
     .,0.24251390D+03,0.381D+03,0.313D+03,0.29420000D+01,0.29146000D+01
     .,0.28970710D+03,0.381D+03,0.314D+03,0.29420000D+01,0.29407000D+01
     .,0.24238610D+03,0.381D+03,0.315D+03,0.29420000D+01,0.29859000D+01
     .,0.21463710D+03,0.381D+03,0.327D+03,0.29420000D+01,0.77785000D+01
     .,0.23384620D+03,0.381D+03,0.328D+03,0.29420000D+01,0.62918000D+01
     .,0.25833420D+03,0.381D+03,0.331D+03,0.29420000D+01,0.29233000D+01
     .,0.29794670D+03,0.381D+03,0.332D+03,0.29420000D+01,0.29186000D+01
     .,0.29487070D+03,0.381D+03,0.333D+03,0.29420000D+01,0.29709000D+01
     .,0.34780090D+03,0.381D+03,0.349D+03,0.29420000D+01,0.29353000D+01
     .,0.39805300D+03,0.381D+03,0.350D+03,0.29420000D+01,0.29259000D+01
     .,0.40261790D+03,0.381D+03,0.351D+03,0.29420000D+01,0.29315000D+01
     ./)
      grimme_c6_parameters( 151901: 152000)=(/
     . 0.38960690D+03,0.381D+03,0.381D+03,0.29420000D+01,0.29420000D+01
     .,0.39201800D+02,0.382D+03,0.100D+01,0.29081000D+01,0.91180000D+00
     .,0.26154200D+02,0.382D+03,0.200D+01,0.29081000D+01,0.00000000D+00
     .,0.59230750D+03,0.382D+03,0.300D+01,0.29081000D+01,0.00000000D+00
     .,0.34659360D+03,0.382D+03,0.400D+01,0.29081000D+01,0.00000000D+00
     .,0.23511450D+03,0.382D+03,0.500D+01,0.29081000D+01,0.00000000D+00
     .,0.15978570D+03,0.382D+03,0.600D+01,0.29081000D+01,0.00000000D+00
     .,0.11231150D+03,0.382D+03,0.700D+01,0.29081000D+01,0.00000000D+00
     .,0.85390200D+02,0.382D+03,0.800D+01,0.29081000D+01,0.00000000D+00
     .,0.64954800D+02,0.382D+03,0.900D+01,0.29081000D+01,0.00000000D+00
     .,0.50154300D+02,0.382D+03,0.100D+02,0.29081000D+01,0.00000000D+00
     .,0.70906070D+03,0.382D+03,0.110D+02,0.29081000D+01,0.00000000D+00
     .,0.55115190D+03,0.382D+03,0.120D+02,0.29081000D+01,0.00000000D+00
     .,0.50990250D+03,0.382D+03,0.130D+02,0.29081000D+01,0.00000000D+00
     .,0.40375640D+03,0.382D+03,0.140D+02,0.29081000D+01,0.00000000D+00
     .,0.31618250D+03,0.382D+03,0.150D+02,0.29081000D+01,0.00000000D+00
     .,0.26318820D+03,0.382D+03,0.160D+02,0.29081000D+01,0.00000000D+00
     .,0.21563940D+03,0.382D+03,0.170D+02,0.29081000D+01,0.00000000D+00
     .,0.17693360D+03,0.382D+03,0.180D+02,0.29081000D+01,0.00000000D+00
     .,0.11602124D+04,0.382D+03,0.190D+02,0.29081000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 152001: 152100)=(/
     . 0.96482980D+03,0.382D+03,0.200D+02,0.29081000D+01,0.00000000D+00
     .,0.79848900D+03,0.382D+03,0.210D+02,0.29081000D+01,0.00000000D+00
     .,0.77240680D+03,0.382D+03,0.220D+02,0.29081000D+01,0.00000000D+00
     .,0.70804470D+03,0.382D+03,0.230D+02,0.29081000D+01,0.00000000D+00
     .,0.55813800D+03,0.382D+03,0.240D+02,0.29081000D+01,0.00000000D+00
     .,0.61052950D+03,0.382D+03,0.250D+02,0.29081000D+01,0.00000000D+00
     .,0.47961190D+03,0.382D+03,0.260D+02,0.29081000D+01,0.00000000D+00
     .,0.50914700D+03,0.382D+03,0.270D+02,0.29081000D+01,0.00000000D+00
     .,0.52395450D+03,0.382D+03,0.280D+02,0.29081000D+01,0.00000000D+00
     .,0.40203690D+03,0.382D+03,0.290D+02,0.29081000D+01,0.00000000D+00
     .,0.41376860D+03,0.382D+03,0.300D+02,0.29081000D+01,0.00000000D+00
     .,0.48932470D+03,0.382D+03,0.310D+02,0.29081000D+01,0.00000000D+00
     .,0.43309510D+03,0.382D+03,0.320D+02,0.29081000D+01,0.00000000D+00
     .,0.37065200D+03,0.382D+03,0.330D+02,0.29081000D+01,0.00000000D+00
     .,0.33332050D+03,0.382D+03,0.340D+02,0.29081000D+01,0.00000000D+00
     .,0.29238780D+03,0.382D+03,0.350D+02,0.29081000D+01,0.00000000D+00
     .,0.25487000D+03,0.382D+03,0.360D+02,0.29081000D+01,0.00000000D+00
     .,0.13013911D+04,0.382D+03,0.370D+02,0.29081000D+01,0.00000000D+00
     .,0.11493369D+04,0.382D+03,0.380D+02,0.29081000D+01,0.00000000D+00
     .,0.10098313D+04,0.382D+03,0.390D+02,0.29081000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 152101: 152200)=(/
     . 0.90933820D+03,0.382D+03,0.400D+02,0.29081000D+01,0.00000000D+00
     .,0.83029650D+03,0.382D+03,0.410D+02,0.29081000D+01,0.00000000D+00
     .,0.64261650D+03,0.382D+03,0.420D+02,0.29081000D+01,0.00000000D+00
     .,0.71635260D+03,0.382D+03,0.430D+02,0.29081000D+01,0.00000000D+00
     .,0.54725930D+03,0.382D+03,0.440D+02,0.29081000D+01,0.00000000D+00
     .,0.59800230D+03,0.382D+03,0.450D+02,0.29081000D+01,0.00000000D+00
     .,0.55503560D+03,0.382D+03,0.460D+02,0.29081000D+01,0.00000000D+00
     .,0.46292020D+03,0.382D+03,0.470D+02,0.29081000D+01,0.00000000D+00
     .,0.48966130D+03,0.382D+03,0.480D+02,0.29081000D+01,0.00000000D+00
     .,0.61279550D+03,0.382D+03,0.490D+02,0.29081000D+01,0.00000000D+00
     .,0.56824370D+03,0.382D+03,0.500D+02,0.29081000D+01,0.00000000D+00
     .,0.50783300D+03,0.382D+03,0.510D+02,0.29081000D+01,0.00000000D+00
     .,0.47198620D+03,0.382D+03,0.520D+02,0.29081000D+01,0.00000000D+00
     .,0.42758360D+03,0.382D+03,0.530D+02,0.29081000D+01,0.00000000D+00
     .,0.38515720D+03,0.382D+03,0.540D+02,0.29081000D+01,0.00000000D+00
     .,0.15855821D+04,0.382D+03,0.550D+02,0.29081000D+01,0.00000000D+00
     .,0.14639079D+04,0.382D+03,0.560D+02,0.29081000D+01,0.00000000D+00
     .,0.12899128D+04,0.382D+03,0.570D+02,0.29081000D+01,0.00000000D+00
     .,0.59969740D+03,0.382D+03,0.580D+02,0.29081000D+01,0.27991000D+01
     .,0.12986324D+04,0.382D+03,0.590D+02,0.29081000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 152201: 152300)=(/
     . 0.12476103D+04,0.382D+03,0.600D+02,0.29081000D+01,0.00000000D+00
     .,0.12164825D+04,0.382D+03,0.610D+02,0.29081000D+01,0.00000000D+00
     .,0.11878330D+04,0.382D+03,0.620D+02,0.29081000D+01,0.00000000D+00
     .,0.11624311D+04,0.382D+03,0.630D+02,0.29081000D+01,0.00000000D+00
     .,0.91733060D+03,0.382D+03,0.640D+02,0.29081000D+01,0.00000000D+00
     .,0.10280579D+04,0.382D+03,0.650D+02,0.29081000D+01,0.00000000D+00
     .,0.99208130D+03,0.382D+03,0.660D+02,0.29081000D+01,0.00000000D+00
     .,0.10492180D+04,0.382D+03,0.670D+02,0.29081000D+01,0.00000000D+00
     .,0.10270231D+04,0.382D+03,0.680D+02,0.29081000D+01,0.00000000D+00
     .,0.10070473D+04,0.382D+03,0.690D+02,0.29081000D+01,0.00000000D+00
     .,0.99511980D+03,0.382D+03,0.700D+02,0.29081000D+01,0.00000000D+00
     .,0.84045040D+03,0.382D+03,0.710D+02,0.29081000D+01,0.00000000D+00
     .,0.82879200D+03,0.382D+03,0.720D+02,0.29081000D+01,0.00000000D+00
     .,0.75780230D+03,0.382D+03,0.730D+02,0.29081000D+01,0.00000000D+00
     .,0.64104200D+03,0.382D+03,0.740D+02,0.29081000D+01,0.00000000D+00
     .,0.65256880D+03,0.382D+03,0.750D+02,0.29081000D+01,0.00000000D+00
     .,0.59243330D+03,0.382D+03,0.760D+02,0.29081000D+01,0.00000000D+00
     .,0.54333580D+03,0.382D+03,0.770D+02,0.29081000D+01,0.00000000D+00
     .,0.45219510D+03,0.382D+03,0.780D+02,0.29081000D+01,0.00000000D+00
     .,0.42282310D+03,0.382D+03,0.790D+02,0.29081000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 152301: 152400)=(/
     . 0.43514150D+03,0.382D+03,0.800D+02,0.29081000D+01,0.00000000D+00
     .,0.62994840D+03,0.382D+03,0.810D+02,0.29081000D+01,0.00000000D+00
     .,0.61718100D+03,0.382D+03,0.820D+02,0.29081000D+01,0.00000000D+00
     .,0.56851380D+03,0.382D+03,0.830D+02,0.29081000D+01,0.00000000D+00
     .,0.54299390D+03,0.382D+03,0.840D+02,0.29081000D+01,0.00000000D+00
     .,0.50202460D+03,0.382D+03,0.850D+02,0.29081000D+01,0.00000000D+00
     .,0.46091780D+03,0.382D+03,0.860D+02,0.29081000D+01,0.00000000D+00
     .,0.15008218D+04,0.382D+03,0.870D+02,0.29081000D+01,0.00000000D+00
     .,0.14498449D+04,0.382D+03,0.880D+02,0.29081000D+01,0.00000000D+00
     .,0.12851719D+04,0.382D+03,0.890D+02,0.29081000D+01,0.00000000D+00
     .,0.11587220D+04,0.382D+03,0.900D+02,0.29081000D+01,0.00000000D+00
     .,0.11488988D+04,0.382D+03,0.910D+02,0.29081000D+01,0.00000000D+00
     .,0.11125743D+04,0.382D+03,0.920D+02,0.29081000D+01,0.00000000D+00
     .,0.11434030D+04,0.382D+03,0.930D+02,0.29081000D+01,0.00000000D+00
     .,0.11076634D+04,0.382D+03,0.940D+02,0.29081000D+01,0.00000000D+00
     .,0.62853000D+02,0.382D+03,0.101D+03,0.29081000D+01,0.00000000D+00
     .,0.20170300D+03,0.382D+03,0.103D+03,0.29081000D+01,0.98650000D+00
     .,0.25762390D+03,0.382D+03,0.104D+03,0.29081000D+01,0.98080000D+00
     .,0.19809520D+03,0.382D+03,0.105D+03,0.29081000D+01,0.97060000D+00
     .,0.14988210D+03,0.382D+03,0.106D+03,0.29081000D+01,0.98680000D+00
     ./)
      grimme_c6_parameters( 152401: 152500)=(/
     . 0.10475870D+03,0.382D+03,0.107D+03,0.29081000D+01,0.99440000D+00
     .,0.76663400D+02,0.382D+03,0.108D+03,0.29081000D+01,0.99250000D+00
     .,0.53088800D+02,0.382D+03,0.109D+03,0.29081000D+01,0.99820000D+00
     .,0.29465140D+03,0.382D+03,0.111D+03,0.29081000D+01,0.96840000D+00
     .,0.45526290D+03,0.382D+03,0.112D+03,0.29081000D+01,0.96280000D+00
     .,0.46254200D+03,0.382D+03,0.113D+03,0.29081000D+01,0.96480000D+00
     .,0.37345290D+03,0.382D+03,0.114D+03,0.29081000D+01,0.95070000D+00
     .,0.30696940D+03,0.382D+03,0.115D+03,0.29081000D+01,0.99470000D+00
     .,0.26028570D+03,0.382D+03,0.116D+03,0.29081000D+01,0.99480000D+00
     .,0.21340440D+03,0.382D+03,0.117D+03,0.29081000D+01,0.99720000D+00
     .,0.40761910D+03,0.382D+03,0.119D+03,0.29081000D+01,0.97670000D+00
     .,0.77230000D+03,0.382D+03,0.120D+03,0.29081000D+01,0.98310000D+00
     .,0.40917160D+03,0.382D+03,0.121D+03,0.29081000D+01,0.18627000D+01
     .,0.39511390D+03,0.382D+03,0.122D+03,0.29081000D+01,0.18299000D+01
     .,0.38722670D+03,0.382D+03,0.123D+03,0.29081000D+01,0.19138000D+01
     .,0.38350230D+03,0.382D+03,0.124D+03,0.29081000D+01,0.18269000D+01
     .,0.35362940D+03,0.382D+03,0.125D+03,0.29081000D+01,0.16406000D+01
     .,0.32753820D+03,0.382D+03,0.126D+03,0.29081000D+01,0.16483000D+01
     .,0.31249710D+03,0.382D+03,0.127D+03,0.29081000D+01,0.17149000D+01
     .,0.30547070D+03,0.382D+03,0.128D+03,0.29081000D+01,0.17937000D+01
     ./)
      grimme_c6_parameters( 152501: 152600)=(/
     . 0.30136610D+03,0.382D+03,0.129D+03,0.29081000D+01,0.95760000D+00
     .,0.28355320D+03,0.382D+03,0.130D+03,0.29081000D+01,0.19419000D+01
     .,0.46002380D+03,0.382D+03,0.131D+03,0.29081000D+01,0.96010000D+00
     .,0.40553300D+03,0.382D+03,0.132D+03,0.29081000D+01,0.94340000D+00
     .,0.36444410D+03,0.382D+03,0.133D+03,0.29081000D+01,0.98890000D+00
     .,0.33344240D+03,0.382D+03,0.134D+03,0.29081000D+01,0.99010000D+00
     .,0.29439140D+03,0.382D+03,0.135D+03,0.29081000D+01,0.99740000D+00
     .,0.48683630D+03,0.382D+03,0.137D+03,0.29081000D+01,0.97380000D+00
     .,0.93949220D+03,0.382D+03,0.138D+03,0.29081000D+01,0.98010000D+00
     .,0.72246140D+03,0.382D+03,0.139D+03,0.29081000D+01,0.19153000D+01
     .,0.54104620D+03,0.382D+03,0.140D+03,0.29081000D+01,0.19355000D+01
     .,0.54639880D+03,0.382D+03,0.141D+03,0.29081000D+01,0.19545000D+01
     .,0.50999070D+03,0.382D+03,0.142D+03,0.29081000D+01,0.19420000D+01
     .,0.57035510D+03,0.382D+03,0.143D+03,0.29081000D+01,0.16682000D+01
     .,0.44558690D+03,0.382D+03,0.144D+03,0.29081000D+01,0.18584000D+01
     .,0.41703620D+03,0.382D+03,0.145D+03,0.29081000D+01,0.19003000D+01
     .,0.38750290D+03,0.382D+03,0.146D+03,0.29081000D+01,0.18630000D+01
     .,0.37479630D+03,0.382D+03,0.147D+03,0.29081000D+01,0.96790000D+00
     .,0.37128680D+03,0.382D+03,0.148D+03,0.29081000D+01,0.19539000D+01
     .,0.58473500D+03,0.382D+03,0.149D+03,0.29081000D+01,0.96330000D+00
     ./)
      grimme_c6_parameters( 152601: 152700)=(/
     . 0.53055010D+03,0.382D+03,0.150D+03,0.29081000D+01,0.95140000D+00
     .,0.49790060D+03,0.382D+03,0.151D+03,0.29081000D+01,0.97490000D+00
     .,0.47168750D+03,0.382D+03,0.152D+03,0.29081000D+01,0.98110000D+00
     .,0.43157390D+03,0.382D+03,0.153D+03,0.29081000D+01,0.99680000D+00
     .,0.57682000D+03,0.382D+03,0.155D+03,0.29081000D+01,0.99090000D+00
     .,0.12167162D+04,0.382D+03,0.156D+03,0.29081000D+01,0.97970000D+00
     .,0.91391750D+03,0.382D+03,0.157D+03,0.29081000D+01,0.19373000D+01
     .,0.58172760D+03,0.382D+03,0.159D+03,0.29081000D+01,0.29425000D+01
     .,0.56972170D+03,0.382D+03,0.160D+03,0.29081000D+01,0.29455000D+01
     .,0.55175870D+03,0.382D+03,0.161D+03,0.29081000D+01,0.29413000D+01
     .,0.55422640D+03,0.382D+03,0.162D+03,0.29081000D+01,0.29300000D+01
     .,0.53359620D+03,0.382D+03,0.163D+03,0.29081000D+01,0.18286000D+01
     .,0.55760720D+03,0.382D+03,0.164D+03,0.29081000D+01,0.28732000D+01
     .,0.52397000D+03,0.382D+03,0.165D+03,0.29081000D+01,0.29086000D+01
     .,0.53273770D+03,0.382D+03,0.166D+03,0.29081000D+01,0.28965000D+01
     .,0.49751580D+03,0.382D+03,0.167D+03,0.29081000D+01,0.29242000D+01
     .,0.48340880D+03,0.382D+03,0.168D+03,0.29081000D+01,0.29282000D+01
     .,0.48024390D+03,0.382D+03,0.169D+03,0.29081000D+01,0.29246000D+01
     .,0.50441450D+03,0.382D+03,0.170D+03,0.29081000D+01,0.28482000D+01
     .,0.46426970D+03,0.382D+03,0.171D+03,0.29081000D+01,0.29219000D+01
     ./)
      grimme_c6_parameters( 152701: 152800)=(/
     . 0.62577080D+03,0.382D+03,0.172D+03,0.29081000D+01,0.19254000D+01
     .,0.58183450D+03,0.382D+03,0.173D+03,0.29081000D+01,0.19459000D+01
     .,0.53190280D+03,0.382D+03,0.174D+03,0.29081000D+01,0.19292000D+01
     .,0.53741510D+03,0.382D+03,0.175D+03,0.29081000D+01,0.18104000D+01
     .,0.47245060D+03,0.382D+03,0.176D+03,0.29081000D+01,0.18858000D+01
     .,0.44483850D+03,0.382D+03,0.177D+03,0.29081000D+01,0.18648000D+01
     .,0.42512390D+03,0.382D+03,0.178D+03,0.29081000D+01,0.19188000D+01
     .,0.40652810D+03,0.382D+03,0.179D+03,0.29081000D+01,0.98460000D+00
     .,0.39335910D+03,0.382D+03,0.180D+03,0.29081000D+01,0.19896000D+01
     .,0.62845220D+03,0.382D+03,0.181D+03,0.29081000D+01,0.92670000D+00
     .,0.57444200D+03,0.382D+03,0.182D+03,0.29081000D+01,0.93830000D+00
     .,0.55791660D+03,0.382D+03,0.183D+03,0.29081000D+01,0.98200000D+00
     .,0.54322420D+03,0.382D+03,0.184D+03,0.29081000D+01,0.98150000D+00
     .,0.50808860D+03,0.382D+03,0.185D+03,0.29081000D+01,0.99540000D+00
     .,0.64972250D+03,0.382D+03,0.187D+03,0.29081000D+01,0.97050000D+00
     .,0.12125054D+04,0.382D+03,0.188D+03,0.29081000D+01,0.96620000D+00
     .,0.68824310D+03,0.382D+03,0.189D+03,0.29081000D+01,0.29070000D+01
     .,0.79252420D+03,0.382D+03,0.190D+03,0.29081000D+01,0.28844000D+01
     .,0.70936470D+03,0.382D+03,0.191D+03,0.29081000D+01,0.28738000D+01
     .,0.62816270D+03,0.382D+03,0.192D+03,0.29081000D+01,0.28878000D+01
     ./)
      grimme_c6_parameters( 152801: 152900)=(/
     . 0.60477390D+03,0.382D+03,0.193D+03,0.29081000D+01,0.29095000D+01
     .,0.72374190D+03,0.382D+03,0.194D+03,0.29081000D+01,0.19209000D+01
     .,0.16920360D+03,0.382D+03,0.204D+03,0.29081000D+01,0.19697000D+01
     .,0.16658210D+03,0.382D+03,0.205D+03,0.29081000D+01,0.19441000D+01
     .,0.12253210D+03,0.382D+03,0.206D+03,0.29081000D+01,0.19985000D+01
     .,0.98442100D+02,0.382D+03,0.207D+03,0.29081000D+01,0.20143000D+01
     .,0.67767000D+02,0.382D+03,0.208D+03,0.29081000D+01,0.19887000D+01
     .,0.29929840D+03,0.382D+03,0.212D+03,0.29081000D+01,0.19496000D+01
     .,0.36151620D+03,0.382D+03,0.213D+03,0.29081000D+01,0.19311000D+01
     .,0.34761240D+03,0.382D+03,0.214D+03,0.29081000D+01,0.19435000D+01
     .,0.30275900D+03,0.382D+03,0.215D+03,0.29081000D+01,0.20102000D+01
     .,0.25504960D+03,0.382D+03,0.216D+03,0.29081000D+01,0.19903000D+01
     .,0.41985730D+03,0.382D+03,0.220D+03,0.29081000D+01,0.19349000D+01
     .,0.40420110D+03,0.382D+03,0.221D+03,0.29081000D+01,0.28999000D+01
     .,0.40925130D+03,0.382D+03,0.222D+03,0.29081000D+01,0.38675000D+01
     .,0.37462180D+03,0.382D+03,0.223D+03,0.29081000D+01,0.29110000D+01
     .,0.28320230D+03,0.382D+03,0.224D+03,0.29081000D+01,0.10619100D+02
     .,0.24283500D+03,0.382D+03,0.225D+03,0.29081000D+01,0.98849000D+01
     .,0.23833220D+03,0.382D+03,0.226D+03,0.29081000D+01,0.91376000D+01
     .,0.27849510D+03,0.382D+03,0.227D+03,0.29081000D+01,0.29263000D+01
     ./)
      grimme_c6_parameters( 152901: 153000)=(/
     . 0.25970610D+03,0.382D+03,0.228D+03,0.29081000D+01,0.65458000D+01
     .,0.36569310D+03,0.382D+03,0.231D+03,0.29081000D+01,0.19315000D+01
     .,0.38632290D+03,0.382D+03,0.232D+03,0.29081000D+01,0.19447000D+01
     .,0.35500350D+03,0.382D+03,0.233D+03,0.29081000D+01,0.19793000D+01
     .,0.33085020D+03,0.382D+03,0.234D+03,0.29081000D+01,0.19812000D+01
     .,0.50318910D+03,0.382D+03,0.238D+03,0.29081000D+01,0.19143000D+01
     .,0.48540080D+03,0.382D+03,0.239D+03,0.29081000D+01,0.28903000D+01
     .,0.48989620D+03,0.382D+03,0.240D+03,0.29081000D+01,0.39106000D+01
     .,0.47377460D+03,0.382D+03,0.241D+03,0.29081000D+01,0.29225000D+01
     .,0.41981260D+03,0.382D+03,0.242D+03,0.29081000D+01,0.11055600D+02
     .,0.37122640D+03,0.382D+03,0.243D+03,0.29081000D+01,0.95402000D+01
     .,0.35107190D+03,0.382D+03,0.244D+03,0.29081000D+01,0.88895000D+01
     .,0.35706620D+03,0.382D+03,0.245D+03,0.29081000D+01,0.29696000D+01
     .,0.37278680D+03,0.382D+03,0.246D+03,0.29081000D+01,0.57095000D+01
     .,0.47232770D+03,0.382D+03,0.249D+03,0.29081000D+01,0.19378000D+01
     .,0.51322190D+03,0.382D+03,0.250D+03,0.29081000D+01,0.19505000D+01
     .,0.48446450D+03,0.382D+03,0.251D+03,0.29081000D+01,0.19523000D+01
     .,0.46794670D+03,0.382D+03,0.252D+03,0.29081000D+01,0.19639000D+01
     .,0.60895860D+03,0.382D+03,0.256D+03,0.29081000D+01,0.18467000D+01
     .,0.63182890D+03,0.382D+03,0.257D+03,0.29081000D+01,0.29175000D+01
     ./)
      grimme_c6_parameters( 153001: 153100)=(/
     . 0.46949580D+03,0.382D+03,0.272D+03,0.29081000D+01,0.38840000D+01
     .,0.49006850D+03,0.382D+03,0.273D+03,0.29081000D+01,0.28988000D+01
     .,0.45612840D+03,0.382D+03,0.274D+03,0.29081000D+01,0.10915300D+02
     .,0.41497090D+03,0.382D+03,0.275D+03,0.29081000D+01,0.98054000D+01
     .,0.39089370D+03,0.382D+03,0.276D+03,0.29081000D+01,0.91527000D+01
     .,0.39804290D+03,0.382D+03,0.277D+03,0.29081000D+01,0.29424000D+01
     .,0.41852820D+03,0.382D+03,0.278D+03,0.29081000D+01,0.66669000D+01
     .,0.50537700D+03,0.382D+03,0.281D+03,0.29081000D+01,0.19302000D+01
     .,0.53408270D+03,0.382D+03,0.282D+03,0.29081000D+01,0.19356000D+01
     .,0.54469760D+03,0.382D+03,0.283D+03,0.29081000D+01,0.19655000D+01
     .,0.54102390D+03,0.382D+03,0.284D+03,0.29081000D+01,0.19639000D+01
     .,0.67046940D+03,0.382D+03,0.288D+03,0.29081000D+01,0.18075000D+01
     .,0.12713380D+03,0.382D+03,0.305D+03,0.29081000D+01,0.29128000D+01
     .,0.11469320D+03,0.382D+03,0.306D+03,0.29081000D+01,0.29987000D+01
     .,0.86806100D+02,0.382D+03,0.307D+03,0.29081000D+01,0.29903000D+01
     .,0.28266470D+03,0.382D+03,0.313D+03,0.29081000D+01,0.29146000D+01
     .,0.33866010D+03,0.382D+03,0.314D+03,0.29081000D+01,0.29407000D+01
     .,0.28113750D+03,0.382D+03,0.315D+03,0.29081000D+01,0.29859000D+01
     .,0.24847100D+03,0.382D+03,0.327D+03,0.29081000D+01,0.77785000D+01
     .,0.27223020D+03,0.382D+03,0.328D+03,0.29081000D+01,0.62918000D+01
     ./)
      grimme_c6_parameters( 153101: 153200)=(/
     . 0.30012720D+03,0.382D+03,0.331D+03,0.29081000D+01,0.29233000D+01
     .,0.34667580D+03,0.382D+03,0.332D+03,0.29081000D+01,0.29186000D+01
     .,0.34212760D+03,0.382D+03,0.333D+03,0.29081000D+01,0.29709000D+01
     .,0.40346440D+03,0.382D+03,0.349D+03,0.29081000D+01,0.29353000D+01
     .,0.46298340D+03,0.382D+03,0.350D+03,0.29081000D+01,0.29259000D+01
     .,0.46750670D+03,0.382D+03,0.351D+03,0.29081000D+01,0.29315000D+01
     .,0.45116740D+03,0.382D+03,0.381D+03,0.29081000D+01,0.29420000D+01
     .,0.52418400D+03,0.382D+03,0.382D+03,0.29081000D+01,0.29081000D+01
     .,0.39743800D+02,0.383D+03,0.100D+01,0.29500000D+01,0.91180000D+00
     .,0.26627800D+02,0.383D+03,0.200D+01,0.29500000D+01,0.00000000D+00
     .,0.58321980D+03,0.383D+03,0.300D+01,0.29500000D+01,0.00000000D+00
     .,0.34623830D+03,0.383D+03,0.400D+01,0.29500000D+01,0.00000000D+00
     .,0.23662000D+03,0.383D+03,0.500D+01,0.29500000D+01,0.00000000D+00
     .,0.16159220D+03,0.383D+03,0.600D+01,0.29500000D+01,0.00000000D+00
     .,0.11393640D+03,0.383D+03,0.700D+01,0.29500000D+01,0.00000000D+00
     .,0.86791400D+02,0.383D+03,0.800D+01,0.29500000D+01,0.00000000D+00
     .,0.66113100D+02,0.383D+03,0.900D+01,0.29500000D+01,0.00000000D+00
     .,0.51096100D+02,0.383D+03,0.100D+02,0.29500000D+01,0.00000000D+00
     .,0.69876860D+03,0.383D+03,0.110D+02,0.29500000D+01,0.00000000D+00
     .,0.54919660D+03,0.383D+03,0.120D+02,0.29500000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 153201: 153300)=(/
     . 0.51016460D+03,0.383D+03,0.130D+02,0.29500000D+01,0.00000000D+00
     .,0.40605930D+03,0.383D+03,0.140D+02,0.29500000D+01,0.00000000D+00
     .,0.31927240D+03,0.383D+03,0.150D+02,0.29500000D+01,0.00000000D+00
     .,0.26639090D+03,0.383D+03,0.160D+02,0.29500000D+01,0.00000000D+00
     .,0.21872080D+03,0.383D+03,0.170D+02,0.29500000D+01,0.00000000D+00
     .,0.17975600D+03,0.383D+03,0.180D+02,0.29500000D+01,0.00000000D+00
     .,0.11409307D+04,0.383D+03,0.190D+02,0.29500000D+01,0.00000000D+00
     .,0.95709360D+03,0.383D+03,0.200D+02,0.29500000D+01,0.00000000D+00
     .,0.79362090D+03,0.383D+03,0.210D+02,0.29500000D+01,0.00000000D+00
     .,0.76903960D+03,0.383D+03,0.220D+02,0.29500000D+01,0.00000000D+00
     .,0.70568530D+03,0.383D+03,0.230D+02,0.29500000D+01,0.00000000D+00
     .,0.55635380D+03,0.383D+03,0.240D+02,0.29500000D+01,0.00000000D+00
     .,0.60939430D+03,0.383D+03,0.250D+02,0.29500000D+01,0.00000000D+00
     .,0.47886060D+03,0.383D+03,0.260D+02,0.29500000D+01,0.00000000D+00
     .,0.50944850D+03,0.383D+03,0.270D+02,0.29500000D+01,0.00000000D+00
     .,0.52372160D+03,0.383D+03,0.280D+02,0.29500000D+01,0.00000000D+00
     .,0.40186070D+03,0.383D+03,0.290D+02,0.29500000D+01,0.00000000D+00
     .,0.41492100D+03,0.383D+03,0.300D+02,0.29500000D+01,0.00000000D+00
     .,0.49028010D+03,0.383D+03,0.310D+02,0.29500000D+01,0.00000000D+00
     .,0.43566600D+03,0.383D+03,0.320D+02,0.29500000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 153301: 153400)=(/
     . 0.37411390D+03,0.383D+03,0.330D+02,0.29500000D+01,0.00000000D+00
     .,0.33709110D+03,0.383D+03,0.340D+02,0.29500000D+01,0.00000000D+00
     .,0.29625040D+03,0.383D+03,0.350D+02,0.29500000D+01,0.00000000D+00
     .,0.25864890D+03,0.383D+03,0.360D+02,0.29500000D+01,0.00000000D+00
     .,0.12807871D+04,0.383D+03,0.370D+02,0.29500000D+01,0.00000000D+00
     .,0.11397642D+04,0.383D+03,0.380D+02,0.29500000D+01,0.00000000D+00
     .,0.10048393D+04,0.383D+03,0.390D+02,0.29500000D+01,0.00000000D+00
     .,0.90672570D+03,0.383D+03,0.400D+02,0.29500000D+01,0.00000000D+00
     .,0.82902620D+03,0.383D+03,0.410D+02,0.29500000D+01,0.00000000D+00
     .,0.64306490D+03,0.383D+03,0.420D+02,0.29500000D+01,0.00000000D+00
     .,0.71626640D+03,0.383D+03,0.430D+02,0.29500000D+01,0.00000000D+00
     .,0.54850410D+03,0.383D+03,0.440D+02,0.29500000D+01,0.00000000D+00
     .,0.59937630D+03,0.383D+03,0.450D+02,0.29500000D+01,0.00000000D+00
     .,0.55674870D+03,0.383D+03,0.460D+02,0.29500000D+01,0.00000000D+00
     .,0.46407170D+03,0.383D+03,0.470D+02,0.29500000D+01,0.00000000D+00
     .,0.49165550D+03,0.383D+03,0.480D+02,0.29500000D+01,0.00000000D+00
     .,0.61377870D+03,0.383D+03,0.490D+02,0.29500000D+01,0.00000000D+00
     .,0.57101580D+03,0.383D+03,0.500D+02,0.29500000D+01,0.00000000D+00
     .,0.51187060D+03,0.383D+03,0.510D+02,0.29500000D+01,0.00000000D+00
     .,0.47658080D+03,0.383D+03,0.520D+02,0.29500000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 153401: 153500)=(/
     . 0.43252650D+03,0.383D+03,0.530D+02,0.29500000D+01,0.00000000D+00
     .,0.39023930D+03,0.383D+03,0.540D+02,0.29500000D+01,0.00000000D+00
     .,0.15608728D+04,0.383D+03,0.550D+02,0.29500000D+01,0.00000000D+00
     .,0.14501356D+04,0.383D+03,0.560D+02,0.29500000D+01,0.00000000D+00
     .,0.12821300D+04,0.383D+03,0.570D+02,0.29500000D+01,0.00000000D+00
     .,0.60410230D+03,0.383D+03,0.580D+02,0.29500000D+01,0.27991000D+01
     .,0.12878172D+04,0.383D+03,0.590D+02,0.29500000D+01,0.00000000D+00
     .,0.12378955D+04,0.383D+03,0.600D+02,0.29500000D+01,0.00000000D+00
     .,0.12071956D+04,0.383D+03,0.610D+02,0.29500000D+01,0.00000000D+00
     .,0.11789199D+04,0.383D+03,0.620D+02,0.29500000D+01,0.00000000D+00
     .,0.11538573D+04,0.383D+03,0.630D+02,0.29500000D+01,0.00000000D+00
     .,0.91395230D+03,0.383D+03,0.640D+02,0.29500000D+01,0.00000000D+00
     .,0.10187768D+04,0.383D+03,0.650D+02,0.29500000D+01,0.00000000D+00
     .,0.98379020D+03,0.383D+03,0.660D+02,0.29500000D+01,0.00000000D+00
     .,0.10423525D+04,0.383D+03,0.670D+02,0.29500000D+01,0.00000000D+00
     .,0.10203958D+04,0.383D+03,0.680D+02,0.29500000D+01,0.00000000D+00
     .,0.10006811D+04,0.383D+03,0.690D+02,0.29500000D+01,0.00000000D+00
     .,0.98867650D+03,0.383D+03,0.700D+02,0.29500000D+01,0.00000000D+00
     .,0.83714090D+03,0.383D+03,0.710D+02,0.29500000D+01,0.00000000D+00
     .,0.82836360D+03,0.383D+03,0.720D+02,0.29500000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 153501: 153600)=(/
     . 0.75891210D+03,0.383D+03,0.730D+02,0.29500000D+01,0.00000000D+00
     .,0.64292980D+03,0.383D+03,0.740D+02,0.29500000D+01,0.00000000D+00
     .,0.65498530D+03,0.383D+03,0.750D+02,0.29500000D+01,0.00000000D+00
     .,0.59558850D+03,0.383D+03,0.760D+02,0.29500000D+01,0.00000000D+00
     .,0.54692440D+03,0.383D+03,0.770D+02,0.29500000D+01,0.00000000D+00
     .,0.45573730D+03,0.383D+03,0.780D+02,0.29500000D+01,0.00000000D+00
     .,0.42633520D+03,0.383D+03,0.790D+02,0.29500000D+01,0.00000000D+00
     .,0.43904410D+03,0.383D+03,0.800D+02,0.29500000D+01,0.00000000D+00
     .,0.63141780D+03,0.383D+03,0.810D+02,0.29500000D+01,0.00000000D+00
     .,0.62017920D+03,0.383D+03,0.820D+02,0.29500000D+01,0.00000000D+00
     .,0.57284430D+03,0.383D+03,0.830D+02,0.29500000D+01,0.00000000D+00
     .,0.54797510D+03,0.383D+03,0.840D+02,0.29500000D+01,0.00000000D+00
     .,0.50752580D+03,0.383D+03,0.850D+02,0.29500000D+01,0.00000000D+00
     .,0.46668040D+03,0.383D+03,0.860D+02,0.29500000D+01,0.00000000D+00
     .,0.14815226D+04,0.383D+03,0.870D+02,0.29500000D+01,0.00000000D+00
     .,0.14387553D+04,0.383D+03,0.880D+02,0.29500000D+01,0.00000000D+00
     .,0.12792885D+04,0.383D+03,0.890D+02,0.29500000D+01,0.00000000D+00
     .,0.11574185D+04,0.383D+03,0.900D+02,0.29500000D+01,0.00000000D+00
     .,0.11456007D+04,0.383D+03,0.910D+02,0.29500000D+01,0.00000000D+00
     .,0.11094582D+04,0.383D+03,0.920D+02,0.29500000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 153601: 153700)=(/
     . 0.11376821D+04,0.383D+03,0.930D+02,0.29500000D+01,0.00000000D+00
     .,0.11025605D+04,0.383D+03,0.940D+02,0.29500000D+01,0.00000000D+00
     .,0.63497600D+02,0.383D+03,0.101D+03,0.29500000D+01,0.00000000D+00
     .,0.20170420D+03,0.383D+03,0.103D+03,0.29500000D+01,0.98650000D+00
     .,0.25799550D+03,0.383D+03,0.104D+03,0.29500000D+01,0.98080000D+00
     .,0.19963690D+03,0.383D+03,0.105D+03,0.29500000D+01,0.97060000D+00
     .,0.15154880D+03,0.383D+03,0.106D+03,0.29500000D+01,0.98680000D+00
     .,0.10626960D+03,0.383D+03,0.107D+03,0.29500000D+01,0.99440000D+00
     .,0.77952800D+02,0.383D+03,0.108D+03,0.29500000D+01,0.99250000D+00
     .,0.54119700D+02,0.383D+03,0.109D+03,0.29500000D+01,0.99820000D+00
     .,0.29420730D+03,0.383D+03,0.111D+03,0.29500000D+01,0.96840000D+00
     .,0.45432800D+03,0.383D+03,0.112D+03,0.29500000D+01,0.96280000D+00
     .,0.46321330D+03,0.383D+03,0.113D+03,0.29500000D+01,0.96480000D+00
     .,0.37584780D+03,0.383D+03,0.114D+03,0.29500000D+01,0.95070000D+00
     .,0.31000460D+03,0.383D+03,0.115D+03,0.29500000D+01,0.99470000D+00
     .,0.26343270D+03,0.383D+03,0.116D+03,0.29500000D+01,0.99480000D+00
     .,0.21644080D+03,0.383D+03,0.117D+03,0.29500000D+01,0.99720000D+00
     .,0.40808240D+03,0.383D+03,0.119D+03,0.29500000D+01,0.97670000D+00
     .,0.76638090D+03,0.383D+03,0.120D+03,0.29500000D+01,0.98310000D+00
     .,0.41133690D+03,0.383D+03,0.121D+03,0.29500000D+01,0.18627000D+01
     ./)
      grimme_c6_parameters( 153701: 153800)=(/
     . 0.39725380D+03,0.383D+03,0.122D+03,0.29500000D+01,0.18299000D+01
     .,0.38928370D+03,0.383D+03,0.123D+03,0.29500000D+01,0.19138000D+01
     .,0.38534090D+03,0.383D+03,0.124D+03,0.29500000D+01,0.18269000D+01
     .,0.35616420D+03,0.383D+03,0.125D+03,0.29500000D+01,0.16406000D+01
     .,0.33009770D+03,0.383D+03,0.126D+03,0.29500000D+01,0.16483000D+01
     .,0.31492830D+03,0.383D+03,0.127D+03,0.29500000D+01,0.17149000D+01
     .,0.30778390D+03,0.383D+03,0.128D+03,0.29500000D+01,0.17937000D+01
     .,0.30308940D+03,0.383D+03,0.129D+03,0.29500000D+01,0.95760000D+00
     .,0.28611150D+03,0.383D+03,0.130D+03,0.29500000D+01,0.19419000D+01
     .,0.46138820D+03,0.383D+03,0.131D+03,0.29500000D+01,0.96010000D+00
     .,0.40830150D+03,0.383D+03,0.132D+03,0.29500000D+01,0.94340000D+00
     .,0.36791630D+03,0.383D+03,0.133D+03,0.29500000D+01,0.98890000D+00
     .,0.33720180D+03,0.383D+03,0.134D+03,0.29500000D+01,0.99010000D+00
     .,0.29824950D+03,0.383D+03,0.135D+03,0.29500000D+01,0.99740000D+00
     .,0.48781130D+03,0.383D+03,0.137D+03,0.29500000D+01,0.97380000D+00
     .,0.93186330D+03,0.383D+03,0.138D+03,0.29500000D+01,0.98010000D+00
     .,0.72138820D+03,0.383D+03,0.139D+03,0.29500000D+01,0.19153000D+01
     .,0.54373140D+03,0.383D+03,0.140D+03,0.29500000D+01,0.19355000D+01
     .,0.54904170D+03,0.383D+03,0.141D+03,0.29500000D+01,0.19545000D+01
     .,0.51286200D+03,0.383D+03,0.142D+03,0.29500000D+01,0.19420000D+01
     ./)
      grimme_c6_parameters( 153801: 153900)=(/
     . 0.57179580D+03,0.383D+03,0.143D+03,0.29500000D+01,0.16682000D+01
     .,0.44904810D+03,0.383D+03,0.144D+03,0.29500000D+01,0.18584000D+01
     .,0.42033540D+03,0.383D+03,0.145D+03,0.29500000D+01,0.19003000D+01
     .,0.39069990D+03,0.383D+03,0.146D+03,0.29500000D+01,0.18630000D+01
     .,0.37774640D+03,0.383D+03,0.147D+03,0.29500000D+01,0.96790000D+00
     .,0.37486870D+03,0.383D+03,0.148D+03,0.29500000D+01,0.19539000D+01
     .,0.58634250D+03,0.383D+03,0.149D+03,0.29500000D+01,0.96330000D+00
     .,0.53378120D+03,0.383D+03,0.150D+03,0.29500000D+01,0.95140000D+00
     .,0.50206010D+03,0.383D+03,0.151D+03,0.29500000D+01,0.97490000D+00
     .,0.47633350D+03,0.383D+03,0.152D+03,0.29500000D+01,0.98110000D+00
     .,0.43655340D+03,0.383D+03,0.153D+03,0.29500000D+01,0.99680000D+00
     .,0.57950930D+03,0.383D+03,0.155D+03,0.29500000D+01,0.99090000D+00
     .,0.12052309D+04,0.383D+03,0.156D+03,0.29500000D+01,0.97970000D+00
     .,0.91205970D+03,0.383D+03,0.157D+03,0.29500000D+01,0.19373000D+01
     .,0.58609720D+03,0.383D+03,0.159D+03,0.29500000D+01,0.29425000D+01
     .,0.57401590D+03,0.383D+03,0.160D+03,0.29500000D+01,0.29455000D+01
     .,0.55599730D+03,0.383D+03,0.161D+03,0.29500000D+01,0.29413000D+01
     .,0.55823140D+03,0.383D+03,0.162D+03,0.29500000D+01,0.29300000D+01
     .,0.53660520D+03,0.383D+03,0.163D+03,0.29500000D+01,0.18286000D+01
     .,0.56156960D+03,0.383D+03,0.164D+03,0.29500000D+01,0.28732000D+01
     ./)
      grimme_c6_parameters( 153901: 154000)=(/
     . 0.52788270D+03,0.383D+03,0.165D+03,0.29500000D+01,0.29086000D+01
     .,0.53626980D+03,0.383D+03,0.166D+03,0.29500000D+01,0.28965000D+01
     .,0.50142950D+03,0.383D+03,0.167D+03,0.29500000D+01,0.29242000D+01
     .,0.48728280D+03,0.383D+03,0.168D+03,0.29500000D+01,0.29282000D+01
     .,0.48403880D+03,0.383D+03,0.169D+03,0.29500000D+01,0.29246000D+01
     .,0.50809720D+03,0.383D+03,0.170D+03,0.29500000D+01,0.28482000D+01
     .,0.46804880D+03,0.383D+03,0.171D+03,0.29500000D+01,0.29219000D+01
     .,0.62749410D+03,0.383D+03,0.172D+03,0.29500000D+01,0.19254000D+01
     .,0.58451000D+03,0.383D+03,0.173D+03,0.29500000D+01,0.19459000D+01
     .,0.53534350D+03,0.383D+03,0.174D+03,0.29500000D+01,0.19292000D+01
     .,0.53996900D+03,0.383D+03,0.175D+03,0.29500000D+01,0.18104000D+01
     .,0.47674360D+03,0.383D+03,0.176D+03,0.29500000D+01,0.18858000D+01
     .,0.44912500D+03,0.383D+03,0.177D+03,0.29500000D+01,0.18648000D+01
     .,0.42935080D+03,0.383D+03,0.178D+03,0.29500000D+01,0.19188000D+01
     .,0.41050840D+03,0.383D+03,0.179D+03,0.29500000D+01,0.98460000D+00
     .,0.39782250D+03,0.383D+03,0.180D+03,0.29500000D+01,0.19896000D+01
     .,0.63050780D+03,0.383D+03,0.181D+03,0.29500000D+01,0.92670000D+00
     .,0.57817950D+03,0.383D+03,0.182D+03,0.29500000D+01,0.93830000D+00
     .,0.56250870D+03,0.383D+03,0.183D+03,0.29500000D+01,0.98200000D+00
     .,0.54834310D+03,0.383D+03,0.184D+03,0.29500000D+01,0.98150000D+00
     ./)
      grimme_c6_parameters( 154001: 154100)=(/
     . 0.51367500D+03,0.383D+03,0.185D+03,0.29500000D+01,0.99540000D+00
     .,0.65289240D+03,0.383D+03,0.187D+03,0.29500000D+01,0.97050000D+00
     .,0.12037016D+04,0.383D+03,0.188D+03,0.29500000D+01,0.96620000D+00
     .,0.69337750D+03,0.383D+03,0.189D+03,0.29500000D+01,0.29070000D+01
     .,0.79621000D+03,0.383D+03,0.190D+03,0.29500000D+01,0.28844000D+01
     .,0.71328770D+03,0.383D+03,0.191D+03,0.29500000D+01,0.28738000D+01
     .,0.63298840D+03,0.383D+03,0.192D+03,0.29500000D+01,0.28878000D+01
     .,0.60969380D+03,0.383D+03,0.193D+03,0.29500000D+01,0.29095000D+01
     .,0.72537520D+03,0.383D+03,0.194D+03,0.29500000D+01,0.19209000D+01
     .,0.17061220D+03,0.383D+03,0.204D+03,0.29500000D+01,0.19697000D+01
     .,0.16810260D+03,0.383D+03,0.205D+03,0.29500000D+01,0.19441000D+01
     .,0.12413050D+03,0.383D+03,0.206D+03,0.29500000D+01,0.19985000D+01
     .,0.99890200D+02,0.383D+03,0.207D+03,0.29500000D+01,0.20143000D+01
     .,0.68938900D+02,0.383D+03,0.208D+03,0.29500000D+01,0.19887000D+01
     .,0.30082770D+03,0.383D+03,0.212D+03,0.29500000D+01,0.19496000D+01
     .,0.36319850D+03,0.383D+03,0.213D+03,0.29500000D+01,0.19311000D+01
     .,0.35008330D+03,0.383D+03,0.214D+03,0.29500000D+01,0.19435000D+01
     .,0.30566690D+03,0.383D+03,0.215D+03,0.29500000D+01,0.20102000D+01
     .,0.25814020D+03,0.383D+03,0.216D+03,0.29500000D+01,0.19903000D+01
     .,0.42185200D+03,0.383D+03,0.220D+03,0.29500000D+01,0.19349000D+01
     ./)
      grimme_c6_parameters( 154101: 154200)=(/
     . 0.40692810D+03,0.383D+03,0.221D+03,0.29500000D+01,0.28999000D+01
     .,0.41206730D+03,0.383D+03,0.222D+03,0.29500000D+01,0.38675000D+01
     .,0.37711770D+03,0.383D+03,0.223D+03,0.29500000D+01,0.29110000D+01
     .,0.28588310D+03,0.383D+03,0.224D+03,0.29500000D+01,0.10619100D+02
     .,0.24556070D+03,0.383D+03,0.225D+03,0.29500000D+01,0.98849000D+01
     .,0.24095060D+03,0.383D+03,0.226D+03,0.29500000D+01,0.91376000D+01
     .,0.28076020D+03,0.383D+03,0.227D+03,0.29500000D+01,0.29263000D+01
     .,0.26203990D+03,0.383D+03,0.228D+03,0.29500000D+01,0.65458000D+01
     .,0.36803530D+03,0.383D+03,0.231D+03,0.29500000D+01,0.19315000D+01
     .,0.38919220D+03,0.383D+03,0.232D+03,0.29500000D+01,0.19447000D+01
     .,0.35850420D+03,0.383D+03,0.233D+03,0.29500000D+01,0.19793000D+01
     .,0.33459570D+03,0.383D+03,0.234D+03,0.29500000D+01,0.19812000D+01
     .,0.50567630D+03,0.383D+03,0.238D+03,0.29500000D+01,0.19143000D+01
     .,0.48906840D+03,0.383D+03,0.239D+03,0.29500000D+01,0.28903000D+01
     .,0.49395440D+03,0.383D+03,0.240D+03,0.29500000D+01,0.39106000D+01
     .,0.47754800D+03,0.383D+03,0.241D+03,0.29500000D+01,0.29225000D+01
     .,0.42396710D+03,0.383D+03,0.242D+03,0.29500000D+01,0.11055600D+02
     .,0.37545330D+03,0.383D+03,0.243D+03,0.29500000D+01,0.95402000D+01
     .,0.35525030D+03,0.383D+03,0.244D+03,0.29500000D+01,0.88895000D+01
     .,0.36064340D+03,0.383D+03,0.245D+03,0.29500000D+01,0.29696000D+01
     ./)
      grimme_c6_parameters( 154201: 154300)=(/
     . 0.37633490D+03,0.383D+03,0.246D+03,0.29500000D+01,0.57095000D+01
     .,0.47544030D+03,0.383D+03,0.249D+03,0.29500000D+01,0.19378000D+01
     .,0.51667410D+03,0.383D+03,0.250D+03,0.29500000D+01,0.19505000D+01
     .,0.48876370D+03,0.383D+03,0.251D+03,0.29500000D+01,0.19523000D+01
     .,0.47264780D+03,0.383D+03,0.252D+03,0.29500000D+01,0.19639000D+01
     .,0.61239630D+03,0.383D+03,0.256D+03,0.29500000D+01,0.18467000D+01
     .,0.63629250D+03,0.383D+03,0.257D+03,0.29500000D+01,0.29175000D+01
     .,0.47384040D+03,0.383D+03,0.272D+03,0.29500000D+01,0.38840000D+01
     .,0.49409450D+03,0.383D+03,0.273D+03,0.29500000D+01,0.28988000D+01
     .,0.46071470D+03,0.383D+03,0.274D+03,0.29500000D+01,0.10915300D+02
     .,0.41970150D+03,0.383D+03,0.275D+03,0.29500000D+01,0.98054000D+01
     .,0.39577380D+03,0.383D+03,0.276D+03,0.29500000D+01,0.91527000D+01
     .,0.40234540D+03,0.383D+03,0.277D+03,0.29500000D+01,0.29424000D+01
     .,0.42301710D+03,0.383D+03,0.278D+03,0.29500000D+01,0.66669000D+01
     .,0.50934070D+03,0.383D+03,0.281D+03,0.29500000D+01,0.19302000D+01
     .,0.53837690D+03,0.383D+03,0.282D+03,0.29500000D+01,0.19356000D+01
     .,0.54954870D+03,0.383D+03,0.283D+03,0.29500000D+01,0.19655000D+01
     .,0.54627450D+03,0.383D+03,0.284D+03,0.29500000D+01,0.19639000D+01
     .,0.67441620D+03,0.383D+03,0.288D+03,0.29500000D+01,0.18075000D+01
     .,0.12875890D+03,0.383D+03,0.305D+03,0.29500000D+01,0.29128000D+01
     ./)
      grimme_c6_parameters( 154301: 154400)=(/
     . 0.11617900D+03,0.383D+03,0.306D+03,0.29500000D+01,0.29987000D+01
     .,0.88102700D+02,0.383D+03,0.307D+03,0.29500000D+01,0.29903000D+01
     .,0.28508900D+03,0.383D+03,0.313D+03,0.29500000D+01,0.29146000D+01
     .,0.34088270D+03,0.383D+03,0.314D+03,0.29500000D+01,0.29407000D+01
     .,0.28413180D+03,0.383D+03,0.315D+03,0.29500000D+01,0.29859000D+01
     .,0.25096550D+03,0.383D+03,0.327D+03,0.29500000D+01,0.77785000D+01
     .,0.27414590D+03,0.383D+03,0.328D+03,0.29500000D+01,0.62918000D+01
     .,0.30303570D+03,0.383D+03,0.331D+03,0.29500000D+01,0.29233000D+01
     .,0.34976730D+03,0.383D+03,0.332D+03,0.29500000D+01,0.29186000D+01
     .,0.34567500D+03,0.383D+03,0.333D+03,0.29500000D+01,0.29709000D+01
     .,0.40735630D+03,0.383D+03,0.349D+03,0.29500000D+01,0.29353000D+01
     .,0.46691700D+03,0.383D+03,0.350D+03,0.29500000D+01,0.29259000D+01
     .,0.47196350D+03,0.383D+03,0.351D+03,0.29500000D+01,0.29315000D+01
     .,0.45575440D+03,0.383D+03,0.381D+03,0.29500000D+01,0.29420000D+01
     .,0.52876490D+03,0.383D+03,0.382D+03,0.29500000D+01,0.29081000D+01
     .,0.53388100D+03,0.383D+03,0.383D+03,0.29500000D+01,0.29500000D+01
     .,0.92092000D+01,0.405D+03,0.100D+01,0.45856000D+01,0.91180000D+00
     .,0.63181000D+01,0.405D+03,0.200D+01,0.45856000D+01,0.00000000D+00
     .,0.12066280D+03,0.405D+03,0.300D+01,0.45856000D+01,0.00000000D+00
     .,0.75131100D+02,0.405D+03,0.400D+01,0.45856000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 154401: 154500)=(/
     . 0.52960600D+02,0.405D+03,0.500D+01,0.45856000D+01,0.00000000D+00
     .,0.37004200D+02,0.405D+03,0.600D+01,0.45856000D+01,0.00000000D+00
     .,0.26508300D+02,0.405D+03,0.700D+01,0.45856000D+01,0.00000000D+00
     .,0.20399800D+02,0.405D+03,0.800D+01,0.45856000D+01,0.00000000D+00
     .,0.15657800D+02,0.405D+03,0.900D+01,0.45856000D+01,0.00000000D+00
     .,0.12160800D+02,0.405D+03,0.100D+02,0.45856000D+01,0.00000000D+00
     .,0.14500200D+03,0.405D+03,0.110D+02,0.45856000D+01,0.00000000D+00
     .,0.11807480D+03,0.405D+03,0.120D+02,0.45856000D+01,0.00000000D+00
     .,0.11143770D+03,0.405D+03,0.130D+02,0.45856000D+01,0.00000000D+00
     .,0.90574000D+02,0.405D+03,0.140D+02,0.45856000D+01,0.00000000D+00
     .,0.72514500D+02,0.405D+03,0.150D+02,0.45856000D+01,0.00000000D+00
     .,0.61218400D+02,0.405D+03,0.160D+02,0.45856000D+01,0.00000000D+00
     .,0.50810200D+02,0.405D+03,0.170D+02,0.45856000D+01,0.00000000D+00
     .,0.42132400D+02,0.405D+03,0.180D+02,0.45856000D+01,0.00000000D+00
     .,0.23618020D+03,0.405D+03,0.190D+02,0.45856000D+01,0.00000000D+00
     .,0.20306790D+03,0.405D+03,0.200D+02,0.45856000D+01,0.00000000D+00
     .,0.16941860D+03,0.405D+03,0.210D+02,0.45856000D+01,0.00000000D+00
     .,0.16529120D+03,0.405D+03,0.220D+02,0.45856000D+01,0.00000000D+00
     .,0.15225000D+03,0.405D+03,0.230D+02,0.45856000D+01,0.00000000D+00
     .,0.12032780D+03,0.405D+03,0.240D+02,0.45856000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 154501: 154600)=(/
     . 0.13219840D+03,0.405D+03,0.250D+02,0.45856000D+01,0.00000000D+00
     .,0.10419900D+03,0.405D+03,0.260D+02,0.45856000D+01,0.00000000D+00
     .,0.11150630D+03,0.405D+03,0.270D+02,0.45856000D+01,0.00000000D+00
     .,0.11415060D+03,0.405D+03,0.280D+02,0.45856000D+01,0.00000000D+00
     .,0.87805200D+02,0.405D+03,0.290D+02,0.45856000D+01,0.00000000D+00
     .,0.91572800D+02,0.405D+03,0.300D+02,0.45856000D+01,0.00000000D+00
     .,0.10787050D+03,0.405D+03,0.310D+02,0.45856000D+01,0.00000000D+00
     .,0.97349000D+02,0.405D+03,0.320D+02,0.45856000D+01,0.00000000D+00
     .,0.84829800D+02,0.405D+03,0.330D+02,0.45856000D+01,0.00000000D+00
     .,0.77153300D+02,0.405D+03,0.340D+02,0.45856000D+01,0.00000000D+00
     .,0.68441600D+02,0.405D+03,0.350D+02,0.45856000D+01,0.00000000D+00
     .,0.60254400D+02,0.405D+03,0.360D+02,0.45856000D+01,0.00000000D+00
     .,0.26610180D+03,0.405D+03,0.370D+02,0.45856000D+01,0.00000000D+00
     .,0.24185040D+03,0.405D+03,0.380D+02,0.45856000D+01,0.00000000D+00
     .,0.21572630D+03,0.405D+03,0.390D+02,0.45856000D+01,0.00000000D+00
     .,0.19615430D+03,0.405D+03,0.400D+02,0.45856000D+01,0.00000000D+00
     .,0.18030420D+03,0.405D+03,0.410D+02,0.45856000D+01,0.00000000D+00
     .,0.14125220D+03,0.405D+03,0.420D+02,0.45856000D+01,0.00000000D+00
     .,0.15672560D+03,0.405D+03,0.430D+02,0.45856000D+01,0.00000000D+00
     .,0.12128760D+03,0.405D+03,0.440D+02,0.45856000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 154601: 154700)=(/
     . 0.13232810D+03,0.405D+03,0.450D+02,0.45856000D+01,0.00000000D+00
     .,0.12329130D+03,0.405D+03,0.460D+02,0.45856000D+01,0.00000000D+00
     .,0.10277530D+03,0.405D+03,0.470D+02,0.45856000D+01,0.00000000D+00
     .,0.10928870D+03,0.405D+03,0.480D+02,0.45856000D+01,0.00000000D+00
     .,0.13508140D+03,0.405D+03,0.490D+02,0.45856000D+01,0.00000000D+00
     .,0.12715210D+03,0.405D+03,0.500D+02,0.45856000D+01,0.00000000D+00
     .,0.11540180D+03,0.405D+03,0.510D+02,0.45856000D+01,0.00000000D+00
     .,0.10829220D+03,0.405D+03,0.520D+02,0.45856000D+01,0.00000000D+00
     .,0.99110900D+02,0.405D+03,0.530D+02,0.45856000D+01,0.00000000D+00
     .,0.90129600D+02,0.405D+03,0.540D+02,0.45856000D+01,0.00000000D+00
     .,0.32498720D+03,0.405D+03,0.550D+02,0.45856000D+01,0.00000000D+00
     .,0.30696860D+03,0.405D+03,0.560D+02,0.45856000D+01,0.00000000D+00
     .,0.27449320D+03,0.405D+03,0.570D+02,0.45856000D+01,0.00000000D+00
     .,0.13602870D+03,0.405D+03,0.580D+02,0.45856000D+01,0.27991000D+01
     .,0.27357430D+03,0.405D+03,0.590D+02,0.45856000D+01,0.00000000D+00
     .,0.26338860D+03,0.405D+03,0.600D+02,0.45856000D+01,0.00000000D+00
     .,0.25696540D+03,0.405D+03,0.610D+02,0.45856000D+01,0.00000000D+00
     .,0.25103460D+03,0.405D+03,0.620D+02,0.45856000D+01,0.00000000D+00
     .,0.24578320D+03,0.405D+03,0.630D+02,0.45856000D+01,0.00000000D+00
     .,0.19745530D+03,0.405D+03,0.640D+02,0.45856000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 154701: 154800)=(/
     . 0.21647080D+03,0.405D+03,0.650D+02,0.45856000D+01,0.00000000D+00
     .,0.20953600D+03,0.405D+03,0.660D+02,0.45856000D+01,0.00000000D+00
     .,0.22258700D+03,0.405D+03,0.670D+02,0.45856000D+01,0.00000000D+00
     .,0.21794160D+03,0.405D+03,0.680D+02,0.45856000D+01,0.00000000D+00
     .,0.21381010D+03,0.405D+03,0.690D+02,0.45856000D+01,0.00000000D+00
     .,0.21110760D+03,0.405D+03,0.700D+02,0.45856000D+01,0.00000000D+00
     .,0.18048560D+03,0.405D+03,0.710D+02,0.45856000D+01,0.00000000D+00
     .,0.18074340D+03,0.405D+03,0.720D+02,0.45856000D+01,0.00000000D+00
     .,0.16687410D+03,0.405D+03,0.730D+02,0.45856000D+01,0.00000000D+00
     .,0.14241400D+03,0.405D+03,0.740D+02,0.45856000D+01,0.00000000D+00
     .,0.14542480D+03,0.405D+03,0.750D+02,0.45856000D+01,0.00000000D+00
     .,0.13310380D+03,0.405D+03,0.760D+02,0.45856000D+01,0.00000000D+00
     .,0.12287620D+03,0.405D+03,0.770D+02,0.45856000D+01,0.00000000D+00
     .,0.10304210D+03,0.405D+03,0.780D+02,0.45856000D+01,0.00000000D+00
     .,0.96613000D+02,0.405D+03,0.790D+02,0.45856000D+01,0.00000000D+00
     .,0.99656100D+02,0.405D+03,0.800D+02,0.45856000D+01,0.00000000D+00
     .,0.13964810D+03,0.405D+03,0.810D+02,0.45856000D+01,0.00000000D+00
     .,0.13828410D+03,0.405D+03,0.820D+02,0.45856000D+01,0.00000000D+00
     .,0.12908340D+03,0.405D+03,0.830D+02,0.45856000D+01,0.00000000D+00
     .,0.12428020D+03,0.405D+03,0.840D+02,0.45856000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 154801: 154900)=(/
     . 0.11600970D+03,0.405D+03,0.850D+02,0.45856000D+01,0.00000000D+00
     .,0.10744210D+03,0.405D+03,0.860D+02,0.45856000D+01,0.00000000D+00
     .,0.31132220D+03,0.405D+03,0.870D+02,0.45856000D+01,0.00000000D+00
     .,0.30650670D+03,0.405D+03,0.880D+02,0.45856000D+01,0.00000000D+00
     .,0.27521710D+03,0.405D+03,0.890D+02,0.45856000D+01,0.00000000D+00
     .,0.25216490D+03,0.405D+03,0.900D+02,0.45856000D+01,0.00000000D+00
     .,0.24821560D+03,0.405D+03,0.910D+02,0.45856000D+01,0.00000000D+00
     .,0.24044920D+03,0.405D+03,0.920D+02,0.45856000D+01,0.00000000D+00
     .,0.24457260D+03,0.405D+03,0.930D+02,0.45856000D+01,0.00000000D+00
     .,0.23732770D+03,0.405D+03,0.940D+02,0.45856000D+01,0.00000000D+00
     .,0.14454100D+02,0.405D+03,0.101D+03,0.45856000D+01,0.00000000D+00
     .,0.43974600D+02,0.405D+03,0.103D+03,0.45856000D+01,0.98650000D+00
     .,0.56652700D+02,0.405D+03,0.104D+03,0.45856000D+01,0.98080000D+00
     .,0.44988800D+02,0.405D+03,0.105D+03,0.45856000D+01,0.97060000D+00
     .,0.34722600D+02,0.405D+03,0.106D+03,0.45856000D+01,0.98680000D+00
     .,0.24752500D+02,0.405D+03,0.107D+03,0.45856000D+01,0.99440000D+00
     .,0.18383100D+02,0.405D+03,0.108D+03,0.45856000D+01,0.99250000D+00
     .,0.12929100D+02,0.405D+03,0.109D+03,0.45856000D+01,0.99820000D+00
     .,0.63812300D+02,0.405D+03,0.111D+03,0.45856000D+01,0.96840000D+00
     .,0.98372400D+02,0.405D+03,0.112D+03,0.45856000D+01,0.96280000D+00
     ./)
      grimme_c6_parameters( 154901: 155000)=(/
     . 0.10158890D+03,0.405D+03,0.113D+03,0.45856000D+01,0.96480000D+00
     .,0.84115800D+02,0.405D+03,0.114D+03,0.45856000D+01,0.95070000D+00
     .,0.70462900D+02,0.405D+03,0.115D+03,0.45856000D+01,0.99470000D+00
     .,0.60525500D+02,0.405D+03,0.116D+03,0.45856000D+01,0.99480000D+00
     .,0.50270800D+02,0.405D+03,0.117D+03,0.45856000D+01,0.99720000D+00
     .,0.89856900D+02,0.405D+03,0.119D+03,0.45856000D+01,0.97670000D+00
     .,0.16335340D+03,0.405D+03,0.120D+03,0.45856000D+01,0.98310000D+00
     .,0.91795100D+02,0.405D+03,0.121D+03,0.45856000D+01,0.18627000D+01
     .,0.88738900D+02,0.405D+03,0.122D+03,0.45856000D+01,0.18299000D+01
     .,0.86926400D+02,0.405D+03,0.123D+03,0.45856000D+01,0.19138000D+01
     .,0.85880600D+02,0.405D+03,0.124D+03,0.45856000D+01,0.18269000D+01
     .,0.80037500D+02,0.405D+03,0.125D+03,0.45856000D+01,0.16406000D+01
     .,0.74393000D+02,0.405D+03,0.126D+03,0.45856000D+01,0.16483000D+01
     .,0.70987100D+02,0.405D+03,0.127D+03,0.45856000D+01,0.17149000D+01
     .,0.69319400D+02,0.405D+03,0.128D+03,0.45856000D+01,0.17937000D+01
     .,0.67783500D+02,0.405D+03,0.129D+03,0.45856000D+01,0.95760000D+00
     .,0.64779800D+02,0.405D+03,0.130D+03,0.45856000D+01,0.19419000D+01
     .,0.10192230D+03,0.405D+03,0.131D+03,0.45856000D+01,0.96010000D+00
     .,0.91589500D+02,0.405D+03,0.132D+03,0.45856000D+01,0.94340000D+00
     .,0.83502300D+02,0.405D+03,0.133D+03,0.45856000D+01,0.98890000D+00
     ./)
      grimme_c6_parameters( 155001: 155100)=(/
     . 0.77170000D+02,0.405D+03,0.134D+03,0.45856000D+01,0.99010000D+00
     .,0.68871400D+02,0.405D+03,0.135D+03,0.45856000D+01,0.99740000D+00
     .,0.10786680D+03,0.405D+03,0.137D+03,0.45856000D+01,0.97380000D+00
     .,0.19856600D+03,0.405D+03,0.138D+03,0.45856000D+01,0.98010000D+00
     .,0.15735980D+03,0.405D+03,0.139D+03,0.45856000D+01,0.19153000D+01
     .,0.12138420D+03,0.405D+03,0.140D+03,0.45856000D+01,0.19355000D+01
     .,0.12250750D+03,0.405D+03,0.141D+03,0.45856000D+01,0.19545000D+01
     .,0.11484620D+03,0.405D+03,0.142D+03,0.45856000D+01,0.19420000D+01
     .,0.12665710D+03,0.405D+03,0.143D+03,0.45856000D+01,0.16682000D+01
     .,0.10138250D+03,0.405D+03,0.144D+03,0.45856000D+01,0.18584000D+01
     .,0.94998700D+02,0.405D+03,0.145D+03,0.45856000D+01,0.19003000D+01
     .,0.88451500D+02,0.405D+03,0.146D+03,0.45856000D+01,0.18630000D+01
     .,0.85377300D+02,0.405D+03,0.147D+03,0.45856000D+01,0.96790000D+00
     .,0.85227400D+02,0.405D+03,0.148D+03,0.45856000D+01,0.19539000D+01
     .,0.12959790D+03,0.405D+03,0.149D+03,0.45856000D+01,0.96330000D+00
     .,0.11945590D+03,0.405D+03,0.150D+03,0.45856000D+01,0.95140000D+00
     .,0.11338670D+03,0.405D+03,0.151D+03,0.45856000D+01,0.97490000D+00
     .,0.10828980D+03,0.405D+03,0.152D+03,0.45856000D+01,0.98110000D+00
     .,0.10002100D+03,0.405D+03,0.153D+03,0.45856000D+01,0.99680000D+00
     .,0.12944610D+03,0.405D+03,0.155D+03,0.45856000D+01,0.99090000D+00
     ./)
      grimme_c6_parameters( 155101: 155200)=(/
     . 0.25605470D+03,0.405D+03,0.156D+03,0.45856000D+01,0.97970000D+00
     .,0.19871970D+03,0.405D+03,0.157D+03,0.45856000D+01,0.19373000D+01
     .,0.13207060D+03,0.405D+03,0.159D+03,0.45856000D+01,0.29425000D+01
     .,0.12936140D+03,0.405D+03,0.160D+03,0.45856000D+01,0.29455000D+01
     .,0.12538070D+03,0.405D+03,0.161D+03,0.45856000D+01,0.29413000D+01
     .,0.12566750D+03,0.405D+03,0.162D+03,0.45856000D+01,0.29300000D+01
     .,0.12008750D+03,0.405D+03,0.163D+03,0.45856000D+01,0.18286000D+01
     .,0.12632050D+03,0.405D+03,0.164D+03,0.45856000D+01,0.28732000D+01
     .,0.11891980D+03,0.405D+03,0.165D+03,0.45856000D+01,0.29086000D+01
     .,0.12044740D+03,0.405D+03,0.166D+03,0.45856000D+01,0.28965000D+01
     .,0.11313110D+03,0.405D+03,0.167D+03,0.45856000D+01,0.29242000D+01
     .,0.11000160D+03,0.405D+03,0.168D+03,0.45856000D+01,0.29282000D+01
     .,0.10921440D+03,0.405D+03,0.169D+03,0.45856000D+01,0.29246000D+01
     .,0.11430830D+03,0.405D+03,0.170D+03,0.45856000D+01,0.28482000D+01
     .,0.10569650D+03,0.405D+03,0.171D+03,0.45856000D+01,0.29219000D+01
     .,0.13894310D+03,0.405D+03,0.172D+03,0.45856000D+01,0.19254000D+01
     .,0.13037550D+03,0.405D+03,0.173D+03,0.45856000D+01,0.19459000D+01
     .,0.12030200D+03,0.405D+03,0.174D+03,0.45856000D+01,0.19292000D+01
     .,0.12054080D+03,0.405D+03,0.175D+03,0.45856000D+01,0.18104000D+01
     .,0.10824460D+03,0.405D+03,0.176D+03,0.45856000D+01,0.18858000D+01
     ./)
      grimme_c6_parameters( 155201: 155300)=(/
     . 0.10224360D+03,0.405D+03,0.177D+03,0.45856000D+01,0.18648000D+01
     .,0.97889800D+02,0.405D+03,0.178D+03,0.45856000D+01,0.19188000D+01
     .,0.93574800D+02,0.405D+03,0.179D+03,0.45856000D+01,0.98460000D+00
     .,0.91193000D+02,0.405D+03,0.180D+03,0.45856000D+01,0.19896000D+01
     .,0.13986370D+03,0.405D+03,0.181D+03,0.45856000D+01,0.92670000D+00
     .,0.12975270D+03,0.405D+03,0.182D+03,0.45856000D+01,0.93830000D+00
     .,0.12706290D+03,0.405D+03,0.183D+03,0.45856000D+01,0.98200000D+00
     .,0.12448510D+03,0.405D+03,0.184D+03,0.45856000D+01,0.98150000D+00
     .,0.11742660D+03,0.405D+03,0.185D+03,0.45856000D+01,0.99540000D+00
     .,0.14593990D+03,0.405D+03,0.187D+03,0.45856000D+01,0.97050000D+00
     .,0.25758460D+03,0.405D+03,0.188D+03,0.45856000D+01,0.96620000D+00
     .,0.15618080D+03,0.405D+03,0.189D+03,0.45856000D+01,0.29070000D+01
     .,0.17763750D+03,0.405D+03,0.190D+03,0.45856000D+01,0.28844000D+01
     .,0.15984520D+03,0.405D+03,0.191D+03,0.45856000D+01,0.28738000D+01
     .,0.14284510D+03,0.405D+03,0.192D+03,0.45856000D+01,0.28878000D+01
     .,0.13782260D+03,0.405D+03,0.193D+03,0.45856000D+01,0.29095000D+01
     .,0.16054880D+03,0.405D+03,0.194D+03,0.45856000D+01,0.19209000D+01
     .,0.38474500D+02,0.405D+03,0.204D+03,0.45856000D+01,0.19697000D+01
     .,0.38139800D+02,0.405D+03,0.205D+03,0.45856000D+01,0.19441000D+01
     .,0.28676300D+02,0.405D+03,0.206D+03,0.45856000D+01,0.19985000D+01
     ./)
      grimme_c6_parameters( 155301: 155400)=(/
     . 0.23290000D+02,0.405D+03,0.207D+03,0.45856000D+01,0.20143000D+01
     .,0.16298700D+02,0.405D+03,0.208D+03,0.45856000D+01,0.19887000D+01
     .,0.66869600D+02,0.405D+03,0.212D+03,0.45856000D+01,0.19496000D+01
     .,0.80700500D+02,0.405D+03,0.213D+03,0.45856000D+01,0.19311000D+01
     .,0.78583500D+02,0.405D+03,0.214D+03,0.45856000D+01,0.19435000D+01
     .,0.69411500D+02,0.405D+03,0.215D+03,0.45856000D+01,0.20102000D+01
     .,0.59323900D+02,0.405D+03,0.216D+03,0.45856000D+01,0.19903000D+01
     .,0.93919400D+02,0.405D+03,0.220D+03,0.45856000D+01,0.19349000D+01
     .,0.91307200D+02,0.405D+03,0.221D+03,0.45856000D+01,0.28999000D+01
     .,0.92515400D+02,0.405D+03,0.222D+03,0.45856000D+01,0.38675000D+01
     .,0.84657000D+02,0.405D+03,0.223D+03,0.45856000D+01,0.29110000D+01
     .,0.65034900D+02,0.405D+03,0.224D+03,0.45856000D+01,0.10619100D+02
     .,0.56292100D+02,0.405D+03,0.225D+03,0.45856000D+01,0.98849000D+01
     .,0.55169800D+02,0.405D+03,0.226D+03,0.45856000D+01,0.91376000D+01
     .,0.63454300D+02,0.405D+03,0.227D+03,0.45856000D+01,0.29263000D+01
     .,0.59424700D+02,0.405D+03,0.228D+03,0.45856000D+01,0.65458000D+01
     .,0.82444700D+02,0.405D+03,0.231D+03,0.45856000D+01,0.19315000D+01
     .,0.87528200D+02,0.405D+03,0.232D+03,0.45856000D+01,0.19447000D+01
     .,0.81489600D+02,0.405D+03,0.233D+03,0.45856000D+01,0.19793000D+01
     .,0.76593900D+02,0.405D+03,0.234D+03,0.45856000D+01,0.19812000D+01
     ./)
      grimme_c6_parameters( 155401: 155500)=(/
     . 0.11280930D+03,0.405D+03,0.238D+03,0.45856000D+01,0.19143000D+01
     .,0.11017370D+03,0.405D+03,0.239D+03,0.45856000D+01,0.28903000D+01
     .,0.11160800D+03,0.405D+03,0.240D+03,0.45856000D+01,0.39106000D+01
     .,0.10787110D+03,0.405D+03,0.241D+03,0.45856000D+01,0.29225000D+01
     .,0.96603000D+02,0.405D+03,0.242D+03,0.45856000D+01,0.11055600D+02
     .,0.86127600D+02,0.405D+03,0.243D+03,0.45856000D+01,0.95402000D+01
     .,0.81685300D+02,0.405D+03,0.244D+03,0.45856000D+01,0.88895000D+01
     .,0.82288700D+02,0.405D+03,0.245D+03,0.45856000D+01,0.29696000D+01
     .,0.85628100D+02,0.405D+03,0.246D+03,0.45856000D+01,0.57095000D+01
     .,0.10669460D+03,0.405D+03,0.249D+03,0.45856000D+01,0.19378000D+01
     .,0.11592860D+03,0.405D+03,0.250D+03,0.45856000D+01,0.19505000D+01
     .,0.11062760D+03,0.405D+03,0.251D+03,0.45856000D+01,0.19523000D+01
     .,0.10754340D+03,0.405D+03,0.252D+03,0.45856000D+01,0.19639000D+01
     .,0.13712500D+03,0.405D+03,0.256D+03,0.45856000D+01,0.18467000D+01
     .,0.14310680D+03,0.405D+03,0.257D+03,0.45856000D+01,0.29175000D+01
     .,0.10750530D+03,0.405D+03,0.272D+03,0.45856000D+01,0.38840000D+01
     .,0.11175770D+03,0.405D+03,0.273D+03,0.45856000D+01,0.28988000D+01
     .,0.10503500D+03,0.405D+03,0.274D+03,0.45856000D+01,0.10915300D+02
     .,0.96275900D+02,0.405D+03,0.275D+03,0.45856000D+01,0.98054000D+01
     .,0.91232500D+02,0.405D+03,0.276D+03,0.45856000D+01,0.91527000D+01
     ./)
      grimme_c6_parameters( 155501: 155600)=(/
     . 0.92145800D+02,0.405D+03,0.277D+03,0.45856000D+01,0.29424000D+01
     .,0.96759100D+02,0.405D+03,0.278D+03,0.45856000D+01,0.66669000D+01
     .,0.11499010D+03,0.405D+03,0.281D+03,0.45856000D+01,0.19302000D+01
     .,0.12156000D+03,0.405D+03,0.282D+03,0.45856000D+01,0.19356000D+01
     .,0.12447110D+03,0.405D+03,0.283D+03,0.45856000D+01,0.19655000D+01
     .,0.12415670D+03,0.405D+03,0.284D+03,0.45856000D+01,0.19639000D+01
     .,0.15117960D+03,0.405D+03,0.288D+03,0.45856000D+01,0.18075000D+01
     .,0.29680400D+02,0.405D+03,0.305D+03,0.45856000D+01,0.29128000D+01
     .,0.26850600D+02,0.405D+03,0.306D+03,0.45856000D+01,0.29987000D+01
     .,0.20588600D+02,0.405D+03,0.307D+03,0.45856000D+01,0.29903000D+01
     .,0.64333200D+02,0.405D+03,0.313D+03,0.45856000D+01,0.29146000D+01
     .,0.76403800D+02,0.405D+03,0.314D+03,0.45856000D+01,0.29407000D+01
     .,0.64812700D+02,0.405D+03,0.315D+03,0.45856000D+01,0.29859000D+01
     .,0.57198700D+02,0.405D+03,0.327D+03,0.45856000D+01,0.77785000D+01
     .,0.61697400D+02,0.405D+03,0.328D+03,0.45856000D+01,0.62918000D+01
     .,0.68793500D+02,0.405D+03,0.331D+03,0.45856000D+01,0.29233000D+01
     .,0.79165600D+02,0.405D+03,0.332D+03,0.45856000D+01,0.29186000D+01
     .,0.78747800D+02,0.405D+03,0.333D+03,0.45856000D+01,0.29709000D+01
     .,0.92535500D+02,0.405D+03,0.349D+03,0.45856000D+01,0.29353000D+01
     .,0.10552950D+03,0.405D+03,0.350D+03,0.45856000D+01,0.29259000D+01
     ./)
      grimme_c6_parameters( 155601: 155700)=(/
     . 0.10712000D+03,0.405D+03,0.351D+03,0.45856000D+01,0.29315000D+01
     .,0.10385430D+03,0.405D+03,0.381D+03,0.45856000D+01,0.29420000D+01
     .,0.11970710D+03,0.405D+03,0.382D+03,0.45856000D+01,0.29081000D+01
     .,0.12129570D+03,0.405D+03,0.383D+03,0.45856000D+01,0.29500000D+01
     .,0.28031500D+02,0.405D+03,0.405D+03,0.45856000D+01,0.45856000D+01
     .,0.73662000D+01,0.406D+03,0.100D+01,0.39844000D+01,0.91180000D+00
     .,0.52567000D+01,0.406D+03,0.200D+01,0.39844000D+01,0.00000000D+00
     .,0.87818300D+02,0.406D+03,0.300D+01,0.39844000D+01,0.00000000D+00
     .,0.56466200D+02,0.406D+03,0.400D+01,0.39844000D+01,0.00000000D+00
     .,0.40896200D+02,0.406D+03,0.500D+01,0.39844000D+01,0.00000000D+00
     .,0.29283000D+02,0.406D+03,0.600D+01,0.39844000D+01,0.00000000D+00
     .,0.21419900D+02,0.406D+03,0.700D+01,0.39844000D+01,0.00000000D+00
     .,0.16754400D+02,0.406D+03,0.800D+01,0.39844000D+01,0.00000000D+00
     .,0.13054600D+02,0.406D+03,0.900D+01,0.39844000D+01,0.00000000D+00
     .,0.10271600D+02,0.406D+03,0.100D+02,0.39844000D+01,0.00000000D+00
     .,0.10592480D+03,0.406D+03,0.110D+02,0.39844000D+01,0.00000000D+00
     .,0.88262000D+02,0.406D+03,0.120D+02,0.39844000D+01,0.00000000D+00
     .,0.84307300D+02,0.406D+03,0.130D+02,0.39844000D+01,0.00000000D+00
     .,0.69722400D+02,0.406D+03,0.140D+02,0.39844000D+01,0.00000000D+00
     .,0.56785200D+02,0.406D+03,0.150D+02,0.39844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 155701: 155800)=(/
     . 0.48568100D+02,0.406D+03,0.160D+02,0.39844000D+01,0.00000000D+00
     .,0.40851600D+02,0.406D+03,0.170D+02,0.39844000D+01,0.00000000D+00
     .,0.34305000D+02,0.406D+03,0.180D+02,0.39844000D+01,0.00000000D+00
     .,0.17296850D+03,0.406D+03,0.190D+02,0.39844000D+01,0.00000000D+00
     .,0.15082030D+03,0.406D+03,0.200D+02,0.39844000D+01,0.00000000D+00
     .,0.12634910D+03,0.406D+03,0.210D+02,0.39844000D+01,0.00000000D+00
     .,0.12400130D+03,0.406D+03,0.220D+02,0.39844000D+01,0.00000000D+00
     .,0.11458700D+03,0.406D+03,0.230D+02,0.39844000D+01,0.00000000D+00
     .,0.91023300D+02,0.406D+03,0.240D+02,0.39844000D+01,0.00000000D+00
     .,0.99976800D+02,0.406D+03,0.250D+02,0.39844000D+01,0.00000000D+00
     .,0.79263000D+02,0.406D+03,0.260D+02,0.39844000D+01,0.00000000D+00
     .,0.84954700D+02,0.406D+03,0.270D+02,0.39844000D+01,0.00000000D+00
     .,0.86660100D+02,0.406D+03,0.280D+02,0.39844000D+01,0.00000000D+00
     .,0.67082300D+02,0.406D+03,0.290D+02,0.39844000D+01,0.00000000D+00
     .,0.70282000D+02,0.406D+03,0.300D+02,0.39844000D+01,0.00000000D+00
     .,0.82324800D+02,0.406D+03,0.310D+02,0.39844000D+01,0.00000000D+00
     .,0.75207600D+02,0.406D+03,0.320D+02,0.39844000D+01,0.00000000D+00
     .,0.66414700D+02,0.406D+03,0.330D+02,0.39844000D+01,0.00000000D+00
     .,0.60991300D+02,0.406D+03,0.340D+02,0.39844000D+01,0.00000000D+00
     .,0.54682400D+02,0.406D+03,0.350D+02,0.39844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 155801: 155900)=(/
     . 0.48650000D+02,0.406D+03,0.360D+02,0.39844000D+01,0.00000000D+00
     .,0.19559960D+03,0.406D+03,0.370D+02,0.39844000D+01,0.00000000D+00
     .,0.17983950D+03,0.406D+03,0.380D+02,0.39844000D+01,0.00000000D+00
     .,0.16177380D+03,0.406D+03,0.390D+02,0.39844000D+01,0.00000000D+00
     .,0.14800690D+03,0.406D+03,0.400D+02,0.39844000D+01,0.00000000D+00
     .,0.13670500D+03,0.406D+03,0.410D+02,0.39844000D+01,0.00000000D+00
     .,0.10823560D+03,0.406D+03,0.420D+02,0.39844000D+01,0.00000000D+00
     .,0.11959950D+03,0.406D+03,0.430D+02,0.39844000D+01,0.00000000D+00
     .,0.93626900D+02,0.406D+03,0.440D+02,0.39844000D+01,0.00000000D+00
     .,0.10181940D+03,0.406D+03,0.450D+02,0.39844000D+01,0.00000000D+00
     .,0.95161200D+02,0.406D+03,0.460D+02,0.39844000D+01,0.00000000D+00
     .,0.79665700D+02,0.406D+03,0.470D+02,0.39844000D+01,0.00000000D+00
     .,0.84713900D+02,0.406D+03,0.480D+02,0.39844000D+01,0.00000000D+00
     .,0.10361980D+03,0.406D+03,0.490D+02,0.39844000D+01,0.00000000D+00
     .,0.98343100D+02,0.406D+03,0.500D+02,0.39844000D+01,0.00000000D+00
     .,0.90179700D+02,0.406D+03,0.510D+02,0.39844000D+01,0.00000000D+00
     .,0.85234300D+02,0.406D+03,0.520D+02,0.39844000D+01,0.00000000D+00
     .,0.78668600D+02,0.406D+03,0.530D+02,0.39844000D+01,0.00000000D+00
     .,0.72161700D+02,0.406D+03,0.540D+02,0.39844000D+01,0.00000000D+00
     .,0.23924420D+03,0.406D+03,0.550D+02,0.39844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 155901: 156000)=(/
     . 0.22805560D+03,0.406D+03,0.560D+02,0.39844000D+01,0.00000000D+00
     .,0.20554070D+03,0.406D+03,0.570D+02,0.39844000D+01,0.00000000D+00
     .,0.10630350D+03,0.406D+03,0.580D+02,0.39844000D+01,0.27991000D+01
     .,0.20400390D+03,0.406D+03,0.590D+02,0.39844000D+01,0.00000000D+00
     .,0.19661650D+03,0.406D+03,0.600D+02,0.39844000D+01,0.00000000D+00
     .,0.19187330D+03,0.406D+03,0.610D+02,0.39844000D+01,0.00000000D+00
     .,0.18748180D+03,0.406D+03,0.620D+02,0.39844000D+01,0.00000000D+00
     .,0.18359400D+03,0.406D+03,0.630D+02,0.39844000D+01,0.00000000D+00
     .,0.14929180D+03,0.406D+03,0.640D+02,0.39844000D+01,0.00000000D+00
     .,0.16190910D+03,0.406D+03,0.650D+02,0.39844000D+01,0.00000000D+00
     .,0.15698310D+03,0.406D+03,0.660D+02,0.39844000D+01,0.00000000D+00
     .,0.16653800D+03,0.406D+03,0.670D+02,0.39844000D+01,0.00000000D+00
     .,0.16307020D+03,0.406D+03,0.680D+02,0.39844000D+01,0.00000000D+00
     .,0.16000710D+03,0.406D+03,0.690D+02,0.39844000D+01,0.00000000D+00
     .,0.15788900D+03,0.406D+03,0.700D+02,0.39844000D+01,0.00000000D+00
     .,0.13608820D+03,0.406D+03,0.710D+02,0.39844000D+01,0.00000000D+00
     .,0.13729240D+03,0.406D+03,0.720D+02,0.39844000D+01,0.00000000D+00
     .,0.12762070D+03,0.406D+03,0.730D+02,0.39844000D+01,0.00000000D+00
     .,0.10983770D+03,0.406D+03,0.740D+02,0.39844000D+01,0.00000000D+00
     .,0.11232740D+03,0.406D+03,0.750D+02,0.39844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 156001: 156100)=(/
     . 0.10346160D+03,0.406D+03,0.760D+02,0.39844000D+01,0.00000000D+00
     .,0.96033300D+02,0.406D+03,0.770D+02,0.39844000D+01,0.00000000D+00
     .,0.81236300D+02,0.406D+03,0.780D+02,0.39844000D+01,0.00000000D+00
     .,0.76428200D+02,0.406D+03,0.790D+02,0.39844000D+01,0.00000000D+00
     .,0.78850000D+02,0.406D+03,0.800D+02,0.39844000D+01,0.00000000D+00
     .,0.10789760D+03,0.406D+03,0.810D+02,0.39844000D+01,0.00000000D+00
     .,0.10736650D+03,0.406D+03,0.820D+02,0.39844000D+01,0.00000000D+00
     .,0.10105710D+03,0.406D+03,0.830D+02,0.39844000D+01,0.00000000D+00
     .,0.97833200D+02,0.406D+03,0.840D+02,0.39844000D+01,0.00000000D+00
     .,0.91999000D+02,0.406D+03,0.850D+02,0.39844000D+01,0.00000000D+00
     .,0.85843200D+02,0.406D+03,0.860D+02,0.39844000D+01,0.00000000D+00
     .,0.23075540D+03,0.406D+03,0.870D+02,0.39844000D+01,0.00000000D+00
     .,0.22882200D+03,0.406D+03,0.880D+02,0.39844000D+01,0.00000000D+00
     .,0.20694660D+03,0.406D+03,0.890D+02,0.39844000D+01,0.00000000D+00
     .,0.19164430D+03,0.406D+03,0.900D+02,0.39844000D+01,0.00000000D+00
     .,0.18809650D+03,0.406D+03,0.910D+02,0.39844000D+01,0.00000000D+00
     .,0.18230090D+03,0.406D+03,0.920D+02,0.39844000D+01,0.00000000D+00
     .,0.18437780D+03,0.406D+03,0.930D+02,0.39844000D+01,0.00000000D+00
     .,0.17908370D+03,0.406D+03,0.940D+02,0.39844000D+01,0.00000000D+00
     .,0.11329900D+02,0.406D+03,0.101D+03,0.39844000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 156101: 156200)=(/
     . 0.33215800D+02,0.406D+03,0.103D+03,0.39844000D+01,0.98650000D+00
     .,0.43062000D+02,0.406D+03,0.104D+03,0.39844000D+01,0.98080000D+00
     .,0.34999000D+02,0.406D+03,0.105D+03,0.39844000D+01,0.97060000D+00
     .,0.27520600D+02,0.406D+03,0.106D+03,0.39844000D+01,0.98680000D+00
     .,0.20046800D+02,0.406D+03,0.107D+03,0.39844000D+01,0.99440000D+00
     .,0.15175100D+02,0.406D+03,0.108D+03,0.39844000D+01,0.99250000D+00
     .,0.10939100D+02,0.406D+03,0.109D+03,0.39844000D+01,0.99820000D+00
     .,0.48162200D+02,0.406D+03,0.111D+03,0.39844000D+01,0.96840000D+00
     .,0.74002800D+02,0.406D+03,0.112D+03,0.39844000D+01,0.96280000D+00
     .,0.77136200D+02,0.406D+03,0.113D+03,0.39844000D+01,0.96480000D+00
     .,0.64967200D+02,0.406D+03,0.114D+03,0.39844000D+01,0.95070000D+00
     .,0.55237500D+02,0.406D+03,0.115D+03,0.39844000D+01,0.99470000D+00
     .,0.48022100D+02,0.406D+03,0.116D+03,0.39844000D+01,0.99480000D+00
     .,0.40420900D+02,0.406D+03,0.117D+03,0.39844000D+01,0.99720000D+00
     .,0.69043400D+02,0.406D+03,0.119D+03,0.39844000D+01,0.97670000D+00
     .,0.12207070D+03,0.406D+03,0.120D+03,0.39844000D+01,0.98310000D+00
     .,0.71085400D+02,0.406D+03,0.121D+03,0.39844000D+01,0.18627000D+01
     .,0.68829700D+02,0.406D+03,0.122D+03,0.39844000D+01,0.18299000D+01
     .,0.67438300D+02,0.406D+03,0.123D+03,0.39844000D+01,0.19138000D+01
     .,0.66556800D+02,0.406D+03,0.124D+03,0.39844000D+01,0.18269000D+01
     ./)
      grimme_c6_parameters( 156201: 156300)=(/
     . 0.62393100D+02,0.406D+03,0.125D+03,0.39844000D+01,0.16406000D+01
     .,0.58177600D+02,0.406D+03,0.126D+03,0.39844000D+01,0.16483000D+01
     .,0.55565400D+02,0.406D+03,0.127D+03,0.39844000D+01,0.17149000D+01
     .,0.54239700D+02,0.406D+03,0.128D+03,0.39844000D+01,0.17937000D+01
     .,0.52798400D+02,0.406D+03,0.129D+03,0.39844000D+01,0.95760000D+00
     .,0.50885600D+02,0.406D+03,0.130D+03,0.39844000D+01,0.19419000D+01
     .,0.78050500D+02,0.406D+03,0.131D+03,0.39844000D+01,0.96010000D+00
     .,0.71014300D+02,0.406D+03,0.132D+03,0.39844000D+01,0.94340000D+00
     .,0.65441400D+02,0.406D+03,0.133D+03,0.39844000D+01,0.98890000D+00
     .,0.61004100D+02,0.406D+03,0.134D+03,0.39844000D+01,0.99010000D+00
     .,0.55002900D+02,0.406D+03,0.135D+03,0.39844000D+01,0.99740000D+00
     .,0.83241800D+02,0.406D+03,0.137D+03,0.39844000D+01,0.97380000D+00
     .,0.14851410D+03,0.406D+03,0.138D+03,0.39844000D+01,0.98010000D+00
     .,0.11976540D+03,0.406D+03,0.139D+03,0.39844000D+01,0.19153000D+01
     .,0.94117300D+02,0.406D+03,0.140D+03,0.39844000D+01,0.19355000D+01
     .,0.95000900D+02,0.406D+03,0.141D+03,0.39844000D+01,0.19545000D+01
     .,0.89422900D+02,0.406D+03,0.142D+03,0.39844000D+01,0.19420000D+01
     .,0.97841700D+02,0.406D+03,0.143D+03,0.39844000D+01,0.16682000D+01
     .,0.79575000D+02,0.406D+03,0.144D+03,0.39844000D+01,0.18584000D+01
     .,0.74728700D+02,0.406D+03,0.145D+03,0.39844000D+01,0.19003000D+01
     ./)
      grimme_c6_parameters( 156301: 156400)=(/
     . 0.69773000D+02,0.406D+03,0.146D+03,0.39844000D+01,0.18630000D+01
     .,0.67307000D+02,0.406D+03,0.147D+03,0.39844000D+01,0.96790000D+00
     .,0.67402800D+02,0.406D+03,0.148D+03,0.39844000D+01,0.19539000D+01
     .,0.99752200D+02,0.406D+03,0.149D+03,0.39844000D+01,0.96330000D+00
     .,0.92802100D+02,0.406D+03,0.150D+03,0.39844000D+01,0.95140000D+00
     .,0.88743400D+02,0.406D+03,0.151D+03,0.39844000D+01,0.97490000D+00
     .,0.85265700D+02,0.406D+03,0.152D+03,0.39844000D+01,0.98110000D+00
     .,0.79371600D+02,0.406D+03,0.153D+03,0.39844000D+01,0.99680000D+00
     .,0.10047420D+03,0.406D+03,0.155D+03,0.39844000D+01,0.99090000D+00
     .,0.19124940D+03,0.406D+03,0.156D+03,0.39844000D+01,0.97970000D+00
     .,0.15114110D+03,0.406D+03,0.157D+03,0.39844000D+01,0.19373000D+01
     .,0.10329330D+03,0.406D+03,0.159D+03,0.39844000D+01,0.29425000D+01
     .,0.10119170D+03,0.406D+03,0.160D+03,0.39844000D+01,0.29455000D+01
     .,0.98146700D+02,0.406D+03,0.161D+03,0.39844000D+01,0.29413000D+01
     .,0.98227000D+02,0.406D+03,0.162D+03,0.39844000D+01,0.29300000D+01
     .,0.93519300D+02,0.406D+03,0.163D+03,0.39844000D+01,0.18286000D+01
     .,0.98621300D+02,0.406D+03,0.164D+03,0.39844000D+01,0.28732000D+01
     .,0.93007000D+02,0.406D+03,0.165D+03,0.39844000D+01,0.29086000D+01
     .,0.93977100D+02,0.406D+03,0.166D+03,0.39844000D+01,0.28965000D+01
     .,0.88582200D+02,0.406D+03,0.167D+03,0.39844000D+01,0.29242000D+01
     ./)
      grimme_c6_parameters( 156401: 156500)=(/
     . 0.86174300D+02,0.406D+03,0.168D+03,0.39844000D+01,0.29282000D+01
     .,0.85510700D+02,0.406D+03,0.169D+03,0.39844000D+01,0.29246000D+01
     .,0.89191500D+02,0.406D+03,0.170D+03,0.39844000D+01,0.28482000D+01
     .,0.82798600D+02,0.406D+03,0.171D+03,0.39844000D+01,0.29219000D+01
     .,0.10701830D+03,0.406D+03,0.172D+03,0.39844000D+01,0.19254000D+01
     .,0.10110190D+03,0.406D+03,0.173D+03,0.39844000D+01,0.19459000D+01
     .,0.93960100D+02,0.406D+03,0.174D+03,0.39844000D+01,0.19292000D+01
     .,0.93667200D+02,0.406D+03,0.175D+03,0.39844000D+01,0.18104000D+01
     .,0.85392500D+02,0.406D+03,0.176D+03,0.39844000D+01,0.18858000D+01
     .,0.80955200D+02,0.406D+03,0.177D+03,0.39844000D+01,0.18648000D+01
     .,0.77699700D+02,0.406D+03,0.178D+03,0.39844000D+01,0.19188000D+01
     .,0.74376300D+02,0.406D+03,0.179D+03,0.39844000D+01,0.98460000D+00
     .,0.72783200D+02,0.406D+03,0.180D+03,0.39844000D+01,0.19896000D+01
     .,0.10824170D+03,0.406D+03,0.181D+03,0.39844000D+01,0.92670000D+00
     .,0.10128820D+03,0.406D+03,0.182D+03,0.39844000D+01,0.93830000D+00
     .,0.99667900D+02,0.406D+03,0.183D+03,0.39844000D+01,0.98200000D+00
     .,0.98057500D+02,0.406D+03,0.184D+03,0.39844000D+01,0.98150000D+00
     .,0.93106900D+02,0.406D+03,0.185D+03,0.39844000D+01,0.99540000D+00
     .,0.11330310D+03,0.406D+03,0.187D+03,0.39844000D+01,0.97050000D+00
     .,0.19337770D+03,0.406D+03,0.188D+03,0.39844000D+01,0.96620000D+00
     ./)
      grimme_c6_parameters( 156501: 156600)=(/
     . 0.12204020D+03,0.406D+03,0.189D+03,0.39844000D+01,0.29070000D+01
     .,0.13787680D+03,0.406D+03,0.190D+03,0.39844000D+01,0.28844000D+01
     .,0.12470980D+03,0.406D+03,0.191D+03,0.39844000D+01,0.28738000D+01
     .,0.11209800D+03,0.406D+03,0.192D+03,0.39844000D+01,0.28878000D+01
     .,0.10834540D+03,0.406D+03,0.193D+03,0.39844000D+01,0.29095000D+01
     .,0.12418240D+03,0.406D+03,0.194D+03,0.39844000D+01,0.19209000D+01
     .,0.29881900D+02,0.406D+03,0.204D+03,0.39844000D+01,0.19697000D+01
     .,0.29891600D+02,0.406D+03,0.205D+03,0.39844000D+01,0.19441000D+01
     .,0.22951700D+02,0.406D+03,0.206D+03,0.39844000D+01,0.19985000D+01
     .,0.18917200D+02,0.406D+03,0.207D+03,0.39844000D+01,0.20143000D+01
     .,0.13552500D+02,0.406D+03,0.208D+03,0.39844000D+01,0.19887000D+01
     .,0.51352500D+02,0.406D+03,0.212D+03,0.39844000D+01,0.19496000D+01
     .,0.61961000D+02,0.406D+03,0.213D+03,0.39844000D+01,0.19311000D+01
     .,0.60868700D+02,0.406D+03,0.214D+03,0.39844000D+01,0.19435000D+01
     .,0.54394100D+02,0.406D+03,0.215D+03,0.39844000D+01,0.20102000D+01
     .,0.47094300D+02,0.406D+03,0.216D+03,0.39844000D+01,0.19903000D+01
     .,0.72552400D+02,0.406D+03,0.220D+03,0.39844000D+01,0.19349000D+01
     .,0.70967000D+02,0.406D+03,0.221D+03,0.39844000D+01,0.28999000D+01
     .,0.71959500D+02,0.406D+03,0.222D+03,0.39844000D+01,0.38675000D+01
     .,0.65947300D+02,0.406D+03,0.223D+03,0.39844000D+01,0.29110000D+01
     ./)
      grimme_c6_parameters( 156601: 156700)=(/
     . 0.51461000D+02,0.406D+03,0.224D+03,0.39844000D+01,0.10619100D+02
     .,0.44917900D+02,0.406D+03,0.225D+03,0.39844000D+01,0.98849000D+01
     .,0.43990200D+02,0.406D+03,0.226D+03,0.39844000D+01,0.91376000D+01
     .,0.49914800D+02,0.406D+03,0.227D+03,0.39844000D+01,0.29263000D+01
     .,0.46907100D+02,0.406D+03,0.228D+03,0.39844000D+01,0.65458000D+01
     .,0.63911700D+02,0.406D+03,0.231D+03,0.39844000D+01,0.19315000D+01
     .,0.68034300D+02,0.406D+03,0.232D+03,0.39844000D+01,0.19447000D+01
     .,0.63962100D+02,0.406D+03,0.233D+03,0.39844000D+01,0.19793000D+01
     .,0.60572300D+02,0.406D+03,0.234D+03,0.39844000D+01,0.19812000D+01
     .,0.87389100D+02,0.406D+03,0.238D+03,0.39844000D+01,0.19143000D+01
     .,0.85966800D+02,0.406D+03,0.239D+03,0.39844000D+01,0.28903000D+01
     .,0.87311600D+02,0.406D+03,0.240D+03,0.39844000D+01,0.39106000D+01
     .,0.84504100D+02,0.406D+03,0.241D+03,0.39844000D+01,0.29225000D+01
     .,0.76386900D+02,0.406D+03,0.242D+03,0.39844000D+01,0.11055600D+02
     .,0.68623700D+02,0.406D+03,0.243D+03,0.39844000D+01,0.95402000D+01
     .,0.65290500D+02,0.406D+03,0.244D+03,0.39844000D+01,0.88895000D+01
     .,0.65394900D+02,0.406D+03,0.245D+03,0.39844000D+01,0.29696000D+01
     .,0.67836300D+02,0.406D+03,0.246D+03,0.39844000D+01,0.57095000D+01
     .,0.83227000D+02,0.406D+03,0.249D+03,0.39844000D+01,0.19378000D+01
     .,0.90268300D+02,0.406D+03,0.250D+03,0.39844000D+01,0.19505000D+01
     ./)
      grimme_c6_parameters( 156701: 156800)=(/
     . 0.86757400D+02,0.406D+03,0.251D+03,0.39844000D+01,0.19523000D+01
     .,0.84742500D+02,0.406D+03,0.252D+03,0.39844000D+01,0.19639000D+01
     .,0.10658000D+03,0.406D+03,0.256D+03,0.39844000D+01,0.18467000D+01
     .,0.11146330D+03,0.406D+03,0.257D+03,0.39844000D+01,0.29175000D+01
     .,0.84445100D+02,0.406D+03,0.272D+03,0.39844000D+01,0.38840000D+01
     .,0.87680900D+02,0.406D+03,0.273D+03,0.39844000D+01,0.28988000D+01
     .,0.83080500D+02,0.406D+03,0.274D+03,0.39844000D+01,0.10915300D+02
     .,0.76686700D+02,0.406D+03,0.275D+03,0.39844000D+01,0.98054000D+01
     .,0.73066600D+02,0.406D+03,0.276D+03,0.39844000D+01,0.91527000D+01
     .,0.73485300D+02,0.406D+03,0.277D+03,0.39844000D+01,0.29424000D+01
     .,0.77012400D+02,0.406D+03,0.278D+03,0.39844000D+01,0.66669000D+01
     .,0.90346700D+02,0.406D+03,0.281D+03,0.39844000D+01,0.19302000D+01
     .,0.95397300D+02,0.406D+03,0.282D+03,0.39844000D+01,0.19356000D+01
     .,0.97851700D+02,0.406D+03,0.283D+03,0.39844000D+01,0.19655000D+01
     .,0.97881700D+02,0.406D+03,0.284D+03,0.39844000D+01,0.19639000D+01
     .,0.11758210D+03,0.406D+03,0.288D+03,0.39844000D+01,0.18075000D+01
     .,0.23621000D+02,0.406D+03,0.305D+03,0.39844000D+01,0.29128000D+01
     .,0.21537700D+02,0.406D+03,0.306D+03,0.39844000D+01,0.29987000D+01
     .,0.16816900D+02,0.406D+03,0.307D+03,0.39844000D+01,0.29903000D+01
     .,0.50039700D+02,0.406D+03,0.313D+03,0.39844000D+01,0.29146000D+01
     ./)
      grimme_c6_parameters( 156801: 156900)=(/
     . 0.59158300D+02,0.406D+03,0.314D+03,0.39844000D+01,0.29407000D+01
     .,0.51004800D+02,0.406D+03,0.315D+03,0.39844000D+01,0.29859000D+01
     .,0.45389100D+02,0.406D+03,0.327D+03,0.39844000D+01,0.77785000D+01
     .,0.48414900D+02,0.406D+03,0.328D+03,0.39844000D+01,0.62918000D+01
     .,0.53961700D+02,0.406D+03,0.331D+03,0.39844000D+01,0.29233000D+01
     .,0.61903800D+02,0.406D+03,0.332D+03,0.39844000D+01,0.29186000D+01
     .,0.61943800D+02,0.406D+03,0.333D+03,0.39844000D+01,0.29709000D+01
     .,0.72970300D+02,0.406D+03,0.349D+03,0.39844000D+01,0.29353000D+01
     .,0.82717000D+02,0.406D+03,0.350D+03,0.39844000D+01,0.29259000D+01
     .,0.84217700D+02,0.406D+03,0.351D+03,0.39844000D+01,0.29315000D+01
     .,0.82282500D+02,0.406D+03,0.381D+03,0.39844000D+01,0.29420000D+01
     .,0.94131500D+02,0.406D+03,0.382D+03,0.39844000D+01,0.29081000D+01
     .,0.95601800D+02,0.406D+03,0.383D+03,0.39844000D+01,0.29500000D+01
     .,0.22379700D+02,0.406D+03,0.405D+03,0.39844000D+01,0.45856000D+01
     .,0.18206700D+02,0.406D+03,0.406D+03,0.39844000D+01,0.39844000D+01
     .,0.21006400D+02,0.414D+03,0.100D+01,0.38677000D+01,0.91180000D+00
     .,0.13854700D+02,0.414D+03,0.200D+01,0.38677000D+01,0.00000000D+00
     .,0.30879530D+03,0.414D+03,0.300D+01,0.38677000D+01,0.00000000D+00
     .,0.18425660D+03,0.414D+03,0.400D+01,0.38677000D+01,0.00000000D+00
     .,0.12577640D+03,0.414D+03,0.500D+01,0.38677000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 156901: 157000)=(/
     . 0.85522300D+02,0.414D+03,0.600D+01,0.38677000D+01,0.00000000D+00
     .,0.59931900D+02,0.414D+03,0.700D+01,0.38677000D+01,0.00000000D+00
     .,0.45368800D+02,0.414D+03,0.800D+01,0.38677000D+01,0.00000000D+00
     .,0.34318700D+02,0.414D+03,0.900D+01,0.38677000D+01,0.00000000D+00
     .,0.26335800D+02,0.414D+03,0.100D+02,0.38677000D+01,0.00000000D+00
     .,0.36977170D+03,0.414D+03,0.110D+02,0.38677000D+01,0.00000000D+00
     .,0.29187160D+03,0.414D+03,0.120D+02,0.38677000D+01,0.00000000D+00
     .,0.27132020D+03,0.414D+03,0.130D+02,0.38677000D+01,0.00000000D+00
     .,0.21589980D+03,0.414D+03,0.140D+02,0.38677000D+01,0.00000000D+00
     .,0.16943560D+03,0.414D+03,0.150D+02,0.38677000D+01,0.00000000D+00
     .,0.14099550D+03,0.414D+03,0.160D+02,0.38677000D+01,0.00000000D+00
     .,0.11535420D+03,0.414D+03,0.170D+02,0.38677000D+01,0.00000000D+00
     .,0.94402700D+02,0.414D+03,0.180D+02,0.38677000D+01,0.00000000D+00
     .,0.60221160D+03,0.414D+03,0.190D+02,0.38677000D+01,0.00000000D+00
     .,0.50727030D+03,0.414D+03,0.200D+02,0.38677000D+01,0.00000000D+00
     .,0.42088950D+03,0.414D+03,0.210D+02,0.38677000D+01,0.00000000D+00
     .,0.40781600D+03,0.414D+03,0.220D+02,0.38677000D+01,0.00000000D+00
     .,0.37420690D+03,0.414D+03,0.230D+02,0.38677000D+01,0.00000000D+00
     .,0.29450370D+03,0.414D+03,0.240D+02,0.38677000D+01,0.00000000D+00
     .,0.32309480D+03,0.414D+03,0.250D+02,0.38677000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 157001: 157100)=(/
     . 0.25339650D+03,0.414D+03,0.260D+02,0.38677000D+01,0.00000000D+00
     .,0.27008810D+03,0.414D+03,0.270D+02,0.38677000D+01,0.00000000D+00
     .,0.27767940D+03,0.414D+03,0.280D+02,0.38677000D+01,0.00000000D+00
     .,0.21252810D+03,0.414D+03,0.290D+02,0.38677000D+01,0.00000000D+00
     .,0.21988700D+03,0.414D+03,0.300D+02,0.38677000D+01,0.00000000D+00
     .,0.26030910D+03,0.414D+03,0.310D+02,0.38677000D+01,0.00000000D+00
     .,0.23133020D+03,0.414D+03,0.320D+02,0.38677000D+01,0.00000000D+00
     .,0.19840790D+03,0.414D+03,0.330D+02,0.38677000D+01,0.00000000D+00
     .,0.17847990D+03,0.414D+03,0.340D+02,0.38677000D+01,0.00000000D+00
     .,0.15647810D+03,0.414D+03,0.350D+02,0.38677000D+01,0.00000000D+00
     .,0.13621020D+03,0.414D+03,0.360D+02,0.38677000D+01,0.00000000D+00
     .,0.67586350D+03,0.414D+03,0.370D+02,0.38677000D+01,0.00000000D+00
     .,0.60371340D+03,0.414D+03,0.380D+02,0.38677000D+01,0.00000000D+00
     .,0.53268760D+03,0.414D+03,0.390D+02,0.38677000D+01,0.00000000D+00
     .,0.48073180D+03,0.414D+03,0.400D+02,0.38677000D+01,0.00000000D+00
     .,0.43942810D+03,0.414D+03,0.410D+02,0.38677000D+01,0.00000000D+00
     .,0.34034780D+03,0.414D+03,0.420D+02,0.38677000D+01,0.00000000D+00
     .,0.37931480D+03,0.414D+03,0.430D+02,0.38677000D+01,0.00000000D+00
     .,0.28993610D+03,0.414D+03,0.440D+02,0.38677000D+01,0.00000000D+00
     .,0.31720640D+03,0.414D+03,0.450D+02,0.38677000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 157101: 157200)=(/
     . 0.29452200D+03,0.414D+03,0.460D+02,0.38677000D+01,0.00000000D+00
     .,0.24486850D+03,0.414D+03,0.470D+02,0.38677000D+01,0.00000000D+00
     .,0.25988150D+03,0.414D+03,0.480D+02,0.38677000D+01,0.00000000D+00
     .,0.32493450D+03,0.414D+03,0.490D+02,0.38677000D+01,0.00000000D+00
     .,0.30248790D+03,0.414D+03,0.500D+02,0.38677000D+01,0.00000000D+00
     .,0.27103870D+03,0.414D+03,0.510D+02,0.38677000D+01,0.00000000D+00
     .,0.25216040D+03,0.414D+03,0.520D+02,0.38677000D+01,0.00000000D+00
     .,0.22853700D+03,0.414D+03,0.530D+02,0.38677000D+01,0.00000000D+00
     .,0.20580950D+03,0.414D+03,0.540D+02,0.38677000D+01,0.00000000D+00
     .,0.82382010D+03,0.414D+03,0.550D+02,0.38677000D+01,0.00000000D+00
     .,0.76760950D+03,0.414D+03,0.560D+02,0.38677000D+01,0.00000000D+00
     .,0.67935020D+03,0.414D+03,0.570D+02,0.38677000D+01,0.00000000D+00
     .,0.31968540D+03,0.414D+03,0.580D+02,0.38677000D+01,0.27991000D+01
     .,0.68142510D+03,0.414D+03,0.590D+02,0.38677000D+01,0.00000000D+00
     .,0.65512090D+03,0.414D+03,0.600D+02,0.38677000D+01,0.00000000D+00
     .,0.63890630D+03,0.414D+03,0.610D+02,0.38677000D+01,0.00000000D+00
     .,0.62397630D+03,0.414D+03,0.620D+02,0.38677000D+01,0.00000000D+00
     .,0.61074860D+03,0.414D+03,0.630D+02,0.38677000D+01,0.00000000D+00
     .,0.48368880D+03,0.414D+03,0.640D+02,0.38677000D+01,0.00000000D+00
     .,0.53820120D+03,0.414D+03,0.650D+02,0.38677000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 157201: 157300)=(/
     . 0.51982010D+03,0.414D+03,0.660D+02,0.38677000D+01,0.00000000D+00
     .,0.55187870D+03,0.414D+03,0.670D+02,0.38677000D+01,0.00000000D+00
     .,0.54029010D+03,0.414D+03,0.680D+02,0.38677000D+01,0.00000000D+00
     .,0.52989220D+03,0.414D+03,0.690D+02,0.38677000D+01,0.00000000D+00
     .,0.52355130D+03,0.414D+03,0.700D+02,0.38677000D+01,0.00000000D+00
     .,0.44329500D+03,0.414D+03,0.710D+02,0.38677000D+01,0.00000000D+00
     .,0.43927910D+03,0.414D+03,0.720D+02,0.38677000D+01,0.00000000D+00
     .,0.40232530D+03,0.414D+03,0.730D+02,0.38677000D+01,0.00000000D+00
     .,0.34031200D+03,0.414D+03,0.740D+02,0.38677000D+01,0.00000000D+00
     .,0.34676670D+03,0.414D+03,0.750D+02,0.38677000D+01,0.00000000D+00
     .,0.31508760D+03,0.414D+03,0.760D+02,0.38677000D+01,0.00000000D+00
     .,0.28909700D+03,0.414D+03,0.770D+02,0.38677000D+01,0.00000000D+00
     .,0.24031030D+03,0.414D+03,0.780D+02,0.38677000D+01,0.00000000D+00
     .,0.22456090D+03,0.414D+03,0.790D+02,0.38677000D+01,0.00000000D+00
     .,0.23141000D+03,0.414D+03,0.800D+02,0.38677000D+01,0.00000000D+00
     .,0.33360810D+03,0.414D+03,0.810D+02,0.38677000D+01,0.00000000D+00
     .,0.32796730D+03,0.414D+03,0.820D+02,0.38677000D+01,0.00000000D+00
     .,0.30290300D+03,0.414D+03,0.830D+02,0.38677000D+01,0.00000000D+00
     .,0.28964470D+03,0.414D+03,0.840D+02,0.38677000D+01,0.00000000D+00
     .,0.26800240D+03,0.414D+03,0.850D+02,0.38677000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 157301: 157400)=(/
     . 0.24608550D+03,0.414D+03,0.860D+02,0.38677000D+01,0.00000000D+00
     .,0.78245740D+03,0.414D+03,0.870D+02,0.38677000D+01,0.00000000D+00
     .,0.76183620D+03,0.414D+03,0.880D+02,0.38677000D+01,0.00000000D+00
     .,0.67780430D+03,0.414D+03,0.890D+02,0.38677000D+01,0.00000000D+00
     .,0.61315740D+03,0.414D+03,0.900D+02,0.38677000D+01,0.00000000D+00
     .,0.60632200D+03,0.414D+03,0.910D+02,0.38677000D+01,0.00000000D+00
     .,0.58710090D+03,0.414D+03,0.920D+02,0.38677000D+01,0.00000000D+00
     .,0.60167790D+03,0.414D+03,0.930D+02,0.38677000D+01,0.00000000D+00
     .,0.58314710D+03,0.414D+03,0.940D+02,0.38677000D+01,0.00000000D+00
     .,0.33712600D+02,0.414D+03,0.101D+03,0.38677000D+01,0.00000000D+00
     .,0.10727210D+03,0.414D+03,0.103D+03,0.38677000D+01,0.98650000D+00
     .,0.13717830D+03,0.414D+03,0.104D+03,0.38677000D+01,0.98080000D+00
     .,0.10598260D+03,0.414D+03,0.105D+03,0.38677000D+01,0.97060000D+00
     .,0.80142700D+02,0.414D+03,0.106D+03,0.38677000D+01,0.98680000D+00
     .,0.55839400D+02,0.414D+03,0.107D+03,0.38677000D+01,0.99440000D+00
     .,0.40663500D+02,0.414D+03,0.108D+03,0.38677000D+01,0.99250000D+00
     .,0.27908600D+02,0.414D+03,0.109D+03,0.38677000D+01,0.99820000D+00
     .,0.15615450D+03,0.414D+03,0.111D+03,0.38677000D+01,0.96840000D+00
     .,0.24139030D+03,0.414D+03,0.112D+03,0.38677000D+01,0.96280000D+00
     .,0.24630130D+03,0.414D+03,0.113D+03,0.38677000D+01,0.96480000D+00
     ./)
      grimme_c6_parameters( 157401: 157500)=(/
     . 0.19975300D+03,0.414D+03,0.114D+03,0.38677000D+01,0.95070000D+00
     .,0.16446690D+03,0.414D+03,0.115D+03,0.38677000D+01,0.99470000D+00
     .,0.13940860D+03,0.414D+03,0.116D+03,0.38677000D+01,0.99480000D+00
     .,0.11413580D+03,0.414D+03,0.117D+03,0.38677000D+01,0.99720000D+00
     .,0.21587970D+03,0.414D+03,0.119D+03,0.38677000D+01,0.97670000D+00
     .,0.40567650D+03,0.414D+03,0.120D+03,0.38677000D+01,0.98310000D+00
     .,0.21796280D+03,0.414D+03,0.121D+03,0.38677000D+01,0.18627000D+01
     .,0.21039040D+03,0.414D+03,0.122D+03,0.38677000D+01,0.18299000D+01
     .,0.20610620D+03,0.414D+03,0.123D+03,0.38677000D+01,0.19138000D+01
     .,0.20396330D+03,0.414D+03,0.124D+03,0.38677000D+01,0.18269000D+01
     .,0.18858340D+03,0.414D+03,0.125D+03,0.38677000D+01,0.16406000D+01
     .,0.17467580D+03,0.414D+03,0.126D+03,0.38677000D+01,0.16483000D+01
     .,0.16656740D+03,0.414D+03,0.127D+03,0.38677000D+01,0.17149000D+01
     .,0.16276320D+03,0.414D+03,0.128D+03,0.38677000D+01,0.17937000D+01
     .,0.16019460D+03,0.414D+03,0.129D+03,0.38677000D+01,0.95760000D+00
     .,0.15131410D+03,0.414D+03,0.130D+03,0.38677000D+01,0.19419000D+01
     .,0.24494460D+03,0.414D+03,0.131D+03,0.38677000D+01,0.96010000D+00
     .,0.21672460D+03,0.414D+03,0.132D+03,0.38677000D+01,0.94340000D+00
     .,0.19508440D+03,0.414D+03,0.133D+03,0.38677000D+01,0.98890000D+00
     .,0.17853020D+03,0.414D+03,0.134D+03,0.38677000D+01,0.99010000D+00
     ./)
      grimme_c6_parameters( 157501: 157600)=(/
     . 0.15754230D+03,0.414D+03,0.135D+03,0.38677000D+01,0.99740000D+00
     .,0.25790200D+03,0.414D+03,0.137D+03,0.38677000D+01,0.97380000D+00
     .,0.49295740D+03,0.414D+03,0.138D+03,0.38677000D+01,0.98010000D+00
     .,0.38205370D+03,0.414D+03,0.139D+03,0.38677000D+01,0.19153000D+01
     .,0.28794440D+03,0.414D+03,0.140D+03,0.38677000D+01,0.19355000D+01
     .,0.29066410D+03,0.414D+03,0.141D+03,0.38677000D+01,0.19545000D+01
     .,0.27129600D+03,0.414D+03,0.142D+03,0.38677000D+01,0.19420000D+01
     .,0.30236440D+03,0.414D+03,0.143D+03,0.38677000D+01,0.16682000D+01
     .,0.23727980D+03,0.414D+03,0.144D+03,0.38677000D+01,0.18584000D+01
     .,0.22191000D+03,0.414D+03,0.145D+03,0.38677000D+01,0.19003000D+01
     .,0.20606750D+03,0.414D+03,0.146D+03,0.38677000D+01,0.18630000D+01
     .,0.19915530D+03,0.414D+03,0.147D+03,0.38677000D+01,0.96790000D+00
     .,0.19779040D+03,0.414D+03,0.148D+03,0.38677000D+01,0.19539000D+01
     .,0.31041220D+03,0.414D+03,0.149D+03,0.38677000D+01,0.96330000D+00
     .,0.28266840D+03,0.414D+03,0.150D+03,0.38677000D+01,0.95140000D+00
     .,0.26580530D+03,0.414D+03,0.151D+03,0.38677000D+01,0.97490000D+00
     .,0.25202720D+03,0.414D+03,0.152D+03,0.38677000D+01,0.98110000D+00
     .,0.23068720D+03,0.414D+03,0.153D+03,0.38677000D+01,0.99680000D+00
     .,0.30678390D+03,0.414D+03,0.155D+03,0.38677000D+01,0.99090000D+00
     .,0.63715160D+03,0.414D+03,0.156D+03,0.38677000D+01,0.97970000D+00
     ./)
      grimme_c6_parameters( 157601: 157700)=(/
     . 0.48296010D+03,0.414D+03,0.157D+03,0.38677000D+01,0.19373000D+01
     .,0.31010960D+03,0.414D+03,0.159D+03,0.38677000D+01,0.29425000D+01
     .,0.30369930D+03,0.414D+03,0.160D+03,0.38677000D+01,0.29455000D+01
     .,0.29412610D+03,0.414D+03,0.161D+03,0.38677000D+01,0.29413000D+01
     .,0.29533450D+03,0.414D+03,0.162D+03,0.38677000D+01,0.29300000D+01
     .,0.28374430D+03,0.414D+03,0.163D+03,0.38677000D+01,0.18286000D+01
     .,0.29720650D+03,0.414D+03,0.164D+03,0.38677000D+01,0.28732000D+01
     .,0.27927050D+03,0.414D+03,0.165D+03,0.38677000D+01,0.29086000D+01
     .,0.28372210D+03,0.414D+03,0.166D+03,0.38677000D+01,0.28965000D+01
     .,0.26527330D+03,0.414D+03,0.167D+03,0.38677000D+01,0.29242000D+01
     .,0.25777900D+03,0.414D+03,0.168D+03,0.38677000D+01,0.29282000D+01
     .,0.25608900D+03,0.414D+03,0.169D+03,0.38677000D+01,0.29246000D+01
     .,0.26901820D+03,0.414D+03,0.170D+03,0.38677000D+01,0.28482000D+01
     .,0.24764990D+03,0.414D+03,0.171D+03,0.38677000D+01,0.29219000D+01
     .,0.33234580D+03,0.414D+03,0.172D+03,0.38677000D+01,0.19254000D+01
     .,0.30938790D+03,0.414D+03,0.173D+03,0.38677000D+01,0.19459000D+01
     .,0.28312170D+03,0.414D+03,0.174D+03,0.38677000D+01,0.19292000D+01
     .,0.28556720D+03,0.414D+03,0.175D+03,0.38677000D+01,0.18104000D+01
     .,0.25178560D+03,0.414D+03,0.176D+03,0.38677000D+01,0.18858000D+01
     .,0.23694270D+03,0.414D+03,0.177D+03,0.38677000D+01,0.18648000D+01
     ./)
      grimme_c6_parameters( 157701: 157800)=(/
     . 0.22631410D+03,0.414D+03,0.178D+03,0.38677000D+01,0.19188000D+01
     .,0.21617050D+03,0.414D+03,0.179D+03,0.38677000D+01,0.98460000D+00
     .,0.20948600D+03,0.414D+03,0.180D+03,0.38677000D+01,0.19896000D+01
     .,0.33326920D+03,0.414D+03,0.181D+03,0.38677000D+01,0.92670000D+00
     .,0.30567610D+03,0.414D+03,0.182D+03,0.38677000D+01,0.93830000D+00
     .,0.29742190D+03,0.414D+03,0.183D+03,0.38677000D+01,0.98200000D+00
     .,0.28985610D+03,0.414D+03,0.184D+03,0.38677000D+01,0.98150000D+00
     .,0.27129160D+03,0.414D+03,0.185D+03,0.38677000D+01,0.99540000D+00
     .,0.34569720D+03,0.414D+03,0.187D+03,0.38677000D+01,0.97050000D+00
     .,0.63670530D+03,0.414D+03,0.188D+03,0.38677000D+01,0.96620000D+00
     .,0.36700470D+03,0.414D+03,0.189D+03,0.38677000D+01,0.29070000D+01
     .,0.42126010D+03,0.414D+03,0.190D+03,0.38677000D+01,0.28844000D+01
     .,0.37698280D+03,0.414D+03,0.191D+03,0.38677000D+01,0.28738000D+01
     .,0.33444420D+03,0.414D+03,0.192D+03,0.38677000D+01,0.28878000D+01
     .,0.32204370D+03,0.414D+03,0.193D+03,0.38677000D+01,0.29095000D+01
     .,0.38313380D+03,0.414D+03,0.194D+03,0.38677000D+01,0.19209000D+01
     .,0.90695600D+02,0.414D+03,0.204D+03,0.38677000D+01,0.19697000D+01
     .,0.89119000D+02,0.414D+03,0.205D+03,0.38677000D+01,0.19441000D+01
     .,0.65487900D+02,0.414D+03,0.206D+03,0.38677000D+01,0.19985000D+01
     .,0.52413600D+02,0.414D+03,0.207D+03,0.38677000D+01,0.20143000D+01
     ./)
      grimme_c6_parameters( 157801: 157900)=(/
     . 0.35824700D+02,0.414D+03,0.208D+03,0.38677000D+01,0.19887000D+01
     .,0.15991150D+03,0.414D+03,0.212D+03,0.38677000D+01,0.19496000D+01
     .,0.19305340D+03,0.414D+03,0.213D+03,0.38677000D+01,0.19311000D+01
     .,0.18599960D+03,0.414D+03,0.214D+03,0.38677000D+01,0.19435000D+01
     .,0.16212890D+03,0.414D+03,0.215D+03,0.38677000D+01,0.20102000D+01
     .,0.13657580D+03,0.414D+03,0.216D+03,0.38677000D+01,0.19903000D+01
     .,0.22361620D+03,0.414D+03,0.220D+03,0.38677000D+01,0.19349000D+01
     .,0.21570270D+03,0.414D+03,0.221D+03,0.38677000D+01,0.28999000D+01
     .,0.21838960D+03,0.414D+03,0.222D+03,0.38677000D+01,0.38675000D+01
     .,0.19966610D+03,0.414D+03,0.223D+03,0.38677000D+01,0.29110000D+01
     .,0.15083440D+03,0.414D+03,0.224D+03,0.38677000D+01,0.10619100D+02
     .,0.12933240D+03,0.414D+03,0.225D+03,0.38677000D+01,0.98849000D+01
     .,0.12689320D+03,0.414D+03,0.226D+03,0.38677000D+01,0.91376000D+01
     .,0.14822590D+03,0.414D+03,0.227D+03,0.38677000D+01,0.29263000D+01
     .,0.13826350D+03,0.414D+03,0.228D+03,0.38677000D+01,0.65458000D+01
     .,0.19524610D+03,0.414D+03,0.231D+03,0.38677000D+01,0.19315000D+01
     .,0.20652060D+03,0.414D+03,0.232D+03,0.38677000D+01,0.19447000D+01
     .,0.19004830D+03,0.414D+03,0.233D+03,0.38677000D+01,0.19793000D+01
     .,0.17712870D+03,0.414D+03,0.234D+03,0.38677000D+01,0.19812000D+01
     .,0.26785250D+03,0.414D+03,0.238D+03,0.38677000D+01,0.19143000D+01
     ./)
      grimme_c6_parameters( 157901: 158000)=(/
     . 0.25910620D+03,0.414D+03,0.239D+03,0.38677000D+01,0.28903000D+01
     .,0.26164690D+03,0.414D+03,0.240D+03,0.38677000D+01,0.39106000D+01
     .,0.25270610D+03,0.414D+03,0.241D+03,0.38677000D+01,0.29225000D+01
     .,0.22395860D+03,0.414D+03,0.242D+03,0.38677000D+01,0.11055600D+02
     .,0.19799630D+03,0.414D+03,0.243D+03,0.38677000D+01,0.95402000D+01
     .,0.18716590D+03,0.414D+03,0.244D+03,0.38677000D+01,0.88895000D+01
     .,0.19002130D+03,0.414D+03,0.245D+03,0.38677000D+01,0.29696000D+01
     .,0.19842220D+03,0.414D+03,0.246D+03,0.38677000D+01,0.57095000D+01
     .,0.25147160D+03,0.414D+03,0.249D+03,0.38677000D+01,0.19378000D+01
     .,0.27356280D+03,0.414D+03,0.250D+03,0.38677000D+01,0.19505000D+01
     .,0.25871400D+03,0.414D+03,0.251D+03,0.38677000D+01,0.19523000D+01
     .,0.25005790D+03,0.414D+03,0.252D+03,0.38677000D+01,0.19639000D+01
     .,0.32429550D+03,0.414D+03,0.256D+03,0.38677000D+01,0.18467000D+01
     .,0.33722250D+03,0.414D+03,0.257D+03,0.38677000D+01,0.29175000D+01
     .,0.25084450D+03,0.414D+03,0.272D+03,0.38677000D+01,0.38840000D+01
     .,0.26138080D+03,0.414D+03,0.273D+03,0.38677000D+01,0.28988000D+01
     .,0.24338630D+03,0.414D+03,0.274D+03,0.38677000D+01,0.10915300D+02
     .,0.22137160D+03,0.414D+03,0.275D+03,0.38677000D+01,0.98054000D+01
     .,0.20849420D+03,0.414D+03,0.276D+03,0.38677000D+01,0.91527000D+01
     .,0.21188810D+03,0.414D+03,0.277D+03,0.38677000D+01,0.29424000D+01
     ./)
      grimme_c6_parameters( 158001: 158100)=(/
     . 0.22292680D+03,0.414D+03,0.278D+03,0.38677000D+01,0.66669000D+01
     .,0.26896090D+03,0.414D+03,0.281D+03,0.38677000D+01,0.19302000D+01
     .,0.28451810D+03,0.414D+03,0.282D+03,0.38677000D+01,0.19356000D+01
     .,0.29053760D+03,0.414D+03,0.283D+03,0.38677000D+01,0.19655000D+01
     .,0.28876380D+03,0.414D+03,0.284D+03,0.38677000D+01,0.19639000D+01
     .,0.35718170D+03,0.414D+03,0.288D+03,0.38677000D+01,0.18075000D+01
     .,0.68110600D+02,0.414D+03,0.305D+03,0.38677000D+01,0.29128000D+01
     .,0.61216900D+02,0.414D+03,0.306D+03,0.38677000D+01,0.29987000D+01
     .,0.46103100D+02,0.414D+03,0.307D+03,0.38677000D+01,0.29903000D+01
     .,0.15146030D+03,0.414D+03,0.313D+03,0.38677000D+01,0.29146000D+01
     .,0.18102370D+03,0.414D+03,0.314D+03,0.38677000D+01,0.29407000D+01
     .,0.15063080D+03,0.414D+03,0.315D+03,0.38677000D+01,0.29859000D+01
     .,0.13228840D+03,0.414D+03,0.327D+03,0.38677000D+01,0.77785000D+01
     .,0.14466440D+03,0.414D+03,0.328D+03,0.38677000D+01,0.62918000D+01
     .,0.16060910D+03,0.414D+03,0.331D+03,0.38677000D+01,0.29233000D+01
     .,0.18547740D+03,0.414D+03,0.332D+03,0.38677000D+01,0.29186000D+01
     .,0.18319150D+03,0.414D+03,0.333D+03,0.38677000D+01,0.29709000D+01
     .,0.21524240D+03,0.414D+03,0.349D+03,0.38677000D+01,0.29353000D+01
     .,0.24705720D+03,0.414D+03,0.350D+03,0.38677000D+01,0.29259000D+01
     .,0.24975520D+03,0.414D+03,0.351D+03,0.38677000D+01,0.29315000D+01
     ./)
      grimme_c6_parameters( 158101: 158200)=(/
     . 0.24045180D+03,0.414D+03,0.381D+03,0.38677000D+01,0.29420000D+01
     .,0.27943950D+03,0.414D+03,0.382D+03,0.38677000D+01,0.29081000D+01
     .,0.28220780D+03,0.414D+03,0.383D+03,0.38677000D+01,0.29500000D+01
     .,0.64108300D+02,0.414D+03,0.405D+03,0.38677000D+01,0.45856000D+01
     .,0.50205300D+02,0.414D+03,0.406D+03,0.38677000D+01,0.39844000D+01
     .,0.14977340D+03,0.414D+03,0.414D+03,0.38677000D+01,0.38677000D+01
     .,0.23178400D+02,0.432D+03,0.100D+01,0.38972000D+01,0.91180000D+00
     .,0.15480100D+02,0.432D+03,0.200D+01,0.38972000D+01,0.00000000D+00
     .,0.33056660D+03,0.432D+03,0.300D+01,0.38972000D+01,0.00000000D+00
     .,0.19940340D+03,0.432D+03,0.400D+01,0.38972000D+01,0.00000000D+00
     .,0.13726170D+03,0.432D+03,0.500D+01,0.38972000D+01,0.00000000D+00
     .,0.94035700D+02,0.432D+03,0.600D+01,0.38972000D+01,0.00000000D+00
     .,0.66329300D+02,0.432D+03,0.700D+01,0.38972000D+01,0.00000000D+00
     .,0.50474100D+02,0.432D+03,0.800D+01,0.38972000D+01,0.00000000D+00
     .,0.38369700D+02,0.432D+03,0.900D+01,0.38972000D+01,0.00000000D+00
     .,0.29574000D+02,0.432D+03,0.100D+02,0.38972000D+01,0.00000000D+00
     .,0.39624310D+03,0.432D+03,0.110D+02,0.38972000D+01,0.00000000D+00
     .,0.31527200D+03,0.432D+03,0.120D+02,0.38972000D+01,0.00000000D+00
     .,0.29419700D+03,0.432D+03,0.130D+02,0.38972000D+01,0.00000000D+00
     .,0.23539440D+03,0.432D+03,0.140D+02,0.38972000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 158201: 158300)=(/
     . 0.18572260D+03,0.432D+03,0.150D+02,0.38972000D+01,0.00000000D+00
     .,0.15516910D+03,0.432D+03,0.160D+02,0.38972000D+01,0.00000000D+00
     .,0.12747850D+03,0.432D+03,0.170D+02,0.38972000D+01,0.00000000D+00
     .,0.10474120D+03,0.432D+03,0.180D+02,0.38972000D+01,0.00000000D+00
     .,0.64529730D+03,0.432D+03,0.190D+02,0.38972000D+01,0.00000000D+00
     .,0.54647840D+03,0.432D+03,0.200D+02,0.38972000D+01,0.00000000D+00
     .,0.45407710D+03,0.432D+03,0.210D+02,0.38972000D+01,0.00000000D+00
     .,0.44076620D+03,0.432D+03,0.220D+02,0.38972000D+01,0.00000000D+00
     .,0.40485430D+03,0.432D+03,0.230D+02,0.38972000D+01,0.00000000D+00
     .,0.31900750D+03,0.432D+03,0.240D+02,0.38972000D+01,0.00000000D+00
     .,0.35008820D+03,0.432D+03,0.250D+02,0.38972000D+01,0.00000000D+00
     .,0.27496140D+03,0.432D+03,0.260D+02,0.38972000D+01,0.00000000D+00
     .,0.29335770D+03,0.432D+03,0.270D+02,0.38972000D+01,0.00000000D+00
     .,0.30126690D+03,0.432D+03,0.280D+02,0.38972000D+01,0.00000000D+00
     .,0.23092580D+03,0.432D+03,0.290D+02,0.38972000D+01,0.00000000D+00
     .,0.23939590D+03,0.432D+03,0.300D+02,0.38972000D+01,0.00000000D+00
     .,0.28294690D+03,0.432D+03,0.310D+02,0.38972000D+01,0.00000000D+00
     .,0.25245910D+03,0.432D+03,0.320D+02,0.38972000D+01,0.00000000D+00
     .,0.21744760D+03,0.432D+03,0.330D+02,0.38972000D+01,0.00000000D+00
     .,0.19619620D+03,0.432D+03,0.340D+02,0.38972000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 158301: 158400)=(/
     . 0.17258230D+03,0.432D+03,0.350D+02,0.38972000D+01,0.00000000D+00
     .,0.15072600D+03,0.432D+03,0.360D+02,0.38972000D+01,0.00000000D+00
     .,0.72493940D+03,0.432D+03,0.370D+02,0.38972000D+01,0.00000000D+00
     .,0.65048490D+03,0.432D+03,0.380D+02,0.38972000D+01,0.00000000D+00
     .,0.57557310D+03,0.432D+03,0.390D+02,0.38972000D+01,0.00000000D+00
     .,0.52045920D+03,0.432D+03,0.400D+02,0.38972000D+01,0.00000000D+00
     .,0.47644890D+03,0.432D+03,0.410D+02,0.38972000D+01,0.00000000D+00
     .,0.37016770D+03,0.432D+03,0.420D+02,0.38972000D+01,0.00000000D+00
     .,0.41205940D+03,0.432D+03,0.430D+02,0.38972000D+01,0.00000000D+00
     .,0.31604420D+03,0.432D+03,0.440D+02,0.38972000D+01,0.00000000D+00
     .,0.34550510D+03,0.432D+03,0.450D+02,0.38972000D+01,0.00000000D+00
     .,0.32111170D+03,0.432D+03,0.460D+02,0.38972000D+01,0.00000000D+00
     .,0.26721350D+03,0.432D+03,0.470D+02,0.38972000D+01,0.00000000D+00
     .,0.28372370D+03,0.432D+03,0.480D+02,0.38972000D+01,0.00000000D+00
     .,0.35360350D+03,0.432D+03,0.490D+02,0.38972000D+01,0.00000000D+00
     .,0.33013010D+03,0.432D+03,0.500D+02,0.38972000D+01,0.00000000D+00
     .,0.29681450D+03,0.432D+03,0.510D+02,0.38972000D+01,0.00000000D+00
     .,0.27677860D+03,0.432D+03,0.520D+02,0.38972000D+01,0.00000000D+00
     .,0.25152290D+03,0.432D+03,0.530D+02,0.38972000D+01,0.00000000D+00
     .,0.22713240D+03,0.432D+03,0.540D+02,0.38972000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 158401: 158500)=(/
     . 0.88397990D+03,0.432D+03,0.550D+02,0.38972000D+01,0.00000000D+00
     .,0.82666440D+03,0.432D+03,0.560D+02,0.38972000D+01,0.00000000D+00
     .,0.73357140D+03,0.432D+03,0.570D+02,0.38972000D+01,0.00000000D+00
     .,0.35001970D+03,0.432D+03,0.580D+02,0.38972000D+01,0.27991000D+01
     .,0.73468830D+03,0.432D+03,0.590D+02,0.38972000D+01,0.00000000D+00
     .,0.70659670D+03,0.432D+03,0.600D+02,0.38972000D+01,0.00000000D+00
     .,0.68917900D+03,0.432D+03,0.610D+02,0.38972000D+01,0.00000000D+00
     .,0.67312870D+03,0.432D+03,0.620D+02,0.38972000D+01,0.00000000D+00
     .,0.65890990D+03,0.432D+03,0.630D+02,0.38972000D+01,0.00000000D+00
     .,0.52379680D+03,0.432D+03,0.640D+02,0.38972000D+01,0.00000000D+00
     .,0.58056100D+03,0.432D+03,0.650D+02,0.38972000D+01,0.00000000D+00
     .,0.56104910D+03,0.432D+03,0.660D+02,0.38972000D+01,0.00000000D+00
     .,0.59575320D+03,0.432D+03,0.670D+02,0.38972000D+01,0.00000000D+00
     .,0.58326490D+03,0.432D+03,0.680D+02,0.38972000D+01,0.00000000D+00
     .,0.57208340D+03,0.432D+03,0.690D+02,0.38972000D+01,0.00000000D+00
     .,0.56513830D+03,0.432D+03,0.700D+02,0.38972000D+01,0.00000000D+00
     .,0.47972770D+03,0.432D+03,0.710D+02,0.38972000D+01,0.00000000D+00
     .,0.47662680D+03,0.432D+03,0.720D+02,0.38972000D+01,0.00000000D+00
     .,0.43746730D+03,0.432D+03,0.730D+02,0.38972000D+01,0.00000000D+00
     .,0.37093970D+03,0.432D+03,0.740D+02,0.38972000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 158501: 158600)=(/
     . 0.37819490D+03,0.432D+03,0.750D+02,0.38972000D+01,0.00000000D+00
     .,0.34433520D+03,0.432D+03,0.760D+02,0.38972000D+01,0.00000000D+00
     .,0.31647760D+03,0.432D+03,0.770D+02,0.38972000D+01,0.00000000D+00
     .,0.26374820D+03,0.432D+03,0.780D+02,0.38972000D+01,0.00000000D+00
     .,0.24671740D+03,0.432D+03,0.790D+02,0.38972000D+01,0.00000000D+00
     .,0.25430200D+03,0.432D+03,0.800D+02,0.38972000D+01,0.00000000D+00
     .,0.36374800D+03,0.432D+03,0.810D+02,0.38972000D+01,0.00000000D+00
     .,0.35827790D+03,0.432D+03,0.820D+02,0.38972000D+01,0.00000000D+00
     .,0.33183780D+03,0.432D+03,0.830D+02,0.38972000D+01,0.00000000D+00
     .,0.31789300D+03,0.432D+03,0.840D+02,0.38972000D+01,0.00000000D+00
     .,0.29484760D+03,0.432D+03,0.850D+02,0.38972000D+01,0.00000000D+00
     .,0.27138550D+03,0.432D+03,0.860D+02,0.38972000D+01,0.00000000D+00
     .,0.84145020D+03,0.432D+03,0.870D+02,0.38972000D+01,0.00000000D+00
     .,0.82171730D+03,0.432D+03,0.880D+02,0.38972000D+01,0.00000000D+00
     .,0.73289850D+03,0.432D+03,0.890D+02,0.38972000D+01,0.00000000D+00
     .,0.66526380D+03,0.432D+03,0.900D+02,0.38972000D+01,0.00000000D+00
     .,0.65709130D+03,0.432D+03,0.910D+02,0.38972000D+01,0.00000000D+00
     .,0.63634590D+03,0.432D+03,0.920D+02,0.38972000D+01,0.00000000D+00
     .,0.65090570D+03,0.432D+03,0.930D+02,0.38972000D+01,0.00000000D+00
     .,0.63106470D+03,0.432D+03,0.940D+02,0.38972000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 158601: 158700)=(/
     . 0.36966400D+02,0.432D+03,0.101D+03,0.38972000D+01,0.00000000D+00
     .,0.11625770D+03,0.432D+03,0.103D+03,0.38972000D+01,0.98650000D+00
     .,0.14894110D+03,0.432D+03,0.104D+03,0.38972000D+01,0.98080000D+00
     .,0.11591450D+03,0.432D+03,0.105D+03,0.38972000D+01,0.97060000D+00
     .,0.88153200D+02,0.432D+03,0.106D+03,0.38972000D+01,0.98680000D+00
     .,0.61839900D+02,0.432D+03,0.107D+03,0.38972000D+01,0.99440000D+00
     .,0.45314100D+02,0.432D+03,0.108D+03,0.38972000D+01,0.99250000D+00
     .,0.31360300D+02,0.432D+03,0.109D+03,0.38972000D+01,0.99820000D+00
     .,0.16914050D+03,0.432D+03,0.111D+03,0.38972000D+01,0.96840000D+00
     .,0.26122720D+03,0.432D+03,0.112D+03,0.38972000D+01,0.96280000D+00
     .,0.26736160D+03,0.432D+03,0.113D+03,0.38972000D+01,0.96480000D+00
     .,0.21800740D+03,0.432D+03,0.114D+03,0.38972000D+01,0.95070000D+00
     .,0.18033050D+03,0.432D+03,0.115D+03,0.38972000D+01,0.99470000D+00
     .,0.15342250D+03,0.432D+03,0.116D+03,0.38972000D+01,0.99480000D+00
     .,0.12613260D+03,0.432D+03,0.117D+03,0.38972000D+01,0.99720000D+00
     .,0.23497420D+03,0.432D+03,0.119D+03,0.38972000D+01,0.97670000D+00
     .,0.43767790D+03,0.432D+03,0.120D+03,0.38972000D+01,0.98310000D+00
     .,0.23797060D+03,0.432D+03,0.121D+03,0.38972000D+01,0.18627000D+01
     .,0.22980530D+03,0.432D+03,0.122D+03,0.38972000D+01,0.18299000D+01
     .,0.22513260D+03,0.432D+03,0.123D+03,0.38972000D+01,0.19138000D+01
     ./)
      grimme_c6_parameters( 158701: 158800)=(/
     . 0.22270380D+03,0.432D+03,0.124D+03,0.38972000D+01,0.18269000D+01
     .,0.20634830D+03,0.432D+03,0.125D+03,0.38972000D+01,0.16406000D+01
     .,0.19131890D+03,0.432D+03,0.126D+03,0.38972000D+01,0.16483000D+01
     .,0.18247980D+03,0.432D+03,0.127D+03,0.38972000D+01,0.17149000D+01
     .,0.17828580D+03,0.432D+03,0.128D+03,0.38972000D+01,0.17937000D+01
     .,0.17518440D+03,0.432D+03,0.129D+03,0.38972000D+01,0.95760000D+00
     .,0.16597640D+03,0.432D+03,0.130D+03,0.38972000D+01,0.19419000D+01
     .,0.26653500D+03,0.432D+03,0.131D+03,0.38972000D+01,0.96010000D+00
     .,0.23678670D+03,0.432D+03,0.132D+03,0.38972000D+01,0.94340000D+00
     .,0.21387070D+03,0.432D+03,0.133D+03,0.38972000D+01,0.98890000D+00
     .,0.19624890D+03,0.432D+03,0.134D+03,0.38972000D+01,0.99010000D+00
     .,0.17373160D+03,0.432D+03,0.135D+03,0.38972000D+01,0.99740000D+00
     .,0.28107340D+03,0.432D+03,0.137D+03,0.38972000D+01,0.97380000D+00
     .,0.53187620D+03,0.432D+03,0.138D+03,0.38972000D+01,0.98010000D+00
     .,0.41462030D+03,0.432D+03,0.139D+03,0.38972000D+01,0.19153000D+01
     .,0.31443980D+03,0.432D+03,0.140D+03,0.38972000D+01,0.19355000D+01
     .,0.31740770D+03,0.432D+03,0.141D+03,0.38972000D+01,0.19545000D+01
     .,0.29662500D+03,0.432D+03,0.142D+03,0.38972000D+01,0.19420000D+01
     .,0.32966960D+03,0.432D+03,0.143D+03,0.38972000D+01,0.16682000D+01
     .,0.26011760D+03,0.432D+03,0.144D+03,0.38972000D+01,0.18584000D+01
     ./)
      grimme_c6_parameters( 158801: 158900)=(/
     . 0.24341820D+03,0.432D+03,0.145D+03,0.38972000D+01,0.19003000D+01
     .,0.22622740D+03,0.432D+03,0.146D+03,0.38972000D+01,0.18630000D+01
     .,0.21858540D+03,0.432D+03,0.147D+03,0.38972000D+01,0.96790000D+00
     .,0.21737600D+03,0.432D+03,0.148D+03,0.38972000D+01,0.19539000D+01
     .,0.33818310D+03,0.432D+03,0.149D+03,0.38972000D+01,0.96330000D+00
     .,0.30894110D+03,0.432D+03,0.150D+03,0.38972000D+01,0.95140000D+00
     .,0.29123020D+03,0.432D+03,0.151D+03,0.38972000D+01,0.97490000D+00
     .,0.27666850D+03,0.432D+03,0.152D+03,0.38972000D+01,0.98110000D+00
     .,0.25387120D+03,0.432D+03,0.153D+03,0.38972000D+01,0.99680000D+00
     .,0.33505240D+03,0.432D+03,0.155D+03,0.38972000D+01,0.99090000D+00
     .,0.68699570D+03,0.432D+03,0.156D+03,0.38972000D+01,0.97970000D+00
     .,0.52395750D+03,0.432D+03,0.157D+03,0.38972000D+01,0.19373000D+01
     .,0.33962030D+03,0.432D+03,0.159D+03,0.38972000D+01,0.29425000D+01
     .,0.33261730D+03,0.432D+03,0.160D+03,0.38972000D+01,0.29455000D+01
     .,0.32220350D+03,0.432D+03,0.161D+03,0.38972000D+01,0.29413000D+01
     .,0.32336760D+03,0.432D+03,0.162D+03,0.38972000D+01,0.29300000D+01
     .,0.31025500D+03,0.432D+03,0.163D+03,0.38972000D+01,0.18286000D+01
     .,0.32531030D+03,0.432D+03,0.164D+03,0.38972000D+01,0.28732000D+01
     .,0.30584570D+03,0.432D+03,0.165D+03,0.38972000D+01,0.29086000D+01
     .,0.31046310D+03,0.432D+03,0.166D+03,0.38972000D+01,0.28965000D+01
     ./)
      grimme_c6_parameters( 158901: 159000)=(/
     . 0.29063460D+03,0.432D+03,0.167D+03,0.38972000D+01,0.29242000D+01
     .,0.28247120D+03,0.432D+03,0.168D+03,0.38972000D+01,0.29282000D+01
     .,0.28057190D+03,0.432D+03,0.169D+03,0.38972000D+01,0.29246000D+01
     .,0.29443330D+03,0.432D+03,0.170D+03,0.38972000D+01,0.28482000D+01
     .,0.27137930D+03,0.432D+03,0.171D+03,0.38972000D+01,0.29219000D+01
     .,0.36212170D+03,0.432D+03,0.172D+03,0.38972000D+01,0.19254000D+01
     .,0.33783560D+03,0.432D+03,0.173D+03,0.38972000D+01,0.19459000D+01
     .,0.30986550D+03,0.432D+03,0.174D+03,0.38972000D+01,0.19292000D+01
     .,0.31199870D+03,0.432D+03,0.175D+03,0.38972000D+01,0.18104000D+01
     .,0.27647840D+03,0.432D+03,0.176D+03,0.38972000D+01,0.18858000D+01
     .,0.26047040D+03,0.432D+03,0.177D+03,0.38972000D+01,0.18648000D+01
     .,0.24897200D+03,0.432D+03,0.178D+03,0.38972000D+01,0.19188000D+01
     .,0.23789260D+03,0.432D+03,0.179D+03,0.38972000D+01,0.98460000D+00
     .,0.23089260D+03,0.432D+03,0.180D+03,0.38972000D+01,0.19896000D+01
     .,0.36361850D+03,0.432D+03,0.181D+03,0.38972000D+01,0.92670000D+00
     .,0.33453020D+03,0.432D+03,0.182D+03,0.38972000D+01,0.93830000D+00
     .,0.32604840D+03,0.432D+03,0.183D+03,0.38972000D+01,0.98200000D+00
     .,0.31819910D+03,0.432D+03,0.184D+03,0.38972000D+01,0.98150000D+00
     .,0.29845520D+03,0.432D+03,0.185D+03,0.38972000D+01,0.99540000D+00
     .,0.37759560D+03,0.432D+03,0.187D+03,0.38972000D+01,0.97050000D+00
     ./)
      grimme_c6_parameters( 159001: 159100)=(/
     . 0.68770170D+03,0.432D+03,0.188D+03,0.38972000D+01,0.96620000D+00
     .,0.40183270D+03,0.432D+03,0.189D+03,0.38972000D+01,0.29070000D+01
     .,0.46011490D+03,0.432D+03,0.190D+03,0.38972000D+01,0.28844000D+01
     .,0.41238990D+03,0.432D+03,0.191D+03,0.38972000D+01,0.28738000D+01
     .,0.36661110D+03,0.432D+03,0.192D+03,0.38972000D+01,0.28878000D+01
     .,0.35322130D+03,0.432D+03,0.193D+03,0.38972000D+01,0.29095000D+01
     .,0.41784880D+03,0.432D+03,0.194D+03,0.38972000D+01,0.19209000D+01
     .,0.99170000D+02,0.432D+03,0.204D+03,0.38972000D+01,0.19697000D+01
     .,0.97688000D+02,0.432D+03,0.205D+03,0.38972000D+01,0.19441000D+01
     .,0.72259500D+02,0.432D+03,0.206D+03,0.38972000D+01,0.19985000D+01
     .,0.58097400D+02,0.432D+03,0.207D+03,0.38972000D+01,0.20143000D+01
     .,0.40013200D+02,0.432D+03,0.208D+03,0.38972000D+01,0.19887000D+01
     .,0.17423120D+03,0.432D+03,0.212D+03,0.38972000D+01,0.19496000D+01
     .,0.21029720D+03,0.432D+03,0.213D+03,0.38972000D+01,0.19311000D+01
     .,0.20317830D+03,0.432D+03,0.214D+03,0.38972000D+01,0.19435000D+01
     .,0.17773730D+03,0.432D+03,0.215D+03,0.38972000D+01,0.20102000D+01
     .,0.15032780D+03,0.432D+03,0.216D+03,0.38972000D+01,0.19903000D+01
     .,0.24395900D+03,0.432D+03,0.220D+03,0.38972000D+01,0.19349000D+01
     .,0.23581030D+03,0.432D+03,0.221D+03,0.38972000D+01,0.28999000D+01
     .,0.23880070D+03,0.432D+03,0.222D+03,0.38972000D+01,0.38675000D+01
     ./)
      grimme_c6_parameters( 159101: 159200)=(/
     . 0.21840030D+03,0.432D+03,0.223D+03,0.38972000D+01,0.29110000D+01
     .,0.16577460D+03,0.432D+03,0.224D+03,0.38972000D+01,0.10619100D+02
     .,0.14252950D+03,0.432D+03,0.225D+03,0.38972000D+01,0.98849000D+01
     .,0.13980680D+03,0.432D+03,0.226D+03,0.38972000D+01,0.91376000D+01
     .,0.16260680D+03,0.432D+03,0.227D+03,0.38972000D+01,0.29263000D+01
     .,0.15184970D+03,0.432D+03,0.228D+03,0.38972000D+01,0.65458000D+01
     .,0.21328870D+03,0.432D+03,0.231D+03,0.38972000D+01,0.19315000D+01
     .,0.22581390D+03,0.432D+03,0.232D+03,0.38972000D+01,0.19447000D+01
     .,0.20845000D+03,0.432D+03,0.233D+03,0.38972000D+01,0.19793000D+01
     .,0.19473060D+03,0.432D+03,0.234D+03,0.38972000D+01,0.19812000D+01
     .,0.29242890D+03,0.432D+03,0.238D+03,0.38972000D+01,0.19143000D+01
     .,0.28359490D+03,0.432D+03,0.239D+03,0.38972000D+01,0.28903000D+01
     .,0.28662000D+03,0.432D+03,0.240D+03,0.38972000D+01,0.39106000D+01
     .,0.27689930D+03,0.432D+03,0.241D+03,0.38972000D+01,0.29225000D+01
     .,0.24611820D+03,0.432D+03,0.242D+03,0.38972000D+01,0.11055600D+02
     .,0.21811560D+03,0.432D+03,0.243D+03,0.38972000D+01,0.95402000D+01
     .,0.20639140D+03,0.432D+03,0.244D+03,0.38972000D+01,0.88895000D+01
     .,0.20911520D+03,0.432D+03,0.245D+03,0.38972000D+01,0.29696000D+01
     .,0.21815300D+03,0.432D+03,0.246D+03,0.38972000D+01,0.57095000D+01
     .,0.27516580D+03,0.432D+03,0.249D+03,0.38972000D+01,0.19378000D+01
     ./)
      grimme_c6_parameters( 159201: 159300)=(/
     . 0.29921170D+03,0.432D+03,0.250D+03,0.38972000D+01,0.19505000D+01
     .,0.28364510D+03,0.432D+03,0.251D+03,0.38972000D+01,0.19523000D+01
     .,0.27457510D+03,0.432D+03,0.252D+03,0.38972000D+01,0.19639000D+01
     .,0.35440230D+03,0.432D+03,0.256D+03,0.38972000D+01,0.18467000D+01
     .,0.36886820D+03,0.432D+03,0.257D+03,0.38972000D+01,0.29175000D+01
     .,0.27514660D+03,0.432D+03,0.272D+03,0.38972000D+01,0.38840000D+01
     .,0.28653550D+03,0.432D+03,0.273D+03,0.38972000D+01,0.28988000D+01
     .,0.26750210D+03,0.432D+03,0.274D+03,0.38972000D+01,0.10915300D+02
     .,0.24384710D+03,0.432D+03,0.275D+03,0.38972000D+01,0.98054000D+01
     .,0.23006870D+03,0.432D+03,0.276D+03,0.38972000D+01,0.91527000D+01
     .,0.23344450D+03,0.432D+03,0.277D+03,0.38972000D+01,0.29424000D+01
     .,0.24547400D+03,0.432D+03,0.278D+03,0.38972000D+01,0.66669000D+01
     .,0.29494270D+03,0.432D+03,0.281D+03,0.38972000D+01,0.19302000D+01
     .,0.31192660D+03,0.432D+03,0.282D+03,0.38972000D+01,0.19356000D+01
     .,0.31874160D+03,0.432D+03,0.283D+03,0.38972000D+01,0.19655000D+01
     .,0.31709360D+03,0.432D+03,0.284D+03,0.38972000D+01,0.19639000D+01
     .,0.39042810D+03,0.432D+03,0.288D+03,0.38972000D+01,0.18075000D+01
     .,0.75031600D+02,0.432D+03,0.305D+03,0.38972000D+01,0.29128000D+01
     .,0.67585400D+02,0.432D+03,0.306D+03,0.38972000D+01,0.29987000D+01
     .,0.51187400D+02,0.432D+03,0.307D+03,0.38972000D+01,0.29903000D+01
     ./)
      grimme_c6_parameters( 159301: 159400)=(/
     . 0.16569080D+03,0.432D+03,0.313D+03,0.38972000D+01,0.29146000D+01
     .,0.19769460D+03,0.432D+03,0.314D+03,0.38972000D+01,0.29407000D+01
     .,0.16535710D+03,0.432D+03,0.315D+03,0.38972000D+01,0.29859000D+01
     .,0.14552910D+03,0.432D+03,0.327D+03,0.38972000D+01,0.77785000D+01
     .,0.15855360D+03,0.432D+03,0.328D+03,0.38972000D+01,0.62918000D+01
     .,0.17612940D+03,0.432D+03,0.331D+03,0.38972000D+01,0.29233000D+01
     .,0.20319220D+03,0.432D+03,0.332D+03,0.38972000D+01,0.29186000D+01
     .,0.20106830D+03,0.432D+03,0.333D+03,0.38972000D+01,0.29709000D+01
     .,0.23637610D+03,0.432D+03,0.349D+03,0.38972000D+01,0.29353000D+01
     .,0.27080520D+03,0.432D+03,0.350D+03,0.38972000D+01,0.29259000D+01
     .,0.27404840D+03,0.432D+03,0.351D+03,0.38972000D+01,0.29315000D+01
     .,0.26442240D+03,0.432D+03,0.381D+03,0.38972000D+01,0.29420000D+01
     .,0.30657470D+03,0.432D+03,0.382D+03,0.38972000D+01,0.29081000D+01
     .,0.30987480D+03,0.432D+03,0.383D+03,0.38972000D+01,0.29500000D+01
     .,0.70691700D+02,0.432D+03,0.405D+03,0.38972000D+01,0.45856000D+01
     .,0.55685700D+02,0.432D+03,0.406D+03,0.38972000D+01,0.39844000D+01
     .,0.16418110D+03,0.432D+03,0.414D+03,0.38972000D+01,0.38677000D+01
     .,0.18029120D+03,0.432D+03,0.432D+03,0.38972000D+01,0.38972000D+01
     .,0.31602000D+02,0.450D+03,0.100D+01,0.39123000D+01,0.91180000D+00
     .,0.21215400D+02,0.450D+03,0.200D+01,0.39123000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 159401: 159500)=(/
     . 0.45591990D+03,0.450D+03,0.300D+01,0.39123000D+01,0.00000000D+00
     .,0.27300460D+03,0.450D+03,0.400D+01,0.39123000D+01,0.00000000D+00
     .,0.18738080D+03,0.450D+03,0.500D+01,0.39123000D+01,0.00000000D+00
     .,0.12831130D+03,0.450D+03,0.600D+01,0.39123000D+01,0.00000000D+00
     .,0.90618400D+02,0.450D+03,0.700D+01,0.39123000D+01,0.00000000D+00
     .,0.69093900D+02,0.450D+03,0.800D+01,0.39123000D+01,0.00000000D+00
     .,0.52666100D+02,0.450D+03,0.900D+01,0.39123000D+01,0.00000000D+00
     .,0.40719500D+02,0.450D+03,0.100D+02,0.39123000D+01,0.00000000D+00
     .,0.54650960D+03,0.450D+03,0.110D+02,0.39123000D+01,0.00000000D+00
     .,0.43237650D+03,0.450D+03,0.120D+02,0.39123000D+01,0.00000000D+00
     .,0.40262520D+03,0.450D+03,0.130D+02,0.39123000D+01,0.00000000D+00
     .,0.32143630D+03,0.450D+03,0.140D+02,0.39123000D+01,0.00000000D+00
     .,0.25331660D+03,0.450D+03,0.150D+02,0.39123000D+01,0.00000000D+00
     .,0.21163180D+03,0.450D+03,0.160D+02,0.39123000D+01,0.00000000D+00
     .,0.17395170D+03,0.450D+03,0.170D+02,0.39123000D+01,0.00000000D+00
     .,0.14307940D+03,0.450D+03,0.180D+02,0.39123000D+01,0.00000000D+00
     .,0.89120910D+03,0.450D+03,0.190D+02,0.39123000D+01,0.00000000D+00
     .,0.75145760D+03,0.450D+03,0.200D+02,0.39123000D+01,0.00000000D+00
     .,0.62382770D+03,0.450D+03,0.210D+02,0.39123000D+01,0.00000000D+00
     .,0.60513210D+03,0.450D+03,0.220D+02,0.39123000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 159501: 159600)=(/
     . 0.55562000D+03,0.450D+03,0.230D+02,0.39123000D+01,0.00000000D+00
     .,0.43806280D+03,0.450D+03,0.240D+02,0.39123000D+01,0.00000000D+00
     .,0.48022450D+03,0.450D+03,0.250D+02,0.39123000D+01,0.00000000D+00
     .,0.37740640D+03,0.450D+03,0.260D+02,0.39123000D+01,0.00000000D+00
     .,0.40204340D+03,0.450D+03,0.270D+02,0.39123000D+01,0.00000000D+00
     .,0.41305650D+03,0.450D+03,0.280D+02,0.39123000D+01,0.00000000D+00
     .,0.31692740D+03,0.450D+03,0.290D+02,0.39123000D+01,0.00000000D+00
     .,0.32786560D+03,0.450D+03,0.300D+02,0.39123000D+01,0.00000000D+00
     .,0.38724130D+03,0.450D+03,0.310D+02,0.39123000D+01,0.00000000D+00
     .,0.34490650D+03,0.450D+03,0.320D+02,0.39123000D+01,0.00000000D+00
     .,0.29675050D+03,0.450D+03,0.330D+02,0.39123000D+01,0.00000000D+00
     .,0.26767240D+03,0.450D+03,0.340D+02,0.39123000D+01,0.00000000D+00
     .,0.23547970D+03,0.450D+03,0.350D+02,0.39123000D+01,0.00000000D+00
     .,0.20576180D+03,0.450D+03,0.360D+02,0.39123000D+01,0.00000000D+00
     .,0.10009319D+04,0.450D+03,0.370D+02,0.39123000D+01,0.00000000D+00
     .,0.89470560D+03,0.450D+03,0.380D+02,0.39123000D+01,0.00000000D+00
     .,0.79039380D+03,0.450D+03,0.390D+02,0.39123000D+01,0.00000000D+00
     .,0.71409530D+03,0.450D+03,0.400D+02,0.39123000D+01,0.00000000D+00
     .,0.65341870D+03,0.450D+03,0.410D+02,0.39123000D+01,0.00000000D+00
     .,0.50749190D+03,0.450D+03,0.420D+02,0.39123000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 159601: 159700)=(/
     . 0.56500310D+03,0.450D+03,0.430D+02,0.39123000D+01,0.00000000D+00
     .,0.43325440D+03,0.450D+03,0.440D+02,0.39123000D+01,0.00000000D+00
     .,0.47345910D+03,0.450D+03,0.450D+02,0.39123000D+01,0.00000000D+00
     .,0.43998550D+03,0.450D+03,0.460D+02,0.39123000D+01,0.00000000D+00
     .,0.36659430D+03,0.450D+03,0.470D+02,0.39123000D+01,0.00000000D+00
     .,0.38876210D+03,0.450D+03,0.480D+02,0.39123000D+01,0.00000000D+00
     .,0.48465320D+03,0.450D+03,0.490D+02,0.39123000D+01,0.00000000D+00
     .,0.45175780D+03,0.450D+03,0.500D+02,0.39123000D+01,0.00000000D+00
     .,0.40568490D+03,0.450D+03,0.510D+02,0.39123000D+01,0.00000000D+00
     .,0.37809630D+03,0.450D+03,0.520D+02,0.39123000D+01,0.00000000D+00
     .,0.34349120D+03,0.450D+03,0.530D+02,0.39123000D+01,0.00000000D+00
     .,0.31018060D+03,0.450D+03,0.540D+02,0.39123000D+01,0.00000000D+00
     .,0.12200459D+04,0.450D+03,0.550D+02,0.39123000D+01,0.00000000D+00
     .,0.11376146D+04,0.450D+03,0.560D+02,0.39123000D+01,0.00000000D+00
     .,0.10078507D+04,0.450D+03,0.570D+02,0.39123000D+01,0.00000000D+00
     .,0.47859810D+03,0.450D+03,0.580D+02,0.39123000D+01,0.27991000D+01
     .,0.10109240D+04,0.450D+03,0.590D+02,0.39123000D+01,0.00000000D+00
     .,0.97204260D+03,0.450D+03,0.600D+02,0.39123000D+01,0.00000000D+00
     .,0.94802150D+03,0.450D+03,0.610D+02,0.39123000D+01,0.00000000D+00
     .,0.92588830D+03,0.450D+03,0.620D+02,0.39123000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 159701: 159800)=(/
     . 0.90627400D+03,0.450D+03,0.630D+02,0.39123000D+01,0.00000000D+00
     .,0.71942080D+03,0.450D+03,0.640D+02,0.39123000D+01,0.00000000D+00
     .,0.79940550D+03,0.450D+03,0.650D+02,0.39123000D+01,0.00000000D+00
     .,0.77227150D+03,0.450D+03,0.660D+02,0.39123000D+01,0.00000000D+00
     .,0.81910080D+03,0.450D+03,0.670D+02,0.39123000D+01,0.00000000D+00
     .,0.80189050D+03,0.450D+03,0.680D+02,0.39123000D+01,0.00000000D+00
     .,0.78645970D+03,0.450D+03,0.690D+02,0.39123000D+01,0.00000000D+00
     .,0.77695490D+03,0.450D+03,0.700D+02,0.39123000D+01,0.00000000D+00
     .,0.65887080D+03,0.450D+03,0.710D+02,0.39123000D+01,0.00000000D+00
     .,0.65329340D+03,0.450D+03,0.720D+02,0.39123000D+01,0.00000000D+00
     .,0.59921110D+03,0.450D+03,0.730D+02,0.39123000D+01,0.00000000D+00
     .,0.50805680D+03,0.450D+03,0.740D+02,0.39123000D+01,0.00000000D+00
     .,0.51781620D+03,0.450D+03,0.750D+02,0.39123000D+01,0.00000000D+00
     .,0.47129410D+03,0.450D+03,0.760D+02,0.39123000D+01,0.00000000D+00
     .,0.43309810D+03,0.450D+03,0.770D+02,0.39123000D+01,0.00000000D+00
     .,0.36112210D+03,0.450D+03,0.780D+02,0.39123000D+01,0.00000000D+00
     .,0.33790780D+03,0.450D+03,0.790D+02,0.39123000D+01,0.00000000D+00
     .,0.34812330D+03,0.450D+03,0.800D+02,0.39123000D+01,0.00000000D+00
     .,0.49876900D+03,0.450D+03,0.810D+02,0.39123000D+01,0.00000000D+00
     .,0.49062310D+03,0.450D+03,0.820D+02,0.39123000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 159801: 159900)=(/
     . 0.45390390D+03,0.450D+03,0.830D+02,0.39123000D+01,0.00000000D+00
     .,0.43458510D+03,0.450D+03,0.840D+02,0.39123000D+01,0.00000000D+00
     .,0.40290830D+03,0.450D+03,0.850D+02,0.39123000D+01,0.00000000D+00
     .,0.37079470D+03,0.450D+03,0.860D+02,0.39123000D+01,0.00000000D+00
     .,0.11599029D+04,0.450D+03,0.870D+02,0.39123000D+01,0.00000000D+00
     .,0.11298719D+04,0.450D+03,0.880D+02,0.39123000D+01,0.00000000D+00
     .,0.10064862D+04,0.450D+03,0.890D+02,0.39123000D+01,0.00000000D+00
     .,0.91246220D+03,0.450D+03,0.900D+02,0.39123000D+01,0.00000000D+00
     .,0.90219930D+03,0.450D+03,0.910D+02,0.39123000D+01,0.00000000D+00
     .,0.87376550D+03,0.450D+03,0.920D+02,0.39123000D+01,0.00000000D+00
     .,0.89481040D+03,0.450D+03,0.930D+02,0.39123000D+01,0.00000000D+00
     .,0.86739140D+03,0.450D+03,0.940D+02,0.39123000D+01,0.00000000D+00
     .,0.50394000D+02,0.450D+03,0.101D+03,0.39123000D+01,0.00000000D+00
     .,0.15913760D+03,0.450D+03,0.103D+03,0.39123000D+01,0.98650000D+00
     .,0.20372270D+03,0.450D+03,0.104D+03,0.39123000D+01,0.98080000D+00
     .,0.15821370D+03,0.450D+03,0.105D+03,0.39123000D+01,0.97060000D+00
     .,0.12031900D+03,0.450D+03,0.106D+03,0.39123000D+01,0.98680000D+00
     .,0.84513800D+02,0.450D+03,0.107D+03,0.39123000D+01,0.99440000D+00
     .,0.62066500D+02,0.450D+03,0.108D+03,0.39123000D+01,0.99250000D+00
     .,0.43143200D+02,0.450D+03,0.109D+03,0.39123000D+01,0.99820000D+00
     ./)
      grimme_c6_parameters( 159901: 160000)=(/
     . 0.23190190D+03,0.450D+03,0.111D+03,0.39123000D+01,0.96840000D+00
     .,0.35800890D+03,0.450D+03,0.112D+03,0.39123000D+01,0.96280000D+00
     .,0.36577110D+03,0.450D+03,0.113D+03,0.39123000D+01,0.96480000D+00
     .,0.29764030D+03,0.450D+03,0.114D+03,0.39123000D+01,0.95070000D+00
     .,0.24597730D+03,0.450D+03,0.115D+03,0.39123000D+01,0.99470000D+00
     .,0.20927130D+03,0.450D+03,0.116D+03,0.39123000D+01,0.99480000D+00
     .,0.17213180D+03,0.450D+03,0.117D+03,0.39123000D+01,0.99720000D+00
     .,0.32212730D+03,0.450D+03,0.119D+03,0.39123000D+01,0.97670000D+00
     .,0.60186910D+03,0.450D+03,0.120D+03,0.39123000D+01,0.98310000D+00
     .,0.32550230D+03,0.450D+03,0.121D+03,0.39123000D+01,0.18627000D+01
     .,0.31438040D+03,0.450D+03,0.122D+03,0.39123000D+01,0.18299000D+01
     .,0.30805200D+03,0.450D+03,0.123D+03,0.39123000D+01,0.19138000D+01
     .,0.30483850D+03,0.450D+03,0.124D+03,0.39123000D+01,0.18269000D+01
     .,0.28215030D+03,0.450D+03,0.125D+03,0.39123000D+01,0.16406000D+01
     .,0.26159540D+03,0.450D+03,0.126D+03,0.39123000D+01,0.16483000D+01
     .,0.24956670D+03,0.450D+03,0.127D+03,0.39123000D+01,0.17149000D+01
     .,0.24387510D+03,0.450D+03,0.128D+03,0.39123000D+01,0.17937000D+01
     .,0.23989280D+03,0.450D+03,0.129D+03,0.39123000D+01,0.95760000D+00
     .,0.22689510D+03,0.450D+03,0.130D+03,0.39123000D+01,0.19419000D+01
     .,0.36463660D+03,0.450D+03,0.131D+03,0.39123000D+01,0.96010000D+00
     ./)
      grimme_c6_parameters( 160001: 160100)=(/
     . 0.32340730D+03,0.450D+03,0.132D+03,0.39123000D+01,0.94340000D+00
     .,0.29186440D+03,0.450D+03,0.133D+03,0.39123000D+01,0.98890000D+00
     .,0.26775420D+03,0.450D+03,0.134D+03,0.39123000D+01,0.99010000D+00
     .,0.23705490D+03,0.450D+03,0.135D+03,0.39123000D+01,0.99740000D+00
     .,0.38525160D+03,0.450D+03,0.137D+03,0.39123000D+01,0.97380000D+00
     .,0.73162570D+03,0.450D+03,0.138D+03,0.39123000D+01,0.98010000D+00
     .,0.56861590D+03,0.450D+03,0.139D+03,0.39123000D+01,0.19153000D+01
     .,0.43018180D+03,0.450D+03,0.140D+03,0.39123000D+01,0.19355000D+01
     .,0.43434220D+03,0.450D+03,0.141D+03,0.39123000D+01,0.19545000D+01
     .,0.40590280D+03,0.450D+03,0.142D+03,0.39123000D+01,0.19420000D+01
     .,0.45173170D+03,0.450D+03,0.143D+03,0.39123000D+01,0.16682000D+01
     .,0.35582860D+03,0.450D+03,0.144D+03,0.39123000D+01,0.18584000D+01
     .,0.33309730D+03,0.450D+03,0.145D+03,0.39123000D+01,0.19003000D+01
     .,0.30966650D+03,0.450D+03,0.146D+03,0.39123000D+01,0.18630000D+01
     .,0.29933180D+03,0.450D+03,0.147D+03,0.39123000D+01,0.96790000D+00
     .,0.29736580D+03,0.450D+03,0.148D+03,0.39123000D+01,0.19539000D+01
     .,0.46329930D+03,0.450D+03,0.149D+03,0.39123000D+01,0.96330000D+00
     .,0.42259500D+03,0.450D+03,0.150D+03,0.39123000D+01,0.95140000D+00
     .,0.39800110D+03,0.450D+03,0.151D+03,0.39123000D+01,0.97490000D+00
     .,0.37792500D+03,0.450D+03,0.152D+03,0.39123000D+01,0.98110000D+00
     ./)
      grimme_c6_parameters( 160101: 160200)=(/
     . 0.34668560D+03,0.450D+03,0.153D+03,0.39123000D+01,0.99680000D+00
     .,0.45839400D+03,0.450D+03,0.155D+03,0.39123000D+01,0.99090000D+00
     .,0.94552740D+03,0.450D+03,0.156D+03,0.39123000D+01,0.97970000D+00
     .,0.71867700D+03,0.450D+03,0.157D+03,0.39123000D+01,0.19373000D+01
     .,0.46437650D+03,0.450D+03,0.159D+03,0.39123000D+01,0.29425000D+01
     .,0.45481020D+03,0.450D+03,0.160D+03,0.39123000D+01,0.29455000D+01
     .,0.44056910D+03,0.450D+03,0.161D+03,0.39123000D+01,0.29413000D+01
     .,0.44222540D+03,0.450D+03,0.162D+03,0.39123000D+01,0.29300000D+01
     .,0.42469280D+03,0.450D+03,0.163D+03,0.39123000D+01,0.18286000D+01
     .,0.44484260D+03,0.450D+03,0.164D+03,0.39123000D+01,0.28732000D+01
     .,0.41824050D+03,0.450D+03,0.165D+03,0.39123000D+01,0.29086000D+01
     .,0.42468210D+03,0.450D+03,0.166D+03,0.39123000D+01,0.28965000D+01
     .,0.39737350D+03,0.450D+03,0.167D+03,0.39123000D+01,0.29242000D+01
     .,0.38619540D+03,0.450D+03,0.168D+03,0.39123000D+01,0.29282000D+01
     .,0.38360070D+03,0.450D+03,0.169D+03,0.39123000D+01,0.29246000D+01
     .,0.40253610D+03,0.450D+03,0.170D+03,0.39123000D+01,0.28482000D+01
     .,0.37098070D+03,0.450D+03,0.171D+03,0.39123000D+01,0.29219000D+01
     .,0.49582350D+03,0.450D+03,0.172D+03,0.39123000D+01,0.19254000D+01
     .,0.46234390D+03,0.450D+03,0.173D+03,0.39123000D+01,0.19459000D+01
     .,0.42390050D+03,0.450D+03,0.174D+03,0.39123000D+01,0.19292000D+01
     ./)
      grimme_c6_parameters( 160201: 160300)=(/
     . 0.42713880D+03,0.450D+03,0.175D+03,0.39123000D+01,0.18104000D+01
     .,0.37805750D+03,0.450D+03,0.176D+03,0.39123000D+01,0.18858000D+01
     .,0.35625810D+03,0.450D+03,0.177D+03,0.39123000D+01,0.18648000D+01
     .,0.34062570D+03,0.450D+03,0.178D+03,0.39123000D+01,0.19188000D+01
     .,0.32564110D+03,0.450D+03,0.179D+03,0.39123000D+01,0.98460000D+00
     .,0.31586290D+03,0.450D+03,0.180D+03,0.39123000D+01,0.19896000D+01
     .,0.49832750D+03,0.450D+03,0.181D+03,0.39123000D+01,0.92670000D+00
     .,0.45783400D+03,0.450D+03,0.182D+03,0.39123000D+01,0.93830000D+00
     .,0.44587260D+03,0.450D+03,0.183D+03,0.39123000D+01,0.98200000D+00
     .,0.43494050D+03,0.450D+03,0.184D+03,0.39123000D+01,0.98150000D+00
     .,0.40780020D+03,0.450D+03,0.185D+03,0.39123000D+01,0.99540000D+00
     .,0.51650850D+03,0.450D+03,0.187D+03,0.39123000D+01,0.97050000D+00
     .,0.94554140D+03,0.450D+03,0.188D+03,0.39123000D+01,0.96620000D+00
     .,0.54936590D+03,0.450D+03,0.189D+03,0.39123000D+01,0.29070000D+01
     .,0.62982470D+03,0.450D+03,0.190D+03,0.39123000D+01,0.28844000D+01
     .,0.56451290D+03,0.450D+03,0.191D+03,0.39123000D+01,0.28738000D+01
     .,0.50156450D+03,0.450D+03,0.192D+03,0.39123000D+01,0.28878000D+01
     .,0.48322840D+03,0.450D+03,0.193D+03,0.39123000D+01,0.29095000D+01
     .,0.57296750D+03,0.450D+03,0.194D+03,0.39123000D+01,0.19209000D+01
     .,0.13526050D+03,0.450D+03,0.204D+03,0.39123000D+01,0.19697000D+01
     ./)
      grimme_c6_parameters( 160301: 160400)=(/
     . 0.13332140D+03,0.450D+03,0.205D+03,0.39123000D+01,0.19441000D+01
     .,0.98654000D+02,0.450D+03,0.206D+03,0.39123000D+01,0.19985000D+01
     .,0.79452200D+02,0.450D+03,0.207D+03,0.39123000D+01,0.20143000D+01
     .,0.54900500D+02,0.450D+03,0.208D+03,0.39123000D+01,0.19887000D+01
     .,0.23805490D+03,0.450D+03,0.212D+03,0.39123000D+01,0.19496000D+01
     .,0.28733370D+03,0.450D+03,0.213D+03,0.39123000D+01,0.19311000D+01
     .,0.27734590D+03,0.450D+03,0.214D+03,0.39123000D+01,0.19435000D+01
     .,0.24249400D+03,0.450D+03,0.215D+03,0.39123000D+01,0.20102000D+01
     .,0.20506870D+03,0.450D+03,0.216D+03,0.39123000D+01,0.19903000D+01
     .,0.33372060D+03,0.450D+03,0.220D+03,0.39123000D+01,0.19349000D+01
     .,0.32229080D+03,0.450D+03,0.221D+03,0.39123000D+01,0.28999000D+01
     .,0.32638510D+03,0.450D+03,0.222D+03,0.39123000D+01,0.38675000D+01
     .,0.29865910D+03,0.450D+03,0.223D+03,0.39123000D+01,0.29110000D+01
     .,0.22674830D+03,0.450D+03,0.224D+03,0.39123000D+01,0.10619100D+02
     .,0.19495560D+03,0.450D+03,0.225D+03,0.39123000D+01,0.98849000D+01
     .,0.19127030D+03,0.450D+03,0.226D+03,0.39123000D+01,0.91376000D+01
     .,0.22252350D+03,0.450D+03,0.227D+03,0.39123000D+01,0.29263000D+01
     .,0.20778550D+03,0.450D+03,0.228D+03,0.39123000D+01,0.65458000D+01
     .,0.29143960D+03,0.450D+03,0.231D+03,0.39123000D+01,0.19315000D+01
     .,0.30837570D+03,0.450D+03,0.232D+03,0.39123000D+01,0.19447000D+01
     ./)
      grimme_c6_parameters( 160401: 160500)=(/
     . 0.28445060D+03,0.450D+03,0.233D+03,0.39123000D+01,0.19793000D+01
     .,0.26569090D+03,0.450D+03,0.234D+03,0.39123000D+01,0.19812000D+01
     .,0.40006500D+03,0.450D+03,0.238D+03,0.39123000D+01,0.19143000D+01
     .,0.38751810D+03,0.450D+03,0.239D+03,0.39123000D+01,0.28903000D+01
     .,0.39155320D+03,0.450D+03,0.240D+03,0.39123000D+01,0.39106000D+01
     .,0.37846930D+03,0.450D+03,0.241D+03,0.39123000D+01,0.29225000D+01
     .,0.33635920D+03,0.450D+03,0.242D+03,0.39123000D+01,0.11055600D+02
     .,0.29811220D+03,0.450D+03,0.243D+03,0.39123000D+01,0.95402000D+01
     .,0.28214800D+03,0.450D+03,0.244D+03,0.39123000D+01,0.88895000D+01
     .,0.28612510D+03,0.450D+03,0.245D+03,0.39123000D+01,0.29696000D+01
     .,0.29849500D+03,0.450D+03,0.246D+03,0.39123000D+01,0.57095000D+01
     .,0.37650510D+03,0.450D+03,0.249D+03,0.39123000D+01,0.19378000D+01
     .,0.40920080D+03,0.450D+03,0.250D+03,0.39123000D+01,0.19505000D+01
     .,0.38757520D+03,0.450D+03,0.251D+03,0.39123000D+01,0.19523000D+01
     .,0.37504230D+03,0.450D+03,0.252D+03,0.39123000D+01,0.19639000D+01
     .,0.48468920D+03,0.450D+03,0.256D+03,0.39123000D+01,0.18467000D+01
     .,0.50402900D+03,0.450D+03,0.257D+03,0.39123000D+01,0.29175000D+01
     .,0.37581480D+03,0.450D+03,0.272D+03,0.39123000D+01,0.38840000D+01
     .,0.39163870D+03,0.450D+03,0.273D+03,0.39123000D+01,0.28988000D+01
     .,0.36554820D+03,0.450D+03,0.274D+03,0.39123000D+01,0.10915300D+02
     ./)
      grimme_c6_parameters( 160501: 160600)=(/
     . 0.33325000D+03,0.450D+03,0.275D+03,0.39123000D+01,0.98054000D+01
     .,0.31443610D+03,0.450D+03,0.276D+03,0.39123000D+01,0.91527000D+01
     .,0.31935010D+03,0.450D+03,0.277D+03,0.39123000D+01,0.29424000D+01
     .,0.33574880D+03,0.450D+03,0.278D+03,0.39123000D+01,0.66669000D+01
     .,0.40362310D+03,0.450D+03,0.281D+03,0.39123000D+01,0.19302000D+01
     .,0.42669190D+03,0.450D+03,0.282D+03,0.39123000D+01,0.19356000D+01
     .,0.43576920D+03,0.450D+03,0.283D+03,0.39123000D+01,0.19655000D+01
     .,0.43337030D+03,0.450D+03,0.284D+03,0.39123000D+01,0.19639000D+01
     .,0.53385140D+03,0.450D+03,0.288D+03,0.39123000D+01,0.18075000D+01
     .,0.10232470D+03,0.450D+03,0.305D+03,0.39123000D+01,0.29128000D+01
     .,0.92326000D+02,0.450D+03,0.306D+03,0.39123000D+01,0.29987000D+01
     .,0.70080000D+02,0.450D+03,0.307D+03,0.39123000D+01,0.29903000D+01
     .,0.22605040D+03,0.450D+03,0.313D+03,0.39123000D+01,0.29146000D+01
     .,0.26996790D+03,0.450D+03,0.314D+03,0.39123000D+01,0.29407000D+01
     .,0.22554180D+03,0.450D+03,0.315D+03,0.39123000D+01,0.29859000D+01
     .,0.19911820D+03,0.450D+03,0.327D+03,0.39123000D+01,0.77785000D+01
     .,0.21713920D+03,0.450D+03,0.328D+03,0.39123000D+01,0.62918000D+01
     .,0.24041780D+03,0.450D+03,0.331D+03,0.39123000D+01,0.29233000D+01
     .,0.27737170D+03,0.450D+03,0.332D+03,0.39123000D+01,0.29186000D+01
     .,0.27434930D+03,0.450D+03,0.333D+03,0.39123000D+01,0.29709000D+01
     ./)
      grimme_c6_parameters( 160601: 160700)=(/
     . 0.32315090D+03,0.450D+03,0.349D+03,0.39123000D+01,0.29353000D+01
     .,0.37016740D+03,0.450D+03,0.350D+03,0.39123000D+01,0.29259000D+01
     .,0.37439290D+03,0.450D+03,0.351D+03,0.39123000D+01,0.29315000D+01
     .,0.36163550D+03,0.450D+03,0.381D+03,0.39123000D+01,0.29420000D+01
     .,0.41924330D+03,0.450D+03,0.382D+03,0.39123000D+01,0.29081000D+01
     .,0.42353200D+03,0.450D+03,0.383D+03,0.39123000D+01,0.29500000D+01
     .,0.96417900D+02,0.450D+03,0.405D+03,0.39123000D+01,0.45856000D+01
     .,0.76081000D+02,0.450D+03,0.406D+03,0.39123000D+01,0.39844000D+01
     .,0.22392830D+03,0.450D+03,0.414D+03,0.39123000D+01,0.38677000D+01
     .,0.24599220D+03,0.450D+03,0.432D+03,0.39123000D+01,0.38972000D+01
     .,0.33610200D+03,0.450D+03,0.450D+03,0.39123000D+01,0.39123000D+01
     .,0.36783600D+02,0.482D+03,0.100D+01,0.39098000D+01,0.91180000D+00
     .,0.24792600D+02,0.482D+03,0.200D+01,0.39098000D+01,0.00000000D+00
     .,0.53122450D+03,0.482D+03,0.300D+01,0.39098000D+01,0.00000000D+00
     .,0.31732060D+03,0.482D+03,0.400D+01,0.39098000D+01,0.00000000D+00
     .,0.21779730D+03,0.482D+03,0.500D+01,0.39098000D+01,0.00000000D+00
     .,0.14929680D+03,0.482D+03,0.600D+01,0.39098000D+01,0.00000000D+00
     .,0.10560300D+03,0.482D+03,0.700D+01,0.39098000D+01,0.00000000D+00
     .,0.80644400D+02,0.482D+03,0.800D+01,0.39098000D+01,0.00000000D+00
     .,0.61573700D+02,0.482D+03,0.900D+01,0.39098000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 160701: 160800)=(/
     . 0.47684400D+02,0.482D+03,0.100D+02,0.39098000D+01,0.00000000D+00
     .,0.63682150D+03,0.482D+03,0.110D+02,0.39098000D+01,0.00000000D+00
     .,0.50280810D+03,0.482D+03,0.120D+02,0.39098000D+01,0.00000000D+00
     .,0.46801840D+03,0.482D+03,0.130D+02,0.39098000D+01,0.00000000D+00
     .,0.37358140D+03,0.482D+03,0.140D+02,0.39098000D+01,0.00000000D+00
     .,0.29452850D+03,0.482D+03,0.150D+02,0.39098000D+01,0.00000000D+00
     .,0.24623230D+03,0.482D+03,0.160D+02,0.39098000D+01,0.00000000D+00
     .,0.20258030D+03,0.482D+03,0.170D+02,0.39098000D+01,0.00000000D+00
     .,0.16681140D+03,0.482D+03,0.180D+02,0.39098000D+01,0.00000000D+00
     .,0.10395015D+04,0.482D+03,0.190D+02,0.39098000D+01,0.00000000D+00
     .,0.87485890D+03,0.482D+03,0.200D+02,0.39098000D+01,0.00000000D+00
     .,0.72603180D+03,0.482D+03,0.210D+02,0.39098000D+01,0.00000000D+00
     .,0.70421370D+03,0.482D+03,0.220D+02,0.39098000D+01,0.00000000D+00
     .,0.64655260D+03,0.482D+03,0.230D+02,0.39098000D+01,0.00000000D+00
     .,0.51001320D+03,0.482D+03,0.240D+02,0.39098000D+01,0.00000000D+00
     .,0.55878150D+03,0.482D+03,0.250D+02,0.39098000D+01,0.00000000D+00
     .,0.43938300D+03,0.482D+03,0.260D+02,0.39098000D+01,0.00000000D+00
     .,0.46773930D+03,0.482D+03,0.270D+02,0.39098000D+01,0.00000000D+00
     .,0.48056400D+03,0.482D+03,0.280D+02,0.39098000D+01,0.00000000D+00
     .,0.36899340D+03,0.482D+03,0.290D+02,0.39098000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 160801: 160900)=(/
     . 0.38142390D+03,0.482D+03,0.300D+02,0.39098000D+01,0.00000000D+00
     .,0.45032390D+03,0.482D+03,0.310D+02,0.39098000D+01,0.00000000D+00
     .,0.40100460D+03,0.482D+03,0.320D+02,0.39098000D+01,0.00000000D+00
     .,0.34508980D+03,0.482D+03,0.330D+02,0.39098000D+01,0.00000000D+00
     .,0.31140410D+03,0.482D+03,0.340D+02,0.39098000D+01,0.00000000D+00
     .,0.27412300D+03,0.482D+03,0.350D+02,0.39098000D+01,0.00000000D+00
     .,0.23971550D+03,0.482D+03,0.360D+02,0.39098000D+01,0.00000000D+00
     .,0.11675181D+04,0.482D+03,0.370D+02,0.39098000D+01,0.00000000D+00
     .,0.10418714D+04,0.482D+03,0.380D+02,0.39098000D+01,0.00000000D+00
     .,0.91996850D+03,0.482D+03,0.390D+02,0.39098000D+01,0.00000000D+00
     .,0.83102350D+03,0.482D+03,0.400D+02,0.39098000D+01,0.00000000D+00
     .,0.76040220D+03,0.482D+03,0.410D+02,0.39098000D+01,0.00000000D+00
     .,0.59076540D+03,0.482D+03,0.420D+02,0.39098000D+01,0.00000000D+00
     .,0.65761940D+03,0.482D+03,0.430D+02,0.39098000D+01,0.00000000D+00
     .,0.50446970D+03,0.482D+03,0.440D+02,0.39098000D+01,0.00000000D+00
     .,0.55107490D+03,0.482D+03,0.450D+02,0.39098000D+01,0.00000000D+00
     .,0.51214360D+03,0.482D+03,0.460D+02,0.39098000D+01,0.00000000D+00
     .,0.42704150D+03,0.482D+03,0.470D+02,0.39098000D+01,0.00000000D+00
     .,0.45257800D+03,0.482D+03,0.480D+02,0.39098000D+01,0.00000000D+00
     .,0.56405260D+03,0.482D+03,0.490D+02,0.39098000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 160901: 161000)=(/
     . 0.52557130D+03,0.482D+03,0.500D+02,0.39098000D+01,0.00000000D+00
     .,0.47195910D+03,0.482D+03,0.510D+02,0.39098000D+01,0.00000000D+00
     .,0.43993100D+03,0.482D+03,0.520D+02,0.39098000D+01,0.00000000D+00
     .,0.39979760D+03,0.482D+03,0.530D+02,0.39098000D+01,0.00000000D+00
     .,0.36119780D+03,0.482D+03,0.540D+02,0.39098000D+01,0.00000000D+00
     .,0.14230570D+04,0.482D+03,0.550D+02,0.39098000D+01,0.00000000D+00
     .,0.13251273D+04,0.482D+03,0.560D+02,0.39098000D+01,0.00000000D+00
     .,0.11733669D+04,0.482D+03,0.570D+02,0.39098000D+01,0.00000000D+00
     .,0.55692770D+03,0.482D+03,0.580D+02,0.39098000D+01,0.27991000D+01
     .,0.11775400D+04,0.482D+03,0.590D+02,0.39098000D+01,0.00000000D+00
     .,0.11321484D+04,0.482D+03,0.600D+02,0.39098000D+01,0.00000000D+00
     .,0.11041399D+04,0.482D+03,0.610D+02,0.39098000D+01,0.00000000D+00
     .,0.10783321D+04,0.482D+03,0.620D+02,0.39098000D+01,0.00000000D+00
     .,0.10554583D+04,0.482D+03,0.630D+02,0.39098000D+01,0.00000000D+00
     .,0.83768840D+03,0.482D+03,0.640D+02,0.39098000D+01,0.00000000D+00
     .,0.93165810D+03,0.482D+03,0.650D+02,0.39098000D+01,0.00000000D+00
     .,0.89994220D+03,0.482D+03,0.660D+02,0.39098000D+01,0.00000000D+00
     .,0.95379600D+03,0.482D+03,0.670D+02,0.39098000D+01,0.00000000D+00
     .,0.93372910D+03,0.482D+03,0.680D+02,0.39098000D+01,0.00000000D+00
     .,0.91573150D+03,0.482D+03,0.690D+02,0.39098000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 161001: 161100)=(/
     . 0.90466320D+03,0.482D+03,0.700D+02,0.39098000D+01,0.00000000D+00
     .,0.76704550D+03,0.482D+03,0.710D+02,0.39098000D+01,0.00000000D+00
     .,0.76010300D+03,0.482D+03,0.720D+02,0.39098000D+01,0.00000000D+00
     .,0.69715900D+03,0.482D+03,0.730D+02,0.39098000D+01,0.00000000D+00
     .,0.59132700D+03,0.482D+03,0.740D+02,0.39098000D+01,0.00000000D+00
     .,0.60261270D+03,0.482D+03,0.750D+02,0.39098000D+01,0.00000000D+00
     .,0.54853340D+03,0.482D+03,0.760D+02,0.39098000D+01,0.00000000D+00
     .,0.50415770D+03,0.482D+03,0.770D+02,0.39098000D+01,0.00000000D+00
     .,0.42063020D+03,0.482D+03,0.780D+02,0.39098000D+01,0.00000000D+00
     .,0.39369250D+03,0.482D+03,0.790D+02,0.39098000D+01,0.00000000D+00
     .,0.40549310D+03,0.482D+03,0.800D+02,0.39098000D+01,0.00000000D+00
     .,0.58079990D+03,0.482D+03,0.810D+02,0.39098000D+01,0.00000000D+00
     .,0.57106960D+03,0.482D+03,0.820D+02,0.39098000D+01,0.00000000D+00
     .,0.52826530D+03,0.482D+03,0.830D+02,0.39098000D+01,0.00000000D+00
     .,0.50580110D+03,0.482D+03,0.840D+02,0.39098000D+01,0.00000000D+00
     .,0.46902930D+03,0.482D+03,0.850D+02,0.39098000D+01,0.00000000D+00
     .,0.43179360D+03,0.482D+03,0.860D+02,0.39098000D+01,0.00000000D+00
     .,0.13523973D+04,0.482D+03,0.870D+02,0.39098000D+01,0.00000000D+00
     .,0.13158434D+04,0.482D+03,0.880D+02,0.39098000D+01,0.00000000D+00
     .,0.11716435D+04,0.482D+03,0.890D+02,0.39098000D+01,0.00000000D+00
     ./)
      grimme_c6_parameters( 161101: 161200)=(/
     . 0.10619693D+04,0.482D+03,0.900D+02,0.39098000D+01,0.00000000D+00
     .,0.10504296D+04,0.482D+03,0.910D+02,0.39098000D+01,0.00000000D+00
     .,0.10173620D+04,0.482D+03,0.920D+02,0.39098000D+01,0.00000000D+00
     .,0.10421717D+04,0.482D+03,0.930D+02,0.39098000D+01,0.00000000D+00
     .,0.10101837D+04,0.482D+03,0.940D+02,0.39098000D+01,0.00000000D+00
     .,0.58587500D+02,0.482D+03,0.101D+03,0.39098000D+01,0.00000000D+00
     .,0.18499140D+03,0.482D+03,0.103D+03,0.39098000D+01,0.98650000D+00
     .,0.23683180D+03,0.482D+03,0.104D+03,0.39098000D+01,0.98080000D+00
     .,0.18395600D+03,0.482D+03,0.105D+03,0.39098000D+01,0.97060000D+00
     .,0.14003800D+03,0.482D+03,0.106D+03,0.39098000D+01,0.98680000D+00
     .,0.98524700D+02,0.482D+03,0.107D+03,0.39098000D+01,0.99440000D+00
     .,0.72487200D+02,0.482D+03,0.108D+03,0.39098000D+01,0.99250000D+00
     .,0.50522200D+02,0.482D+03,0.109D+03,0.39098000D+01,0.99820000D+00
     .,0.26973770D+03,0.482D+03,0.111D+03,0.39098000D+01,0.96840000D+00
     .,0.41633670D+03,0.482D+03,0.112D+03,0.39098000D+01,0.96280000D+00
     .,0.42518440D+03,0.482D+03,0.113D+03,0.39098000D+01,0.96480000D+00
     .,0.34595860D+03,0.482D+03,0.114D+03,0.39098000D+01,0.95070000D+00
     .,0.28602000D+03,0.482D+03,0.115D+03,0.39098000D+01,0.99470000D+00
     .,0.24349690D+03,0.482D+03,0.116D+03,0.39098000D+01,0.99480000D+00
     .,0.20046870D+03,0.482D+03,0.117D+03,0.39098000D+01,0.99720000D+00
     ./)
      grimme_c6_parameters( 161201: 161300)=(/
     . 0.37503550D+03,0.482D+03,0.119D+03,0.39098000D+01,0.97670000D+00
     .,0.70097800D+03,0.482D+03,0.120D+03,0.39098000D+01,0.98310000D+00
     .,0.37867460D+03,0.482D+03,0.121D+03,0.39098000D+01,0.18627000D+01
     .,0.36578460D+03,0.482D+03,0.122D+03,0.39098000D+01,0.18299000D+01
     .,0.35844930D+03,0.482D+03,0.123D+03,0.39098000D+01,0.19138000D+01
     .,0.35474250D+03,0.482D+03,0.124D+03,0.39098000D+01,0.18269000D+01
     .,0.32825710D+03,0.482D+03,0.125D+03,0.39098000D+01,0.16406000D+01
     .,0.30438240D+03,0.482D+03,0.126D+03,0.39098000D+01,0.16483000D+01
     .,0.29042420D+03,0.482D+03,0.127D+03,0.39098000D+01,0.17149000D+01
     .,0.28381310D+03,0.482D+03,0.128D+03,0.39098000D+01,0.17937000D+01
     .,0.27924290D+03,0.482D+03,0.129D+03,0.39098000D+01,0.95760000D+00
     .,0.26402220D+03,0.482D+03,0.130D+03,0.39098000D+01,0.19419000D+01
     .,0.42402640D+03,0.482D+03,0.131D+03,0.39098000D+01,0.96010000D+00
     .,0.37603190D+03,0.482D+03,0.132D+03,0.39098000D+01,0.94340000D+00
     .,0.33942410D+03,0.482D+03,0.133D+03,0.39098000D+01,0.98890000D+00
     .,0.31150380D+03,0.482D+03,0.134D+03,0.39098000D+01,0.99010000D+00
     .,0.27595340D+03,0.482D+03,0.135D+03,0.39098000D+01,0.99740000D+00
     .,0.44859350D+03,0.482D+03,0.137D+03,0.39098000D+01,0.97380000D+00
     .,0.85231430D+03,0.482D+03,0.138D+03,0.39098000D+01,0.98010000D+00
     .,0.66191080D+03,0.482D+03,0.139D+03,0.39098000D+01,0.19153000D+01
     ./)
      grimme_c6_parameters( 161301: 161400)=(/
     . 0.50057750D+03,0.482D+03,0.140D+03,0.39098000D+01,0.19355000D+01
     .,0.50546450D+03,0.482D+03,0.141D+03,0.39098000D+01,0.19545000D+01
     .,0.47245030D+03,0.482D+03,0.142D+03,0.39098000D+01,0.19420000D+01
     .,0.52594030D+03,0.482D+03,0.143D+03,0.39098000D+01,0.16682000D+01
     .,0.41423030D+03,0.482D+03,0.144D+03,0.39098000D+01,0.18584000D+01
     .,0.38785700D+03,0.482D+03,0.145D+03,0.39098000D+01,0.19003000D+01
     .,0.36065710D+03,0.482D+03,0.146D+03,0.39098000D+01,0.18630000D+01
     .,0.34865520D+03,0.482D+03,0.147D+03,0.39098000D+01,0.96790000D+00
     .,0.34625000D+03,0.482D+03,0.148D+03,0.39098000D+01,0.19539000D+01
     .,0.53916270D+03,0.482D+03,0.149D+03,0.39098000D+01,0.96330000D+00
     .,0.49165990D+03,0.482D+03,0.150D+03,0.39098000D+01,0.95140000D+00
     .,0.46303140D+03,0.482D+03,0.151D+03,0.39098000D+01,0.97490000D+00
     .,0.43973150D+03,0.482D+03,0.152D+03,0.39098000D+01,0.98110000D+00
     .,0.40350580D+03,0.482D+03,0.153D+03,0.39098000D+01,0.99680000D+00
     .,0.53352020D+03,0.482D+03,0.155D+03,0.39098000D+01,0.99090000D+00
     .,0.11018490D+04,0.482D+03,0.156D+03,0.39098000D+01,0.97970000D+00
     .,0.83668870D+03,0.482D+03,0.157D+03,0.39098000D+01,0.19373000D+01
     .,0.54039720D+03,0.482D+03,0.159D+03,0.39098000D+01,0.29425000D+01
     .,0.52927220D+03,0.482D+03,0.160D+03,0.39098000D+01,0.29455000D+01
     .,0.51271470D+03,0.482D+03,0.161D+03,0.39098000D+01,0.29413000D+01
     ./)
      grimme_c6_parameters( 161401: 161500)=(/
     . 0.51464180D+03,0.482D+03,0.162D+03,0.39098000D+01,0.29300000D+01
     .,0.49434850D+03,0.482D+03,0.163D+03,0.39098000D+01,0.18286000D+01
     .,0.51763800D+03,0.482D+03,0.164D+03,0.39098000D+01,0.28732000D+01
     .,0.48672230D+03,0.482D+03,0.165D+03,0.39098000D+01,0.29086000D+01
     .,0.49423650D+03,0.482D+03,0.166D+03,0.39098000D+01,0.28965000D+01
     .,0.46243040D+03,0.482D+03,0.167D+03,0.39098000D+01,0.29242000D+01
     .,0.44942300D+03,0.482D+03,0.168D+03,0.39098000D+01,0.29282000D+01
     .,0.44639320D+03,0.482D+03,0.169D+03,0.39098000D+01,0.29246000D+01
     .,0.46834080D+03,0.482D+03,0.170D+03,0.39098000D+01,0.28482000D+01
     .,0.43169210D+03,0.482D+03,0.171D+03,0.39098000D+01,0.29219000D+01
     .,0.57700800D+03,0.482D+03,0.172D+03,0.39098000D+01,0.19254000D+01
     .,0.53808640D+03,0.482D+03,0.173D+03,0.39098000D+01,0.19459000D+01
     .,0.49341180D+03,0.482D+03,0.174D+03,0.39098000D+01,0.19292000D+01
     .,0.49722060D+03,0.482D+03,0.175D+03,0.39098000D+01,0.18104000D+01
     .,0.44014790D+03,0.482D+03,0.176D+03,0.39098000D+01,0.18858000D+01
     .,0.41487760D+03,0.482D+03,0.177D+03,0.39098000D+01,0.18648000D+01
     .,0.39675610D+03,0.482D+03,0.178D+03,0.39098000D+01,0.19188000D+01
     .,0.37939980D+03,0.482D+03,0.179D+03,0.39098000D+01,0.98460000D+00
     .,0.36797200D+03,0.482D+03,0.180D+03,0.39098000D+01,0.19896000D+01
     .,0.58018030D+03,0.482D+03,0.181D+03,0.39098000D+01,0.92670000D+00
     ./)
      grimme_c6_parameters( 161501: 161600)=(/
     . 0.53289470D+03,0.482D+03,0.182D+03,0.39098000D+01,0.93830000D+00
     .,0.51891070D+03,0.482D+03,0.183D+03,0.39098000D+01,0.98200000D+00
     .,0.50620180D+03,0.482D+03,0.184D+03,0.39098000D+01,0.98150000D+00
     .,0.47470440D+03,0.482D+03,0.185D+03,0.39098000D+01,0.99540000D+00
     .,0.60111980D+03,0.482D+03,0.187D+03,0.39098000D+01,0.97050000D+00
     .,0.11015277D+04,0.482D+03,0.188D+03,0.39098000D+01,0.96620000D+00
     .,0.63923770D+03,0.482D+03,0.189D+03,0.39098000D+01,0.29070000D+01
     .,0.73305960D+03,0.482D+03,0.190D+03,0.39098000D+01,0.28844000D+01
     .,0.65721210D+03,0.482D+03,0.191D+03,0.39098000D+01,0.28738000D+01
     .,0.58388650D+03,0.482D+03,0.192D+03,0.39098000D+01,0.28878000D+01
     .,0.56256740D+03,0.482D+03,0.193D+03,0.39098000D+01,0.29095000D+01
     .,0.66728070D+03,0.482D+03,0.194D+03,0.39098000D+01,0.19209000D+01
     .,0.15719910D+03,0.482D+03,0.204D+03,0.39098000D+01,0.19697000D+01
     .,0.15506850D+03,0.482D+03,0.205D+03,0.39098000D+01,0.19441000D+01
     .,0.11488240D+03,0.482D+03,0.206D+03,0.39098000D+01,0.19985000D+01
     .,0.92650800D+02,0.482D+03,0.207D+03,0.39098000D+01,0.20143000D+01
     .,0.64174400D+02,0.482D+03,0.208D+03,0.39098000D+01,0.19887000D+01
     .,0.27667550D+03,0.482D+03,0.212D+03,0.39098000D+01,0.19496000D+01
     .,0.33398620D+03,0.482D+03,0.213D+03,0.39098000D+01,0.19311000D+01
     .,0.32238950D+03,0.482D+03,0.214D+03,0.39098000D+01,0.19435000D+01
     ./)
      grimme_c6_parameters( 161601: 161700)=(/
     . 0.28199150D+03,0.482D+03,0.215D+03,0.39098000D+01,0.20102000D+01
     .,0.23862230D+03,0.482D+03,0.216D+03,0.39098000D+01,0.19903000D+01
     .,0.38820850D+03,0.482D+03,0.220D+03,0.39098000D+01,0.19349000D+01
     .,0.37487440D+03,0.482D+03,0.221D+03,0.39098000D+01,0.28999000D+01
     .,0.37965070D+03,0.482D+03,0.222D+03,0.39098000D+01,0.38675000D+01
     .,0.34749740D+03,0.482D+03,0.223D+03,0.39098000D+01,0.29110000D+01
     .,0.26405320D+03,0.482D+03,0.224D+03,0.39098000D+01,0.10619100D+02
     .,0.22711690D+03,0.482D+03,0.225D+03,0.39098000D+01,0.98849000D+01
     .,0.22282550D+03,0.482D+03,0.226D+03,0.39098000D+01,0.91376000D+01
     .,0.25908200D+03,0.482D+03,0.227D+03,0.39098000D+01,0.29263000D+01
     .,0.24194730D+03,0.482D+03,0.228D+03,0.39098000D+01,0.65458000D+01
     .,0.33891650D+03,0.482D+03,0.231D+03,0.39098000D+01,0.19315000D+01
     .,0.35857470D+03,0.482D+03,0.232D+03,0.39098000D+01,0.19447000D+01
     .,0.33082030D+03,0.482D+03,0.233D+03,0.39098000D+01,0.19793000D+01
     .,0.30911340D+03,0.482D+03,0.234D+03,0.39098000D+01,0.19812000D+01
     .,0.46550130D+03,0.482D+03,0.238D+03,0.39098000D+01,0.19143000D+01
     .,0.45081160D+03,0.482D+03,0.239D+03,0.39098000D+01,0.28903000D+01
     .,0.45551320D+03,0.482D+03,0.240D+03,0.39098000D+01,0.39106000D+01
     .,0.44042440D+03,0.482D+03,0.241D+03,0.39098000D+01,0.29225000D+01
     .,0.39158340D+03,0.482D+03,0.242D+03,0.39098000D+01,0.11055600D+02
     ./)
      grimme_c6_parameters( 161701: 161800)=(/
     . 0.34719340D+03,0.482D+03,0.243D+03,0.39098000D+01,0.95402000D+01
     .,0.32867310D+03,0.482D+03,0.244D+03,0.39098000D+01,0.88895000D+01
     .,0.33331550D+03,0.482D+03,0.245D+03,0.39098000D+01,0.29696000D+01
     .,0.34765890D+03,0.482D+03,0.246D+03,0.39098000D+01,0.57095000D+01
     .,0.43817200D+03,0.482D+03,0.249D+03,0.39098000D+01,0.19378000D+01
     .,0.47608450D+03,0.482D+03,0.250D+03,0.39098000D+01,0.19505000D+01
     .,0.45091710D+03,0.482D+03,0.251D+03,0.39098000D+01,0.19523000D+01
     .,0.43638380D+03,0.482D+03,0.252D+03,0.39098000D+01,0.19639000D+01
     .,0.56401480D+03,0.482D+03,0.256D+03,0.39098000D+01,0.18467000D+01
     .,0.58633110D+03,0.482D+03,0.257D+03,0.39098000D+01,0.29175000D+01
     .,0.43725330D+03,0.482D+03,0.272D+03,0.39098000D+01,0.38840000D+01
     .,0.45578380D+03,0.482D+03,0.273D+03,0.39098000D+01,0.28988000D+01
     .,0.42555250D+03,0.482D+03,0.274D+03,0.39098000D+01,0.10915300D+02
     .,0.38809680D+03,0.482D+03,0.275D+03,0.39098000D+01,0.98054000D+01
     .,0.36629140D+03,0.482D+03,0.276D+03,0.39098000D+01,0.91527000D+01
     .,0.37206660D+03,0.482D+03,0.277D+03,0.39098000D+01,0.29424000D+01
     .,0.39108870D+03,0.482D+03,0.278D+03,0.39098000D+01,0.66669000D+01
     .,0.46992250D+03,0.482D+03,0.281D+03,0.39098000D+01,0.19302000D+01
     .,0.49666200D+03,0.482D+03,0.282D+03,0.39098000D+01,0.19356000D+01
     .,0.50715130D+03,0.482D+03,0.283D+03,0.39098000D+01,0.19655000D+01
     ./)
      grimme_c6_parameters( 161801: 161900)=(/
     . 0.50436840D+03,0.482D+03,0.284D+03,0.39098000D+01,0.19639000D+01
     .,0.62120410D+03,0.482D+03,0.288D+03,0.39098000D+01,0.18075000D+01
     .,0.11907380D+03,0.482D+03,0.305D+03,0.39098000D+01,0.29128000D+01
     .,0.10755120D+03,0.482D+03,0.306D+03,0.39098000D+01,0.29987000D+01
     .,0.81781000D+02,0.482D+03,0.307D+03,0.39098000D+01,0.29903000D+01
     .,0.26273830D+03,0.482D+03,0.313D+03,0.39098000D+01,0.29146000D+01
     .,0.31386840D+03,0.482D+03,0.314D+03,0.39098000D+01,0.29407000D+01
     .,0.26230480D+03,0.482D+03,0.315D+03,0.39098000D+01,0.29859000D+01
     .,0.23191300D+03,0.482D+03,0.327D+03,0.39098000D+01,0.77785000D+01
     .,0.25285690D+03,0.482D+03,0.328D+03,0.39098000D+01,0.62918000D+01
     .,0.27961360D+03,0.482D+03,0.331D+03,0.39098000D+01,0.29233000D+01
     .,0.32256300D+03,0.482D+03,0.332D+03,0.39098000D+01,0.29186000D+01
     .,0.31909300D+03,0.482D+03,0.333D+03,0.39098000D+01,0.29709000D+01
     .,0.37612340D+03,0.482D+03,0.349D+03,0.39098000D+01,0.29353000D+01
     .,0.43071080D+03,0.482D+03,0.350D+03,0.39098000D+01,0.29259000D+01
     .,0.43559950D+03,0.482D+03,0.351D+03,0.39098000D+01,0.29315000D+01
     .,0.42108940D+03,0.482D+03,0.381D+03,0.39098000D+01,0.29420000D+01
     .,0.48797400D+03,0.482D+03,0.382D+03,0.39098000D+01,0.29081000D+01
     .,0.49291380D+03,0.482D+03,0.383D+03,0.39098000D+01,0.29500000D+01
     .,0.11222540D+03,0.482D+03,0.405D+03,0.39098000D+01,0.45856000D+01
     ./)
      grimme_c6_parameters( 161901: 161925)=(/
     . 0.88703000D+02,0.482D+03,0.406D+03,0.39098000D+01,0.39844000D+01
     .,0.26034680D+03,0.482D+03,0.414D+03,0.39098000D+01,0.38677000D+01
     .,0.28611790D+03,0.482D+03,0.432D+03,0.39098000D+01,0.38972000D+01
     .,0.39112500D+03,0.482D+03,0.450D+03,0.39098000D+01,0.39123000D+01
     .,0.45528540D+03,0.482D+03,0.482D+03,0.39098000D+01,0.39098000D+01
     ./)
c
c     Extract data from tables in usable format
c
      do iline=0,max_elements
         maxcn(iline)=0
      enddo
c
      idata=1
      do iline=1,nlines
       iat=int(grimme_c6_parameters(idata+1))
       jat=int(grimme_c6_parameters(idata+2))
       call xc_vdwlimit(iat,jat,iadr,jadr)
       maxcn(iat)=max(maxcn(iat),iadr)
       maxcn(jat)=max(maxcn(jat),jadr)
       c6ab(iat,jat,iadr,jadr,1)=grimme_c6_parameters(idata)
       c6ab(iat,jat,iadr,jadr,2)=grimme_c6_parameters(idata+3)
       c6ab(iat,jat,iadr,jadr,3)=grimme_c6_parameters(idata+4)
       c6ab(jat,iat,jadr,iadr,1)=grimme_c6_parameters(idata)
       c6ab(jat,iat,jadr,iadr,2)=grimme_c6_parameters(idata+4)
       c6ab(jat,iat,jadr,iadr,3)=grimme_c6_parameters(idata+3)
       idata=(iline*5)+1
      enddo
      return
      end
c
c     Initialize, scale, and convert covalent radii from angstrom to au
c
      subroutine init_cov_rad_d3(ang2au)
      implicit none
#include "xc_vdw.fh"
      double precision ang2au
      integer i
c
c     Grimme:
c     covalent radii (taken from Pyykko and Atsumi, Chem. Eur. J. 15, 2009, 188-197)
c     values for metals decreased by 10 %
c
      cov_table(1:max_elements)=(/
     .  0.32, 0.46, 1.20, 0.94, 0.77, 0.75, 0.71, 0.63, 0.64, 0.67
     ., 1.40, 1.25, 1.13, 1.04, 1.10, 1.02, 0.99, 0.96, 1.76, 1.54
     ., 1.33, 1.22, 1.21, 1.10, 1.07, 1.04, 1.00, 0.99, 1.01, 1.09
     ., 1.12, 1.09, 1.15, 1.10, 1.14, 1.17, 1.89, 1.67, 1.47, 1.39
     ., 1.32, 1.24, 1.15, 1.13, 1.13, 1.08, 1.15, 1.23, 1.28, 1.26
     ., 1.26, 1.23, 1.32, 1.31, 2.09, 1.76, 1.62, 1.47, 1.58, 1.57
     ., 1.56, 1.55, 1.51, 1.52, 1.51, 1.50, 1.49, 1.49, 1.48, 1.53
     ., 1.46, 1.37, 1.31, 1.23, 1.18, 1.16, 1.11, 1.12, 1.13, 1.32
     ., 1.30, 1.30, 1.36, 1.31, 1.38, 1.42, 2.01, 1.81, 1.67, 1.58
     ., 1.52, 1.53, 1.54, 1.55 /)
c
      do i=1,max_elements
         cov_table(i)=cov_table(i)*k2*ang2au
      enddo
      return
      end
c
c     initialize Qat for c8ab term properly scaling with atom number Z
c
      subroutine init_qat
      implicit none
#include "xc_vdw.fh"
      integer i
c
c     Grimme:
c     PBE0/def2-QZVP atomic values
c
      Qatom(1:max_elements)=(/
     .  8.0589,  3.4698, 29.0974, 14.8517, 11.8799,  7.8715,  5.5588,
     .  4.7566,  3.8025,  3.1036, 26.1552, 17.2304, 17.7210, 12.7442,
     .  9.5361,  8.1652,  6.7463,  5.6004, 29.2012, 22.3934, 19.0598,
     . 16.8590, 15.4023, 12.5589, 13.4788, 12.2309, 11.2809, 10.5569,
     . 10.1428,  9.4907, 13.4606, 10.8544,  8.9386,  8.1350,  7.1251,
     .  6.1971, 30.0162, 24.4103, 20.3537, 17.4780, 13.5528, 11.8451,
     . 11.0355, 10.1997,  9.5414,  9.0061,  8.6417,  8.9975, 14.0834,
     . 11.8333, 10.0179,  9.3844,  8.4110,  7.5152, 32.7622, 27.5708,
     . 23.1671, 21.6003, 20.9615, 20.4562, 20.1010, 19.7475, 19.4828,
     . 15.6013, 19.2362, 17.4717, 17.8321, 17.4237, 17.1954, 17.1631,
     . 14.5716, 15.8758, 13.8989, 12.4834, 11.4421, 10.2671,  8.3549,
     .  7.8496,  7.3278,  7.4820, 13.5124, 11.6554, 10.0959,  9.7340,
     .  8.8584,  8.0125, 29.8135, 26.3157, 19.1885, 15.8542, 16.1305,
     . 15.6161, 15.1226, 16.1576 /)
c
      do i=1,max_elements
         Qatom(i)=dsqrt(0.5d0*Qatom(i)*dble(i)**0.50d0)
      enddo
      return
      end
c
c     Initialize r0ab table and convert from angstrom to au
c
      subroutine init_r0ab_d3(ang2au)
      implicit none
#include "xc_vdw.fh"
      double precision ang2au
      double precision r0ab_ref_table_grimme(4465)
      integer i,j,k
c
      r0ab_ref_table_grimme(   1:  70)=(/
     .   2.1823,  1.8547,  1.7347,  2.9086,  2.5732,  3.4956,  2.3550
     .,  2.5095,  2.9802,  3.0982,  2.5141,  2.3917,  2.9977,  2.9484
     .,  3.2160,  2.4492,  2.2527,  3.1933,  3.0214,  2.9531,  2.9103
     .,  2.3667,  2.1328,  2.8784,  2.7660,  2.7776,  2.7063,  2.6225
     .,  2.1768,  2.0625,  2.6395,  2.6648,  2.6482,  2.5697,  2.4846
     .,  2.4817,  2.0646,  1.9891,  2.5086,  2.6908,  2.6233,  2.4770
     .,  2.3885,  2.3511,  2.2996,  1.9892,  1.9251,  2.4190,  2.5473
     .,  2.4994,  2.4091,  2.3176,  2.2571,  2.1946,  2.1374,  2.9898
     .,  2.6397,  3.6031,  3.1219,  3.7620,  3.2485,  2.9357,  2.7093
     .,  2.5781,  2.4839,  3.7082,  2.5129,  2.7321,  3.1052,  3.2962
     ./)
      r0ab_ref_table_grimme(  71: 140)=(/
     .   3.1331,  3.2000,  2.9586,  3.0822,  2.8582,  2.7120,  3.2570
     .,  3.4839,  2.8766,  2.7427,  3.2776,  3.2363,  3.5929,  3.2826
     .,  3.0911,  2.9369,  2.9030,  2.7789,  3.3921,  3.3970,  4.0106
     .,  2.8884,  2.6605,  3.7513,  3.1613,  3.3605,  3.3325,  3.0991
     .,  2.9297,  2.8674,  2.7571,  3.8129,  3.3266,  3.7105,  3.7917
     .,  2.8304,  2.5538,  3.3932,  3.1193,  3.1866,  3.1245,  3.0465
     .,  2.8727,  2.7664,  2.6926,  3.4608,  3.2984,  3.5142,  3.5418
     .,  3.5017,  2.6190,  2.4797,  3.1331,  3.0540,  3.0651,  2.9879
     .,  2.9054,  2.8805,  2.7330,  2.6331,  3.2096,  3.5668,  3.3684
     .,  3.3686,  3.3180,  3.3107,  2.4757,  2.4019,  2.9789,  3.1468
     ./)
      r0ab_ref_table_grimme( 141: 210)=(/
     .   2.9768,  2.8848,  2.7952,  2.7457,  2.6881,  2.5728,  3.0574
     .,  3.3264,  3.3562,  3.2529,  3.1916,  3.1523,  3.1046,  2.3725
     .,  2.3289,  2.8760,  2.9804,  2.9093,  2.8040,  2.7071,  2.6386
     .,  2.5720,  2.5139,  2.9517,  3.1606,  3.2085,  3.1692,  3.0982
     .,  3.0352,  2.9730,  2.9148,  3.2147,  2.8315,  3.8724,  3.4621
     .,  3.8823,  3.3760,  3.0746,  2.8817,  2.7552,  2.6605,  3.9740
     .,  3.6192,  3.6569,  3.9586,  3.6188,  3.3917,  3.2479,  3.1434
     .,  4.2411,  2.7597,  3.0588,  3.3474,  3.6214,  3.4353,  3.4729
     .,  3.2487,  3.3200,  3.0914,  2.9403,  3.4972,  3.7993,  3.6773
     .,  3.8678,  3.5808,  3.8243,  3.5826,  3.4156,  3.8765,  4.1035
     ./)
      r0ab_ref_table_grimme( 211: 280)=(/
     .   2.7361,  2.9765,  3.2475,  3.5004,  3.4185,  3.4378,  3.2084
     .,  3.2787,  3.0604,  2.9187,  3.4037,  3.6759,  3.6586,  3.8327
     .,  3.5372,  3.7665,  3.5310,  3.3700,  3.7788,  3.9804,  3.8903
     .,  2.6832,  2.9060,  3.2613,  3.4359,  3.3538,  3.3860,  3.1550
     .,  3.2300,  3.0133,  2.8736,  3.4024,  3.6142,  3.5979,  3.5295
     .,  3.4834,  3.7140,  3.4782,  3.3170,  3.7434,  3.9623,  3.8181
     .,  3.7642,  2.6379,  2.8494,  3.1840,  3.4225,  3.2771,  3.3401
     .,  3.1072,  3.1885,  2.9714,  2.8319,  3.3315,  3.5979,  3.5256
     .,  3.4980,  3.4376,  3.6714,  3.4346,  3.2723,  3.6859,  3.8985
     .,  3.7918,  3.7372,  3.7211,  2.9230,  2.6223,  3.4161,  2.8999
     ./)
      r0ab_ref_table_grimme( 281: 350)=(/
     .   3.0557,  3.3308,  3.0555,  2.8508,  2.7385,  2.6640,  3.5263
     .,  3.0277,  3.2990,  3.7721,  3.5017,  3.2751,  3.1368,  3.0435
     .,  3.7873,  3.2858,  3.2140,  3.1727,  3.2178,  3.4414,  2.5490
     .,  2.7623,  3.0991,  3.3252,  3.1836,  3.2428,  3.0259,  3.1225
     .,  2.9032,  2.7621,  3.2490,  3.5110,  3.4429,  3.3845,  3.3574
     .,  3.6045,  3.3658,  3.2013,  3.6110,  3.8241,  3.7090,  3.6496
     .,  3.6333,  3.0896,  3.5462,  2.4926,  2.7136,  3.0693,  3.2699
     .,  3.1272,  3.1893,  2.9658,  3.0972,  2.8778,  2.7358,  3.2206
     .,  3.4566,  3.3896,  3.3257,  3.2946,  3.5693,  3.3312,  3.1670
     .,  3.5805,  3.7711,  3.6536,  3.5927,  3.5775,  3.0411,  3.4885
     ./)
      r0ab_ref_table_grimme( 351: 420)=(/
     .   3.4421,  2.4667,  2.6709,  3.0575,  3.2357,  3.0908,  3.1537
     .,  2.9235,  3.0669,  2.8476,  2.7054,  3.2064,  3.4519,  3.3593
     .,  3.2921,  3.2577,  3.2161,  3.2982,  3.1339,  3.5606,  3.7582
     .,  3.6432,  3.5833,  3.5691,  3.0161,  3.4812,  3.4339,  3.4327
     .,  2.4515,  2.6338,  3.0511,  3.2229,  3.0630,  3.1265,  2.8909
     .,  3.0253,  2.8184,  2.6764,  3.1968,  3.4114,  3.3492,  3.2691
     .,  3.2320,  3.1786,  3.2680,  3.1036,  3.5453,  3.7259,  3.6090
     .,  3.5473,  3.5327,  3.0018,  3.4413,  3.3907,  3.3593,  3.3462
     .,  2.4413,  2.6006,  3.0540,  3.1987,  3.0490,  3.1058,  2.8643
     .,  2.9948,  2.7908,  2.6491,  3.1950,  3.3922,  3.3316,  3.2585
     ./)
      r0ab_ref_table_grimme( 421: 490)=(/
     .   3.2136,  3.1516,  3.2364,  3.0752,  3.5368,  3.7117,  3.5941
     .,  3.5313,  3.5164,  2.9962,  3.4225,  3.3699,  3.3370,  3.3234
     .,  3.3008,  2.4318,  2.5729,  3.0416,  3.1639,  3.0196,  3.0843
     .,  2.8413,  2.7436,  2.7608,  2.6271,  3.1811,  3.3591,  3.3045
     .,  3.2349,  3.1942,  3.1291,  3.2111,  3.0534,  3.5189,  3.6809
     .,  3.5635,  3.5001,  3.4854,  2.9857,  3.3897,  3.3363,  3.3027
     .,  3.2890,  3.2655,  3.2309,  2.8502,  2.6934,  3.2467,  3.1921
     .,  3.5663,  3.2541,  3.0571,  2.9048,  2.8657,  2.7438,  3.3547
     .,  3.3510,  3.9837,  3.6871,  3.4862,  3.3389,  3.2413,  3.1708
     .,  3.6096,  3.6280,  3.6860,  3.5568,  3.4836,  3.2868,  3.3994
     ./)
      r0ab_ref_table_grimme( 491: 560)=(/
     .   3.3476,  3.3170,  3.2950,  3.2874,  3.2606,  3.9579,  2.9226
     .,  2.6838,  3.7867,  3.1732,  3.3872,  3.3643,  3.1267,  2.9541
     .,  2.8505,  2.7781,  3.8475,  3.3336,  3.7359,  3.8266,  3.5733
     .,  3.3959,  3.2775,  3.1915,  3.9878,  3.8816,  3.5810,  3.5364
     .,  3.5060,  3.8097,  3.3925,  3.3348,  3.3019,  3.2796,  3.2662
     .,  3.2464,  3.7136,  3.8619,  2.9140,  2.6271,  3.4771,  3.1774
     .,  3.2560,  3.1970,  3.1207,  2.9406,  2.8322,  2.7571,  3.5455
     .,  3.3514,  3.5837,  3.6177,  3.5816,  3.3902,  3.2604,  3.1652
     .,  3.7037,  3.6283,  3.5858,  3.5330,  3.4884,  3.5789,  3.4094
     .,  3.3473,  3.3118,  3.2876,  3.2707,  3.2521,  3.5570,  3.6496
     ./)
      r0ab_ref_table_grimme( 561: 630)=(/
     .   3.6625,  2.7300,  2.5870,  3.2471,  3.1487,  3.1667,  3.0914
     .,  3.0107,  2.9812,  2.8300,  2.7284,  3.3259,  3.3182,  3.4707
     .,  3.4748,  3.4279,  3.4182,  3.2547,  3.1353,  3.5116,  3.9432
     .,  3.8828,  3.8303,  3.7880,  3.3760,  3.7218,  3.3408,  3.3059
     .,  3.2698,  3.2446,  3.2229,  3.4422,  3.5023,  3.5009,  3.5268
     .,  2.6026,  2.5355,  3.1129,  3.2863,  3.1029,  3.0108,  2.9227
     .,  2.8694,  2.8109,  2.6929,  3.1958,  3.4670,  3.4018,  3.3805
     .,  3.3218,  3.2815,  3.2346,  3.0994,  3.3937,  3.7266,  3.6697
     .,  3.6164,  3.5730,  3.2522,  3.5051,  3.4686,  3.4355,  3.4084
     .,  3.3748,  3.3496,  3.3692,  3.4052,  3.3910,  3.3849,  3.3662
     ./)
      r0ab_ref_table_grimme( 631: 700)=(/
     .   2.5087,  2.4814,  3.0239,  3.1312,  3.0535,  2.9457,  2.8496
     .,  2.7780,  2.7828,  2.6532,  3.1063,  3.3143,  3.3549,  3.3120
     .,  3.2421,  3.1787,  3.1176,  3.0613,  3.3082,  3.5755,  3.5222
     .,  3.4678,  3.4231,  3.1684,  3.3528,  3.3162,  3.2827,  3.2527
     .,  3.2308,  3.2029,  3.3173,  3.3343,  3.3092,  3.2795,  3.2452
     .,  3.2096,  3.2893,  2.8991,  4.0388,  3.6100,  3.9388,  3.4475
     .,  3.1590,  2.9812,  2.8586,  2.7683,  4.1428,  3.7911,  3.8225
     .,  4.0372,  3.7059,  3.4935,  3.3529,  3.2492,  4.4352,  4.0826
     .,  3.9733,  3.9254,  3.8646,  3.9315,  3.7837,  3.7465,  3.7211
     .,  3.7012,  3.6893,  3.6676,  3.7736,  4.0660,  3.7926,  3.6158
     ./)
      r0ab_ref_table_grimme( 701: 770)=(/
     .   3.5017,  3.4166,  4.6176,  2.8786,  3.1658,  3.5823,  3.7689
     .,  3.5762,  3.5789,  3.3552,  3.4004,  3.1722,  3.0212,  3.7241
     .,  3.9604,  3.8500,  3.9844,  3.7035,  3.9161,  3.6751,  3.5075
     .,  4.1151,  4.2877,  4.1579,  4.1247,  4.0617,  3.4874,  3.9848
     .,  3.9280,  3.9079,  3.8751,  3.8604,  3.8277,  3.8002,  3.9981
     .,  3.7544,  4.0371,  3.8225,  3.6718,  4.3092,  4.4764,  2.8997
     .,  3.0953,  3.4524,  3.6107,  3.6062,  3.5783,  3.3463,  3.3855
     .,  3.1746,  3.0381,  3.6019,  3.7938,  3.8697,  3.9781,  3.6877
     .,  3.8736,  3.6451,  3.4890,  3.9858,  4.1179,  4.0430,  3.9563
     .,  3.9182,  3.4002,  3.8310,  3.7716,  3.7543,  3.7203,  3.7053
     ./)
      r0ab_ref_table_grimme( 771: 840)=(/
     .   3.6742,  3.8318,  3.7631,  3.7392,  3.9892,  3.7832,  3.6406
     .,  4.1701,  4.3016,  4.2196,  2.8535,  3.0167,  3.3978,  3.5363
     .,  3.5393,  3.5301,  3.2960,  3.3352,  3.1287,  2.9967,  3.6659
     .,  3.7239,  3.8070,  3.7165,  3.6368,  3.8162,  3.5885,  3.4336
     .,  3.9829,  4.0529,  3.9584,  3.9025,  3.8607,  3.3673,  3.7658
     .,  3.7035,  3.6866,  3.6504,  3.6339,  3.6024,  3.7708,  3.7283
     .,  3.6896,  3.9315,  3.7250,  3.5819,  4.1457,  4.2280,  4.1130
     .,  4.0597,  3.0905,  2.7998,  3.6448,  3.0739,  3.2996,  3.5262
     .,  3.2559,  3.0518,  2.9394,  2.8658,  3.7514,  3.2295,  3.5643
     .,  3.7808,  3.6931,  3.4723,  3.3357,  3.2429,  4.0280,  3.5589
     ./)
      r0ab_ref_table_grimme( 841: 910)=(/
     .   3.4636,  3.4994,  3.4309,  3.6177,  3.2946,  3.2376,  3.2050
     .,  3.1847,  3.1715,  3.1599,  3.5555,  3.8111,  3.7693,  3.5718
     .,  3.4498,  3.3662,  4.1608,  3.7417,  3.6536,  3.6154,  3.8596
     .,  3.0301,  2.7312,  3.5821,  3.0473,  3.2137,  3.4679,  3.1975
     .,  2.9969,  2.8847,  2.8110,  3.6931,  3.2076,  3.4943,  3.5956
     .,  3.6379,  3.4190,  3.2808,  3.1860,  3.9850,  3.5105,  3.4330
     .,  3.3797,  3.4155,  3.6033,  3.2737,  3.2145,  3.1807,  3.1596
     .,  3.1461,  3.1337,  3.4812,  3.6251,  3.7152,  3.5201,  3.3966
     .,  3.3107,  4.1128,  3.6899,  3.6082,  3.5604,  3.7834,  3.7543
     .,  2.9189,  2.6777,  3.4925,  2.9648,  3.1216,  3.2940,  3.0975
     ./)
      r0ab_ref_table_grimme( 911: 980)=(/
     .   2.9757,  2.8493,  2.7638,  3.6085,  3.1214,  3.4006,  3.4793
     .,  3.5147,  3.3806,  3.2356,  3.1335,  3.9144,  3.4183,  3.3369
     .,  3.2803,  3.2679,  3.4871,  3.1714,  3.1521,  3.1101,  3.0843
     .,  3.0670,  3.0539,  3.3890,  3.5086,  3.5895,  3.4783,  3.3484
     .,  3.2559,  4.0422,  3.5967,  3.5113,  3.4576,  3.6594,  3.6313
     .,  3.5690,  2.8578,  2.6334,  3.4673,  2.9245,  3.0732,  3.2435
     .,  3.0338,  2.9462,  2.8143,  2.7240,  3.5832,  3.0789,  3.3617
     .,  3.4246,  3.4505,  3.3443,  3.1964,  3.0913,  3.8921,  3.3713
     .,  3.2873,  3.2281,  3.2165,  3.4386,  3.1164,  3.1220,  3.0761
     .,  3.0480,  3.0295,  3.0155,  3.3495,  3.4543,  3.5260,  3.4413
     ./)
      r0ab_ref_table_grimme( 981:1050)=(/
     .   3.3085,  3.2134,  4.0170,  3.5464,  3.4587,  3.4006,  3.6027
     .,  3.5730,  3.4945,  3.4623,  2.8240,  2.5960,  3.4635,  2.9032
     .,  3.0431,  3.2115,  2.9892,  2.9148,  2.7801,  2.6873,  3.5776
     .,  3.0568,  3.3433,  3.3949,  3.4132,  3.3116,  3.1616,  3.0548
     .,  3.8859,  3.3719,  3.2917,  3.2345,  3.2274,  3.4171,  3.1293
     .,  3.0567,  3.0565,  3.0274,  3.0087,  2.9939,  3.3293,  3.4249
     .,  3.4902,  3.4091,  3.2744,  3.1776,  4.0078,  3.5374,  3.4537
     .,  3.3956,  3.5747,  3.5430,  3.4522,  3.4160,  3.3975,  2.8004
     .,  2.5621,  3.4617,  2.9154,  3.0203,  3.1875,  2.9548,  2.8038
     .,  2.7472,  2.6530,  3.5736,  3.0584,  3.3304,  3.3748,  3.3871
     ./)
      r0ab_ref_table_grimme(1051:1120)=(/
     .   3.2028,  3.1296,  3.0214,  3.8796,  3.3337,  3.2492,  3.1883
     .,  3.1802,  3.4050,  3.0756,  3.0478,  3.0322,  3.0323,  3.0163
     .,  3.0019,  3.3145,  3.4050,  3.4656,  3.3021,  3.2433,  3.1453
     .,  3.9991,  3.5017,  3.4141,  3.3520,  3.5583,  3.5251,  3.4243
     .,  3.3851,  3.3662,  3.3525,  2.7846,  2.5324,  3.4652,  2.8759
     .,  3.0051,  3.1692,  2.9273,  2.7615,  2.7164,  2.6212,  3.5744
     .,  3.0275,  3.3249,  3.3627,  3.3686,  3.1669,  3.0584,  2.9915
     .,  3.8773,  3.3099,  3.2231,  3.1600,  3.1520,  3.4023,  3.0426
     .,  3.0099,  2.9920,  2.9809,  2.9800,  2.9646,  3.3068,  3.3930
     .,  3.4486,  3.2682,  3.1729,  3.1168,  3.9952,  3.4796,  3.3901
     ./)
      r0ab_ref_table_grimme(1121:1190)=(/
     .   3.3255,  3.5530,  3.5183,  3.4097,  3.3683,  3.3492,  3.3360
     .,  3.3308,  2.5424,  2.6601,  3.2555,  3.2807,  3.1384,  3.1737
     .,  2.9397,  2.8429,  2.8492,  2.7225,  3.3875,  3.4910,  3.4520
     .,  3.3608,  3.3036,  3.2345,  3.2999,  3.1487,  3.7409,  3.8392
     .,  3.7148,  3.6439,  3.6182,  3.1753,  3.5210,  3.4639,  3.4265
     .,  3.4075,  3.3828,  3.3474,  3.4071,  3.3754,  3.3646,  3.3308
     .,  3.4393,  3.2993,  3.8768,  3.9891,  3.8310,  3.7483,  3.3417
     .,  3.3019,  3.2250,  3.1832,  3.1578,  3.1564,  3.1224,  3.4620
     .,  2.9743,  2.8058,  3.4830,  3.3474,  3.6863,  3.3617,  3.1608
     .,  3.0069,  2.9640,  2.8427,  3.5885,  3.5219,  4.1314,  3.8120
     ./)
      r0ab_ref_table_grimme(1191:1260)=(/
     .   3.6015,  3.4502,  3.3498,  3.2777,  3.8635,  3.8232,  3.8486
     .,  3.7215,  3.6487,  3.4724,  3.5627,  3.5087,  3.4757,  3.4517
     .,  3.4423,  3.4139,  4.1028,  3.8388,  3.6745,  3.5562,  3.4806
     .,  3.4272,  4.0182,  3.9991,  4.0007,  3.9282,  3.7238,  3.6498
     .,  3.5605,  3.5211,  3.5009,  3.4859,  3.4785,  3.5621,  4.2623
     .,  3.0775,  2.8275,  4.0181,  3.3385,  3.5379,  3.5036,  3.2589
     .,  3.0804,  3.0094,  2.9003,  4.0869,  3.5088,  3.9105,  3.9833
     .,  3.7176,  3.5323,  3.4102,  3.3227,  4.2702,  4.0888,  3.7560
     .,  3.7687,  3.6681,  3.6405,  3.5569,  3.4990,  3.4659,  3.4433
     .,  3.4330,  3.4092,  3.8867,  4.0190,  3.7961,  3.6412,  3.5405
     ./)
      r0ab_ref_table_grimme(1261:1330)=(/
     .   3.4681,  4.3538,  4.2136,  3.9381,  3.8912,  3.9681,  3.7909
     .,  3.6774,  3.6262,  3.5999,  3.5823,  3.5727,  3.5419,  4.0245
     .,  4.1874,  3.0893,  2.7917,  3.7262,  3.3518,  3.4241,  3.5433
     .,  3.2773,  3.0890,  2.9775,  2.9010,  3.8048,  3.5362,  3.7746
     .,  3.7911,  3.7511,  3.5495,  3.4149,  3.3177,  4.0129,  3.8370
     .,  3.7739,  3.7125,  3.7152,  3.7701,  3.5813,  3.5187,  3.4835
     .,  3.4595,  3.4439,  3.4242,  3.7476,  3.8239,  3.8346,  3.6627
     .,  3.5479,  3.4639,  4.1026,  3.9733,  3.9292,  3.8667,  3.9513
     .,  3.8959,  3.7698,  3.7089,  3.6765,  3.6548,  3.6409,  3.5398
     .,  3.8759,  3.9804,  4.0150,  2.9091,  2.7638,  3.5066,  3.3377
     ./)
      r0ab_ref_table_grimme(1331:1400)=(/
     .   3.3481,  3.2633,  3.1810,  3.1428,  2.9872,  2.8837,  3.5929
     .,  3.5183,  3.6729,  3.6596,  3.6082,  3.5927,  3.4224,  3.2997
     .,  3.8190,  4.1865,  4.1114,  4.0540,  3.6325,  3.5697,  3.5561
     .,  3.5259,  3.4901,  3.4552,  3.4315,  3.4091,  3.6438,  3.6879
     .,  3.6832,  3.7043,  3.5557,  3.4466,  3.9203,  4.2919,  4.2196
     .,  4.1542,  3.7573,  3.7039,  3.6546,  3.6151,  3.5293,  3.4849
     .,  3.4552,  3.5192,  3.7673,  3.8359,  3.8525,  3.8901,  2.7806
     .,  2.7209,  3.3812,  3.4958,  3.2913,  3.1888,  3.0990,  3.0394
     .,  2.9789,  2.8582,  3.4716,  3.6883,  3.6105,  3.5704,  3.5059
     .,  3.4619,  3.4138,  3.2742,  3.7080,  3.9773,  3.9010,  3.8409
     ./)
      r0ab_ref_table_grimme(1401:1470)=(/
     .   3.7944,  3.4465,  3.7235,  3.6808,  3.6453,  3.6168,  3.5844
     .,  3.5576,  3.5772,  3.5959,  3.5768,  3.5678,  3.5486,  3.4228
     .,  3.8107,  4.0866,  4.0169,  3.9476,  3.6358,  3.5800,  3.5260
     .,  3.4838,  3.4501,  3.4204,  3.3553,  3.6487,  3.6973,  3.7398
     .,  3.7405,  3.7459,  3.7380,  2.6848,  2.6740,  3.2925,  3.3386
     .,  3.2473,  3.1284,  3.0301,  2.9531,  2.9602,  2.8272,  3.3830
     .,  3.5358,  3.5672,  3.5049,  3.4284,  3.3621,  3.3001,  3.2451
     .,  3.6209,  3.8299,  3.7543,  3.6920,  3.6436,  3.3598,  3.5701
     .,  3.5266,  3.4904,  3.4590,  3.4364,  3.4077,  3.5287,  3.5280
     .,  3.4969,  3.4650,  3.4304,  3.3963,  3.7229,  3.9402,  3.8753
     ./)
      r0ab_ref_table_grimme(1471:1540)=(/
     .   3.8035,  3.5499,  3.4913,  3.4319,  3.3873,  3.3520,  3.3209
     .,  3.2948,  3.5052,  3.6465,  3.6696,  3.6577,  3.6388,  3.6142
     .,  3.5889,  3.3968,  3.0122,  4.2241,  3.7887,  4.0049,  3.5384
     .,  3.2698,  3.1083,  2.9917,  2.9057,  4.3340,  3.9900,  4.6588
     .,  4.1278,  3.8125,  3.6189,  3.4851,  3.3859,  4.6531,  4.3134
     .,  4.2258,  4.1309,  4.0692,  4.0944,  3.9850,  3.9416,  3.9112
     .,  3.8873,  3.8736,  3.8473,  4.6027,  4.1538,  3.8994,  3.7419
     .,  3.6356,  3.5548,  4.8353,  4.5413,  4.3891,  4.3416,  4.3243
     .,  4.2753,  4.2053,  4.1790,  4.1685,  4.1585,  4.1536,  4.0579
     .,  4.1980,  4.4564,  4.2192,  4.0528,  3.9489,  3.8642,  5.0567
     ./)
      r0ab_ref_table_grimme(1541:1610)=(/
     .   3.0630,  3.3271,  4.0432,  4.0046,  4.1555,  3.7426,  3.5130
     .,  3.5174,  3.2884,  3.1378,  4.1894,  4.2321,  4.1725,  4.1833
     .,  3.8929,  4.0544,  3.8118,  3.6414,  4.6373,  4.6268,  4.4750
     .,  4.4134,  4.3458,  3.8582,  4.2583,  4.1898,  4.1562,  4.1191
     .,  4.1069,  4.0639,  4.1257,  4.1974,  3.9532,  4.1794,  3.9660
     .,  3.8130,  4.8160,  4.8272,  4.6294,  4.5840,  4.0770,  4.0088
     .,  3.9103,  3.8536,  3.8324,  3.7995,  3.7826,  4.2294,  4.3380
     .,  4.4352,  4.1933,  4.4580,  4.2554,  4.1072,  5.0454,  5.1814
     .,  3.0632,  3.2662,  3.6432,  3.8088,  3.7910,  3.7381,  3.5093
     .,  3.5155,  3.3047,  3.1681,  3.7871,  3.9924,  4.0637,  4.1382
     ./)
      r0ab_ref_table_grimme(1611:1680)=(/
     .   3.8591,  4.0164,  3.7878,  3.6316,  4.1741,  4.3166,  4.2395
     .,  4.1831,  4.1107,  3.5857,  4.0270,  3.9676,  3.9463,  3.9150
     .,  3.9021,  3.8708,  4.0240,  4.1551,  3.9108,  4.1337,  3.9289
     .,  3.7873,  4.3666,  4.5080,  4.4232,  4.3155,  3.8461,  3.8007
     .,  3.6991,  3.6447,  3.6308,  3.5959,  3.5749,  4.0359,  4.3124
     .,  4.3539,  4.1122,  4.3772,  4.1785,  4.0386,  4.7004,  4.8604
     .,  4.6261,  2.9455,  3.2470,  3.6108,  3.8522,  3.6625,  3.6598
     .,  3.4411,  3.4660,  3.2415,  3.0944,  3.7514,  4.0397,  3.9231
     .,  4.0561,  3.7860,  3.9845,  3.7454,  3.5802,  4.1366,  4.3581
     .,  4.2351,  4.2011,  4.1402,  3.5381,  4.0653,  4.0093,  3.9883
     ./)
      r0ab_ref_table_grimme(1681:1750)=(/
     .   3.9570,  3.9429,  3.9112,  3.8728,  4.0682,  3.8351,  4.1054
     .,  3.8928,  3.7445,  4.3415,  4.5497,  4.3833,  4.3122,  3.8051
     .,  3.7583,  3.6622,  3.6108,  3.5971,  3.5628,  3.5408,  4.0780
     .,  4.0727,  4.2836,  4.0553,  4.3647,  4.1622,  4.0178,  4.5802
     .,  4.9125,  4.5861,  4.6201,  2.9244,  3.2241,  3.5848,  3.8293
     .,  3.6395,  3.6400,  3.4204,  3.4499,  3.2253,  3.0779,  3.7257
     .,  4.0170,  3.9003,  4.0372,  3.7653,  3.9672,  3.7283,  3.5630
     .,  4.1092,  4.3347,  4.2117,  4.1793,  4.1179,  3.5139,  4.0426
     .,  3.9867,  3.9661,  3.9345,  3.9200,  3.8883,  3.8498,  4.0496
     .,  3.8145,  4.0881,  3.8756,  3.7271,  4.3128,  4.5242,  4.3578
     ./)
      r0ab_ref_table_grimme(1751:1820)=(/
     .   4.2870,  3.7796,  3.7318,  3.6364,  3.5854,  3.5726,  3.5378
     .,  3.5155,  4.0527,  4.0478,  4.2630,  4.0322,  4.3449,  4.1421
     .,  3.9975,  4.5499,  4.8825,  4.5601,  4.5950,  4.5702,  2.9046
     .,  3.2044,  3.5621,  3.8078,  3.6185,  3.6220,  3.4019,  3.4359
     .,  3.2110,  3.0635,  3.7037,  3.9958,  3.8792,  4.0194,  3.7460
     .,  3.9517,  3.7128,  3.5474,  4.0872,  4.3138,  4.1906,  4.1593
     .,  4.0973,  3.4919,  4.0216,  3.9657,  3.9454,  3.9134,  3.8986
     .,  3.8669,  3.8289,  4.0323,  3.7954,  4.0725,  3.8598,  3.7113
     .,  4.2896,  4.5021,  4.3325,  4.2645,  3.7571,  3.7083,  3.6136
     .,  3.5628,  3.5507,  3.5155,  3.4929,  4.0297,  4.0234,  4.2442
     ./)
      r0ab_ref_table_grimme(1821:1890)=(/
     .   4.0112,  4.3274,  4.1240,  3.9793,  4.5257,  4.8568,  4.5353
     .,  4.5733,  4.5485,  4.5271,  2.8878,  3.1890,  3.5412,  3.7908
     .,  3.5974,  3.6078,  3.3871,  3.4243,  3.1992,  3.0513,  3.6831
     .,  3.9784,  3.8579,  4.0049,  3.7304,  3.9392,  3.7002,  3.5347
     .,  4.0657,  4.2955,  4.1705,  4.1424,  4.0800,  3.4717,  4.0043
     .,  3.9485,  3.9286,  3.8965,  3.8815,  3.8500,  3.8073,  4.0180
     .,  3.7796,  4.0598,  3.8470,  3.6983,  4.2678,  4.4830,  4.3132
     .,  4.2444,  3.7370,  3.6876,  3.5935,  3.5428,  3.5314,  3.4958
     .,  3.4730,  4.0117,  4.0043,  4.2287,  3.9939,  4.3134,  4.1096
     .,  3.9646,  4.5032,  4.8356,  4.5156,  4.5544,  4.5297,  4.5083
     ./)
      r0ab_ref_table_grimme(1891:1960)=(/
     .   4.4896,  2.8709,  3.1737,  3.5199,  3.7734,  3.5802,  3.5934
     .,  3.3724,  3.4128,  3.1877,  3.0396,  3.6624,  3.9608,  3.8397
     .,  3.9893,  3.7145,  3.9266,  3.6877,  3.5222,  4.0448,  4.2771
     .,  4.1523,  4.1247,  4.0626,  3.4530,  3.9866,  3.9310,  3.9115
     .,  3.8792,  3.8641,  3.8326,  3.7892,  4.0025,  3.7636,  4.0471
     .,  3.8343,  3.6854,  4.2464,  4.4635,  4.2939,  4.2252,  3.7169
     .,  3.6675,  3.5739,  3.5235,  3.5126,  3.4768,  3.4537,  3.9932
     .,  3.9854,  4.2123,  3.9765,  4.2992,  4.0951,  3.9500,  4.4811
     .,  4.8135,  4.4959,  4.5351,  4.5105,  4.4891,  4.4705,  4.4515
     .,  2.8568,  3.1608,  3.5050,  3.7598,  3.5665,  3.5803,  3.3601
     ./)
      r0ab_ref_table_grimme(1961:2030)=(/
     .   3.4031,  3.1779,  3.0296,  3.6479,  3.9471,  3.8262,  3.9773
     .,  3.7015,  3.9162,  3.6771,  3.5115,  4.0306,  4.2634,  4.1385
     .,  4.1116,  4.0489,  3.4366,  3.9732,  3.9176,  3.8983,  3.8659
     .,  3.8507,  3.8191,  3.7757,  3.9907,  3.7506,  4.0365,  3.8235
     .,  3.6745,  4.2314,  4.4490,  4.2792,  4.2105,  3.7003,  3.6510
     .,  3.5578,  3.5075,  3.4971,  3.4609,  3.4377,  3.9788,  3.9712
     .,  4.1997,  3.9624,  4.2877,  4.0831,  3.9378,  4.4655,  4.7974
     .,  4.4813,  4.5209,  4.4964,  4.4750,  4.4565,  4.4375,  4.4234
     .,  2.6798,  3.0151,  3.2586,  3.5292,  3.5391,  3.4902,  3.2887
     .,  3.3322,  3.1228,  2.9888,  3.4012,  3.7145,  3.7830,  3.6665
     ./)
      r0ab_ref_table_grimme(2031:2100)=(/
     .   3.5898,  3.8077,  3.5810,  3.4265,  3.7726,  4.0307,  3.9763
     .,  3.8890,  3.8489,  3.2706,  3.7595,  3.6984,  3.6772,  3.6428
     .,  3.6243,  3.5951,  3.7497,  3.6775,  3.6364,  3.9203,  3.7157
     .,  3.5746,  3.9494,  4.2076,  4.1563,  4.0508,  3.5329,  3.4780
     .,  3.3731,  3.3126,  3.2846,  3.2426,  3.2135,  3.7491,  3.9006
     .,  3.8332,  3.8029,  4.1436,  3.9407,  3.7998,  4.1663,  4.5309
     .,  4.3481,  4.2911,  4.2671,  4.2415,  4.2230,  4.2047,  4.1908
     .,  4.1243,  2.5189,  2.9703,  3.3063,  3.6235,  3.4517,  3.3989
     .,  3.2107,  3.2434,  3.0094,  2.8580,  3.4253,  3.8157,  3.7258
     .,  3.6132,  3.5297,  3.7566,  3.5095,  3.3368,  3.7890,  4.1298
     ./)
      r0ab_ref_table_grimme(2101:2170)=(/
     .   4.0190,  3.9573,  3.9237,  3.2677,  3.8480,  3.8157,  3.7656
     .,  3.7317,  3.7126,  3.6814,  3.6793,  3.6218,  3.5788,  3.8763
     .,  3.6572,  3.5022,  3.9737,  4.3255,  4.1828,  4.1158,  3.5078
     .,  3.4595,  3.3600,  3.3088,  3.2575,  3.2164,  3.1856,  3.8522
     .,  3.8665,  3.8075,  3.7772,  4.1391,  3.9296,  3.7772,  4.2134
     .,  4.7308,  4.3787,  4.3894,  4.3649,  4.3441,  4.3257,  4.3073
     .,  4.2941,  4.1252,  4.2427,  3.0481,  2.9584,  3.6919,  3.5990
     .,  3.8881,  3.4209,  3.1606,  3.1938,  2.9975,  2.8646,  3.8138
     .,  3.7935,  3.7081,  3.9155,  3.5910,  3.4808,  3.4886,  3.3397
     .,  4.1336,  4.1122,  3.9888,  3.9543,  3.8917,  3.5894,  3.8131
     ./)
      r0ab_ref_table_grimme(2171:2240)=(/
     .   3.7635,  3.7419,  3.7071,  3.6880,  3.6574,  3.6546,  3.9375
     .,  3.6579,  3.5870,  3.6361,  3.5039,  4.3149,  4.2978,  4.1321
     .,  4.1298,  3.8164,  3.7680,  3.7154,  3.6858,  3.6709,  3.6666
     .,  3.6517,  3.8174,  3.8608,  4.1805,  3.9102,  3.8394,  3.8968
     .,  3.7673,  4.5274,  4.6682,  4.3344,  4.3639,  4.3384,  4.3162
     .,  4.2972,  4.2779,  4.2636,  4.0253,  4.1168,  4.1541,  2.8136
     .,  3.0951,  3.4635,  3.6875,  3.4987,  3.5183,  3.2937,  3.3580
     .,  3.1325,  2.9832,  3.6078,  3.8757,  3.7616,  3.9222,  3.6370
     .,  3.8647,  3.6256,  3.4595,  3.9874,  4.1938,  4.0679,  4.0430
     .,  3.9781,  3.3886,  3.9008,  3.8463,  3.8288,  3.7950,  3.7790
     ./)
      r0ab_ref_table_grimme(2241:2310)=(/
     .   3.7472,  3.7117,  3.9371,  3.6873,  3.9846,  3.7709,  3.6210
     .,  4.1812,  4.3750,  4.2044,  4.1340,  3.6459,  3.5929,  3.5036
     .,  3.4577,  3.4528,  3.4146,  3.3904,  3.9014,  3.9031,  4.1443
     .,  3.8961,  4.2295,  4.0227,  3.8763,  4.4086,  4.7097,  4.4064
     .,  4.4488,  4.4243,  4.4029,  4.3842,  4.3655,  4.3514,  4.1162
     .,  4.2205,  4.1953,  4.2794,  2.8032,  3.0805,  3.4519,  3.6700
     .,  3.4827,  3.5050,  3.2799,  3.3482,  3.1233,  2.9747,  3.5971
     .,  3.8586,  3.7461,  3.9100,  3.6228,  3.8535,  3.6147,  3.4490
     .,  3.9764,  4.1773,  4.0511,  4.0270,  3.9614,  3.3754,  3.8836
     .,  3.8291,  3.8121,  3.7780,  3.7619,  3.7300,  3.6965,  3.9253
     ./)
      r0ab_ref_table_grimme(2311:2380)=(/
     .   3.6734,  3.9733,  3.7597,  3.6099,  4.1683,  4.3572,  4.1862
     .,  4.1153,  3.6312,  3.5772,  3.4881,  3.4429,  3.4395,  3.4009
     .,  3.3766,  3.8827,  3.8868,  4.1316,  3.8807,  4.2164,  4.0092
     .,  3.8627,  4.3936,  4.6871,  4.3882,  4.4316,  4.4073,  4.3858
     .,  4.3672,  4.3485,  4.3344,  4.0984,  4.2036,  4.1791,  4.2622
     .,  4.2450,  2.7967,  3.0689,  3.4445,  3.6581,  3.4717,  3.4951
     .,  3.2694,  3.3397,  3.1147,  2.9661,  3.5898,  3.8468,  3.7358
     .,  3.9014,  3.6129,  3.8443,  3.6054,  3.4396,  3.9683,  4.1656
     .,  4.0394,  4.0158,  3.9498,  3.3677,  3.8718,  3.8164,  3.8005
     .,  3.7662,  3.7500,  3.7181,  3.6863,  3.9170,  3.6637,  3.9641
     ./)
      r0ab_ref_table_grimme(2381:2450)=(/
     .   3.7503,  3.6004,  4.1590,  4.3448,  4.1739,  4.1029,  3.6224
     .,  3.5677,  3.4785,  3.4314,  3.4313,  3.3923,  3.3680,  3.8698
     .,  3.8758,  4.1229,  3.8704,  4.2063,  3.9987,  3.8519,  4.3832
     .,  4.6728,  4.3759,  4.4195,  4.3952,  4.3737,  4.3551,  4.3364
     .,  4.3223,  4.0861,  4.1911,  4.1676,  4.2501,  4.2329,  4.2208
     .,  2.7897,  3.0636,  3.4344,  3.6480,  3.4626,  3.4892,  3.2626
     .,  3.3344,  3.1088,  2.9597,  3.5804,  3.8359,  3.7251,  3.8940
     .,  3.6047,  3.8375,  3.5990,  3.4329,  3.9597,  4.1542,  4.0278
     .,  4.0048,  3.9390,  3.3571,  3.8608,  3.8056,  3.7899,  3.7560
     .,  3.7400,  3.7081,  3.6758,  3.9095,  3.6552,  3.9572,  3.7436
     ./)
      r0ab_ref_table_grimme(2451:2520)=(/
     .   3.5933,  4.1508,  4.3337,  4.1624,  4.0916,  3.6126,  3.5582
     .,  3.4684,  3.4212,  3.4207,  3.3829,  3.3586,  3.8604,  3.8658
     .,  4.1156,  3.8620,  4.1994,  3.9917,  3.8446,  4.3750,  4.6617
     .,  4.3644,  4.4083,  4.3840,  4.3625,  4.3439,  4.3253,  4.3112
     .,  4.0745,  4.1807,  4.1578,  4.2390,  4.2218,  4.2097,  4.1986
     .,  2.8395,  3.0081,  3.3171,  3.4878,  3.5360,  3.5145,  3.2809
     .,  3.3307,  3.1260,  2.9940,  3.4741,  3.6675,  3.7832,  3.6787
     .,  3.6156,  3.8041,  3.5813,  3.4301,  3.8480,  3.9849,  3.9314
     .,  3.8405,  3.8029,  3.2962,  3.7104,  3.6515,  3.6378,  3.6020
     .,  3.5849,  3.5550,  3.7494,  3.6893,  3.6666,  3.9170,  3.7150
     ./)
      r0ab_ref_table_grimme(2521:2590)=(/
     .   3.5760,  4.0268,  4.1596,  4.1107,  3.9995,  3.5574,  3.5103
     .,  3.4163,  3.3655,  3.3677,  3.3243,  3.2975,  3.7071,  3.9047
     .,  3.8514,  3.8422,  3.8022,  3.9323,  3.7932,  4.2343,  4.4583
     .,  4.3115,  4.2457,  4.2213,  4.1945,  4.1756,  4.1569,  4.1424
     .,  4.0620,  4.0494,  3.9953,  4.0694,  4.0516,  4.0396,  4.0280
     .,  4.0130,  2.9007,  2.9674,  3.8174,  3.5856,  3.6486,  3.5339
     .,  3.2832,  3.3154,  3.1144,  2.9866,  3.9618,  3.8430,  3.9980
     .,  3.8134,  3.6652,  3.7985,  3.5756,  3.4207,  4.4061,  4.2817
     .,  4.1477,  4.0616,  3.9979,  3.6492,  3.8833,  3.8027,  3.7660
     .,  3.7183,  3.6954,  3.6525,  3.9669,  3.8371,  3.7325,  3.9160
     ./)
      r0ab_ref_table_grimme(2591:2660)=(/
     .   3.7156,  3.5714,  4.6036,  4.4620,  4.3092,  4.2122,  3.8478
     .,  3.7572,  3.6597,  3.5969,  3.5575,  3.5386,  3.5153,  3.7818
     .,  4.1335,  4.0153,  3.9177,  3.8603,  3.9365,  3.7906,  4.7936
     .,  4.7410,  4.5461,  4.5662,  4.5340,  4.5059,  4.4832,  4.4604
     .,  4.4429,  4.2346,  4.4204,  4.3119,  4.3450,  4.3193,  4.3035
     .,  4.2933,  4.1582,  4.2450,  2.8559,  2.9050,  3.8325,  3.5442
     .,  3.5077,  3.4905,  3.2396,  3.2720,  3.0726,  2.9467,  3.9644
     .,  3.8050,  3.8981,  3.7762,  3.6216,  3.7531,  3.5297,  3.3742
     .,  4.3814,  4.2818,  4.1026,  4.0294,  3.9640,  3.6208,  3.8464
     .,  3.7648,  3.7281,  3.6790,  3.6542,  3.6117,  3.8650,  3.8010
     ./)
      r0ab_ref_table_grimme(2661:2730)=(/
     .   3.6894,  3.8713,  3.6699,  3.5244,  4.5151,  4.4517,  4.2538
     .,  4.1483,  3.8641,  3.7244,  3.6243,  3.5589,  3.5172,  3.4973
     .,  3.4715,  3.7340,  4.0316,  3.9958,  3.8687,  3.8115,  3.8862
     .,  3.7379,  4.7091,  4.7156,  4.5199,  4.5542,  4.5230,  4.4959
     .,  4.4750,  4.4529,  4.4361,  4.1774,  4.3774,  4.2963,  4.3406
     .,  4.3159,  4.3006,  4.2910,  4.1008,  4.1568,  4.0980,  2.8110
     .,  2.8520,  3.7480,  3.5105,  3.4346,  3.3461,  3.1971,  3.2326
     .,  3.0329,  2.9070,  3.8823,  3.7928,  3.8264,  3.7006,  3.5797
     .,  3.7141,  3.4894,  3.3326,  4.3048,  4.2217,  4.0786,  3.9900
     .,  3.9357,  3.6331,  3.8333,  3.7317,  3.6957,  3.6460,  3.6197
     ./)
      r0ab_ref_table_grimme(2731:2800)=(/
     .   3.5779,  3.7909,  3.7257,  3.6476,  3.5729,  3.6304,  3.4834
     .,  4.4368,  4.3921,  4.2207,  4.1133,  3.8067,  3.7421,  3.6140
     .,  3.5491,  3.5077,  3.4887,  3.4623,  3.6956,  3.9568,  3.8976
     .,  3.8240,  3.7684,  3.8451,  3.6949,  4.6318,  4.6559,  4.4533
     .,  4.4956,  4.4641,  4.4366,  4.4155,  4.3936,  4.3764,  4.1302
     .,  4.3398,  4.2283,  4.2796,  4.2547,  4.2391,  4.2296,  4.0699
     .,  4.1083,  4.0319,  3.9855,  2.7676,  2.8078,  3.6725,  3.4804
     .,  3.3775,  3.2411,  3.1581,  3.1983,  2.9973,  2.8705,  3.8070
     .,  3.7392,  3.7668,  3.6263,  3.5402,  3.6807,  3.4545,  3.2962
     .,  4.2283,  4.1698,  4.0240,  3.9341,  3.8711,  3.5489,  3.7798
     ./)
      r0ab_ref_table_grimme(2801:2870)=(/
     .   3.7000,  3.6654,  3.6154,  3.5882,  3.5472,  3.7289,  3.6510
     .,  3.6078,  3.5355,  3.5963,  3.4480,  4.3587,  4.3390,  4.1635
     .,  4.0536,  3.7193,  3.6529,  3.5512,  3.4837,  3.4400,  3.4191
     .,  3.3891,  3.6622,  3.8934,  3.8235,  3.7823,  3.7292,  3.8106
     .,  3.6589,  4.5535,  4.6013,  4.3961,  4.4423,  4.4109,  4.3835
     .,  4.3625,  4.3407,  4.3237,  4.0863,  4.2835,  4.1675,  4.2272
     .,  4.2025,  4.1869,  4.1774,  4.0126,  4.0460,  3.9815,  3.9340
     .,  3.8955,  2.6912,  2.7604,  3.6037,  3.4194,  3.3094,  3.1710
     .,  3.0862,  3.1789,  2.9738,  2.8427,  3.7378,  3.6742,  3.6928
     .,  3.5512,  3.4614,  3.4087,  3.4201,  3.2607,  4.1527,  4.0977
     ./)
      r0ab_ref_table_grimme(2871:2940)=(/
     .   3.9523,  3.8628,  3.8002,  3.4759,  3.7102,  3.6466,  3.6106
     .,  3.5580,  3.5282,  3.4878,  3.6547,  3.5763,  3.5289,  3.5086
     .,  3.5593,  3.4099,  4.2788,  4.2624,  4.0873,  3.9770,  3.6407
     .,  3.5743,  3.5178,  3.4753,  3.3931,  3.3694,  3.3339,  3.6002
     .,  3.8164,  3.7478,  3.7028,  3.6952,  3.7669,  3.6137,  4.4698
     .,  4.5488,  4.3168,  4.3646,  4.3338,  4.3067,  4.2860,  4.2645
     .,  4.2478,  4.0067,  4.2349,  4.0958,  4.1543,  4.1302,  4.1141
     .,  4.1048,  3.9410,  3.9595,  3.8941,  3.8465,  3.8089,  3.7490
     .,  2.7895,  2.5849,  3.6484,  3.0162,  3.1267,  3.2125,  3.0043
     .,  2.9572,  2.8197,  2.7261,  3.7701,  3.2446,  3.5239,  3.4696
     ./)
      r0ab_ref_table_grimme(2941:3010)=(/
     .   3.4261,  3.3508,  3.1968,  3.0848,  4.1496,  3.6598,  3.5111
     .,  3.4199,  3.3809,  3.5382,  3.2572,  3.2100,  3.1917,  3.1519
     .,  3.1198,  3.1005,  3.5071,  3.5086,  3.5073,  3.4509,  3.3120
     .,  3.2082,  4.2611,  3.8117,  3.6988,  3.5646,  3.6925,  3.6295
     .,  3.5383,  3.4910,  3.4625,  3.4233,  3.4007,  3.2329,  3.6723
     .,  3.6845,  3.6876,  3.6197,  3.4799,  3.3737,  4.4341,  4.0525
     .,  3.9011,  3.8945,  3.8635,  3.8368,  3.8153,  3.7936,  3.7758
     .,  3.4944,  3.4873,  3.9040,  3.7110,  3.6922,  3.6799,  3.6724
     .,  3.5622,  3.6081,  3.5426,  3.4922,  3.4498,  3.3984,  3.4456
     .,  2.7522,  2.5524,  3.5742,  2.9508,  3.0751,  3.0158,  2.9644
     ./)
      r0ab_ref_table_grimme(3011:3080)=(/
     .   2.8338,  2.7891,  2.6933,  3.6926,  3.1814,  3.4528,  3.4186
     .,  3.3836,  3.2213,  3.1626,  3.0507,  4.0548,  3.5312,  3.4244
     .,  3.3409,  3.2810,  3.4782,  3.1905,  3.1494,  3.1221,  3.1128
     .,  3.0853,  3.0384,  3.4366,  3.4562,  3.4638,  3.3211,  3.2762
     .,  3.1730,  4.1632,  3.6825,  3.5822,  3.4870,  3.6325,  3.5740
     .,  3.4733,  3.4247,  3.3969,  3.3764,  3.3525,  3.1984,  3.5989
     .,  3.6299,  3.6433,  3.4937,  3.4417,  3.3365,  4.3304,  3.9242
     .,  3.7793,  3.7623,  3.7327,  3.7071,  3.6860,  3.6650,  3.6476
     .,  3.3849,  3.3534,  3.8216,  3.5870,  3.5695,  3.5584,  3.5508
     .,  3.4856,  3.5523,  3.4934,  3.4464,  3.4055,  3.3551,  3.3888
     ./)
      r0ab_ref_table_grimme(3081:3150)=(/
     .   3.3525,  2.7202,  2.5183,  3.4947,  2.8731,  3.0198,  3.1457
     .,  2.9276,  2.7826,  2.7574,  2.6606,  3.6090,  3.0581,  3.3747
     .,  3.3677,  3.3450,  3.1651,  3.1259,  3.0147,  3.9498,  3.3857
     .,  3.2917,  3.2154,  3.1604,  3.4174,  3.0735,  3.0342,  3.0096
     .,  3.0136,  2.9855,  2.9680,  3.3604,  3.4037,  3.4243,  3.2633
     .,  3.1810,  3.1351,  4.0557,  3.5368,  3.4526,  3.3699,  3.5707
     .,  3.5184,  3.4085,  3.3595,  3.3333,  3.3143,  3.3041,  3.1094
     .,  3.5193,  3.5745,  3.6025,  3.4338,  3.3448,  3.2952,  4.2158
     .,  3.7802,  3.6431,  3.6129,  3.5853,  3.5610,  3.5406,  3.5204
     .,  3.5036,  3.2679,  3.2162,  3.7068,  3.4483,  3.4323,  3.4221
     ./)
      r0ab_ref_table_grimme(3151:3220)=(/
     .   3.4138,  3.3652,  3.4576,  3.4053,  3.3618,  3.3224,  3.2711
     .,  3.3326,  3.2950,  3.2564,  2.5315,  2.6104,  3.2734,  3.2299
     .,  3.1090,  2.9942,  2.9159,  2.8324,  2.8350,  2.7216,  3.3994
     .,  3.4475,  3.4354,  3.3438,  3.2807,  3.2169,  3.2677,  3.1296
     .,  3.7493,  3.8075,  3.6846,  3.6104,  3.5577,  3.2052,  3.4803
     .,  3.4236,  3.3845,  3.3640,  3.3365,  3.3010,  3.3938,  3.3624
     .,  3.3440,  3.3132,  3.4035,  3.2754,  3.8701,  3.9523,  3.8018
     .,  3.7149,  3.3673,  3.3199,  3.2483,  3.2069,  3.1793,  3.1558
     .,  3.1395,  3.4097,  3.5410,  3.5228,  3.5116,  3.4921,  3.4781
     .,  3.4690,  4.0420,  4.1759,  4.0078,  4.0450,  4.0189,  3.9952
     ./)
      r0ab_ref_table_grimme(3221:3290)=(/
     .   3.9770,  3.9583,  3.9434,  3.7217,  3.8228,  3.7826,  3.8640
     .,  3.8446,  3.8314,  3.8225,  3.6817,  3.7068,  3.6555,  3.6159
     .,  3.5831,  3.5257,  3.2133,  3.1689,  3.1196,  3.3599,  2.9852
     .,  2.7881,  3.5284,  3.3493,  3.6958,  3.3642,  3.1568,  3.0055
     .,  2.9558,  2.8393,  3.6287,  3.5283,  4.1511,  3.8259,  3.6066
     .,  3.4527,  3.3480,  3.2713,  3.9037,  3.8361,  3.8579,  3.7311
     .,  3.6575,  3.5176,  3.5693,  3.5157,  3.4814,  3.4559,  3.4445
     .,  3.4160,  4.1231,  3.8543,  3.6816,  3.5602,  3.4798,  3.4208
     .,  4.0542,  4.0139,  4.0165,  3.9412,  3.7698,  3.6915,  3.6043
     .,  3.5639,  3.5416,  3.5247,  3.5153,  3.5654,  4.2862,  4.0437
     ./)
      r0ab_ref_table_grimme(3291:3360)=(/
     .   3.8871,  3.7741,  3.6985,  3.6413,  4.2345,  4.3663,  4.3257
     .,  4.0869,  4.0612,  4.0364,  4.0170,  3.9978,  3.9834,  3.9137
     .,  3.8825,  3.8758,  3.9143,  3.8976,  3.8864,  3.8768,  3.9190
     .,  4.1613,  4.0566,  3.9784,  3.9116,  3.8326,  3.7122,  3.6378
     .,  3.5576,  3.5457,  4.3127,  3.1160,  2.8482,  4.0739,  3.3599
     .,  3.5698,  3.5366,  3.2854,  3.1039,  2.9953,  2.9192,  4.1432
     .,  3.5320,  3.9478,  4.0231,  3.7509,  3.5604,  3.4340,  3.3426
     .,  4.3328,  3.8288,  3.7822,  3.7909,  3.6907,  3.6864,  3.5793
     .,  3.5221,  3.4883,  3.4649,  3.4514,  3.4301,  3.9256,  4.0596
     .,  3.8307,  3.6702,  3.5651,  3.4884,  4.4182,  4.2516,  3.9687
     ./)
      r0ab_ref_table_grimme(3361:3430)=(/
     .   3.9186,  3.9485,  3.8370,  3.7255,  3.6744,  3.6476,  3.6295
     .,  3.6193,  3.5659,  4.0663,  4.2309,  4.0183,  3.8680,  3.7672
     .,  3.6923,  4.5240,  4.4834,  4.1570,  4.3204,  4.2993,  4.2804
     .,  4.2647,  4.2481,  4.2354,  3.8626,  3.8448,  4.2267,  4.1799
     .,  4.1670,  3.8738,  3.8643,  3.8796,  4.0575,  4.0354,  3.9365
     .,  3.8611,  3.7847,  3.7388,  3.6826,  3.6251,  3.5492,  4.0889
     .,  4.2764,  3.1416,  2.8325,  3.7735,  3.3787,  3.4632,  3.5923
     .,  3.3214,  3.1285,  3.0147,  2.9366,  3.8527,  3.5602,  3.8131
     .,  3.8349,  3.7995,  3.5919,  3.4539,  3.3540,  4.0654,  3.8603
     .,  3.7972,  3.7358,  3.7392,  3.8157,  3.6055,  3.5438,  3.5089
     ./)
      r0ab_ref_table_grimme(3431:3500)=(/
     .   3.4853,  3.4698,  3.4508,  3.7882,  3.8682,  3.8837,  3.7055
     .,  3.5870,  3.5000,  4.1573,  4.0005,  3.9568,  3.8936,  3.9990
     .,  3.9433,  3.8172,  3.7566,  3.7246,  3.7033,  3.6900,  3.5697
     .,  3.9183,  4.0262,  4.0659,  3.8969,  3.7809,  3.6949,  4.2765
     .,  4.2312,  4.1401,  4.0815,  4.0580,  4.0369,  4.0194,  4.0017
     .,  3.9874,  3.8312,  3.8120,  3.9454,  3.9210,  3.9055,  3.8951
     .,  3.8866,  3.8689,  3.9603,  3.9109,  3.9122,  3.8233,  3.7438
     .,  3.7436,  3.6981,  3.6555,  3.5452,  3.9327,  4.0658,  4.1175
     .,  2.9664,  2.8209,  3.5547,  3.3796,  3.3985,  3.3164,  3.2364
     .,  3.1956,  3.0370,  2.9313,  3.6425,  3.5565,  3.7209,  3.7108
     ./)
      r0ab_ref_table_grimme(3501:3570)=(/
     .   3.6639,  3.6484,  3.4745,  3.3492,  3.8755,  4.2457,  3.7758
     .,  3.7161,  3.6693,  3.6155,  3.5941,  3.5643,  3.5292,  3.4950
     .,  3.4720,  3.4503,  3.6936,  3.7392,  3.7388,  3.7602,  3.6078
     .,  3.4960,  3.9800,  4.3518,  4.2802,  3.8580,  3.8056,  3.7527
     .,  3.7019,  3.6615,  3.5768,  3.5330,  3.5038,  3.5639,  3.8192
     .,  3.8883,  3.9092,  3.9478,  3.7995,  3.6896,  4.1165,  4.5232
     .,  4.4357,  4.4226,  4.4031,  4.3860,  4.3721,  4.3580,  4.3466
     .,  4.2036,  4.2037,  3.8867,  4.2895,  4.2766,  4.2662,  4.2598
     .,  3.8408,  3.9169,  3.8681,  3.8250,  3.7855,  3.7501,  3.6753
     .,  3.5499,  3.4872,  3.5401,  3.8288,  3.9217,  3.9538,  4.0054
     ./)
      r0ab_ref_table_grimme(3571:3640)=(/
     .   2.8388,  2.7890,  3.4329,  3.5593,  3.3488,  3.2486,  3.1615
     .,  3.1000,  3.0394,  2.9165,  3.5267,  3.7479,  3.6650,  3.6263
     .,  3.5658,  3.5224,  3.4762,  3.3342,  3.7738,  4.0333,  3.9568
     .,  3.8975,  3.8521,  3.4929,  3.7830,  3.7409,  3.7062,  3.6786
     .,  3.6471,  3.6208,  3.6337,  3.6519,  3.6363,  3.6278,  3.6110
     .,  3.4825,  3.8795,  4.1448,  4.0736,  4.0045,  3.6843,  3.6291
     .,  3.5741,  3.5312,  3.4974,  3.4472,  3.4034,  3.7131,  3.7557
     .,  3.7966,  3.8005,  3.8068,  3.8015,  3.6747,  4.0222,  4.3207
     .,  4.2347,  4.2191,  4.1990,  4.1811,  4.1666,  4.1521,  4.1401
     .,  3.9970,  3.9943,  3.9592,  4.0800,  4.0664,  4.0559,  4.0488
     ./)
      r0ab_ref_table_grimme(3641:3710)=(/
     .   3.9882,  4.0035,  3.9539,  3.9138,  3.8798,  3.8355,  3.5359
     .,  3.4954,  3.3962,  3.5339,  3.7595,  3.8250,  3.8408,  3.8600
     .,  3.8644,  2.7412,  2.7489,  3.3374,  3.3950,  3.3076,  3.1910
     .,  3.0961,  3.0175,  3.0280,  2.8929,  3.4328,  3.5883,  3.6227
     .,  3.5616,  3.4894,  3.4241,  3.3641,  3.3120,  3.6815,  3.8789
     .,  3.8031,  3.7413,  3.6939,  3.4010,  3.6225,  3.5797,  3.5443
     .,  3.5139,  3.4923,  3.4642,  3.5860,  3.5849,  3.5570,  3.5257
     .,  3.4936,  3.4628,  3.7874,  3.9916,  3.9249,  3.8530,  3.5932
     .,  3.5355,  3.4757,  3.4306,  3.3953,  3.3646,  3.3390,  3.5637
     .,  3.7053,  3.7266,  3.7177,  3.6996,  3.6775,  3.6558,  3.9331
     ./)
      r0ab_ref_table_grimme(3711:3780)=(/
     .   4.1655,  4.0879,  4.0681,  4.0479,  4.0299,  4.0152,  4.0006
     .,  3.9883,  3.8500,  3.8359,  3.8249,  3.9269,  3.9133,  3.9025
     .,  3.8948,  3.8422,  3.8509,  3.7990,  3.7570,  3.7219,  3.6762
     .,  3.4260,  3.3866,  3.3425,  3.5294,  3.7022,  3.7497,  3.7542
     .,  3.7494,  3.7370,  3.7216,  3.4155,  3.0522,  4.2541,  3.8218
     .,  4.0438,  3.5875,  3.3286,  3.1682,  3.0566,  2.9746,  4.3627
     .,  4.0249,  4.6947,  4.1718,  3.8639,  3.6735,  3.5435,  3.4479
     .,  4.6806,  4.3485,  4.2668,  4.1690,  4.1061,  4.1245,  4.0206
     .,  3.9765,  3.9458,  3.9217,  3.9075,  3.8813,  3.9947,  4.1989
     .,  3.9507,  3.7960,  3.6925,  3.6150,  4.8535,  4.5642,  4.4134
     ./)
      r0ab_ref_table_grimme(3781:3850)=(/
     .   4.3688,  4.3396,  4.2879,  4.2166,  4.1888,  4.1768,  4.1660
     .,  4.1608,  4.0745,  4.2289,  4.4863,  4.2513,  4.0897,  3.9876
     .,  3.9061,  5.0690,  5.0446,  4.6186,  4.6078,  4.5780,  4.5538
     .,  4.5319,  4.5101,  4.4945,  4.1912,  4.2315,  4.5534,  4.4373
     .,  4.4224,  4.4120,  4.4040,  4.2634,  4.7770,  4.6890,  4.6107
     .,  4.5331,  4.4496,  4.4082,  4.3095,  4.2023,  4.0501,  4.2595
     .,  4.5497,  4.3056,  4.1506,  4.0574,  3.9725,  5.0796,  3.0548
     .,  3.3206,  3.8132,  3.9720,  3.7675,  3.7351,  3.5167,  3.5274
     .,  3.3085,  3.1653,  3.9500,  4.1730,  4.0613,  4.1493,  3.8823
     .,  4.0537,  3.8200,  3.6582,  4.3422,  4.5111,  4.3795,  4.3362
     ./)
      r0ab_ref_table_grimme(3851:3920)=(/
     .   4.2751,  3.7103,  4.1973,  4.1385,  4.1129,  4.0800,  4.0647
     .,  4.0308,  4.0096,  4.1619,  3.9360,  4.1766,  3.9705,  3.8262
     .,  4.5348,  4.7025,  4.5268,  4.5076,  3.9562,  3.9065,  3.8119
     .,  3.7605,  3.7447,  3.7119,  3.6916,  4.1950,  4.2110,  4.3843
     .,  4.1631,  4.4427,  4.2463,  4.1054,  4.7693,  5.0649,  4.7365
     .,  4.7761,  4.7498,  4.7272,  4.7076,  4.6877,  4.6730,  4.4274
     .,  4.5473,  4.5169,  4.5975,  4.5793,  4.5667,  4.5559,  4.3804
     .,  4.6920,  4.6731,  4.6142,  4.5600,  4.4801,  4.0149,  3.8856
     .,  3.7407,  4.1545,  4.2253,  4.4229,  4.1923,  4.5022,  4.3059
     .,  4.1591,  4.7883,  4.9294,  3.3850,  3.4208,  3.7004,  3.8800
     ./)
      r0ab_ref_table_grimme(3921:3990)=(/
     .   3.9886,  3.9040,  3.6719,  3.6547,  3.4625,  3.3370,  3.8394
     .,  4.0335,  4.2373,  4.3023,  4.0306,  4.1408,  3.9297,  3.7857
     .,  4.1907,  4.3230,  4.2664,  4.2173,  4.1482,  3.6823,  4.0711
     .,  4.0180,  4.0017,  3.9747,  3.9634,  3.9383,  4.1993,  4.3205
     .,  4.0821,  4.2547,  4.0659,  3.9359,  4.3952,  4.5176,  4.3888
     .,  4.3607,  3.9583,  3.9280,  3.8390,  3.7971,  3.7955,  3.7674
     .,  3.7521,  4.1062,  4.3633,  4.2991,  4.2767,  4.4857,  4.3039
     .,  4.1762,  4.6197,  4.8654,  4.6633,  4.5878,  4.5640,  4.5422
     .,  4.5231,  4.5042,  4.4901,  4.3282,  4.3978,  4.3483,  4.4202
     .,  4.4039,  4.3926,  4.3807,  4.2649,  4.6135,  4.5605,  4.5232
     ./)
      r0ab_ref_table_grimme(3991:4060)=(/
     .   4.4676,  4.3948,  4.0989,  3.9864,  3.8596,  4.0942,  4.2720
     .,  4.3270,  4.3022,  4.5410,  4.3576,  4.2235,  4.6545,  4.7447
     .,  4.7043,  3.0942,  3.2075,  3.5152,  3.6659,  3.8289,  3.7459
     .,  3.5156,  3.5197,  3.3290,  3.2069,  3.6702,  3.8448,  4.0340
     .,  3.9509,  3.8585,  3.9894,  3.7787,  3.6365,  4.1425,  4.1618
     .,  4.0940,  4.0466,  3.9941,  3.5426,  3.8952,  3.8327,  3.8126
     .,  3.7796,  3.7635,  3.7356,  4.0047,  3.9655,  3.9116,  4.1010
     .,  3.9102,  3.7800,  4.2964,  4.3330,  4.2622,  4.2254,  3.8195
     .,  3.7560,  3.6513,  3.5941,  3.5810,  3.5420,  3.5178,  3.8861
     .,  4.1459,  4.1147,  4.0772,  4.3120,  4.1207,  3.9900,  4.4733
     ./)
      r0ab_ref_table_grimme(4061:4130)=(/
     .   4.6157,  4.4580,  4.4194,  4.3954,  4.3739,  4.3531,  4.3343
     .,  4.3196,  4.2140,  4.2339,  4.1738,  4.2458,  4.2278,  4.2158
     .,  4.2039,  4.1658,  4.3595,  4.2857,  4.2444,  4.1855,  4.1122
     .,  3.7839,  3.6879,  3.5816,  3.8633,  4.1585,  4.1402,  4.1036
     .,  4.3694,  4.1735,  4.0368,  4.5095,  4.5538,  4.5240,  4.4252
     .,  3.0187,  3.1918,  3.5127,  3.6875,  3.7404,  3.6943,  3.4702
     .,  3.4888,  3.2914,  3.1643,  3.6669,  3.8724,  3.9940,  4.0816
     .,  3.8054,  3.9661,  3.7492,  3.6024,  4.0428,  4.1951,  4.1466
     .,  4.0515,  4.0075,  3.5020,  3.9158,  3.8546,  3.8342,  3.8008
     .,  3.7845,  3.7549,  3.9602,  3.8872,  3.8564,  4.0793,  3.8835
     ./)
      r0ab_ref_table_grimme(4131:4200)=(/
     .   3.7495,  4.2213,  4.3704,  4.3300,  4.2121,  3.7643,  3.7130
     .,  3.6144,  3.5599,  3.5474,  3.5093,  3.4853,  3.9075,  4.1115
     .,  4.0473,  4.0318,  4.2999,  4.1050,  3.9710,  4.4320,  4.6706
     .,  4.5273,  4.4581,  4.4332,  4.4064,  4.3873,  4.3684,  4.3537
     .,  4.2728,  4.2549,  4.2032,  4.2794,  4.2613,  4.2491,  4.2375
     .,  4.2322,  4.3665,  4.3061,  4.2714,  4.2155,  4.1416,  3.7660
     .,  3.6628,  3.5476,  3.8790,  4.1233,  4.0738,  4.0575,  4.3575
     .,  4.1586,  4.0183,  4.4593,  4.5927,  4.4865,  4.3813,  4.4594
     .,  2.9875,  3.1674,  3.4971,  3.6715,  3.7114,  3.6692,  3.4446
     .,  3.4676,  3.2685,  3.1405,  3.6546,  3.8579,  3.9637,  4.0581
     ./)
      r0ab_ref_table_grimme(4201:4270)=(/
     .   3.7796,  3.9463,  3.7275,  3.5792,  4.0295,  4.1824,  4.1247
     .,  4.0357,  3.9926,  3.4827,  3.9007,  3.8392,  3.8191,  3.7851
     .,  3.7687,  3.7387,  3.9290,  3.8606,  3.8306,  4.0601,  3.8625
     .,  3.7269,  4.2062,  4.3566,  4.3022,  4.1929,  3.7401,  3.6888
     .,  3.5900,  3.5350,  3.5226,  3.4838,  3.4594,  3.8888,  4.0813
     .,  4.0209,  4.0059,  4.2810,  4.0843,  3.9486,  4.4162,  4.6542
     .,  4.5005,  4.4444,  4.4196,  4.3933,  4.3741,  4.3552,  4.3406
     .,  4.2484,  4.2413,  4.1907,  4.2656,  4.2474,  4.2352,  4.2236
     .,  4.2068,  4.3410,  4.2817,  4.2479,  4.1921,  4.1182,  3.7346
     .,  3.6314,  3.5168,  3.8582,  4.0927,  4.0469,  4.0313,  4.3391
     ./)
      r0ab_ref_table_grimme(4271:4340)=(/
     .   4.1381,  3.9962,  4.4429,  4.5787,  4.4731,  4.3588,  4.4270
     .,  4.3957,  2.9659,  3.1442,  3.4795,  3.6503,  3.6814,  3.6476
     .,  3.4222,  3.4491,  3.2494,  3.1209,  3.6324,  3.8375,  3.9397
     .,  3.8311,  3.7581,  3.9274,  3.7085,  3.5598,  4.0080,  4.1641
     .,  4.1057,  4.0158,  3.9726,  3.4667,  3.8802,  3.8188,  3.7989
     .,  3.7644,  3.7474,  3.7173,  3.9049,  3.8424,  3.8095,  4.0412
     .,  3.8436,  3.7077,  4.1837,  4.3366,  4.2816,  4.1686,  3.7293
     .,  3.6709,  3.5700,  3.5153,  3.5039,  3.4684,  3.4437,  3.8663
     .,  4.0575,  4.0020,  3.9842,  4.2612,  4.0643,  3.9285,  4.3928
     .,  4.6308,  4.4799,  4.4244,  4.3996,  4.3737,  4.3547,  4.3358
     ./)
      r0ab_ref_table_grimme(4341:4410)=(/
     .   4.3212,  4.2275,  4.2216,  4.1676,  4.2465,  4.2283,  4.2161
     .,  4.2045,  4.1841,  4.3135,  4.2562,  4.2226,  4.1667,  4.0932
     .,  3.7134,  3.6109,  3.4962,  3.8352,  4.0688,  4.0281,  4.0099
     .,  4.3199,  4.1188,  3.9768,  4.4192,  4.5577,  4.4516,  4.3365
     .,  4.4058,  4.3745,  4.3539,  2.8763,  3.1294,  3.5598,  3.7465
     .,  3.5659,  3.5816,  3.3599,  3.4024,  3.1877,  3.0484,  3.7009
     .,  3.9451,  3.8465,  3.9873,  3.7079,  3.9083,  3.6756,  3.5150
     .,  4.0829,  4.2780,  4.1511,  4.1260,  4.0571,  3.4865,  3.9744
     .,  3.9150,  3.8930,  3.8578,  3.8402,  3.8073,  3.7977,  4.0036
     .,  3.7604,  4.0288,  3.8210,  3.6757,  4.2646,  4.4558,  4.2862
     ./)
      r0ab_ref_table_grimme(4411:4465)=(/
     .   4.2122,  3.7088,  3.6729,  3.5800,  3.5276,  3.5165,  3.4783
     .,  3.4539,  3.9553,  3.9818,  4.2040,  3.9604,  4.2718,  4.0689
     .,  3.9253,  4.4869,  4.7792,  4.4918,  4.5342,  4.5090,  4.4868
     .,  4.4680,  4.4486,  4.4341,  4.2023,  4.3122,  4.2710,  4.3587
     .,  4.3407,  4.3281,  4.3174,  4.1499,  4.3940,  4.3895,  4.3260
     .,  4.2725,  4.1961,  3.7361,  3.6193,  3.4916,  3.9115,  3.9914
     .,  3.9809,  3.9866,  4.3329,  4.1276,  3.9782,  4.5097,  4.6769
     .,  4.5158,  4.3291,  4.3609,  4.3462,  4.3265,  4.4341
     ./)
c
c     Convert from lower triangle to full square matrix of R0AB
c
      k=0
      do i=1,max_elements
         do j=1,i
            k=k+1
            r0AB(i,j)=r0ab_ref_table_grimme(k)*ang2au 
            r0AB(j,i)=r0ab_ref_table_grimme(k)*ang2au 
         enddo
      enddo
      return
      end
